       IDENTIFICATION DIVISION.
       PROGRAM-ID. C72WMAP.
      *
      *  Routine per parametri stampe word
      *
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT O-FILTST ASSIGN TO DISK 
                  ORGANIZATION LINE SEQUENTIAL
                  STATUS SF-O-TST.
           SELECT FILTST ASSIGN TO DISK 
                  ORGANIZATION LINE SEQUENTIAL
                  STATUS SF-TST.
       DATA DIVISION.
       FILE SECTION.
       FD  O-FILTST LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-O-TST 
           RECORD 240 DATA RECORD O-RF-TST.
       01  O-RF-TST.
           05 O-TST-A.
              10 O-TST-C1    PIC X.
              10 FILLER    PIC X(9).
           05 O-TST-B        PIC X(230).
      *
       FD  FILTST LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-TST 
           RECORD 240 DATA RECORD RF-TST.
       01  RF-TST.
           05 TST-A.
              10 TST-C1    PIC X.
              10 FILLER    PIC X(9).
           05 TST-B        PIC X(230).
       WORKING-STORAGE SECTION.
           COPY 'parzf'.
           COPY 'parmc3'.
       01  ID-TST  PIC X(60).
       01  ID-O-TST  PIC X(60).
       01  SF-TST  PIC XX.
       01  SF-O-TST  PIC XX.
       01  AREE.
           05 CAMPO1   PIC X(10).
           05 CAMPO2   PIC X(60).
           05 W1       PIC X(6).
           05 W2       PIC XXX.
           05 W2N  REDEFINES W2 PIC 999.
           05 W3       PIC X.
           05 W3N  REDEFINES W3 PIC 9.
           05 W4       PIC X(20).
           05 DLOC     PIC X(45).
           05 W5       PIC XXX.
           05 W5N REDEFINES W5 PIC 999.
           05 W6       PIC XXXXX.
           05 FLGA     PIC 9 VALUE ZERO.
           05 I        PIC 999 VALUE ZERO.
           05 FLGOK    PIC 9 VALUE ZERO.

      *---------------------------------------------------------
      * Parametri CBL_CHECK_EXIST_FILE
       01  FILE-NAME          PIC X(60).
       01  FILE-DETAILS.
           05 FILE-SIZE       PIC X(8) COMP-X.
           05 FILE-DATE.
              10 F-DAY        PIC X  COMP-X.
              10 F-MONTH      PIC X  COMP-X.
              10 F-YEAR       PIC X(2) COMP-X.
           05 FILE-TIME.
              10 F-HOURS      PIC X COMP-X.
              10 F-MINUTES    PIC X COMP-X.
              10 F-SECONDS    PIC X COMP-X.
              10 F-HINDREDTHS PIC X COMP-X.
       01  STATUS-CODE        PIC X(2)   COMP-X.
      *---------------------------------------------------------
      * Parametri CBL_RENAME_FILE
       01  OLD-FILE-NAME       PIC X(60).
       01  NEW-FILE-NAME       PIC X(60).
      *---------------------------------------------------------
       LINKAGE SECTION.
       PROCEDURE DIVISION.
       INIZIO.
           COPY 'strsub'.
      *
           MOVE SPACE TO ID-TST.
           STRING EX-UTI '\wordmap' DELIMITED SPACE INTO ID-TST.
      *
           MOVE SPACE TO ID-O-TST.
           STRING EX-UTI '\wordmap.p1503' DELIMITED SPACE INTO ID-O-TST.
           MOVE ID-TST TO FILE-NAME.
           CALL "CBL_CHECK_FILE_EXIST" USING FILE-NAME
                                             FILE-DETAILS
                               RETURNING STATUS-CODE.
           IF STATUS-CODE NOT = ZERO
              GO TO FINE.
       
           MOVE ID-O-TST TO FILE-NAME.
           CALL "CBL_CHECK_FILE_EXIST" USING FILE-NAME
                                             FILE-DETAILS
                               RETURNING STATUS-CODE.
           IF STATUS-CODE = ZERO
              GO TO FINE.

           MOVE ID-TST   TO OLD-FILE-NAME.
           MOVE ID-O-TST TO NEW-FILE-NAME.
           CALL "CBL_RENAME_FILE" USING OLD-FILE-NAME
                                        NEW-FILE-NAME
                             RETURNING STATUS-CODE.
           IF STATUS-CODE NOT = ZERO
              GO TO FINE.
      *
           MOVE ZERO TO FLGOK.
           OPEN EXTEND FILTST.
           OPEN INPUT O-FILTST.
      *
       TAB10.
           READ O-FILTST.
           IF SF-O-TST > '02'   GO TO TAB90.
           IF O-TST-C1 = '#'    GO TO TAB11.
           IF O-RF-TST = SPACE  GO TO TAB11.

           IF O-TST-A = '[word]'
              IF O-TST-B = SPACE
                 GO TO TAB11
              ELSE
                 GO TO TAB11.
      *
           IF O-TST-A = '[dirloc]'
              IF O-TST-B = SPACE
                 GO TO TAB11
              ELSE
                 GO TO TAB11.
      *
           IF O-TST-A = '[tipint]'
              IF O-TST-B = SPACE
                 GO TO TAB11
              ELSE
                 GO TO TAB11.
      *
           IF O-TST-A = '[tippub]'
              IF TST-B = SPACE
                 GO TO TAB11
              ELSE
                 GO TO TAB11.
      *
           IF O-TST-A = '[close]'
              IF O-TST-B = SPACE
                 GO TO TAB11
              ELSE
                 GO TO TAB11.
      *
      * Acquisizione codice azienda
           IF O-TST-A = '[azi]'
              IF O-TST-B = SPACE
                 GO TO TAB11
              ELSE
                 GO TO TAB11.

      * area dati sezione 2 / 3
      *
           UNSTRING O-RF-TST DELIMITED ALL SPACE
              INTO W1 W2 W3 W4 W5 W6.
      *
           IF W1 = 'cerri2' GO TO TAB10.
           IF W1 NOT = 'cerrit' GO TO TAB11.
      *
           MOVE O-RF-TST TO RF-TST.
           WRITE RF-TST.
      *
           IF FLGOK = 1
              GO TO TAB10.
           MOVE 1 TO FLGOK.
           MOVE 'cerri2 -   - cerri2.doc    001 L' TO RF-TST.
           WRITE RF-TST.
      *
           GO TO TAB10.
       TAB11.
           MOVE O-RF-TST TO RF-TST.
           WRITE RF-TST.
      *
           GO TO TAB10.
       TAB90.
           CLOSE FILTST.
           CLOSE O-FILTST.
      *
       ERRORE.
           GO TO FINE.
      *
       FINE.
           EXIT PROGRAM.
      *------------------
