      $set sql
       IDENTIFICATION DIVISION.
       PROGRAM-ID. DSV-OPF-F.
      *
      * Lettura dati DSV via ODBC
      *
      *   acquisizione record tabella ordfor_opf data service
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
       DATA DIVISION.
       FILE SECTION.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
       01  COMODI.
           05 MESS    PIC X(40) VALUE SPACE.
           05 SWOPE   PIC 9     VALUE ZERO.
           05 SWCUR   PIC 9     VALUE ZERO.
      *
       01  AREE-MS.
           05 SQL-TEXT     PIC X(1000) VALUE SPACE.
           05 SERIE        PIC 9(4).
           05 I-SERIE      PIC 9(8) COMP-5.
           05 NUM          PIC 9(5).
           05 I-NUM        PIC 9(8) COMP-5.
           05 PRG          PIC 999.
           05 I-PRG        PIC 9(8) COMP-5.
           05 PPRG         PIC 9999.
      *
       EXEC SQL
           INCLUDE SQLCA
       END-EXEC.

       EXEC SQL DECLARE C1 CURSOR FOR ordfor_opf_sql END-EXEC.
      *
       LINKAGE SECTION.
           COPY 'dsv-odbcl.cpy'.
           COPY 'dsv-get.cpy'.
       PROCEDURE DIVISION USING D-ODBC-CTR D-GET-P-IN D-GET-P-OUT.
           COPY 'declxer1'.
           COPY 'declxer2'.
       INIZIO.
           IF D-GET-FUN = 'C'
              PERFORM CL-FILE
              GO TO FINE.

           IF D-GET-FUN = 'c'
              PERFORM CL-CUR
              GO TO FINE.
      *
           COPY 'strsub'.
      *
           IF D-GET-FUN = 'O'
              PERFORM OP-FILE
              GO TO FINE.
      *
           MOVE ZERO  TO D-ODBC-SQLCODE.
           MOVE SPACE TO D-ODBC-SQLWARN.
           MOVE SPACE TO D-ODBC-SQLERRMC.
           MOVE SPACE TO D-ODBC-SQLSTATE.
      *
           IF D-GET-LOOP = ZERO
              PERFORM RD-CUR
              IF SQLCODE NOT = ZERO GO TO CHIUDI.

           PERFORM AZZ-OUT.

           MOVE ZERO TO SERIE NUM PRG PPRG.
           MOVE ZERO TO I-SERIE I-NUM I-PRG.

           EXEC SQL
              FETCH C1 INTO :SERIE:I-SERIE, :NUM:I-NUM, :PRG:I-PRG,
                            :PPRG, :D-GET-ID, :D-GET-UUID
           END-EXEC.

           IF SQLCODE NOT = ZERO
              IF SQLCODE = 100
                 MOVE ZERO TO D-GET-LOOP
                 MOVE ZERO TO SQLCODE

                 PERFORM CL-CUR
              ELSE
                 GO TO ERRIO-SQL.

           IF I-SERIE NOT = ZERO MOVE ZERO TO SERIE.
           IF I-NUM NOT = ZERO MOVE ZERO TO NUM.
           IF I-PRG NOT = ZERO MOVE ZERO TO NUM.

           STRING SERIE NUM PRG PPRG INTO D-GET-KEY.

           GO TO CHIUDI.
      *
       ERRIO-SQL.
           PERFORM AZZ-OUT.
           MOVE SQLCODE  TO D-ODBC-SQLCODE.
           MOVE SQLWARN  TO D-ODBC-SQLWARN.
           MOVE SQLERRMC TO D-ODBC-SQLERRMC.
           MOVE SQLSTATE TO D-ODBC-SQLSTATE.
      *
       ERRIO.
           COPY 'errsub'.
       CHIUDI.
           IF ERRIO-ST NOT = ZERO
              PERFORM CL-FILE.
       FINE.
           EXIT PROGRAM.
      *-------------------*
       OP-FILE.
           IF SWOPE = ZERO
              MOVE 1 TO SWOPE.
      *-------------------*
       CL-FILE.
           IF SWOPE = 1
              MOVE ZERO TO SWOPE.
      *-------------------*
       AZZ-OUT.
           INITIALIZE D-GET-P-OUT.
           MOVE 9 TO D-GET-FOUT.
      *-------------------*
       RD-CUR.
           MOVE 1 TO D-GET-LOOP.
           MOVE ZERO TO SWCUR.

           MOVE SPACE TO SQL-TEXT.
           STRING "SELECT o.orf_serie, o.orf_num, r.rif_prg, "
                  "p.opf_prg, p.opf_id, p.uuid "
                  "FROM ordfor as o "
                  "RIGHT OUTER JOIN ordfor_rig as r ON "
                  "(r.orf_id = o.orf_id) "
                  "RIGHT OUTER JOIN ordfor_opf as p ON "
                  "(p.rif_id = r.rif_id) "
      **** rel 7.2
      *           "WHERE r.azi_codice = ? AND "
                  "WHERE p.azi_codice = ? AND "
      ************
                  "(o.orf_storico IS FALSE OR o.orf_storico IS NULL)"
                  "ORDER BY o.orf_serie, o.orf_num, r.rif_prg, "
                  "p.opf_prg"
                  DELIMITED SIZE INTO SQL-TEXT.

           EXEC SQL
              PREPARE ordfor_opf_sql FROM :SQL-TEXT
           END-EXEC.

           IF SQLCODE = ZERO
              EXEC SQL
                 OPEN C1 USING
                 :D-ODBC-AZI-D
              END-EXEC
              MOVE 1 TO SWCUR.
           IF SQLCODE NOT = ZERO GO TO ERRIO-SQL.
      *-------------------*
       CL-CUR.
            IF SWCUR NOT = ZERO
               EXEC SQL
                   CLOSE C1
               END-EXEC
               MOVE ZERO TO SWCUR
               IF SQLCODE NOT = ZERO
                  GO TO ERRIO-SQL.
      *-------------------*
