       IDENTIFICATION DIVISION.
       PROGRAM-ID. VAMM140.
      *
      * Calcolo stampa aggiornamento ammortamenti
      *
      * Nel caso di stampa brogliaccio, e stampa con aggiornamenti
      * viene generato il file di lavoro WDS145 contenente i
      * movimenti contabili.
      * La rimozione di questo file viene fatta all'uscita da VAMMG45.
      * Attenzione : Richiamato da screenset VAMM138, VAMM139 e VAMM140
      **** rel 6.1
      * ristrutturato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'grianasl'.
           COPY 'griammsl'.
           COPY 'gricamsl'.
           COPY 'gricatsl'.
           COPY 'gritabsl'.
           COPY 'gri145sl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
           SELECT WDSLA3 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL3 STATUS SF-LA3.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griana'.
           COPY 'griamm'.
           COPY 'gricam'.
           COPY 'gricat'.
           COPY 'gritab'.
           COPY 'gri145'.
       FD  WDSLA3 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA3
           DATA RECORD RF-LA3.
       01  RF-LA3.
           05 KEYL3.
              10 KL3-CAT PIC 9(3).
           05 RECLA3.
              10 LA3-COSIN PIC S9(11)V99 COMP-3.
              10 LA3-INCRE PIC S9(11)V99 COMP-3.
              10 LA3-INCAM PIC S9(11)V99 COMP-3.
              10 LA3-DECRE PIC S9(11)V99 COMP-3.
              10 LA3-UTAMM PIC S9(11)V99 COMP-3.
              10 LA3-ACCIN PIC S9(11)V99 COMP-3.
              10 LA3-NONAM PIC S9(11)V99 COMP-3.
              10 LA3-NONIN PIC S9(11)V99 COMP-3.
              10 LA3-NONDE PIC S9(11)V99 COMP-3.
              10 LA3-PLUSV PIC S9(11)V99 COMP-3.
              10 LA3-MINUS PIC S9(11)V99 COMP-3.
              10 LA3-AMMOR OCCURS 2.
                 15 LA3-VALA PIC S9(11)V99 COMP-3 OCCURS 20.
                 15 LA3-ALIQ PIC 999V999 OCCURS 20.
                 15 LA3-IMPO PIC S9(11)V99 COMP-3 OCCURS 20.
                 15 LA3-VALAF PIC S9(11)V99 COMP-3 OCCURS 20.
                 15 LA3-IMPOF PIC S9(11)V99 COMP-3 OCCURS 20.

       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 23 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
              10 KLV-AZI PIC 999.
              10 KLV-RAG PIC 999.
              10 KLV-ANN PIC 9(4).
              10 KLV-COD PIC 9(5).
              10 KLV-AN2 PIC 9(4).
              10 KLV-INC PIC 9(3).
           05 LAV-TIP PIC X.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'grit25rk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parpsb'.
           COPY 'parmb'.
           COPY 'parpv'.
           COPY 'parer'.
           COPY 'rsteur'.
           COPY 'parrd'.

       01  ESTERNE1 EXTERNAL.
           02 EX1-DTAPE   PIC 9(5).
           02 EX1-DTCHI   PIC 9(5).

       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-ANA PIC X(15) VALUE 'anammo'.
       01  ID-AMM PIC X(15) VALUE 'movamm'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  ID-145 PIC X(15) VALUE 'wds145'.
       01  ID-TAC PIC X(15) VALUE 'tacoam'.
       01  ID-LA3 PIC X(15) VALUE 'wdsla3'.
       01  ID-CAT PIC X(15) VALUE 'catamm'.
       01  COMODI.
           05 SF-TAB   PIC XX.
           05 SF-AZI   PIC XX.
           05 SF-ANA   PIC XX.
           05 SF-AMM   PIC XX.
           05 SF-LAV   PIC XX.
           05 SF-145   PIC XX.
           05 SF-TAC   PIC XX.
           05 SF-LA3   PIC XX.
           05 SF-CAT   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 LIVSTA   PIC 9.
           05 ALNORM   PIC 99V999    VALUE ZERO.
           05 ALANTI   PIC 99V999    VALUE ZERO.
           05 AMTOES   PIC 9         VALUE ZERO.
           05 AMTOESF  PIC 9         VALUE ZERO.
           05 COM-AMTOES PIC 9.
           05 COM-AMESER PIC 9.
           05 SWD      PIC X         VALUE SPACES.
           05 SW1      PIC X         VALUE SPACES.
           05 SW3      PIC X         VALUE SPACES.
           05 SW5      PIC X         VALUE SPACES.
           05 ANNI     PIC 9(4)      VALUE ZERO.
           05 RESID    PIC S9(13)V99 VALUE ZERO.
           05 COMCAT   PIC 999       VALUE ZERO.
           05 ACQUIS   PIC S9(13)V99 VALUE ZERO.
           05 ACCANT   PIC S9(13)V99 VALUE ZERO.
           05 ACCANTF  PIC S9(13)V99 VALUE ZERO.
           05 ACANTO   PIC S9(13)V99 VALUE ZERO.
           05 ACANTA   PIC S9(13)V99 VALUE ZERO.
           05 UTILO    PIC S9(13)V99 VALUE ZERO.
           05 UTILA    PIC S9(13)V99 VALUE ZERO.
           05 UTILOZ   PIC S9(13)V99 VALUE ZERO.
           05 UTILAZ   PIC S9(13)V99 VALUE ZERO.
           05 SAVMES   PIC 99        VALUE ZERO.
           05 AMMENS   PIC S9(13)V99 VALUE ZERO.
           05 UTILIZ   PIC S9(13)V99 VALUE ZERO.
           05 VALAMM   PIC S9(13)V99 VALUE ZERO.
           05 VALAMMF  PIC S9(13)V99 VALUE ZERO.
           05 PDEDFIS  PIC 999V99    VALUE ZERO.
           05 PDEDFISCH PIC 999V999  VALUE ZERO.
           05 COM-ANACQ PIC 99999 VALUE ZERO.
           05 SVNORM   PIC 99V999    VALUE ZERO.
           05 SVANTI   PIC 99V999    VALUE ZERO.
           05 FLG1AN   PIC 9         VALUE ZERO.
           05 NONAMM   PIC S9(13)V99 VALUE ZERO.
           05 NONAMMF  PIC S9(13)V99 VALUE ZERO.
           05 CACQUIS  PIC S9(13)V99 VALUE ZERO.
           05 CACCANT  PIC S9(13)V99 VALUE ZERO.
           05 CAMMENS  PIC S9(13)V99 VALUE ZERO.
           05 CUTILIZ  PIC S9(13)V99 VALUE ZERO.
           05 CRESID   PIC S9(13)V99 VALUE ZERO.
           05 TACQUIS  PIC S9(13)V99 VALUE ZERO.
           05 TACCANT  PIC S9(13)V99 VALUE ZERO.
           05 TAMMENS  PIC S9(13)V99 VALUE ZERO.
           05 TUTILIZ  PIC S9(13)V99 VALUE ZERO.
           05 TUTILOZ  PIC S9(13)V99 VALUE ZERO.
           05 TUTILAZ  PIC S9(13)V99 VALUE ZERO.
           05 TNONAMM  PIC S9(13)V99 VALUE ZERO.
           05 TRESID   PIC S9(13)V99 VALUE ZERO.
           05 TIMPORD  PIC S9(13)V99 VALUE ZERO.
           05 TAMMORD  PIC S9(13)V99 VALUE ZERO.
           05 TIMPANT  PIC S9(13)V99 VALUE ZERO.
           05 TAMMANT  PIC S9(13)V99 VALUE ZERO.
           05 COMODO   PIC S9(13)V99 VALUE ZERO.
           05 COMOD3   PIC S9(13)V99 VALUE ZERO.
           05 TOT1     PIC S9(13)V99 VALUE ZERO.
           05 TOT2     PIC S9(13)V99 VALUE ZERO.
           05 TOT3     PIC S9(13)V99 VALUE ZERO.
           05 TOT4     PIC S9(13)V99 VALUE ZERO.
           05 TOT5     PIC S9(13)V99 VALUE ZERO.
           05 TOT6     PIC S9(13)V99 VALUE ZERO.
           05 VARUTIL  PIC S9(13)V99 VALUE ZERO.
           05 ALNORMF  PIC 99V999    VALUE ZERO.
           05 ALANTIF  PIC 99V999    VALUE ZERO.
           05 AMMENSF  PIC S9(13)V99 VALUE ZERO.
           05 AMMANTF  PIC S9(13)V99 VALUE ZERO.
           05 AMMENST  PIC S9(13)V99 VALUE ZERO.
           05 AMMENSTC PIC S9(13)V99 VALUE ZERO.
           05 RESAUM   PIC S9(13)V99 VALUE ZERO.
           05 VARRET   PIC S9(13)V99 VALUE ZERO.
           05 TVARRET  PIC S9(13)V99 VALUE ZERO.
           05 TVARAUM  PIC S9(13)V99 VALUE ZERO.
           05 TOTGDIM  PIC S9(13)V99 VALUE ZERO.
           05 TOTGAUM  PIC S9(13)V99 VALUE ZERO.
           05 TOTGALI  PIC S9(13)V99 VALUE ZERO.
           05 TTGDIM2  PIC S9(13)V99 VALUE ZERO.
           05 TTGAUM2  PIC S9(13)V99 VALUE ZERO.
           05 TVARALI  PIC S9(13)V99 VALUE ZERO.
           05 VARALI   PIC S9(13)V99 VALUE ZERO.
           05 COMTFIS  PIC S9(13)V99 VALUE ZERO.
           05 TOTAFIS  PIC S9(13)V99 VALUE ZERO.
           05 TOTACIV  PIC S9(13)V99 VALUE ZERO.
           05 TAMMFIS  PIC S9(13)V99 VALUE ZERO.
           05 RESFIS   PIC S9(13)V99 VALUE ZERO.
           05 VARAUM   PIC S9(13)V99 VALUE ZERO.
           05 TOTANT   PIC S9(13)V99 VALUE ZERO.
           05 FLGTPAM  PIC 99 VALUE ZERO.
           05 FLGMOV   PIC 9  VALUE ZERO.
           05 SW-STA   PIC 9         VALUE ZERO.
           05 PERCNO   PIC 999V999   VALUE ZERO.
           05 COMODX   PIC S9(14)V9(4) VALUE ZERO.
           05 COMODY   PIC S9(14)V9(4) VALUE ZERO.
           05 COMOD1   PIC S9(14)V9(4) VALUE ZERO.
           05 COMOD2   PIC 999V9999  VALUE ZERO.
           05 N        PIC 999       VALUE ZERO.
           05 K        PIC 999       VALUE ZERO.
           05 K1       PIC 99        VALUE ZERO.
           05 K2       PIC 99        VALUE ZERO.
           05 KATTESA  PIC 9(5)      VALUE ZERO.
           05 CODICE   PIC 9(5)      VALUE ZERO.
           05 ANACQ    PIC 9(4)      VALUE ZERO.
           05 SW-COD   PIC 9         VALUE ZERO.
           05 TINCREM   PIC S9(13)V99 VALUE ZERO.
           05 TINCAMM   PIC S9(13)V99 VALUE ZERO.
           05 TPLUSVA   PIC S9(13)V99 VALUE ZERO.
           05 TINCNON   PIC S9(13)V99 VALUE ZERO.
           05 TDECREM   PIC S9(13)V99 VALUE ZERO.
           05 TMINUSV   PIC S9(13)V99 VALUE ZERO.
           05 TDECNON   PIC S9(13)V99 VALUE ZERO.
           05 FLAMM     PIC 9        VALUE ZERO.
           05 PLUSV     PIC 9(7)     VALUE ZERO.
           05 MINUS     PIC 9(7)     VALUE ZERO.
           05 TOTPLU    PIC S9(11)V99 VALUE ZERO.
           05 TOTMIN    PIC S9(11)V99 VALUE ZERO.
           05 PERCOM    PIC 9(3)V999 VALUE ZERO.
      **** rel 6.3
           05 PERCOM1   PIC 9(3)V999 VALUE ZERO.
      ************
      **** rel 7.1
           05 FLGDEL    PIC 9        VALUE ZERO.
      ************
           05 INIESK    PIC 9(5) COMP-3 VALUE ZERO.
           05 FINESK    PIC 9(5) COMP-3 VALUE ZERO.
           05 DTCON     PIC 9(5) COMP-3 VALUE ZERO.
           05 DTCHIU    PIC 9(5) COMP-3 VALUE ZERO.
           05 DTAPEP    PIC 9(5) COMP-3 VALUE ZERO.
           05 COMNMES   PIC 99.
           05 PRCD.
              10 PRRAG  PIC 999.
              10 PRCOD  PIC 9(5).
              10 PRINC  PIC 9(3).
           05 ULCD.
              10 ULRAG  PIC 999.
              10 ULCOD  PIC 9(5).
              10 ULINC  PIC 9(3).
           05 T25ESE   PIC 9 VALUE ZERO.
           05 DTAPE.
              10 MMAPE  PIC 99.
              10 AAAPE  PIC 9999.
           05 MMCHI  PIC 99 VALUE ZERO.
           05 OLD-DTAPE  PIC 99999.
           05 TINCAMMF PIC S9(13)V99 VALUE ZERO.
           05 INCAMM   PIC S9(13)V99 VALUE ZERO.
           05 INCAMMF  PIC S9(13)V99 VALUE ZERO.
           05 TOTVALC  PIC S9(13)V99 VALUE ZERO.
           05 TOTVALF  PIC S9(13)V99 VALUE ZERO.
      **** rel 7.1
           05 MEMO-ANACQ PIC 9999.
           05 MEMO-COEFFI  PIC 99V99.
           05 MEMO-COEFAN  PIC 99V99.
           05 MEMO-COEFOR  PIC 99V99.
           05 SW-ACQES     PIC 9.
      ************
      *
           05 C-TTS2.
              10 INTC1C PIC X(56).
              10 FILLER PIC X(60) VALUE
                'RIEPILOGO AMMORTAMENTI PER ALIQUOTA'.
           05 C-TINT2-1.
              10 FILLER   PIC 9      VALUE 1.
              10 FILLER PIC X(46).
              10 FILLER PIC X(60) VALUE
                'CIVILE                                  FISCALE'.
           05 C-TINT2-2.
              10 FILLER   PIC 9      VALUE 1.
              10 FILLER PIC X(26).
              10 FILLER   PIC XXXXXXXX VALUE 'Aliq.a'.
              10 FILLER   PIC X VALUE SPACES.
              10 FILLER   PIC XXXXXXXXXXXXXXX VALUE 'Val. Amort.'.
              10 FILLER   PIC X VALUE SPACES.
              10 FILLER   PIC XXXXXXXXXXXXXXX VALUE 'Accantonato'.
              10 FILLER   PIC X(10) VALUE SPACES.
              10 FILLER   PIC XXXXXXXXXXXXXXX VALUE 'Val. Amort.'.
              10 FILLER   PIC X VALUE SPACES.
              10 FILLER   PIC X(28) VALUE 'Accantonato (Deducibile)'.
      *
       01  REKT14D.
           05 FILLER   PIC X(5).
           05 T14CAMO  PIC 9(3).
           05 T14CAMI  PIC 9(3).
           05 T14CUTI  PIC 9(3).
           05 T14CPLU  PIC 9(3).
           05 T14CMIN  PIC 9(3).
           05 T14RAGG  PIC 9.
           05 FILLER   PIC X(51).
      *
           COPY 'vamm140.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-LMOD      PIC 99.
           05 IF-MOVC      PIC 9.
           05 IF-FLA       PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
      * data
           05 IF-INIES     PIC 9(6).
      * data
           05 IF-FINES     PIC 9(6).
           05 IF-TIPLAV    PIC 9.
           05 IF-TPALI     PIC 9.
           05 IF-TPAMM     PIC 9.
           05 IF-ESERC     PIC 9999.
           05 IF-NUMMES    PIC 99.
           05 IF-PRRAG     PIC 999.
           05 IF-PRCOD     PIC 9(5).
           05 IF-PRINC     PIC 999.
           05 IF-ULRAG     PIC 999.
           05 IF-ULCOD     PIC 9(5).
           05 IF-ULINC     PIC 999.
      * data
           05 IF-DATCHI    PIC 9(6).
      * data
           05 IF-DATCON    PIC 9(6).
           05 IF-FLAMM     PIC 9.
           05 IF-LIVSTA    PIC 9.
           05 IF-STAECC    PIC 9.
           05 IF-FL        PIC 9.
           05 IF-LIREUR    PIC 9.
           05 IF-NBOL      PIC 9.
           05 IF-NUM-1     PIC 9(5).
           05 IF-ANNO      PIC 9(4).
           05 IF-PIEDE-1   PIC X(60).
           05 IF-PIEDE-2   PIC X(60).
           05 IF-TOTAM     PIC 9.
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclana'.
           COPY 'dclamm'.
           COPY 'dclcam'.
           COPY 'dclcat'.
           COPY 'dcllav'.
           COPY 'dcltab'.
           COPY 'dcl145'.
           COPY 'dclla3'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
      **** rel 6.1
      *                    GO TO CHIUDI.
                           GO TO FINE.
      ************
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vamm140: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE WDSLAV WDS145 WDSLA3.
           OPEN OUTPUT WDSLAV WDS145 WDSLA3.
           CLOSE WDSLAV WDS145 WDSLA3.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'grianaer'.
           COPY 'griammer'.
           COPY 'gricamer'.
           COPY 'gricater'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           IF NOT (IF-TIPLAV = 1 OR 2 OR 3)
              MOVE 'vamm140 parametro IF-TIPLAV errato' TO MESS
              GO TO ERRIO.
      *
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV WDS145 WDSLA3.
           CLOSE WDSLAV WDS145 WDSLA3.
      *
           MOVE 'anazol' TO ID-AZI.
           OPEN INPUT ANAAZI.
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID MOVE ZERO TO AZI-DTAPE.
           CLOSE ANAAZI.
           MOVE AZI-DTAPE TO OLD-DTAPE.

           MOVE 'anaazi' TO ID-AZI.
           OPEN INPUT ANAAZI.
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID
                PERFORM INVK-AZI
                CLOSE ANAAZI
                GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
           CLOSE ANAAZI.
      *
           MOVE AZI-FLAMM TO FLAMM.
           OPEN INPUT TABELL.
           IF FLAMM = ZERO GO TO INI-ELABORA-10.
           MOVE 14 TO KTB-TIP.
           MOVE 4  TO KTB-COD.
           READ TABELL INTO REKT14D INVALID MOVE ZERO TO T14CAMO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT14D.
           IF T14CAMO = ZERO
              MOVE 'Errore causali' TO F-MES1
              MOVE 'Errore legami'  TO F-MES2
              MOVE ZERO TO FLAMM
              MOVE 2 TO F-NMES
              CALL 'vrmbox' USING PARMB.
           IF FLAMM = ZERO GO TO INI-ELABORA-10.
           IF IF-TIPLAV = 3
              OPEN I-O TACOAM
           ELSE
              OPEN INPUT TACOAM.
           IF SF-TAC NOT = ZERO
              MOVE 'Errore open TACOAM' TO F-MES1
              MOVE 'Errore legami'      TO F-MES2
              MOVE 2 TO F-NMES
              MOVE ZERO TO FLAMM
              CALL 'vrmbox' USING PARMB
              GO TO INI-ELABORA-10.
           MOVE ZERO   TO KTC-CAT.
           MOVE IF-AZI TO KTC-AZI.
           READ TACOAM INVALID MOVE ZERO TO TAC-AMORD TAC-AMANT
                                            TAC-DTAPE.
           IF TAC-AMORD = ZERO
              MOVE 'Manca conto plusvalenze' TO F-MES1
              MOVE 'Errore legami'           TO F-MES2
              MOVE 2 TO F-NMES
              MOVE ZERO TO FLAMM
              CALL 'vrmbox' USING PARMB.
           MOVE TAC-AMORD TO PLUSV.
           MOVE TAC-AMANT TO MINUS.
           CLOSE TACOAM.
           IF TAC-DTAPE = ZERO
              MOVE 'Manca Data Ap. Cespiti' TO F-MES1
              MOVE 'Verificare Esercizio'   TO F-MES2
              MOVE 2 TO F-NMES
              MOVE ZERO TO FLAMM
              GO TO ERRIO.
           MOVE ZERO TO IF-MOVC.
           IF TAC-DTAPE < OLD-DTAPE
              MOVE 1 TO IF-MOVC.
       INI-ELABORA-10.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-ESE TO T25ESE.
           CLOSE TABELL.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
      *
           MOVE ZERO TO IF-INIES
                        IF-FINES
                        IF-TPALI
                        IF-TPAMM
                        IF-ESERC
                        IF-NUMMES
                        IF-PRRAG
                        IF-PRCOD
                        IF-PRINC
                        IF-DATCHI
                        IF-DATCON
                        IF-FLAMM
                        IF-LIVSTA
                        IF-TOTAM
                        IF-LIREUR
                        IF-FL.
           MOVE 1 TO IF-TPAMM IF-STAECC.
           MOVE 99999 TO IF-ULRAG
                         IF-ULCOD
                         IF-ULINC.
      *
           MOVE ZERO TO LIVSTA.
           MOVE ZERO TO COMNMES.
           MOVE ZERO TO IF-NBOL
                        IF-NUM-1
                        IF-ANNO.
           MOVE SPACE TO IF-PIEDE-1
                         IF-PIEDE-2.
           IF IF-FLA NOT = 0
              MOVE EX1-DTAPE TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE AA4   TO AAAPE
              MOVE MM9   TO MMAPE
              MOVE GGMMAA TO IF-INIES
              MOVE EX1-DTCHI TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GGMMAA TO IF-FINES
           ELSE
              IF TAC-DTAPE NOT = ZERO
                 MOVE TAC-DTAPE TO AAGGG
                 MOVE 2 TO TIPOP1
                 CALL 'rdata' USING PARCDT
                 MOVE AA4   TO AAAPE
                 MOVE MM9   TO MMAPE
                 MOVE GGMMAA TO IF-INIES
      **** rel 6.2
                 IF T25ESE = 1
                    SUBTRACT 1 FROM AAGGG
                    MOVE 2 TO TIPOP1
                    CALL 'rdata' USING PARCDT
                    ADD 1 TO AA9
                    MOVE GGMMAA TO IF-FINES
                 ELSE
      ************
                 MOVE 31 TO GG9
                 MOVE 12 TO MM9
                 MOVE GGMMAA TO IF-FINES.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-INIES.
           MOVE 'IF-INIES' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-INIES.
           IF IF-INIES = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-INIES TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO INIESK.
           IF FUN = 'V'
              IF INIESK < TAC-DTAPE AND IF-FLA = 0
                  SUBTRACT 1 FROM AAAPE.
           MOVE MM9   TO COMNMES.
           IF IF-FINES NOT = ZERO AND FUN NOT = 'V'
              GO TO E-INIES.
      *
           ADD 11 TO MM9.
           IF MM9 > 12
              ADD 1 TO AA9
              SUBTRACT 12 FROM MM9.
           MOVE 31 TO GG9.
       V-INIES-10.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 NOT = ZERO
              SUBTRACT 1 FROM GG9
              GO TO V-INIES-10.
           IF GG9 < 28 MOVE ZERO TO GGMMAA.
           MOVE GGMMAA TO IF-FINES.
       E-INIES.
      *
       V-FINES.
           MOVE 'IF-FINES' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FINES.
           MOVE 1 TO TIPOP1.
           MOVE IF-FINES TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO FINESK.
           IF FINESK < INIESK
              PERFORM ERR-DINC
              GO TO V-ERROR.
      *
           MOVE IF-FINES TO IF-DATCHI.
           MOVE FINESK TO DTCHIU.
           MOVE MM9 TO MMCHI.
           IF MM9 < COMNMES ADD 12 TO MM9.
           COMPUTE IF-NUMMES = MM9 + 1 - COMNMES.
           MOVE AA4 TO IF-ESERC.
       E-FINES.
      *
       V-TPAMM.
           MOVE 'IF-TPAMM' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPAMM.
           IF IF-TIPLAV = 2
              MOVE 1    TO IF-LIVSTA
              MOVE ZERO TO IF-FLAMM
              GO TO E-TPAMM.
       E-TPAMM.
      *
       V-FLAMM.
           MOVE 'IF-FLAMM' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLAMM.
           IF IF-FLAMM = 1
              IF FLAMM NOT = 1
                 MOVE 'Non abilitato su azienda, adeguato' TO MESS
                 MOVE ZERO TO IF-FLAMM
                 GO TO V-ERROR
              ELSE
                 IF IF-TIPLAV = 2
                    PERFORM ERR-DINC
                    MOVE ZERO TO IF-FLAMM
                    GO TO V-ERROR.

       E-FLAMM.
      *
       V-DTCON.
           MOVE 'IF-DATCON' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTCON.
           IF IF-FLAMM = ZERO
              MOVE ZERO TO IF-DATCON
              GO TO E-DTCON.
           IF IF-TIPLAV = 3
              IF IF-DATCON = ZERO
                 PERFORM ERR-ZERO
                 GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATCON TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DTCON.
           MOVE ZERO TO IF-FL.
           IF AZI-DTAPE = ZERO AND DTCON > DTCHIU
              MOVE 1 TO IF-FL
              GO TO E-DTCON-1.
           IF IF-TIPLAV = 3
              IF DTCHIU NOT > AZI-DTAPE
                 MOVE 1 TO IF-FL
              END-IF
           ELSE
              IF DTCHIU < AZI-DTAPE
                 MOVE 1 TO IF-FL.
       E-DTCON-1.
           IF (IF-FL = 1 AND DTCON < OLD-DTAPE)
           OR (IF-FL NOT = 1 AND DTCON < AZI-DTAPE)
                MOVE 'Data contabile errata' TO MESS
                GO TO V-ERROR.
       E-DTCON.
      *
       V-TOTAM.
           MOVE 'IF-TOTAM' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TOTAM.
           IF IF-TOTAM = 1 AND IF-TIPLAV = 3
              MOVE 'ATTENZIONE : eseguire la stampa' TO F-MES1
              MOVE 'su output di prova !           ' TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-WARNING.
       E-TOTAM.
      * esegue sempre
           IF NOT (IF-TIPLAV = 1 OR 2) GO TO END-V-DATI.
           MOVE IF-PRRAG TO PRRAG.
           MOVE IF-PRCOD TO PRCOD.
           MOVE IF-PRINC TO PRINC.
           MOVE IF-ULRAG TO ULRAG.
           MOVE IF-ULCOD TO ULCOD.
           MOVE IF-ULINC TO ULINC.
           IF ULCD < PRCD
              MOVE 'Selezione cod. da stampare incongruenti' TO MESS
              GO TO V-ERROR.
      *
       END-V-DATI.
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           IF RP-TRPT = ZERO 
              MOVE 'E'' possibile stampare il Report' TO F-MES1
              MOVE 'solo a carattere o visuale.'     TO F-MES2
              MOVE 'Forzato visuale.' TO F-MES3
              MOVE 3 TO F-NMES
              MOVE 'W' TO MB-TIPO
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO RP-TRPT.
      *
           IF IF-NBOL = 1
              MOVE 'PBK_ADES' TO RP-BLK
              MOVE IF-PIEDE-1 TO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE 'PBK_ACIT' TO RP-BLK
              MOVE IF-PIEDE-2 TO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE 'PBK_DPAG' TO RP-BLK
              STRING 'Anno: ' IF-ANNO
                     DELIMITED SIZE INTO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE 'PBK_NPAG' TO RP-BLK
              MOVE IF-NUM-1 TO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE IF-ANNO  TO PANNO PANNO1
              MOVE '/'      TO PBARR PBARR1
              IF IF-ANNO = ZERO 
                 MOVE SPACE TO PANNO  PBARR
                               PANNO1 PBARR1
              END-IF
              MOVE ZERO TO FNPG
           ELSE
              MOVE SPACE TO RTPAG
              MOVE 1 TO FNPG
              MOVE 'np' TO RP-VERM.    *> per non stampare il piede

           MOVE SPACE TO INT-TIPO.
           MOVE IF-AZI   TO PIN-COD.
           MOVE AZRGSOC  TO PIN-RAG.
           MOVE IF-ESERC TO PIN-ESE.
           IF IF-FLA = 1
              MOVE 1 TO IF-TIPLAV.
           IF IF-TIPLAV = 3 GO TO RUN-ELAB-TIPLAV3.
      *
      * stampa brogliaccio o prospetto riepilogativo
      *
       B00-PROVA.
           IF IF-TIPLAV = 1 AND IF-FLA = 0
              MOVE '*** BROGLIACCIO ***' TO INT-TIPO.
           IF IF-FLA = 1
             MOVE 'Il programma non aggiorna alcun tipo di' TO F-MES1
             MOVE 'dato al contrario della stampa registro.' TO F-MES2
             MOVE 'Esegue solo la ristampa.         '        TO F-MES3
             MOVE '                                        ' TO F-MES4
             MOVE '      '                                   TO F-MES5
             MOVE 5 TO F-NMES
             CALL 'vrmbox' USING PARMB
             MOVE ZERO TO PRCD
             MOVE 99999999999 TO ULCD.

           OPEN INPUT ANAMMO.
           OPEN INPUT MOVAMM.
           OPEN I-O WDSLAV.
           OPEN I-O WDS145.
           OPEN I-O WDSLA3.
           OPEN INPUT TACOAM.
           PERFORM D00-ESTRAZ THRU D99.
           PERFORM BC00-CALSTA THRU BC99.
           CLOSE ANAMMO.
           CLOSE MOVAMM.
           CLOSE WDSLAV.
           IF IF-TIPLAV NOT = 2
              IF IF-LIVSTA = ZERO GO TO B60.
      *
           MOVE 1 TO LIVSTA.
      *
           OPEN INPUT CATAMM.
           PERFORM N00-STAPRO THRU N99.
           CLOSE CATAMM.
       B60.
           CLOSE WDSLA3.
           CLOSE WDS145.
           CLOSE TACOAM.
           GO TO NO-STAMPA.
      *
      * stampa registro e aggiornamento
      *
       RUN-ELAB-TIPLAV3.
       C00-BOLLATO.
           MOVE SPACE TO INT-TIPO.
           MOVE 'Il programma archivia i dati dei cespiti' TO F-MES1.
           MOVE 'Le stampe saranno ripetibili dalla '      TO F-MES2.
           MOVE 'gestione storici.'                        TO F-MES3.
           MOVE 5 TO F-NMES.
           CALL 'vrmbox' USING PARMB
      *
           MOVE 'Confermi la stampa e l''aggiornamento ?' TO F-MES1.
           MOVE 1   TO F-NMES.
           MOVE 'Q' TO MB-TIPO.
           MOVE '2' TO MB-DEFAULT.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP NOT = 'S'
      * forzo if-flamm = zero per evitare che l'interfaccia
      * lanci lo zoom vammx45 sul file di lavoro dei movimenti.
              MOVE ZERO TO IF-FLAMM
              GO TO NO-STAMPA.

           OPEN I-O TACOAM.
           MOVE ZERO   TO KTC-CAT.
           MOVE IF-AZI TO KTC-AZI.
           READ TACOAM INVALID MOVE ZERO TO TAC-AMORD TAC-AMANT
                                            TAC-DTAPE.
           MOVE TAC-DTAPE TO DTAPEP.
           MOVE DTCHIU TO TAC-DTAPE.
           ADD 1 TO TAC-DTAPE.
           WRITE RF-TAC INVALID
             REWRITE RF-TAC INVALID PERFORM INVK-TAC
                            GO TO ERRIO.
           CLOSE TACOAM.
      *
           OPEN I-O ANAMMO.
           OPEN I-O MOVAMM.
           OPEN I-O WDSLAV.
           OPEN I-O WDS145.
           OPEN I-O WDSLA3.
           OPEN INPUT TACOAM.
           MOVE ZERO TO PRCD.
           MOVE 99999999999 TO ULCD.
           PERFORM S00-STORICO THRU S99.
           PERFORM D00-ESTRAZ THRU D99.
           PERFORM BC00-CALSTA THRU BC99.
           CLOSE ANAMMO.
           CLOSE MOVAMM.
           CLOSE WDSLAV.
      *
           IF IF-LIVSTA = ZERO GO TO C60.
      *
           MOVE 1 TO LIVSTA.
           OPEN INPUT CATAMM.
           PERFORM N00-STAPRO THRU N99.
           CLOSE CATAMM.
       C60.
           CLOSE WDSLA3.
           CLOSE WDS145.
           CLOSE TACOAM.
       NO-STAMPA.
      *
           COPY 'grirpt-r'.
      *
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV ID-145 ID-LA3.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
           STRING 'w2' PID DELIMITED SPACE INTO ID-145.
           STRING 'w3' PID DELIMITED SPACE INTO ID-LA3.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       BC00-CALSTA.
           MOVE ZERO TO K145-PROG.
           MOVE ZERO TO TOTPLU TOTMIN.
           MOVE ZERO TO TACQUIS TACCANT TAMMENS TUTILIZ TIMPORD
                        NONAMMF
                        TNONAMM TRESID TAMMORD TIMPANT TAMMANT.
           MOVE ZERO TO TOT1 TOT2 TOT3.
           MOVE ZERO TO CACQUIS CACCANT CAMMENS CUTILIZ
                        CRESID SW-COD CODICE.
           MOVE ZERO TO ACQUIS ACCANT AMMENS UTILIZ NONAMM
                        RESID COMODO SW-STA.
           MOVE ZERO TO ACCANTF.
           MOVE ZERO TO AMMENST AMMENSF AMMANTF VARRET TVARRET TVARAUM
                        TOTAFIS VARALI TOTACIV RESFIS VARAUM TOTANT
                        TVARALI COMTFIS RESAUM TOTGDIM TOTGAUM
                        TTGDIM2 TTGAUM2 AMMENSTC
                        TOTGALI TAMMFIS SVNORM SVANTI.
           MOVE ZERO TO FLGTPAM FLG1AN.
           MOVE ZERO TO COMOD1.
           MOVE ZERO TO ACANTO ACANTA UTILO UTILA
                        UTILOZ UTILAZ TUTILOZ TUTILAZ.
           MOVE ZERO TO INCAMM INCAMMF.
           MOVE ZERO TO TINCAMM TINCAMMF.
           MOVE ZERO TO TOTVALC TOTVALF.
           MOVE ZERO TO ANACQ.
           MOVE SPACE TO ST-XXX ST-BAR.
           MOVE ' ***' TO ST-XXX.
           MOVE ZERO  TO ST-MES ST-DOD.
           MOVE AZRGSOC  TO INT-RAG.
           MOVE IF-AZI   TO INT-COD.
           MOVE IF-INIES TO ST-INIES.
           MOVE IF-FINES TO ST-FINES.
           MOVE IF-AZI   TO KLV-AZI.
           MOVE ZERO TO KLV-RAG KLV-ANN KLV-COD KLV-AN2 KLV-INC.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO BC99.
       BC01.
           READ WDSLAV NEXT AT END GO TO BC99.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO BC01.
           IF KLV-AZI > IF-AZI   GO TO BC99.
           IF KLV-AN2 > IF-ESERC GO TO BC01.
       BCX1.
      *
           MOVE 1 TO RP-JMP.
      *
           MOVE 'CATEGORIA :' TO ST-RD02.
           OPEN INPUT CATAMM.
           MOVE KLV-RAG TO COMCAT.
           MOVE IF-AZI  TO KCT-AZI.
           MOVE KLV-RAG TO KCT-CAT.
           READ CATAMM INVALID MOVE ALL '*' TO CAT-DESCR.
           MOVE KCT-CAT   TO ST-CRG.
           MOVE CAT-DESCR TO ST-RAG.
           CLOSE CATAMM.
           MOVE KLV-RAG TO KL3-CAT.
           READ WDSLA3 INVALID PERFORM M00-AZZ THRU M99.
           IF IF-TIPLAV = 2 GO TO BCX1-00.

      *-- inizializza parametri per stampa a caratteri --*
           IF IF-LMOD = 12
              MOVE 72 TO NRGF
              MOVE 66 TO NRGL
           ELSE
              MOVE 66 TO NRGF
              MOVE 57 TO NRGL.
      *    MOVE 59      TO NRGL.
           MOVE C-TTS0  TO RTTS.
           MOVE 3       TO NINT.
           MOVE C-TINT0-1 TO XTINT(1).
           MOVE C-TINT0-2 TO XTINT(2).
           MOVE C-TINT0-3 TO XTINT(3).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'REGISTRO CESPITI AMMORTIZZABILI ' INT-TIPO  
                  'DAL 'ST-INIES  ' AL ' ST-FINES
                  DELIMITED SIZE INTO RP-TIT1.
      *
           MOVE SPACE TO RP-TIT2.
           STRING ST-RD02 ' ' ST-CRG ' ' ST-RAG
                  DELIMITED SIZE INTO RP-TIT2.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG3-INTC.
      *
      *    MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  

           MOVE ALL '=' TO ST-SOTT2.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG7' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
       BCX1-00.
           IF IF-FLAMM = ZERO GO TO BCX2.
           MOVE IF-AZI  TO KTC-AZI.
           MOVE KLV-RAG TO KTC-CAT.
           READ TACOAM INVALID MOVE ZERO TO TAC-CONTO.
           IF TAC-CONTO = ZERO
              MOVE CAT-DESCR       TO F-MES1
              MOVE 'Errore legami' TO F-MES2
              MOVE 2 TO F-NMES
              CALL 'vrmbox' USING PARMB
              MOVE ZERO TO IF-FLAMM
              GO TO BCX1-00.
           ADD 1 TO K145-PROG.
           READ WDS145 INVALID MOVE ZERO TO REC145
                               MOVE SPACE TO L145-DESAG L145-DESA2.
       BCX2.
           IF KLV-INC = ZERO
              MOVE KLV-COD TO CODICE
           ELSE
              MOVE ZERO    TO CODICE.
       BC02.
           MOVE KLV-AZI TO KAN-AZI.
           MOVE KLV-RAG TO KAN-RAG.
           MOVE KLV-COD TO KAN-COD.
           MOVE KLV-INC TO KAN-INC.
           IF IF-FLA = 0
              MOVE 99999 TO KAN-DTAPE KAN-DTCHI
           ELSE
              MOVE EX1-DTAPE TO KAN-DTAPE
              MOVE EX1-DTCHI TO KAN-DTCHI.
           READ ANAMMO KEY KEYAN INVALID PERFORM INVK-ANA
                                         GO TO ERRIO.
      **** rel 7.1
           MOVE ANA-ANACQ TO MEMO-ANACQ.
           MOVE ANA-COEFFI TO MEMO-COEFFI.
           MOVE ANA-COEFAN TO MEMO-COEFAN.
           MOVE ANA-COEFOR TO MEMO-COEFOR.
           IF ANA-ANACQ > IF-ESERC
             MOVE ZERO TO ANA-COEFFI ANA-COEFAN ANA-COEFOR
             MOVE IF-ESERC TO ANA-ANACQ.      
      ************
           MOVE ZERO TO ACCANTF.
           MOVE ANA-ANACQ  TO COM-ANACQ.
           PERFORM CHECK-TIPO THRU EX-CHECK-TIPO.
           MOVE ANA-AMESER TO COM-AMESER.
           MOVE ANA-AMTOES TO COM-AMTOES.
           IF ANA-AMESER = 1
             IF ANA-TOTACIV NOT = ZERO
               MOVE 99,99 TO ANA-COEFFI ANA-COEFAN.
           IF ANA-AMTOES = 1
             IF ANA-TOTACIV NOT = ZERO
               MOVE 99,99 TO ANA-COEFOR.
           MOVE ANA-COEFOR TO ALNORM.
           MOVE ANA-COEFFI TO ALNORMF.
           MOVE ANA-COEFAN TO ALANTIF ALANTI.
           IF IF-TPAMM = 0 MOVE ZERO TO ALANTIF ALANTI.
           MOVE ZERO TO FLG1AN.
           IF T25ESE = ZERO
              IF ANA-ANACQ NOT = IF-ESERC
                 GO TO BC02-00
              END-IF
              IF NOT ( ANA-TIPBEN = 0 OR 6 OR 7)
                 GO TO BC02-00.
           IF T25ESE NOT = 1 GO TO BC02-0.
           COMPUTE COMODO = IF-ESERC - ANA-ANACQ.
           IF NOT (COMODO = ZERO OR 1 ) GO TO BC02-00.
           IF COMODO = 1
              IF NOT (ANA-ANACQ >= AAAPE  AND
                      ANA-MSACQ >= MMAPE) GO TO BC02-00.
           IF NOT (IF-ESERC > 1987    AND
                   (ANA-TIPBEN = ZERO OR 6 OR 7)) GO TO BC02-00.
       BC02-0.
           IF IF-ESERC > 1987
              MOVE ALNORM TO SVNORM
              MOVE ALANTI TO SVANTI
              MOVE 1 TO FLG1AN
      **** rel 6.3
      *       COMPUTE COMOD2 = ALNORM / 2 + 0,0009
      *       MOVE COMOD2 TO ALNORM
      *       COMPUTE COMOD2 = ALNORMF / 2 + 0,0009
      *       MOVE COMOD2 TO ALNORMF
      *       COMPUTE COMOD2 = ALANTI / 2 + 0,0009
      *       MOVE COMOD2 TO ALANTI
      *       MOVE COMOD2 TO ALANTIF.
              COMPUTE RD-NUM = ALNORM / 2
              CALL 'vrround' USING NNN-D PARRD DEC-2
              MOVE RD-NUM TO ALNORM
              COMPUTE RD-NUM = ALNORMF / 2
              CALL 'vrround' USING NNN-D PARRD DEC-2
              MOVE RD-NUM TO ALNORMF
              COMPUTE RD-NUM = ALANTI / 2
              CALL 'vrround' USING NNN-D PARRD DEC-2
              MOVE RD-NUM TO ALANTI ALANTIF.
      ************
       BC02-00.
           MOVE SPACES TO ST-MESE.
           IF ANA-MSACQ NOT = ZERO
              MOVE ANA-MSACQ TO ST-MESE(2:2)
              MOVE '/'       TO ST-MESE(4:1).
           MOVE ANA-ANACQ  TO ST-ANNO.
           MOVE ANA-DESBEN TO ST-DESC.
           IF IF-NUMMES = 12 AND
              (ANA-MSIN = ZERO OR > IF-NUMMES)
              GO TO BC020.
           MOVE IF-NUMMES TO SAVMES.
           IF ANA-MSIN > ZERO AND < IF-NUMMES
              MOVE ANA-MSIN TO IF-NUMMES.
           IF FLG1AN = 1 AND ANA-MSIN > ZERO
              MOVE SVNORM TO ALNORM
              MOVE SVANTI TO ALANTI.
           MOVE 'AMMORTAMENTO IN:' TO ST-AMRD.
           MOVE IF-NUMMES TO ST-NUME.
           MOVE '/'       TO ST-BARR.
           MOVE 12        TO ST-DODI.
           IF ANA-MSIN NOT = 12 AND > IF-NUMMES
      **** rel 6.3
      *       COMPUTE COMOD2 = ((ALNORM * IF-NUMMES / 12) *
      *                          ANA-MSIN / 12) + 0,0009
      *    ELSE
      *       COMPUTE COMOD2 = ALNORM * IF-NUMMES / 12 + 0,0009.
      *    MOVE COMOD2 TO ALNORM.
      *    COMPUTE COMOD2 = ALNORMF * SAVMES    / 12 + 0,0009.
      *    MOVE COMOD2 TO ALNORMF.
      *    COMPUTE COMOD2 = ALANTIF * SAVMES    / 12 + 0,0009.
      *    MOVE COMOD2 TO ALANTIF.
              COMPUTE RD-NUM = (ALNORM * IF-NUMMES / 12) *
                                 ANA-MSIN / 12
              CALL 'vrround' USING NNN-D PARRD DEC-2
           ELSE
              COMPUTE RD-NUM = ALNORM * IF-NUMMES / 12
              CALL 'vrround' USING NNN-D PARRD DEC-2.
           MOVE RD-NUM TO ALNORM.
           COMPUTE RD-NUM = ALNORMF * SAVMES / 12.
           CALL 'vrround' USING NNN-D PARRD DEC-2.
           MOVE RD-NUM TO ALNORMF.
           COMPUTE RD-NUM = ALANTIF * SAVMES / 12.
           CALL 'vrround' USING NNN-D PARRD DEC-2.
           MOVE RD-NUM TO ALANTIF.
      ************
           MOVE SAVMES TO IF-NUMMES.
       BC020.
           IF IF-TIPLAV = 2 GO TO BC021.
           MOVE 'CODICE : ' TO ST-CODI.
           MOVE KAN-RAG     TO ST-CRAG.
           MOVE '/'         TO ST-CRAGB.
           MOVE KAN-COD TO ST-CDBE.
           MOVE '.'     TO ST-PUNT.
           MOVE KAN-INC TO ST-INCR.
           MOVE 1 TO XCRR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           IF ANA-DESBEN2 = SPACES GO TO BC021.
           MOVE ANA-DESBEN2 TO ST-DESC.
           MOVE 1 TO XCRR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
       BC021.
           MOVE 'DATI INIZIO ESER. CIVILI' TO ST-DSMO.
           MOVE ZERO TO VARUTIL.
           MOVE ANA-VALAMM TO ACQUIS.
           MOVE ANA-VALACQ TO ST-VACQUISTO.
           MOVE ANA-VALAMM TO VALAMM ST-VAMM.
           MOVE ANA-VALAMMF TO VALAMMF.
           MOVE ANA-COEDFI  TO PDEDFIS.
           COMPUTE PDEDFISCH = PDEDFIS / 100.

           MOVE ANA-TOTACIV TO ACANTO ACCANT TOTACIV.
           MOVE ANA-TOTAFIS TO TOTAFIS COMTFIS.
           COMPUTE RESFIS = ( VALAMMF * PDEDFISCH ) - TOTAFIS.
           MOVE ACCANT TO ST-ACCA.
           IF NONAMM = ZERO
              MOVE ZERO TO PERCNO
           ELSE
              COMPUTE PERCNO = (NONAMM * 100) / VALAMM.
           ADD ACQUIS TO LA3-COSIN.
           ADD ACCANT TO LA3-ACCIN.
      **** rel 6.2
      **** rel 6.3
      *    MOVE ANA-NONAMM TO LA3-NONAM.
           ADD ANA-NONAMM TO LA3-NONAM.
      ************
      ************
           IF IF-TIPLAV = 2 GO TO BC022.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
       BC022.
           MOVE KAN-AZI TO KAM-AZI.
           MOVE KAN-RAG TO KAM-RAG.
           MOVE KAN-COD TO KAM-COD.
           MOVE KAN-INC TO KAM-INC.
           MOVE ZERO TO KAM-DAT KAM-PRG.

           MOVE ' ' TO SWD.
           MOVE ' ' TO SW3 SW1.
      **** rel 7.1
           MOVE ZERO TO FLGDEL.
      ************
           START MOVAMM KEY NOT < KEYAM INVALID GO TO BC10.
       BC03.
           READ MOVAMM NEXT AT END GO TO BC10.
           IF SF-AMM = '9D' OR '9A' OR '35' GO TO BC03.
           IF KAM-AZI > KAN-AZI GO TO BC10.
           IF KAM-RAG > KAN-RAG GO TO BC10.
           IF KAM-COD > KAN-COD GO TO BC10.
           IF KAM-INC > KAN-INC GO TO BC10.
           IF KAM-DAT < INIESK OR > FINESK GO TO BC03.
           MOVE KAM-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO ST-DATA.
           MOVE 1 TO SW-STA.
           MOVE SPACE TO ST-DSMO.
           IF IF-TIPLAV = 2 GO TO AMM1.
           MOVE ZERO TO K1.
           MOVE 1 TO K2.
       AMM0.
           ADD 1 TO K1 K2.
           MOVE AMM-DSCRI(K1) TO ST-DSMO.
           IF K2 > 5 OR AMM-DSCRI(K2) = SPACE GO TO AMM1.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           GO TO AMM0.
       AMM1.
           IF AMM-TIPO = ZERO AND IF-TIPLAV = 2 GO TO BC05.
           IF AMM-TIPO = ZERO
              MOVE 'RIG3' TO RP-BLK
              PERFORM RST THRU EX-RST
      *  
              GO TO BC05.
           IF AMM-TIPO NOT = 1 GO TO AMM2.
              MOVE '*' TO SW1
           IF AMM-IMPORF NOT = ZERO
              MOVE '( Fiscale  ' TO FILLERX
              MOVE ')' TO FILLER1.

           IF AMM-IMPOR NOT = ZERO
              MOVE '( Civile ' TO ST-VACQUISTO-X
              MOVE ')' TO ST-PAR-CH.
           MOVE AMM-IMPOR TO ST-ACQU.
           MOVE AMM-IMPORF TO ST-AMMO.
           ADD AMM-IMPOR TO ACQUIS VALAMM.
           ADD AMM-IMPORF TO VALAMMF ANA-VALAMMF.
           ADD AMM-IMPOR TO LA3-INCRE.
           IF IF-TIPLAV = 2 GO TO BC05.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           GO TO BC05.
       AMM2.
           IF AMM-TIPO NOT = 2 GO TO AMM3.
           IF AMM-IMPORF NOT = ZERO
              MOVE '( Fiscale  ' TO FILLERX
              MOVE ')' TO FILLER1.
           IF AMM-IMPOR NOT = ZERO
              MOVE '( Civile ' TO ST-VACQUISTO-X
              MOVE ')' TO ST-PAR-CH.
           MOVE AMM-IMPOR TO ST-ACQU.
           MOVE AMM-IMPORF TO ST-AMMO.
           ADD AMM-IMPOR TO ACCANT.
           ADD AMM-IMPOR TO LA3-INCAM.
           COMPUTE AMM-IMPOR = AMM-IMPOR * (-1).
           ADD AMM-IMPOR TO VALAMM.
           IF IF-TIPLAV = 2 GO TO BC05.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           GO TO BC05.
       AMM3.
           IF AMM-TIPO NOT = 3 GO TO AMM4.
      **** rel 7.1
           MOVE 1 TO FLGDEL.
      ************
           IF AMM-IMPORF NOT = ZERO
           IF ANA-TOTAFIS = ( ANA-VALAMMF * PDEDFISCH )
                   AND NOT = ZERO
             MOVE '( Fiscale  ' TO FILLERX
             MOVE ')' TO FILLER1.
           IF AMM-IMPOR NOT = ZERO
             MOVE '( Civile ' TO ST-VACQUISTO-X
             MOVE ')' TO ST-PAR-CH.
           MOVE '*' TO SWD.
           COMPUTE AMM-IMPOR = AMM-IMPOR * (-1).
           MOVE AMM-IMPOR TO ST-ACQU.
           ADD AMM-IMPOR TO ACQUIS.
           ADD AMM-IMPOR TO LA3-DECRE.
           SUBTRACT NONAMM FROM LA3-NONDE.
           IF IF-TIPLAV = 2 GO TO AMM31.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           MOVE 'UTILIZZO F.DO AMMORTAM.' TO ST-DSMO.
       AMM31.
           IF IF-FLAMM = ZERO GO TO AMM31-00.
           IF T14RAGG  = ZERO GO TO AMM31-00.
           MOVE T14CUTI TO L145-CAUSA.
           MOVE 'A' TO L145-DAVE.
           MOVE 1 TO L145-TIPRG.
           MOVE ZERO TO L145-SEGNO.
           MOVE TAC-CONTO TO L145-PART.
           MOVE ANA-DESBEN TO L145-DESAG L145-DESA2.
           MOVE ACANTO TO L145-IMPOR.
           MOVE TAC-FDORD TO L145-CPART.
           WRITE RF-145 INVALID PERFORM L00-ERR-WDS THRU L99
                                GO TO AMM31-00.
           ADD 1 TO K145-PROG.
           READ WDS145 INVALID MOVE ZERO TO REC145
                               MOVE SPACE TO L145-DESAG L145-DESA2.
           IF ACANTA = ZERO GO TO AMM31-00.
           GO TO AMM31-00.
      *    MOVE T14CUTI TO L145-CAUSA.
      *    MOVE 'A'        TO L145-DAVE.
      *    MOVE 1          TO L145-TIPRG.
      *    MOVE ZERO       TO L145-SEGNO.
      *    MOVE TAC-CONTO  TO L145-PART.
      *    MOVE ANA-DESBEN TO L145-DESAG L145-DESA2.
      *    MOVE ANA-FONANT TO L145-IMPOR.
      *    MOVE TAC-FDANT  TO L145-CPART.
      *    WRITE RF-145 INVALID PERFORM L00-ERR-WDS THRU L99
      *                         GO TO AMM31-00.
      *    ADD 1 TO K145-PROG.
      *    READ WDS145 INVALID MOVE ZERO TO REC145.
       AMM31-00.
           IF AMM-IMPORF NOT = ZERO
              MOVE '( Fiscale  ' TO FILLERX
              MOVE ')' TO FILLER1.
           IF AMM-IMPOR NOT = ZERO
              MOVE '( Civile ' TO ST-VACQUISTO-X
              MOVE ')' TO ST-PAR-CH.
           MOVE ACCANT TO ST-ACQU.
           MOVE AMM-IMPORF TO ST-AMMO.
           ADD ACCANT TO UTILIZ.
           ADD ACANTO TO UTILOZ.
           ADD ACANTA TO UTILAZ.
           COMPUTE ACCANT = ACCANT * (-1).
           MULTIPLY -1 BY ACANTO ACANTA.
           ADD ACCANT TO ACQUIS.
           ADD ACCANT TO LA3-DECRE LA3-UTAMM.
           ADD UTILIZ TO ACCANT.
           ADD UTILOZ TO ACANTO.
           ADD UTILAZ TO ACANTA.
           IF IF-TIPLAV = 2 GO TO AMM32.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
       AMM32.
           IF ACQUIS = ZERO GO TO AMM32-01.
           IF ACQUIS > ZERO GO TO AMM33.
           MOVE 'PLUSVALENZA' TO ST-DSMO.
           MOVE ACQUIS TO COMODO.
           COMPUTE COMODO = COMODO * (-1).
           IF IF-FLAMM = ZERO GO TO AMM32-00.
           IF T14RAGG = ZERO ADD COMODO TO TOTPLU
                             GO TO AMM32-00.
           MOVE T14CPLU    TO L145-CAUSA.
           MOVE 'D'        TO L145-DAVE.
           MOVE 1          TO L145-TIPRG.
           MOVE ZERO       TO L145-SEGNO.
           MOVE TAC-CONTO  TO L145-PART.
           MOVE ANA-DESBEN TO L145-DESAG L145-DESA2.
           MOVE COMODO     TO L145-IMPOR.
           MOVE PLUSV      TO L145-CPART.
           WRITE RF-145 INVALID PERFORM L00-ERR-WDS THRU L99
                                GO TO AMM32-00.
           ADD 1 TO K145-PROG.
           READ WDS145 INVALID MOVE ZERO TO REC145
                               MOVE SPACE TO L145-DESAG L145-DESA2.
       AMM32-00.
           IF AMM-TIPO = 3
           MOVE '*' TO SW3.
           IF AMM-IMPORF NOT = ZERO
              MOVE '( Fiscale  ' TO FILLERX
              MOVE ')' TO FILLER1.
           IF AMM-IMPOR NOT = ZERO
              MOVE '( Civile ' TO ST-VACQUISTO-X
              MOVE ')' TO ST-PAR-CH.
           MOVE COMODO TO ST-ACQU.
           MOVE AMM-IMPORF TO ST-AMMO.
           ADD COMODO TO ACQUIS.
           ADD COMODO TO LA3-DECRE LA3-PLUSV.
           MOVE ZERO TO COMODO PERCNO.
           IF IF-TIPLAV = 2 GO TO BC05.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           IF AMM-TIPO NOT = 3 GO TO BC05.
           IF ANA-VARRET = ZERO GO TO BC05.
           MOVE AMM-TIPO TO FLGTPAM.
           MOVE 'VAR. RETTIF. STORNATE' TO ST-DSMO.
           MOVE '(' TO ST-PAR-AP.
           MOVE ')' TO ST-PAR-CH.
           ADD ANA-VARRET TO VARALI.
           MOVE ANA-VARRET TO ST-ACQU.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           GO TO BC05.
       AMM32-01.
           MOVE '*' TO SW3.
           MOVE ZERO TO PERCNO.
           IF IF-TIPLAV = 2 GO TO BC05.
           IF ANA-VARRET = ZERO GO TO BC05.
           MOVE AMM-TIPO TO FLGTPAM.
           MOVE 'VAR. RETTIF. STORNATE' TO ST-DSMO.
           MOVE '(' TO ST-PAR-AP.
           MOVE ')' TO ST-PAR-CH.
           ADD ANA-VARRET TO VARALI.
           MOVE ANA-VARRET TO ST-ACQU.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           GO TO BC05.
       AMM33.
           MOVE 'MINUSVALENZA' TO ST-DSMO.
           MOVE ACQUIS TO COMODO.
           IF IF-FLAMM = ZERO GO TO AMM33-00.
           IF T14RAGG = ZERO ADD COMODO TO TOTMIN
                             GO TO AMM33-00.
           MOVE T14CMIN    TO L145-CAUSA.
           MOVE 'A'        TO L145-DAVE.
           MOVE 1          TO L145-TIPRG.
           MOVE ZERO       TO L145-SEGNO.
           MOVE TAC-CONTO  TO L145-PART.
           MOVE ANA-DESBEN TO L145-DESAG L145-DESA2.
           MOVE COMODO     TO L145-IMPOR.
           MOVE MINUS      TO L145-CPART.
           WRITE RF-145 INVALID PERFORM L00-ERR-WDS THRU L99
                                GO TO AMM33-00.
           ADD 1 TO K145-PROG.
           READ WDS145 INVALID MOVE ZERO TO REC145
                               MOVE SPACE TO L145-DESAG L145-DESA2.
       AMM33-00.
           MOVE '*' TO SW3
           COMPUTE COMODO = COMODO * (-1).
           MOVE COMODO TO ST-ACQU.
           ADD COMODO TO ACQUIS.
           ADD COMODO TO LA3-DECRE LA3-MINUS.
           MOVE ZERO TO COMODO PERCNO.
           IF IF-TIPLAV = 2 GO TO BC05.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           IF AMM-TIPO NOT = 3 GO TO BC05.
           IF ANA-VARRET = ZERO GO TO BC05.
           MOVE AMM-TIPO TO FLGTPAM.
           MOVE 'VAR. RETTIF. STORNATE' TO ST-DSMO.
           MOVE '(' TO ST-PAR-AP.
           MOVE ')' TO ST-PAR-CH.
           ADD ANA-VARRET TO VARALI.
           MOVE ANA-VARRET TO ST-ACQU.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           GO TO BC05.
       AMM4.
           IF AMM-TIPO NOT = 4 GO TO AMM5.
           IF AMM-IMPOR NOT = ZERO
             MOVE '( Civile ' TO ST-VACQUISTO-X
             MOVE ')' TO ST-PAR-CH.
           COMPUTE AMM-IMPOR = AMM-IMPOR * (-1).
           MOVE AMM-IMPOR TO ST-ACQU.
           ADD AMM-IMPOR TO ACQUIS VALAMM COMODO.
           IF ( ANA-VALAMMF * PDEDFISCH ) NOT = ANA-TOTAFIS
              ADD AMM-IMPOR TO VALAMMF.
           ADD AMM-IMPOR TO LA3-DECRE.
           IF IF-TIPLAV = 2 GO TO BC05.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           GO TO BC05.
       AMM5.
           IF AMM-TIPO NOT = 5 GO TO AMM6.
           IF ANA-FONANT = ZERO MOVE ZERO TO UTILA
                                MOVE AMM-IMPOR TO UTILO
                                GO TO AMM51-00.
           COMPUTE RD-NUM = ((ANA-FONANT / ACCANT) * AMM-IMPOR).
           CALL 'vrround' USING NNN-E PARRD DEC-2.
           MOVE RD-NUM TO UTILA.
           IF UTILA > ANA-FONANT MOVE ANA-FONANT TO UTILA.
           COMPUTE UTILO = AMM-IMPOR - UTILA.
       AMM51-00.
           IF IF-FLAMM = ZERO GO TO AMM5-00.
           IF T14RAGG  = ZERO GO TO AMM5-00.
           MOVE T14CUTI    TO L145-CAUSA.
           MOVE 'A'        TO L145-DAVE.
           MOVE 1          TO L145-TIPRG.
           MOVE ZERO       TO L145-SEGNO.
           MOVE TAC-CONTO  TO L145-PART.
           MOVE ANA-DESBEN TO L145-DESAG L145-DESA2.
           MOVE UTILO      TO L145-IMPOR.
           MOVE TAC-FDORD  TO L145-CPART.
           WRITE RF-145 INVALID PERFORM L00-ERR-WDS THRU L99
                                GO TO AMM5-00.
           ADD 1 TO K145-PROG.
           READ WDS145 INVALID MOVE ZERO TO REC145
                               MOVE SPACE TO L145-DESAG L145-DESA2.
           IF UTILA = ZERO GO TO AMM5-00.
           GO TO AMM5-00.
      *    MOVE T14CUTI    TO L145-CAUSA.
      *    MOVE 'A'        TO L145-DAVE.
      *    MOVE 1          TO L145-TIPRG.
      *    MOVE ZERO       TO L145-SEGNO.
      *    MOVE TAC-CONTO  TO L145-PART.
      *    MOVE ANA-DESBEN TO L145-DESAG L145-DESA2.
      *    MOVE UTILA      TO L145-IMPOR.
      *    MOVE TAC-FDANT  TO L145-CPART.
      *    WRITE RF-145 INVALID PERFORM L00-ERR-WDS THRU L99
      *                         GO TO AMM5-00.
      *    ADD 1 TO K145-PROG.
      *    READ WDS145 INVALID MOVE ZERO TO REC145
      *                        MOVE SPACE TO L145-DESAG L145-DESA2.
       AMM5-00.
           IF AMM-IMPORF NOT = ZERO
      **** rel 6.3
      *      IF (ANA-TOTAFIS NOT = ( ANA-VALAMMF * PDEDFISCH ))
      ************
              OR AMM-SWTIPO5 = 1
             MOVE '( Fiscale  ' TO FILLERX
             MOVE ')' TO FILLER1.
           IF AMM-IMPOR NOT = ZERO
             MOVE '( Civile ' TO ST-VACQUISTO-X
             MOVE ')' TO ST-PAR-CH.
           IF AMM-DESCR = SPACE
              MOVE 'UTILIZZO F.DO AMMORTAM.' TO ST-DSMO.
           COMPUTE VARUTIL = VARUTIL + AMM-IMPORF - AMM-IMPOR.
           ADD AMM-IMPOR TO UTILIZ.
           SUBTRACT AMM-IMPOR FROM TOTACIV.
      **** rel 6.3
      *    IF (( ANA-VALAMMF * PDEDFISCH ) NOT = ANA-TOTAFIS
      *      AND SW1 NOT = '*')
           IF SW1 NOT = '*'
      ************
             OR AMM-SWTIPO5 = 1
               SUBTRACT AMM-IMPORF FROM TOTAFIS COMTFIS.
           ADD UTILO TO UTILOZ.
           ADD UTILA TO UTILAZ.
           COMPUTE AMM-IMPOR = AMM-IMPOR * (-1).
           COMPUTE AMM-IMPORF = AMM-IMPORF * (-1).
           MULTIPLY -1 BY UTILO UTILA.
           MOVE AMM-IMPOR TO ST-ACQU.
      **** rel 6.3
      *    IF (( ANA-VALAMMF * PDEDFISCH ) NOT = ANA-TOTAFIS
      *      AND SW1 NOT = '*')
           IF SW1 NOT = '*'
      ************
             OR AMM-SWTIPO5 = 1
                MOVE AMM-IMPORF TO ST-AMMO.
           ADD AMM-IMPOR TO ACQUIS ACCANT VALAMM COMODO.
      **** rel 6.3
      *    IF (( ANA-VALAMMF * PDEDFISCH ) NOT = ANA-TOTAFIS
      *      AND SW1 NOT = '*')
           IF SW1 NOT = '*'
      ************
             OR AMM-SWTIPO5 = 1
                ADD AMM-IMPORF TO VALAMMF.
           IF SW5 = '*'
               ADD AMM-IMPORF TO ACCANTF.
           ADD UTILO TO ACANTO.
           ADD UTILA TO ACANTA.
           MOVE ZERO TO UTILO UTILA.
           ADD AMM-IMPOR TO LA3-DECRE LA3-UTAMM.
           IF IF-TIPLAV = 2 GO TO BC05.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           GO TO BC05.
       AMM6.
           IF AMM-TIPO NOT = 6 GO TO AMM7.
           IF AMM-IMPOR NOT = ZERO
             MOVE '( Civile ' TO ST-VACQUISTO-X
             MOVE ')' TO ST-PAR-CH.
           IF AMM-IMPOR = ZERO GO TO BC05.
           IF IF-FLAMM = ZERO GO TO AMM6-00.
           IF T14RAGG = ZERO ADD AMM-IMPOR TO TOTPLU
                             GO TO AMM6-00.
           MOVE T14CPLU    TO L145-CAUSA.
           MOVE 'D'        TO L145-DAVE.
           MOVE 1          TO L145-TIPRG.
           MOVE ZERO       TO L145-SEGNO.
           MOVE TAC-CONTO  TO L145-PART.
           MOVE ANA-DESBEN TO L145-DESAG L145-DESA2.
           MOVE AMM-IMPOR  TO L145-IMPOR.
           MOVE PLUSV      TO L145-CPART.
           WRITE RF-145 INVALID PERFORM L00-ERR-WDS THRU L99
                                GO TO AMM6-00.
           ADD 1 TO K145-PROG.
           READ WDS145 INVALID MOVE ZERO TO REC145
                               MOVE SPACE TO L145-DESAG L145-DESA2.
       AMM6-00.
           IF AMM-DESCR = SPACE MOVE 'PLUSVALENZA' TO ST-DSMO.
           MOVE AMM-IMPOR TO ST-ACQU.
           ADD AMM-IMPOR TO ACQUIS VALAMM COMODO.
           IF ( ANA-VALAMMF * PDEDFISCH ) NOT = ANA-TOTAFIS
              ADD AMM-IMPORF TO VALAMMF.
           ADD AMM-IMPOR TO LA3-DECRE LA3-PLUSV.
           IF IF-TIPLAV = 2 GO TO BC05.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           GO TO BC05.
       AMM7.
           IF AMM-TIPO NOT = 7 GO TO AMM8.
           IF AMM-IMPOR = ZERO GO TO BC05.
           IF IF-FLAMM = ZERO GO TO AMM7-00.
           IF T14RAGG = ZERO ADD AMM-IMPOR TO TOTMIN
                             GO TO AMM7-00.
           MOVE T14CMIN    TO L145-CAUSA.
           MOVE 'A'        TO L145-DAVE.
           MOVE 1          TO L145-TIPRG.
           MOVE ZERO       TO L145-SEGNO.
           MOVE TAC-CONTO  TO L145-PART.
           MOVE ANA-DESBEN TO L145-DESAG L145-DESA2.
           MOVE AMM-IMPOR  TO L145-IMPOR.
           MOVE MINUS      TO L145-CPART.
           WRITE RF-145 INVALID PERFORM L00-ERR-WDS THRU L99
                                GO TO AMM7-00.
           ADD 1 TO K145-PROG.
           READ WDS145 INVALID MOVE ZERO TO REC145
                               MOVE SPACE TO L145-DESAG L145-DESA2.
       AMM7-00.
           IF AMM-IMPOR NOT = ZERO
             MOVE '( Civile ' TO ST-VACQUISTO-X
             MOVE ')' TO ST-PAR-CH.
           IF AMM-DESCR = SPACE MOVE 'MINUSVALENZA' TO ST-DSMO.
           COMPUTE AMM-IMPOR = AMM-IMPOR * (-1).
           COMPUTE AMM-IMPORF = AMM-IMPORF * (-1).
           MOVE AMM-IMPOR TO ST-ACQU.
           ADD AMM-IMPOR TO ACQUIS VALAMM COMODO.
           IF ( ANA-VALAMMF * PDEDFISCH ) NOT = ANA-TOTAFIS
              ADD AMM-IMPORF TO VALAMMF.
           ADD AMM-IMPOR TO LA3-DECRE LA3-MINUS.
           IF IF-TIPLAV = 2 GO TO BC05.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           GO TO BC05.
       AMM8.
           IF AMM-TIPO NOT = 8 GO TO AMM9.
           IF AMM-IMPOR = ZERO GO TO BC05.
           IF AMM-IMPOR NOT = ZERO
              MOVE '( Civile ' TO ST-VACQUISTO-X
              MOVE ')' TO ST-PAR-CH.
           IF AMM-DESCR = SPACE
              MOVE 'PLUSVALENZA REINVESTITA' TO ST-DSMO.
           MOVE AMM-IMPOR TO ST-ACQU.
           ADD AMM-IMPOR TO VALAMM COMODO.
           IF IF-TIPLAV = 2 GO TO BC05.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           GO TO BC05.
       AMM9.
           IF AMM-TIPO NOT = 9 GO TO AMM10.
           IF AMM-IMPORF NOT = ZERO
             MOVE '( Fiscale  ' TO FILLERX
             MOVE ')' TO FILLER1.
           IF AMM-IMPOR NOT = ZERO
             MOVE '( Civile ' TO ST-VACQUISTO-X
             MOVE ')' TO ST-PAR-CH.
           MOVE AMM-IMPOR TO ST-ACQU.
           MOVE AMM-IMPORF TO ST-AMMO.
           ADD AMM-IMPOR TO INCAMM TINCAMM.
           ADD AMM-IMPORF TO INCAMMF TINCAMMF.
           ADD VALAMM TO TOTVALC.
           ADD VALAMMF TO TOTVALF.
           ADD AMM-IMPOR TO ACCANT.
           ADD AMM-IMPOR TO ACANTO.
           ADD AMM-IMPOR TO LA3-INCAM.
           IF IF-TIPLAV = 2 GO TO BC05.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           GO TO BC05.
       AMM10.
           IF AMM-IMPORF NOT = ZERO
              MOVE '( Fiscale  ' TO FILLERX
              MOVE ')' TO FILLER1.
           IF AMM-IMPOR NOT = ZERO
              MOVE '( Civile ' TO ST-VACQUISTO-X
              MOVE ')' TO ST-PAR-CH.
           ADD AMM-IMPOR TO NONAMM.
           ADD AMM-IMPOR TO LA3-NONIN.
      **** rel 6.2
           SUBTRACT AMM-IMPOR FROM LA3-INCRE.
      ************
           ADD AMM-IMPORF TO NONAMMF.
           COMPUTE AMM-IMPOR = AMM-IMPOR * -1.
           COMPUTE AMM-IMPORF = AMM-IMPORF * -1.
           ADD AMM-IMPOR TO VALAMM.
           ADD AMM-IMPORF TO VALAMMF.
           MOVE AMM-IMPOR TO ST-ACQU.
           MOVE AMM-IMPORF TO ST-AMMO.
           IF IF-TIPLAV = 2 GO TO BC05.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
       BC05.
           GO TO BC03.
       BC10.
           IF SW-STA = ZERO GO TO BC20.
           IF VARUTIL NOT = ZERO
              AND SW3 NOT = '*'
                 ADD VARUTIL TO VARALI
                 MOVE 'VAR. RETTIF. STORNATE' TO ST-DSMO
                 MOVE '(' TO ST-PAR-AP
                 MOVE ')' TO ST-PAR-CH
                 MOVE VARUTIL TO ST-ACQU
                 MOVE 'RIG3' TO RP-BLK
                 PERFORM RST THRU EX-RST.
      *  
           IF PERCNO NOT = ZERO
              COMPUTE COMOD1 = (COMODO * PERCNO) / 100
              MOVE COMOD1 TO RD-NUM
              CALL 'vrround' USING NNN-E PARRD DEC-2
              MOVE RD-NUM TO COMOD1
              MOVE COMOD1 TO COMODO
              ADD COMODO TO NONAMM
              ADD COMODO TO LA3-NONDE
              MOVE ZERO TO PERCNO COMODO COMOD1.
           MOVE ZERO TO SW-STA.
           IF ACQUIS = ZERO MOVE ZERO TO VALAMM NONAMM VALAMMF NONAMMF.
      **** rel 6.2
           IF ACQUIS = ZERO MOVE ZERO TO TOTAFIS COMTFIS.
      ************
           IF IF-TIPLAV = 2 GO TO BC20.
           MOVE ALL '-' TO SOTTOL.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG6' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           MOVE ACQUIS TO ST-ACQU.
           MOVE UTILIZ TO ST-UTIL.
           IF SW3 NOT = '*'
              MOVE ACCANT TO ST-ACCA.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
       BC20.
           IF T25ESE = ZERO AND
              ANA-ANACQ NOT = IF-ESERC
                 MOVE ZERO TO ANA-AMTOES ANA-AMESER.
           IF T25ESE NOT = ZERO
              COMPUTE ANACQ = IF-ESERC - ANA-ANACQ
              IF (ANACQ   = 1)       AND
                 NOT (ANA-ANACQ >= AAAPE AND ANA-MSACQ >= MMAPE)
                     MOVE ZERO TO ANA-AMESER ANA-AMTOES.
           IF ANA-ANSCAD > ZERO COMPUTE ANNI = ANA-ANSCAD - 1.
           IF (T25ESE NOT = ZERO) AND
              (ANA-ANACQ >= AAAPE AND ANA-MSACQ >= MMAPE)
              IF ANA-TIPBEN = 4 AND (ANA-ANACQ NOT < (IF-ESERC - 1))
                 GO TO BC80.
           IF ANA-TIPBEN = 4 AND ANA-ANACQ NOT < IF-ESERC GO TO BC80.
           IF ANA-TIPBEN = 1 AND ANA-ANSCAD = ZERO GO TO BC25.
           IF ANA-TIPBEN = 1 AND ANA-ANSCAD < IF-ESERC GO TO BC80.
           IF ANA-TIPBEN = 2 AND ANA-ANSCAD = ZERO GO TO BC25.
           IF ANA-TIPBEN = 2 AND ANNI < IF-ESERC GO TO BC80.
       BC25.
           MOVE ZERO TO COMODO RESID.
           IF SW3 = '*'
              MOVE NONAMM TO COMODO
              MOVE ZERO TO ACCANT
           ELSE
              COMPUTE COMODO = NONAMM + ACCANT.
           COMPUTE RESID  = ACQUIS - COMODO.
      **** rel 6.2
      *    COMPUTE RESFIS = ( VALAMMF * PDEDFISCH ) - ANA-TOTAFIS.
           COMPUTE RESFIS = ( VALAMMF * PDEDFISCH ) - TOTAFIS.
      ************
      **** rel 7.1
      *    IF RESID NOT > ZERO
      *       IF RESFIS > ZERO
           IF RESID NOT > ZERO AND
              RESFIS NOT > ZERO
      ************
                 PERFORM CALC-FISCALE THRU C99
      **** rel 7.1
      *       END-IF
      *       GO TO BC80.
                 GO TO BC80.
      ************
           IF ACQUIS = VALAMM GO TO BC30.
           IF NONAMM = ZERO GO TO BC30.
           COMPUTE RESID = VALAMM - ACCANT.
           COMPUTE RESFIS = ( VALAMMF * PDEDFISCH ) - ANA-TOTAFIS.
           IF RESID NOT > ZERO
              IF RESFIS > ZERO
                 PERFORM CALC-FISCALE THRU C99
              END-IF
              GO TO BC80.
       BC30.
           MOVE ANA-AMESER TO AMTOESF.
           MOVE ANA-AMTOES TO AMTOES.
           IF AMTOESF = 1
              IF ALNORMF = ZERO MOVE 100 TO ALNORMF.
           IF AMTOES = 1
              IF ALNORM = ZERO MOVE 100 TO ALNORM.
           MOVE ZERO TO COMOD1.
           COMPUTE COMOD1 = (VALAMM * ALNORM) / 100.
           MOVE COMOD1 TO RD-NUM.
           CALL 'vrround' USING NNN-E PARRD DEC-2.
           MOVE RD-NUM TO COMOD1.
           MOVE COMOD1 TO AMMENS.
           IF VALAMMF NOT = ZERO
              IF TOTAFIS = ( VALAMMF * PDEDFISCH ) GO TO BC31.
           MOVE ZERO TO COMOD1.
           COMPUTE COMODX = (VALAMMF * ALNORMF) / 100.
           COMPUTE COMOD1 = (((VALAMMF * ALNORMF) / 100) *
                            PDEDFIS) / 100.
           MOVE COMOD1 TO RD-NUM.
           CALL 'vrround' USING NNN-E PARRD DEC-2.
           MOVE RD-NUM TO COMOD1.
           MOVE COMOD1 TO AMMENSF.
       BC31.
           ADD INCAMMF TO AMMENSF.
           IF AMTOES = 1
              MOVE VALAMM TO AMMENS
              IF ALNORM = ZERO MOVE VALAMM TO AMMENS
              ELSE MOVE VALAMM TO AMMENSTC.
           IF AMTOESF = 1
              MOVE VALAMMF TO AMMENSF
              IF ALNORMF = ZERO MOVE VALAMMF TO AMMENSF
              ELSE MOVE VALAMMF TO AMMENST.
           IF AMMENS > RESID
              MOVE RESID TO AMMENS
      **** rel 7.1
      *       COMPUTE RD-NUM = AMMENS * IF-NUMMES / 12 
      *       CALL 'vrround' USING NNN-E PARRD DEC-2
      *       MOVE RD-NUM TO AMMENS
      ************
              COMPUTE COMOD1 = AMMENS * 100
      **** rel 6.3
      *       COMPUTE COMOD2 = COMOD1 / VALAMM + 0,0009
      *       MOVE COMOD2 TO ALNORM.
              COMPUTE RD-NUM = COMOD1 / VALAMM 
              CALL 'vrround' USING NNN-D PARRD DEC-2
              MOVE RD-NUM TO ALNORM.
      ************
           SUBTRACT AMMENS FROM RESID.
           IF VALAMMF NOT = ZERO
              IF TOTAFIS = ( VALAMMF * PDEDFISCH ) GO TO BC31-A.
           MOVE ZERO TO VARRET.
           IF ANA-AMESER = ZERO
              IF AMMENSF > RESFIS
                 MOVE RESFIS TO AMMENSF COMODX
      **** rel 7.1
      *          COMPUTE RD-NUM = AMMENSF * IF-NUMMES / 12  
      *          CALL 'vrround' USING NNN-E PARRD DEC-2
      *          MOVE RD-NUM TO AMMENSF
      ************
                 COMPUTE COMOD1 = AMMENSF * 100
      **** rel 6.3
      *          COMPUTE COMOD2 = COMOD1 / VALAMMF + 0,0009
      *          MOVE COMOD2 TO ALNORMF
                 COMPUTE RD-NUM = COMOD1 / VALAMMF
                 CALL 'vrround' USING NNN-D PARRD DEC-2
                 MOVE RD-NUM TO ALNORMF
      ************
              END-IF
           ELSE
              MOVE RESFIS TO AMMENSF.
           SUBTRACT AMMENSF FROM RESFIS.

       BC31-A.
      *> calcola variazione rettificativa come differenze fra
      *> quota amm. fiscale e quota civilistica
           COMPUTE VARRET = AMMENSF - (AMMENS + INCAMM).
      ************
       BC32.
           MOVE 'AMMORTAMENTO ESER. CIVILE' TO ST-DSMO.
           MOVE VALAMM TO ST-VAMM.
           MOVE ALNORM TO ST-PERC.
           IF AMTOES = 1 AND ALNORM = ZERO
              MOVE 100,00 TO ST-PERC1
              MOVE 100 TO PERCOM
           ELSE
              MOVE ALNORM TO PERCOM.
           MOVE 1 TO K1.
           MOVE ZERO TO K2.
       BC32-00.
           ADD 1 TO K2.
      **** rel 6.3
           MOVE PERCOM TO PERCOM1.
           IF PERCOM1 = ZERO
             MOVE 888,888 TO PERCOM1.
      ************
           IF LA3-ALIQ(K1 K2) = ZERO AND LA3-IMPO(K1 K2) = ZERO
      **** rel 6.3
      *       MOVE PERCOM  TO LA3-ALIQ(K1 K2)
              MOVE PERCOM1 TO LA3-ALIQ(K1 K2)
      ************
              MOVE AMMENS  TO LA3-IMPO(K1 K2)
              MOVE VALAMM  TO LA3-VALA(K1 K2)
              GO TO BC32-10.
      **** rel 6.3
      *    IF LA3-ALIQ(K1 K2) = PERCOM
           IF LA3-ALIQ(K1 K2) = PERCOM1
      ************
              ADD AMMENS  TO LA3-IMPO(K1 K2)
              ADD VALAMM  TO LA3-VALA(K1 K2)
              GO TO BC32-10.
           IF K2 = 20
              MOVE 999,999 TO LA3-ALIQ(K1 K2)
              ADD VALAMM   TO LA3-VALA(K1 K2)
              ADD AMMENS   TO LA3-IMPO(K1 K2)
              GO TO BC32-10.
           GO TO BC32-00.
       BC32-10.
           MOVE AMMENS TO ST-AMMO ST-ACCA.
           ADD AMMENS TO ACCANT TAMMORD.
           ADD AMMENS TO ACANTO.
           IF IF-TIPLAV = 3
              IF AMTOESF = 1
                 IF ALNORMF = ZERO
                    ADD AMMENSF TO TOTAFIS
                 ELSE
                    ADD AMMENST TO TOTAFIS
                 END-IF
              ELSE
                 ADD AMMENSF TO TOTAFIS
              END-IF
              IF AMTOES = 1
                 IF ALNORM = ZERO
                    ADD AMMENS TO TOTACIV
                 ELSE
                    ADD AMMENSTC TO TOTACIV
                 END-IF
              ELSE
                 ADD AMMENS TO TOTACIV
              END-IF
           ELSE
              IF AMTOESF = 1
                 IF ALNORMF = ZERO
                    ADD AMMENSF TO COMTFIS
                 ELSE
                    ADD AMMENST TO COMTFIS
                 END-IF
              ELSE
                 ADD AMMENSF TO COMTFIS.

           ADD VALAMM TO TIMPORD.
       BC35.
           IF IF-TIPLAV = 2 GO TO BC351.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           IF IF-TIPLAV NOT = 3
              COMPUTE RESFIS = ( VALAMMF * PDEDFISCH ) - COMTFIS
           ELSE
              COMPUTE RESFIS = ( VALAMMF * PDEDFISCH ) - TOTAFIS.
           IF AMTOES = 1      AND
              VALAMM = AMMENS AND
              RESID  = ZERO   GO TO BC351.
           IF RESFIS = ZERO AND VARRET > ZERO
              GO TO BC351.
           IF RESFIS NOT = ZERO GO TO BC351.

           MOVE ZERO TO COMOD1.
           COMPUTE COMOD1 = AMMENSF + AMMANTF.
           IF COMOD1 NOT < AMMENS MOVE ZERO TO COMOD1.
           IF COMOD1 > ZERO
              MOVE ZERO TO VARAUM
              IF COMOD1 NOT < AMMENS
                 COMPUTE VARAUM = AMMENS - COMOD1
              END-IF
           ELSE
              MOVE ZERO TO VARAUM
              IF (AMMENSF + AMMANTF) NOT < AMMENS
                 COMPUTE VARAUM = AMMENS - RESFIS.
      **** rel 6.3
           IF VARAUM = AMMENSF + AMMANTF
             MOVE ZERO TO VARAUM.
      ************
           IF VARAUM > ANA-VARRET AND
              ANA-VARRET = ZERO
              AND RESID = ZERO
              AND RESFIS = ZERO
                 MOVE ANA-VARRET TO VARAUM.
           IF VARAUM >= ANA-VARRET
             AND NOT = ZERO
                                  MOVE VARAUM TO VARRET
                                  MULTIPLY -1 BY VARRET
                                  MOVE ZERO TO VARAUM.

           IF VARAUM = ZERO GO TO BC351.

           ADD INCAMMF TO AMMENSF.
           IF IF-TIPLAV = 3
              IF TOTAFIS > ( VALAMMF * PDEDFISCH )
                 COMPUTE TOTAFIS = TOTAFIS - VARAUM.
           IF IF-TIPLAV NOT = 3
              IF COMTFIS > ( VALAMMF * PDEDFISCH )
                 COMPUTE COMTFIS = COMTFIS - VARAUM.
           IF ANA-VARRET < ZERO
                 MOVE ZERO TO VARAUM.
      ************
       BC351.
           IF SW-STA = 1 MOVE ZERO TO SW-STA GO TO BC80.
           IF RESID NOT > ZERO GO TO BC80.
           IF AMTOES = 1       AND
              VALAMM = AMMENSTC AND
              RESID  > ZERO
              IF ALNORM NOT = ZERO MOVE RESID TO VARRET
                                   GO TO BC80.
           IF ALANTI = ZERO GO TO BC80.
           COMPUTE COMODO = IF-ESERC - ANA-ANACQ.
           IF (T25ESE NOT = ZERO) AND
              (ANA-ANACQ <= AAAPE  AND ANA-MSACQ >= MMAPE)
                 COMPUTE COMODO = (IF-ESERC - 1) - ANA-ANACQ.
           IF ANA-STATO = 1 AND IF-ESERC > 1988 AND ANA-ANACQ > 1987
              IF ANA-RES > ZERO
                 COMPUTE COMODO = COMODO + 3 - ANA-RES
              ELSE
                 GO TO BC80.
           IF COMODO NOT < 3
              MOVE ZERO TO COMODO
              GO TO BC351-A.
           IF COM-AMESER = 1 AND IF-NUMMES < 12 
              MOVE ZERO TO COMODO
              GO TO BC351-A.
           COMPUTE COMODY = (VALAMMF * ALANTIF) / 100.
           COMPUTE COMOD1 = (((VALAMMF * ALANTIF) / 100) *
                             PDEDFIS) / 100.
           MOVE COMOD1 TO RD-NUM.
           CALL 'vrround' USING NNN-E PARRD DEC-2.
           MOVE RD-NUM TO COMOD1.
           MOVE COMOD1 TO COMODO.

           IF COMODO > RESFIS
              MOVE RESFIS TO COMODO
              COMPUTE COMOD1 = COMODO * 100
      **** rel 6.3
      *       COMPUTE COMOD2 = COMOD1 / VALAMMF + 0,0009
      *       MOVE COMOD2 TO ALANTIF.
              COMPUTE RD-NUM = COMOD1 / VALAMMF
              CALL 'vrround' USING NNN-D PARRD DEC-2
              MOVE RD-NUM TO ALANTIF.
      ************
       BC351-A.
           SUBTRACT COMODO FROM RESFIS.
           MOVE COMODO TO AMMANTF.
           MOVE COMODO TO TOTANT.
           IF IF-TIPLAV = 3
              ADD COMODO TO TOTAFIS
           ELSE
              ADD COMODO TO COMTFIS.

      *> Calcola variazione rettificativa come differenze fra
      *> quota amm. fiscale e quota civilistica
           MOVE ZERO TO VARRET.
           MOVE ZERO TO COMOD1.
           COMPUTE COMOD1 = AMMENSF + AMMANTF.
           COMPUTE VARRET = COMOD1 - AMMENS.

           GO TO BC80.
           MOVE 2 TO K1.
           MOVE ZERO TO K2.
       BC35-00.
           ADD 1 TO K2.
      **** rel 6.3
           MOVE ALANTI TO PERCOM1
           IF PERCOM1 = ZERO
             MOVE 888,888 TO PERCOM1.
      ************
           IF LA3-ALIQ(K1 K2) = ZERO
      **** rel 6.3
      *       MOVE ALANTI TO LA3-ALIQ(K1 K2)
              MOVE PERCOM1 TO LA3-ALIQ(K1 K2)
      ************
              MOVE COMODO TO LA3-IMPO(K1 K2)
              MOVE VALAMM TO LA3-VALA(K1 K2)
              GO TO BC35-10.
      **** rel 6.3
      *    IF LA3-ALIQ(K1 K2) = ALANTI
           IF LA3-ALIQ(K1 K2) = PERCOM1
      ************
              ADD COMODO TO LA3-IMPO(K1 K2)
              ADD VALAMM TO LA3-VALA(K1 K2)
              GO TO BC35-10.
           IF K2 = 20
              MOVE 999,999 TO LA3-ALIQ(K1 K2)
              ADD VALAMM   TO LA3-VALA(K1 K2)
              ADD COMODO   TO LA3-IMPO(K1 K2)
              GO TO BC35-10.
           GO TO BC35-00.
       BC35-10.
           MOVE 'AMMORTAMENTO ANTICIPATO' TO ST-DSMO.
           MOVE ALANTI TO ST-PERC.
           MOVE COMODO TO ST-AMMO ST-ACCA.
           ADD COMODO TO AMMENS ACCANT TAMMANT.
           ADD COMODO TO ACANTA.
           ADD VALAMM TO TIMPANT.
           IF IF-TIPLAV = 2 GO TO BC801.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
       BC80.
           IF IF-TIPLAV = 2 GO TO BC801.
           MOVE ALL '-' TO SOTTOL.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG6' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           MOVE 'VALORI FINE ESER. CIVILI' TO ST-DSMO.
           ADD INCAMM  TO AMMENS.
           MOVE ACQUIS TO ST-VAMM.
           MOVE AMMENS TO ST-AMMO.
           MOVE UTILIZ TO ST-UTIL.
           MOVE ACCANT TO ST-ACCA.
       BC801.
           COMPUTE COMODO = NONAMM + ACCANT.
           COMPUTE RESID  = ACQUIS - COMODO.
           MOVE RESID  TO ST-RESI.
           ADD ACQUIS TO TACQUIS CACQUIS.
           ADD AMMENS TO TAMMENS CAMMENS.
           ADD UTILIZ TO TUTILIZ CUTILIZ.
           ADD NONAMM TO TNONAMM.
           ADD UTILOZ TO TUTILOZ.
           ADD UTILAZ TO TUTILAZ.
           ADD ACCANT TO TACCANT CACCANT.
           ADD RESID  TO TRESID CRESID.
           IF VARRET > ZERO
              IF RESID = ZERO
                IF PDEDFISCH = 1
                   IF ANA-VARRET < ZERO
                      ADD VARRET TO TVARRET 
                   ELSE
                      ADD VARRET TO TVARRET 
                   END-IF
                ELSE
                   MOVE ZERO TO AMMENSF
                END-IF
              ELSE
               ADD VARRET TO TVARRET.
           IF ANA-ANACQ NOT = IF-ESERC
              IF ANA-VARRET > ZERO AND VARRET < 0
                 AND (ANA-VARRET + VARRET) < 0
                    COMPUTE TOTGAUM = TOTGAUM + ANA-VARRET
                    COMPUTE TTGAUM2 = TTGAUM2 - (ANA-VARRET + VARRET)
                    COMPUTE TVARAUM = TVARAUM - VARRET
                    GO TO SALTO.
           IF VARRET < ZERO
              IF RESID NOT = ZERO
              OR (RESID = ZERO AND ANA-TOTACIV NOT = ANA-VALAMM)
                 MOVE VARRET TO COMODO
                 MULTIPLY -1 BY COMODO
                 IF ANA-ANACQ = IF-ESERC
                   ADD COMODO TO TVARAUM TTGAUM2
                 ELSE
                   IF ANA-VARRET > ZERO
                     ADD COMODO TO TVARAUM TOTGAUM
                   ELSE
                     ADD COMODO TO TVARAUM TTGAUM2
                   END-IF
                 END-IF
              ELSE MOVE ZERO TO VARRET.
       SALTO.
           ADD VARAUM TO TVARAUM TOTGAUM.
           ADD VARALI TO TVARALI TOTGALI.
           IF SW3 NOT = '*'           
              ADD AMMENSF TO TAMMFIS
              ADD AMMANTF TO TAMMFIS
           ELSE SUBTRACT AMMENSF FROM TVARRET 
                SUBTRACT AMMANTF FROM TVARRET.
           IF IF-TIPLAV = 2 GO TO BC90F.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
      *> calcolo residuo da rettificare in aumento
           MOVE ANA-VARRET TO RESAUM.
           ADD VARRET TO RESAUM.
           IF VARAUM NOT = ZERO
              SUBTRACT VARAUM FROM RESAUM.
      *
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           IF FLGTPAM = 3 GO TO BC802.
           IF RESID = ZERO
              IF ( ANA-VALAMMF * PDEDFISCH ) NOT = ANA-TOTAFIS
                   AND SWD = '*'
                       GO TO BC802.
           IF COM-AMESER = 1 AND ANA-ANACQ NOT = IF-ESERC
             IF SW3 NOT = ' '
                 GO TO BC802.

           MOVE 'DATI FISCALI PER CALCOLO ' TO ST-DSMO.
           IF PDEDFISCH NOT = 1
              MOVE '(Ded. Fiscale' TO ST-AMMOX.
           MOVE VALAMMF TO ST-VAMM.
           IF IF-TIPLAV = 3
              MOVE COMTFIS TO ST-ACCA
           ELSE
              MOVE TOTAFIS TO ST-ACCA.
           IF PDEDFISCH NOT = 1
              MOVE '              )' TO FILLER1
              COMPUTE ST-UTIL = VALAMMF * PDEDFISCH.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           IF ANA-TOTAFIS + ACCANTF = ( VALAMMF * PDEDFISCH )
              GO TO NO-FISC.
           MOVE 'AMM. FISCALE ORDINARIO :' TO ST-DSMO.
      **** rel 6.3
           IF AMMENSF NOT = ZERO 
      ************
           MOVE ALNORMF TO ST-PERC.
           IF AMTOESF = 1 MOVE 100,00 TO ST-PERC.
           MOVE AMMENSF TO ST-AMMO.
           IF ANA-AMESER = 1
              MOVE VALAMMF TO COMODX.
           IF PDEDFISCH NOT = 1
      **** rel 6.3
              IF PDEDFISCH NOT = ZERO
      ************
              MOVE COMODX TO ST-CALFIS
              IF AMMENSF = COMODX AND ANA-AMESER NOT = 1
                  MOVE '(Residuo Anno Precedente ' TO FILLER3
                  MOVE ')' TO ST-PARC1
              ELSE
                  MOVE '(Ded. Fisc.' TO ST-PARA1
                  MOVE  ANA-COEDFI TO ST-PDED
                  MOVE '% di ' TO ST-PARA2
                  MOVE ')' TO ST-PARC1.

           IF AMTOESF = 1 MOVE 100,00 TO ST-PERC1.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           IF AMMANTF = ZERO GO TO NO-FISC.
           MOVE '             ANTICIPATO:' TO ST-DSMO.
           MOVE ALANTIF TO ST-PERC.
           MOVE AMMANTF TO ST-AMMO.
           IF AMMANTF NOT = COMODY AND PDEDFISCH NOT = 1
                 MOVE '(Ded. Fisc.' TO ST-PARA1
                 MOVE  ANA-COEDFI TO ST-PDED
                 MOVE '% di ' TO ST-PARA2
                 MOVE ')' TO ST-PARC1
                 MOVE COMODY TO ST-CALFIS.
           IF AMTOESF = 1 MOVE 100,00 TO ST-PERC.
           MOVE 1 TO XCRR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
       BC90F.
           COMPUTE PERCOM = ALNORMF + ALANTIF.
           MOVE 1 TO K1.
           MOVE ZERO TO K2.
           IF AMMANTF = ZERO GO TO BC80-10A.
       BC80-00A.
           ADD 1 TO K2.
      **** rel 6.3
           MOVE PERCOM TO PERCOM1.
           IF PERCOM1 = ZERO
             MOVE 888,888 TO PERCOM1.
      ************
           IF LA3-ALIQ(K1 K2) = ZERO AND LA3-IMPOF(K1 K2) = ZERO
      **** rel 6.3
      *       MOVE PERCOM  TO LA3-ALIQ(K1 K2)
              MOVE PERCOM1 TO LA3-ALIQ(K1 K2)
      ************
              MOVE AMMANTF  TO LA3-IMPOF(K1 K2)
              GO TO BC80-10A.
      **** rel 6.3
      *    IF LA3-ALIQ(K1 K2) = PERCOM
           IF LA3-ALIQ(K1 K2) = PERCOM1
      ************
              ADD AMMANTF  TO LA3-IMPOF(K1 K2)
              GO TO BC80-10A.
           IF K2 = 20
              MOVE 999,999 TO LA3-ALIQ(K1 K2)
              ADD AMMANTF  TO LA3-IMPOF(K1 K2)
              GO TO BC80-10A.
           GO TO BC80-00A.
       BC80-10A.
           IF IF-TIPLAV = 2 GO TO BC91F.
       NO-FISC.
           MOVE ALL '-' TO SOTTOL.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG6' TO RP-BLK.
           PERFORM RST THRU EX-RST.

       BC91F.
           IF AMTOESF = 1 AND ALNORMF = ZERO
              MOVE 100 TO PERCOM
           ELSE
              IF AMMANTF = ZERO
                 MOVE ALNORMF TO PERCOM
              ELSE
                 COMPUTE PERCOM = ALNORMF + ALANTIF.
           IF AMMENSF = ZERO GO TO BC80-10.
      **** rel 6.3
      *    IF PERCOM  = ZERO GO TO BC80-10.
      ************
           MOVE 1 TO K1.
           MOVE ZERO TO K2.
       BC80-00.
           ADD 1 TO K2.
      **** rel 6.3
           MOVE PERCOM TO PERCOM1.
           IF PERCOM1 = ZERO
             MOVE 888,888 TO PERCOM1.
      ************
           IF LA3-ALIQ(K1 K2) = ZERO AND LA3-IMPOF(K1 K2) = ZERO
      **** rel 6.3
      *       MOVE PERCOM  TO LA3-ALIQ(K1 K2)
              MOVE PERCOM1 TO LA3-ALIQ(K1 K2)
      ************
              MOVE AMMENSF  TO LA3-IMPOF(K1 K2)
              MOVE VALAMMF  TO LA3-VALAF(K1 K2)
              GO TO BC80-10.
      **** rel 6.3
      *    IF LA3-ALIQ(K1 K2) = PERCOM
           IF LA3-ALIQ(K1 K2) = PERCOM1
      ************
              ADD VALAMMF TO LA3-VALAF(K1 K2)
              ADD AMMENSF TO LA3-IMPOF(K1 K2)
              GO TO BC80-10.
           IF K2 = 20
              MOVE 999,999 TO LA3-ALIQ(K1 K2)
              ADD VALAMMF  TO LA3-VALAF(K1 K2)
              ADD AMMENSF  TO LA3-IMPOF(K1 K2)
              GO TO BC80-10.
           GO TO BC80-00.
       BC80-10.
           IF IF-TIPLAV = 2 GO TO BC90.
           MOVE ZERO TO FLGTPAM.
           MOVE 'VALORI FINE ESER. FISCALE' TO ST-DSMO.
           COMPUTE ST-AMMO = AMMENSF + AMMANTF.
           COMPUTE TOT1    = TOT1 + VALAMMF.
           IF IF-TIPLAV = 3 MOVE TOTAFIS  TO ST-ACCA
                            ADD  TOTAFIS  TO TOT2
           ELSE             MOVE COMTFIS  TO ST-ACCA
                            ADD  COMTFIS  TO TOT2.

           IF IF-TIPLAV = 3 COMPUTE ST-RESI = (VALAMMF * PDEDFISCH)
                                              - TOTAFIS
                            COMPUTE TOT3    = TOT3 +
                                            ((VALAMMF * PDEDFISCH)
                                             - TOTAFIS)
           ELSE             COMPUTE ST-RESI = (VALAMMF * PDEDFISCH)
                                               - COMTFIS
                            COMPUTE TOT3    = TOT3 +
                                            ((VALAMMF * PDEDFISCH)
                                            - COMTFIS).
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           IF VARRET = ZERO GO TO NO-VARDIM.
           IF VARRET < ZERO AND
            (RESID = ZERO AND ANA-TOTACIV = ANA-VALAMM)
                GO TO NO-VARDIM.
           MOVE 'ECCEDENZE FISCALI SU CIVILISTICO ESERCIZIO' TO ST-VAR.
           MOVE VARRET TO ST-RETT.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
       NO-VARDIM.
           IF VARAUM = ZERO GO TO NO-VARAUM.

           MOVE 'ECCEDENZE FISCALI SU CIVILISTICO ESERCIZIO' TO ST-VAR.
           COMPUTE VARAUM = VARAUM * (-1).
           MOVE VARAUM TO ST-RETT.
           COMPUTE VARAUM = VARAUM * (-1).
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
       NO-VARAUM.
           SUBTRACT VARUTIL FROM RESAUM.
           MOVE 'TOTALE ECCEDENZE FISCALI SU CIVILISTICO' TO ST-VAR.
           MOVE RESAUM  TO ST-RETT.
           MOVE 1 TO XCRR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           IF RESAUM NOT = ZERO
              IF RESID = RESFIS AND = ZERO
                 MOVE 'TOTALE ECCEDENZE FISCALI SU CIV.(STORNO)'
                       TO ST-VAR
                 MULTIPLY -1 BY RESAUM
                 IF RESAUM > ZERO
                    ADD RESAUM TO TVARRET 
                    ADD RESAUM TO TTGDIM2
                 ELSE
                    SUBTRACT RESAUM FROM TVARAUM TOTGAUM
                 END-IF
                 MOVE RESAUM  TO ST-RETT
                 MOVE 1 TO XCRR
                 MOVE 'RIG4' TO RP-BLK
                 PERFORM RST THRU EX-RST.
      *  
       BC802.
           IF IF-TIPLAV NOT = 3 GO TO BC90.
           MOVE VALAMM TO ANA-VALAMM.
           MOVE VALAMMF TO ANA-VALAMMF.
           MOVE 12      TO ANA-MSIN.
           IF NONAMM NOT = ZERO
              MOVE NONAMM TO ANA-NONAMM.
           MOVE ACANTO TO ANA-ACCANT.
           ADD VARRET TO ANA-VARRET.
           ADD VARUTIL TO VARAUM.
           IF VARAUM NOT = ZERO SUBTRACT VARAUM FROM ANA-VARRET.
           IF RESID = RESFIS AND = ZERO
                MOVE ZERO TO ANA-VARRET.
           MOVE TOTAFIS TO ANA-TOTAFIS.
           MOVE TOTACIV TO ANA-TOTACIV.
           ADD INCAMM TO ANA-TOTACIV.
           ADD  TOTANT TO ANA-TOTANT.
           MOVE COM-AMESER TO ANA-AMESER.
           IF ANA-AMESER = 1
                MOVE ZERO TO ANA-COEFFI ANA-COEFAN.
           MOVE COM-AMTOES TO ANA-AMTOES.
      **** rel 6.3
      * riabilitato test per delete record
      *
      * ritolto e modificato test per delete record
      *    IF ANA-VALAMM = ZERO DELETE ANAMMO GO TO BC90.
      ************
           MOVE COM-ANACQ  TO ANA-ANACQ.
      **** rel 6.2
           IF ANA-VALACQ = ZERO
              MOVE ANA-VALAMM TO ANA-VALACQ
              ADD ANA-NONAMM  TO ANA-VALACQ.
      ************
      **** rel 6.3
           IF ANA-VALACQ NOT = ZERO AND ANA-VALAMM = ZERO  
              AND ANA-VALAMMF = ZERO
             DELETE ANAMMO 
             GO TO BC90.
      ************
      **** rel 7.1
           IF FLGDEL NOT = ZERO
             DELETE ANAMMO 
             GO TO BC90.
      ************
      **** rel 7.1
           MOVE MEMO-ANACQ TO ANA-ANACQ.
           MOVE MEMO-COEFFI TO ANA-COEFFI.
           MOVE MEMO-COEFAN TO ANA-COEFAN.
           MOVE MEMO-COEFOR TO ANA-COEFOR.
      ************
           REWRITE RF-ANA.
       BC90.
      *
           IF VARRET > ZERO 
              IF RESAUM < ZERO
                 ADD VARRET TO TTGDIM2
              ELSE
                 IF VARRET NOT > RESAUM
                    ADD VARRET TO TOTGDIM
                 ELSE
                    ADD RESAUM TO TOTGDIM
                    COMPUTE TTGDIM2 = TTGDIM2 + (VARRET - RESAUM).
      *
           MOVE ZERO TO ACQUIS AMMENS UTILIZ VALAMM NONAMM
                        VALAMMF NONAMMF VARUTIL
                        ACCANT RESID COMODO COMOD1 SW-STA.
           MOVE ZERO TO ACANTO ACANTA UTILO UTILA UTILOZ UTILAZ.
           MOVE ZERO TO VARRET TOTAFIS TOTACIV VARAUM COMTFIS AMMENST
                        AMMENSF AMMANTF SVNORM SVANTI AMMENSTC
                        RESAUM VARALI RESFIS TOTANT.
           MOVE ZERO TO INCAMM INCAMMF.
           MOVE ZERO TO FLGTPAM.
           DELETE WDSLAV.
       BC91.
           READ WDSLAV NEXT AT END GO TO BC95.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO BC91.
           IF KLV-AZI > IF-AZI   GO TO BC95.
           IF KLV-AN2 > IF-ESERC GO TO BC91.
           IF KLV-RAG = COMCAT   GO TO BC93.
           PERFORM F00-TOTALI THRU F99.
           IF IF-TIPLAV = 2 GO TO H00-CAMB-CAT.
      *
           GO TO BCX1.
       BC93.
           IF KLV-COD NOT = CODICE PERFORM G00-TOT-CESP THRU G99
                                   GO TO BCX2.
           IF IF-TIPLAV = 2
              MOVE 1 TO SW-COD
              GO TO BC02.
           MOVE ALL '=' TO SOTTOL.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG6' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           MOVE 1 TO SW-COD.
           GO TO BC02.
       BC95.
           PERFORM F00-TOTALI THRU F99.
           IF IF-STAECC NOT = 1 GO TO BC99.
      *
           IF IF-TIPLAV = 2 GO TO BC96.

      *-- inizializza parametri per stampa report --*
           MOVE SPACE TO RP-TIT2.
           STRING 'TOTALI GENERALI' 
                     DELIMITED SIZE INTO RP-TIT2.
      *---------------------------------------------*
      *
      * salto x visuale, nel carattere salta perch arriva
      * a fondo pagina con la barratura
           MOVE 1 TO RP-JMP.
      *
           MOVE 'TOTALI GENERALI' TO ST-RAG.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RST THRU EX-RST.
           MOVE ALL '=' TO ST-SOTT2.  
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG7' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
      * righe vuote per visuale
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-AZZ.
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RST THRU EX-RST.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-AZZ.
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-AZZ.
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
      *> totali generali rettifiche in diminuzione/aumento
           MOVE 'TOT. GEN. ECCEDENZE POSITIVE X AMMORTAMENTO'
                                                             TO ST-VAR.
           MOVE 'VALORE PER CALCOLARE LA % DI IMPOSTE DIFFERITE'
                                                             TO ST-VAR1.
           MOVE TOTGDIM TO ST-RETT.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  

           IF TTGDIM2 = ZERO GO TO NO-DIM.
           MOVE 'TOT. GEN. ECCEDENZE POSITIVE X AMMORTAMENTO'
                                                             TO ST-VAR.
           MOVE TTGDIM2 TO ST-RETT.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
       NO-DIM.
           MOVE 'TOT. GEN. ECCEDENZE NEGATIVE X AMMORTAMENTO'
                                                              TO ST-VAR.
           IF TTGAUM2 < ZERO
                ADD TTGAUM2 TO TOTGAUM
                MOVE ZERO TO TTGAUM2.
           IF TOTGAUM < ZERO
                ADD TOTGAUM TO TTGAUM2
                MOVE ZERO TO TOTGAUM.

           MOVE TOTGAUM TO ST-RETT.
           MOVE 1 TO XCRR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           IF TTGAUM2 = ZERO GO TO NO-AUM.
           MOVE 'TOT. GEN. ECCEDENZE NEGATIVE X AMMORTAMENTO'
                                                              TO ST-VAR.
           MOVE 'VALORE PER CALCOLARE LA % DI IMPOSTE ANTICIPATE'
                                                             TO ST-VAR1.
           MOVE TTGAUM2 TO ST-RETT.
           MOVE 1 TO XCRR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
       NO-AUM.

      *> totali generali rettifiche in aumento x alienazione
           MOVE 'TOT. GEN. ECCEDENZE STORNATE X ALIENAZIONE'
                                                              TO ST-VAR.
           MOVE TOTGALI TO ST-RETT.
           MOVE 1 TO XCRR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
       BC96.
           MOVE ZERO TO TOTGDIM TOTGAUM TOTGALI.
           MOVE ZERO TO TTGDIM2 TTGAUM2.
           IF IF-TIPLAV = 2 GO TO BC99.
      *
      * per barratura
           PERFORM F9 THRU F99.
       BC99.
           EXIT.
      *------------------
       D00-ESTRAZ.
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO D02.
       D01.
           READ WDSLAV NEXT AT END GO TO D02.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO D01.
           DELETE WDSLAV.
           GO TO D01.
       D02.
           MOVE LOW-VALUE TO KEY145.
           START WDS145 KEY NOT < KEY145 INVALID GO TO D02-10.
       D02-00.
           READ WDS145 NEXT AT END GO TO D02-10.
           IF SF-145 = '9D' OR '9A' OR '35' GO TO D02-00.
           DELETE WDS145.
           GO TO D02-00.
       D02-10.
           MOVE LOW-VALUE TO KEYL3.
           START WDSLA3 KEY NOT < KEYL3 INVALID GO TO D02-30.
       D02-20.
           READ WDSLA3 NEXT AT END GO TO D02-30.
           IF SF-LA3 = '9D' OR '9A' OR '35' GO TO D02-20.
           DELETE WDSLA3.
           GO TO D02-20.
       D02-30.
           MOVE ZERO TO FLGMOV.
           MOVE ZERO TO CODICE ANACQ.
           MOVE IF-AZI TO KAN-AZI.
           IF IF-FLA = 0
             MOVE 99999 TO KAN-DTAPE KAN-DTCHI
           ELSE
             MOVE EX1-DTAPE TO KAN-DTAPE
             MOVE EX1-DTCHI TO KAN-DTCHI.
           MOVE PRCD   TO KAN-CD.
           START ANAMMO KEY NOT < KEYAN INVALID GO TO D99.
       D03.
           READ ANAMMO NEXT AT END GO TO D99.
           IF SF-AMM = '9D' OR '9A' OR '35' GO TO D03.
           IF KAN-AZI > IF-AZI GO TO D99.
           IF KAN-CD  > ULCD   GO TO D99.
           IF IF-FLA = 1
             IF KAN-DTAPE NOT = EX1-DTAPE GO TO D99.
      **** rel 7.1
      *    IF ANA-ANACQ > IF-ESERC GO TO D50.
      **** rel 7.1
      * 16/06/14 MCN-MAT : non vi  motivo di trattare beni 
      *                    pluriennali diversamente dagli altri
      *    IF ANA-TIPBEN = 3
      *      IF (ANA-VALAMM NOT = ZERO AND = ANA-TOTACIV)
      *      AND (ANA-VALAMMF NOT = ZERO AND = ANA-TOTAFIS)
      *      GO TO D50.
      ************
           PERFORM CHECK-TIPO THRU EX-CHECK-TIPO.
           IF SW-ACQES NOT = ZERO
             GO TO D03.
           IF ANA-ANACQ > IF-ESERC 
             MOVE IF-ESERC TO ANA-ANACQ.
      ************
           IF (IF-TOTAM = 1) AND
           (ANA-VALAMM = ANA-TOTACIV AND NOT = ZERO)
              PERFORM VERIFICA-MOVIMENTI THRU V99
              IF FLGMOV NOT = 1
                 IF ANA-TOTACIV NOT = ZERO
                    IF ANA-TOTACIV = ANA-VALAMM AND
                       ANA-TOTAFIS = (ANA-VALAMMF * PDEDFISCH)
                          GO TO D03.
      **** rel 7.1
      * Se non ho movimenti devo verificare l'anno di acquisizione del
      * cespite che non sia successivo al periodo selezionato
           IF FLGMOV NOT = 1
              MOVE 1 TO GG9
              MOVE 1 TO MM9
              MOVE ANA-ANACQ TO AA9
              MOVE 1 TO TIPOP1
              CALL 'rdata' USING PARCDT
              IF AAGGG > FINESK GO TO D03.
      ************
           IF T25ESE NOT = ZERO
      **** rel 6.2 
      *       IF ANA-ANACQ = IF-ESERC AND ANA-MSACQ > MMCHI GO TO D03.
              IF ANA-ANACQ = IF-ESERC AND ANA-MSACQ > MMCHI GO TO D50.
      ************
           MOVE KAN-AZI TO KLV-AZI.
           MOVE KAN-RAG TO KLV-RAG.
           MOVE KAN-COD TO KLV-COD.
           MOVE KAN-INC TO KLV-INC.
           IF KAN-INC = ZERO MOVE KAN-COD TO CODICE
                             MOVE ANA-ANACQ TO KLV-ANN ANACQ
                             GO TO D04.
           IF KAN-COD = CODICE
              MOVE ANACQ TO KLV-ANN
           ELSE
              MOVE ANA-ANACQ TO KLV-ANN.
       D04.
           MOVE ANA-ANACQ TO KLV-AN2.
           MOVE ANA-TIPBEN TO LAV-TIP.
           WRITE RF-LAV.
           GO TO D03.
       D50.
           IF IF-TIPLAV NOT = 3
              GO TO D03.
           MOVE KAN-AZI TO KAM-AZI.
           MOVE KAN-RAG TO KAM-RAG.
           MOVE KAN-COD TO KAM-COD.
           MOVE KAN-INC TO KAM-INC.
           MOVE ZERO TO KAM-DAT KAM-PRG.
           START MOVAMM KEY NOT < KEYAM INVALID GO TO D03.
       D51.
           READ MOVAMM NEXT AT END GO TO D59.
           IF SF-AMM = '9D' OR '9A' OR '35' GO TO D51.
           IF KAM-AZI > KAN-AZI GO TO D59.
           IF KAM-RAG > KAN-RAG GO TO D59.
           IF KAM-COD > KAN-COD GO TO D59.
           IF KAM-INC > KAN-INC GO TO D59.
           IF KAM-DAT < INIESK OR > FINESK GO TO D51.
           EVALUATE AMM-TIPO
             WHEN 0 GO TO D51
             WHEN 1
                   ADD AMM-IMPOR TO ANA-VALAMM
                   ADD AMM-IMPORF TO ANA-VALAMMF
             WHEN 2
                   SUBTRACT AMM-IMPOR FROM ANA-VALAMM
             WHEN 3
                   SUBTRACT AMM-IMPOR FROM ANA-VALAMM 
                   SUBTRACT AMM-IMPORF FROM ANA-VALAMMF
             WHEN 4
                   SUBTRACT AMM-IMPOR FROM  ANA-VALAMM
                   SUBTRACT AMM-IMPOR FROM VALAMMF
             WHEN 5
                   SUBTRACT AMM-IMPOR FROM ANA-ACCANT
                                           ANA-VALAMM
                   SUBTRACT AMM-IMPORF FROM ANA-VALAMMF
             WHEN 6
                   ADD AMM-IMPOR  TO ANA-VALAMM
                   ADD AMM-IMPORF TO ANA-VALAMMF
             WHEN 7
                   SUBTRACT AMM-IMPOR FROM ANA-VALAMM
                   SUBTRACT AMM-IMPORF FROM ANA-VALAMMF
             WHEN 8
                   ADD AMM-IMPOR TO ANA-VALAMM
             WHEN 9
                   ADD AMM-IMPOR  TO ANA-ACCANT
                   ADD AMM-IMPOR  TO ANA-TOTACIV
                   ADD AMM-IMPORF TO ANA-TOTAFIS
             WHEN OTHER
                   ADD AMM-IMPOR TO ANA-NONAMM
                   SUBTRACT AMM-IMPOR FROM ANA-VALAMM
                   SUBTRACT AMM-IMPORF FROM ANA-VALAMMF
           END-EVALUATE.
           GO TO D51.
       D59.
           IF ANA-VALACQ = ZERO
              MOVE ANA-VALAMM TO ANA-VALACQ
              ADD ANA-NONAMM  TO ANA-VALACQ.
           REWRITE RF-ANA.
           GO TO D03.
       D99.
           EXIT.
      *------------------
       F00-TOTALI.
           PERFORM G00-TOT-CESP THRU G99.
           IF IF-TIPLAV = 2 GO TO F030.
       F001.
       F002.
           EXIT.
      *------------------
       F003.
       F003-00.
           MOVE ZERO TO K.
       F003-10.
           ADD 1 TO K.
           IF K > 2 GO TO F003-40.
           MOVE ZERO TO N K1.
           MOVE 1 TO K2.
       F003-20.
           ADD 1 TO K1 K2.
           IF K2 > 20 GO TO F003-30.
           IF LA3-ALIQ(K K1) = ZERO AND LA3-IMPO(K K1) = ZERO
              GO TO F003-30.
           MOVE K TO SW-STA.
           IF LA3-ALIQ(K K2) = ZERO AND LA3-IMPO(K K2) = ZERO
              GO TO F003-30.
           IF LA3-ALIQ(K K1) NOT > LA3-ALIQ(K K2)
              GO TO F003-20.
           MOVE 1 TO N.
           MOVE LA3-ALIQ(K K1) TO PERCNO.
           MOVE LA3-IMPO(K K1) TO COMODO.
           MOVE LA3-VALA(K K1) TO COMOD3.
           MOVE LA3-ALIQ(K K2) TO LA3-ALIQ(K K1).
           MOVE PERCNO TO LA3-ALIQ(K K2).
           MOVE LA3-IMPO(K K2) TO LA3-IMPO(K K1).
           MOVE COMODO TO LA3-IMPO(K K2).
           MOVE LA3-VALA(K K2) TO LA3-VALA(K K1).
           MOVE COMOD3 TO LA3-VALA(K K2).
           MOVE LA3-IMPOF(K K1) TO COMODO.
           MOVE LA3-VALAF(K K1) TO COMOD3.
           MOVE LA3-IMPOF(K K2) TO LA3-IMPOF(K K1).
           MOVE COMODO TO LA3-IMPOF(K K2).
           MOVE LA3-VALAF(K K2) TO LA3-VALAF(K K1).
           MOVE COMOD3 TO LA3-VALAF(K K2).
           GO TO F003-20.
       F003-30.
           IF N = 1 MOVE ZERO TO N K1
                    MOVE 1 TO K2
                    GO TO F003-20.
           GO TO F003-10.
       F003-40.
           MOVE 1 TO XCRR.
      *
           MOVE SPACES TO INTC1C.
           STRING 'Categoria ' CAT-DESCR
                DELIMITED SIZE INTO INTC1C.
      *
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE C-TTS2 TO P999.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RST THRU EX-RST.
           MOVE C-TINT2-1(2:) TO P999.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RST THRU EX-RST.
           MOVE C-TINT2-2(2:) TO P999.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           MOVE ZERO TO TOT4 TOT5 TOT6.
           MOVE 1 TO K1.
           MOVE ZERO TO K2.
       F003-50.
           ADD 1 TO K2.
           IF K2 > 20 GO TO F005.
           IF LA3-ALIQ(K1 K2) = ZERO GO TO F003-50.
           MOVE LA3-VALA(K1 K2) TO ST-VALA.
           ADD LA3-VALA(K1 K2) TO TOT6.
           MOVE LA3-IMPO(K1 K2) TO ST-IMPO.
           MOVE LA3-ALIQ(K1 K2) TO ST-PCAT.
      **** rel 6.3
           IF LA3-ALIQ(K1 K2) = 888,888
             MOVE ZERO TO ST-PCAT.
      ************
           MOVE LA3-VALAF(K1 K2) TO ST-VALAF.
           MOVE LA3-IMPOF(K1 K2) TO ST-IMPOF.
           ADD LA3-VALAF(K1 K2) TO TOT5.
           ADD LA3-IMPOF(K1 K2) TO TOT4.
           MOVE 1 TO XCRR.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           PERFORM F001 THRU F002.
           GO TO F003-50.
       F005.
           IF IF-TOTAM NOT = ZERO
              GO TO F005-003.
           IF TACQUIS - TOT6 - TNONAMM - TOTVALC = ZERO
              GO TO F005-001.
           COMPUTE ST-VALA = TACQUIS - TOT6 - TNONAMM
                             - TOTVALC
           MOVE 'TOT. AMMORTIZZATI' TO ST-DTOTALE.
       F005-001.
           IF TOT1 - TOT5 - TOTVALF = 0
              GO TO F005-002.
           COMPUTE ST-VALAF = TOT1 - TOT5 - TOTVALF.
           MOVE 'TOT. AMMORTIZZATI' TO ST-DTOTALEF.
       F005-002.
           IF P999 NOT = SPACE
              MOVE 'RIG5' TO RP-BLK
              PERFORM RST THRU EX-RST.
      *

           IF TINCAMM NOT = ZERO
              MOVE 'Incremento Ammort.' TO SOTTOC2
              MOVE TINCAMM TO ST-IMPO.
           IF TINCAMMF NOT = ZERO
              MOVE 'Incremento Ammort.' TO SOTTOC2F
              MOVE TINCAMMF TO ST-IMPOF.
              MOVE ZERO TO TOTVALC TOTVALF.
           IF TINCAMM NOT = ZERO OR TINCAMMF NOT = ZERO
              MOVE 1 TO XCRR
              MOVE 'RIG5' TO RP-BLK
              PERFORM RST THRU EX-RST.
      *

       F005-003.
           MOVE ALL '-' TO SOTTOC2 SOTTOC2F.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE TIMPORD TO ST-VALA.
           IF IF-TOTAM = ZERO
              COMPUTE ST-VALA = TACQUIS - TNONAMM.
           COMPUTE ST-IMPO = TAMMORD + TINCAMM.

           MOVE TOT1    TO ST-VALAF.
      **** rel 6.3
      *    MOVE TOT4    TO ST-IMPOF.
           MOVE TAMMFIS TO ST-IMPOF.
      ************

           MOVE 1 TO XCRR.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           PERFORM F001 THRU F002.
           IF TAMMANT = ZERO GO TO F010.
           MOVE ALL '=' TO SOTTO2.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG6' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE 'AMMORTAMENTI ANTICIPATI' TO ST-DSMO.
           MOVE 2 TO K1.
           MOVE ZERO TO K2.
       F005-10.
           ADD 1 TO K2.
           IF K2 > 20 GO TO F007.
           IF LA3-ALIQ(K1 K2) = ZERO GO TO F005-10.
           MOVE LA3-VALA(K1 K2) TO ST-VAMM.
           MOVE LA3-IMPO(K1 K2) TO ST-AMMO.
           IF LA3-ALIQ(K1 K2) > 99,99
              MOVE LA3-ALIQ(K1 K2) TO ST-PERC1
           ELSE
              MOVE LA3-ALIQ(K1 K2) TO ST-PERC.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           PERFORM F001 THRU F002.
           GO TO F005-10.
       F007.
           MOVE ALL '-' TO SOTTO2.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG6' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      * 
           MOVE TIMPANT TO ST-VAMM.
           MOVE TAMMANT TO ST-AMMO.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
       F010.
           MOVE ALL '-' TO ST-SOTT.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG6' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      * 
       F020.
           PERFORM F001 THRU F002.
           MOVE ZERO TO SW-STA.
           MOVE 'TOT.CATEGORIA CIVILISTICI' TO ST-DSMO.
           COMPUTE ST-VAMM = TACQUIS - TNONAMM.
           MOVE TAMMENS TO ST-AMMO.
           MOVE TUTILIZ TO ST-UTIL.
           MOVE TACCANT TO ST-ACCA.
           MOVE TRESID  TO ST-RESI.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           MOVE 'TOT.CATEGORIA FISCALI' TO ST-DSMO.
           MOVE TOT1    TO ST-VAMM.
           MOVE TAMMFIS TO ST-AMMO.
           MOVE TOT2    TO ST-ACCA.
           MOVE TOT3    TO ST-RESI.
           MOVE ZERO    TO TOT1 TOT2 TOT3.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
      *> totale rettifiche in diminuzione
           MOVE 'TOT.ECCEDENZE FISC/CIV POSITIVE' TO ST-VAR.
           MOVE TVARRET TO ST-RETT.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  

      *> totale rettifiche in aumento
           MOVE 'TOT.ECCEDENZE FISC/CIV NEGATIVE' TO ST-VAR.
           MOVE TVARAUM TO ST-RETT.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  

      *> totale rettifiche in aumento per alienazione bene
           IF TVARALI = ZERO GO TO F020-05.
           MOVE 'TOT.RETTIF. IN AUMENTO X ALIENAZIONE' TO ST-VAR.
           MOVE TVARALI TO ST-RETT.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
       F020-05.
           IF IF-FLAMM = ZERO GO TO F030.
           IF TAMMORD + TINCAMM = ZERO GO TO F020-10.
           MOVE T14CAMO   TO L145-CAUSA.
           MOVE 1         TO L145-TIPRG.
           MOVE ZERO      TO L145-SEGNO.
           MOVE 'A'       TO L145-DAVE.
           MOVE SPACE     TO L145-DESAG L145-DESA2.
           MOVE TAC-FDORD TO L145-PART.
           MOVE TAC-AMORD TO L145-CPART.
           MOVE TAMMORD   TO L145-IMPOR.
           ADD TINCAMM    TO L145-IMPOR.
           WRITE RF-145 INVALID PERFORM L00-ERR-WDS THRU L99
                                GO TO F030.
           ADD 1 TO K145-PROG.
           READ WDS145 INVALID MOVE ZERO TO REC145
                               MOVE SPACE TO L145-DESAG L145-DESA2.
       F020-10.
           IF TAMMANT = ZERO GO TO F020-20.
           GO TO F020-20.
      *    MOVE T14CAMI   TO L145-CAUSA.
      *    MOVE 1         TO L145-TIPRG.
      *    MOVE 'A'       TO L145-DAVE.
      *    MOVE ZERO      TO L145-SEGNO.
      *    MOVE SPACE     TO L145-DESAG L145-DESA2.
      *    MOVE TAC-FDANT TO L145-PART.
      *    MOVE TAC-AMANT TO L145-CPART.
      *    MOVE TAMMANT   TO L145-IMPOR.
      *    WRITE RF-145 INVALID PERFORM L00-ERR-WDS THRU L99
      *                         GO TO F030.
      *    ADD 1 TO K145-PROG.
      *    READ WDS145 INVALID MOVE ZERO TO REC145
      *                        MOVE SPACE TO L145-DESAG L145-DESA2.
       F020-20.
           IF T14RAGG NOT = ZERO GO TO F030.
           IF TUTILIZ = ZERO GO TO F020-30.
           MOVE T14CUTI   TO L145-CAUSA.
           MOVE 1         TO L145-TIPRG.
           MOVE 'A'       TO L145-DAVE.
           MOVE ZERO      TO L145-SEGNO.
           MOVE SPACE     TO L145-DESAG L145-DESA2.
           MOVE TAC-CONTO TO L145-PART.
           MOVE TAC-FDORD TO L145-CPART.
           MOVE TUTILOZ   TO L145-IMPOR.
           WRITE RF-145 INVALID PERFORM L00-ERR-WDS THRU L99
                                GO TO F030.
           ADD 1 TO K145-PROG.
           READ WDS145 INVALID MOVE ZERO TO REC145
                               MOVE SPACE TO L145-DESAG L145-DESA2.
           IF TUTILAZ = ZERO GO TO F020-30.
           GO TO F020-30.
      *    MOVE T14CUTI   TO L145-CAUSA.
      *    MOVE 1         TO L145-TIPRG.
      *    MOVE 'A'       TO L145-DAVE.
      *    MOVE ZERO      TO L145-SEGNO.
      *    MOVE SPACE     TO L145-DESAG L145-DESA2.
      *    MOVE TAC-CONTO TO L145-PART.
      *    MOVE TAC-FDANT TO L145-CPART.
      *    MOVE TUTILAZ   TO L145-IMPOR.
      *    WRITE RF-145 INVALID PERFORM L00-ERR-WDS THRU L99
      *                         GO TO F030.
      *    ADD 1 TO K145-PROG.
      *    READ WDS145 INVALID MOVE ZERO TO REC145
      *                        MOVE SPACE TO L145-DESAG L145-DESA2.
       F020-30.
           IF TOTPLU = ZERO GO TO F020-40.
           MOVE T14CPLU   TO L145-CAUSA.
           MOVE 'D'       TO L145-DAVE.
           MOVE 1         TO L145-TIPRG.
           MOVE ZERO      TO L145-SEGNO.
           MOVE TAC-CONTO TO L145-PART.
           MOVE TOTPLU    TO L145-IMPOR.
           MOVE PLUSV     TO L145-CPART.
           WRITE RF-145 INVALID PERFORM L00-ERR-WDS THRU L99
                                GO TO F030.
           ADD 1 TO K145-PROG.
           READ WDS145 INVALID MOVE ZERO TO REC145
                               MOVE SPACE TO L145-DESAG L145-DESA2.
       F020-40.
           IF TOTMIN = ZERO GO TO F030.
           MOVE T14CMIN   TO L145-CAUSA.
           MOVE 'A'       TO L145-DAVE.
           MOVE 1         TO L145-TIPRG.
           MOVE ZERO      TO L145-SEGNO.
           MOVE TAC-CONTO TO L145-PART.
           MOVE TOTMIN    TO L145-IMPOR.
           MOVE MINUS     TO L145-CPART.
           WRITE RF-145 INVALID PERFORM L00-ERR-WDS THRU L99.
       F030.
           MOVE ZERO TO TOTPLU TOTMIN.
           ADD 1 TO K145-PROG.
           READ WDS145 INVALID MOVE ZERO TO REC145
                               MOVE SPACE TO L145-DESAG L145-DESA2.
           WRITE RF-LA3 INVALID
                 MOVE 'vamm140:Errore WR.WDSLA3' TO F-MES1
                 MOVE 1 TO F-NMES
                 CALL 'vrmbox' USING PARMB.
           MOVE ZERO TO TACQUIS TAMMENS TUTILIZ TNONAMM TIMPORD
                        TACCANT TRESID TAMMORD TIMPANT TAMMANT.
           MOVE ZERO TO TVARRET TVARAUM TVARALI TAMMFIS.
           MOVE ZERO TO TUTILOZ TUTILAZ.
           MOVE ZERO TO TINCAMM TINCAMMF.
           MOVE ZERO TO COMODO PERCNO.
           IF IF-TIPLAV = 2 GO TO F99.
           MOVE ALL '=' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
       F9.
      * solo stampa a carattere
           IF RP-TRPT = 1     GO TO F99.
      * sempre barratura
      *    IF IF-FLA = 0
      *    IF IF-TIPLAV NOT = 3 GO TO F99.
           IF NRIG NOT < NRGL GO TO F99.
           COMPUTE N = NRGL - NRIG.
           COMPUTE N = N + (132 - N) / 2.
           MOVE N TO K.
           ADD 1 TO N.
       F10.    
           IF NRIG NOT < (NRGL - 2) GO TO F99. 
           ADD 1 TO NRIG.
           IF NRIG = (NRGL - 2) 
              MOVE ALL '=' TO P999 
              MOVE 2 TO RP-FLGR
              MOVE 'RIG5' TO RP-BLK 
           ELSE 
              SUBTRACT 1 FROM N K
              MOVE '/' TO RX(N) RX(K)
              MOVE 2 TO RP-FLGR
              MOVE 'RIG8' TO RP-BLK.

           SUBTRACT 1 FROM NRIG.   
           PERFORM RST THRU EX-RST.
      *  
           GO TO F10.
       F99.
           EXIT.
      *------------------
       G00-TOT-CESP.
           IF IF-TIPLAV = 2 GO TO G20.
           IF SW-COD NOT = 1 GO TO G10.
           MOVE ALL '=' TO SOTTOL.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG6' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           MOVE 'TOTALE CESPITE' TO ST-DSMO.
           MOVE CACQUIS TO ST-VAMM.
           MOVE CAMMENS TO ST-AMMO.
           MOVE CUTILIZ TO ST-UTIL.
           MOVE CACCANT TO ST-ACCA.
           MOVE CRESID  TO ST-RESI.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
       G10.
           MOVE ALL '=' TO ST-SOTT.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG6' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      * 
       G20.
           MOVE ZERO TO CACQUIS CAMMENS CUTILIZ CACCANT
                        CRESID SW-COD.
       G99.
           EXIT.
      *------------------
       H00-CAMB-CAT.
           OPEN INPUT CATAMM.
           MOVE IF-AZI  TO KCT-AZI.
           MOVE KLV-RAG TO KCT-CAT COMCAT.
           READ CATAMM INVALID MOVE ALL '*' TO CAT-DESCR.
           MOVE KCT-CAT TO ST-CRG.
           MOVE CAT-DESCR TO ST-RAG.
           CLOSE CATAMM.
           MOVE KLV-RAG TO KL3-CAT.
           READ WDSLA3 INVALID PERFORM M00-AZZ THRU M99.
           IF IF-TIPLAV= 2 GO TO BCX1-00.
      *
      *-- inizializza parametri per stampa report --*
           MOVE SPACE TO RP-TIT2.
           STRING ST-RD02 ' ' ST-CRG ' ' ST-RAG
                     DELIMITED SIZE INTO RP-TIT2.
      *
      *---------------------------------------------*
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *
           MOVE ALL '=' TO ST-SOTT2.  
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG7' TO RP-BLK.
           PERFORM RST THRU EX-RST.
      *  
           GO TO BCX1-00.
      *----------*
       L00-ERR-WDS.
           MOVE 'vamm140:Errore wdsla2' TO F-MES1.
           MOVE 1 TO F-NMES.
           CALL 'vrmbox' USING PARMB.
           MOVE ZERO TO IF-FLAMM.
       L99.
           EXIT.
      *------------------
       M00-AZZ.
           MOVE ZERO TO LA3-COSIN LA3-INCRE LA3-DECRE
                        LA3-INCAM LA3-UTAMM LA3-ACCIN
                        LA3-NONAM LA3-PLUSV LA3-MINUS
                        LA3-NONIN LA3-NONDE.
           MOVE ZERO TO K1.
       M10.
           ADD 1 TO K1.
           IF K1 > 2 GO TO M99.
           MOVE ZERO TO K2.
       M20.
           ADD 1 TO K2.
           IF K2 > 20 GO TO M10.
           MOVE ZERO TO LA3-VALAF(K1 K2)
                        LA3-IMPOF(K1 K2).
           MOVE ZERO TO LA3-VALA(K1 K2)
           MOVE ZERO TO LA3-ALIQ(K1 K2)
                        LA3-IMPO(K1 K2).
           GO TO M20.
       M99.
           EXIT.
      *------------------
       N00-STAPRO.
      *
           MOVE 1 TO RP-JMP.
      *
           MOVE ZERO TO TACQUIS TACCANT TNONAMM TAMMORD TAMMANT
                        TUTILIZ TINCREM TINCAMM TPLUSVA TINCNON
                        TDECREM TMINUSV TDECNON.
           MOVE ZERO TO KL3-CAT.

      *-- inizializza parametri per stampa a caratteri --*
           IF IF-LMOD = 12
              MOVE 72 TO NRGF
              MOVE 66 TO NRGL
           ELSE
              MOVE 66 TO NRGF
              MOVE 57 TO NRGL.
           MOVE C-TTS1  TO RTTS.
           MOVE 3       TO NINT.
           MOVE C-TINT1-1 TO XTINT(1).
           MOVE C-TINT1-2 TO XTINT(2).
           MOVE C-TINT1-3 TO XTINT(3).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'CESPITI AMMORTIZZABILI - ESERCIZIO ' PIN-ESE
                  '- PROSPETTO RIEPILOGATIVO CIVILISTICO'
                 DELIMITED SIZE INTO RP-TIT1.
      *
           MOVE SPACE TO RP-TIT2.
      *
           PERFORM RPT-RIG2B-INTC.
      *
      *    MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

           START WDSLA3 KEY NOT < KEYL3 INVALID GO TO N99.
           READ WDSLA3 NEXT AT END GO TO N99.
       N10.
           MOVE IF-AZI TO KCT-AZI.
           MOVE KL3-CAT TO KCT-CAT.
           READ CATAMM INVALID MOVE ALL '*' TO CAT-DESCR.
      **** rel 6.3
           MOVE KL3-CAT TO ST-DSCAT.
      ************
           MOVE CAT-DESCR TO ST-DSTIT.
           MOVE 'RIG1B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
           MOVE ALL '-' TO ST-DSTIT.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
           MOVE 'VALORI INIZIO ESERCIZIO' TO ST-DSPRO.
           MOVE LA3-COSIN TO ST-VAPRO.
           ADD  LA3-COSIN TO TACQUIS.
           MOVE LA3-ACCIN TO ST-ACPRO.
           ADD  LA3-ACCIN TO TACCANT.
           MOVE LA3-NONAM TO ST-NOPRO.
           ADD  LA3-NONAM TO TNONAMM.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
           MOVE 'INCREMENTI' TO ST-DSPRO.
           IF LA3-INCRE > ZERO
              MOVE LA3-INCRE TO ST-MOVVA
           ELSE
              MOVE LA3-INCRE TO ST-VAPRO.
           ADD LA3-INCRE TO TINCREM LA3-COSIN.
           IF LA3-INCAM = ZERO GO TO N20.
           MOVE LA3-INCAM TO ST-MOVAM.
           ADD  LA3-INCAM TO TINCAMM LA3-ACCIN.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
       N20.
           MOVE ZERO TO K SW-STA.
       N21.
           ADD 1 TO K.
           IF K > 2 MOVE ZERO TO K1 COMOD1 GO TO N30.
           MOVE ZERO TO N K1.
           MOVE 1 TO K2.
       N22.
           ADD 1 TO K1 K2.
           IF K2 > 20 GO TO N23.
           IF LA3-ALIQ(K K1) = ZERO AND LA3-IMPO(K K1) = ZERO
              GO TO N23.
           MOVE K TO SW-STA.
           IF LA3-ALIQ(K K2) = ZERO AND LA3-IMPO(K K2) = ZERO
              GO TO N23.
           IF LA3-ALIQ(K K1) NOT > LA3-ALIQ(K K2)
              GO TO N22.
           MOVE 1 TO N.
           MOVE LA3-ALIQ(K K1) TO PERCNO.
           MOVE LA3-IMPO(K K1) TO COMODO.
           MOVE LA3-ALIQ(K K2) TO LA3-ALIQ(K K1).
           MOVE PERCNO TO LA3-ALIQ(K K2).
           MOVE LA3-IMPO(K K2) TO LA3-IMPO(K K1).
           MOVE COMODO TO LA3-IMPO(K K2).
           GO TO N22.
       N23.
           IF N = 1 MOVE ZERO TO N K1
                    MOVE 1 TO K2
                    GO TO N22.
           GO TO N21.
       N30.
           ADD 1 TO K1.
           IF K1 > 2 GO TO N40.
           MOVE ZERO TO K2 COMODO.
       N31.
           ADD 1 TO K2.
           IF LA3-ALIQ(K1 K2) = ZERO AND LA3-IMPO(K1 K2) = ZERO
              GO TO N30.
       N32.
           IF LA3-ALIQ(K1 K2) = ZERO OR
              LA3-IMPO(K1 K2) = ZERO GO TO N32A.
           MOVE LA3-ALIQ(K1 K2) TO ST-PEPRO.
           IF LA3-ALIQ(K1 K2) > 99,99
              MOVE LA3-ALIQ(K1 K2) TO ST-PEPR1.
      **** rel 6.3
           IF LA3-ALIQ(K1 K2) = 888,888
             MOVE ZERO TO ST-PEPRO.
      ************
           MOVE '%' TO ST-SEPRO.
           MOVE LA3-IMPO(K1 K2) TO ST-AMPRO.
           ADD  LA3-IMPO(K1 K2) TO COMODO COMOD1.
           IF K1 = 1
              ADD LA3-IMPO(K1 K2) TO TAMMORD
           ELSE
              ADD LA3-IMPO(K1 K2) TO TAMMANT.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
       N32A.
           ADD 1 TO K2.
           IF NOT (K2 > 20 OR
                  (LA3-ALIQ(K1 K2) = ZERO AND LA3-IMPO(K1 K2) = ZERO))
                    GO TO N32.

           IF K1 = 2  OR SW-STA = 1 GO TO N40.
           IF COMODO > ZERO
              MOVE COMODO TO ST-MOVAM
           ELSE
              MOVE COMODO TO ST-ACPRO.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
       N40.
           IF COMODO > ZERO
              MOVE COMODO TO ST-MOVAM
           ELSE
              MOVE COMODO TO ST-ACPRO.
           ADD  COMOD1 TO LA3-ACCIN.
           IF LA3-NONIN > ZERO
              MOVE LA3-NONIN TO ST-MOVNO
           ELSE
              MOVE LA3-NONIN TO ST-NOPRO.
           ADD  LA3-NONIN TO LA3-NONAM TINCNON.
           MOVE LA3-PLUSV TO ST-PLPRO.
           IF LA3-PLUSV NOT = ZERO MOVE 'P' TO ST-INPRO
                                   ADD  LA3-PLUSV TO TPLUSVA.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
           MOVE 'DECREMENTI' TO ST-DSPRO.
           MOVE LA3-DECRE TO ST-VAPRO.
           ADD  LA3-DECRE TO LA3-COSIN TDECREM.
           MOVE LA3-UTAMM TO ST-UTPRO ST-ACPRO.
           ADD  LA3-UTAMM TO TUTILIZ LA3-ACCIN.
           MOVE LA3-NONDE TO ST-NOPRO.
           ADD  LA3-NONDE TO TDECNON LA3-NONAM.
           MOVE LA3-MINUS TO ST-PLPRO.
           IF LA3-MINUS NOT = ZERO MOVE 'M' TO ST-INPRO
                                   ADD  LA3-MINUS TO TMINUSV.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
           MOVE ALL '-' TO P998B.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
           MOVE 'VALORI  FINE  ESERCIZIO' TO ST-DSPRO.
           MOVE LA3-COSIN TO ST-VAPRO.
           MOVE COMOD1 TO ST-AMPRO.
           MOVE LA3-UTAMM TO ST-UTPRO.
           MOVE LA3-ACCIN TO ST-ACPRO.
           MOVE LA3-NONAM TO ST-NOPRO.
      **** rel 6.2
      *    COMPUTE COMODO = LA3-COSIN - (LA3-ACCIN + LA3-NONAM).   
           COMPUTE COMODO = LA3-COSIN - LA3-ACCIN.   *> mary
      ************
           MOVE COMODO TO ST-REPRO.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
           MOVE ALL '=' TO P999B.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
       N50.
           DELETE WDSLA3.
           READ WDSLA3 NEXT AT END GO TO N90.
           IF SF-LA3 = '9D' OR '9A' OR '35' GO TO N50.
           GO TO N10.
       N90.
           MOVE ZERO TO COMODO.
           MOVE 'T O T A L I' TO ST-DSTIT.
           MOVE 'RIG1B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
           MOVE ALL '-' TO ST-DSTIT.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
           MOVE 'VALORI INIZIO ESERCIZIO' TO ST-DSPRO.
           MOVE TACQUIS TO ST-VAPRO.
           MOVE TACCANT TO ST-ACPRO.
           MOVE TNONAMM TO ST-NOPRO.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
           MOVE 'INCREMENTI' TO ST-DSPRO.
           IF TINCREM > ZERO
              MOVE TINCREM TO ST-MOVVA
           ELSE
              MOVE TINCREM TO ST-VAPRO.
           ADD TINCREM TO TACQUIS.
           IF TINCAMM = ZERO GO TO N91.
           MOVE TINCAMM TO ST-MOVAM.
           ADD  TINCAMM TO TACCANT.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *
       N91.
           MOVE TAMMORD TO ST-AMPRO.
           ADD TAMMORD TO TACCANT COMODO.
           IF TAMMANT = ZERO GO TO N92.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
           MOVE 'ANTICIP.' TO ST-DSTIP.
           MOVE TAMMANT TO ST-AMPRO.
           ADD TAMMANT TO TACCANT COMODO.
       N92.
           IF COMODO > ZERO
              MOVE COMODO TO ST-MOVAM
           ELSE
              MOVE COMODO TO ST-ACPRO.
      *
           IF TINCNON > ZERO
              MOVE TINCNON TO ST-MOVNO
           ELSE
              MOVE TINCNON TO ST-NOPRO.
           ADD  TINCNON TO TNONAMM.
           MOVE TPLUSVA TO ST-PLPRO.
           IF TPLUSVA NOT = ZERO MOVE 'P' TO ST-INPRO.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *
           MOVE 'DECREMENTI' TO ST-DSPRO.
           MOVE TDECREM TO ST-VAPRO.
           ADD  TDECREM TO TACQUIS.
           MOVE TUTILIZ TO ST-UTPRO ST-ACPRO.
           ADD  TUTILIZ TO TACCANT.
           MOVE TDECNON TO ST-NOPRO.
           ADD  TDECNON TO TNONAMM.
           MOVE TMINUSV TO ST-PLPRO.
           IF TMINUSV NOT = ZERO MOVE 'M' TO ST-INPRO.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
           MOVE ALL '-' TO P998B.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
           MOVE 'VALORI  FINE  ESERCIZIO' TO ST-DSPRO.
           MOVE TACQUIS TO ST-VAPRO.
           MOVE TACCANT TO ST-ACPRO.
           MOVE TNONAMM TO ST-NOPRO.
           MOVE COMODO  TO ST-AMPRO.
           MOVE TUTILIZ TO ST-UTPRO.
           MOVE ZERO TO COMODO.
      **** rel 6.2
      *    COMPUTE COMODO = TACQUIS - (TACCANT + TNONAMM).
           COMPUTE COMODO = TACQUIS - TACCANT.     *> mary
      ************
           MOVE COMODO TO ST-REPRO.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
           MOVE ALL '=' TO P999B.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3B' TO RP-BLK.
           PERFORM RST-B THRU EX-RST-B.
      *  
           IF RP-TRPT = 1     GO TO N99.
      * sempre barratura
      *    IF IF-TIPLAV NOT = 3 GO TO N99.
           IF NRIG NOT < NRGL GO TO N99.
           COMPUTE N = NRGL - NRIG.
           COMPUTE N = N + (132 - N) / 2.
           MOVE N TO K.
           ADD 1 TO N.
       N95.    
           IF NRIG NOT < (NRGL - 2) GO TO N99. 
           ADD 1 TO NRIG.
           IF NRIG = (NRGL - 2) 
              MOVE ALL '=' TO P999B 
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3B' TO RP-BLK 
           ELSE 
              SUBTRACT 1 FROM N K
              MOVE '/' TO RXB(N) RXB(K)
              MOVE 2 TO RP-FLGR
              MOVE 'RIG5B' TO RP-BLK.

           SUBTRACT 1 FROM NRIG.   
           PERFORM RST-B THRU EX-RST-B.
      *  
           GO TO N95.
       N99.
           EXIT.
      *------------------
       VERIFICA-MOVIMENTI.
           MOVE ZERO TO FLGMOV.
           MOVE KAN-AZI TO KAM-AZI.
           MOVE KAN-RAG TO KAM-RAG.
           MOVE KAN-COD TO KAM-COD.
           MOVE KAN-INC TO KAM-INC.
           MOVE ZERO TO KAM-DAT KAM-PRG.
           START MOVAMM KEY NOT < KEYAM INVALID GO TO V99.
       RDNX.
           READ MOVAMM NEXT AT END GO TO V99.
           IF SF-AMM = '9D' OR '9A' OR '35' GO TO RDNX.
           IF KAM-AZI > KAN-AZI GO TO V99.
           IF KAM-RAG > KAN-RAG GO TO V99.
           IF KAM-COD > KAN-COD GO TO V99.
           IF KAM-INC > KAN-INC GO TO V99.
           IF KAM-DAT < INIESK OR > FINESK GO TO RDNX.
           MOVE 1 TO FLGMOV.
       V99.
           EXIT.
      *------------------
       CALC-FISCALE.
           MOVE ZERO TO AMMENSF AMMANTF.
           IF ALNORMF = ZERO GO TO C99.

      *> calcolo quota amm. ordinario fiscale
           MOVE ZERO TO COMOD1 COMOD2.
           COMPUTE COMOD1 = (((VALAMMF * ALNORMF) / 100) *
                             PDEDFIS) / 100.
           MOVE COMOD1 TO RD-NUM.
           CALL 'vrround' USING NNN-E PARRD DEC-2.
           MOVE RD-NUM TO COMOD1.
           MOVE COMOD1 TO AMMENSF.
           IF AMTOES = 1 MOVE VALAMM TO AMMENSF.
           IF AMMENSF > RESFIS
              MOVE RESFIS TO AMMENSF
              COMPUTE COMOD1 = AMMENSF * 100
      **** rel 6.3
      *       COMPUTE COMOD2 = COMOD1 / VALAMMF + 0,0009
      *       MOVE COMOD2 TO ALNORMF.
              COMPUTE RD-NUM = COMOD1 / VALAMMF 
              CALL 'vrround' USING NNN-D PARRD DEC-2
              MOVE RD-NUM TO ALNORMF.
      ************
           SUBTRACT AMMENSF FROM RESFIS.

      *> variazione rettificativa (fiscale - civilistico)
           COMPUTE VARRET = AMMENSF - AMMENS.

           IF IF-TIPLAV = 3 ADD AMMENSF TO TOTAFIS
           ELSE ADD AMMENSF TO COMTFIS.

           IF RESFIS = ZERO GO TO C99.
      *> calcolo se sono ancora nei primi 3 anni x Amm. Anticipato
           IF ALANTI = ZERO GO TO C99.
           COMPUTE COMODO = IF-ESERC - ANA-ANACQ.
           IF (T25ESE NOT = ZERO) AND
              (ANA-ANACQ <= AAAPE  AND ANA-MSACQ >= MMAPE)
              COMPUTE COMODO = (IF-ESERC - 1) - ANA-ANACQ.
           IF ANA-STATO = 1 AND IF-ESERC > 1988 AND ANA-ANACQ > 1987
              IF ANA-RES > ZERO
                 COMPUTE COMODO = COMODO + 3 - ANA-RES
              ELSE
                 GO TO C99.
           IF COMODO NOT < 3 GO TO C99.

      *> calcolo quota amm. anticipato fiscale
           COMPUTE COMOD1 = (((VALAMMF * ALANTIF) / 100) *
                            PDEDFIS) / 100.
           MOVE COMOD1 TO RD-NUM.
           CALL 'vrround' USING NNN-E PARRD DEC-2.
           MOVE RD-NUM TO COMOD1.
           MOVE COMOD1 TO COMODO.

           IF COMODO > RESFIS
              MOVE RESFIS TO COMODO
              COMPUTE COMOD1 = COMODO * 100
      **** rel 6.3
      *       COMPUTE COMOD2 = COMOD1 / VALAMMF + 0,0009
      *       MOVE COMOD2 TO ALANTIF.
              COMPUTE RD-NUM = COMOD1 / VALAMMF 
              CALL 'vrround' USING NNN-D PARRD DEC-2
              MOVE RD-NUM TO ALANTIF.
      ************

           MOVE COMODO TO AMMANTF.
           MOVE COMODO TO TOTANT.
           IF IF-TIPLAV = 3 ADD COMODO TO TOTAFIS
           ELSE ADD COMODO TO COMTFIS.
           SUBTRACT AMMANTF FROM RESFIS.

      *> variazione rettificativa
           COMPUTE COMOD1 = AMMENSF + AMMANTF.
           COMPUTE VARRET = COMOD1 - AMMENS.
       C99.
           EXIT.
      *------------------
       S00-STORICO.
           MOVE ZERO TO CODICE.
           MOVE IF-AZI TO KAN-AZI.
           MOVE 99999 TO KAN-DTAPE KAN-DTCHI.
           MOVE PRCD   TO KAN-CD.
           START ANAMMO KEY NOT < KEYAN INVALID GO TO S99.
       S03.
           READ ANAMMO NEXT AT END GO TO S99.
           IF SF-AMM = '9D' OR '9A' OR '35' GO TO S03.
           IF KAN-AZI > IF-AZI GO TO S99.
           IF KAN-CD  > ULCD   GO TO S99.
           IF ANA-ANACQ > IF-ESERC GO TO S50.
           IF T25ESE NOT = ZERO
      **** rel 6.2
      *       IF ANA-ANACQ = IF-ESERC AND ANA-MSACQ > MMCHI GO TO S03.
              IF ANA-ANACQ = IF-ESERC AND ANA-MSACQ > MMCHI GO TO S50.
      ************
           MOVE DTAPEP  TO KAN-DTAPE.
           MOVE DTCHIU  TO KAN-DTCHI.
           WRITE RF-ANA INVALID PERFORM INVK-ANA
                                 GO TO ERRIO.
           GO TO S03.

       S50.
           MOVE KAN-AZI TO KAM-AZI.
           MOVE KAN-RAG TO KAM-RAG.
           MOVE KAN-COD TO KAM-COD.
           MOVE KAN-INC TO KAM-INC.
           MOVE ZERO TO KAM-DAT KAM-PRG.
           START MOVAMM KEY NOT < KEYAM INVALID GO TO S03.
       S51.
           READ MOVAMM NEXT AT END GO TO S03.
           IF SF-AMM = '9D' OR '9A' OR '35' GO TO S51.
           IF KAM-AZI > KAN-AZI GO TO S03.
           IF KAM-RAG > KAN-RAG GO TO S03.
           IF KAM-COD > KAN-COD GO TO S03.
           IF KAM-INC > KAN-INC GO TO S03.
           IF KAM-DAT < INIESK OR > FINESK GO TO S51.
           MOVE DTAPEP  TO KAN-DTAPE.
           MOVE DTCHIU  TO KAN-DTCHI.
           WRITE RF-ANA INVALID PERFORM INVK-ANA
                                 GO TO ERRIO.
           GO TO S03.
       S99.
           EXIT.
      *------------------
       CHECK-TIPO.
      **** rel 7.1
           MOVE ZERO TO SW-ACQES.
      ************
           MOVE KAN-AZI TO KAM-AZI.
           MOVE KAN-RAG TO KAM-RAG.
           MOVE KAN-COD TO KAM-COD.
           MOVE KAN-INC TO KAM-INC.
           MOVE ZERO TO KAM-DAT KAM-PRG.
           MOVE SPACES TO SW5.
           START MOVAMM KEY NOT < KEYAM INVALID GO TO EX-CHECK-TIPO.
       CHECK-01.
           READ MOVAMM NEXT AT END GO TO EX-CHECK-TIPO.
           IF SF-AMM = '9D' OR '9A' OR '35' GO TO EX-CHECK-TIPO.
           IF KAM-AZI > KAN-AZI GO TO EX-CHECK-TIPO.
           IF KAM-RAG > KAN-RAG GO TO EX-CHECK-TIPO.
           IF KAM-COD > KAN-COD GO TO EX-CHECK-TIPO.
           IF KAM-INC > KAN-INC GO TO EX-CHECK-TIPO.
      **** rel 7.1
           IF KAM-DAT > FINESK AND AMM-TIPO = 1
             AND ANA-ANACQ > IF-ESERC
               MOVE 1 TO SW-ACQES
               GO TO EX-CHECK-TIPO.
      ************
           IF KAM-DAT < INIESK OR > FINESK GO TO CHECK-01.
           IF AMM-TIPO = 5 AND AMM-SWTIPO5 = 1
                MOVE '*' TO SW5
                GO TO EX-CHECK-TIPO.
           IF AMM-TIPO NOT = 1 GO TO CHECK-01.
              MOVE KAM-DAT TO AAGGG
              MOVE 1 TO TIPOP1
              CALL 'rdata' USING PARCDT
              GO TO CHECK-01.
       EX-CHECK-TIPO.
           EXIT.
      *------------------
      *-------------*
       RST.
           PERFORM RPT-WR.
           IF RP-TRPT = 2 AND (NRIG NOT < (NRGL - 2))
                 PERFORM STA-PIE.
       EX-RST.
           EXIT.
      *------------------
       RST-B.
           PERFORM RPT-WR.
           IF RP-TRPT = 2 AND (NRIG NOT < (NRGL - 2))
                 PERFORM STA-PIE-B.
       EX-RST-B.
           EXIT.
      *------------------
       STA-PIE.
           IF IF-NBOL = 1
              MOVE IF-PIEDE-1 TO P999
              MOVE 2 TO RP-FLGR
              MOVE 'RIG5' TO RP-BLK
              PERFORM RPT-WR
              MOVE IF-PIEDE-2 TO P999
              MOVE 2 TO RP-FLGR
              MOVE 'RIG5' TO RP-BLK
              PERFORM RPT-WR.
      *------------------
       STA-PIE-B.
           IF IF-NBOL = 1
              MOVE IF-PIEDE-1 TO P999B
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3B' TO RP-BLK
              PERFORM RPT-WR
              MOVE IF-PIEDE-2 TO P999B
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3B' TO RP-BLK
              PERFORM RPT-WR.
      *------------------
       RPT-RIG3-INTC.
           MOVE 'RIG3' TO RP-BLK.
      *
           MOVE 'Data' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Val. Acquisto' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      **** rel 6.2
      *    MOVE 'Val. Ammortizzzato          Perc.' TO RP-IFLD.
      *    PERFORM RPT-ADD-I.
           MOVE 'Val. Ammortizzabile         Perc.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      ************
           MOVE 'Importo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Utilizzato         Accantonato        Residuo'
                 TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
       RPT-RIG2B-INTC.
           MOVE 'RIG2B' TO RP-BLK.
      *
           MOVE 'Descrizione' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Val. Cespiti' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      **** rel 6.2
      *    MOVE 'Amm. Aliq.' TO RP-IFLD.
      *    PERFORM RPT-ADD-I.
      *    MOVE 'Amm. Importi' TO RP-IFLD.
      *    PERFORM RPT-ADD-I.
      *    MOVE 'Fondo Amm. Util.' TO RP-IFLD.
      *    PERFORM RPT-ADD-I.
      *    MOVE 'Fondo Amm. Accan.' TO RP-IFLD.
      *    PERFORM RPT-ADD-I.
           MOVE 'Aliquota Amm.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Importo Amm.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'F.do Amm. Utiliz.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'F.do Amm. Accanto.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      ************
           MOVE 'Val. Non Ammort.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Residuo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Plus/Minusvalenze' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
