       IDENTIFICATION DIVISION.
       PROGRAM-ID. VARC123.
      *
      * Lista di controllo tabella parametri
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'gritabsl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS 
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gritab'.
           COPY 'gricon'.
       FD  WDSLAV LABEL RECORD STANDARD 
           VALUE OF FILE-ID ID-LAV
           RECORD 100 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
              10 KLV-VID   PIC 99.
              10 KLV-PRG   PIC 9(3).
           05 LAV-COD      PIC 9(7).
           05 LAV-TIP      PIC 9.
           05 LAV-DSVID    PIC X(52).
           05 FILLER       PIC X(35).
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'gritabrk'.
           COPY 'grit14g'.
           COPY 'grit14h'.
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CON  PIC X(15) VALUE 'anacon'.
       01  ID-LAV  PIC X(15) VALUE 'wdslav'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-CON  PIC XX.
           05 SF-LAV   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
       01  REKT14L.
           05 FILLER     PIC X(5).
           05 T14LCRCGR  PIC 9(7) COMP-3.
           05 T14LCRSCM  PIC 9(7) COMP-3.
           05 T14LCFTEM1 PIC 9(7) COMP-3.
           05 T14LCFTEM2 PIC 9(7) COMP-3.
           05 T14LCFTEM3 PIC 9(7) COMP-3.
           05 T14LCNAEM1 PIC 9(7) COMP-3.
           05 T14LCNAEM2 PIC 9(7) COMP-3.
           05 T14LCNAEM3 PIC 9(7) COMP-3.
           05 T14LCFTRC1 PIC 9(7) COMP-3.
           05 T14LCFTRC2 PIC 9(7) COMP-3.
           05 T14LCFTRC3 PIC 9(7) COMP-3.
           05 T14LCNARC1 PIC 9(7) COMP-3.
           05 T14LCNARC2 PIC 9(7) COMP-3.
           05 T14LCNARC3 PIC 9(7) COMP-3.
           05 T14LCAUFEM PIC 999.
           05 T14LCAUFRC PIC 999.
           05 T14LFILLER PIC X(5).
      *
           COPY 'varc123.cpy'.
      *
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'. 
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcllav'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'varc123: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE ANACON.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'gritaber'.
           COPY 'griazier'.
           COPY 'griconer'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           IF IF-FL = ZERO
              MOVE 'tabell' TO ID-TAB
           ELSE
              MOVE 'tabold' TO ID-TAB
              MOVE 'anazol' TO ID-AZI
              MOVE 'anacol' TO ID-CON.
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN INPUT ANACON.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O WDSLAV.
           MOVE 1 TO SWINI.

           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           PERFORM RPT-INI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.     
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB KEY KEYTB INVALID
                MOVE ZERO TO T01-CIVAV T01-CIVAQ T01-CRPCL T01-CRPC1
                             T01-CRPC2 T01-CRPFR T01-CRPF1 T01-CRPF2
                             T01-MCLI T01-MFOR T01-CIVSO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *
           MOVE ZERO TO RF-LAV.
           MOVE 1 TO KLV-VID.
           MOVE 2 TO KLV-PRG.
           MOVE T01-CIVAV TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO IVA VENDITE' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 1 TO KLV-VID.
           MOVE 3 TO KLV-PRG.
           MOVE T01-CIVAQ TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO IVA ACQUISTI' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 1 TO KLV-VID.
           MOVE 4 TO KLV-PRG.
           MOVE T01-CIVSO TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO IVA FATTURE IN SOSPESO' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 1 TO KLV-VID.
           MOVE 5 TO KLV-PRG.
           MOVE T01-MCLI TO LAV-COD.
           MOVE 1 TO LAV-TIP.
           MOVE 'MASTRO CLIENTI' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 1 TO KLV-VID.
           MOVE 6 TO KLV-PRG.
           MOVE T01-MFOR TO LAV-COD.
           MOVE 1 TO LAV-TIP.
           MOVE 'MASTRO FORNITORI' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 6 TO KLV-VID.
           MOVE 1 TO KLV-PRG.
           MOVE T01-CRPFR TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RIEPILOGATIVO CATEGORIA 0/1' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 6 TO KLV-VID.
           MOVE 2 TO KLV-PRG.
           MOVE T01-CRPF1 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RIEPILOGATIVO CATEGORIA 2' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 6 TO KLV-VID.
           MOVE 3 TO KLV-PRG.
           MOVE T01-CRPF2 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RIEPILOGATIVO CATEGORIA 3' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 7 TO KLV-VID.
           MOVE 1 TO KLV-PRG.
           MOVE T01-CRPCL TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RIEPILOGATIVO CATEGORIA 0/1' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 7 TO KLV-VID.
           MOVE 3 TO KLV-PRG.
           MOVE T01-CRPC1 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RIEPILOGATIVO CATEGORIA 2' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 7 TO KLV-VID.
           MOVE 5 TO KLV-PRG.
           MOVE T01-CRPC2 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RIEPILOGATIVO CATEGORIA 3' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 14 TO KTB-TIP.
           MOVE 1 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE ZERO TO T14-RICAV T14-SPBOL T14-SPBAN
                             T14-RIBAN T14-TRATT T14-FATT T14-RB
                             T14-TRT T14-IVABL T14-IVABA T14-CMAG
                             T14-CDCOR T14-FTRI T14-COSTI.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE 1 TO KLV-VID.
           MOVE 7 TO KLV-PRG.
           MOVE T14-COSTI TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO COSTI' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 1 TO KLV-VID.
           MOVE 8 TO KLV-PRG.
           MOVE T14-RICAV TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO RICAVI' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 1 TO KLV-VID.
           MOVE 9 TO KLV-PRG.
           MOVE T14-CDCOR TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO CORRISPETTIVI DA SCORPORARE' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 6 TO KLV-PRG.
           MOVE T14-SPBOL TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO SPESE BOLLO' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 7 TO KLV-PRG.
           MOVE T14-SPBAN TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO SPESE BANCA' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 8 TO KLV-PRG.
           MOVE T14-RIBAN TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO PORTAFOGLIO RICEVUTE BANCARIE' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 9 TO KLV-PRG.
           MOVE T14-TRATT TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO PORTAFOGLIO TRATTE' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 11 TO KLV-PRG.
           MOVE T14-FATT TO LAV-COD.
           MOVE 2 TO LAV-TIP.
           MOVE 'CAUSALE CONTABILITA'' : FATTURA' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 15 TO KLV-PRG.
           MOVE T14-RB TO LAV-COD.
           MOVE 2 TO LAV-TIP.
           MOVE 'CAUSALE CONTABILITA'' : RICEVUTE BANCARIE' 
                                               TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 16 TO KLV-PRG.
           MOVE T14-TRT TO LAV-COD.
           MOVE 2 TO LAV-TIP.
           MOVE 'CAUSALE CONTABILITA'' : TRATTE' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 20 TO KLV-PRG.
           MOVE T14-IVABL TO LAV-COD.
           MOVE 3 TO LAV-TIP.
           MOVE 'CODICE IVA FATTURA : SPESE BOLLO' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 21 TO KLV-PRG.
           MOVE T14-IVABA TO LAV-COD.
           MOVE 3 TO LAV-TIP.
           MOVE 'CODICE IVA FATTURA : SPESE BANCA' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 14 TO KTB-TIP.
           MOVE 10 TO KTB-COD.
           READ TABELL INTO REKT14L INVALID
           MOVE ZERO TO T14LCRCGR  T14LCRSCM  T14LCFTEM1 T14LCFTEM2 
                        T14LCFTEM3 T14LCNAEM1 T14LCNAEM2 T14LCNAEM3 
                        T14LCFTRC1 T14LCFTRC2 T14LCFTRC3 T14LCNARC1 
                        T14LCNARC2 T14LCNARC3.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT14L.
           MOVE 14 TO KTB-TIP.
           MOVE 2 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE ZERO TO T14-ACCR T14-FTSO T14-ACSO T14-CSGR
                             T14-IVGR T14-SCON T14-RIC1 T14-RIC2
                             T14-RIC3 T14-IVRB T14-ACCO T14-CACC.
           MOVE 7 TO KLV-VID.
           MOVE 2 TO KLV-PRG.
           MOVE T14-RIC1 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RICAVI CATEGORIA 0/1' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 7 TO KLV-VID.
           MOVE 4 TO KLV-PRG.
           MOVE T14-RIC2 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RICAVI CATEGORIA 2' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 7 TO KLV-VID.
           MOVE 6 TO KLV-PRG.
           MOVE T14-RIC3 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RICAVI CATEGORIA 3' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 1 TO KLV-PRG.
           MOVE T14-CSGR TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO COSTO PER CESSIONI GRATUITE' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 2 TO KLV-PRG.
           MOVE T14LCRCGR TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO RICAVO PER CESSIONI GRATUITE' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 3 TO KLV-PRG.
           MOVE T14-IVGR TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO COSTO PER IVA NON ADDEBITATA' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 4 TO KLV-PRG.
           MOVE T14-SCON TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO COSTO SCONTI O PREMI IN MERCE' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 5 TO KLV-PRG.
           MOVE T14LCRSCM TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO RICAVO SCONTI O PREMI IN MERCE' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 10 TO KLV-PRG.
           MOVE T14-CACC TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO CASSA ACCONTI MERCE DA FATTURARE' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 12 TO KLV-PRG.
           MOVE T14-ACCR TO LAV-COD.
           MOVE 2 TO LAV-TIP.
           MOVE 'CAUSALE CONTABILITA'' : ACCREDITO' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 13 TO KLV-PRG.
           MOVE T14-FTSO TO LAV-COD.
           MOVE 2 TO LAV-TIP.
           MOVE 'CAUSALE CONTABILITA'' : FATTURA IN SOSPESO' 
                                               TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 14 TO KLV-PRG.
           MOVE T14-ACSO TO LAV-COD.
           MOVE 2 TO LAV-TIP.
           MOVE 'CAUSALE CONTABILITA'' : ACCREDITO IN SOSPESO' 
                                               TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 17 TO KLV-PRG.
           MOVE T14-ACCO TO LAV-COD.
           MOVE 2 TO LAV-TIP.
           MOVE 'CAUSALE CONTABILITA'' : ACCONTI MERCE DA FATT.'
                                                  TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 14 TO KTB-TIP.
           MOVE 5 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE ZERO TO T14-IVER T14-RICO T14-GIIV T14-GICO
                             T14-IDIR T14-ITRI T14-IIND T14-ISCV
                             T14-IRSM T14-IASS T14-ISIN T14-1ACQ
                             T14-1ACR T14-1ACT T14-2ACQ T14-3ACQ
                             T14-IPOS.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE 1 TO KLV-VID.
           MOVE 1 TO KLV-PRG.
           MOVE T14-IVER TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO ERARIO C/O IVA' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 1 TO KLV-VID.
           MOVE 10 TO KLV-PRG.
           MOVE T14-RICO TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO RICAVI CORRISPETTIVI' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 18 TO KLV-PRG.
           MOVE T14-GICO TO LAV-COD.
           MOVE 2 TO LAV-TIP.
           MOVE 'CAUSALE CONTABILITA'' : GIRO SCORPORO CORRISP.'
                                                  TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 2 TO KLV-VID.
           MOVE 19 TO KLV-PRG.
           MOVE T14-GIIV TO LAV-COD.
           MOVE 2 TO LAV-TIP.
           MOVE 'CAUSALE CONTABILITA'' : GIRO IVA A ERARIO.'
                                                  TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 4 TO KLV-VID.
           MOVE 1 TO KLV-PRG.
           MOVE T14-1ACQ TO LAV-COD.
           MOVE 3 TO LAV-TIP.
           MOVE 'ACQUISTI ART.8 c.2' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 4 TO KLV-VID.
           MOVE 2 TO KLV-PRG.
           MOVE T14-1ACR TO LAV-COD.
           MOVE 3 TO LAV-TIP.
           MOVE 'ACQUISTI DA ESPORTARE NELLO STATO ORIGINARIO'
                                                 TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 4 TO KLV-VID.
           MOVE 3 TO KLV-PRG.
           MOVE T14-1ACT TO LAV-COD.
           MOVE 3 TO LAV-TIP.
           MOVE 'ACQUISTI IN TRIANGOLAZIONE' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 4 TO KLV-VID.
           MOVE 4 TO KLV-PRG.
           MOVE T14-2ACQ TO LAV-COD.
           MOVE 3 TO LAV-TIP.
           MOVE 'ACQUISTI ART.8bis c.2' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 4 TO KLV-VID.
           MOVE 5 TO KLV-PRG.
           MOVE T14-3ACQ TO LAV-COD.
           MOVE 3 TO LAV-TIP.
           MOVE 'ACQUISTI ART.9 c.2' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 4 TO KLV-VID.
           MOVE 6 TO KLV-PRG.
           MOVE T14-IDIR TO LAV-COD.
           MOVE 3 TO LAV-TIP.
           MOVE 'ESPORTAZIONI ART.8 c.1/a' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 4 TO KLV-VID.
           MOVE 7 TO KLV-PRG.
           MOVE T14-ITRI TO LAV-COD.
           MOVE 3 TO LAV-TIP.
           MOVE 'ESPORTAZIONI IN TRIANGOLAZIONE' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 4 TO KLV-VID.
           MOVE 8 TO KLV-PRG.
           MOVE T14-IIND TO LAV-COD.
           MOVE 3 TO LAV-TIP.
           MOVE 'ESPORTAZIONI ART.8 c.1/b' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 4 TO KLV-VID.
           MOVE 9 TO KLV-PRG.
           MOVE T14-ISCV TO LAV-COD.
           MOVE 3 TO LAV-TIP.
           MOVE 'ESPORTAZIONI STATO CITTA'' DEL VATICANO' 
                                            TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 4 TO KLV-VID.
           MOVE 10 TO KLV-PRG.
           MOVE T14-IRSM TO LAV-COD.
           MOVE 3 TO LAV-TIP.
           MOVE 'ESPORTAZIONI REPUBBLICA S. MARINO' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 4 TO KLV-VID.
           MOVE 11 TO KLV-PRG.
           MOVE T14-IPOS TO LAV-COD.
           MOVE 3 TO LAV-TIP.
           MOVE 'ESPORTAZIONI A MEZZO UFFICIO POSTALE' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 4 TO KLV-VID.
           MOVE 12 TO KLV-PRG.
           MOVE T14-IASS TO LAV-COD.
           MOVE 3 TO LAV-TIP.
           MOVE 'OPERAZIONI ASSIMILATE ART.8bis c.1' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 4 TO KLV-VID.
           MOVE 13 TO KLV-PRG.
           MOVE T14-ISIN TO LAV-COD.
           MOVE 3 TO LAV-TIP.
           MOVE 'SERVIZI INTERNAZIONALI ART.9 c.1' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 14 TO KTB-TIP.
           MOVE 6 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE ZERO TO T14-CAVC T14-CARC T14-CAOC T14-CASC
                             T14-CAGC T14-CAAF T14-CARF.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE 3 TO KLV-VID.
           MOVE ZERO TO KLV-PRG.
           MOVE ZERO TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE '** CODICI CAUSALI DI MAGAZZINO :' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 3 TO KLV-VID.
           MOVE 1 TO KLV-PRG.
           MOVE T14-CAVC TO LAV-COD.
           MOVE 7 TO LAV-TIP.
           MOVE 'VENDITE' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 3 TO KLV-VID.
           MOVE 2 TO KLV-PRG.
           MOVE T14-CARC TO LAV-COD.
           MOVE 7 TO LAV-TIP.
           MOVE 'RESI DA CLIENTI' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 3 TO KLV-VID.
           MOVE 3 TO KLV-PRG.
           MOVE T14-CAOC TO LAV-COD.
           MOVE 7 TO LAV-TIP.
           MOVE 'CESSIONI GRATUITE' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 3 TO KLV-VID.
           MOVE 4 TO KLV-PRG.
           MOVE T14-CASC TO LAV-COD.
           MOVE 7 TO LAV-TIP.
           MOVE 'CESSIONI SCONTI IN MERCE' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 3 TO KLV-VID.
           MOVE 5 TO KLV-PRG.
           MOVE T14-CAGC TO LAV-COD.
           MOVE 7 TO LAV-TIP.
           MOVE 'CESSIONI PER SOSTITUZIONE IN GARANZIA' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 3 TO KLV-VID.
           MOVE 6 TO KLV-PRG.
           MOVE T14-CAAF TO LAV-COD.
           MOVE 7 TO LAV-TIP.
           MOVE 'ACQUISTI' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 3 TO KLV-VID.
           MOVE 7 TO KLV-PRG.
           MOVE T14-CARF TO LAV-COD.
           MOVE 7 TO LAV-TIP.
           MOVE 'RESI DA FORNITORI' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 4 TO KLV-VID.
           MOVE ZERO TO KLV-PRG.
           MOVE ZERO TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE '** CODICI IVA PER GESTIONE PLAFOND :' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 14 TO KTB-TIP.
           MOVE 7  TO KTB-COD.
           READ TABELL INTO RKTB14G INVALID
           MOVE ZERO TO T14-CRPC3 T14-CRPC4 T14-CRPC5 T14-CRPC6
                        T14-CRPC7 T14-CRPC8
                        T14-CRPF3 T14-CRPF4 T14-CRPF5 T14-CRPF6
                        T14-CRPF7 T14-CRPF8.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB14G.
           MOVE 14 TO KTB-TIP.
           MOVE 8  TO KTB-COD.
           READ TABELL INTO RKTB14H INVALID 
           MOVE ZERO TO T14-RIC4 T14-RIC5 T14-RIC6 T14-RIC7
                        T14-RIC8 T14-RIC9.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB14H.
           MOVE 6 TO KLV-VID.
           MOVE ZERO TO KLV-PRG.
           MOVE ZERO TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE '** CONTI RIEPILOGATIVI FORNITORI :' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 6 TO KLV-VID.
           MOVE 4 TO KLV-PRG.
           MOVE T14-CRPF3 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RIEPILOGATIVO CATEGORIA 4' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 6 TO KLV-VID.
           MOVE 5 TO KLV-PRG.
           MOVE T14-CRPF4 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RIEPILOGATIVO CATEGORIA 5' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 6 TO KLV-VID.
           MOVE 6 TO KLV-PRG.
           MOVE T14-CRPF5 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RIEPILOGATIVO CATEGORIA 6' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 6 TO KLV-VID.
           MOVE 7 TO KLV-PRG.
           MOVE T14-CRPF6 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RIEPILOGATIVO CATEGORIA 7' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 6 TO KLV-VID.
           MOVE 8 TO KLV-PRG.
           MOVE T14-CRPF7 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RIEPILOGATIVO CATEGORIA 8' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 6 TO KLV-VID.
           MOVE 9 TO KLV-PRG.
           MOVE T14-CRPF8 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RIEPILOGATIVO CATEGORIA 9' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 7 TO KLV-VID.
           MOVE ZERO TO KLV-PRG.
           MOVE ZERO TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE '** CONTI RIEPILOGATIVI E RICAVI CLIENTI :' 
                                                           TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 7 TO KLV-VID.
           MOVE 7 TO KLV-PRG.
           MOVE T14-CRPC3 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RIEPILOGATIVO CATEGORIA 4' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 7 TO KLV-VID.
           MOVE 8 TO KLV-PRG.
           MOVE T14-RIC4 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RICAVI CATEGORIA 4' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 7 TO KLV-VID.
           MOVE 9 TO KLV-PRG.
           MOVE T14-CRPC4 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RIEPILOGATIVO CATEGORIA 5' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 7 TO KLV-VID.
           MOVE 10 TO KLV-PRG.
           MOVE T14-RIC5 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RICAVI CATEGORIA 5' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 7 TO KLV-VID.
           MOVE 11 TO KLV-PRG.
           MOVE T14-CRPC5 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RIEPILOGATIVO CATEGORIA 6' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 7 TO KLV-VID.
           MOVE 12 TO KLV-PRG.
           MOVE T14-RIC6 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RICAVI CATEGORIA 6' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 7 TO KLV-VID.
           MOVE 13 TO KLV-PRG.
           MOVE T14-CRPC6 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RIEPILOGATIVO CATEGORIA 7' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 7 TO KLV-VID.
           MOVE 14 TO KLV-PRG.
           MOVE T14-RIC7 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RICAVI CATEGORIA 7' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 7 TO KLV-VID.
           MOVE 15 TO KLV-PRG.
           MOVE T14-CRPC7 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RIEPILOGATIVO CATEGORIA 8' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 7 TO KLV-VID.
           MOVE 16 TO KLV-PRG.
           MOVE T14-RIC8 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RICAVI CATEGORIA 8' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 7 TO KLV-VID.
           MOVE 17 TO KLV-PRG.
           MOVE T14-CRPC8 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RIEPILOGATIVO CATEGORIA 9' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 7 TO KLV-VID.
           MOVE 18 TO KLV-PRG.
           MOVE T14-RIC9 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'RICAVI CATEGORIA 9' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 14 TO KTB-TIP.
           MOVE 9 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE ZERO TO T14-CA1DC T14-CA2DC T14-CA3DC
                             T14-UTCAM T14-PECAM.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE 5 TO KLV-VID.
           MOVE ZERO TO KLV-PRG.
           MOVE ZERO TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE '** PARAMETRI CONTABILITA'' IN VALUTA :' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 5 TO KLV-VID.
           MOVE 1 TO KLV-PRG.
           MOVE T14-CA1DC TO LAV-COD.
           MOVE 2 TO LAV-TIP.
           MOVE 'CAUSALE DIFFERENZA CAMBI : GENERALE' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 5 TO KLV-VID.
           MOVE 2 TO KLV-PRG.
           MOVE T14-CA2DC TO LAV-COD.
           MOVE 2 TO LAV-TIP.
           MOVE 'CAUSALE DIFFERENZA CAMBI : CLIENTI' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 5 TO KLV-VID.
           MOVE 3 TO KLV-PRG.
           MOVE T14-CA3DC TO LAV-COD.
           MOVE 2 TO LAV-TIP.
           MOVE 'CAUSALE DIFFERENZA CAMBI : FORNITORI' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 5 TO KLV-VID.
           MOVE 4 TO KLV-PRG.
           MOVE T14-UTCAM TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO DIFFERENZA ATTIVA CAMBI' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 5 TO KLV-VID.
           MOVE 5 TO KLV-PRG.
           MOVE ZERO TO LAV-TIP.
           MOVE T14-PECAM TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'CONTO DIFFERENZA PASSIVA CAMBI' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 9 TO KLV-VID.
           MOVE 1 TO KLV-PRG.
           MOVE ZERO TO LAV-TIP.
           MOVE T14LCFTRC1 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'FATTURE DA RICEVERE : CONTO 1' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 9 TO KLV-VID.
           MOVE 2 TO KLV-PRG.
           MOVE ZERO TO LAV-TIP.
           MOVE T14LCFTRC2 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'FATTURE DA RICEVERE : CONTO 2' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 9 TO KLV-VID.
           MOVE 3 TO KLV-PRG.
           MOVE ZERO TO LAV-TIP.
           MOVE T14LCFTRC3 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'FATTURE DA RICEVERE : CONTO 3' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 9 TO KLV-VID.
           MOVE 4 TO KLV-PRG.
           MOVE ZERO TO LAV-TIP.
           MOVE T14LCNARC1 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'NOTE ACCREDITO DA RICEVERE : CONTO 1' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 9 TO KLV-VID.
           MOVE 5 TO KLV-PRG.
           MOVE ZERO TO LAV-TIP.
           MOVE T14LCNARC2 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'NOTE ACCREDITO DA RICEVERE : CONTO 2' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 9 TO KLV-VID.
           MOVE 6 TO KLV-PRG.
           MOVE ZERO TO LAV-TIP.
           MOVE T14LCNARC3 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'NOTE ACCREDITO DA RICEVERE : CONTO 3' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 9 TO KLV-VID.
           MOVE 10 TO KLV-PRG.
           MOVE ZERO TO LAV-TIP.
           MOVE T14LCFTEM1 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'FATTURE DA EMETTERE : CONTO 1' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 9 TO KLV-VID.
           MOVE 11 TO KLV-PRG.
           MOVE ZERO TO LAV-TIP.
           MOVE T14LCFTEM2 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'FATTURE DA EMETTERE : CONTO 2' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 9 TO KLV-VID.
           MOVE 12 TO KLV-PRG.
           MOVE ZERO TO LAV-TIP.
           MOVE T14LCFTEM3 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'FATTURE DA EMETTERE : CONTO 3' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 9 TO KLV-VID.
           MOVE 13 TO KLV-PRG.
           MOVE ZERO TO LAV-TIP.
           MOVE T14LCNAEM1 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'NOTE ADDEBITO DA EMETTERE : CONTO 1' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 9 TO KLV-VID.
           MOVE 14 TO KLV-PRG.
           MOVE ZERO TO LAV-TIP.
           MOVE T14LCNAEM2 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'NOTE ADDEBITO DA EMETTERE : CONTO 2' TO LAV-DSVID.
           WRITE RF-LAV.
           MOVE 9 TO KLV-VID.
           MOVE 15 TO KLV-PRG.
           MOVE ZERO TO LAV-TIP.
           MOVE T14LCNAEM3 TO LAV-COD.
           MOVE ZERO TO LAV-TIP.
           MOVE 'NOTE ADDEBITO DA EMETTERE : CONTO 3' TO LAV-DSVID.
           WRITE RF-LAV.
      *
           MOVE AZRGSOC TO INTEAZ.
      *
      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 57      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           MOVE 'TABELLA PARAMETRI - LISTA DI CONTROLLO' TO RP-TIT1.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG1-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
      *
           MOVE ZERO TO KEYLV.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO STAM-90.
       STAM-00.
           READ WDSLAV NEXT AT END GO TO STAM-90.
           MOVE LAV-DSVID TO RDSVID.
           IF KLV-PRG = ZERO GO TO STAM-20.
           IF LAV-TIP > 1 GO TO STAM-10.
           MOVE KAZ-COD TO KPC-AZI.
           MOVE LAV-COD TO KPC-COD RCOD.
           IF (LAV-TIP = 1) AND (KLV-PRG = 5 OR 6)
              IF LAV-COD = ZERO
                 PERFORM CON-ERR THRU CON99
                 MOVE CON-DSC TO RDSCOD
                 GO TO STAM-20
              ELSE
                 GO TO STAM-20.
           IF LAV-TIP = 1 MULTIPLY 100000 BY KPC-COD.
           READ ANACON INVALID PERFORM CON-ERR THRU CON99.
           MOVE CON-DSC TO RDSCOD.
           GO TO STAM-20.
       STAM-10.
           MOVE LAV-TIP TO KTB-TIP.
           MOVE LAV-COD TO KTB-COD RCOD.
           READ TABELL INTO REKTAB INVALID PERFORM TAB-ERR THRU TAB99.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RDSCOD.
       STAM-20.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           COPY 'grirpt-r'.
      *
           GO TO STAM-00.
       STAM-90.
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       CON-ERR.
           MOVE ALL '*' TO CON-DSC.
           IF KLV-VID NOT = 1 GO TO CON10.
           IF KLV-PRG = 1
              MOVE 'GIROCONTO IVA AUTOMATICO ESCLUSO' TO RDSNOT.
           IF KLV-PRG = 2 OR 3
              MOVE 'CONTABILITA'' ESCLUSA' TO RDSNOT.
           IF KLV-PRG = 4 
              MOVE 'GEST. FATTURE IN SOSPESO ESCLUSA' TO RDSNOT.
           IF KLV-PRG = 5 OR 6 
              MOVE 'DATO ASSOLUTAMENTE OBBLIGATORIO' TO RDSNOT.
           IF KLV-PRG = 7 
              MOVE 'GEST.FATT. FORN.DA BOLLE ESCLUSA' TO RDSNOT.
           IF KLV-PRG = 8 
              MOVE 'GESTIONE VENDITE ESCLUSA' TO RDSNOT.
           IF KLV-PRG = 9 
              MOVE 'GESTIONE CORRISPETTIVI ESCLUSA' TO RDSNOT.
           GO TO CON99.
       CON10.
           IF KLV-VID NOT = 2 GO TO CON20.
           IF KLV-PRG = 2 
              MOVE 'RIVALSA IVA SU OMAGGI ESCLUSA' TO RDSNOT.
           IF KLV-PRG = 4 OR 5
              MOVE 'CONTABILIZZAZIONE SU CONTO RICAVI' TO RDSNOT.
           IF KLV-PRG = 6 OR 7
              MOVE 'CONTABILIZZ.AUTOM.EFFETTI ESCLUSA' TO RDSNOT.
           IF KLV-PRG = 8
              MOVE 'CONTABILIZZ.AUTOM.FATTURE ESCLUSA' TO RDSNOT.
           GO TO CON99.
       CON20.
           IF KLV-VID = 5 AND ( KLV-PRG = 4 OR 5 )
              MOVE 'CONTABIL.AUTOM.DIFF.CAMBI ESCLUSA' TO RDSNOT.
           IF KLV-VID = 6 AND KLV-PRG = 1
              MOVE 'CONTABILITA'' FORNITORI ESCLUSA' TO RDSNOT.
           IF KLV-VID = 7 AND KLV-PRG = 1
              MOVE 'CONTABILITA'' CLIENTI ESCLUSA' TO RDSNOT.
       CON99.
           EXIT.
      *------------------
       TAB-ERR.
           MOVE ALL '*' TO TAB-DESCR.
           IF KLV-VID NOT = 2 GO TO TAB10.
           IF ( KLV-PRG > 8 AND < 13 )
              MOVE 'CONTABILIZZ.AUTOM.FATTURE ESCLUSA' TO RDSNOT.
           IF ( KLV-PRG = 13 OR 14 )
              MOVE 'CONTABILIZZ.AUTOM.EFFETTI ESCLUSA' TO RDSNOT.
           IF KLV-PRG = 15
              MOVE 'CONTABILIZZ.AUTOM.ACCONTI ESCLUSA' TO RDSNOT.
           IF ( KLV-PRG = 16 OR 17 )
              MOVE 'GIROCONTO IVA AUTOMATICO ESCLUSO' TO RDSNOT.
           IF ( KLV-PRG = 18 OR 19 )
              MOVE 'ADDEBITO SPESE IN FATTURA ESCLUSO' TO RDSNOT.
           GO TO TAB99.
       TAB10.
           IF KLV-VID = 5 
              MOVE 'CONTABIL.AUTOM.DIFF.CAMBI ESCLUSA' TO RDSNOT.
           IF KLV-VID = 4 
              MOVE 'ESCLUSO DA CALCOLO PLAFOND' TO RDSNOT.
       TAB99.
           EXIT.
      *------------------
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'Descrizione Voce' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Codice' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione Codice' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Annotazioni' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
