       IDENTIFICATION DIVISION.
       PROGRAM-ID. VBIC130.
      *
      * Bilancio CEE - Stampa di controllo
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gritabsl'.
           COPY 'griconsl'.
           COPY 'grimovsl'.
           COPY 'grimvxsl'.
           COPY 'griceesl'.
           COPY 'gricecsl'.
      **** rel 6.2
           COPY 'gricolsl'.
      **********
           SELECT ERRORI  ASSIGN TO DISK
                  ORGANIZATION LINE SEQUENTIAL STATUS SF-ERR.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gritab'.
           COPY 'gricon'.
           COPY 'grimov'.                                         
           COPY 'grimvx'.                                         
           COPY 'gricee'.
           COPY 'gricec'.
      **** rel 6.2
           COPY 'gricol'.
      **********
       FD  ERRORI LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-ERR
           RECORD 87 DATA RECORD RF-ERR.
       01  RF-ERR.
           05 ERRTES      PIC X(3).
           05 ERRMES.
              10 ERCODI   PIC X(14).
              10 ERMSAG   PIC X(70).
              10 ERMSAX   REDEFINES ERMSAG.
                 15 ERCONTO PIC X(7).
                 15 ERSPACE PIC X.
                 15 ERDESCO PIC X(37).
                 15 ERMESS  PIC X(25).
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 135 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
              10 KLV-PROG PIC 9(7).
           05 RECLAV.
              10 LAV-DSCO PIC X(36).
              10 LAV-IMPO PIC S9(13)V99.
              10 LAV-VOCE.
                 15 LAV-VOCX PIC X(14) OCCURS 10. 
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'griconrk'.
           COPY 'grimovrk'.                                       
           COPY 'gritabrk'.
           COPY 'grit20rk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parer'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-MVX PIC X(15) VALUE 'movmxx'.
       01  ID-CEE PIC X(15) VALUE 'bilcee'.
       01  ID-CEC PIC X(15) VALUE 'bilcec'.
      **** rel 6.2
       01  ID-COL PIC X(15) VALUE 'anacol'.
      **********
       01  ID-ERR PIC X(15) VALUE 'errori'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-CON PIC XX.
           05 SF-MOV PIC XX.
           05 SF-MVX PIC XX.
           05 SF-CEE PIC XX.
           05 SF-CEC PIC XX.
      **** rel 6.2
           05 SF-COL PIC XX.
      **********
           05 SF-ERR PIC XX.
           05 SF-LAV PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).

      *--- Da vecchio programma
      
           05 J        PIC 9      VALUE ZERO.
           05 K1BAR    PIC 999.
           05 K2BAR    PIC 999.
           05 K        PIC 99     VALUE ZERO.
           05 K1       PIC 99     VALUE ZERO.
           05 RISP     PIC 9      VALUE ZERO.
           05 FUNZ     PIC 9      VALUE ZERO.
           05 IDE-DES  PIC X(20)  VALUE SPACE.
           05 DFUNZ    PIC X(18).
           05 DTSTA    PIC 9(6)   VALUE ZERO.
           05 DIFFE    PIC S9(13)V99 VALUE ZERO.
           05 COMOD    PIC S9(13)V99 VALUE ZERO.
           05 SALDO    PIC S9(13)V99 VALUE ZERO.
           05 TTPAT    PIC S9(13)V99 VALUE ZERO.
           05 TTECO    PIC S9(13)V99 VALUE ZERO.
           05 TTORD    PIC S9(13)V99 VALUE ZERO.
           05 TOTTIC   PIC S9(12)V99 VALUE ZERO.
           05 TOTVOC   PIC S9(12)V99 VALUE ZERO.
           05 TOTGRC   PIC S9(12)V99 VALUE ZERO.
           05 DTBI     PIC 9(6)   VALUE ZERO.
      **** rel 6.2
           05 SAVPC     PIC 9(10).
      **********
           05 CODINI   PIC 9(7)   VALUE ZERO.
           05 SWERR    PIC 9      VALUE ZERO.
           05 FLGALL   PIC 9      VALUE ZERO.
           05 PKDAT    PIC 9(5)   COMP-3 VALUE ZERO.
           05 DSDAT    PIC X(28)  VALUE SPACE.
           05 CODULT.
              10 CODUM PIC 99.
              10 CODUX.
                 15 CODUS PIC 99.
                 15 CODUC PIC 9(3).
           05 TIPO     PIC 9      VALUE ZERO.
           05 VOCE     PIC X      VALUE SPACE.
           05 GRUP     PIC 9      VALUE ZERO.
           05 TRAI     PIC 99     VALUE ZERO.
           05 DETT     PIC X      VALUE SPACE.
           05 DTIP     PIC X(28)  VALUE SPACE.
           05 DVOC     PIC X(30)  VALUE SPACE.
           05 DGRU     PIC X(30)  VALUE SPACE.
           05 DTRA     PIC X(30)  VALUE SPACE.
           05 DESCR.
              10 DESC1 PIC X(30)  VALUE SPACE.
              10 DESC2 PIC X(30)  VALUE SPACE.
           05 FLGSTA   PIC 9      VALUE ZERO.
           05 ESE1     PIC X(34) VALUE
           '------ ESERCIZIO CORRENTE ------'.
           05 ESE2     PIC X(34) VALUE
           '----- ESERCIZIO PRECEDENTE -----'.
           05 RGRU.
              10 FILLER PIC X(5) VALUE '   I.'.
              10 FILLER PIC X(5) VALUE '  II.'.
              10 FILLER PIC X(5) VALUE ' III.'.
              10 FILLER PIC X(5) VALUE '  IV.'.
              10 FILLER PIC X(5) VALUE '   V.'.
              10 FILLER PIC X(5) VALUE '  VI.'.
              10 FILLER PIC X(5) VALUE ' VII.'.
              10 FILLER PIC X(5) VALUE 'VIII.'.
              10 FILLER PIC X(5) VALUE '  IX.'.
           05 RGRUX REDEFINES RGRU PIC X(5) OCCURS 9.
           05 DSTIP.
              10 FILLER PIC X(22) VALUE 'ATTIVO'.
              10 FILLER PIC X(22) VALUE 'CONTI D''ORDINE ATTIVO'.
              10 FILLER PIC X(22) VALUE 'PASSIVO'.
              10 FILLER PIC X(22) VALUE 'CONTI D''ORDINE PASSIVO'.
              10 FILLER PIC X(22) VALUE 'CONTO ECONOMICO'.
           05 DSTIPX REDEFINES DSTIP PIC X(22) OCCURS 5.
           05 ORDST  PIC X(5) VALUE '13245'.
           05 ORDSTA REDEFINES ORDST PIC 9 OCCURS 5.
      *------------------------

           COPY 'vbic130.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           05 IF-TIP       PIC 9.
           05 IF-SWERR     PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-DATA      PIC 9(6).
           05 IF-LIREUR    PIC 9.
      **** rel 6.2
           05 IF-FLRIP     PIC 9.
      **********

      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcon'.
           COPY 'dclmov'.
           COPY 'dclmvx'.
           COPY 'dcltab'.
           COPY 'dclcee'.
           COPY 'dclcec'.
      **** rel 6.2
           COPY 'dclcol'.
      **********
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
      *                 GO TO FINE.   
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO FINE.
           IF FUN = 'S' PERFORM STA-ERRORI THRU EX-STA-ERRORI
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vbic130: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           UNLOCK BILCEE.
           CLOSE ANAAZI ANACON TABELL BILCEE ERRORI.
           CLOSE BILCEC.
           CLOSE MOVIME MOVMXX.
      **** rel 6.2
           CLOSE ANACOL.
      **********
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN OUTPUT ERRORI.
           CLOSE ERRORI.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griconer'.
           COPY 'grimover'.
           COPY 'grimvxer'.
           COPY 'gritaber'.
           COPY 'griceeer'.
           COPY 'gricecer'.
      **** rel 6.2
           COPY 'gricoler'.
      **********
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           PERFORM CREA-IDERR THRU EX-CREA-IDERR.
           IF IF-FL = 1     MOVE 'anazol' TO ID-AZI
                            MOVE 'tabold' TO ID-TAB
                            MOVE 'anacol' TO ID-CON
                            MOVE 'movmol' TO ID-MOV
                            MOVE 'movoxx' TO ID-MVX
                            MOVE 'bilolc' TO ID-CEC
                            MOVE 'bilold' TO ID-CEE.
           IF IF-FL = ZERO 
                            MOVE 'anaazi' TO ID-AZI
                            MOVE 'tabell' TO ID-TAB
                            MOVE 'anacon' TO ID-CON
                            MOVE 'movime' TO ID-MOV
                            MOVE 'movmxx' TO ID-MVX
                            MOVE 'bilcec' TO ID-CEC
                            MOVE 'bilcee' TO ID-CEE.
           MOVE ESE1 TO TINT11.
           IF ( IF-FL = ZERO AND IF-TIP = 1 ) OR
              ( IF-FL = 1 AND IF-TIP = 1 ) 
              MOVE ESE2 TO TINT11.
           IF ( IF-FL = ZERO AND IF-TIP = 1 ) 
              MOVE 'bilcep' TO ID-CEC.
           IF ( IF-FL = 1 AND IF-TIP = 1 )  
              MOVE 'bilolp' TO ID-CEC.
           IF ( IF-FL = ZERO AND IF-TIP = ZERO)
              MOVE 'Movimenti al ..............:' TO DSDAT 
           ELSE MOVE 'Bilancio al ...............:' TO DSDAT.

           OPEN INPUT  ANAAZI.
           OPEN INPUT  TABELL.
           OPEN INPUT  ANACON.
           OPEN INPUT  MOVIME.
           OPEN INPUT  MOVMXX.
           OPEN  I-O   BILCEE.
           OPEN  I-O   BILCEC.
      **** rel 6.2
           OPEN INPUT  ANACOL.
      **********
           OPEN OUTPUT ERRORI.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O WDSLAV.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
           MOVe AZRGSOC TO IF-AZI-D.

           MOVE '20001' TO KEYTB.
           READ TABELL INTO RKTB20 INVALID
                PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB20.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE ZERO TO IF-DATA.
           MOVE ZERO TO IF-LIREUR.
      **** rel 6.2
           MOVE ZERO TO IF-FLRIP.
      **********

           MOVE KAZ-COD TO KCE-AZI.
           MOVE 1 TO KCE-TIPO.
           MOVE 'A' TO KCE-VOCE.
           MOVE ZERO TO KCE-GRUP KCE-TRAI.
           MOVE ZERO  TO KCE-PRG.
           MOVE SPACE TO KCE-DES.
           MOVE SPACE TO KCE-DETT.
           READ BILCEE KEPT LOCK INVALID PERFORM INVK-CEE
                                         GO TO ERRIO.
           IF SF-CEE = '9D' OR '9A' OR '35' 
                        MOVE 'Bilancio gia'' in uso !!!' TO MESS
                        GO TO ERRIO.     
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DATA.
           MOVE 'IF-DATA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DATA.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           MOVE ZERO TO IEUR.
           IF IF-LIREUR = 1
              MOVE 'E' TO IEUR.
           OPEN OUTPUT ERRORI.

           MOVE GBMMBA TO RDTBI.
           MOVE AAGGG TO PKDAT.
           MOVE AZRGSOC TO TAZI.

      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'BILANCIO AL ' RDTBI
                  DELIMITED SIZE INTO RP-TIT1.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG1-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

           IF IF-TIP = 1 GO TO STAMPA.
           MOVE KAZ-COD TO KPC-AZI.
           MOVE ZERO TO KPC-COD.
           START ANACON KEY NOT < KEYPC INVALID GO TO CALCOL.
       ANA10.
           READ ANACON NEXT INTO REKCON AT END GO TO CALCOL.
           IF SF-CON = '9D' OR '9A' OR '35' GO TO ANA10.
           IF KPC-AZI NOT = KAZ-COD GO TO CALCOL.
           IF CON-MOVIM NOT = ZERO GO TO ANA10.
           MOVE KPC-COD TO KLV-PROG.
           MOVE CON-DESCR TO LAV-DSCO.
           MOVE ZERO TO LAV-IMPO.
           MOVE SPACE TO LAV-VOCE.
           WRITE RF-LAV.
           GO TO ANA10.
       CALCOL.
           MOVE ZERO TO TTPAT TTECO TTORD DIFFE.
           MOVE KAZ-COD TO KCE-AZI.
           MOVE ZERO  TO KCE-DATI.
           MOVE SPACE TO KCE-DES.
           MOVE SPACE TO KCE-VOCE KCE-DETT.
           START BILCEE KEY NOT < KEYCE INVALID GO TO CAL-90.
       CAL-10.
           READ BILCEE NEXT AT END GO TO CAL-90.
           IF SF-CEE = '9D' OR '9A' OR '35' GO TO CAL-10.
           IF KCE-AZI NOT = KAZ-COD GO TO CAL-90.
           IF KCE-TIPO = 3 AND KCE-VOCE = 'A' AND KCE-GRUP = 9
                                                  GO TO CAL-10.
           IF KCE-TIPO = 5 AND KCE-TRAI = 23 GO TO CAL-10.
           MOVE ZERO TO CEE-TOTVO COMOD.
           MOVE KCE-AZI TO KEC-AZI.
           MOVE KCE-DATI TO KEC-DATI.
           MOVE ZERO TO KEC-CONTO.
           START BILCEC KEY NOT < KEYEC INVALID GO TO CAL-30.
       CAL-20.
           READ BILCEC NEXT AT END GO TO CAL-30.
           IF SF-CEC = '9D' OR '9A' OR '35' GO TO CAL-20.
           IF KEC-AZI NOT = KCE-AZI OR
              KEC-DATI NOT = KCE-DATI GO TO CAL-30.
           MOVE ZERO TO CEC-IMPO.
           PERFORM A00-CAL-BIL THRU A99.
           REWRITE RF-CEC INVALID PERFORM INVK-CEC
                                          GO TO ERRIO.
           GO TO CAL-20.
       CAL-30.
           MOVE COMOD TO CEE-TOTVO.
           MOVE ZERO TO COMOD.
           IF KCE-TIPO = 2 OR 4 ADD CEE-VARIA TO TTORD.
           IF KCE-TIPO = 1 OR 3 ADD CEE-VARIA TO TTPAT DIFFE.
           IF KCE-TIPO = 5 ADD CEE-VARIA TO TTECO DIFFE.
           REWRITE RF-CEE INVALID PERFORM INVK-CEE
                                          GO TO ERRIO.
           GO TO CAL-10.
       CAL-90.
           MULTIPLY -1 BY TTPAT TTECO.
           MOVE KAZ-COD TO KCE-AZI.
           MOVE 3 TO KCE-TIPO.
           MOVE 'A' TO KCE-VOCE.
           MOVE 9 TO KCE-GRUP.
           MOVE ZERO TO KCE-TRAI.
           MOVE ZERO  TO KCE-PRG.
           MOVE SPACE TO KCE-DES.
           MOVE SPACE TO KCE-DETT.
           READ BILCEE INVALID PERFORM INVK-CEE
                                       GO TO ERRIO.
           MOVE TTPAT TO CEE-TOTVO.
           REWRITE RF-CEE INVALID PERFORM INVK-CEE
                                          GO TO ERRIO.
           MOVE 5 TO KCE-TIPO.
           MOVE 'E' TO KCE-VOCE.
           MOVE ZERO TO KCE-GRUP.
           MOVE SPACE TO KCE-DETT.
           MOVE 23 TO KCE-TRAI.
           MOVE ZERO  TO KCE-PRG.
           MOVE SPACE TO KCE-DES.
           READ BILCEE INVALID PERFORM INVK-CEE
                                       GO TO ERRIO.
           MOVE TTECO TO CEE-TOTVO.
           REWRITE RF-CEE INVALID PERFORM INVK-CEE
                                          GO TO ERRIO.
           COMPUTE COMOD = TTPAT + TTECO.
           IF DIFFE NOT = ZERO
                    MOVE 'ER' TO ERRTES
                    MOVE SPACE TO ERCODI
                    MOVE 'SBILANCIO VARIAZIONI' TO ERMSAG
                    WRITE RF-ERR
                    MOVE 1 TO SWERR.
           IF TTORD NOT = ZERO
                    MOVE 'ER' TO ERRTES
                    MOVE SPACE TO ERCODI
                    MOVE 'SBILANCIO CONTI D'' ORDINE' TO ERMSAG
                    WRITE RF-ERR
                    MOVE 1 TO SWERR.
           IF COMOD = ZERO GO TO STAMPA.

           MOVE 'Attenzione sbilancio !!!' TO MESS.
           MOVE 8 TO ERRIO-ST.

           MOVE 'ER' TO ERRTES.
           MOVE SPACE TO ERCODI.
           MOVE 'SBILANCIO PATRIMONIALE/ECONOMICO' TO ERMSAG.
           WRITE RF-ERR.
           MOVE 1 TO SWERR.
       STAMPA.
           MOVE KAZ-COD TO KCE-AZI.
           MOVE ZERO TO TIPO GRUP TRAI.
           MOVE SPACE TO VOCE DETT.
           MOVE ZERO TO XCRR NPAG TOTTIC TOTVOC TOTGRC.
           MOVE 1    TO RP-JMP.
           MOVE ZERO TO J.
       STA-05.
           ADD 1 TO J.     
           IF J > 5 GO TO FNSTA.
           MOVE ZERO TO KCE-DATI.
           MOVE SPACE TO KCE-DES.
           MOVE SPACE TO KCE-VOCE KCE-DETT.
           MOVE ORDSTA (J) TO KCE-TIPO.
           START BILCEE KEY NOT < KEYCE INVALID GO TO STA-05.
       STA-10.
           READ BILCEE NEXT AT END GO TO STA-05.
           IF SF-CEE = '9D' OR '9A' OR '35' GO TO STA-10.
           IF IF-TIP = 1 MOVE CEE-ANPRE TO CEE-ANCOR.

           IF KCE-AZI NOT = KAZ-COD GO TO STA-05.
           IF KCE-TIPO NOT = ORDSTA (J) GO TO STA-05.
           IF TIPO = ZERO MOVE KCE-TIPO TO TIPO GO TO STA-20.
           IF KCE-TIPO = TIPO GO TO STA-30.
           PERFORM C00-TOT-TIP THRU C99.
       STA-20.
           IF KCE-TIPO = 3 OR 2 OR 5 
              MOVE ZERO TO XCRR
              MOVE 1    TO RP-JMP.
      *-- inizializza parametri per stampa report --*
           MOVE SPACE TO RP-TIT2.
           STRING DSTIPX (KCE-TIPO)
                  DELIMITED SIZE INTO RP-TIT2.
      *
           PERFORM RPT-RIG1-INTC.
      *---------------------------------------------*
           MOVE KCE-TIPO TO TIPO.
           MOVE DSTIPX (KCE-TIPO) TO RDESX.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE ALL '=' TO RDESX. 
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE SPACE TO VOCE DETT. 
           MOVE ZERO  TO GRUP TRAI.
       STA-30.
           IF VOCE = SPACE MOVE KCE-VOCE TO VOCE GO TO STA-30-40.
           IF KCE-VOCE = VOCE GO TO STA-30-10.
           IF ( TIPO = 1 AND VOCE = 'A' ) OR 
              ( TIPO = 3 AND VOCE = 'C' ) OR
                TIPO = 5
                MOVE KCE-VOCE TO VOCE GO TO STA-30-40.
           PERFORM D00-TOT-VOCE THRU D99.
           MOVE KCE-VOCE TO VOCE GO TO STA-30-40.
       STA-30-10.
           IF ( TIPO = 3 AND ( VOCE = 'B' OR 'D' ) ) OR TIPO = 5
                                                 GO TO STA-30-20.
           IF GRUP = ZERO MOVE KCE-GRUP TO GRUP GO TO STA-30-30.
           IF KCE-GRUP = GRUP GO TO STA-30-20.
           IF TIPO = 3 AND KCE-VOCE = 'A' AND GRUP = 7
                                       GO TO STA-30-15.
           IF TIPO = 3 AND KCE-VOCE = 'A' 
                           MOVE KCE-GRUP TO GRUP GO TO STA-30-30.
       STA-30-15.
           PERFORM E00-TOT-GRUP THRU E99.
           MOVE KCE-GRUP TO GRUP GO TO STA-30-30.
       STA-30-20.
           IF KCE-DETT NOT = SPACE MOVE KCE-DETT TO RDETT 
                                   MOVE ')' TO RDETTP GO TO STA-60.
           MOVE SPACE TO RCOMP.
           IF KCE-TRAI NOT = ZERO
              IF KCE-PRG = ZERO AND KCE-DES = SPACE 
                 MOVE KCE-TRAI TO RTRAI
                 MOVE ')'      TO RTRAIP
              ELSE
                 MOVE KCE-TRAI TO RTRAI1
                 MOVE KCE-DES  TO RDES
                 MOVE ')'      TO RTRAIP1
              END-IF
              GO TO STA-60.
       STA-30-30.
           IF KCE-GRUP NOT = ZERO MOVE RGRUX ( KCE-GRUP ) TO RGRUP
                                        MOVE ZERO TO TOTGRC 
                                                      GO TO STA-50.
       STA-30-40.
           MOVE KCE-VOCE TO RVOCE.
           MOVE ')' TO RVOCEP.
           IF KCE-VOCE = 'Z' MOVE SPACE TO RVOCE RVOCEP.
           MOVE ZERO TO GRUP TOTGRC TOTVOC.
           MOVE CEE-DESCR TO DESCR.
           PERFORM F00-CTR-ALL THRU F99.
           IF FLGALL = 1 MOVE ZERO TO FLGALL GO TO STA-40.
           MOVE DESC1 TO RDESC.
           IF DESC2 = SPACE GO TO STA-30-42.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE DESC2 TO RDESC.
       STA-30-42.
           ADD CEE-VARIA TO CEE-TOTVO.
           IF ( KCE-TIPO = 3 OR 4 )
               MULTIPLY -1 BY CEE-TOTVO CEE-CREIN CEE-CREOU.
           ADD CEE-TOTVO TO TOTTIC.
           IF KCE-TIPO = 2 OR 4 GO TO STA-30-44.
           IF KCE-TIPO = 1 AND KCE-VOCE = 'A'
              IF CEE-EVIDE = ZERO GO TO STA-30-44 
              ELSE 
                   MOVE 'RIG1' TO RP-BLK
                   PERFORM RPT-WR
                   MOVE 1 TO XCRR
                   MOVE CEE-TOTVO TO RIMP2
                   IF IF-LIREUR = 1
                      MOVE CEE-TOTVO TO ER-IMPORTO
                      CALL 'rlitimp' USING ER-IMPORTO
                      MOVE ER-IMPORTO TO ERIMP2
                   END-IF
                   MOVE 'RIG1' TO RP-BLK
                   PERFORM RPT-WR
                   MOVE 'Quote richiamate' TO RDES1
                   MOVE CEE-EVIDE TO RIMP1
                   IF IF-LIREUR = 1
                      MOVE CEE-EVIDE TO ER-IMPORTO
                      CALL 'rlitimp' USING ER-IMPORTO
                      MOVE ER-IMPORTO TO ERIMP1
                   END-IF
                   MOVE '(' TO RPAR1
                   MOVE ')' TO RPAR11
                   PERFORM H00-STA-CONT THRU H99
                   MOVE ALL '=' TO RSOT1 
                   MOVE 2 TO RP-FLGR
                   MOVE 'RIG1' TO RP-BLK
                   PERFORM RPT-WR
                   GO TO STA-10.
           IF KCE-TIPO = 3 AND KCE-VOCE = 'C' GO TO STA-30-44.
           IF ( KCE-TIPO = 1 AND KCE-VOCE = 'D' ) OR
              ( KCE-TIPO = 3 AND KCE-VOCE = 'E' )
              IF CEE-CREIN = ZERO AND CEE-CREIP = ZERO
                                       GO TO STA-30-44
              ELSE 
                   MOVE 'RIG1' TO RP-BLK
                   PERFORM RPT-WR
                   MOVE 1 TO XCRR
                   MOVE 'Ratei e risconti' TO RDES1
                   COMPUTE COMOD =  CEE-TOTVO - CEE-CREIN
                   MOVE COMOD TO RIMP1
                   IF IF-LIREUR = 1
                      MOVE COMOD TO ER-IMPORTO
                      CALL 'rlitimp' USING ER-IMPORTO
                      MOVE ER-IMPORTO TO ERIMP1
                   END-IF
                   MOVE 'RIG1' TO RP-BLK
                   PERFORM RPT-WR
                   MOVE CEE-CREIN TO RIMP1
                   IF IF-LIREUR = 1
                      MOVE CEE-CREIN TO ER-IMPORTO
                      CALL 'rlitimp' USING ER-IMPORTO
                      MOVE ER-IMPORTO TO ERIMP1
                   END-IF
                   MOVE CEE-TOTVO TO RIMP2
                   IF IF-LIREUR = 1
                      MOVE CEE-TOTVO TO ER-IMPORTO
                      CALL 'rlitimp' USING ER-IMPORTO
                      MOVE ER-IMPORTO TO ERIMP2
                   END-IF
                   IF KCE-VOCE = 'D'
                      MOVE 'Disaggio su prestiti' TO RDES1
                      PERFORM H00-STA-CONT THRU H99
                      MOVE ALL '=' TO RSOT1 
                      MOVE 2 TO RP-FLGR
                      MOVE 'RIG1' TO RP-BLK
                      PERFORM RPT-WR
                      GO TO STA-10
                   ELSE
                      MOVE 'Aggio su prestiti' TO RDES1
                      PERFORM H00-STA-CONT THRU H99
                      MOVE ALL '=' TO RSOT1 
                      MOVE 2 TO RP-FLGR
                      MOVE 'RIG1' TO RP-BLK
                      PERFORM RPT-WR
                      GO TO STA-10.
       STA-30-44.
           MOVE CEE-TOTVO TO RIMP2.
           IF IF-LIREUR = 1
              MOVE CEE-TOTVO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP2.
           PERFORM H00-STA-CONT THRU H99.
           MOVE 1 TO XCRR.
           GO TO STA-10.
       STA-40.
           MOVE DESC1 TO RDESC.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           IF DESC2 = SPACE GO TO STA-10.
           MOVE DESC2 TO RDESC.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           GO TO STA-10.
       STA-50.
           MOVE CEE-DESCR TO DESCR.
           PERFORM F00-CTR-ALL THRU F99.
           IF FLGALL = 1 MOVE ZERO TO FLGALL GO TO STA-40.
           MOVE DESC1 TO RDESC.
           IF DESC2 = SPACE GO TO STA-50-10.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE DESC2 TO RDESC.
       STA-50-10.
           ADD CEE-VARIA TO CEE-TOTVO.
           IF KCE-TIPO = 3 MULTIPLY -1 BY CEE-TOTVO 
                                          CEE-CREIN CEE-CREOU.
           ADD CEE-TOTVO TO TOTVOC TOTTIC.
           MOVE CEE-TOTVO TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CEE-TOTVO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           PERFORM H00-STA-CONT THRU H99.
           MOVE 1 TO XCRR.
           MOVE ALL '=' TO RSOT1.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           GO TO STA-10.
       STA-60.
           IF KCE-TIPO = 5 GO TO STA-70.
           MOVE CEE-DESCR TO DESCR.
           PERFORM F00-CTR-ALL THRU F99.
           IF FLGALL = 1 MOVE ZERO TO FLGALL GO TO STA-40.
           MOVE DESC1 TO RDESC.
           IF DESC2 = SPACE GO TO STA-60-10.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE DESC2 TO RDESC.
       STA-60-10.
           ADD CEE-VARIA TO CEE-TOTVO.
           IF KCE-TIPO = 3 MULTIPLY -1 BY CEE-TOTVO 
                                          CEE-CREIN CEE-CREOU.
           ADD CEE-TOTVO TO TOTVOC TOTGRC TOTTIC.
           IF ( KCE-TIPO = 1 AND KCE-VOCE = 'B' AND KCE-GRUP = 3
                AND KCE-TRAI = 2 )
           OR ( KCE-TIPO = 1 AND KCE-VOCE = 'C' AND KCE-GRUP = 2 )
           OR ( KCE-TIPO = 3 AND KCE-VOCE = 'D' )
                GO TO STA-60-20.
           IF KCE-TIPO = 1 AND ( KCE-VOCE = 'B' OR 'C' ) AND 
              KCE-GRUP = 3 AND KCE-TRAI = 4 AND
              KCE-PRG  = ZERO AND KCE-DES = SPACE AND
              CEE-TOTVO NOT = ZERO
              IF CEE-EVIDE = ZERO 
              MOVE 'ER' TO ERRTES
              MOVE KCE-DATI TO ERCODI
              MOVE 'MANCA VALORE NOMINALE COMPLESSIVO' TO ERMSAG
              MOVE 1 TO SWERR
              WRITE RF-ERR
              GO TO STA-60-30
                 ELSE MOVE CEE-TOTVO TO RIMP1
                      IF IF-LIREUR = 1
                         MOVE CEE-TOTVO TO ER-IMPORTO
                         CALL 'rlitimp' USING ER-IMPORTO
                         MOVE ER-IMPORTO TO ERIMP1
                      END-IF
                      MOVE 'RIG1' TO RP-BLK
                      PERFORM RPT-WR
                      MOVE 1 TO XCRR
                      MOVE 'Valore nomin.compl.' TO RDES1
                      MOVE '(' TO RPAR1 
                      MOVE CEE-EVIDE TO RIMP1
                      IF IF-LIREUR = 1
                         MOVE CEE-EVIDE TO ER-IMPORTO
                         CALL 'rlitimp' USING ER-IMPORTO
                         MOVE ER-IMPORTO TO ERIMP1
                      END-IF
                      MOVE ')' TO RPAR11 
                      PERFORM H00-STA-CONT THRU H99
                      GO TO STA-10.
           GO TO STA-60-30.
       STA-60-20.
           IF CEE-CREIN = ZERO AND CEE-CREOU = ZERO AND
              CEE-TOTVO = ZERO GO TO STA-60-30.
           COMPUTE COMOD = CEE-CREIN + CEE-CREOU.
           IF COMOD = ZERO AND CEE-TOTVO = ZERO GO TO STA-60-30.
           IF COMOD = ZERO MOVE 'ER' TO ERRTES
                           MOVE 'MANCA RIPARTO' TO ERMSAG
                           MOVE KCE-DATI TO ERCODI
                           MOVE 1 TO SWERR
                           WRITE RF-ERR
                           GO TO STA-60-30.
           IF COMOD NOT = CEE-TOTVO MOVE 'ER' TO ERRTES
                          MOVE 'RIPARTO ERRATO' TO ERMSAG
                          MOVE KCE-DATI TO ERCODI
                          MOVE 1 TO SWERR
                          WRITE RF-ERR
                          GO TO STA-60-30.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE 'Entro esercizio suc.' TO RDES1.
           MOVE CEE-CREIN TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CEE-CREIN TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 'Oltre esercizio suc.' TO RDES1.
           MOVE CEE-CREOU TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CEE-CREOU TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           PERFORM H00-STA-CONT THRU H99.
           GO TO STA-10.
       STA-60-30.
           MOVE CEE-TOTVO TO RIMP1.
           IF IF-LIREUR = 1
              MOVE CEE-TOTVO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP1.
           PERFORM H00-STA-CONT THRU H99.
           MOVE 1 TO XCRR.
           GO TO STA-10.
       STA-70.
           MOVE CEE-DESCR TO DESCR.
           PERFORM F00-CTR-ALL THRU F99.
           IF FLGALL = 1 MOVE ZERO TO FLGALL GO TO STA-40.
           MOVE DESC1 TO RDESC.
           IF DESC2 = SPACE GO TO STA-70-10.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MOVE DESC2 TO RDESC.
       STA-70-10.
           ADD CEE-VARIA TO CEE-TOTVO.
           IF KCE-TRAI NOT = 23
              MULTIPLY -1 BY CEE-TOTVO.
           ADD CEE-TOTVO TO TOTVOC TOTTIC.
           IF KCE-TRAI = 5 GO TO STA-70-20.
           IF KCE-TRAI < 15 OR 
            ( KCE-TRAI = 16 AND ( KCE-DETT = 'b' OR 'c' ) ) OR
            ( KCE-TRAI = 18 OR 19 ) OR KCE-TRAI > 21
                                     GO TO STA-70-30.
       STA-70-20. 
           IF KCE-TRAI = 5
              IF CEE-CREIN = ZERO GO TO STA-70-30
              ELSE
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR
              MULTIPLY -1 BY CEE-CREIN 
              SUBTRACT CEE-CREIN FROM CEE-TOTVO
              MOVE 'Ricavi e Proventi' TO RDES1
              MOVE CEE-TOTVO TO RIMP1

              IF IF-LIREUR = 1
                 MOVE CEE-TOTVO TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1
              END-IF
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR
              MOVE 'Contrib.cto eserciz.' TO RDES1
              MOVE CEE-CREIN TO RIMP1
              IF IF-LIREUR = 1
                 MOVE CEE-CREIN TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1
              END-IF
              PERFORM H00-STA-CONT THRU H99
              GO TO STA-70-40.
           IF KCE-TRAI NOT = 15 GO TO STA-70-21.
           IF CEE-CREIN = ZERO AND CEE-CREOU = ZERO
                                    GO TO STA-70-30.
           MULTIPLY -1 BY CEE-CREIN CEE-CREOU.
           COMPUTE CEE-TOTVO = CEE-TOTVO - ( CEE-CREIN + CEE-CREOU ).
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           IF CEE-CREIN NOT = ZERO 
              MOVE  'Da Impr.Controllate' TO RDES1
              MOVE CEE-CREIN TO RIMP1 
              IF IF-LIREUR = 1
                 MOVE CEE-CREIN TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1
              END-IF
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR.
           IF CEE-CREOU NOT = ZERO 
              MOVE  'Da Impr.Collegate' TO RDES1
              MOVE CEE-CREOU TO RIMP1 
              IF IF-LIREUR = 1
                 MOVE CEE-CREOU TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1
              END-IF
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR.
           MOVE 'Altre Partecipazioni' TO RDES1.
           GO TO STA-70-30.
       STA-70-21.
           IF NOT ( KCE-TRAI = 16 OR 17 ) GO TO STA-70-23.
           IF CEE-CREIN = ZERO AND CEE-EVIDE = ZERO AND
              CEE-CREOU = ZERO GO TO STA-70-30.
           MULTIPLY -1 BY CEE-CREIN CEE-CREOU CEE-EVIDE.
           COMPUTE CEE-TOTVO = CEE-TOTVO -
                            ( CEE-CREIN + CEE-CREOU + CEE-EVIDE ).
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           IF CEE-CREIN NOT = ZERO MOVE CEE-CREIN TO RIMP1 
              IF IF-LIREUR = 1
                 MOVE CEE-CREIN TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1
              END-IF
              IF KCE-TRAI = 16 MOVE  'Da Impr.Controllate' TO RDES1
                               MOVE 'RIG1' TO RP-BLK
                               PERFORM RPT-WR
                          ELSE MOVE 'Verso Controllate' TO RDES1
                               MOVE 'RIG1' TO RP-BLK
                               PERFORM RPT-WR. 
           IF CEE-CREOU NOT = ZERO MOVE CEE-CREOU TO RIMP1 
              IF IF-LIREUR = 1
                 MOVE CEE-CREOU TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1
              END-IF
              IF KCE-TRAI = 16 MOVE  'Da Impr.Collegate' TO RDES1
                                      MOVE 'RIG1' TO RP-BLK
                                      PERFORM RPT-WR
                          ELSE MOVE  'Verso Collegate' TO RDES1
                                      MOVE 'RIG1' TO RP-BLK
                                      PERFORM RPT-WR.
           IF CEE-EVIDE NOT = ZERO MOVE CEE-EVIDE TO RIMP1 
              IF IF-LIREUR = 1
                 MOVE CEE-EVIDE TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1
              END-IF
              IF KCE-TRAI = 16 MOVE  'Da Impr.Controllanti' TO RDES1
                                      MOVE 'RIG1' TO RP-BLK
                                      PERFORM RPT-WR
                          ELSE MOVE  'Verso Controllanti' TO RDES1
                                      MOVE 'RIG1' TO RP-BLK
                                      PERFORM RPT-WR.
           IF KCE-TRAI = 17 MOVE 'Verso Altri' TO RDES1
                      ELSE  MOVE 'Da Altri' TO RDES1.
           GO TO STA-70-30.
       STA-70-23.
           IF KCE-TRAI = 20 
              IF CEE-CREIN = ZERO GO TO STA-70-30
              ELSE
              MULTIPLY -1 BY CEE-CREIN
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR
              SUBTRACT CEE-CREIN FROM CEE-TOTVO
              MOVE 'Plusval.da alienaz.' TO RDES1
              MOVE CEE-CREIN TO RIMP1
              IF IF-LIREUR = 1
                 MOVE CEE-CREIN TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1
              END-IF
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR
              MOVE 'Altri proventi' TO RDES1
              GO TO STA-70-30.
           IF KCE-TRAI NOT = 21 GO TO STA-70-30.
           IF CEE-CREIN = ZERO AND CEE-CREOU = ZERO
                                    GO TO STA-70-30.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           MULTIPLY -1 BY CEE-CREIN CEE-CREOU.
           COMPUTE CEE-TOTVO = CEE-TOTVO - ( CEE-CREIN + CEE-CREOU ).
           IF CEE-CREIN NOT = ZERO 
              MOVE 'Minusv.da alienaz.' TO RDES1
              MOVE CEE-CREIN TO RIMP1
              IF IF-LIREUR = 1
                 MOVE CEE-CREIN TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1
              END-IF
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR.
           IF CEE-CREOU NOT = ZERO 
              MOVE 'Imposte eserc.prec.' TO RDES1
              MOVE CEE-CREOU TO RIMP1
              IF IF-LIREUR = 1
                 MOVE CEE-CREOU TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1
              END-IF
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR.
           MOVE 'Altri oneri' TO RDES1.
       STA-70-30.
           IF KCE-TRAI > 21
              MOVE CEE-TOTVO TO RIMP2 
              IF IF-LIREUR = 1
                 MOVE CEE-TOTVO TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP2
              END-IF
           ELSE
              MOVE CEE-TOTVO TO RIMP1
              IF IF-LIREUR = 1
                 MOVE CEE-TOTVO TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP1.
           PERFORM H00-STA-CONT THRU H99.
           MOVE 1 TO XCRR.
       STA-70-40.
           IF KCE-TRAI = 5 MOVE ALL '=' TO R2SOT1 
                  MOVE 2 TO RP-FLGR
                  MOVE 'RIG2' TO RP-BLK
                  PERFORM RPT-WR
                  MOVE 'TOTALE VALORE PRODUZIONE' TO R2TOT
                  MOVE TOTVOC TO R2IMP2
                  IF IF-LIREUR = 1
                     MOVE TOTVOC TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER2IMP2
                  END-IF
                  MOVE 'RIG2' TO RP-BLK
                  PERFORM RPT-WR
                  MOVE 2 TO XCRR
                  MOVE ZERO TO TOTVOC.
           IF KCE-TRAI = 14 MOVE ALL '=' TO R2SOT1 
                  MOVE 2 TO RP-FLGR
                  MOVE 'RIG2' TO RP-BLK
                  PERFORM RPT-WR
                  MOVE 'TOTALE COSTI PRODUZIONE' TO R2TOT
                  MOVE TOTVOC TO R2IMP2
                  IF IF-LIREUR = 1
                     MOVE TOTVOC TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER2IMP2
                  END-IF
                  MOVE 'RIG2' TO RP-BLK
                  PERFORM RPT-WR
                  MOVE ZERO TO TOTVOC 
                  MOVE ALL '-' TO R2SOT2
                  MOVE 2 TO RP-FLGR
                  MOVE 'RIG2' TO RP-BLK
                  PERFORM RPT-WR
                  MOVE 'DIFFERENZA VALORE E COSTI PRODUZIONE' TO R2TOT
                  MOVE TOTTIC TO R2IMP2
                  IF IF-LIREUR = 1
                     MOVE TOTTIC TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER2IMP2
                  END-IF
                  MOVE 'RIG2' TO RP-BLK
                  PERFORM RPT-WR
                  MOVE 2 TO XCRR.
           IF KCE-TRAI = 17 AND KCE-PRG NOT = ZERO
                  MOVE ALL '=' TO R2SOT1
                  MOVE 2 TO RP-FLGR
                  MOVE 'RIG1' TO RP-BLK
                  PERFORM RPT-WR
                  MOVE 'TOTALE PROVENTI E ONERI FINANZIARI' TO R2TOT
                  MOVE TOTVOC TO R2IMP2
                  IF IF-LIREUR = 1
                     MOVE TOTVOC TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER2IMP2
                  END-IF
                  MOVE 'RIG2' TO RP-BLK
                  PERFORM RPT-WR
                  MOVE 2 TO XCRR
                  MOVE ZERO TO TOTVOC.
           IF KCE-TRAI = 19 AND KCE-DETT = 'c'
                  MOVE ALL '=' TO R2SOT1 
                  MOVE 2 TO RP-FLGR
                  MOVE 'RIG2' TO RP-BLK
                  PERFORM RPT-WR
                  MOVE 'TOTALE RETTIFICHE VALORE ATTIV.FINANZ.' TO R2TOT
                  MOVE TOTVOC TO R2IMP2
                  IF IF-LIREUR = 1
                     MOVE TOTVOC TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER2IMP2
                  END-IF
                  MOVE 'RIG2' TO RP-BLK
                  PERFORM RPT-WR
                  MOVE 2 TO XCRR
                  MOVE ZERO TO TOTVOC.
           IF KCE-TRAI = 21 MOVE ALL '=' TO R2SOT1 
                  MOVE 2 TO RP-FLGR
                  MOVE 'RIG2' TO RP-BLK
                  PERFORM RPT-WR
                  MOVE 'TOTALE PARTITE STRAORDINARIE' TO R2TOT
                  MOVE TOTVOC TO R2IMP2
                  IF IF-LIREUR = 1
                     MOVE TOTVOC TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER2IMP2
                  END-IF
                  MOVE 'RIG2' TO RP-BLK
                  PERFORM RPT-WR
                  MOVE ZERO TO TOTVOC
                  MOVE ALL '-' TO R2SOT2 
                  MOVE 2 TO RP-FLGR
                  MOVE 'RIG2' TO RP-BLK
                  PERFORM RPT-WR
                  MOVE 'RISULTATO PRIMA DELLE IMPOSTE' TO R2TOT
                  MOVE TOTTIC TO R2IMP2
                  IF IF-LIREUR = 1
                     MOVE TOTTIC TO ER-IMPORTO
                     CALL 'rlitimp' USING ER-IMPORTO
                     MOVE ER-IMPORTO TO ER2IMP2
                  END-IF
                  MOVE 'RIG2' TO RP-BLK
                  PERFORM RPT-WR
                  MOVE 2 TO XCRR.
      *
           COPY 'grirpt-r'.
      *
           GO TO STA-10.
       FNSTA.
      *
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
      *
           IF IF-TIP = 1 GO TO FINE.
           MOVE ZERO TO KLV-PROG.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO FNS90.
       FNS10.
           READ WDSLAV NEXT AT END GO TO FNS90.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO FNS10.
           IF LAV-VOCX (1) = SPACE GO TO FNS20.
           IF LAV-VOCX (2) = SPACE GO TO FNS80.
           GO TO FNS30.
       FNS20.
           MOVE LAV-VOCX (1) TO ERCODI.
           MOVE KLV-PROG TO ERCONTO.
           MOVE SPACE TO ERSPACE.
           MOVE LAV-DSCO TO ERDESCO.
           MOVE 'Escluso dal calcolo' TO ERMESS.
           MOVE 1 TO SWERR.
           WRITE RF-ERR.
           GO TO FNS80.
       FNS30.
           MOVE ZERO TO K.
       FNS40.
           ADD 1 TO K.
           IF K > 10 GO TO FNS80.
           IF LAV-VOCX (K) = SPACE GO TO FNS80.
           MOVE LAV-VOCX (K) TO ERCODI.
           MOVE KLV-PROG TO ERCONTO.
           MOVE SPACE TO ERSPACE.
           MOVE LAV-DSCO TO ERDESCO.
           MOVE 'Utilizzato in piu'' voci' TO ERMESS.
           MOVE 1 TO SWERR.
           WRITE RF-ERR.
           GO TO FNS40.
       FNS80.
           DELETE WDSLAV.
           GO TO FNS10.
       FNS90.
           MOVE SWERR TO IF-SWERR.
           CLOSE ERRORI.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-IDERR.
           MOVE SPACE TO ID-ERR.
           STRING 'w1' PID DELIMITED SPACE INTO ID-ERR.
       EX-CREA-IDERR.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w2' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       A00-CAL-BIL.
           MOVE KEC-CONTO TO CODINI CODULT.
           IF CODUX = ZERO MOVE  99 TO CODUS
                           MOVE 999 TO CODUC.
           IF CODUC = ZERO MOVE 999 TO CODUC.
           MOVE KAZ-COD TO KPC-AZI.
           MOVE CODINI TO KPC-COD.
           START ANACON KEY NOT < KEYPC INVALID GO TO A99.
       A10.
           READ ANACON NEXT INTO REKCON AT END GO TO A99.
           IF SF-CON = '9D' OR '9A' OR '35' GO TO A10.
           IF KPC-AZI NOT = KAZ-COD OR
              KPC-COD > CODULT GO TO A99.
           IF CON-MOVIM NOT = ZERO GO TO A10.
      **** rel 6.2
      *    IF ( IF-FL = 1 AND IF-TIP = ZERO) GO TO A10-20.
      **********
           PERFORM G00-LEGGE-CONTO THRU G99.
           ADD CON-SPSP TO CON-SESP. 
           MOVE CON-SESP TO SALDO.
      **** rel 6.2
           IF ( IF-FL = 1 )
              PERFORM B00-CALCSALDO THRU B99.
      **********
      **** rel 6.2
           IF IF-FLRIP = ZERO OR IF-FL = 1 GO TO NORIP.
           IF CON-TIPO = 'E' GO TO NORIP.
           MOVE KEYPC TO SAVPC KEYCL.
           READ ANACOL INTO REKCON INVALID MOVE ZERO TO CON-SESP
                                                        CON-SE-D
                                                        CON-SE-A. 
           COMPUTE SALDO = SALDO + CON-SESP + CON-SE-D - CON-SE-A.
      *
           MOVE SAVPC TO KEYPC.
           READ ANACON INTO REKCON.
       NORIP.
      **********
           GO TO A10-40.
       A10-20.
           IF KPC-COD = T20-COUTI OR
              KPC-COD = T20-COPER GO TO A10.
           COMPUTE SALDO = CON-SESP + CON-SE-D - CON-SE-A.
      **** rel 6.2
      *    IF ( IF-FL = 1 AND IF-TIP = ZERO )
      *       PERFORM B00-CALCSALDO THRU B99.
      **********
       A10-40.
           IF KCE-TIPO NOT = 2 GO TO A10-50.
           IF CEE-TEST1 = 1 AND SALDO < ZERO GO TO A10.
           ADD SALDO TO TTORD.
           GO TO A50.
       A10-50.
           IF KCE-TIPO NOT = 4 GO TO A10-60.
           IF CEE-TEST1 = 1 AND SALDO > ZERO GO TO A10.
           ADD SALDO TO TTORD.
           GO TO A50.
       A10-60.
           IF KCE-TIPO NOT = 1 GO TO A20.
           IF CEE-TEST1 = 1 AND SALDO < ZERO GO TO A10.
           ADD SALDO TO TTPAT.
           GO TO A50.
       A20.
           IF KCE-TIPO NOT = 3 GO TO A30.
           IF CEE-TEST1 = 1 AND SALDO > ZERO GO TO A10.
           ADD SALDO TO TTPAT.
           GO TO A50.
       A30.
           IF KCE-TIPO NOT = 5 GO TO A50.
           ADD SALDO TO TTECO.
       A50.
           ADD SALDO TO COMOD CEC-IMPO.
           MOVE KPC-COD TO KLV-PROG.
           READ WDSLAV INVALID GO TO A10.
           MOVE SALDO TO LAV-IMPO.
           MOVE ZERO TO K.
       A60.
           ADD 1 TO K.
           IF K > 10 GO TO A70.
           IF LAV-VOCX (K) NOT = SPACE GO TO A60.
           MOVE KCE-DATI TO LAV-VOCX (K).
       A70.
           REWRITE RF-LAV INVALID GO TO A10.
           GO TO A10.
       A99.
           EXIT.
      *------------------------
       B00-CALCSALDO.
           MOVE LOW-VALUE TO KEYMV.
           MOVE KPC-AZI   TO KMV-AZI.
           MOVE KPC-COD   TO KMV-CON.
           START MOVIME KEY NOT < KEYMV INVALID GO TO B20.
       B10.
           READ MOVIME NEXT INTO REKMOV AT END GO TO B20.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO B10.
           IF KMV-AZI > KPC-AZI GO TO B20.
           IF KMV-CON > KPC-COD GO TO B20.
      **** rel 6.2
           IF KMV-DAT > PKDAT   GO TO B20.
      **********
           IF NOT ( MOV-CAUS = T20-CDSOC OR 
                    MOV-CAUS = T20-CASOC ) GO TO B10.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO SALDO 
           ELSE SUBTRACT MOV-IMPO FROM SALDO.
           GO TO B10.
       B20.
           MOVE LOW-VALUE TO KEYMX.
           MOVE KPC-AZI   TO KMX-AZI.
           MOVE KPC-COD   TO KMX-CON.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO B99.
       B30.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO B99.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO B30.
           IF KMX-AZI > KPC-AZI GO TO B99.
           IF KMX-CON > KPC-COD GO TO B99.
      **** rel 6.2
           IF KMX-DAT > PKDAT   GO TO B30.
      **********
           IF NOT ( MOV-CAUS = T20-CDSOC OR 
                    MOV-CAUS = T20-CASOC ) GO TO B30.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO SALDO 
                ELSE SUBTRACT MOV-IMPO FROM SALDO.
           GO TO B30.
       B99.      
           EXIT.
      *----------------*
       C00-TOT-TIP.
           MOVE ALL '-' TO R2SOT2.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           IF TIPO = 1 MOVE 'TOTALE ATTIVO' TO R2TOT.
           IF TIPO = 2 MOVE 'TOTALE CONTI D''ORDINE ATTIVO' TO R2TOT.
           IF TIPO = 3 MOVE 'TOTALE PASSIVO' TO R2TOT.
           IF TIPO = 4 MOVE 'TOTALE CONTI D''ORDINE PASSIVO' TO R2TOT.
           MOVE TOTTIC TO R2IMP2.
           IF IF-LIREUR = 1
              MOVE TOTTIC TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2IMP2.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE ALL '=' TO R2SOT2.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE ZERO TO TOTTIC.
       C99.
           EXIT.
      *----------------*
       D00-TOT-VOCE.
           PERFORM E00-TOT-GRUP THRU E99.
           IF TIPO = 1 AND VOCE = 'B'
              MOVE 'TOTALE IMMOBILIZZAZIONI' TO R2TOT.
           IF TIPO = 1 AND VOCE = 'C'
              MOVE 'TOTALE ATTIVO CIRCOLANTE' TO R2TOT.
           IF TIPO = 3 AND VOCE = 'A'
              MOVE 'TOTALE PATRIMONIO NETTO' TO R2TOT.
           IF TIPO = 3 AND VOCE = 'B'
              MOVE ALL '=' TO R2SOT1 
              MOVE 2 TO RP-FLGR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 'TOTALE FONDI RISCHI E ONERI' TO R2TOT.
           IF TIPO = 3 AND VOCE = 'D'
              MOVE ALL '=' TO R2SOT1 
              MOVE 2 TO RP-FLGR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 'TOTALE DEBITI' TO R2TOT.
           MOVE TOTVOC TO R2IMP2.
           IF IF-LIREUR = 1
              MOVE TOTVOC TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2IMP2.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 2 TO XCRR.
           MOVE ZERO TO TOTVOC.
       D99.
           EXIT.
      *----------------*
       E00-TOT-GRUP.
           IF GRUP = ZERO GO TO E99.
           IF TIPO = 3 AND VOCE = 'A' AND GRUP = 9 GO TO E99.
           MOVE ALL '-' TO R2SOT1.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           IF TIPO = 1 AND VOCE = 'B' AND GRUP = 1
              MOVE 'TOTALE IMMOBILIZZAZIONI IMMATERIALI' TO R2TOT.
           IF TIPO = 1 AND VOCE = 'B' AND GRUP = 2
              MOVE 'TOTALE IMMOBILIZZAZIONI MATERIALI' TO R2TOT.
           IF TIPO = 1 AND VOCE = 'B' AND GRUP = 3
              MOVE 'TOTALE IMMOBILIZZAZIONI FINANZIARIE' TO R2TOT.
           IF TIPO = 1 AND VOCE = 'C' AND GRUP = 1
              MOVE 'TOTALE RIMANENZE' TO R2TOT.
           IF TIPO = 1 AND VOCE = 'C' AND GRUP = 2
              MOVE 'TOTALE CREDITI' TO R2TOT.
           IF TIPO = 1 AND VOCE = 'C' AND GRUP = 3
              MOVE 'TOTALE ATTIVITA'' FINANZIARIE' TO R2TOT.
           IF TIPO = 1 AND VOCE = 'C' AND GRUP = 4
              MOVE 'TOTALE DISPONIBILITA'' LIQUIDE' TO R2TOT.
           MOVE TOTGRC TO R2IMP1.
           IF IF-LIREUR = 1
              MOVE TOTGRC TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ER2IMP1.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE ZERO TO TOTGRC.
           MOVE ALL '=' TO R2SOT1.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
       E99.
           EXIT.
      *----------------*
       F00-CTR-ALL.
           MOVE ZERO TO FLGALL.
           IF KCE-TIPO = 1 AND ( KCE-VOCE > 'A' AND < 'D' )
                           AND KCE-GRUP = ZERO 
                           MOVE 1 TO FLGALL GO TO F99.
           IF KCE-TIPO = 1 AND ( KCE-VOCE > 'A' AND < 'D' )
                           AND KCE-TRAI = ZERO 
                           MOVE 1 TO FLGALL GO TO F99.
           IF KCE-TIPO = 1 AND KCE-VOCE = 'B' AND KCE-GRUP = 3 AND
             (KCE-TRAI = 1 OR 2) AND KCE-DETT = SPACE 
                            MOVE 1 TO FLGALL GO TO F99.
           IF KCE-TIPO = 3 AND KCE-VOCE = 'A' AND 
                               KCE-GRUP = ZERO 
                            MOVE 1 TO FLGALL GO TO F99.
           IF KCE-TIPO = 3 AND (KCE-VOCE = 'B' OR 'D') AND
                               KCE-TRAI = ZERO 
                            MOVE 1 TO FLGALL GO TO F99.
           IF KCE-TIPO = 3 AND KCE-VOCE = 'A' AND
              KCE-GRUP = 7 AND KCE-DETT = SPACE 
                            MOVE 1 TO FLGALL GO TO F99.
           IF KCE-TIPO = 5 AND KCE-TRAI = ZERO 
                            MOVE 1 TO FLGALL GO TO F99.
           IF KCE-TIPO = 5 AND
              (KCE-TRAI = 9 OR 10 OR 16 OR 18 OR 19) AND
                              KCE-DETT = SPACE 
                            MOVE 1 TO FLGALL GO TO F99.
       F99.
           EXIT.
      *----------------*
       G00-LEGGE-CONTO.
           MOVE ZERO TO CON-SP-D CON-SP-A CON-SE-D CON-SE-A.
           IF PKDAT > AZI-RVDT MOVE ZERO TO CON-SESP GO TO G40.
           MOVE ZERO TO CON-SPSP CON-SESP.
           MOVE LOW-VALUE TO KEYMX.
           MOVE KPC-AZI TO KMX-AZI.
           MOVE KPC-COD TO KMX-CON.
           MOVE AZI-DTAPE TO KMX-DAT.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO G40.
       G10.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO G40.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO G10.
           IF KMX-AZI > KPC-AZI GO TO G40.
           IF KMX-CON > KPC-COD GO TO G40.
           IF KMX-DAT > PKDAT   GO TO G40.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO CON-SESP
           ELSE SUBTRACT MOV-IMPO FROM CON-SESP.
           GO TO G10.
       G40.
           MOVE LOW-VALUE TO KEYMV.
           MOVE KPC-AZI TO KMV-AZI.
           MOVE KPC-COD TO KMV-CON.
           MOVE ZERO    TO KMV-DAT.
           START MOVIME KEY NOT < KEYMV INVALID GO TO G99.
       G50.
           READ MOVIME NEXT INTO REKMOV AT END GO TO G99.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO G50.
           IF KMV-AZI > KPC-AZI GO TO G99.
           IF KMV-CON > KPC-COD GO TO G99.
           IF KMV-DAT > PKDAT   GO TO G99.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO CON-SPSP
           ELSE SUBTRACT MOV-IMPO FROM CON-SPSP.
           GO TO G50.
        G99.
           EXIT.
      *----------------*
       H00-STA-CONT.
           IF CEE-VARIA NOT = ZERO
              MOVE 'Variazioni' TO RSOT3
              MOVE CEE-VARIA TO RIMP4
              IF IF-LIREUR = 1
                 MOVE CEE-VARIA TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO ERIMP4
              END-IF
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR.
           MOVE ZERO TO FLGSTA.
           MOVE KCE-AZI TO KEC-AZI.
           MOVE KCE-DATI TO KEC-DATI
           MOVE ZERO TO KEC-CONTO.
           START BILCEC KEY NOT < KEYEC INVALID GO TO H90.
       H10.
           READ BILCEC NEXT AT END GO TO H90.
           IF SF-CEC = '9D' OR '9A' OR '35' GO TO H10.
           IF KEC-AZI NOT = KCE-AZI OR
              KEC-DATI NOT = KCE-DATI GO TO H90.
           MOVE 1 TO FLGSTA.
           MOVE KAZ-COD TO KPC-AZI.
           MOVE KEC-CONTO TO KPC-COD.
           READ ANACON INTO REKCON INVALID MOVE ALL '*' TO CON-DSABB.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-DSABB TO RDES2.
           MOVE KEC-CONTO TO RIMP3.
           MOVE CEC-IMPO  TO RIMP4.
           IF IF-LIREUR = 1
              MOVE CEC-IMPO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO ERIMP4.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           GO TO H10.
       H90.
           IF FLGSTA = ZERO MOVE 'RIG1' TO RP-BLK
                            PERFORM RPT-WR.
       H99.
           EXIT.
      *----------------*
       STA-ERRORI.
           PERFORM RPT-INI.
           MOVE AZRGSOC TO TAZI.
      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 0       TO NINT.
      *--------------------------------------------------*
      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'LISTA ANOMALIE '
                  DELIMITED SIZE INTO RP-TIT1.
      *---------------------------------------------*
           OPEN INPUT ERRORI.
           MOVE ZERO TO XCRR NPAG.
           MOVE ' LISTA ANOMALIE ' TO P999B.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1B' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 2 TO XCRR.
       STERR.
           READ ERRORI AT END GO TO CHISTA.
           MOVE RF-ERR TO P999B.
           MOVE 'RIG1B' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           GO TO STERR.
       CHISTA.
           PERFORM RPT-CL.
           CLOSE ERRORI.
       EX-STA-ERRORI.
           EXIT.
      *----------------*
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *      
           MOVE DSTIPX (KCE-TIPO) TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE TINT11 TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Conto' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione Conto' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Importo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
