       IDENTIFICATION DIVISION.
       PROGRAM-ID. VBICP10.
      *
      * Stampa voci bilancio CEE
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'griceesl'.
           COPY 'gricecsl'.
           COPY 'gricepsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricon'.
           COPY 'gricee'.
           COPY 'gricec'.
           COPY 'gricep'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griconrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
       01  ID-CEE PIC X(15) VALUE 'bilcee'.
       01  ID-CEC PIC X(15) VALUE 'bilcec'.
       01  ID-CEP PIC X(15) VALUE 'bilcep'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-CON   PIC XX.
           05 SF-CEE   PIC XX.
           05 SF-CEC   PIC XX.
           05 SF-CEP   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 FLGALL   PIC 9.
           05 TIPO     PIC 9.
           05 AZINI.
              10 TIPIN PIC 9.
              10 VOCIN PIC X.
              10 GRUIN PIC 9.
              10 TRAIN PIC 99.
              10 PRGIN PIC 99.
              10 DESIN PIC X(5).
              10 DETIN PIC X.
           05 AZIFI.
              10 TIPFI PIC 9.
              10 VOCFI PIC X.
              10 GRUFI PIC 9.
              10 TRAFI PIC 99.
              10 PRGFI PIC 99.
              10 DESFI PIC X(5).
              10 DETFI PIC X.
           05 RGRU.
              10 FILLER PIC X(5) VALUE '   I.'.
              10 FILLER PIC X(5) VALUE '  II.'.
              10 FILLER PIC X(5) VALUE ' III.'.
              10 FILLER PIC X(5) VALUE '  IV.'.
              10 FILLER PIC X(5) VALUE '   V.'.
              10 FILLER PIC X(5) VALUE '  VI.'.
              10 FILLER PIC X(5) VALUE ' VII.'.
              10 FILLER PIC X(5) VALUE 'VIII.'.
              10 FILLER PIC X(5) VALUE '  IX.'.
           05 RGRUX REDEFINES RGRU PIC X(5) OCCURS 9.
           05 DSTIP.
              10 FILLER PIC X(22) VALUE 'ATTIVO'.
              10 FILLER PIC X(22) VALUE 'CONTI D''ORDINE ATTIVO'.
              10 FILLER PIC X(22) VALUE 'PASSIVO'.
              10 FILLER PIC X(22) VALUE 'CONTI D''ORDINE PASSIVO'.
              10 FILLER PIC X(22) VALUE 'CONTO ECONOMICO'.
           05 DSTIPX REDEFINES DSTIP PIC X(22) OCCURS 5.

           COPY 'vbicp10.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           05 IF-TIP       PIC 9.
           COPY 'grirpt-l'.
      *----------------------------------------------
      * IF-TIP  puo' valere:
      *     0= esercizio corrente
      *     1= esercizio precedente
      *----------------------------------------------
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-TIPIN     PIC 9.
           05 IF-VOCIN     PIC X.
           05 IF-GRUIN     PIC 9.
           05 IF-TRAIN     PIC 99.
           05 IF-DETIN     PIC X.
           05 IF-TIPFI     PIC 9.
           05 IF-VOCFI     PIC X.
           05 IF-GRUFI     PIC 9.
           05 IF-TRAFI     PIC 99.
           05 IF-DETFI     PIC X.
           05 IF-TIPAZ     PIC 9.
           05 IF-DATA      PIC 9(6).
           05 IF-PRGIN     PIC 99.
           05 IF-DESIN     PIC X(5).
           05 IF-PRGFI     PIC 99.
           05 IF-DESFI     PIC X(5).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcon'.
           COPY 'dclcee'.
           COPY 'dclcec'.
           COPY 'dclcep'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vbicp10: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI
                 ANACON
                 BILCEE
                 BILCEC
                 BILCEP.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griconer'.
           COPY 'griceeer'.
           COPY 'gricecer'.
           COPY 'griceper'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           IF IF-FL = ZERO
              MOVE 'anaazi' TO ID-AZI
              MOVE 'anacon' TO ID-CON
              MOVE 'bilcee' TO ID-CEE
              MOVE 'bilcec' TO ID-CEC
              MOVE 'bilcep' TO ID-CEP
           ELSE
              MOVE 'anazol' TO ID-AZI
              MOVE 'anacol' TO ID-CON
              MOVE 'bilold' TO ID-CEE
              MOVE 'bilolc' TO ID-CEC
              MOVE 'bilolp' TO ID-CEP.
      *
           OPEN INPUT ANAAZI
                      ANACON
                      BILCEE
                      BILCEC
                      BILCEP.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE ZERO  TO IF-TIPIN
                         IF-GRUIN
                         IF-TRAIN
                         IF-PRGIN
                         IF-TIPFI
                         IF-GRUFI
                         IF-TRAFI
                         IF-DATA.
           MOVE SPACE TO IF-VOCIN
                         IF-DESIN
                         IF-DETIN
                         IF-VOCFI
                         IF-DETFI.
           MOVE 99      TO IF-PRGFI.
           MOVE ALL 'z' TO IF-DESFI.
           MOVE 1 TO IF-TIPAZ.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-TIPIN.
           MOVE 'IF-TIPIN' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TIPIN.
           IF IF-TIPIN  > 5
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-TIPIN.
      *
       V-TIPAZ.
           MOVE 'IF-TIPAZ' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TIPAZ.
           IF NOT (IF-TIPAZ = 1 OR 2)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-TIPAZ.
      *
       V-DATA.
           MOVE 'IF-DATA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DATA.
      * esegue sempre
           MOVE IF-TIPIN TO TIPIN.
           MOVE IF-VOCIN TO VOCIN.
           MOVE IF-GRUIN TO GRUIN.
           MOVE IF-TRAIN TO TRAIN.
           MOVE IF-PRGIN TO PRGIN.
           MOVE IF-DESIN TO DESIN.
           MOVE IF-DETIN TO DETIN.
           MOVE IF-TIPFI TO TIPFI.
           MOVE IF-VOCFI TO VOCFI.
           MOVE IF-GRUFI TO GRUFI.
           MOVE IF-TRAFI TO TRAFI.
           MOVE IF-PRGFI TO PRGFI.
           MOVE IF-DESFI TO DESFI.
           MOVE IF-DETFI TO DETFI.
           IF AZIFI < AZINI
              PERFORM ERR-DINC
              GO TO V-ERROR.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           COPY 'grirpt-sn' REPLACING 1 BY 2
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           MOVE IF-DATA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO TDTEL.
      *
      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'LISTA VOCI BILANCIO C.E.E. - '  TDTEL
                  DELIMITED SIZE INTO RP-TIT1.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG1-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
      *
           
           MOVE ZERO TO XCRR
                        NPAG
                        TIPO 
                        FLGALL.
      *
           MOVE KAZ-COD TO KCE-AZI.
           MOVE AZINI   TO KCE-DATI.
           START BILCEE KEY NOT < KEYCE INVALID GO TO FNSTA.
       STP-10.
           READ  BILCEE NEXT AT END GO TO FNSTA.
           IF SF-CEE = '9D' OR '9A' OR '35' GO TO STP-10.
           IF KCE-AZI NOT = KAZ-COD GO TO FNSTA.
           IF KCE-DATI    > AZIFI   GO TO FNSTA.
           MOVE KCE-DATI TO RCDI.
           IF KCE-PRG = ZERO OR '00' MOVE SPACE TO RCDI(6:2).
           IF KCE-TIPO NOT = TIPO
              MOVE KCE-TIPO TO TIPO
              MOVE DSTIPX(KCE-TIPO) TO RDESC
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.
           IF KCE-DETT NOT = SPACE
              MOVE KCE-DETT TO RDETT 
              MOVE ')'      TO RDETTP
              GO TO STP-20.
           IF KCE-TRAI NOT = ZERO
              IF KCE-PRG = ZERO AND KCE-DES = SPACE 
                 MOVE KCE-TRAI TO RTRAI
                 MOVE ')'      TO RTRAIP
              ELSE
                 MOVE KCE-TRAI TO RTRAI1
                 MOVE KCE-DES  TO RDES
                 MOVE ')'      TO RTRAIP1
              END-IF
              GO TO STP-20.
           IF KCE-GRUP NOT = ZERO
              MOVE RGRUX (KCE-GRUP) TO RGRUP
              GO TO STP-20.
           MOVE KCE-VOCE TO RVOCE.
           MOVE ')'      TO RVOCEP.
       STP-20.
           MOVE CEE-DESC1 TO RDESC.
           IF CEE-DESC2 NOT = SPACE
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR
              MOVE CEE-DESC2 TO RDESC.
           IF IF-TIPAZ = 1 GO TO STP-40.
           IF IF-TIP   = 1 GO TO STP-50.
           MOVE KCE-AZI  TO KEC-AZI.
           MOVE KCE-DATI TO KEC-DATI.
           MOVE ZERO     TO KEC-CONTO.
           START BILCEC KEY NOT < KEYEC INVALID GO TO STP-40.
       STP-30.
           READ BILCEC NEXT AT END GO TO STP-40.
           IF SF-CEC = '9D' OR '9A' OR '35' GO TO STP-30.
           IF KEC-AZI  NOT = KCE-AZI  OR
              KEC-DATI NOT = KCE-DATI GO TO STP-40.
           MOVE 1 TO FLGALL.
           MOVE KEC-CONTO TO KPC-COD RCONTO.
           MOVE KEC-AZI   TO KPC-AZI.
           READ ANACON INTO REKCON INVALID MOVE ALL '*' TO CON-DSABB.
           MOVE CON-DSABB TO RDSCON.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
           GO TO STP-30.
       STP-40.
           IF FLGALL = ZERO MOVE 'RIG1' TO RP-BLK
                            PERFORM RPT-WR
                            MOVE 1 TO XCRR.
           MOVE ZERO TO FLGALL.
      *
           COPY 'grirpt-r' REPLACING 1 BY 2
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           GO TO STP-10.
       STP-50.
           MOVE KCE-AZI  TO KEP-AZI.
           MOVE KCE-DATI TO KEP-DATI.
           MOVE ZERO     TO KEP-CONTO.
           START BILCEP KEY NOT < KEYEP INVALID GO TO STP-40.
       STP-60.
           READ BILCEP NEXT AT END GO TO STP-40.
           IF SF-CEP = '9D' OR '9A' OR '35' GO TO STP-60.
           IF KEP-AZI  NOT = KCE-AZI  OR
              KEP-DATI NOT = KCE-DATI GO TO STP-40.
           MOVE 1 TO FLGALL.
           MOVE KEP-CONTO TO KPC-COD RCONTO.
           MOVE KEP-AZI   TO KPC-AZI.
           READ ANACON INTO REKCON INVALID MOVE ALL '*' TO CON-DSABB.
           MOVE CON-DSABB TO RDSCON.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
      *
           COPY 'grirpt-r'.
      *
           GO TO STP-60.
       FNSTA.
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'Codice' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Conto Collegato' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
