       IDENTIFICATION DIVISION.
       PROGRAM-ID. VBON191.
      *
      * OGGETTO   :   Travaso bonifici da presentare su file posizionale
      *
      **** rel 6.2
      * Riscritto
      ************
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griprasl'.
           COPY 'griclfsl'.
           COPY 'griscasl'.
           COPY 'gribansl'.
           COPY 'griabasl'.
           COPY 'gribonsl'.
           SELECT WDSLAV ASSIGN TO DISK 
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gripra'.
           COPY 'grisca'.
           COPY 'griclf'.
           COPY 'griban'.
           COPY 'griaba'.
           COPY 'gribon'.
           COPY 'gritab'.

       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 55 DATA RECORD RF-LAV.
       01 RF-LAV.
           02 KEYLV.
              05 KWS-BAN     PIC 9(5).
              05 KWS-FOR     PIC 9(7).
              05 KWS-IBAN    PIC X(34).
              05 KWS-DTV     PIC 9(5) COMP-3.
              05 KWS-DTS     PIC 9(5) COMP-3.
              05 KWS-PGR     PIC 9(5) COMP-3.

       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griclfrk'.
           COPY 'gritabrk'.
           COPY 'griazirk'.
           COPY 'parzf'.
           COPY 'parmb'.
           COPY 'parcdt'.
           COPY 'parpcfgr'.
           COPY 'parpcfgc'.
           COPY 'pariban'.
           COPY 'parwxml'.
           COPY 'parwtxt'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-BAN PIC X(15) VALUE 'anaban'.
       01  ID-ABA PIC X(15) VALUE 'appban'.
       01  ID-BFO PIC X(15) VALUE 'bonfor'.
       01  ID-PRA PIC X(15) VALUE 'proazi'.
       01  ID-SCA PIC X(15) VALUE 'anasca'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  COMODI.
           05 SF-AZI PIC XX.
           05 SF-TAB PIC XX.
           05 SF-CLF PIC XX.
           05 SF-BAN PIC XX.
           05 SF-ABA PIC XX.
           05 SF-BFO PIC XX.
           05 SF-PRA PIC XX.
           05 SF-SCA PIC XX.
           05 SF-LAV PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 DATK1    PIC 9(5) VALUE ZERO.
           05 DATK2    PIC 9(5) VALUE ZERO.
           05 NFAT     PIC ZZZZ9 VALUE ZERO.
           05 CODFOR.
              10 MAS PIC 99 VALUE ZERO.
              10 COD PIC 9(5) VALUE ZERO.
           05 FORNIT.
              10 SPAZIO PIC X(11) VALUE ZERO.
              10 CODICE PIC X(5).
           05 DBAND PIC X(30).
           05 CBAN1BON PIC 9(5).
           05 COMFOR PIC 9(7) VALUE ZERO.
           05 COMDTV PIC 9(5) COMP-3 VALUE ZERO.
           05 COMIBAN PIC X(34)     VALUE SPACE.
           05 CONTABON PIC 9(7)     VALUE ZERO.
           05 CONTA    PIC 9(7)     VALUE ZERO.
           05 PROG     PIC 9(4)     VALUE ZERO.
           05 TOTDTV PIC S9(11)V999 VALUE ZERO.
           05 TOTGEN PIC S9(11)V999 VALUE ZERO.
           05 KONT   PIC 9          VALUE ZERO.
           05 KONT2  PIC 9          VALUE ZERO.
           05 CNDC1  PIC ZZZZ9      VALUE ZERO.
           05 VNDC1 REDEFINES CNDC1 PIC X OCCURS 5.
           05 CNDC2.
              10 VNDC2 PIC X OCCURS 5.
           05 DESCRI.
              10 DSD PIC X(30) OCCURS 3 VALUE SPACE.
           05 KONCA    PIC 999.
           05 CONCAIN  PIC X(36).
           05 CONCOUT.
              10 CONCO1 PIC X(30).
              10 CONCO2 PIC X(30).
              10 CONCO3 PIC X(30).
              10 CONCO4 PIC X(10).
      **** rel 7.2
           05 ORAT.
              10 ORAOO PIC 99.
              10 ORAMM PIC 99.
           05 COMNUM   PIC 9(10)V9(6).
           05 K1       PIC 9(5).
      ************
      *
           05 CIBAN-2.
              10 PAE-2  PIC XX.
              10 IBAN-2.
                 15 CTR-2    PIC XX.
                 15 COD-2    PIC X(30).
                 15 BBAN-2 REDEFINES COD-2.
                    20 IBAN-CIN-2  PIC X.
                    20 IBAN-ABI-2  PIC 9(5).
                    20 IBAN-CAB-2  PIC 9(5).
                    20 IBAN-CC-2   PIC X(12).
                    20 IBAN-FIL-2  PIC X(7).
      *
           05 PATH     PIC X(80) VALUE SPACE.
           05 NOMEFILE.
              10 LBL1 PIC X(4) VALUE 'SDD-'.
              10 DAT  PIC X(6) VALUE ZERO.
              10 LBL2 PIC X(1) VALUE '-'.
              10 ORA  PIC 99   VALUE ZERO.
              10 LBL3 PIC X(1) VALUE '-'.
              10 MIN  PIC 99   VALUE ZERO.
      *
      *
      * Parametri CBL_CHECK_EXIST_FILE
       01  FILE-NAME          PIC X(60).
       01  FILE-DETAILS.
           05 FILE-SIZE       PIC X(8) COMP-X.
           05 FILE-DATE.
              10 F-DAY        PIC X  COMP-X.
              10 F-MONTH      PIC X  COMP-X.
              10 F-YEAR       PIC X(2) COMP-X.
           05 FILE-TIME.
              10 F-HOURS      PIC X COMP-X.
              10 F-MINUTES    PIC X COMP-X.
              10 F-SECONDS    PIC X COMP-X.
              10 F-HINDREDTHS PIC X COMP-X.
       01  STATUS-CODE        PIC X(2)   COMP-X.
      *---------------------------------------------------------
      *
           COPY 'vbon191.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-BAN       PIC 9(5).
           05 IF-BAN-D     PIC X(36).
           05 IF-IBAN.
              10 PAE-1  PIC XX.
              10 IBAN-1.
                 15 CTR-1    PIC XX.
                 15 COD-1    PIC X(30).
                 15 BBAN-1 REDEFINES COD-1.
                    20 IBAN-CIN-1  PIC X.
                    20 IBAN-ABI-1  PIC 9(5).
                    20 IBAN-CAB-1  PIC 9(5).
                    20 IBAN-CC-1   PIC X(12).
                    20 IBAN-FIL-1  PIC X(7).
           05 IF-FOR-1     PIC 9(5).
           05 IF-FOR-2     PIC 9(5).
           05 IF-DTSCA-1   PIC 9(6).
           05 IF-DTSCA-2   PIC 9(6).
           05 IF-TPTRA     PIC 9.
           05 IF-DATA      PIC 9(6).
           05 IF-BNF-D     PIC X(80).
           05 IF-CONT      PIC 9(9).
           05 IF-TOTGEN    PIC S9(15)V99.
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclpra'.
           COPY 'dclclf'.
           COPY 'dclsca'.
           COPY 'dclban'.
           COPY 'dclaba'.
           COPY 'dclbon'.
           COPY 'dcllav'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vbon191: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE TABELL.
           CLOSE ANAAZI.
           CLOSE PROAZI.
           CLOSE ANACLF.
           CLOSE ANABAN.
           CLOSE APPBAN.
           CLOSE BONFOR.
           CLOSE ANASCA.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gritaber'.
           COPY 'gribaner'.
           COPY 'griboner'.
           COPY 'griscaer'.
           COPY 'griclfer'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           OPEN INPUT ANAAZI.
           OPEN INPUT PROAZI.
           OPEN INPUT TABELL.
           OPEN INPUT ANABAN.
           OPEN INPUT APPBAN.
           OPEN INPUT ANACLF.
           OPEN INPUT ANASCA.
           OPEN I-O BONFOR.
      *
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           MOVE KAZ-COD TO KEYPR.
           READ PROAZI INVALID MOVE ZERO  TO PRA-COD.
      *
           MOVE 1 TO KTB-TIP.
           MOVE 1 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB 
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' MOVE RF-TAB TO REKTAB.
           MOVE T01-MFOR TO MAS.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.

           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DATA DAT.
      *
      **** rel 7.2
           ACCEPT ORAT FROM TIME.
           MOVE ORAOO TO ORA.
           MOVE ORAMM TO MIN.
      ************

           MOVE ZERO   TO IF-BAN
                          IF-DTSCA-1
                          IF-DTSCA-2
                          DATK1
                          DATK2
                          IF-TPTRA.
           MOVE SPACE  TO IF-BAN-D
                          IF-IBAN.
           MOVE ZERO   TO IF-FOR-1.
           MOVE 99999  TO IF-FOR-2.

           MOVE ZERO    TO IF-CONT.
           MOVE ZERO    TO IF-TOTGEN.

           MOVE SPACE TO PATH.
           IF EX-DFL NOT = LOW-VALUE AND
              EX-FL NOT = LOW-VALUE
                STRING EX-DFL EX-FL '\' DELIMITED SPACE INTO PATH.
           IF EX-WS NOT = LOW-VALUE AND
              EX-UTI NOT = LOW-VALUE
      **** rel 6.3
      *          MOVE EX-UTI TO PCFG-PATH
                 DISPLAY 'PRF-DIR' UPON ENVIRONMENT-NAME
                 ACCEPT PCFG-PATH FROM ENVIRONMENT-VALUE ON EXCEPTION
                        MOVE EX-UTI TO PCFG-PATH
                 END-ACCEPT
      ************
                 MOVE ZERO TO PCFG-R-FUN
                 MOVE EX-WS TO PCFG-R-WS
                 MOVE 'PATH-BOF' TO PCFG-R-COD
                 CALL 'readcfg' USING PARPCFG-R PCFG-CTR
                                      ON EXCEPTION MOVE 9 TO PCFG-ST
                 END-CALL
                 IF PCFG-ST = ZERO AND PCFG-R-VAL NOT = SPACE
                    MOVE SPACE TO PATH
                    STRING PCFG-R-VAL '\' DELIMITED SPACE INTO PATH.

           STRING PATH DELIMITED SPACE
                  NOMEFILE DELIMITED SPACE
                  '.xml' DELIMITED SIZE INTO IF-BNF-D.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-BAN.
           MOVE 'IF-BAN' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-BAN.
           MOVE SPACE TO IF-BAN-D.
           IF IF-BAN = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE IF-BAN TO KBA-BAN.
           READ ANABAN INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           MOVE BAN-RGSOC TO IF-BAN-D.
      **** rel 6.3
      *    MOVE KEYBA TO KEYABA.
           MOVE KAZ-COD TO KABA-AZI.
           MOVE KBA-BAN TO KABA-BAN.
      ************
           READ APPBAN INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF ABA-CUC = SPACE
              MOVE 'Valorizzare codice CUC su banca' TO MESS
              GO TO V-ERROR.
           IF NOT (ABA-PAE = 'IT' OR 'SM') OR ABA-IBAN = SPACE
                PERFORM ERR-DINV
                GO TO V-ERROR.
           IF FUN = 'V'
              MOVE ABA-CIBAN TO IF-IBAN.
       E-BAN.
      *
       V-IBAN.  
           MOVE 'IF-IBAN' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IBAN.  
           MOVE IF-IBAN TO IBAN.
           CALL 'riban' USING PARIBAN PARBBAN.
           IF IBAN-FLG = 9
                PERFORM ERR-DINV
                GO TO V-ERROR.
       E-IBAN.  
      *
       V-FOR-2.
           MOVE 'IF-FOR-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FOR-2.
           IF IF-FOR-2 < IF-FOR-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-FOR-2.
      *
       V-DTSCA-1.
            MOVE 'IF-DTSCA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTSCA-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTSCA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DATK1.
       E-DTSCA-1.
      *
       V-DTSCA-2.
           MOVE 'IF-DTSCA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTSCA-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTSCA-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DATK2.
           IF DATK2 < DATK1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DTSCA-2.
      *
       V-TPTRA.
           MOVE 'IF-TPTRA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPTRA.
           IF NOT (IF-TPTRA = ZERO OR 1)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-TPTRA.
      *
       V-DATA.
           MOVE 'IF-DATA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DATA.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O WDSLAV.
      *
           MOVE ZERO TO IF-CONT.
           MOVE ZERO TO IF-TOTGEN.

      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'STAMPA  ANOMALIE RISCONTRATE '
                  DELIMITED SIZE INTO RP-TIT1.
      *
      *    MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
      *
      *    OPEN OUTPUT BONIFICI.
      *
           MOVE LOW-VALUE TO KEYBF.
           MOVE IF-AZI  TO KBF-AZI.
           MOVE ZERO    TO KBF-TIP.
           MOVE IF-BAN  TO KBF-BAN.
       LPDAT.
           MOVE DATK1   TO KBF-DTS.
       LPSTR.
           MOVE ZERO    TO KBF-PGR.
           START BONFOR KEY NOT < KEYBF INVALID GO TO L075-1.
       L075.
           READ BONFOR NEXT AT END GO TO L075-1.
           IF SF-BFO = '9D' OR '9A' GO TO L075.
           IF KBF-AZI > IF-AZI   GO TO L075-1.
           IF KBF-TIP > ZERO     GO TO L075-1.
           IF KBF-BAN NOT = IF-BAN  GO TO L075-1.

           IF KBF-DTS < DATK1 GO TO LPDAT.
           IF KBF-DTS > DATK2 MOVE 99999 TO KBF-DTS GO TO LPSTR.

           IF BFO-FLTRAV = 1 GO TO L075.

           MOVE KBF-AZI TO KSC-AZI.
           MOVE 2       TO KSC-TIPO.
           MOVE KBF-DTS TO KSC-DTSCA.
           MOVE KBF-PGR TO KSC-PRG.
           READ ANASCA INVALID PERFORM INVK-SCA
                               PERFORM VISK-BFO
                               GO TO ERRIO.

           MOVE KBF-BAN   TO KWS-BAN. 
           MOVE KAZ-COD   TO KCF-AZI.
           MOVE KS2-CODCF TO KCF-COD.
           MOVE KS2-CODCF TO CODFOR.
           IF COD < IF-FOR-1 OR > IF-FOR-2 GO TO L075.
      *
           MOVE BFO-CIBAN TO IBAN.
           CALL 'riban' USING PARIBAN PARBBAN.
           IF IBAN-FLG = 9  
              MOVE KBF-DTS TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE KBF-PGR TO LGW5
              STRING 'Codice IBAN errato: '
                     'Azi: ' KBF-AZI
                     ' Tipo: ' KBF-TIP
                     ' Banca: ' KBF-BAN
                     ' Data: ' GBMMBA
                     ' Prg: ' LGW5
                     ' Cod For: ' COD
                     DELIMITED SIZE INTO P999
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR
              GO TO L075.
      *
           MOVE KS2-CODCF TO KWS-FOR.
           MOVE BFO-DTV   TO KWS-DTV.
           MOVE BFO-CIBAN TO KWS-IBAN.
           MOVE KBF-DTS   TO KWS-DTS.
           MOVE KBF-PGR   TO KWS-PGR.
           WRITE RF-LAV INVALID KEY MOVE 'WR LAV' TO MESS GO TO ERRIO.
           GO TO L075.
       L075-1.
           MOVE ZERO TO CONTABON.

      *
           MOVE ZERO TO PARWXML.
           MOVE SPACE TO PWXM-NOMEFX.
           MOVE IF-BNF-D TO PWXM-NOMEFX.
           MOVE SPACE TO PWXM-FUN.
           MOVE SPACE TO PWXM-TAG.
           MOVE SPACE TO PWXM-ATTR.
           MOVE ZERO  TO PWXM-TIPO.
           MOVE SPACE TO PWXM-CAMPO.
           MOVE ZERO  TO PWXM-NUM.
           MOVE ZERO  TO PWXM-DATA.
           CALL 'vxml-wr' USING PARWXML.
      *
           MOVE ZERO TO PARWTXT.
           MOVE IF-BNF-D TO PWTX-NOMEFX.
           MOVE SPACE   TO PWTX-SEP.
      *
           MOVE 'E' TO PWTX-FUN.
           CALL 'vtxt-wr' USING PARWTXT.
      *
           MOVE 'w' TO PWTX-FUN.
           CALL 'vtxt-wr' USING PARWTXT.
      *
           MOVE 'C' TO PWTX-FUN.
           MOVE '<?xml version="1.0" encoding="UTF-8"?>' TO PWTX-CAMPO.
           CALL 'vtxt-wr' USING PARWTXT.
      *
      *    MOVE '<CBIBdyPaymentRequest ' TO PWTX-CAMPO.
      *    CALL 'vtxt-wr' USING PARWTXT.
      *
      *    STRING '          xmlns="urn:CBI:xsd:CBIBdyPayment'
      *           'Request.00.04.00"' DELIMITED SIZE INTO PWTX-CAMPO.
      *    CALL 'vtxt-wr' USING PARWTXT.
      *
      *    STRING '          xmlns:xsi="http://www.w3.org/2001'
      *           '/XMLSchema-instance"' DELIMITED SIZE INTO PWTX-CAMPO.
      *    CALL 'vtxt-wr' USING PARWTXT.
      *
      *    STRING '          xsi:schemaLocation="urn:CBI:xsd:CBIBdy'
      *           'PaymentRequest.00.03.09 CBIBdyPaymentRequest'
      *           '.00.03.09.xsd">' DELIMITED SIZE INTO PWTX-CAMPO.
      *    CALL 'vtxt-wr' USING PARWTXT.
      *
      *    MOVE '<CBIEnvelPaymentRequest>' TO PWTX-CAMPO.
      *    CALL 'vtxt-wr' USING PARWTXT.
      *
           MOVE 'E' TO PWTX-FUN.
           CALL 'vtxt-wr' USING PARWTXT.
      *
      * Inizio CBIPaymentRequest
           MOVE '+'  TO PWXM-FUN.
           MOVE 'CBIPaymentRequest' TO PWXM-TAG.
           MOVE 'xmlns' TO PWXM-NATTR(1).
           MOVE 'urn:CBI:xsd:CBIPaymentRequest.00.04.00' 
                TO PWXM-VATTR(1).
           call 'vxml-wr' using parwxml.
      *
      * Inizio GrpHdr
           MOVE '+'  TO PWXM-FUN.
           MOVE 'GrpHdr' TO PWXM-TAG.
      *    MOVE 'xmlns' TO PWXM-NATTR(1).
      *    MOVE 'urn:CBI:xsd:CBIPaymentRequest.00.03.09' 
      *         TO PWXM-VATTR(1).
           call 'vxml-wr' using parwxml.
      *
           MOVE 'MsgId' TO PWXM-TAG.
           MOVE NOMEFILE TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 1 TO TIPOP1.
           MOVE DAT TO GGMMAA.
           CALL 'rdata' USING PARCDT.
      *
           MOVE 'CreDtTm' TO PWXM-TAG.
           STRING AA4 '-' MM9 '-' GG9 'T' ORAOO ':'ORAMM ':00+01:00'
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE ZERO TO CONTA TOTGEN.
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID GO TO L092.
       L077.
           READ WDSLAV NEXT AT END GO TO L092.
           MOVE KAZ-COD TO KBF-AZI.
           MOVE ZERO    TO KBF-TIP.
           MOVE KWS-BAN TO KBF-BAN.
           MOVE KWS-DTS TO KBF-DTS.
           MOVE KWS-PGR TO KBF-PGR.
           READ BONFOR INVALID PERFORM INVK-BFO
                               GO TO ERRIO.
           ADD BFO-PAG TO TOTGEN.
           ADD 1 TO CONTA.
           GO TO L077.
       L092.
           MOVE 'NbOfTxs' TO PWXM-TAG.
           MOVE CONTA TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'CtrlSum' TO PWXM-TAG.
           MOVE TOTGEN TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Inizio InitgPty
           MOVE '+'  TO PWXM-FUN.
           MOVE 'InitgPty' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'Nm' TO PWXM-TAG.
           MOVE AZI-RGSOC TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Inizio Id
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Id' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      * Inizio OrgId
           MOVE '+'  TO PWXM-FUN.
           MOVE 'OrgId' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      * Inizio Othr
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Othr' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'Id' TO PWXM-TAG.
           MOVE ABA-CUC TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'Issr' TO PWXM-TAG.
           MOVE 'CBI' TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Fine Othr
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Fine OrgId
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Fine Id
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Fine InitgPty
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      *
      * Fine GrpHdr
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      *
      * Inizio PmtInf
           MOVE '+'  TO PWXM-FUN.
           MOVE 'PmtInf' TO PWXM-TAG.
      *    MOVE 'xmlns' TO PWXM-NATTR(1).
      *    MOVE 'urn:CBI:xsd:CBIPaymentRequest.00.03.09' 
      *         TO PWXM-VATTR(1).
           call 'vxml-wr' using parwxml.
      *
           MOVE 'PmtInfId' TO PWXM-TAG.
           MOVE NOMEFILE TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'PmtMtd' TO PWXM-TAG.
           MOVE 'TRF' TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
      * Inizio PmtTpInf
           MOVE '+'  TO PWXM-FUN.
           MOVE 'PmtTpInf' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'InstrPrty' TO PWXM-TAG.
           MOVE 'NORM' TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Inizio SvcLvl
           MOVE '+'  TO PWXM-FUN.
           MOVE 'SvcLvl' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'Cd' TO PWXM-TAG.
           MOVE 'SEPA' TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Fine SvcLvl
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      *
      * Fine PmtTpInf
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'ReqdExctnDt' TO PWXM-TAG.
           STRING AA4 '-' MM9 '-' GG9 DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Inizio Dbtr
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Dbtr' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'Nm' TO PWXM-TAG.
           MOVE AZI-RGSOC TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Fine Dbtr
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Inizio DbtrAcct
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DbtrAcct' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      * Inizio Id
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Id' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'IBAN' TO PWXM-TAG.
           MOVE IF-IBAN TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Fine Id
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Fine DbtrAcct
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Inizio DbtrAgt
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DbtrAgt' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      * Inizio FinInstnId
           MOVE '+'  TO PWXM-FUN.
           MOVE 'FinInstnId' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      * Inizio ClrSysMmbId
           MOVE '+'  TO PWXM-FUN.
           MOVE 'ClrSysMmbId' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'MmbId' TO PWXM-TAG.
           MOVE ABA-IBAN-ABI TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Fine ClrSysMmbId
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Fine FinInstnId
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Fine DbtrAgt
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'ChrgBr' TO PWXM-TAG.
           MOVE 'SLEV' TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE ZERO TO COMFOR COMDTV COMIBAN TOTDTV TOTGEN.

           MOVE SPACE TO DESCRI.
           MOVE ZERO TO CBAN1BON.
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID GO TO L091.
       L076.
           READ WDSLAV NEXT AT END GO TO L090.
           MOVE KAZ-COD TO KBF-AZI.
           MOVE ZERO    TO KBF-TIP.
           MOVE KWS-BAN TO KBF-BAN.
           MOVE KWS-DTS TO KBF-DTS.
           MOVE KWS-PGR TO KBF-PGR.
           READ BONFOR INVALID PERFORM INVK-BFO
                               GO TO ERRIO.
           IF CBAN1BON = ZERO MOVE BFO-BAF TO CBAN1BON.

           MOVE KBF-AZI TO KSC-AZI.
           MOVE 2       TO KSC-TIPO.
           MOVE KBF-DTS TO KSC-DTSCA.
           MOVE KBF-PGR TO KSC-PRG.
           READ ANASCA INVALID PERFORM INVK-SCA
                               GO TO ERRIO.
      *
           MOVE KAZ-COD   TO KCF-AZI.
           MOVE KWS-FOR   TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID PERFORM INVK-CLF
                                           GO TO ERRIO.
      *
           MOVE BFO-CIBAN TO CIBAN-2.
           ADD BFO-PAG TO TOTDTV TOTGEN.
           MOVE SCA-NDOC  TO CNDC1.
           MOVE SCA-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      *    PERFORM CAR-DESCRI THRU CAREX.
      *
           ADD 1 TO IF-CONT.
           MOVE TOTGEN TO IF-TOTGEN.
      *
      * Inizio CdtTrfTxInf
           MOVE '+'  TO PWXM-FUN.
           MOVE 'CdtTrfTxInf' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      * Inizio PmtId
           MOVE '+'  TO PWXM-FUN.
           MOVE 'PmtId' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'InstrId' TO PWXM-TAG.
           MOVE IF-CONT TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'EndToEndId' TO PWXM-TAG.
           MOVE IF-CONT TO PROG.
           STRING NOMEFILE '-' PROG DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Fine PmtId
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Inizio PmtTpInf
           MOVE '+'  TO PWXM-FUN.
           MOVE 'PmtTpInf' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      * Inizio CtgyPurp
           MOVE '+'  TO PWXM-FUN.
           MOVE 'CtgyPurp' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'Cd' TO PWXM-TAG.
           MOVE 'SUPP' TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Fine CtgyPurp
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Fine PmtTpInf
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Inizio Amt
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Amt' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'InstdAmt' TO PWXM-TAG.
           MOVE 'Ccy' TO PWXM-NATTR(1).
           MOVE 'EUR' TO PWXM-VATTR(1).
           MOVE BFO-PAG TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Fine Amt
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Inizio Cdtr
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Cdtr' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'Nm' TO PWXM-TAG.
           MOVE CLF-RGSOC TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Fine Cdtr
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Inizio CdtrAcct
           MOVE '+'  TO PWXM-FUN.
           MOVE 'CdtrAcct' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      * Inizio Id
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Id' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'IBAN' TO PWXM-TAG.
           MOVE KWS-IBAN TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Fine Id
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Fine CdtrAcct
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Inizio RmtInf
           MOVE '+'  TO PWXM-FUN.
           MOVE 'RmtInf' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'Ustrd' TO PWXM-TAG.
           MOVE  BFO-BAF TO NFAT.
           STRING 'PAGAMENTO FATTURA ' NFAT DELIMITED SIZE
                  INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Fine RmtInf
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Fine CdtTrfTxInf
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      *
           IF IF-TPTRA = ZERO GO TO L076.

           MOVE 1 TO BFO-FLTRAV.
           REWRITE RF-BFO INVALID PERFORM INVK-BFO
                                  GO TO ERRIO.
           GO TO L076.
       L090.
       L091.
      * Fine PmtInf
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Fine CBIBdyPaymentRequest
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'E'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      *
           COPY 'grirpt-r'.
      *
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       T-CIFRA.
           MOVE 1 TO K1.
           PERFORM UNTIL COMNUM(K1:1) NOT = ZERO
             ADD 1 TO K1. 
           IF K1 > 10
              MOVE 10 TO K1. 
       EX-T-CIFRA.
           EXIT.
      *------------------
