       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCDC140.
      *
      *    Tabulato per centri di costo
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'grimovsl'.
           COPY 'grimvxsl'.
           COPY 'gricdcsl'.
           COPY 'gritrtsl'.
           COPY 'gritrrsl'.
           COPY 'gripfcsl'.
           COPY 'gritabsl'.
           COPY 'griclfsl'.
           COPY 'grimlisl'.
      *
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
      *
           SELECT WDSLA2 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL2 STATUS SF-LA2.
           SELECT WDSLA3 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL3 STATUS SF-LA3.
           SELECT WDSLA4 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL4 STATUS SF-LA4.
           SELECT WDSLA5 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL5 STATUS SF-LA5.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'grimov'.
           COPY 'grimvx'.
           COPY 'gricon'.
           COPY 'gricdc'.
           COPY 'gritrt'.
           COPY 'gritrr'.
           COPY 'gripfc'.
           COPY 'gritab'.
           COPY 'griclf'.
           COPY 'grimli'.
      *
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 56 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
              10 KLV-COM  PIC X(4).
              10 KLV-CON  PIC 9(7).
           05 RECLAV.
              10 LAV-PPRE  PIC S9(15)V99.
              10 LAV-DARE  PIC S9(15)V99.
              10 LAV-AVER  PIC S9(15)V99.
      *
       FD  WDSLA2 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA2
           RECORD 8 DATA RECORD RF-LA2.
       01  RF-LA2.
           05 KEYL2.
              10 KL2-COM   PIC X(4).
           05 RECLA2.
              10 LA2-PADRE PIC X(4).

       FD  WDSLA3 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA3
           RECORD 87 DATA RECORD RF-LA3.
       01  RF-LA3.
           05 KEYL3.
              10 KL3-COM   PIC X(4).
              10 KL3-CON   PIC 9(7).
              10 KL3-NDOC  PIC 9(5).
              10 KL3-DTDOC PIC 9(5).
              10 KL3-PRG   PIC 9(5).
           05 RECLA3.
              10 LA3-IMPOD PIC S9(11)V99.
              10 LA3-IMPOA PIC S9(11)V99.
              10 LA3-CDFOR PIC X(30).
              10 LA3-NPRGI PIC 9(5).

       FD  WDSLA4 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA4
           RECORD 7 DATA RECORD RF-LA4.
       01  RF-LA4.
           05 KEYL4.
              10 KL4-AZI   PIC 999. 
              10 KL4-CDCOS PIC X(4).

       FD  WDSLA5 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA5
           RECORD 90 DATA RECORD RF-LA5.
       01  RF-LA5.
           05 KEYL5.
              10 KL5-COM   PIC X(4).
              10 KL5-CON   PIC 9(7).
              10 KL5-PRG   PIC 9(3).
           05 RECLA5.
              10 LA5-DARE  PIC S9(11)V99.
              10 LA5-AVERE PIC S9(11)V99.
              10 LA5-DESCR PIC X(50).
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griconrk'.
           COPY 'gritabrk'.
           COPY 'griazirk'.
           COPY 'grimovrk'.
           COPY 'griclfrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-CDC PIC X(15) VALUE 'cdcost'.
       01  ID-TRT PIC X(15) VALUE 'tabrit'.
       01  ID-TRR PIC X(15) VALUE 'tabrir'.
       01  ID-PFC PIC X(15) VALUE 'dbpfc'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  ID-LA2 PIC X(15) VALUE 'wdsla2'.
       01  ID-LA3 PIC X(15) VALUE 'wdsla3'.
       01  ID-LA4 PIC X(15) VALUE 'wdsla4'.
       01  ID-LA5 PIC X(15) VALUE 'wdsla5'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-MLI PIC X(15) VALUE 'movlib'.
       01  ID-AZI PIC X(15).
       01  ID-TAB PIC X(15).
       01  ID-MOV PIC X(40).
       01  ID-MVX PIC X(40).
       01  ID-CON PIC X(15).
       01  COMODI.
           05 SF-CDC  PIC XX.
           05 SF-TRT  PIC XX.
           05 SF-TRR  PIC XX.
           05 SF-PFC  PIC XX.
           05 SF-LAV  PIC XX.
           05 SF-LA2  PIC XX.
           05 SF-LA3  PIC XX.
           05 SF-LA4  PIC XX.
           05 SF-LA5  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-MLI  PIC XX.
           05 SF-AZI  PIC XX.
           05 SF-CON  PIC XX.
           05 SF-TAB  PIC XX.
           05 SF-MOV  PIC XX.
           05 SF-MVX  PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 COMC     PIC X(4).
           05 SAVCOM   PIC X(4).
           05 TOTCOE   PIC 9(11)V9999 VALUE ZERO.
           05 CONCOE   PIC 9(11)V9999 VALUE ZERO.
           05 FLGUNO   PIC 9.
           05 CONTI    PIC 9.
           05 CONTO    PIC 9.
           05 CCOSI    PIC X(4).
           05 CCOSO    PIC X(4).
           05 CODCEN   PIC X(4).
           05 K        PIC 99.
           05 J        PIC 99.
           05 LIVEL    PIC 99.
           05 MAXLIV   PIC 99 VALUE 20.
           05 PKDT1    PIC 9(5)   COMP-3.
           05 PKDT2    PIC 9(5)   COMP-3.
           05 SAV-IMPO PIC S9(11)V99 COMP-3.
           05 SAVIMPO  PIC S9(11)V99 COMP-3.
           05 SAVKEY   PIC X(13) OCCURS 20.
           05 TOTALI  OCCURS 21.
              10 TOTPRE PIC S9(11)V99.
              10 TOTDAR PIC S9(11)V99.
              10 TOTAVE PIC S9(11)V99.
              10 TOTSAL PIC S9(11)V99.
           05 TABP.
              10 TP PIC X(4) OCCURS 16.
           05 SAVCOST  PIC X(4).
           05 CLVD     PIC S9(13)V99 VALUE ZERO.
           05 CLVA     PIC S9(13)V99 VALUE ZERO.
           05 PROGR    PIC 9(5) VALUE ZERO.
           05 RG.
              10 RCOM  PIC X(4).
              10 FILLER PIC X.
              10 RDCOM PIC X(31).

           COPY 'vcdc140.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-CCOST     PIC X(4).
           05 IF-CCOST-D   PIC X(30).
           05 IF-DATA-1    PIC 9(6).
           05 IF-DATA-2    PIC 9(6).
           05 IF-TPLIV     PIC 9.
           05 IF-TPSTA     PIC 9.
           05 IF-FLRIM     PIC 9.
           05 IF-DTELA     PIC 9(6).
           05 IF-CCOST2    PIC X(4).
           05 IF-CCOST2-D  PIC X(30).
           05 IF-FLEXT     PIC 9.
           05 IF-TPEXT     PIC 9.
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclcon'.
           COPY 'dclazi'.
           COPY 'dclmov'.
           COPY 'dclmvx'.
           COPY 'dcltab'.
           COPY 'dclcdc'.
           COPY 'dcltrt'.
           COPY 'dcltrr'.
           COPY 'dclpfc'.
           COPY 'dcllav'.
           COPY 'dclla2'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcdc140: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANACON.
           CLOSE CDCOST.
           CLOSE DBPFC.
           CLOSE TABRIT.
           CLOSE TABRIR.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE WDSLAV.
           CLOSE WDSLA2.
           OPEN OUTPUT WDSLAV WDSLA2.
           CLOSE WDSLAV WDSLA2.
           CLOSE WDSLA3 WDSLA4 WDSLA5.
           OPEN OUTPUT WDSLA3 WDSLA4 WDSLA5.
           CLOSE WDSLA3 WDSLA4 WDSLA5.
           CLOSE ANACLF.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griconer'.
           COPY 'griazier'.
           COPY 'grimover'.
           COPY 'grimvxer'.
           COPY 'gritaber'.
           COPY 'gricdcer'.
           COPY 'gritrter'.
           COPY 'gritrrer'.
           COPY 'gripfcer'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV WDSLA2.
           CLOSE WDSLAV WDSLA2.
           OPEN OUTPUT WDSLA3 WDSLA4 WDSLA5.
           CLOSE WDSLA3 WDSLA4 WDSLA5.
      *
           IF IF-FL = ZERO
              MOVE 'anaazi' TO ID-AZI
              MOVE 'anacon' TO ID-CON
              MOVE 'movime' TO ID-MOV
              MOVE 'movmxx' TO ID-MVX
              MOVE 'anaclf' TO ID-CLF
              MOVE 'movlib' TO ID-MLI
              MOVE 'tabell' TO ID-TAB
           ELSE
              MOVE 'anazol' TO ID-AZI
              MOVE 'movmol' TO ID-MOV
              MOVE 'movoxx' TO ID-MVX
              MOVE 'tabold' TO ID-TAB
              MOVE 'anacfx' TO ID-CLF
              MOVE 'movlix' TO ID-MLI
              MOVE 'anacol' TO ID-CON.
      *
           OPEN INPUT ANAAZI TABELL.
           OPEN I-O WDSLAV.
           OPEN I-O WDSLA2.
           OPEN I-O WDSLA3 WDSLA4 WDSLA5.
           OPEN INPUT ANACLF.
           OPEN INPUT ANACON CDCOST TABRIT TABRIR DBPFC.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DTELA.
      *
           MOVE AZRGSOC TO IF-AZI-D.
      *
           MOVE SPACE  TO IF-CCOST
                          IF-CCOST-D.
           MOVE SPACE  TO IF-CCOST2
                          IF-CCOST2-D.
           MOVE 1      TO IF-FLEXT.
           MOVE ZERO   TO IF-TPEXT.
           MOVE ZERO   TO IF-DATA-1
                          IF-DATA-2
                          IF-TPLIV
                          IF-FLRIM.
           MOVE 1      TO IF-TPSTA.
      *
           MOVE ZERO TO PKDT1
                        PKDT2.
           MOVE IF-AZI TO KCD-AZI.
           MOVE SPACE TO KCD-COD.
           START CDCOST KEY NOT < KEYCD INVALID GO TO EX-INI-CAMPI.
           READ CDCOST NEXT AT END GO TO EX-INI-CAMPI.
           IF KCD-AZI NOT = IF-AZI GO TO EX-INI-CAMPI.
           MOVE KCD-COD TO IF-CCOST.
           MOVE CDC-DESCR TO IF-CCOST-D.
           MOVE IF-AZI TO KCD-AZI.
           MOVE HIGH-VALUE TO KCD-COD.
           START CDCOST KEY NOT > KEYCD INVALID GO TO EX-INI-CAMPI.
           READ CDCOST PREVIOUS AT END GO TO EX-INI-CAMPI.
           IF KCD-AZI NOT = IF-AZI GO TO EX-INI-CAMPI.
           MOVE KCD-COD TO IF-CCOST2.
           MOVE CDC-DESCR TO IF-CCOST2-D.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-CCOST.
           MOVE 'IF-CCOST' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CCOST.
           MOVE SPACE TO IF-CCOST-D.
           MOVE IF-CCOST TO CODCEN.
           CALL 'rcart4' USING CODCEN.
           MOVE CODCEN TO IF-CCOST.
           MOVE IF-AZI   TO KCD-AZI.
           MOVE IF-CCOST TO KCD-COD.
           READ CDCOST INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           MOVE CDC-DESCR TO IF-CCOST-D.
       E-CCOST.
      *
       V-CCOST2.
           MOVE 'IF-CCOST2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CCOST2.
           MOVE SPACE TO IF-CCOST2-D.
           MOVE IF-CCOST2 TO CODCEN.
           CALL 'rcart4' USING CODCEN.
           MOVE CODCEN TO IF-CCOST2.
           MOVE IF-AZI   TO KCD-AZI.
           MOVE IF-CCOST2 TO KCD-COD.
           READ CDCOST INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           MOVE CDC-DESCR TO IF-CCOST2-D.
           IF IF-CCOST2 < IF-CCOST PERFORM ERR-DINC
                                   GO TO V-ERROR.
       E-CCOST2.
      *
       V-DATA-1.
           MOVE 'IF-DATA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKDT1.
           IF PKDT1 < AZI-DTAPE
              MOVE 'Data inferiore alla data apertura' TO MESS
              GO TO V-ERROR.
       E-DATA-1.
      *
       V-DATA-2.
           MOVE 'IF-DATA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKDT2.
           IF PKDT2 < PKDT1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DATA-2.
      *
       V-TPLIV.
           MOVE 'IF-TPLIV' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPLIV.
           IF NOT (IF-TPLIV = ZERO OR 1)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-TPLIV.
      *
       V-TPSTA.
           MOVE 'IF-TPSTA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPSTA.
           IF NOT (IF-TPSTA = ZERO OR 1)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-TPSTA.
      *
       V-DTELA.
           MOVE 'IF-DTELA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTELA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTELA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTELA.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
      * scrive wdsla4 con centri di costo da considerare
           PERFORM SCRIVI-LA4 THRU EX-SCRIVI-LA4.
      * scrive wdsla2 con centri di costo da considerare
           PERFORM A00 THRU END-LA4.
      * elaborazione
           OPEN INPUT MOVIME MOVMXX.
           PERFORM C00 THRU C99.
           CLOSE MOVIME MOVMXX.
           IF IF-FLEXT = 1
              OPEN INPUT MOVLIB
              PERFORM MOV-EXTRA THRU END-MOV-EXTRA
              CLOSE MOVLIB.
      * fase di stampa
       LFL1.
           MOVE ZERO TO XCRR.
      *
           MOVE IF-DTELA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO TDATEL.
      *
           MOVE IF-DATA-1 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO TDAT1.
      *
           MOVE IF-DATA-2 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO TDAT2.
      *
           MOVE AZRGSOC TO TAZI.

      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 1       TO NINT.
           MOVE 1       TO LMOD.
           MOVE C-TINT1 TO XTINT(1).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'TABULATO SITUAZIONE C/COSTO DAL ' 
                  TDAT1  'AL ' TDAT2 '  -  '   TDATEL 
                 DELIMITED SIZE INTO RP-TIT1.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG1-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
 
           MOVE LOW-VALUE TO KEYL4.
           START WDSLA4 KEY > KEYL4 INVALID GO TO END-LOOP.
       RDNEXT.
           READ WDSLA4 NEXT AT END GO TO END-LOOP.
           IF SF-LA4 = '9D' OR '9A' OR '35' GO TO RDNEXT.
           MOVE 1 TO LIVEL.
           PERFORM UNTIL LIVEL > 21
              MOVE ZERO TO TOTPRE(LIVEL)
                           TOTDAR(LIVEL)
                           TOTAVE(LIVEL)
                           TOTSAL(LIVEL)
              ADD 1 TO LIVEL
           END-PERFORM.
      *
           MOVE ZERO TO LIVEL.
           MOVE KL4-CDCOS TO KPFC-PRF SAVCOM.
           PERFORM STAMPA-CENTRO THRU EX-STAMPA-CENTRO.
       STDB.
           MOVE LOW-VALUE TO KEYPFC.
           MOVE KAZ-COD   TO KPFC-AZI.
           MOVE SAVCOM    TO KPFC-PRP.
           START DBPFC KEY NOT < KEYPFC INVALID GO TO RISALI.
       LOOPDB.
           READ DBPFC NEXT AT END GO TO RISALI.
           IF SF-PFC = '9A' OR '9D' OR '35' GO TO LOOPDB.
           IF KPFC-AZI > KAZ-COD GO TO RISALI.
           IF KPFC-PRP > SAVCOM  GO TO RISALI.
           IF KPFC-PRF = SPACE   GO TO LOOPDB.
           IF IF-TPLIV = ZERO AND LIVEL = 1 GO TO RISALI.
           IF LIVEL = MAXLIV MOVE 'OVF LIVELLI' TO MESS
                             GO TO ERRIO.
           ADD 1 TO LIVEL.
           MOVE KEYPFC TO SAVKEY(LIVEL).
           MOVE KPFC-PRF TO SAVCOM.
           PERFORM STAMPA-CENTRO THRU EX-STAMPA-CENTRO.
           GO TO STDB.
       RISALI.
           IF LIVEL = 0 GO TO END-DISTINTA.
           MOVE SAVKEY(LIVEL) TO KEYPFC.
           READ DBPFC INVALID PERFORM INVK-PFC
                              GO TO ERRIO.
           IF NOT (IF-TPSTA = 1 AND IF-TPLIV = ZERO)
              PERFORM STAMPA-TOTALE THRU EX-STAMPA-TOTALE
           ELSE
              ADD TOTPRE(LIVEL + 1) TO TOTPRE(LIVEL)
              ADD TOTDAR(LIVEL + 1) TO TOTDAR(LIVEL)
              ADD TOTAVE(LIVEL + 1) TO TOTAVE(LIVEL)
              ADD TOTSAL(LIVEL + 1) TO TOTSAL(LIVEL)
              MOVE ZERO TO TOTPRE(LIVEL + 1) TOTDAR(LIVEL + 1) 
                           TOTAVE(LIVEL + 1) TOTSAL(LIVEL + 1).
           MOVE KPFC-PRP TO SAVCOM.
           SUBTRACT 1 FROM LIVEL.
           GO TO LOOPDB.
       END-DISTINTA.
           MOVE KL4-CDCOS TO KPFC-PRF.
           PERFORM STAMPA-TOTALE THRU EX-STAMPA-TOTALE.
      *
           COPY 'grirpt-r'.
      *
           GO TO RDNEXT.
       END-LOOP.
           PERFORM RPT-CL.
      *
      *------------------
      * elimina sort
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID GO TO X20.
       X10.
           READ WDSLAV NEXT AT END GO TO X20.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO X10.
           DELETE WDSLAV.
           GO TO X10.
       X20.
           MOVE LOW-VALUE TO KEYL2.
           START WDSLA2 KEY > KEYL2 INVALID GO TO X40.
       X30.
           READ WDSLA2 NEXT AT END GO TO X40.
           IF SF-LA2 = '9D' OR '9A' OR '35' GO TO X30.
           DELETE WDSLA2.
           GO TO X30.
       X40.
           MOVE LOW-VALUE TO KEYL3.
           START WDSLA3 KEY > KEYL3 INVALID GO TO X60.
       X50.
           READ WDSLA3 NEXT AT END GO TO X60.
           IF SF-LA3 = '9D' OR '9A' OR '35' GO TO X50.
           DELETE WDSLA3.
           GO TO X50.
       X60.
           MOVE LOW-VALUE TO KEYL4.
           START WDSLA4 KEY > KEYL4 INVALID GO TO X80.
       X70.
           READ WDSLA4 NEXT AT END GO TO X80.
           IF SF-LA4 = '9D' OR '9A' OR '35' GO TO X70.
           DELETE WDSLA4.
           GO TO X70.
       X80.
           MOVE LOW-VALUE TO KEYL5.
           START WDSLA5 KEY > KEYL5 INVALID GO TO X95.
       X90.
           READ WDSLA5 NEXT AT END GO TO X95.
           IF SF-LA5 = '9D' OR '9A' OR '35' GO TO X90.
           DELETE WDSLA5.
           GO TO X90.
       X95.
      *
      *------------------
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       C00.
           MOVE LOW-VALUE TO KEYMX.
           MOVE KAZ-COD TO KMX-AZI.
           MOVE ZERO    TO KMX-CON.
       C03.
           MOVE AZI-DTAPE TO KMX-DAT.
       C05.
           MOVE ZERO TO KMX-NUM.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO C40.
       C10.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO C40.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO C10.
           IF KMX-AZI > KAZ-COD GO TO C40.
           IF KMX-DAT > PKDT2
              MOVE 99999 TO KMX-DAT
              GO TO C05.
           IF KMX-DAT < AZI-DTAPE GO TO C03.
           IF KMX-DAT < PKDT1 AND IF-FLRIM = ZERO GO TO C10.
           IF MOV-CCOST = SPACE GO TO C10.
      *
           MOVE KMX-CON TO KPC-COD.
           MOVE KAZ-COD TO KPC-AZI.
           READ ANACON INTO REKCON INVALID MOVE ZERO TO CON-TRIP.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           IF CON-TRIP = ZERO 
              MOVE MOV-CCOST TO KL2-COM
              READ WDSLA2 INVALID GO TO C10
      * se nel centro di costo c'e' l codice della tabella di ripartizione
           ELSE
              PERFORM LEGGI-TABRIT THRU EX-LEGGI-TABRIT
              GO TO C10.
      * se nel centro di costo c'e' direttamente il codice del centro
           MOVE LA2-PADRE TO KLV-COM.
           IF IF-TPSTA = ZERO
              MOVE CON-COD TO KLV-CON
           ELSE
              MOVE ZERO    TO KLV-CON.
           PERFORM SCRIVI-LAV THRU EX-SCRIVI-LAV.
           GO TO C10.
      *
       C40.
           MOVE LOW-VALUE TO KEYMV.
           MOVE KAZ-COD TO KMV-AZI.
           MOVE ZERO    TO KMV-CON.
       C43.
           MOVE AZI-DTAPE TO KMV-DAT.
       C45.
           MOVE ZERO TO KMV-NUM.
           START MOVIME KEY NOT < KEYMV INVALID GO TO C99.
       C50.
           READ MOVIME NEXT INTO REKMOV AT END GO TO C99.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO C50.
           IF KMV-AZI > KAZ-COD GO TO C99.
           IF KMV-DAT > PKDT2
              MOVE 99999 TO KMV-DAT
              GO TO C45.
           IF KMV-DAT < AZI-DTAPE GO TO C43.
           IF KMV-DAT < PKDT1 AND IF-FLRIM = ZERO GO TO C50.
           IF MOV-CCOST = SPACE GO TO C50.
      *
           MOVE KMV-CON TO KPC-COD.
           MOVE KAZ-COD TO KPC-AZI.
           READ ANACON INTO REKCON INVALID MOVE ZERO TO CON-TRIP.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           IF CON-TRIP = ZERO 
              MOVE MOV-CCOST TO KL2-COM
              READ WDSLA2 INVALID GO TO C50
      * se nel centro di costo c'e' l codice della tabella di ripartizione
           ELSE
              PERFORM LEGGI-TABRIT THRU EX-LEGGI-TABRIT
              GO TO C50.
      * se nel centro di costo c'e' direttamente il codice del centro
           MOVE LA2-PADRE TO KLV-COM.
           IF IF-TPSTA = ZERO
              MOVE CON-COD TO KLV-CON
           ELSE
              MOVE ZERO    TO KLV-CON.
           PERFORM SCRIVI-LAV THRU EX-SCRIVI-LAV.
           GO TO C50.
       C99.
           EXIT.
      *------------------
       A00.
      * legge il file di sort wdsla4 con i centri di costo (da.. a..)
      * selezionati, e uno alla volta prosegue con l'elaborazione.
           MOVE SPACE TO SAVCOST.
           MOVE LOW-VALUE TO KEYL4.
           START WDSLA4 KEY > KEYL4 INVALID GO TO END-LA4.
       RD4.
           READ WDSLA4 NEXT AT END GO TO END-LA4.
           IF SF-LA4 = '9D' OR '9A' OR '35' GO TO RD4.

           MOVE KL4-CDCOS TO KL2-COM.
           READ WDSLA2 NOT INVALID GO TO RD4.
           MOVE KL4-CDCOS TO SAVCOST.

      * scrivi nel wdsla2 i centri di costo da considerare,
      * controllando la distinta del centro richiesto
           MOVE KAZ-COD  TO KPFC-AZI.
           MOVE SAVCOST  TO KPFC-PRP.
           MOVE SPACE    TO KPFC-PRF.
           MOVE ZERO    TO K.
           START DBPFC KEY NOT < KEYPFC INVALID KEY GO TO A98.
       LRDE.
           READ DBPFC NEXT AT END GO TO A98.
           IF SF-PFC = '9D' OR '9A' OR '35' GO TO LRDE. 
           IF KPFC-AZI > KAZ-COD  GO TO A98.
           IF KPFC-PRP > SAVCOST  GO TO A98.
           MOVE KPFC-PRP TO KL2-COM LA2-PADRE.
           WRITE RF-LA2.
       LP1.
           ADD 1 TO K.
           IF K > 16 GO TO A99.
           MOVE KPFC-PRP TO TP(K).
       LPRD. 
           READ DBPFC NEXT AT END GO TO LCALC. 
           IF SF-PFC = '9D' OR '9A' OR '35' GO TO LPRD.
           IF KPFC-AZI > KAZ-COD GO TO LCALC.
           IF KPFC-PRP = TP(K)   GO TO STLV.
       LCALC.
           MOVE TP (K) TO KPFC-PRF.
           SUBTRACT 1 FROM K.
           IF K = ZERO GO TO A99.
           MOVE TP (K) TO KPFC-PRP.
           MOVE KAZ-COD TO KPFC-AZI.
           START DBPFC KEY > KEYPFC INVALID KEY GO TO LCALC.
           GO TO LPRD.
       STLV.
           PERFORM WRITE-LA2 THRU EX-WRITE-LA2.
           MOVE KPFC-PRF TO KPFC-PRP COMC.
           MOVE SPACE    TO KPFC-PRF.
           MOVE KAZ-COD  TO KPFC-AZI.
           START DBPFC KEY NOT < KEYPFC INVALID KEY GO TO ENRD.
       L19D.
           READ DBPFC NEXT AT END GO TO ENRD. 
           IF SF-PFC = '9D' OR '9A' OR '35' GO TO L19D.
           IF KPFC-AZI > KAZ-COD GO TO ENRD.
           IF KPFC-PRP = COMC
              MOVE ZERO TO J
              GO TO LOOP.
           PERFORM WRITE-LA2 THRU EX-WRITE-LA2.
       ENRD.
           MOVE TP(K)   TO KPFC-PRP.
           MOVE COMC    TO KPFC-PRF.
           MOVE KAZ-COD TO KPFC-AZI.
           START DBPFC KEY > KEYPFC INVALID KEY GO TO LCALC.
           GO TO LPRD.
       LOOP.
           ADD 1 TO J.
           IF J > K GO TO LP1.
           IF TP(J) NOT = KPFC-PRP GO TO LOOP.
           GO TO A99.
       A98.
           MOVE SAVCOST  TO KL2-COM.
           READ WDSLA2 NOT INVALID GO TO A99.
           MOVE SAVCOST  TO KL2-COM LA2-PADRE.
           WRITE RF-LA2.
       A99.
           GO TO RD4.
       END-LA4.
           EXIT.
      *------------------
       LEGGI-TABRIT.
      * controlla se esiste la tabella di ripartizione
           MOVE KAZ-COD   TO KTRT-AZI.
           MOVE MOV-CCOST TO KTRT-COD.
           READ TABRIT INVALID GO TO EX-LEGGI-TABRIT.
      * calcola il totale della tabella per determinare i coefficienti
           IF TRT-TIPCO = 'C' 
              PERFORM CALCOLA-TOTALE THRU EX-CALCOLA-TOTALE
              MOVE TOTCOE   TO CONCOE
              MOVE MOV-IMPO TO SAVIMPO.
      * passa tutta la tabella per leggere i coefficienti del centro
      * di costo  e dei suoi figli 
           MOVE KTRT-AZI  TO KTRR-AZI.
           MOVE KTRT-COD  TO KTRR-COD.
           MOVE LOW-VALUE TO KTRR-CDC.
           START TABRIR KEY NOT < KEYTRR INVALID GO TO EX-LEGGI-TABRIT.
       LEG01.
           READ TABRIR NEXT AT END GO TO EX-LEGGI-TABRIT.
           IF SF-TRR = '9D' OR '9A' OR '35' GO TO LEG01.
           IF KTRR-AZI > KTRT-AZI GO TO EX-LEGGI-TABRIT.
           IF KTRR-COD > KTRT-COD GO TO EX-LEGGI-TABRIT.
      *
           MOVE KAZ-COD   TO KTRR-AZI.
           MOVE MOV-CCOST TO KTRR-COD.
           MOVE KTRR-CDC  TO KTRR-CDC.
           READ TABRIR INVALID GO TO LEG01.
           MOVE MOV-IMPO TO SAV-IMPO.
           IF TRT-TIPCO = 'P' 
              COMPUTE MOV-IMPO = (MOV-IMPO * TRR-PERC) / 100.
           IF TRT-TIPCO = 'C'
              COMPUTE MOV-IMPO = MOV-IMPO * (TRR-COEFF / TOTCOE)
      * all'ultimo somma l'arrotondamento
              SUBTRACT TRR-COEFF FROM CONCOE
              SUBTRACT MOV-IMPO  FROM SAVIMPO
              IF CONCOE = ZERO
                 COMPUTE MOV-IMPO = MOV-IMPO + SAVIMPO.
      *
           MOVE KTRR-CDC TO KL2-COM.
           READ WDSLA2 INVALID MOVE SAV-IMPO TO MOV-IMPO
                               GO TO LEG01. 
           MOVE LA2-PADRE TO KLV-COM.
           IF IF-TPSTA = ZERO
              MOVE CON-COD TO KLV-CON
           ELSE
              MOVE ZERO    TO KLV-CON.
           PERFORM SCRIVI-LAV THRU EX-SCRIVI-LAV.
           MOVE SAV-IMPO TO MOV-IMPO.
           GO TO LEG01.
       EX-LEGGI-TABRIT.
           EXIT.
      *------------------
       CALCOLA-TOTALE.
      * totale tabella di ripartizione per calcolo coefficienti
           MOVE ZERO TO TOTCOE.
           MOVE KTRT-AZI  TO KTRR-AZI.
           MOVE KTRT-COD  TO KTRR-COD.
           MOVE LOW-VALUE TO KTRR-CDC.
           START TABRIR KEY NOT < KEYTRR INVALID 
                 GO TO EX-CALCOLA-TOTALE.
       CAL01.
           READ TABRIR NEXT AT END GO TO EX-CALCOLA-TOTALE.
           IF SF-TRR = '9D' OR '9A' OR '35' GO TO CAL01.
           IF KTRR-AZI > KTRT-AZI GO TO EX-CALCOLA-TOTALE.
           IF KTRR-COD > KTRT-COD GO TO EX-CALCOLA-TOTALE.
           COMPUTE TOTCOE = TOTCOE + TRR-COEFF. 
           GO TO CAL01.
       EX-CALCOLA-TOTALE.
           EXIT.
      *------------------
       SCRIVI-LAV.
      * scrittura file di sort
           READ WDSLAV INVALID
                MOVE ZERO TO RECLAV.
           IF NOT (MOV-DAT < PKDT1)
              IF MOV-D-A = 'D'
                 ADD MOV-IMPO TO LAV-DARE
              ELSE
                 ADD MOV-IMPO TO LAV-AVER
           ELSE 
              IF MOV-D-A = 'D'
                 ADD MOV-IMPO TO LAV-PPRE
              ELSE
                 SUBTRACT MOV-IMPO FROM LAV-PPRE.
           IF SF-LAV = ZERO
              REWRITE RF-LAV INVALID MOVE 'RW LAV' TO MESS
                                     GO TO ERRIO. 
           IF SF-LAV > ZERO
              WRITE RF-LAV INVALID MOVE 'WR LAV' TO MESS
                                   GO TO ERRIO.                   
           MOVE LOW-VALUE TO KEYL3.
           MOVE KLV-COM   TO KL3-COM.
           MOVE KLV-CON   TO KL3-CON.
           MOVE MOV-NDOC  TO KL3-NDOC.
           MOVE MOV-DTDOC TO KL3-DTDOC.
           MOVE ZERO      TO KL3-PRG PROGR.
           START WDSLA3 KEY NOT < KEYL3 INVALID GO TO NORIG.
       RD-LA3.
           READ WDSLA3 NEXT AT END GO TO NORIG.
           IF SF-LA3 = '9D' OR '9A' OR '35' GO TO RD-LA3.
           IF KL3-COM   > KLV-COM   GO TO NORIG.
           IF KL3-CON   > KLV-CON   GO TO NORIG.
           IF KL3-NDOC  > MOV-NDOC  GO TO NORIG.
           IF KL3-DTDOC > MOV-DTDOC GO TO NORIG.
           MOVE KL3-PRG TO PROGR.
           GO TO RD-LA3.
       NORIG.
           ADD 1 TO PROGR.

           MOVE KLV-COM   TO KL3-COM. 
           MOVE KLV-CON   TO KL3-CON. 
           MOVE MOV-NDOC  TO KL3-NDOC.
           MOVE MOV-DTDOC TO KL3-DTDOC.
           MOVE PROGR     TO KL3-PRG.
           READ WDSLA3 INVALID MOVE ZERO  TO RECLA3
                               MOVE SPACE TO LA3-CDFOR.
           IF MOV-TREG = 1 MOVE MOV-DSAGG TO LA3-CDFOR
                           GO TO NO-CLFO.
           MOVE KAZ-COD  TO KCF-AZI.
           MOVE MOV-PART TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID MOVE SPACE TO CLF-RGSOC.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           MOVE CLF-RGSOC TO LA3-CDFOR.
       NO-CLFO.
           MOVE MOV-NPRGI TO LA3-NPRGI.

           IF MOV-D-A = 'D'
              MOVE MOV-IMPO TO LA3-IMPOD
           ELSE
              MOVE MOV-IMPO TO LA3-IMPOA.
           IF SF-LA3 = ZERO
              REWRITE RF-LA3 INVALID MOVE 'RW LA3' TO MESS
                                     GO TO ERRIO. 
           IF SF-LA3 > ZERO
              WRITE RF-LA3 INVALID MOVE 'WR LA3' TO MESS
                                   GO TO ERRIO.                   
       EX-SCRIVI-LAV.
           EXIT.
      *------------------
       WRITE-LA2.
           IF KPFC-PRF = SPACE GO TO EX-WRITE-LA2.
           IF IF-TPLIV = 1 OR KPFC-PRP = SAVCOST  
              MOVE KPFC-PRF TO LA2-PADRE
              GO TO WRLA2.
           MOVE KPFC-PRP TO LA2-PADRE.
       RDPAD.
           MOVE LA2-PADRE TO KL2-COM.
           READ WDSLA2 INVALID MOVE 'RD LA2' TO MESS
                               GO TO ERRIO.
           IF LA2-PADRE NOT = KL2-COM GO TO RDPAD.

           MOVE KL2-COM  TO LA2-PADRE.
       WRLA2.
           MOVE KPFC-PRF TO KL2-COM.
           WRITE RF-LA2.
       EX-WRITE-LA2.
           EXIT.
      *------------------
       STAMPA-CENTRO.
           MOVE ZERO TO FLGUNO.
           MOVE LOW-VALUE TO KEYLV.
           MOVE KPFC-PRF  TO KLV-COM.
           PERFORM VALORIZZA-CENTRO THRU EX-VALORIZZA-CENTRO.
           START WDSLAV KEY > KEYLV INVALID GO TO S99.
       S10.
           READ WDSLAV NEXT AT END GO TO S99.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO S10.
           IF KPFC-PRF NOT = KLV-COM GO TO S99.
           IF KLV-CON = ZERO GO TO NOCON.
           MOVE KAZ-COD TO KPC-AZI.
           MOVE KLV-CON TO KPC-COD RCON.
           READ ANACON INVALID MOVE ZERO TO CON-DSC.
           MOVE CON-DSC TO RDCON.
       NOCON.
           IF IF-FLRIM = 1 MOVE LAV-PPRE TO RPPRE.
           MOVE LAV-DARE TO RDARE.
           MOVE LAV-AVER TO RAVER.
           ADD LAV-PPRE TO TOTPRE(LIVEL + 1).
           ADD LAV-DARE TO TOTDAR(LIVEL + 1).
           ADD LAV-AVER TO TOTAVE(LIVEL + 1).
           COMPUTE RSALD = LAV-PPRE + LAV-DARE - LAV-AVER.
           COMPUTE TOTSAL(LIVEL + 1) = TOTSAL(LIVEL + 1) + LAV-PPRE + 
                                       LAV-DARE - LAV-AVER.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           IF IF-TPSTA = ZERO
              PERFORM STAMPA-DOCUMENTI THRU EX-STAMPA-DOCUMENTI
              MOVE 2 TO XCRR.
           IF IF-TPSTA = ZERO AND
              IF-FLEXT = 1
              PERFORM STAMPA-MOV-EXTRA THRU EX-STAMPA-MOV-EXTRA
              MOVE 2 TO XCRR.
           MOVE 1 TO FLGUNO.
           GO TO S10.
       S99.
           IF FLGUNO = ZERO MOVE 'RIG1' TO RP-BLK
                            PERFORM RPT-WR
                            MOVE 1 TO XCRR.
       EX-STAMPA-CENTRO.
           EXIT.
      *------------------
       STAMPA-TOTALE.
           IF TOTPRE(LIVEL + 1) = ZERO AND TOTDAR(LIVEL + 1) = ZERO AND
              TOTAVE(LIVEL + 1) = ZERO AND TOTSAL(LIVEL + 1) = ZERO
              GO TO EX-STAMPA-TOTALE.
           IF LIVEL NOT = ZERO
              MOVE ALL '-' TO RTTRAT1 RTTRAT2 RTTRAT3 RTTRAT4
           ELSE
              MOVE ALL '=' TO RTTRAT1 RTTRAT2 RTTRAT3 RTTRAT4.
           MOVE 1 TO XCRR.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE KAZ-COD  TO KCD-AZI.
           MOVE KPFC-PRF TO KCD-COD.
           READ CDCOST INVALID MOVE ALL'*' TO CDC-DESCR.
           STRING 'TOTALE ' , KCD-COD , ' ' , CDC-DESCR
                  DELIMITED SIZE INTO RTDCON.
           IF IF-FLRIM = 1 MOVE TOTPRE(LIVEL + 1) TO RTPPRE.
           MOVE TOTDAR(LIVEL + 1) TO RTDARE.
           MOVE TOTAVE(LIVEL + 1) TO RTAVER.
           MOVE TOTSAL(LIVEL + 1) TO RTSALD.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
           IF LIVEL = 0 GO TO NOADD.
           ADD TOTPRE(LIVEL + 1) TO TOTPRE(LIVEL).
           ADD TOTDAR(LIVEL + 1) TO TOTDAR(LIVEL).
           ADD TOTAVE(LIVEL + 1) TO TOTAVE(LIVEL).
           ADD TOTSAL(LIVEL + 1) TO TOTSAL(LIVEL).
       NOADD.
           IF LIVEL NOT = ZERO
              MOVE ALL '-' TO RTTRAT1 RTTRAT2 RTTRAT3 RTTRAT4
           ELSE
              MOVE ALL '=' TO RTTRAT1 RTTRAT2 RTTRAT3 RTTRAT4.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ZERO TO TOTPRE(LIVEL + 1) TOTDAR(LIVEL + 1) 
                        TOTAVE(LIVEL + 1) TOTSAL(LIVEL + 1).
       EX-STAMPA-TOTALE.
           EXIT.
      *------------------
       VALORIZZA-CENTRO.
           MOVE KAZ-COD TO KCD-AZI.
           MOVE KLV-COM TO KCD-COD.
           READ CDCOST INVALID MOVE ALL '*' TO CDC-DESCR.
           MOVE KLV-COM TO CCOSI.
           PERFORM TOGLI-SPACE THRU EX-TOGLI-SPACE.
           IF LIVEL >= 0 AND LIVEL <=20
              PERFORM R-IND.
       EX-VALORIZZA-CENTRO.
           EXIT.
      *------------------
       R-IND.
           MOVE SPACE TO RGN.
           IF LIVEL > 0 MOVE ALL '-' TO RGN(1:LIVEL).
           MOVE CCOSO TO RCOM.
           MOVE CDC-DESCR TO RDCOM.
           MOVE RG TO RGN(LIVEL + 1:).
      *------------------
       TOGLI-SPACE.
           MOVE SPACE TO CCOSO.
           MOVE ZERO TO CONTI.
           MOVE 1 TO CONTO.
       TOGLI01.
           IF CONTI = 4 GO TO TOGLI02.
           ADD 1 TO CONTI.
           IF CCOSI(CONTI:1) = SPACE GO TO TOGLI01.
           MOVE CCOSI(CONTI:1) TO CCOSO(CONTO:1).
           ADD 1 TO CONTO.
           GO TO TOGLI01.
       TOGLI02.
       EX-TOGLI-SPACE.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV ID-LA2.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
           STRING 'w2' PID DELIMITED SPACE INTO ID-LA2.
           MOVE SPACE TO ID-LA3 ID-LA4 ID-LA5.
           STRING 'w9' PID DELIMITED SPACE INTO ID-LA3.
           STRING 'w8' PID DELIMITED SPACE INTO ID-LA4.
           STRING 'w7' PID DELIMITED SPACE INTO ID-LA5.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       STAMPA-DOCUMENTI.
           MOVE LOW-VALUE TO KEYL3.
           MOVE KLV-COM   TO KL3-COM.
           MOVE KLV-CON   TO KL3-CON.
           MOVE ZERO      TO KL3-NDOC.
           MOVE ZERO      TO KL3-DTDOC.
           MOVE ZERO      TO KL3-PRG.
           START WDSLA3 KEY NOT < KEYL3 INVALID
                                        GO TO EX-STAMPA-DOCUMENTI.
       S30.
           READ WDSLA3 NEXT AT END GO TO EX-STAMPA-DOCUMENTI.
           IF SF-LA3 = '9D' OR '9A' OR '35' GO TO S30.
           IF KL3-COM > KLV-COM GO TO EX-STAMPA-DOCUMENTI.
           IF KL3-CON > KLV-CON GO TO EX-STAMPA-DOCUMENTI.

           MOVE 'Prt.'    TO RDPRT.
           MOVE LA3-NPRGI TO RNPRGI.
           IF NOT (KL3-NDOC = ZERO AND KL3-DTDOC = ZERO)
              MOVE 'Doc.' TO RDNDOC
              MOVE 'del'  TO RDEL
           MOVE KL3-NDOC  TO RNDOC.
           MOVE KL3-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GMMMA     TO RDTDOC.

           IF LA3-IMPOD NOT = ZERO MOVE LA3-IMPOD TO RDAR1
                                   MOVE '(' TO RPAR1
                                   MOVE ')' TO RPAR2.
           IF LA3-IMPOA NOT = ZERO MOVE LA3-IMPOA TO RAVER1
                                   MOVE '(' TO RPAR3
                                   MOVE ')' TO RPAR4.
           MOVE LA3-CDFOR TO RDFORN.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           GO TO S30.
       EX-STAMPA-DOCUMENTI.
           EXIT.
      *------------------
       SCRIVI-LA4.
           MOVE KAZ-COD  TO KCD-AZI.
           MOVE IF-CCOST TO KCD-COD.
           START CDCOST KEY NOT < KEYCD INVALID GO TO EX-SCRIVI-LA4.
       LSTC.
           READ CDCOST NEXT AT END GO TO EX-SCRIVI-LA4.
           IF SF-CDC = '9D' OR '9A' OR '35' GO TO LSTC.
           IF KCD-AZI > KAZ-COD   GO TO EX-SCRIVI-LA4.
           IF KCD-COD > IF-CCOST2 GO TO EX-SCRIVI-LA4.
           MOVE KCD-AZI TO KL4-AZI.
           MOVE KCD-COD TO KL4-CDCOS.
           WRITE RF-LA4.
           GO TO LSTC.
       EX-SCRIVI-LA4.
           EXIT.
      *------------------
      *
      *> legge archivio movimenti extra-contabili x C/C
      *
       MOV-EXTRA.
           MOVE LOW-VALUE TO KEYMLI.
           MOVE KAZ-COD   TO KMLI-AZI.
           START MOVLIB KEY NOT < KEYMLI INVALID GO TO END-MOV-EXTRA.
       RD-EXT.
           READ MOVLIB NEXT AT END GO TO END-MOV-EXTRA.
           IF SF-MLI = '9D' OR '9A' OR '35' GO TO RD-EXT.
           IF KMLI-AZI > KAZ-COD GO TO END-MOV-EXTRA.
           IF MLI-DATA < AZI-DTAPE GO TO RD-EXT.
           IF MLI-DATA < PKDT1 AND IF-FLRIM = ZERO GO TO RD-EXT.
           IF MLI-DATA > PKDT2 GO TO RD-EXT.
           IF MLI-CCOST  = SPACE GO TO RD-EXT.
      * esclude movimenti extracontabili passati a movimento
      * contabile in data precedente

           IF MLI-VALID = 1 
              IF NOT MLI-DTVALID > PKDT2 
              GO TO RD-EXT.
      *
           MOVE KAZ-COD    TO KPC-AZI.
           MOVE KMLI-CONTO TO KPC-COD.
           READ ANACON INTO REKCON INVALID MOVE ZERO TO CON-TRIP.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           IF CON-TRIP = ZERO 
              MOVE MLI-CCOST TO KL2-COM
              READ WDSLA2 INVALID GO TO RD-EXT
      * se nel centro di costo c'e' l codice della tabella di ripartizione
           ELSE
              PERFORM LEGGI-TABRIT-EXT THRU EX-LEGGI-TABRIT-EXT
              GO TO RD-EXT.
      * se nel centro di costo c'e' direttamente il codice del centro
           MOVE LA2-PADRE TO KLV-COM.
           IF IF-TPSTA = ZERO
              MOVE CON-COD TO KLV-CON
           ELSE
              MOVE ZERO    TO KLV-CON.
           PERFORM SCRIVI-LAV-EXT THRU EX-SCRIVI-LAV-EXT.
           GO TO RD-EXT.
       END-MOV-EXTRA.
           EXIT.
      *------------------
       LEGGI-TABRIT-EXT.
      * controlla se esiste la tabella di ripartizione
           MOVE KAZ-COD   TO KTRT-AZI.
           MOVE MLI-CCOST TO KTRT-COD.
           READ TABRIT INVALID GO TO EX-LEGGI-TABRIT-EXT.
      * calcola il totale della tabella per determinare i coefficienti
           IF TRT-TIPCO = 'C' 
              PERFORM CALCOLA-TOTALE THRU EX-CALCOLA-TOTALE
              MOVE TOTCOE   TO CONCOE
              IF MLI-DARE NOT = ZERO MOVE MLI-DARE TO SAVIMPO
              ELSE MOVE MLI-AVERE TO SAVIMPO.
      * passa tutta la tabella per leggere i coefficienti del centro
      * di costo  e dei suoi figli 
           MOVE KTRT-AZI  TO KTRR-AZI.
           MOVE KTRT-COD  TO KTRR-COD.
           MOVE LOW-VALUE TO KTRR-CDC.
           START TABRIR KEY NOT < KEYTRR INVALID
                                         GO TO EX-LEGGI-TABRIT-EXT.
       LEG01-EXT.
           READ TABRIR NEXT AT END GO TO EX-LEGGI-TABRIT-EXT.
           IF SF-TRR = '9D' OR '9A' OR '35' GO TO LEG01-EXT.
           IF KTRR-AZI > KTRT-AZI GO TO EX-LEGGI-TABRIT-EXT.
           IF KTRR-COD > KTRT-COD GO TO EX-LEGGI-TABRIT-EXT.
      *
           MOVE KAZ-COD   TO KTRR-AZI.
           MOVE MLI-CCOST TO KTRR-COD.
           MOVE KTRR-CDC  TO KTRR-CDC.
           READ TABRIR INVALID GO TO LEG01-EXT.
           IF MLI-DARE NOT = ZERO MOVE MLI-DARE TO SAV-IMPO
           ELSE MOVE MLI-AVERE TO SAV-IMPO.
           IF TRT-TIPCO = 'P' 
              IF MLI-DARE NOT = ZERO
                 COMPUTE MLI-DARE = (MLI-DARE * TRR-PERC) / 100
              ELSE
                 COMPUTE MLI-AVERE = (MLI-AVERE * TRR-PERC) / 100.
           IF TRT-TIPCO = 'C'
              IF MLI-DARE NOT = ZERO
                 COMPUTE MLI-DARE = MLI-DARE * (TRR-COEFF / TOTCOE)
              ELSE
                 COMPUTE MLI-AVERE = MLI-AVERE * (TRR-COEFF / TOTCOE)
              END-IF
      * all'ultimo somma l'arrotondamento
              SUBTRACT TRR-COEFF FROM CONCOE
              IF MLI-DARE NOT = ZERO SUBTRACT MLI-DARE  FROM SAVIMPO
              ELSE SUBTRACT MLI-AVERE  FROM SAVIMPO
              END-IF
              IF CONCOE = ZERO
                 IF MLI-DARE NOT = ZERO
                    COMPUTE MLI-DARE = MLI-DARE + SAVIMPO
                 ELSE
                    COMPUTE MLI-AVERE = MLI-AVERE + SAVIMPO.
      *
           MOVE KTRR-CDC TO KL2-COM.
           READ WDSLA2 INVALID IF MLI-DARE NOT = ZERO
                                  MOVE SAV-IMPO TO MLI-DARE
                               ELSE
                                  MOVE SAV-IMPO TO MLI-AVERE
                               END-IF
                               GO TO LEG01-EXT. 
           MOVE LA2-PADRE TO KLV-COM.
           IF IF-TPSTA = ZERO
              MOVE CON-COD TO KLV-CON
           ELSE
              MOVE ZERO    TO KLV-CON.
           PERFORM SCRIVI-LAV-EXT THRU EX-SCRIVI-LAV-EXT.
           IF MLI-DARE NOT = ZERO MOVE SAV-IMPO TO MLI-DARE
           ELSE MOVE SAV-IMPO TO MLI-AVERE.
           GO TO LEG01-EXT.
       EX-LEGGI-TABRIT-EXT.
           EXIT.
      *------------------
       SCRIVI-LAV-EXT.
      * scrittura file di sort
           READ WDSLAV INVALID
                MOVE ZERO TO RECLAV.
           IF NOT (MLI-DATA < PKDT1)
              IF MLI-DARE NOT = ZERO
                 ADD MLI-DARE TO LAV-DARE
              ELSE
                 ADD MLI-AVERE TO LAV-AVER
           ELSE 
              IF MLI-DARE NOT = ZERO
                 ADD MLI-DARE TO LAV-PPRE
              ELSE
                 SUBTRACT MLI-AVERE FROM LAV-PPRE.
           IF SF-LAV = ZERO
              REWRITE RF-LAV INVALID MOVE 'RW LAV' TO MESS
                                     GO TO ERRIO. 
           IF SF-LAV > ZERO
              WRITE RF-LAV INVALID MOVE 'WR LAV' TO MESS
                                   GO TO ERRIO.                   
           MOVE KMLI-PRG  TO KL5-PRG.
           MOVE KLV-COM   TO KL5-COM. 
           MOVE KLV-CON   TO KL5-CON. 
           READ WDSLA5 INVALID MOVE ZERO  TO RECLA5
                               MOVE SPACE TO LA5-DESCR.
           MOVE MLI-DARE  TO LA5-DARE
           MOVE MLI-AVERE TO LA5-AVERE.
           MOVE MLI-DESCR TO LA5-DESCR.

           IF SF-LA5 = ZERO
              REWRITE RF-LA5 INVALID MOVE 'RW LA5' TO MESS
                                     GO TO ERRIO. 
           IF SF-LA5 > ZERO
              WRITE RF-LA5 INVALID MOVE 'WR LA5' TO MESS
                                   GO TO ERRIO.                   
       EX-SCRIVI-LAV-EXT.
           EXIT.
      *------------------
       STAMPA-MOV-EXTRA.
           MOVE ZERO TO CLVD CLVA.
           MOVE LOW-VALUE TO KEYL5.
           MOVE KLV-COM   TO KL5-COM.
           MOVE KLV-CON   TO KL5-CON.
           START WDSLA5 KEY NOT < KEYL5 INVALID
                                        GO TO EX-STAMPA-MOV-EXTRA.
       RDNX-EXT.
           READ WDSLA5 NEXT AT END GO TO END-EXT.
           IF SF-LA5 = '9D' OR '9A' OR '35' GO TO RDNX-EXT.
           IF KL5-COM > KLV-COM GO TO END-EXT.
           IF KL5-CON > KLV-CON GO TO END-EXT.

           IF IF-TPEXT = ZERO
              ADD LA5-DARE  TO CLVD
              ADD LA5-AVERE TO CLVA
              GO TO RDNX-EXT.

           MOVE LA5-DESCR TO RDESCR.
           STRING '(Extra-Cont.) ' , LA5-DESCR 
                  DELIMITED SIZE INTO RDESCR.

           IF LA5-DARE  NOT = ZERO MOVE LA5-DARE  TO RDAR1
                                   MOVE '(' TO RPAR1
                                   MOVE ')' TO RPAR2.
           IF LA5-AVERE NOT = ZERO MOVE LA5-AVERE TO RAVER1
                                   MOVE '(' TO RPAR3
                                   MOVE ')' TO RPAR4.
           MOVE 1 TO XCRR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           GO TO RDNX-EXT.
       END-EXT.
           IF IF-TPEXT NOT = ZERO GO TO EX-STAMPA-MOV-EXTRA.
           IF CLVD NOT = ZERO MOVE CLVD TO RDAR1
                              MOVE '('  TO RPAR1
                              MOVE ')'  TO RPAR2.
           IF CLVA NOT = ZERO MOVE CLVA TO RAVER1
                              MOVE '('  TO RPAR3
                              MOVE ')'  TO RPAR4.
           MOVE 'Movimenti extra-contabili x c/c' TO RDESCR.
           MOVE 1 TO XCRR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ZERO TO CLVD CLVA.
       EX-STAMPA-MOV-EXTRA.
           EXIT.
      *------------------
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'Centro di Costo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Contropartita' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Saldo Preced.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Dare' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Avere' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Saldo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
