       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCDC155.
      *
      *    Lista spunda budget
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'gritrtsl'.
           COPY 'gritrrsl'.
           COPY 'griacosl'.
           COPY 'griacxsl'.
           COPY 'gricdcsl'.
           COPY 'gritabsl'.
      *
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
           SELECT WDSLA2 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLA2 STATUS SF-LA2.

       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricon'.
           COPY 'gritrt'.
           COPY 'gritrr'.
           COPY 'gricdc'.
           COPY 'griaco'.
           COPY 'griacx'.
           COPY 'gritab'.

       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 197 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
              10 KLV-CON  PIC 9(7).
              10 KLV-TIP  PIC 9.
              10 KLV-COM  PIC X(4).
           05 RECLAV.
              10 LAV-PERC PIC 9(3)V99 COMP-3.
              10 LAV-BUD1  PIC S9(12)V99 COMP-3.
              10 LAV-BUDM1 PIC S9(11)V99 COMP-3 OCCURS 12.
              10 LAV-BUD2  PIC S9(12)V99 COMP-3.
              10 LAV-BUDM2 PIC S9(11)V99 COMP-3 OCCURS 12.

      * sort ripartizione centri di costo
       FD  WDSLA2 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA2
           RECORD 12 DATA RECORD RF-LA2.
       01  RF-LA2.
           05 KEYLA2.
              10 KL2-TTIP PIC X(3).
           05 LA2-TCOEFF  PIC 9(6)V999. 
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griconrk'.
           COPY 'gritabrk'.
           COPY 'griazirk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parrd'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
       01  ID-TRT PIC X(15) VALUE 'tabrit'.
       01  ID-TRR PIC X(15) VALUE 'tabrir'.
       01  ID-CDC PIC X(15) VALUE 'cdcost'.
       01  ID-ACO PIC X(15) VALUE 'appcon'.
       01  ID-ACX PIC X(15) VALUE 'appcol'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-LAV PIC X(15) VALUE SPACE.
       01  ID-LA2 PIC X(15) VALUE SPACE.
       01  COMODI.
           05 SF-CDC  PIC XX.
           05 SF-ACO  PIC XX.
           05 SF-ACX  PIC XX.
           05 SF-LAV  PIC XX.
           05 SF-LA2  PIC XX.
           05 SF-AZI  PIC XX.
           05 SF-CON  PIC XX.
           05 SF-TRT  PIC XX.
           05 SF-TRR  PIC XX.
           05 SF-TAB  PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 COMC     PIC X(4).
           05 SAVCOM   PIC X(4).
           05 K        PIC 99.
           05 J        PIC 99.
           05 CODCON   PIC 9(7).
           05 CODCEN   PIC X(4).
           05 COMTIP   PIC 9.
           05 MESE     PIC Z9.

           COPY 'vcdc155.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-CONTO-1   PIC 9(7).
           05 IF-CONTO-1-D PIC X(30).
           05 IF-CONTO-2   PIC 9(7).
           05 IF-CONTO-2-D PIC X(30).
           05 IF-TPSTA     PIC 9.
           05 IF-DTELA     PIC 9(6).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclcon'.
           COPY 'dcltrt'.
           COPY 'dcltrr'.
           COPY 'dclazi'.
           COPY 'dclaco'.
           COPY 'dclacx'.
           COPY 'dcltab'.
           COPY 'dclcdc'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcdc155: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANACON.
           CLOSE CDCOST.
           CLOSE APPCON.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE TABRIT.
           CLOSE TABRIR.
           IF IF-FL = ZERO
              CLOSE APPCOL.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           CLOSE WDSLA2.
           OPEN OUTPUT WDSLA2.
           CLOSE WDSLA2.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griconer'.
           COPY 'griazier'.
           COPY 'griacoer'.
           COPY 'griacxer'.
           COPY 'gritaber'.
           COPY 'gricdcer'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLA2.
           CLOSE WDSLA2.
           IF IF-FL = ZERO
              MOVE 'anaazi' to ID-AZI 
              MOVE 'tabell' to ID-TAB 
              MOVE 'anacon' to ID-CON 
              MOVE 'appcon' to ID-ACO 
              MOVE 'appcol' to ID-ACX 
              OPEN INPUT ANACON CDCOST APPCON APPCOL.
           IF IF-FL = 1   
              MOVE 'anazol' to ID-AZI 
              MOVE 'tabold' to ID-TAB 
              MOVE 'anacol' to ID-CON 
              MOVE 'appcol' to ID-ACO 
              OPEN INPUT ANACON CDCOST APPCON.
           OPEN INPUT ANAAZI TABELL TABRIT TABRIR CDCOST.
           OPEN I-O WDSLAV.
           OPEN I-O WDSLA2.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DTELA.
      *
           MOVE AZRGSOC TO IF-AZI-D.
      *
           MOVE ZERO   TO IF-CONTO-1.
           MOVE SPACE  TO IF-CONTO-1-D.
           MOVE 9999999 TO IF-CONTO-2.
           MOVE SPACE  TO IF-CONTO-2-D.
           MOVE ZERO   TO IF-TPSTA.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-CONTO-1.
           MOVE 'IF-CONTO-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CONTO-1.
           MOVE SPACE TO IF-CONTO-1-D.
           IF IF-CONTO-1 = ZERO
              GO TO E-CONTO-1.
           MOVE IF-AZI TO KPC-AZI.
           MOVE IF-CONTO-1 TO KPC-COD.
           READ ANACON INTO REKCON INVALID 
                MOVE ZERO TO IF-CONTO-1
                PERFORM ERR-CINE        
                GO TO V-ERROR.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-DSC TO IF-CONTO-1-D.
       E-CONTO-1.
       V-CONTO-2.
           MOVE 'IF-CONTO-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CONTO-2.
           MOVE SPACE TO IF-CONTO-2-D.
           IF IF-CONTO-2 = 9999999
              GO TO E-CONTO-2.
           MOVE IF-AZI TO KPC-AZI.
           MOVE IF-CONTO-2 TO KPC-COD.
           READ ANACON INTO REKCON INVALID 
                MOVE ZERO TO IF-CONTO-2
                PERFORM ERR-CINE        
                GO TO V-ERROR.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-DSC TO IF-CONTO-2-D.
           IF IF-CONTO-2 < IF-CONTO-1
                PERFORM ERR-DINC
                GO TO V-ERROR.
       E-CONTO-2.

       V-TPSTA-1.
           MOVE 'IF-TPSTA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPSTA-1.
           IF IF-FL = 1
           IF IF-TPSTA = 1
              MOVE 'NEL VECCHIO ESERCIZIO NON E'' POSSIBILE' TO F-MES1
              MOVE 'CONFRONTARE CON ANNO PRECEDENTE' TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
       E-TPSTA-1.
      *
       V-DTELA.
           MOVE 'IF-DTELA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTELA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTELA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTELA.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
      *
      * genera sort per totale coefficenti tabella ripartizione
           PERFORM CREA-WDSLA2 THRU EX-CREA-WDSLA2.

           MOVE IF-DTELA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO TDATEL.
      *
           IF IF-TPSTA = ZERO MOVE 'SUCCESSIVO' TO TIPSTA
              ELSE MOVE 'PRECEDENTE' TO TIPSTA.
           MOVE IF-AZI TO KPC-AZI.
           MOVE IF-CONTO-1 TO KPC-COD.
           START ANACON KEY NOT < KEYPC INVALID GO TO EX-RUN-ELABORA.
       RD-CON.
           READ ANACON NEXT INTO REKCON  AT END GO TO INISTA.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           IF KPC-AZI > IF-AZI GO TO INISTA.
           IF KPC-COD > IF-CONTO-2 GO TO INISTA.
           MOVE KEYPC TO KEYACO.
           READ APPCON INVALID GO TO RD-CON.
           IF IF-FL = 1 PERFORM AZZ-ACX ELSE
              MOVE KEYPC TO KEYACX
              READ APPCOL INVALID PERFORM AZZ-ACX.
           IF CON-TRIP = 1 GO TO RD-CON1.
           IF ACO-CDC = SPACE GO TO RD-CON.
           MOVE ZERO TO RF-LAV.
           PERFORM AZZ-LAV.
           MOVE 1    TO KLV-TIP.  
           MOVE ACO-CDC TO KLV-COM.
           GO TO RD-CON2.
      *
      * su tabella ripartizione
       RD-CON1.
           MOVE IF-AZI TO KTRT-AZI.
           MOVE CON-TTIP TO KTRT-COD.
           READ TABRIT INVALID GO TO RD-CON.
           PERFORM ATTRIBUZIONE-INDIRETTA 
           THRU EX-ATTRIBUZIONE-INDIRETTA.
           GO TO RD-CON.

       RD-CON2. 
           MOVE 100 TO LAV-PERC.
           MOVE KPC-COD TO KLV-CON.
      *    MOVE ACO-BUDC TO LAV-BUD1.
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
                MOVE ACO-BUDMC(K) TO LAV-BUDM1(K)
                ADD ACO-BUDMC(K) TO LAV-BUD1
                ADD 1 TO K
           END-PERFORM.
           IF IF-TPSTA = 1 GO TO TPSTA1.
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
              MOVE ACO-BUDMS(K) TO LAV-BUDM2(K)
              ADD ACO-BUDMS(K) TO LAV-BUD2
              ADD 1 TO K
           END-PERFORM.
           GO TO WR-LAV.
       TPSTA1.
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
              MOVE ACX-BUDMC(K) TO LAV-BUDM2(K)
              ADD ACX-BUDMC(K) TO LAV-BUD2
              ADD 1 TO K
           END-PERFORM.
       WR-LAV.
           WRITE RF-LAV INVALID MOVE 'WR LAV' TO MESS GO TO ERRIO.
           GO TO RD-CON.
       INISTA.
           MOVE AZRGSOC TO TAZI.

           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY NOT < KEYLV INVALID 
                                        GO TO EX-RUN-ELABORA.
           IF IF-FL = 1
              MOVE 'LISTA SPUNTA BUDGET V.E. ' TO DESBUD.

      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING DESBUD ' - ' TDATEL
                  DELIMITED SIZE INTO RP-TIT1.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG1-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

           MOVE ZERO TO XCRR.
           MOVE SPACE TO CODCEN.
           MOVE ZERO  TO COMTIP CODCON.
       RD-LAV.
           READ WDSLAV NEXT AT END GO TO EN-RUN-ELABORA.
      *
           COPY 'grirpt-r'.
      *
           IF KLV-CON  = CODCON
              GO TO RD-LAV1.
           MOVE IF-AZI TO KPC-AZI.
           MOVE KLV-CON TO KPC-COD RCON1.
           READ ANACON INTO REKCON INVALID MOVE ALL '*' TO CON-DSC.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-DSC TO RDCON1.
           MOVE 2 TO XCRR.
       RD-LAV1.
           IF KLV-CON = CODCON
              IF KLV-COM  = CODCEN
                 GO TO RD-LAV2.
           MOVE IF-AZI TO KCD-AZI.
           MOVE KLV-COM TO KCD-COD RCOM1.
           READ CDCOST INVALID MOVE ALL '*' TO CDC-DESCR.
           MOVE CDC-DESCR TO RDCOM1.
           MOVE LAV-PERC TO RDPERC.
           MOVE 2 TO XCRR.
       RD-LAV2.
           MOVE KLV-TIP TO COMTIP.
           MOVE KLV-COM TO CODCEN.
           MOVE KLV-CON TO CODCON.
           IF NOT LAV-BUD1 = ZERO
              MOVE 'ANN' TO RMESE
              MOVE LAV-BUD1 TO RBUD1. 
           IF NOT LAV-BUD2 = ZERO
              MOVE 'ANN' TO RMESE
              MOVE LAV-BUD2 TO RBUD2. 
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ZERO TO K.
           MOVE 1 TO XCRR.
       RD-MESI.
           ADD 1 TO K.
           IF K > 12 GO TO RD-LAV.
           IF LAV-BUDM1(K) = ZERO AND LAV-BUDM2(K) = ZERO
              GO TO RD-MESI.
           MOVE K TO MESE.
           MOVE MESE TO RMESE.  
           MOVE LAV-BUDM1(K) TO RBUD1.
           MOVE LAV-BUDM2(K) TO RBUD2.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           GO TO RD-MESI.
       EN-RUN-ELABORA.
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
           
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
           STRING 'w2' PID DELIMITED SPACE INTO ID-LA2.
       EX-CREA-IDLAV.
           EXIT.
      * sort per ripartizione c/c su tabella ripartizione
      * per tabelle di tipo a coefficiente
      * determina il totale dei coefficienti da ripartire
       CREA-WDSLA2.
           MOVE IF-AZI TO KTRT-AZI.
           MOVE SPACE TO KTRT-COD.
           START TABRIT KEY NOT < KEYTRT INVALID GO TO EX-CREA-WDSLA2.
      * loop testate
       RD-TRT.
           READ TABRIT NEXT AT END GO TO EX-CREA-WDSLA2.
           IF TRT-TIPCO = 'P' GO TO RD-TRT.
           MOVE KTRT-AZI TO KTRR-AZI.
           MOVE KTRT-COD TO KTRR-COD.
           MOVE SPACE    TO KTRR-CDC.
           START TABRIR KEY NOT < KEYTRR INVALID GO TO RD-TRT.
      * loop righi    
       RD-TRRL.
           READ TABRIR NEXT AT END GO TO RD-TRT.
           IF KTRR-AZI NOT = KTRT-AZI OR
              KTRR-COD NOT = KTRT-COD 
              GO TO RD-TRT.
           MOVE KTRR-COD TO KL2-TTIP. 
           READ WDSLA2 INVALID MOVE ZERO TO LA2-TCOEFF
                               WRITE RF-LA2.
           ADD TRR-COEFF TO LA2-TCOEFF.
           REWRITE RF-LA2.
           GO TO RD-TRRL.
       EX-CREA-WDSLA2.
           EXIT.
      * per tabelle a percentuale applica la % di ogni CDC
      * per tabelle a coefficiente legge wdsla2
       ATTRIBUZIONE-INDIRETTA.
           MOVE IF-AZI TO KTRT-AZI.
           MOVE CON-TTIP TO KTRT-COD.
           READ TABRIT INVALID GO TO EX-ATTRIBUZIONE-INDIRETTA.
           MOVE KTRT-AZI TO KTRR-AZI.
           MOVE KTRT-COD TO KTRR-COD.
           MOVE SPACE    TO KTRR-CDC.
           START TABRIR KEY NOT < KEYTRR INVALID 
                        GO TO EX-ATTRIBUZIONE-INDIRETTA.
       RD-TRRA.
           READ TABRIR NEXT AT END GO TO EX-ATTRIBUZIONE-INDIRETTA.
           IF KTRR-AZI NOT = KTRT-AZI OR
              KTRR-COD NOT = KTRT-COD 
              GO TO EX-ATTRIBUZIONE-INDIRETTA.
           MOVE 2 TO KLV-TIP.
           MOVE KTRR-CDC TO KLV-COM.
           MOVE KPC-COD TO KLV-CON.
           READ WDSLAV INVALID MOVE 2 TO KLV-TIP
                               MOVE KTRR-CDC TO KLV-COM
                               MOVE KPC-COD TO KLV-CON
                               PERFORM AZZ-LAV
                               WRITE RF-LAV.
           MOVE ZERO TO K.
       NXTK.
           ADD 1 TO K.
           IF K > 12 GO TO ENDK.
      * indiretta percentuale
           IF TRT-TIPCO = 'P'
              COMPUTE RD-NUM  = ACO-BUDMC(K) * TRR-PERC / 100 
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE  RD-NUM TO LAV-BUDM1(K) 
              ADD   RD-NUM TO LAV-BUD1
              IF IF-TPSTA = ZERO
                 COMPUTE RD-NUM  = ACO-BUDMS(K) * TRR-PERC / 100 
              ELSE
                 COMPUTE RD-NUM  = ACX-BUDMC(K) * TRR-PERC / 100 
              END-IF
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE  RD-NUM TO LAV-BUDM2(K)  
              ADD   RD-NUM TO LAV-BUD2
              GO TO NXTK.
      * indiretta a coefficiente  
           IF TRT-TIPCO = 'C'
              MOVE KTRT-COD TO KL2-TTIP
              READ WDSLA2 INVALID MOVE ZERO TO LA2-TCOEFF
              END-READ
              IF LA2-TCOEFF NOT = ZERO
                 COMPUTE RD-NUM  = ACO-BUDMC(K) * TRR-COEFF / LA2-TCOEFF
                 CALL 'vrround' USING NNN-M PARRD DEC-0
                 MOVE  RD-NUM TO LAV-BUDM1(K) 
                 ADD   RD-NUM TO LAV-BUD1
                 IF IF-TPSTA = ZERO
                                   COMPUTE RD-NUM  = 
                                   ACO-BUDMS(K) * TRR-COEFF / LA2-TCOEFF
                 ELSE
                                   COMPUTE RD-NUM  = 
                                   ACX-BUDMC(K) * TRR-COEFF / LA2-TCOEFF
                 END-IF
                 CALL 'vrround' USING NNN-M PARRD DEC-0
                 ADD   RD-NUM TO LAV-BUD2
                 MOVE  RD-NUM TO LAV-BUDM2(K) 
              END-IF
              GO TO NXTK.
       ENDK.
              IF TRT-TIPCO = 'P' MOVE TRR-PERC TO LAV-PERC. 
              IF TRT-TIPCO = 'C' COMPUTE RD-NUM   = TRR-COEFF * 100
                                                  / LA2-TCOEFF 
                                 CALL 'vrround' USING NNN-M PARRD DEC-2
                                 MOVE RD-NUM TO LAV-PERC.
              REWRITE RF-LAV INVALID MOVE 'RW LAV' TO MESS GO TO ERRIO.
              GO TO RD-TRRA.
       EX-ATTRIBUZIONE-INDIRETTA.
           EXIT.

       AZZ-ACX.
           MOVE ZERO TO ACX-BUDC ACX-BUDS.
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
                MOVE ZERO TO ACX-BUDMC(K)
           ADD 1 TO K
           END-PERFORM.

       AZZ-LAV.
           MOVE ZERO TO LAV-PERC LAV-BUD1 LAV-BUD2.
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
              MOVE ZERO TO LAV-BUDM1(K) LAV-BUDM2(K)
              ADD 1 TO K
           END-PERFORM.
      *------------------
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'Anagrafica Conto' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Centro di Costo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE '% Attrib.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Mese' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Anno CORRENTE' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           STRING 'Anno ' TIPSTA DELIMITED SIZE INTO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
