       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON121.
      *
      * Stampa libro giornale (unificato) con raggruppamento conti IVA
      *
      *           FLAG ESERCIZIO IN CHIAVE WDSLAV
      *
      *           RIORDINO PER APERTURE E CHIUSURE
      *           INSERITO IN CHIAVE WDSLAV TIPO MOVIMENTO:
      *
      *           1 = PATRIMONIALI ATTIVI 1    (caus.ap. D + < clienti)
      *           2 = CLIENTI                  (causale apertura)
      *           3 = PATRIMONIALI ATTIVI 2    (caus.ap. D + > clienti)
      *           4 = CONTO BILANCIO APERTURA  (causale apertura A)
      *           5 = CONTO BILANCIO APERTURA  (causale apertura D)
      *           6 = PATRIMONIALI PASSIVI 1   (caus.ap. A + < fornitori
      *           7 = FORNITORI                (causale apertura)
      *           8 = PATRIMONIALI PASSIVI 2   (caus.ap. A + > fornitori
      *
      *           A = MOVIMENTI NORMALI        (causale non di ap. o ch.
      *
      *           C = RICAVI                   (caus.ch. D + 'E')
      *           D = COSTI                    (caus.ch. A + 'E')
      *           E = CONTO PROFITTI E PERDITE (caus.ch. D + conto P.P.)
      *           F = CONTO PROFITTI E PERDITE (caus.ch. A + conto P.P.)
      *           G = RILEVAMENTO UTILE        (causale da tab.param.chi
      *           H = PATRIMONIALI ATTIVI 1    (caus.ch.A+<>'E'+>clienti
      *           I = CLIENTI                  (causale chiusura)
      *           L = PATRIMONIALI ATTIVI 2    (caus.ch.A+<>'E'+>clienti
      *           M = CONTO BILANCIO CHIUSURA  (caus.chiusura D)
      *           N = CONTO BILANCIO CHIUSURA  (caus.chiusura A)
      *           O = PATRIMONIALI PASSIVI 1   (caus.ch.D+<>'E'+<forn.)
      *           P = FORNITORI                (causale chiusura)
      *           Q = PATRIMONIALI PASSIVI 2   (caus.ch.D+<>'E'+>forn.)
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griprasl'.
           COPY 'gritabsl'.
           COPY 'griconsl'.
           COPY 'griclfsl'.
           COPY 'grimovsl'.
           COPY 'grimszsl'.
           COPY 'grimolsl'.
           COPY 'grimslsl'.
           COPY 'grite2sl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gripra'.
           COPY 'gritab'.
           COPY 'gricon'.
           COPY 'griclf'.
           COPY 'grimov'. 
           COPY 'grimsz'.
           COPY 'grimol'. 
           COPY 'grimsl'. 
           COPY 'grite2'. 
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 81 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
             10 KLV-DAT    PIC 9(5).
             10 KLV-ESER   PIC 9.
             10 KLV-TIPO   PIC X.
             10 KLV-NREG   PIC 9(5).
             10 KLV-D-A    PIC X.
             10 KLV-NUM    PIC 9(5).
             10 KLV-CONTO  PIC 9(7) COMP-3.
             10 KLV-CAUS   PIC 999  COMP-3.
           05 LAV-D-A      PIC X.
           05 LAV-TREG     PIC 9.
           05 LAV-IMPO     PIC S9(11)V99 COMP-3.
           05 LAV-NDOC     PIC 9(5) COMP-3.
           05 LAV-DTDOC    PIC 9(5) COMP-3.
           05 LAV-DTSCD    PIC 9(5) COMP-3.
           05 LAV-NPRGI    PIC 9(5) COMP-3.
           05 LAV-FLAG     PIC 9.
           05 LAV-DSAGG    PIC X(30).
           05 LAV-PART     PIC 9(7) COMP-3.
           05 LAV-REG      PIC 9.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parmb'.
           COPY 'griazirk'.
           COPY 'gritabrk'.
           COPY 'grimovrk'.  
           COPY 'grimolrk'. 
           COPY 'griconrk'.
           COPY 'grit20rk'.
           COPY 'grit14g'.
           COPY 'grite2rk'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-PRA PIC X(15) VALUE 'proazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-MSZ PIC X(15) VALUE 'movsez'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  ID-MOL PIC X(15) VALUE 'movmol'.
       01  ID-MSL PIC X(15) VALUE 'movsol'.
       01  ID-TE2 PIC X(15) VALUE 'tabeu2'.
       01  COMODI.
           05 SF-AZI  PIC XX.
           05 SF-PRA  PIC XX.
           05 SF-TAB  PIC XX.
           05 SF-CON  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-MOV  PIC XX.
           05 SF-MSZ  PIC XX.
           05 SF-LAV  PIC XX.
           05 SF-MOL  PIC XX.
           05 SF-MSL  PIC XX.
           05 SF-TE2  PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 MCLI     PIC 99.
           05 MFOR     PIC 99.
           05 DAT1     PIC 9(5) COMP-3.
           05 DAT2     PIC 9(5) COMP-3.
           05 CRPCL    PIC 9(7).
           05 CRPC1    PIC 9(7).
           05 CRPC2    PIC 9(7).
           05 CRPFR    PIC 9(7).
           05 CRPF1    PIC 9(7).
           05 CRPF2    PIC 9(7).
           05 CIVAV    PIC 9(7).
           05 CIVAQ    PIC 9(7).
           05 CIVSO    PIC 9(7).
           05 TOTPGD   PIC S9(12)V99 VALUE ZERO.
           05 TOTPGA   PIC S9(12)V99 VALUE ZERO.
           05 TOTPRD   PIC S9(12)V99 VALUE ZERO.
           05 TOTPRA   PIC S9(12)V99 VALUE ZERO.
           05 SAVRIG   PIC X(132) VALUE SPACE.
           05 K       PIC 999 VALUE ZERO.
           05 N       PIC 999 VALUE ZERO.
           05 FIVAS PIC 9.
           05 FIVAV PIC 9.
           05 FIVAQ PIC 9.
           05 COMCON PIC 9(7).
           05 KONCA   PIC 999.
           05 POSIZ   PIC 999.
           05 CONCAIN PIC X(36).
           05 CONCOUT.
              10 WDSK21 PIC X(62).
              10 WDSK22 PIC X(62).
              10 WDSK23 PIC X(62).
           05 COMCOUT.
              10 FILLER PIC X(62).
              10 FILLER PIC X(62).
              10 FILLER PIC X(62).
           05 CLAV    PIC 9(7) VALUE ZERO.
           05 DTLIG   PIC 9(5).
           05 DTBIG   PIC 9(5).
      * righe logiche per visuale
           05 NRGLV    PIC 9(2) VALUE 40.
      **** rel 6.3
           05 SNREG    PIC 9(5) VALUE ZERO.
           05 CONTA    PIC 9(7) VALUE ZERO.
      ************

           COPY 'vcon121.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           05 IF-LMOD      PIC 99.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-DATA-1    PIC 9(6).
           05 IF-DATA-2    PIC 9(6).
           05 IF-FLAG      PIC 9.
           05 IF-FLNREG    PIC 9.
           05 IF-NBOL      PIC 9.
           05 IF-NUM-1     PIC 9(5).
           05 IF-ANNO      PIC 9(4).
           05 IF-PIEDE-1   PIC X(60).
           05 IF-PIEDE-2   PIC X(60).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclpra'.
           COPY 'dcltab'.
           COPY 'dclcon'.
           COPY 'dclclf'.
           COPY 'dclmov'.
           COPY 'dclmsz'.
           COPY 'dclmol'.
           COPY 'dclmsl'.
           COPY 'dcllav'.
           COPY 'dclte2'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon121: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE ANACON.
           CLOSE ANACLF.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gripraer'.
           COPY 'gritaber'.
           COPY 'griconer'.
           COPY 'griclfer'.
           COPY 'grimover'.
           COPY 'grimszer'.
           COPY 'grimoler'.
           COPY 'grimsler'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O   WDSLAV.
      *
      **** rel 6.2
      *    IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
      *                    MOVE 'tabell' TO ID-TAB
      *                    MOVE 'anacon' TO ID-CON
      *                    MOVE 'anaclf' TO ID-CLF
      *                    MOVE 'movime' TO ID-MOV
      *                    MOVE 'movsez' TO ID-MSZ.
      *    IF IF-FL = 1    MOVE 'anazol' TO ID-AZI
      *                    MOVE 'tabold' TO ID-TAB
      *                    MOVE 'anacol' TO ID-CON
      *                    MOVE 'anacfx' TO ID-CLF
      *                    MOVE 'movmol' TO ID-MOV
      *                    MOVE 'movsol' TO ID-MSZ.
      *
      *> Previsto IF-FL = 2 per chiamata da men GAP000
      *> per storicizzazione archivi.
      *
           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'tabell' TO ID-TAB
                           MOVE 'anacon' TO ID-CON
                           MOVE 'anaclf' TO ID-CLF
                           MOVE 'movime' TO ID-MOV
                           MOVE 'movsez' TO ID-MSZ
           ELSE            
                           MOVE 'anazol' TO ID-AZI
                           MOVE 'tabold' TO ID-TAB
                           MOVE 'anacol' TO ID-CON
                           MOVE 'anacfx' TO ID-CLF
                           MOVE 'movmol' TO ID-MOV
                           MOVE 'movsol' TO ID-MSZ.
      ************
      *
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN INPUT ANACON.
           OPEN INPUT ANACLF.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
              PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MCLI.
           MOVE T01-MFOR TO MFOR.
           MOVE T01-CRPCL TO CRPCL.
           MOVE T01-CRPC1 TO CRPC1.
           MOVE T01-CRPC2 TO CRPC2.
           MOVE T01-CRPFR TO CRPFR.
           MOVE T01-CRPF1 TO CRPF1.
           MOVE T01-CRPF2 TO CRPF2.
           MOVE T01-CIVAV TO CIVAV.
           MOVE T01-CIVAQ TO CIVAQ.
           MOVE T01-CIVSO TO CIVSO.
           MOVE 14 TO KTB-TIP.
           MOVE 7  TO KTB-COD.
           READ TABELL INTO RKTB14G INVALID PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB14G.
           MOVE 20 TO KTB-TIP.
           MOVE 1  TO KTB-COD.
           READ TABELL INTO RKTB20 INVALID PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
           MOVE ZERO TO IF-DATA-2.
           MOVE ZERO TO IF-DATA-1.
           MOVE ZERO TO IF-FLAG.
           MOVE ZERO TO IF-FLNREG.
           MOVE ZERO TO IF-NBOL
                        IF-NUM-1
                        IF-ANNO.
           MOVE SPACE TO IF-PIEDE-1
                         IF-PIEDE-2.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DATA-1.
           MOVE 'IF-DATA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DAT1.
           IF AAGGG < AZI-DTAPE
              MOVE "Data inferiore alla data apertura" TO MESS
              GO TO V-ERROR.
           IF FUN NOT = 'W' GO TO E-DATA-1.
           CALL 'vrdtbigb' USING DTBIG.
           IF DAT1 > DTBIG GO TO E-DATA-1.
           MOVE 'Il periodo selezionato riguarda'      TO F-MES1.
           MOVE 'le transazioni fatte in Lire.'        TO F-MES2.
           MOVE 'L''operazione deve essere effettuata' TO F-MES3.
           MOVE 'da Primula versione Euro1.'           TO F-MES4.
           MOVE 'Vuoi proseguire ugualmente ?'         TO F-MES5.
           MOVE 5 TO F-NMES.
           MOVE 'Q' TO MB-TIPO.
           MOVE '2' TO MB-DEFAULT.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP NOT = 'S' 
              MOVE 'Operazione non eseguita ' TO MESS
              GO TO V-ERROR.
           IF IF-FLAG = 1
              MOVE ZERO TO IF-FLAG
              MOVE 'Non verra'' effettuata la stampa' TO F-MES1
              MOVE 'definitiva, ma provvisoria'       TO F-MES2
              MOVE 2 TO F-NMES
              CALL 'vrmbox' USING PARMB.
       E-DATA-1.
      *
       V-DATA-2.
           MOVE 'IF-DATA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DAT2.
           IF DAT2 < DAT1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DATA-2.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           COPY 'grirpt-sn' REPLACING 1 BY 2
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           COPY 'grirpt-sn' REPLACING 1 BY 3
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-3.
      *
           COPY 'grirpt-sn' REPLACING 1 BY 4
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-4.
      *
           COPY 'grirpt-sn' REPLACING 1 BY 5
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-5.
      * 
           IF RP-TRPT = ZERO 
              MOVE 'E'' possibile stampare il Report' TO F-MES1
              MOVE 'solo a carattere o visuale.'     TO F-MES2
              MOVE 'Forzato visuale.' TO F-MES3
              MOVE 3 TO F-NMES
              MOVE 'W' TO MB-TIPO
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO RP-TRPT.
      *
           IF IF-NBOL = 1
              MOVE 'PBK_ADES' TO RP-BLK
              MOVE IF-PIEDE-1 TO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE 'PBK_ACIT' TO RP-BLK
              MOVE IF-PIEDE-2 TO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE 'PBK_DPAG' TO RP-BLK
              STRING 'Anno: ' IF-ANNO
                     DELIMITED SIZE INTO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE 'PBK_NPAG' TO RP-BLK
              MOVE IF-NUM-1 TO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE IF-ANNO  TO PANNO
              MOVE '/'      TO PBARR
              IF IF-ANNO = ZERO 
                 MOVE SPACE TO PANNO PBARR
              END-IF
              MOVE ZERO TO FNPG
           ELSE
              MOVE SPACE TO RTPAG
              MOVE 1 TO FNPG
              MOVE 'np' TO RP-VERM.    *> per non stampare il piede

           IF IF-FLAG = ZERO GO TO NO-BIL-CON.
           IF DTBIG   = ZERO GO TO NO-BIL-CON.
           OPEN INPUT TABEU2.
           MOVE 5      TO KT2-TIP.
           MOVE IF-AZI TO KT2-COD.
           READ TABEU2 INTO REKTE2 INVALID MOVE ZERO TO REKTE2
                                           MOVE 1    TO TE205-FLGDE.
           IF SF-TE2 = '9D' OR '9A' OR '35' MOVE RF-TE2 TO REKTE2.
           CLOSE TABEU2.
           IF TE205-FLGDE = ZERO
              MOVE 'Non e'' stato stampato il bilancio' TO F-MES1
              MOVE 'di conversione !                  ' TO F-MES2
              MOVE '(Scelta 6 della Procedura STARTUP)' TO F-MES3
              MOVE 3 TO F-NMES
              GO TO ERRIO.
       NO-BIL-CON.

           MOVE KAZ-COD TO KPC-AZI.
           MOVE CIVAV   TO KPC-COD.
           READ ANACON INTO REKCON INVALID PERFORM INVK-CON
                                           GO TO ERRIO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-FLRIE TO FIVAV.
           IF AZI-FLGIS = ZERO
                          MOVE ZERO TO CIVSO FIVAS GO TO LAZ4.
           MOVE CIVSO   TO KPC-COD.
           READ ANACON INTO REKCON INVALID PERFORM INVK-CON
                                           GO TO ERRIO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-FLRIE TO FIVAS.
       LAZ4.
           MOVE CIVAQ   TO KPC-COD.
           READ ANACON INTO REKCON INVALID PERFORM INVK-CON
                                           GO TO ERRIO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-FLRIE TO FIVAQ.
      **** rel 6.2
      *    IF IF-FL = 1 GO TO MSZ10.
           IF IF-FL = 1 OR 2
              GO TO MSZ10.
      ************
           OPEN INPUT MOVSEZ.
           MOVE LOW-VALUE TO KEYMS.
           MOVE KAZ-COD TO KMS-AZI.
       LPE0.
           MOVE ZERO TO KMS-NUM.
           START MOVSEZ KEY NOT < KEYMS INVALID GO TO MSZ5.
       LPES.
           READ MOVSEZ NEXT AT END GO TO MSZ5.
           IF SF-MSZ = '9D' OR '9A' OR '35' GO TO LPES.
           IF KMS-AZI > KAZ-COD GO TO MSZ5.
           IF KMS-DAT < DAT1 MOVE DAT1 TO KMS-DAT GO TO LPE0.
           IF KMS-DAT > DAT2 MOVE 99999 TO KMS-DAT GO TO LPE0.
           MOVE RF-MSZ TO REKMOV.
           IF KMS-CON NOT = CIVAV AND KMS-CON NOT = CIVAQ
                                  AND KMS-CON NOT = CIVSO GO TO SOTTO.
           IF MOV-IMPO = ZERO GO TO LPES.
       SOTTO.
           MOVE RF-MSZ TO REKMOV.
           MOVE 1 TO KLV-ESER.
           MOVE 'A' TO KLV-TIPO.
           IF MOV-CAUS = T20-CDCLA OR
              MOV-CAUS = T20-CACLA MOVE '2' TO KLV-TIPO.
           IF MOV-CAUS = T20-CDFOA OR
              MOV-CAUS = T20-CAFOA MOVE '7' TO KLV-TIPO.
           IF MOV-CAUS = T20-CDCLC OR
              MOV-CAUS = T20-CACLC MOVE 'I' TO KLV-TIPO.
           IF MOV-CAUS = T20-CDFOC OR
              MOV-CAUS = T20-CAFOC MOVE 'P' TO KLV-TIPO.
           MOVE MOV-NREG TO KLV-NREG.
      **** rel 6.3
           IF MOV-CAUS = (T20-CDCLC OR T20-CACLC OR T20-CDFOC OR 
                         T20-CAFOC OR T20-CDSOC OR T20-CASOC) AND 
                          KLV-NREG= ZERO
              MOVE 99999 TO KLV-NREG.
      ************
           IF MOV-D-A = 'A' MOVE 'A' TO KLV-D-A
           ELSE MOVE SPACE TO KLV-D-A.
           MOVE MOV-CON TO KLV-CONTO.
           MOVE MOV-DAT TO KLV-DAT.
           MOVE MOV-NUM TO KLV-NUM.
           MOVE MOV-CAUS TO KLV-CAUS.
           MOVE MOV-D-A TO LAV-D-A.
           MOVE MOV-TREG TO LAV-TREG.
           MOVE MOV-IMPO TO LAV-IMPO.
           MOVE MOV-NDOC TO LAV-NDOC.
           MOVE MOV-DTDOC TO LAV-DTDOC.
           MOVE MOV-DTSCD TO LAV-DTSCD.
           MOVE MOV-NPRGI TO LAV-NPRGI.
           MOVE MOV-FLAG TO LAV-FLAG.
           MOVE MOV-DSAGG TO LAV-DSAGG.
           MOVE MOV-PART TO LAV-PART.
           MOVE 2 TO LAV-REG.
           WRITE RF-LAV INVALID KEY MOVE 'LAV' TO MESS GO TO ERRIO.
           ADD 1 TO CLAV.
      *
           COPY 'grirpt-r' REPLACING 1 BY 5
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-5.
      *
           GO TO LPES.
       MSZ5.
           CLOSE MOVSEZ.
       MSZ10.
           OPEN INPUT MOVSOL.
           MOVE LOW-VALUE TO KEYSL.
           MOVE KAZ-COD TO KSL-AZI.
       MSZ15.
           MOVE ZERO TO KSL-NUM.
           START MOVSOL KEY NOT < KEYSL INVALID GO TO LPGEN.
       LPESOL.
           READ MOVSOL NEXT AT END GO TO LPGEN.
           IF SF-MSL = '9D' OR '9A' OR '35' GO TO LPESOL.
           IF KSL-AZI > KAZ-COD GO TO LPGEN.
           IF KSL-DAT < DAT1 MOVE DAT1 TO KSL-DAT GO TO MSZ15.
           IF KSL-DAT > DAT2 MOVE 99999 TO KSL-DAT GO TO MSZ15.
           MOVE RF-MSL TO REKMOV.
           MOVE ZERO TO KLV-ESER.
           MOVE 'A' TO KLV-TIPO.
           IF MOV-CAUS = T20-CDCLA OR
              MOV-CAUS = T20-CACLA MOVE '2' TO KLV-TIPO.
           IF MOV-CAUS = T20-CDFOA OR
              MOV-CAUS = T20-CAFOA MOVE '7' TO KLV-TIPO.
           IF MOV-CAUS = T20-CDCLC OR
              MOV-CAUS = T20-CACLC MOVE 'I' TO KLV-TIPO.
           IF MOV-CAUS = T20-CDFOC OR
              MOV-CAUS = T20-CAFOC MOVE 'P' TO KLV-TIPO.
           MOVE MOV-NREG TO KLV-NREG.
      **** rel 6.3
           IF MOV-CAUS = (T20-CDCLC OR T20-CACLC OR T20-CDFOC OR 
                         T20-CAFOC OR T20-CDSOC OR T20-CASOC) AND 
                          KLV-NREG= ZERO
              MOVE 99999 TO KLV-NREG.
      ************
           IF MOV-D-A = 'A' MOVE 'A' TO KLV-D-A
           ELSE MOVE SPACE TO KLV-D-A.
           MOVE MOV-CON TO KLV-CONTO.
           MOVE MOV-DAT TO KLV-DAT.
           MOVE MOV-NUM TO KLV-NUM.
           MOVE MOV-CAUS TO KLV-CAUS.
           MOVE MOV-D-A TO LAV-D-A.
           MOVE MOV-TREG TO LAV-TREG.
           MOVE MOV-IMPO TO LAV-IMPO.
           MOVE MOV-NDOC TO LAV-NDOC.
           MOVE MOV-DTDOC TO LAV-DTDOC.
           MOVE MOV-DTSCD TO LAV-DTSCD.
           MOVE MOV-NPRGI TO LAV-NPRGI.
           MOVE MOV-FLAG TO LAV-FLAG.
           MOVE MOV-DSAGG TO LAV-DSAGG.
           MOVE MOV-PART TO LAV-PART.
           MOVE 2 TO LAV-REG.
           WRITE RF-LAV INVALID KEY MOVE 'LAV' TO MESS GO TO ERRIO.
           ADD 1 TO CLAV.
      *
           COPY 'grirpt-r' REPLACING 1 BY 4
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-4.
      *
           GO TO LPESOL.
       LPGEN.
           CLOSE MOVSOL.
      **** rel 6.2
      *    IF IF-FL = 1 GO TO EXES.
           IF IF-FL = 1 OR 2 
              GO TO EXES.
      ************
           OPEN INPUT MOVIME.
           MOVE ZERO TO COMCON.
           MOVE LOW-VALUE TO KEYMV.
           MOVE KAZ-COD TO KMV-AZI.
       STMOV.
           MOVE ZERO TO KMV-NUM.
           START MOVIME KEY NOT < KEYMV INVALID GO TO EXES0.
       RDMOV.
           READ MOVIME NEXT AT END GO TO EXES0.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO RDMOV.
           IF KMV-AZI > KAZ-COD GO TO EXES0.
           IF KMV-DAT < DAT1 MOVE DAT1 TO KMV-DAT GO TO STMOV.
           IF KMV-DAT > DAT2 MOVE 99999 TO KMV-DAT GO TO STMOV.
           IF KMV-NUM < 99991 GO TO RDMOV1.
           IF KMV-CON = CRPCL GO TO RDMOV.
           IF KMV-CON = CRPC1 GO TO RDMOV.
           IF KMV-CON = CRPC2 GO TO RDMOV.
           IF KMV-CON = T14-CRPC3 GO TO RDMOV.
           IF KMV-CON = T14-CRPC4 GO TO RDMOV.
           IF KMV-CON = T14-CRPC5 GO TO RDMOV.
           IF KMV-CON = T14-CRPC6 GO TO RDMOV.
           IF KMV-CON = T14-CRPC7 GO TO RDMOV.
           IF KMV-CON = T14-CRPC8 GO TO RDMOV.
           IF KMV-CON = CRPFR GO TO RDMOV.
           IF KMV-CON = CRPF1 GO TO RDMOV.
           IF KMV-CON = CRPF2 GO TO RDMOV.
           IF KMV-CON = T14-CRPF3 GO TO RDMOV.
           IF KMV-CON = T14-CRPF4 GO TO RDMOV.
           IF KMV-CON = T14-CRPF5 GO TO RDMOV.
           IF KMV-CON = T14-CRPF6 GO TO RDMOV.
           IF KMV-CON = T14-CRPF7 GO TO RDMOV.
           IF KMV-CON = T14-CRPF8 GO TO RDMOV.
       RDMOV1.
           MOVE RF-MOV TO REKMOV.
           IF MOV-FLAG = ZERO AND MOV-IMPO = ZERO GO TO RDMOV.
           MOVE 1 TO KLV-ESER.
           PERFORM B00-COMPILA-TIPO THRU B99.
           IF ( MOV-CON = CIVAV AND FIVAV = 1 ) OR 
              ( MOV-CON = CIVSO AND FIVAS = 1 ) OR 
              ( MOV-CON = CIVAQ AND FIVAQ = 1 )     
              MOVE ZERO TO MOV-NDOC MOV-DTDOC MOV-DTSCD
                           MOV-NPRGI MOV-PART MOV-TREG MOV-NREG
              MOVE SPACE TO MOV-DSAGG
              MOVE 99990 TO MOV-NUM
              MOVE 1     TO MOV-FLAG.
           IF MOV-D-A = 'A' MOVE 'A' TO KLV-D-A
           ELSE MOVE SPACE TO KLV-D-A.
           MOVE MOV-NREG TO KLV-NREG.
      **** rel 6.3
           IF MOV-CAUS = (T20-CDCLC OR T20-CACLC OR T20-CDFOC OR 
                         T20-CAFOC OR T20-CDSOC OR T20-CASOC) AND 
                          KLV-NREG= ZERO
              MOVE 99999 TO KLV-NREG.
      ************
           MOVE MOV-CON TO KLV-CONTO.
           MOVE MOV-DAT TO KLV-DAT.
           MOVE MOV-NUM TO KLV-NUM.
           MOVE MOV-CAUS TO KLV-CAUS.
           READ WDSLAV INVALID MOVE ZERO TO LAV-IMPO.
           MOVE MOV-D-A TO LAV-D-A.
           MOVE MOV-TREG TO LAV-TREG.
           ADD  MOV-IMPO TO LAV-IMPO.
           MOVE MOV-NDOC TO LAV-NDOC.
           MOVE MOV-DTDOC TO LAV-DTDOC.
           MOVE MOV-DTSCD TO LAV-DTSCD.
           MOVE MOV-NPRGI TO LAV-NPRGI.
           MOVE MOV-FLAG TO LAV-FLAG.
           MOVE MOV-DSAGG TO LAV-DSAGG.
           MOVE MOV-PART TO LAV-PART.
           MOVE 1 TO LAV-REG.
           IF SF-LAV = ZERO 
              REWRITE RF-LAV INVALID MOVE 'RW LAV' TO MESS GO TO ERRIO
           ELSE WRITE RF-LAV INVALID MOVE 'WR LAV' TO MESS GO TO ERRIO.
           ADD 1 TO CLAV.
      *
           COPY 'grirpt-r' REPLACING 1 BY 3
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-3.
      *
           GO TO RDMOV.
       EXES0.
           CLOSE MOVIME.
       EXES.
           OPEN INPUT MOVMOL.
           MOVE ZERO TO COMCON.
           MOVE LOW-VALUE TO KEYML.
           MOVE KAZ-COD TO KML-AZI.
       STMOL.
           MOVE ZERO TO KML-NUM.
           START MOVMOL KEY NOT < KEYML INVALID KEY GO TO EXES1.
       LPMOL.
           READ MOVMOL NEXT INTO REKMOL AT END GO TO EXES1.
           IF SF-MOL = '9D' OR '9A' OR '35' GO TO LPMOL.
           IF KML-AZI > KAZ-COD GO TO EXES1.
           IF KML-DAT < DAT1 MOVE DAT1 TO KML-DAT GO TO STMOL.
           IF KML-DAT > DAT2 MOVE 99999 TO KML-DAT GO TO STMOL.
           IF KML-NUM < 99991 GO TO RDMOL1.
           IF KML-CON = CRPCL GO TO LPMOL.
           IF KML-CON = CRPC1 GO TO LPMOL.
           IF KML-CON = CRPC2 GO TO LPMOL.
           IF KML-CON = T14-CRPC3 GO TO LPMOL.
           IF KML-CON = T14-CRPC4 GO TO LPMOL.
           IF KML-CON = T14-CRPC5 GO TO LPMOL.
           IF KML-CON = T14-CRPC6 GO TO LPMOL.
           IF KML-CON = T14-CRPC7 GO TO LPMOL.
           IF KML-CON = T14-CRPC8 GO TO LPMOL.
           IF KML-CON = CRPFR GO TO LPMOL.
           IF KML-CON = CRPF1 GO TO LPMOL.
           IF KML-CON = CRPF2 GO TO LPMOL.
           IF KML-CON = T14-CRPF3 GO TO LPMOL.
           IF KML-CON = T14-CRPF4 GO TO LPMOL.
           IF KML-CON = T14-CRPF5 GO TO LPMOL.
           IF KML-CON = T14-CRPF6 GO TO LPMOL.
           IF KML-CON = T14-CRPF7 GO TO LPMOL.
           IF KML-CON = T14-CRPF8 GO TO LPMOL.
       RDMOL1.
           IF MOL-FLAG = ZERO AND MOL-IMPO = ZERO GO TO LPMOL.
           MOVE ZERO TO KLV-ESER.
           PERFORM D00-COMPILA-TIPO THRU D99.
           IF ( MOL-CON = CIVAV AND FIVAV = 1 ) OR 
              ( MOL-CON = CIVSO AND FIVAS = 1 ) OR 
              ( MOL-CON = CIVAQ AND FIVAQ = 1 )     
              MOVE ZERO TO MOL-NDOC MOL-DTDOC MOL-DTSCD
                           MOL-NPRGI MOL-PART MOL-TREG MOL-NREG
              MOVE SPACE TO MOL-DSAGG
              MOVE 99990 TO MOL-NUM
              MOVE 1     TO MOL-FLAG.
           IF MOL-D-A = 'A' MOVE 'A' TO KLV-D-A
           ELSE MOVE SPACE TO KLV-D-A.
           MOVE MOL-NREG TO KLV-NREG.
      **** rel 6.3
           IF MOL-CAUS = (T20-CDCLC OR T20-CACLC OR T20-CDFOC OR 
                         T20-CAFOC OR T20-CDSOC OR T20-CASOC) AND 
                          KLV-NREG= ZERO
              MOVE 99999 TO KLV-NREG.
      ************
           MOVE MOL-CON TO KLV-CONTO.
           MOVE MOL-DAT TO KLV-DAT.
           MOVE MOL-NUM TO KLV-NUM.
           MOVE MOL-CAUS TO KLV-CAUS.
           READ WDSLAV INVALID MOVE ZERO TO LAV-IMPO.
           MOVE MOL-D-A TO LAV-D-A.
           MOVE MOL-TREG TO LAV-TREG.
           ADD  MOL-IMPO TO LAV-IMPO.
           MOVE MOL-NDOC TO LAV-NDOC.
           MOVE MOL-DTDOC TO LAV-DTDOC.
           MOVE MOL-DTSCD TO LAV-DTSCD.
           MOVE MOL-NPRGI TO LAV-NPRGI.
           MOVE MOL-FLAG TO LAV-FLAG.
           MOVE MOL-DSAGG TO LAV-DSAGG.
           MOVE MOL-PART TO LAV-PART.
           MOVE 1 TO LAV-REG.
           IF SF-LAV = ZERO 
              REWRITE RF-LAV INVALID MOVE 'RW LAV' TO MESS GO TO ERRIO
           ELSE WRITE RF-LAV INVALID MOVE 'WR LAV' TO MESS GO TO ERRIO.
           ADD 1 TO CLAV.
      *
           COPY 'grirpt-r' REPLACING 1 BY 2
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           GO TO LPMOL.
       EXES1.
           CLOSE MOVMOL.
           IF CLAV = ZERO GO TO EX-RUN-ELABORA.

      * Inizio stampa
           MOVE ZERO TO TOTPGD TOTPGA TOTPRD TOTPRA.

           MOVE KAZ-COD TO KPC-AZI.
           MOVE AZRGSOC TO RT01.
           MOVE ZERO TO DTLIG.
      *
      *-- inizializza parametri per stampa a caratteri --*
           IF IF-LMOD = 12
              MOVE 72 TO NRGF                
              MOVE 64 TO NRGL                  
           ELSE 
              MOVE 66 TO NRGF                        
              MOVE 58 TO NRGL.                       
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'LIBRO  GIORNALE  DI  CONTABILITA'''
                  DELIMITED SIZE INTO RP-TIT1.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG1-INTC.
      *
      *    MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
      *
      **** rel 6.3
           MOVE ZERO TO CONTA SNREG.
      ************
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID GO TO ENDA.
       LOPM.
           READ WDSLAV NEXT AT END GO TO ENDA.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO LOPM.
      **** rel 6.3
           IF KLV-NREG NOT = SNREG OR CONTA = ZERO
              ADD 1 TO CONTA
              MOVE KLV-NREG TO SNREG.
      ************
           PERFORM RLIB THRU EX-RLIB.
           DELETE WDSLAV.
           IF KLV-DAT > DTLIG MOVE KLV-DAT TO DTLIG.
      *
           COPY 'grirpt-r'.
      *
           GO TO LOPM.
       ENDA.
           PERFORM STA-TOT THRU EX-STA-TOT.
      * solo stampa a carattere
           IF RP-TRPT = 1 GO TO ECHS.
           IF NRIG NOT < NRGL - 6 GO TO ECHS.
           COMPUTE N = (NRGL - 2) - NRIG.
           COMPUTE N = N + (132 - N) / 2.
           MOVE N TO K.
           ADD 1 TO N.
       LCHS.    
           IF NRIG NOT < (NRGL - 2) GO TO ECHS. 
           ADD 1 TO NRIG.
           IF NRIG = (NRGL - 2)
              MOVE ALL '=' TO P999
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3' TO RP-BLK 
           ELSE 
              SUBTRACT 1 FROM N K
              MOVE '/' TO KKBAR(N) KKBAR(K)
              MOVE 2 TO RP-FLGR
              MOVE 'RIG4' TO RP-BLK.

           SUBTRACT 1 FROM NRIG.   
           PERFORM RPT-WR.
           GO TO LCHS.
       ECHS.
           PERFORM STA-PIE.
      *
           PERFORM RPT-CL.
      *
      **** rel 6.3
      *    COPY 'grirpt-e'.
      ************
      *
           IF IF-FLAG = 1 AND DTLIG NOT = ZERO
              OPEN I-O PROAZI
              MOVE KAZ-COD TO KPR-COD
              READ PROAZI INVALID
                 PERFORM INVK-PRA
                 GO TO ERRIO
              END-READ
              IF DTLIG > PRA-DTLIG
                 MOVE DTLIG TO PRA-DTLIG
                 REWRITE RF-PRA INVALID
                    PERFORM INVK-PRA
                    GO TO ERRIO
                 END-REWRITE
              END-IF
              CLOSE PROAZI.
      **** rel 6.3
           STRING 'Numero registrazioni stampate: ' CONTA INTO F-MES1.
           MOVE 1 TO F-NMES.
           CALL 'vrmbox' USING PARMB.
      *
           COPY 'grirpt-e'.
      ************
      *
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       RST.
           IF RP-TRPT = 2 AND
               (NRIG NOT < (NRGL - 6))
                 PERFORM STA-TOT THRU EX-STA-TOT
                 PERFORM STA-PIE
                 MOVE 1 TO RP-JMP.
           IF RP-TRPT = 1 AND
               (RP-NRIGG NOT < (NRGLV - 2))
                 PERFORM STA-TOT THRU EX-STA-TOT
                 MOVE 1 TO RP-JMP.
       RSS.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.

       EX-RST.
           EXIT.
      *-------------*
       RLIB.
           MOVE KLV-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO RG1.
           MOVE 2 TO KTB-TIP.
           MOVE KLV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
                       MOVE '********' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF LAV-REG > 1 GO TO RLIB10.
           MOVE KLV-CONTO TO KPC-COD.
           MOVE KAZ-COD TO KPC-AZI.
           READ ANACON INVALID KEY
                MOVE '********' TO CON-DSC.
           MOVE KLV-CONTO TO RG2.
           MOVE CON-DSC TO CONCOUT.
           GO TO LK0.
       RLIB10.
           MOVE KAZ-COD TO KCF-AZI.
           MOVE KLV-CONTO TO KCF-COD.
           READ ANACLF INVALID
                MOVE '******** ' TO CLF-RGS.
           MOVE KLV-CONTO TO RG2.
           MOVE CLF-RGS  TO CONCOUT.
           MOVE CLF-RGS2 TO CONCAIN.
           PERFORM CONCATENA.
       LK0.
           MOVE TAB-DESCR TO CONCAIN.
           PERFORM CONCATENA.
           IF LAV-FLAG NOT = ZERO
              MOVE LAV-DSAGG TO CONCAIN
              PERFORM CONCATENA.
           PERFORM ALLINEA.
           MOVE WDSK21 TO ERG.
           IF WDSK22 NOT = SPACE PERFORM RST THRU EX-RST
                                 MOVE WDSK22 TO ERG.
           IF WDSK23 NOT = SPACE PERFORM RST THRU EX-RST
                                 MOVE WDSK23 TO ERG.
           IF LAV-NPRGI NOT = ZERO
                  IF T02-TIPRG = 3 MOVE LAV-NPRGI TO ERG12
                  ELSE
                  IF LAV-NPRGI NOT = LAV-NDOC
                      MOVE LAV-NPRGI TO ERG12.
           IF IF-FLNREG NOT = ZERO AND KLV-NREG NOT = ZERO
      **** rel 6.3
              AND KLV-NREG NOT = 99999
      ************
               MOVE KLV-NREG TO RGNREG.
           MOVE LAV-NDOC TO RG5.
           IF LAV-DTDOC > ZERO MOVE LAV-DTDOC TO AAGGG
                               CALL 'rdata' USING PARCDT
                               MOVE GBMMBA TO RG7.
           IF T02-TIPRG = 1 AND T02-FLDOC = 1
                               MOVE ZERO TO RG5 ERG12
                               MOVE SPACE TO RG7.
           IF LAV-D-A = 'D'    MOVE LAV-IMPO TO RG8
           ELSE                MOVE LAV-IMPO TO RG9.
           PERFORM RST THRU EX-RST.
           IF LAV-D-A = 'D'    ADD LAV-IMPO TO TOTPGD TOTPRD
           ELSE                ADD LAV-IMPO TO TOTPGA TOTPRA.
       EX-RLIB.
           EXIT.
      * ---------------- *
       CONCATENA.
           PERFORM VARYING KONCA FROM 186 BY -1
                   UNTIL CONCOUT(KONCA:1) NOT = SPACE OR KONCA = ZERO
                   CONTINUE.
           IF KONCA > ZERO ADD 1 TO KONCA.
           ADD 1 TO KONCA.
           IF KONCA NOT > 186 MOVE CONCAIN TO CONCOUT(KONCA:).
      * ---------------- *
       ALLINEA.
           MOVE 62 TO POSIZ.
           PERFORM SPEZZA THRU EX-SPEZZA.

           MOVE 124 TO POSIZ.
           PERFORM SPEZZA THRU EX-SPEZZA.
      * ---------------- *
       SPEZZA.
           IF CONCOUT(POSIZ + 1:) = SPACE GO TO EX-SPEZZA.
           IF CONCOUT(POSIZ + 1:1) NOT = SPACE GO TO SPEZZA-10.
           ADD 1 TO POSIZ.
           PERFORM VARYING KONCA FROM POSIZ BY 1
                   UNTIL CONCOUT(KONCA:1) NOT = SPACE
                   CONTINUE.
           SUBTRACT 1 FROM POSIZ.
           MOVE CONCOUT(1:POSIZ) TO COMCOUT.
           MOVE CONCOUT(KONCA:) TO COMCOUT(POSIZ + 1:).
           MOVE COMCOUT TO CONCOUT.
           GO TO EX-SPEZZA.
       SPEZZA-10.
           IF CONCOUT(POSIZ:1) = SPACE GO TO EX-SPEZZA.
           PERFORM VARYING KONCA FROM POSIZ BY -1
                   UNTIL CONCOUT(KONCA:1) = SPACE OR KONCA = ZERO
                   CONTINUE.
           IF KONCA = ZERO GO TO EX-SPEZZA.
           MOVE CONCOUT(1:KONCA) TO COMCOUT.
           MOVE CONCOUT(KONCA + 1:) TO COMCOUT(POSIZ + 1:).
           MOVE COMCOUT TO CONCOUT.
       EX-SPEZZA.
           EXIT.
      * ---------------- *
       B00-COMPILA-TIPO.
           MOVE 'A' TO KLV-TIPO.
           IF NOT ( MOV-CAUS = T20-CDSOA OR T20-CASOA
                            OR T20-CDCLA OR T20-CACLA
                            OR T20-CDFOA OR T20-CAFOA) GO TO B20.
           IF MOV-CON NOT = T20-COBA GO TO B10.
           IF MOV-CAUS = T20-CASOA OR T20-CDCLA
                      OR T20-CDFOA MOVE '4' TO KLV-TIPO.
           IF MOV-CAUS = T20-CDSOA OR T20-CACLA
                      OR T20-CAFOA MOVE '5' TO KLV-TIPO.
           GO TO B99.
       B10.
           IF MOV-CAUS = T20-CDSOA AND
              MOV-CON  < CRPCL     MOVE '1' TO KLV-TIPO.
           IF MOV-CAUS = T20-CDSOA AND
              MOV-CON > T14-CRPC8 MOVE '3' TO KLV-TIPO.
           IF MOV-CAUS = T20-CASOA AND
              MOV-CON  < CRPFR     MOVE '6' TO KLV-TIPO.
           IF MOV-CAUS = T20-CASOA AND
              MOV-CON > T14-CRPF8 MOVE '8' TO KLV-TIPO.
           GO TO B99.
       B20.
           IF MOV-CAUS = T20-CUTIL MOVE 'G' TO KLV-TIPO GO TO B99.
           IF NOT ( MOV-CAUS = T20-CDSOC OR T20-CASOC
                            OR T20-CDCLC OR T20-CACLC
                            OR T20-CDFOC OR T20-CAFOC) GO TO B99.
           IF MOV-CON NOT = T20-COPP GO TO B30.
           IF MOV-CAUS = T20-CDSOC MOVE 'E' TO KLV-TIPO.
           IF MOV-CAUS = T20-CASOC MOVE 'F' TO KLV-TIPO.
           GO TO B99.
       B30.
           IF MOV-CON NOT = T20-COBC GO TO B40.
           IF MOV-CAUS = T20-CDSOC OR T20-CACLC
                      OR T20-CAFOC MOVE 'M' TO KLV-TIPO.
           IF MOV-CAUS = T20-CASOC OR T20-CDCLC
                      OR T20-CDFOC MOVE 'N' TO KLV-TIPO.
           GO TO B99.
       B40.
           IF MOV-CON = COMCON GO TO B45.
           MOVE KAZ-COD TO KPC-AZI.
           MOVE MOV-CON TO KPC-COD COMCON.
           READ ANACON INTO REKCON INVALID PERFORM INVK-CON
                                           PERFORM VISK-MOV
                                           GO TO ERRIO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
       B45.
           IF CON-TIPO NOT = 'E' GO TO B50.
           IF MOV-CAUS = T20-CDSOC MOVE 'C' TO KLV-TIPO.
           IF MOV-CAUS = T20-CASOC MOVE 'D' TO KLV-TIPO.
           GO TO B99.
       B50.
           IF MOV-CAUS = T20-CASOC AND 
              MOV-CON  < CRPCL     MOVE 'H' TO KLV-TIPO.
           IF MOV-CAUS = T20-CASOC AND
              MOV-CON  > T14-CRPC8 MOVE 'L' TO KLV-TIPO.
           IF MOV-CAUS = T20-CDSOC AND 
              MOV-CON  < CRPFR     MOVE 'O' TO KLV-TIPO.
           IF MOV-CAUS = T20-CDSOC AND
              MOV-CON  > T14-CRPF8 MOVE 'Q' TO KLV-TIPO.
       B99.
           EXIT.
      *-------------*
       D00-COMPILA-TIPO.
           MOVE 'A' TO KLV-TIPO.
           IF NOT ( MOL-CAUS = T20-CDSOA OR T20-CASOA 
                            OR T20-CDCLA OR T20-CACLA
                            OR T20-CDFOA OR T20-CAFOA) GO TO D20.
           IF MOL-CON NOT = T20-COBA GO TO D10.
           IF MOL-CAUS = T20-CASOA OR T20-CDCLA
                      OR T20-CDFOA MOVE '4' TO KLV-TIPO.
           IF MOL-CAUS = T20-CDSOA OR T20-CACLA
                      OR T20-CAFOA MOVE '5' TO KLV-TIPO.
           GO TO D99.
       D10.
           IF MOL-CAUS = T20-CDSOA AND
              MOL-CON  < CRPCL     MOVE '1' TO KLV-TIPO.
           IF MOL-CAUS = T20-CDSOA AND
              MOL-CON > T14-CRPC8 MOVE '3' TO KLV-TIPO.                
           IF MOL-CAUS = T20-CASOA AND
              MOL-CON  < CRPFR     MOVE '6' TO KLV-TIPO.
           IF MOL-CAUS = T20-CASOA AND
              MOL-CON > T14-CRPF8 MOVE '8' TO KLV-TIPO.                
           GO TO D99.
       D20.
           IF MOL-CAUS = T20-CUTIL MOVE 'G' TO KLV-TIPO GO TO D99.
           IF NOT ( MOL-CAUS = T20-CDSOC OR T20-CASOC
                            OR T20-CDCLC OR T20-CACLC
                            OR T20-CDFOC OR T20-CAFOC) GO TO D99.
           IF MOL-CON NOT = T20-COPP GO TO D30.
           IF MOL-CAUS = T20-CDSOC MOVE 'E' TO KLV-TIPO.
           IF MOL-CAUS = T20-CASOC MOVE 'F' TO KLV-TIPO.
           GO TO D99.
       D30.
           IF MOL-CON NOT = T20-COBC GO TO D40.
           IF MOL-CAUS = T20-CDSOC OR T20-CACLC
                      OR T20-CAFOC MOVE 'M' TO KLV-TIPO.
           IF MOL-CAUS = T20-CASOC OR T20-CDCLC 
                      OR T20-CDFOC MOVE 'N' TO KLV-TIPO.
           GO TO D99.
       D40.
           IF MOL-CON = COMCON GO TO D45.
           MOVE KAZ-COD TO KPC-AZI.
           MOVE MOL-CON TO KPC-COD COMCON.
           READ ANACON INTO REKCON INVALID PERFORM INVK-CON
                                           PERFORM INVK-MOL
                                           GO TO ERRIO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
       D45.
           IF CON-TIPO NOT = 'E' GO TO D50.
           IF MOL-CAUS = T20-CDSOC MOVE 'C' TO KLV-TIPO.
           IF MOL-CAUS = T20-CASOC MOVE 'D' TO KLV-TIPO.
           GO TO D99.
       D50.
           IF MOL-CAUS = T20-CASOC AND 
              MOL-CON  < CRPCL     MOVE 'H' TO KLV-TIPO.
           IF MOL-CAUS = T20-CASOC AND
              MOL-CON  > T14-CRPC8 MOVE 'L' TO KLV-TIPO.
           IF MOL-CAUS = T20-CDSOC AND 
              MOL-CON  < CRPFR     MOVE 'O' TO KLV-TIPO.
           IF MOL-CAUS = T20-CDSOC AND
              MOL-CON  > T14-CRPF8 MOVE 'Q' TO KLV-TIPO.
       D99.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       STA-TOT.
           MOVE ALL '=' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.

           MOVE 'TOTALI DI PAGINA....' TO RDTOT.
           MOVE TOTPGD TO RTOTD.
           MOVE TOTPGA TO RTOTA.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.

           MOVE 'TOTALI PROGRESSIVI..' TO RDTOT.
           MOVE TOTPRD TO RTOTD.
           MOVE TOTPRA TO RTOTA.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.

           MOVE ALL '=' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.

           MOVE ZERO TO TOTPGD TOTPGA.
       EX-STA-TOT.
           EXIT.
      *------------------
       STA-PIE.
           IF IF-NBOL = 1
              MOVE IF-PIEDE-1 TO P999
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3' TO RP-BLK
              PERFORM RPT-WR
              MOVE IF-PIEDE-2 TO P999
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3' TO RP-BLK
              PERFORM RPT-WR.
      *------------------
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'Data' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Conto' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione Movimento' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Prot.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'N.Doc' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Data Doc' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           IF IF-FLNREG NOT = ZERO MOVE 'N.Reg' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Dare' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Avere' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
