       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON123.
      *
      * Stampa brogliaccio di prima nota per raggruppamenti
      *
      *           FLAG ESERCIZIO IN CHIAVE WDSLAV
      *
      *           RIORDINO PER APERTURE E CHIUSURE
      *           INSERITO IN CHIAVE WDSLAV TIPO MOVIMENTO:
      *
      *           1 = PATRIMONIALI ATTIVI 1    (caus.ap. D + < clienti)
      *           2 = CLIENTI                  (causale apertura)
      *           3 = PATRIMONIALI ATTIVI 2    (caus.ap. D + > clienti)
      *           4 = CONTO BILANCIO APERTURA  (causale apertura A)
      *           5 = CONTO BILANCIO APERTURA  (causale apertura D)
      *           6 = PATRIMONIALI PASSIVI 1   (caus.ap. A + < fornitori
      *           7 = FORNITORI                (causale apertura)
      *           8 = PATRIMONIALI PASSIVI 2   (caus.ap. A + > fornitori
      *
      *           A = MOVIMENTI NORMALI        (causale non di ap. o ch.
      *
      *           C = RICAVI                   (caus.ch. D + 'E')
      *           D = COSTI                    (caus.ch. A + 'E')
      *           E = CONTO PROFITTI E PERDITE (caus.ch. D + conto P.P.)
      *           F = CONTO PROFITTI E PERDITE (caus.ch. A + conto P.P.)
      *           G = RILEVAMENTO UTILE        (causale da tab.param.chi
      *           H = PATRIMONIALI ATTIVI 1    (caus.ch.A+<>'E'+>clienti
      *           I = CLIENTI                  (causale chiusura)
      *           L = PATRIMONIALI ATTIVI 2    (caus.ch.A+<>'E'+>clienti
      *           M = CONTO BILANCIO CHIUSURA  (caus.chiusura D)
      *           N = CONTO BILANCIO CHIUSURA  (caus.chiusura A)
      *           O = PATRIMONIALI PASSIVI 1   (caus.ch.D+<>'E'+<forn.)
      *           P = FORNITORI                (causale chiusura)
      *           Q = PATRIMONIALI PASSIVI 2   (caus.ch.D+<>'E'+>forn.)
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gritabsl'.
           COPY 'griconsl'.
           COPY 'griclfsl'.
           COPY 'grimovsl'.
           COPY 'grimszsl'.
           COPY 'grimolsl'.
           COPY 'grimslsl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
           SELECT WDSLA1 ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL1 STATUS SF-LA1.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gritab'.
           COPY 'gricon'.
           COPY 'griclf'.
           COPY 'grimov'.   
           COPY 'grimsz'.  
           COPY 'grimol'. 
           COPY 'grimsl'.
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
      **** rel 6.2
      *    RECORD 113 DATA RECORD RF-LAV.
           RECORD 121 DATA RECORD RF-LAV.
      ************
       01  RF-LAV.
           05 KEYLV.
             10 KLV-RAG    PIC 9.
      **** rel 6.2
      * utilizzati SOLO per ordinamento protocollo/data
             10 KLV-CATT3  PIC X.
             10 SKLV-NPRGI3.
                15 KLV-NPRGI3 PIC 9(5) COMP-3.
      ************
             10 KLV-DAT    PIC 9(5).
             10 KLV-ESER   PIC 9.
             10 KLV-TIPO   PIC X.
      **** rel 6.2
      * utilizzati SOLO per ordinamento data/protocollo
             10 KLV-CATT2  PIC X.
             10 SKLV-NPRGI2.
                15 KLV-NPRGI2  PIC 9(5) COMP-3.
      ************
             10 KLV-NREG   PIC 9(5).
             10 KLV-D-A    PIC X.
             10 KLV-NUM    PIC 9(5).
             10 KLV-CONTO  PIC 9(7) COMP-3.
             10 KLV-CAUS   PIC 999  COMP-3.
           05 KEYL2 REDEFINES KEYLV.
             10 KL2-RAG    PIC 9.
             10 KL2-NREG   PIC 9(5).
             10 KL2-ESER   PIC 9.
             10 KL2-TIPO   PIC X.
             10 KL2-DAT    PIC 9(5).
             10 KL2-D-A    PIC X.
             10 KL2-NUM    PIC 9(5).
             10 KL2-CONTO  PIC 9(7) COMP-3.
             10 KL2-CAUS   PIC 999  COMP-3.
      **** rel 6.2
             10 FILLER     PIC X(8).
      ************
           05 LAV-D-A      PIC X.
           05 LAV-TREG     PIC 9.
           05 LAV-IMPO     PIC S9(11)V99 COMP-3.
           05 LAV-NDOC     PIC 9(5) COMP-3.
           05 LAV-DTDOC    PIC 9(5) COMP-3.
           05 LAV-DTSCD    PIC 9(5) COMP-3.
           05 LAV-NPRGI    PIC 9(5) COMP-3.
           05 LAV-FLAG     PIC 9.
           05 LAV-DSAGG    PIC X(30).
           05 LAV-PART     PIC 9(7) COMP-3.
           05 LAV-REG      PIC 9.
           05 LAV-VALUT    PIC 999.
           05 LAV-CAMGG    PIC 9(5)V9(6).
           05 LAV-IMVAL    PIC S9(11)V99.
           05 LAV-CCOST    PIC XXXX.
       FD  WDSLA1 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA1
           RECORD 135 DATA RECORD RF-LA1.
       01  RF-LA1.
           05 LA1-REC.
              10 KEYL1.
                 15 KL1-REG PIC 9(5).
                 15 KL1-DAT PIC 9(5) COMP-3.
                 15 KL1-AZI PIC 999.
                 15 KL1-NUM PIC 9(5) COMP-3.
                 15 KL1-CON PIC 9(7) COMP-3.
              10 LA1-CAUS   PIC 999  COMP-3.
              10 LA1-D-A    PIC X.
              10 LA1-TREG   PIC 9.
              10 LA1-IMPO   PIC S9(11)V99 COMP-3.
              10 LA1-NDOC   PIC 9(5) COMP-3.
              10 LA1-DTDOC  PIC 9(5) COMP-3.
              10 LA1-DTSCD  PIC 9(5) COMP-3.
              10 LA1-NPRGI  PIC 9(5) COMP-3.
              10 LA1-FLAG   PIC 9.
              10 LA1-FILL1.
                 15 LA1-IVA PIC 999.
                 15 LA1-ACF PIC 9(7) COMP-3.
                 15 LA1-TIP PIC 9.
                 15 LA1-IMP PIC S9(11)V99.
                 15 LA1-IVN PIC S9(11)V99.
              10 LA1-FILL2 REDEFINES LA1-FILL1.
                 15 LA1-DSAGG PIC X(30).
                 15 FILLER    PIC X(4).
              10 LA1-DSCEE REDEFINES LA1-FILL1.
                 15 FILLER  PIC X(8).
                 15 LA1-IMV PIC S9(11)V99 COMP-3.
                 15 LA1-IML PIC S9(11)V99 COMP-3.
                 15 LA1-INL PIC S9(11)V99 COMP-3.
                 15 LA1-VAL PIC 9(3)      COMP-3.
                 15 FILLER  PIC X(3).
              10 LA1-PART   PIC 9(7) COMP-3.
              10 LA1-NREG   PIC 9(5).
              10 LA1-CATT   PIC X.
              10 LA1-FEV    PIC 9.
              10 LA1-PLAF. 
                 15 LA1-MES PIC 99.
                 15 LA1-ANN PIC 9.
              10 LA1-VALUT  PIC 9(3).
              10 LA1-CAMGG  PIC 9(5)V9(6).
              10 LA1-IMVAL  PIC S9(11)V99.
              10 LA1-CCOST  PIC X(4).
              10 LA1-TST    PIC 9.
              10 FILLER     PIC X(13).
           05 LA2-REC REDEFINES LA1-REC.
              10 KEYA2.
                 15 LA2-REG PIC 9(5).
              10 LA2REC PIC X(130).
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parps'.
           COPY 'gritabrk'.
           COPY 'grimovrk'.                                        
           COPY 'grimolrk'.                                        
           COPY 'griconrk'.
           COPY 'grit20rk'.
           COPY 'grit14g'.
           COPY 'griazirk'.                                        
           COPY 'parer'.
           COPY 'parmb'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-MSZ PIC X(15) VALUE 'movsez'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  ID-LA1 PIC X(15) VALUE 'wdsla1'.
       01  ID-MOL PIC X(15) VALUE 'movmol'.
       01  ID-MSL PIC X(15) VALUE 'movsol'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-CON  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-MOV  PIC XX.
           05 SF-MSZ  PIC XX.
           05 SF-LAV  PIC XX.
           05 SF-LA1  PIC XX.
           05 SF-MOL  PIC XX.
           05 SF-MSL  PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 CIVAV   PIC 9(7) VALUE ZERO.
           05 CIVAQ   PIC 9(7) VALUE ZERO.
           05 FIVAV   PIC 9    VALUE ZERO.
           05 FIVAQ   PIC 9    VALUE ZERO.
           05 COMCON  PIC 9(7) VALUE ZERO.
           05 MCLI    PIC 99.
           05 MFOR    PIC 99.
           05 CLF-COD PIC 9(7).
           05 CFACD REDEFINES CLF-COD.
              10 CFMS PIC 99.
              10 CFCD PIC 9(5).
           05 DAT1    PIC 9(5) COMP-3 VALUE ZERO.
           05 DAT2    PIC 9(5) COMP-3 VALUE ZERO.
           05 CRPCL   PIC 9(7).
           05 CRPC1   PIC 9(7).
           05 CRPC2   PIC 9(7).
           05 CRPFR   PIC 9(7).
           05 CRPF1   PIC 9(7).
           05 CRPF2   PIC 9(7).
           05 TOTPGD  PIC S9(12)V99 VALUE ZERO.
           05 TOTPGA  PIC S9(12)V99 VALUE ZERO.
           05 TOTPRD  PIC S9(12)V99 VALUE ZERO.
           05 TOTPRA  PIC S9(12)V99 VALUE ZERO.
           05 COMNREG PIC 9(5)   VALUE ZERO.
           05 SAVRIG  PIC X(132) VALUE SPACE.
           05 RAG     PIC 9      VALUE ZERO.
           05 NREG    PIC 9(5)   VALUE ZERO.
           05 CLAV    PIC 9(7)   VALUE ZERO.
           05 KONCA   PIC 999.
           05 POSIZ   PIC 999.
           05 CONCAIN PIC X(36).
           05 CONCOUT.
              10 WDSK21 PIC X(61).
              10 WDSK22 PIC X(61).
              10 WDSK23 PIC X(61).
           05 COMCOUT.
              10 FILLER PIC X(61).
              10 FILLER PIC X(61).
              10 FILLER PIC X(61).
           05 COMEURO PIC 9(3).
           05 SAVDAT   PIC 9(5) VALUE ZERO.
           05 FLGOK   PIC 9    VALUE ZERO.
           05 X       PIC 99   VALUE ZERO.
           05 CAUS    PIC 999  VALUE ZERO.
           05 DTREG   PIC 9(5) VALUE ZERO.
           05 SVKEYL1.
              10 SV-KL1-REG PIC 9(5).
              10 SV-KL1-AZI PIC 999.
              10 SV-KL1-NUM PIC 9(5) COMP-3.
              10 SV-KL1-DAT PIC 9(5) COMP-3.
              10 SV-KL1-CON PIC 9(7) COMP-3.
      * righe scritte e logiche per visuale
           05 NRGLV    PIC 9(2) VALUE 40.
      **** rel 6.2
           05 FLGES    PIC 9.
           05 SAVKEY   PIC X(50).
           05 CONTO    PIC 9(7).
           05 DTDOC    PIC 9(5).
           05 NDOC     PIC 9(5).
      ************

           COPY 'vcon123.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-DATA-1    PIC 9(6).
           05 IF-DATA-2    PIC 9(6).
           05 IF-REG-1     PIC 9(5).
           05 IF-REG-2     PIC 9(5).
           05 IF-TPRAG     PIC 9.
           05 IF-TPSTA     PIC 9.
           05 IF-TPVAL     PIC 9.
           05 IF-CAUX.
              10 IF-CAU-1     PIC 9(3).
              10 IF-CAU-2     PIC 9(3).
              10 IF-CAU-3     PIC 9(3).
              10 IF-CAU-4     PIC 9(3).
              10 IF-CAU-5     PIC 9(3).
              10 IF-CAU-6     PIC 9(3).
              10 IF-CAU-7     PIC 9(3).
              10 IF-CAU-8     PIC 9(3).
              10 IF-CAU-9     PIC 9(3).
              10 IF-CAU-10    PIC 9(3).
           05 IF-CAUV REDEFINES IF-CAUX PIC 9(3) OCCURS 10.
           05 IF-TIPO      PIC 9.
           05 IF-CDCON-1   PIC 9(7).
           05 IF-CDCON-2   PIC 9(7).
      **** rel 6.2
           05 IF-FLGATT    PIC 9.
           05 IF-CLI-1   PIC 9(5).
           05 IF-CLI-2   PIC 9(5).
           05 IF-FOR-1   PIC 9(5).
           05 IF-FOR-2   PIC 9(5).
      ************
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcltab'.
           COPY 'dclcon'.
           COPY 'dclclf'.
           COPY 'dclmov'.
           COPY 'dclmsz'.
           COPY 'dclmol'.
           COPY 'dclmsl'.
           COPY 'dcllav'.
           COPY 'dclla1'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon123: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE ANACON.
           CLOSE ANACLF.
           CLOSE WDSLAV.
           CLOSE WDSLA1.
           OPEN OUTPUT WDSLAV WDSLA1.
           CLOSE WDSLAV.
           CLOSE WDSLA1.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gritaber'.
           COPY 'griconer'.
           COPY 'griclfer'.
           COPY 'grimover'.
           COPY 'grimszer'.
           COPY 'grimoler'.
           COPY 'grimsler'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV WDSLA1.
           CLOSE WDSLAV WDSLA1.
           OPEN I-O   WDSLAV WDSLA1.
      *
           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'tabell' TO ID-TAB
                           MOVE 'anacon' TO ID-CON
                           MOVE 'anaclf' TO ID-CLF
                           MOVE 'movime' TO ID-MOV
                           MOVE 'movsez' TO ID-MSZ.
           IF IF-FL = 1    MOVE 'anazol' TO ID-AZI
                           MOVE 'tabold' TO ID-TAB
                           MOVE 'anacol' TO ID-CON
                           MOVE 'anacfx' TO ID-CLF
                           MOVE 'movmol' TO ID-MOV
                           MOVE 'movsol' TO ID-MSZ.
      *
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN INPUT ANACON.
           OPEN INPUT ANACLF.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
              PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MCLI.
           MOVE T01-MFOR TO MFOR.
           MOVE T01-CRPCL TO CRPCL.
           MOVE T01-CRPC1 TO CRPC1.
           MOVE T01-CRPC2 TO CRPC2.
           MOVE T01-CRPFR TO CRPFR.
           MOVE T01-CRPF1 TO CRPF1.
           MOVE T01-CRPF2 TO CRPF2.
           MOVE T01-CIVAV TO CIVAV.
           MOVE T01-CIVAQ TO CIVAQ.
           MOVE 14 TO KTB-TIP.
           MOVE 7  TO KTB-COD.
           READ TABELL INTO RKTB14G INVALID PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB14G.
           MOVE 20 TO KTB-TIP.
           MOVE 1  TO KTB-COD.
           READ TABELL INTO RKTB20 INVALID PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB20.
      *
           CALL 'rveur' USING COMEURO.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
           MOVE ZERO    TO IF-DATA-1 IF-DATA-2 IF-TPSTA IF-TPVAL 
                           IF-TPRAG IF-REG-1.
           MOVE 99999   TO IF-REG-2.
           MOVE ZERO TO IF-CAU-1 IF-CAU-2 IF-CAU-3
                        IF-CAU-4 IF-CAU-5 IF-CAU-6
                        IF-CAU-7 IF-CAU-8 IF-CAU-9 IF-CAU-10.
           MOVE 1    TO IF-TIPO.
           MOVE ZERO TO IF-CDCON-1.
           MOVE 9999999 TO IF-CDCON-2.
      **** rel 6.2
           MOVE ZERO    TO IF-FLGATT.
           MOVE ZERO    TO IF-CLI-1.
           MOVE ZERO    TO IF-FOR-1.
           MOVE 99999   TO IF-CLI-2.
           MOVE 99999   TO IF-FOR-2.
      ************
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DATA-1.
           MOVE 'IF-DATA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DAT1.
           IF IF-FL = 1
              IF AAGGG < AZI-DTAPE
                 MOVE "Data inferiore alla data apertura" TO MESS
                 GO TO V-ERROR.
       E-DATA-1.
      *
       V-DATA-2.
           MOVE 'IF-DATA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DAT2.
           IF DAT2 < DAT1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DATA-2.
      **** rel 6.2
      *
       V-CLI.
           MOVE 'IF-CLI' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CLI.
           IF IF-CLI-2 < IF-CLI-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-CLI.
      *
       V-FOR.
           MOVE 'IF-FOR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FOR.
           IF IF-FOR-2 < IF-FOR-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-FOR.
      ************
      *
       V-REG-1.
           MOVE 'IF-REG-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-REG-1.
       E-REG-1.
      *
       V-REG-2.
           MOVE 'IF-REG-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-REG-2.
           IF IF-REG-2 < IF-REG-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-REG-2.

       V-CDCON-2.
           MOVE 'IF-CDCON-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDCON-2.
           IF IF-CDCON-2 < IF-CDCON-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-CDCON-2.
      *
       V-TPRAG.
           MOVE 'IF-TPRAG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPRAG.
           IF NOT (IF-TPRAG = ZERO OR 1 OR 2 OR 3)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-TPRAG.
      *
       V-TPSTA.
           MOVE 'IF-TPSTA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPSTA.
      **** rel 6.2
      *    IF NOT (IF-TPSTA = ZERO OR 1)
           IF NOT (IF-TPSTA = ZERO OR 1 OR 2 OR 3)
      ************
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-TPSTA.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           COPY 'grirpt-sn' REPLACING 1 BY 2
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           COPY 'grirpt-sn' REPLACING 1 BY 3
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-3.
      *
           COPY 'grirpt-sn' REPLACING 1 BY 4
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-4.
      *
           COPY 'grirpt-sn' REPLACING 1 BY 5
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-5.
      *

      * 
           IF RP-TRPT = ZERO 
              MOVE 'E'' possibile stampare il Report' TO F-MES1
              MOVE 'solo a carattere o visuale.'     TO F-MES2
              MOVE 'Forzato visuale.' TO F-MES3
              MOVE 3 TO F-NMES
              MOVE 'W' TO MB-TIPO
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO RP-TRPT.
      *
           MOVE KAZ-COD TO KPC-AZI.
           MOVE CIVAV   TO KPC-COD.
           READ ANACON INTO REKCON INVALID PERFORM INVK-CON
                                           GO TO ERRIO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-FLRIE TO FIVAV.
           MOVE CIVAQ   TO KPC-COD.
           READ ANACON INTO REKCON INVALID PERFORM INVK-CON
                                           GO TO ERRIO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-FLRIE TO FIVAQ.
           MOVE ZERO TO CLAV.
           IF IF-FL = 1 GO TO MSZ10.
           OPEN INPUT MOVSEZ.
           MOVE LOW-VALUE TO KEYMS.
           MOVE KAZ-COD TO KMS-AZI.
       LPE0.
           MOVE ZERO TO KMS-NUM.
           START MOVSEZ KEY NOT < KEYMS INVALID GO TO MSZ5.
       LPES.
           READ MOVSEZ NEXT INTO REKMOV AT END GO TO MSZ5.
           IF SF-MSZ = '9D' OR '9A' OR '35' GO TO LPES.
           IF KMS-AZI > KAZ-COD GO TO MSZ5.
           IF KMS-DAT < DAT1 MOVE DAT1 TO KMS-DAT GO TO LPE0.
           IF KMS-DAT > DAT2 MOVE 99999 TO KMS-DAT GO TO LPE0.
           IF KS2-NREG < IF-REG-1 OR > IF-REG-2 GO TO LPES.
           MOVE MOV-CAUS TO CAUS.
           PERFORM CONTROLLA-CAUS THRU C99.
           IF FLGOK = ZERO GO TO LPES.
           MOVE KS2-NREG TO KL1-REG.
           MOVE RF-MSZ TO LA2REC.
           MOVE KMS-AZI TO KL1-AZI.
           MOVE KMS-NUM TO KL1-NUM.
           MOVE KMS-DAT TO KL1-DAT.
           MOVE KMS-CON TO KL1-CON.
           MOVE 1 TO LA1-TST.
           WRITE RF-LA1 INVALID KEY MOVE 'WR.LA1' TO MESS
                                              GO TO ERRIO.
      *
           COPY 'grirpt-r' REPLACING 1 BY 5
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-5.
      *
           GO TO LPES.
       MSZ5.
           CLOSE MOVSEZ.
       MSZ10.
           OPEN INPUT MOVSOL.
           MOVE LOW-VALUE TO KEYSL.
           MOVE KAZ-COD TO KSL-AZI.
       MSZ15.
           MOVE ZERO TO KSL-NUM.
           START MOVSOL KEY NOT < KEYSL INVALID GO TO LPGEN.
       LPESOL.
           READ MOVSOL NEXT INTO REKMOV AT END GO TO LPGEN.
           IF SF-MSL = '9D' OR '9A' OR '35' GO TO LPESOL.
           IF KSL-AZI > KAZ-COD GO TO LPGEN.
           IF KSL-DAT < DAT1 MOVE DAT1 TO KSL-DAT GO TO MSZ15.
           IF KSL-DAT > DAT2 MOVE 99999 TO KSL-DAT GO TO MSZ15.
           IF KSL2-NREG < IF-REG-1 OR > IF-REG-2 GO TO LPESOL.
           MOVE MOV-CAUS TO CAUS.
           PERFORM CONTROLLA-CAUS THRU C99.
           IF FLGOK = ZERO GO TO LPESOL.
           MOVE KSL2-NREG TO KL1-REG.
           MOVE RF-MSL TO LA2REC.
           MOVE KSL-AZI TO KL1-AZI.
           MOVE KSL-NUM TO KL1-NUM.
           MOVE KSL-DAT TO KL1-DAT.
           MOVE KSL-CON TO KL1-CON.
           MOVE 2 TO LA1-TST.
           WRITE RF-LA1 INVALID KEY MOVE 'WR.LA1' TO MESS
                                              GO TO ERRIO.
      *
           COPY 'grirpt-r' REPLACING 1 BY 4
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-4.
      *
           GO TO LPESOL.
       LPGEN.
           CLOSE MOVSOL.
           IF IF-FL = 1 GO TO EXES.
      **** rel 6.2
           OPEN INPUT MOVSEZ.
      ************
           OPEN INPUT MOVIME.
           MOVE ZERO TO COMCON.
           MOVE LOW-VALUE TO KEYMV.
           MOVE KAZ-COD TO KMV-AZI.
       STMOV.
           MOVE ZERO TO KMV-NUM.
           START MOVIME KEY NOT < KEYMV INVALID GO TO EXES0.
       RDMOV.
           READ MOVIME NEXT INTO REKMOV AT END GO TO EXES0.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO RDMOV.
           IF KMV-AZI > KAZ-COD GO TO EXES0.
           IF KMV-DAT < DAT1 MOVE DAT1 TO KMV-DAT GO TO STMOV.
           IF KMV-DAT > DAT2 MOVE 99999 TO KMV-DAT GO TO STMOV.
           IF KM2-NREG < IF-REG-1 OR > IF-REG-2 GO TO RDMOV.
           MOVE MOV-CAUS TO CAUS.
           PERFORM CONTROLLA-CAUS THRU C99.
           IF FLGOK = ZERO GO TO RDMOV.
           IF KMV-NUM < 99991 GO TO RDMOV1.
           IF KMV-CON = CRPCL GO TO RDMOV.
           IF KMV-CON = CRPC1 GO TO RDMOV.
           IF KMV-CON = CRPC2 GO TO RDMOV.
           IF KMV-CON = T14-CRPC3 GO TO RDMOV.
           IF KMV-CON = T14-CRPC4 GO TO RDMOV.
           IF KMV-CON = T14-CRPC5 GO TO RDMOV.
           IF KMV-CON = T14-CRPC6 GO TO RDMOV.
           IF KMV-CON = T14-CRPC7 GO TO RDMOV.
           IF KMV-CON = T14-CRPC8 GO TO RDMOV.
           IF KMV-CON = CRPFR GO TO RDMOV.
           IF KMV-CON = CRPF1 GO TO RDMOV.
           IF KMV-CON = CRPF2 GO TO RDMOV.
           IF KMV-CON = T14-CRPF3 GO TO RDMOV.
           IF KMV-CON = T14-CRPF4 GO TO RDMOV.
           IF KMV-CON = T14-CRPF5 GO TO RDMOV.
           IF KMV-CON = T14-CRPF6 GO TO RDMOV.
           IF KMV-CON = T14-CRPF7 GO TO RDMOV.
           IF KMV-CON = T14-CRPF8 GO TO RDMOV.
       RDMOV1.
           MOVE KM2-NREG TO KL1-REG.
           MOVE RF-MOV TO LA2REC.
           MOVE KMV-AZI TO KL1-AZI.
           MOVE KMV-NUM TO KL1-NUM.
           MOVE KMV-DAT TO KL1-DAT.
           MOVE KMV-CON TO KL1-CON.
           MOVE 3 TO LA1-TST.
           WRITE RF-LA1 INVALID KEY MOVE 'WR.LA1' TO MESS
                                              GO TO ERRIO.
      *
           COPY 'grirpt-r' REPLACING 1 BY 3
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-3.
      *
           GO TO RDMOV.
       EXES0.
           CLOSE MOVIME.
      **** rel 6.2
           CLOSE MOVSEZ.
      ************
       EXES.
      **** rel 6.2
           OPEN INPUT MOVSOL.
      ************
           OPEN INPUT MOVMOL.
           MOVE ZERO TO COMCON.
           MOVE LOW-VALUE TO KEYML.
           MOVE KAZ-COD TO KML-AZI.
       STMOL.
           MOVE ZERO TO KML-NUM.
           START MOVMOL KEY NOT < KEYML INVALID KEY GO TO EXES1.
       LPMOL.
           READ MOVMOL NEXT INTO REKMOL AT END GO TO EXES1.
           IF SF-MOL = '9D' OR '9A' OR '35' GO TO LPMOL.
           IF KML-AZI > KAZ-COD GO TO EXES1.
           IF KML-DAT < DAT1 MOVE DAT1 TO KML-DAT GO TO STMOL.
           IF KML-DAT > DAT2 MOVE 99999 TO KML-DAT GO TO STMOL.
           IF KML2-NREG < IF-REG-1 OR > IF-REG-2 GO TO LPMOL.
           MOVE MOL-CAUS TO CAUS.
           PERFORM CONTROLLA-CAUS THRU C99.
           IF FLGOK = ZERO GO TO LPMOL.
           IF KML-NUM < 99991 GO TO RDMOL1.
           IF KML-CON = CRPCL GO TO LPMOL.
           IF KML-CON = CRPC1 GO TO LPMOL.
           IF KML-CON = CRPC2 GO TO LPMOL.
           IF KML-CON = T14-CRPC3 GO TO LPMOL.
           IF KML-CON = T14-CRPC4 GO TO LPMOL.
           IF KML-CON = T14-CRPC5 GO TO LPMOL.
           IF KML-CON = T14-CRPC6 GO TO LPMOL.
           IF KML-CON = T14-CRPC7 GO TO LPMOL.
           IF KML-CON = T14-CRPC8 GO TO LPMOL.
           IF KML-CON = CRPFR GO TO LPMOL.
           IF KML-CON = CRPF1 GO TO LPMOL.
           IF KML-CON = CRPF2 GO TO LPMOL.
           IF KML-CON = T14-CRPF3 GO TO LPMOL.
           IF KML-CON = T14-CRPF4 GO TO LPMOL.
           IF KML-CON = T14-CRPF5 GO TO LPMOL.
           IF KML-CON = T14-CRPF6 GO TO LPMOL.
           IF KML-CON = T14-CRPF7 GO TO LPMOL.
           IF KML-CON = T14-CRPF8 GO TO LPMOL.
       RDMOL1.
           MOVE KML2-NREG TO KL1-REG.
           MOVE RF-MOL TO LA2REC.
           MOVE KML-AZI TO KL1-AZI.
           MOVE KML-NUM TO KL1-NUM.
           MOVE KML-DAT TO KL1-DAT.
           MOVE KML-CON TO KL1-CON.
           MOVE 4 TO LA1-TST.
           WRITE RF-LA1 INVALID KEY MOVE 'WR.LA1' TO MESS
                                              GO TO ERRIO.
      *
           COPY 'grirpt-r' REPLACING 1 BY 2
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           GO TO LPMOL.
       EXES1.
           CLOSE MOVMOL.
      **** rel 6.2
           CLOSE MOVSOL.
      ************
           MOVE ZERO TO KL1-REG.
       STLA1.
           MOVE ZERO TO KL1-AZI KL1-NUM KL1-DAT KL1-CON.
           START WDSLA1 KEY NOT < KEYL1 INVALID GO TO STAM.
       RDLA1.
           READ WDSLA1 NEXT AT END GO TO STAM.
       TSLA1.
           IF IF-TPRAG < 2 AND LA1-TST > 2 GO TO RDLA1.
           MOVE KL1-CON TO CLF-COD.
           IF ( IF-TPRAG = 0 AND CFMS NOT = MFOR ) OR
              ( IF-TPRAG = 1 AND CFMS NOT = MCLI ) 
                             GO TO RDLA1.
      **** rel 6.2
           IF CFMS = MFOR
              IF CFCD < IF-FOR-1 OR > IF-FOR-2 GO TO RDLA1.
           IF CFMS = MCLI
              IF CFCD < IF-CLI-1 OR > IF-CLI-2 GO TO RDLA1.
      ************
           MOVE 2 TO KTB-TIP.
           MOVE LA1-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                       PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF ( IF-TPRAG < 2 AND NOT ( T02-TIPOP = 1 OR 8 ) ) OR
              ( IF-TPRAG = 2 AND ( T02-TIPOP = 1 OR 8 ) )
                             GO TO RDLA1.
           MOVE KL1-REG TO NREG.
           MOVE KL1-DAT TO DTREG.
           PERFORM VERIFICA-REG THRU EX-VERIFICA-REG.
           IF FLGOK = ZERO ADD 1 TO KL1-REG GO TO STLA1.
           MOVE KL1-REG TO NREG.
           MOVE 3 TO RAG.
           IF LA1-TST < 3 AND ( T02-TIPOP = 1 OR 8 )
                          AND CFMS = MFOR MOVE 1 TO RAG.
           IF LA1-TST < 3 AND ( T02-TIPOP = 1 OR 8 )
                          AND CFMS = MCLI MOVE 2 TO RAG.
       AGLA1.
           PERFORM A00-AGG-WDS THRU A99.
           DELETE WDSLA1.
       RDLA2.
           READ WDSLA1 NEXT AT END GO TO STAM.
           IF KL1-REG NOT = NREG  OR
              KL1-REG = NREG AND KL1-DAT NOT = DTREG
              GO TO TSLA1.
           GO TO AGLA1.
       STAM.
           IF CLAV = ZERO GO TO EX-RUN-ELABORA.
           MOVE ZERO TO RAG.
           MOVE ZERO TO XCRR TOTPGD TOTPGA TOTPRD TOTPRA COMNREG.
           MOVE ZERO TO SAVDAT.
      *
           MOVE AZRGSOC TO RT01.
           MOVE DAT1 TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DATIN.
           MOVE DAT2 TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DATFI.
           MOVE SPACE  TO RTIP.
      *
      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 64      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 3       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
           MOVE C-TINT3 TO XTINT(3).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'BROGLIACCIO DI PRIMA NOTA DAL ' DATIN  'AL ' DATFI
                  DELIMITED SIZE INTO RP-TIT1.
      *
           MOVE RTIP TO RP-TIT2.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG1-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
      *
           MOVE KAZ-COD TO KPC-AZI.
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID GO TO ENDA.
       LOPM.
           READ WDSLAV NEXT AT END GO TO ENDA.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO LOPM.
           IF RAG = ZERO MOVE KLV-RAG TO RAG.
           PERFORM RLIB THRU EX-RLIB.
           DELETE WDSLAV.
      *
           COPY 'grirpt-r'.
      *
           GO TO LOPM.
       ENDA.
           PERFORM STA-TOT THRU EX-STA-TOT.
      *
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV ID-LA1.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
           STRING 'w2' PID DELIMITED SPACE INTO ID-LA1.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       RST.
           IF KLV-RAG = 1
              MOVE 'A C Q U I S T I' TO RTIP
           ELSE
              IF KLV-RAG = 2
                 MOVE 'V E N D I T E '  TO RTIP
              ELSE
                 IF KLV-RAG = 3
                    MOVE 'C O N T A B I L I T A''  G E N E R A L E'
                                                           TO RTIP.
      *-- inizializza parametri per stampa a caratteri --*
           MOVE C-TINT1 TO XTINT(1).
      *--------------------------------------------------*
      *-- inizializza parametri per stampa report --*
           MOVE RTIP TO RP-TIT2.
      *---------------------------------------------*

           IF RP-TRPT = 2 AND
              (KLV-RAG NOT = RAG OR
               NRIG NOT < (NRGL - 6))
                 PERFORM STA-TOT THRU EX-STA-TOT.

           IF RP-TRPT = 1 AND
              (KLV-RAG NOT = RAG OR
               RP-NRIGG NOT < (NRGLV - 2))
                 PERFORM STA-TOT THRU EX-STA-TOT.

           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
       EX-RST.
           EXIT.
      *-------------*
       RLIB.
      *    IF XCRR NOT = ZERO
      **** rel 6.2
      *       IF (IF-TPSTA = ZERO AND
              IF (IF-TPSTA NOT = 1 AND
      ************
                  KLV-DAT NOT = SAVDAT) OR
                 (IF-TPSTA = 1  AND
                  COMNREG NOT = KL2-NREG)
                     PERFORM RST THRU EX-RST.

      **** rel 6.2
      *    IF IF-TPSTA = ZERO
           IF IF-TPSTA NOT = 1
      ************
              IF COMNREG NOT = KLV-NREG
                 MOVE KLV-NREG TO RREG
              END-IF
              MOVE KLV-NREG TO COMNREG
              MOVE KLV-DAT TO SAVDAT.

           IF IF-TPSTA = 1
              IF COMNREG NOT = KL2-NREG
                 MOVE KL2-NREG TO RREG
              END-IF
              MOVE KL2-NREG TO COMNREG.

           MOVE KLV-NUM TO RNUM.
      **** rel 6.2
      *    IF IF-TPSTA = ZERO MOVE KLV-DAT TO AAGGG
           IF IF-TPSTA NOT = 1 MOVE KLV-DAT TO AAGGG
      ************
                         ELSE MOVE KL2-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GMMMA TO RG1.
           MOVE 2 TO KTB-TIP.
           MOVE KLV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                       MOVE '********' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF LAV-REG > 1 GO TO RLIB10.
           MOVE KLV-CONTO TO KPC-COD.
           MOVE KAZ-COD TO KPC-AZI.
           READ ANACON INVALID KEY
                MOVE '********' TO CON-DSC.
           MOVE KLV-CONTO TO RG2.
           MOVE CON-DSC TO CONCOUT.
           GO TO LK0.
       RLIB10.
           MOVE KAZ-COD TO KCF-AZI.
           MOVE KLV-CONTO TO KCF-COD.
           READ ANACLF INVALID MOVE '********' TO CLF-RGS.
           MOVE KLV-CONTO TO RG2.
           MOVE CLF-RGS  TO CONCOUT.
           MOVE CLF-RGS2 TO CONCAIN.
           PERFORM CONCATENA.
       LK0.
           MOVE TAB-DESCR TO CONCAIN.
           PERFORM CONCATENA.
           IF LAV-FLAG NOT = ZERO
              MOVE LAV-DSAGG TO CONCAIN
              PERFORM CONCATENA.
           PERFORM ALLINEA.
       EX3.
           MOVE WDSK21 TO ERG.
           IF WDSK22 NOT = SPACE PERFORM RST THRU EX-RST
                                 MOVE WDSK22 TO ERG.
           IF WDSK23 NOT = SPACE PERFORM RST THRU EX-RST
                                 MOVE WDSK23 TO ERG.
           IF LAV-NPRGI NOT = ZERO
                  IF T02-TIPRG = 3 MOVE LAV-NPRGI TO ERG12
                  ELSE
                  IF LAV-NPRGI NOT = LAV-NDOC
                      MOVE LAV-NPRGI TO ERG12.
           MOVE LAV-NDOC TO RG5.
           IF LAV-DTDOC > ZERO MOVE LAV-DTDOC TO AAGGG
                               CALL 'rdata' USING PARCDT
                               MOVE GBMMBA TO RG7.
           IF T02-TIPRG = 1 AND T02-FLDOC = 1
                               MOVE ZERO TO RG5 ERG12
                               MOVE SPACE TO RG7.
           IF LAV-D-A = 'D'    MOVE LAV-IMPO TO RG8 RGVD
           ELSE                MOVE LAV-IMPO TO RG9 RGVA.
           MOVE LAV-CCOST TO RCCOST.
           PERFORM RST THRU EX-RST.
           IF IF-TPVAL NOT = 1 GO TO NOVAL.
           IF (LAV-VALUT = ZERO OR COMEURO ) GO TO NOVAL.
           IF LAV-D-A = 'D' MOVE LAV-IMVAL TO RG8 RGVD
           ELSE             MOVE LAV-IMVAL TO RG9 RGVA.
           IF LAV-VALUT = 1 
              IF LAV-D-A = 'D'    MOVE LAV-IMVAL TO RG8V RGVDV
              ELSE                MOVE LAV-IMVAL TO RG9V RGVAV.
           MOVE 10 TO KTB-TIP.
           MOVE LAV-VALUT TO KTB-COD.
           READ TABELL INTO RKTB10 INVALID MOVE ALL '*' TO T10-DSINT.
           MOVE T10-DSINT TO RG5V.
           MOVE LAV-CAMGG TO EC-CAMBIO.
           CALL 're2cam' USING EC-PAR.
           MOVE EC-XCAMBIO TO RG7.
           PERFORM RST THRU EX-RST.
       NOVAL.
           IF LAV-D-A = 'D'    ADD LAV-IMPO TO TOTPGD TOTPRD
           ELSE                ADD LAV-IMPO TO TOTPGA TOTPRA.
       EX-RLIB.
           EXIT.
      *-------------*
       A00-AGG-WDS.
           MOVE RAG TO KLV-RAG.
           IF LA1-TST = 2 GO TO A20.
           IF LA1-TST = 3 GO TO A30.
           IF LA1-TST = 4 GO TO A40.
           MOVE 1 TO KLV-ESER.
       A10.
           MOVE 'A' TO KLV-TIPO.
           IF LA1-CAUS = T20-CDCLA OR
              LA1-CAUS = T20-CACLA MOVE '2' TO KLV-TIPO.
           IF LA1-CAUS = T20-CDFOA OR
              LA1-CAUS = T20-CAFOA MOVE '7' TO KLV-TIPO.
           IF LA1-CAUS = T20-CDCLC OR
              LA1-CAUS = T20-CACLC MOVE 'I' TO KLV-TIPO.
           IF LA1-CAUS = T20-CDFOC OR
              LA1-CAUS = T20-CAFOC MOVE 'P' TO KLV-TIPO.
      **** rel 6.2
      *    IF IF-TPSTA = ZERO MOVE LA1-NREG TO KLV-NREG
           IF IF-TPSTA NOT = 1 MOVE LA1-NREG TO KLV-NREG
      ************
                         ELSE MOVE LA1-NREG TO KL2-NREG.
           IF LA1-D-A = 'A' MOVE 'A' TO KLV-D-A
           ELSE MOVE SPACE TO KLV-D-A.
           MOVE KL1-CON TO KLV-CONTO.
      **** rel 6.2
      *    IF IF-TPSTA = ZERO MOVE KL1-DAT TO KLV-DAT
           IF IF-TPSTA NOT = 1 MOVE KL1-DAT TO KLV-DAT
      ************
                         ELSE MOVE KL1-DAT TO KL2-DAT.
           MOVE KL1-NUM TO KLV-NUM.
           MOVE LA1-CAUS TO KLV-CAUS.
           MOVE LA1-D-A TO LAV-D-A.
           MOVE LA1-TREG TO LAV-TREG.
           MOVE LA1-IMPO TO LAV-IMPO.
           MOVE LA1-NDOC TO LAV-NDOC.
           MOVE LA1-DTDOC TO LAV-DTDOC.
           MOVE LA1-DTSCD TO LAV-DTSCD.
           MOVE LA1-NPRGI TO LAV-NPRGI.
      **** rel 6.2
           IF IF-TPSTA NOT = 1
              PERFORM COMPILA-PRGI THRU EX-COMPILA-PRGI.
      ************
           MOVE LA1-FLAG TO LAV-FLAG.
           MOVE LA1-DSAGG TO LAV-DSAGG.
           MOVE LA1-PART TO LAV-PART.
           MOVE LA1-VALUT TO LAV-VALUT.
           MOVE LA1-CAMGG TO LAV-CAMGG.
           MOVE LA1-IMVAL TO LAV-IMVAL.
           MOVE LA1-CCOST TO LAV-CCOST.
           MOVE 2 TO LAV-REG.
           WRITE RF-LAV INVALID KEY MOVE 'WR.LAV' TO MESS
                                              GO TO ERRIO.
           ADD 1 TO CLAV.
           GO TO A99.
       A20.
           MOVE ZERO TO KLV-ESER.
           GO TO A10.
       A30.
           MOVE ZERO TO COMCON.
           MOVE 1 TO KLV-ESER.
       A35.
           PERFORM B00-COMPILA-TIPO THRU B99.
           IF ( KL1-CON = CIVAV AND FIVAV = 1 ) OR 
              ( KL1-CON = CIVAQ AND FIVAQ = 1 )     
              MOVE ZERO TO LA1-NDOC LA1-DTDOC LA1-DTSCD
                           LA1-NPRGI LA1-PART LA1-TREG LA1-NREG
              MOVE SPACE TO LA1-DSAGG
              MOVE 99990 TO KL1-NUM
              MOVE 1     TO LA1-FLAG.
           IF LA1-D-A = 'A' MOVE 'A' TO KLV-D-A
           ELSE MOVE SPACE TO KLV-D-A.
      **** rel 6.2
      *    IF IF-TPSTA = ZERO MOVE LA1-NREG TO KLV-NREG
           IF IF-TPSTA NOT = 1 MOVE LA1-NREG TO KLV-NREG
      ************
                         ELSE MOVE LA1-NREG TO KL2-NREG.
           MOVE KL1-CON TO KLV-CONTO.
      **** rel 6.2
      *    IF IF-TPSTA = ZERO MOVE KL1-DAT TO KLV-DAT
           IF IF-TPSTA NOT = 1 MOVE KL1-DAT TO KLV-DAT
      ************
                         ELSE MOVE KL1-DAT TO KL2-DAT.
           MOVE KL1-NUM TO KLV-NUM.
           MOVE LA1-CAUS TO KLV-CAUS.
           READ WDSLAV INVALID MOVE ZERO TO LAV-IMPO.
           MOVE LA1-D-A TO LAV-D-A.
           MOVE LA1-TREG TO LAV-TREG.
           ADD  LA1-IMPO TO LAV-IMPO.
           MOVE LA1-NDOC TO LAV-NDOC.
           MOVE LA1-DTDOC TO LAV-DTDOC.
           MOVE LA1-DTSCD TO LAV-DTSCD.
           MOVE LA1-NPRGI TO LAV-NPRGI.
      **** rel 6.2
           IF IF-TPSTA NOT = 1
              PERFORM COMPILA-PRGI THRU EX-COMPILA-PRGI.
      ************
           MOVE LA1-FLAG TO LAV-FLAG.
           MOVE LA1-DSAGG TO LAV-DSAGG.
           MOVE LA1-PART TO LAV-PART.
           MOVE LA1-VALUT TO LAV-VALUT.
           MOVE LA1-CAMGG TO LAV-CAMGG.
           MOVE LA1-IMVAL TO LAV-IMVAL.
           MOVE LA1-CCOST TO LAV-CCOST.
           MOVE 1 TO LAV-REG.
           IF SF-LAV = ZERO 
              REWRITE RF-LAV INVALID MOVE 'RW LAV' TO MESS GO TO ERRIO
           ELSE WRITE RF-LAV INVALID MOVE 'WR LAV' TO MESS GO TO ERRIO.
           ADD 1 TO CLAV.
           GO TO A99.
       A40.
           MOVE ZERO TO COMCON.
           MOVE ZERO TO KLV-ESER.
           GO TO A35.
       A99.
           EXIT.
      *-------------*
       B00-COMPILA-TIPO.
           MOVE 'A' TO KLV-TIPO.
           IF NOT ( LA1-CAUS = T20-CDSOA OR T20-CASOA
                            OR T20-CDCLA OR T20-CACLA
                            OR T20-CDFOA OR T20-CAFOA) GO TO B20.
           IF KL1-CON NOT = T20-COBA GO TO B10.
           IF LA1-CAUS = T20-CASOA OR T20-CDCLA
                      OR T20-CDFOA MOVE '4' TO KLV-TIPO.
           IF LA1-CAUS = T20-CDSOA OR T20-CACLA
                      OR T20-CAFOA MOVE '5' TO KLV-TIPO.
           GO TO B99.
       B10.
           IF LA1-CAUS = T20-CDSOA AND
              KL1-CON  < CRPCL     MOVE '1' TO KLV-TIPO.
           IF LA1-CAUS = T20-CDSOA AND
              KL1-CON > T14-CRPC8 MOVE '3' TO KLV-TIPO.
           IF LA1-CAUS = T20-CASOA AND
              KL1-CON  < CRPFR     MOVE '6' TO KLV-TIPO.
           IF LA1-CAUS = T20-CASOA AND
              KL1-CON > T14-CRPF8 MOVE '8' TO KLV-TIPO.
           GO TO B99.
       B20.
           IF LA1-CAUS = T20-CUTIL MOVE 'G' TO KLV-TIPO GO TO B99.
           IF NOT ( LA1-CAUS = T20-CDSOC OR T20-CASOC
                            OR T20-CDCLC OR T20-CACLC
                            OR T20-CDFOC OR T20-CAFOC) GO TO B99.
           IF KL1-CON NOT = T20-COPP GO TO B30.
           IF LA1-CAUS = T20-CDSOC MOVE 'E' TO KLV-TIPO.
           IF LA1-CAUS = T20-CASOC MOVE 'F' TO KLV-TIPO.
           GO TO B99.
       B30.
           IF KL1-CON NOT = T20-COBC GO TO B40.
           IF LA1-CAUS = T20-CDSOC OR T20-CACLC
                      OR T20-CAFOC MOVE 'M' TO KLV-TIPO.
           IF LA1-CAUS = T20-CASOC OR T20-CDCLC
                      OR T20-CDFOC MOVE 'N' TO KLV-TIPO.
           GO TO B99.
       B40.
           IF KL1-CON = COMCON GO TO B45.
           MOVE KAZ-COD TO KPC-AZI.
           MOVE KL1-CON TO KPC-COD COMCON.
           READ ANACON INTO REKCON INVALID PERFORM INVK-CON
                                           GO TO ERRIO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
       B45.
           IF CON-TIPO NOT = 'E' GO TO B50.
           IF LA1-CAUS = T20-CDSOC MOVE 'C' TO KLV-TIPO.
           IF LA1-CAUS = T20-CASOC MOVE 'D' TO KLV-TIPO.
           GO TO B99.
       B50.
           IF LA1-CAUS = T20-CASOC AND 
              KL1-CON  < CRPCL     MOVE 'H' TO KLV-TIPO.
           IF LA1-CAUS = T20-CASOC AND
              KL1-CON  > T14-CRPC8 MOVE 'L' TO KLV-TIPO.
           IF LA1-CAUS = T20-CDSOC AND 
              KL1-CON  < CRPFR     MOVE 'O' TO KLV-TIPO.
           IF LA1-CAUS = T20-CDSOC AND
              KL1-CON  > T14-CRPF8 MOVE 'Q' TO KLV-TIPO.
       B99.
           EXIT.
      *-------------*
       CONCATENA.
           PERFORM VARYING KONCA FROM 183 BY -1
                   UNTIL CONCOUT(KONCA:1) NOT = SPACE OR KONCA = ZERO
                   CONTINUE.
           IF KONCA > ZERO ADD 1 TO KONCA.
           ADD 1 TO KONCA.
           IF KONCA NOT > 183 MOVE CONCAIN TO CONCOUT(KONCA:).
      * ---------------- *
       ALLINEA.
           MOVE 61 TO POSIZ.
           PERFORM SPEZZA THRU EX-SPEZZA.

           MOVE 122 TO POSIZ.
           PERFORM SPEZZA THRU EX-SPEZZA.
      * ---------------- *
       SPEZZA.
           IF CONCOUT(POSIZ + 1:) = SPACE GO TO EX-SPEZZA.
           IF CONCOUT(POSIZ + 1:1) NOT = SPACE GO TO SPEZZA-10.
           ADD 1 TO POSIZ.
           PERFORM VARYING KONCA FROM POSIZ BY 1
                   UNTIL CONCOUT(KONCA:1) NOT = SPACE
                   CONTINUE.
           SUBTRACT 1 FROM POSIZ.
           MOVE CONCOUT(1:POSIZ) TO COMCOUT.
           MOVE CONCOUT(KONCA:) TO COMCOUT(POSIZ + 1:).
           MOVE COMCOUT TO CONCOUT.
           GO TO EX-SPEZZA.
       SPEZZA-10.
           IF CONCOUT(POSIZ:1) = SPACE GO TO EX-SPEZZA.
           PERFORM VARYING KONCA FROM POSIZ BY -1
                   UNTIL CONCOUT(KONCA:1) = SPACE OR KONCA = ZERO
                   CONTINUE.
           IF KONCA = ZERO GO TO EX-SPEZZA.
           MOVE CONCOUT(1:KONCA) TO COMCOUT.
           MOVE CONCOUT(KONCA + 1:) TO COMCOUT(POSIZ + 1:).
           MOVE COMCOUT TO CONCOUT.
       EX-SPEZZA.
           EXIT.
      * ---------------- *
       CONTROLLA-CAUS.
           MOVE ZERO TO FLGOK.

           IF IF-TIPO = 1 MOVE 1 TO FLGOK
                          GO TO C99.

           MOVE ZERO TO X FLGOK.       
       LAZXX.
           ADD 1 TO X.       
           IF CAUS = IF-CAUV(X) 
              MOVE 1 TO FLGOK
              MOVE 10 TO X.
           IF X < 10 GO TO LAZXX.
       C99.
           EXIT.
      * ---------------- *
       VERIFICA-REG.
           MOVE ZERO TO FLGOK.

           IF NOT (KL1-CON < IF-CDCON-1 OR > IF-CDCON-2)
              MOVE 1 TO FLGOK 
              GO TO EX-VERIFICA-REG.

           IF NOT (LA1-PART < IF-CDCON-1 OR > IF-CDCON-2 )
              MOVE 1 TO FLGOK
              GO TO EX-VERIFICA-REG.


           MOVE KEYL1 TO SVKEYL1.
       RD-LA1.
           READ WDSLA1 NEXT AT END GO TO END-LA1.
           IF KL1-REG NOT = NREG GO TO END-LA1.

           IF NOT (KL1-CON < IF-CDCON-1 OR > IF-CDCON-2)
              MOVE 1 TO FLGOK 
              GO TO END-LA1.

           IF NOT (LA1-PART < IF-CDCON-1 OR > IF-CDCON-2 )
              MOVE 1 TO FLGOK
              GO TO END-LA1.

           GO TO RD-LA1.
       END-LA1.
           MOVE SVKEYL1 TO KEYL1.
           READ WDSLA1.
       EX-VERIFICA-REG.
           EXIT.
      * ---------------- *
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'N.RG.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Prg' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Data' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Conto' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione Movimento' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'C.C' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Prot.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'N.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Data' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Dare' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Avere' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
       STA-TOT.
           IF SAVDAT = ZERO AND COMNREG = ZERO GO TO EX-STA-TOT.
           IF RP-TRPT = 2 
              MOVE ALL '=' TO P999
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3' TO RP-BLK
              PERFORM RPT-WR
              MOVE 'TOTALI DI PAGINA....' TO RDTOT
              MOVE TOTPGD TO RTOTD
              MOVE 2 TO RP-FLGR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE TOTPGA TO RTOTA
              MOVE 2 TO RP-FLGR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 'TOTALI PROGRESSIVI..' TO RDTOT
              MOVE TOTPRD TO RTOTD
              MOVE 2 TO RP-FLGR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE TOTPRA TO RTOTA
              MOVE 2 TO RP-FLGR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE ALL '=' TO P999
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3' TO RP-BLK
              PERFORM RPT-WR
           ELSE
              MOVE 'TOTALI DI PAGINA' TO RDTOT
              MOVE TOTPGD TO RVTOTD
              MOVE TOTPGA TO RVTOTA
              MOVE 1 TO RP-FLGR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 'TOTALI PROGRESSIVI' TO RDTOT
              MOVE TOTPRD TO RVTOTD
              MOVE TOTPRA TO RVTOTA
              MOVE 1 TO RP-FLGR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR.

           MOVE ZERO TO TOTPGD TOTPGA.
           IF KLV-RAG NOT = RAG
              MOVE KLV-RAG TO RAG
              MOVE ZERO TO TOTPRD TOTPRA.
           MOVE 1 TO RP-JMP.
       EX-STA-TOT.
           EXIT.
      *------------------
      **** rel 6.2
       COMPILA-PRGI.
           MOVE ZERO TO KLV-CATT2  KLV-CATT3.
           MOVE ZERO TO KLV-NPRGI2 KLV-NPRGI3.
           IF IF-TPSTA = ZERO  GO TO EX-COMPILA-PRGI.
      *
      * utilizzati SOLO per ordinamento data/protocollo
           IF IF-TPSTA = 2 
              IF IF-FLGATT = 1 
                 MOVE LA1-CATT  TO KLV-CATT2
              ELSE 
                 MOVE ZERO      TO KLV-CATT2
              END-IF
              MOVE LA1-NPRGI TO KLV-NPRGI2
              IF KLV-NPRGI2 = ZERO MOVE HIGH-VALUE TO SKLV-NPRGI2.
      *
      * utilizzati SOLO per ordinamento protocollo/data
           IF IF-TPSTA = 3
              IF IF-FLGATT = 1 
                 MOVE LA1-CATT  TO KLV-CATT3
              ELSE 
                 MOVE ZERO      TO KLV-CATT3
              END-IF
              MOVE LA1-NPRGI TO KLV-NPRGI3
              IF KLV-NPRGI3 = ZERO MOVE HIGH-VALUE TO SKLV-NPRGI3.
      *
           IF KLV-CATT2 = SPACE MOVE ZERO TO KLV-CATT2.
           IF KLV-CATT3 = SPACE MOVE ZERO TO KLV-CATT3.
       EX-COMPILA-PRGI.
           EXIT.
      *------------------
      ************
