       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON141.
      * 
      * Stampa registro fatture in sospeso
      *        con sort per data e numero registrazione
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gritabsl'.
           COPY 'griclfsl'.
           COPY 'grimovsl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS 
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gritab'.
           COPY 'griclf'.
           COPY 'grimov'.   
       FD  WDSLAV LABEL RECORD STANDARD 
           VALUE OF FILE-ID ID-LAV
           RECORD 18 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
              10 KLV-DAT   PIC 9(5).
              10 KLV-NPRGI PIC 9(5) COMP-3.
              10 KLV-CDCLI PIC 9(7) COMP-3.
              10 KLV-IVA   PIC 999.
              10 KLV-NUM   PIC 9(5) COMP-3.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parmb'.
           COPY 'parpsb'.
           COPY 'parpv'.
           COPY 'griazirk'.
           COPY 'gritabrk'.
           COPY 'grit35rk'.
           COPY 'grit25rk'.
           COPY 'grimovrk'.  
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  COMODI.
           05 SF-AZI PIC XX.
           05 SF-TAB PIC XX.
           05 SF-CLF PIC XX.
           05 SF-MOV PIC XX.
           05 SF-LAV PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 K PIC 999 VALUE ZERO.
           05 N PIC 999 VALUE ZERO.
           05 DAT1 PIC 9(5) COMP-3.
           05 DAT2 PIC 9(5) COMP-3.
           05 COMCOD   PIC 9(7) COMP-3 VALUE ZERO.
           05 COMNPRGI PIC 9(5) COMP-3 VALUE ZERO.
           05 COMIVA   PIC 999    VALUE ZERO.
           05 COMIMP   PIC S9(11)V99 VALUE ZERO.
           05 COMIMPO  PIC S9(11)V99 VALUE ZERO.
           05 COMIVN   PIC S9(11)V99 VALUE ZERO.
           05 TOTIMP   PIC S9(11)V99 VALUE ZERO.
           05 TOTAIVA  PIC S9(11)V99 VALUE ZERO.
           05 TOTDOC   PIC S9(15)V99 VALUE ZERO.
           05 T25ESE   PIC 9      VALUE ZERO.
           05 MATCON   OCCURS 50.
              10 CODIVA PIC 9(3).
              10 IMPCON PIC S9(13)V99.
              10 IVACON PIC S9(13)V99.
              10 INDCON PIC S9(13)V99.
           05 K5        PIC 99.
           05 TTIMP     PIC S9(13)V99 VALUE ZERO.
           05 TTIVA     PIC S9(13)V99 VALUE ZERO.
           05 TTIND     PIC S9(13)V99 VALUE ZERO.
           05 FTRI      PIC 9 VALUE ZERO.
           05 SW        PIC 9 VALUE ZERO.
           05 CLAV PIC S9(11)V99.
           05 CLV1 PIC S9(11)V99.
           05 CLV2 PIC S9(11)V99.
           05 CIVA PIC 9(7) COMP-3.
           05 CONTA PIC 9(7) VALUE ZERO.

           COPY 'vcon141.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           05 IF-LMOD      PIC 99.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-DATA-1    PIC 9(6).
           05 IF-DATA-2    PIC 9(6).
           05 IF-FLSTA     PIC 9.
           05 IF-NBOL      PIC 9.
           05 IF-NUM-1     PIC 9(5).
           05 IF-ANNO      PIC 9(4).
           05 IF-PIEDE-1   PIC X(60).
           05 IF-PIEDE-2   PIC X(60).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcltab'.
           COPY 'dclclf'.
           COPY 'dclmov'.
           COPY 'dcllav'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon141: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE MOVIME.
           CLOSE ANACLF.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gritaber'.
           COPY 'griclfer'.
           COPY 'grimover'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O   WDSLAV.
      *
           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'tabell' TO ID-TAB
                           MOVE 'anaclf' TO ID-CLF
                           MOVE 'movime' TO ID-MOV.
           IF IF-FL = 1    MOVE 'anazol' TO ID-AZI
                           MOVE 'tabold' TO ID-TAB
                           MOVE 'anacfx' TO ID-CLF
                           MOVE 'movmol' TO ID-MOV.
      *
           OPEN INPUT ANACLF.
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN INPUT MOVIME.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI GO TO ERRIO.
      *
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID 
                       PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-ESE TO T25ESE.
           IF IF-FL = 1 AND T25ESE = 1
                          CLOSE TABELL
                          MOVE 'tabell' TO ID-TAB
                          OPEN  INPUT TABELL.
      *
           MOVE 1 TO KTB-COD.
           MOVE 14 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-FTRI TO FTRI.
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
              PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-CIVSO TO CIVA.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D RAZI.
           MOVE ZERO TO IF-DATA-1 IF-DATA-2 IF-FLSTA.
           MOVE ZERO TO IF-NBOL
                        IF-NUM-1
                        IF-ANNO.
           MOVE SPACE TO IF-PIEDE-1
                         IF-PIEDE-2.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DATA-1.
           MOVE 'IF-DATA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DAT1.
       E-DATA-1.
      *
       V-DATA-2.
           MOVE 'IF-DATA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DAT2.
           IF DAT2 < DAT1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DATA-2.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           COPY 'grirpt-sn' REPLACING 1 BY 2
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      * 
           IF RP-TRPT = ZERO 
              MOVE 'E'' possibile stampare il Report' TO F-MES1
              MOVE 'solo a carattere o visuale.'     TO F-MES2
              MOVE 'Forzato visuale.' TO F-MES3
              MOVE 3 TO F-NMES
              MOVE 'W' TO MB-TIPO
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO RP-TRPT.
      *
           IF IF-NBOL = 1
              MOVE 'PBK_ADES' TO RP-BLK
              MOVE IF-PIEDE-1 TO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE 'PBK_ACIT' TO RP-BLK
              MOVE IF-PIEDE-2 TO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE 'PBK_DPAG' TO RP-BLK
              STRING 'Anno: ' IF-ANNO
                     DELIMITED SIZE INTO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE 'PBK_NPAG' TO RP-BLK
              MOVE IF-NUM-1 TO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE IF-ANNO  TO PANNO
              MOVE '/'      TO PBARR
              IF IF-ANNO = ZERO 
                 MOVE SPACE TO PANNO PBARR
              END-IF
              MOVE ZERO TO FNPG
           ELSE
              MOVE SPACE TO RTPAG
              MOVE 1 TO FNPG
              MOVE 'np' TO RP-VERM.    *> per non stampare il piede
      *
           MOVE ZERO TO TOTIMP TOTAIVA TOTDOC.
           MOVE KAZ-COD TO KMV-AZI.
           MOVE CIVA TO KMV-CON.
           MOVE DAT1 TO KMV-DAT.
           MOVE ZERO TO KMV-NUM.
           START MOVIME KEY NOT < KEYMV INVALID KEY GO TO ENDA.
       LOPM.
           READ MOVIME NEXT INTO REKMOV AT END GO TO ENDA.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO LOPM.
           IF KMV-AZI > KAZ-COD GO TO ENDA.
           IF KMV-CON > CIVA GO TO ENDA.
           IF KMV-DAT < DAT1 GO TO LOPM.
           IF KMV-DAT > DAT2 GO TO ENDA.
           IF MOV-FLAG = 1 GO TO LOPM.
           MOVE KMV-DAT TO KLV-DAT.
           MOVE KMV-NUM TO KLV-NUM.
           MOVE MOV-NPRGI TO KLV-NPRGI.
           MOVE MOV-IVA TO KLV-IVA.
           MOVE MOV-PART TO KLV-CDCLI.
           WRITE RF-LAV INVALID MOVE 'WR LAV' TO MESS GO TO ERRIO.
           ADD 1 TO CONTA.
      *
           COPY 'grirpt-r' REPLACING 1 BY 2
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           GO TO LOPM.
       ENDA.
           IF CONTA = ZERO GO TO NO-PRINT.

      *-- inizializza parametri per stampa a caratteri --*
           IF IF-LMOD = 12
              MOVE 72 TO NRGF                
              MOVE 64 TO NRGL                  
           ELSE
              MOVE 66 TO NRGF                        
              MOVE 58 TO NRGL.                       
      *    MOVE 59      TO NRGL.
           MOVE C-TTS0  TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT0-1 TO XTINT(1).
           MOVE C-TINT0-2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'REGISTRO DELLE FATTURE IN SOSPESO ' 
                  DELIMITED SIZE INTO RP-TIT1.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG1-INTC.
      *
      *    MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
           MOVE ZERO TO COMCOD COMNPRGI SW.
           MOVE ZERO TO COMIMP COMIMPO COMIVN COMIVA.
           MOVE 1 TO K5.
           PERFORM UNTIL K5 > 50 
              MOVE ZERO TO CODIVA (K5) IVACON (K5) IMPCON (K5)
                                                   INDCON (K5)
              ADD 1 TO K5.
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID GO TO ENDB.
       LOPL.
           READ WDSLAV NEXT AT END
                MOVE 1 TO SW GO TO RLIB2.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO LOPL.
           MOVE KAZ-COD TO KMV-AZI.
           MOVE CIVA    TO KMV-CON.
           MOVE KLV-DAT TO KMV-DAT.
           MOVE KLV-NUM TO KMV-NUM.
           READ MOVIME INTO REKMOV INVALID 
                PERFORM INVK-MOV GO TO ERRIO.
           IF SF-MOV = '9D' OR '9A' OR '35' MOVE RF-MOV TO REKMOV.
           IF COMNPRGI = ZERO MOVE KLV-NPRGI TO COMNPRGI.
           IF COMNPRGI = KLV-NPRGI
              IF COMCOD = ZERO OR COMCOD = KLV-CDCLI GO TO LOPL0.
           MOVE 2 TO SW GO TO RLIB2.
       LOPL-0.
           IF FTRI = ZERO MOVE KLV-NPRGI TO COMNPRGI
                          MOVE ZERO TO COMCOD COMIVA TOTIMP TOTAIVA
                          GO TO LOPL0.
           MOVE ALL '=' TO RTRA1.
           MOVE 'TOTALE ........' TO DESTOT.
           COMPUTE TOTDOC = TOTIMP + TOTAIVA.
           MOVE TOTDOC TO RTRA3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
           MOVE KLV-NPRGI TO COMNPRGI.
           MOVE ZERO TO COMCOD COMIVA TOTIMP TOTAIVA.
       LOPL0.
           PERFORM RLIB THRU EX-RLIB.
       LOPL1.
           DELETE WDSLAV.
      *
           COPY 'grirpt-r'.
      *
           GO TO LOPL.
       ENDB.
           IF FTRI = ZERO GO TO ENDB1.
           MOVE ALL '=' TO RTRA1.
           MOVE 'TOTALE ........' TO DESTOT.
           COMPUTE TOTDOC = TOTIMP + TOTAIVA.
           MOVE TOTDOC TO RTRA3.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
           MOVE KLV-NPRGI TO COMNPRGI.
       ENDB1.
      * solo stampa a carattere
           IF RP-TRPT = 1     GO TO CHSTA.
           IF NRIG NOT < NRGL GO TO CHSTA.
           MOVE 1 TO XCRR.
           MOVE ALL '=' TO P999.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           COMPUTE N = NRGL - NRIG.
           COMPUTE N = N + (132 - N) / 2.
           MOVE N TO K.
           ADD 1 TO N.
       LCHS.    
           IF NRIG NOT < (NRGL - 2) GO TO CHSTA. 
           ADD 1 TO NRIG.
           IF NRIG = (NRGL - 2) 
              MOVE ALL '=' TO P999 
              MOVE 'RIG4' TO RP-BLK
           ELSE SUBTRACT 1 FROM N K
              MOVE '/' TO RX(N) RX(K)
              MOVE 'RIG3' TO RP-BLK.

           SUBTRACT 1 FROM NRIG.   
           PERFORM RPT-WR.
      *
           GO TO LCHS.
       CHSTA.
           PERFORM STA-PIE.
      *
           IF IF-FLSTA = 1 
              PERFORM STCON THRU EX-STCON
              MOVE ZERO TO IF-FLSTA.
       NO-PRINT.
      *
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       RLIB.
           MOVE 2 TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                             MOVE ZERO TO REKTAB.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF MOV-FLAG = 1 GO TO EX-RLIB.
       RLIB0.
           IF MOV-PART = COMCOD GO TO RLIB1.
           MOVE MOV-PART TO KCF-COD COMCOD.
           MOVE MOV-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO RG1.
           MOVE KAZ-COD TO KCF-AZI.
           READ ANACLF INVALID KEY
               MOVE SPACE TO CLF-RGS2
               MOVE 'INES.' TO CLF-RGS.
           MOVE MOV-NPRGI TO RV2.
           MOVE CLF-RGS TO RV3.
           IF CLF-RGS2 NOT = SPACE
                       MOVE 'RIG1' TO RP-BLK
                       PERFORM RPT-WR
                       PERFORM STA-PIE
                       MOVE CLF-RGS2 TO RV3.
           MOVE MOV-NDOC TO RV4.
           IF MOV-CATT NOT = '0'
              MOVE '/' TO RV41
              MOVE MOV-CATT TO RV42.
           MOVE MOV-DTDOC TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO RV5.
       RLIB1.
           IF NOT ( T02-SEGNO = 1 OR T02-TIPOP = 8 ) 
                                   MOVE SPACE TO RV9.
           IF T02-SEGNO = 1 MOVE 'STORNO CONTABILE' TO RV9.
           IF T02-TIPOP = 8 MOVE 'VARIAZ.ART.26' TO RV9
                            MULTIPLY -1 BY MOV-IMP
                            MULTIPLY -1 BY MOV-IMPO
                            MULTIPLY -1 BY MOV-IVN.
           IF COMIVA = ZERO
              MOVE MOV-IVA  TO COMIVA
              MOVE MOV-IMP  TO COMIMP
              MOVE MOV-IMPO TO COMIMPO
              MOVE MOV-IVN  TO COMIVN
              GO TO EX-RLIB.
           IF COMIVA = MOV-IVA
              ADD MOV-IMP  TO COMIMP
              ADD MOV-IMPO TO COMIMPO
              ADD MOV-IVN  TO COMIVN
              GO TO EX-RLIB.
       RLIB2.
           MOVE COMIMP TO RV6.
           ADD COMIMP TO TOTIMP.
           MOVE 3 TO KTB-TIP.
           MOVE COMIVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                            MOVE ZERO TO REKTAB.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE ZERO TO K5.
       CARV.
           ADD 1 TO K5.
           IF K5 > 50 GO TO CARV1.
           IF CODIVA (K5) = ZERO
              MOVE COMIVA TO CODIVA (K5).
           IF CODIVA (K5) NOT = COMIVA GO TO CARV.
           ADD COMIMP  TO IMPCON (K5).
           ADD COMIMPO TO IVACON (K5).
       CARV1.
           MOVE T03-DSIVA TO RV7.
           MOVE COMIMPO TO RV8.
           ADD COMIMPO TO TOTAIVA.
           IF T03-TPIVA = ZERO GO TO STAMR.
           MOVE 'IVA INDETRAIBILE' TO RV9.
           IF T03-TPIVA = 1 GO TO STAMQ.
           MOVE TAB-DESCR TO RV9.
           IF T03-TPIVA < 7 GO TO STAMR.
           MOVE SPACE TO RV9.
           MOVE COMIMP TO CLAV.
      **** rel 6.2
      *    COMPUTE CLV1 = CLAV / 2.
           IF T03-PERIVA = ZERO MOVE 50 TO T03-PERIVA.
           COMPUTE CLV1 = CLAV * T03-PERIVA / 100.
      ************
           COMPUTE CLV2 = CLAV - CLV1.
           MOVE CLV2 TO RV6.
           MOVE COMIMPO TO RV8.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
           MOVE CLV1 TO RV6.
       STAMQ.
           MOVE COMIVN TO RV8.
           ADD COMIVN TO TOTAIVA INDCON (K5).
           MOVE T03-DSIVA TO RV7.
           MOVE 'IVA INDETRAIBILE' TO RV9.
       STAMR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
           MOVE ZERO TO COMIMP COMIMPO COMIVN COMIVA.
           IF SW = 1 GO TO ENDB.
           IF SW = 2 MOVE ZERO TO SW GO TO LOPL-0 
           ELSE GO TO RLIB0.
       EX-RLIB.
           EXIT.
      *---------------------*
       STCON.
           MOVE ZERO TO K5 TTIMP TTIVA TTIND XCRR.
           MOVE 1 TO RP-JMP.

      *-- inizializza parametri per stampa a caratteri --*
           IF IF-LMOD = 12
              MOVE 72 TO NRGF                
              MOVE 64 TO NRGL                  
           ELSE
              MOVE 66 TO NRGF                        
              MOVE 58 TO NRGL.                       
      *    MOVE 59      TO NRGL.
           MOVE 3       TO NINT.
           MOVE C-TINT1-1 TO XTINT(1).
           MOVE C-TINT1-2 TO XTINT(2).
           MOVE C-TINT1-3 TO XTINT(3).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE SPACE TO RP-TIT2.
           STRING 'PROSPETTO CONTROLLO IVA IN SOSPESO' 
                  DELIMITED SIZE INTO RP-TIT2.
      *
           PERFORM RPT-RIG1B-INTC.
      *
      *---------------------------------------------*
       STCON1.
           ADD 1 TO K5.
           IF CODIVA (K5) = ZERO GO TO STCON2.
           IF K5 > 50 GO TO STCON2.
           IF CODIVA (K5) = 999
              MOVE SPACE TO RGC1
              MOVE 'DA VENTILARE' TO RGC2
              GO TO STCON1-1.
           MOVE CODIVA (K5) TO KTB-COD.
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                            PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-DSIVA TO RGC1.
           MOVE TAB-DESCR TO RGC2.
       STCON1-1.
           MOVE IMPCON (K5) TO RGC3.
           ADD IMPCON (K5) TO TTIMP. 
           MOVE IVACON (K5) TO RGC4.
           ADD IVACON (K5) TO TTIVA.
           MOVE 'RIG1B' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE-B.
           GO TO STCON1.
       STCON2.
           MOVE ALL '-' TO RGC3X RGC4X.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1B' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE-B.
           MOVE 'T O T A L I ' TO RGC2.
           IF TTIMP > ZERO MOVE TTIMP TO RGC3.
           IF TTIVA > ZERO MOVE TTIVA TO RGC4.
           IF TTIND > ZERO MOVE TTIND TO RGC5.
           MOVE 1 TO RP-FLGP.
           MOVE 'RIG1B' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE-B.
      *
      * solo stampa a carattere
           IF RP-TRPT = 1     GO TO CHSTAB.
           IF NRIG NOT < NRGL GO TO CHSTAB.
           MOVE 1 TO XCRR.
           MOVE ALL '=' TO P999B.
           MOVE 'RIG3B' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE-B.
      *
           COMPUTE N = NRGL - NRIG.
           COMPUTE N = N + (132 - N) / 2.
           MOVE N TO K.
           ADD 1 TO N.
       LCHSB.    
           IF NRIG NOT < (NRGL - 2) GO TO CHSTAB. 
           ADD 1 TO NRIG.
           IF NRIG = (NRGL - 2) 
              MOVE ALL '=' TO P999B
              MOVE 'RIG3B' TO RP-BLK
           ELSE SUBTRACT 1 FROM N K
              MOVE '/' TO RXB(N) RXB(K)
              MOVE 'RIG2B' TO RP-BLK.

           SUBTRACT 1 FROM NRIG.   
           PERFORM RPT-WR.
      *
           GO TO LCHSB.
       CHSTAB.
           PERFORM STA-PIE-B.
       EX-STCON.
           EXIT.
      *------------------
       STA-PIE.
           IF IF-NBOL = 1 AND (NRIG NOT < (NRGL - 2))
              MOVE IF-PIEDE-1 TO P999
              MOVE 2 TO RP-FLGR
              MOVE 'RIG4' TO RP-BLK
              PERFORM RPT-WR
              MOVE IF-PIEDE-2 TO P999
              MOVE 2 TO RP-FLGR
              MOVE 'RIG4' TO RP-BLK
              PERFORM RPT-WR.
      *-------------*
       STA-PIE-B.
           IF IF-NBOL = 1 AND (NRIG NOT < (NRGL - 2))
              MOVE IF-PIEDE-1 TO P999B
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3B' TO RP-BLK
              PERFORM RPT-WR
              MOVE IF-PIEDE-2 TO P999B
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3B' TO RP-BLK
              PERFORM RPT-WR.
      *-------------*
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'Data' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Progr.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Ragione Sociale' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'N Doc/A' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Data' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Imponibile' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Aliq.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Imposta' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Note / Rif.Registro Vendite' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
       RPT-RIG1B-INTC.
           MOVE 'RIG1B' TO RP-BLK.
      *
           MOVE 'Cod.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Iva' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Imponibile' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Imposta' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
