       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON161.
      *
      * Stampa parametrica del bilancio alla data
      *
      *--------------------------------------------------------------
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'grimovsl'.
           COPY 'grimvxsl'.
      **** rel 6.2
           COPY 'griclfsl'.
           COPY 'grimszsl'.
           COPY 'grimsxsl'.
      ************
           COPY 'gricolsl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
      **** rel 6.2
           SELECT WDSLA2 ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL2 STATUS SF-LA2.
      ************
           COPY 'gritabsl'.
      **** rel 6.3
           COPY 'grimlisl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricon'.
           COPY 'grimov'.   
           COPY 'grimvx'.  
      **** rel 6.2
           COPY 'griclf'.  
           COPY 'grimsz'.  
           COPY 'grimsx'.  
      ************
           COPY 'gricol'.
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
      **** rel 6.2
      *    RECORD 75 DATA RECORD RF-LAV.
           RECORD 78 DATA RECORD RF-LAV.
      ************
       01  RF-LAV.
           02 KEYLV.
              05 KLV-B1 PIC 9.
              05 KLV-B2 PIC 99.
              05 KLV-B3 PIC 99.
              05 KLV-CD PIC 9(7).
           02 LAV-DESCR PIC X(36).
           02 LAV-TIPO  PIC X.
           02 LAV-SALDO PIC S9(11)V99.
           02 LAV-ANPRE PIC S9(11)V99.
      **** rel 6.2
      * Codice inserito sulle chiavi di bilancio per leggere le voci di 
      * prospetto
           02 LAV-TOTAL PIC 9(3).
      **********
           COPY 'gritab'.
      **** rel 6.3
           COPY 'grimli'.
      ************
      **** rel 6.2
       FD  WDSLA2 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA2
           RECORD 28 DATA RECORD RF-LA2.
       01  RF-LA2.
           02 KEYL2.
              05 KL2-CD     PIC 9(7).
              05 KL2-CLIFOR PIC 9(7).
              05 KL2-ESE    PIC 9.
           02 LA2-SALDO PIC S9(11)V99.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'griconrk'.
       01  REKCO2.
           05 CO2-KEYID.
              10 CO2-AZI  PIC 999   VALUE ZERO.
              10 CO2-COD  PIC 9(7)  VALUE ZERO.
           05 CO2-DESCR   PIC X(36) VALUE SPACE.
           05 CO2-DSABB   PIC X(20) VALUE SPACE.
           05 CO2-TIPO    PIC X     VALUE SPACE.
           05 CO2-SALDI.
              10 CO2-SP-D PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CO2-SP-A PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CO2-SPSP PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CO2-SE-D PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CO2-SE-A PIC S9(11)V99 COMP-3 VALUE ZERO.
              10 CO2-SESP PIC S9(11)V99 COMP-3 VALUE ZERO.
           05 CO2-SALDR REDEFINES CO2-SALDI.
              10 CO2-SXYY PIC S9(11)V99 COMP-3 OCCURS 6.
           05 CO2-BIL1  PIC 9  VALUE ZERO.
           05 CO2-BIL2  PIC 99 VALUE ZERO.
           05 CO2-BIL3  PIC 99 VALUE ZERO.
           05 CO2-BIL4  PIC 9  VALUE ZERO.
           05 CO2-FLRIE PIC 9  VALUE ZERO.
           05 CO2-MOVIM PIC 9  VALUE ZERO.
           05 CO2-FLAUT PIC 9  VALUE ZERO.
           05 CO2-TPCOP PIC 9  VALUE ZERO.
           05 CO2-TPCON PIC 9  VALUE ZERO.
           05 CO2-PRO1  PIC 99 VALUE ZERO.
           05 CO2-PRO2  PIC 99 VALUE ZERO.
           05 CO2-BIL5  PIC 9  VALUE ZERO.
           05 CO2-CVAL  PIC 9  VALUE ZERO.
           05 FILLER    PIC X(4) VALUE ZERO.
           COPY 'gritabrk'.
           COPY 'grimovrk'.   
      **** rel 6.2
           COPY 'griclfrk'.
           COPY 'grit14g'.
           COPY 'grit39rk'.
      ************
           COPY 'parcdt'.
           COPY 'parzf'.
           COPY 'parer'.
           COPY 'parmb'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-MVX PIC X(15) VALUE 'movmxx'.
       01  ID-COL PIC X(15) VALUE 'anacol'.
      **** rel 6.2
       01  ID-LA2 PIC X(15) VALUE 'wdsla2'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-MSZ PIC X(15) VALUE 'movsez'.
       01  ID-MSX PIC X(15) VALUE 'movsxx'.
      ************
      **** rel 6.3
       01  ID-MLI PIC X(15) VALUE 'movlib'.
      ************
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-CON   PIC XX.
           05 SF-LAV   PIC XX.
           05 SF-MOV   PIC XX.
           05 SF-MVX   PIC XX.
           05 SF-COL   PIC XX.
      **** rel 6.2
           05 SF-LA2   PIC XX.
           05 SF-CLF   PIC XX.
           05 SF-MSZ   PIC XX.
           05 SF-MSX   PIC XX.
      ************
      **** rel 6.3
           05 SF-MLI   PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 TOTG     PIC S9(13)V99.
           05 TOTP     PIC S9(13)V99.
           05 TOTPP    PIC S9(13)V99.
           05 TOTPPPT  PIC S9(13)V99.
           05 TOTPPAT  PIC S9(13)V99.
           05 TOTANP   PIC S9(13)V99 VALUE ZERO.
           05 TOTANC   PIC S9(13)V99 VALUE ZERO.
           05 COMODO   PIC S9(13)V99 VALUE ZERO.
           05 BIL1     PIC 9.
           05 BIL2     PIC 99.
           05 DESB1    PIC X(24).
           05 DESB2    PIC X(24).
           05 DATEL    PIC 9(6).
           05 PKDAT    PIC 9(5) COMP-3 VALUE ZERO.
           05 PKDTC    PIC 9(5) COMP-3 VALUE ZERO.
           05 DATCO.
              10 GGC   PIC 99.
              10 MMC   PIC 99.
              10 AAC   PIC 99.
           05 PKDAT1   PIC 9(5) COMP-3 VALUE ZERO.
           05 PKDAT2   PIC 9(5) COMP-3 VALUE ZERO.
      **** rel 6.2
           05 CATCON PIC 9 VALUE ZERO.
           05 WCRPCL PIC 9(7).
           05 WCRPFR PIC 9(7).
           05 CRPCL  PIC 9(7) OCCURS 9.
           05 CRPFR  PIC 9(7) OCCURS 9.
           05 MCLI   PIC 99.
           05 MFOR   PIC 99.
           05 SAVCF     PIC 9(7).
           05 SAVSALDO  PIC S9(11)V99.
           05 CODTTNEW PIC 9(3) VALUE ZERO.
           05 COMTOTAL PIC 9(3) VALUE ZERO.
           05 TTANN  PIC S9(11)V99 VALUE ZERO.
           05 TTDAR  PIC S9(11)V99 VALUE ZERO.
           05 TTAVE  PIC S9(11)V99 VALUE ZERO.
           05 COMBIL PIC 999 VALUE ZERO.
      **********
      **** rel 6.3
           05 TEAVE PIC S9(13)V99 VALUE ZERO.
           05 TEDAR PIC S9(13)V99 VALUE ZERO.
           05 SALDO    PIC S9(11)V99 VALUE ZERO.
           05 COMLIB   PIC 9 VALUE ZERO.
           05 TTCD   PIC S9(11)V99 VALUE ZERO.
           05 TTCA   PIC S9(11)V99 VALUE ZERO.
           05 COMTCA  PIC 9(11)V99 VALUE ZERO.
      ************
      **** rel 7.1
           05 SW-FINE PIC 9.
      ************

           COPY 'vcon161.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-COD-1     PIC 9.
           05 IF-COD-2     PIC 9.
           05 IF-DATA-1    PIC 9(6).
           05 IF-DATA-2    PIC 9(6).
           05 IF-DATA      PIC 9(6).
           05 IF-FLRIP     PIC 9.
           05 IF-LIREUR    PIC 9.
      **** rel 6.0a
           05 IF-COMODO    PIC 999.
      *************
      **** rel 6.2
           05 IF-FLGDET    PIC 9.
           05 IF-TPSTA     PIC 9.
      ************
      **** rel 6.3
           05 IF-FLEXT     PIC 9.
      ************

       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcon'.
           COPY 'dclmov'.
           COPY 'dclmvx'.
           COPY 'dcltab'.
           COPY 'dclcol'.
           COPY 'dcllav'.
      **** rel 6.2
           COPY 'dclla2'.
           COPY 'dclclf'.
           COPY 'dclmsz'.
           COPY 'dclmsx'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' OR
                    '1' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon161: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE WDSLAV.
           OPEN  OUTPUT WDSLAV.
           CLOSE WDSLAV.
           CLOSE ANACON.
           CLOSE WDSLAV.
           CLOSE MOVIME.
           CLOSE MOVMXX.
      **** rel 6.2
           CLOSE ANACLF.
           CLOSE MOVSEZ.
           CLOSE MOVSXX.
           CLOSE WDSLA2.
           OPEN  OUTPUT WDSLA2.
           CLOSE WDSLA2.
      ************
      **** rel 6.3
           CLOSE MOVLIB.
      ************
           IF IF-FL = ZERO CLOSE ANACOL.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gritaber'.
      **** rel 6.3
           COPY 'grimlier'.
           COPY 'griconer'.
      ************
      **** rel 6.2
           COPY 'griclfer'.
      ************
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'tabell' TO ID-TAB
      **** rel 6.2
                           MOVE 'anaclf' TO ID-CLF
                           MOVE 'movsez' TO ID-MSZ
                           MOVE 'movsxx' TO ID-MSX
      ************
                           MOVE 'anacon' TO ID-CON
                           MOVE 'movime' TO ID-MOV
                           MOVE 'movmxx' TO ID-MVX
      **** rel 6.3
                           MOVE 'movlib' TO ID-MLI
      ************
           ELSE
                           MOVE 'anazol' TO ID-AZI
                           MOVE 'tabold' TO ID-TAB
      **** rel 6.2
                           MOVE 'anacfx' TO ID-CLF
                           MOVE 'movsol' TO ID-MSZ
                           MOVE 'mosoxx' TO ID-MSX
      ************
                           MOVE 'anacol' TO ID-CON
                           MOVE 'movmol' TO ID-MOV
      **** rel 6.3
                           MOVE 'movlix' TO ID-MLI
      ************
                           MOVE 'movoxx' TO ID-MVX.

           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN INPUT ANACON.
           OPEN INPUT MOVIME.
           OPEN INPUT MOVMXX.
      **** rel 6.2
           OPEN INPUT ANACLF.
           OPEN INPUT MOVSEZ.
           OPEN INPUT MOVSXX.
      ************
      **** rel 6.3
           OPEN INPUT MOVLIB.
      **** rel 7.1
      * PER 7.1 : per situazione con storico senza movlix
      *           aggiunta archiviazione a storico in 7.1
           IF SF-MLI = '35' OR '47'
              OPEN I-O MOVLIB
              MOVE LOW-VALUE TO RF-MLI
              WRITE RF-MLI
              CLOSE MOVLIB
              OPEN INPUT MOVLIB.
      ************
      ************
           IF IF-FL = ZERO OPEN INPUT ANACOL.

           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O WDSLAV.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
      **** rel 6.2
           OPEN OUTPUT WDSLA2.
           CLOSE WDSLA2.
           OPEN I-O WDSLA2.
      *
           MOVE 14 TO KTB-TIP.
           MOVE  7 TO KTB-COD.
           READ TABELL INTO RKTB14G INVALID PERFORM INVK-TAB
                                            GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB14G.
      *
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *
           MOVE T01-CRPCL TO CRPCL(1).
           MOVE T01-CRPC1 TO CRPCL(2).
           MOVE T01-CRPC2 TO CRPCL(3).
           MOVE T14-CRPC3 TO CRPCL(4).
           MOVE T14-CRPC4 TO CRPCL(5).
           MOVE T14-CRPC5 TO CRPCL(6).
           MOVE T14-CRPC6 TO CRPCL(7).
           MOVE T14-CRPC7 TO CRPCL(8).
           MOVE T14-CRPC8 TO CRPCL(9).

           MOVE T01-CRPFR TO CRPFR(1).
           MOVE T01-CRPF1 TO CRPFR(2).
           MOVE T01-CRPF2 TO CRPFR(3).
           MOVE T14-CRPF3 TO CRPFR(4).
           MOVE T14-CRPF4 TO CRPFR(5).
           MOVE T14-CRPF5 TO CRPFR(6).
           MOVE T14-CRPF6 TO CRPFR(7).
           MOVE T14-CRPF7 TO CRPFR(8).
           MOVE T14-CRPF8 TO CRPFR(9).
      *
           MOVE T01-MCLI TO MCLI.
           MOVE T01-MFOR TO MFOR.
      ************
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DATA.

           MOVE AZRGSOC TO IF-AZI-D.
           MOVE ZERO    TO IF-COD-1.
           MOVE 9       TO IF-COD-2.
           MOVE ZERO    TO IF-FLRIP.
           MOVE ZERO    TO IF-LIREUR.
           MOVE ZERO   TO IF-DATA-1
                          IF-DATA-2.
      **** rel 6.0a
           MOVE ZERO TO IF-COMODO.
      *************
      **** rel 6.2
           MOVE ZERO TO IF-FLGDET.
           MOVE ZERO TO IF-TPSTA.
      ************
      **** rel 6.3
      **** rel 7.1
      *    MOVE 1       TO IF-FLEXT.
      *    MOVE ZERO    TO IF-FLEXT.
      *    IF IF-FL = 2 MOVE ZERO TO IF-FLEXT.
           MOVE 1       TO IF-FLEXT.
      ************
      *
      * propone data apertura esercizio e chiusura
           MOVE AZI-DTAPE TO AAGGG.
           MOVE 2         TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA    TO IF-DATA-1.
           ADD  1         TO AA9.
           MOVE 1         TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           SUBTRACT 1 FROM AAGGG.
           MOVE 2         TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA    TO IF-DATA-2.
      ************
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
      **** rel 6.0a
       V-TB1.
           MOVE 'IF-TB1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TB1.
           IF FUN = 'V'
              MOVE IF-COMODO(1:1) TO IF-COD-1.
       E-TB1.
      *
       V-TB2.
           MOVE 'IF-TB2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TB2.
           IF FUN = 'V'
              MOVE IF-COMODO(1:1) TO IF-COD-2.
       E-TB2.
      *************
       V-COD-2.
           MOVE 'IF-COD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-2.
           IF IF-COD-2 < IF-COD-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-COD-2.
      *
       V-DATA.
           MOVE 'IF-DATA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF AAGGG < AZI-DTAPE
              MOVE "Data inferiore alla data apertura" TO MESS
              GO TO V-ERROR.
       E-DATA.
      *
       V-DATA-1.
           MOVE 'IF-DATA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF AAGGG < AZI-DTAPE
              MOVE "Data inferiore alla data apertura" TO MESS
              GO TO V-ERROR.
           MOVE AAGGG TO PKDAT1.
       E-DATA-1.
      *
       V-DATA-2.
           MOVE 'IF-DATA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF AAGGG < AZI-DTAPE
              MOVE "Data inferiore alla data apertura" TO MESS
              GO TO V-ERROR.
           MOVE AAGGG TO PKDAT2.
           IF PKDAT2 < PKDAT1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DATA-2.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           COPY 'grirpt-sn' REPLACING 1 BY 2
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      **** rel 6.2
           IF IF-FLGDET NOT = ZERO
              PERFORM AGGIORNA-LA2 THRU EX-AGGIORNA-LA2.
      ************
      *
           MOVE ZERO TO IEUR.
           IF IF-LIREUR = 1
              MOVE 'E' TO IEUR.
           MOVE ZERO TO TOTPP.
           MOVE ZERO TO TOTPPPT TOTPPAT.
           MOVE ZERO TO TOTANP TOTANC.

           MOVE AZRGSOC TO TAZI.

           MOVE 1 TO TIPOP1.
           MOVE IF-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO PKDAT.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO TDAT1.
      *
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO TDAT2.

           MOVE AA9 TO AAC.
           MOVE 01 TO GGC MMC.
           MOVE DATCO TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO PKDTC.

      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'BILANCIO DAL ' TDAT1  ' AL ' TDAT2
                  DELIMITED SIZE INTO RP-TIT1.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG2-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

      **** rel 7.1
           MOVE ZERO TO SW-FINE.
      ************
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID GO TO L110.
       L100.
           READ WDSLAV NEXT AT END GO TO L110.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO L100.
           DELETE WDSLAV.
           GO TO L100.
       L110.
           MOVE LOW-VALUE TO KEYPC.
           MOVE KAZ-COD TO KPC-AZI.
           START ANACON KEY NOT < KEYPC INVALID GO TO L200.
       L120.
           READ ANACON NEXT INTO REKCON AT END GO TO L200. 
           IF SF-CON = '9D' OR '9A' OR '35' GO TO L120.
           IF KPC-AZI > KAZ-COD GO TO L200.
           IF CON-BIL1 = ZERO GO TO L120.
           IF CON-BIL1 < IF-COD-1 GO TO L120.
           IF CON-BIL1 > IF-COD-2 GO TO L120.
           IF (CON-TIPO = 'P' OR SPACE) AND CON-BIL1 > 4 OR
              CON-TIPO = 'E' AND CON-BIL1 < 5
              MOVE SPACE TO F-MES1 
              STRING 'Conto ' CON-COD
                     '      Tipo ''' CON-TIPO 
                     '''     Gruppo ' CON-BIL1
                     DELIMITED SIZE INTO F-MES1
              MOVE 'Conto classificato in modo anomalo' TO F-MES2
              MOVE 2 TO F-NMES
              CALL 'vrmbox' USING PARMB.

           IF IF-FL NOT = ZERO OR CON-TIPO  = 'E' OR IF-FLRIP = ZERO
                             MOVE ZERO TO CO2-SESP GO TO L120-90.
           MOVE KAZ-COD TO KCL-AZI.
           MOVE KPC-COD TO KCL-COD.
           READ ANACOL INTO REKCO2 INVALID MOVE ZERO TO CO2-SESP
                                                    GO TO L120-90.
           IF SF-COL = '9D' OR '9A' OR '35' MOVE RF-COL TO REKCO2.
           COMPUTE CO2-SESP = CO2-SESP + CO2-SE-D - CO2-SE-A.
       L120-90.
           PERFORM C00-LEGGE-CONTO THRU C99.
           ADD CON-SPSP TO CON-SESP. 
           ADD CO2-SESP TO CON-SESP.
           IF CON-BIL4 = ZERO AND CON-SESP = ZERO AND
      **** rel 6.3
                                  COMLIB = ZERO AND
      ************
                                  CO2-SESP = ZERO GO TO L120.
           IF ( ( CON-BIL1 = 1 OR 2 ) AND CON-SESP NOT < ZERO ) OR
              ( ( CON-BIL1 = 3 OR 4 ) AND CON-SESP NOT > ZERO )
              GO TO L130.
           IF CON-BIL5 = ZERO GO TO L130.
           MOVE CON-BIL5 TO KLV-B1.
           MOVE CON-BIL3 TO KLV-B2.
      **** rel 6.2
      *    MOVE CON-BIL3 TO COMBIL.
           STRING CON-BIL5 CON-BIL3 INTO COMBIL.
           PERFORM LEGGI-T16 THRU EX-LEGGI-T16.
      **********
           GO TO L140.
       L130.
           MOVE CON-BIL1 TO KLV-B1.
           MOVE CON-BIL2 TO KLV-B2.
      **** rel 6.2
      *    MOVE CON-BIL2 TO COMBIL.
           STRING CON-BIL1 CON-BIL2 INTO COMBIL.
           PERFORM LEGGI-T16 THRU EX-LEGGI-T16.
      **********
       L140.
           MOVE ZERO TO KLV-B3.
           MOVE KPC-COD TO KLV-CD.
           MOVE CON-DESCR TO LAV-DESCR.
           MOVE CON-SESP TO LAV-SALDO.
           MOVE CO2-SESP TO LAV-ANPRE.
           MOVE CON-TIPO TO LAV-TIPO.
           IF CON-TIPO = 'E' ADD CON-SESP TO TOTPP
                             GO TO WRLAV.
           IF CON-TIPO = 'P' ADD CON-SESP TO TOTPPPT
                             ADD CO2-SESP TO TOTANP
                             GO TO WRLAV.
           ADD CON-SESP TO TOTPPAT.
           ADD CO2-SESP TO TOTANC.
       WRLAV.
           WRITE RF-LAV INVALID KEY MOVE 'WR LAV' TO MESS GO TO ERRIO.
      *
           COPY 'grirpt-r' REPLACING 1 BY 2
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           GO TO L120.
      *
       L200.
      **** rel 6.2
           MOVE ZERO TO TTANN TTDAR TTAVE.
           MOVE ZERO TO COMTOTAL.
      ************
      **** rel 6.3
           MOVE ZERO TO TTCA TTCD.
      ************
           MOVE ZERO TO BIL1 BIL2 XCRR.
           MOVE ZERO TO TOTG TOTP.
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID GO TO L290.
       L210.
           READ WDSLAV NEXT AT END GO TO L290. 
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO L210.
      **** rel 7.1
           IF KLV-B1 NOT = BIL1 PERFORM A00-BIL1 THRU A99.
           IF KLV-B2 NOT = BIL2 PERFORM B00-BIL2 THRU B99.
      *    IF KLV-B2 NOT = BIL2 PERFORM B00-BIL2 THRU B99.
      *    IF KLV-B1 NOT = BIL1 PERFORM A00-BIL1 THRU A99.
      ************
      **** rel 7.1
      **** rel 6.2
      * Stampo a rottura di TOTALIZZATORE
      *    IF LAV-TOTAL NOT = COMTOTAL AND COMTOTAL NOT = ZERO
      *       PERFORM STAMPA-TOTAL THRU EX-STAMPA-TOTAL
      *       MOVE ZERO TO TTANN TTDAR TTAVE.
      ************
      ************
           MOVE KLV-CD TO PCOD.
           MOVE LAV-DESCR TO PDES.
           MOVE LAV-TIPO TO PTIPO.
           IF LAV-ANPRE = ZERO GO TO L220.
      *    MOVE 'ESERCIZIO PRECEDENTE' TO DESCR1.
           MOVE 'Es. Prec.' TO DESCR1.
           MOVE LAV-ANPRE TO PANN.
           IF IF-LIREUR = 1
              MOVE LAV-ANPRE TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPANN.
      *
      **** rel 6.2
      *    MOVE 'RIG2' TO RP-BLK.
      *    PERFORM RPT-WR.
      *
      *    MOVE 1 TO XCRR.
           IF IF-TPSTA = ZERO
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              MOVE 1 TO XCRR.
      ************
           COMPUTE COMODO = LAV-SALDO - LAV-ANPRE.
      *    MOVE 'ESERCIZIO CORRENTE' TO DESCR1.
           MOVE 'Es. Corr.' TO DESCR1.
           MOVE COMODO TO PANN.
           IF IF-LIREUR = 1
              MOVE COMODO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPANN.
       L220.
      **** rel 6.2
      *    IF LAV-SALDO < ZERO MOVE LAV-SALDO TO PAVE
      *    ELSE MOVE LAV-SALDO TO PDAR.
           IF LAV-SALDO < ZERO
              MOVE LAV-SALDO TO PAVE
      **** rel 6.3
              ADD  LAV-SALDO TO TTCA
      ************
              IF NOT LAV-TOTAL = ZERO *> sommo solo se il totalizzatore  valorizzato
                 ADD  LAV-SALDO TO TTAVE
              END-IF
           ELSE
              MOVE LAV-SALDO TO PDAR
      **** rel 6.3
              ADD  LAV-SALDO TO TTCD
      ************
              IF NOT LAV-TOTAL = ZERO *> sommo solo se il totalizzatore  valorizzato
                 ADD  LAV-SALDO TO TTDAR 
              END-IF.
      ************
           IF IF-LIREUR = 1
              MOVE LAV-SALDO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              IF LAV-SALDO < ZERO
                 MOVE ER-IMPORTO TO EPAVE
              ELSE
                 MOVE ER-IMPORTO TO EPDAR.
      *
      **** rel 6.2
      *    MOVE 'RIG2' TO RP-BLK.
      *    PERFORM RPT-WR.
      *
      *    MOVE 1 TO XCRR.
           IF IF-TPSTA = ZERO
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR.
      ************
      *
           MOVE 1 TO XCRR.
           ADD LAV-SALDO TO TOTP TOTG.
           DELETE WDSLAV.
      **** rel 6.2
           IF IF-FLGDET NOT = ZERO AND IF-TPSTA = ZERO
                 PERFORM STAMPA-CLIFOR THRU EX-STAMPA-CLIFOR.
      *
           MOVE LAV-TOTAL TO COMTOTAL.
      ************
      **** rel 6.3
           IF IF-FLEXT = 1 PERFORM STAMPA-MLI THRU EX-STAMPA-MLI.
      ************
      *
           COPY 'grirpt-r'.
      *
           GO TO L210.
       L290.
      **** rel 7.1
           MOVE 1 TO SW-FINE.
           PERFORM A00-BIL1 THRU A50.
      ************
      **** rel 6.2
      * Stampo a rottura di TOTALIZZATORE
           IF COMTOTAL NOT = ZERO
              PERFORM STAMPA-TOTAL THRU EX-STAMPA-TOTAL
              MOVE ZERO TO TTANN TTDAR TTAVE.
      ************
      **** rel 7.1
      *    PERFORM A00-BIL1 THRU A50.
      ************
           IF BIL1 = ZERO AND BIL2 = ZERO GO TO L291.
           MOVE 3 TO XCRR.
      *
           COMPUTE TOTPP = TOTPP * -1.
           IF TOTPPPT NOT = TOTPP
              IF TOTPP > ZERO
                 MOVE 'UTILE RILEVATO (DA ECONOMICO)' TO PDESTAR
              ELSE  MOVE 'PERDITA RILEVATA (DA ECONOMICO)' TO PDESTAR
           ELSE
           IF TOTPP > ZERO MOVE 'UTILE RILEVATO' TO PDESTAR
              ELSE  MOVE 'PERDITA RILEVATA' TO PDESTAR.
           IF TOTPP > ZERO MOVE TOTPP TO PTGD
              ELSE  MOVE TOTPP TO PTGA.
           IF IF-LIREUR = 1
              MOVE TOTPP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              IF TOTPP > ZERO
                 MOVE ER-IMPORTO TO EPTGD
              ELSE
                 MOVE ER-IMPORTO TO EPTGA.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
       L290A.
           IF TOTPPPT = TOTPP GO TO L290B.
      *
           IF TOTPPPT > ZERO
              MOVE 'UTILE RILEVATO (DA PATRIMONIALE)' TO PDESTAR
              MOVE TOTPPPT TO PTGD
              ELSE 
              MOVE 'PERDITA RILEVATA (DA PATRIMONIALE)' TO PDESTAR
              MOVE TOTPPPT TO PTGA.
           IF IF-LIREUR = 1
              MOVE TOTPPPT TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              IF TOTPPPT > ZERO
                 MOVE ER-IMPORTO TO EPTGD
              ELSE
                 MOVE ER-IMPORTO TO EPTGA.
           IF TOTANP = ZERO GO TO L290A-00.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           COMPUTE COMODO = TOTPPPT - TOTANP.
           MULTIPLY -1 BY TOTANP.
           MOVE 'DIFFERENZA ESERCIZIO PRECEDENTE' TO PDESTAR.
           IF TOTANP  > ZERO MOVE  TOTANP TO PTGD
                        ELSE MOVE  TOTANP TO PTGA.
           IF IF-LIREUR = 1
              MOVE TOTANP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              IF TOTANP  > ZERO
                 MOVE ER-IMPORTO TO EPTGD
              ELSE
                 MOVE ER-IMPORTO TO EPTGA.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
           IF COMODO > ZERO
              MOVE 'UTILE ESERCIZIO (DA PATRIMONIALE)' TO PDESTAR
              MOVE COMODO TO PTGD
              ELSE 
              MOVE 'PERDITA ESERCIZIO (DA PATRIMONIALE)' TO PDESTAR
              MOVE COMODO TO PTGA.
           IF IF-LIREUR = 1
              MOVE COMODO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              IF COMODO > ZERO
                 MOVE ER-IMPORTO TO EPTGD
              ELSE 
                 MOVE ER-IMPORTO TO EPTGA.
           GO TO L290A-10.
       L290A-00.
           MOVE 2 TO XCRR.
       L290A-10.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
       L290B.
           IF TOTPPAT = ZERO GO TO L290C.
           MOVE 1 TO XCRR.
           MOVE ALL '=' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'SBILANCIO CONTI NON CLASSIFICATI' TO PDESTAR.
           IF TOTPPAT > ZERO
              MOVE TOTPPAT TO PTGD
              ELSE 
              MOVE TOTPPAT TO PTGA.
           IF IF-LIREUR = 1
              MOVE TOTPPAT TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              IF TOTPPAT > ZERO
                 MOVE ER-IMPORTO TO EPTGD
              ELSE
                 MOVE ER-IMPORTO TO EPTGA.
           IF TOTANC = ZERO GO TO L290B-00.
           MOVE 2 TO XCRR.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           COMPUTE COMODO = TOTPPAT - TOTANC.
           MULTIPLY -1 BY TOTANC.
           MOVE 'CONTI ESERCIZIO PRECEDENTE' TO PDESTAR.
           IF TOTANC  > ZERO MOVE TOTANC TO PTGD
                        ELSE MOVE TOTANC TO PTGA.
           IF IF-LIREUR = 1
              MOVE TOTANC TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              IF TOTANC > ZERO
                 MOVE ER-IMPORTO TO EPTGD
              ELSE
                 MOVE ER-IMPORTO TO EPTGA.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
           IF COMODO > ZERO MOVE COMODO TO PTGD
                       ELSE MOVE COMODO TO PTGA.
           IF IF-LIREUR = 1
              MOVE COMODO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              IF COMODO > ZERO
                 MOVE ER-IMPORTO TO EPTGD
              ELSE
                 MOVE ER-IMPORTO TO EPTGA.
           GO TO L290B-10.
       L290B-00.
           MOVE 2 TO XCRR.
       L290B-10.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
       L290C.
           MOVE 1 TO XCRR.
           MOVE ALL '=' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
       L291.
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w9' PID DELIMITED SPACE INTO ID-LAV.
      **** rel 6.2
           MOVE SPACE TO ID-LA2.
           STRING 'w8' PID DELIMITED SPACE INTO ID-LA2.
      ************
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       A00-BIL1.
           PERFORM B00-BIL2 THRU B50.
           IF BIL1 = ZERO GO TO A50.
           MOVE ALL '=' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE SPACE TO PDESTAR.
           STRING 'TOTALE ' DESB1 DELIMITED SIZE
                  INTO PDESTAR.
           IF TOTG < ZERO MOVE TOTG TO PTGA
           ELSE MOVE TOTG TO PTGD.
           IF IF-LIREUR = 1
              MOVE TOTG TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              IF TOTG < ZERO
                 MOVE ER-IMPORTO TO EPTGA
              ELSE
                 MOVE ER-IMPORTO TO EPTGD.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
      *  riga vuota per visuale 
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
      *  riga vuota per visuale 
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ALL '=' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
       A50. EXIT.
       A60.
           MOVE ZERO TO TOTG.
           MOVE KLV-B1 TO BIL1.
           MOVE ZERO TO BIL2.
           MOVE ALL '*' TO PSTAR.
           MOVE 16 TO T16-TIP.
           MOVE KLV-B1 TO T16-COD.
           MOVE ZERO TO T16-GRU.
           MOVE T16-KEYID TO KEYTB.
           READ TABELL INTO REKTAB INVALID 
                MOVE ALL '*' TO T16-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T16-DESCR TO PDESTAR DESB1.
           IF XCRR > ZERO MOVE 3 TO XCRR.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 2 TO XCRR.
       A99. EXIT.
      *------------------
       B00-BIL2.
      **** rel 7.1
      * Stampo a rottura di TOTALIZZATORE
      *    IF LAV-TOTAL NOT = COMTOTAL AND COMTOTAL NOT = ZERO
      *       PERFORM STAMPA-TOTAL THRU EX-STAMPA-TOTAL
      *       MOVE ZERO TO TTANN TTDAR TTAVE.
      ************
           IF BIL2 = ZERO GO TO B50.
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'TOTALE' TO    PXTOT.
           MOVE DESB2 TO PDTOT.
           IF TOTP < ZERO MOVE TOTP TO PTAVE
           ELSE MOVE TOTP TO PTDAR.
           IF IF-LIREUR = 1
              MOVE TOTP TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              IF TOTP < ZERO
                 MOVE ER-IMPORTO TO EPTAVE
              ELSE
                 MOVE ER-IMPORTO TO EPTDAR.
      *
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
      **** rel 7.1
      * Stampo a rottura di TOTALIZZATORE
           IF LAV-TOTAL NOT = COMTOTAL AND COMTOTAL NOT = ZERO
              PERFORM STAMPA-TOTAL THRU EX-STAMPA-TOTAL
              MOVE ZERO TO TTANN TTDAR TTAVE.
      * Stampo a fine elaborazione
           IF LAV-TOTAL NOT = ZERO AND SW-FINE = 1
              PERFORM STAMPA-TOTAL THRU EX-STAMPA-TOTAL
              MOVE ZERO TO TTANN TTDAR TTAVE.
      ************
       B50. EXIT.
       B60.
      **** rel 7.1
      **** rel 6.2
      * Stampo a rottura di TOTALIZZATORE
      *    IF LAV-TOTAL NOT = COMTOTAL AND COMTOTAL NOT = ZERO
      *       PERFORM STAMPA-TOTAL THRU EX-STAMPA-TOTAL
      *       MOVE ZERO TO TTANN TTDAR TTAVE.
      **********
      ************
      **** rel 6.3
           IF IF-TPSTA = 1
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-AZZ.
      ************
           MOVE ZERO TO TOTP.
           MOVE KLV-B2 TO BIL2.
           MOVE '     ----' TO PTRACOD.
           MOVE 16 TO T16-TIP.
           MOVE KLV-B1 TO T16-COD.
           MOVE KLV-B2 TO T16-GRU.
           MOVE T16-KEYID TO KEYTB.
           READ TABELL INTO REKTAB INVALID 
                MOVE ALL '*' TO T16-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T16-DESCR TO PDES DESB2.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
       B99. EXIT.
      *------------------
       C00-LEGGE-CONTO.
           MOVE ZERO TO CON-SP-D CON-SP-A CON-SE-D CON-SE-A.
           MOVE ZERO TO CON-SPSP CON-SESP.
           MOVE LOW-VALUE TO KEYMX.
           MOVE KPC-AZI TO KMX-AZI.
           MOVE KPC-COD TO KMX-CON.
           MOVE PKDAT1  TO KMX-DAT.
       C05.
           MOVE ZERO    TO KMX-NUM.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO C40.
       C10.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO C40.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO C10.
           IF KMX-AZI > KPC-AZI GO TO C40.
           IF KMX-CON > KPC-COD GO TO C40.
           IF KMX-DAT < PKDAT1 MOVE PKDAT1 TO KMX-DAT GO TO C05.
           IF KMX-DAT > PKDAT2 GO TO C40.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO CON-SESP
           ELSE SUBTRACT MOV-IMPO FROM CON-SESP.
           GO TO C10.
       C40.
           MOVE LOW-VALUE TO KEYMV.
           MOVE KPC-AZI TO KMV-AZI.
           MOVE KPC-COD TO KMV-CON.
           MOVE PKDAT1  TO KMV-DAT.
       C45.
           MOVE ZERO    TO KMV-NUM.
      **** rel 6.3
      *    START MOVIME KEY NOT < KEYMV INVALID GO TO C99.
           START MOVIME KEY NOT < KEYMV INVALID GO TO C90.
      ************
       C50.
      **** rel 6.3
      *    READ MOVIME NEXT INTO REKMOV AT END GO TO C99.
           READ MOVIME NEXT INTO REKMOV AT END GO TO C90.
      ************
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO C50.
      **** rel 6.3
      *    IF KMV-AZI > KPC-AZI GO TO C99.
      *    IF KMV-CON > KPC-COD GO TO C99.
           IF KMV-AZI > KPC-AZI GO TO C90.
           IF KMV-CON > KPC-COD GO TO C90.
      ************
           IF KMV-DAT < PKDAT1 MOVE PKDAT1 TO KMV-DAT GO TO C45.
      **** rel 6.3
      *    IF KMV-DAT > PKDAT2 GO TO C99.
           IF KMV-DAT > PKDAT2 GO TO C90.
      ************
           IF MOV-D-A = 'D' ADD MOV-IMPO TO CON-SPSP
           ELSE SUBTRACT MOV-IMPO FROM CON-SPSP.
           GO TO C50.
      **** rel 6.3
        C90.
           MOVE ZERO TO COMLIB.
           MOVE LOW-VALUE TO KEYMLI.
           MOVE KPC-AZI   TO KMLI-AZI.
           MOVE KPC-COD   TO KMLI-CONTO.
           MOVE ZERO      TO KMLI-PRG.
           START MOVLIB KEY NOT < SKEYMLI1 INVALID GO TO C99.
       C95.
           READ MOVLIB NEXT AT END GO TO C99.
           IF SF-MLI = '9D' OR '9A' OR '35' GO TO C95.
           IF KMLI-AZI   > KPC-AZI GO TO C99.
           IF KMLI-CONTO > KPC-COD  GO TO C99.
           IF MLI-DARE = ZERO AND MLI-AVERE = ZERO GO TO C95.
           IF MLI-DATA < PKDAT1 OR
              MLI-DATA > PKDAT2 GO TO C95.
           IF MLI-VALID = 1
              IF MLI-DTVALID < PKDAT2 GO TO C95.
           IF COMLIB = 1 GO TO C99.
           MOVE 1 TO COMLIB.
           GO TO C95.
      ************
        C99.
           EXIT.
      *------------------
       RPT-RIG2-INTC.
           MOVE 'RIG2' TO RP-BLK.
      *
           MOVE 'Codice' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           PERFORM RPT-ADD-I.
           PERFORM RPT-ADD-I.
           MOVE 'Dare' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Avere' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
      **** rel 6.2
       AGGIORNA-LA2.
           MOVE LOW-VALUE TO KEYSX.
           MOVE IF-AZI    TO KSX-AZI.
           START MOVSXX KEY NOT < KEYSX INVALID GO TO ST-MSZ.
       RD-MSX.
           READ MOVSXX NEXT INTO REKMOV AT END GO TO ST-MSZ.
           IF SF-MSX = '9D' OR '9A' OR '35' GO TO RD-MSX.
           IF KSX-AZI > IF-AZI GO TO ST-MSZ.
           IF KSX-DAT < PKDAT1 OR > PKDAT2 GO TO RD-MSX.
      *
           PERFORM SCRIVI-LA2 THRU S99.
      *
           GO TO RD-MSX.
       ST-MSZ.
      *
           MOVE LOW-VALUE TO KEYMS.
           MOVE IF-AZI    TO KMS-AZI.
           START MOVSEZ KEY NOT < KEYMS INVALID GO TO END-MSZ.
       RD-MSZ.
           READ MOVSEZ NEXT INTO REKMOV AT END GO TO END-MSZ.
           IF SF-MSZ = '9D' OR '9A' OR '35' GO TO RD-MSZ.
           IF KMS-AZI > IF-AZI GO TO END-MSZ.
           IF KMS-DAT < PKDAT1 OR > PKDAT2 GO TO RD-MSZ.
      *
           PERFORM SCRIVI-LA2 THRU S99.
      *
           GO TO RD-MSZ.
       END-MSZ.
      *
           IF IF-FLRIP NOT = ZERO
              PERFORM ELABORA-ANACFX THRU EX-ELABORA-ANACFX.
      *
       EX-AGGIORNA-LA2.
           EXIT.
      *------------------
       SCRIVI-LA2.
           MOVE MOV-AZI TO KCF-AZI.
           MOVE MOV-CON TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID PERFORM INVK-CLF
                                           GO TO ERRIO.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
      *
           MOVE CLF-CATCON TO CATCON.
           IF CATCON = ZERO MOVE 1 TO CATCON.
      *
           MOVE CRPCL (CATCON) TO WCRPCL.
           MOVE CRPFR (CATCON) TO WCRPFR.
      *
           MOVE 1 TO KL2-ESE.
           IF MOV-TREG = 2 MOVE WCRPCL TO KL2-CD.
           IF MOV-TREG = 3 MOVE WCRPFR TO KL2-CD.
           MOVE KCF-COD TO KL2-CLIFOR.
           READ WDSLA2 INVALID 
                MOVE ZERO TO RF-LA2
                MOVE 1    TO KL2-ESE
                IF MOV-TREG = 2 MOVE WCRPCL TO KL2-CD
                END-IF
                IF MOV-TREG = 3 MOVE WCRPFR TO KL2-CD
                END-IF
                MOVE KCF-COD TO KL2-CLIFOR
                WRITE RF-LA2 INVALID MOVE 'WR LA2' TO MESS
                                     GO TO ERRIO.
      *
           IF MOV-D-A = 'D' ADD MOV-IMPO TO LA2-SALDO
           ELSE             SUBTRACT MOV-IMPO FROM LA2-SALDO.
      *
           REWRITE RF-LA2 INVALID MOVE 'WR LA2' TO MESS
                                  GO TO ERRIO.
       S99.
           EXIT.
      *----------------------*
       STAMPA-CLIFOR.
           MOVE ZERO TO SAVCF.
           MOVE ZERO TO SAVSALDO.
      *
           MOVE LOW-VALUE TO KEYL2.
           MOVE KLV-CD    TO KL2-CD.
           MOVE ZERO      TO KL2-ESE.
           START WDSLA2 KEY > KEYL2 INVALID GO TO END-LA2.
       RD-LA2.
           READ WDSLA2 NEXT AT END GO TO END-LA2.
           IF SF-LA2 = '9D' OR '9A' OR '35' GO TO RD-LA2.
           IF KL2-CD > KLV-CD  GO TO END-LA2.
      *
           IF LA2-SALDO = ZERO GO TO RD-LA2.
      *
           IF SAVCF NOT = ZERO 
              IF SAVCF = KL2-CLIFOR
                 MOVE 'RIG2A' TO RP-BLK
                 PERFORM RPT-WR
                 MOVE LA2-SALDO TO PDANN
                 IF IF-FLRIP NOT = ZERO
                    ADD LA2-SALDO  TO SAVSALDO
                    IF SAVSALDO > ZERO MOVE SAVSALDO TO PDDAR END-IF
                    IF SAVSALDO < ZERO MOVE SAVSALDO TO PDAVE END-IF
                    MOVE 'Es. Corr.' TO DESCR2 
                 END-IF
                 MOVE 'RIG2A' TO RP-BLK
                 PERFORM RPT-WR
                 MOVE ZERO TO SAVSALDO SAVCF
                 GO TO RD-LA2
              ELSE
                 IF IF-FLRIP NOT = ZERO
                    IF SAVSALDO > ZERO MOVE SAVSALDO TO PDDAR END-IF
                    IF SAVSALDO < ZERO MOVE SAVSALDO TO PDAVE END-IF
                 END-IF
                 MOVE 'RIG2A' TO RP-BLK
                 PERFORM RPT-WR
              END-IF
           END-IF
      *
           MOVE IF-AZI     TO KCF-AZI.
           MOVE KL2-CLIFOR TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID PERFORM INVK-CLF
                                           GO TO ERRIO.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
      *
           MOVE KL2-CLIFOR TO PCLF.
           MOVE CLF-RGSOC  TO PDCLF.
      *
           MOVE LA2-SALDO TO PDANN.
           MOVE KL2-CLIFOR TO SAVCF.
           MOVE LA2-SALDO  TO SAVSALDO.
      *
           IF IF-FLRIP NOT = ZERO
              MOVE 'Es. Prec.' TO DESCR2
              IF KL2-ESE = 1
                 MOVE 'Es. Corr.' TO DESCR2.
      *
           GO TO RD-LA2.
      *
       END-LA2.
      *
       IF SAVCF NOT = ZERO 
          IF SAVCF = KL2-CLIFOR
             MOVE 'RIG2A' TO RP-BLK
             PERFORM RPT-WR
          ELSE
             IF IF-FLRIP NOT = ZERO
                IF SAVSALDO > ZERO MOVE SAVSALDO TO PDDAR END-IF
                IF SAVSALDO < ZERO MOVE SAVSALDO TO PDAVE END-IF
             END-IF
             MOVE 'RIG2A' TO RP-BLK
             PERFORM RPT-WR
          END-IF
       END-IF.
      *
       EX-STAMPA-CLIFOR.
           EXIT.
      *----------------------*
       LEGGI-T16.
      *
           MOVE 16     TO KTB-TIP.
           MOVE COMBIL TO KTB-COD.
           READ TABELL INTO RKTB16 INVALID MOVE ZERO TO T16-TOTAL.
           MOVE T16-TOTAL TO LAV-TOTAL.
      *
       EX-LEGGI-T16.
           EXIT.
      *----------------------*
       STAMPA-TOTAL.
      *
      * Salvo totalizzatore
           MOVE LAV-TOTAL TO CODTTNEW.
      * Qui muovo il capoconto veccio
           MOVE COMTOTAL TO LAV-TOTAL.
      * Leggo la descrizione
           MOVE 39        TO T39-TIP.
           MOVE LAV-TOTAL TO T39-COD.
           MOVE T39-KEYID TO KEYTB.
           READ TABELL INTO REKT39 INVALID
                MOVE ALL '*' TO T39-DESCR.
      *
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
      *
           MOVE 'TOTALE'  TO PXTOT.
           MOVE T39-DESCR TO PDTOT.
           IF IF-LIREUR = 1
              MOVE TTDAR TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTDAR
              MOVE TTAVE TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTAVE
           ELSE
              MOVE TTDAR TO PTDAR
              MOVE TTAVE TO PTAVE.
      *
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
      *  riga vuota per visuale 
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 2 TO XCRR.
      *
      * Ripristino il nuovo capoconto per continuare a leggere 
      * il file di sort
      *
           MOVE CODTTNEW TO LAV-TOTAL.
           MOVE ZERO TO COMTOTAL.
      *
       EX-STAMPA-TOTAL.
      *
           EXIT.
      *----------------------*
       ELABORA-ANACFX.
           CLOSE ANACLF.
           MOVE 'anacfx' TO ID-CLF.
           OPEN INPUT ANACLF.
      *
           MOVE LOW-VALUE TO KEYCF.
           MOVE KAZ-COD   TO KCF-AZI.
           START ANACLF KEY NOT < KEYCF INVALID GO TO END-CLF.
       RD-CLF.
           READ ANACLF NEXT INTO REKCLF AT END GO TO END-CLF.
           IF SF-CLF = '9D' OR '9A' OR '35' GO TO RD-CLF.
      *
           COMPUTE CLF-SESP = CLF-SESP + CLF-SE-D - CLF-SE-A.
      **** rel 6.3
           IF KCF-AZI NOT = KAZ-COD GO TO END-CLF.
      ************
      *
           MOVE CLF-CATCON TO CATCON.
           IF CATCON = ZERO MOVE 1 TO CATCON.
      *
           MOVE CRPCL (CATCON) TO WCRPCL.
           MOVE CRPFR (CATCON) TO WCRPFR.
      *
           MOVE ZERO TO KL2-ESE.
           IF CLF-MS = MCLI MOVE WCRPCL TO KL2-CD.
           IF CLF-MS = MFOR MOVE WCRPFR TO KL2-CD.
           MOVE KCF-COD TO KL2-CLIFOR.
           READ WDSLA2 INVALID 
                MOVE ZERO TO RF-LA2
                MOVE ZERO TO KL2-ESE
                IF CLF-MS = MCLI MOVE WCRPCL TO KL2-CD
                END-IF
                IF CLF-MS = MFOR MOVE WCRPFR TO KL2-CD
                END-IF
                MOVE KCF-COD TO KL2-CLIFOR
                WRITE RF-LA2 INVALID MOVE 'WR LA2' TO MESS
                                     GO TO ERRIO.
      *
           ADD CLF-SESP TO LA2-SALDO.
      *
           REWRITE RF-LA2 INVALID MOVE 'WR LA2' TO MESS
                                  GO TO ERRIO.
      *
           GO TO RD-CLF.
       END-CLF.
           CLOSE ANACLF.
           MOVE 'anaclf' TO ID-CLF.
           OPEN INPUT ANACLF.
       EX-ELABORA-ANACFX.
           EXIT.
      *----------------------*
      ************
      **** rel 6.3
       STAMPA-MLI.
           MOVE ZERO TO TEAVE TEDAR.
           MOVE LOW-VALUE TO KEYMLI.
           MOVE KAZ-COD   TO KMLI-AZI.
           MOVE KLV-CD    TO KMLI-CONTO.
           MOVE ZERO      TO KMLI-PRG.
           START MOVLIB KEY NOT < SKEYMLI1 INVALID GO TO END-MLI.
       RDNX-MLI.
           READ MOVLIB NEXT AT END GO TO END-MLI.
           IF SF-MLI = '9D' OR '9A' OR '35' GO TO RDNX-MLI.
           IF KMLI-AZI   > KAZ-COD GO TO END-MLI.
           IF KMLI-CONTO > KLV-CD  GO TO END-MLI.
           IF MLI-DARE = ZERO AND MLI-AVERE = ZERO GO TO RDNX-MLI.
           IF MLI-DATA < PKDAT1 OR
              MLI-DATA > PKDAT2 GO TO RDNX-MLI.
      **** rel 6.3
      *    MOVE 'RIG2' TO RP-BLK.
      *    PERFORM RPT-AZZ.
           IF MLI-VALID = 1
              IF MLI-DTVALID > PKDAT2 GO TO RDNX-MLI.
      ************
      *
           MOVE KAZ-COD    TO KPC-AZI.
           MOVE KMLI-CONTO TO KPC-COD.
           READ ANACON INTO REKCON INVALID PERFORM INVK-CON
                                           GO TO ERRIO.
      *
       SOMMA.
           MOVE ZERO TO SALDO.
           COMPUTE SALDO = MLI-DARE - MLI-AVERE.
           IF SALDO < ZERO
              MOVE SALDO TO PAVE
              ADD  SALDO TO TEAVE
              ADD  SALDO TO TTAVE
           ELSE
              MOVE SALDO TO PDAR
      **** rel 6.3
      *       ADD  SALDO TO TEDAR.
              ADD  SALDO TO TEDAR
      ************
              ADD  SALDO TO TTDAR.
      *
           ADD SALDO TO TOTP TOTG.
      *
           IF CON-TIPO = 'E' ADD SALDO TO TOTPP
           ELSE ADD SALDO TO TOTPPPT.
      *
           GO TO RDNX-MLI.
       END-MLI.
      *
           IF NOT (TEAVE = ZERO AND TEDAR = ZERO)
              PERFORM STAMPA-EXTRA THRU EX-STAMPA-EXTRA.
      *
           MOVE ZERO TO TTCD TTCA. 
       EX-STAMPA-MLI.
           EXIT.
      *----------------------*
       STAMPA-EXTRA.
      *
      **** rel 6.3
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-AZZ.
      *
           MULTIPLY TEAVE BY -1 GIVING TEAVE.
      *
           IF TEDAR > TEAVE
              SUBTRACT TEAVE FROM TEDAR
              MOVE ZERO TO TEAVE
           ELSE
              SUBTRACT TEDAR FROM TEAVE
              MOVE ZERO TO TEDAR.
      *
      ************
           IF IF-TPSTA = 1 GO TO STAEX-SINT.
      *> Per analitica
           MOVE '(Extra Contabile)' TO PDES.
      *
      *> dare
           IF TEDAR NOT = ZERO 
              MOVE TEDAR TO PDAR.
              IF IF-LIREUR = 1
                 MOVE TEDAR TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO EPDAR
              END-IF.
      *
      *> avere
           IF TEAVE NOT = ZERO
              MOVE TEAVE TO PAVE.
              IF IF-LIREUR = 1
                 MOVE TEAVE TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO EPAVE 
              END-IF.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
      *
      **** rel 6.3
      *    GO TO EX-STAMPA-EXTRA.
           GO TO EX-STAMPA-EX-10.
      ************
      *
       STAEX-SINT.
      *> Per sintetica
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-AZZ.
       
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
       
           MOVE '(Extra Contabile)' TO PDES.
       
      *> dare
           IF TEDAR NOT = ZERO 
              MOVE TEDAR TO PDAR.
              IF IF-LIREUR = 1
                 MOVE TEDAR TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO EPDAR
              END-IF.
       
      *> avere
           IF TEAVE NOT = ZERO
              MOVE TEAVE TO PAVE.
              IF IF-LIREUR = 1
                 MOVE TEAVE TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO EPAVE 
              END-IF.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
      **** rel 6.3
       EX-STAMPA-EX-10.
      *
      **** rel 7.2
           MULTIPLY TEAVE BY -1 GIVING TEAVE.
      ************
           ADD TEDAR TO TTCD.
           ADD TEAVE TO TTCA.
           MOVE 1 TO XCRR.
           PERFORM STAMPA-TCON THRU EX-STAMPA-TCON.
      ************
      *
       EX-STAMPA-EXTRA.
           EXIT.
      *----------------------*
      **** rel 6.3
       STAMPA-TCON.
      *
      * Leggo la descrizione
      *
           MOVE KAZ-COD   TO KPC-AZI.
           MOVE KLV-CD    TO KPC-COD.
           READ ANACON INTO REKCON INVALID
                MOVE ALL '*' TO CON-DESCR.
      *
           STRING 'Totale ' CON-DESCR DELIMITED SIZE INTO PDES.
      *
           MOVE ZERO TO SALDO.
      **** rel 6.3
           MOVE ZERO TO COMTCA.
           MOVE TTCA TO COMTCA.
      ************
           COMPUTE SALDO = TTCD - COMTCA.
           IF SALDO < ZERO
              MOVE SALDO TO PAVE
           ELSE
              MOVE SALDO TO PDAR.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           PERFORM RPT-AZZ.
      *
       EX-STAMPA-TCON.
           EXIT.
      *----------------------*
      ************
