       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON162.
      *
      * Stampa bilancio situazione economico patrimoniale
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'grimolsl'.
           COPY 'grimmosl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricon'.
           COPY 'grimol'. 
           COPY 'grimmo'.  
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 61 DATA RECORD RF-LAV.
       01  RF-LAV.
           02 KEYLV.
              05 KLV-B1 PIC 9.
              05 KLV-B2 PIC 99.
              05 KLV-B3 PIC 99.
              05 KLV-CD PIC 9(7).
           02 LAV-DESCR PIC X(36).
           02 LAV-SALDO PIC S9(11)V99.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griconrk'.
           COPY 'gritabrk'.
           COPY 'grit20rk'.
           COPY 'grimovrk'.  
           COPY 'parcdt'.
           COPY 'parzf'.
           COPY 'parer'.
       01  ID-AZI   PIC X(15) VALUE 'anaazi'.
       01  ID-TAB   PIC X(15) VALUE 'tabell'.  
       01  ID-CON   PIC X(15) VALUE 'anacon'.
       01  ID-MOL   PIC X(15) VALUE 'movmol'.
       01  ID-LAV   PIC X(15) VALUE 'wdslav'.
       01  ID-MMO   PIC X(15) VALUE 'movoxx'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-CON   PIC XX.
           05 SF-MOL   PIC XX.
           05 SF-LAV   PIC XX.
           05 SF-MMO   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 BIL1     PIC 9.
           05 BIL2     PIC 99.
           05 DESB1    PIC X(36).
           05 DESB2    PIC X(36).
           05 DESCR    PIC X(36) VALUE SPACE.
           05 SWTOT    PIC 9 VALUE ZERO.
           05 RIEP     PIC 9 VALUE ZERO.
           05 SALDO    PIC S9(13)V99.
           05 RISPAT   PIC S9(13)V99.
           05 RISECO   PIC S9(13)V99.
           05 ESTERNA PIC 99 VALUE ZERO.
           05 TOTS    PIC S9(13)V99 VALUE ZERO.
           05 SGDESB2 PIC X(36).
           05 TOT-GRUPPI.
              10 TG1   PIC S9(13)V99.
              10 TG2   PIC S9(13)V99.
              10 TG3   PIC S9(13)V99.
              10 TG4   PIC S9(13)V99.
              10 TG5   PIC S9(13)V99.
              10 TG6   PIC S9(13)V99.
           05 FILLER REDEFINES TOT-GRUPPI.
              10 TG    PIC S9(13)V99 OCCURS 6.
           05 TOT-STAMPA.
              10 TGEN  PIC S9(13)V99.
              10 TGRU  PIC S9(13)V99.
              10 TSOT  PIC S9(13)V99.
           05 MESSER.
              10 FILLER PIC X(11) VALUE SPACE.
              10 FILLER PIC X(34) VALUE
              'ATTENZIONE:   S B I L A N C I O'.
              10 FILLER PIC X(25) VALUE
              'R I S U L T A T O   ! ! !'.
           05 SW1 PIC 9 VALUE ZERO.

           COPY 'vcon162.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-TPALL     PIC 9.
           05 IF-FLSTA     PIC 9.
           05 IF-DATA      PIC 9(6).
           05 IF-LIREUR    PIC 9.
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcon'.
           COPY 'dclmol'.
           COPY 'dclmmo'.
           COPY 'dcltab'.
           COPY 'dcllav'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon162: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE WDSLAV.
           OPEN  OUTPUT WDSLAV.
           CLOSE WDSLAV.
           CLOSE ANACON.
           CLOSE MOVMOL.
           CLOSE MOVOXX.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'tabell' TO ID-TAB
                           MOVE 'anacon' TO ID-CON
                           MOVE 'movmol' TO ID-MOL
                           MOVE 'movoxx' TO ID-MMO
           ELSE
                           MOVE 'anazol' TO ID-AZI
                           MOVE 'tabold' TO ID-TAB
                           MOVE 'anacol' TO ID-CON
                           MOVE 'movmol' TO ID-MOL
                           MOVE 'movoxx' TO ID-MMO.

           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O WDSLAV.
           OPEN INPUT ANACON.
           OPEN INPUT MOVMOL.
           OPEN INPUT MOVOXX.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
           MOVE '20001' TO KEYTB.
           READ TABELL INTO RKTB20 INVALID
                PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB20.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DATA.

           MOVE AZRGSOC TO IF-AZI-D.
           MOVE ZERO    TO IF-TPALL
                           IF-LIREUR
                           IF-FLSTA.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DATA.
           MOVE 'IF-DATA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DATA.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           COPY 'grirpt-sn' REPLACING 1 BY 2
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           MOVE AZRGSOC TO TAZI.
           MOVE ZERO TO IEUR.
           IF IF-LIREUR = 1
              MOVE 'E' TO IEUR.
           MOVE IF-DATA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO TDAT.

      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 1       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'BILANCIO AL ' TDAT
                  DELIMITED SIZE INTO RP-TIT1.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

           MOVE ZERO TO TG1  TG2  TG3  TG4  TG5  TG6.
           MOVE LOW-VALUE TO KEYPC.
           MOVE KAZ-COD TO KPC-AZI.
           START ANACON KEY NOT < KEYPC INVALID GO TO L200.
       L120.
           READ ANACON NEXT INTO REKCON AT END GO TO L200. 
           IF SF-CON = '9D' OR '9A' OR '35' GO TO L120.
           IF KPC-AZI > KAZ-COD GO TO L200.
           IF CON-BIL1 = ZERO OR
              CON-BIL1 > 6    GO TO L120.
           IF KPC-COD = T20-COUTI OR
              KPC-COD = T20-COPER GO TO L120.
           COMPUTE SALDO = CON-SESP + CON-SE-D - CON-SE-A.
           IF IF-FL NOT = ZERO
                PERFORM F00-CALCSALDO THRU F99.
           IF CON-BIL4 = ZERO AND SALDO = ZERO GO TO L120.
           IF ( ( CON-BIL1 = 1 OR 2 ) AND SALDO NOT < ZERO ) OR
              ( ( CON-BIL1 = 3 OR 4 ) AND SALDO NOT > ZERO )
              GO TO L130.
           IF CON-BIL5 = ZERO GO TO L130.
           ADD SALDO TO TG (CON-BIL5).
           MOVE CON-BIL5 TO KLV-B1.
           MOVE CON-BIL3 TO KLV-B2.
           GO TO L140.
       L130.
           ADD SALDO TO TG(CON-BIL1).
           MOVE CON-BIL1 TO KLV-B1.
           MOVE CON-BIL2 TO KLV-B2.
       L140.
           MOVE ZERO TO KLV-B3.
           MOVE KPC-COD TO KLV-CD.
           MOVE CON-DESCR TO LAV-DESCR.
           MOVE SALDO TO LAV-SALDO.
           WRITE RF-LAV INVALID KEY MOVE 'WR LAV' TO MESS GO TO ERRIO.
      *
           COPY 'grirpt-r' REPLACING 1 BY 2
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           GO TO L120.
       L200.
           COMPUTE RISPAT  = TG1  + TG3.
           COMPUTE RISECO  = TG5  + TG6.

           MOVE ZERO TO BIL1 BIL2 XCRR NPAG.
           MOVE ZERO TO TGEN TGRU TSOT.
           MOVE ZERO TO SW1.
           MOVE ZERO TO ESTERNA TOTS.
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID GO TO L290.
       L210.
           READ WDSLAV NEXT AT END GO TO L290. 
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO L210.
           IF KLV-B1 NOT = BIL1 PERFORM A00-BIL1 THRU A99.
           IF KLV-B2 NOT = BIL2 PERFORM B00-BIL2 THRU B99.
           IF RIEP = 1 GO TO L220.
           MOVE LAV-DESCR TO PDES.
           MOVE LAV-SALDO TO PSAL.
           IF IF-LIREUR = 1
              MOVE LAV-SALDO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           IF KLV-B1 = 5 MOVE 1 TO SW1.
           MOVE 1 TO XCRR.
       L220.
           COMPUTE TOTS = TOTS + LAV-SALDO.
           ADD LAV-SALDO TO TSOT  TGRU  TGEN.
           IF RIEP = 1 AND IF-TPALL = 2 GO TO L210.
           IF RIEP = 1 AND IF-TPALL = 1
              IF KLV-B1 = 5 OR 6 GO TO L210.
           DELETE WDSLAV.
      *
           COPY 'grirpt-r'.
      *
           GO TO L210.
       L290.
           PERFORM A00-BIL1 THRU A50.
           COMPUTE SALDO = RISPAT + RISECO.
           IF SALDO NOT = ZERO
              MOVE 2 TO XCRR
              MOVE ZERO TO RP-JMP
              MOVE MESSER TO P998
              MOVE 'RIG4' TO RP-BLK
              PERFORM RPT-WR.
      *
           PERFORM C00-DETTAGLIO THRU C99.

           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w9' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       A00-BIL1.
           IF IF-FLSTA = 1
              IF TOTS NOT = ZERO PERFORM TOT-SOTTOG THRU TS99
                            MOVE ZERO TO ESTERNA.
           PERFORM B00-BIL2 THRU B50.
           IF BIL1 = ZERO GO TO A50.
           MOVE ZERO TO SWTOT.
           MOVE 2 TO XCRR.
           IF BIL1 NOT = 1 GO TO A10.
           IF RISPAT NOT < ZERO GO TO A10.
      *    --- ATTIVITA': PERDITA DI ESERCIZIO
           MOVE ALL '-' TO P999.
           MOVE 1 TO XCRR.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'TOTALE' TO PXTOTS.
           MOVE DESB1 TO PDTOTS.
           MOVE 1 TO SWTOT.
           MOVE TGRU TO PTSALSTAR.
           IF IF-LIREUR = 1
              MOVE TGRU TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTSALSTAR.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 2 TO XCRR.
      * riga vuota per visuale
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'PERDITA D''ESERCIZIO' TO PDESTAR.
           IF RISPAT  < ZERO
              COMPUTE SALDO = - RISPAT
              MOVE SALDO TO PTSALSTAR
              IF IF-LIREUR = 1
                 MOVE SALDO TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO EPTSALSTAR
              END-IF
              ADD SALDO TO TGRU TGEN.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
       A10.
           IF BIL1 NOT = 3 GO TO A20.
           IF RISPAT < ZERO GO TO A20.
      *    --- PASSIVITA': UTILE DI ESERCIZIO
           MOVE ALL '-' TO P999.
           MOVE 1 TO XCRR.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'TOTALE' TO PXTOTS.
           STRING DESB1 DELIMITED '  '
                  ' ' DELIMITED SIZE
                  'E NETTO' DELIMITED SIZE INTO DESCR.
           MOVE DESCR TO PDTOTS.
           MOVE 1 TO SWTOT.
           MOVE TGRU TO PTSALSTAR.
           IF IF-LIREUR = 1
              MOVE TGRU TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTSALSTAR.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 2 TO XCRR.
      * riga vuota per visuale
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'UTILE D''ESERCIZIO' TO PDESTAR.
           IF RISPAT  NOT < ZERO
              COMPUTE SALDO = - RISPAT
              MOVE SALDO TO PTSALSTAR
              IF IF-LIREUR = 1
                 MOVE SALDO TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO EPTSALSTAR
              END-IF
              ADD SALDO TO TGRU TGEN.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
       A20.
      *    --- TOTALI GRUPPO
           IF BIL1 = 2 OR 4 MOVE 2 TO XCRR GO TO A25.
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           MOVE 'TOTALE' TO PXTOTS.
           MOVE DESB1 TO PDTOTS.
           IF SWTOT = 1 MOVE ZERO TO SWTOT
              MOVE SPACE TO PDTOTS.
           MOVE TGRU TO PTSALSTAR.
           IF IF-LIREUR = 1
              MOVE TGRU TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTSALSTAR.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 2 TO XCRR.
      * riga vuota per visuale
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           IF BIL1 = 1 AND KLV-B1 > 2 GO TO A28.
           IF BIL1 = 3 AND KLV-B1 > 4 GO TO A28.
           IF NOT ( BIL1 = 2 OR 4 ) GO TO A30.
       A25.
      *    --- ATTIVITA'/PASSIVITA': TOTALE GENERALE
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           MOVE 'TOTALE GENERALE' TO PDESTAR.
           MOVE TGEN TO PTSALSTAR.
           IF IF-LIREUR = 1
              MOVE TGEN TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTSALSTAR.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
       A28.
           MOVE 1 TO XCRR.
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RPT-WR.
      *
       A30.
           IF BIL1 NOT = 5 GO TO A40.
           IF RISECO NOT > ZERO GO TO A38.
      *    --- RICAVI: PERDITA DI ESERCIZIO
           MOVE 'PERDITA D''ESERCIZIO' TO PDESTAR.
           IF RISECO  > ZERO
              COMPUTE SALDO = - RISECO
              MOVE SALDO TO PTSALSTAR
              IF IF-LIREUR = 1
                 MOVE SALDO TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO EPTSALSTAR
              END-IF
              ADD SALDO TO TGEN.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           MOVE 'TOTALE A PAREGGIO' TO PDESTAR.
           MOVE TGEN TO PTSALSTAR.
           IF IF-LIREUR = 1
              MOVE TGEN TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTSALSTAR.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
       A38.
           MOVE 1 TO XCRR.
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RPT-WR.
      *
       A40.
           IF BIL1 NOT = 6 GO TO A50.
           IF RISECO > ZERO GO TO A48.
      *    --- COSTI: UTILE DI ESERCIZIO
           MOVE 'UTILE D''ESERCIZIO' TO PDESTAR.
           IF RISECO  NOT > ZERO
              COMPUTE SALDO = - RISECO
              MOVE SALDO TO PTSALSTAR
              IF IF-LIREUR = 1
                 MOVE SALDO TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO EPTSALSTAR
              END-IF
              ADD SALDO TO TGEN.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           MOVE 'TOTALE A PAREGGIO' TO PDESTAR.
           MOVE TGEN TO PTSALSTAR.
           IF IF-LIREUR = 1
              MOVE TGEN TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTSALSTAR.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
       A48.
           MOVE 1 TO XCRR.
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ZERO TO XCRR.
           MOVE 1 TO RP-JMP.
           MOVE ZERO TO TGEN.
       A50. EXIT.
       A60.
           MOVE ZERO TO TGRU.
           MOVE KLV-B1 TO BIL1.
           MOVE ZERO TO BIL2.
           IF BIL1 = 1 OR 3 OR 5 
              MOVE ZERO TO XCRR
              MOVE 1 TO RP-JMP.
           IF BIL1 = 6    AND
              SW1  = ZERO MOVE ZERO TO XCRR
                          MOVE 1 TO RP-JMP.
           IF BIL1 = 1 OR 3 OR 5 OR 6
              MOVE ZERO TO TGEN.
           MOVE '  ****   ' TO PSTAR.
           MOVE 16 TO T16-TIP.
           MOVE KLV-B1 TO T16-COD.
           MOVE ZERO TO T16-GRU.
           MOVE T16-KEYID TO KEYTB.
           READ TABELL INTO REKTAB INVALID 
                MOVE ALL '*' TO T16-DSC.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T16-DSC TO PDESTAR DESB1.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 2 TO XCRR.
       A99. EXIT.
      *------------------
       B00-BIL2.
           IF BIL2 = ZERO GO TO B50.
           IF RIEP = ZERO GO TO B50.
           MOVE DESB2 TO PDES.
           MOVE TSOT TO PSAL.
           IF IF-LIREUR = 1
              MOVE TSOT TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
       B50. EXIT.
       B60.
           MOVE ZERO TO TSOT.
           MOVE KLV-B2 TO BIL2.
           MOVE 16 TO T16-TIP.
           MOVE KLV-B1 TO T16-COD.
           MOVE KLV-B2 TO T16-GRU.
           MOVE T16-KEYID TO KEYTB.
           READ TABELL INTO REKTAB INVALID 
                MOVE ALL '*' TO T16-DSC 
                MOVE ZERO TO T16-TESTA.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T16-DSC TO DESB2.
           MOVE T16-TESTA TO RIEP.
           IF IF-FLSTA = 1
              IF KLV-B2 NOT = ESTERNA
                 IF TOTS NOT = ZERO PERFORM TOT-SOTTOG THRU TS99
                 END-IF
                 MOVE KLV-B2 TO ESTERNA.
           MOVE DESB2 TO SGDESB2.
       B99. EXIT.
      *------------------
       C00-DETTAGLIO.
           MOVE ZERO TO BIL1 BIL2.
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID GO TO C90.
       C20.
           READ WDSLAV NEXT AT END GO TO C90.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO C20.
           IF KLV-B1 NOT = BIL1 OR
              KLV-B2 NOT = BIL2
              PERFORM E00-ROT-DETTAGLIO THRU E99.
           MOVE LAV-DESCR TO PDES.
           MOVE LAV-SALDO TO PSAL.
           IF IF-LIREUR = 1
              MOVE LAV-SALDO TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSAL.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           ADD LAV-SALDO TO TSOT.
           DELETE WDSLAV.
           GO TO C20.
       C90.
           PERFORM E00-ROT-DETTAGLIO THRU E50.
       C99.
           EXIT.
      *------------------
       E00-ROT-DETTAGLIO.
           IF BIL2 = ZERO GO TO E50.
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'TOTALE' TO PXTOT.
           MOVE DESB2 TO PDTOT.
           MOVE TSOT TO PTSAL.
           IF IF-LIREUR = 1
              MOVE TSOT TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTSAL.
      *
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 2 TO XCRR.
       E50. EXIT.
       E60.
           MOVE ZERO TO TSOT.
           IF KLV-B1 = BIL1 GO TO E70.
           MOVE ZERO TO XCRR.
           MOVE 1 TO RP-JMP.
           MOVE '  ****   ' TO PSTAR.
           MOVE 16 TO T16-TIP.
           MOVE KLV-B1 TO T16-COD BIL1.
           MOVE ZERO   TO T16-GRU.
           MOVE T16-KEYID TO KEYTB.
           READ TABELL INTO REKTAB INVALID 
                MOVE ALL '*' TO T16-DSC.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T16-DSC TO DESB1 PDESTAR.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 3 TO XCRR.
       E70.
           MOVE '  ----   ' TO PSTAR.
           MOVE KLV-B2 TO T16-GRU BIL2.
           MOVE T16-KEYID TO KEYTB.
           READ TABELL INTO REKTAB INVALID 
                MOVE ALL '*' TO T16-DSC.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T16-DSC TO DESB2 PDESTAR.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 2 TO XCRR.
       E99. EXIT.
      *------------------
       F00-CALCSALDO.
           MOVE LOW-VALUE TO KEYML.
           MOVE KPC-AZI   TO KML-AZI.
           MOVE KPC-COD   TO KML-CON.
           START MOVMOL KEY NOT < KEYML INVALID GO TO F20.
       F10.
           READ MOVMOL NEXT INTO REKMOV AT END GO TO F20.
           IF SF-MOL = '9D' OR '9A' OR '35' GO TO F10.
           IF KML-AZI > KPC-AZI GO TO F20.
           IF KML-CON > KPC-COD GO TO F20.
           IF NOT ( MOV-CAUS = T20-CDSOC OR 
                    MOV-CAUS = T20-CASOC ) GO TO F10.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO SALDO 
           ELSE SUBTRACT MOV-IMPO FROM SALDO.
           GO TO F10.
       F20.
           MOVE LOW-VALUE TO KEYMO.
           MOVE KPC-AZI   TO KMO-AZI.
           MOVE KPC-COD   TO KMO-CON.
           START MOVOXX KEY NOT < KEYMO INVALID GO TO F99.
       F30.
           READ MOVOXX NEXT INTO REKMOV AT END GO TO F99.
           IF SF-MMO = '9D' OR '9A' OR '35' GO TO F30.
           IF KMO-AZI > KPC-AZI GO TO F99.
           IF KMO-CON > KPC-COD GO TO F99.
           IF NOT ( MOV-CAUS = T20-CDSOC OR 
                    MOV-CAUS = T20-CASOC ) GO TO F30.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO SALDO 
           ELSE SUBTRACT MOV-IMPO FROM SALDO.
           GO TO F30.
       F99.      
            EXIT.
      *------------------
       TOT-SOTTOG.
           IF ESTERNA = ZERO AND TOTS = ZERO GO TO TS99.
           IF ESTERNA = ZERO GO TO TS01.
           MOVE ALL '-' TO P999.
           MOVE 1 TO XCRR.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE '     *   ' TO PTSTAR.
           MOVE 'TOTALE' TO PXTOT.
           MOVE SGDESB2 TO PDTOT.
           MOVE TOTS TO PTSAL.
           IF IF-LIREUR = 1
              MOVE TOTS TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTSAL.
      *
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
       TS01.
      *
      * riga vuota
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ZERO TO TOTS.
       TS99.
           EXIT.
      *------------------
