       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON170.
      *
      * Stampa saldi clienti/fornitori con criteri di sort
      *
      **** rel 7.2
      * Ricompilato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'gricfxsl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS 
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'gricfx'.
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 54 DATA RECORD RF-LAV.
       01  RF-LAV.
           02 KEYLV.
             05 KLV-SORT   PIC X(44).
             05 KLV-CHIA   PIC 9(10).
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griclfrk'.
           COPY 'gritabrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parer'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  ID-CFX PIC X(15) VALUE 'anacfx'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-LAV  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-CFX  PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 RINIZ    PIC X(15).
           05 RFINE    PIC X(15).
           05 SCALC    PIC S9(11)V99 VALUE ZERO.
           05 TOTSAL   PIC S9(11)V99 VALUE ZERO.
           05 TOTDAR   PIC S9(11)V99 VALUE ZERO.
           05 TOTAVR   PIC S9(11)V99 VALUE ZERO.
           05 MAST     PIC 99     VALUE ZERO.
           05 MCLI     PIC 99     VALUE ZERO.
           05 MFOR     PIC 99     VALUE ZERO.
           05 ABSSL    PIC 9(11)V99  VALUE ZERO.
           05 KS       PIC 9      VALUE ZERO.
           05 DS1      PIC X(20)  VALUE 'CATEGORIA CONTABILE'.
           05 DS2      PIC X(20)  VALUE 'AGENTE'.
           05 DS3      PIC X(20)  VALUE 'ZONA'.
           05 DS4      PIC X(20)  VALUE 'GRUPPO STATISTICO'.
           05 DS5      PIC X(20)  VALUE 'RAGIONE SOCIALE'.

           COPY 'vcon170.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-TPCLF     PIC 9.
           05 IF-DTELA     PIC 9(6).
           05 IF-SALDO     PIC 9(11)V99.
           05 IF-FLPRE     PIC 9.
           05 IF-NS1       PIC 9.
           05 IF-T1        PIC 9.
           05 IF-DA1       PIC 9.
           05 IF-A1        PIC 9.
           05 IF-NS2       PIC 9.
           05 IF-T2        PIC 9.
           05 IF-DA2       PIC 9(3).
           05 IF-A2        PIC 9(3).
           05 IF-NS3       PIC 9.
           05 IF-T3        PIC 9.
           05 IF-DA3       PIC X(3).
           05 IF-A3        PIC X(3).
           05 IF-NS4       PIC 9.
           05 IF-T4        PIC 9.
           05 IF-DA4       PIC 9.
           05 IF-A4        PIC 9.
           05 IF-NS5       PIC 9.
           05 IF-T5        PIC 9.
           05 IF-DA5       PIC X(15).
           05 IF-A5        PIC X(15).
           05 IF-LIREUR    PIC 9.
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dcltab'.
           COPY 'dcllav'.
           COPY 'dclcfx'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon170: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE ANACLF.
           CLOSE ANACFX.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'gricfxer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'tabell' TO ID-TAB
                           MOVE 'anaclf' TO ID-CLF
           ELSE
                           MOVE 'anazol' TO ID-AZI
                           MOVE 'tabold' TO ID-TAB
                           MOVE 'anacfx' TO ID-CLF.
      *
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN INPUT ANACLF.
           OPEN INPUT ANACFX.
      *
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O WDSLAV.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MCLI.
           MOVE T01-MFOR TO MFOR.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DTELA.

           MOVE AZRGSOC TO IF-AZI-D.

           MOVE ZERO TO IF-TPCLF
                        IF-SALDO
                        IF-FLPRE.

           MOVE 1    TO IF-NS1.
           MOVE ZERO TO IF-T1
                        IF-DA1
                        IF-A1.

           MOVE 2    TO IF-NS2.
           MOVE ZERO TO IF-T2
                        IF-DA2
                        IF-A2.

           MOVE 3     TO IF-NS3.
           MOVE ZERO  TO IF-T3.
           MOVE SPACE TO IF-DA3
                         IF-A3.

           MOVE 4    TO IF-NS4.
           MOVE ZERO TO IF-T4
                        IF-DA4
                        IF-A4.

           MOVE 5     TO IF-NS5.
           MOVE ZERO  TO IF-T5.
           MOVE SPACE TO IF-DA5
                         IF-A5.
           MOVE ZERO TO IF-LIREUR.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DTELA.
           MOVE 'IF-DTELA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTELA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTELA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTELA.
      *
       V-T1.
           MOVE 'IF-T1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-T1.
           IF NOT (IF-T1 = ZERO OR 1)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF IF-T1 = ZERO MOVE ZERO TO IF-DA1 IF-A1.
       E-T1.
      *
       V-NS1.
           MOVE 'IF-NS1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NS1.
           IF IF-NS1 > 5
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-NS1.
      *
       V-A1.
           MOVE 'IF-A1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-A1.
           IF IF-A1 < IF-DA1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-A1.
      *
       V-T2.
           MOVE 'IF-T2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-T2.
           IF NOT (IF-T2 = ZERO OR 1)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF IF-T2 = ZERO MOVE ZERO TO IF-DA2 IF-A2.
       E-T2.
      *
       V-NS2.
           MOVE 'IF-NS2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NS2.
           IF IF-NS2 > 5
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-NS2.
      *
       V-A2.
           MOVE 'IF-A2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-A2.
           IF IF-A2 < IF-DA2
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-A2.
      *
       V-T3.
           MOVE 'IF-T3' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-T3.
           IF NOT (IF-T3 = ZERO OR 1)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF IF-T3 = ZERO MOVE SPACE TO IF-DA3 IF-A3.
       E-T3.
      *
       V-NS3.
           MOVE 'IF-NS3' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NS3.
           IF IF-NS3 > 5
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-NS3.
      *
       V-A3.
           MOVE 'IF-A3' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-A3.
           IF IF-A3 < IF-DA3
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-A3.
      *
       V-T4.
           MOVE 'IF-T4' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-T4.
           IF NOT (IF-T4 = ZERO OR 1)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF IF-T4 = ZERO MOVE ZERO TO IF-DA4 IF-A4.
       E-T4.
      *
       V-NS4.
           MOVE 'IF-NS4' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NS4.
           IF IF-NS4 > 5
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-NS4.
      *
       V-A4.
           MOVE 'IF-A4' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-A4.
           IF IF-A4 < IF-DA4
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-A4.
      *
       V-T5.
           MOVE 'IF-T5' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-T5.
           IF NOT (IF-T5 = ZERO OR 1)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF IF-T5 = ZERO MOVE SPACE TO IF-DA5 IF-A5.
       E-T5.
      *
       V-NS5.
           MOVE 'IF-NS5' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NS5.
           IF IF-NS5 > 5
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-NS5.
      *
       V-A5.
           MOVE 'IF-A5' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-A5.
           IF IF-A5 < IF-DA5
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-A5.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           COPY 'grirpt-sn' REPLACING 1 BY 2
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           MOVE ZERO TO IEUR.
           IF IF-LIREUR = 1
              MOVE 'E' TO IEUR.
           MOVE IF-DTELA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DATAB.
      *
           MOVE AZRGSOC TO ARAGSOC.
           MOVE ZERO TO NPAG XCRR TOTSAL TOTAVR TOTDAR.
           IF IF-TPCLF = ZERO
              MOVE '  ELENCO CLIENTI' TO PINTE
              MOVE MCLI TO MAST
           ELSE
              MOVE 'ELENCO FORNITORI' TO PINTE
              MOVE MFOR TO MAST.

           IF IF-SALDO NOT = ZERO
              MOVE '(SALDO >' TO PINTE2
              MOVE IF-SALDO TO PSALDT
              MOVE ')' TO PINTE3
           ELSE MOVE SPACE TO PINTE2 PINTE3
                MOVE ZERO TO PSALDT.
           IF IF-LIREUR = 1
              IF IF-SALDO NOT = ZERO
                 MOVE IF-SALDO TO ER-IMPORTO
                 CALL 'rlitimp' USING ER-IMPORTO
                 MOVE ER-IMPORTO TO EPSALDT
              ELSE
                 MOVE ZERO TO EPSALDT.

      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING PINTE 'SCOPERTI AL ' DATAB 
                  DELIMITED SIZE INTO RP-TIT1.
      *
           MOVE SPACE TO RP-TIT2.
           STRING PINTE2 PSALDT PINTE3 ' PER ' RT02
                  DELIMITED SIZE INTO RP-TIT2.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG1-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
           
           IF IF-T5 = ZERO
              MOVE LOW-VALUE  TO RINIZ 
              MOVE HIGH-VALUE TO RFINE
              GO TO STALL
           ELSE
              MOVE IF-DA5     TO RINIZ
              MOVE IF-A5      TO RFINE.

           MOVE RINIZ TO KEYCFS.
           START ANACLF KEY NOT < KEYCFS INVALID GO TO EX-RUN-ELABORA.
           GO TO CICLO.
       STALL.
           MOVE RINIZ TO KEYCFS.
           START ANACLF KEY > KEYCFS INVALID GO TO EX-RUN-ELABORA.
       CICLO.
           READ ANACLF NEXT INTO REKCLF AT END GO TO LBSTA.
           IF SF-CLF = '9D' OR '9A' OR '35' GO TO CICLO.
           IF CLF-RGSOC > RFINE GO TO LBSTA.
           IF CLF-AZI NOT = KAZ-COD GO TO CICLO.
           IF CLF-MS NOT = MAST GO TO CICLO.
           COMPUTE SCALC = CLF-SESP + CLF-SE-D - CLF-SE-A.
           IF IF-FLPRE = ZERO GO TO CICLO-00.
           MOVE KEYCF TO KEYCX.
           READ ANACFX INTO REKCLF INVALID GO TO CICLO-00.
           IF SF-CFX = '9D' OR '9A' OR '35' MOVE RF-CFX TO REKCLF.
           COMPUTE SCALC = SCALC + CLF-SESP + CLF-SE-D - CLF-SE-A.
       CICLO-00.
           MOVE SCALC TO ABSSL.
           IF ABSSL NOT > IF-SALDO GO TO CICLO.
           IF IF-T1 NOT = ZERO
              IF CLF-CATCON < IF-DA1 OR > IF-A1 GO TO CICLO.
           IF IF-T2 NOT = ZERO
              IF CLF-AGEN   < IF-DA2 OR > IF-A2 GO TO CICLO.
           IF IF-T3 NOT = ZERO
              IF CLF-ZONA   < IF-DA3 OR > IF-A3 GO TO CICLO.
           IF IF-T4 NOT = ZERO
              IF CLF-GRM    < IF-DA4 OR > IF-A4 GO TO CICLO.
           IF IF-T5 NOT = ZERO
              IF CLF-RGSOC  < IF-DA5 OR > IF-A5 GO TO CICLO.
      *------ compilazione chiave file di sort
           MOVE HIGH-VALUE TO KLV-SORT.
           MOVE ZERO TO KS.
       LCHIA.
           ADD 1 TO KS.
           IF KS > 5 GO TO LWRSORT.
           IF IF-NS1 = KS
              STRING KLV-SORT   DELIMITED HIGH-VALUE,
                     CLF-CATCON,
                     HIGH-VALUE DELIMITED SIZE INTO KLV-SORT.
           IF IF-NS2 = KS
              STRING KLV-SORT   DELIMITED HIGH-VALUE,
                     CLF-AGEN,  
                     HIGH-VALUE DELIMITED SIZE INTO KLV-SORT.
           IF IF-NS3 = KS
              STRING KLV-SORT   DELIMITED HIGH-VALUE,
                     CLF-ZONA,  
                     HIGH-VALUE DELIMITED SIZE INTO KLV-SORT.
           IF IF-NS4 = KS
              STRING KLV-SORT   DELIMITED HIGH-VALUE, 
                     CLF-GRM,
                     HIGH-VALUE DELIMITED SIZE INTO KLV-SORT.
           IF IF-NS5 = KS
              STRING KLV-SORT   DELIMITED HIGH-VALUE, 
                     CLF-RGSOC,
                     HIGH-VALUE DELIMITED SIZE INTO KLV-SORT.
           GO TO LCHIA.
       LWRSORT.
           MOVE KEYCF TO KLV-CHIA.
           WRITE RF-LAV INVALID KEY
                        MOVE 'WR-SORT' TO MESS GO TO ERRIO.
      *
           COPY 'grirpt-r' REPLACING 1 BY 2
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           GO TO CICLO. 
       LBSTA.
           IF IF-NS1 = 1 MOVE DS1 TO RT02 GO TO LSTSORT.
           IF IF-NS2 = 1 MOVE DS2 TO RT02 GO TO LSTSORT.
           IF IF-NS3 = 1 MOVE DS3 TO RT02 GO TO LSTSORT.
           IF IF-NS4 = 1 MOVE DS4 TO RT02 GO TO LSTSORT.
           IF IF-NS5 = 1 MOVE DS5 TO RT02 GO TO LSTSORT.
           MOVE SPACE TO RT02.
       LSTSORT.
      *-- inizializza parametri per stampa a caratteri --*
           MOVE C-TTS   TO RTTS.
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE SPACE TO RP-TIT2.
           STRING PINTE2 PSALDT PINTE3 ' PER ' RT02
                  DELIMITED SIZE INTO RP-TIT2.
      *---------------------------------------------*
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID KEY GO TO EX-RUN-ELABORA.
       LRDSORT.
           READ WDSLAV NEXT AT END GO TO STAMPA-TOT.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO LRDSORT.
           MOVE KLV-CHIA TO KEYCF.
           READ ANACLF INTO REKCLF INVALID KEY
                            PERFORM INVK-CLF GO TO ERRIO.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           COMPUTE SCALC = CLF-SESP + CLF-SE-D - CLF-SE-A.
           MOVE CLF-CD TO PCOD.
           MOVE CLF-RGSOC TO PRGSOC.
           MOVE CLF-INDIR TO PINDIR.
           IF CLF-CAP = ZERO MOVE SPACE TO PCAP
           ELSE MOVE CLF-CAP TO PCAP.
           MOVE CLF-CITTA TO PCITTA.
           MOVE CLF-CATCON TO PCATCO.
           MOVE CLF-AGEN TO PAGEN.
           MOVE CLF-ZONA TO PZONA.
           MOVE CLF-GRM  TO PGRUP.
           IF IF-FLPRE = ZERO GO TO SALTA.
           MOVE KEYCF TO KEYCX.
           READ ANACFX INTO REKCLF INVALID GO TO SALTA.
           IF SF-CFX = '9D' OR '9A' OR '35' MOVE RF-CFX TO REKCLF.
           COMPUTE SCALC = SCALC + CLF-SESP + CLF-SE-D - CLF-SE-A.
       SALTA.
           MOVE SCALC TO PSALDO.
           IF IF-LIREUR = 1
              MOVE SCALC TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPSALDO.
           IF IF-TPCLF = ZERO 
              IF SCALC < ZERO MOVE 'A' TO PDAR.
           IF IF-TPCLF = 1
              IF SCALC > ZERO MOVE 'D' TO PDAR.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           IF SCALC > ZERO ADD SCALC TO TOTDAR.
           IF SCALC < ZERO SUBTRACT SCALC FROM TOTAVR.
      *
           COPY 'grirpt-r'.
      *
           GO TO LRDSORT.
       STAMPA-TOT.
      *    MOVE SPACE TO RIGA.
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'TOTALE DARE' TO PINTET.
           MOVE TOTDAR TO PTOT.
           IF IF-LIREUR = 1
              MOVE TOTDAR TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTOT.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'TOTALE AVERE' TO PINTET.
           MOVE TOTAVR TO PTOT.
           IF IF-LIREUR = 1
              MOVE TOTAVR TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTOT.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ALL '=' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
           COMPUTE TOTSAL = TOTDAR - TOTAVR.
           MOVE 'SALDO' TO PINTET.
           MOVE TOTSAL TO PTOT.
           IF IF-LIREUR = 1
              MOVE TOTSAL TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EPTOT.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
      *    MOVE SPACE TO RIGA.
           MOVE ALL '=' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'Cod.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Ragione Sociale' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Indirizzo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Cap' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Citt' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'C.Co' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Age' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Zona' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'G.S' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Saldo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
