       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON180.
      *
      * Tabulato IVA clienti / fornitori
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'grifcdsl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'grifcd'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'gritabrk'.
           COPY 'griclfrk'.
           COPY 'parmb'.
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-FCD PIC X(15) VALUE 'forncd'.
       01  COMODI.
           05 SF-AZI  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-TAB  PIC XX.
           05 SF-FCD  PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).

           05 BDOG    PIC 9(5) VALUE ZERO.
           05 CODICE.
              10 MAS PIC 99.
              10 COD PIC 9(5).
           05 I      PIC 9 VALUE ZERO.
           05 COM1   PIC S9(15)V99 VALUE ZERO.
           05 SW PIC 9 VALUE ZERO.
       01  RX-91      PIC 99 COMP-X.
       01  FX-91      PIC 99 COMP-X VALUE 47.
       01  TOTALI.
           05 TOTRIG PIC S9(15)V99 VALUE ZERO.
           05 TOTPAG.
              10 TNF    PIC S9(7).
              10 TA     PIC S9(13)V99.
              10 TB     PIC S9(13)V99.
              10 TC     PIC S9(13)V99.
              10 TD     PIC S9(13)V99.
           05 TOTBOL.
              10 BDNUM  PIC S9(7).
              10 BDA    PIC S9(13)V99.
              10 BDB    PIC S9(13)V99.
              10 BDC    PIC S9(13)V99.
              10 BDD    PIC S9(13)V99.

           COPY 'vcon180.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-CATT      PIC X.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-CLFO      PIC X.
           05 IF-COD-1     PIC 9(5).
           05 IF-COD-2     PIC 9(5).
           05 IF-TIPO      PIC 9.
           05 IF-13IVA-1   PIC 9.
           05 IF-13IVA-2   PIC 9.
           05 IF-DATEL     PIC 9(6).

      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dclfcd'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'C' PERFORM CONT-ELABORA THRU EX-CONT-ELABORA 
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon180: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI ANACLF TABELL FORNCD.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'tabell' TO ID-TAB
                           MOVE 'forncd' TO ID-FCD
                           MOVE 'anaclf' TO ID-CLF.
           IF IF-FL = 1 OR 2    
                           MOVE 'anazol' TO ID-AZI
                           MOVE 'tabold' TO ID-TAB
                           MOVE 'forncx' TO ID-FCD
                           MOVE 'anacfx' TO ID-CLF.

           IF IF-FL = 3    MOVE 'anaazi' TO ID-AZI
                           MOVE 'tabell' TO ID-TAB
                           MOVE 'allfdx' TO ID-FCD
                           MOVE 'allcfx' TO ID-CLF.

           OPEN INPUT ANAAZI TABELL FORNCD ANACLF.

           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
           MOVE AZRGSOC TO IF-AZI-D.

           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY PERFORM INVK-TAB
                                               GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO IF-DATEL.
           MOVE AA9 TO GG9.
           MOVE IF-DATEL TO AA9.
           MOVE GGMMAA TO IF-DATEL.

           MOVE 'C'    TO IF-CLFO.
           MOVE ZERO   TO IF-TIPO.
           MOVE ZERO   TO IF-COD-1.
           MOVE ZERO   TO IF-COD-2.
           MOVE ZERO   TO IF-13IVA-1
                          IF-13IVA-2.
       EX-INI-CAMPI.
           EXIT.
      *------------------
       CONT-ELABORA.
      **** rel 6.1
      *    GO TO EX-CONT-ELABORA.
      *    IF IF-FL = 3 GO TO EX-CONT-ELABORA.
           IF IF-FL NOT = 3 GO TO EX-CONT-ELABORA.
      ************
           MOVE AZI-DTAPE TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE ZERO TO SW.
           IF AZI-FLGIS > ZERO MOVE 1 TO SW.
           IF GG9 NOT = 1 OR MM9 NOT = 1 MOVE 1 TO SW.
           IF SW = ZERO GO TO EX-CONT-ELABORA.

           MOVE 'Q' TO MB-TIPO.
           MOVE '2' TO MB-DEFAULT.
           MOVE 'Attenzione !' TO MB-TITOLO. 

           MOVE 'Il prospetto dei dati di fatturato ai  ' TO F-MES1.
           MOVE 'fini  I.V.A.   deve  essere  ottenuto  ' TO F-MES2.
           MOVE '         mediante la procedura         ' TO F-MES3.
           MOVE '       RICALCOLO ALLEGATI I.V.A.       ' TO F-MES4.
           MOVE '           Vuoi Continuare ?           ' TO F-MES5.
           MOVE 5 TO F-NMES.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP NOT = 'S' MOVE 3 TO IF-ST.   
       EX-CONT-ELABORA.
           EXIT.
      *-------------------------*
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-COD-2.
           MOVE 'IF-COD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-2.
           IF IF-COD-2 < IF-COD-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-COD-2.
      *
       V-DATEL.
           MOVE 'IF-DATEL' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATEL.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATEL TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DATEL.
      *
       V-TIPO.
           MOVE 'IF-TIPO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TIPO. 
           IF IF-TIPO > 1 
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-TIPO. 
      *
       V-13IVA-2.
           MOVE 'IF-13IVA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-13IVA-2.
           IF IF-13IVA-2 < IF-13IVA-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-13IVA-2.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           IF IF-CLFO = 'C' MOVE T01-MCLI TO MAS
           ELSE MOVE T01-MFOR TO MAS.

           IF IF-CLFO = 'C' MOVE 'C L I E N T I' TO RTCF
           ELSE MOVE 'F O R N I T O R I' TO RTCF.
           MOVE IF-DATEL TO PDATEL.
      **** rel 6.3
           MOVE IF-AZI-D TO RAZI.
      ************
           IF IF-CLFO = 'C' 
              MOVE '  DATI ANAGRAFICI DEI CLIENTI' TO TCLIFOR
           ELSE
              MOVE '  DATI ANAGRAFICI DEI FORNITORI' TO TCLIFOR.

      *
      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 58      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 7       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
           MOVE C-TINT3 TO XTINT(3).
           MOVE C-TINT4 TO XTINT(4).
           MOVE C-TINT5 TO XTINT(5).
           MOVE C-TINT6 TO XTINT(6).
           MOVE C-TINT7 TO XTINT(7).
           MOVE C-TINT8 TO XTINT(8).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           IF IF-CLFO = 'C' 
              STRING 'TABULATO IVA CLIENTI' 
                     DELIMITED SIZE INTO RP-TIT1
           ELSE
              STRING 'TABULATO IVA FORNITORI' 
                     DELIMITED SIZE INTO RP-TIT1.
      *
           MOVE SPACE TO RP-TIT2.
           STRING 'DATA DI ELABORAZIONE ' PDATEL 
                  DELIMITED SIZE INTO RP-TIT2.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG1-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
      *
           MOVE ZERO TO RF-FCD FCD-IMPON FCD-NIMPO FCD-ESENT
                        FCD-IMIVA FCD-TACCR.
           MOVE ZERO TO TOTRIG.
           MOVE ZERO TO TNF TA TB TC TD.
           MOVE ZERO TO BDNUM BDA BDB BDC BDD.
           MOVE KAZ-COD TO KCF-AZI.
           MOVE IF-COD-1 TO COD.
           MOVE CODICE TO KCF-COD.
           START ANACLF KEY NOT < KEYCF.
       RDCLF.
           READ ANACLF NEXT INTO REKCLF AT END GO TO CLST.
           IF SF-CLF = '9D' OR '9A' OR '35' GO TO RDCLF.
           IF KCF-AZI > KAZ-COD GO TO CLST.
           IF CLF-MS > MAS GO TO CLST.
           IF CLF-CD > IF-COD-2 GO TO CLST.
           IF CLF-13IVA < IF-13IVA-1 GO TO RDCLF.
           IF CLF-13IVA > IF-13IVA-2 GO TO RDCLF.
           IF IF-CLFO = 'C' GO TO CLF.
           IF CLF-13IVA NOT = 3 GO TO CLF.
           MOVE KEYCF TO KEYFD.
           READ FORNCD INVALID MOVE ZERO TO RF-FCD FCD-IMPON
                FCD-NIMPO FCD-ESENT FCD-IMIVA FCD-TACCR. 
           ADD CLF-NFATT TO BDNUM.
           ADD FCD-NFATT TO BDNUM.
           ADD CLF-IMPON TO BDA.
           ADD FCD-IMPON TO BDA.
           ADD CLF-IMIVA TO BDB.
           ADD FCD-IMIVA TO BDB.
           ADD CLF-ESENT TO BDC.
           ADD FCD-ESENT TO BDC.
           ADD CLF-NIMPO TO BDD.
           ADD FCD-NIMPO TO BDD.
           GO TO RDCLF.
       CLF.
           MOVE KEYCF TO KEYFD.
           READ FORNCD INVALID MOVE ZERO TO RF-FCD FCD-IMPON
                FCD-NIMPO FCD-ESENT FCD-IMIVA FCD-TACCR. 
           IF CLF-IMPON NOT = ZERO GO TO CLFOK.
           IF CLF-NIMPO NOT = ZERO GO TO CLFOK.
           IF CLF-ESENT NOT = ZERO GO TO CLFOK.
           IF CLF-IMIVA NOT = ZERO GO TO CLFOK.
           IF CLF-TACCR NOT = ZERO GO TO CLFOK.
           IF CLF-NFATT NOT = ZERO GO TO CLFOK.
           IF CLF-NOPNI NOT = ZERO GO TO CLFOK.
           IF CLF-NACCR NOT = ZERO GO TO CLFOK.
           IF FCD-IMPON NOT = ZERO GO TO CLFOK.
           IF FCD-NIMPO NOT = ZERO GO TO CLFOK.
           IF FCD-ESENT NOT = ZERO GO TO CLFOK.
           IF FCD-IMIVA NOT = ZERO GO TO CLFOK.
           IF FCD-TACCR NOT = ZERO GO TO CLFOK.
           IF FCD-NFATT NOT = ZERO GO TO CLFOK.
           IF FCD-NOPNI NOT = ZERO GO TO CLFOK.
           IF FCD-NACCR NOT = ZERO GO TO CLFOK.
           GO TO RDCLF.
       CLFOK.
           MOVE '!' TO PFIL1 PFIL2 PFIL3 PFIL4 
                       PFIL5 PFIL6 PFIL7 PFIL8.
           MOVE CLF-CD TO PCOD.
           MOVE CLF-PIVA TO PPIVA.
           MOVE CLF-RGS TO PRAG.
           MOVE 'CORRENTE' TO PANNO.
           MOVE CLF-NFATT TO PNF.
           ADD CLF-NFATT TO TNF.
           MOVE CLF-IMPON TO COM1.
           PERFORM C00-TOTALE-RIGA THRU C99.
           IF IF-TIPO = ZERO MOVE COM1 TO PA ELSE MOVE COM1 TO PA1.
           ADD COM1 TO TA.
           MOVE CLF-IMIVA TO COM1.
           PERFORM C00-TOTALE-RIGA THRU C99.
           IF IF-TIPO = ZERO MOVE COM1 TO PB ELSE MOVE COM1 TO PB1.
           ADD COM1 TO TB.
           MOVE CLF-ESENT TO COM1.
           PERFORM C00-TOTALE-RIGA THRU C99.
           IF IF-TIPO = ZERO MOVE COM1 TO PC ELSE MOVE COM1 TO PC1.
           ADD COM1 TO TC.
           MOVE CLF-NIMPO TO COM1.
           PERFORM C00-TOTALE-RIGA THRU C99.
           ADD COM1 TO TD.
           IF IF-TIPO = ZERO MOVE COM1 TO PD
           ELSE MOVE COM1 TO PD1.
           IF IF-TIPO = ZERO MOVE TOTRIG TO PT
           ELSE MOVE TOTRIG TO PT1.
           MOVE ZERO TO TOTRIG.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE '!' TO PFIL1 PFIL2 PFIL3 PFIL4 
                       PFIL5 PFIL6 PFIL7 PFIL8.
           IF CLF-RGS2 NOT = SPACE MOVE CLF-RGS2 TO PRAG
           ELSE
           MOVE CLF-INDIR TO PRAG.
           IF CLF-13IVA = ZERO MOVE 'ESCL.' TO PTEST.
           IF CLF-13IVA = 2 MOVE 'P.F.' TO PTEST.
           IF CLF-13IVA = 3 MOVE 'B.D.' TO PTEST.
           IF CLF-13IVA = 4 MOVE 'E.CEE' TO PTEST.
           MOVE 'PRECEDENTE' TO PANNO.
           MOVE FCD-NFATT TO PNF.
           ADD FCD-NFATT TO TNF.
           MOVE FCD-IMPON TO COM1.
           PERFORM C00-TOTALE-RIGA THRU C99.
           IF IF-TIPO = ZERO MOVE COM1 TO PA ELSE MOVE COM1 TO PA1.
           ADD COM1 TO TA.
           MOVE FCD-IMIVA TO COM1.
           PERFORM C00-TOTALE-RIGA THRU C99.
           IF IF-TIPO = ZERO MOVE COM1 TO PB ELSE MOVE COM1 TO PB1.
           ADD COM1 TO TB.
           MOVE FCD-ESENT TO COM1.
           PERFORM C00-TOTALE-RIGA THRU C99.
           IF IF-TIPO = ZERO MOVE COM1 TO PC ELSE MOVE COM1 TO PC1.
           ADD COM1 TO TC.
           MOVE FCD-NIMPO TO COM1.
           PERFORM C00-TOTALE-RIGA THRU C99.
           ADD COM1 TO TD.
           IF IF-TIPO = ZERO MOVE COM1 TO PD
           ELSE MOVE COM1 TO PD1.
           IF IF-TIPO = ZERO MOVE TOTRIG TO PT
           ELSE MOVE TOTRIG TO PT1.
           MOVE ZERO TO TOTRIG.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           IF CLF-RGS2 NOT = SPACE MOVE '!' TO PFIL1 PFIL2 PFIL3 PFIL4 
                                   PFIL5 PFIL6 PFIL7 PFIL8
                                   MOVE CLF-INDIR TO PRAG
                                   MOVE 'RIG1' TO RP-BLK
                                   PERFORM RPT-WR.
      *
           IF CLF-INDIR2 NOT = SPACE 
                                   MOVE '!' TO PFIL1 PFIL2 PFIL3 PFIL4 
                                   PFIL5 PFIL6 PFIL7 PFIL8
                                   MOVE CLF-INDIR2 TO PRAG
                                   MOVE 'RIG1' TO RP-BLK
                                   PERFORM RPT-WR.
      *
           MOVE '!' TO PFIL1 PFIL2 PFIL3 PFIL4 
                       PFIL5 PFIL6 PFIL7 PFIL8.
           MOVE CLF-CAP TO PCAP.
           MOVE CLF-CITTA TO PLOC.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           COPY 'grirpt-r'.
      *
           GO TO RDCLF.
       CLST.
           PERFORM B00-TOTALI THRU B99.
      *
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       B00-TOTALI.
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE '!' TO P2FIL3 P2FIL4 
                       P2FIL5 P2FIL6 P2FIL7 P2FIL8.
           IF IF-CLFO = 'C' GO TO B10.
           MOVE '   DATI RELATIVI ALLE IMPORTAZIONI' TO P2RAG.
           MOVE BDNUM TO P2NF.
           ADD BDNUM TO TNF.
           MOVE BDA TO COM1.
           PERFORM C00-TOTALE-RIGA THRU C99.
           IF IF-TIPO = ZERO MOVE COM1 TO PA ELSE MOVE COM1 TO P2A1.
           ADD COM1 TO TA.
           MOVE BDB TO COM1.
           PERFORM C00-TOTALE-RIGA THRU C99.
           IF IF-TIPO = ZERO MOVE COM1 TO PB ELSE MOVE COM1 TO P2B1.
           ADD COM1 TO TB.
           MOVE BDC TO COM1.
           PERFORM C00-TOTALE-RIGA THRU C99.
           IF IF-TIPO = ZERO MOVE COM1 TO PC ELSE MOVE COM1 TO P2C1.
           ADD COM1 TO TC.
           MOVE BDD TO COM1.
           PERFORM C00-TOTALE-RIGA THRU C99.
           IF IF-TIPO = ZERO MOVE COM1 TO PD ELSE MOVE COM1 TO P2D1.
           ADD COM1 TO TD.
           IF IF-TIPO = ZERO MOVE TOTRIG TO PT ELSE MOVE TOTRIG TO P2T1.
           MOVE ZERO TO TOTRIG.
       B10.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE '!' TO P2FIL3 P2FIL4 
                       P2FIL5 P2FIL6 P2FIL7 P2FIL8.
           MOVE '                            TOTALI' TO P2RAG.
           MOVE TNF TO P2NF.
           IF IF-TIPO = ZERO
              MOVE TA TO P2A
              MOVE TB TO P2B
              MOVE TC TO P2C
           ELSE MOVE TA TO P2A1
                MOVE TB TO P2B1
                MOVE TC TO P2C1.
           IF IF-TIPO = ZERO MOVE TD TO P2D
           ELSE MOVE TD TO P2D1.
           ADD TA TB TC TD GIVING COM1.
           IF IF-TIPO = ZERO MOVE COM1 TO P2T
           ELSE MOVE COM1 TO P2T1.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ZERO TO TNF TA TB TC TD.
       B99. EXIT.
      *-------------------
       C00-TOTALE-RIGA.
           ADD COM1 TO TOTRIG.
       C99. EXIT.
      *-------------------
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'Cod.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Partita Iva' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           IF IF-CLFO = 'C' 
              MOVE 'Dati Anagrafici dei Clienti' TO RP-IFLD
           ELSE
              MOVE 'Dati Anagrafici dei Fornitori' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Anno' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'N Fatture' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'A: Operaz. Imponibili' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'B: Imposte Addebitate' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'C: Senza App.Imposta' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'D: Non Imp. Art. 8' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Totale (A+B+C+D)' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
