       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON190.
      *
      * Gestione totali IVA - Calcolo e stampa
      *
      * Oltre ai valori soliti, FUN puo' valere anche:
      * M = caricamento dati del prospetto liquidazione IVA a video
      * w = valida tutto dati 2a videata (db2)
      * S = rientro nella run-elabora dopo la richiesta dati
      *     occorrenti per chiamare vcon145.
      *     Da lanciare dopo la 'R' se IF-HS-145 = 1
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griivasl'.
           COPY 'gritabsl'.
           COPY 'gri142sl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griiva'.
           COPY 'gritab'.
           COPY 'gri142'.
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 32 DATA RECORD RF-LAV.
       01  RF-LAV.
           02 KEYLV.
             05 KLV-AZI   PIC 9(3).
             05 KLV-COD   PIC 999.
           02 REKLAV.
             05 LAV-AVEN  PIC S9(11)V99.
             05 LAV-PAVE  PIC S9(11)V99.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'gritabrk'.
           COPY 'grit35rk'.
           COPY 'grit25rk'.
           COPY 'griivark'.
           COPY 'pariv'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parmb'.
           COPY 'parlk'.
           COPY 'pardmi'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-IVA PIC X(15) VALUE 'totiva'.
       01  ID-142 PIC X(15) VALUE 'wds142'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  ID-MOV PIC X(15).
      * parametri per vcon143
       01  PARLINK-143.
           05 FL-143     PIC 9.
           05 ID-TAB-143 PIC X(15).
           05 ID-IVA-143 PIC X(15).
           05 TOTIV-143  PIC S9(11)V99.
           05 RIMB-143   PIC S9(11)V99.
           05 COMPE-143  PIC S9(11)V99.
           05 ACCIVA-143 PIC S9(11)V99.
           05 NMES-143   PIC 99.
           05 T25ESE-143 PIC 9.
           05 DTVEK-143  PIC 9(5) COMP-3.
      * parametri per vcon142
       01  PARLINK-142.
           05 ID-IVA-142 PIC X(15).
           05 ID-TAB-142 PIC X(15).
      * parametri per vcon145
       01  PARLINK-145.
           05 ID-AZI-145  PIC X(15).
           05 ID-TAB-145  PIC X(15).
           05 ID-MOV-145  PIC X(15).
           05 FL-145      PIC 9.
           05 CDAZ-145    PIC 9(3).
           05 DTCON-145   PIC 9(6).
           05 DSAGG-145   PIC X(26).
      *
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-IVA   PIC XX.
           05 SF-142   PIC XX.
           05 SF-LAV   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 NETCRE   PIC S9(11)V99 VALUE ZERO.
           05 COMPE    PIC S9(11)V99 VALUE ZERO.
           05 TOTIVCN  PIC S9(12)V99 VALUE ZERO.
           05 T25PRIS  PIC zz9,99    VALUE ZERO.
           05 T25RIC   PIC S9(11)V99 VALUE ZERO.
           05 NTRIME   PIC 9         VALUE ZERO.
           05 SAV-ACREDI PIC S9(11)V99.
           05 SAV-DAVERS PIC S9(11)V99.
           05 ANNO4    PIC 9(4).
           05 N PIC 999 VALUE ZERO.
      *
           05 VTLIQ.
              10 DTLIQ PIC   9(5) OCCURS 12.
              10 IMLIQ PIC S9(11)V99 OCCURS 12.
           05 VTRIM.
              10 IMRIB PIC S9(11)V99 OCCURS 3.
           05 COMEDIT  PIC ZZZZ.ZZZ.ZZ9,99-.
           05 TOT3     PIC S9(13)V99.
           05 TOT4     PIC S9(13)V99.
           05 TOT5     PIC S9(13)V99.
           05 TOT6     PIC S9(13)V99.
           05 TOT7     PIC S9(13)V99.
           05 TOT8     PIC S9(13)V99.
           05 TOT9     PIC S9(13)V99.
           05 TOT10    PIC S9(13)V99.
           05 TOT11    PIC S9(13)V99.
           05 TOT12    PIC S9(13)V99.
           05 T25CIC   PIC 9         VALUE ZERO.
           05 TOT14    PIC S9(13)V99 VALUE ZERO.
           05 PRD      PIC 9(3)V99   VALUE ZERO.
           05 T25IND   PIC 9(7)    VALUE ZERO.
           05 T25PER   PIC 9       VALUE ZERO.
           05 T25ESE   PIC 9       VALUE ZERO.
           05 T25ATT   PIC 9       VALUE ZERO.
           05 T25PRI   PIC 9(3)V99 VALUE ZERO.
           05 T25RIM   PIC 9       VALUE ZERO.
           05 T25FLST  PIC 9       VALUE ZERO.
           05 T25ACC   PIC S9(11)V99 VALUE ZERO.
           05 T25RIB   PIC S9(11)V99 VALUE ZERO.
           05 COMODO   PIC S9(11)V99 VALUE ZERO.
           05 J        PIC 99      VALUE ZERO.
           05 PRI      PIC 9(3)V99 VALUE ZERO.
           05 K        PIC 99      VALUE ZERO.
           05 SW       PIC 9       VALUE ZERO.
           05 TOTAG    PIC 9       VALUE ZERO.
           05 DT1      PIC 9(5)    COMP-3 VALUE ZERO.
           05 DT2      PIC 9(5)    COMP-3 VALUE ZERO.
           05 DTAPE    PIC 9(5).
           05 COMO-CAL PIC 999V99  VALUE ZERO.
           05 IMPOSTA  PIC S9(13)V99 VALUE ZERO.
           05 IMPON    PIC S9(13)V99 VALUE ZERO.
           05 IMPONC   PIC S9(13)V99 VALUE ZERO.
           05 COMO-ATT PIC X       VALUE '0'.
           05 ULDET    PIC S9(12)V99 VALUE ZERO.
           05 ULDE2    PIC S9(12)V99 VALUE ZERO.
           05 TOTIV    PIC S9(12)V99 VALUE ZERO.
           05 TOTIVC   PIC S9(12)V99 VALUE ZERO.
           05 TOTIVD   PIC S9(12)V99 VALUE ZERO.
           05 TOTIND0  PIC S9(12)V99 VALUE ZERO.
           05 TOTIVCP  PIC S9(12)V99 VALUE ZERO.
           05 TOTALE   PIC S9(12)V99 VALUE ZERO.
      **** NT 7.1
      *    05 K1       PIC 99      VALUE ZERO.
      *    05 K2       PIC 99      VALUE ZERO.
           05 K1       PIC 9(4)    VALUE ZERO.
           05 K2       PIC 9(4)    VALUE ZERO.
      **********
           05 CALPERC  PIC 999V999 VALUE ZERO.
           05 COMPERC  PIC 999V99  VALUE ZERO.
           05 TOTPERC  PIC 999V99  VALUE ZERO.
           05 COMINCAS PIC S9(12)V99 VALUE ZERO.
           05 COMIVAC  PIC S9(11)V99 VALUE ZERO.
           05 TOTCVEN  PIC S9(13)V99 VALUE ZERO.
           05 TOTINC   PIC S9(13)V99 VALUE ZERO.
           05 TOTIMPC  PIC S9(13)V99 VALUE ZERO.
           05 TOTIVAC  PIC S9(11)V99 VALUE ZERO.
           05 DIFFER   PIC S9(11)V99 VALUE ZERO.
           05 TOTCOR   PIC S9(13)V99 VALUE ZERO.
           05 NMES     PIC 99      VALUE ZERO.
           05 ANNO1    PIC 99      VALUE ZERO.
           05 EARROT   PIC 9V99 VALUE 0,50.
           05 DTBIG    PIC 9(5).
           05 AABIG    PIC 9(4).
      **** rel 7.1
           05 DIFFDATE PIC 9(5) VALUE ZERO.
      ************
           05 DAT1.
              10 GG1 PIC 99 VALUE ZERO.
              10 MM1 PIC 99 VALUE ZERO.
              10 AA1 PIC 99 VALUE ZERO.
           05 DAT2.
              10 GG2 PIC 99 VALUE ZERO.
              10 MM2 PIC 99 VALUE ZERO.
              10 AA2 PIC 99 VALUE ZERO.
           05 MATRICE.
      **** NT 7.1
      *       10 CDIVA  PIC 9(3)   OCCURS 50.
      *       10 ACQVE  PIC S9(13)V99 OCCURS 50.
              10 CDIVA  PIC 9(3)   OCCURS 999.
      **********
      **** rel 4.0
      *       10 ACQVE  PIC S9(13) OCCURS 50.
      **** NT 7.1
      *       10 ACQVE  PIC S9(13)V99 OCCURS 50.
              10 ACQVE  PIC S9(13)V99 OCCURS 999.
      ************
           05 MESI.
              10 FILLER PIC X(9)    VALUE 'GENNAIO'.
              10 FILLER PIC X(9)    VALUE 'FEBBRAIO'.
              10 FILLER PIC X(9)    VALUE 'MARZO'.
              10 FILLER PIC X(9)    VALUE 'APRILE'.
              10 FILLER PIC X(9)    VALUE 'MAGGIO'.
              10 FILLER PIC X(9)    VALUE 'GIUGNO'.
              10 FILLER PIC X(9)    VALUE 'LUGLIO'.
              10 FILLER PIC X(9)    VALUE 'AGOSTO'.
              10 FILLER PIC X(9)    VALUE 'SETTEMBRE'.
              10 FILLER PIC X(9)    VALUE 'OTTOBRE'.
              10 FILLER PIC X(9)    VALUE 'NOVEMBRE'.
              10 FILLER PIC X(9)    VALUE 'DICEMBRE'.
           05 MESE REDEFINES MESI PIC X(9) OCCURS 12.
           05 TRIME.
              10 FILLER PIC X(12)   VALUE '1o TRIMESTRE'.
              10 FILLER PIC X(12)   VALUE '2o TRIMESTRE'.
              10 FILLER PIC X(12)   VALUE '3o TRIMESTRE'.
              10 FILLER PIC X(12)   VALUE '4o TRIMESTRE'.
           05 TRIM REDEFINES TRIME PIC X(12) OCCURS 4.
           05 COD      PIC 9(3)     VALUE ZERO.
      *
           05 DESCOR     PIC X(38) VALUE
           '   ____ C O R R I S P E T T I V I ___'.
           05 TESCOR PIC X(30)  VALUE '   IMP.LORDO   IMPONIBILE'.
           05 TESCOR1 PIC X(8)  VALUE 'IMPOSTA'.
      *
2      01  TINT5.
           05 FILLER  PIC X(42) VALUE SPACE.
           05 FILLER  PIC X(19) VALUE 'PROSPETTO CALCOLO'.
           05 FILLER  PIC X(29) VALUE 'CORRISPETTIVI A VENTILAZIONE'.
           05 FILLER  PIC X(42) VALUE SPACE.
2      01  TINT6.
           05 FILLER PIC X(16) VALUE SPACE.
           05 FILLER PIC X(30) VALUE 'COD.  DESCRIZIONE IVA'.
           05 FILLER PIC X(41) VALUE
           'ACQ.DEST.RIVEND.   %   IMPORTO CORRISP.'.
           05 FILLER PIC X(29) VALUE '   IMPONIBILE   IVA CALCOLATA'.
           05 FILLER PIC X(16) VALUE SPACE.
      *
           COPY 'vcon190.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
      * data
           05 IF-DTAGG     PIC 9(6).
           05 IF-TPLAV     PIC 9.
           05 IF-TPELA     PIC 9.
      * data
           05 IF-DATA-1    PIC 9(6).
      * data
           05 IF-DATA-2    PIC 9(6).
           05 IF-FLPRO     PIC 9.
           05 IF-FLLIQ     PIC 9.
           05 IF-PER-D     PIC X(15).
      * data
           05 IF-DTMOV-1   PIC 9(6).
      * data
           05 IF-DTMOV-2   PIC 9(6).


           05 IF-IVEN      PIC S9(11)V99.
           05 IF-IACQ      PIC S9(11)V99.
           05 IF-ICOR      PIC S9(11)V99.
           05 IF-ULTDE     PIC S9(11)V99.
           05 IF-DPREC     PIC S9(11)V99.
           05 IF-CPREC     PIC S9(11)V99.
           05 IF-PRORA     PIC S9(11)V99.
           05 IF-IMDE      PIC S9(11)V99.
           05 IF-IMCR      PIC S9(11)V99.
           05 IF-IMIN      PIC S9(11)V99.
           05 IF-ACCV      PIC S9(11)V99.
      * data
           05 IF-DTVE      PIC 9(6).
           05 IF-CDBA      PIC X(11).
           05 IF-RIMB      PIC S9(11)V99.
           05 IF-TOTCRE    PIC S9(11)V99.
      * data
           05 IF-DTCON     PIC 9(6).
           05 IF-DSAGG     PIC X(26).
      * flag hide-show interfaccia
      *    05 IF-HS-ULTRIN PIC 9.
           05 IF-HS-W-DB1  PIC 9.
           05 IF-HS-ACCV   PIC 9.
           05 IF-HS-PER-D  PIC 9.
           05 IF-HS-DTVE   PIC 9.
           05 IF-HS-RIMB   PIC 9.
           05 IF-HS-145    PIC 9.
      *------------------------------------------------------------------
      * note dei flags hide-show
      * IF-HS-W-DB1 : visualizzazione finestra prospetto (W-DB1)
      *               liquidazione IVA
      *               0=no  1=si
      * IF-HS-ACCV  : abilitazione campo IF-ACCV su W-DB1
      *               0=no  1=si
      * IF-HS-PER-D : abilitazione campo IF-PER-D su W-DB1
      *               0=no  1=si
      * IF-HS-DTVE  : abilitazione campi IF-DTVE e IF-CDBA su W-DB1
      *               0=no  1=si
      * IF-HS-RIMB  : abilitazione campi IF-RIMB e IF-TOTCRE su W-DB1
      *               0=no  1=si
      * IF-HS-145   : richiesta dati per vcon145
      *               (l'interfaccia lo testera' dopo la 'R')
      *               0=no
      *               1=si   l'interfaccia chiedera' IF-DTCON e IF-DSAGG
      *                      e lancera' la funzione 'S'.
      *------------------------------------------------------------------
      *
           05 IF-NMESE    PIC 99.
           05 IF-HS-RIMBO PIC 9.
           05 IF-DAVERS   PIC S9(11)V99.
           05 IF-ACREDI   PIC S9(11)V99.
           05 IF-VP7D     PIC S9(11)V99.
           05 IF-VP7C     PIC S9(11)V99.
           05 IF-VP8      PIC S9(11)V99.
           05 IF-VP9      PIC S9(11)V99.
           05 IF-VP11     PIC S9(11)V99.
           05 IF-VP12D    PIC S9(11)V99.
           05 IF-VP12C    PIC S9(11)V99.
           05 IF-VP13     PIC S9(11)V99.
           05 IF-VP19R    PIC S9(11)V99.
           05 IF-VP19C    PIC S9(11)V99.
           05 IF-FLGERR   PIC 9.
           05 IF-NBOL      PIC 9.
           05 IF-NUM-1     PIC 9(5).
           05 IF-ANNO      PIC 9(4).
           05 IF-PIEDE-1   PIC X(60).
           05 IF-PIEDE-2   PIC X(60).

       01  IF-MESS         PIC X(204).

       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcliva'.
           COPY 'dcltab'.
           COPY 'dcl142'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' OR
                    'w' GO TO F-WALIDA.
           IF FUN = 'M' IF IF-TPLAV = 1
                           PERFORM VISIVA THRU EX-VISIVA
                        END-IF
                        GO TO FINE.
           IF FUN = 'R' OR
                    'S' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
??                         GO TO FINE
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon190: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI TABELL TOTIVA WDS142.
           OPEN OUTPUT WDS142.
           CLOSE WDS142.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griivaer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDS142.
           CLOSE WDS142.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
      *
           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'tabell' TO ID-TAB
                           MOVE 'totiva' TO ID-IVA.
           IF IF-FL = 1 MOVE 'anazol' TO ID-AZI
                        MOVE 'tabold' TO ID-TAB
                        MOVE 'tivaol' TO ID-IVA.
           OPEN I-O TABELL.
           OPEN I-O TOTIVA.
           OPEN I-O ANAAZI.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE ZERO TO IF-REC.
           MOVE ZERO TO IF-IVEN
                        IF-IACQ
                        IF-ICOR
                        IF-ULTDE
                        IF-DPREC
                        IF-CPREC
                        IF-PRORA
                        IF-IMDE
                        IF-IMCR
                        IF-IMIN
                        IF-ACCV
                        IF-RIMB
                        IF-TOTCRE.
           MOVE SPACE TO IF-AZI-D
                         IF-PER-D
                         IF-CDBA
                         IF-DSAGG.
      *
           MOVE ZERO TO IF-NMESE
                        IF-HS-RIMBO
                        IF-DAVERS
                        IF-ACREDI
                        IF-VP7D
                        IF-VP7C
                        IF-VP8
                        IF-VP9
                        IF-VP11
                        IF-VP12D
                        IF-VP12C
                        IF-VP13
                        IF-VP19R
                        IF-VP19C
                        IF-FLGERR.
           MOVE ZERO TO COMPE.
      *
           MOVE 1    TO IF-TPLAV
                        IF-FLPRO
                        IF-FLLIQ.
           MOVE ZERO TO IF-TPELA.
      * azzeramento flags hide-show interfaccia
           MOVE ZERO TO IF-HS-W-DB1
                        IF-HS-ACCV
                        IF-HS-PER-D
                        IF-HS-DTVE
                        IF-HS-RIMB
                        IF-HS-145.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
           MOVE AZI-RGSOC TO IF-AZI-D.
      *
           MOVE ZERO TO TOTAG TOT3 TOT4 TOT5 TOT6 TOT7 TOT8
                        TOT9 TOT10 TOT12 TOT11
                        IF-CPREC IF-DPREC IF-ACCV
                        TOTIVC TOTIVD TOTIND0
                        TOTIV TOTALE.
           MOVE ZERO TO TOTIVCN TOT14.
           MOVE ZERO TO TOTIVCP.
           MOVE KAZ-COD TO IV-CDAZ.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-ESE TO T25ESE.
           IF IF-FL = 1  AND T25ESE = 1
              CLOSE ANAAZI TOTIVA TABELL
              MOVE 'tivaol' TO ID-IVA
              MOVE 'tabold' TO ID-TAB
              MOVE 'anazol' TO ID-AZI
              OPEN INPUT ANAAZI
              OPEN  I-O  TOTIVA
              OPEN  I-O  TABELL.
           MOVE KAZ-COD TO IV-CDAZ.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-ESE TO T25ESE.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
           IF AZI-DTAPE = ZERO
              MOVE 'Manca data apertura esercizio' TO MESS
              GO TO ERRIO.
           MOVE AZI-DTAPE TO DTAPE.
           IF T25ESE = 1
              MOVE AZI-DTAPE TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE 1 TO GG9 MM9
              MOVE 1 TO TIPOP1
              CALL 'rdata' USING PARCDT
              IF SWRET1 = 1
                 PERFORM ERR-DATA
                 GO TO ERRIO
              ELSE
                 MOVE AAGGG TO DTAPE.
           MOVE DTAPE TO IV-DTAPE.
           IF NOT (IF-FL = 1 AND T25ESE = 1) GO TO LPAZ0.
           CLOSE ANAAZI TABELL TOTIVA.
           MOVE 'anaazi' TO ID-AZI.
           MOVE 'tabell' TO ID-TAB.
           MOVE 'totiva' TO ID-IVA.
           OPEN INPUT ANAAZI.
           OPEN  I-O  TOTIVA.
           OPEN  I-O  TABELL.
       LPAZ0.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '3'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE ZERO TO K1.
       LPAZ1.
           ADD 1 TO K1.
           MOVE T25-DT3(K1) TO DTLIQ(K1).
           MOVE T25-VE3(K1) TO IMLIQ(K1).
           IF K1 < 7 GO TO LPAZ1.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '4'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-VE4(6) TO IF-ACCV.
           MOVE ZERO TO K2.
       LPAZ2.
           ADD 1 TO K1 K2.
           MOVE T25-DT4(K2) TO DTLIQ(K1).
           MOVE T25-VE4(K2) TO IMLIQ(K1).
           IF K2 < 5 GO TO LPAZ2.
           MOVE '5' TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '1'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-ATT TO T25ATT.
           MOVE T25-PRI TO T25PRI.
           MOVE T25-IND TO T25IND.
           MOVE T25-FLST TO T25FLST.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-ESE TO T25ESE.
           MOVE T25-PER TO T25PER.
           MOVE T25-RIM TO T25RIM.
           MOVE T25-CIC TO T25CIC.
           MOVE T25-DUP TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DTAGG.
      *
           IF T25-DUP = ZERO
              MOVE IV-DTAPE TO AAGGG DT1
           ELSE
              MOVE T25-DUP TO AAGGG DT1
              ADD 1 TO AAGGG DT1.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DATA-1 DAT1.
           MOVE ZERO TO IF-NBOL
                        IF-NUM-1
                        IF-ANNO.
           MOVE SPACE TO IF-PIEDE-1
                         IF-PIEDE-2.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
           IF FUN = 'w' GO TO V-DATI-DB2.
      *
       V-TPLAV.
           MOVE 'IF-TPLAV' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPLAV.
           IF NOT (IF-TPLAV = 1 OR 2 OR 3)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF IF-TPLAV NOT = 3 GO TO V-TPLAV-10.
           CALL 'vrdtbigb' USING DTBIG.
           IF DTBIG = ZERO GO TO V-TPLAV-10.
           MOVE DTBIG TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO AABIG.

           MOVE IF-DTAGG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF AA4 <= AABIG
              MOVE 'Big-Bang effettuato'     TO F-MES1
              MOVE 'Operazione non permessa' TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
       V-TPLAV-10.
           IF IF-TPLAV = 3
              MOVE ZERO TO IF-DATA-1
                           IF-DATA-2.
           IF IF-TPLAV = 2 OR 3
              MOVE 1 TO TOTAG
              MOVE 1 TO IF-TPELA
              MOVE ZERO TO IF-FLPRO
                           IF-FLLIQ.
           IF FUN NOT = 'V' GO TO E-TPLAV.
           IF IF-TPLAV = 1
              MOVE 1 TO IF-FLPRO
                        IF-FLLIQ
              MOVE ZERO TO IF-TPELA.
           IF IF-TPLAV = 2 OR
              (IF-TPLAV = 1 AND IF-TPELA = ZERO)
              IF T25-DUP = ZERO
                 MOVE IV-DTAPE TO AAGGG
              ELSE
                 MOVE T25-DUP TO AAGGG
                 ADD 1 TO AAGGG
              END-IF
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GGMMAA TO IF-DATA-1 DAT1
              MOVE AAGGG TO DT1 IV-DTINK.
       E-TPLAV.
      *
       V-TPELA.
           MOVE 'IF-TPELA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPELA.
           IF NOT (IF-TPELA = ZERO OR 1)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF IF-TPELA = ZERO AND
              IF-TPLAV = 1    AND
              FUN = 'V'
              IF T25-DUP = ZERO
                 MOVE IV-DTAPE TO AAGGG
              ELSE
                 MOVE T25-DUP TO AAGGG
                 ADD 1 TO AAGGG
              END-IF
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GGMMAA TO IF-DATA-1 DAT1
              MOVE AAGGG TO DT1 IV-DTINK.
           MOVE IF-TPELA TO TOTAG.
           IF IF-TPELA NOT = 1 GO TO E-TPELA.
           IF IF-TPLAV = 1
              MOVE ZERO TO IF-DATA-1
                           IF-DATA-2
              IF T25-DUP = ZERO
                 MOVE 'Nessun dato, selezione non ammessa' TO MESS
                 GO TO V-ERROR.
       E-TPELA.
      *
       V-DATA-1.
           MOVE 'IF-DATA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-1.
           IF IF-TPLAV = 2 OR 3 GO TO E-DATA-1.
           IF IF-TPLAV = 1 AND IF-TPELA = 1
              MOVE ZERO TO IF-DATA-1
              GO TO E-DATA-1.
           IF IF-DATA-1 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE IF-DATA-1 TO DAT1.
           MOVE AAGGG TO DT1 IV-DTINK.
           IF DT1 < IV-DTAPE
              MOVE 'Data anteriore a quella di apertura' TO MESS
              GO TO V-ERROR.
       E-DATA-1.
      *
       V-DATA-2.
           MOVE 'IF-DATA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-2.
           IF IF-TPLAV = 3 GO TO E-DATA-2.
           IF IF-TPLAV = 1 AND IF-TPELA = 1
              MOVE ZERO TO IF-DATA-2
              GO TO E-DATA-2.
           IF IF-DATA-2 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DT2.
           IF DT1 > DT2
              PERFORM ERR-DINC
              GO TO V-ERROR.
           IF (DT1 NOT > T25-DUP) AND (DT2 > T25-DUP)
              MOVE 'Periodo errato' TO MESS
              GO TO V-ERROR.
           MOVE DT2 TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE 1 TO TIPOP1.
           MOVE 31 TO GG9.
       LPDAT3.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 NOT = ZERO
              SUBTRACT 1 FROM GG9
              GO TO LPDAT3.
           MOVE GGMMAA TO IF-DATA-2 DAT2.
           MOVE IF-DATA-1 TO DAT1.
           IF AA2 NOT = AA1
              PERFORM ERR-DINC
              GO TO V-ERROR.
           MOVE AAGGG TO DT2 IV-DTFIK.
           IF DT2 > T25-DUP
              MOVE 1 TO IV-TSDAT
           ELSE
              MOVE ZERO TO IV-TSDAT.
           MOVE ZERO TO N.
           SUBTRACT MM1 FROM MM2 GIVING N.
           IF (IF-TPLAV = 1 OR 2) AND ((T25-PER = 0 AND N > 0) OR
                                       (T25-PER > 0 AND N > 2))
              MOVE ZERO TO N 
              MOVE 'Periodo errato' TO MESS
              GO TO V-ERROR.
           IF IF-TPLAV = 2 AND T25-PER > ZERO AND
              NOT (MM2 = 3 OR 6 OR 9 OR 12)
              MOVE 'Periodo errato' TO MESS
              GO TO V-ERROR.
       E-DATA-2.
      *
       V-FLPRO.
           MOVE 'IF-FLPRO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLPRO.
           IF IF-FLPRO = ZERO
              MOVE ZERO TO IF-FLLIQ.
       E-FLPRO.
      *
       V-FLLIQ.
           MOVE 'IF-FLLIQ' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLLIQ.
           IF IF-FLLIQ = 1 AND IF-FLPRO = ZERO
              MOVE ZERO TO IF-FLLIQ
              MOVE 'Selezione errata, adeguata' TO MESS
              GO TO V-ERROR.
       E-FLLIQ.
      *
           IF FUN = 'W' GO TO END-V-DATI.
      *
      * validazione dati 2a finestra (db2)
      *
       V-DATI-DB2.
      *
       V-ACCV.
           MOVE 'IF-ACCV' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ACCV.
           IF IF-HS-ACCV = ZERO
              GO TO E-ACCV.
           IF NMES NOT = 12 OR TOTAG = 1
              MOVE ZERO TO IF-ACCV
              GO TO E-ACCV.
           IF FUN = 'w'
              SUBTRACT IF-ACCV FROM TOTIV.
           PERFORM VISIVA THRU EX-VISIVA.
       E-ACCV.
      *
       V-DTVE.
           MOVE 'IF-DTVE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTVE.
           IF IF-HS-DTVE = ZERO
              GO TO E-DTVE.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTVE TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTVE.
      *
       V-DTCON.
           MOVE 'IF-DTCON' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTCON.
           IF IF-HS-145 = ZERO
              GO TO E-DTCON.
      * attenzione: controllo eseguito solo per chiamata diretta
           IF FUN NOT = 'V' GO TO E-DTCON.
           IF IF-DTCON = ZERO
                PERFORM ERR-ZERO
                GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTCON TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
      **** rel 7.1
           IF AAGGG < IV-DTAPE
              MOVE 'Data anteriore a quella di apertura' TO MESS
              GO TO V-ERROR.
      ************
           IF AAGGG < AZI-RVDT
              MOVE 'Data inferiore alla chiusura mensile' TO MESS
              GO TO V-ERROR.
       E-DTCON.
      *
       END-V-DATI.
           IF FUN NOT = 'W' GO TO END-V-DATI9.
           IF IF-TPLAV  = 1    AND 
              IF-DATA-1 = ZERO AND
              IF-DATA-2 = ZERO GO TO END-V-DATI9.
           CALL 'vrdtbigb' USING DTBIG.
           IF DTBIG = ZERO GO TO END-V-DATI9.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF AAGGG <= DTBIG
              IF IF-TPLAV = 1
                 MOVE 'Il periodo selezionato riguarda'      TO F-MES1
                 MOVE 'le transazioni fatte in Lire.'        TO F-MES2
                 MOVE 'L''operazione deve essere effettuata' TO F-MES3
                 MOVE 'da Primula versione Euro1.'           TO F-MES4
                 MOVE 'Vuoi proseguire ugualmente ?'         TO F-MES5
                 MOVE 5 TO F-NMES
                 MOVE 'Q' TO MB-TIPO
                 MOVE '2' TO MB-DEFAULT
                 CALL 'vrmbox' USING PARMB
                 IF MB-RISP NOT = 'S'
                    MOVE 'Operazione non eseguita ' TO MESS
                    MOVE 'IF-DATA-2' TO CAMPO
                    GO TO V-ERROR.
           IF AAGGG <= DTBIG
              IF IF-TPLAV = 2
                 MOVE 'Il periodo selezionato riguarda'      TO F-MES1
                 MOVE 'le transazioni fatte in Lire.'        TO F-MES2
                 MOVE 'L''operazione deve essere effettuata' TO F-MES3
                 MOVE 'da Primula versione Euro1.'           TO F-MES4
                 MOVE 4 TO F-NMES
                 MOVE 'IF-DATA-2' TO CAMPO
                 GO TO V-ERROR.
       END-V-DATI9.
      **** rel 7.1
           IF FUN NOT = 'W' GO TO END-V-DATI8.
      *
           IF IF-TPLAV NOT = 2 GO TO END-V-DATI8.
      *
           IF T25ESE NOT = ZERO 
              MOVE DTAPE TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE 31 TO GG9
              MOVE 12 TO MM9
              CALL 'rdata' USING PARCDT
              MOVE AAGGG TO DIFFDATE
              IF DT2 > DIFFDATE
                 MOVE 'W' TO MB-TIPO
                 MOVE 'Totali IVA e Aggiornamento' TO MB-TITOLO
                 MOVE 'Data selezionata maggiore della data' TO F-MES1
                 MOVE 'fine esercizio.' TO F-MES2
                 MOVE 2 TO F-NMES
                 CALL 'vrmbox' USING PARMB
              END-IF
           ELSE
              IF IF-FL NOT = ZERO
                 MOVE 'W' TO MB-TIPO
                 MOVE 'Totali IVA e Aggiornamento' TO MB-TITOLO
                 MOVE 'Questa procedura, se eseguita da vecchio' 
                    TO F-MES1
                 MOVE 'esercizio potrebbe aggiornare in modo' 
                    TO F-MES2
                 MOVE 'errato i Totali IVA.' TO F-MES3
                 MOVE 3 TO F-NMES
                 CALL 'vrmbox' USING PARMB.
      *    
      *
       END-V-DATI8.
      ************
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           IF IF-TPLAV = 3
              PERFORM AZZERA THRU EX-AZZERA
              GO TO NOPRINT.
           IF IF-TPLAV = 1
              IF IF-FLPRO = 1
                 PERFORM STAMP THRU EX-STAMP
                 IF IF-HS-145 = 1
                    GO TO NOPRINT
                 END-IF
              END-IF
              CLOSE WDS142
              CLOSE WDSLAV
              GO TO NOPRINT.
           IF IF-TPLAV = 2
              PERFORM AGGIORNA-TOT THRU EX-AGGIORNA-TOT
              GO TO NOPRINT.
      *
           COPY 'grirpt-r'.
       NOPRINT.
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
      * azzeramento totali
       AZZERA.
           MOVE 'Azzeramento Totali Annuali' TO MB-TITOLO.
           MOVE 'Vuoi azzerare ?' TO F-MES1.
           MOVE 1   TO F-NMES.
           MOVE 'Q' TO MB-TIPO.
           MOVE '2' TO MB-DEFAULT.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP = 'N' GO TO EX-AZZERA.
      *
           MOVE KAZ-COD TO KIV-AZI.
           MOVE '0'     TO KIV-CATT.
           MOVE 1       TO KIV-COD.
           START TOTIVA KEY NOT < KEYIV INVALID GO TO FNAZZ.
       LPAZZ.
           READ TOTIVA NEXT INTO REKIVA AT END GO TO FNAZZ.
           IF SF-IVA = '9D' OR '9A' OR '35' GO TO LPAZZ.
           IF IVA-AZI > KAZ-COD GO TO FNAZZ.
           MOVE ZERO TO IVA-PVIMP IVA-PVIVA IVA-PAIMP IVA-PAIVA
                        IVA-PAIVN IVA-PCOR  IVA-PAVE
                        IVA-VIMP IVA-VIVA IVA-AIMP IVA-AIVA IVA-AIVN
                        IVA-CORR IVA-AVEN IVA-IVCE IVA-IMCE.
           REWRITE RF-IVA FROM REKIVA INVALID PERFORM INVK-IVA
                                              GO TO ERRIO.
           GO TO LPAZZ.
       FNAZZ.
           MOVE 25      TO T25-TIP.
           MOVE '0'     TO T25-PRG.
           MOVE KAZ-COD TO T25-COD.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 KEPT LOCK INVALID PERFORM INVK-TAB
                                                     GO TO ERRIO.
           IF SF-TAB NOT = ZERO PERFORM REC-LOCK
                                GO TO FNAZZ.
           MOVE ZERO TO T25-DUP.
           MOVE ZERO TO IF-DTAGG.
           REWRITE RF-TAB FROM REKT25 INVALID PERFORM INVK-TAB
                                              GO TO ERRIO.
           UNLOCK TABELL.
           IF T25ESE = ZERO GO TO FNAZ9.
           CLOSE TABELL.
           MOVE 'tabold' TO ID-TAB.
           OPEN I-O TABELL.
           IF SF-TAB NOT = ZERO GO TO FNAZ9.
       FNAZ1.
           MOVE 25      TO T25-TIP.
           MOVE '0'     TO T25-PRG.
           MOVE KAZ-COD TO T25-COD.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 KEPT LOCK INVALID PERFORM INVK-TAB
                                                     GO TO ERRIO.
           IF SF-TAB NOT = ZERO PERFORM REC-LOCK
                                GO TO FNAZ1.
           MOVE ZERO TO T25-DUP.
           REWRITE RF-TAB FROM REKT25 INVALID PERFORM INVK-TAB
                                              GO TO ERRIO.
           UNLOCK TABELL.
           CLOSE TABELL.
           MOVE 'tabell' TO ID-TAB.
           OPEN I-O TABELL.
       FNAZ9.
           MOVE 'Azzeramento Dati Liquidazioni' TO MB-TITOLO.
           MOVE 'Vuoi azzerare ?' TO F-MES1.
           MOVE 1   TO F-NMES.
           MOVE 'Q' TO MB-TIPO.
           MOVE '2' TO MB-DEFAULT.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP = 'N' GO TO FNAZ99.
       FNAZ91.
           MOVE 25      TO T25-TIP.
           MOVE '0'     TO T25-PRG.
           MOVE KAZ-COD TO T25-COD.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 KEPT LOCK INVALID PERFORM INVK-TAB
                                                     GO TO ERRIO.
           IF SF-TAB NOT = ZERO PERFORM REC-LOCK
                                GO TO FNAZ91.
           MOVE ZERO TO T25-PPR T25-VER.
           REWRITE RF-TAB FROM REKT25 INVALID PERFORM INVK-TAB
                                              GO TO ERRIO.
           UNLOCK TABELL.
       FNAZ92.
           MOVE 25      TO T25-TIP.
           MOVE '2'     TO T25-PRG.
           MOVE KAZ-COD TO T25-COD.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 KEPT LOCK INVALID PERFORM INVK-TAB
                                                     GO TO ERRIO.
           IF SF-TAB NOT = ZERO PERFORM REC-LOCK
                                GO TO FNAZ92.
           MOVE ZERO TO T25-IVC T25-UDE T25-PRO.
           REWRITE RF-TAB FROM REKT25 INVALID PERFORM INVK-TAB
                                              GO TO ERRIO.
           UNLOCK TABELL.
       FNAZ93.
           MOVE 25      TO T25-TIP.
           MOVE '3'     TO T25-PRG.
           MOVE KAZ-COD TO T25-COD.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 KEPT LOCK INVALID PERFORM INVK-TAB
                                                     GO TO ERRIO.
           IF SF-TAB NOT = ZERO PERFORM REC-LOCK
                                GO TO FNAZ93.
           MOVE ZERO TO T25-DT3(1) T25-VE3(1) T25-DT3(2)
                        T25-VE3(2) T25-DT3(3) T25-VE3(3)
                        T25-DT3(4) T25-VE3(4) T25-DT3(5)
                        T25-VE3(5) T25-DT3(6) T25-VE3(6)
                        T25-DT3(7) T25-VE3(7).
           REWRITE RF-TAB FROM REKT25 INVALID PERFORM INVK-TAB
                                              GO TO ERRIO.
           UNLOCK TABELL.
       FNAZ94.
           MOVE 25      TO T25-TIP.
           MOVE '4'     TO T25-PRG.
           MOVE KAZ-COD TO T25-COD.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 KEPT LOCK INVALID PERFORM INVK-TAB
                                                     GO TO ERRIO.
           IF SF-TAB NOT = ZERO PERFORM REC-LOCK
                                GO TO FNAZ94.
           MOVE ZERO TO T25-DT4(1) T25-VE4(1) T25-DT4(2)
                        T25-VE4(2) T25-DT4(3) T25-VE4(3)
                        T25-DT4(4) T25-VE4(4) T25-DT4(5)
                        T25-VE4(5) T25-DT4(6) T25-VE4(6).
           REWRITE RF-TAB FROM REKT25 INVALID PERFORM INVK-TAB
                                              GO TO ERRIO.
           UNLOCK TABELL.
           PERFORM AZZ-DPEIVA THRU EX-AZZ-DPEIVA.
       FNAZ99.
      *
       EX-AZZERA.
           EXIT.
      *------------------
       STAMP.
           IF FUN = 'S' GO TO RUN-RIENTRO.
      *
           IF RP-TRPT = ZERO 
              MOVE 'E'' possibile stampare il Report' TO F-MES1
              MOVE 'solo a carattere o visuale.'     TO F-MES2
              MOVE 'Forzato visuale.' TO F-MES3
              MOVE 3 TO F-NMES
              MOVE 'W' TO MB-TIPO
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO RP-TRPT.
      *
           IF IF-NBOL = 1
              MOVE 'PBK_ADES' TO RP-BLK
              MOVE IF-PIEDE-1 TO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE 'PBK_ACIT' TO RP-BLK
              MOVE IF-PIEDE-2 TO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE 'PBK_DPAG' TO RP-BLK
              STRING 'Anno: ' IF-ANNO
                     DELIMITED SIZE INTO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE 'PBK_NPAG' TO RP-BLK
              MOVE IF-NUM-1 TO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE IF-ANNO  TO PANNO
              MOVE '/'      TO PBARR
              IF IF-ANNO = ZERO 
                 MOVE SPACE TO PANNO  PBARR 
              END-IF
              MOVE ZERO TO FNPG
           ELSE
              MOVE SPACE TO RTPAG
              MOVE 1 TO FNPG
              MOVE 'np' TO RP-VERM.    *> per non stampare il piede
      *
           MOVE ZERO TO IF-HS-145.
      *
           MOVE IF-PER-D  TO TSY4.
           MOVE AZI-RGSOC TO TSX3.
      *
           MOVE ZERO TO K SW.
       STAMP1.
           MOVE 'R I E P I L O G A T I V O   I V A' TO TSX1.
           MOVE 'D I   P E R I O D O' TO TSX4.
           IF TOTAG = 1 MOVE 'P R O G R E S S I V I' TO TSX4.
           MOVE IF-PER-D TO TSX41.
           IF K = ZERO
              MOVE AZI-DATT TO RDATT
              MOVE '0' TO COMO-ATT
              GO TO STAMP1-1.
           MOVE T35-DATT TO RDATT.
           MOVE T35-CATT TO COMO-ATT.
       STAMP1-1.
           IF K = ZERO
              MOVE ZERO TO XCRR
              MOVE 1 TO RP-JMP
           ELSE
              MOVE 2 TO XCRR
              MOVE 2 TO RP-FLGR
              MOVE RDATT TO SOTTOY
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR
              PERFORM STA-PIE
      *
              GO TO STAMP2.
           IF IV-CDCOR NOT = ZERO
              MOVE DESCOR TO RDESCOR
              MOVE TESCOR TO RTESCOR
              MOVE TESCOR1 TO RTESCOR1.
       STAMP2.
      *
      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 58      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 5       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
           MOVE C-TINT3 TO XTINT(3).
           MOVE C-TINT4 TO XTINT(4).
           MOVE C-TINT5 TO XTINT(5).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'RIEPILOGATIVO IVA DI PERIODO - ' TSX41
                  DELIMITED SIZE INTO RP-TIT1.
           IF TOTAG = 1
              STRING 'RIEPILOGATIVO IVA PROGRESSIVI - ' TSX41
                     DELIMITED SIZE INTO RP-TIT1.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG3-INTC.
           PERFORM RPT-RIG5-INTC.
      *
      *    MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
      *
           MOVE 1 TO RP-FLGR.
           MOVE RDATT TO SOTTOY.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 2 TO XCRR.
           MOVE ZERO TO TOT3 TOT4 TOT5 TOT6 TOT7 TOT8
                        TOT9 TOT10 TOT11 TOTCOR TOTCVEN K1.
       STAMP2-1.
           ADD 1 TO K1.
      **** NT 7.1
      *    IF K1 > 50 GO TO STAMP2-2.
           IF K1 > 999 GO TO STAMP2-2.
      **********
           MOVE ZERO TO CDIVA(K1) ACQVE(K1).
           GO TO STAMP2-1.
       STAMP2-2.
           MOVE KAZ-COD TO K142-AZI.
           IF K = ZERO
              MOVE '0' TO K142-CATT
           ELSE
              MOVE T35-CATT TO K142-CATT.
           MOVE 1 TO K142-COD.
           START WDS142 KEY NOT < KEY142 INVALID MOVE 1 TO SW
                                                 GO TO STOT.
       LOPST.
           READ WDS142 NEXT AT END MOVE 1 TO SW
                                   GO TO STOT.
           IF SF-142 = '9D' OR '9A' OR '35' GO TO LOPST.
           IF K142-AZI > KAZ-COD MOVE 1 TO SW
                                GO TO STOT.
           IF K142-CATT NOT = COMO-ATT GO TO STOT.
           IF K142-COD = 999
              ADD L142-CORR TO TOTCOR
              GO TO LOPST.
           MOVE 3        TO KTB-TIP.
           MOVE K142-COD TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.

           IF L142-AVEN = ZERO AND
              L142-PAVE = ZERO GO TO CAR1.
           IF T03-ALVEN = ZERO
              MOVE K142-COD TO COD
           ELSE
              MOVE T03-ALVEN TO COD.
           MOVE ZERO TO K1.
       CAR0.
           ADD 1 TO K1.
      **** NT 7.1
      *    IF K1 > 50 GO TO LOPST-1.
           IF K1 > 999 GO TO LOPST-1.
      **********
           IF CDIVA(K1) = ZERO
              MOVE COD TO CDIVA(K1)
              IF TOTAG = 1
                 ADD L142-PAVE TO ACQVE(K1) TOTCVEN
                 GO TO CAR1
              ELSE
                 ADD L142-AVEN TO ACQVE(K1) TOTCVEN
                 ADD L142-PAVE TO ACQVE(K1) TOTCVEN
                 GO TO CAR1.
           IF CDIVA(K1) = COD
              IF TOTAG = 1
                 ADD L142-PAVE TO ACQVE(K1) TOTCVEN
                 GO TO CAR1
              ELSE
                 ADD L142-AVEN TO ACQVE(K1) TOTCVEN
                 ADD L142-PAVE TO ACQVE(K1) TOTCVEN
                 GO TO CAR1.
           GO TO CAR0.
       CAR1.
           MOVE T03-DSIVA  TO RG1.
           MOVE TAB-DESCR  TO RG2.
           MOVE L142-VIMP  TO RG3.
           MOVE L142-VIVA  TO RG4.
           MOVE L142-AIMP  TO RG5.
           MOVE L142-AIVA  TO RG6.
           MOVE L142-AIVN  TO RG7.
           IF T03-ULDET > ZERO AND L142-AIMP > ZERO
              COMPUTE IMPOSTA = ((L142-AIMP * T03-ULDET) / 100) + 0,0049
              MOVE IMPOSTA TO ULDET.
           IF T03-ULDET > ZERO AND L142-AIMP < ZERO
              COMPUTE IMPOSTA = ((L142-AIMP * T03-ULDET) / 100) - 0,0049
              MOVE IMPOSTA TO ULDET.
           IF T03-ULDE2 > ZERO AND L142-AIMP > ZERO
              COMPUTE IMPOSTA = ((L142-AIMP * T03-ULDE2) / 100) + 0,0049
              MOVE IMPOSTA TO ULDE2.
           IF T03-ULDE2 > ZERO AND L142-AIMP < ZERO
              COMPUTE IMPOSTA = ((L142-AIMP * T03-ULDE2) / 100) - 0,0049
              MOVE IMPOSTA TO ULDE2.
           IF IV-CDCOR = ZERO GO TO STRS.
           IF L142-CORR = ZERO
              MOVE ZERO TO IMPON IMPOSTA
              GO TO LOPST-1.
           COMPUTE COMO-CAL = (100 + T03-ALIVA) / 100.
           COMPUTE IMPON    = L142-CORR / COMO-CAL.
           COMPUTE IMPOSTA  = L142-CORR - IMPON.
       LOPST-1.
           MOVE L142-CORR TO RG8.
           MOVE IMPON     TO RG9.
           MOVE IMPOSTA   TO RG10.
       STRS.
      **** rel 7.1
      * non stampa i totalizzatori con tutti i dati a zero
           IF L142-VIMP  = ZERO AND
              L142-VIVA  = ZERO AND
              L142-AIMP  = ZERO AND
              L142-AIVA  = ZERO AND
              L142-AIVN  = ZERO AND
              L142-CORR  = ZERO AND
              IMPON      = ZERO AND
              IMPOSTA    = ZERO
              GO TO NO-STRIG3.
      ************
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      **** rel 7.1
       NO-STRIG3.
      ************
      *
           MOVE 1 TO XCRR.
           IF ULDET NOT = ZERO
              MOVE 'ULTERIORE DETRAZIONE' TO RG2
              MOVE ULDET TO RG6
              MOVE 'RIG3' TO RP-BLK
              PERFORM RPT-WR
              PERFORM STA-PIE.
      *
           IF ULDE2 NOT = ZERO
              MOVE 'ULTERIORE DETRAZ.(2)' TO RG2
              MOVE ULDE2 TO RG6
              MOVE 1 TO XCRR
              MOVE 'RIG3' TO RP-BLK
              PERFORM RPT-WR
              PERFORM STA-PIE.
      *
           ADD L142-VIMP TO TOT3.
           ADD L142-VIVA TO TOT4.
           ADD L142-AIMP TO TOT5.
           ADD L142-AIVA TO TOT6.
           ADD L142-AIVN TO TOT7.
           ADD L142-CORR TO TOT8.
           ADD IMPON     TO TOT9.
           ADD IMPOSTA   TO TOT10.
           ADD ULDET     TO TOT11.
           MOVE ZERO     TO ULDET.
           ADD ULDE2     TO TOT11.
           MOVE ZERO     TO ULDE2.
           GO TO LOPST.
       STOT.
           MOVE ALL '-' TO P999(27:).
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 'T O T A L I   I V A      ' TO RG2.
           MOVE TOT3    TO RG3.
           MOVE TOT4    TO RG4.
           MOVE TOT5    TO RG5.
           MOVE TOT6    TO RG6.
           MOVE TOT7    TO RG7.
           IF IV-CDCOR = ZERO GO TO STOT-0.
           MOVE TOT8  TO RG8.
           MOVE TOT9  TO RG9.
           MOVE TOT10 TO RG10.
       STOT-0.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           IF TOT11 > ZERO
              MOVE 'ULTERIORE DETRAZIONE' TO RG2
              MOVE TOT11 TO RG6
              MOVE 1 TO XCRR
              MOVE 'RIG3' TO RP-BLK
              PERFORM RPT-WR
              PERFORM STA-PIE.
      *
           IF TOT6 = ZERO GO TO FNPRA.
           IF T25ATT = ZERO AND
              T25PRI = ZERO AND
              T25IND = ZERO GO TO FNPRA.
           MOVE T25PRI TO PRI.
           IF T25ATT = 1
              IF COMO-ATT NOT = ZERO AND T35-GES = 1
                 MOVE T35-PRI TO PRI.
           IF PRI = ZERO AND T25IND = ZERO GO TO FNPRA.
           COMPUTE PRD = 100 - PRI.
           COMPUTE TOT12 = ( ( TOT6 * PRD ) / 100 ) + 0,0049.
           COMPUTE TOT14 = ( ( TOT6 * PRI ) / 100 ) + 0,0049.
           IF PRD = ZERO
              IF COMO-ATT NOT = ZERO AND T35-FLST = ZERO GO TO FNPRA
              ELSE
                 IF COMO-ATT = ZERO AND T25FLST = ZERO GO TO FNPRA.
           MOVE 'IVA DETRAIB. PRO-RATA' TO RG2.
           MOVE T25PRI TO T25PRIS.
           IF T25ATT = 1
                  IF COMO-ATT NOT = ZERO AND T35-GES = 1
                  MOVE T35-PRI TO T25PRIS.
           MOVE 'IVA DETRAIB. PRO-RATA ' TO RG2.
           MOVE T25PRIS TO RG3PRIS. 
           MOVE ' %'    TO RPERC.
           MOVE TOT14 TO RG6.
           MOVE 1 TO XCRR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
       FNPRA.
           MOVE ALL '=' TO P999(27:).
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 3 TO XCRR.
           IF IV-CDCOR = ZERO GO TO STOT-01.
           MOVE ZERO TO K1 COMPERC COMINCAS TOTINC
                        TOTIMPC TOTPERC COMIVAC TOTIVAC.
           PERFORM LOOP-LAV THRU EX-LOOP-LAV.
           IF TOTCVEN = ZERO GO TO STOT-01.
           MOVE TINT5 TO P999.
           MOVE 3 TO XCRR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE TINT6 TO P999.
           MOVE 2 TO XCRR.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE ZERO TO K2.
           MOVE LOW-VALUE TO KEYLV.
           MOVE KAZ-COD   TO KLV-AZI.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO STCVEN2.
       RDNX.
           READ WDSLAV NEXT AT END GO TO STCVEN2.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO RDNX.

           ADD 1 TO K2.
           MOVE ZERO TO ACQVE(1).

           MOVE 3         TO KTB-TIP.
           MOVE KLV-COD   TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-DSIVA TO RIGC1.
           MOVE TAB-DESCR TO RIGC2.
           IF TOTAG = 1
              MOVE LAV-PAVE  TO ACQVE(1)
           ELSE
              ADD LAV-PAVE TO LAV-AVEN GIVING ACQVE(1).

           MOVE ACQVE(1) TO RIGC3.
           COMPUTE CALPERC = (ACQVE (1) * 100) / TOTCVEN.

           ADD 0,005 TO CALPERC.
           MOVE CALPERC TO COMPERC.
           ADD COMPERC TO TOTPERC.
           IF K2 = K1
              COMPUTE DIFFER = 100 - TOTPERC
              ADD DIFFER TO COMPERC
              COMPUTE COMINCAS = TOTCOR - TOTINC
           ELSE
              COMPUTE COMINCAS = (TOTCOR * COMPERC) / 100.
           MOVE COMPERC TO RIGC4.
           ADD COMINCAS TO TOTINC.
       STCVEN1.
           MOVE COMINCAS TO RIGC5.
           COMPUTE COMO-CAL = (100 + T03-ALIVA) / 100.
           COMPUTE IMPONC = COMINCAS / COMO-CAL.
           ADD IMPONC TO TOTIMPC.
           MOVE IMPONC TO RIGC51.
           COMPUTE COMIVAC = COMINCAS - IMPONC.
           MOVE COMIVAC TO RIGC6.
           ADD COMIVAC TO TOTIVAC.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 1 TO XCRR.
           GO TO RDNX.
       STCVEN2.
           MOVE ALL '-' TO P998.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG6' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 'TOTALE' TO RIGC2.
      *
           MOVE TOTCVEN  TO RIGC3.
           MOVE TOTINC   TO RIGC5.
           MOVE TOTIMPC  TO RIGC51.
           MOVE TOTIVAC  TO RIGC6.
           MOVE 'RIG5' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE ALL '=' TO P998.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG6' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 2 TO XCRR.
       STOT-01.
           IF SW = 1 GO TO STOT-1.
           MOVE 35        TO T35-TIP.
           MOVE KAZ-COD   TO T35-CDAZ.
           MOVE K142-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           MOVE 1 TO K.
           GO TO STAMP1.
       STOT-1.
           IF K = ZERO GO TO STOT-2.
      * riga vuota visuale
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 'T O T. G E N E R A L I '  TO RG2.
           MOVE IV-TIMPOV TO RG3.
           MOVE IV-TIVAV  TO RG4.
           MOVE IV-TIMPOA TO RG5.
           MOVE IV-TIVAA  TO RG6.
           MOVE IV-TINDA  TO RG7.
           IF IV-CDCOR = ZERO GO TO STOT-2.
           MOVE IV-TINCAC TO RG8.
           MOVE IV-TIMPOC TO RG9.
           MOVE IV-TIVACO TO RG10.
       STOT-2.
           MOVE 3 TO XCRR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           IF K = ZERO GO TO STOT-21.
           IF IV-TULDET > ZERO
              MOVE 'ULTERIORE DETRAZIONE' TO RG2
              MOVE IV-TULDET TO RG6
              MOVE 1 TO XCRR
              MOVE 'RIG3' TO RP-BLK
              PERFORM RPT-WR
              PERFORM STA-PIE.
      *
           IF IV-DEP0 > ZERO OR IV-INDEP0 > ZERO
              MOVE 'IVA DETRAIB. PRO-RATA' TO RG2
              MOVE IV-DEP0 TO RG6
              MOVE 1 TO XCRR
              MOVE 'RIG3' TO RP-BLK
              PERFORM RPT-WR
              PERFORM STA-PIE.
      *
           MOVE 1 TO XCRR.
           MOVE ALL '=' TO P999(27:).
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
       STOT-21.
           IF IF-CPREC  = ZERO AND
              IV-IVAVEN = ZERO AND
              IV-IVACOR = ZERO AND
              IV-IVAACQ = ZERO AND
              IV-IVAULT = ZERO AND
              IV-IVAIND = ZERO GO TO STPRO-6.
           IF IF-FLLIQ = ZERO GO TO STPRO-6.
           MOVE 4 TO XCRR.
      * righe vuote grafico
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 1 TO NINT.
      *
           MOVE 'L I Q U I D A Z I O N E   I V A ' TO TLIQ.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE ALL '-' TO SOTTOY.
           MOVE 1 TO XCRR.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE '         DEBITI' TO DEBITI.
           MOVE '        CREDITI' TO CREDITI.
           MOVE 1 TO XCRR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 2 TO XCRR.
           IF IF-CPREC = ZERO AND IF-DPREC = ZERO GO TO STPRO-1.
       STPRO-1.
           COMPUTE TOTIVD = IV-IVAVEN + IV-IVACOR.
           MOVE IV-DTINK TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO ANNO4.
           IF ANNO4 = 2000 OR 2001
              IF TOTIVD > 0 ADD EARROT TO TOTIVD
              ELSE          SUBTRACT EARROT FROM TOTIVD
              END-IF
              COMPUTE TOTIVD = TOTIVD / 100
              COMPUTE TOTIVD = TOTIVD * 100.
           IF TOTIVD = ZERO GO TO STPRO-2.
           MOVE 'IVA VENDITE / CORRISPETTIVI ......:' TO DESCRI.
           MOVE TOTIVD TO RVALOR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 1 TO XCRR.
       STPRO-2.
           COMPUTE TOTIVC = IV-IVAACQ + IV-IVAULT.
           IF IV-DEP0 = ZERO AND IV-INDEP0 NOT = ZERO
              COMPUTE TOTIVC = IV-IVAACQ + IV-IVAULT - IV-INDEP0.
           IF ANNO4 = 2000 OR 2001
              IF TOTIVC > 0 ADD EARROT TO TOTIVC
              ELSE          SUBTRACT EARROT FROM TOTIVC
              END-IF
              COMPUTE TOTIVC = TOTIVC / 100
              COMPUTE TOTIVC = TOTIVC * 100.
           IF TOTIVC = ZERO AND IV-IVAACQ = ZERO GO TO STPRO-4.
           MOVE IV-IVAACQ TO TOTIVCP.
           IF ANNO4 = 2000 OR 2001
              IF TOTIVCP > 0 ADD EARROT TO TOTIVCP
              ELSE          SUBTRACT EARROT FROM TOTIVCP
              END-IF
              COMPUTE TOTIVCP = TOTIVCP / 100
              COMPUTE TOTIVCP = TOTIVCP * 100.
           MOVE 'IVA ACQUISTI / ULT.DETRAZ. .......:' TO DESCRI.
           IF TOTIVC = ZERO AND IV-IVAACQ NOT = ZERO
              MOVE TOTIVCP TO RVALOC
           ELSE
              MOVE TOTIVC TO RVALOC.
           MOVE ZERO TO TOTIVCN.
           IF IV-DEP0 NOT = ZERO
              COMPUTE TOTIVCN = IV-DEP0 + IV-IVAULT.
           IF IV-DEP0 = ZERO AND IV-INDEP0 NOT = ZERO
              COMPUTE TOTIVCN = IV-IVAACQ + IV-IVAULT - IV-INDEP0.
           IF ANNO4 = 2000 OR 2001
              IF TOTIVCN > 0 ADD EARROT TO TOTIVCN
              ELSE          SUBTRACT EARROT FROM TOTIVCN
              END-IF
              COMPUTE TOTIVCN = TOTIVCN / 100
              COMPUTE TOTIVCN = TOTIVCN * 100.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 1 TO XCRR.
       STPRO-4.
           IF IV-DEP0 = ZERO AND IV-INDEP0 = ZERO
              GO TO STPRO-43.
           MOVE IV-DEP0 TO TOTIND0.
           IF ANNO4 = 2000 OR 2001
              IF TOTIND0 > 0 ADD EARROT TO TOTIND0
              ELSE           SUBTRACT EARROT FROM TOTIND0
              END-IF
              COMPUTE TOTIND0 = TOTIND0 / 100
              COMPUTE TOTIND0 = TOTIND0 * 100.
           MOVE TOTIND0 TO VALOREC.
           MOVE 'IVA DETRAIBILE / PRO-RATA ........:' TO DESCRI.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 1 TO XCRR.
       STPRO-43.
           IF TOTIVCN NOT = ZERO
              COMPUTE TOTIV = TOTIVD - TOTIVCN
           ELSE
              COMPUTE TOTIV = TOTIVD - TOTIVC.
           MOVE ZERO TO IF-VP7D IF-VP7C.
           IF TOTIV > ZERO MOVE TOTIV TO IF-VP7D
              ELSE
              COMPUTE IF-VP7C = TOTIV * - 1.
           IF IF-VP7D NOT = ZERO
              MOVE 'IVA A DEBITO DEL PERIODO..........:' TO DESCRI
              MOVE IF-VP7D TO VALORE.
           IF IF-VP7C NOT = ZERO
              MOVE 'IVA A CREDITO DEL PERIODO.........:' TO DESCRI
              MOVE IF-VP7C TO VALOREC.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 1 TO XCRR.
           MOVE 'VARIAZ.IMPOSTA E INTER. PER.PREC..:' TO DESCRI
           IF P-VP8 < ZERO
              COMPUTE VALOREC = P-VP8 * - 1
           ELSE
              MOVE P-VP8 TO VALORE.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 'IVA NON VERS. E INTER. PER.PREC...:' TO DESCRI
           MOVE P-VP9 TO VALORE.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 'DEBITO IVA PER.PRECEDENTE ........:' TO DESCRI
           MOVE IF-DPREC  TO VALORE.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 'CREDITO IVA PER.PRECEDENTE .......:' TO DESCRI
           MOVE IF-CPREC TO VALOREC.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 'CRED.IVA COMPENSABILE DETRATTO ...:' TO DESCRI
           MOVE P-VP11 TO VALOREC.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE ZERO TO IF-VP12D IF-VP12C.
           IF IF-VP7C > ZERO GO TO STPRO-48.
           COMPUTE IF-VP12D = IF-VP7D + P-VP8 + P-VP9
              + IF-DPREC - IF-CPREC - P-VP11.
           MOVE IF-VP12D TO TOTIV.
           IF IF-VP12D < ZERO COMPUTE IF-VP12C = IF-VP12D * - 1
              MOVE ZERO TO IF-VP12D.
           GO TO STPRO-49.
       STPRO-48.
           COMPUTE IF-VP12C = IF-VP7C - P-VP8 - P-VP9
              - IF-DPREC + IF-CPREC + P-VP11.
           COMPUTE TOTIV = IF-VP12C * - 1.
           IF IF-VP12C < ZERO COMPUTE IF-VP12D = IF-VP12C * - 1
              MOVE ZERO TO IF-VP12C.
       STPRO-49.
           IF IF-VP12D NOT = ZERO
              MOVE 'IVA DOVUTA DEL PERIODO ...........:' TO DESCRI
              MOVE IF-VP12D TO RVALOR.
           IF IF-VP12C NOT = ZERO
              MOVE 'IVA A CREDITO DEL PERIODO ........:' TO DESCRI
              MOVE IF-VP12C TO RVALOC.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 'CREDITI SPECIALI IMPOSTA DETRATTI.:' TO DESCRI.
           MOVE P-VP13  TO RVALOC.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           COMPUTE TOTIV = TOTIV - P-VP13.
       STPRO-5.
           IF IF-ACCV = ZERO GO TO STPRO-5-1.
           MOVE 'ACCONTO VERSATO ..................:' TO DESCRI.
           MOVE IF-ACCV TO RVALOC.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 1 TO XCRR.
       STPRO-5-1.
           IF TOTAG = 1 AND T25-VER > ZERO
              MOVE 'TOTALE VERSAMENTI NELL''ANNO ......:' TO DESCRI
              MOVE T25-VER TO RVALOR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              PERFORM STA-PIE
              MOVE 1 TO XCRR.
           IF TOTAG = 1 AND T25RIB > ZERO
              MOVE 'TOTALE RIMBORSI INFRANNUALI .......:' TO DESCRI
              MOVE T25RIB TO RVALOR
              MOVE 'RIG2' TO RP-BLK
              PERFORM RPT-WR
              PERFORM STA-PIE
              MOVE 1 TO XCRR.
           IF TOTAG = 1 AND T25RIC > ZERO
                 MOVE 'TOTALE COMPENSAZ. INFRANNUALI......:' TO DESCRI
                 MOVE T25RIC TO RVALOR
                 MOVE 'RIG2' TO RP-BLK
                 PERFORM RPT-WR
                 PERFORM STA-PIE
                 MOVE 1 TO XCRR.
           COMPUTE TOTIV = TOTIV - IV-IVAULT.
           IF TOTAG = 1 COMPUTE TOTIV = TOTIV - T25-VER.
           IF TOTAG = 1 ADD T25RIB TO TOTIV.
           IF TOTAG = 1 ADD T25RIC TO TOTIV.
           IF TOTAG = ZERO SUBTRACT IF-ACCV FROM TOTIV.
           IF TOTAG = ZERO AND TOTIV = ZERO GO TO STPRO-56.
           IF TOTAG = 1 AND TOTIV = ZERO GO TO STPRO-56.
           IF TOTIV > ZERO
              MOVE 'DEBITO IVA .......................:' TO DESCRI
                MOVE TOTIV TO TOTALE
                MOVE TOTALE TO VALORE
           ELSE
                MOVE TOTIV TO TOTALE
                MULTIPLY -1 BY TOTALE
                MOVE TOTALE TO VALOREC
                MOVE 'CREDITO IVA ......................:' TO DESCRI.
           MOVE 1 TO XCRR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           IF T25-PER = ZERO GO TO STPRO-52.
           IF NOT (NMES = 3 OR 6 OR 9 OR 12) GO TO STPRO-6.
       STPRO-52.
           IF TOTIV  > ZERO OR (IF-RIMB = ZERO AND COMPE = ZERO)
              GO TO STPRO-53.
           MOVE TOTIV TO TOTALE.
           MULTIPLY -1 BY TOTALE.
           MOVE 'TOTALE IMPORTO A CREDITO .........:' TO DESCRI.
           MOVE TOTALE TO VALORE.
           IF IF-RIMB = ZERO GO TO NORIMB.
           SUBTRACT IF-RIMB FROM TOTALE.
           ADD IF-RIMB TO TOTIV.
           MOVE TOTALE TO IMPVE.
           MOVE IF-RIMB TO TOTALE.
           IF ANNO4 > ZERO AND ANNO4 < 2002
              ADD EARROT TO TOTALE
              COMPUTE TOTALE = TOTALE / 100
              COMPUTE TOTALE = TOTALE * 100.
           MOVE TOTALE TO RRIMB.
           MOVE 'CREDITO RESIDUO' TO CREDITI.
           MOVE 'IMPORTO CHIESTO A RIMBORSO' TO DSCR4.
           MOVE ZERO TO TOTALE.
           MOVE 2 TO XCRR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
       NORIMB.
           IF COMPE = ZERO GO TO NOCOMPE.
           MOVE TOTIV TO TOTALE.
           MULTIPLY -1 BY TOTALE.
           MOVE 'TOTALE IMPORTO A CREDITO .........:' TO DESCRI.
           MOVE TOTALE TO VALORE.
           ADD COMPE TO TOTIV.
           SUBTRACT COMPE  FROM TOTALE.
           MOVE TOTALE TO IMPVE.
           MOVE COMPE TO TOTALE.
           IF ANNO4 > ZERO AND ANNO4 < 2002
              ADD EARROT TO TOTALE
              COMPUTE TOTALE = TOTALE / 100
              COMPUTE TOTALE = TOTALE * 100.
           MOVE TOTALE TO RRIMB.
           MOVE 'CREDITO RESIDUO' TO CREDITI.
           MOVE 'IMPORTO COMPENSATO MOD. F24' TO DSCR4.
           MOVE ZERO TO TOTALE.
           MOVE 2 TO XCRR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
       NOCOMPE.
           GO TO STPRO-56.
       STPRO-53.
           IF TOTIV < T25-MIN GO TO STPRO-56.
           IF ANNO4 > ZERO AND ANNO4 < 2002
              COMPUTE TOTALE = (TOTALE + EARROT) / 100
              COMPUTE TOTALE = TOTALE * 100.
           MOVE 'IMPOSTA DA VERSARE ...............:' TO DESCRI.
           MOVE TOTALE TO VALORE.
           MOVE 2 TO XCRR.
           IF T25-PER = ZERO
              MOVE TOTALE TO IMPVE
              GO TO STPRO-54.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
           MOVE 1 TO XCRR.
           COMPUTE IF-IMIN = (TOTALE * T25-TAS).
           COMPUTE IF-IMIN = (IF-IMIN / 100) + 0,0049.
           IF ANNO4 > ZERO AND ANNO4 < 2002
              COMPUTE IF-IMIN = (IF-IMIN + EARROT) / 100
              COMPUTE IF-IMIN = IF-IMIN * 100.
           MOVE 'INTERESSI ........................:' TO DESCRI.
           MOVE IF-IMIN TO VALORE.
           ADD IF-IMIN TO TOTALE.
           MOVE TOTALE TO IMPVE.
           SUBTRACT IF-IMIN FROM TOTALE.
       STPRO-54.
           MOVE 'VERSAMENTO DI   ' TO CREDITI.
           MOVE 'EFFETTUATO IL' TO DSCR2.
           IF IF-DTVE NOT = ZERO MOVE IF-DTVE TO DTVER.
           MOVE 'A MEZZO' TO DSCR3.
           IF IF-CDBA NOT = SPACE MOVE IF-CDBA TO DSBAN.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
      *
       STPRO-56.
      * solo stampa a carattere
           IF RP-TRPT = 1     GO TO ECHS.
           IF NRIG NOT < NRGL GO TO ECHS.
           MOVE 1 TO XCRR.
           MOVE ALL '=' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE.
           COMPUTE N = NRGL - NRIG.
           COMPUTE N = N + (132 - N) / 2.
           MOVE N TO K.
           ADD 1 TO N.
       LCHS.    
           IF NRIG NOT < (NRGL - 2) GO TO ECHS. 
           ADD 1 TO NRIG.
           IF NRIG = (NRGL - 2)
              MOVE ALL '=' TO P999 
              MOVE 'RIG4' TO RP-BLK
           ELSE
              SUBTRACT 1 FROM N K
              MOVE '/' TO KKBAR(N) KKBAR(K)
              MOVE 'RIG7' TO RP-BLK.
           SUBTRACT 1 FROM NRIG.  
           PERFORM RPT-WR.
           GO TO LCHS.
       ECHS.
           PERFORM STA-PIE.
      *
           IF TOTAG = 1 GO TO STPRO-6.
           IF IV-TSDAT NOT = 1 GO TO STPRO-7.
      *
           CALL 'vrdtbigb' USING DTBIG.
           IF DTBIG = ZERO GO TO STPRO-57.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF AAGGG <= DTBIG
              MOVE 'Il periodo selezionato comprende'       TO F-MES1
              MOVE 'anche le transazioni fatte in Lire'     TO F-MES2
              MOVE 'Aggiornamento totali IVA non possibile' TO F-MES3
              MOVE 3 TO F-NMES
              CALL 'vrmbox' USING PARMB
              GO TO STPRO-7.
       STPRO-57.
      *
           MOVE 'Aggiornamento totali IVA ?' TO F-MES1.
           MOVE 1   TO F-NMES.
           MOVE 'Q' TO MB-TIPO.
           MOVE '2' TO MB-DEFAULT.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP = 'N' GO TO STPRO-7.
      *
           CLOSE TABELL TOTIVA WDS142.
           CLOSE WDSLAV.
      *
      * riporto a nuovo
           MOVE ZERO TO NTRIME.
           IF MM2 = ( 1 OR 2 OR 3 ) MOVE 1 TO NTRIME.
           IF MM2 = ( 4 OR 5 OR 6 ) MOVE 2 TO NTRIME.
           IF MM2 = ( 7 OR 8 OR 9 ) MOVE 3 TO NTRIME.
           IF MM2 = ( 10 OR 11 OR 12 ) MOVE 4 TO NTRIME.
           IF IF-VP12C NOT = ZERO
              COMPUTE TOTIV = IF-VP12C * - 1.
           IF T25-PER = ZERO AND
              IF-NMESE = ( 3 OR 6 OR 9)
              AND IF-VP12C NOT = ZERO
              COMPUTE IF-VP12C = IF-VP12C - IF-RIMB - COMPE.
           IF T25-PER NOT = ZERO AND
              NTRIME = ( 1 OR 2 OR 3)
              AND IF-VP12C NOT = ZERO
              COMPUTE IF-VP12C = IF-VP12C - IF-RIMB - COMPE.
           IF IF-VP12D NOT = ZERO COMPUTE TOTIV
                            = IF-VP12D - IF-ACCV - P-VP13.
      *
           MOVE IF-FL   TO FL-143.
           MOVE ID-TAB  TO ID-TAB-143.
           MOVE ID-IVA  TO ID-IVA-143.
           MOVE TOTIV   TO TOTIV-143.
           MOVE IF-RIMB TO RIMB-143.
           MOVE IF-ACCV TO ACCIVA-143.
           MOVE NMES    TO NMES-143.
           MOVE T25ESE  TO T25ESE-143.
      *
           MOVE IF-DTVE TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO DTVEK-143.
      *
           MOVE COMPE TO COMPE-143.
      *
           CALL 'vcon143' USING PARLINK-143 PARIV.
           CANCEL 'vcon143'.
           IF ERRIO-ST = 9 GO TO ERRIO.
           MOVE COMPE-143 TO COMPE.
           OPEN I-O TOTIVA WDS142 TABELL.
           OPEN I-O WDSLAV.
           IF IV-TIVAV  = ZERO AND
              IV-TIVAA  = ZERO AND
              IV-TIMPOC = ZERO AND
              IV-TIVACO = ZERO AND
              IV-INDEP0 = ZERO GO TO STPRO-7.
           CLOSE ANAAZI TABELL.
           IF T25ESE = 1 MOVE 'tabell' TO ID-TAB.
           MOVE 'movime' TO ID-MOV.
           IF IF-FL = 1 MOVE 'movmol' TO ID-MOV.
      *
           MOVE 'Aggiornamenti contabili ?' TO F-MES1.
           MOVE 1   TO F-NMES.
           MOVE 'Q' TO MB-TIPO.
           MOVE '2' TO MB-DEFAULT.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP = 'N' GO TO RDL-000.
           MOVE 1 TO IF-HS-145.
           GO TO EX-STAMP.
      * label di rientro per fun = 'S'
       RUN-RIENTRO.
           MOVE ZERO TO IF-HS-145.
      *
           MOVE ID-AZI   TO ID-AZI-145.
           MOVE ID-TAB   TO ID-TAB-145.
           MOVE ID-MOV   TO ID-MOV-145.
           MOVE IF-FL    TO FL-145.
           MOVE IV-CDAZ  TO CDAZ-145.
           MOVE IF-DTCON TO DTCON-145.
           MOVE IF-DSAGG TO DSAGG-145.
      *
           CALL 'vcon145' USING PARLINK-145 IV-CAMPLAV.
           CANCEL 'vcon145'.
           IF ERRIO-ST = 9 GO TO ERRIO.
       RDL-000.
           OPEN INPUT ANAAZI.
           OPEN I-O  TABELL.
           GO TO STPRO-7.
       STPRO-6.
           IF TOTAG NOT = 1 GO TO STPRO-69.
           MOVE ZERO TO XCRR.
           MOVE 1 TO RP-JMP.
           MOVE 2 TO NINT.
      *
           MOVE 1 TO RP-FLGR.
           MOVE RDATT TO SOTTOYB.
           MOVE 'RIG1B' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE-B.
      *
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE-B.
      *
           MOVE 2 TO XCRR.
           MOVE 'LIQUIDAZIONI :' TO RDTLI.
           MOVE 'A DEBITO' TO RDSDEB.
           MOVE 'A CREDITO' TO RDSCRE.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE-B.
      *
           MOVE 2 TO XCRR.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '3'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID GO TO STPRO-69.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE ZERO TO K J.
        STPRO-62.
           ADD 1 TO K J.
           MOVE ZERO TO COMODO.
           MOVE COMODO TO RCRLI RVELI.
           MOVE T25-VE3(K) TO COMODO.
           IF COMODO = ZERO GO TO STPRO-63.
           IF COMODO > ZERO
              MOVE COMODO TO RCRLI
           ELSE
              MULTIPLY -1 BY COMODO
              MOVE COMODO TO RVELI.
           IF T25-DT3(K) > ZERO
              MOVE T25-DT3(K) TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GBMMBA TO RDALI.
        STPRO-63.
           MOVE MESE(J) TO RMELI.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE-B.
      *
           MOVE 1 TO XCRR.
           IF K < 7 GO TO STPRO-62.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '4'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID GO TO STPRO-69.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE ZERO TO K.
        STPRO-64.
           ADD 1 TO K J.
           MOVE ZERO TO COMODO.
           MOVE COMODO TO RCRLI RVELI.
           MOVE T25-VE4(K) TO COMODO.
           IF COMODO = ZERO GO TO STPRO-65.
           IF COMODO > ZERO
              MOVE COMODO TO RCRLI
           ELSE
              MULTIPLY -1 BY COMODO
              MOVE COMODO TO RVELI.
           IF T25-DT4(K) > ZERO
              MOVE T25-DT4(K) TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GBMMBA TO RDALI.
        STPRO-65.
           IF J > 12
              MOVE 'ACCONTO' TO RMELI
           ELSE
              MOVE MESE(J) TO RMELI.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE-B.
      *
           MOVE 1 TO XCRR.
           IF K < 6 GO TO STPRO-64.
           IF T25RIM = ZERO GO TO STPRO-67.
           MOVE 2 TO XCRR.
           MOVE 'RIMBORSI :' TO RDTLI.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE-B.
      *
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '5'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID GO TO STPRO-69.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE ZERO TO K.
        STPRO-66.
           ADD 1 TO K.
           MOVE TRIM(K) TO RMELI.
           MOVE P-VP19R (K) TO COMODO.
           MOVE COMODO TO RVELI.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE-B.
      *
           MOVE 1 TO XCRR.
           IF K < 3 GO TO STPRO-66.
       STPRO-67.
           IF T25CIC = ZERO GO TO STPRO-69.
           MOVE 2 TO XCRR.
           MOVE 'COMPENSAZIONI :' TO RDTLI.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE-B.
      *
           MOVE ZERO TO K.
       STPRO-68.
           ADD 1 TO K.
           MOVE TRIM (K) TO RMELI.
           MOVE P-VP19C (K) TO COMODO.
           MOVE COMODO TO RVELI.
           MOVE 'RIG2B' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE-B.
      *
           MOVE 1 TO XCRR.
           IF K < 3  GO TO STPRO-68.
       STPRO-69.
      * solo stampa a carattere
           IF RP-TRPT = 1     GO TO ECHSB.
           IF NRIG NOT < NRGL GO TO ECHSB.
           MOVE 1 TO XCRR.
           MOVE ALL '=' TO P999B.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3B' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM STA-PIE-B.
           COMPUTE N = NRGL - NRIG.
           COMPUTE N = N + (132 - N) / 2.
           MOVE N TO K.
           ADD 1 TO N.
       LCHSB.    
           IF NRIG NOT < (NRGL - 2) GO TO ECHSB. 
           ADD 1 TO NRIG.
           IF NRIG = (NRGL - 2)
              MOVE ALL '=' TO P999B
              MOVE 'RIG3B' TO RP-BLK
           ELSE
              SUBTRACT 1 FROM N K
              MOVE '/' TO KKBARB(N) KKBARB(K)
              MOVE 'RIG4B' TO RP-BLK.
           SUBTRACT 1 FROM NRIG.  
           PERFORM RPT-WR.
           GO TO LCHSB.
       ECHSB.
           PERFORM STA-PIE-B.
      *
       STPRO-7.
           MOVE 4 TO NINT.
           MOVE ZERO TO SW.
       EX-STAMP.
           EXIT.
      *------------------
      * preparazione dati per prospetto a video della liquidazione IVA
       VISIVA.
           MOVE ZERO TO IF-HS-W-DB1
                        IF-HS-ACCV
                        IF-HS-PER-D
                        IF-HS-DTVE
                        IF-HS-RIMB.
           MOVE ZERO TO SAV-ACREDI
                        SAV-DAVERS.
           MOVE IF-DATA-1 TO DAT1.
      * abilitazione show finestra prospetto liquidazione IVA
           MOVE 1 TO IF-HS-W-DB1.
      *
           IF TOTAG = 1
              MOVE 2 TO IV-TSDAT
              MOVE ZERO TO IV-DTINK IV-DTFIK
              GO TO LIQ-20.
           IF IF-FLPRO = ZERO GO TO LIQ-10.
           MOVE 1 TO GG1.
           IF T25PER = ZERO GO TO LIQ-10.
           MOVE 1 TO MM1.
           IF MM2 > 3 AND < 7  MOVE 4 TO MM1.
           IF MM2 > 6 AND < 10 MOVE 7 TO MM1.
           IF MM2 > 9 MOVE 10 TO MM1.
       LIQ-10.
           MOVE DAT1 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DTMOV-1.
           MOVE AAGGG TO IV-DTINK.
           MOVE DT2 TO IV-DTFIK.
       LIQ-20.
           CLOSE TABELL TOTIVA.
      *
           MOVE ID-IVA TO ID-IVA-142.
           MOVE ID-TAB TO ID-TAB-142.
      *
           CALL 'vcon142' USING PARLINK-142 PARIV.
           CANCEL 'vcon142'.
           IF ERRIO-ST = 9 GO TO ERRIO.
           IF TOTAG = ZERO
              PERFORM READ-DPEIVA-MESE THRU EX-READ-DPEIVA-MESE.
           IF TOTAG = 1
              PERFORM READ-DPEIVA-ANNO THRU EX-READ-DPEIVA-ANNO.
           MOVE ZERO TO K1.
           MOVE ZERO TO T25RIB T25RIC.
       LIQ-30.
           ADD 1 TO K1.
           ADD P-VP19R(K1) TO T25RIB.
           ADD P-VP19C(K1) TO T25RIC.
           IF K1 < 3 GO TO LIQ-30.
           IF TOTAG = 1 MOVE T25RIB TO IF-VP19R
                        MOVE T25RIC TO IF-VP19C.
      *
           MOVE IV-IVAVEN TO IF-IVEN.
           MOVE IV-IVAACQ TO IF-IACQ.
           MOVE IV-IVACOR TO IF-ICOR.
           MOVE IV-IVAULT TO IF-ULTDE.
           MOVE IV-DEP0   TO IF-PRORA.
      *
           IF TOTAG = ZERO
              MOVE IV-DTPK TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GGMMAA TO IF-DTMOV-2.
           OPEN I-O WDS142 TOTIVA TABELL.
           OPEN I-O WDSLAV.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE ZERO TO IF-DPREC IF-CPREC.
           IF IV-TSDAT = 2
              MOVE ZERO    TO IF-CPREC
              GO TO VIS-20.
           IF IV-TSDAT = 1
              MOVE T25-PPR TO IF-CPREC
              GO TO VIS-20.
           IF MM1 = 1
              MOVE ZERO    TO IF-CPREC
              GO TO VIS-20.
           SUBTRACT 1 FROM MM1.
           MOVE IMLIQ(MM1) TO IF-CPREC.
       VIS-20.
           IF IF-CPREC < ZERO
              COMPUTE IF-DPREC = IF-CPREC * -1
              MOVE ZERO TO IF-CPREC
           ELSE
              MOVE ZERO TO IF-DPREC.
           IF IV-TSDAT NOT = ZERO OR MM1 = 1 GO TO VIS-40.
           ADD 1 TO MM1.
           IF IF-CPREC NOT = ZERO
              IF MM1 = 3 OR 6 OR 9
                 IF DT2 > T25-DUP
                 COMPUTE IF-CPREC = IF-CPREC - IF-VP19C - IF-VP19R.
              IF MM1 = 4 OR 7 OR 10
                 IF DT2 NOT > T25-DUP
                    COMPUTE IF-CPREC = IF-CPREC - IF-VP19C - IF-VP19R.
       VIS-40.
           IF IF-DPREC NOT < T25-MIN MOVE ZERO TO IF-DPREC.
           MOVE ZERO TO TOTIV IF-IMDE IF-IMCR.
           MOVE ZERO TO TOTIVD TOTIVC TOTIND0.
           MOVE ZERO TO TOTIVCN.
           COMPUTE TOTIVD = IV-IVAVEN + IV-IVACOR.
           MOVE IV-DTINK TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO ANNO4.
           IF ANNO4 = 2000 OR 2001
              IF TOTIVD > 0 ADD EARROT TO TOTIVD
              ELSE          SUBTRACT EARROT FROM TOTIVD
              END-IF
              COMPUTE TOTIVD = TOTIVD / 100
              COMPUTE TOTIVD = TOTIVD * 100.
      *
           COMPUTE TOTIVC = IV-IVAACQ + IV-IVAULT.
           IF IV-DEP0 = ZERO AND IV-INDEP0 NOT = ZERO
              COMPUTE TOTIVC = IV-IVAACQ + IV-IVAULT - IV-INDEP0.
           IF ANNO4 = 2000 OR 2001
              IF TOTIVC > 0 ADD EARROT TO TOTIVC
              ELSE          SUBTRACT EARROT FROM TOTIVC
              END-IF
              COMPUTE TOTIVC = TOTIVC / 100
              COMPUTE TOTIVC = TOTIVC * 100.
      *
           IF IV-DEP0 NOT = ZERO
              COMPUTE TOTIVCN = IV-DEP0 + IV-IVAULT.
           IF IV-DEP0 = ZERO AND IV-INDEP0 NOT = ZERO
              COMPUTE TOTIVCN = IV-IVAACQ + IV-IVAULT - IV-INDEP0.
           IF ANNO4 = 2000 OR 2001
              IF TOTIVCN > 0 ADD EARROT TO TOTIVCN
              ELSE          SUBTRACT EARROT FROM TOTIVCN
              END-IF
              COMPUTE TOTIVCN = TOTIVCN / 100
              COMPUTE TOTIVCN = TOTIVCN * 100.
      *                             IF-CPREC + TOTIND0.
           IF TOTIVCN NOT = ZERO
              COMPUTE TOTIV = TOTIVD - TOTIVCN
           ELSE
              COMPUTE TOTIV = TOTIVD - TOTIVC.
           MOVE ZERO TO IF-VP7D.
           MOVE ZERO TO IF-VP7C.
           MOVE ZERO TO IF-VP12C.
           MOVE ZERO TO IF-VP12D.
           IF TOTIV > ZERO MOVE TOTIV TO IF-VP7D
              ELSE
              COMPUTE IF-VP7C = TOTIV  * - 1.
           IF IF-VP7C NOT = ZERO GO TO VIS-41.
           COMPUTE IF-VP12D = IF-VP7D + P-VP8
                            + P-VP9 + IF-DPREC - IF-CPREC - P-VP11.
           MOVE IF-VP12D TO TOTIV.
           IF IF-VP12D < ZERO COMPUTE IF-VP12C = IF-VP12D * - 1
                              MOVE ZERO TO IF-VP12D.
           GO TO VIS-42.
       VIS-41.
           COMPUTE IF-VP12C = IF-VP7C - P-VP8
                            - P-VP9 - IF-DPREC + IF-CPREC + P-VP11.
           COMPUTE TOTIV = IF-VP12C * - 1.
           IF IF-VP12C < ZERO COMPUTE IF-VP12D = IF-VP12C * - 1
                              MOVE ZERO TO IF-VP12C.
       VIS-42.
           MOVE ZERO TO IF-DAVERS IF-ACREDI.
           IF IF-VP12D NOT = ZERO
              COMPUTE IF-DAVERS = IF-VP12D - P-VP13.
           IF IF-VP12C NOT = ZERO
              COMPUTE IF-ACREDI = IF-VP12C + P-VP13.
           IF IF-DAVERS < ZERO COMPUTE IF-ACREDI = IF-DAVERS * - 1
              MOVE ZERO TO IF-DAVERS.
           IF IF-ACREDI < ZERO COMPUTE IF-DAVERS = IF-ACREDI * - 1
              MOVE ZERO TO IF-ACREDI.
      * abilitazione/disabilitazione del campo 'acconto versato'
           IF MM2 NOT = 12 OR TOTAG = 1
              MOVE ZERO TO IF-ACCV
              MOVE ZERO TO IF-HS-ACCV
           ELSE
              MOVE 1 TO IF-HS-ACCV.
           IF TOTAG = ZERO SUBTRACT IF-ACCV FROM TOTIV.
           MOVE IF-ACREDI TO SAV-ACREDI.
           MOVE IF-DAVERS TO SAV-DAVERS.
           IF IF-DAVERS NOT = ZERO SUBTRACT IF-ACCV FROM IF-DAVERS.
           IF IF-DAVERS < ZERO COMPUTE IF-ACREDI = IF-DAVERS * - 1
              MOVE ZERO TO IF-DAVERS
              GO TO ACC2.
           IF IF-ACREDI NOT = ZERO
              COMPUTE IF-ACREDI = IF-ACREDI + IF-ACCV.
       ACC2.
           IF TOTAG = 1 COMPUTE TOTIV = TOTIV - T25-VER.
           IF TOTIV < ZERO
              MOVE TOTIV TO IF-IMCR
              COMPUTE IF-IMCR = IF-IMCR * -1
              MOVE ZERO TO IF-IMDE
           ELSE
              MOVE TOTIV TO IF-IMDE
              MOVE ZERO  TO IF-IMCR.
            IF (T25-PER = 1 OR 2) AND
               TOTAG = ZERO       AND
               TOTIV > ZERO
                     COMPUTE IF-IMIN = IF-IMDE * T25-TAS
                     COMPUTE IF-IMIN = (IF-IMIN / 100) + 0,0049
                     COMPUTE IF-DAVERS = IF-DAVERS + IF-IMIN
                     COMPUTE SAV-DAVERS = IF-DAVERS + IF-IMIN.
           IF TOTAG = 1
              MOVE SPACE TO F-MES1
              MOVE T25-VER TO COMEDIT
              STRING 'Versamenti nell''anno : ' COMEDIT
                   DELIMITED BY SIZE INTO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB.
           MOVE ZERO TO IF-HS-RIMBO.
           IF TOTAG = 1
              MOVE T25RIB TO IF-VP19R
              MOVE T25RIC TO IF-VP19C
              MOVE 1 TO IF-HS-RIMBO
              GO TO CKDATI.
           IF NMESE = ( 3 OR 6 OR 9 ) MOVE 1    TO IF-HS-RIMBO
           ELSE                       MOVE ZERO TO IF-HS-RIMBO.
       CKDATI.
           PERFORM CONTROLLO THRU EX-CONTROLLO.
      * abilitazione richiesta descrizione periodo
           MOVE 1 TO IF-HS-PER-D.
       STAGG.
           IF IF-IMDE = ZERO GO TO RIMB00.
           IF IF-IMDE < T25-MIN GO TO VISIV9.
           IF IF-FLLIQ = ZERO GO TO VISIV9.
      * abilitazione richiesta estremi versamento
           MOVE 1 TO IF-HS-DTVE.
       RIMB00.
           IF NOT ( MM2 = 3 OR 6 OR 9 ) GO TO VISIV9.
      * abilitazione richiesta dati rimborso
           IF T25-RIM = ZERO
              GO COMP00.
           MOVE IF-VP19R TO IF-RIMB.
           SUBTRACT IF-RIMB FROM IF-IMCR.
       COMP00.
           IF T25-CIC = ZERO GO VISIV9.
           MOVE IF-VP19C TO COMPE.
           SUBTRACT COMPE FROM IF-IMCR.
       VISIV9.
           IF IF-TPELA = 1
              IF IF-PER-D = SPACE MOVE 'ANNO' TO IF-PER-D
              END-IF
              GO TO EX-VISIVA.
           MOVE SPACE TO IF-PER-D.
           MOVE IF-DATA-2 TO GGMMAA.
           MOVE MM9 TO NMES.
           MOVE AA9 TO ANNO1.
           IF T25-PER = ZERO
              STRING MESE(NMES) DELIMITED ' '
                     ' ' ANNO1  DELIMITED SIZE
                                INTO IF-PER-D
           ELSE
              IF (NMES = 3 OR 6 OR 9 OR 12)
                 DIVIDE 3 INTO NMES
                 STRING TRIM (NMES) DELIMITED SIZE
                          ' ' ANNO1 DELIMITED SIZE
                                    INTO IF-PER-D
                 MULTIPLY 3 BY NMES.
      *
       EX-VISIVA.
           EXIT.
      *------------------
      * aggiornamento totali IVA
       AGGIORNA-TOT.
           CLOSE TABELL TOTIVA.
      *
           MOVE ID-IVA TO ID-IVA-142.
           MOVE ID-TAB TO ID-TAB-142.
      *
           CALL 'vcon142' USING PARLINK-142 PARIV.
           CANCEL 'vcon142'.
           IF ERRIO-ST = 9 GO TO ERRIO.
      *
           MOVE ZERO TO TOTIV IF-RIMB IF-ACCV NMES.
           MOVE IF-FL   TO FL-143.
           MOVE ID-TAB  TO ID-TAB-143.
           MOVE ID-IVA  TO ID-IVA-143.
           MOVE TOTIV   TO TOTIV-143.
           MOVE IF-RIMB TO RIMB-143.
           MOVE ZERO    TO COMPE-143.
           MOVE IF-ACCV TO ACCIVA-143.
           MOVE NMES    TO NMES-143.
           MOVE T25ESE  TO T25ESE-143.
           MOVE ZERO    TO DTVEK-143.
      *
           CALL 'vcon143' USING PARLINK-143 PARIV.
           CANCEL 'vcon143'.
           IF ERRIO-ST = 9 GO TO ERRIO.
           MOVE COMPE-143 TO COMPE.
           OPEN I-O TABELL TOTIVA.
       EX-AGGIORNA-TOT.
           EXIT.
      *------------------
      * Nota: l'ID assegnato a ID-142 deve essere uguale anche
      *       in vcon142 e vcon143
       CREA-IDLAV.
           MOVE SPACE TO ID-142.
           STRING 'w9' PID DELIMITED SPACE INTO ID-142.
           MOVE SPACE TO ID-LAV.
           STRING 'w8' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       REC-LOCK.
           CALL 'rlock' USING PARLK.
           EXIT.
      *------------------
       AZZ-DPEIVA.
           IF IF-FL = 1
              MOVE 1 TO FLOLD
           ELSE
              MOVE ZERO TO FLOLD.
           MOVE IF-AZI TO CODAZI.
           MOVE ZERO   TO NMESE IF-NMESE.
           MOVE 2      TO FLRDM.
           CALL 'varc126' USING PARDMI.
           CANCEL 'varc126'.
       EX-AZZ-DPEIVA.
           EXIT.
      *------------------
       READ-DPEIVA-MESE.
           IF IF-FL = 1
              MOVE 1 TO FLOLD
           ELSE
              MOVE ZERO TO FLOLD.
           MOVE IF-AZI TO CODAZI.
           MOVE MM2    TO NMESE IF-NMESE.
           MOVE 1      TO FLRDM.
           CALL 'varc126' USING PARDMI.
           CANCEL 'varc126'.
           MOVE ZERO TO NTRIME.
           IF MM1 = ( 1 OR 2 OR 3 ) MOVE 1 TO NTRIME.
           IF MM1 = ( 4 OR 5 OR 6 ) MOVE 2 TO NTRIME.
           IF MM1 > 6               MOVE 3 TO NTRIME.
      **** rel 6.1
           IF MM1 > 9               MOVE 4 TO NTRIME.
      ************
           IF MM1 = ( 3 OR 6 OR 9 )
              MOVE P-VP19R(NTRIME) TO IF-VP19R
              MOVE P-VP19C(NTRIME) TO IF-VP19C.
           IF MM1 = ( 4 OR 7 OR 10 )
              MOVE P-VP19R(NTRIME - 1) TO IF-VP19R
              MOVE P-VP19C(NTRIME - 1) TO IF-VP19C.

           MOVE P-VP8    TO IF-VP8.
           MOVE P-VP9    TO IF-VP9.
           MOVE P-VP11   TO IF-VP11.
           MOVE P-VP13   TO IF-VP13.
       EX-READ-DPEIVA-MESE.
           EXIT.
      *------------------
       READ-DPEIVA-ANNO.
           IF IF-FL = 1
              MOVE 1 TO FLOLD
           ELSE
              MOVE ZERO TO FLOLD.
           MOVE IF-AZI TO CODAZI.
           MOVE 99     TO NMESE IF-NMESE.
           MOVE 1      TO FLRDM.
           CALL 'varc126' USING PARDMI.
           CANCEL 'varc126'.

           MOVE P-VP8    TO IF-VP8.
           MOVE P-VP9    TO IF-VP9.
           MOVE P-VP11   TO IF-VP11.
           MOVE P-VP13   TO IF-VP13.
       EX-READ-DPEIVA-ANNO.
           EXIT.
      *------------------
       CONTROLLO.
           MOVE ZERO TO IF-FLGERR.
           IF IF-IMDE NOT = ZERO
                 AND ( TOTAG = ZERO AND NMESE = ( 3 OR 6 OR 9 ) )
                 AND IF-VP19R NOT = ZERO
                 MOVE 'Iva dovuta rimb.infr.errato ' TO F-MES1
                 MOVE 1 TO F-NMES
                 CALL 'vrmbox' USING PARMB
                 MOVE 1 TO IF-FLGERR
                 GO TO EX-CONTROLLO.
           IF IF-IMDE NOT = ZERO
                 AND ( TOTAG = ZERO AND NMESE = ( 3 OR 6 OR 9 ) )
                 AND IF-VP19C NOT = ZERO
                 MOVE 'Iva dovuta comp.infr.errata ' TO F-MES1
                 MOVE 1 TO F-NMES
                 CALL 'vrmbox' USING PARMB
                 MOVE 1 TO IF-FLGERR
                 GO TO EX-CONTROLLO.
           COMPUTE NETCRE = IF-IMCR - IF-VP19C - IF-VP19R.
           IF IF-IMCR NOT = ZERO AND NETCRE < ZERO
                 AND ( TOTAG = ZERO AND NMESE = ( 3 OR 6 OR 9 ) )
                 MOVE 'Rimb./compens. eccedenti credito' TO F-MES1
                 MOVE 1 TO F-NMES
                 CALL 'vrmbox' USING PARMB
                 MOVE 1 TO IF-FLGERR
                 GO TO EX-CONTROLLO.
           IF IF-IMDE  = ZERO AND IF-VP13 NOT = ZERO
                 AND ( TOTAG = ZERO AND NMESE = ( 3 OR 6 OR 9 ) )
                 MOVE 'Iva cred. errata detr.crediti speciali' TO F-MES1
                 MOVE 1 TO F-NMES
                 CALL 'vrmbox' USING PARMB
                 MOVE 1 TO IF-FLGERR
                 GO TO EX-CONTROLLO.
           COMPUTE NETCRE = IF-IMDE - IF-VP13.
           IF IF-IMDE NOT = ZERO AND NETCRE < ZERO
                 AND ( TOTAG = ZERO AND NMESE = ( 3 OR 6 OR 9 ) )
                 MOVE 'Crediti spec. eccedenti debito ' TO F-MES1
                 MOVE 1 TO F-NMES
                 CALL 'vrmbox' USING PARMB
                 MOVE 1 TO IF-FLGERR
                 GO TO EX-CONTROLLO.
       EX-CONTROLLO.
           EXIT.
      *------------------
       LOOP-LAV.
           MOVE ZERO TO TOTCVEN.
           MOVE LOW-VALUE TO KEYLV.
           MOVE KAZ-COD   TO KLV-AZI.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO EX-LOOP-LAV.
       RDLV-NEXT.
           READ WDSLAV NEXT AT END GO TO EX-LOOP-LAV.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO RDLV-NEXT.
           ADD 1 TO K1.

           MOVE 3       TO KTB-TIP.
           MOVE KLV-COD TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.

           IF LAV-AVEN = ZERO AND
              LAV-PAVE = ZERO GO TO RDLV-NEXT.

           IF TOTAG = 1
              ADD LAV-PAVE TO TOTCVEN
              GO TO RDLV-NEXT
           ELSE
              ADD LAV-AVEN TO TOTCVEN
              ADD LAV-PAVE TO TOTCVEN
              GO TO RDLV-NEXT.
           GO TO RDLV-NEXT.
       EX-LOOP-LAV.
           EXIT.
      *------------------*
       STA-PIE.
           IF IF-NBOL = 1 AND (NRIG NOT < (NRGL - 2))
              MOVE IF-PIEDE-1 TO P999
              MOVE 2 TO RP-FLGR
              MOVE 'RIG4' TO RP-BLK
              PERFORM RPT-WR
              MOVE IF-PIEDE-2 TO P999
              MOVE 2 TO RP-FLGR
              MOVE 'RIG4' TO RP-BLK
              PERFORM RPT-WR.
      *------------------*
       STA-PIE-B.
           IF IF-NBOL = 1 AND (NRIG NOT < (NRGL - 2))
              MOVE IF-PIEDE-1 TO P999B
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3B' TO RP-BLK
              PERFORM RPT-WR
              MOVE IF-PIEDE-2 TO P999B
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3B' TO RP-BLK
              PERFORM RPT-WR.
      *------------------*
       RPT-RIG3-INTC.
           MOVE 'RIG3' TO RP-BLK.
      *
           MOVE 'Cod' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione Iva' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Vendite Imponibile' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Vendite Imposta' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Acquisti Imponibile' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Acquisti Imposta' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Acq. Indetraibile' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           IF IV-CDCOR NOT = ZERO
              MOVE 'Corris. Imp. Lordo' TO RP-IFLD
              PERFORM RPT-ADD-I
              MOVE 'Corris. Imponibile' TO RP-IFLD
              PERFORM RPT-ADD-I
              MOVE 'Corris. Imposta' TO RP-IFLD
              PERFORM RPT-ADD-I
           ELSE
              PERFORM RPT-ADD-I
              PERFORM RPT-ADD-I
              PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
       RPT-RIG5-INTC.
           MOVE 'RIG5' TO RP-BLK.
      *
           MOVE 'Cod' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione Iva' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Acq.Dest.Rivend.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE '%' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Importo Corrisp.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Imponibile' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Iva Calcolata' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
