      $SET LINKCOUNT"128"
       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON200.
      *
      * OGGETTO: Visualizzazione scheda contabile
      *          Considera sia movimenti storici che di periodo
      *
      * IF-FL    :  0 = visualizza esercizio in corso
      *             1 = visualizza da vecchio esercizio
      *             2 = visualizza da gestione anni precedenti
      * Oltre alle funzioni solite, gestisce anche la funzione:
      *   x : restituisce il record in RG-MOV-REC per la
      *       visualizzazione dello stesso
      **** rel 2.0
      *   3 : identifica che il programma e' chiamato da VUTI130
      *       pertanto visualizza anche movimenti con importo = 0
      *       per permetterne l'annullamento
      ************
      *
      **** rel 7.2
      * Ricompilato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'griclfsl'.
           COPY 'grimovsl'.
           COPY 'grimszsl'.
           COPY 'grimvxsl'.
           COPY 'grimsxsl'.
           COPY 'gricolsl'.
           COPY 'gricfxsl'.
           COPY 'gritabsl'.
      **** rel 6.2
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV 
                  ALTERNATE RECORD KEY 
                        SKEYLV1 = KLV-ESER KLV-NREG KLV-DAT KLV-NUM
                  WITH DUPLICATES
                  ALTERNATE RECORD KEY 
                        SKEYLV2 = KLV-ESER KLV-DAT KLV-CATT KLV-NPRGI 
                                  KLV-NREG
                  WITH DUPLICATES
                  ALTERNATE RECORD KEY 
                        SKEYLV3 = KLV-ESER KLV-CATT KLV-NPRGI KLV-DAT
                                  KLV-NREG
                  WITH DUPLICATES
                  STATUS SF-LAV.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricon'.
           COPY 'griclf'.
           COPY 'grimov'.
           COPY 'grimsz'.
           COPY 'grimvx'.
           COPY 'grimsx'.
           COPY 'gritab'.
           COPY 'gricol'.
           COPY 'gricfx'.
      **** rel 6.2
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 41 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
             10 KLV-ESER   PIC 9.
             10 KLV-DAT    PIC 9(5).
             10 KLV-NREG   PIC 9(5).
             10 KLV-NUM    PIC 9(5).
             10 KLV-CATT   PIC X.
             10 SKLV-NPRGI.
                15 KLV-NPRGI PIC 9(5) COMP-3.
           05 LAV-KEY      PIC X(20).
           05 LAV-TIPFIL   PIC 9.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'griconrk'.
           COPY 'gritabrk'.
      **** rel 6.3
           COPY 'grit20rk'.
      ************
           COPY 'grimovrk'.
           COPY 'griclfrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
      **** rel 1.2
           COPY 'parer'.
      ************
       01  ID-AZI PIC X(15).
       01  ID-CON PIC X(15).
       01  ID-TAB PIC X(15).
       01  ID-MOV PIC X(15).
       01  ID-MSZ PIC X(15).
       01  ID-CLF PIC X(15).
       01  ID-MVX PIC X(15).
       01  ID-MSX PIC X(15).
       01  ID-COL PIC X(15) VALUE 'anacol'.
       01  ID-CFX PIC X(15) VALUE 'anacfx'.
      **** rel 6.2
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
      ************
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-CON   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-MOV   PIC XX.
           05 SF-MSZ   PIC XX.
           05 SF-CLF   PIC XX.
           05 SF-MVX   PIC XX.
           05 SF-MSX   PIC XX.
           05 SF-COL   PIC XX.
           05 SF-CFX   PIC XX.
      **** rel 6.2
           05 SF-LAV   PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 LNSEZ    PIC 999.
           05 LF       PIC X     VALUE X'0A'.
           05 CODICE   PIC 9(7).
           05 CODCF    PIC 9(5).
           05 MCLI     PIC 99.
           05 MFOR     PIC 99.
           05 IVAVEN   PIC 9(7).
           05 IVAACQ   PIC 9(7).
           05 IVASOS   PIC 9(7).
           05 CDCLI    PIC 9(7).
           05 CDCLF REDEFINES CDCLI.
              10 MAS   PIC 99.
              10 CLF   PIC 9(5).
      **** rel 4.0
      *    05 SALDAP   PIC S9(11).
      *    05 LTCAD    PIC S9(13).
      *    05 LTCAA    PIC S9(13).
      *    05 LTCAS    PIC S9(13).
           05 SALDAP   PIC S9(11)V99.
           05 LTCAD    PIC S9(13)V99.
           05 LTCAA    PIC S9(13)V99.
           05 LTCAS    PIC S9(13)V99.
      ************
      **** rel 7.1
           05 COMTIP   PIC 9 VALUE ZERO.
      ************
           05 PKDT     PIC 9(5) COMP-3.
           05 PKDT1    PIC 9(5) COMP-3.
           05 PKDT2    PIC 9(5) COMP-3.
           05 WKDES    PIC X(132).
           05 WKDEX REDEFINES WKDES.
              10 WKDE1   PIC X(44).
              10 WKDE2   PIC X(44).
              10 WKDE3   PIC X(44).
           05 CMDES    PIC X(99).
           05 COMCOD   PIC 9(7).
           05 SW       PIC 9.
           05 TIPFIL   PIC 9.
      *       tipfile: 1=movime/movmol
      *                2=movmxx/movoxx
      *                3=movsez/movsol
      *                4=movsxx/mosoxx
           05 KVET     PIC 999.
      **** rel 1.2
           05 EURO     PIC 9.
      ************
      **** rel 4.0
           05 COMEURO  PIC 9(3).
      ************
      **** rel 2.0
      * swimp0: 1=chiamato da vuti130, visualizza anche movimenti
      *           con importi = zero
           05 SWIMP0   PIC 9.
      ************
      **** rel 6.2
           05 CLAV   PIC S9(11)V99.
      ************
      **** rel 7.1
           05 FLGVAL PIC 9.
      ************
       01  AREA-C201.
           05 C201-TIP PIC 9.
           05 C201-FL  PIC 9.
           05 C201-AZI PIC 999.
           05 C201-CON PIC 9(7) COMP-3.
           05 C201-DAT PIC 9(5) COMP-3.
           05 C201-NUM PIC 9(5) COMP-3.
      **** rel 4.0
      *    05 C201-RF  PIC X(120).
           05 C201-RF  PIC X(130).
      ************
      *       c201-rf lunghezza record movime - da copy grimov
           05 C201-ST  PIC 9.
       01  RIGAVIDEO.
           05 WDAT PIC X(8) VALUE SPACE.
           05 WDES PIC X(44) VALUE SPACE.
           05 FILLER PIC X.
           05 WNPRT  PIC ZZZZZ-.
           05 WNDOC  PIC ZZZZZ VALUE ZERO.
           05 FILLER PIC X.
           05 WDMOV  PIC X(7) VALUE SPACE.
           05 FILLER PIC X.
      **** rel 2.0
      *    05 WAVER  PIC ZZZZZZZZ.ZZZ.ZZZ.ZZZ-.
           05 WAVER  PIC ZZZZZZZZ.ZZZ.ZZZ.ZZ9-.
      ************
           05 FILLER REDEFINES WAVER.
      **** rel 2.0
      *       10 WDAR PIC ZZ.ZZZ.ZZZ.ZZZ-.
              10 WDAR PIC ZZ.ZZZ.ZZZ.ZZ9-.
      ************
              10 FILLER PIC X(6).
           05 WAVERV REDEFINES WAVER PIC ZZZZZ.ZZZ.ZZZ.ZZZ,ZZ-.
           05 FILLER REDEFINES WAVER.
              10 WDARV PIC ZZZ.ZZZ.ZZZ,ZZ-.
              10 FILLER PIC X(6).
      **** rel 1.2
      **** rel 4.0
      *    05 EWAVER REDEFINES WAVER PIC ZZZZZ.ZZZ.ZZZ.ZZZ,ZZ-.
      *    05 FILLER REDEFINES WAVER.
      *       10 EWDAR  PIC ZZZ.ZZZ.ZZZ,ZZ-.
      *       10 FILLER PIC X(6).
      ************
      ************
           05 FILLER REDEFINES WAVER.
              10 WDVAL PIC X(3).
              10 FILLER PIC X(18).
      **** rel 6.2
           10 FILLER PIC X.
           10 WPRG  PIC ZZZ.ZZZ.ZZZ,ZZ-.
      ************
       01  VETMOV OCCURS 800.
           05 ELTIP PIC 9.
           05 ELDAT PIC 9(5) COMP-3.
           05 ELNUM PIC 9(5) COMP-3.
      *-------------------------------------------------------------
       01  CONTATORI.
      **** rel 3.0b
      *    05 KBUF     PIC 999   VALUE 800.
           05 KBUF     PIC 999   VALUE 795.
      ************
           05 KNUM     PIC 999   VALUE 80.
           05 KULT     PIC 999.
           05 KBLO     PIC 999.
           05 KTOT     PIC 999.
           05 BUF-ST   PIC 9.
              88 BUF-PIENO VALUE 1.
      *    kbuf = limite massimo di righe da visualizzazione
      *           (la visualizzazione si interrompe quando il n. di
      *            righe visualizzate ha superato kbuf; il buffer
      *            corrente viene comunque sempre completato)
      *    knum = n. righe da caricare nel buffer
      *           mantenere < 100 se servono piu' righe video per record
      *    kult = n. ultima riga caricata nel buffer
      *    kblo = n. di riga ultimo blocco logico completo caricato
      *    ktot = n. totale righe caricate da inizio visualizzazione
      *-------------------------------------------------------------
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-EOF       PIC 9.
           05 IF-NBYTE     PIC 9(5).
           05 IF-POS       PIC 9(3).
           05 IF-FL        PIC 9.
      *----------------------------------------
      * Nota: 
      * - IF-POS: item selezionato dal list-box
      * - IF-FL puo' assumere:
      *       0=esercizio corrente
      *       1=vecchio esercizio
      *       2=esercizio anni precedenti (GAP)
      *----------------------------------------

      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-DTIPO     PIC X(10).
           05 IF-RIPO      PIC 9.
           05 IF-CODCON    PIC 9(7).
           05 IF-CODCF     PIC 9(5).
           05 IF-CODCON-D  PIC X(36).
           05 IF-CODCF-D   PIC X(36).
           05 IF-CODCF-D1  PIC X(24).
      * data
           05 IF-DAT       PIC 9(6).
      * data
           05 IF-DAT2      PIC 9(6).
      **** rel 4.0
      *    05 IF-SALAT     PIC S9(11).
           05 IF-SALAT     PIC S9(11)V99.
      ************
      **** rel 1.2
      **** rel 4.0
      *    05 IF-ESALAT    PIC S9(9)V99.
           05 IF-ESALAT    PIC S9(11)V99.
      ************
      ************
      **** rel 4.0
      *    05 IF-SALDIP    PIC S9(11).
           05 IF-SALDIP    PIC S9(11)V99.
      ************
      **** rel 1.2
      **** rel 4.0
      *    05 IF-ESALDIP   PIC S9(9)V99.
           05 IF-ESALDIP   PIC S9(11)V99.
      ************
      ************
      **** rel 4.0
      *    05 IF-SALDPR    PIC S9(11).
           05 IF-SALDPR    PIC S9(11)V99.
      ************
      **** rel 1.2
      **** rel 4.0
      *    05 IF-ESALDPR   PIC S9(9)V99.
           05 IF-ESALDPR   PIC S9(11)V99.
      ************
      ************
      **** rel 4.0
      *    05 IF-SALDDI    PIC S9(11).
           05 IF-SALDDI    PIC S9(11)V99.
      ************
      **** rel 1.2
      **** rel 4.0
      *    05 IF-ESALDDI   PIC S9(9)V99.
           05 IF-ESALDDI   PIC S9(11)V99.
      ************
      ************
      **** rel 4.0
      *    05 IF-TOTFAT    PIC S9(11).
           05 IF-TOTFAT    PIC S9(11)V99.
      ************
      **** rel 1.2
      **** rel 4.0
      *    05 IF-ETOTFAT   PIC S9(9)V99.
           05 IF-ETOTFAT   PIC S9(11)V99.
      ************
      ************
      **** rel 6.2
           05 IF-FLGATT    PIC 9.
           05 IF-TPORD     PIC 9.
           05 IF-FLGPRO    PIC 9.
      ************
      *
      * 1o Buffer righe di visualizzazione
      *
       01  IF-BUFF.
           05 IF-RIGA OCCURS 100.
      **** rel 6.2
      *       10 IF-RIG    PIC X(94).
              10 IF-RIG    PIC X(110).
      ************
              10 IF-EOR    PIC X.
      *
      * 2o Buffer righe di visualizzazione
      *
       01  IF-BUFF2.
           05 IF-RIGA2 OCCURS 100.
      **** rel 6.2
      *       10 IF-RIG2   PIC X(94).
              10 IF-RIG2   PIC X(110).
      ************
              10 IF-EOR2   PIC X.
      *
      * Record dati da visualizzare
      *
       01  RG-MOV-REC.
           05 RG-MOV-AZI    PIC 999.
           05 RG-MOV-CON    PIC 9(7).
      * data
           05 RG-MOV-DAT    PIC 9(6).
           05 RG-MOV-NUM    PIC 9(5).
           05 RG-MOV-CAUS   PIC 999.
           05 RG-MOV-CAUS-D PIC X(36).
           05 RG-MOV-D-A    PIC X.
           05 RG-MOV-TREG   PIC 9.
      **** rel 4.0
      *    05 RG-MOV-IMPO   PIC S9(11).
           05 RG-MOV-IMPO   PIC S9(11)V99.
      ************
      **** rel 1.2
      **** rel 4.0
      *    05 RG-MOV-EIMPO  PIC S9(9)V99.
           05 RG-MOV-EIMPO  PIC S9(11)V99.
      ************
      ************
           05 RG-MOV-NDOC   PIC 9(5).
      * data
           05 RG-MOV-DTDOC  PIC 9(6).
      * data
           05 RG-MOV-DTSCD  PIC 9(6).
           05 RG-MOV-NPRGI  PIC 9(5).
           05 RG-MOV-FLAG   PIC 9.
           05 RG-MOV-DSAGG  PIC X(30).
           05 RG-MOV-IVA    PIC 999.
           05 RG-MOV-ACF    PIC 9(7).
           05 RG-MOV-TIP    PIC 9.
      **** rel 4.0
      *    05 RG-MOV-IMP    PIC S9(11).
           05 RG-MOV-IMP    PIC S9(11)V99.
      ************
      **** rel 1.2
      **** rel 4.0
      *    05 RG-MOV-EIMP   PIC S9(9)V99.
           05 RG-MOV-EIMP   PIC S9(11)V99.
      ************
      ************
      **** rel 4.0
      *    05 RG-MOV-IVN    PIC S9(11).
           05 RG-MOV-IVN    PIC S9(11)V99.
      ************
      **** rel 1.2
      **** rel 4.0
      *    05 RG-MOV-EIVN   PIC S9(9)V99.
           05 RG-MOV-EIVN   PIC S9(11)V99.
      ************
      ************
           05 RG-MOV-IMV    PIC S9(11)V99.
      **** rel 4.0
      *    05 RG-MOV-IML    PIC S9(11).
           05 RG-MOV-IML    PIC S9(11)V99.
      ************
      **** rel 1.2
      **** rel 4.0
      *    05 RG-MOV-EIML   PIC S9(9)V99.
           05 RG-MOV-EIML   PIC S9(11)V99.
      ************
      ************
      **** rel 4.0
      *    05 RG-MOV-INL    PIC S9(11).
           05 RG-MOV-INL    PIC S9(11)V99.
      ************
      **** rel 1.2
      **** rel 4.0
      *    05 RG-MOV-EINL   PIC S9(9)V99.
           05 RG-MOV-EINL   PIC S9(11)V99.
      ************
      ************
           05 RG-MOV-VAL    PIC 9(3).
           05 RG-MOV-PART   PIC 9(7).
           05 RG-MOV-PART-D PIC X(36).
           05 RG-MOV-NREG   PIC 9(5).
           05 RG-MOV-CATT   PIC X.
           05 RG-MOV-FEV    PIC 9.
           05 RG-MOV-MES    PIC 99.
           05 RG-MOV-ANN    PIC 9.
           05 RG-MOV-VALUT  PIC 9(3).
      **** rel 4.0
      *    05 RG-MOV-CAMGG  PIC 9999V999.
           05 RG-MOV-CAMGG  PIC 9(5)V9(6).
      ************
           05 RG-MOV-IMVAL  PIC S9(11)V99.
           05 RG-MOV-CCOST  PIC X(4).
      **** rel 7.1
           05 RG-MOV-TPSOG PIC 9.
           05 RG-MOV-CDSOG PIC 9(5).
      ************
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-BUFF
                                IF-BUFF2
                                RG-MOV-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcon'.
           COPY 'dclclf'.
           COPY 'dclmov'.
           COPY 'dclmsz'.
           COPY 'dclmvx'.
           COPY 'dclmsx'.
           COPY 'dcltab'.
      **** rel 6.2
           COPY 'dcllav'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST IF-NBYTE.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

      **** rel 1.2
      *
      * sincronizza stato variabile EURO con interfaccia
           IF FUN = 'j'
              MOVE ZERO TO EURO
              GO TO FINE.
      *
      * commutazione stato lire/euro
           IF FUN = 'J'
              IF EURO = ZERO
                 MOVE 1    TO EURO
              ELSE
                 MOVE ZERO TO EURO
              END-IF
              GO TO FINE.
      ************
           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        PERFORM LENGHT-SEZ
                        GO TO FINE.
           IF FUN = 'B'
              IF KTOT >= KBUF OR IF-EOF NOT = ZERO
                 MOVE 'Impossibile visualizzare altri dati' TO F-MES1
                 MOVE '   Eseguire una nuova selezione'     TO F-MES2
                 MOVE 2 TO F-NMES
                 GO TO WARNING
              ELSE
                 PERFORM SHIFT-BUF-INDIETRO
                 PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                 PERFORM LENGHT-SEZ
                 GO TO FINE.
           IF FUN = 'x' GO TO F-VIS-RECORD.
      **** rel 2.0
           IF FUN = '3' 
              MOVE 1 TO SWIMP0
              GO TO FINE.
      ************
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon200: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       F-VIS-RECORD.
           MOVE ELTIP(IF-POS) TO C201-TIP.
           MOVE IF-FL         TO C201-FL.
      **** rel 4.1
           IF IF-FL = 2 MOVE 1 TO C201-FL.
      ************
           MOVE IF-AZI        TO C201-AZI.
           IF IF-DTIPO = 'Generale'
      **** rel 7.1
                 MOVE ZERO TO COMTIP
      ************
              MOVE IF-CODCON TO C201-CON
           ELSE
              MOVE IF-CODCF  TO CLF
              IF IF-DTIPO = 'Clienti'
                 MOVE MCLI TO MAS
      **** rel 7.1
                 MOVE 1 TO COMTIP
      ************
              ELSE
                 MOVE MFOR TO MAS
      **** rel 7.1
                 MOVE 2 TO COMTIP
      ************
              END-IF
              MOVE CDCLI TO C201-CON.
           MOVE ELDAT(IF-POS) TO C201-DAT.
           MOVE ELNUM(IF-POS) TO C201-NUM.
           CALL 'vcon201' USING AREA-C201.
           IF C201-ST = 9
              MOVE 'Errore lettura movimento' TO MESS
              MOVE ZERO TO F-NMES
              PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
              MOVE 8 TO ERRIO-ST
              GO TO FINE.

           MOVE C201-RF TO REKMOV.

           MOVE ZERO  TO RG-MOV-REC.
           MOVE SPACE TO RG-MOV-D-A
                         RG-MOV-DSAGG
                         RG-MOV-CATT
                         RG-MOV-CCOST
                         RG-MOV-CAUS-D
                         RG-MOV-PART-D.
           MOVE ZERO  TO RG-MOV-IMPO
                         RG-MOV-IMP
                         RG-MOV-IVN
                         RG-MOV-IMV
                         RG-MOV-IML
                         RG-MOV-INL
                         RG-MOV-IMVAL.
      **** rel 1.2
           MOVE ZERO  TO RG-MOV-EIMPO
                         RG-MOV-EIMP
                         RG-MOV-EIVN
                         RG-MOV-EIML
                         RG-MOV-EINL.
      ************
      *
           MOVE MOV-AZI   TO RG-MOV-AZI.
           MOVE MOV-CON   TO RG-MOV-CON.
      *
           MOVE MOV-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-MOV-DAT.
      *
           MOVE MOV-NUM   TO RG-MOV-NUM.
           MOVE MOV-CAUS  TO RG-MOV-CAUS.
      *
           MOVE 2        TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID 
                MOVE ALL '*' TO TAB-DESCR.
           MOVE TAB-DESCR TO RG-MOV-CAUS-D.
      *
           MOVE MOV-D-A   TO RG-MOV-D-A.
           MOVE MOV-TREG  TO RG-MOV-TREG.
           MOVE MOV-IMPO  TO RG-MOV-IMPO.
           MOVE MOV-NDOC  TO RG-MOV-NDOC.
      *
           MOVE MOV-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-MOV-DTDOC.
      *
           MOVE MOV-DTSCD TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-MOV-DTSCD.
      *
           MOVE MOV-NPRGI TO RG-MOV-NPRGI.
           MOVE MOV-FLAG  TO RG-MOV-FLAG.
           IF MOV-FLAG = 1
              MOVE MOV-DSAGG TO RG-MOV-DSAGG
              GO TO F-VIS-RECORD-10.
           MOVE MOV-IVA   TO RG-MOV-IVA.
           MOVE MOV-ACF   TO RG-MOV-ACF.
           MOVE MOV-TIP   TO RG-MOV-TIP.
           IF MOV-TIP = 4
              MOVE MOV-IMV TO RG-MOV-IMV
              MOVE MOV-IML TO RG-MOV-IML
              MOVE MOV-INL TO RG-MOV-INL
              MOVE MOV-VAL TO RG-MOV-VAL
           ELSE
              MOVE MOV-IMP TO RG-MOV-IMP
              MOVE MOV-IVN TO RG-MOV-IVN.
       F-VIS-RECORD-10.
           MOVE MOV-PART  TO RG-MOV-PART.
           IF MOV-PART = MOV-CON GO TO F-VIS-RECORD-20.
           IF MOV-PART = 9999999 GO TO F-VIS-RECORD-20.
           IF MOV-PART = ZERO    GO TO F-VIS-RECORD-20.
           MOVE MOV-PART TO CDCLI.
           IF T02-TIPRG = 1 GO TO F-VIS-RECORD-15.
           IF NOT (MAS = MCLI OR MFOR) GO TO F-VIS-RECORD-15.
           MOVE MOV-AZI  TO KCF-AZI.
           MOVE MOV-PART TO KCF-COD.
           READ ANACLF INVALID MOVE ALL '*' TO CLF-RGS.
           MOVE CLF-RGS TO RG-MOV-PART-D.
           GO TO F-VIS-RECORD-20.
       F-VIS-RECORD-15.
           MOVE MOV-AZI  TO KPC-AZI.
           MOVE MOV-PART TO KPC-COD.
           READ ANACON INVALID MOVE ALL '*' TO CON-DSC.
           MOVE CON-DSC TO RG-MOV-PART-D.
       F-VIS-RECORD-20.
           MOVE MOV-NREG  TO RG-MOV-NREG.
           MOVE MOV-CATT  TO RG-MOV-CATT.
           MOVE MOV-FEV   TO RG-MOV-FEV.
           MOVE MOV-MES   TO RG-MOV-MES.
           MOVE MOV-ANN   TO RG-MOV-ANN.
           MOVE MOV-VALUT TO RG-MOV-VALUT.
           MOVE MOV-CAMGG TO RG-MOV-CAMGG.
           MOVE MOV-IMVAL TO RG-MOV-IMVAL.
           MOVE MOV-CCOST TO RG-MOV-CCOST.
      **** rel 7.1
           IF IF-DTIPO = 'Generale'
              MOVE ZERO TO RG-MOV-TPSOG RG-MOV-CDSOG
           ELSE
              MOVE COMTIP TO RG-MOV-TPSOG
              MOVE IF-CODCF TO RG-MOV-CDSOG.
      ************
      **** rel 1.2
           MOVE RG-MOV-IMPO TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'reurimp' USING ER-IMPORTO.
           CALL 'rlitimp' USING ER-IMPORTO.
      ************
           MOVE ER-IMPORTO TO RG-MOV-EIMPO.
           MOVE RG-MOV-IMP TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'reurimp' USING ER-IMPORTO.
           CALL 'rlitimp' USING ER-IMPORTO.
      ************
           MOVE ER-IMPORTO TO RG-MOV-EIMP.
           MOVE RG-MOV-IVN TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'reurimp' USING ER-IMPORTO.
           CALL 'rlitimp' USING ER-IMPORTO.
      ************
           MOVE ER-IMPORTO TO RG-MOV-EIVN.
           MOVE RG-MOV-IML TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'reurimp' USING ER-IMPORTO.
           CALL 'rlitimp' USING ER-IMPORTO.
      ************
           MOVE ER-IMPORTO TO RG-MOV-EIML.
           MOVE RG-MOV-INL TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'reurimp' USING ER-IMPORTO.
           CALL 'rlitimp' USING ER-IMPORTO.
      ************
           MOVE ER-IMPORTO TO RG-MOV-EINL.
      ************
           GO TO FINE.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANACON ANACLF TABELL MOVIME MOVSEZ
                 MOVMXX MOVSXX ANAAZI ANACOL ANACFX.
      **** rel 6.2
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
      ************
           MOVE ZERO TO SWINI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griconer'.
           COPY 'griclfer'.
           COPY 'grimover'.
           COPY 'grimszer'.
           COPY 'grimvxer'.
           COPY 'grimsxer'.
           COPY 'gricoler'.
           COPY 'gricfxer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione elaborazione
       INI-ELABORA.
           IF IF-FL = ZERO
              MOVE 'anaazi' TO ID-AZI
              MOVE 'tabell' TO ID-TAB
              MOVE 'anaclf' TO ID-CLF
              MOVE 'anacon' TO ID-CON
              MOVE 'movime' TO ID-MOV
              MOVE 'movsez' TO ID-MSZ
              MOVE 'movmxx' TO ID-MVX
              MOVE 'movsxx' TO ID-MSX
           ELSE
              MOVE 'anazol' TO ID-AZI
              MOVE 'tabold' TO ID-TAB
              MOVE 'anacfx' TO ID-CLF
              MOVE 'anacol' TO ID-CON
              MOVE 'movmol' TO ID-MOV
              MOVE 'movsol' TO ID-MSZ
              MOVE 'movoxx' TO ID-MVX
              MOVE 'mosoxx' TO ID-MSX.
      *
           OPEN INPUT ANACON ANACLF TABELL MOVIME MOVSEZ
                      MOVMXX MOVSXX ANAAZI ANACOL ANACFX.
      **** rel 6.2
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O WDSLAV.
      ************
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           MOVE 1 TO KTB-TIP
                     KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY PERFORM INVK-TAB
                                               GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI  TO MCLI.
           MOVE T01-MFOR  TO MFOR.
           MOVE T01-CIVAV TO IVAVEN.
           MOVE T01-CIVSO TO IVASOS.                                   
           MOVE T01-CIVAQ TO IVAACQ.
      **** rel 6.3
           MOVE 20 TO KTB-TIP.
           MOVE 1  TO KTB-COD.
           READ TABELL INTO RKTB20 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB20.
      ************
      **** rel 1.2
      *
           MOVE ZERO TO EURO.
      ************
      **** rel 2.0
           MOVE ZERO TO SWIMP0.
      ************
      **** rel 4.0
           CALL 'rveur' USING COMEURO.
      ************
      *
           MOVE ZERO TO IF-EOF.
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZI-RGSOC  TO IF-AZI-D.
           MOVE 'Generale' TO IF-DTIPO.
           MOVE ZERO  TO IF-RIPO
                         IF-CODCON
                         IF-CODCF
                         IF-SALAT
                         IF-SALDIP
                         IF-SALDPR
                         IF-SALDDI
                         IF-TOTFAT.
      **** rel 1.2
           MOVE ZERO  TO IF-ESALAT
                         IF-ESALDIP
                         IF-ESALDPR
                         IF-ESALDDI
                         IF-ETOTFAT.
      ************
      **** rel 6.2
           MOVE ZERO  TO IF-FLGPRO.
      ************
           MOVE SPACE TO IF-CODCON-D
                         IF-CODCF-D
                         IF-CODCF-D1.
      *
           MOVE AZI-ULTDT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE 1 TO GG9.
           IF MM9 > 3
              SUBTRACT 3 FROM MM9
           ELSE
              MOVE 1 TO MM9.
           MOVE GGMMAA TO IF-DAT.
           MOVE 31 TO GG9.
           MOVE 12 TO MM9.
           MOVE GGMMAA TO IF-DAT2.
      **** rel 6.2
           MOVE ZERO    TO IF-FLGATT.
           MOVE ZERO    TO IF-TPORD.
      ************
      *
       FLPDT.
      *
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DTIPO.
           MOVE 'IF-DTIPO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTIPO.
           IF NOT (IF-DTIPO = 'Generale' OR 'Clienti' OR 'Fornitori')
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-DTIPO.
      *
       V-RIPO.
           MOVE 'IF-RIPO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-RIPO.
           IF IF-RIPO > 1
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-RIPO.
      *
       V-CODCON.
           MOVE 'IF-CODCON' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CODCON.
           IF IF-DTIPO NOT = 'Generale' GO TO E-CODCON.
           MOVE SPACE TO IF-CODCON-D.
           MOVE IF-AZI    TO KPC-AZI.
           MOVE IF-CODCON TO KPC-COD.
           READ ANACON INVALID KEY 
                PERFORM ERR-CINE
                GO TO V-ERROR.
           MOVE CON-DSC TO IF-CODCON-D.
           MOVE ZERO TO SALDAP.
      *
           IF IF-RIPO = ZERO GO TO V-CODCON-10.
           MOVE KEYPC TO KEYCL.
           READ ANACOL INTO REKCON INVALID
                MOVE ZERO TO SALDAP
                GO TO V-CODCON-10.
           IF SF-COL = '9D' OR '9A' OR '35' MOVE RF-COL TO REKCON.
           COMPUTE SALDAP = CON-SESP + CON-SE-D - CON-SE-A.
       V-CODCON-10.
           READ ANACON INTO REKCON INVALID KEY
                MOVE SPACE TO IF-CODCON-D
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-COD TO CODICE.
           COMPUTE IF-SALAT = CON-SESP + CON-SE-D - CON-SE-A.
           IF CON-TIPO = 'E' MOVE ZERO TO SALDAP.
           IF IF-RIPO > ZERO ADD SALDAP TO IF-SALAT.
      **** rel 1.2
           MOVE IF-SALAT TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'reurimp' USING ER-IMPORTO.
           CALL 'rlitimp' USING ER-IMPORTO.
      ************
           MOVE ER-IMPORTO TO IF-ESALAT.
      ************
       E-CODCON.
      *
       V-CODCF.
           MOVE 'IF-CODCF' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CODCF.
           IF NOT (IF-DTIPO = 'Clienti' OR 'Fornitori') GO TO E-CODCF.
           MOVE SPACE TO IF-CODCF-D
                         IF-CODCF-D1.
           IF IF-DTIPO = 'Fornitori'
              MOVE MFOR TO MAS
           ELSE
              MOVE MCLI TO MAS.
           MOVE IF-CODCF TO CLF.
           MOVE CDCLI   TO KCF-COD.
           MOVE IF-AZI   TO KCF-AZI.
           READ ANACLF INTO REKCLF INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           MOVE CLF-RGS TO IF-CODCF-D.
           MOVE CLF-CIT TO IF-CODCF-D1.
           MOVE ZERO TO SALDAP.
      *
           IF IF-RIPO = ZERO GO TO V-CODCF-10.
           MOVE KEYCF TO KEYCX.
           READ ANACFX INTO REKCLF INVALID
                MOVE ZERO TO SALDAP
                GO TO V-CODCF-10.
           IF SF-CFX = '9D' OR '9A' OR '35' MOVE RF-CFX TO REKCLF.
           COMPUTE SALDAP = CLF-SESP + CLF-SE-D - CLF-SE-A.
       V-CODCF-10.
           READ ANACLF INTO REKCLF INVALID KEY
                MOVE SPACE TO IF-CODCF-D
                              IF-CODCF-D1
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           MOVE CLF-COD TO COMCOD.
           COMPUTE IF-TOTFAT = CLF-IMPON + CLF-NIMPO + CLF-ESENT.
           COMPUTE IF-SALAT  = CLF-SESP  + CLF-SE-D  - CLF-SE-A.
           IF IF-RIPO > ZERO ADD SALDAP TO IF-SALAT.
      **** rel 1.2
           MOVE IF-SALAT TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'reurimp' USING ER-IMPORTO.
           CALL 'rlitimp' USING ER-IMPORTO.
      ************
           MOVE ER-IMPORTO TO IF-ESALAT.
           MOVE IF-TOTFAT TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'reurimp' USING ER-IMPORTO.
           CALL 'rlitimp' USING ER-IMPORTO.
      ************
           MOVE ER-IMPORTO TO IF-ETOTFAT.
      ************
       E-CODCF.
      *
       V-DAT.
           MOVE 'IF-DAT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DAT.
           MOVE 1 TO TIPOP1.
           MOVE IF-DAT TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKDT1.
           IF AAGGG < AZI-DTAPE
              MOVE 'Data < data apertura' TO MESS
              GO TO V-ERROR.
       E-DAT.
      *
       V-DAT2.
           MOVE 'IF-DAT2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DAT2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DAT2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKDT2.
           IF PKDT2 < PKDT1
              PERFORM ERR-DINC
              GO TO V-ERROR.
           COMPUTE PKDT = PKDT1 - 1.
       E-DAT2.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione
       RUN-ELABORA.
           IF FUN = 'B'
              IF IF-DTIPO = 'Generale'
                 GO TO RUN-RIENTRO-GEN
              ELSE
                 GO TO RUN-RIENTRO.
      *
           MOVE 1 TO KVET.
           PERFORM UNTIL KVET > 800
              MOVE ZERO TO ELDAT(KVET)
                           ELNUM(KVET)
              ADD 1 TO KVET
           END-PERFORM.
           MOVE ZERO TO KVET.
           MOVE ZERO TO TIPFIL.
      *    
           MOVE ZERO TO KULT KBLO KTOT.
           MOVE ZERO TO IF-EOF.
      **** rel 4.0-2
      *
           MOVE ZERO TO IF-SALDIP
                        IF-SALDPR
                        IF-SALDDI
                        IF-ESALDIP
                        IF-ESALDPR
                        IF-ESALDDI.
      *
           IF IF-DTIPO = 'Generale' GO TO RUN-ELABORA-03.
           IF IF-DTIPO = 'Fornitori'
              MOVE MFOR TO MAS
           ELSE
              MOVE MCLI TO MAS.
           MOVE IF-CODCF TO CLF.
           MOVE CDCLI  TO KCF-COD.
           MOVE IF-AZI TO KCF-AZI.
           READ ANACLF INTO REKCLF INVALID PERFORM INVK-CLF
                                           GO TO ERRIO.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           GO TO RUN-ELABORA-05.
       RUN-ELABORA-03.
           MOVE IF-AZI    TO KPC-AZI
           MOVE IF-CODCON TO KPC-COD
           READ ANACON INTO REKCON INVALID KEY PERFORM INVK-CLF
                                               GO TO ERRIO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
       RUN-ELABORA-05.
      ************
      *
      * calcolo saldi
      *
           IF IF-DTIPO = 'Generale' GO TO RUN-ELABORA-10.
      *
           PERFORM T00-BILCOM THRU T99.
           COMPUTE IF-SALDIP = (CLF-SPSP + CLF-SP-D - CLF-SP-A) +
                               (LTCAS    + LTCAD    - LTCAA).
           IF IF-RIPO > ZERO
              ADD SALDAP TO IF-SALDIP.
           MOVE IF-SALDIP  TO IF-SALDPR.
      **** rel 1.2
           MOVE IF-SALDIP TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'reurimp' USING ER-IMPORTO.
           CALL 'rlitimp' USING ER-IMPORTO.
      ************
           MOVE ER-IMPORTO TO IF-ESALDIP.
           MOVE IF-ESALDIP TO IF-ESALDPR.
      ************
           GO TO RUN-ELABORA-20.
       RUN-ELABORA-10.
           PERFORM R00-BILCOM THRU R99.
           COMPUTE IF-SALDIP = (CON-SPSP + CON-SP-D - CON-SP-A) +
                               (LTCAS    + LTCAD    - LTCAA).
           IF IF-RIPO > ZERO 
              ADD SALDAP TO IF-SALDIP.
           MOVE IF-SALDIP TO IF-SALDPR.
           COMPUTE IF-SALDDI = IF-SALDPR - IF-SALDIP.
      **** rel 1.2
           MOVE IF-SALDIP TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'reurimp' USING ER-IMPORTO.
           CALL 'rlitimp' USING ER-IMPORTO.
      ************
           MOVE ER-IMPORTO TO IF-ESALDIP.
           MOVE IF-ESALDIP TO IF-ESALDPR.
           MOVE IF-SALDDI TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'reurimp' USING ER-IMPORTO.
           CALL 'rlitimp' USING ER-IMPORTO.
      ************
           MOVE ER-IMPORTO TO IF-ESALDDI.
      ************
       RUN-ELABORA-20.
      **** rel 6.2
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O   WDSLAV.
      **** rel 6.2
           MOVE IF-SALDIP TO CLAV.
      ************
      ************
           IF IF-DTIPO = 'Generale' GO TO LP190.
      *
      * scansione per visualizzazione di mov. clienti/fornitori
      *
           IF PKDT1 NOT > AZI-RVDT GO TO LP10.
           GO TO LP50.
       LP10.
           MOVE ZERO TO SW.
           MOVE KAZ-COD TO KSX-AZI.
           MOVE COMCOD  TO KSX-CON.
           MOVE PKDT1   TO KSX-DAT.
           MOVE ZERO    TO KSX-NUM.
           COMPUTE IF-SALDDI = IF-SALDPR - IF-SALDIP.
      **** rel 1.2
           MOVE IF-SALDDI TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'reurimp' USING ER-IMPORTO.
           CALL 'rlitimp' USING ER-IMPORTO.
      ************
           MOVE ER-IMPORTO TO IF-ESALDDI.
      ************
           START MOVSXX KEY NOT < KEYSX INVALID KEY GO TO LP50.
      *
      **** rel 6.2
      * label di rientro per visualizzazione pagine successive
      *RUN-RIENTRO.
      *    IF TIPFIL = 3 GO TO LPMOV.
      *
      ************
       LP20.
           READ MOVSXX NEXT AT END GO TO LP50.
           IF SF-MSX = '9D' OR '9A' OR '35' GO TO LP20.
           IF KSX-AZI > KAZ-COD GO TO LP50.
           IF KSX-CON > COMCOD  GO TO LP50.
           IF KSX-DAT > PKDT2   GO TO LP50.
           MOVE 4 TO TIPFIL.
           MOVE RF-MSX TO REKMOV.
      **** rel 6.2
           PERFORM WR-LAV THRU EX-WR-LAV.
           GO TO LP20.
      *    GO TO LP100.
      ************
       LP50.
           MOVE 1 TO SW.
           MOVE KAZ-COD TO KMS-AZI.
           MOVE COMCOD  TO KMS-CON.
           MOVE PKDT1   TO KMS-DAT.
           MOVE ZERO    TO KMS-NUM.
      **** rel 6.2
      *    START MOVSEZ KEY NOT < KEYMS INVALID KEY GO TO RD-END.
      *LPMOV.
      *    READ MOVSEZ NEXT AT END GO TO RD-END.
           START MOVSEZ KEY NOT < KEYMS INVALID KEY GO TO LP100.
       LPMOV.
           READ MOVSEZ NEXT AT END GO TO LP100.
      ************
           IF SF-MSZ = '9D' OR '9A' OR '35' GO TO LPMOV.
      **** rel 6.2
      *    IF KMS-AZI > KAZ-COD GO TO RD-END.
      *    IF KMS-CON > COMCOD  GO TO RD-END.
      *    IF KMS-DAT > PKDT2   GO TO RD-END.
           IF KMS-AZI > KAZ-COD GO TO LP100.
           IF KMS-CON > COMCOD  GO TO LP100.
           IF KMS-DAT > PKDT2   GO TO LP100.
      ************
           MOVE 3 TO TIPFIL.
           MOVE RF-MSZ TO REKMOV.
      **** rel 6.2
           PERFORM WR-LAV THRU EX-WR-LAV.
           GO TO LPMOV.
      ************
       LP100.
      **** rel 6.2
           MOVE LOW-VALUE TO KEYLV.
           IF IF-TPORD = ZERO
              START WDSLAV KEY NOT < KEYLV INVALID KEY GO TO RD-END.
           IF IF-TPORD = 1
              START WDSLAV KEY NOT < SKEYLV1 INVALID KEY GO TO RD-END.
           IF IF-TPORD = 2
              START WDSLAV KEY NOT < SKEYLV2 INVALID KEY GO TO RD-END.
           IF IF-TPORD = 3
              START WDSLAV KEY NOT < SKEYLV3 INVALID KEY GO TO RD-END.
      * label di rientro per visualizzazione pagine successive
       RUN-RIENTRO.
       RD-LAV.
           READ WDSLAV NEXT AT END GO TO RD-END.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO RD-LAV.
           IF KLV-ESER NOT = ZERO
              MOVE LAV-KEY   TO KEYMS
              READ MOVSEZ INVALID PERFORM INVK-MSZ
                                  GO TO ERRIO
              END-READ
              MOVE RF-MSZ TO REKMOV
           ELSE
              MOVE LAV-KEY   TO KEYSX
              READ MOVSXX INVALID PERFORM INVK-MSX
                                  GO TO ERRIO
              END-READ
              MOVE RF-MSX TO REKMOV.
      *
           MOVE LAV-TIPFIL TO TIPFIL.
      ************
           MOVE MOV-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GMMMA TO WDAT.
           MOVE 2 TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID 
                PERFORM INVK-TAB
                IF SW = ZERO
                   PERFORM VISK-MSX
                   GO TO ERRIO
                ELSE
                   PERFORM VISK-MSZ
                   GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE SPACE TO CMDES.
           STRING TAB-DESCR DELIMITED '  '
                  ' ' DELIMITED SIZE
                  MOV-DSAGG DELIMITED SIZE INTO CMDES.
           MOVE CMDES TO WKDES.
           IF MOV-PART = MOV-CON GO TO LPMOX.
           IF MOV-PART = 9999999 GO TO LPMOX.
           IF MOV-PART = ZERO    GO TO LPMOX.
           MOVE MOV-AZI  TO KPC-AZI KCF-AZI.
           MOVE MOV-PART TO KPC-COD KCF-COD CDCLI.
           READ ANACON INTO REKCON INVALID GO TO LPMOX.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
       LP120.
           MOVE SPACE TO WKDES.
           IF CON-DSABB = SPACE
              STRING CMDES DELIMITED '   '
                  SPACE DELIMITED SIZE
                  CON-DSC DELIMITED SIZE INTO WKDES
           ELSE
              STRING CMDES DELIMITED '   '
                  SPACE DELIMITED SIZE
                  CON-DSABB DELIMITED SIZE INTO WKDES.
       LPMOX.
           PERFORM A10 THRU A99.
           IF BUF-PIENO GO TO EX-RUN-ELABORA.
      **** rel 6.2
      *    IF SW = ZERO
      *       GO TO LP20
      *    ELSE
      *       GO TO LPMOV.
           GO TO RD-LAV.
      ************
      *
      * scansione per visualizzazione mov. di generale
      *
       LP190.
           IF PKDT1 NOT > AZI-RVDT 
              GO TO LP200
           ELSE
              GO TO LP300.
       LP200.
           MOVE ZERO TO SW.
           MOVE KAZ-COD TO KMX-AZI.
           MOVE CODICE  TO KMX-CON.
           MOVE PKDT1   TO KMX-DAT.
           MOVE ZERO    TO KMX-NUM.
           START MOVMXX KEY NOT < KEYMX INVALID KEY GO TO LP300.
      *
      * label di rientro per visualizzazione pagine successive
      **** rel 6.2
      *RUN-RIENTRO-GEN.
      *    IF TIPFIL = 1 GO TO LPMOVG.
      *
      ************
       LP250.
           READ MOVMXX NEXT AT END GO TO LP300.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO LP250.
           IF KMX-AZI > KAZ-COD GO TO LP300.
           IF KMX-CON > CODICE  GO TO LP300.
           IF KMX-DAT > PKDT2   GO TO LP300.
           MOVE 2 TO TIPFIL.
           MOVE RF-MVX TO REKMOV.
           IF KMX-CON NOT = IVAVEN AND
              KMX-CON NOT = IVAACQ AND
      **** rel 6.2
      *       KMX-CON NOT = IVASOS GO TO SOT01.
      *    IF MOV-FLAG = 1 GO TO SOT01.                                
              KMX-CON NOT = IVASOS GO TO LP290.
           IF MOV-FLAG = 1 GO TO LP290.
      **********                         
           IF MOV-TIP NOT = 4                                          
      **** rel 2.0
              IF SWIMP0 = ZERO
      ************
              IF MOV-IMPO = ZERO GO TO LP250.
      **** rel 6.2
      *    GO TO SOT01.
       LP290.
           PERFORM WR-LAV THRU EX-WR-LAV.
           GO TO LP250.
      ************
       LP300.
           MOVE 1 TO SW.
           MOVE KAZ-COD TO KMV-AZI.
           MOVE CODICE  TO KMV-CON.
           MOVE PKDT1   TO KMV-DAT.
           MOVE ZERO    TO KMV-NUM.
      **** rel 6.2
      *    START MOVIME KEY NOT < KEYMV INVALID KEY GO TO RD-END.
      *LPMOVG.
      *    READ MOVIME NEXT AT END GO TO RD-END.
           START MOVIME KEY NOT < KEYMV INVALID KEY GO TO SOT01.
       LPMOVG.
           READ MOVIME NEXT AT END GO TO SOT01.
      ************
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO LPMOVG.
      **** rel 6.2
      *    IF KMV-AZI > KAZ-COD GO TO RD-END.
      *    IF KMV-CON > CODICE  GO TO RD-END.
      *    IF KMV-DAT > PKDT2   GO TO RD-END.
           IF KMV-AZI > KAZ-COD GO TO SOT01.
           IF KMV-CON > CODICE  GO TO SOT01.
           IF KMV-DAT > PKDT2   GO TO SOT01.
      ************
           MOVE 1 TO TIPFIL.
           MOVE RF-MOV TO REKMOV.
           IF KMV-CON NOT = IVAVEN AND
              KMV-CON NOT = IVAACQ AND
      **** rel 6.2
      *       KMV-CON NOT = IVASOS GO TO SOT01.
      *    IF MOV-FLAG = 1 GO TO SOT01.                                
              KMV-CON NOT = IVASOS GO TO SOT00.
           IF MOV-FLAG = 1 GO TO SOT00.                                
      **********                            
           IF MOV-TIP NOT = 4                                          
      **** rel 2.0
              IF SWIMP0 = ZERO
      ************
              IF MOV-IMPO = ZERO GO TO LPMOVG.
      **** rel 6.2
       SOT00.
           PERFORM WR-LAV THRU EX-WR-LAV.
           GO TO LPMOVG.
      ************
       SOT01.
      **** rel 6.2
           MOVE LOW-VALUE TO KEYLV.
           IF IF-TPORD = ZERO
              START WDSLAV KEY NOT < KEYLV INVALID KEY GO TO RD-END.
           IF IF-TPORD = 1
              START WDSLAV KEY NOT < SKEYLV1 INVALID KEY GO TO RD-END.
           IF IF-TPORD = 2
              START WDSLAV KEY NOT < SKEYLV2 INVALID KEY GO TO RD-END.
           IF IF-TPORD = 3
              START WDSLAV KEY NOT < SKEYLV3 INVALID KEY GO TO RD-END.
      * label di rientro per visualizzazione pagine successive
       RUN-RIENTRO-GEN.
       RD-LAV-GEN.
           READ WDSLAV NEXT AT END GO TO RD-END.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO RD-LAV-GEN.
           IF KLV-ESER NOT = ZERO
              MOVE LAV-KEY TO KEYMV
              READ MOVIME INVALID PERFORM INVK-MOV
                                  GO TO ERRIO
              END-READ
              MOVE RF-MOV TO REKMOV
           ELSE
              MOVE LAV-KEY TO KEYMX
              READ MOVMXX INVALID PERFORM INVK-MVX
                                  GO TO ERRIO
              END-READ
              MOVE RF-MVX TO REKMOV.
      ************
           MOVE MOV-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GMMMA TO WDAT.
           MOVE MOV-PART TO KCF-COD KPC-COD CDCLI.
           MOVE 2 TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                IF SW = ZERO
                   PERFORM VISK-MVX
                   GO TO ERRIO
                ELSE
                   PERFORM VISK-MOV
                   GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF CDCLI = ZERO GO TO LPCAUS.
           MOVE KAZ-COD TO KCF-AZI KPC-AZI.
           IF T02-TIPRG = 1 GO TO SOT01-10.
           IF NOT (MAS = MCLI OR MFOR) GO TO SOT01-10.
           READ ANACLF INTO REKCLF INVALID
                MOVE SPACE TO CLF-RGS
                GO TO LPCAUS.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           GO TO LPCAUS.
       SOT01-10.
           READ ANACON INTO REKCON INVALID
                MOVE SPACE TO CLF-RGS
                GO TO LPCAUS.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           IF CON-DSABB = SPACE
              MOVE CON-DSC   TO CLF-RGS
           ELSE
              MOVE CON-DSABB TO CLF-RGS.
       LPCAUS.
           MOVE SPACE TO CMDES WKDES.
           IF MOV-FLAG = ZERO
              MOVE TAB-DESCR TO CMDES 
           ELSE
              STRING TAB-DESCR DELIMITED '  '
                SPACE MOV-DSAGG DELIMITED SIZE INTO CMDES.
           IF CDCLI = ZERO OR CLF-RGS = SPACE
              MOVE CMDES TO WKDES
           ELSE
              STRING CMDES DELIMITED '   '
                SPACE CLF-RGS DELIMITED SIZE INTO WKDES.
           PERFORM A10 THRU A99.
           IF BUF-PIENO GO TO EX-RUN-ELABORA.
      **** rel 6.2
      *    IF SW = ZERO
      *       GO TO LP250
      *    ELSE
      *       GO TO LPMOVG.
           GO TO RD-LAV-GEN.
      ************
      *
       RD-END.
      * per fine scansione setta blocco completato e EOF 
           PERFORM CHIUDI-BLOCCO-DATI.
      **** rel 7.1
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
      ************
           MOVE 1 TO IF-EOF.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CARICA-BUF.
           MOVE ZERO TO BUF-ST.
           ADD 1 TO KULT KTOT.
           MOVE RIGAVIDEO TO IF-RIG(KULT).
      *
           PERFORM CARICA-BUF2 THRU EX-CARICA-BUF2.
      *
           ADD 1 TO KVET.
           MOVE TIPFIL  TO ELTIP(KVET).
      **** rel 7.1
           MOVE LAV-TIPFIL  TO ELTIP(KVET).
      ************
           MOVE MOV-DAT TO ELDAT(KVET).
           MOVE MOV-NUM TO ELNUM(KVET).
      *
           MOVE SPACE TO RIGAVIDEO.
           MOVE LF TO IF-EOR(KULT).
           MOVE LF TO IF-EOR2(KULT).
           IF KULT >= KNUM MOVE 1 TO BUF-ST.
      **** rel 3.0
           IF KVET >= KBUF MOVE 1 TO BUF-ST.
      ************
      *------------------
       CARICA-BUF2.
      **** rel 7.1
           IF FLGVAL = ZERO GO TO CARICA-BUF2-10.
      ************
      **** rel 4.0
      *    IF MOV-D-A = 'D' MOVE MOV-IMVAL TO WDARV.
      *    IF MOV-D-A = 'A' MOVE MOV-IMVAL TO WAVERV.
      *    IF MOV-VALUT NOT > 1 GO TO CARICA-BUF2-10.
           IF MOV-D-A = 'D' MOVE MOV-IMVAL TO WDARV.
           IF MOV-D-A = 'A' MOVE MOV-IMVAL TO WAVERV.
           IF MOV-VALUT = 1
              IF MOV-D-A = 'D' MOVE 
                 MOV-IMVAL TO WDAR
              ELSE
                 IF MOV-D-A = 'A'
                    MOVE MOV-IMVAL TO WAVER.

      **** rel 7.1
      *    IF (MOV-VALUT = ZERO OR COMEURO) GO TO CARICA-BUF2-10.
           IF (MOV-VALUT = ZERO OR COMEURO)
              IF MOV-D-A = 'D' MOVE MOV-IMPO TO WDARV END-IF
              IF MOV-D-A = 'A' MOVE MOV-IMPO TO WAVERV.
      ************
           MOVE 10        TO KTB-TIP.
           MOVE MOV-VALUT TO KTB-COD.
      **** rel 7.1
           IF MOV-VALUT = ZERO MOVE COMEURO TO KTB-COD.
      ************
           READ TABELL INTO REKTAB INVALID MOVE ALL '*' TO T10-DSINT.
           MOVE T10-DSINT TO WDVAL.
       CARICA-BUF2-10.
           MOVE RIGAVIDEO TO IF-RIG2(KULT).
      **** rel 7.1
           MOVE ZERO TO FLGVAL.
      ************
       EX-CARICA-BUF2.
      *------------------
       LENGHT-SEZ.
           IF KULT = ZERO
              MOVE ZERO TO LNSEZ
           ELSE
              MOVE 1 TO LNSEZ
              PERFORM UNTIL IF-BUFF(LNSEZ:1) = LF ADD 1 TO LNSEZ.
           IF KBLO = ZERO
              COMPUTE IF-NBYTE = LNSEZ * KULT
           ELSE
              COMPUTE IF-NBYTE = LNSEZ * KBLO.
      *------------------
       SHIFT-BUF-INDIETRO.
           MOVE ZERO TO KULT.
           IF KBLO NOT = ZERO
              PERFORM UNTIL KBLO >= KNUM
                 ADD 1 TO KBLO KULT
                 MOVE IF-RIGA(KBLO)  TO IF-RIGA(KULT)
                 MOVE IF-RIGA2(KBLO) TO IF-RIGA2(KULT)
              END-PERFORM.
           MOVE ZERO TO KBLO.
      *------------------
       CHIUDI-BLOCCO-DATI.
           MOVE KULT TO KBLO.
      *------------------
       A10.
      **** rel 7.1
           MOVE ZERO TO FLGVAL.
      ************
           MOVE WKDE1 TO WDES.
           IF WKDE2 = SPACE GO TO A13.
           IF WKDE3 = SPACE 
              PERFORM L010-VIS-RIGA
              MOVE WKDE2 TO WDES
              GO TO A13.
           PERFORM L010-VIS-RIGA.
           MOVE WKDE2 TO WDES.
           PERFORM L010-VIS-RIGA.
           MOVE WKDE3 TO WDES GO TO A13.
           GO TO A10.
       A13.
           IF MOV-NPRGI = ZERO GO TO A15.
           IF MOV-TREG = 3 
              MOVE MOV-NPRGI TO WNPRT
           ELSE
              IF MOV-NPRGI NOT = MOV-NDOC
                 MOVE MOV-NPRGI TO WNPRT.
       A15.
           MOVE MOV-NDOC TO WNDOC.
           IF MOV-DTDOC NOT = ZERO
              MOVE MOV-DTDOC TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GMMMA TO WDMOV.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO IF-SALDPR
           ELSE             SUBTRACT MOV-IMPO FROM IF-SALDPR.
           COMPUTE IF-SALDDI = IF-SALDPR - IF-SALDIP.
      **** rel 1.2
           MOVE IF-SALDPR TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'reurimp' USING ER-IMPORTO.
           CALL 'rlitimp' USING ER-IMPORTO.
      ************
           MOVE ER-IMPORTO TO IF-ESALDPR.
           MOVE IF-SALDDI TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'reurimp' USING ER-IMPORTO.
           CALL 'rlitimp' USING ER-IMPORTO.
      ************
           MOVE ER-IMPORTO TO IF-ESALDDI.
      ************
      **** rel 7.1
           MOVE 1    TO FLGVAL.
      ************
      **** rel 4.0
      *    IF MOV-D-A = 'D' MOVE MOV-IMPO TO WDAR.
      *    IF MOV-D-A = 'A' MOVE MOV-IMPO TO WAVER.
           IF MOV-D-A = 'D' MOVE MOV-IMPO TO WDARV.
           IF MOV-D-A = 'A' MOVE MOV-IMPO TO WAVERV.
      ************
      **** rel 1.2
           IF EURO = 1
              MOVE MOV-IMPO TO ER-IMPORTO
      **** rel 4.0
      *       CALL 'reurimp' USING ER-IMPORTO
      *       IF MOV-D-A = 'D'
      *          MOVE ER-IMPORTO TO EWDAR
      *       ELSE
      *          IF MOV-D-A = 'A'
      *             MOVE ER-IMPORTO TO EWAVER.
              CALL 'rlitimp' USING ER-IMPORTO
              IF MOV-D-A = 'D'
                 MOVE ER-IMPORTO TO WDAR
              ELSE
                 IF MOV-D-A = 'A'
                    MOVE ER-IMPORTO TO WAVER.
      ************
      ************
      **** rel 6.2
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO CLAV
              ELSE
                 IF MOV-D-A = 'A'
                    SUBTRACT MOV-IMPO FROM CLAV.
      *
           IF IF-FLGPRO NOT = ZERO MOVE CLAV TO WPRG.
      ************
           PERFORM L010-VIS-RIGA.
       A99.
           EXIT.
      *------------------
       L010-VIS-RIGA.
           PERFORM CARICA-BUF.
           MOVE SPACE TO RIGAVIDEO.
      *------------------
       R00-BILCOM.
           MOVE ZERO TO CON-SP-D CON-SP-A LTCAD LTCAA.
           IF PKDT > AZI-RVDT
              MOVE CON-SESP TO LTCAS
              SUBTRACT CON-SESP FROM CON-SPSP
              GO TO R40.
           MOVE ZERO TO CON-SPSP LTCAS.
           MOVE LOW-VALUE TO KEYMX.
           MOVE KPC-AZI   TO KMX-AZI.
           MOVE KPC-COD   TO KMX-CON.
           MOVE AZI-DTAPE TO KMX-DAT.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO R40.
       R10.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO R40.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO R10.
           IF KMX-AZI > KPC-AZI GO TO R40.
           IF KMX-CON > KPC-COD GO TO R40.
           IF KMX-DAT NOT < PKDT GO TO R20.
           IF MOV-CAUS > 899 AND < 951 GO TO R15.
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO CON-SPSP
           ELSE
              SUBTRACT MOV-IMPO FROM CON-SPSP.
           GO TO R10.
       R15.
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO LTCAS
           ELSE
              SUBTRACT MOV-IMPO FROM LTCAS.
           GO TO R10.
       R20.
           IF KMX-DAT > PKDT GO TO R40.
           IF MOV-CAUS > 899 AND < 951 GO TO R25.
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO CON-SP-D 
           ELSE
              ADD MOV-IMPO TO CON-SP-A.
           GO TO R10.
       R25.
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO LTCAD
           ELSE
              ADD MOV-IMPO TO LTCAA.
           GO TO R10.
       R40.
           MOVE LOW-VALUE TO KEYMV.
           MOVE KPC-AZI TO KMV-AZI.
           MOVE KPC-COD TO KMV-CON.
           MOVE ZERO TO KMV-DAT.
           START MOVIME KEY NOT < KEYMV INVALID GO TO R99.
       R50.
           READ MOVIME NEXT INTO REKMOV AT END GO TO R99.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO R50.
           IF KMV-AZI > KPC-AZI GO TO R99.
           IF KMV-CON > KPC-COD GO TO R99.
           IF KMV-DAT NOT < PKDT GO TO R60.
           IF MOV-CAUS > 899 AND < 951 GO TO R55.
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO CON-SPSP
           ELSE
              SUBTRACT MOV-IMPO FROM CON-SPSP.
           GO TO R50.
       R55.
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO LTCAS
           ELSE
              SUBTRACT MOV-IMPO FROM LTCAS.
           GO TO R50.
       R60.
           IF KMV-DAT > PKDT GO TO R99.
           IF MOV-CAUS > 899 AND < 951 GO TO R65.
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO CON-SP-D
           ELSE
              ADD MOV-IMPO TO CON-SP-A.
           GO TO R50.
       R65.
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO LTCAD
           ELSE
              ADD MOV-IMPO TO LTCAA.
           GO TO R50.
       R99.
           EXIT.
      *------------------
       T00-BILCOM.
           MOVE ZERO TO CLF-SP-D CLF-SP-A LTCAD LTCAA.
           IF PKDT > AZI-RVDT
              MOVE CLF-SESP TO LTCAS
              SUBTRACT CLF-SESP FROM CLF-SPSP
              GO TO T40.
           MOVE ZERO TO CLF-SPSP LTCAS.
           MOVE LOW-VALUE TO KEYSX.
           MOVE KCF-AZI   TO KSX-AZI.
           MOVE KCF-COD   TO KSX-CON.
           MOVE AZI-DTAPE TO KSX-DAT
           START MOVSXX KEY NOT < KEYSX INVALID GO TO T40.
       T10.
           READ MOVSXX NEXT INTO REKMOV AT END GO TO T40.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO T10.
           IF KSX-AZI > KCF-AZI GO TO T40.
           IF KSX-CON > KCF-COD GO TO T40.
           IF KSX-DAT NOT < PKDT GO TO T20.
           IF MOV-CAUS > 899 AND < 951 GO TO T15.
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO CLF-SPSP
           ELSE
              SUBTRACT MOV-IMPO FROM CLF-SPSP.
           GO TO T10.
       T15.
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO LTCAS
           ELSE
              SUBTRACT MOV-IMPO FROM LTCAS.
           GO TO T10.
       T20.
           IF KSX-DAT > PKDT GO TO T40.
           IF MOV-CAUS > 899 AND < 951 GO TO T25.
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO CLF-SP-D 
           ELSE
              ADD MOV-IMPO TO CLF-SP-A.
           GO TO T10.
       T25.
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO LTCAD
           ELSE
              ADD MOV-IMPO TO LTCAA.
           GO TO T10.
       T40.
           MOVE LOW-VALUE TO KEYMS.
           MOVE KCF-AZI TO KMS-AZI.
           MOVE KCF-COD TO KMS-CON.
           MOVE ZERO    TO KMS-DAT.
           START MOVSEZ KEY NOT < KEYMS INVALID GO TO T99.
       T50.
           READ MOVSEZ NEXT INTO REKMOV AT END GO TO T99.
           IF SF-MSZ = '9D' OR '9A' OR '35' GO TO T50.
           IF KMS-AZI > KCF-AZI GO TO T99.
           IF KMS-CON > KCF-COD GO TO T99.
           IF KMS-DAT NOT < PKDT GO TO T60.
           IF MOV-CAUS > 899 AND < 951 GO TO T55.
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO CLF-SPSP
           ELSE
              SUBTRACT MOV-IMPO FROM CLF-SPSP.
           GO TO T50.
       T55.
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO LTCAS
           ELSE
              SUBTRACT MOV-IMPO FROM LTCAS.
           GO TO T50.
       T60.
           IF KMS-DAT > PKDT GO TO T99.
           IF MOV-CAUS > 899 AND < 951 GO TO T65.
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO CLF-SP-D
           ELSE
              ADD MOV-IMPO TO CLF-SP-A.
           GO TO T50.
       T65.
           IF MOV-D-A = 'D'
              ADD MOV-IMPO TO LTCAD
           ELSE
              ADD MOV-IMPO TO LTCAA.
           GO TO T50.
       T99.
           EXIT.
      *------------------
      **** rel 6.2
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w2' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       WR-LAV.
           MOVE ZERO TO KEYLV.
           IF TIPFIL = 2 OR 4 MOVE ZERO TO KLV-ESER
           ELSE               MOVE 1    TO KLV-ESER.
           MOVE MOV-DAT   TO KLV-DAT.
      *
           MOVE MOV-CATT  TO KLV-CATT.
           IF KLV-CATT = SPACE MOVE ZERO TO KLV-CATT.
      *
           IF IF-FLGATT = ZERO MOVE ZERO TO KLV-CATT.
      *
           MOVE MOV-NPRGI TO KLV-NPRGI.
           IF KLV-NPRGI = ZERO MOVE HIGH-VALUE TO SKLV-NPRGI.
      *
           MOVE MOV-NREG  TO KLV-NREG.
      **** rel 6.3
           IF MOV-CAUS = (T20-CDCLC OR T20-CACLC OR T20-CDFOC OR 
                         T20-CAFOC OR T20-CDSOC OR T20-CASOC) AND 
                          KLV-NREG= ZERO
              MOVE 99999 TO KLV-NREG.
      ************
           MOVE MOV-NUM   TO KLV-NUM.
           MOVE MOV-KEYID TO LAV-KEY.
           MOVE TIPFIL    TO LAV-TIPFIL.
      *
           WRITE RF-LAV INVALID MOVE 'WR LAV' TO MESS
                                GO TO ERRIO.
       EX-WR-LAV.
           EXIT.
      *------------------
      ************
