       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON360.
      *
      * Rinumerazione fatture fornitori
      *
      * Note:
      * - IF-ST : ST = 8 per richiedere all'interfaccia la
      *           visualizzazione del messaggio conto caricato
      *           in modo anomalo
      *           Al termine della visualizzazione verra' richiamato
      *           il cobol con fun = 1 che permette di riposizionarsi 
      *           a run-rientro
      *   
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'grimovsl'.
           COPY 'grimszsl'.
           SELECT MOVIM2 ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYM2
                  ALTERNATE RECORD KEY KEYM22 WITH DUPLICATES 
                  STATUS SF-MO2.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'grimov'.                                         
           COPY 'grimsz'.                                         
           COPY 'gritab'.
       FD  MOVIM2 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-MO2
           RECORD 130 DATA RECORD RF-MO2.
       01  RF-MO2.
           05 KEYM2.
              10 KM2-AZI PIC 999.
              10 KM2-CON PIC 9(7) COMP-3.
              10 KM2-DAT PIC 9(5) COMP-3.
              10 KM2-NUM PIC 9(5) COMP-3.
           05 FILLER     PIC X(62).
           05 KEYM22.
              10 K22-NREG PIC 9(5).
           05 FILLER      PIC X(50).   
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 149 DATA RECORD RF-LAV.
       01  RF-LAV.
           02 KEYLV.
              05 KLV-AZI PIC 999.
              05 KLV-DAT PIC 9(5) COMP-3.
              05 KLV-NRG PIC 9(5).
              05 KLV-TIP PIC 9.
              05 KLV-NUM PIC 9(5) COMP-3.
              05 KLV-CON PIC 9(7) COMP-3.
           02 REKLAV.
              05 FILLER PIC X(13).
              05 LAV-CAUS   PIC 999  COMP-3.
              05 LAV-D-A    PIC X.
              05 LAV-TREG   PIC 9.
              05 LAV-IMPO   PIC S9(11)V99 COMP-3.
              05 LAV-NDOC   PIC 9(5) COMP-3.
              05 LAV-DTDOC  PIC 9(5) COMP-3.
              05 LAV-DTSCD  PIC 9(5) COMP-3.
              05 LAV-NPRGI  PIC 9(5) COMP-3.
              05 LAV-FLAG   PIC 9.
              05 LAV-FILL1.
                 10 LAV-IVA PIC 999.
                 10 LAV-ACF PIC 9(7) COMP-3.
                 10 LAV-TIP PIC 9.
                 10 LAV-IMP PIC S9(11)V99.
                 10 LAV-IVN PIC S9(11)V99.
              05 LAV-FILL2 REDEFINES LAV-FILL1.
                 10 LAV-DSAGG PIC X(30).
                 10 FILLER    PIC X(4).
              05 LAV-DSCEE REDEFINES LAV-FILL1.
                 10 FILLER  PIC X(8).
                 10 LAV-IMV PIC S9(11)V99 COMP-3.
                 10 LAV-IML PIC S9(11)V99 COMP-3.
                 10 LAV-INL PIC S9(11)V99 COMP-3.
                 10 LAV-VAL PIC 9(3)      COMP-3.
                 10 FILLER  PIC X(3).
              05 LAV-PART   PIC 9(7) COMP-3.
              05 LAV-NREG   PIC 9(5).
              05 LAV-CATT   PIC X.
              05 LAV-FEV    PIC 9.
              05 LAV-PLAF. 
                 10 LAV-MES PIC 99.
                 10 LAV-ANN PIC 9.
              05 LAV-VALUT  PIC 9(3).
              05 LAV-CAMGG  PIC 9(5)V9(6).
              05 LAV-IMVAL  PIC S9(11)V99.
              05 LAV-CCOST  PIC X(4).
              05 LAV-TST    PIC 9.
              05 FILLER     PIC X.
              05 FILLER     PIC X(12).

       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'griclfrk'.
           COPY 'gritabrk'.
           COPY 'grit25rk'.
           COPY 'grit35rk'.
           COPY 'grimovrk'.                                       
           COPY 'parcdt'.
           COPY 'parzf'.
      **** rel 7.1
           COPY 'parppar'.
      ************
       01  ID-AZI  PIC X(15) VALUE 'anaazi'.
       01  ID-CLF  PIC X(15) VALUE 'anaclf'.
       01  ID-TAB  PIC X(15) VALUE 'tabell'.
       01  ID-MOV  PIC X(15) VALUE 'movime'.
       01  ID-MO2  PIC X(15) VALUE 'movime'.
       01  ID-MSZ  PIC X(15) VALUE 'movsez'.
       01  ID-LAV  PIC X(15) VALUE 'wdslav'. 
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-CLF   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-LAV   PIC XX.
           05 SF-MOV   PIC XX.
           05 SF-MO2   PIC XX.
           05 SF-MSZ   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).

           05 CIVAQ    PIC 9(7)   VALUE ZERO.
           05 INC      PIC 9(5)   VALUE ZERO.
           05 T25ESE   PIC 9      VALUE ZERO.
           05 DTK      PIC 9(5)   COMP-3 VALUE ZERO.
           05 UDK      PIC 9(5)   COMP-3 VALUE ZERO.
   
           05 MESS0    PIC X(18)  VALUE SPACE.
           05 RISP     PIC 9      VALUE ZERO.
           05 FLMOV    PIC 9      VALUE ZERO.
           05 CNF      PIC X      VALUE SPACE.
           05 NREG     PIC 9(5)   VALUE ZERO.
           05 DTR      PIC 9(6)   VALUE ZERO.
           05 UDT      PIC 9(6)   VALUE ZERO.
           05 ULDK     PIC 9(5)   COMP-3 VALUE ZERO.
           05 ULDT     PIC 9(6)   VALUE ZERO.
           05 ULNR     PIC 9(5)   VALUE ZERO.
           05 LIS      PIC 9      VALUE ZERO.
           05 SW       PIC 9      VALUE ZERO.
           05 TIPOP    PIC 9      VALUE ZERO.
           05 SEGNO    PIC 9      VALUE ZERO.
           05 DTCOM    PIC 9(5)   COMP-3 VALUE ZERO.
           05 COMCOD   PIC 9(7)   COMP-3 VALUE ZERO.
           05 COMNPRGI PIC 9(5)   COMP-3 VALUE ZERO.
           05 COMIVA   PIC 999    VALUE ZERO.
           05 COMCAU   PIC 999    VALUE ZERO.
           05 COMIMP   PIC S9(11)V99 VALUE ZERO.
           05 COMIMPO  PIC S9(11)V99 VALUE ZERO.
           05 COMIVN   PIC S9(11)V99 VALUE ZERO.
           05 TOTIMP   PIC S9(11)V99 VALUE ZERO.
           05 CLAV     PIC S9(11)V99 VALUE ZERO.
           05 CLV1     PIC S9(11)V99 VALUE ZERO.
           05 CLV2     PIC S9(11)V99 VALUE ZERO.

           05 FLGERR   PIC 9. 
           05 ZULNR    PIC ZZZZ9 VALUE ZERO.
           05 ZULDT    PIC ZZ/ZZ/ZZ VALUE ZERO.

           COPY 'vcon360.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-CATT      PIC X.
           05 IF-CATT-D    PIC X(24).
           05 IF-DATA      PIC 9(6).
           05 IF-PROT      PIC 9(7).
           05 IF-DTMOV     PIC 9(6).
      *
       01  IF-MESS         PIC X(204).

       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dclmov'.
           COPY 'dclmsz'.
           COPY 'dcltab'.
           COPY 'dcllav'.
      *
           COPY 'gridcl' REPLACING ==(SIGLA)== BY ==MO2==
                                   ==NFILE== BY ==MOVIM2==
                                   =='nfile'== BY =='movim2'==.
      *
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' OR
                    '1' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF FLGERR NOT = ZERO GO TO WARNING
                           ELSE GO TO FINE.
           IF FUN = 'S' PERFORM STAMPA-CNT THRU EX-STAMPA-CNT
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
      **** rel 7.1
      *                    GO TO CHIUDI.
                           GO TO ESCI.
      **********
           IF FUN = 'N' PERFORM NUMERA THRU EX-NUMERA
                        GO TO CHIUDI. 
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon360: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE TABELL ANACLF MOVIME MOVIM2 MOVSEZ WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'grimover'.
           COPY 'grimszer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.

           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'tabell' TO ID-TAB
                           MOVE 'anaclf' TO ID-CLF
                           MOVE 'movime' TO ID-MOV 
                           MOVE 'movime' TO ID-MO2
                           MOVE 'movsez' TO ID-MSZ 
           ELSE            MOVE 'anazol' TO ID-AZI
                           MOVE 'tabold' TO ID-TAB
                           MOVE 'anacfx' TO ID-CLF
                           MOVE 'movmol' TO ID-MOV
                           MOVE 'movmol' TO ID-MO2
                           MOVE 'movsol' TO ID-MSZ.

           OPEN INPUT ANACLF MOVIM2.
           OPEN I-O TABELL MOVIME MOVSEZ.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.      
           OPEN I-O WDSLAV.  

           OPEN INPUT ANAAZI.
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
           MOVE AZRGSOC TO IF-AZI-D.
           CLOSE ANAAZI.

           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB 
                                                   GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-CIVAQ TO CIVAQ.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE ZERO  TO IF-DATA IF-DTMOV IF-PROT.
           MOVE SPACE TO IF-CATT IF-CATT-D.
           MOVE ZERO TO FLGERR. 
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-CATT.
           MOVE 'IF-CATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CATT.
           IF IF-CATT = ZERO OR SPACE GO TO RDT25.
           IF IF-CATT NOT NUMERIC 
              PERFORM ERR-DINV
              GO TO V-ERROR.
           IF IF-CATT > '8' 
              PERFORM ERR-DINV
              GO TO V-ERROR.
           MOVE 35 TO T35-TIP.
           MOVE KAZ-COD TO T35-CDAZ.
           MOVE IF-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID PERFORM ERR-CINE
                                           GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           MOVE T35-DATT TO IF-CATT-D.
           MOVE T35-UNR TO IF-PROT. 
           MOVE T35-DTR TO AAGGG DTK.
           GO TO ACCDT.  
       RDT25.
           MOVE '0' TO IF-CATT.
           MOVE AZI-DATT TO IF-CATT-D.
           MOVE 25 TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '1' TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-DTR TO AAGGG DTK.
           MOVE T25-UNR TO IF-PROT.
       ACCDT.   
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DATA.
           MOVE IF-CATT-D TO DESCS3.
       E-CATT.  
      *
       V-DTMOV.
           MOVE 'IF-DTMOV' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTMOV.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTMOV TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA 
              GO TO V-ERROR.
           IF AAGGG NOT > DTK
              PERFORM ERR-DINV
              GO TO V-ERROR.
           MOVE AAGGG TO UDK.
       E-DTMOV. 
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           IF FUN = '1' MOVE ZERO TO FLGERR
                        GO TO RUN-RIENTRO.

           IF IF-FL = 1 AND T25ESE = 1
              CLOSE TABELL
              MOVE 'tabold' TO ID-TAB
              OPEN  I-O  TABELL.

           MOVE AZRGSOC TO DESCS1.
           MOVE 25 TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0' TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID
                            PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-ESE TO T25ESE.
           IF NOT ( IF-FL = 1 AND T25ESE = 1 ) GO TO TSRIN.
           CLOSE TABELL.
           MOVE 'tabell' TO ID-TAB.
           OPEN I-O TABELL.
           MOVE 25 TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0' TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID
                            PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
       TSRIN.
           IF T25-TSR = ZERO 
      **** rel 6.1
      *       MOVE 'Rinumerazione non ammessa' TO F-MESS
              MOVE 'Rinumerazione non ammessa' TO MESS
      ************
              GO TO ERRIO.

           MOVE ZERO TO INC ULNR.
       FDLV.
           MOVE KAZ-COD TO KM2-AZI.
           MOVE CIVAQ   TO KM2-CON.
           MOVE DTK     TO KM2-DAT.
           MOVE ZERO    TO KM2-NUM.
           START MOVIM2 KEY NOT < KEYM2 INVALID GO TO FNRD.
       RDMV.
           READ MOVIM2 NEXT INTO REKMOV AT END GO TO FNRD.
           IF SF-MO2 = '9D' OR '9A' OR '35' GO TO RDMV.
           MOVE ZERO TO FLMOV.
           IF KM2-AZI > KAZ-COD OR
              KM2-CON > CIVAQ   GO TO FNRD.
           IF KM2-DAT  NOT > DTK GO TO RDMV.
           IF MOV-CATT NOT = IF-CATT GO TO RDMV.
           IF MOV-FLAG NOT = ZERO  GO TO RDMV.
           MOVE MOV-NREG TO KS2-NREG NREG.
           IF MOV-TIP = 4 MOVE 1 TO FLMOV GO TO STMOV.                 
           START MOVSEZ KEY NOT < KEYMS2 INVALID GO TO STMOV.
       RDMSZ.
           READ MOVSEZ NEXT INTO REKMOV AT END GO TO STMOV.
           IF SF-MSZ = '9D' OR '9A' OR '35' GO TO RDMSZ.
           IF MOV-NREG > NREG GO TO STMOV.
           IF MOV-AZI NOT = KAZ-COD GO TO RDMSZ.
           IF KMS-DAT NOT = KM2-DAT GO TO RDMSZ.
           MOVE 1 TO FLMOV.
           MOVE KAZ-COD TO KLV-AZI.
           MOVE KMS-DAT TO KLV-DAT.
           MOVE MOV-NREG TO KLV-NRG.
           MOVE ZERO TO KLV-TIP.
           MOVE MOV-NUM TO KLV-NUM.  
           MOVE MOV-CON TO KLV-CON.   
           MOVE REKMOV TO REKLAV.
           WRITE RF-LAV INVALID GO TO RDMV.
           GO TO RDMSZ.
       STMOV.
           IF FLMOV = ZERO GO TO RDMV.
           MOVE NREG TO KEYMV2.
           START MOVIME KEY NOT < KEYMV2 INVALID GO TO RDMV.
       RDMOV.
           READ MOVIME NEXT INTO REKMOV AT END GO TO RDMV.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO RDMOV.
           IF MOV-CAUS = 999 GO TO RDMOV.
           IF MOV-NREG > NREG GO TO RDMV.
           IF MOV-AZI NOT = KAZ-COD GO TO RDMOV.
           IF MOV-DAT NOT = KM2-DAT GO TO RDMOV.
           IF MOV-FLAG = ZERO AND MOV-TIP = 4                          
                         IF MOV-CON NOT = CIVAQ GO TO RDMOV.           
           MOVE KAZ-COD TO KLV-AZI.
           MOVE KMV-DAT TO KLV-DAT.
           MOVE MOV-NREG TO KLV-NRG.
           MOVE 1 TO KLV-TIP.
           MOVE MOV-NUM TO KLV-NUM.  
           MOVE MOV-CON TO KLV-CON.   
           MOVE REKMOV TO REKLAV.
           WRITE RF-LAV INVALID GO TO RDMV.
           GO TO RDMOV.
       FNRD. 
           MOVE ZERO TO FLMOV.
           MOVE ZERO TO DTK NREG ULDK.
           MOVE IF-PROT TO INC.
           MOVE ZERO TO KEYLV.
           MOVE ZERO TO KLV-DAT KLV-NUM KLV-CON DTK NREG.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO FNNU.
       RDLAV.
           READ WDSLAV NEXT AT END GO TO FNNU.
           IF LAV-NPRGI NOT > IF-PROT GO TO RDLAV.
           IF KLV-DAT NOT = DTK OR
              KLV-NRG NOT = NREG
                      MOVE KLV-DAT TO DTK
                      MOVE KLV-NRG TO NREG
                      ADD 1 TO INC.
           IF KLV-NRG NOT = NREG
                      MOVE KLV-NRG TO NREG
                      ADD 1 TO INC.
           IF DTK NOT > UDK MOVE INC TO ULNR.
           IF DTK > ULDK MOVE DTK TO ULDK.
           MOVE INC TO LAV-NPRGI.
           REWRITE RF-LAV INVALID MOVE 'RWR.LAV' TO MESS
                                            GO TO ERRIO.
           MOVE 1 TO FLMOV.
           GO TO RDLAV.
       FNNU.
           IF FLMOV = ZERO MOVE 'Nessun Movimento' TO F-MES1
                           MOVE 1 TO F-NMES
                           MOVE 1 TO FLGERR
                           GO TO EX-RUN-ELABORA.
       RUN-RIENTRO.
           MOVE ULDK TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO ULDT.
           IF FLMOV = ZERO GO TO EX-RUN-ELABORA.

           MOVE ULNR TO ZULNR.
           MOVE ULDT TO ZULDT.
           STRING 'Ultimo protocollo assegnato: ' ZULNR
                  DELIMITED SIZE INTO F-MES1.
           STRING 'Data ultimo movimento acquisti: ' ZULDT
                  DELIMITED SIZE INTO F-MES2.
           MOVE 'Lista di Controllo ?' TO F-MES3.
           MOVE 3 TO F-NMES.
           GO TO QUESTION.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       NUMERA.
           IF FLMOV = 1
              PERFORM B00-AGG-MOV THRU B99.
           IF IF-CATT = '0' GO TO AGGAZ.
           MOVE 35 TO T35-TIP.
           MOVE KAZ-COD TO T35-CDAZ.
           MOVE IF-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
       AGCAT.
           READ TABELL INTO REKT35 KEPT LOCK INVALID PERFORM INVK-TAB 
                                                     GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' GO TO AGCAT.
           MOVE INC TO T35-RANRG.
           MOVE ULNR TO T35-UNR.
           MOVE UDK  TO T35-DTR.
           REWRITE RF-TAB FROM REKT35 INVALID PERFORM INVK-TAB 
                                              GO TO ERRIO.
           UNLOCK TABELL.
           IF NOT ( IF-FL = 1 AND T25ESE = 1 ) GO TO EX-NUMERA.
           CLOSE TABELL.
           MOVE 'tabold' TO ID-TAB.
           OPEN I-O TABELL.
           MOVE 35 TO T35-TIP.
           MOVE KAZ-COD TO T35-CDAZ.
           MOVE IF-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
       AGCA1.
           READ TABELL INTO REKT35 KEPT LOCK INVALID PERFORM INVK-TAB 
                                                     GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' GO TO AGCA1.
           MOVE INC TO T35-RANRG.
           MOVE ULNR TO T35-UNR.
           MOVE UDK  TO T35-DTR.
           REWRITE RF-TAB FROM REKT35 INVALID PERFORM INVK-TAB 
                                              GO TO ERRIO.
           UNLOCK TABELL.
           CLOSE TABELL.
           MOVE 'tabell' TO ID-TAB.
           OPEN I-O TABELL.
           GO TO EX-NUMERA.  
       AGGAZ.
           OPEN I-O ANAAZI.
       AGGAZ1.
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID
                            PERFORM INVK-AZI 
                            CLOSE ANAAZI GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' GO TO AGGAZ1.
           MOVE INC TO AZI-RANRG.
           REWRITE RF-AZI FROM REKAZI INVALID PERFORM INVK-AZI
                                              GO TO ERRIO.
           UNLOCK ANAAZI.
           CLOSE ANAAZI.
           MOVE 25 TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '1' TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
       AGCAT0.
           READ TABELL INTO REKT25 KEPT LOCK INVALID
                            PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' GO TO AGCAT0.
           MOVE ULNR TO T25-UNR.
           MOVE UDK  TO T25-DTR.
           REWRITE RF-TAB FROM REKT25 INVALID 
                            PERFORM INVK-TAB GO TO ERRIO.
           UNLOCK TABELL.
           IF NOT ( IF-FL = 1 AND T25ESE = 1 ) GO TO EX-NUMERA.  
           MOVE 'anaazi' TO ID-AZI.
           OPEN I-O ANAAZI.
       AGGAZ2.
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID
                            PERFORM INVK-AZI 
                            CLOSE ANAAZI GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' GO TO AGGAZ2.
           MOVE INC TO AZI-RANRG.
           REWRITE RF-AZI FROM REKAZI INVALID PERFORM INVK-AZI
                                              GO TO ERRIO.
           UNLOCK ANAAZI.
           CLOSE ANAAZI.
           MOVE 'anazol' TO ID-AZI.
           CLOSE TABELL.
           MOVE 'tabold' TO ID-TAB.
           OPEN I-O TABELL.
           MOVE 25 TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '1' TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
       AGCA20.
           READ TABELL INTO REKT25 KEPT LOCK INVALID PERFORM INVK-TAB
                                                     GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' GO TO AGCA20.
           MOVE ULNR TO T25-UNR.
           MOVE UDK  TO T25-DTR.
           REWRITE RF-TAB FROM REKT25 INVALID PERFORM INVK-TAB
                                              GO TO ERRIO.
           UNLOCK TABELL.
           CLOSE TABELL.
           MOVE 'tabell' TO ID-TAB.
           OPEN I-O TABELL.
       EX-NUMERA.
           EXIT.
      *------------------
       STAMPA-CNT.   
           COPY 'grirpt-s'.
      *
           MOVE ZERO TO COMCOD COMNPRGI SW.
           MOVE ZERO TO DTCOM COMCAU.
           MOVE ZERO TO COMIMP COMIMPO COMIVN COMIVA.
           MOVE ZERO TO XCRR NPAG.

      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 58      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'ELENCO FATTURE FORNITORI'
                  DELIMITED SIZE INTO RP-TIT1.
      *
           MOVE DESCS3 TO RP-TIT2.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG1-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID GO TO ENDB.
       LOPL.
           READ WDSLAV NEXT AT END GO TO ENDB.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO LOPL.
           IF KLV-CON NOT = CIVAQ GO TO LOPL.
           IF DTCOM = ZERO MOVE KLV-DAT TO DTCOM.
           IF COMNPRGI = ZERO MOVE LAV-NPRGI TO COMNPRGI.
           IF DTCOM NOT = KLV-DAT MOVE ZERO TO COMNPRGI
                          MOVE KLV-DAT TO DTCOM.
           IF COMNPRGI = LAV-NPRGI
              IF (COMCOD = ZERO OR COMCOD = LAV-PART)
                 AND (COMCAU = ZERO OR COMCAU = LAV-CAUS)
                                             GO TO LOPL0.
      
           MOVE 2 TO SW GO TO RLIB2.
       LOPL-0.
           MOVE LAV-NPRGI TO COMNPRGI.
           MOVE ZERO TO COMCOD COMIVA TOTIMP COMCAU.
       LOPL0.
           PERFORM RLIB THRU EX-RLIB.
      *
           COPY 'grirpt-r'.
      *
           GO TO LOPL.
       ENDB.
           MOVE 1 TO SW PERFORM RLIB2 THRU EX-RLIB.
      *
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       A99.
       EX-STAMPA-CNT.  
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       RLIB.
           IF LAV-CAUS = COMCAU GO TO RLIB0.
           MOVE LAV-CAUS TO COMCAU.
           MOVE 2 TO KTB-TIP.
           MOVE LAV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                             MOVE ZERO TO REKTAB.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T02-TIPOP TO TIPOP.
           MOVE T02-SEGNO TO SEGNO.
           IF LAV-FLAG = 1 GO TO EX-RLIB.
       RLIB0.
           IF LAV-PART = COMCOD GO TO RLIB1.
           MOVE LAV-PART TO KCF-COD COMCOD.
           MOVE 1 TO XCRR.
           MOVE KLV-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO RG1.
           MOVE KAZ-COD TO KCF-AZI.
           READ ANACLF INVALID KEY
               MOVE 'INES.' TO CLF-RGS.
           MOVE LAV-NPRGI TO RV2.
           MOVE CLF-RGS TO RV3.
           MOVE LAV-NDOC TO RV4.
           MOVE LAV-DTDOC TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO RV5.
       RLIB1.
           IF NOT ( T02-SEGNO = 1 OR T02-TIPOP = 8 ) 
                                   MOVE SPACE TO RV9.
           IF SEGNO = 1 MOVE 'STORNO CONTABILE' TO RV9.
           IF TIPOP = 8 MOVE 'VARIAZIONE ART. 26' TO RV9.
           IF COMIVA NOT = ZERO GO TO RLIB1-00.
           IF TIPOP = 8 MULTIPLY -1 BY LAV-IMPO                        
              IF LAV-TIP = 4 MULTIPLY -1 BY LAV-IML                    
                             MULTIPLY -1 BY LAV-INL                    
                             ELSE MULTIPLY -1 BY LAV-IMP               
                                  MULTIPLY -1 BY LAV-IVN.
           MOVE LAV-IVA  TO COMIVA.
           MOVE LAV-IMPO TO COMIMPO.
           IF LAV-TIP = 4 MOVE LAV-IML TO COMIMP                       
                          MOVE LAV-INL TO COMIVN                       
                          ELSE MOVE LAV-IMP  TO COMIMP                 
                               MOVE LAV-IVN  TO COMIVN.
           GO TO EX-RLIB.
       RLIB1-00.
           IF NOT (COMIVA = LAV-IVA) GO TO RLIB2.
           IF TIPOP = 8 MULTIPLY -1 BY LAV-IMPO                        
              IF LAV-TIP = 4 MULTIPLY -1 BY LAV-IML                    
                             MULTIPLY -1 BY LAV-INL                    
                             ELSE MULTIPLY -1 BY LAV-IMP               
                                  MULTIPLY -1 BY LAV-IVN.
           ADD LAV-IMPO TO COMIMPO.
           IF LAV-TIP = 4 ADD LAV-IML TO COMIMP                        
                          ADD LAV-INL TO COMIVN                        
                          ELSE ADD LAV-IMP  TO COMIMP                  
                               ADD LAV-IVN  TO COMIVN.
           GO TO EX-RLIB.
       RLIB2.
           MOVE COMIMP TO RV6.
           ADD COMIMP TO TOTIMP.
           MOVE 3 TO KTB-TIP.
           MOVE COMIVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                            MOVE ZERO TO REKTAB
                            MOVE SPACE TO T03-DSIVA.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
       CARV1.
           MOVE T03-DSIVA TO RV7.
           MOVE COMIMPO TO RV8.
           IF T03-TPIVA = ZERO GO TO STAMS.
           MOVE 'IVA INDETRAIBILE' TO RV9.
           IF T03-TPIVA = 1 GO TO STAMQ.
           MOVE TAB-DESCR TO RV9.
           IF T03-TPIVA < 7 GO TO STAMS.
           MOVE SPACE TO RV9.
           MOVE COMIMP TO CLAV.
      **** rel 6.2
      *    COMPUTE CLV1 = CLAV / 2.
           IF T03-PERIVA = ZERO MOVE 50 TO T03-PERIVA.
           COMPUTE CLV1 = CLAV * T03-PERIVA / 100.
      ************
           COMPUTE CLV2 = CLAV - CLV1.
           MOVE CLV2 TO RV6.
           MOVE COMIMPO TO RV8.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE CLV1 TO RV6.
       STAMQ.
           MOVE COMIVN TO RV8.
           MOVE T03-DSIVA TO RV7.
           MOVE 'IVA INDETRAIBILE' TO RV9.
       STAMS.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ZERO TO COMIMP COMIMPO COMIVN COMIVA.
           IF SW = 1 GO TO EX-RLIB.
           IF SW = 2 MOVE ZERO TO SW GO TO LOPL-0 
           ELSE GO TO RLIB0.
       EX-RLIB.
           EXIT.
      *--------------*
       B00-AGG-MOV.
           MOVE ZERO TO KEYLV KLV-DAT KLV-NUM KLV-CON.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO B99.
       B10.
           READ WDSLAV NEXT AT END GO TO B99.
           MOVE REKLAV TO REKMOV.
           IF KLV-TIP = 1 GO TO B20.
           REWRITE RF-MSZ FROM REKMOV INVALID
                          PERFORM INVK-MSZ GO TO ERRIO. 
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MSZ.
      ************
           GO TO B10.
       B20.
           REWRITE RF-MOV FROM REKMOV INVALID
                          PERFORM INVK-MOV GO TO ERRIO. 
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOV.
      ************
           GO TO B10.
       B99.
           EXIT.
      *--------------*
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'Data' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Progr.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Ragione Sociale' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'N.Doc' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Data' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Imponibile' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Aliq.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Imposta' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Note' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
      **** rel 7.1
       CALL-VSRV133-MOV.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'MOV'   TO PPAR-TARC.
           MOVE KEYMV   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           IF ID-MOV = 'movime' MOVE '0' TO PPAR-OPZ(81:1).
           IF ID-MOV = 'movmol' MOVE '1' TO PPAR-OPZ(81:1).
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 MOV. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *
       CALL-VSRV133-MSZ.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'MSZ'   TO PPAR-TARC.
           MOVE KEYMS   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           IF ID-MSZ = 'movsez' MOVE '0' TO PPAR-OPZ(81:1).
           IF ID-MSZ = 'movsol' MOVE '1' TO PPAR-OPZ(81:1).
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 MSZ. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      ************
