       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON370.
      *
      * Prospetto bilancio
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'grimovsl'.
           COPY 'grimvxsl'.
           COPY 'gritabsl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
       DATA DIVISION.
       FILE SECTION.
       COPY 'griazi'.
       COPY 'gritab'.
       COPY 'gricon'.
       COPY 'grimov'.
       COPY 'grimvx'.
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 110 DATA RECORD RF-LAV.
       01  RF-LAV.
           02 KEYLV.
              05 KLV-B1  PIC 9.
              05 KLV-PRO PIC 99.
              05 KLV-CON PIC 9(7).
           02 LAV-DESCR PIC X(40).
           02 LAV-APERT PIC S9(13)V99.
           02 LAV-INCRE PIC S9(13)V99.
           02 LAV-DECRE PIC S9(13)V99.
           02 LAV-SALDO PIC S9(13)V99.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
       COPY 'griconrk'.
       COPY 'gritabrk'.
       COPY 'grit20rk'.
       COPY 'grit26rk'.
       COPY 'grimovrk'.
       COPY 'parcdt'.
       COPY 'parzf'.
       01  ID-AZI   PIC X(15) VALUE 'anaazi'.
       01  ID-TAB   PIC X(15) VALUE 'tabell'.  
       01  ID-CON   PIC X(15) VALUE 'anacon'.
       01  ID-MOV   PIC X(15) VALUE 'movime'.
       01  ID-LAV   PIC X(15) VALUE 'wdslav'.
       01  ID-MVX   PIC X(15) VALUE 'movmxx'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-CON   PIC XX.
           05 SF-MOV   PIC XX.
           05 SF-LAV   PIC XX.
           05 SF-MVX   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
       01  AREE.
           05 BIL1     PIC 9.
           05 PRO1     PIC 99.
           05 APERT    PIC S9(13)V99 VALUE ZERO.
           05 INCRE    PIC S9(13)V99 VALUE ZERO.
           05 DECRE    PIC S9(13)V99 VALUE ZERO.
           05 SALDO    PIC S9(13)V99 VALUE ZERO.
           05 LAVTE    PIC S9(13)V99 VALUE ZERO.
           05 COMIN    PIC S9(13)V99 VALUE ZERO.
           05 COMDE    PIC S9(13)V99 VALUE ZERO.
           05 COMSA    PIC S9(13)V99 VALUE ZERO.
           05 BILAN    PIC S9(13)V99 VALUE ZERO.
           05 PROPE    PIC S9(13)V99 VALUE ZERO.
           05 DIFFE    PIC S9(13)V99 VALUE ZERO.
           05 SBILA    PIC 9      VALUE ZERO.
           05 UTPEP    PIC 9      VALUE ZERO.
           05 UTPEE    PIC 9      VALUE ZERO.
           05 SW       PIC 9      VALUE ZERO.

           COPY 'vcon370.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-TPSTA     PIC 9.
           05 IF-DTSTA     PIC 9(6).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcon'.
           COPY 'dclmov'.
           COPY 'dclmvx'.
           COPY 'dcltab'.
           COPY 'dcllav'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon370: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI TABELL ANACON MOVIME MOVMXX WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griconer'.
           COPY 'grimover'.
           COPY 'grimvxer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'tabell' TO ID-TAB
                           MOVE 'anacon' TO ID-CON
                           MOVE 'movime' TO ID-MOV
                           MOVE 'movmxx' TO ID-MVX.
           IF IF-FL = 1    MOVE 'anazol' TO ID-AZI
                           MOVE 'tabold' TO ID-TAB
                           MOVE 'anacol' TO ID-CON
                           MOVE 'movmol' TO ID-MOV
                           MOVE 'movoxx' TO ID-MVX.
           OPEN INPUT ANAAZI TABELL ANACON MOVIME MOVMXX.
           OPEN I-O WDSLAV.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID KEY PERFORM INVK-AZI GO TO ERRIO.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DTSTA.
           MOVE ZERO   TO IF-TPSTA.
           MOVE AZRGSOC TO IF-AZI-D.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DTSTA.
           MOVE 'IF-DTSTA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTSTA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTSTA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTSTA.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           COPY 'grirpt-sn' REPLACING 1 BY 2
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           MOVE AZRGSOC TO TAZI.
      *
           MOVE IF-DTSTA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO TDAT.

      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'PROSPETTO DI BILANCIO '  TDAT
                  DELIMITED SIZE INTO RP-TIT1.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG1-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID GO TO L110.
       L100.
           READ WDSLAV NEXT AT END GO TO L110.
           IF SF-LAV = '9D' OR '9A' GO TO L100.
           DELETE WDSLAV.
           GO TO L100.
       L110.
           MOVE ZERO TO LAVTE BILAN PROPE.
           MOVE ZERO TO SW.
           MOVE LOW-VALUE TO KEYPC.
           MOVE KAZ-COD TO KPC-AZI.
           START ANACON KEY NOT < KEYPC INVALID GO TO L200.
       L120.
           READ ANACON NEXT INTO REKCON AT END GO TO L200. 
           IF SF-CON = '9D' OR '9A' GO TO L120.
           IF KPC-AZI > KAZ-COD GO TO L200.
           IF ( CON-BIL1 = ZERO OR 2 OR 4 OR > 6 ) OR
              CON-PRO1 = ZERO GO TO L120.
           IF KPC-COD = T20-COUTI OR
              KPC-COD = T20-COPER GO TO L120.
      *
           COPY 'grirpt-r' REPLACING 1 BY 2
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           MOVE 1 TO SW.
           MOVE ZERO TO INCRE DECRE.
           MOVE CON-SESP TO APERT.
           IF CON-BIL1 = 1 OR 3 MOVE CON-SE-D TO INCRE
                                MOVE CON-SE-A TO DECRE.
           COMPUTE SALDO = CON-SESP + CON-SE-D - CON-SE-A.
           PERFORM F00-CALC-SALDO THRU F99.
           IF CON-TPCOP = 1 ADD SALDO TO LAVTE.
           IF CON-BIL1 > 4 MOVE CON-BIL1 TO KLV-B1
                           MOVE CON-PRO1 TO KLV-PRO
                           ADD SALDO TO PROPE
                           PERFORM A00-AGG-LAV THRU A99
                           GO TO L120.
           ADD SALDO TO BILAN.
           MOVE CON-BIL1 TO KLV-B1.
           MOVE CON-PRO1 TO KLV-PRO.
           IF CON-BIL1 NOT = 1 GO TO L130.
           IF APERT NOT < ZERO AND SALDO NOT < ZERO
                          PERFORM A00-AGG-LAV THRU A99
                          GO TO L120.
           IF CON-PRO2 = ZERO PERFORM A00-AGG-LAV THRU A99
                         GO TO L120.
           IF APERT NOT > ZERO AND SALDO NOT > ZERO 
                          MOVE CON-BIL5 TO KLV-B1
                          MOVE CON-PRO2 TO KLV-PRO
                          PERFORM A00-AGG-LAV THRU A99
                          GO TO L120.
           IF APERT < ZERO AND SALDO > ZERO 
                          MOVE DECRE TO COMDE
                          MOVE SALDO TO COMSA
                          COMPUTE COMIN = INCRE + APERT
                          COMPUTE INCRE = INCRE - COMIN
                          MOVE ZERO TO DECRE SALDO
                          MOVE CON-BIL5 TO KLV-B1
                          MOVE CON-PRO2 TO KLV-PRO
                          PERFORM A00-AGG-LAV THRU A99
                          MOVE COMDE TO DECRE
                          MOVE COMSA TO SALDO
                          MOVE COMIN TO INCRE
                          MOVE ZERO TO APERT
                          MOVE CON-BIL1 TO KLV-B1
                          MOVE CON-PRO1 TO KLV-PRO
                          PERFORM A00-AGG-LAV THRU A99
                          GO TO L120.
           IF APERT > ZERO AND SALDO < ZERO 
                          MOVE APERT TO COMSA
                          COMPUTE DECRE = DECRE - APERT
                          MOVE ZERO TO APERT
                          MOVE CON-BIL5 TO KLV-B1
                          MOVE CON-PRO2 TO KLV-PRO
                          PERFORM A00-AGG-LAV THRU A99
                          MOVE COMSA TO APERT DECRE
                          MOVE ZERO TO SALDO INCRE
                          MOVE CON-BIL1 TO KLV-B1
                          MOVE CON-PRO1 TO KLV-PRO
                          PERFORM A00-AGG-LAV THRU A99
                          GO TO L120.
       L130.
           IF CON-BIL1 NOT = 3 GO TO L120.
           IF APERT NOT > ZERO AND SALDO NOT > ZERO
                          PERFORM A00-AGG-LAV THRU A99
                          GO TO L120.
           IF CON-PRO2 = ZERO PERFORM A00-AGG-LAV THRU A99
                         GO TO L120.
           IF APERT NOT < ZERO AND SALDO NOT < ZERO 
                          MOVE CON-BIL5 TO KLV-B1
                          MOVE CON-PRO2 TO KLV-PRO
                          PERFORM A00-AGG-LAV THRU A99
                          GO TO L120.
           IF APERT > ZERO AND SALDO < ZERO 
                          MOVE INCRE TO COMIN
                          MOVE DECRE TO COMDE
                          MOVE SALDO TO COMSA
                          MOVE APERT TO DECRE
                          MOVE ZERO TO INCRE SALDO
                          MOVE CON-BIL5 TO KLV-B1
                          MOVE CON-PRO2 TO KLV-PRO
                          PERFORM A00-AGG-LAV THRU A99
                          MOVE COMDE TO DECRE
                          MOVE COMSA TO SALDO
                          MOVE COMIN TO INCRE
                          COMPUTE DECRE = DECRE - APERT
                          MOVE ZERO TO APERT
                          MOVE CON-BIL1 TO KLV-B1
                          MOVE CON-PRO1 TO KLV-PRO
                          PERFORM A00-AGG-LAV THRU A99
                          GO TO L120.
           IF APERT < ZERO AND SALDO > ZERO 
                          MOVE INCRE TO COMIN
                          MOVE APERT TO COMSA
                          MOVE DECRE TO COMDE.
                          COMPUTE INCRE = INCRE + APERT
                          MOVE ZERO TO APERT
                          MOVE CON-BIL5 TO KLV-B1
                          MOVE CON-PRO2 TO KLV-PRO
                          PERFORM A00-AGG-LAV THRU A99
                          MOVE COMSA TO APERT INCRE
                          MULTIPLY -1 BY INCRE
                          MOVE ZERO TO SALDO DECRE
                          MOVE CON-BIL1 TO KLV-B1
                          MOVE CON-PRO1 TO KLV-PRO
                          PERFORM A00-AGG-LAV THRU A99
                          GO TO L120.
       L200.
           MOVE ZERO TO SBILA UTPEP UTPEE.
           COMPUTE DIFFE = BILAN + PROPE.
           IF DIFFE NOT = ZERO MOVE 1 TO SBILA
                          ELSE MOVE ZERO TO SBILA. 
           IF BILAN < ZERO MOVE 1 TO UTPEP
                           MULTIPLY -1 BY BILAN
                           ELSE MOVE ZERO TO UTPEP.
           IF PROPE > ZERO MOVE 1 TO UTPEE
                           ELSE MOVE ZERO TO UTPEE.
           IF PROPE < ZERO MULTIPLY -1 BY PROPE.


           IF SW = ZERO MOVE 'Nessun dato' TO MESS
                        MOVE 8 TO ERRIO-ST
                        GO TO EX-RUN-ELABORA.

           MOVE 1 TO BIL1.
           MOVE ZERO TO PRO1 APERT INCRE DECRE SALDO XCRR NPAG.
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID GO TO L300.
       L210.
           READ WDSLAV NEXT AT END GO TO L300. 
           IF SF-LAV = '9D' OR '9A' GO TO L210.
           IF KLV-B1 NOT = BIL1 PERFORM B00-CAM-INT THRU B99.
           IF IF-TPSTA = 1 GO TO L220.
           MOVE 26 TO T26-TIP.
           MOVE KLV-PRO TO T26-COD PVOC.
           MOVE T26-KEYID TO KEYTB.
           READ TABELL INTO REKT26 INVALID MOVE ALL '*' TO T26-DESCR.
           MOVE T26-DESCR TO PDES.
           IF KLV-B1 = 1 OR 3 MOVE LAV-APERT TO PAPE
                              IF T26-TEST = 1 MOVE LAV-INCRE TO PINC
                                              MOVE LAV-DECRE TO PDEC.
           MOVE LAV-SALDO TO PSAL.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           GO TO L210.
       L220.
           IF KLV-PRO NOT = PRO1 PERFORM C00-CAM-VOC THRU C99.
           MOVE LAV-DESCR TO PDES.
           IF KLV-B1 = 1 OR 3 MOVE LAV-APERT TO PAPE
                              ADD  LAV-APERT TO APERT
                              IF T26-TEST = 1 MOVE LAV-INCRE TO PINC
                                              ADD LAV-INCRE TO INCRE
                                              ADD LAV-DECRE TO DECRE
                                              MOVE LAV-DECRE TO PDEC.
           MOVE LAV-SALDO TO PSAL.
           ADD  LAV-SALDO TO SALDO.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
      *
           COPY 'grirpt-r'.
      *
           GO TO L210.
       L300.
           IF IF-TPSTA = ZERO GO TO L310.
           MOVE ALL '-' TO R4SOTT2.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
           IF BIL1 = 1 OR 3 MOVE APERT TO P2APE
                              IF T26-TEST = 1 MOVE INCRE TO P2INC
                                              MOVE DECRE TO P2DEC.
           MOVE SALDO TO P2SAL.
           MOVE ZERO TO APERT INCRE DECRE SALDO PRO1.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ALL '=' TO R4SOTT2.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
       L310.
           IF BIL1 = 1 AND UTPEP = 1
                       MOVE ALL '*' TO R3SOTT1 R3SOTT2 R3SOTT3
                       MOVE ' P E R D I T A ' TO P3DES
                       MOVE BILAN TO P3SAL
                       MOVE 2 TO XCRR
                       MOVE 'RIG3' TO RP-BLK
                       PERFORM RPT-WR.
           IF BIL1 = 3 AND UTPEP = ZERO
                       MOVE ALL '*' TO R3SOTT1 R3SOTT2 R3SOTT3
                       MOVE ' U T I L E     ' TO P3DES
                       MOVE BILAN TO P3SAL
                       MOVE 2 TO XCRR
                       MOVE 'RIG3' TO RP-BLK
                       PERFORM RPT-WR.
           IF BIL1 = 6 AND UTPEE = ZERO
                       MOVE ALL '*' TO R3SOTT1 R3SOTT2 R3SOTT3
                       MOVE ' U T I L E     ' TO P3DES
                       MOVE PROPE TO P3SAL
                       MOVE 2 TO XCRR
                       MOVE 'RIG3' TO RP-BLK
                       PERFORM RPT-WR.
           IF BIL1 = 7 AND UTPEE = 1
                       MOVE ALL '*' TO R3SOTT1 R3SOTT2 R3SOTT3
                       MOVE ' P E R D I T A ' TO P3DES
                       MOVE PROPE TO P3SAL
                       MOVE 2 TO XCRR
                       MOVE 'RIG3' TO RP-BLK
                       PERFORM RPT-WR.
           IF LAVTE NOT = ZERO MOVE 2 TO XCRR
                          MOVE ' LAVORAZIONE PRESSO TERZI' TO P3DES
                          MOVE LAVTE TO P3SAL
                          MOVE 'RIG3' TO RP-BLK
                          PERFORM RPT-WR.
           IF SBILA NOT = ZERO MOVE 2 TO XCRR
                          MOVE ALL '*' TO R3SOTT1 R3SOTT2 R3SOTT3
                          MOVE ' S B I L A N C I O ' TO P3DES
                          MOVE DIFFE TO P3SAL
                          MOVE 'RIG3' TO RP-BLK
                          PERFORM RPT-WR.
      *
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       F00-CALC-SALDO.
           MOVE LOW-VALUE TO KEYMV.
           MOVE KPC-AZI   TO KMV-AZI.
           MOVE KPC-COD   TO KMV-CON.
           START MOVIME KEY NOT < KEYMV INVALID GO TO F20.
       F10.
           READ MOVIME NEXT INTO REKMOV AT END GO TO F20.
           IF SF-MOV = '9D' OR '9A' GO TO F10.
           IF KMV-AZI > KPC-AZI GO TO F20.
           IF KMV-CON > KPC-COD GO TO F20.
           IF NOT ( MOV-CAUS = T20-CDSOC OR 
                    MOV-CAUS = T20-CASOC OR
                    MOV-CAUS = T20-CDSOA OR
                    MOV-CAUS = T20-CASOA ) GO TO F10.
           IF CON-BIL1 > 4 AND
             ( MOV-CAUS = T20-CDSOA OR T20-CASOA ) GO TO F10.
           IF MOV-CAUS = T20-CDSOC OR T20-CASOC GO TO F15.
           IF MOV-D-A = 'D' ADD MOV-IMPO TO APERT
                            SUBTRACT MOV-IMPO FROM INCRE.
           IF MOV-D-A = 'A' SUBTRACT MOV-IMPO FROM APERT DECRE.
           GO TO F10.
       F15.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO SALDO 
           ELSE SUBTRACT MOV-IMPO FROM SALDO.
           GO TO F10.
       F20.
           MOVE LOW-VALUE TO KEYMX.
           MOVE KPC-AZI   TO KMX-AZI.
           MOVE KPC-COD   TO KMX-CON.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO F99.
       F30.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO F99.
           IF SF-MVX = '9D' OR '9A' GO TO F30.
           IF KMX-AZI > KPC-AZI GO TO F99.
           IF KMX-CON > KPC-COD GO TO F99.
           IF NOT ( MOV-CAUS = T20-CDSOC OR 
                    MOV-CAUS = T20-CASOC ) GO TO F30.
           IF MOV-D-A = 'A' ADD MOV-IMPO TO SALDO 
           ELSE SUBTRACT MOV-IMPO FROM SALDO.
           GO TO F30.
       F99.      
            EXIT.
      *----------------------------------
       A00-AGG-LAV.
           IF KLV-B1 = 5 MOVE 7 TO KLV-B1
                         MULTIPLY -1 BY SALDO.
           IF KLV-B1 = 3 MULTIPLY -1 BY APERT SALDO.
           IF IF-TPSTA = ZERO MOVE ZERO TO KPC-COD
                           MOVE SPACE TO CON-DESCR.
           MOVE KPC-COD TO KLV-CON.
           READ WDSLAV INVALID GO TO A10.
           ADD APERT TO LAV-APERT.
           IF KLV-B1 = 3 ADD DECRE TO LAV-INCRE
                         ADD INCRE TO LAV-DECRE.
           IF KLV-B1 = 1 ADD INCRE TO LAV-INCRE 
                         ADD DECRE TO LAV-DECRE.
           ADD SALDO TO LAV-SALDO.
           REWRITE RF-LAV INVALID MOVE 'WR LAV' TO MESS GO TO ERRIO.
           GO TO A99.
       A10.
           MOVE ZERO TO LAV-APERT LAV-INCRE LAV-DECRE LAV-SALDO.
           MOVE APERT TO LAV-APERT.
           IF KLV-B1 = 3 MOVE DECRE TO LAV-INCRE
                         MOVE INCRE TO LAV-DECRE.
           IF KLV-B1 = 1 MOVE INCRE TO LAV-INCRE 
                         MOVE DECRE TO LAV-DECRE.
           MOVE CON-DESCR TO LAV-DESCR.
           MOVE SALDO TO LAV-SALDO.
           WRITE RF-LAV INVALID MOVE 'WR LAV' TO MESS GO TO ERRIO.
       A99.
           EXIT. 
      *----------------------------------
       B00-CAM-INT.
           IF IF-TPSTA = ZERO GO TO B10.
           MOVE ALL '-' TO R4SOTT2.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
           IF BIL1 = 1 OR 3 MOVE APERT TO P2APE
                              IF T26-TEST = 1 MOVE INCRE TO P2INC
                                              MOVE DECRE TO P2DEC.
           MOVE SALDO TO P2SAL.
           MOVE ZERO TO APERT INCRE DECRE SALDO PRO1.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE ALL '=' TO R4SOTT2.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
       B10.
           IF KLV-B1 NOT = 3  GO TO B20.
           IF BIL1 = 1 AND UTPEP = 1 MOVE ALL '*' TO R3SOTT1 
                                                     R3SOTT2 
                                                     R3SOTT3
                                     MOVE 2 TO XCRR
                                     MOVE 'P E R D I T A' TO P3DES
                                     MOVE BILAN TO P3SAL
                                     MOVE 'RIG3' TO RP-BLK
                                     PERFORM RPT-WR.
           MOVE 2 TO XCRR.
       B20.
           IF KLV-B1 NOT = 6  GO TO B30.
           IF BIL1 = 3 AND UTPEP = ZERO MOVE ALL '*' TO R3SOTT1 
                                                        R3SOTT2 
                                                        R3SOTT3
                                     MOVE 2 TO XCRR
                                     MOVE ' U T I L E ' TO P3DES
                                     MOVE BILAN TO P3SAL 
                                     MOVE 'RIG3' TO RP-BLK
                                     PERFORM RPT-WR.
           MOVE ALL '=' TO P999.
           MOVE 2 TO XCRR.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG5' TO RP-BLK
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           MOVE ' P E R D I T E ' TO PDES.
      *
           MOVE 'RIG1' TO RP-BLK
           PERFORM RPT-WR.
      *
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG5' TO RP-BLK
           PERFORM RPT-WR.
      *
       B30.
           IF KLV-B1 NOT = 7 GO TO B40.
           IF BIL1 = 6 AND UTPEE = ZERO MOVE ALL '*' TO R3SOTT1 
                                                        R3SOTT2 
                                                        R3SOTT3
                                     MOVE 2 TO XCRR
                                     MOVE ' U T I L E ' TO P3DES
                                     MOVE PROPE TO P3SAL
                                     MOVE 'RIG3' TO RP-BLK
                                     PERFORM RPT-WR.
           MOVE ALL '=' TO P999.
           MOVE 2 TO XCRR.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG5' TO RP-BLK
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           MOVE ' P R O F I T T I ' TO PDES.
      *
           MOVE 'RIG1' TO RP-BLK
           PERFORM RPT-WR.
      *
           MOVE ALL '-' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG5' TO RP-BLK
           PERFORM RPT-WR.
      *
       B40.
           MOVE KLV-B1 TO BIL1.
       B99.
           EXIT.
      *----------------------------------
       C00-CAM-VOC.
           IF PRO1 = ZERO GO TO C10.
           MOVE ALL '-' TO R4SOTT2.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
           IF KLV-B1 = 1 OR 3 MOVE APERT TO P2APE
                              IF T26-TEST = 1 MOVE INCRE TO P2INC
                                              MOVE DECRE TO P2DEC.
           MOVE SALDO TO P2SAL.
           MOVE ZERO TO APERT INCRE DECRE SALDO.
      *
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
           MOVE ALL '=' TO R4SOTT2.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 2 TO XCRR.
       C10.
           MOVE KLV-PRO TO PRO1.
           MOVE 26 TO T26-TIP.
           MOVE KLV-PRO TO T26-COD PVOC.
           MOVE T26-KEYID TO KEYTB.
           READ TABELL INTO REKT26 INVALID MOVE ALL '*' TO T26-DESCR.
           MOVE T26-DESCR TO PDES.
           MOVE 'RIG1' TO RP-BLK
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
       C99.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'Voce' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Saldo Iniziale' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Incrementi' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Decrementi' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Saldo Finale' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
