       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCONG40. 
      *
      *    Interfaccia FATSOS per scheda
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griftssl'.
           COPY 'griclfsl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'grifts'.
           COPY 'griclf'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'gritabrk'.
           COPY 'griclfrk'.
           COPY 'grit35rk'.
           COPY 'parzf'.
           COPY 'parcdt'.
      **** rel 4.0
           COPY 'parer'.
      ************
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-FTS PIC X(15) VALUE 'fatsos'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-FTS   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-CLF   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(50).
           05 IF-AZI   PIC 9(3).
           05 K        PIC 9.
           05 J        PIC 9.
      **** rel 4.0
      *    05 CIMPIVA  PIC S9(10).
           05 CIMPIVA  PIC S9(11)V99.
      ************
           05 SWIVA    PIC 9.
           05 CODCLI.
              10 MAS     PIC 99.
              10 COD     PIC 9(5).
      **** rel 4.0
           05 COM-ALIVA PIC 9(3)V99.
      ************
       LINKAGE SECTION.
           COPY 'griftsrg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-FTS-CTRL
                                RG-FTS-REC
                                RG-FTS-VETT
                                RA-FTS-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclfts'.
           COPY 'dclclf'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-FTS-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-FTS-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           IF (RG-FTS-FUN = 'N' OR 'n') AND
              (RG-FTS-EOF = 2 OR 3)     GO TO ESCI.
           IF (RG-FTS-FUN = 'P' OR 'p') AND
              (RG-FTS-EOF = 1 OR 2)     GO TO ESCI.
           MOVE RG-FTS-FUN   TO FUN.
           MOVE RG-FTS-IDX   TO IDX.
           MOVE RG-FTS-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-FTS-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'vcong40: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-FTS-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-FTS-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-FTS-ST = 7 GO TO FINE.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK FATSOS.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-FTS INVALID
              PERFORM INVK-FTS
              GO TO ERRIO.
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-FTS INVALID
              PERFORM INVK-FTS
              GO TO ERRIO.
           UNLOCK FATSOS.
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-FTS
              GO TO WARNING.
           IF RG-FTS-ST = 7 GO TO FINE.
           PERFORM DB-STORNA THRU EX-DB-STORNA.
           DELETE FATSOS INVALID
              PERFORM INVK-FTS
              GO TO ERRIO.
           UNLOCK FATSOS.
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-FTS-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK FATSOS.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-FTS-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI
                 ANACLF
                 TABELL
                 FATSOS.
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-FTS-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-FTS-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griftser'.
           COPY 'griclfer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           OPEN INPUT ANAAZI ANACLF.
           OPEN I-O TABELL FATSOS.
      *
           MOVE RG-FTS-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID
                PERFORM INVK-AZI
                GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MAS.
      *
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-FTS-EOF.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO TO RF-FTS.
           MOVE SPACE TO KFS-CATT.
           MOVE ZERO  TO FTS-DTDOC
                         FTS-ULPAG.
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              MOVE ZERO TO FTS-IMPON(K)
                           FTS-IMIVA(K)
                           FTS-CDIVA(K)
                           FTS-IMPAG(K)
                           FTS-IVPAG(K)
              ADD 1 TO K
           END-PERFORM.
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
           MOVE RG-FTS-AZI TO IF-AZI.

      * azzeramento aree interfaccia
           MOVE ZERO  TO RG-FTS-REC.
           MOVE SPACE TO RG-FTS-CATT.
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              MOVE ZERO TO RG-FTS-IMPON(K)
                           RG-FTS-IMIVA(K)
                           RG-FTS-CDIVA(K)
                           RG-FTS-ALIVA(K)
                           RG-FTS-IMPAG(K)
                           RG-FTS-IVPAG(K)
              ADD 1 TO K
           END-PERFORM.

           MOVE ZERO  TO RA-FTS-AGG.
           MOVE SPACE TO RA-FTS-CLI-D
                         RA-FTS-CATT-D.
           MOVE ZERO  TO RA-FTS-TIMPON
                         RA-FTS-TIMIVA
                         RA-FTS-TIMPAG
                         RA-FTS-TIVPAG.

      * ripristino dei campi chiave fissi
           MOVE IF-AZI TO RG-FTS-AZI.
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-FTS-AZI  TO KFS-AZI.
           MOVE RG-FTS-CLI  TO KFS-CLI.
           MOVE RG-FTS-ANNO TO KFS-ANNO.
           MOVE RG-FTS-CATT TO KFS-CATT.
           MOVE RG-FTS-NFAT TO KFS-NFAT.
           MOVE KEYFS TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYFS.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ FATSOS INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ FATSOS KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-FTS > ZERO MOVE 7 TO RG-FTS-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ FATSOS PREVIOUS AT END MOVE 1 TO EOF
           ELSE
              READ FATSOS NEXT AT END MOVE 3 TO EOF.
           IF EOF > ZERO GO TO RNP-80.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-FTS = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *


      * trovato record valido: reset EOF
           MOVE ZERO TO RG-FTS-EOF.
           MOVE KEYFS TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-FTS-EOF.
           IF RG-FTS-EOF = 4 MOVE 2 TO RG-FTS-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-FTS = LOW-VALUE GO TO EX-TEST-EOL.
           IF KFS-AZI = RG-FTS-AZI GO TO EX-TEST-EOL.
           IF FUN = 'P' OR 'p'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE RG-FTS-AZI       TO KFS-AZI.
           MOVE RG-FTS-CLI       TO KFS-CLI.
           MOVE RG-FTS-ANNO      TO KFS-ANNO.
           MOVE RG-FTS-CATT      TO KFS-CATT.
           MOVE RG-FTS-NFAT      TO KFS-NFAT.
           MOVE RG-FTS-NREG      TO FTS-NREG.
           MOVE RG-FTS-TDOC      TO FTS-TDOC.
           MOVE RG-FTS-ULIVA     TO FTS-ULIVA.
           MOVE RG-FTS-FLAG      TO FTS-FLAG.
      *    
           MOVE RG-FTS-DTDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO FTS-DTDOC.
      *    
           MOVE RG-FTS-ULPAG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO FTS-ULPAG.
      *    
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              MOVE RG-FTS-IMPON(K) TO FTS-IMPON(K)
              MOVE RG-FTS-IMIVA(K) TO FTS-IMIVA(K)
              MOVE RG-FTS-CDIVA(K) TO FTS-CDIVA(K)
              MOVE RG-FTS-IMPAG(K) TO FTS-IMPAG(K)
              MOVE RG-FTS-IVPAG(K) TO FTS-IVPAG(K)
              ADD 1 TO K
           END-PERFORM.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE KFS-AZI   TO RG-FTS-AZI.
           MOVE KFS-CLI   TO RG-FTS-CLI.
           MOVE KFS-ANNO  TO RG-FTS-ANNO.
           MOVE KFS-CATT  TO RG-FTS-CATT.
           MOVE KFS-NFAT  TO RG-FTS-NFAT.
           MOVE FTS-NREG  TO RG-FTS-NREG.
           MOVE FTS-TDOC  TO RG-FTS-TDOC.
           MOVE FTS-ULIVA TO RG-FTS-ULIVA.
           MOVE FTS-FLAG  TO RG-FTS-FLAG.
      *    
           MOVE FTS-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-FTS-DTDOC.
      *    
           MOVE FTS-ULPAG TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-FTS-ULPAG.
      *    
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              MOVE FTS-IMPON(K) TO RG-FTS-IMPON(K)
              MOVE FTS-IMIVA(K) TO RG-FTS-IMIVA(K)
              MOVE FTS-CDIVA(K) TO RG-FTS-CDIVA(K)
              MOVE FTS-IMPAG(K) TO RG-FTS-IMPAG(K)
              MOVE FTS-IVPAG(K) TO RG-FTS-IVPAG(K)
              ADD 1 TO K
           END-PERFORM.
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
           MOVE KFS-CLI TO COD.
           MOVE CODCLI  TO KCF-COD.
           MOVE KFS-AZI TO KCF-AZI.
           READ ANACLF INVALID MOVE ALL '*' TO CLF-RGS.
           MOVE CLF-RGS TO RA-FTS-CLI-D.
      *
           MOVE ZERO TO K.
       CARICA-RA-10.
           ADD 1 TO K.
           IF K > 6 GO TO CARICA-RA-20.
           IF FTS-CDIVA(K) = ZERO 
              MOVE ZERO TO RG-FTS-ALIVA(K)
              GO TO CARICA-RA-10.
           MOVE 3            TO KTB-TIP.
           MOVE FTS-CDIVA(K) TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ZERO TO T03-ALIVA.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-ALIVA TO RG-FTS-ALIVA(K).
           GO TO CARICA-RA-10.
       CARICA-RA-20.
           PERFORM CALC-TOTALI.
      *
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-FTS-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
      *
       V-CLI.
           MOVE 'FTS-CLI' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CLI.
           MOVE SPACE TO RA-FTS-CLI-D.
           IF RG-FTS-CLI = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE RG-FTS-CLI TO COD.
           MOVE CODCLI     TO KCF-COD.
           MOVE RG-FTS-AZI TO KCF-AZI.
           READ ANACLF INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           MOVE CLF-RGS TO RA-FTS-CLI-D.
       E-CLI.
      *
       V-ANNO.
           MOVE 'FTS-ANNO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ANNO.
           IF RG-FTS-ANNO = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           CALL 'ranno4' USING RG-FTS-ANNO.
       E-ANNO.
      *
       V-CATT.
           MOVE 'FTS-CATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CATT.
           IF RG-FTS-CATT = SPACE
              MOVE ZERO TO RG-FTS-CATT
              GO TO E-CATT.
           IF RG-FTS-CATT = ZERO
              GO TO E-CATT.
           MOVE 35          TO T35-TIP.
           MOVE RG-FTS-AZI  TO T35-CDAZ.
           MOVE RG-FTS-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
       E-CATT.
      *
       V-NFAT.
           MOVE 'FTS-NFAT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NFAT.
           IF RG-FTS-NFAT = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-NFAT.
      *
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-FTS-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
           MOVE ZERO TO SWIVA.
      *
       V-DTDOC.
           MOVE 'FTS-DTDOC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTDOC.
           IF RG-FTS-DTDOC = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE RG-FTS-DTDOC TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF AA4 NOT = RG-FTS-ANNO
              MOVE "Data diversa dall'anno di competenza" TO MESS
              GO TO V-ERROR.
       E-DTDOC.
      *
       V-TDOC.
           MOVE 'FTS-TDOC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TDOC.
           IF NOT (RG-FTS-TDOC = ZERO OR 1)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-TDOC.
      *
       V-ULPAG.
           MOVE 'FTS-ULPAG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ULPAG.
           IF RG-FTS-ULPAG = ZERO GO TO E-ULPAG.
           MOVE 1 TO TIPOP1.
           MOVE RG-FTS-ULPAG TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF RG-FTS-ULPAG < RG-FTS-DTDOC 
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-ULPAG.
      *
       V-FLAG.
           MOVE 'FTS-FLAG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLAG.
           IF RG-FTS-FLAG > 1
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-FLAG.
      *
       V-CDIVA.
           MOVE 'FTS-CDIVA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDIVA.
           MOVE ZERO TO K.
       V-CDIVA-10.
           ADD 1 TO K.
           IF K > 6 GO TO E-CDIVA.
           IF FUN = 'W'
              MOVE K TO RG-FTS-IDXVET
           ELSE
              IF K NOT = RG-FTS-IDXVET
                 GO TO V-CDIVA-10.
           MOVE ZERO TO RG-FTS-ALIVA(K).
           IF RG-FTS-CDIVA(K) = ZERO
              MOVE ZERO  TO RG-FTS-IMPON(K)
                            RG-FTS-IMIVA(K)
                            RG-FTS-ALIVA(K)
                            RG-FTS-IMPAG(K)
                            RG-FTS-IVPAG(K)
              GO TO V-CDIVA-10.
           MOVE RG-FTS-CDIVA(K) TO KTB-COD.
           MOVE 3               TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-ALIVA TO RG-FTS-ALIVA(K).
           IF FUN = 'W' GO TO E-CDIVA.
           PERFORM CALC-IMPOR-IMIVA.
           PERFORM CALC-IMPOR-IVPAG.
           GO TO V-CDIVA-10.
       E-CDIVA.
      *
       V-IMPON.
           MOVE 'FTS-IMPON' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IMPON.
           MOVE ZERO TO K.
       V-IMPON-10.
           ADD 1 TO K.
           IF K > 6 GO TO E-IMPON.
           IF FUN = 'W'
              MOVE K TO RG-FTS-IDXVET
           ELSE
              IF K NOT = RG-FTS-IDXVET
                 GO TO V-IMPON-10.
           IF RG-FTS-IMPON(K) = ZERO
              MOVE ZERO TO RG-FTS-IMIVA(K)
              IF RG-FTS-CDIVA(K) = ZERO
                 GO TO V-IMPON-10
              ELSE
                 PERFORM ERR-ZERO
                 GO TO V-ERROR.
           MOVE RG-FTS-CDIVA(K) TO KTB-COD.
           MOVE 3               TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ZERO TO RG-FTS-IMIVA(K)
                GO TO V-IMPON-10.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T03-TPIVA = 1 OR 7
              MOVE ZERO TO RG-FTS-IMIVA(K)
              GO TO V-IMPON-10.
           PERFORM CALC-IMPOR-IMIVA.
           GO TO V-IMPON-10.
       E-IMPON.
      *
       V-IMPAG.
           MOVE 'FTS-IMPAG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IMPAG.
           MOVE ZERO TO K.
       V-IMPAG-10.
           ADD 1 TO K.
           IF K > 6 GO TO E-IMPAG.
           IF FUN = 'W'
              MOVE K TO RG-FTS-IDXVET
           ELSE
              IF K NOT = RG-FTS-IDXVET
                 GO TO V-IMPAG-10.
      **** rel 7.2
           IF FUN = 'W'
              GO TO E-IMPAG.
      ************
           IF RG-FTS-IMPAG(K) = ZERO
              MOVE ZERO TO RG-FTS-IVPAG(K)
              GO TO V-IMPAG-10.
           MOVE RG-FTS-CDIVA(K) TO KTB-COD.
           MOVE 3               TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ZERO TO RG-FTS-IVPAG(K)
                GO TO V-IMPAG-10.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T03-TPIVA = 1 OR 7
              MOVE ZERO TO RG-FTS-IVPAG(K)
              GO TO V-IMPAG-10.
           PERFORM CALC-IMPOR-IVPAG.
           GO TO V-IMPAG-10.
       E-IMPAG.
      * esegue sempre
           PERFORM CALC-TOTALI.
      * esegue solo se valida tutto
           IF FUN NOT = 'W' GO TO V-END-RIGO.
      * compatta vettore
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              IF RG-FTS-CDIVA(K) = ZERO
                 MOVE K TO J
                 ADD 1 TO J
                 PERFORM UNTIL J > 6
                    IF RG-FTS-CDIVA(J) NOT = ZERO
                       MOVE RG-FTS-VETT(J) TO RG-FTS-VETT(K)
                       MOVE ZERO TO RG-FTS-VETT(J)
                       ADD 1 TO K
                    END-IF
                    ADD 1 TO J
                 END-PERFORM
                 MOVE 6 TO K
              END-IF
                 ADD 1 TO K
           END-PERFORM.
      *
           IF SWIVA = 1
              MOVE "L'importo IVA di uno o piu' righi"  TO F-MES1
              MOVE "e' diverso  da  quello  calcolato"  TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-WARNING.
      *
       V-END-RIGO.
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
       CALC-IMPOR-IMIVA.
      **** rel 4.0
      *    COMPUTE CIMPIVA =
      *            RG-FTS-IMPON(K) * RG-FTS-ALIVA(K) / 100 + 0,99.
           MOVE RG-FTS-IMPON(K) TO ER-IMPORTO.
           MOVE ZERO            TO ER-VALUT.
           MOVE RG-FTS-ALIVA(K) TO COM-ALIVA.
           CALL 're2iva' USING ER-IMPORTO ER-VALUT COM-ALIVA.
           MOVE ER-IMPORTO      TO CIMPIVA.
      ************
           IF FUN = 'W' AND CIMPIVA NOT = RG-FTS-IMIVA(K)
              MOVE 1 TO SWIVA
           ELSE
              MOVE CIMPIVA TO RG-FTS-IMIVA(K).
           PERFORM CALC-TOTALI.
      *------------------
       CALC-IMPOR-IVPAG.
      **** rel 4.0
      *    COMPUTE CIMPIVA =
      *            RG-FTS-IMPAG(K) * RG-FTS-ALIVA(K) / 100 + 0,99.
           MOVE RG-FTS-IMPAG(K) TO ER-IMPORTO.
           MOVE ZERO            TO ER-VALUT.
           MOVE RG-FTS-ALIVA(K) TO COM-ALIVA.
           CALL 're2iva' USING ER-IMPORTO ER-VALUT COM-ALIVA.
           MOVE ER-IMPORTO      TO CIMPIVA.
      ************
           IF FUN = 'W' AND CIMPIVA NOT = RG-FTS-IVPAG(K)
              MOVE 1 TO SWIVA
           ELSE
              MOVE CIMPIVA TO RG-FTS-IVPAG(K).
           PERFORM CALC-TOTALI.
      *------------------
       CALC-TOTALI.
           MOVE ZERO TO RA-FTS-TIMPON
                        RA-FTS-TIMIVA
                        RA-FTS-TIMPAG
                        RA-FTS-TIVPAG.
           MOVE 1 TO J.
           PERFORM UNTIL J > 6
              ADD RG-FTS-IMPON(J) TO RA-FTS-TIMPON
              ADD RG-FTS-IMIVA(J) TO RA-FTS-TIMIVA
              ADD RG-FTS-IMPAG(J) TO RA-FTS-TIMPAG
              ADD RG-FTS-IVPAG(J) TO RA-FTS-TIVPAG
              ADD 1 TO J
           END-PERFORM.
      *------------------
