       IDENTIFICATION DIVISION.
       PROGRAM-ID. VOPCG10.
      *
      *    Interfaccia ORDPRC per scheda
      *
      * Non e' gestito FUN = P, p, N, n
      * Valori particolari di FUN:
      *     d = controlli di validazione periodo
      *     m = esegue l'aggiornamento dell'ordinato sul rigo ordine
      *         ed aggiorna MAGART e MAGARD.
      *
      **** rel 5.0
      * nuovo
      ************
      **** rel 6.2
      * ricompilato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griopcsl'.
           COPY 'gritprsl'.
           COPY 'griordsl'.
      **** rel 6.2
           COPY 'griorcsl'.
      ************
           COPY 'gririgsl'.
           COPY 'griartsl'.
           COPY 'griardsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griopc'.
           COPY 'gritpr'.
           COPY 'griord'.
      **** rel 6.2
           COPY 'griorc'.
      ************
           COPY 'gririg'.
           COPY 'griart'.
           COPY 'griard'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritpr13'.
           COPY 'griordrk'.
           COPY 'gririgrk'.
           COPY 'griartrk'.
           COPY 'griardrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parmb'.
           COPY 'parset'.
      **** rel 5.2
           COPY 'parpdop'.
      ************
           COPY 'parlk'.
           COPY 'parroc'.
      **** rel 7.1
           COPY 'parppar'.
      ************
       01  ID-ORD PIC X(15) VALUE 'ordcli'.
      **** rel 6.2
       01  ID-ORC PIC X(15) VALUE 'ordric'.
      ************
       01  ID-RIG PIC X(15) VALUE 'ordrig'.
       01  ID-ART PIC X(15) VALUE 'magart'.
       01  ID-ARD PIC X(15) VALUE 'magard'.
       01  ID-OPC PIC X(15) VALUE 'ordprc'.
       01  ID-TPR PIC X(15) VALUE 'tabpro'.
       01  COMODI.
           05 SF-ORD   PIC XX.
      **** rel 6.2
           05 SF-ORC   PIC XX.
      ************
           05 SF-RIG   PIC XX.
           05 SF-ART   PIC XX.
           05 SF-ARD   PIC XX.
           05 SF-OPC   PIC XX.
           05 SF-TPR   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(50).
           05 IF-AZI   PIC 9(3).
           05 IF-NUM   PIC 9(5).
           05 IF-PRG   PIC 9(3).
           05 IF-PROG  PIC 9(4).
           05 NUMGG    PIC S9(5).
           05 NMESI    PIC 99.
           05 RESTO    PIC 9.
      **** rel 5.2
      *    05 MESE     PIC X(10).
      *    05 COMDAT   PIC 9(5).
      ************
           05 NWDATA   PIC 9(5).
           05 RESID    PIC S9(10)V999.
           05 DAT      PIC 9(6).
           05 FILLER REDEFINES DAT.
              10 GG  PIC 99.
              10 MM  PIC 99.
              10 AA  PIC 99.
      **** rel 6.2
           05 SAVART  PIC X(18).
           05 NOPC    PIC 999 VALUE ZERO.
      ************
      **** rel 7.2
           05 DTINT    PIC 9(5).
      ************

       LINKAGE SECTION.
           COPY 'griopcrg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-OPC-CTRL
                                RG-OPC-REC
                                RA-OPC-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclopc'.
           COPY 'dcltpr'.
           COPY 'dclord'.
      **** rel 6.2
           COPY 'dclorc'.
      ************
           COPY 'dclrig'.
           COPY 'dclart'.
           COPY 'dclard'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-OPC-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-OPC-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-OPC-FUN   TO FUN.
           MOVE RG-OPC-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-OPC-EOF
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'd' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           IF FUN = 'm' GO TO F-AGG-ORDRIG.
           MOVE 'vopcg10: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-OPC-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-OPC-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-OPC-ST = 7 GO TO FINE.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK ORDPRC.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-OPC INVALID
              PERFORM INVK-OPC
              GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-O.
      ************
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-OPC INVALID
              PERFORM INVK-OPC
              GO TO ERRIO.
           UNLOCK ORDPRC.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-O.
      ************
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-OPC
              GO TO WARNING.
           IF RG-OPC-ST = 7 GO TO FINE.
           PERFORM DB-STORNA THRU EX-DB-STORNA.
           DELETE ORDPRC INVALID
              PERFORM INVK-OPC
              GO TO ERRIO.
           UNLOCK ORDPRC.
      **** rel 7.1
      **** rel 7.2
           MOVE ORD-DAT TO DTINT.
      ************
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-O.
      ************
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-OPC-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK ORDPRC.
           GO TO CHIUDI.
      * - - - - - *
       F-AGG-ORDRIG.
           MOVE RG-OPC-AZI TO KRI-AZI.
           MOVE RG-OPC-NUM TO KRI-NUM.
           MOVE RG-OPC-PRG TO KRI-PRG.
           READ ORDRIG INTO REKRIG INVALID PERFORM INVK-RIG
                                           GO TO ERRIO.
           PERFORM SUBMAG THRU EX-SUBMAG.
           MOVE RG-OPC-AZI TO KRI-AZI.
           MOVE RG-OPC-NUM TO KRI-NUM.
           MOVE RG-OPC-PRG TO KRI-PRG.
       LBRIG.
           READ ORDRIG INTO REKRIG KEPT LOCK INVALID
              PERFORM INVK-RIG
              GO TO ERRIO.
           IF SF-RIG NOT = ZERO PERFORM REC-LOCK
                                GO TO LBRIG.
           MOVE KRI-AZI TO PROC-AZI.
           MOVE KRI-NUM TO PROC-NUM.
           MOVE KRI-PRG TO PROC-PRG.
           MOVE ZERO    TO PROC-DATA.
           CALL 'vrropc' USING PARROC.
           MOVE PROC-RESID TO RIG-QUANT.
           MOVE ZERO TO RIG-QSPED.
           MOVE ZERO TO RIG-SALDO.
           REWRITE RF-RIG FROM REKRIG INVALID PERFORM INVK-RIG
                                              GO TO ERRIO.
           UNLOCK ORDRIG.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-R.
      ************
      *
           PERFORM ADDMAG THRU EX-ADDMAG.
           GO TO FINE.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-OPC-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE TABPRO.
           CLOSE ORDCLI.
      **** rel 6.2
           CLOSE ORDRIC.
      ************
           CLOSE ORDPRC.
           CLOSE ORDRIG.
           CLOSE MAGART.
           CLOSE MAGARD.

           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-OPC-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-OPC-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griopcer'.
           COPY 'gritprer'.
           COPY 'griorder'.
      **** rel 6.2
           COPY 'griorcer'.
      ************
           COPY 'gririger'.
           COPY 'griarter'.
           COPY 'griarder'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           OPEN INPUT TABPRO.
           OPEN INPUT ORDCLI.
      **** rel 6.2
           OPEN INPUT ORDRIC.
      ************
           OPEN I-O ORDPRC.
           OPEN I-O ORDRIG.
           OPEN I-O MAGART.
           OPEN I-O MAGARD.
      *
           MOVE RG-OPC-AZI TO KOR-AZI.
           MOVE RG-OPC-NUM TO KOR-NUM.
           READ ORDCLI INTO REKORD INVALID PERFORM INVK-ORD
                                           GO TO ERRIO.
           IF SF-ORD = '9D' OR '9A' OR '35' MOVE RF-ORD TO REKORD.
      *
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-OPC-EOF.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO TO RF-OPC.
           MOVE ZERO TO OPC-QTAPR
                        OPC-QTACF.
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
           MOVE RG-OPC-AZI  TO IF-AZI.
           MOVE RG-OPC-NUM  TO IF-NUM.
           MOVE RG-OPC-PRG  TO IF-PRG.
           MOVE RG-OPC-PROG TO IF-PROG.

      * azzeramento aree interfaccia
           MOVE ZERO  TO RG-OPC-REC.
           MOVE ZERO  TO RG-OPC-QTAPR
                         RG-OPC-QTACF.
           MOVE ZERO  TO RA-OPC-AGG.
           MOVE SPACE TO RA-OPC-DATA-D.

      * ripristino dei campi chiave fissi
           MOVE IF-AZI  TO RG-OPC-AZI.
           MOVE IF-NUM  TO RG-OPC-NUM.
           MOVE IF-PRG  TO RG-OPC-PRG.
           MOVE IF-PROG TO RG-OPC-PROG.
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
           IF RG-OPC-PROG = ZERO GO TO INI-CAMPI-50.
           MOVE RG-OPC-AZI  TO KOPC-AZI.
           MOVE RG-OPC-NUM  TO KOPC-NUM.
           MOVE RG-OPC-PRG  TO KOPC-PRG.
           MOVE RG-OPC-PROG TO KOPC-PROG.
           READ ORDPRC NOT INVALID GO TO INI-CAMPI-60.
       INI-CAMPI-50.
           MOVE RG-OPC-AZI TO KTR-AZI.
           MOVE 13         TO KTR-TIP.
           READ TABPRO INTO REKTPR13 INVALID
                PERFORM INVK-TPR
                GO TO ERRIO.
           IF SF-TPR = '9A' OR '9D' OR '35' MOVE RF-TPR TO REKTPR13.
           MOVE TPR13-TIPS TO OPC-TIPO.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO OPC-DATA.
       INI-CAMPI-60.
           MOVE OPC-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF OPC-TIPO = ZERO GO TO CAR-GIOR.
           IF OPC-TIPO = 1 GO TO CAR-SETT.
           GO TO CAR-ALTRI.
       CAR-GIOR.
           MOVE 1 TO NUMGG.
           CALL 'raddgg' USING PARCDT NUMGG.
           MOVE AAGGG TO NWDATA.
           GO TO CAR-END.
       CAR-SETT.
           MOVE 7 TO NUMGG.
           CALL 'raddgg' USING PARCDT NUMGG.
           MOVE AAGGG TO NWDATA.
           GO TO CAR-END.
       CAR-ALTRI.
           IF OPC-TIPO = 2 MOVE 1 TO NMESI.
           IF OPC-TIPO = 3 MOVE 2 TO NMESI.
           IF OPC-TIPO = 4 MOVE 3 TO NMESI.
           IF OPC-TIPO = 5 MOVE 4 TO NMESI.
           IF OPC-TIPO = 6 MOVE 6 TO NMESI.
           IF OPC-TIPO = 7 MOVE 12 TO NMESI.
           COMPUTE MM9 = MM9 + NMESI.
           IF MM9 > 12
              COMPUTE MM9 = MM9 - 12
              ADD 1 TO AA9.
           PERFORM A00-FINE-MESE THRU A99.
           MOVE AAGGG TO NWDATA.
       CAR-END.
           MOVE OPC-TIPO TO RG-OPC-TIPO.
           MOVE NWDATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-OPC-DATA.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
      *
           MOVE RG-OPC-AZI TO SKOPC-AZI.
           MOVE RG-OPC-NUM TO SKOPC-NUM.
           MOVE RG-OPC-PRG TO SKOPC-PRG.
           MOVE ZERO       TO SKOPC-PROG.
           START ORDPRC KEY NOT < KEYOPC INVALID GO TO END-PROG.
       LP-PROG.
           READ ORDPRC NEXT AT END GO TO END-PROG.
           IF RG-OPC-AZI NOT = SKOPC-AZI GO TO END-PROG.
           IF RG-OPC-NUM NOT = SKOPC-NUM GO TO END-PROG.
           IF RG-OPC-PRG NOT = SKOPC-PRG GO TO END-PROG.
           MOVE KOPC-PROG TO RG-OPC-PROG.
           GO TO LP-PROG.
       END-PROG.
           ADD 1 TO RG-OPC-PROG.
      *
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-OPC-AZI  TO KOPC-AZI.
           MOVE RG-OPC-NUM  TO KOPC-NUM.
           MOVE RG-OPC-PRG  TO KOPC-PRG.
           MOVE RG-OPC-PROG TO KOPC-PROG.
           MOVE KEYOPC TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYOPC.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ ORDPRC INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ ORDPRC KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-OPC > ZERO MOVE 7 TO RG-OPC-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE RG-OPC-AZI       TO KOPC-AZI.
           MOVE RG-OPC-NUM       TO KOPC-NUM.
           MOVE RG-OPC-PRG       TO KOPC-PRG.
           MOVE RG-OPC-PROG      TO KOPC-PROG.
      *
           MOVE RG-OPC-DATA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO OPC-DATA.
      *
           MOVE RG-OPC-TIPO      TO OPC-TIPO.
           MOVE RG-OPC-QTAPR     TO OPC-QTAPR.
           MOVE RG-OPC-QTACF     TO OPC-QTACF.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE KOPC-AZI       TO RG-OPC-AZI.
           MOVE KOPC-NUM       TO RG-OPC-NUM.
           MOVE KOPC-PRG       TO RG-OPC-PRG.
           MOVE KOPC-PROG      TO RG-OPC-PROG.
      *
           MOVE OPC-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-OPC-DATA.
      *
           MOVE OPC-TIPO      TO RG-OPC-TIPO.
           MOVE OPC-QTAPR     TO RG-OPC-QTAPR.
           MOVE OPC-QTACF     TO RG-OPC-QTACF.
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
           PERFORM B00-GIORNO THRU B99.
      *
           MOVE RG-OPC-DATA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF RG-OPC-TIPO = ZERO GO TO EX-CARICA-RA.
           IF RG-OPC-TIPO NOT = 1 GO TO CARICA-RA-20.
      * settimana
           MOVE ZERO TO PARSET.
           MOVE 2 TO SE-TCAL.
           CALL 'rsett' USING PARSET PARCDT.
           COMPUTE DAT = ( SE-SS * 100 ) + SE-AA.
           GO TO CARICA-RA-10.
       CARICA-RA-20.
           IF RG-OPC-TIPO = 2 MOVE 1 TO NMESI.
           IF RG-OPC-TIPO = 3 MOVE 2 TO NMESI.
           IF RG-OPC-TIPO = 4 MOVE 3 TO NMESI.
           IF RG-OPC-TIPO = 5 MOVE 4 TO NMESI.
           IF RG-OPC-TIPO = 6 MOVE 6 TO NMESI.
           IF RG-OPC-TIPO = 7 MOVE 12 TO NMESI.
           DIVIDE NMESI INTO MM9 GIVING MM9 REMAINDER RESTO.
           IF RESTO NOT = ZERO ADD 1 TO MM9.
           IF RG-OPC-TIPO < 7
              COMPUTE DAT = ( MM9 * 100 ) + AA9.
       CARICA-RA-10.
           MOVE AA TO RA-OPC-ANNO
           CALL 'ranno4' USING RA-OPC-ANNO
           IF RG-OPC-TIPO NOT = 7
              MOVE MM TO RA-OPC-PERI.
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-OPC-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
      *
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-OPC-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-TIPO.
           MOVE 'OPC-TIPO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TIPO.
           IF NOT (RG-OPC-TIPO = ZERO OR 1 OR 2 OR
                                    3 OR 4 OR 5 OR 6 OR 7)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF FUN NOT = 'V' GO TO E-TIPO.
           IF RG-OPC-DATA NOT = ZERO
              PERFORM CARICA-RA THRU EX-CARICA-RA.
       E-TIPO.
      *
       V-DATA.
           MOVE 'OPC-DATA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA.
           IF RG-OPC-TIPO > ZERO GO TO E-DATA.
           IF RG-OPC-DATA = ZERO GO TO E-DATA.
           MOVE 1 TO TIPOP1.
           MOVE RG-OPC-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DATA.
      *
       V-PERI.
           MOVE 'OPC-PERI' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PERI.
           IF RG-OPC-TIPO = ZERO OR 7
              GO TO E-PERI.
           IF RA-OPC-PERI = ZERO
              PERFORM ERR-DINV
              GO TO V-ERROR.
           IF RG-OPC-TIPO = 1 AND RA-OPC-PERI <= 52 GO TO E-PERI.
           IF RG-OPC-TIPO = 2 AND RA-OPC-PERI <= 12 GO TO E-PERI.
           IF RG-OPC-TIPO = 3 AND RA-OPC-PERI <= 6  GO TO E-PERI.
           IF RG-OPC-TIPO = 4 AND RA-OPC-PERI <= 4  GO TO E-PERI.
           IF RG-OPC-TIPO = 5 AND RA-OPC-PERI <= 3  GO TO E-PERI.
           IF RG-OPC-TIPO = 6 AND RA-OPC-PERI <= 2  GO TO E-PERI.
      *
           PERFORM ERR-DINV.
           GO TO V-ERROR.
       E-PERI.
      *
       V-ANNO.
           MOVE 'OPC-ANNO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ANNO.
           CALL 'ranno4' USING RA-OPC-ANNO.
       E-ANNO.
      *
       V-QTAPR.
           MOVE 'OPC-QTAPR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-QTAPR.
       E-QTAPR.
      *
       V-QTACF.
           MOVE 'OPC-QTACF' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-QTACF.
      **** rel 6.2
           IF RG-OPC-QTACF NOT = ZERO
              PERFORM VER-ART-PRO THRU EX-VER-ART-PRO
              IF NOPC > ZERO
                 MOVE 'Quantit Confermata Errata' TO MESS
                 GO TO V-ERROR.
      ************
       E-QTACF.
      *
           IF FUN = 'V' GO TO END-V-DATI.
      * validazione periodo (per FUN = W/d)
       V-DATI-PERIODO.
           MOVE RG-OPC-AZI TO KTR-AZI.
           MOVE 13         TO KTR-TIP.
           READ TABPRO INTO REKTPR13 INVALID
                PERFORM INVK-TPR
                GO TO ERRIO.
           IF SF-TPR = '9A' OR '9D' OR '35' MOVE RF-TPR TO REKTPR13.
           IF TPR13-SETT = ZERO
      **** rel 7.1
      *       MOVE  5 TO TPR13-SETT
      *       MOVE 31 TO TPR13-MESE.
              MOVE  5 TO TPR13-SETT.
           IF TPR13-MESE = ZERO
              MOVE 31 TO TPR13-MESE.
      ************
           IF TPR13-BIM-M = ZERO
              MOVE  2 TO TPR13-BIM-M
              MOVE 31 TO TPR13-BIM-G.
           IF TPR13-TRI-M = ZERO
              MOVE  3 TO TPR13-TRI-M
              MOVE 31 TO TPR13-TRI-G.
           IF TPR13-QUA-M = ZERO
              MOVE  4 TO TPR13-QUA-M
              MOVE 31 TO TPR13-QUA-G.
           IF TPR13-SEM-M = ZERO
              MOVE  6 TO TPR13-SEM-M
              MOVE 31 TO TPR13-SEM-G.
           IF TPR13-ANN-M = ZERO
              MOVE 12 TO TPR13-ANN-M
              MOVE 31 TO TPR13-ANN-G.
           MOVE RA-OPC-ANNO TO AA.
           MOVE RA-OPC-PERI TO MM.
           IF RG-OPC-TIPO = 1
              MOVE ZERO TO PARSET
              MOVE 1  TO SE-TCAL
              MOVE AA TO SE-AA
              MOVE MM TO SE-SS
              MOVE TPR13-SETT TO SE-GIOR
              CALL 'rsett' USING PARSET PARCDT
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GGMMAA TO RG-OPC-DATA.
           IF RG-OPC-TIPO = 2
              COMPUTE DAT = (TPR13-MESE * 10000) + ( MM * 100 ) + AA.
           IF RG-OPC-TIPO = 3
              COMPUTE DAT = (TPR13-BIM-G * 10000) +
              ((((MM - 1) * 2 ) + TPR13-BIM-M) * 100) + AA.
           IF RG-OPC-TIPO = 4
              COMPUTE DAT = (TPR13-TRI-G * 10000) +
              ((((MM - 1) * 3 ) + TPR13-TRI-M) * 100) + AA.
           IF RG-OPC-TIPO = 5
              COMPUTE DAT = (TPR13-QUA-G * 10000) +
              ((((MM - 1) * 4 ) + TPR13-QUA-M) * 100) + AA.
           IF RG-OPC-TIPO = 6
              COMPUTE DAT = (TPR13-SEM-G * 10000) +
              ((((MM - 1) * 6 ) + TPR13-SEM-M) * 100) + AA.
           IF RG-OPC-TIPO = 7
              COMPUTE DAT = (TPR13-ANN-G * 10000) +
              (TPR13-ANN-M * 100) + AA.
           IF RG-OPC-TIPO = 2 OR 3 OR 4 OR 5 OR 6 OR 7
              MOVE DAT TO GGMMAA
              PERFORM A00-FINE-MESE THRU A99
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GGMMAA TO RG-OPC-DATA.
           IF RG-OPC-DATA = ZERO
              MOVE 'ATTENZIONE: inserendo il valore ZERO'      TO F-MES1
              MOVE 'il rigo e'' sospeso e non piu'' evadibile' TO F-MES2
              MOVE 2 TO F-NMES
              CALL 'vrmbox' USING PARMB.
           PERFORM B00-GIORNO THRU B99.
       END-V-DATI.
      *
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
       A00-FINE-MESE.
           ADD 1 TO GG9.
       A10.
           SUBTRACT 1 FROM GG9.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 = 1 GO TO A10.
       A99.
           EXIT.
      *------------------
       B00-GIORNO.
           IF RG-OPC-DATA = ZERO
              MOVE '** SOSPESO **' TO RA-OPC-DATA-D
              GO TO B99.
           MOVE RG-OPC-DATA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      **** rel 5.2
      * sostituita creazione descrizione data scadenza con call VRDOPR
           MOVE RG-OPC-TIPO TO PDOP-TIPO.
           MOVE AAGGG TO PDOP-DATA.
           CALL 'vrdopr' USING PAR-PDOP.
           MOVE PDOP-DDAT TO RA-OPC-DATA-D.
      ************
       B99.
           EXIT.
      *------------------
       SUBMAG.
           IF RIG-SALDO = 1     GO TO EX-SUBMAG.
           IF RIG-ARTIC = SPACE GO TO EX-SUBMAG.
           SUBTRACT RIG-QSPED FROM RIG-QUANT GIVING RESID.
           IF RESID NOT > ZERO GO TO EX-SUBMAG.
           MOVE RIG-AZI   TO KMA-AZI.
           MOVE RIG-ARTIC TO KMA-ART.
       SMAG1.
           READ MAGART INTO REKART KEPT LOCK INVALID PERFORM INVK-ART
                                                     PERFORM VISK-RIG
                                                     GO TO ERRIO.
           IF SF-ART NOT = ZERO PERFORM REC-LOCK
                                GO TO SMAG1.
           MOVE KMA-AZI  TO KAD-AZI.
           MOVE ORD-CDEP TO KAD-DEP.
           MOVE KMA-ART  TO KAD-ART.
       SMAG2.
           READ MAGARD INTO REKARD KEPT LOCK INVALID PERFORM INVK-ARD
                                                     PERFORM VISK-RIG
                                                     GO TO ERRIO.
           IF SF-ARD NOT = ZERO PERFORM REC-LOCK
                                GO TO SMAG2.
           SUBTRACT RESID FROM ART-IMPCL ARD-CIMPE.
           REWRITE RF-ART FROM REKART INVALID PERFORM INVK-ART
                                              PERFORM VISK-RIG
                                              GO TO ERRIO.
           UNLOCK MAGART.
           REWRITE RF-ARD FROM REKARD INVALID PERFORM INVK-ARD
                                              PERFORM VISK-RIG
                                              GO TO ERRIO.
           UNLOCK MAGARD.
       EX-SUBMAG.
           EXIT.
      *------------------
       ADDMAG.
           IF RIG-ARTIC = SPACE GO TO EX-ADDMAG.
           SUBTRACT RIG-QSPED FROM RIG-QUANT GIVING RESID.
           IF RESID NOT > ZERO GO TO EX-ADDMAG.
           MOVE ORD-AZI   TO KMA-AZI.
           MOVE RIG-ARTIC TO KMA-ART.
       LRART.
           READ MAGART INTO REKART KEPT LOCK INVALID PERFORM INVK-ART
                                                     PERFORM VISK-RIG
                                                     GO TO ERRIO.
           IF SF-ART NOT = ZERO PERFORM REC-LOCK
                                GO TO LRART.
           MOVE KMA-AZI  TO KAD-AZI.
           MOVE ORD-CDEP TO KAD-DEP.
           MOVE KMA-ART  TO KAD-ART.
       LRARD.
           READ MAGARD INTO REKARD KEPT LOCK INVALID PERFORM INVK-ARD
                                                     PERFORM VISK-RIG
                                                     GO TO ERRIO.
           IF SF-ARD NOT = ZERO PERFORM REC-LOCK
                                GO TO LRARD.
           ADD RESID TO ART-IMPCL ARD-CIMPE.
           REWRITE RF-ART FROM REKART INVALID PERFORM INVK-ART
                                              PERFORM VISK-RIG
                                              GO TO ERRIO.
           UNLOCK MAGART.
           REWRITE RF-ARD FROM REKARD INVALID PERFORM INVK-ARD
                                              PERFORM VISK-RIG
                                              GO TO ERRIO.
           UNLOCK MAGARD.
       EX-ADDMAG.
           EXIT.
      *------------------
       REC-LOCK.
           CALL 'rlock' USING PARLK.
           EXIT.
      *------------------
      **** rel 6.2
       VER-ART-PRO.
           MOVE ZERO TO NOPC.

           MOVE RG-OPC-AZI TO KRI-AZI.
           MOVE RG-OPC-NUM TO KRI-NUM.
           MOVE RG-OPC-PRG TO KRI-PRG.
           READ ORDRIG INTO REKRIG INVALID PERFORM INVK-RIG
                                           GO TO ERRIO.
           MOVE RIG-ARTIC TO SAVART.
      *
           MOVE RG-OPC-AZI TO KORC-AZI.
           MOVE RG-OPC-NUM TO ORC-ORD.
           START ORDRIC KEY NOT < SKEYORC1 INVALID GO TO NOORC2.
       RDORC2.
           READ ORDRIC NEXT AT END GO TO NOORC2.
           IF SF-ORC = '9D' OR '9A' OR '35' GO TO RDORC2.
           IF KORC-AZI > RG-OPC-AZI GO TO NOORC2.
           IF ORC-ORD  > RG-OPC-NUM GO TO NOORC2.
      *
           MOVE LOW-VALUE  TO KEYRI.
           MOVE SAVART     TO KRI-ART.
           MOVE KORC-ORD   TO KRI-NUM.
           START ORDRIG KEY NOT < SKEYRI2 INVALID GO TO NOPRO.
       RDPRO.
           READ ORDRIG NEXT INTO REKRIG AT END GO TO NOPRO.
           IF SF-RIG = '9D' OR '9A' OR '35' GO TO RDPRO.
           IF KRI-ART NOT = SAVART GO TO NOPRO.
           IF KRI-NUM NOT = KORC-ORD GO TO NOPRO.

           IF KRI-AZI NOT = RG-OPC-AZI GO TO RDPRO.

           ADD 1 TO NOPC.
           GO TO NOORC2.
       NOPRO.
      *
           GO TO RDORC2.
       NOORC2.

       EX-VER-ART-PRO.
           EXIT.
      *------------------*
      ************
      **** rel 7.1
       CALL-VSRV133-R.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'RIG'   TO PPAR-TARC.
           MOVE KEYRI   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 RIG ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------
       CALL-VSRV133-O.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'OPC'   TO PPAR-TARC.
           MOVE KEYOPC  TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           IF PPAR-TOPE = 'C'
      **** rel 7.2
      *       MOVE ORD-DAT TO PPAR-OPZ(1:5).
              MOVE DTINT TO PPAR-OPZ(1:5).
      ************
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 OPC ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------
      ************
