       IDENTIFICATION DIVISION.
       PROGRAM-ID. VOPFG10.
      *
      *    Interfaccia ORDPRF per scheda
      *
      * Non e' gestito FUN = P, p, N, n
      * Valori particolari di FUN:
      *     d = controlli di validazione periodo
      *     m = esegue l'aggiornamento dell'ordinato sul rigo ordine
      *         ed aggiorna MAGART e MAGARD.
      *
      **** rel 5.0
      * nuovo
      ************
      **** rel 6.2
      * ricompilato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griopfsl'.
           COPY 'gritprsl'.
           COPY 'griorfsl'.
      **** rel 6.2
           COPY 'grirofsl'.
      ************
           COPY 'gririfsl'.
           COPY 'griartsl'.
           COPY 'griardsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griopf'.
           COPY 'gritpr'.
           COPY 'griorf'.
      **** rel 6.2
           COPY 'grirof'.
      ************
           COPY 'gririf'.
           COPY 'griart'.
           COPY 'griard'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritpr14'.
           COPY 'griorfrk'.
           COPY 'gririfrk'.
           COPY 'griartrk'.
           COPY 'griardrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parmb'.
           COPY 'parset'.
      **** rel 5.2
           COPY 'parpdop'.
      ************
           COPY 'parlk'.
           COPY 'parrof'.
      *** rel 5.1-1
           COPY 'parrd'.
      *************
      **** rel 7.1
           COPY 'parppar'.
      ************
       01  ID-ORF PIC X(15) VALUE 'ordfor'.
      **** rel 6.2
       01  ID-ROF PIC X(15) VALUE 'orfric'.
      ************
       01  ID-RIF PIC X(15) VALUE 'ordrif'.
       01  ID-ART PIC X(15) VALUE 'magart'.
       01  ID-ARD PIC X(15) VALUE 'magard'.
       01  ID-OPF PIC X(15) VALUE 'ordprf'.
       01  ID-TPR PIC X(15) VALUE 'tabpro'.
       01  COMODI.
           05 SF-ORF   PIC XX.
      **** rel 6.2
           05 SF-ROF   PIC XX.
      ************
           05 SF-RIF   PIC XX.
           05 SF-ART   PIC XX.
           05 SF-ARD   PIC XX.
           05 SF-OPF   PIC XX.
           05 SF-TPR   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(50).
           05 IF-AZI   PIC 9(3).
           05 IF-NUM   PIC 9(5).
           05 IF-PRG   PIC 9(3).
           05 IF-PROG  PIC 9(4).
           05 NUMGG    PIC S9(5).
           05 NMESI    PIC 99.
           05 RESTO    PIC 9.
      **** rel 5.2
      *    05 MESE     PIC X(10).
      *    05 COMDAT   PIC 9(5).
      ************
           05 NWDATA   PIC 9(5).
           05 RESID    PIC S9(10)V999.
           05 DAT      PIC 9(6).
           05 FILLER REDEFINES DAT.
              10 GG  PIC 99.
              10 MM  PIC 99.
              10 AA  PIC 99.
      **** rel 6.2
           05 SAVART  PIC X(18).
           05 NROF    PIC 999 VALUE ZERO.
      ************
      **** rel 7.2
           05 DTINT    PIC 9(5).
      ************

       LINKAGE SECTION.
           COPY 'griopfrg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-OPF-CTRL
                                RG-OPF-REC
                                RA-OPF-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclopf'.
           COPY 'dcltpr'.
           COPY 'dclorf'.
      **** rel 6.2
           COPY 'dclrof'.
      ************
           COPY 'dclrif'.
           COPY 'dclart'.
           COPY 'dclard'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-OPF-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-OPF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-OPF-FUN   TO FUN.
           MOVE RG-OPF-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-OPF-EOF
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'd' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           IF FUN = 'm' GO TO F-AGG-ORDRIF.
           MOVE 'vopfg10: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-OPF-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-OPF-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-OPF-ST = 7 GO TO FINE.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK ORDPRF.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-OPF INVALID
              PERFORM INVK-OPF
              GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-O.
      ************
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-OPF INVALID
              PERFORM INVK-OPF
              GO TO ERRIO.
           UNLOCK ORDPRF.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-O.
      ************
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-OPF
              GO TO WARNING.
           IF RG-OPF-ST = 7 GO TO FINE.
           PERFORM DB-STORNA THRU EX-DB-STORNA.
           DELETE ORDPRF INVALID
              PERFORM INVK-OPF
              GO TO ERRIO.
           UNLOCK ORDPRF.
      **** rel 7.1
      **** rel 7.2
           MOVE ORF-DAT TO DTINT.
      ************
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-O.
      ************
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-OPF-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK ORDPRF.
           GO TO CHIUDI.
      * - - - - - *
       F-AGG-ORDRIF.
           MOVE RG-OPF-AZI TO KRF-AZI.
           MOVE RG-OPF-NUM TO KRF-NUM.
           MOVE RG-OPF-PRG TO KRF-PRG.
           READ ORDRIF INTO REKRIF INVALID PERFORM INVK-RIF
                                           GO TO ERRIO.
           PERFORM SUBMAG THRU EX-SUBMAG.
           MOVE RG-OPF-AZI TO KRF-AZI.
           MOVE RG-OPF-NUM TO KRF-NUM.
           MOVE RG-OPF-PRG TO KRF-PRG.
       LBRIF.
           READ ORDRIF INTO REKRIF KEPT LOCK INVALID
              PERFORM INVK-RIF
              GO TO ERRIO.
           IF SF-RIF NOT = ZERO PERFORM REC-LOCK
                                GO TO LBRIF.
           MOVE KRF-AZI TO PROF-AZI.
           MOVE KRF-NUM TO PROF-NUM.
           MOVE KRF-PRG TO PROF-PRG.
           MOVE ZERO    TO PROF-DATA.
           CALL 'vrropf' USING PARROF.
           MOVE PROF-RESID TO RIF-QUANT.
           MOVE ZERO TO RIF-QARR.
           MOVE ZERO TO RIF-SALDO.
           REWRITE RF-RIF FROM REKRIF INVALID PERFORM INVK-RIF
                                              GO TO ERRIO.
           UNLOCK ORDRIF.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-R.
      ************
           PERFORM ADDMAG THRU EX-ADDMAG.
           GO TO FINE.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-OPF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE TABPRO.
           CLOSE ORDFOR.
      **** rel 6.2
           CLOSE ORFRIC.
      ************
           CLOSE ORDPRF.
           CLOSE ORDRIF.
           CLOSE MAGART.
           CLOSE MAGARD.

           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-OPF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-OPF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griopfer'.
           COPY 'gritprer'.
           COPY 'griorfer'.
      **** rel 6.2
           COPY 'grirofer'.
      ************
           COPY 'gririfer'.
           COPY 'griarter'.
           COPY 'griarder'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           OPEN INPUT TABPRO.
           OPEN INPUT ORDFOR.
      **** rel 6.2
           OPEN INPUT ORFRIC.
      ************
           OPEN I-O ORDPRF.
           OPEN I-O ORDRIF.
           OPEN I-O MAGART.
           OPEN I-O MAGARD.
      *
           MOVE RG-OPF-AZI TO KOF-AZI.
           MOVE RG-OPF-NUM TO KOF-NUM.
           READ ORDFOR INTO REKORF INVALID PERFORM INVK-ORF
                                           GO TO ERRIO.
           IF SF-ORF = '9D' OR '9A' OR '35' MOVE RF-ORF TO REKORF.
      *
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-OPF-EOF.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO TO RF-OPF.
           MOVE ZERO TO OPF-QTAPR
                        OPF-QTACF.
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
           MOVE RG-OPF-AZI  TO IF-AZI.
           MOVE RG-OPF-NUM  TO IF-NUM.
           MOVE RG-OPF-PRG  TO IF-PRG.
           MOVE RG-OPF-PROG TO IF-PROG.

      * azzeramento aree interfaccia
           MOVE ZERO  TO RG-OPF-REC.
           MOVE ZERO  TO RG-OPF-QTAPR
                         RG-OPF-QTACF.
           MOVE ZERO  TO RA-OPF-AGG.
           MOVE SPACE TO RA-OPF-DATA-D.

      * ripristino dei campi chiave fissi
           MOVE IF-AZI  TO RG-OPF-AZI.
           MOVE IF-NUM  TO RG-OPF-NUM.
           MOVE IF-PRG  TO RG-OPF-PRG.
           MOVE IF-PROG TO RG-OPF-PROG.
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
           IF RG-OPF-PROG = ZERO GO TO INI-CAMPI-50.
           MOVE RG-OPF-AZI  TO KOPF-AZI.
           MOVE RG-OPF-NUM  TO KOPF-NUM.
           MOVE RG-OPF-PRG  TO KOPF-PRG.
           MOVE RG-OPF-PROG TO KOPF-PROG.
           READ ORDPRF NOT INVALID GO TO INI-CAMPI-60.
       INI-CAMPI-50.
           MOVE RG-OPF-AZI TO KTR-AZI.
           MOVE 14         TO KTR-TIP.
           READ TABPRO INTO REKTPR14 INVALID
                PERFORM INVK-TPR
                GO TO ERRIO.
           IF SF-TPR = '9A' OR '9D' OR '35' MOVE RF-TPR TO REKTPR14.
           MOVE TPR14-TIPS TO OPF-TIPO.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO OPF-DATA.
       INI-CAMPI-60.
           MOVE OPF-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF OPF-TIPO = ZERO GO TO CAR-GIOR.
           IF OPF-TIPO = 1 GO TO CAR-SETT.
           GO TO CAR-ALTRI.
       CAR-GIOR.
           MOVE 1 TO NUMGG.
           CALL 'raddgg' USING PARCDT NUMGG.
           MOVE AAGGG TO NWDATA.
           GO TO CAR-END.
       CAR-SETT.
           MOVE 7 TO NUMGG.
           CALL 'raddgg' USING PARCDT NUMGG.
           MOVE AAGGG TO NWDATA.
           GO TO CAR-END.
       CAR-ALTRI.
           IF OPF-TIPO = 2 MOVE 1 TO NMESI.
           IF OPF-TIPO = 3 MOVE 2 TO NMESI.
           IF OPF-TIPO = 4 MOVE 3 TO NMESI.
           IF OPF-TIPO = 5 MOVE 4 TO NMESI.
           IF OPF-TIPO = 6 MOVE 6 TO NMESI.
           IF OPF-TIPO = 7 MOVE 12 TO NMESI.
           COMPUTE MM9 = MM9 + NMESI.
           IF MM9 > 12
              COMPUTE MM9 = MM9 - 12
              ADD 1 TO AA9.
           PERFORM A00-FINE-MESE THRU A99.
           MOVE AAGGG TO NWDATA.
       CAR-END.
           MOVE OPF-TIPO TO RG-OPF-TIPO.
           MOVE NWDATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-OPF-DATA.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
      *
           MOVE RG-OPF-AZI TO SKOPF-AZI.
           MOVE RG-OPF-NUM TO SKOPF-NUM.
           MOVE RG-OPF-PRG TO SKOPF-PRG.
           MOVE ZERO       TO SKOPF-PROG.
           START ORDPRF KEY NOT < KEYOPF INVALID GO TO END-PROG.
       LP-PROG.
           READ ORDPRF NEXT AT END GO TO END-PROG.
           IF RG-OPF-AZI NOT = SKOPF-AZI GO TO END-PROG.
           IF RG-OPF-NUM NOT = SKOPF-NUM GO TO END-PROG.
           IF RG-OPF-PRG NOT = SKOPF-PRG GO TO END-PROG.
           MOVE KOPF-PROG TO RG-OPF-PROG.
           GO TO LP-PROG.
       END-PROG.
           ADD 1 TO RG-OPF-PROG.
      *
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-OPF-AZI  TO KOPF-AZI.
           MOVE RG-OPF-NUM  TO KOPF-NUM.
           MOVE RG-OPF-PRG  TO KOPF-PRG.
           MOVE RG-OPF-PROG TO KOPF-PROG.
           MOVE KEYOPF TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYOPF.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ ORDPRF INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ ORDPRF KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-OPF > ZERO MOVE 7 TO RG-OPF-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE RG-OPF-AZI       TO KOPF-AZI.
           MOVE RG-OPF-NUM       TO KOPF-NUM.
           MOVE RG-OPF-PRG       TO KOPF-PRG.
           MOVE RG-OPF-PROG      TO KOPF-PROG.
      *
           MOVE RG-OPF-DATA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO OPF-DATA.
      *
           MOVE RG-OPF-TIPO      TO OPF-TIPO.
           MOVE RG-OPF-QTAPR     TO OPF-QTAPR.
           MOVE RG-OPF-QTACF     TO OPF-QTACF.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE KOPF-AZI       TO RG-OPF-AZI.
           MOVE KOPF-NUM       TO RG-OPF-NUM.
           MOVE KOPF-PRG       TO RG-OPF-PRG.
           MOVE KOPF-PROG      TO RG-OPF-PROG.
      *
           MOVE OPF-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-OPF-DATA.
      *
           MOVE OPF-TIPO      TO RG-OPF-TIPO.
           MOVE OPF-QTAPR     TO RG-OPF-QTAPR.
           MOVE OPF-QTACF     TO RG-OPF-QTACF.
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
           PERFORM B00-GIORNO THRU B99.
      *
           MOVE RG-OPF-DATA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF RG-OPF-TIPO = ZERO GO TO EX-CARICA-RA.
           IF RG-OPF-TIPO NOT = 1 GO TO CARICA-RA-20.
      * settimana
           MOVE ZERO TO PARSET.
           MOVE 2 TO SE-TCAL.
           CALL 'rsett' USING PARSET PARCDT.
           COMPUTE DAT = ( SE-SS * 100 ) + SE-AA.
           GO TO CARICA-RA-10.
       CARICA-RA-20.
           IF RG-OPF-TIPO = 2 MOVE 1 TO NMESI.
           IF RG-OPF-TIPO = 3 MOVE 2 TO NMESI.
           IF RG-OPF-TIPO = 4 MOVE 3 TO NMESI.
           IF RG-OPF-TIPO = 5 MOVE 4 TO NMESI.
           IF RG-OPF-TIPO = 6 MOVE 6 TO NMESI.
           IF RG-OPF-TIPO = 7 MOVE 12 TO NMESI.
           DIVIDE NMESI INTO MM9 GIVING MM9 REMAINDER RESTO.
           IF RESTO NOT = ZERO ADD 1 TO MM9.
           IF RG-OPF-TIPO < 7
              COMPUTE DAT = ( MM9 * 100 ) + AA9.
       CARICA-RA-10.
           MOVE AA TO RA-OPF-ANNO
           CALL 'ranno4' USING RA-OPF-ANNO
           IF RG-OPF-TIPO NOT = 7
              MOVE MM TO RA-OPF-PERI.
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-OPF-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
      *
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-OPF-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-TIPO.
           MOVE 'OPF-TIPO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TIPO.
           IF NOT (RG-OPF-TIPO = ZERO OR 1 OR 2 OR
                                    3 OR 4 OR 5 OR 6 OR 7)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF FUN NOT = 'V' GO TO E-TIPO.
           IF RG-OPF-DATA NOT = ZERO
              PERFORM CARICA-RA THRU EX-CARICA-RA.
       E-TIPO.
      *
       V-DATA.
           MOVE 'OPF-DATA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA.
           IF RG-OPF-TIPO > ZERO GO TO E-DATA.
           IF RG-OPF-DATA = ZERO GO TO E-DATA.
           MOVE 1 TO TIPOP1.
           MOVE RG-OPF-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DATA.
      *
       V-PERI.
           MOVE 'OPF-PERI' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PERI.
           IF RG-OPF-TIPO = ZERO OR 7
              GO TO E-PERI.
           IF RA-OPF-PERI = ZERO
              PERFORM ERR-DINV
              GO TO V-ERROR.
           IF RG-OPF-TIPO = 1 AND RA-OPF-PERI <= 52 GO TO E-PERI.
           IF RG-OPF-TIPO = 2 AND RA-OPF-PERI <= 12 GO TO E-PERI.
           IF RG-OPF-TIPO = 3 AND RA-OPF-PERI <= 6  GO TO E-PERI.
           IF RG-OPF-TIPO = 4 AND RA-OPF-PERI <= 4  GO TO E-PERI.
           IF RG-OPF-TIPO = 5 AND RA-OPF-PERI <= 3  GO TO E-PERI.
           IF RG-OPF-TIPO = 6 AND RA-OPF-PERI <= 2  GO TO E-PERI.
      *
           PERFORM ERR-DINV.
           GO TO V-ERROR.
       E-PERI.
      *
       V-ANNO.
           MOVE 'OPF-ANNO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ANNO.
           CALL 'ranno4' USING RA-OPF-ANNO.
       E-ANNO.
      *
       V-QTAPR.
           MOVE 'OPF-QTAPR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-QTAPR.
       E-QTAPR.
      *
       V-QTACF.
           MOVE 'OPF-QTACF' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-QTACF.
      **** rel 6.2
           IF RG-OPF-QTACF NOT = ZERO
              PERFORM VER-ART-PRO THRU EX-VER-ART-PRO
              IF NROF > ZERO
                 MOVE 'Quantit Confermata Errata' TO MESS
                 GO TO V-ERROR.
      ************
       E-QTACF.
      *
           IF FUN = 'V' GO TO END-V-DATI.
      * validazione periodo (per FUN = W/d)
       V-DATI-PERIODO.
           MOVE RG-OPF-AZI TO KTR-AZI.
           MOVE 14         TO KTR-TIP.
           READ TABPRO INTO REKTPR14 INVALID
                PERFORM INVK-TPR
                GO TO ERRIO.
           IF SF-TPR = '9A' OR '9D' OR '35' MOVE RF-TPR TO REKTPR14.
           IF TPR14-SETT = ZERO
      **** rel 7.1
      *       MOVE  5 TO TPR14-SETT
      *       MOVE 31 TO TPR14-MESE.
              MOVE  5 TO TPR14-SETT.
           IF TPR14-MESE = ZERO
              MOVE 31 TO TPR14-MESE.
      ************
           IF TPR14-BIM-M = ZERO
              MOVE  2 TO TPR14-BIM-M
              MOVE 31 TO TPR14-BIM-G.
           IF TPR14-TRI-M = ZERO
              MOVE  3 TO TPR14-TRI-M
              MOVE 31 TO TPR14-TRI-G.
           IF TPR14-QUA-M = ZERO
              MOVE  4 TO TPR14-QUA-M
              MOVE 31 TO TPR14-QUA-G.
           IF TPR14-SEM-M = ZERO
              MOVE  6 TO TPR14-SEM-M
              MOVE 31 TO TPR14-SEM-G.
           IF TPR14-ANN-M = ZERO
              MOVE 12 TO TPR14-ANN-M
              MOVE 31 TO TPR14-ANN-G.
           MOVE RA-OPF-ANNO TO AA.
           MOVE RA-OPF-PERI TO MM.
           IF RG-OPF-TIPO = 1
              MOVE ZERO TO PARSET
              MOVE 1  TO SE-TCAL
              MOVE AA TO SE-AA
              MOVE MM TO SE-SS
              MOVE TPR14-SETT TO SE-GIOR
              CALL 'rsett' USING PARSET PARCDT
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GGMMAA TO RG-OPF-DATA.
           IF RG-OPF-TIPO = 2
              COMPUTE DAT = (TPR14-MESE * 10000) + ( MM * 100 ) + AA.
           IF RG-OPF-TIPO = 3
              COMPUTE DAT = (TPR14-BIM-G * 10000) +
              ((((MM - 1) * 2 ) + TPR14-BIM-M) * 100) + AA.
           IF RG-OPF-TIPO = 4
              COMPUTE DAT = (TPR14-TRI-G * 10000) +
              ((((MM - 1) * 3 ) + TPR14-TRI-M) * 100) + AA.
           IF RG-OPF-TIPO = 5
              COMPUTE DAT = (TPR14-QUA-G * 10000) +
              ((((MM - 1) * 4 ) + TPR14-QUA-M) * 100) + AA.
           IF RG-OPF-TIPO = 6
              COMPUTE DAT = (TPR14-SEM-G * 10000) +
              ((((MM - 1) * 6 ) + TPR14-SEM-M) * 100) + AA.
           IF RG-OPF-TIPO = 7
              COMPUTE DAT = (TPR14-ANN-G * 10000) +
              (TPR14-ANN-M * 100) + AA.
           IF RG-OPF-TIPO = 2 OR 3 OR 4 OR 5 OR 6 OR 7
              MOVE DAT TO GGMMAA
              PERFORM A00-FINE-MESE THRU A99
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GGMMAA TO RG-OPF-DATA.
           PERFORM B00-GIORNO THRU B99.
       END-V-DATI.
      *
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
       A00-FINE-MESE.
           ADD 1 TO GG9.
       A10.
           SUBTRACT 1 FROM GG9.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 = 1 GO TO A10.
       A99.
           EXIT.
      *------------------
       B00-GIORNO.
           MOVE RG-OPF-DATA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      **** rel 5.2
      * sostituita creazione descrizione data scadenza con call VRDOPR
           MOVE RG-OPF-TIPO TO PDOP-TIPO.
           MOVE AAGGG TO PDOP-DATA.
           CALL 'vrdopr' USING PAR-PDOP.
           MOVE PDOP-DDAT TO RA-OPF-DATA-D.
      ************
       B99.
           EXIT.
      *------------------
       SUBMAG.
           IF RIF-SALDO = 1     GO TO EX-SUBMAG.
           IF RIF-ARTIC = SPACE GO TO EX-SUBMAG.
           SUBTRACT RIF-QARR FROM RIF-QUANT GIVING RESID.
           IF RESID NOT > ZERO GO TO EX-SUBMAG.
           MOVE RIF-AZI   TO KMA-AZI.
           MOVE RIF-ARTIC TO KMA-ART.
       SMAG1.
           READ MAGART INTO REKART KEPT LOCK INVALID PERFORM INVK-ART
                                                     PERFORM VISK-RIF
                                                     GO TO ERRIO.
           IF SF-ART NOT = ZERO PERFORM REC-LOCK
                                GO TO SMAG1.
           MOVE KMA-AZI   TO KAD-AZI.
           MOVE ORF-CDDEP TO KAD-DEP.
           MOVE KMA-ART   TO KAD-ART.
       SMAG2.
           READ MAGARD INTO REKARD KEPT LOCK INVALID PERFORM INVK-ARD
                                                     PERFORM VISK-RIF
                                                     GO TO ERRIO.
           IF SF-ARD NOT = ZERO PERFORM REC-LOCK
                                GO TO SMAG2.
      *** rel 5.1-1
           IF RIF-UNMIS NOT = ART-UNMIS AND
              ART-COEFF NOT = ZERO
                 COMPUTE RD-NUM = RESID / ART-COEFF
                 CALL 'vrround' USING QTA-S PARRD ART-TQUAN
                 MOVE RD-NUM TO RESID.
      *************
           SUBTRACT RESID FROM ART-IMPFO ARD-DORDA.
           REWRITE RF-ART FROM REKART INVALID PERFORM INVK-ART
                                              PERFORM VISK-RIF
                                              GO TO ERRIO.
           UNLOCK MAGART.
           REWRITE RF-ARD FROM REKARD INVALID PERFORM INVK-ARD
                                              PERFORM VISK-RIF
                                              GO TO ERRIO.
           UNLOCK MAGARD.
       EX-SUBMAG.
          EXIT.
      *------------------
       ADDMAG.
           IF RIF-ARTIC = SPACE GO TO EX-ADDMAG.
           SUBTRACT RIF-QARR FROM RIF-QUANT GIVING RESID.
           IF RESID NOT > ZERO GO TO EX-ADDMAG.
           MOVE ORF-AZI   TO KMA-AZI.
           MOVE RIF-ARTIC TO KMA-ART.
       LRART.
           READ MAGART INTO REKART KEPT LOCK INVALID PERFORM INVK-ART
                                                     PERFORM VISK-RIF
                                                     GO TO ERRIO.
           IF SF-ART NOT = ZERO PERFORM REC-LOCK
                                GO TO LRART.
           MOVE KMA-AZI   TO KAD-AZI.
           MOVE ORF-CDDEP TO KAD-DEP.
           MOVE KMA-ART   TO KAD-ART.
       LRARD.
           READ MAGARD INTO REKARD KEPT LOCK INVALID PERFORM INVK-ARD
                                                     PERFORM VISK-RIF
                                                     GO TO ERRIO.
           IF SF-ARD NOT = ZERO PERFORM REC-LOCK
                                GO TO LRARD.
      *** rel 5.1-1
           IF RIF-UNMIS NOT = ART-UNMIS AND
              ART-COEFF NOT = ZERO
                 COMPUTE RD-NUM = RESID / ART-COEFF
                 CALL 'vrround' USING QTA-S PARRD ART-TQUAN
                 MOVE RD-NUM TO RESID.
      *************
           ADD RESID TO ART-IMPFO ARD-DORDA.
           REWRITE RF-ART FROM REKART INVALID PERFORM INVK-ART
                                              PERFORM VISK-RIF
                                              GO TO ERRIO.
           UNLOCK MAGART.
           REWRITE RF-ARD FROM REKARD INVALID PERFORM INVK-ARD
                                              PERFORM VISK-RIF
                                              GO TO ERRIO.
           UNLOCK MAGARD.
       EX-ADDMAG.
           EXIT.
      *------------------
       REC-LOCK.
           CALL 'rlock' USING PARLK.
           EXIT.
      *------------------
      **** rel 6.2
       VER-ART-PRO.
           MOVE ZERO TO NROF.

           MOVE RG-OPF-AZI TO KRF-AZI.
           MOVE RG-OPF-NUM TO KRF-NUM.
           MOVE RG-OPF-PRG TO KRF-PRG.
           READ ORDRIF INTO REKRIF INVALID PERFORM INVK-RIF
                                           GO TO ERRIO.
           MOVE RIF-ARTIC TO SAVART.
      *
           MOVE RG-OPF-AZI TO KROF-AZI.
           MOVE RG-OPF-NUM TO ROF-OPF.
           START ORFRIC KEY NOT < SKEYROF1 INVALID GO TO NOROF2.
       RDROF2.
           READ ORFRIC NEXT AT END GO TO NOROF2.
           IF SF-ROF = '9D' OR '9A' OR '35' GO TO RDROF2.
           IF KROF-AZI > RG-OPF-AZI GO TO NOROF2.
           IF ROF-OPF  > RG-OPF-NUM GO TO NOROF2.
      *
           MOVE LOW-VALUE  TO KEYRF.
           MOVE SAVART     TO KRF-ART.
           MOVE KROF-ORD   TO KRF-NU2.
           START ORDRIF KEY NOT < KEYRF2 INVALID GO TO NOPRO.
       RDPRO.
           READ ORDRIF NEXT INTO REKRIF AT END GO TO NOPRO.
           IF SF-RIF = '9D' OR '9A' OR '35' GO TO RDPRO.
           IF KRF-ART NOT = SAVART GO TO NOPRO.
           IF KRF-NU2 NOT = KROF-ORD GO TO NOPRO.

           IF KRF-AZI NOT = RG-OPF-AZI GO TO RDPRO.

           ADD 1 TO NROF.
           GO TO NOROF2.
       NOPRO.
      *
           GO TO RDROF2.
       NOROF2.

       EX-VER-ART-PRO.
           EXIT.
      *------------------*
      ************
      **** rel 7.1
       CALL-VSRV133-R.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'RIF'   TO PPAR-TARC.
           MOVE KEYRF   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 RIF ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------
       CALL-VSRV133-O.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'OPF'   TO PPAR-TARC.
           MOVE KEYOPF  TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           IF PPAR-TOPE = 'C'
      **** rel 7.2
      *       MOVE ORF-DAT TO PPAR-OPZ(1:5).
              MOVE DTINT TO PPAR-OPZ(1:5).
      ************
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 OPF ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------
      ************
