       IDENTIFICATION DIVISION.
       PROGRAM-ID. VORD180.
      *
      * OGGETTO: Valorizzazione bolle clienti non fatturate
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'gribctsl'.
           COPY 'gribcrsl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'gribct'.
           COPY 'gribcr'.
           COPY 'gritab'.
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 9 DATA RECORD RF-LAV.
       01  RF-LAV.
           02 KEYLV.
             05 KLV-CLI   PIC 9(5) COMP-3.
             05 KLV-NUM   PIC 9.
             05 KLV-BOL   PIC 9(5).
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
           COPY 'griclfrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parer'.
           COPY 'paracf'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-BCT PIC X(15) VALUE 'bolcte'.
       01  ID-BCR PIC X(15) VALUE 'bolcri'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  COMODI .
           05 SF-AZI   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-CLF   PIC XX.
           05 SF-BCT   PIC XX.
           05 SF-BCR   PIC XX.
           05 SF-LAV   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 CLIPRE  PIC 9(5).
           05 DATBL   PIC 9(5) COMP-3 VALUE ZERO.
           05 DATFA   PIC 9(5) COMP-3 VALUE ZERO.
           05 DADAT   PIC 9(5) COMP-3 VALUE ZERO.
           05 PKDAT   PIC 9(5) COMP-3.
           05 AA0     PIC 9(4).
           05 MM0     PIC 99.
           05 GIORNI PIC 9(4).
           05 MESI   PIC 9(4).
           05 RESTO  PIC 9(4).
           05 VALUT  PIC 999.
           05 K      PIC 99.
           05 J      PIC 99.
           05 KI     PIC 99.
           05 JI     PIC 99.
           05 NRATA  PIC 99.
           05 VALOR  PIC S9(15)V99 VALUE ZERO.
           05 IMRATA PIC S9(11)V99 VALUE ZERO.
           05 IMPZ   PIC -------9,999.
           05 EIMPZ REDEFINES IMPZ PIC -------9.999.
           05 ITRONC REDEFINES IMPZ.
              10 IMPX   PIC X(8).
              10 FILLER PIC X(4).
           05 TOTALI.
              10 TOT PIC S9(11)V99 OCCURS 14.
      **** rel 6.0a
           05 TOTIMP   PIC S9(12)V99   VALUE ZERO.
      *************
           05 CFOR.
              10 MAS PIC 99.
              10 COD PIC 9(5).
           05 TBMM   PIC X(36) VALUE
             'GENFEBMARAPRMAGGIULUGAGOSETOTTNOVDIC'.
           05 TBM    REDEFINES TBMM PIC XXX OCCURS 12.
           05 RMESI.
              10 FILLER PIC X(18)  VALUE 'Gennaio'.
              10 FILLER PIC X(18)  VALUE 'Febbraio'.
              10 FILLER PIC X(18)  VALUE 'Marzo'.
              10 FILLER PIC X(18)  VALUE 'Aprile'.
              10 FILLER PIC X(18)  VALUE 'Maggio'.
              10 FILLER PIC X(18)  VALUE 'Giugno'.
              10 FILLER PIC X(18)  VALUE 'Luglio'.
              10 FILLER PIC X(18)  VALUE 'Agosto'.
              10 FILLER PIC X(18)  VALUE 'Settembre'.
              10 FILLER PIC X(18)  VALUE 'Ottobre'.
              10 FILLER PIC X(18)  VALUE 'Novembre'.
              10 FILLER PIC X(18)  VALUE 'Dicembre'.
           05 RMESE REDEFINES RMESI PIC X(18) OCCURS 12.
           05 DTCON  PIC 9(5) COMP-3.
           05 TDOC   PIC 9 VALUE ZERO.
           05 COMEURO PIC 9(3).
           05 FLGMCL   PIC 9    VALUE ZERO.
       01  WDS-REC.
           05 WDS-IMP PIC S9(11)V99 OCCURS 14.

           COPY 'vord180.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-DTFAT     PIC 9(6).
           05 IF-DATA      PIC 9(6).
           05 IF-LIREUR    PIC 9.
           05 IF-TPVAL     PIC 9.
           05 IF-DADAT     PIC 9(6).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dclbct'.
           COPY 'dclbcr'.
           COPY 'dcltab'.
           COPY 'dcllav'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vord180: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI TABELL ANACLF BOLCTE BOLCRI WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'erreur'.
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'gribcter'.
           COPY 'gribcrer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O WDSLAV.
           OPEN INPUT ANAAZI TABELL ANACLF BOLCTE BOLCRI.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MAS.
      *
           CALL 'rveur' USING COMEURO.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
           MOVE ZERO TO IF-DTFAT.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DATA.
           MOVE ZERO TO IF-LIREUR.
           MOVE 1    TO IF-TPVAL.
           SUBTRACT 1 FROM MM9.
           MOVE 1 TO GG9.
           IF MM9 = ZERO
              SUBTRACT 1 FROM AA9
              MOVE 12 TO MM9.
           MOVE GGMMAA TO IF-DADAT.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DTFAT.
           MOVE 'IF-DTFAT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTFAT.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTFAT TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DATFA.
       E-DTFAT.
      *
       V-DATA.
           MOVE 'IF-DATA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKDAT.
           MOVE AA4 TO AA0.
           MOVE MM9 TO MM0.
           IF GG9 < 15 SUBTRACT 1 FROM MM0.
           IF MM0 = ZERO MOVE 12 TO MM0  SUBTRACT 1 FROM AA0.
       E-DATA.
      *
       V-DADAT.
           MOVE 'IF-DADAT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DADAT.
           MOVE 1 TO TIPOP1.
           MOVE IF-DADAT TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DADAT.
       E-DADAT.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           MOVE ZERO TO IEUR.
           IF IF-LIREUR = 1
              MOVE 'E' TO IEUR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO TDATEL.
           MOVE ZERO TO XCRR.
           MOVE AZRGSOC TO TAZI.
           MOVE ZERO TO J.
           MOVE MM0 TO K.
       CALC01.
           ADD 1 TO J K.
           IF J > 8 GO TO CALC02.
           IF K > 12 MOVE 1 TO K.
           MOVE TBM(K) TO TMM(J).
           GO TO CALC01.
       CALC02.
           MOVE 'OLTRE' TO TOLTRE.
           MOVE ZERO TO NPAG.
           MOVE ZERO TO TOT(1).
           MOVE ZERO TO TOT(2).
           MOVE ZERO TO TOT(3).
           MOVE ZERO TO TOT(4).
           MOVE ZERO TO TOT(5).
           MOVE ZERO TO TOT(6).
           MOVE ZERO TO TOT(7).
           MOVE ZERO TO TOT(8).
           MOVE ZERO TO TOT(9).
           MOVE ZERO TO TOT(10).
           MOVE ZERO TO TOT(11).
           MOVE ZERO TO TOT(12).
           MOVE ZERO TO TOT(13).
           MOVE ZERO TO TOT(14).
           MOVE ZERO TO CLIPRE.

      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'VALORIZZAZIONE BOLLE DA FATTURARE'
                  DELIMITED SIZE INTO RP-TIT1.
      *
           STRING 'IN CORSO AL ' TDATEL
                  DELIMITED SIZE INTO RP-TIT2.
      *
           PERFORM RPT-RIG1-INTC THRU EX-RPT-RIG1-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

      *  TESTATE  *
           MOVE LOW-VALUE TO KEYBC.
           MOVE ZERO  TO BCT-CLI.
       L020.
           MOVE DADAT TO BCT-DATA.
           START BOLCTE KEY NOT < SKEYBC1 INVALID GO TO L040.
       L030.
           READ BOLCTE NEXT AT END GO TO L040.
           IF SF-BCT = '9D' OR '9A' OR '35' GO TO L030.
           IF BCT-DATA < DADAT GO TO L020.
           IF KBC-AZI NOT = KAZ-COD GO TO L030.
           IF BCT-FLGFT > ZERO GO TO L030.
           IF BCT-ESCFAT > ZERO GO TO L030.
      *> Skippa le bolle con data > di quella presunta da fatturare
           IF BCT-DATA > DATFA GO TO L030.
           MOVE BCT-CLI TO KLV-CLI.
           MOVE KBC-NUM TO KLV-NUM.
           MOVE KBC-BOL TO KLV-BOL.
           WRITE RF-LAV INVALID MOVE 'WR-LAV' TO MESS GO TO ERRIO.
           GO TO L030.
       L040.
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID KEY GO TO EX-RUN-ELABORA.
       L045.
           READ WDSLAV NEXT AT END GO TO ENDSTA.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO L045.
           IF KLV-CLI > CLIPRE PERFORM D00-STAMPA THRU D99.
           MOVE KAZ-COD TO KBC-AZI.
           MOVE KLV-NUM TO KBC-NUM.
           MOVE KLV-BOL TO KBC-BOL.
           START BOLCTE KEY NOT < KEYBC INVALID
                        PERFORM INVK-BCT GO TO ERRIO.
           IF NOT ( KLV-NUM = KBC-NUM AND KLV-BOL = KBC-BOL)
                                                  GO TO L045.
       L050.
           READ BOLCTE NEXT AT END GO TO L045.
           IF SF-BCT = '9D' OR '9A' OR '35' GO TO L050.
           IF KBC-AZI > KAZ-COD GO TO L045.
           IF NOT ( KLV-NUM = KBC-NUM AND KLV-BOL = KBC-BOL)
                                                  GO TO L045.
           MOVE BCT-TDOC TO TDOC.
           MOVE 4 TO KTB-TIP.
           MOVE BCT-CPAG TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ZERO TO REKTAB.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE BCT-DATA TO DATBL.
           MOVE BCT-VALUT TO VALUT.
           IF T04-1SCAD = ZERO OR 1 OR 2 OR 5
              MOVE DATFA TO DTCON.
           IF T04-1SCAD = 3 OR 4 MOVE DATBL TO DTCON.
           IF VALUT = ZERO OR COMEURO GO TO L055.
           MOVE ZERO  TO ER-DATA.
           CALL 'rvalut' USING VALUT ER-DATA CG-PAR.
           IF CG-ST > ZERO
              PERFORM ERR-EURO
              MOVE MESS  TO F-MES1
              MOVE SPACE TO F-MES2
              STRING 'Codice Valuta ' , VALUT DELIMITED SIZE
                                 INTO F-MES2
              PERFORM VISK-BCT
              GO TO ERRIO.
       L055.
      **** rel 6.0a
           MOVE ZERO TO TOTIMP.
      *************
      *  RIGHI  *
           MOVE KAZ-COD TO KCR-AZI.
           MOVE KBC-NUM TO KCR-NUM.
           MOVE KBC-BOL TO KCR-BOL.
           MOVE 1       TO KCR-PGR.
           START BOLCRI KEY NOT < KEYCR INVALID GO TO FINERIG.
       LETT01.
           READ BOLCRI NEXT AT END GO TO FINERIG.
           IF SF-BCR = '9D' OR '9A' OR '35' GO TO LETT01.
           IF KCR-AZI > KAZ-COD GO TO FINERIG.
           IF KCR-NUM > KBC-NUM GO TO FINERIG.
           IF KCR-BOL > KBC-BOL GO TO FINERIG.
           IF KCR-PGR = ZERO    GO TO FINERIG.
      *
           COPY 'grirpt-r'.
      *
       L060.
           IF BCR-TCOR = 1 GO TO LETT01.
           IF BCR-TCOR > 3 AND < 7 GO TO LETT01.
           MOVE BCR-NETRG TO VALOR.
      **** rel 6.0a
           IF BCR-TCOR NOT = 3 GO TO L063.
           MOVE BCR-SPESA TO KTB-COD.
           MOVE 11 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ZERO TO VALOR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T11-TIMP = ZERO MOVE BCR-NETRG TO VALOR
           ELSE COMPUTE VALOR = TOTIMP * BCR-PROVV / 100.
           IF T11-TACC = 2 AND VALOR > ZERO MULTIPLY -1 BY VALOR.

      * rilegge pagamento
           MOVE 4 TO KTB-TIP.
           MOVE BCT-CPAG TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ZERO TO REKTAB.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
       L063.
      *************
           IF VALUT = ZERO OR COMEURO GO TO L065.
           MOVE VALOR TO ER-IMPORTO.
           MOVE CG-CAMBIO TO ER-CAMBIO.
           MOVE CG-VALUT  TO ER-VALUT.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT
                               ER-CAMBIO.
           MOVE ER-IMPORTO TO VALOR.
       L065.
      **** rel 6.0a
           ADD VALOR TO TOTIMP.
      *************
           IF IF-TPVAL = ZERO PERFORM C00-CALCOLO-MESE THRU C99
                              GO TO L081.
           IF T04-NRATE = ZERO MOVE 2 TO K  GO TO L080.
           COMPUTE IMRATA = VALOR / T04-NRATE.
           MOVE 1 TO NRATA.
           MOVE T04-NG1SC TO GIORNI.
           PERFORM B00-CALCOLO-MESE THRU B99.
       L070.
           ADD 1 TO NRATA.
           IF NRATA > T04-NRATE GO TO L080.
           ADD T04-NGSSC TO GIORNI.
           PERFORM B00-CALCOLO-MESE THRU B99.
           GO TO L070.
       L080.
           IF TDOC = 3 SUBTRACT VALOR FROM WDS-IMP(K)
           ELSE ADD VALOR TO WDS-IMP(K).
       L081.
           GO TO LETT01.
       FINERIG.
           GO TO L045.
      *
       ENDSTA.
           PERFORM D00-STAMPA THRU D50.
           MOVE ALL '-' TO P999.
           MOVE 2 TO XCRR.
           MOVE 'RIG3' TO RP-BLK.
           MOVE 2 TO RP-FLGR.
           PERFORM RPT-WR.
           MOVE ZERO TO K.
       L150.
           ADD 1 TO K.
           IF K > 10 GO TO L160.
           MOVE TOT(K) TO IMPZ.
           IF IF-LIREUR = 1
              MOVE TOT(K) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EIMPZ.
           IF K = 1 MOVE IMPX TO P2IMP1.
           IF K = 2 MOVE IMPX TO P2IMP2.
           IF K = 3 MOVE IMPX TO P2IMP3.
           IF K = 4 MOVE IMPX TO P2IMP4.
           IF K = 5 MOVE IMPX TO P2IMP5.
           IF K = 6 MOVE IMPX TO P2IMP6.
           IF K = 7 MOVE IMPX TO P2IMP7.
           IF K = 8 MOVE IMPX TO P2IMP8.
           IF K = 9 MOVE IMPX TO P2IMP9.
           IF K = 10 MOVE IMPX TO P2IMP10.
           GO TO L150.
       L160.
           MOVE 1 TO XCRR.
           MOVE 'T O T A L I' TO P2RAG.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE ALL '-' TO P999.
           MOVE 2 TO XCRR.
           MOVE 'RIG3' TO RP-BLK.
           MOVE 2 TO RP-FLGR.
           PERFORM RPT-WR.
           MOVE ZERO TO K.
           MOVE ZERO TO VALOR.
       L170.
           ADD 1 TO K.
           IF K > 10 GO TO L180.
           ADD TOT(K) TO VALOR.
           MOVE VALOR TO IMPZ.
           IF IF-LIREUR = 1
              MOVE VALOR TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EIMPZ.
           IF K = 1 MOVE IMPX TO P2IMP1.
           IF K = 2 MOVE IMPX TO P2IMP2.
           IF K = 3 MOVE IMPX TO P2IMP3.
           IF K = 4 MOVE IMPX TO P2IMP4.
           IF K = 5 MOVE IMPX TO P2IMP5.
           IF K = 6 MOVE IMPX TO P2IMP6.
           IF K = 7 MOVE IMPX TO P2IMP7.
           IF K = 8 MOVE IMPX TO P2IMP8.
           IF K = 9 MOVE IMPX TO P2IMP9.
           IF K = 10 MOVE IMPX TO P2IMP10.
           GO TO L170.
       L180.
           MOVE 1 TO XCRR.
           MOVE 'PROGRESSIVI' TO P2RAG.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       B00-CALCOLO-MESE.
           MOVE 2 TO TIPOP1.
           DIVIDE 30 INTO GIORNI GIVING MESI REMAINDER RESTO.
           IF RESTO > ZERO GO TO B10.
           MOVE DTCON TO AAGGG.
           CALL 'rdata' USING PARCDT.
           ADD MESI TO MM9.
           IF MM9 > 12 ADD 1 TO AA4  SUBTRACT 12 FROM MM9.
           GO TO B20.
       B10.
           MOVE DTCON TO AAGGG.
           ADD GIORNI TO AAGGG.
           CALL 'rdata' USING PARCDT.
       B20.
           IF CLF-GSFM NOT = ZERO PERFORM SOMMA-GG THRU EX-SOMMA-GG.
           IF NRATA = 1
              MOVE ZERO TO FLGMCL
           ELSE
              IF FLGMCL = ZERO
                 GO TO B50
              ELSE
                 GO TO B35.

           MOVE 1 TO K.
       B30.
           IF K > 12 GO TO B32.
           IF RACF-ESCM(K) = ZERO
              ADD 1 TO K
              GO TO B30.
           MOVE 1 TO FLGMCL.
           GO TO B35.

       B32.
           MOVE 1 TO K.
       B33.
           IF K > 12 GO TO B50.
           IF T04-ESCM(K) = ZERO
              ADD 1 TO K
              GO TO B33.
           MOVE 2 TO FLGMCL.

       B35.
           IF (FLGMCL = 1 AND RACF-ESCM(MM9) = 1) OR
              (FLGMCL = 2 AND T04-ESCM(MM9) = 1)
                 GO TO B40.

           GO TO B50.
       B40.
           IF MM9 = 12
              MOVE 1 TO MM9
              ADD 1  TO AA4
           ELSE
              ADD 1 TO MM9.
           GO TO B35.

       B50.
      ************
      **** rel 7.1
           IF AA4 > AA0 + 1 MOVE 14 TO K  GO TO B90.
      ************
           IF AA4 > AA0 AND MM9 > MM0 MOVE 14 TO K  GO TO B90.
           IF AA4 = AA0 AND MM9 NOT > MM0 MOVE 2 TO K  GO TO B90.
           MOVE MM9 TO K.
           IF MM9 NOT > MM0 ADD 12 TO K.
           SUBTRACT MM0 FROM K.
           ADD 1 TO K.
       B90.
           IF TDOC = 3 SUBTRACT IMRATA FROM WDS-IMP(K)
           ELSE ADD IMRATA TO WDS-IMP(K).
           SUBTRACT IMRATA FROM VALOR.
       B99. EXIT.
      *------------------
       D00-STAMPA.
           IF CLIPRE = ZERO GO TO D50.
           IF WDS-IMP(1) = ZERO AND
              WDS-IMP(2) = ZERO AND
              WDS-IMP(3) = ZERO AND
              WDS-IMP(4) = ZERO AND
              WDS-IMP(5) = ZERO AND
              WDS-IMP(6) = ZERO AND
              WDS-IMP(7) = ZERO AND
              WDS-IMP(8) = ZERO AND
              WDS-IMP(9) = ZERO AND
              WDS-IMP(10) = ZERO AND
              WDS-IMP(11) = ZERO AND
              WDS-IMP(12) = ZERO AND
              WDS-IMP(13) = ZERO AND
              WDS-IMP(14) = ZERO GO TO D50.
           ADD WDS-IMP(11) TO WDS-IMP(10).
           ADD WDS-IMP(12) TO WDS-IMP(10).
           ADD WDS-IMP(13) TO WDS-IMP(10).
           ADD WDS-IMP(14) TO WDS-IMP(10).
           MOVE ZERO TO WDS-IMP(11) WDS-IMP(12)
                        WDS-IMP(13) WDS-IMP(14).
           MOVE ZERO TO K.
       D30.
           ADD 1 TO K.
           IF K > 10 GO TO D40.
           MOVE WDS-IMP(K) TO IMPZ.
           IF IF-LIREUR = 1
              MOVE WDS-IMP(K) TO ER-IMPORTO
              CALL 'rlitimp' USING ER-IMPORTO
              MOVE ER-IMPORTO TO EIMPZ.
           IF K = 1 MOVE IMPX TO PIMP1.
           IF K = 2 MOVE IMPX TO PIMP2.
           IF K = 3 MOVE IMPX TO PIMP3.
           IF K = 4 MOVE IMPX TO PIMP4.
           IF K = 5 MOVE IMPX TO PIMP5.
           IF K = 6 MOVE IMPX TO PIMP6.
           IF K = 7 MOVE IMPX TO PIMP7.
           IF K = 8 MOVE IMPX TO PIMP8.
           IF K = 9 MOVE IMPX TO PIMP9.
           IF K = 10 MOVE IMPX TO PIMP10.
           ADD WDS-IMP(K) TO TOT(K).
           GO TO D30.
       D40.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
           MOVE 1 TO XCRR.
       D50. EXIT.
       D60.
           MOVE ZERO TO WDS-IMP(1).
           MOVE ZERO TO WDS-IMP(2).
           MOVE ZERO TO WDS-IMP(3).
           MOVE ZERO TO WDS-IMP(4).
           MOVE ZERO TO WDS-IMP(5).
           MOVE ZERO TO WDS-IMP(6).
           MOVE ZERO TO WDS-IMP(7).
           MOVE ZERO TO WDS-IMP(8).
           MOVE ZERO TO WDS-IMP(9).
           MOVE ZERO TO WDS-IMP(10).
           MOVE ZERO TO WDS-IMP(11).
           MOVE ZERO TO WDS-IMP(12).
           MOVE ZERO TO WDS-IMP(13).
           MOVE ZERO TO WDS-IMP(14).
           MOVE KLV-CLI TO CLIPRE.
           MOVE CLIPRE  TO PCLI COD.
           MOVE KAZ-COD TO KCF-AZI.
           MOVE CFOR TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID MOVE ALL '*' TO CLF-RGSOC
                                           MOVE ZERO TO CLF-GSFM.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           MOVE CLF-RGSOC TO PRAG.
           MOVE KAZ-COD    TO RACF-AZI.
           MOVE CFOR       TO RACF-COD.
           CALL 'rrdacf' USING PARACF.
       D99. EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       SOMMA-GG.
           IF NOT ( T04-1SCAD = 2 OR 4 ) GO TO EX-SOMMA-GG.
           DIVIDE 30 INTO CLF-GSFM GIVING MESI.
           ADD 1 TO MESI.
           ADD MESI TO MM9.
           IF MM9 > 12 ADD 1 TO AA4  SUBTRACT 12 FROM MM9.
       EX-SOMMA-GG.
           EXIT.
      *------------------
       C00-CALCOLO-MESE.
           MOVE 2 TO TIPOP1.
           MOVE DTCON TO AAGGG.
           CALL 'rdata' USING PARCDT.
           IF AA4 > AA0 AND MM9 > MM0 MOVE 14 TO K  GO TO C90.
           IF AA4 = AA0 AND MM9 NOT > MM0 MOVE 2 TO K  GO TO C90.
           MOVE MM9 TO K.
           IF MM9 NOT > MM0 ADD 12 TO K.
           SUBTRACT MM0 FROM K.
           ADD 1 TO K.
       C90.
           IF TDOC = 3 SUBTRACT VALOR FROM WDS-IMP(K)
           ELSE ADD VALOR TO WDS-IMP(K).
       C99.
           EXIT.
      *------------------
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'Cliente' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Scaduto' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *
           MOVE ZERO TO JI.
           MOVE MM0 TO KI.
       CALC01I.
           ADD 1 TO JI KI.
           IF JI > 8 GO TO CALC02I.
           IF KI > 12 MOVE 1 TO KI.
           MOVE RMESE(KI) TO RP-IFLD.
           PERFORM RPT-ADD-I.
           GO TO CALC01I.
       CALC02I.
           MOVE 'Oltre' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
       EX-RPT-RIG1-INTC.
           EXIT.
      *------------------
