       IDENTIFICATION DIVISION.
       PROGRAM-ID. VORDG35.
      *
      *    Interfaccia BOLCRI per scheda
      *
      *--------------------------------------------------------------
      * Note:
      * - IF-FUN: oltre ai valori soliti, puo' essere anche:
      *       e=evasione record selezionati da zoom multiplo
      **** rel 2.0
      *       z=evasione record selezionati da zoom multiplo pronti
      *       T=per tipo rigo 0, importa nelle note aggiuntive del
      *         rigo bolla, le note interne caricate sull'articolo.
      *         Restituisce un warning nel caso che non si possa
      *         importare i dati dell'articolo perche' ci sono gia'
      *         delle note caricate sul rigo bolla
      ************
      *--------------------------------------------------------------
      *
      **** rel 1.2
      *    Ricompilato per variazione tracciato LISVEN e PARVE
      ************
      *
      **** rel 5.2
      * Ricompilato per copy griartrk variata 
      * per campi sconti con decimali
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gritabsl'.
           COPY 'griordsl'.
           COPY 'gririgsl'.
           COPY 'gribctsl'.
           COPY 'gribcrsl'.
           COPY 'griartsl'.
           COPY 'griardsl'.
           COPY 'griobcsl'.
           COPY 'griclfsl'.
           COPY 'griconsl'.
      **** rel 5.2
      *    COPY 'grilissl'.
      *    COPY 'grilvesl'.
      ************
      **** rel 2.0
           COPY 'grinatsl'.
           COPY 'grincrsl'.
           COPY 'grinrisl'.
           COPY 'griporsl'.
           COPY 'gripbrsl'.
      **** rel 5.2
      *    COPY 'grisccsl'.
      ************
      ************
      **** rel 5.0
           COPY 'griopcsl'.
           COPY 'gritprsl'.
           COPY 'griarnsl'.
      **** rel 5.2
      *    COPY 'grilpssl'.
      ************
      ************
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
      **** rel 2.0
           SELECT WDSLA1 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL1 STATUS SF-LA1.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gritab'.
           COPY 'griord'.
           COPY 'gririg'.
           COPY 'gribct'.
           COPY 'gribcr'.
           COPY 'griart'.
           COPY 'griard'.
           COPY 'griobc'.
           COPY 'griclf'.
           COPY 'gricon'.
      **** rel 5.2
      *    COPY 'grilis'.
      *    COPY 'grilve'.
      ************
      **** rel 2.0
           COPY 'grinat'.
           COPY 'grincr'.
           COPY 'grinri'.
           COPY 'gripor'.
           COPY 'gripbr'.
      **** rel 5.2
      *    COPY 'griscc'.
      ************
      ************
      **** rel 5.0
           COPY 'griopc'.
           COPY 'gritpr'.
           COPY 'griarn'.
      **** rel 5.2
      *    COPY 'grilps'.
      ************
      ************
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 8 DATA RECORD RF-LAV.
       01  RF-LAV.
           02 KEYLV.
             05 KLV-NORD   PIC 9(5).
             05 KLV-PGR    PIC 999.
      **** rel 2.0
      *
       FD  WDSLA1 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA1
           RECORD 11 DATA RECORD RF-LA1.
       01  RF-LA1.
           02 KEYL1.
             05 KL1-NORD   PIC 9(5).
             05 KL1-RORD   PIC 999.
             05 KL1-PGR    PIC 999.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'griclfrk'.
           COPY 'griconrk'.
           COPY 'gritabrk'.
           COPY 'griordrk'.
           COPY 'gririgrk'.
           COPY 'griartrk'.
           COPY 'griardrk'.
      **** rel 5.2
      *    COPY 'rekt52'.
      ************
      **** rel 5.0
           COPY 'grit25rk'.
           COPY 'gritpr12'.
      ************
           COPY 'parmag'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parim'.
           COPY 'parrd'.
           COPY 'parve'.
      **** rel 1.2
           COPY 'parlk'.
      ************
      **** rel 2.0
           COPY 'parmb'.
           COPY 'parml'.
      ************
      **** rel 5.0
           COPY 'parbc'.
           COPY 'paroc'.
      ************
      **** rel 4.0
           COPY 'pardp'.
           COPY 'parer'.
      **** rel 5.2
      *    COPY 'parbl'.
      ************
      ************
      **** rel 5.2
           COPY 'parrpz'.
           COPY 'parpcfa'.
      ************
      **** rel 6.0a
           COPY 'parrpv'.
      ************
      **** rel 6.1
           COPY 'parrcr'.
      ************
      **** rel 6.2
           COPY 'partdc'.
      ************
      **** rel 7.1
           COPY 'parppar'.
      *
       01 S-KEYMM.
           05 S-KMM-AZI PIC 999.
           05 S-KMM-DEP PIC 99.
           05 S-KMM-ART PIC X(18).
           05 S-KMM-DAT PIC 9(5) COMP-3.
           05 S-KMM-NUM PIC 9(5) COMP-3.
      ************
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-ORD PIC X(15) VALUE 'ordcli'.
       01  ID-RIG PIC X(15) VALUE 'ordrig'.
       01  ID-BCT PIC X(15) VALUE 'bolcte'.
       01  ID-BCR PIC X(15) VALUE 'bolcri'.
       01  ID-ART PIC X(15) VALUE 'magart'.
       01  ID-ARD PIC X(15) VALUE 'magard'.
       01  ID-OBC PIC X(15) VALUE 'bolord'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
      **** rel 5.2
      *01  ID-LIS PIC X(15) VALUE 'listin'.
      *01  ID-LVE PIC X(15) VALUE 'lisven'.
      ************
       01  ID-LAV PIC X(45).
      **** rel 5.0
       01  ID-OPC PIC X(15) VALUE 'ordprc'.
       01  ID-TPR PIC X(15) VALUE 'tabpro'.
       01  ID-ARN PIC X(15) VALUE 'arcnot'.
      **** rel 5.2
      *01  ID-LPS PIC X(15) VALUE 'lprosc'.
      ************
      ************
      **** rel 2.0
       01  ID-LA1 PIC X(45).
       01  ID-POR PIC X(15) VALUE 'prorig'.
       01  ID-PBR PIC X(15) VALUE 'probcr'.
       01  ID-NCR PIC X(15) VALUE 'notbcr'.
       01  ID-NRI PIC X(15) VALUE 'notrig'.
       01  ID-NAT PIC X(15) VALUE 'notart'.
      **** rel 5.2
      *01  ID-SCC PIC X(15) VALUE 'scocat'.
      ************
      *--------------------------------------------------------
      * costanti
      *    NRIGMAX: n. righe max note aggiuntive rigo cliente
      **** rel 6.2
      *    NRIGMAX: n. righe fisiche max in pari con occurs
      *    NCOLMAX: n. colonne fisiche max
       78  NRIGMAX VALUE 100.
       78  NCOLMAX VALUE 60.
      *78  NRIGMAX VALUE 20.
      ************
      *--------------------------------------------------------
      ************
       01  COMODI.
           05 SF-AZI PIC XX.
           05 SF-TAB PIC XX.
           05 SF-ORD PIC XX.
           05 SF-RIG PIC XX.
           05 SF-BCT PIC XX.
           05 SF-BCR PIC XX.
           05 SF-ART PIC XX.
           05 SF-ARD PIC XX.
           05 SF-OBC PIC XX.
           05 SF-CLF PIC XX.
           05 SF-CON PIC XX.
      **** rel 5.2
      *    05 SF-LIS PIC XX.
      *    05 SF-LVE PIC XX.
      ************
           05 SF-LAV PIC XX.
      **** rel 5.0
           05 SF-OPC PIC XX.
           05 SF-TPR PIC XX.
           05 SF-ARN  PIC XX.
      **** rel 5.2
      *    05 SF-LPS  PIC XX.
      ************
      ************
      **** rel 2.0
           05 SF-LA1 PIC XX.
           05 SF-POR PIC XX.
           05 SF-PBR PIC XX.
           05 SF-NCR PIC XX.
           05 SF-NRI PIC XX.
           05 SF-NAT PIC XX.
      **** rel 5.2
      *    05 SF-SCC PIC XX.
      ************
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(30).
           05 IF-AZI   PIC 9(3).
           05 IF-NUM   PIC 9.
           05 IF-BOL   PIC 9(5).
           05 IF-PGR   PIC 999.
      **** rel 5.0
           05 IF-INTRA PIC 9.
      **** rel 5.2
      *    05 K         PIC 99.
      *    05 SCAPP     PIC S99V99.
      ************
      ************
           05 CODICE.
              10 MAS    PIC 99.
              10 COD    PIC 9(5).
      **** rel 5.1
           05 MCLI     PIC 99.
           05 MFOR     PIC 99.
      ************
           05 SWDEL    PIC 9.
           05 SWERR    PIC 9.
           05 WART     PIC X(18).
           05 IVGR     PIC 9(7)       VALUE ZERO.
           05 IVRB     PIC 9.
           05 RESID    PIC S9(10)V999 VALUE ZERO.
           05 QUAN     PIC S9(10)V999 VALUE ZERO.
           05 OLDQTA   PIC S9(10)V999 VALUE ZERO.
      **** rel 2.0
      *    05 SW-RDORD PIC 9.
           05 SAVORD   PIC 9(5).
      * flgagg: aggiornamento archivi per fatture proforma
           05 FLGAGG  PIC 9.
      ************
           05 SAVSALDO PIC 9.
           05 DESCRIZIONE.
              10 FILLER PIC X(12) VALUE '* NS.RIF.N.'.
              10 DES2   PIC ZZZZ9 VALUE ZERO.
              10 FILLER PIC XXX VALUE ' -'.
              10 DES4   PIC X(8) VALUE SPACE.
           05 DESCRIZIONE2.
              10 FILLER PIC X(12) VALUE '* VS.ORDINE '.
              10 DES6   PIC X(10) VALUE SPACE.
      **** rel 1.2
      **** rel 5.2
      *    05 FLGLVE   PIC 9.
      *    05 SCBLVE   PIC S99V99.
      ************
      ************
      **** rel 2.0
      **** rel 5.2
      *    05 FLGLIS   PIC 9.
      *    05 SCBLIS   PIC S99V99.
      ************
           05 COMQTA   PIC S9(10)V999 VALUE ZERO.
           05 FLGUNO   PIC 9.
           05 KML      PIC 9(5).
           05 KVALID   PIC 9(5).
           05 KN       PIC 9(5).
           05 MAXRIGD  PIC ZZ9.
      ************
      **** rel 7.1
           05 PRIMA-VOLTA PIC 9.
      ************
      **** rel 4.0
           05 COMEURO  PIC 9(3) VALUE ZERO.
      ************
      **** rel 5.2
           05 FLGNBCR PIC 9 VALUE ZERO.
      ************
      **** rel 6.2
      *    NRIGMAXL: n. righe  logiche max rigo cliente
      *    NCOLMAXL: n. colonne max note aggiuntive rigo cliente
           05 NRIGMAXL PIC 9(3).
           05 NCOLMAXL PIC 9(3).
      ************
      **** rel 6.2
       01  COM-IN.
           05 COM-RIN PIC X(60) OCCURS 100.
      ************
      *
       01  PAR-LMS.
           05 PLMS-AZI     PIC 999.
           05 PLMS-FUNZ    PIC 9.
           05 PLMS-NUM     PIC 9.
           05 PLMS-BOL     PIC 9(5).
           05 PLMS-PRG     PIC 999.
           05 PLMS-DTOLD   PIC 9(5).
      *
       LINKAGE SECTION.
           COPY 'gribcrrg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-BCR-CTRL
                                RG-BCR-REC
                                RA-BCR-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcltab'.
           COPY 'dclord'.
           COPY 'dclrig'.
           COPY 'dclbct'.
           COPY 'dclbcr'.
           COPY 'dclart'.
           COPY 'dclard'.
           COPY 'dclobc'.
           COPY 'dclclf'.
           COPY 'dclcon'.
           COPY 'dcllav'.
      **** rel 5.2
      *    COPY 'dcllis'.
      *    COPY 'dcllve'.
      ************
      **** rel 2.0
           COPY 'dclnat'.
           COPY 'dclncr'.
           COPY 'dclnri'.
           COPY 'dclpor'.
           COPY 'dclpbr'.
      **** rel 5.2
      *    COPY 'dclscc'.
      ************
      **** rel 5.0
           COPY 'dclopc'.
           COPY 'dcltpr'.
           COPY 'dclarn'.
      **** rel 5.2
      *    COPY 'dcllps'.
      ************
      ************
           COPY 'dclla1'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-BCR-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-BCR-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
      **** rel 5.0
           IF RG-BCR-FUN = 'V' AND FUN-PREC = 'E' GO TO ESCI.
           IF RG-BCR-FUN = 'A' AND FUN-PREC = 'E' GO TO ESCI.
      ************
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-BCR-FUN   TO FUN.
           MOVE RG-BCR-IDX   TO IDX.
           MOVE RG-BCR-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.
      **** rel 4.0
           IF RG-BCR-FUN = 'r' AND FUN-PREC = 'r' GO TO ESCI.
      ************

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-BCR-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
      **** rel 2.0
           IF FUN = 'T' GO TO F-LEG-NAT.
           IF FUN = 'e' OR
                    'z' GO TO F-MZOOM.
      *    IF FUN = 'e' GO TO F-MZOOM.
      ************
      **** rel 5.0
           IF FUN = 'J' PERFORM F-LEG-TESTO THRU END-F-LEG-TESTO
                        GO TO FINE.
      ************
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'vordg35: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-MZOOM.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
      **** rel 2.0
           PERFORM AZZ-PBR THRU EX-AZZ-PBR.
      ************
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           IF ID-LAV NOT = SPACE PERFORM R-RDR00 THRU R-RDR99.
           GO TO CHIUDI.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-BCR-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
      **** rel 2.0
           PERFORM AZZ-PBR THRU EX-AZZ-PBR.
      ************
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-BCR-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
      **** rel 2.0
              PERFORM AZZ-PBR THRU EX-AZZ-PBR
      ************
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
      **** rel 2.0
           PERFORM AZZ-PBR THRU EX-AZZ-PBR.
      ************
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-BCR-ST = 7 GO TO FINE.
      *    IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           MOVE RA-BCR-SALDO TO SAVSALDO.
           IF FUN = 'r' PERFORM CAR-PARMAG THRU EX-CAR-PARMAG
                        PERFORM DB-STORNA  THRU EX-DB-STORNA
                        IF RG-BCR-NORD NOT = ZERO
                           MOVE RESID TO RA-BCR-RESID.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           MOVE SAVSALDO TO RA-BCR-SALDO.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK BOLCRI.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-BCR INVALID
              PERFORM INVK-BCR
              GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BCR.
      *
           PERFORM CALL-VSRV133-MMG.
      ************
           IF BCR-NORD = ZERO AND BCT-VALUT = CLF-VAL
              PERFORM G00-AGGLVE THRU G999.
      *
           MOVE ZERO TO PLMS-FUNZ.
           PERFORM G-LMS THRU EX-G-LMS.
      **** rel 2.0
      *
       F-SCRIVI-NCR.
           PERFORM DL-WR-NOTE THRU EX-DL-WR-NOTE.
      ************
      *
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           MOVE BCR-QTA TO OLDQTA.
      *
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-BCR INVALID
              PERFORM INVK-BCR
              GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BCR.
      ************
      **** rel 2.0
      *
           PERFORM CONTROLLA-COERENZA THRU EX-CONTROLLA-COERENZA.
      *
      ************
           UNLOCK BOLCRI.
           IF BCR-NORD = ZERO AND BCT-VALUT = CLF-VAL
              PERFORM G00-AGGLVE THRU G999.
      *
           IF BCR-QTA NOT = OLDQTA
              MOVE ZERO TO PLMS-FUNZ
              PERFORM G-LMS THRU EX-G-LMS.
      **** rel 2.0
      *
       F-AGGIOR-NCR.
           PERFORM DL-WR-NOTE THRU EX-DL-WR-NOTE.
      ************
      *
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-BCR
              GO TO WARNING.
           IF RG-BCR-ST = 7 GO TO FINE.
           IF BCR-TCOR = 1 OR 3 GO TO ANN10.
           PERFORM CAR-PARMAG THRU EX-CAR-PARMAG.
           PERFORM DB-STORNA  THRU EX-DB-STORNA.
           IF BCR-TCOR = 2 OR
              ( ( BCR-TCOR = 4 OR 5 ) AND BCR-ART = SPACE )
                                                GO TO ANN10.
      **** rel 5.0
           IF BCR-NMOV = ZERO GO TO ANN10.
      ************
           MOVE BCR-ART    TO M-ART.
           MOVE BCR-NMOV   TO M-ONUM.
           MOVE ZERO       TO M-NQTA.
      **** rel 2.0
      *    CALL 'vrmvmag' USING PARMAG.
      *    IF ERRIO-ST = 9 GO TO ERRIO.
           IF FLGAGG = ZERO
      **** rel 7.1
              MOVE SPACE TO M-FDSV
      ************
              CALL 'vrmvmag' USING PARMAG
              IF ERRIO-ST = 9
                 GO TO ERRIO
              ELSE
                 IF ERRIO-ST = 8 MOVE ZERO TO ERRIO-ST
                                 CALL 'vrmbox' USING PARMB.
      ************
       ANN10.
      **** rel 2.0
           PERFORM DEL-PROBCR THRU EX-DEL-PROBCR.
      ************
           DELETE BOLCRI INVALID
              PERFORM INVK-BCR
              GO TO ERRIO.
           UNLOCK BOLCRI.
      **** rel 7.1
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BCR.
      ************
      *
           MOVE 1 TO PLMS-FUNZ.
           PERFORM G-LMS THRU EX-G-LMS.
      **** rel 2.0
      *
           PERFORM DL-NOTE THRU EX-DL-NOTE.
      ************
      *
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-BCR-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK BOLCRI.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-BCR-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI
                 ORDCLI
                 TABELL
                 ANACLF
                 ANACON
      **** rel 5.2
      *          LISTIN
      ************
                 BOLCTE
                 BOLCRI
                 MAGART
                 MAGARD
                 ORDRIG
      **** rel 2.0
                 PROBCR
                 PRORIG
                 NOTART
                 NOTBCR
                 NOTRIG
      ************
      **** rel 5.0
                 ARCNOT
      ************
                 BOLORD.
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-BCR-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-BCR-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gritaber'.
           COPY 'griorder'.
           COPY 'gririger'.
           COPY 'gribcter'.
           COPY 'gribcrer'.
           COPY 'griarter'.
           COPY 'griarder'.
           COPY 'griobcer'.
           COPY 'griclfer'.
           COPY 'griconer'.
      **** rel 5.2
      *    COPY 'griliser'.
      *    COPY 'grilveer'.
      ************
      **** rel 2.0
           COPY 'griporer'.
           COPY 'gripbrer'.
           COPY 'grinater'.
           COPY 'grincrer'.
           COPY 'grinrier'.
      **** rel 5.2
      *    COPY 'grisccer'.
      ************
      ************
      **** rel 5.0
           COPY 'griopcer'.
      **** rel 5.2
      *    COPY 'grilpser'.
      ************
      ************
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           OPEN INPUT ANAAZI
                      ORDCLI
                      TABELL
                      ANACLF
                      ANACON
      **** rel 2.0
                      NOTART
      **** rel 5.2
      *               NOTRIG
      ************
      *               LISTIN.
                      NOTRIG.
      ************
      **** rel 5.0
           OPEN INPUT ARCNOT.
      ************
           OPEN I-O BOLCTE
                    BOLCRI
                    MAGART
                    MAGARD
                    ORDRIG
      **** rel 2.0
                    PROBCR
                    PRORIG
                    NOTBCR
      ************
                    BOLORD.
      *
           MOVE RG-BCR-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID
                                   PERFORM INVK-AZI
                                   GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           MOVE 14 TO KTB-TIP.
           MOVE 2  TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
              PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-IVGR TO IVGR.
           MOVE T14-IVRB TO IVRB.
      **** rel 5.2
           MOVE T14-NOTBCR TO FLGNBCR.
      ************
      **** rel 5.0
           MOVE 25        TO T25-TIP.
           MOVE KAZ-COD   TO T25-COD.
           MOVE ZERO      TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-INTRA TO RA-BCR-INTRA.
      ************
      *
           MOVE RG-BCR-AZI TO KBC-AZI.
           MOVE RG-BCR-NUM TO KBC-NUM.
           MOVE RG-BCR-BOL TO KBC-BOL.
           READ BOLCTE INVALID PERFORM INVK-BCT
                               GO TO ERRIO.
      **** rel 2.0
      *
           MOVE ZERO TO FLGAGG.
           IF BCT-TDOC = 8 OR 9 MOVE 1 TO FLGAGG.
      ************
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                                   PERFORM INVK-TAB
                                   GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      **** rel 5.1
           MOVE T01-MFOR TO MFOR.
           MOVE T01-MCLI TO MCLI.
      ************
           IF BCT-TDOC = 6 OR 7
              MOVE T01-MFOR TO MAS
           ELSE
              MOVE T01-MCLI TO MAS.
      *
           MOVE RG-BCR-AZI TO KCF-AZI.
           MOVE BCT-CLI    TO COD.
           MOVE CODICE     TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID
                       PERFORM INVK-CLF
                       GO TO ERRIO.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
      **** rel 5.0
      *
           OPEN INPUT TABPRO.
           MOVE RG-BCR-AZI TO KTR-AZI.
           MOVE 12         TO KTR-TIP.
           READ TABPRO INTO REKTPR12 INVALID MOVE ZERO TO TPR12-CFLABI.
           IF SF-TPR = '9A' OR '9D' OR '35' MOVE RF-TPR TO REKTPR12.
           CLOSE TABPRO.
      ************
      *
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
      **** rel 4.0
      *
           CALL 'rveur' USING COMEURO.
      ************
      *
      **** rel 5.2
           CANCEL 'vrdprz'.
      ************
      *
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-BCR-EOF.
      **** rel 6.2
           MOVE RG-BCR-AZI TO PTDC-AZI.
           MOVE 'BOL'      TO PTDC-COD.
           CALL 'vrctdc' USING PARTDC. 
           MOVE PTDC-NRIG TO NRIGMAXL.
           MOVE PTDC-NCOL TO NCOLMAXL.
      ************
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO  TO RF-BCR.
           MOVE ZERO  TO BCR-IVA
                         BCR-QTA
                         BCR-PZLOR
                         BCR-PZNET
                         BCR-NETRG
                         BCR-RIVGR
                         BCR-IPROV
                         BCR-CONTR
      **** rel 5.0
                         BCR-NOMME
      ************
                         BCR-NMOV
                         BCR-SC1
                         BCR-SC2
                         BCR-FPNET.
           MOVE SPACE TO BCR-ART
                         BCR-DESCR
                         BCR-UM.
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
           MOVE RG-BCR-AZI TO IF-AZI.
           MOVE RG-BCR-NUM TO IF-NUM.
           MOVE RG-BCR-BOL TO IF-BOL.
      **** rel 5.0
           MOVE RA-BCR-INTRA TO IF-INTRA.
      ************

      * azzeramento aree interfaccia
           MOVE ZERO  TO RG-BCR-REC.
           MOVE ZERO  TO RG-BCR-QTA
                         RG-BCR-PZLOR
                         RG-BCR-SC1
                         RG-BCR-SC2
                         RG-BCR-PZNET
                         RG-BCR-NETRG
                         RG-BCR-FPNET
      **** rel 5.0
                         RG-BCR-NOMME
      ************
                         RG-BCR-DTLIS.
           MOVE SPACE TO RG-BCR-ART
                         RG-BCR-DESCR
                         RG-BCR-UM.
           MOVE ZERO  TO RA-BCR-AGG.
           MOVE ZERO  TO RA-BCR-ESIS
                         RA-BCR-RESID.
           MOVE SPACE TO RA-BCR-IVA-D
                         RA-BCR-CONTR-D
                         RA-BCR-RIVGR-D.
      **** rel 4.0
           MOVE SPACE TO RA-BCR-FSC-D.
      ************
      **** rel 2.0
           PERFORM AZZ-NOTE.
      ************
      * ripristino dei campi chiave fissi
           MOVE IF-AZI TO RG-BCR-AZI.
           MOVE IF-NUM TO RG-BCR-NUM.
           MOVE IF-BOL TO RG-BCR-BOL.
      **** rel 5.0
           MOVE IF-INTRA TO RA-BCR-INTRA.
      ************
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
           MOVE RG-BCR-AZI TO KCR-AZI.
           MOVE RG-BCR-NUM TO KCR-NUM.
           MOVE RG-BCR-BOL TO KCR-BOL.
           MOVE ZERO TO KCR-PGR RG-BCR-PGR.
           START BOLCRI KEY NOT < KEYCR INVALID GO TO NORIG.
       RDBLR.
           READ BOLCRI NEXT AT END GO TO NORIG.
           IF KCR-AZI > RG-BCR-AZI GO TO NORIG.
           IF KCR-NUM > RG-BCR-NUM GO TO NORIG.
           IF KCR-BOL > RG-BCR-BOL GO TO NORIG.
           MOVE KCR-PGR TO RG-BCR-PGR.
           GO TO RDBLR.
       NORIG.
           ADD 5 TO RG-BCR-PGR.
      *
           PERFORM CAR-PARMAG THRU EX-CAR-PARMAG.
           MOVE ZERO TO M-ODAT.
      *
           MOVE SPACE TO WART.
           MOVE IVRB TO RA-BCR-IVRB.
      **** rel 2.0
           MOVE BCT-TDOC TO RA-BCR-TDOC.
      ************
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-BCR-AZI TO KCR-AZI.
           MOVE RG-BCR-NUM TO KCR-NUM.
           MOVE RG-BCR-BOL TO KCR-BOL.
           MOVE RG-BCR-PGR TO KCR-PGR.
           MOVE KEYCR TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYCR.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ BOLCRI INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ BOLCRI KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-BCR > ZERO MOVE 7 TO RG-BCR-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ BOLCRI PREVIOUS AT END MOVE 1 TO EOF
           ELSE
              READ BOLCRI NEXT AT END MOVE 3 TO EOF.
           IF EOF > ZERO GO TO RNP-80.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-BCR = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *
           IF KCR-AZI NOT = RG-BCR-AZI GO TO RNP-10.
           IF KCR-NUM NOT = RG-BCR-NUM GO TO RNP-10.
           IF KCR-BOL NOT = RG-BCR-BOL GO TO RNP-10.

      * trovato record valido: reset EOF
           MOVE ZERO TO RG-BCR-EOF.
           MOVE KEYCR TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-BCR-EOF.
           IF RG-BCR-EOF = 4 MOVE 2 TO RG-BCR-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-BCR = LOW-VALUE GO TO EX-TEST-EOL.
           IF KCR-AZI = RG-BCR-AZI AND
              KCR-NUM = RG-BCR-NUM AND
              KCR-BOL = RG-BCR-BOL GO TO EX-TEST-EOL.
           IF FUN = 'P' OR 'p'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
           GO TO EX-TEST-EOL.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
      **** rel 2.0
      **** rel 6.2
      *    MOVE NRIGMAX TO ML-MAXRIG.
      *    MOVE 30      TO ML-LUNRIG.
      *    MOVE 1       TO ML-FUN.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 5       TO ML-FUN.
      ************
           CALL 'vrmle' USING ML-CTRL RA-BCR-NOTE.
      *
      ************
           MOVE RG-BCR-AZI       TO KCR-AZI.
           MOVE RG-BCR-NUM       TO KCR-NUM.
           MOVE RG-BCR-BOL       TO KCR-BOL.
           MOVE RG-BCR-PGR       TO KCR-PGR.
           MOVE RG-BCR-TCOR      TO BCR-TCOR.
           MOVE RG-BCR-DESCR     TO BCR-DESCR.
      **** rel 4.0
      *    MOVE RG-BCR-TPRZ      TO BCR-TPRZ.
           MOVE RG-BCR-FSC       TO BCR-FSC.
      ************
      *
           IF RG-BCR-TCOR = 1
      **** rel 2.0
              MOVE RA-BCR-RIGNOT(1) TO BCR-DESCR
      ************
              GO TO EX-CARICA-REC.
      *
           MOVE RG-BCR-IVA       TO BCR-IVA.
           MOVE RG-BCR-CONTR     TO BCR-CONTR.
      **** rel 5.0
           MOVE RG-BCR-NOMME     TO BCR-NOMME.
      ************
      *
           IF RG-BCR-TCOR = 3
              MOVE RG-BCR-SPESA TO BCR-SPESA
              MOVE RG-BCR-PROVV TO BCR-PROVV
              MOVE RG-BCR-PZLOR TO BCR-PZLOR
                                   BCR-PZNET
                                   BCR-NETRG
              GO TO EX-CARICA-REC.
      *
           IF RG-BCR-TCOR = 4 OR = 5
              MOVE RG-BCR-RIVGR TO BCR-RIVGR.
      *--- standard interfaccia: 0=no 1=si
           IF RG-BCR-TCOR = 4
              IF RG-BCR-RIVAL = 0 MOVE 1    TO BCR-RIVAL
              ELSE                MOVE ZERO TO BCR-RIVAL.
      *
           MOVE RG-BCR-ART       TO BCR-ART.
           MOVE RG-BCR-NORD      TO BCR-NORD.
           MOVE RG-BCR-PRORD     TO BCR-PRORD.
           MOVE RG-BCR-TQUAN     TO BCR-TQUAN.
           MOVE RG-BCR-UM        TO BCR-UM.
           MOVE RG-BCR-QTA       TO BCR-QTA.
           MOVE RG-BCR-SC1       TO BCR-SC1.
           MOVE RG-BCR-SC2       TO BCR-SC2.
      **** rel 4.0
      *    MOVE RG-BCR-PZLOR     TO BCR-PZLOR.
      *    MOVE RG-BCR-PZNET     TO BCR-PZNET.
      *
           MOVE RG-BCR-FSC   TO DP-FSC.
           MOVE RG-BCR-PZLOR TO DP-PREZZO.
           CALL 'rforprz' USING DP-PREZZO DP-FSC FSC-UNI.
           MOVE DP-PREZZO    TO BCR-PZLOR.
      *
           MOVE RG-BCR-FSC   TO DP-FSC.
           MOVE RG-BCR-PZNET TO DP-PREZZO.
           CALL 'rforprz' USING DP-PREZZO DP-FSC FSC-UNI.
           MOVE DP-PREZZO    TO BCR-PZNET.
      *
      ************
           MOVE RG-BCR-NETRG     TO BCR-NETRG.
           MOVE RG-BCR-PROVV     TO BCR-PROVV.
           MOVE RG-BCR-IPROV     TO BCR-IPROV.
           MOVE RG-BCR-NMOV      TO BCR-NMOV.
           MOVE RG-BCR-FPNET     TO BCR-FPNET.
      *
           PERFORM SETTA-TQP-BCR THRU EX-SETTA-TQP-BCR.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE KCR-AZI       TO RG-BCR-AZI.
           MOVE KCR-NUM       TO RG-BCR-NUM.
           MOVE KCR-BOL       TO RG-BCR-BOL.
           MOVE KCR-PGR       TO RG-BCR-PGR.
           MOVE BCR-TCOR      TO RG-BCR-TCOR.
           MOVE BCR-DESCR     TO RG-BCR-DESCR.
           MOVE BCR-IVA       TO RG-BCR-IVA.
      **** rel 4.0
      *    MOVE BCR-TPRZ      TO RG-BCR-TPRZ.
           MOVE BCR-FSC       TO RG-BCR-FSC.
      ************
           MOVE BCR-SPESA     TO RG-BCR-SPESA.
           MOVE BCR-CONTR     TO RG-BCR-CONTR.
      **** rel 5.0
           MOVE BCR-NOMME     TO RG-BCR-NOMME.
      ************
           MOVE BCR-RIVGR     TO RG-BCR-RIVGR.
      *--- standard interfaccia: 0=no 1=si
           IF BCR-RIVAL = 0
              MOVE 1    TO RG-BCR-RIVAL
           ELSE
              MOVE ZERO TO RG-BCR-RIVAL.
      *
           MOVE BCR-ART       TO RG-BCR-ART
                                 WART.
           MOVE BCR-NORD      TO RG-BCR-NORD.
           MOVE BCR-PRORD     TO RG-BCR-PRORD.
           MOVE BCR-TQUAN     TO RG-BCR-TQUAN.
           MOVE BCR-UM        TO RG-BCR-UM.
           MOVE BCR-QTA       TO RG-BCR-QTA.
           MOVE BCR-SC1       TO RG-BCR-SC1.
           MOVE BCR-SC2       TO RG-BCR-SC2.
           MOVE BCR-PZLOR     TO RG-BCR-PZLOR.
           MOVE BCR-PZNET     TO RG-BCR-PZNET.
      **** rel 4.0
           IF BCR-TCOR NOT = 3
              MOVE BCR-FSC   TO DP-FSC
              MOVE BCR-PZLOR TO DP-PREZZO
              CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
              MOVE DP-PREZZO TO RG-BCR-PZLOR
              MOVE BCR-FSC   TO DP-FSC
              MOVE BCR-PZNET TO DP-PREZZO
              CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
              MOVE DP-PREZZO TO RG-BCR-PZNET.
      ************
           MOVE BCR-NETRG     TO RG-BCR-NETRG.
           MOVE BCR-PROVV     TO RG-BCR-PROVV.
           MOVE BCR-IPROV     TO RG-BCR-IPROV.
           MOVE BCR-NMOV      TO RG-BCR-NMOV.
           MOVE BCR-FPNET     TO RG-BCR-FPNET.
      *
           IF BCR-TCOR = 2  OR
             ((BCR-TCOR = 4 OR 5) AND BCR-ART = SPACE)
      **** rel 4.0
                MOVE 2 TO RG-BCR-TQUAN.
      *         MOVE 2 TO RG-BCR-TQUAN
      *         MOVE 1 TO RG-BCR-TPRZ.
      ************
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
           MOVE IVRB TO RA-BCR-IVRB.
      **** rel 2.0
           MOVE BCT-TDOC TO RA-BCR-TDOC.
      ************
      *
      **** rel 2.0
      *    IF RG-BCR-TCOR = 1 GO TO EX-CARICA-RA.
           IF RG-BCR-TCOR = 1 GO TO RCO60.
      ************
           MOVE 3          TO KTB-TIP.
           MOVE RG-BCR-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                            MOVE ALL '*' TO T03-DSIVA.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-DSIVA TO RA-BCR-IVA-D.
           IF RG-BCR-TCOR NOT = 3 GO TO RCO20.
      * rigo voce spesa
           MOVE 11           TO KTB-TIP.
           MOVE RG-BCR-SPESA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ALL '*' TO TAB-DESCR
                                           MOVE ZERO TO T11-CONTR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RG-BCR-DESCR.
      **** rel 2.0
      *    GO TO EX-CARICA-RA.
           GO TO RCO60.
      ************
      *
       RCO20.
           IF RG-BCR-TCOR = 2  OR
             ((RG-BCR-TCOR = 4 OR 5) AND RG-BCR-ART = SPACE)
                                                GO TO RCO30.
           MOVE RG-BCR-AZI TO KMA-AZI.
           MOVE RG-BCR-ART TO KMA-ART.
           READ MAGART INTO REKART INVALID
                MOVE ALL '*' TO ARTDESC.
           IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
           MOVE ARTDESC TO RG-BCR-DESCR.
      *
           MOVE RG-BCR-AZI TO KAD-AZI.
           MOVE RG-BCR-ART TO KAD-ART.
           MOVE BCT-CDEP   TO KAD-DEP.
           READ MAGARD INTO REKARD INVALID KEY
                MOVE 'Inesistente su deposito' TO RG-BCR-DESCR
                MOVE ZERO TO ARD-NWMOV.
           IF SF-ARD = '9D' OR '9A' OR '35' MOVE RF-ARD TO REKARD.
           MOVE ARD-NWMOV TO RA-BCR-ESIS.
      *
      **** rel 6.1
      *    IF BCT-TDOC NOT = 3 GO TO RCO40.
      ************
       RCO30.
           IF RG-BCR-CONTR = ZERO GO TO RCO40.
           MOVE RG-BCR-AZI   TO KPC-AZI.
           MOVE RG-BCR-CONTR TO KPC-COD.
           READ ANACON INTO REKCON INVALID MOVE ALL '*' TO CON-DSABB.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
      **** rel 6.1
           IF CON-DSABB = SPACE MOVE CON-DESCR TO CON-DSABB.
      ************
           MOVE CON-DSABB TO RA-BCR-CONTR-D.
       RCO40.
           IF RG-BCR-NORD = ZERO GO TO RCO60.
           MOVE RG-BCR-AZI   TO KRI-AZI KOR-AZI.
           MOVE RG-BCR-NORD  TO KRI-NUM KOR-NUM.
           MOVE RG-BCR-PRORD TO KRI-PRG.
           READ ORDRIG INTO REKRIG INVALID
                MOVE ZERO TO RG-BCR-NORD
                             RG-BCR-PRORD
                             RA-BCR-RESID
                MOVE 1 TO RA-BCR-SALDO
                GO TO RCO60.
           IF SF-RIG = '9D' OR '9A' OR '35' MOVE RF-RIG TO REKRIG.
           COMPUTE RA-BCR-RESID = RIG-QUANT - RIG-QSPED.
           IF RA-BCR-RESID < ZERO MOVE ZERO TO RA-BCR-RESID.
           MOVE RIG-SALDO TO RA-BCR-SALDO.
           READ ORDCLI INTO REKORD INVALID
                MOVE ZERO TO KRI-NUM
                GO TO RCO60.
           IF SF-ORD = '9D' OR '9A' OR '35' MOVE RF-ORD TO REKORD.
           MOVE ORD-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RA-BCR-DTORD.
       RCO60.
      **** rel 4.0
           MOVE ZERO TO RA-BCR-CBFSC.
           IF (RG-BCR-TCOR = 2 OR 4 OR 5) AND RG-BCR-ART = SPACE
              IF RG-BCR-FSC > ZERO MOVE 1 TO RA-BCR-CBFSC.
           PERFORM AGGIORNA-FSC-D.
      ************
      **** rel 2.0
           PERFORM RD-NCR THRU EX-RD-NCR.
      ************
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-BCR-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
      *
       V-PGR.
           MOVE 'BCR-PGR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PGR.
           IF RG-BCR-PGR = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-PGR.
      *
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-BCR-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-TCOR.
           MOVE 'BCR-TCOR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TCOR.
           IF RG-BCR-TCOR > 6
              PERFORM ERR-RADIO
              GO TO V-ERROR.
      **** rel 5.0
           IF (TPR12-CFLABI NOT = 1 AND
               BCT-TDOC > 2         AND
               RG-BCR-TCOR > 6)
             OR
              (TPR12-CFLABI = 1 AND
               BCT-TDOC > 3     AND
               RG-BCR-TCOR > 6)
               PERFORM ERR-DINV
               GO TO V-ERROR.
      ************
           IF RG-BCR-TCOR = 2 AND KCR-AZI = ZERO
      **** rel 2.0
      **** rel 3.0a
      *       MOVE BCR-PROVV TO RG-BCR-PROVV
      *************
      ************
      **** rel 4.0
              MOVE 2 TO RG-BCR-TQUAN.
      *       MOVE 2 TO RG-BCR-TQUAN
      *       MOVE 1 TO RG-BCR-TPRZ.
      ************
      **** rel 3.0a
           IF RG-BCR-TCOR = 2    AND
              KCR-AZI     = ZERO AND
              FUN         = 'V'  MOVE BCT-PROVV TO RG-BCR-PROVV.
      *************
       E-TCOR.
      *
       V-ART.
           MOVE 'BCR-ART' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ART.
           IF NOT (RG-BCR-TCOR = 0 OR 4 OR 5 OR 6) GO TO E-ART.
           IF (RG-BCR-TCOR = 4 OR 5) AND RG-BCR-ART = SPACE
              IF KCR-AZI = ZERO
                 MOVE 2 TO RG-BCR-TQUAN
      **** rel 4.0
      *          MOVE 1 TO RG-BCR-TPRZ
      ************
                 GO TO E-ART
              ELSE
                 GO TO E-ART.
           CALL 'vrcartb' USING RG-BCR-AZI RG-BCR-ART.
           IF RG-BCR-ART = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           IF WART = RG-BCR-ART GO TO E-ART.
      **** rel 5.2
           MOVE 9 TO PCFA-FUN.
       LP-PCFA.
      ************
           MOVE RG-BCR-ART TO WART.
           MOVE RG-BCR-AZI TO KMA-AZI.
           MOVE RG-BCR-ART TO KMA-ART.
           READ MAGART INTO REKART INVALID
      **** rel 5.2
                IF PCFA-FUN = 9
                   MOVE RG-BCR-AZI TO PCFA-AZI
                   IF BCT-TDOC = 6 OR 7
                      MOVE 'F' TO PCFA-TIP
                   ELSE
                      MOVE 'C' TO PCFA-TIP
                   END-IF
                   MOVE BCT-CLI TO PCFA-CLF
                   MOVE RG-BCR-ART TO PCFA-ART
                   CALL 'vrrcfa' USING PARPCFA
                   IF PCFA-ST = ZERO AND
                      PCFA-ART NOT = SPACE
                         MOVE PCFA-ART TO RG-BCR-ART
                         MOVE ZERO TO PCFA-FUN
                         GO TO LP-PCFA
                   END-IF
                END-IF
      ************
                MOVE SPACE TO RG-BCR-DESCR
                PERFORM ERR-CINE
                MOVE SPACE TO WART
                GO TO V-ERROR.
           IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
           IF KCR-AZI NOT = ZERO  GO TO E-ART.
      **** rel 6.0a
           IF FUN = 'V' AND FLGNBCR = 1
              MOVE SPACE TO RA-BCR-NOTE
              MOVE ZERO  TO RA-BCR-FLGNOTE
              PERFORM F-LEG-NAT THRU END-F-LEG-NAT
              IF RA-BCR-NOTE NOT = SPACE
      **** rel 6.2
      *          MOVE NRIGMAX TO KVALID
                 MOVE NRIGMAXL TO KVALID
      ************
                 PERFORM UNTIL RA-BCR-RIGNOT(KVALID) NOT = SPACE
                    SUBTRACT 1 FROM KVALID
                 END-PERFORM
                 IF KVALID > ZERO
                    MOVE 1 TO RA-BCR-FLGNOTE.
      *************
      **** rel 4.0
           MOVE ART-FSC   TO DP-FSC.
           MOVE BCT-VALUT TO DP-VALUT.
           CALL 'rdetfsc' USING DP-VALUT DP-FSC.
           MOVE DP-FSC    TO RG-BCR-FSC.
           PERFORM AGGIORNA-FSC-D.
      ************
           MOVE ART-DESCR TO RG-BCR-DESCR.
           MOVE KMA-AZI  TO KAD-AZI.
           MOVE KMA-ART  TO KAD-ART.
           MOVE BCT-CDEP TO KAD-DEP.
           READ MAGARD INTO REKARD INVALID KEY
                MOVE 'Inesistente su deposito' TO MESS
                MOVE SPACE TO WART
                GO TO V-ERROR.
           IF SF-ARD = '9D' OR '9A' OR '35' MOVE RF-ARD TO REKARD.
           MOVE ARD-NWMOV TO RA-BCR-ESIS.
           IF NOT ( BCT-TDOC = 4 OR 6 ) GO TO V-ART-10.
           MOVE KMA-AZI   TO KAD-AZI.
           MOVE KMA-ART   TO KAD-ART.
           MOVE BCT-CDEP2 TO KAD-DEP.
           READ MAGARD INTO REKARD INVALID KEY
                MOVE 'Inesistente su deposito-2' TO MESS
                MOVE SPACE TO WART
                GO TO V-ERROR.
           IF SF-ARD = '9D' OR '9A' OR '35' MOVE RF-ARD TO REKARD.
       V-ART-10.
      **** rel 5.0
      **** rel 5.2
      *    IF FUN NOT = 'W'
      *       PERFORM CERCA-PROVVIGIONE THRU P99.
      ************
      ************
      **** rel 2.0
      **** rel 5.2
      *    MOVE ZERO TO SCBLIS FLGLIS.
      ************
      ************
           MOVE ART-TQUAN TO RG-BCR-TQUAN.
           MOVE ART-UNMIS TO RG-BCR-UM.
      **** rel 4.0
      *    MOVE ART-TPRZ  TO RG-BCR-TPRZ.
      ************
           MOVE ART-CDIVA TO RG-BCR-IVA.
      **** rel 6.1
      *    MOVE ART-CPART TO RG-BCR-CONTR.
           PERFORM CERCA-CONTR THRU EX-CERCA-CONTR.
      ************
      **** rel 5.0
           IF RA-BCR-INTRA = 1 MOVE ART-NOMME TO RG-BCR-NOMME.
      ************
           MOVE 3          TO KTB-TIP.
           MOVE RG-BCR-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO T03-DSIVA.
           MOVE T03-DSIVA TO RA-BCR-IVA-D.
      **** rel 4.0
      *    IF BCT-VALUT > 1 MOVE 1 TO RG-BCR-TPRZ.
      ************

      **** rel 5.2
      **** rel 6.0a
           MOVE ZERO         TO RPZ-FLGA.
      ************
           MOVE ZERO         TO RPZ-FLVE.
           MOVE ZERO         TO RPZ-FSCC.
           MOVE ZERO         TO RPZ-FPRV.
           MOVE KBC-AZI      TO RPZ-AZI.
           MOVE ZERO         TO RPZ-TIPO.
           MOVE BCT-CLI      TO RPZ-CLI.
           MOVE BCT-VALUT    TO RPZ-VALUT.
           MOVE BCT-DATA     TO RPZ-DATA.
           MOVE BCT-SCBAS    TO RPZ-SCBAS.
           MOVE BCT-PROVV    TO RPZ-TPROV.
           MOVE BCT-CAGE     TO RPZ-CDAGE.
           MOVE BCT-TDOC     TO RPZ-TDOC.
           MOVE RG-BCR-ART   TO RPZ-ART.
           MOVE RG-BCR-TCOR  TO RPZ-TPRIG.
           MOVE RG-BCR-FSC   TO RPZ-FSC.
           MOVE RG-BCR-QTA   TO RPZ-QTA.
           MOVE RG-BCR-TQUAN TO RPZ-TQUAN.
           MOVE BCT-LISRF    TO RPZ-CLIS.
      *
           CLOSE MAGART.
           CALL 'vrdprz' USING PARRPZ.
           OPEN I-O MAGART.
      *
           IF ERRIO-ST NOT = ZERO GO TO ERRIO.
           MOVE RPZ-CLIS    TO RA-BCR-LIS.
           MOVE RPZ-F-PZLOR TO RG-BCR-PZLOR.
           MOVE RPZ-SC1     TO RG-BCR-SC1.
           MOVE RPZ-SC2     TO RG-BCR-SC2.
           MOVE RPZ-FPNET   TO RG-BCR-FPNET.
           MOVE RPZ-GMA-DT  TO RG-BCR-DTLIS.
           MOVE RPZ-PROVV   TO RG-BCR-PROVV.
           MOVE RPZ-IPROV   TO RG-BCR-IPROV.
           IF RPZ-FLIS > ZERO AND RPZ-SLIS NOT = BCT-SCBAS
              MOVE 'Sconto testata diverso da listino' TO MESS
              GO TO V-ERROR.

      **** rel 6.0a
      *    IF FUN = 'V' AND FLGNBCR = 1
      *       MOVE SPACE TO RA-BCR-NOTE
      *       MOVE ZERO  TO RA-BCR-FLGNOTE
      *       PERFORM F-LEG-NAT THRU END-F-LEG-NAT
      *       IF RA-BCR-NOTE NOT = SPACE
      *          MOVE NRIGMAX TO KVALID
      *          PERFORM UNTIL RA-BCR-RIGNOT(KVALID) NOT = SPACE
      *             SUBTRACT 1 FROM KVALID
      *          END-PERFORM
      *          IF KVALID > ZERO
      *             MOVE 1 TO RA-BCR-FLGNOTE.
      *************
      ************
       E-ART.
      *
       V-DESCR.
           MOVE 'BCR-DESCR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DESCR.
           IF NOT (RG-BCR-TCOR = 2 OR 4 OR 5)  GO TO E-DESCR.
           IF (RG-BCR-TCOR = 4 OR 5) AND
               RG-BCR-ART NOT = SPACE
               GO TO E-DESCR.
           IF (RG-BCR-TCOR = 4 OR 5) AND RG-BCR-ART = SPACE
              IF KCR-AZI = ZERO
      **** rel 4.0
                 MOVE 2 TO RG-BCR-TQUAN.
      *          MOVE 2 TO RG-BCR-TQUAN
      *          MOVE 1 TO RG-BCR-TPRZ.
      ************
           IF RG-BCR-DESCR = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-DESCR.
      **** rel 4.0
      *
       V-FSC.
           MOVE 'BCR-FSC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FSC.
           IF NOT (RG-BCR-TCOR = 2 OR 4 OR 5) GO TO E-FSC.
           IF (RG-BCR-TCOR = 4 OR 5) AND
              RG-BCR-ART NOT = SPACE GO TO E-FSC.
           MOVE ZERO  TO RG-BCR-FSC.
           IF RA-BCR-CBFSC = 1 MOVE 3 TO RG-BCR-FSC.
           PERFORM AGGIORNA-FSC-D.
       E-FSC.
      ************
      *
       V-UM.
           MOVE 'BCR-UM' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-UM.
           IF NOT (RG-BCR-TCOR = 2 OR 4 OR 5)  GO TO E-UM.
           IF (RG-BCR-TCOR = 4 OR 5) AND
               RG-BCR-ART NOT = SPACE
               GO TO E-UM.
           IF RG-BCR-UM = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-UM.
      *
       V-IVA.
           MOVE 'BCR-IVA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IVA.
           MOVE SPACE TO RA-BCR-IVA-D.
           IF RG-BCR-TCOR = 1 GO TO E-IVA.
           IF RG-BCR-TCOR = 3
              IF RG-BCR-IVA = ZERO
                 MOVE SPACE TO RA-BCR-IVA-D
                 GO TO E-IVA
              ELSE
                 GO TO IVASPE.
           IF IVRB = ZERO
              IF (RG-BCR-TCOR = 0 OR 6) OR
                 ((RG-BCR-TCOR = 4 OR 5) AND RG-BCR-ART NOT = SPACE)
                   GO TO E-IVA.
           IF RG-BCR-IVA = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       IVASPE.
           MOVE RG-BCR-IVA TO KTB-COD.
           MOVE 3          TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-DSIVA TO RA-BCR-IVA-D.
           IF T03-TPIVA = 1 OR 7
                  MOVE 'Aliquota IVA non ammessa' TO MESS
                  GO TO V-ERROR.
       E-IVA.
      *
       V-QTA.
           MOVE 'BCR-QTA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-QTA.
           IF NOT (RG-BCR-TCOR = 0 OR 2 OR 4 OR 5 OR 6) GO TO E-QTA.
           MOVE RG-BCR-QTA TO RD-NUM.
           CALL 'vrround' USING QTA-S PARRD RG-BCR-TQUAN.
           MOVE RD-NUM TO RG-BCR-QTA.
           IF RD-ST > ZERO
              PERFORM ERR-NDEC
              GO TO V-ERROR.
           IF RG-BCR-QTA = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
      **** rel 5.0
           PERFORM C00-CAL-SCAPP.
           MOVE IM-NETRG TO RG-BCR-NETRG.
      ************
           IF RG-BCR-NORD = ZERO GO TO E-QTA.
      **** rel 5.0
      *    COMPUTE RA-BCR-RESID = RIG-QUANT - RIG-QSPED - RG-BCR-QTA.
           IF BCT-TDOC NOT = 3
              COMPUTE RA-BCR-RESID = RIG-QUANT - RIG-QSPED - RG-BCR-QTA
           ELSE
              COMPUTE RA-BCR-RESID = RIG-QUANT - RIG-QSPED + RG-BCR-QTA.
      ************
           IF RA-BCR-RESID < ZERO MOVE ZERO TO RA-BCR-RESID.
           IF RA-BCR-RESID NOT > ZERO
              MOVE 1 TO RA-BCR-SALDO.
      **** rel 2.0
           IF FUN = 'V' AND
              RA-BCR-RESID > ZERO AND
              RG-BCR-QTA < BCR-QTA
                 MOVE ZERO TO RA-BCR-SALDO.
      ************
       E-QTA.
      *
       V-LIS.
           MOVE 'BCR-LIS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO     GO TO E-LIS.
           MOVE 1 TO RA-BCR-SDEC.
           IF NOT (RG-BCR-TCOR = 0 OR 4 OR 5 OR 6) GO TO E-LIS.
           IF (RG-BCR-TCOR = 4 OR 5) AND RG-BCR-ART = SPACE
               GO TO E-LIS.
           IF RA-BCR-LIS = ZERO GO TO E-LIS.
           IF FUN NOT = 'V'     GO TO E-LIS.
      **** rel 5.2
      **** rel 6.0a
           MOVE 1            TO RPZ-FLGA.
      ************
           MOVE 1            TO RPZ-FLVE.
      **** rel 6.2
      *    MOVE 1            TO RPZ-FSCC.
      *    MOVE 1            TO RPZ-FPRV.
           MOVE ZERO         TO RPZ-FSCC.
           MOVE ZERO         TO RPZ-FPRV.
      ************
           MOVE KBC-AZI      TO RPZ-AZI.
           MOVE ZERO         TO RPZ-TIPO.
           MOVE BCT-CLI      TO RPZ-CLI.
           MOVE BCT-VALUT    TO RPZ-VALUT.
           MOVE BCT-DATA     TO RPZ-DATA.
           MOVE BCT-SCBAS    TO RPZ-SCBAS.
           MOVE BCT-PROVV    TO RPZ-TPROV.
           MOVE BCT-CAGE     TO RPZ-CDAGE.
      **** rel 6.0a
      *    MOVE ZERO         TO RPZ-TDOC.
           MOVE BCT-TDOC     TO RPZ-TDOC.
      *************
           MOVE RG-BCR-ART   TO RPZ-ART.
           MOVE RG-BCR-TCOR  TO RPZ-TPRIG.
           MOVE RG-BCR-FSC   TO RPZ-FSC.
           MOVE RG-BCR-QTA   TO RPZ-QTA.
           MOVE RG-BCR-TQUAN TO RPZ-TQUAN.
           MOVE RA-BCr-LIS   TO RPZ-CLIS.
      *
           CLOSE MAGART.
           CALL 'vrdprz' USING PARRPZ.
           OPEN I-O MAGART.
      *
           IF ERRIO-ST NOT = ZERO GO TO ERRIO.
      *
           IF RA-BCR-LIS > 3
              IF RPZ-CLIS NOT > 3
                 MOVE 'Listino inesistente' TO MESS
                 GO TO V-ERROR
              END-IF
              IF RPZ-VLIS NOT = BCT-VALUT
                 MOVE "Valuta diversa da quella della bolla" TO MESS
                 GO TO V-ERROR.
      *
           MOVE RPZ-F-PZLOR TO RG-BCR-PZLOR.
           MOVE RPZ-CLIS  TO RA-BCR-LIS.
           MOVE RPZ-SC1   TO RG-BCR-SC1.
           MOVE RPZ-SC2   TO RG-BCR-SC2.
      **** rel 6.1
      *    MOVE RPZ-FPNET TO RG-BCR-FPNET.
           IF NOT (RPZ-CLIS = 1 OR 2 OR 3)
              MOVE RPZ-FPNET TO RG-BCR-FPNET
           ELSE 
              MOVE ZERO      TO RG-BCR-FPNET.
      ************
           MOVE RPZ-SDEC  TO RA-BCR-SDEC.
           IF RPZ-FLIS > ZERO AND RPZ-SLIS NOT = BCT-SCBAS
              MOVE 'Sconto testata diverso da listino' TO MESS
              GO TO V-WARNING.
      ************
       E-LIS.
      *
       V-SPESA.
           MOVE 'BCR-SPESA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-SPESA.
           IF RG-BCR-TCOR NOT = 3 GO TO E-SPESA.
           IF RG-BCR-SPESA = ZERO
              MOVE SPACE TO RG-BCR-DESCR
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 11 TO KTB-TIP.
           MOVE RG-BCR-SPESA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO RG-BCR-DESCR
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      **** rel 4.0
      *    IF BCT-VALUT > 1 MOVE 1 TO RG-BCR-TPRZ.
      ************
           MOVE TAB-DESCR TO RG-BCR-DESCR.

           IF RG-BCR-SPESA = BCR-SPESA GO TO E-SPESA.

           MOVE T11-CONTR TO RG-BCR-CONTR.
      **** rel 3.0
           IF RG-BCR-CONTR = ZERO GO TO V-SPESA-10.
           MOVE RG-BCR-AZI   TO KPC-AZI.
           MOVE RG-BCR-CONTR TO KPC-COD.
           READ ANACON INTO REKCON INVALID
                MOVE 'Contropartita inesistente' TO MESS
                GO TO V-ERROR.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           IF CON-MOVIM NOT = ZERO
                MOVE 'Conto non movimentabile' TO MESS
                GO TO V-ERROR.
       V-SPESA-10.
      ************
           IF T11-TIMP = ZERO
              MOVE ZERO TO RG-BCR-PROVV
           ELSE
              MOVE ZERO TO RG-BCR-PZLOR.
      *---
           IF FUN = 'V' OR RG-BCR-IVA = ZERO
              MOVE T11-CIVA TO RG-BCR-IVA.
      *---
           IF RG-BCR-IVA = ZERO
              MOVE SPACE TO RA-BCR-IVA-D
              GO TO E-SPESA.
           MOVE 3 TO KTB-TIP.
           MOVE RG-BCR-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-BCR-IVA-D.
       E-SPESA.
      *
       V-PROVV.
           MOVE 'BCR-PROVV' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PROVV.
           IF RG-BCR-TCOR NOT = 3 GO TO E-PROVV.
           MOVE 11 TO KTB-TIP.
           MOVE RG-BCR-SPESA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO RG-BCR-DESCR
                MOVE 'Manca il codice spesa' TO MESS
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T11-TIMP = ZERO
              MOVE ZERO TO RG-BCR-PROVV
              GO TO E-PROVV.
           IF RG-BCR-PROVV = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-PROVV.
      *
       V-PZLOR.
           MOVE 'BCR-PZLOR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PZLOR.
           IF RG-BCR-TCOR = 3 GO TO PRZSPE.
           IF NOT (RG-BCR-TCOR = 0 OR 2 OR 4 OR 5 OR 6) GO TO E-PZLOR.
      **** rel 4.0
      *    MOVE RG-BCR-PZLOR TO RD-NUM.
      *    CALL 'vrround' USING PRZ-S PARRD RG-BCR-TPRZ.
      *    MOVE RD-NUM TO RG-BCR-PZLOR.
      *    IF RD-ST > ZERO
      *       PERFORM ERR-NDEC
      *       GO TO V-ERROR.
      ************
           IF RG-BCR-TCOR = 2 AND RG-BCR-PZLOR < ZERO
              PERFORM ERR-DINV
              GO TO V-ERROR.
      **** rel 5.0
           PERFORM C00-CAL-SCAPP.
           MOVE IM-NETRG TO RG-BCR-NETRG.
      ************
           GO TO E-PZLOR.
       PRZSPE.
           MOVE 11 TO KTB-TIP.
           MOVE RG-BCR-SPESA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO RG-BCR-DESCR
                MOVE 'Manca il codice spesa' TO MESS
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T11-TIMP = 1
              MOVE ZERO TO RG-BCR-PZLOR
              GO TO E-PZLOR.
      **** rel 4.0
      *    MOVE RG-BCR-PZLOR TO RD-NUM.
      *    CALL 'vrround' USING PRZ-S PARRD RG-BCR-TPRZ.
      *    MOVE RD-NUM TO RG-BCR-PZLOR.
      *    IF RD-ST > ZERO
      *       PERFORM ERR-NDEC
      *       GO TO V-ERROR.
      ************
           IF RG-BCR-PZLOR = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-PZLOR.
      *
       V-FPNET.
           MOVE 'BCR-FPNET' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FPNET.
           IF RG-BCR-FPNET = 1
      **** rel 5.1
      *       MOVE ZERO TO RG-BCR-SC1 RG-BCR-SC2.
              MOVE ZERO TO RG-BCR-SC1 RG-BCR-SC2
              IF NOT (RG-BCR-TCOR = 0 OR 2 OR 6)  GO TO E-FPNET
              ELSE
                 IF RG-BCR-TCOR > 3 AND < 7
                    MOVE ZERO TO RG-BCR-PROVV
      **** rel 5.2
      *                          RG-BCR-IPROV
      *          ELSE
      *             IF FUN NOT = 'W'
      *                PERFORM CERCA-PROVVIGIONE THRU P99.
                                 RG-BCR-IPROV.
      ************
      **** rel 6.0a
           PERFORM AGG-PRV THRU EX-AGG-PRV.
      ************
      *
           PERFORM C00-CAL-SCAPP.
           MOVE IM-NETRG TO RG-BCR-NETRG.
      ************
       E-FPNET.
      *
       V-SC1.
           MOVE 'BCR-SC1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-SC1.
           IF NOT (RG-BCR-TCOR = 0 OR 2 OR 6)  GO TO E-SC1.
           MOVE RG-BCR-SC1 TO RD-NUM.
      **** rel 5.1
      *    CALL 'vrround' USING PRZ-S PARRD AZI-FLSCC.
           IF AZI-FLSCC = ZERO
              CALL 'vrround' USING NNN-S PARRD DEC-0
              IF RD-ST > ZERO
                 PERFORM ERR-NDEC
                 GO TO V-ERROR.
      ************
           MOVE RD-NUM TO RG-BCR-SC1.
      **** rel 5.0
           IF RG-BCR-TCOR > 3 AND < 7
              MOVE ZERO TO RG-BCR-SC1
                           RG-BCR-SC2
                           RG-BCR-PROVV
      **** rel 5.2
      *                    RG-BCR-IPROV
      *    ELSE
      *       IF FUN NOT = 'W'
      *          PERFORM CERCA-PROVVIGIONE THRU P99.
                           RG-BCR-IPROV.
      ************
      **** rel 6.0a
           PERFORM AGG-PRV THRU EX-AGG-PRV.
      ************
      *
           PERFORM C00-CAL-SCAPP.
           MOVE IM-NETRG TO RG-BCR-NETRG.
      ************
       E-SC1.
      *
       V-SC2.
           MOVE 'BCR-SC2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-SC2.
           IF NOT (RG-BCR-TCOR = 0 OR 2 OR 6)  GO TO E-SC2.
           MOVE RG-BCR-SC2 TO RD-NUM.
      **** rel 5.1
      *    CALL 'vrround' USING PRZ-S PARRD AZI-FLSCC.
           IF AZI-FLSCC = ZERO
              CALL 'vrround' USING NNN-S PARRD DEC-0
              IF RD-ST > ZERO
                 PERFORM ERR-NDEC
                 GO TO V-ERROR.
      ************
           MOVE RD-NUM TO RG-BCR-SC2.
      **** rel 5.0
           IF RG-BCR-TCOR > 3 AND < 7
              MOVE ZERO TO RG-BCR-SC1
                           RG-BCR-SC2
                           RG-BCR-PROVV
      **** rel 5.2
      *                    RG-BCR-IPROV
      *    ELSE
      *       IF FUN NOT = 'W'
      *          PERFORM CERCA-PROVVIGIONE THRU P99.
                           RG-BCR-IPROV.
      ************
      **** rel 6.0a
           PERFORM AGG-PRV THRU EX-AGG-PRV.
      ************
      *
           PERFORM C00-CAL-SCAPP.
           MOVE IM-NETRG TO RG-BCR-NETRG.
      ************
       E-SC2.
      *
       V-CONTR.
           MOVE 'BCR-CONTR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CONTR.
           MOVE SPACE TO RA-BCR-CONTR-D.
      **** rel 2.0
           IF RG-BCR-ART NOT = SPACE AND
      **** rel 6.1
      *       RG-BCR-CONTR   = ZERO  MOVE ART-CPART TO RG-BCR-CONTR.
              RG-BCR-CONTR   = ZERO
                 PERFORM CERCA-CONTR THRU EX-CERCA-CONTR.
      ************
      ************
           IF RG-BCR-CONTR = ZERO
              GO TO E-CONTR.
           MOVE RG-BCR-AZI   TO KPC-AZI.
           MOVE RG-BCR-CONTR TO KPC-COD.
           READ ANACON INTO REKCON INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           IF CON-MOVIM NOT = ZERO
                MOVE 'Conto non movimentabile' TO MESS
                GO TO V-ERROR.
           IF CON-DSABB = SPACE MOVE CON-DESCR TO CON-DSABB.
           MOVE CON-DSABB TO RA-BCR-CONTR-D.
       E-CONTR.
      *
       V-RIVGR.
           MOVE 'BCR-RIVGR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-RIVGR.
           IF NOT (RG-BCR-TCOR = 4 OR 5)       GO TO E-RIVGR.
           MOVE SPACE TO RA-BCR-RIVGR-D.
           MOVE RG-BCR-RIVGR TO KTB-COD.
           MOVE 3            TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-DSIVA TO RA-BCR-RIVGR-D.
           IF T03-TPIVA = 1 OR 7
                  MOVE 'Aliquota IVA non ammessa' TO MESS
                  GO TO V-ERROR.
       E-RIVGR.
      *
       V-SALDO.
           MOVE 'BCR-SALDO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-SALDO.
           IF RG-BCR-NORD = ZERO GO TO E-SALDO.
           IF RA-BCR-SALDO = ZERO AND RA-BCR-RESID NOT > ZERO
              MOVE 'Rigo ordine evaso completamente' TO F-MES1
              MOVE '      Flag di saldo errato'      TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
       E-SALDO.
      *
      **** rel 2.0
       V-NOTE.
           MOVE 'BCR-NOTE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NOTE.
      **** rel 6.2
      *    MOVE NRIGMAX TO ML-MAXRIG.
      *    MOVE 30      TO ML-LUNRIG.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
      ************
           MOVE 0       TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL RA-BCR-NOTE.
           IF ML-ST = 1
              MOVE SPACE TO F-MES2
              MOVE 'E'' possibile caricare' TO F-MES1
      **** rel 6.2
      *       MOVE NRIGMAX  TO MAXRIGD
              MOVE NRIGMAXL TO MAXRIGD
      ************
              STRING 'al massimo ' MAXRIGD ' righe'
                     DELIMITED SIZE INTO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
      * accende/spegne bottone presenza note aggiuntive
           MOVE ZERO TO RA-BCR-FLGNOTE.
           IF BCR-TCOR = 1
              MOVE 1 TO RA-BCR-FLGNOTE
              GO TO E-NOTE.
           IF RA-BCR-NOTE = SPACE GO TO E-NOTE.
      *
      **** rel 6.2
      *    MOVE NRIGMAX  TO KVALID.
           MOVE NRIGMAXL TO KVALID.
      ************
           PERFORM UNTIL RA-BCR-RIGNOT(KVALID) NOT = SPACE
              SUBTRACT 1 FROM KVALID
           END-PERFORM.
           IF KVALID > ZERO
              MOVE 1 TO RA-BCR-FLGNOTE.
       E-NOTE.
      *
      ************
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
           MOVE 1 TO SWDEL.
           PERFORM F00-GES-ORD THRU F99.
           MOVE ZERO TO SWDEL.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
           IF BCR-TCOR = 1 OR 3 GO TO EX-DB-AGGIORNA.
           PERFORM C00-CAL-IMP THRU C99.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
       C00-CAL-IMP.
           MOVE BCR-TCOR TO M-TCOR.
           MOVE BCR-ART  TO M-ART.
           MOVE BCR-UM   TO M-UNM.

           MOVE "V"       TO IM-TIPO.
           MOVE BCR-PZLOR TO IM-PZLOR.
           MOVE BCR-QTA   TO IM-QTA.
           MOVE BCT-SCBAS TO IM-SCBAS.
           MOVE BCR-SC1   TO IM-SC1.
           MOVE BCR-SC2   TO IM-SC2.
           MOVE BCT-VALUT TO IM-VALUT.
           MOVE BCR-TCOR  TO IM-TCOR.
           MOVE BCR-TQUAN TO IM-TQUAN.
      **** rel 4.0
      *    MOVE BCR-TPRZ  TO IM-TPRZ.
           MOVE BCR-FSC   TO IM-FSC.
      ************
           MOVE BCR-FPNET TO IM-FPNET.
           CALL 'vrimpor' USING PARIM.
           MOVE IM-PZNET  TO BCR-PZNET.
           MOVE IM-NETRG  TO BCR-NETRG.
           MOVE BCR-NETRG TO M-NIMP.
           IF BCR-TCOR = 2  OR
              ( ( BCR-TCOR = 4 OR 5 ) AND BCR-ART = SPACE )
                                                 GO TO C15.
           MOVE BCR-UM    TO M-UNM.
           MOVE BCR-QTA   TO M-NQTA.
           MOVE BCR-NMOV  TO M-ONUM.
           MOVE ZERO TO M-NMOV M-STAT.
       C15.
           IF BCR-NORD = ZERO GO TO C30.
      **** rel 2.0
           IF FLGAGG NOT = ZERO GO TO C30.
      ************
           MOVE KBC-AZI  TO KBO-AZI OBC-AZI.
           MOVE BCT-DATA TO AAGGG.
           MOVE 2 TO TIPOP1
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO KBO-ANNO OBC-ANNO.
           MOVE KCR-NUM TO KBO-NUM OBC-NUM.
           MOVE KCR-BOL TO KBO-BOL OBC-BOL.
           MOVE KCR-PGR TO KBO-PRB.
           MOVE BCR-NORD TO OBC-NORD.
           MOVE BCR-PRORD TO OBC-RGOR.
           MOVE 1 TO KBO-PRG.
           MOVE ZERO TO OBC.
           MOVE BCR-TQUAN TO OBC-TQUAN.
           MOVE BCR-QTA TO OBC-QUANT.
      **** rel 5.0
           IF BCT-TDOC = 3 MULTIPLY -1 BY OBC-QUANT.
      ************
           WRITE RF-OBC INVALID MOVE
                        'Errore scrittura bolord' TO F-MES1.
      **** rel 5.0
           MOVE ZERO TO PARBC.
           MOVE ZERO     TO BC-FUNZ.
           MOVE 1        TO BC-FLG.
           MOVE BCT-CDEP TO BC-DEP.
           MOVE BCR-ART  TO BC-ART.
           CALL 'vrcbpc' USING KEYBO PARBC.
      ************
       C30.
           MOVE ZERO TO SWDEL.
           PERFORM F00-GES-ORD THRU F99.
       C40.
      **** rel 2.0
      *    IF BCT-TDOC > 7 GO TO C99.
      ************
           IF BCR-TCOR = 2 GO TO C99.
           IF BCR-ART = SPACE GO TO C99.
      **** rel 5.0
           IF BCR-QTA = ZERO GO TO C99.
      ************
      **** rel 2.0
      *    CALL 'vrmvmag' USING PARMAG.
      *    IF ERRIO-ST = 9 GO TO ERRIO.
           IF FLGAGG = ZERO
      **** rel 7.1
              MOVE SPACE TO M-FDSV
              IF KCR-AZI = ZERO MOVE 'N' TO M-FDSV END-IF *> non aggiornare DSV in inserimento
      ************
              CALL 'vrmvmag' USING PARMAG
      **** rel 7.1
              MOVE SPACE TO M-FDSV
      ************
              IF ERRIO-ST = 9
                 GO TO ERRIO
              ELSE
                 IF ERRIO-ST = 8 MOVE ZERO TO ERRIO-ST
                                 CALL 'vrmbox' USING PARMB
                 END-IF
              END-IF
           ELSE
              MOVE ZERO TO M-NMOV.
      ************
           IF M-STAT = ZERO MOVE M-NMOV TO BCR-NMOV.
       C99.
           EXIT.
      *------------------
       F00-GES-ORD.
      **** rel 2.0
           IF FLGAGG NOT = ZERO GO TO F99.
      ************
           IF SWDEL = ZERO GO TO F10.
           MOVE KBC-AZI  TO KBO-AZI.
           MOVE BCT-DATA TO AAGGG.
           MOVE 2 TO TIPOP1
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO KBO-ANNO OBC-ANNO.
           MOVE KCR-NUM TO KBO-NUM.
           MOVE KCR-BOL TO KBO-BOL.
           MOVE KCR-PGR TO KBO-PRB.
           MOVE 1       TO KBO-PRG.
       F05.
           READ BOLORD INVALID GO TO F10.
      **** rel 5.0
           MOVE ZERO TO PARBC.
           MOVE 2        TO BC-FUNZ.
           MOVE 1        TO BC-FLG.
           MOVE BCT-CDEP TO BC-DEP.
           MOVE BCR-ART  TO BC-ART.
           CALL 'vrcbpc' USING KEYBO PARBC.
      ************
           DELETE BOLORD.
       F10.
           IF BCR-NORD = ZERO GO TO F99.
           MOVE KCR-AZI   TO KRI-AZI.
           MOVE BCR-NORD  TO KRI-NUM.
           MOVE BCR-PRORD TO KRI-PRG.
      **** rel 5.0
           MOVE KRI-AZI TO OC-AZI.
           MOVE KRI-NUM TO OC-NUM.
           CALL 'vrvopc' USING PAROC.
           IF OC-FLG = 1 GO TO F99.
      ************
           IF SWDEL = 1
              PERFORM G00-STO-ORD THRU G99
           ELSE
              PERFORM H00-AGG-ORD THRU H99.
       F99.
           EXIT.
      *------------------
       G00-STO-ORD.
           PERFORM I00-RDLCK THRU I99.
           IF SWERR = 1 GO TO G95.
           COMPUTE RESID = RIG-QUANT - RIG-QSPED.
      **** rel 5.0
      *    COMPUTE RIG-QSPED = RIG-QSPED - BCR-QTA.
      *    COMPUTE RESID = RESID + BCR-QTA.
           IF BCT-TDOC NOT = 3
              COMPUTE RIG-QSPED = RIG-QSPED - BCR-QTA
              COMPUTE RESID = RESID + BCR-QTA
           ELSE
              COMPUTE RIG-QSPED = RIG-QSPED + BCR-QTA
              COMPUTE RESID = RESID - BCR-QTA.
      ************
           IF RESID < ZERO MOVE ZERO TO RESID.
           iF BCR-ART = SPACE GO TO G30.
      **** rel 5.0
      *    IF RIG-SALDO = ZERO
      *       ADD BCR-QTA TO ART-IMPCL ARD-CIMPE
      *       ELSE
      *       ADD RESID TO ART-IMPCL ARD-CIMPE.
           IF RIG-SALDO = ZERO
              IF BCT-TDOC NOT = 3
                 ADD BCR-QTA TO ART-IMPCL ARD-CIMPE
              ELSE
                 SUBTRACT BCR-QTA FROM ART-IMPCL ARD-CIMPE
              END-IF
           ELSE
              ADD RESID TO ART-IMPCL ARD-CIMPE.
      ************
       G30.
           MOVE ZERO TO RIG-SALDO.
           IF RIG-QSPED NOT < RIG-QUANT MOVE 1 TO RIG-SALDO.
           IF ( BCR-TCOR > ZERO AND < 4 ) OR BCR-TCOR > 6
                                               GO TO G40.
           IF BCR-ART = SPACE GO TO G40.
           REWRITE RF-ART FROM REKART INVALID
                  MOVE 'Errore scrittura articolo' TO F-MES1
                  GO TO G90.
           UNLOCK MAGART.
           REWRITE RF-ARD FROM REKARD INVALID
                  MOVE 'Errore scrittura deposito' TO F-MES1
                  GO TO G90.
           UNLOCK MAGARD.
       G40.
           PERFORM SETTA-TQP-RIG THRU EX-SETTA-TQP-RIG.
           REWRITE RF-RIG FROM REKRIG INVALID
                  MOVE 'Errore scrittura ordine' TO F-MES1
                  GO TO G90.
           UNLOCK ORDRIG.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-RIG.
      ************
           GO TO G99.
       G90.
           UNLOCK MAGART.
           UNLOCK MAGARD.
           UNLOCK ORDRIG.
       G95.
           MOVE 'Ordine non aggiornato' TO F-MES2.
           MOVE 2 TO F-NMES.
       G99.
           EXIT.
      *------------------
       H00-AGG-ORD.
           PERFORM I00-RDLCK THRU I99.
           IF SWERR = 1 GO TO H95.
           MOVE RA-BCR-SALDO TO RIG-SALDO.
           COMPUTE RESID = RIG-QUANT - RIG-QSPED.
           IF RESID < ZERO MOVE ZERO TO RESID
                          MOVE 1 TO RIG-SALDO.
           MOVE BCR-QTA TO QUAN.
       H20.
      **** rel 5.0
      *    COMPUTE RIG-QSPED = RIG-QSPED + BCR-QTA.
           IF BCT-TDOC NOT = 3
              COMPUTE RIG-QSPED = RIG-QSPED + BCR-QTA
           ELSE
              COMPUTE RIG-QSPED = RIG-QSPED - BCR-QTA.
      ************
           IF ( BCR-TCOR > ZERO AND < 4 ) OR BCR-TCOR > 6
                                               GO TO H30.
           IF BCR-ART = SPACE GO TO H30.
      **** rel 5.0
      *    IF RIG-SALDO > ZERO MOVE RESID TO QUAN.
      *    SUBTRACT QUAN FROM ART-IMPCL ARD-CIMPE.
           IF RIG-SALDO > ZERO
              MOVE RESID TO QUAN
              IF BCT-TDOC = 3 MULTIPLY -1 BY QUAN.
           IF BCT-TDOC NOT = 3
              SUBTRACT QUAN FROM ART-IMPCL ARD-CIMPE
           ELSE
              ADD QUAN TO ART-IMPCL ARD-CIMPE.
      ************
           REWRITE RF-ART FROM REKART INVALID
                  MOVE 'Errore scrittura articolo' TO F-MES1
                  GO TO H90.
           UNLOCK MAGART.
           REWRITE RF-ARD FROM REKARD INVALID
                  MOVE 'Errore scrittura deposito' TO F-MES1
                  GO TO H90.
           UNLOCK MAGARD.
       H30.
           PERFORM SETTA-TQP-RIG THRU EX-SETTA-TQP-RIG.
      **** rel 2.0
      **** rel 3.0b
      *    IF FUN = 'z'
      *       COMPUTE RESID = RIG-QUANT - RIG-QSPED
      *       IF RESID NOT > ZERO MOVE 1 TO RIG-SALDO
      *       ELSE MOVE ZERO TO RIG-SALDO.
      ************
      ************
           REWRITE RF-RIG FROM REKRIG INVALID
                  MOVE 'Errore scrittura ordine' TO F-MES1
                  GO TO H90.
           UNLOCK ORDRIG.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-RIG.
      ************
           GO TO H99.
       H90.
           UNLOCK MAGART.
           UNLOCK MAGARD.
           UNLOCK ORDRIG.
       H95.
           MOVE 'Ordine non aggiornato' TO F-MES2.
           MOVE 2 TO F-NMES.
      **** rel 5.0
      *    DELETE BOLORD.
      ************
       H99.
           EXIT.
      *------------------
       I00-RDLCK.
           MOVE ZERO TO SWERR.
           READ ORDRIG INTO REKRIG KEPT LOCK INVALID KEY
                MOVE 'Manca rigo ordine' TO F-MES1
                GO TO I90.
           IF SF-RIG > ZERO
              PERFORM REC-LOCK
              GO TO I00-RDLCK.
      **** rel 5.0
       I05.
           MOVE KRI-AZI TO KOR-AZI.
           MOVE KRI-NUM TO KOR-NUM.
           READ ORDCLI INTO REKORD INVALID KEY
                MOVE 'Manca ordine' TO F-MES1
                GO TO I90.
           IF SF-ORD > ZERO 
              PERFORM REC-LOCK
              GO TO I05.
      ************
           IF RIG-TPRIG = 1 OR 2 GO TO I99.
           IF RIG-ARTIC = SPACE OR '0' GO TO I99.
       I10.
           MOVE KCR-AZI   TO KMA-AZI KAD-AZI.
           MOVE BCR-ART   TO KMA-ART KAD-ART.
      **** rel 5.0
      *    MOVE BCT-CDEP  TO KAD-DEP.
           MOVE ORD-CDEP  TO KAD-DEP.
      ************
           READ MAGART INTO REKART KEPT LOCK INVALID KEY
                        MOVE 'Manca articolo' TO F-MES1
                        GO TO I90.
           IF SF-ART > ZERO
              PERFORM REC-LOCK
              GO TO I10.
       I20.
           READ MAGARD INTO REKARD KEPT LOCK INVALID KEY
                MOVE 'Manca articolo deposito' TO F-MES1
                GO TO I90.
           IF SF-ARD > ZERO
              PERFORM REC-LOCK
              GO TO I20.
           GO TO I99.
       I90.
           MOVE 1 TO SWERR.
           UNLOCK MAGART.
           UNLOCK MAGARD.
           UNLOCK ORDRIG.
       I99.
           EXIT.
      *------------------
      * evasione automatica righi ordine
       R-RDR00.
      **** rel 2.0
      *    MOVE ZERO TO SW-RDORD.
           MOVE ZERO TO SAVORD.
      ************
      **** rel 7.1
           MOVE ZERO TO PRIMA-VOLTA.
      ************
           OPEN I-O WDSLAV.
      **** rel 2.0
           IF FUN = 'z' PERFORM CREA-IDLA1 THRU EX-CREA-IDLA1
                        OPEN INPUT WDSLA1.
      ************
           MOVE ZERO TO KEYLV.
      **** rel 4.1
       R-RDR05.
      ************
           START WDSLAV KEY NOT < KEYLV INVALID GO TO F-RDRIG.
       R-RDR10.
           READ WDSLAV NEXT AT END GO TO F-RDRIG.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO R-RDR10.
      **** rel 2.0
      *    IF SW-RDORD = 1 GO TO R-RDR15.
           IF FLGAGG NOT = ZERO GO TO R-RDR15.
           IF SAVORD = KLV-NORD GO TO R-RDR15.
           IF SAVORD NOT = ZERO ADD 5 TO RG-BCR-PGR.
           MOVE KLV-NORD TO SAVORD.
      ************
      * lettura testata ordine e caricamento righi bolla fissi
      **** rel 2.0
      *    MOVE 1 TO SW-RDORD.
      ************
           MOVE RG-BCR-AZI TO KOR-AZI.
           MOVE KLV-NORD   TO KOR-NUM.
           READ ORDCLI INTO REKORD INVALID
                PERFORM INVK-ORD
                GO TO WARNING.
           IF SF-ORD = '9D' OR '9A' OR '35' MOVE RF-ORD TO REKORD.
      **** rel 4.1
           IF ORD-VALUT NOT = BCT-VALUT
              MOVE SPACE TO F-MES1
              STRING "Valuta diversa su ordine " ORD-NUM
                     DELIMITED SIZE
                     INTO F-MES1
              MOVE "I suoi righi non sono stati importati." TO F-MES2
              MOVE 2 TO F-NMES
              CALL 'vrmbox' USING PARMB
              IF KLV-NORD = 99999
                 GO TO F-RDRIG
              ELSE
                 ADD 1     TO KLV-NORD
                 MOVE ZERO TO KLV-PGR
      **** rel 4.1a
      *          GO TO R-RDR10.
                 GO TO R-RDR05.
      ************
      ************
      **** rel 7.1
           IF  PRIMA-VOLTA = ZERO
               IF  BCT-VCOD1 = ZERO AND ORD-VETT NOT = ZERO
                   MOVE ORD-VETT TO BCT-VCOD1
                   REWRITE RF-BCT INVALID
                                  PERFORM INVK-BCT
                                  GO TO ERRIO
                   END-REWRITE
                   MOVE 'M' TO PPAR-TOPE
                   PERFORM CALL-VSRV133-BCT
               END-IF
               MOVE 1 TO PRIMA-VOLTA
           END-IF.
      ************
           PERFORM AZZ-REC THRU EX-AZZ-REC.
      **** rel 2.0
           PERFORM AZZ-PBR THRU EX-AZZ-PBR.
      ************
           MOVE KOR-NUM TO DES2.
           MOVE ORD-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DES4.
      **** rel 6.2
      *    MOVE DESCRIZIONE TO BCR-DESCR.
           MOVE DESCRIZIONE TO BCR-DESCR NCR-DESCR.
      ************
           MOVE 1 TO BCR-TCOR.
      **** rel 6.2
      *    MOVE KBC-AZI    TO KCR-AZI.
      *    MOVE KBC-NUM    TO KCR-NUM.
      *    MOVE KBC-BOL    TO KCR-BOL.
      *    MOVE RG-BCR-PGR TO KCR-PGR.
           MOVE KBC-AZI    TO KCR-AZI KNCR-AZI.
           MOVE KBC-NUM    TO KCR-NUM KNCR-NUM.
           MOVE KBC-BOL    TO KCR-BOL KNCR-BOL.
           MOVE RG-BCR-PGR TO KCR-PGR KNCR-PGR.
           MOVE 1          TO KNCR-PGRN.
           WRITE RF-NCR INVALID PERFORM INVK-NCR
                                GO TO WARNING.
      ************
           WRITE RF-BCR INVALID PERFORM INVK-BCR
                                GO TO WARNING.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BCR.
      ************
           IF ORD-VSORD = SPACE GO TO R-RDR15.
           MOVE ORD-VSORD TO DES6.
      **** rel 6.2
      *    MOVE DESCRIZIONE2 TO BCR-DESCR.
           MOVE DESCRIZIONE2 TO BCR-DESCR NCR-DESCR.
      ************
           MOVE 1 TO BCR-TCOR.
           ADD 5 TO RG-BCR-PGR.
      **** rel 6.2
      *    MOVE RG-BCR-PGR TO KCR-PGR.
           MOVE RG-BCR-PGR TO KCR-PGR KNCR-PGR.
           WRITE RF-NCR INVALID PERFORM INVK-NCR
                                GO TO WARNING.
      ************
           WRITE RF-BCR INVALID PERFORM INVK-BCR
                                GO TO WARNING.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BCR.
      ************
       R-RDR15.
           MOVE ZERO TO RESID.
           MOVE KCR-AZI  TO  KRI-AZI.
           MOVE KLV-NORD TO  KRI-NUM.
           MOVE KLV-PGR  TO  KRI-PRG.
           READ ORDRIG INTO REKRIG INVALID PERFORM INVK-RIG
                                           GO TO WARNING.
           IF SF-RIG = '9D' OR '9A' OR '35' MOVE RF-RIG TO REKRIG.
      **** rel 5.0
           OPEN INPUT ORDPRC.
           MOVE KRI-AZI TO KOPC-AZI.
           MOVE KRI-NUM TO KOPC-NUM.
           MOVE KRI-PRG TO KOPC-PRG.
           MOVE ZERO    TO SKOPC-DATA.
           MOVE ZERO    TO KOPC-PROG.
           START ORDPRC KEY NOT < KEYOPC2 INVALID GO TO ENDOPC.
       LOOPOPC.
           READ ORDPRC NEXT AT END GO TO ENDOPC.
           IF SF-OPC = '9A' OR '9D' OR '35' GO TO LOOPOPC.
           IF KOPC-AZI NOT = KRI-AZI GO TO ENDOPC.
           IF KOPC-NUM NOT = KRI-NUM GO TO ENDOPC.
           IF KOPC-PRG NOT = KRI-PRG GO TO ENDOPC.
           IF SKOPC-DATA = ZERO
              MOVE 'Rigo ordine a programma SOSPESO' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
      *k      IF FUNZ = 1 CLOSE ORDPRC
      *k                  GO TO R-RDR10.
              CLOSE ORDPRC
              GO TO R-RDR10.
       ENDOPC.
           CLOSE ORDPRC.
      ************
           IF NOT ( RIG-TPRIG = 1 OR 3 )
      **** rel 5.0
              IF RIG-SALDO NOT = ZERO AND
                 BCT-TDOC NOT = 3 GO TO R-RDR10.
      *       IF RIG-SALDO NOT = ZERO GO TO R-RDR10.
      ************
           PERFORM AZZ-REC THRU EX-AZZ-REC.
      **** rel 2.0
           PERFORM AZZ-PBR THRU EX-AZZ-PBR.
      ************
           MOVE KBC-AZI    TO KCR-AZI.
           MOVE KBC-NUM    TO KCR-NUM.
           MOVE KBC-BOL    TO KCR-BOL.
           ADD 5 TO RG-BCR-PGR.
           MOVE RG-BCR-PGR TO KCR-PGR.
           MOVE RIG-TPRIG  TO BCR-TCOR.
           PERFORM B00-AUTOM THRU B99.
           GO TO R-RDR10.
       F-RDRIG.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
      **** rel 2.0
           IF FUN = 'z' CLOSE WDSLA1
                        OPEN OUTPUT WDSLA1
                        CLOSE WDSLA1.
      ************
       R-RDR99.
           EXIT.
      *------------------
       B00-AUTOM.
           IF RIG-TPRIG = 3 GO TO B40.
           IF RIG-TPRIG = 1 GO TO B50.
           IF RIG-TPRIG = 2 OR
              ( ( RIG-TPRIG = 4 OR 5 ) AND RIG-ARTIC = SPACE )
                                 MOVE RIG-DESAR TO BCR-DESCR
                                 PERFORM L20 THRU L99
                                 GO TO B20.
           MOVE RIG-ARTIC TO BCR-ART.
           PERFORM L00-RD-ART THRU L99.
       B20.
      **** rel 2.0
      *    MOVE QUAN TO BCR-QTA.
           IF FUN NOT = 'z' MOVE QUAN TO BCR-QTA
                            GO TO B25.
           PERFORM SCRIVI-PBR THRU EX-SCRIVI-PBR.
           MOVE COMQTA TO BCR-QTA.
       B25.
      ************
      **** rel 3.0b
           MOVE RIG-SALDO TO RA-BCR-SALDO.
           IF RIG-QUANT - RIG-QSPED - BCR-QTA <= ZERO
              MOVE 1 TO RA-BCR-SALDO.
      ************
           PERFORM C00-CAL-IMP THRU C99.
       B30.
           MOVE KBC-AZI TO KCR-AZI.
           MOVE KBC-NUM TO KCR-NUM.
           MOVE KBC-BOL TO KCR-BOL.
           WRITE RF-BCR INVALID KEY PERFORM INVK-BCR
                                    GO TO WARNING.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BCR.
      *
           PERFORM CALL-VSRV133-MMG.
      ************
      *
           MOVE ZERO TO PLMS-FUNZ.
           PERFORM G-LMS THRU EX-G-LMS.
      *
      **** rel 2.0
           PERFORM TRAVAS-NOTE THRU EX-TRAVAS-NOTE.
      ************
           GO TO B99.
       B40.
           MOVE RIG-CDSPE TO BCR-SPESA.
           MOVE BCR-SPESA TO KTB-COD.
           MOVE 11 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-RIG
                                           GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO BCR-DESCR.
           MOVE T11-CONTR TO BCR-CONTR.
           MOVE RIG-PREZZ TO BCR-PZLOR BCR-NETRG.
      **** rel 4.0
      *    MOVE RIG-TPRZ  TO BCR-TPRZ.
      **** rel 5.2
      *    MOVE RIG-FSC   TO BCR-FSC.
           MOVE ZERO      TO BCR-FSC.
      ************
      ************
           MOVE RIG-CDIVA TO BCR-IVA.
           MOVE RIG-PROVV TO BCR-PROVV.
           MOVE ZERO TO BCR-QTA.
           GO TO B30.
       B50.
           MOVE RIG-DESAR TO BCR-DESCR.
      **** rel 4.0
      *    MOVE ZERO TO BCR-TPRZ.
           MOVE ZERO TO BCR-FSC.
      ************
           GO TO B30.
       B99.
           EXIT.
      *------------------
       L00-RD-ART.
           MOVE BCR-ART TO KMA-ART.
           MOVE RIG-AZI TO KMA-AZI.
           READ MAGART INTO REKART INVALID KEY PERFORM INVK-ART
                                               PERFORM VISK-RIG
                                               GO TO WARNING.
           IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
           MOVE ART-DESCR TO BCR-DESCR.
           MOVE KMA-ART TO KAD-ART.
           MOVE KMA-AZI TO KAD-AZI.
           MOVE BCT-CDEP TO KAD-DEP.
           READ MAGARD INTO REKARD INVALID KEY PERFORM INVK-ARD
                                               PERFORM VISK-RIG
                                               GO TO WARNING.
           IF SF-ARD = '9D' OR '9A' OR '35' MOVE RF-ARD TO REKARD.
       L20.
      **** rel 5.0
           MOVE KRI-AZI TO OC-AZI.
           MOVE KRI-NUM TO OC-NUM.
           CALL 'vrvopc' USING PAROC.
      ************
           MOVE KRI-NUM   TO BCR-NORD.
           MOVE KRI-PRG   TO BCR-PRORD.
           MOVE RIG-TQUAN TO BCR-TQUAN.
      **** rel 4.0
      *    MOVE RIG-TPRZ  TO BCR-TPRZ.
           MOVE RIG-FSC   TO BCR-FSC.
      ************
           MOVE RIG-UNMIS TO BCR-UM.
           MOVE RIG-CDIVA TO BCR-IVA.
           MOVE RIG-PREZZ TO BCR-PZLOR.
           MOVE RIG-FPNET TO BCR-FPNET.
           MOVE RIG-1SCON TO BCR-SC1.
           MOVE RIG-2SCON TO BCR-SC2.
           MOVE RIG-RIVAL TO BCR-RIVAL.
           MOVE RIG-RIVGR TO BCR-RIVGR.
           MOVE RIG-PROVV TO BCR-PROVV.
           MOVE RIG-CONTR TO BCR-CONTR.
      **** rel 5.0
           MOVE RIG-NOMME TO BCR-NOMME.
      ************
           IF RIG-TPRIG = 2 OR
              ( ( RIG-TPRIG = 4 OR 5 ) AND RIG-ARTIC = SPACE )
                                                     GO TO L25.
      **** rel 6.1
      *    IF BCR-CONTR = ZERO MOVE ART-CPART TO BCR-CONTR.
           IF BCR-CONTR = ZERO 
              MOVE ZERO    TO PARRCR
              MOVE KBC-AZI TO RCR-AZI
      **** rel 6.2
              IF BCT-TDOC = 6 OR 7
                 MOVE 'C'     TO RCR-TIP
              ELSE
      ************
                 MOVE 'R'     TO RCR-TIP
      **** rel 6.2
              END-IF
      ************
              MOVE BCT-CLI TO RCR-CLF
              MOVE BCR-ART TO RCR-ART
              CALL 'vrdcrc' USING PARRCR
              MOVE RCR-CONTR TO BCR-CONTR.
      ************
      **** rel 5.0
           IF BCR-NOMME = ZERO AND RA-BCR-INTRA = 1
              MOVE ART-NOMME TO BCR-NOMME.
      ************
       L25.
           COMPUTE RESID = RIG-QUANT - RIG-QSPED.
      **** rel 5.0
      *    MOVE RESID TO  QUAN.
           IF BCT-TDOC NOT = 3
              MOVE RESID TO QUAN
           ELSE
              MOVE RIG-QSPED TO QUAN.
      ************
      **** rel 3.0b
      *    MOVE 1 TO RA-BCR-SALDO.
      ************
           IF BCR-IVA = ZERO GO TO L30.
           MOVE 3 TO KTB-TIP.
           MOVE BCR-IVA TO KTB-COD.
           READ TABELL INVALID PERFORM INVK-TAB
                               PERFORM VISK-RIG
                               GO TO WARNING.
       L30.
           IF BCR-RIVGR = ZERO GO TO L40.
           MOVE 3 TO KTB-TIP.
           MOVE BCR-RIVGR TO KTB-COD.
           READ TABELL INVALID PERFORM INVK-TAB
                               PERFORM VISK-RIG
                               GO TO WARNING.
       L40.
           IF BCR-CONTR = ZERO GO TO L99.
           MOVE KRI-AZI   TO KPC-AZI.
           MOVE BCR-CONTR TO KPC-COD.
           READ ANACON INVALID PERFORM INVK-CON
                               PERFORM VISK-RIG
                               GO TO WARNING.
       L99.
           EXIT.
      *------------------
       CAR-PARMAG.
           MOVE ZERO  TO PARMAG.
           MOVE SPACE TO M-TIPO
                         M-ART
                         M-UNM
                         M-NBOF.
           MOVE 'V'       TO M-TIPO.
      **** rel 5.1
           IF BCT-TDOC = 6 OR 7
              MOVE MFOR TO MAS
           ELSE
              MOVE MCLI TO MAS.
           MOVE BCT-CLI     TO COD.
      ************
           MOVE CODICE    TO M-CLFO.
           MOVE KAZ-COD   TO M-AZI.
           MOVE BCT-TDOC  TO M-TDOC.
           MOVE BCT-CDEP  TO M-DEP1.
           MOVE BCT-CDEP2 TO M-DEP2.
           MOVE BCT-DATA  TO M-NDAT.
           MOVE BCT-DATA  TO M-ODAT.
           MOVE BCT-CAUS  TO M-NCA1.
           MOVE BCT-CAUC  TO M-NCA2.
           MOVE BCT-VALUT TO M-NVAL.
           MOVE BCT-CAMGG TO M-NCAM.
           MOVE BCT-CPAG  TO M-NPAG.
           MOVE KBC-BOL   TO M-NBOL.
       EX-CAR-PARMAG.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w9' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       REC-LOCK.
      **** rel 1.2
           CALL 'rlock' USING PARLK.
      ************
           EXIT.
      *------------------
      **** rel 5.2
      * procedura L00-LISTINO eliminata
      ************
      *------------------*
       G00-AGGLVE.
      **** rel 2.0
           IF FLGAGG NOT = ZERO GO TO G999.
      ************
           IF BCR-TCOR NOT = ZERO GO TO G999.
      **** rel 4.1
           IF BCT-TDOC > 3 GO TO G999.
      ************
           MOVE KCR-AZI    TO VE-AZI.
           MOVE BCR-ART    TO VE-ART.
           MOVE BCT-CLI    TO VE-CLI.
           MOVE 'B'        TO VE-ORIG.
           MOVE KBC-BOL    TO VE-NDOC.
           MOVE BCT-DATA   TO VE-DTDOC.
           MOVE BCR-QTA    TO VE-QTA.
           MOVE BCR-PZLOR  TO VE-PRZ.
           MOVE BCR-SC1    TO VE-SC1.
           MOVE BCR-SC2    TO VE-SC2.
      **** rel 1.2
           MOVE BCT-SCBAS  TO VE-SCBAS.
           MOVE BCR-FPNET  TO VE-FPNET.
      ************
           MOVE ZERO       TO VE-ST.
           CALL 'vrlsven' USING PARVE.
           CANCEL 'vrlsven'.
       G999.
           EXIT.
      *------------------*
      * setta BCR-TQUAN e BCR-TPRZ per righi occasionali BOLLA
       SETTA-TQP-BCR.
           IF NOT ((BCR-TCOR = 2)  OR
                  ((BCR-TCOR = 4 OR 5) AND BCR-ART = SPACE))
                    GO TO EX-SETTA-TQP-BCR.
      *
           MOVE BCR-QTA TO RD-NUM.
           CALL 'vrround' USING QTA-SET PARRD RD-TIPO.
           MOVE RD-TIPO TO BCR-TQUAN.
      *
      **** rel 4.0
      *    MOVE BCR-PZLOR TO RD-NUM.
      *    CALL 'vrround' USING PRZ-SET PARRD RD-TIPO.
      *    MOVE RD-TIPO TO BCR-TPRZ.
      *
      *    MOVE BCR-PZNET TO RD-NUM.
      *    CALL 'vrround' USING PRZ-SET PARRD RD-TIPO.
      *    IF RD-TIPO > BCR-TPRZ
      *       MOVE RD-TIPO TO BCR-TPRZ.
      *
      *    IF BCT-VALUT > 1 MOVE 1 TO BCR-TPRZ.
      ************
       EX-SETTA-TQP-BCR.
           EXIT.
      *------------------*
      * setta RIG-TQUAN e RIG-TPRZ per righi occasionali ORDINE
       SETTA-TQP-RIG.
           IF NOT ((RIG-TPRIG = 2)  OR
                  ((RIG-TPRIG = 4 OR 5) AND RIG-ARTIC = SPACE))
                    GO TO EX-SETTA-TQP-RIG.
      *
           MOVE RIG-QUANT TO RD-NUM.
           CALL 'vrround' USING QTA-SET PARRD RD-TIPO.
           MOVE RD-TIPO TO RIG-TQUAN.
      *
           MOVE RIG-QSPED TO RD-NUM.
           CALL 'vrround' USING QTA-SET PARRD RD-TIPO.
           IF RD-TIPO > RIG-TQUAN
              MOVE RD-TIPO TO RIG-TQUAN.
      *
      **** rel 4.0
      *    MOVE RIG-PREZZ TO RD-NUM.
      *    CALL 'vrround' USING PRZ-SET PARRD RD-TIPO.
      *    MOVE RD-TIPO TO RIG-TPRZ.
      *
      *    IF ORD-VALUT > 1 MOVE 1 TO RIG-TPRZ.
      ************
       EX-SETTA-TQP-RIG.
           EXIT.
      *------------------*
       G-LMS.
           MOVE KAZ-COD  TO PLMS-AZI.
           MOVE KBC-NUM  TO PLMS-NUM.
           MOVE KBC-BOL  TO PLMS-BOL.
           MOVE KCR-PGR  TO PLMS-PRG.
           MOVE ZERO     TO PLMS-DTOLD.
           CALL 'vrclms' USING PAR-LMS.
           CANCEL 'vrclms'.
       EX-G-LMS.
           EXIT.
      *------------------*
      **** rel 2.0
       SCRIVI-PBR.
           IF FLGAGG NOT = ZERO GO TO EX-SCRIVI-PBR.
           MOVE KLV-NORD TO KL1-NORD.
           MOVE KLV-PGR  TO KL1-RORD.
           MOVE ZERO     TO KL1-PGR COMQTA.
           PERFORM CERCA-PGR THRU EX-CERCA-PGR.
           START WDSLA1 KEY NOT < KEYL1 INVALID GO TO SCRIVI90.
       SCRIVI10.
           READ WDSLA1 NEXT AT END GO TO SCRIVI90.
           IF SF-LA1 = '9D' OR '9A' OR '35' GO TO SCRIVI10.
           IF KLV-NORD NOT = KL1-NORD GO TO SCRIVI90.
           IF KLV-PGR  NOT = KL1-RORD GO TO SCRIVI90.

           MOVE KAZ-COD  TO KPOR-AZI.
           MOVE KL1-NORD TO KPOR-NORD.
           MOVE KL1-RORD TO KPOR-RORD.
           MOVE KL1-PGR  TO KPOR-PGR .
           READ PRORIG INVALID PERFORM INVK-POR
                               GO TO ERRIO.

           IF POR-SPED = 9 GO TO SCRIVI10.

           COMPUTE COMQTA = COMQTA + POR-QTA * POR-NIMB.

           MOVE 9 TO POR-SPED.
           REWRITE RF-POR INVALID PERFORM INVK-POR
                                  GO TO ERRIO.

           MOVE KBC-AZI TO KPBR-AZI.
           MOVE KBC-NUM TO KPBR-TNUM.
           MOVE KBC-BOL TO KPBR-NBOL.
           MOVE KCR-PGR TO KPBR-RBOL.
           ADD 5        TO KPBR-PGR.

           MOVE POR-NPAL  TO PBR-NPAL.
           MOVE POR-NCOL  TO PBR-NCOL.
           MOVE KPOR-NORD TO PBR-NORD.
           MOVE KPOR-RORD TO PBR-RORD.
           MOVE KPOR-PGR  TO PBR-PORD.
           MOVE POR-QTA   TO PBR-QTA.
           MOVE POR-PNET  TO PBR-PNET.
           MOVE POR-PLOR  TO PBR-PLOR.
           MOVE POR-COLAT TO PBR-COLAT.
           MOVE POR-IMB   TO PBR-IMB.
           MOVE POR-NIMB  TO PBR-NIMB.
           WRITE RF-PBR INVALID PERFORM INVK-PBR
                                GO TO ERRIO.

           GO TO SCRIVI10.
       SCRIVI90.
       EX-SCRIVI-PBR.
           EXIT.
      *-------------------------+
       CREA-IDLA1.
           MOVE SPACE TO ID-LA1.
           STRING 'w8' PID DELIMITED SPACE INTO ID-LA1.
       EX-CREA-IDLA1.
           EXIT.
      *----------------------*
       CERCA-PGR.
           MOVE KBC-AZI TO KPBR-AZI.
           MOVE KBC-NUM TO KPBR-TNUM.
           MOVE KBC-BOL TO KPBR-NBOL.
           MOVE KCR-PGR TO KPBR-RBOL.
           MOVE ZERO    TO KPBR-PGR.
           START PROBCR KEY NOT < KEYPBR INVALID GO TO CERCA99.
       CERCA10.
           READ PROBCR NEXT AT END GO TO CERCA99.
           IF SF-PBR = '9D' OR '9A' OR '35' GO TO CERCA10.
           IF KBC-AZI NOT = KPBR-AZI  GO TO CERCA99.
           IF KBC-NUM NOT = KPBR-TNUM GO TO CERCA99.
           IF KBC-BOL NOT = KPBR-NBOL GO TO CERCA99.
           IF KCR-PGR NOT = KPBR-RBOL GO TO CERCA99.
           GO TO CERCA10.
       CERCA99.
       EX-CERCA-PGR.
           EXIT.
      *----------------------*
       DEL-PROBCR.
           IF FLGAGG NOT = ZERO GO TO EX-DEL-PROBCR.
           MOVE KCR-AZI TO KPBR-AZI.
           MOVE KCR-NUM TO KPBR-TNUM.
           MOVE KCR-BOL TO KPBR-NBOL.
           MOVE KCR-PGR TO KPBR-RBOL.
           MOVE ZERO    TO KPBR-PGR.
           START PROBCR KEY NOT < KEYPBR INVALID GO TO EX-DEL-PROBCR.
       RDPBR.
           READ PROBCR NEXT AT END GO TO EX-DEL-PROBCR.
           IF SF-PBR = '9D' OR '9A' OR '35' GO TO RDPBR.
           IF KPBR-AZI  NOT = KCR-AZI OR
              KPBR-TNUM NOT = KCR-NUM OR
              KPBR-NBOL NOT = KCR-BOL OR
              KPBR-RBOL NOT = KCR-PGR GO TO EX-DEL-PROBCR.

           DELETE PROBCR INVALID PERFORM INVK-PBR
                                 GO TO ERRIO.

           MOVE KPBR-AZI  TO KPOR-AZI.
           MOVE PBR-NORD  TO KPOR-NORD.
           MOVE PBR-RORD  TO KPOR-RORD.
           MOVE PBR-PORD  TO KPOR-PGR .
           READ PRORIG INVALID GO TO RDPBR.
           IF POR-SPED NOT = 9 GO TO RDPBR.

           MOVE 1 TO POR-SPED.
           REWRITE RF-POR INVALID PERFORM INVK-POR
                                  GO TO ERRIO.

           GO TO RDPBR.
       EX-DEL-PROBCR.
           EXIT.
      *------------------
       AZZ-PBR.
           MOVE ZERO TO REKPBR.
           MOVE ZERO TO PBR-QTA PBR-PNET PBR-PLOR.
           MOVE SPACE TO PBR-COLAT.
       EX-AZZ-PBR.
           EXIT.
      *------------------
       CONTROLLA-COERENZA.
           MOVE KCR-AZI TO KPBR-AZI.
           MOVE KCR-NUM TO KPBR-TNUM.
           MOVE KCR-BOL TO KPBR-NBOL.
           MOVE KCR-PGR TO KPBR-RBOL.
           MOVE ZERO    TO KPBR-PGR FLGUNO COMQTA.
           START PROBCR KEY NOT < KEYPBR INVALID GO TO CONTR99.
       CONTR10.
           READ PROBCR NEXT AT END GO TO CONTR99.
           IF SF-PBR = '9D' OR '9A' OR '35' GO TO CONTR10.
           IF KCR-AZI NOT = KPBR-AZI  GO TO CONTR99.
           IF KCR-NUM NOT = KPBR-TNUM GO TO CONTR99.
           IF KCR-BOL NOT = KPBR-NBOL GO TO CONTR99.
           IF KCR-PGR NOT = KPBR-RBOL GO TO CONTR99.

           COMPUTE COMQTA = COMQTA + PBR-QTA * PBR-NIMB.

           MOVE 1 TO FLGUNO.
           GO TO CONTR10.
       CONTR99.
           IF FLGUNO = ZERO GO TO EX-CONTROLLA-COERENZA.

           IF COMQTA NOT = BCR-QTA
              MOVE 'Quantita'' discordanti tra rigo bolla' TO F-MES1
              MOVE 'e righi pallets corrispondenti'        TO F-MES2
              MOVE 2 TO F-NMES
              CALL 'vrmbox' USING PARMB.
       EX-CONTROLLA-COERENZA.
           EXIT.
      *-------------------*
      * importazione note aggiuntive interne dell'articolo
       F-LEG-NAT.
           IF RG-BCR-ART = SPACE
              GO TO END-F-LEG-NAT.
           IF RA-BCR-NOTE NOT = SPACE
              MOVE 'Per importare le note aggiuntive' TO F-MES1
              MOVE ' dell''articolo e'' necessario'   TO F-MES2
              MOVE 'cancellare il contenuto corrente' TO F-MES3
              MOVE 3 TO F-NMES
              GO TO WARNING.
           MOVE RG-BCR-AZI TO KNAT-AZI.
           MOVE RG-BCR-ART TO KNAT-ART.
           MOVE 1          TO KNAT-TIP.
           MOVE ZERO       TO KNAT-PRG.
           MOVE ZERO TO KN.
           START NOTART KEY > KEYNAT INVALID GO TO F-LEG-NAT-90.
       F-LEG-NAT-10.
           READ NOTART NEXT AT END GO TO F-LEG-NAT-90.
           IF KNAT-AZI > RG-BCR-AZI GO TO F-LEG-NAT-90.
           IF KNAT-ART > RG-BCR-ART GO TO F-LEG-NAT-90.
           IF KNAT-TIP > 1          GO TO F-LEG-NAT-90.
           ADD 1 TO KN.
      **** rel 6.2
      *    IF KN > NRIGMAX GO TO F-LEG-NAT-90.
           IF KN > NRIGMAXL GO TO F-LEG-NAT-90.
      ************
           MOVE NAT-DESCR TO RA-BCR-RIGNOT(KN).
           GO TO F-LEG-NAT-10.
       F-LEG-NAT-90.
           IF KN = ZERO GO TO END-F-LEG-NAT.
      **** rel 6.2
      *    MOVE NRIGMAX TO ML-MAXRIG.
      *    MOVE 30      TO ML-LUNRIG.
      *    MOVE 2       TO ML-FUN.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4       TO ML-FUN.
      ************
           CALL 'vrmle' USING ML-CTRL RA-BCR-NOTE.
       END-F-LEG-NAT.
      **** rel 6.0a
           EXIT.
       END-F-LEG-NAT2.
      *************
           GO TO FINE.
      * - - - - - *
      * fase di scrittura note aggiuntive rigo bolla cliente
       DL-WR-NOTE.
           PERFORM DL-NOTE THRU EX-DL-NOTE.
      *
       WR-NOTE.
      **** rel 6.3
           IF RA-BCR-NOTE = SPACE AND RG-BCR-TCOR = 1
      **** rel 7.2
           AND RG-BCR-FUN NOT = 'A'
      ************
              MOVE KCR-AZI TO KNCR-AZI
              MOVE KCR-NUM TO KNCR-NUM
              MOVE KCR-BOL TO KNCR-BOL
              MOVE KCR-PGR TO KNCR-PGR
              MOVE 1       TO KNCR-PGRN
              MOVE SPACE   TO NCR-DESCR
              WRITE RF-NCR INVALID PERFORM INVK-NCR
                                   GO TO ERRIO
              END-WRITE
              GO TO EX-DL-WR-NOTE.
      ************
           IF RA-BCR-NOTE = SPACE GO TO EX-DL-WR-NOTE.
      *
      **** rel 6.2
      *    MOVE NRIGMAX TO KVALID.
           MOVE NRIGMAXL TO KVALID.
      ************
           PERFORM UNTIL RA-BCR-RIGNOT(KVALID) NOT = SPACE
              SUBTRACT 1 FROM KVALID
           END-PERFORM.
      *
      **** rel 6.3
      *    IF KVALID = 1 AND BCR-TCOR = 1 GO TO EX-DL-WR-NOTE.
      ************
      *
           MOVE KCR-AZI TO KNCR-AZI.
           MOVE KCR-NUM TO KNCR-NUM.
           MOVE KCR-BOL TO KNCR-BOL.
           MOVE KCR-PGR TO KNCR-PGR.
           MOVE ZERO    TO KNCR-PGRN.
      *
           MOVE 1 TO KML.
           PERFORM UNTIL KML > KVALID
              ADD 1 TO KNCR-PGRN
              MOVE RA-BCR-RIGNOT(KML) TO NCR-DESCR
              WRITE RF-NCR INVALID PERFORM INVK-NCR
                                   GO TO ERRIO
              END-WRITE
              ADD 1 TO KML
           END-PERFORM.
      *
           PERFORM CONTA-NBYTE-BCR-NOTE.
      * conversione per visualizzazione automatica nel caso di conferma
      * dopo una variazione
      **** rel 6.2
      *    MOVE NRIGMAX TO ML-MAXRIG.
      *    MOVE 30      TO ML-LUNRIG.
      *    MOVE 2       TO ML-FUN.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4       TO ML-FUN.
      ************
           CALL 'vrmle' USING ML-CTRL RA-BCR-NOTE.
       EX-DL-WR-NOTE.
           EXIT.
      *------------------
      * cancellazione note aggiuntive rigo bolla cliente
       DL-NOTE.
           MOVE KCR-AZI TO KNCR-AZI.
           MOVE KCR-NUM TO KNCR-NUM.
           MOVE KCR-BOL TO KNCR-BOL.
           MOVE KCR-PGR TO KNCR-PGR.
           MOVE ZERO    TO KNCR-PGRN.
      *
           START NOTBCR KEY >= KEYNCR INVALID GO TO EX-DL-NOTE.
       DL-NOTE-10.
           READ NOTBCR NEXT AT END GO TO EX-DL-NOTE.
           IF KNCR-AZI > KCR-AZI GO TO EX-DL-NOTE.
           IF KNCR-NUM > KCR-NUM GO TO EX-DL-NOTE.
           IF KNCR-BOL > KCR-BOL GO TO EX-DL-NOTE.
           IF KNCR-PGR > KCR-PGR GO TO EX-DL-NOTE.
           DELETE NOTBCR INVALID PERFORM INVK-NCR
                                 GO TO V-ERROR.
           GO TO DL-NOTE-10.
       EX-DL-NOTE.
           EXIT.
      *------------------
      * fase di lettura note aggiuntive rigo bolla cliente e
      * caricamento aree interfaccia
       RD-NCR.
           PERFORM AZZ-NOTE.
      *
           MOVE ZERO TO RA-BCR-FLGNOTE.
           MOVE ZERO TO KN.
      *
           MOVE KCR-AZI TO KNCR-AZI.
           MOVE KCR-NUM TO KNCR-NUM.
           MOVE KCR-BOL TO KNCR-BOL.
           MOVE KCR-PGR TO KNCR-PGR.
           MOVE ZERO    TO KNCR-PGRN.
           START NOTBCR KEY >= KEYNCR INVALID GO TO RD-NCR-20.
       RD-NCR-10.
           READ NOTBCR NEXT AT END GO TO RD-NCR-20.
           IF KNCR-AZI > KCR-AZI GO TO RD-NCR-20.
           IF KNCR-NUM > KCR-NUM GO TO RD-NCR-20.
           IF KNCR-BOL > KCR-BOL GO TO RD-NCR-20.
           IF KNCR-PGR > KCR-PGR GO TO RD-NCR-20.
           ADD 1 TO KN.
      **** rel 6.2
      *    IF KN <= NRIGMAX
           IF KN <= NRIGMAXL
      ************
              MOVE NCR-DESCR TO RA-BCR-RIGNOT(KN)
              MOVE 1 TO RA-BCR-FLGNOTE
           GO TO RD-NCR-10.
       RD-NCR-20.
      *
           PERFORM CONTA-NBYTE-BCR-NOTE.
      *
      **** rel 6.2
      *    MOVE NRIGMAX TO ML-MAXRIG.
      *    MOVE 30      TO ML-LUNRIG.
      *    MOVE 2       TO ML-FUN.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4       TO ML-FUN.
      ************
           CALL 'vrmle' USING ML-CTRL RA-BCR-NOTE.
      *
       EX-RD-NCR.
           EXIT.
      *------------------
       AZZ-NOTE.
           MOVE 1 TO KML.
           PERFORM UNTIL KML > NRIGMAX
              MOVE SPACE TO RA-BCR-RIGNOT(KML)
              ADD 1 TO KML
           END-PERFORM.
      *
           MOVE ZERO TO RA-BCR-NBYTE
                        RA-BCR-FLGNOTE.
      *------------------
      * conta nbyte note aggiuntive
       CONTA-NBYTE-BCR-NOTE.
           MOVE ZERO TO RA-BCR-NBYTE.
           IF RA-BCR-NOTE NOT = SPACE
      **** rel 6.2
      *       MOVE NRIGMAX TO KVALID
              MOVE NRIGMAXL TO KVALID
      ************
              PERFORM UNTIL RA-BCR-RIGNOT(KVALID) NOT = SPACE
                 SUBTRACT 1 FROM KVALID
              END-PERFORM
      **** rel 6.2
      *       COMPUTE RA-BCR-NBYTE = KVALID * 30.
              COMPUTE RA-BCR-NBYTE = KVALID * NCOLMAX.
      ************
      *------------------
      * fase di scrittura note aggiuntive rigo bolla cliente
      * da rigo ordine
       TRAVAS-NOTE.
           PERFORM DL-NOTE THRU EX-DL-NOTE.
      **** rel 6.2
           MOVE SPACE TO COM-IN.
      ************
      *
           MOVE KCR-AZI TO KNCR-AZI.
           MOVE KCR-NUM TO KNCR-NUM.
           MOVE KCR-BOL TO KNCR-BOL.
           MOVE KCR-PGR TO KNCR-PGR.
           MOVE ZERO    TO KNCR-PGRN.
      *
           MOVE KRI-AZI TO KNRI-AZI.
           MOVE KRI-NUM TO KNRI-NUM.
           MOVE KRI-PRG TO KNRI-PRG.
           MOVE ZERO    TO KNRI-PRGN.
      *
      **** rel 6.2
      *    START NOTRIG KEY >= KEYNRI INVALID GO TO EX-TRAVAS-NOTE.
      *RD-NOTE-RIG.
      *    READ NOTRIG NEXT AT END GO TO EX-TRAVAS-NOTE.
      *    IF KNRI-AZI > KRI-AZI GO TO EX-TRAVAS-NOTE.
      *    IF KNRI-NUM > KRI-NUM GO TO EX-TRAVAS-NOTE.
      *    IF KNRI-PRG > KRI-PRG GO TO EX-TRAVAS-NOTE.
           START NOTRIG KEY >= KEYNRI INVALID GO TO END-TRAVAS-NOTE.
       RD-NOTE-RIG.
           READ NOTRIG NEXT AT END GO TO END-TRAVAS-NOTE.
           IF KNRI-AZI > KRI-AZI   GO TO END-TRAVAS-NOTE.
           IF KNRI-NUM > KRI-NUM   GO TO END-TRAVAS-NOTE.
           IF KNRI-PRG > KRI-PRG   GO TO END-TRAVAS-NOTE.
      ************
      *
           ADD 1 TO KNCR-PGRN.
      **** rel 6.2
      *    MOVE NRI-DESCR TO NCR-DESCR.
      *    WRITE RF-NCR INVALID PERFORM INVK-NCR GO TO ERRIO.
           MOVE NRI-DESCR TO COM-RIN(KNCR-PGRN).
      ************
           GO TO RD-NOTE-RIG.
      *
      **** rel 6.2
       END-TRAVAS-NOTE.
      **** rel 7.2
      *    IF COM-IN = SPACE GO TO EX-TRAVAS-NOTE.
           IF COM-IN = SPACE
              IF BCR-TCOR = 1
                 MOVE KCR-AZI TO KNCR-AZI
                 MOVE KCR-NUM TO KNCR-NUM
                 MOVE KCR-BOL TO KNCR-BOL
                 MOVE KCR-PGR TO KNCR-PGR
                 MOVE 1       TO KNCR-PGRN
                 MOVE SPACE   TO NCR-DESCR
                 WRITE RF-NCR INVALID PERFORM INVK-NCR
                                      GO TO ERRIO
                 END-WRITE
      **** rel 7.2
      *          GO TO EX-TRAVAS-NOTE
              END-IF
              GO TO EX-TRAVAS-NOTE
           END-IF.
      **********
      *
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4 TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL COM-IN. 
      *    
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 5 TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL COM-IN. 
      *
           MOVE NRIGMAXL TO KVALID.
           PERFORM UNTIL COM-RIN(KVALID) NOT = SPACE
                   SUBTRACT 1 FROM KVALID.
           MOVE ZERO TO KNCR-PGRN.
           PERFORM UNTIL KNCR-PGRN >= KVALID
                ADD 1 TO KNCR-PGRN
                MOVE COM-RIN(KNCR-PGRN) TO NCR-DESCR
                WRITE RF-NCR INVALID PERFORM INVK-NCR GO TO ERRIO.
      ************
       EX-TRAVAS-NOTE.
           EXIT.
      *------------------*
      **** rel 5.2
      * procedura CERCA-SCONTI eliminata
      ************
      *------------------*
      ************
      **** rel 4.0
       AGGIORNA-FSC-D.
           MOVE SPACE TO RA-BCR-FSC-D.
           IF RG-BCR-FSC = 1 MOVE 'x10'   TO RA-BCR-FSC-D.
           IF RG-BCR-FSC = 2 MOVE 'x100'  TO RA-BCR-FSC-D.
           IF RG-BCR-FSC = 3 MOVE 'x1000' TO RA-BCR-FSC-D.
      *------------------
      **** rel 5.2
      * procedura LISTINO-BASE-LIRE eliminata
      ************
      ************
      **** rel 5.0
      *------------------*
      * importazione testi esterni *
       F-LEG-TESTO.
      **** rel 5.0-2
           IF RA-BCR-NTESTO = ZERO GO TO END-F-LEG-TESTO.
      **************
           MOVE RG-BCR-AZI    TO KARN-AZI.
           MOVE RA-BCR-NTESTO TO KARN-NUM.
           MOVE ZERO          TO KARN-PGR.
      *
           MOVE 1 TO KML.
      **** rel 6.2
      *    PERFORM UNTIL KML > NRIGMAX
           PERFORM UNTIL KML > NRIGMAXL
      ************
              MOVE SPACE TO RA-BCR-RIGNOT(KML)
              ADD 1 TO KML
           END-PERFORM.
      *
           MOVE ZERO TO KN.
           START ARCNOT KEY >=  KEYARN INVALID GO TO F-LEG-TESTO-90.
       F-LEG-TESTO-10.
           READ ARCNOT NEXT AT END GO TO F-LEG-TESTO-90.
           IF KARN-AZI NOT = RG-BCR-AZI GO TO F-LEG-TESTO-90.
           IF KARN-NUM NOT = RA-BCR-NTESTO GO TO F-LEG-TESTO-90.

           ADD 1 TO KN.
      **** rel 6.2
      *    IF KN > NRIGMAX GO TO F-LEG-TESTO-90.
           IF KN > NRIGMAXL GO TO F-LEG-TESTO-90.
      ************
           MOVE ARN-NOTE TO RA-BCR-RIGNOT(KN).
           GO TO F-LEG-TESTO-10.

           READ ARCNOT NEXT AT END GO TO F-LEG-TESTO-90.
           IF KARN-AZI NOT = RG-BCR-AZI GO TO F-LEG-TESTO-90.
           IF KARN-NUM NOT = RA-BCR-NTESTO GO TO F-LEG-TESTO-90.

           ADD 1 TO KN.
      **** rel 6.2
      *    IF KN > NRIGMAX GO TO F-LEG-TESTO-90.
           IF KN > NRIGMAXL GO TO F-LEG-TESTO-90.
      ************
           MOVE ARN-NOTE TO RA-BCR-RIGNOT(KN).
           GO TO F-LEG-TESTO-10.
       F-LEG-TESTO-90.
           IF KN = ZERO GO TO END-F-LEG-TESTO.
      **** rel 6.2
      *    MOVE NRIGMAX TO ML-MAXRIG.
      *    MOVE 30      TO ML-LUNRIG.
      *    MOVE 2       TO ML-FUN.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4       TO ML-FUN.
      ************
           CALL 'vrmle' USING ML-CTRL RA-BCR-NOTE.
       END-F-LEG-TESTO.
           EXIT.
      *-------------*
      **** rel 5.2
      * procedura CERCA-PROVVIGIONE eliminata
      ************
      **** rel 6.0a
       AGG-PRV.
           IF FUN = 'W' GO TO EX-AGG-PRV.
           IF RG-BCR-TCOR NOT = ZERO GO TO EX-AGG-PRV.
      *
           MOVE RG-BCR-AZI   TO RPV-AZI.
           MOVE BCT-CLI      TO RPV-CLI.
           MOVE CLF-GRU      TO RPV-GRU.
           MOVE BCT-VALUT    TO RPV-VALUT.
           MOVE BCT-DATA     TO RPV-DATA.
           MOVE BCT-SCBAS    TO RPV-SCBAS.
           MOVE BCT-CAGE     TO RPV-CDAGE.
           MOVE RG-BCR-ART   TO RPV-ART.
           MOVE ART-GMERC    TO RPV-GMERC.
           MOVE RG-BCR-QTA   TO RPV-QTA.
           MOVE RG-BCR-TQUAN TO RPV-TQUAN.
      *
           MOVE RG-BCR-PZLOR TO DP-PREZZO.
           CALL 'rforprz' USING DP-PREZZO DP-FSC FSC-UNI.
           MOVE DP-PREZZO    TO RPV-PZLOR.   
      * 
           MOVE RG-BCR-SC1   TO RPV-SC1.
           MOVE RG-BCR-SC2   TO RPV-SC2.
           MOVE RG-BCR-FPNET TO RPV-FPNET.
           CALL 'vrdprv' USING PARRPV.
           IF RPV-FLGP NOT = ZERO
              MOVE RPV-PROVV TO RG-BCR-PROVV
              MOVE RPV-IPROV TO RG-BCR-IPROV.
       EX-AGG-PRV.
           EXIT.
      ************
      *------------------*
       C00-CAL-SCAPP.

           MOVE "V"       TO IM-TIPO.
      *
      **** rel 5.2
           MOVE RG-BCR-FSC   TO DP-FSC.
      ************
           MOVE RG-BCR-PZLOR TO DP-PREZZO.
           CALL 'rforprz' USING DP-PREZZO DP-FSC FSC-UNI.
           MOVE DP-PREZZO    TO IM-PZLOR.   
      * 
           MOVE RG-BCR-QTA   TO IM-QTA.
           MOVE BCT-SCBAS    TO IM-SCBAS.
           MOVE RG-BCR-SC1   TO IM-SC1.
           MOVE RG-BCR-SC2   TO IM-SC2.
           MOVE BCT-VALUT    TO IM-VALUT.
           MOVE RG-BCR-TCOR  TO IM-TCOR.
           MOVE RG-BCR-TQUAN TO IM-TQUAN.
      **** rel 5.2
           MOVE RG-BCR-FSC  TO IM-FSC.
      ************
           MOVE RG-BCR-FPNET TO IM-FPNET.
           CALL 'vrimpor' USING PARIM.
      **** rel 5.2
      * procedura C00-10. EX-C00-CAL-SCAPP. eliminata
      ************
      **** rel 6.1
      *------------------*
        CERCA-CONTR.
           MOVE ZERO       TO PARRCR.
           MOVE RG-BCR-AZI TO RCR-AZI.
      **** rel 6.2
           IF BCT-TDOC = 6 OR 7
              MOVE 'C'     TO RCR-TIP
           ELSE
      ************
           MOVE 'R'        TO RCR-TIP.
           MOVE BCT-CLI    TO RCR-CLF.
           MOVE RG-BCR-ART TO RCR-ART.
           CALL 'vrdcrc' USING PARRCR.
           MOVE RCR-CONTR TO RG-BCR-CONTR.
      *
           IF RG-BCR-CONTR = ZERO GO TO EX-CERCA-CONTR.
           MOVE RG-BCR-AZI   TO KPC-AZI.
           MOVE RG-BCR-CONTR TO KPC-COD.
           READ ANACON INTO REKCON INVALID MOVE ALL '*' TO CON-DSABB.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           IF CON-DSABB = SPACE MOVE CON-DESCR TO CON-DSABB.
           MOVE CON-DSABB TO RA-BCR-CONTR-D.
        EX-CERCA-CONTR.
           EXIT.
      *------------------*
      ************
      **** rel 7.1
       CALL-VSRV133-RIG.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'RIG'   TO PPAR-TARC.
           MOVE KEYRI   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 RIG ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------*
       CALL-VSRV133-BCR.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'BCR'   TO PPAR-TARC.
           MOVE KEYCR   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 BCR ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------*
       CALL-VSRV133-BCT.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'BCT'   TO PPAR-TARC.
           MOVE KEYBC   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 BCT ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------*
       CALL-VSRV133-MMG.
           IF BCR-TCOR NOT = 2 AND
              BCR-ART NOT = SPACE AND
              BCR-QTA NOT = ZERO AND
              BCR-NMOV NOT = ZERO AND
              FLGAGG = ZERO
                 MOVE ZERO    TO PPAR-FUN
                 MOVE 'MMG'   TO PPAR-TARC
                 MOVE 'I'     TO PPAR-TOPE
                 MOVE KCR-AZI  TO S-KMM-AZI
                 MOVE BCT-CDEP TO S-KMM-DEP
                 MOVE BCR-ART  TO S-KMM-ART
                 MOVE BCT-DATA TO S-KMM-DAT
                 MOVE BCR-NMOV TO S-KMM-NUM
                 MOVE S-KEYMM TO PPAR-KEY
                 MOVE ZERO    TO PPAR-CATT
                 CALL 'vsrv133' USING PARPPAR 'DSV'
                 IF PPAR-ERR > 1
                    MOVE SPACE TO MESS
                    STRING 'Errore vsrv133 MMG ' PPAR-ERR
                            DELIMITED SIZE INTO MESS
                    GO TO ERRIO.
      *------------------*
      ************
