       IDENTIFICATION DIVISION.
       PROGRAM-ID. VORFG15.
      *
      *    Interfaccia ORDRIF per scheda
      *
      *---------------------------------------------------------------
      * Nota: oltre ai valori soliti puo' essere restituito
      *       ST=4 nel caso di unita' di misura del rigo ordine non
      *       corrispondente con una di quelle caricate sull'articolo.
      * Valori particolari di FUN:
      *       T=per tipo rigo 0, importa nelle note aggiuntive del
      *         rigo fornitore, le note esterne caricate sull'articolo.
      *         Restituisce un warning nel caso che non si possa
      *         importare i dati dell'articolo perche' ci sono gia'
      *         delle note caricate sul rigo ordine.
      **** rel 2.0
      *       e=evasione record selezionati da zoom multiplo
      *       f=flegga offerta come non piu' valida
      ************
      **** rel 5.1
      * Ricompilato per copy gririfrk variata per
      * campi sconti di rigo con due decimali
      ************
      **** rel 5.2
      * Ricompilato per copy griartrk variata 
      * per campi sconti con decimali
      ************
      *---------------------------------------------------------------
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
      **** rel 5.0
           COPY 'griarnsl'.
      ************
           COPY 'griclfsl'.
           COPY 'griartsl'.
           COPY 'grinatsl'.
           COPY 'griardsl'.
           COPY 'griorfsl'.
           COPY 'griobfsl'.
           COPY 'gririfsl'.
           COPY 'grinrfsl'.
           COPY 'griconsl'.
      **** rel 6.3
      *    COPY 'grilaqsl'.
      ************
           COPY 'gritabsl'.
      **** rel 5.0
           COPY 'griopfsl'.
      ************
      **** rel 2.0
           COPY 'grifftsl'.
           COPY 'griffrsl'.
           COPY 'grinffsl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
      ************
       DATA DIVISION.
       FILE SECTION.
      **** rel 5.0
           COPY 'griarn'.
      ************
           COPY 'griclf'.
           COPY 'griart'.
           COPY 'grinat'.
           COPY 'griard'.
           COPY 'griorf'.
           COPY 'griobf'.
           COPY 'gririf'.
           COPY 'grinrf'.
           COPY 'gricon'.
      **** rel 6.3
      *    COPY 'grilaq'.
      ************
           COPY 'gritab'.
      **** rel 5.0
           COPY 'griopf'.
      ************
      **** rel 2.0
           COPY 'grifft'.
           COPY 'griffr'.
           COPY 'grinff'.
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 8 DATA RECORD RF-LAV.
       01  RF-LAV.
           02 KEYLV.
             05 KLV-NOFF   PIC 9(5).
             05 KLV-PRG    PIC 999.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
           COPY 'grit35rk'.
           COPY 'griclfrk'.
           COPY 'griartrk'.
           COPY 'griardrk'.
           COPY 'griorfrk'.
           COPY 'gririfrk'.
      **** rel 2.0
           COPY 'grifftrk'.
           COPY 'griffrrk'.
      ************
      **** rel 6.3
           COPY 'grit25rk'.
      ************
           COPY 'rekt21'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parrd'.
           COPY 'parac'.
           COPY 'parml'.
      **** rel 1.2
           COPY 'parlk'.
      ************
      **** rel 2.0
           COPY 'parmb'.
      ************
      **** rel 5.0
           COPY 'parbf'.
      ************
      **** rel 4.0
           COPY 'pardp'.
           COPY 'parbl'.
      ************
      **** rel 5.2
           COPY 'parpcfa'.
      ************
      **** rel 6.2
           COPY 'parorf'.
           COPY 'partdc'.
      ************
      **** rel 7.1
           COPY 'parppar'.
      ************
      **** rel 5.0
       01  ID-ARN PIC X(15) VALUE 'arcnot'.
      ************
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-ART PIC X(15) VALUE 'magart'.
       01  ID-NAT PIC X(15) VALUE 'notart'.
       01  ID-ARD PIC X(15) VALUE 'magard'.
       01  ID-ORF PIC X(15) VALUE 'ordfor'.
       01  ID-OBF PIC X(15) VALUE 'bolorf'.
       01  ID-RIF PIC X(15) VALUE 'ordrif'.
       01  ID-NRF PIC X(15) VALUE 'notrif'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
      **** rel 6.3
      *01  ID-LAQ PIC X(15) VALUE 'lisacq'.
      ************
      **** rel 5.0
       01  ID-OPF PIC X(15) VALUE 'ordprf'.
      ************
      **** rel 2.0
       01 ID-FFT PIC X(15) VALUE 'offfor'.
       01 ID-FFR PIC X(15) VALUE 'offrif'.
       01 ID-NFF PIC X(15) VALUE 'notoff'.
       01 ID-LAV PIC X(45).
      ************
      *--------------------------------------------------------
      * costanti
      *    NRIGMAX: n. righe max note aggiuntive rigo fornitore
      **** rel 6.2
      *    NRIGMAX: n. righe fisiche max in pari con occurs
      *    NCOLMAX: n. colonne fisiche max
       78  NRIGMAX VALUE 100.
       78  NCOLMAX VALUE 60.
      *78  NRIGMAX VALUE 20.
      ************
      *--------------------------------------------------------
       01  COMODI.
      **** rel 5.0
           05 SF-ARN   PIC XX.
      ************
           05 SF-TAB   PIC XX.
           05 SF-CLF   PIC XX.
           05 SF-ART   PIC XX.
           05 SF-NAT   PIC XX.
           05 SF-ARD   PIC XX.
           05 SF-ORF   PIC XX.
           05 SF-OBF   PIC XX.
           05 SF-RIF   PIC XX.
           05 SF-NRF   PIC XX.
           05 SF-CON   PIC XX.
      **** rel 6.3
      *    05 SF-LAQ   PIC XX.
      ************
      **** rel 5.0
           05 SF-OPF   PIC XX.
      ************
      **** rel 2.0
           05 SF-FFT   PIC XX.
           05 SF-FFR   PIC XX.
           05 SF-NFF   PIC XX.
           05 SF-LAV   PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(30).
           05 IF-AZI   PIC 9(3).
           05 IF-NUM   PIC 9(5).
      **** rel 5.0
           05 IF-FLGOPF PIC 9.
           05 COMDATPK  PIC 9(5) COMP-3.
      ************
      **** rel 6.3
           05 IF-INTRA  PIC 9.
      ************
           05 KML      PIC 9(5).
           05 KVALID   PIC 9(5).
           05 KN       PIC 9(5).
           05 MAXRIGD  PIC ZZ9.
           05 WART     PIC X(18).
      **** rel 4.0
      *    05 WPREZ    PIC S9(10)V999 VALUE ZERO.
           05 WPREZ    PIC S9(11)V999 VALUE ZERO.
      ************
           05 CLAV     PIC S9(10)V999 VALUE ZERO.
           05 SW-ESBOL PIC 9.
           05 CODCLI.
              10 MAS   PIC 99.
              10 COD   PIC 9(5).
      **** rel 4.0
           05 COMEURO PIC 9(3) VALUE ZERO.
      ************
      **** rel 2.0
           05 SAVOFF   PIC 9(5).
           05 DESCRIZIONE.
              10 FILLER PIC X(12) VALUE '* NS.RIC.N.'.
              10 DES2   PIC ZZZZ9 VALUE ZERO.
              10 FILLER PIC XXX VALUE ' -'.
              10 DES4   PIC X(8) VALUE SPACE.
           05 DESCRIZIONE2.
              10 FILLER PIC X(12) VALUE '* NS.RIFER. '.
              10 DES6   PIC X(10) VALUE SPACE.
      ************
      **** rel 5.2
           05 FLGNRIF PIC 9 VALUE ZERO.
      ************
      **** rel 7.1
           05 DTINT   PIC 9(5) VALUE ZERO.
      ************
      **** rel 5.0
       01  PAR-SAR.
           05 PSAR-AZI     PIC 999   VALUE ZERO.
           05 PSAR-ART     PIC X(12) VALUE SPACE.
           05 PSAR-TIP     PIC 9     VALUE ZERO.
      **** rel 5.0
           05 PSAR-ESEC    PIC 9     VALUE ZERO.
      ************
           05 PSAR-ERR     PIC 9     VALUE ZERO.
           05 PSAR-TES     PIC X(76) VALUE SPACE.
      ************
      **** rel 6.2
           05 FLGI    PIC 9 VALUE ZERO.
           05 NROF    PIC 999 VALUE ZERO.
           05 FLGCONF PIC 9 VALUE ZERO.
      *    NRIGMAXL: n. righe  logiche max rigo cliente
      *    NCOLMAXL: n. colonne max note aggiuntive rigo cliente
           05 NRIGMAXL PIC 9(3).
           05 NCOLMAXL PIC 9(3).
      ************
      **** rel 6.2
       01  COM-IN.
           05 COM-RIN PIC X(60) OCCURS 100.
      ************
       LINKAGE SECTION.
           COPY 'gririfrg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-RIF-CTRL
                                RG-RIF-REC
                                RA-RIF-AGG
                                IF-MESS.
           COPY 'declxer1'.
      **** rel 5.0
           COPY 'dclarn'.
      ************
           COPY 'dclclf'.
           COPY 'dclart'.
           COPY 'dclnat'.
           COPY 'dclard'.
           COPY 'dclorf'.
           COPY 'dclobf'.
           COPY 'dclrif'.
           COPY 'dclnrf'.
           COPY 'dclcon'.
      **** rel 6.3
      *    COPY 'dcllaq'.
      ************
           COPY 'dcltab'.
      **** rel 5.0
           COPY 'dclopf'.
      ************
      **** rel 2.0
           COPY 'dclfft'.
           COPY 'dclffr'.
           COPY 'dclnff'.
           COPY 'dcllav'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-RIF-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-RIF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           IF (RG-RIF-FUN = 'N' OR 'n') AND
              (RG-RIF-EOF = 2 OR 3)     GO TO ESCI.
           IF (RG-RIF-FUN = 'P' OR 'p') AND
              (RG-RIF-EOF = 1 OR 2)     GO TO ESCI.
           MOVE RG-RIF-FUN   TO FUN.
           MOVE RG-RIF-IDX   TO IDX.
           MOVE RG-RIF-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.
      **** rel 4.0
           IF RG-RIF-FUN = 'r' AND FUN-PREC = 'r' GO TO ESCI.
      ************

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-RIF-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'T' GO TO F-LEG-NAT.
      **** rel 2.0
           IF FUN = 'e' GO TO F-MZOOM.
           IF FUN = 'f' GO TO F-FLEGGA-FFT.
      ************
      **** rel 6.0a
           IF FUN = 'E' GO TO F-EXIT.
      *************
      **** rel 5.0
           IF FUN = 'J' PERFORM F-LEG-TESTO THRU END-F-LEG-TESTO
                        GO TO FINE.
      ************
           MOVE 'vorfg15: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      **** rel 2.0
      * - - - - - *
       F-MZOOM.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           IF ID-LAV NOT = SPACE PERFORM R-RDF00 THRU R-RDF99.
           GO TO CHIUDI.
      * - - - - - *
       F-FLEGGA-FFT.
      * flegga offerta come non piu' valida
      * deve essere valido il valore di SAVOFF
           IF SAVOFF = ZERO GO TO F-FLEGGA-FFT-90.
           MOVE RG-RIF-AZI TO KFFT-AZI.
           MOVE SAVOFF     TO KFFT-NUM.
           READ OFFFOR INTO REKFFT INVALID GO TO F-FLEGGA-FFT-90.
           IF SF-FFT = '9D' OR '9A' OR '35' MOVE RF-FFT TO REKFFT.
           MOVE ZERO TO FFT-FLGVDT.
           REWRITE RF-FFT FROM REKFFT INVALID PERFORM INVK-FFT
                                              GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-FFT.
      ************
       F-FLEGGA-FFT-90.
           GO TO CHIUDI.
      ************
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-RIF-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-RIF-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-RIF-ST = 7 GO TO FINE.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK ORDRIF.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-RIF INVALID
              PERFORM INVK-RIF
              GO TO ERRIO.
           IF ORF-VALUT = CLF-VAL PERFORM G00-AGGLAQ THRU G99.
       F-SCRIVI-NRF.
           PERFORM DL-WR-NOTE THRU EX-DL-WR-NOTE.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-RIF INVALID
              PERFORM INVK-RIF
              GO TO ERRIO.
           UNLOCK ORDRIF.
           IF ORF-VALUT = CLF-VAL PERFORM G00-AGGLAQ THRU G99.
       F-AGGIOR-NRF.
           PERFORM DL-WR-NOTE THRU EX-DL-WR-NOTE.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-RIF
              GO TO WARNING.
           IF RG-RIF-ST = 7 GO TO FINE.
           PERFORM F00-GES-OBF THRU F99.
      **** rel 5.0
           IF SW-ESBOL > ZERO AND RA-RIF-FLGOPF = 1
              MOVE 'Esistono bolle di uscita' TO F-MES1
              MOVE 'Vuoi annullare'           TO F-MES2
              MOVE 2 TO F-NMES
              MOVE 'Q' TO MB-TIPO
              MOVE '1' TO MB-DEFAULT
              CALL 'vrmbox' USING PARMB
              IF MB-RISP = 'S'
                 GO TO F-DELETE-10.
      ************
           IF SW-ESBOL > ZERO
                 MOVE 'Rigo non Annullabile'     TO F-MES1
                 MOVE 'Esistono bolle di uscita' TO F-MES2
                 MOVE 2 TO F-NMES
                 GO TO WARNING.
      **** rel 5.0
       F-DELETE-10.
      ************
           PERFORM DB-STORNA THRU EX-DB-STORNA.
      **** rel 5.0
           IF RA-RIF-FLGOPF = 1
              PERFORM DEL-OBF THRU EX-DEL-OBF.
      ************
           DELETE ORDRIF INVALID
              PERFORM INVK-RIF
              GO TO ERRIO.
           UNLOCK ORDRIF.
      *
           PERFORM DL-NOTE THRU EX-DL-NOTE.
      **** rel 5.0
           IF RA-RIF-FLGOPF = 1
      **** rel 7.1
      *       CALL 'vrdlopf' USING KEYRF.
              CALL 'vrdlopf' USING KEYRF "DSV".
      ************
      ************
      **** rel 7.1
           MOVE ORF-DAT TO DTINT.
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-RIF-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
      * importazione note aggiuntive esterne dell'articolo
       F-LEG-NAT.
           IF RG-RIF-TPRIG NOT = ZERO
              GO TO END-F-LEG-NAT.
           IF RA-RIF-NOTE NOT = SPACE
              MOVE 'Per importare le note aggiuntive' TO F-MES1
              MOVE ' dell''articolo e'' necessario'   TO F-MES2
              MOVE 'cancellare il contenuto corrente' TO F-MES3
              MOVE 3 TO F-NMES
              GO TO WARNING.
           MOVE RG-RIF-AZI   TO KNAT-AZI.
           MOVE RG-RIF-ARTIC TO KNAT-ART.
           MOVE 1            TO KNAT-TIP.
           MOVE ZERO         TO KNAT-PRG.
           MOVE ZERO TO KN.
           START NOTART KEY > KEYNAT INVALID GO TO F-LEG-NAT-90.
       F-LEG-NAT-10.
           READ NOTART NEXT AT END GO TO F-LEG-NAT-90.
           IF KNAT-AZI > RG-RIF-AZI   GO TO F-LEG-NAT-90.
           IF KNAT-ART > RG-RIF-ARTIC GO TO F-LEG-NAT-90.
           IF KNAT-TIP > 1            GO TO F-LEG-NAT-90.
           ADD 1 TO KN.
      **** rel 6.2
      *    IF KN > NRIGMAX GO TO F-LEG-NAT-90.
           IF KN > NRIGMAXL GO TO F-LEG-NAT-90.
      ************
           MOVE NAT-DESCR TO RA-RIF-RIGNOT(KN).
           GO TO F-LEG-NAT-10.
       F-LEG-NAT-90.
           IF KN = ZERO GO TO END-F-LEG-NAT.
      **** rel 6.2
      *    MOVE NRIGMAX TO ML-MAXRIG.
      *    MOVE 30      TO ML-LUNRIG.
      *    MOVE 2       TO ML-FUN.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4       TO ML-FUN.
      ************
           CALL 'vrmle' USING ML-CTRL RA-RIF-NOTE.
       END-F-LEG-NAT.
      **** rel 6.0a
           EXIT.
       END-F-LEG-NAT2.
      *************
           GO TO FINE.
      * - - - - - *
      **** rel 5.0
      * importazione testi esterni *
       F-LEG-TESTO.
      **** rel 5.0-2
           IF RA-RIF-NTESTO = ZERO GO TO END-F-LEG-TESTO.
      **************
           MOVE RG-RIF-AZI    TO KARN-AZI.
           MOVE RA-RIF-NTESTO TO KARN-NUM.
           MOVE ZERO          TO KARN-PGR.
      *
           MOVE 1 TO KML.
      **** rel 6.2
      *    PERFORM UNTIL KML > NRIGMAX
           PERFORM UNTIL KML > NRIGMAXL
      ************
              MOVE SPACE TO RA-RIF-RIGNOT(KML)
              ADD 1 TO KML
           END-PERFORM.
      *
           MOVE ZERO TO KN.
           START ARCNOT KEY >=  KEYARN INVALID GO TO F-LEG-TESTO-90.
       F-LEG-TESTO-10.
           READ ARCNOT NEXT AT END GO TO F-LEG-TESTO-90.
           IF KARN-AZI NOT = RG-RIF-AZI GO TO F-LEG-TESTO-90.
           IF KARN-NUM NOT = RA-RIF-NTESTO GO TO F-LEG-TESTO-90.

           ADD 1 TO KN.
      **** rel 6.2
      *    IF KN > NRIGMAX GO TO F-LEG-TESTO-90.
           IF KN > NRIGMAXL GO TO F-LEG-TESTO-90.
      ************
           MOVE ARN-NOTE TO RA-RIF-RIGNOT(KN).
           GO TO F-LEG-TESTO-10.
       F-LEG-TESTO-90.
           IF KN = ZERO GO TO END-F-LEG-TESTO.
      **** rel 6.2
      *    MOVE NRIGMAX TO ML-MAXRIG.
      *    MOVE 30      TO ML-LUNRIG.
      *    MOVE 2       TO ML-FUN.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4       TO ML-FUN.
      ************
           CALL 'vrmle' USING ML-CTRL RA-RIF-NOTE.
       END-F-LEG-TESTO.
           EXIT.
      *-------------*
      ************
       F-EXIT.
           UNLOCK ORDRIF.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-RIF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE TABELL ANACLF MAGART MAGARD
                 ORDFOR BOLORF ORDRIF NOTRIF
      **** rel 2.0
                 OFFFOR OFFRIF NOTOFF
      ************
      **** rel 5.0
                 ORDPRF ARCNOT
      ************
                 NOTART.
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-RIF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-RIF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
      **** rel 5.0
           COPY 'griarner'.
      ************
           COPY 'griclfer'.
           COPY 'griarter'.
           COPY 'grinater'.
           COPY 'griarder'.
           COPY 'griorfer'.
           COPY 'griobfer'.
           COPY 'gririfer'.
           COPY 'grinrfer'.
           COPY 'griconer'.
           COPY 'gritaber'.
      **** rel 5.0
           COPY 'griopfer'.
      ************
      **** rel 2.0
           COPY 'griffter'.
           COPY 'griffrer'.
           COPY 'grinffer'.
      ************
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           OPEN INPUT TABELL ANACLF NOTART.
      **** rel 2.0
           OPEN INPUT OFFRIF NOTOFF.
           OPEN I-O   OFFFOR.
      ************
           OPEN I-O   MAGART MAGARD ORDFOR BOLORF ORDRIF NOTRIF.
      **** rel 5.0
           OPEN I-O ORDPRF.
           OPEN INPUT ARCNOT.
      ************
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MFOR TO MAS.
      *
      **** rel 5.2
           MOVE 14 TO KTB-TIP.
           MOVE 2  TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
              PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-NOTRIF TO FLGNRIF.
      ************
      **** rel 6.3
           MOVE 25         TO T25-TIP.
           MOVE RG-RIF-AZI TO T25-COD.
           MOVE ZERO       TO T25-PRG.
           MOVE T25-KEYID  TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-INTRA TO RA-RIF-INTRA.
      ************
      *
           MOVE RG-RIF-AZI TO KOF-AZI.
           MOVE RG-RIF-NUM TO KOF-NUM.
           READ ORDFOR INTO REKORF INVALID PERFORM INVK-ORF
                                           GO TO ERRIO.
           IF SF-ORF = '9D' OR '9A' OR '35' MOVE RF-ORF TO REKORF.
           MOVE ORF-CDCLI TO COD.
      *
           MOVE RG-RIF-AZI TO KCF-AZI.
           MOVE CODCLI     TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID PERFORM INVK-CLF
                                           GO TO ERRIO.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
      **** rel 2.0
      *
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
      ************
      **** rel 6.2
      *  verifico se c'e' ordine a richiamo, se si carico sort 
           MOVE ZERO        TO PARORF.
           MOVE RG-RIF-AZI  TO PORF-AZI.
           MOVE RG-RIF-NUM  TO PORF-NUM.
           CALL 'vrrdorf' USING PARORF.
      ************
      **** rel 4.0
           CALL 'rveur' USING COMEURO.
      ************
      **** rel 5.0
      *
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO COMDATPK.
      ************
      *
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-RIF-EOF.
      **** rel 6.2
           MOVE RG-RIF-AZI TO PTDC-AZI.
           MOVE 'ORF'      TO PTDC-COD.
           CALL 'vrctdc' USING PARTDC. 
           MOVE PTDC-NRIG TO NRIGMAXL.
           MOVE PTDC-NCOL TO NCOLMAXL.
      ************
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO  TO RF-RIF REKRIF.
           MOVE ZERO  TO RIF-QUANT
                         RIF-DTCSR
                         RIF-DTCSC
                         RIF-PREZZ
                         RIF-1SCON
                         RIF-2SCON
                         RIF-QARR
                         RIF-2QARR
                         RIF-CONTR.
           MOVE SPACE TO RIF-ARTIC
                         RIF-UNMIS
                         RIF-DESAR.
      *
           MOVE REKRIF TO RF-RIF.
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
           MOVE RG-RIF-AZI TO IF-AZI.
           MOVE RG-RIF-NUM TO IF-NUM.
      **** rel 5.0
           MOVE RA-RIF-FLGOPF TO IF-FLGOPF.
      ************
      **** rel 6.3
           MOVE RA-RIF-INTRA  TO IF-INTRA.
      ************

      * azzeramento aree interfaccia
           MOVE ZERO  TO RG-RIF-REC.
           MOVE ZERO  TO RG-RIF-QUANT
                         RG-RIF-1SCON
                         RG-RIF-2SCON
                         RG-RIF-QARR
                         RG-RIF-2QARR.
           MOVE SPACE TO RG-RIF-ARTIC
                         RG-RIF-UNMIS
                         RG-RIF-DESAR.

           MOVE ZERO  TO RA-RIF-AGG.
           MOVE SPACE TO RA-RIF-CONTR-D
                         RA-RIF-UM1-D
                         RA-RIF-UM2-D
                         RA-RIF-2UNMIS.
           MOVE SPACE TO WART.
      **** rel 4.0
           MOVE SPACE TO RA-RIF-FSC-D.
      ************
      **** rel 5.0
           MOVE ZERO TO RA-RIF-NTESTO.
      ************
      *
           PERFORM AZZ-NOTE.
      *
      * ripristino dei campi chiave fissi
           MOVE IF-AZI TO RG-RIF-AZI.
           MOVE IF-NUM TO RG-RIF-NUM.
      **** rel 5.0
           MOVE IF-FLGOPF TO RA-RIF-FLGOPF.
      ************
      **** rel 6.3
           MOVE IF-INTRA  TO RA-RIF-INTRA.
      ************
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
           MOVE RG-RIF-AZI TO KRF-AZI.
           MOVE RG-RIF-NUM TO KRF-NUM.
           MOVE ZERO TO KRF-PRG RG-RIF-PRG.
           START ORDRIF KEY NOT < KEYRF INVALID GO TO NORIF.
       RDBLR.
           READ ORDRIF NEXT INTO REKRIF AT END GO TO NORIF.
           IF SF-RIF = '9D' OR '9A' OR '35' GO TO RDBLR.
           IF KRF-AZI > RG-RIF-AZI GO TO NORIF.
           IF KRF-NUM > RG-RIF-NUM GO TO NORIF.
           MOVE KRF-PRG TO RG-RIF-PRG.
           GO TO RDBLR.
       NORIF.
           ADD 5 TO RG-RIF-PRG.
      *
           MOVE 2 TO TIPOP1.
           MOVE ORF-DTCSR TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-RIF-DTCSR.
           MOVE ORF-DTCSC TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-RIF-DTCSC.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-RIF-AZI TO KRF-AZI.
           MOVE RG-RIF-NUM TO KRF-NUM.
           MOVE RG-RIF-PRG TO KRF-PRG.
           MOVE KEYRF TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYRF.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ ORDRIF INTO REKRIF INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-RIF = '9D' OR '9A' OR '35' MOVE RF-RIF TO REKRIF.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ ORDRIF INTO REKRIF KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-RIF > ZERO MOVE 7 TO RG-RIF-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ ORDRIF PREVIOUS INTO REKRIF AT END MOVE 1 TO EOF
           ELSE
              READ ORDRIF NEXT INTO REKRIF AT END MOVE 3 TO EOF.
           IF EOF > ZERO GO TO RNP-80.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-RIF = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *


      * trovato record valido: reset EOF
           MOVE ZERO TO RG-RIF-EOF.
           MOVE KEYRF TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-RIF-EOF.
           IF RG-RIF-EOF = 4 MOVE 2 TO RG-RIF-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-RIF = LOW-VALUE GO TO EX-TEST-EOL.
           IF KRF-AZI = RG-RIF-AZI AND
              KRF-NUM = RG-RIF-NUM GO TO EX-TEST-EOL.
           IF FUN = 'P' OR 'p'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
      **** rel 6.2
      *    MOVE NRIGMAX TO ML-MAXRIG.
      *    MOVE 30      TO ML-LUNRIG.
      *    MOVE 1       TO ML-FUN.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 5       TO ML-FUN.
      ************
           CALL 'vrmle' USING ML-CTRL RA-RIF-NOTE.
      *
           MOVE RG-RIF-AZI       TO RIF-AZI
                                    RIF-AZ4.
           MOVE RG-RIF-NUM       TO RIF-NUM
                                    RIF-NU2
                                    RIF-NU3
                                    RIF-NU4.
           MOVE RG-RIF-PRG       TO RIF-PRG.
           MOVE RG-RIF-TPRIG     TO RIF-TPRIG.
           MOVE RG-RIF-DESAR     TO RIF-DESAR.
      *
           IF RG-RIF-TPRIG = 1
              MOVE 1 TO RIF-SALDO
              MOVE RA-RIF-RIGNOT(1) TO RIF-DESAR
              GO TO CARICA-REC-90.
      *
           MOVE RG-RIF-CDIVA     TO RIF-CDIVA.
      **** rel 4.0
      *    MOVE RG-RIF-PREZZ     TO RIF-PREZZ.
      *    IF ORF-VALUT > 1 MOVE 1 TO RG-RIF-TPRZ.
      *    MOVE RG-RIF-TPRZ      TO RIF-TPRZ.
           MOVE RG-RIF-FSC       TO RIF-FSC.
      ************
      *
           IF RG-RIF-TPRIG = 3
              MOVE RG-RIF-CDSPE  TO RIF-CDSPE
      **** rel 4.0
              MOVE RG-RIF-PREZZ  TO RIF-PREZZ
      ************
              MOVE 1 TO RIF-SALDO
              GO TO CARICA-REC-90.
      **** rel 4.0
           MOVE RG-RIF-FSC   TO DP-FSC.
           MOVE RG-RIF-PREZZ TO DP-PREZZO.
           CALL 'rforprz' USING DP-PREZZO DP-FSC FSC-UNI.
           MOVE DP-PREZZO    TO RIF-PREZZ.
      ************
      *
           MOVE RG-RIF-ARTIC     TO RIF-ARTIC.
           MOVE RG-RIF-LOTTO     TO RIF-LOTTO.
           MOVE RG-RIF-QUANT     TO RIF-QUANT.
           MOVE RG-RIF-DTCSR TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO RIF-DTCSR.
           MOVE RG-RIF-DTCSC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO RIF-DTCSC.
           MOVE RG-RIF-UNMIS     TO RIF-UNMIS.
           MOVE RG-RIF-1SCON     TO RIF-1SCON.
           MOVE RG-RIF-2SCON     TO RIF-2SCON.
           MOVE RG-RIF-XC        TO RIF-XC.
           MOVE RG-RIF-TQUAN     TO RIF-TQUAN.
           MOVE RG-RIF-QARR      TO RIF-QARR.
           MOVE RG-RIF-SALDO     TO RIF-SALDO.
           MOVE RG-RIF-2QARR     TO RIF-2QARR.
           MOVE RG-RIF-CONTR     TO RIF-CONTR.
      **** rel 2.0
           IF RIF-QARR > RIF-QUANT
              MOVE 1 TO RIF-SALDO.
      ************
      **** rel 6.3
           MOVE RG-RIF-NOMC TO RIF-NOMC.
      ************
      *
           PERFORM SETTA-TQP-RIF THRU EX-SETTA-TQP-RIF.
       CARICA-REC-90.
           MOVE REKRIF TO RF-RIF.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE RIF-AZI       TO RG-RIF-AZI.
           MOVE RIF-NUM       TO RG-RIF-NUM.
           MOVE RIF-PRG       TO RG-RIF-PRG.
           MOVE RIF-TPRIG     TO RG-RIF-TPRIG.
           MOVE RIF-DESAR     TO RG-RIF-DESAR.
      *
           IF RIF-TPRIG = 1
              GO TO EX-CARICA-RG.
      *
           MOVE RIF-CDIVA     TO RG-RIF-CDIVA.
      **** rel 4.0
      *    MOVE RIF-PREZZ     TO RG-RIF-PREZZ.
           MOVE RIF-FSC       TO RG-RIF-FSC.
      ************
      *
           IF RIF-TPRIG = 3
              MOVE RIF-CDSPE  TO RG-RIF-CDSPE
      **** rel 4.0
              MOVE RIF-PREZZ     TO RG-RIF-PREZZ
      ************
              GO TO EX-CARICA-RG.
      *
      **** rel 4.0
           MOVE RIF-FSC   TO DP-FSC.
           MOVE RIF-PREZZ TO DP-PREZZO.
           CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC.
           MOVE DP-PREZZO TO RG-RIF-PREZZ.
      ************
      *
           IF RIF-TPRIG = 2
              MOVE RIF-CONTR TO RG-RIF-CONTR.
      *
           MOVE RIF-ARTIC     TO RG-RIF-ARTIC
                                 WART.
           MOVE RIF-LOTTO     TO RG-RIF-LOTTO.
           MOVE RIF-QUANT     TO RG-RIF-QUANT.
           MOVE RIF-DTCSR TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-RIF-DTCSR.
           MOVE RIF-DTCSC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-RIF-DTCSC.
           MOVE RIF-UNMIS     TO RG-RIF-UNMIS.
           MOVE RIF-1SCON     TO RG-RIF-1SCON.
           MOVE RIF-2SCON     TO RG-RIF-2SCON.
           MOVE RIF-XC        TO RG-RIF-XC.
           MOVE RIF-TQUAN     TO RG-RIF-TQUAN.
      **** rel 4.0
      *    MOVE RIF-TPRZ      TO RG-RIF-TPRZ.
      ************
           MOVE RIF-QARR      TO RG-RIF-QARR.
           MOVE RIF-SALDO     TO RG-RIF-SALDO.
           MOVE RIF-2QARR     TO RG-RIF-2QARR.
      *
           IF RIF-TPRIG = 2
      **** rel 4.0
      *       MOVE 2 TO RG-RIF-TQUAN
      *       MOVE 1 TO RG-RIF-TPRZ.
              MOVE 2 TO RG-RIF-TQUAN.
      ************
      **** rel 6.3
           MOVE RIF-NOMC TO RG-RIF-NOMC.
      ************
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
           MOVE SPACE TO RA-RIF-CONTR-D.
           IF NOT (RG-RIF-TPRIG = 2) GO TO RVID-30.
           IF RG-RIF-CONTR = ZERO    GO TO RVID-30.
           MOVE 21           TO T21-TIP.
           MOVE RG-RIF-CONTR TO T21-COD.
           MOVE T21-KEYID TO KEYTB.
           READ TABELL INTO REKT21 INVALID
                MOVE 'Codice costo inesistente' TO RA-RIF-CONTR-D
                GO TO RVID-30.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT21.
           MOVE RG-RIF-AZI TO KPC-AZI.
           MOVE T21-CPART  TO KPC-COD.
           OPEN INPUT ANACON.
           READ ANACON INVALID MOVE ALL '*' TO CON-DSC.
           MOVE CON-DSC TO RA-RIF-CONTR-D.
           CLOSE ANACON.
       RVID-30.
           MOVE SPACE TO RA-RIF-2UNMIS
                         RA-RIF-UM1-D
                         RA-RIF-UM2-D.
           MOVE ZERO  TO RA-RIF-2QUANT
                         RA-RIF-TPUM.
           IF NOT (RG-RIF-TPRIG = ZERO) GO TO RVID-90.
           MOVE RG-RIF-AZI   TO KMA-AZI.
           MOVE RG-RIF-ARTIC TO KMA-ART.
           READ MAGART INTO REKART INVALID KEY
                MOVE SPACE TO ART-UNMIS ART-2UNMIS.
           IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
           IF NOT (RG-RIF-UNMIS = ART-UNMIS OR ART-2UNMIS)
              GO TO RVID-40.
           IF ART-2UNMIS NOT = SPACE
              IF RG-RIF-UNMIS = ART-2UNMIS
                 MOVE ART-UNMIS TO RA-RIF-2UNMIS
                 COMPUTE RD-NUM = RG-RIF-QUANT / ART-COEFF
                 CALL 'vrround' USING QTA-S PARRD ART-TQUAN
                 MOVE RD-NUM TO RA-RIF-2QUANT.
           GO TO RVID-90.
       RVID-40.
           IF FUN NOT = 'r'
              IF ART-COEFF NOT = ZERO
                 MOVE ART-2UNMIS TO RA-RIF-2UNMIS
                 COMPUTE RD-NUM = RG-RIF-QUANT / ART-COEFF
                 CALL 'vrround' USING QTA-S PARRD ART-TQUAN
                 MOVE RD-NUM TO RA-RIF-2QUANT
              END-IF
              GO TO RVID-90.
           MOVE ART-UNMIS TO RA-RIF-UM1-D.
           IF ART-2UNMIS = SPACE
              MOVE 1 TO RA-RIF-TPUM
              MOVE "UM del rigo ordine non ammessa !" TO F-MES1
              MOVE "Adeguata a quella dell'articolo"  TO F-MES2
              MOVE 2 TO F-NMES
              MOVE 4 TO ERRIO-ST
           ELSE
              MOVE 2 TO RA-RIF-TPUM
              MOVE ART-2UNMIS TO RA-RIF-UM2-D
              MOVE "  UM del rigo ordine non ammessa !  " TO F-MES1
              MOVE "Selezionarne una tra quelle proposte" TO F-MES2
              MOVE 2 TO F-NMES
              MOVE 4 TO ERRIO-ST.
       RVID-90.
      **** rel 4.0
           MOVE ZERO TO RA-RIF-CBFSC.
           IF RG-RIF-TPRIG = 2
              IF RG-RIF-FSC > ZERO MOVE 1 TO RA-RIF-CBFSC.

           PERFORM AGGIORNA-FSC-D.
      ************
      *
           PERFORM RD-NRF THRU EX-RD-NRF.
      **** rel 6.2
           IF PORF-NOPF NOT = ZERO *> verifico ordine a richiamo
              PERFORM VER-ART-OPF THRU EX-VER-ART-OPF.
      ********
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-RIF-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
      *
       V-PRG.
           MOVE 'RIF-PRG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PRG.
           IF RG-RIF-PRG = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-PRG.
      *
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-RIF-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-TPRIG.
           MOVE 'RIF-TPRIG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPRIG.
           IF NOT (RG-RIF-TPRIG = ZERO OR 1 OR 2 OR 3)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF RG-RIF-TPRIG = 2 AND KRF-AZI = ZERO
      **** rel 4.0
      *       MOVE 2 TO RG-RIF-TQUAN
      *       MOVE 1 TO RG-RIF-TPRZ.
              MOVE 2 TO RG-RIF-TQUAN.
      ************
       E-TPRIG.
      *
       V-ARTIC.
      * Nota: non modificabile in variazione
           MOVE 'RIF-ARTIC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ARTIC.
           IF NOT (RG-RIF-TPRIG = 0) GO TO E-ARTIC.
           CALL 'vrcartb' USING RG-RIF-AZI RG-RIF-ARTIC.
           IF RG-RIF-ARTIC = SPACE OR '0'
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           IF WART = RG-RIF-ARTIC GO TO E-ARTIC.
      **** rel 6.2
           IF RA-RIF-FLGOPF = 1 *> verifico ordine a programma
              IF PORF-FLGR = 1 
                 PERFORM VER-ART-PRO THRU EX-VER-ART-PRO.
           IF PORF-NOPF NOT = ZERO *> verifico ordine a richiamo
              PERFORM VER-ART-OPF THRU EX-VER-ART-OPF.
      ************
      **** rel 5.2
           MOVE 9 TO PCFA-FUN.
       LP-PCFA.
      ************
           MOVE RG-RIF-ARTIC TO WART.
           MOVE SPACE TO RG-RIF-DESAR.
           MOVE RG-RIF-ARTIC TO KMA-ART KAD-ART.
           MOVE RG-RIF-AZI   TO KMA-AZI KAD-AZI.
           READ MAGART INTO REKART INVALID KEY
      **** rel 5.2
                IF PCFA-FUN = 9
                   MOVE RG-RIF-AZI TO PCFA-AZI
                   MOVE 'F' TO PCFA-TIP
                   MOVE ORF-CDCLI TO PCFA-CLF
                   MOVE RG-RIF-ARTIC TO PCFA-ART
                   CALL 'vrrcfa' USING PARPCFA
                   IF PCFA-ST = ZERO AND
                      PCFA-ART NOT = SPACE
                         MOVE PCFA-ART TO RG-RIF-ARTIC
                         MOVE ZERO TO PCFA-FUN
                         GO TO LP-PCFA
                   END-IF
                END-IF
      ************
                PERFORM ERR-CINE
                MOVE SPACE TO WART
                GO TO V-ERROR.
           IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
      **** rel 4.0
           MOVE ART-FSC   TO DP-FSC.
           MOVE ORF-VALUT TO DP-VALUT.
           CALL 'rdetfsc' USING DP-VALUT DP-FSC.
           MOVE DP-FSC    TO RG-RIF-FSC.
           PERFORM AGGIORNA-FSC-D.
      ************
           MOVE ORF-CDDEP TO KAD-DEP.
           READ MAGARD INVALID
                MOVE 'Articolo non caricato su deposito' TO MESS
                MOVE SPACE TO WART
                GO TO V-ERROR.
           MOVE ART-UNMIS  TO RA-RIF-UM1-D.
           MOVE ART-2UNMIS TO RA-RIF-UM2-D.
           IF ART-2UNMIS = SPACE
              MOVE 1         TO RA-RIF-TPUM
              MOVE ART-UNMIS TO RG-RIF-UNMIS
              MOVE SPACE     TO RA-RIF-2UNMIS
           ELSE
              MOVE 2          TO RA-RIF-TPUM
              MOVE ART-2UNMIS TO RG-RIF-UNMIS
              MOVE ART-UNMIS  TO RA-RIF-2UNMIS.
           MOVE ART-CDIVA TO RG-RIF-CDIVA.
           MOVE ART-DESCR TO RG-RIF-DESAR.
           MOVE ART-TQUAN TO RG-RIF-TQUAN.
      **** rel 6.3
           MOVE ART-NOMME TO RG-RIF-NOMC.
      ************
      **** rel 4.0
           IF ORF-VALUT = 1 AND CLF-TPRZ NOT = ZERO
              MOVE CLF-TPRZ TO BL-LIS
              PERFORM LISTINO-BASE-LIRE THRU LL99
              GO TO LIS-LIR.
      ************
      **** rel 4.0
      *    MOVE ART-TPRZ  TO RG-RIF-TPRZ.
      *    IF ORF-VALUT > 1 MOVE 1 TO RG-RIF-TPRZ.
      *    IF ORF-VALUT > 1
           IF NOT (ORF-VALUT = ZERO OR COMEURO)
      ************
              MOVE ZERO TO RG-RIF-PREZZ
           ELSE
              IF CLF-TPRZ = 1
      **** rel 4.0
      *          MOVE ART-PRZ1 TO RG-RIF-PREZZ
                 MOVE RG-RIF-FSC TO DP-FSC
                 MOVE ART-PRZ1   TO DP-PREZZO
                 CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
                 MOVE DP-PREZZO  TO RG-RIF-PREZZ
      ************
              ELSE
                 IF CLF-TPRZ = 2
      **** rel 4.0
      *             MOVE ART-PRZ2 TO RG-RIF-PREZZ
                    MOVE RG-RIF-FSC TO DP-FSC
                    MOVE ART-PRZ2   TO DP-PREZZO
                    CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
                    MOVE DP-PREZZO  TO RG-RIF-PREZZ
      ************
                 ELSE
                    IF CLF-TPRZ = 3
      **** rel 4.0
      *                MOVE ART-PRZ3 TO RG-RIF-PREZZ.
                       MOVE RG-RIF-FSC TO DP-FSC
                       MOVE ART-PRZ3   TO DP-PREZZO
                       CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
                       MOVE DP-PREZZO  TO RG-RIF-PREZZ.
       LIS-LIR.
      ************
           MOVE ART-1SCON TO RG-RIF-1SCON.
           MOVE ART-2SCON TO RG-RIF-2SCON.
           IF ORF-VALUT = CLF-VAL
              PERFORM L00-LISTINO THRU L99
              MOVE RG-RIF-PREZZ TO WPREZ.
      **** rel 5.2
           IF FUN = 'V' AND FLGNRIF = 1
              MOVE SPACE TO RA-RIF-NOTE
              MOVE ZERO  TO RA-RIF-FLGNOTE
              PERFORM F-LEG-NAT THRU END-F-LEG-NAT
              IF RA-RIF-NOTE NOT = SPACE
      **** rel 6.2
      *          MOVE NRIGMAX TO KVALID
                 MOVE NRIGMAXL TO KVALID
      ************
                 PERFORM UNTIL RA-RIF-RIGNOT(KVALID) NOT = SPACE
                    SUBTRACT 1 FROM KVALID
                 END-PERFORM
                 IF KVALID > ZERO
                    MOVE 1 TO RA-RIF-FLGNOTE.
      ************
       E-ARTIC.
      *
       V-TPUM.
           MOVE 'RIF-TPUM' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPUM.
           IF NOT (RG-RIF-TPRIG = 0) GO TO E-TPUM.
           IF RA-RIF-TPUM = 1
              MOVE ART-UNMIS TO RG-RIF-UNMIS
              MOVE SPACE     TO RA-RIF-2UNMIS
              MOVE ZERO      TO RA-RIF-2QUANT.
           IF RA-RIF-TPUM = 2
              MOVE ART-2UNMIS TO RG-RIF-UNMIS
              MOVE ART-UNMIS  TO RA-RIF-2UNMIS
              IF RG-RIF-QUANT = ZERO
                 MOVE ZERO TO RA-RIF-2QUANT
              ELSE
                 COMPUTE RD-NUM = RG-RIF-QUANT / ART-COEFF
                 CALL 'vrround' USING QTA-S PARRD ART-TQUAN
                 MOVE RD-NUM TO RA-RIF-2QUANT.
       E-TPUM.
      *
       V-DESAR.
           MOVE 'RIF-DESAR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DESAR.
           IF NOT (RG-RIF-TPRIG = 2) GO TO E-DESAR.
           IF RG-RIF-DESAR = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-DESAR.
      *
       V-FSC.
           MOVE 'RIF-FSC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FSC.
           IF RG-RIF-TPRIG NOT = 2 GO TO E-FSC.

           MOVE ZERO  TO RG-RIF-FSC.
           IF RA-RIF-CBFSC = 1 MOVE 3 TO RG-RIF-FSC.
           PERFORM AGGIORNA-FSC-D.
       E-FSC.
      *
       V-QUANT.
           MOVE 'RIF-QUANT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-QUANT.
           IF NOT (RG-RIF-TPRIG = 0 OR 2) GO TO E-QUANT.
      **** rel 5.0
           IF RA-RIF-FLGOPF = 1 GO TO E-QUANT.
      ************
           MOVE RG-RIF-QUANT TO RD-NUM.
           CALL 'vrround' USING QTA-S PARRD RG-RIF-TQUAN.
           MOVE RD-NUM TO RG-RIF-QUANT.
           IF RD-ST > ZERO
              PERFORM ERR-NDEC
              GO TO V-ERROR.
           IF RG-RIF-QUANT = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
      *
           IF RG-RIF-TPRIG NOT = ZERO  GO TO E-QUANT.
           IF RG-RIF-UNMIS = ART-UNMIS GO TO E-QUANT.
           COMPUTE RD-NUM = RG-RIF-QUANT / ART-COEFF.
           CALL 'vrround' USING QTA-S PARRD ART-TQUAN.
           MOVE RD-NUM TO RA-RIF-2QUANT.
       E-QUANT.
      *
       V-CDSPE.
           MOVE 'RIF-CDSPE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDSPE.
           IF RG-RIF-TPRIG NOT = 3 GO TO E-CDSPE.
           IF RG-RIF-CDSPE = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 11 TO KTB-TIP.
           MOVE RG-RIF-CDSPE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO RG-RIF-DESAR
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T11-TIMP NOT = ZERO
              MOVE 'Tipo inserimento non valido' TO MESS
              GO TO V-ERROR.
      **** rel 4.0
      *    IF ORF-VALUT > 1 MOVE 1 TO RG-RIF-TPRZ.
      ************
           MOVE TAB-DESCR TO RG-RIF-DESAR.
       E-CDSPE.
      *
       V-PREZZ.
           MOVE 'RIF-PREZZ' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PREZZ.
           IF NOT (RG-RIF-TPRIG = 0 OR 2 OR 3) GO TO E-PREZZ.
      **** rel 4.0
      *    IF ORF-VALUT > 1 MOVE 1 TO RG-RIF-TPRZ.
      *    MOVE RG-RIF-PREZZ TO RD-NUM.
      *    CALL 'vrround' USING PRZ-S PARRD RG-RIF-TPRZ.
      *    MOVE RD-NUM TO RG-RIF-PREZZ.
      *    IF RD-ST > ZERO
      *       PERFORM ERR-NDEC
      *       GO TO V-ERROR.
      ************
       V-PREZZ-10.
           IF RG-RIF-PREZZ NOT = WPREZ AND
      **** rel 4.0
      *       ORF-VALUT NOT > 1 PERFORM A00-AGGPRZ THRU A99.
              (ORF-VALUT = ZERO OR COMEURO)
                  PERFORM A00-AGGPRZ THRU A99.
      ************
       E-PREZZ.
      *
       V-DTCSR.
           MOVE 'RIF-DTCSR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTCSR.
           IF NOT (RG-RIF-TPRIG = 0 OR 2) GO TO E-DTCSR.
           MOVE 1 TO TIPOP1.
           MOVE RG-RIF-DTCSR TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTCSR.
      *
       V-DTCSC.
           MOVE 'RIF-DTCSC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTCSC.
           IF NOT (RG-RIF-TPRIG = 0 OR 2) GO TO E-DTCSC.
           MOVE 1 TO TIPOP1.
           MOVE RG-RIF-DTCSC TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTCSC.
      *
       V-CONTR.
           MOVE 'RIF-CONTR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CONTR.
           IF NOT (RG-RIF-TPRIG = 2) GO TO E-CONTR.
           MOVE SPACE TO RA-RIF-CONTR-D.
           IF RG-RIF-CONTR = ZERO GO TO E-CONTR.
           MOVE 21           TO T21-TIP.
           MOVE RG-RIF-CONTR TO T21-COD.
           MOVE T21-KEYID TO KEYTB.
           READ TABELL INTO REKT21 INVALID
                PERFORM ERR-CINE
      **** rel 7.1
      *         GO TO E-CONTR.
                GO TO V-ERROR.
      ************
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT21.
           MOVE RG-RIF-AZI TO KPC-AZI.
           MOVE T21-CPART  TO KPC-COD.
           OPEN INPUT ANACON.
           READ ANACON INVALID MOVE ALL '*' TO CON-DSC.
           MOVE CON-DSC TO RA-RIF-CONTR-D.
           CLOSE ANACON.
       E-CONTR.
      *
       V-NOTE.
           MOVE 'RIF-NOTE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NOTE.
      **** rel 6.2
      *    MOVE NRIGMAX TO ML-MAXRIG.
      *    MOVE 30      TO ML-LUNRIG.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
      ************
           MOVE 0       TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL RA-RIF-NOTE.
           IF ML-ST = 1
              MOVE SPACE TO F-MES2
              MOVE 'E'' possibile caricare' TO F-MES1
      **** rel 6.2
      *       MOVE NRIGMAX  TO MAXRIGD
              MOVE NRIGMAXL TO MAXRIGD
      ************
              STRING 'al massimo ' MAXRIGD ' righe'
                     DELIMITED SIZE INTO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
      * accende/spegne bottone presenza note aggiuntive
           MOVE ZERO TO RA-RIF-FLGNOTE.
           IF RIF-TPRIG = 1
              MOVE 1 TO RA-RIF-FLGNOTE
              GO TO E-NOTE.
           IF RA-RIF-NOTE = SPACE GO TO E-NOTE.
      *
      **** rel 6.2
      *    MOVE NRIGMAX  TO KVALID.
           MOVE NRIGMAXL TO KVALID.
      ************
           PERFORM UNTIL RA-RIF-RIGNOT(KVALID) NOT = SPACE
              SUBTRACT 1 FROM KVALID
           END-PERFORM.
           IF KVALID > ZERO
              MOVE 1 TO RA-RIF-FLGNOTE.
       E-NOTE.
      *
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
           PERFORM SUBMAG THRU EX-SUBMAG.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
           PERFORM ADDMAG THRU EX-ADDMAG.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
       ADDMAG.
           IF RIF-TPRIG NOT = ZERO GO TO EX-ADDMAG.
           IF RIF-SALDO = 1        GO TO EX-ADDMAG.
           IF RIF-QARR > RIF-QUANT GO TO EX-ADDMAG.
      *
           IF RIF-UNMIS = ART-UNMIS
                COMPUTE CLAV = RIF-QUANT - RIF-QARR
           ELSE COMPUTE CLAV = RA-RIF-2QUANT - RIF-2QARR.
       LRART.
           MOVE ORF-AZI   TO KMA-AZI.
           MOVE RIF-ARTIC TO KMA-ART.
           READ MAGART INTO REKART KEPT LOCK INVALID KEY
                PERFORM INVK-ART
                PERFORM VISK-RIF
                GO TO ERRIO.
           IF SF-ART > ZERO PERFORM REC-LOCK
                            GO TO LRART.
       LRARD.
           MOVE KMA-AZI   TO KAD-AZI.
           MOVE ORF-CDDEP TO KAD-DEP.
           MOVE KMA-ART   TO KAD-ART.
           READ MAGARD INTO REKARD KEPT LOCK INVALID KEY
                PERFORM INVK-ARD
                PERFORM VISK-RIF
                GO TO ERRIO.
           IF SF-ARD > ZERO PERFORM REC-LOCK
                            GO TO LRARD.
           ADD CLAV TO ART-IMPFO ARD-DORDA.
           REWRITE RF-ART FROM REKART INVALID PERFORM INVK-ART
                                              PERFORM VISK-RIF
                                              GO TO ERRIO.
           UNLOCK MAGART.
           REWRITE RF-ARD FROM REKARD INVALID PERFORM INVK-ARD
                                              PERFORM VISK-RIF
                                              GO TO ERRIO.
           UNLOCK MAGARD.
       EX-ADDMAG.
           EXIT.
      *------------------
       SUBMAG.
           IF RIF-TPRIG NOT = ZERO GO TO EX-SUBMAG.
           IF RIF-SALDO = 1        GO TO EX-SUBMAG.
           IF RIF-QARR > RIF-QUANT GO TO EX-SUBMAG.
           MOVE RIF-AZI   TO KMA-AZI.
           MOVE RIF-ARTIC TO KMA-ART.
           READ MAGART INTO REKART KEPT LOCK INVALID KEY
                PERFORM INVK-ART
                PERFORM VISK-RIF
                GO TO ERRIO.
           IF SF-ART > ZERO PERFORM REC-LOCK
                            GO TO SUBMAG.
           IF RIF-UNMIS = ART-UNMIS
              COMPUTE CLAV = RIF-QUANT - RIF-QARR
           ELSE
              COMPUTE RD-NUM = RIF-QUANT / ART-COEFF
              CALL 'vrround' USING QTA-S PARRD ART-TQUAN
              MOVE RD-NUM TO RA-RIF-2QUANT
              COMPUTE CLAV = RA-RIF-2QUANT - RIF-2QARR.
       L2ARD.
           MOVE KMA-AZI   TO KAD-AZI.
           MOVE ORF-CDDEP TO KAD-DEP.
           MOVE KMA-ART   TO KAD-ART.
           READ MAGARD INTO REKARD KEPT LOCK INVALID KEY
                PERFORM INVK-ARD
                PERFORM VISK-RIF
                GO TO ERRIO.
           IF SF-ARD > ZERO PERFORM REC-LOCK
                            GO TO L2ARD.
           SUBTRACT CLAV FROM ART-IMPFO ARD-DORDA.
           REWRITE RF-ARD FROM REKARD INVALID KEY PERFORM INVK-ARD
                                                  PERFORM VISK-RIF
                                                  GO TO ERRIO.
           UNLOCK MAGARD.
           REWRITE RF-ART FROM REKART INVALID KEY PERFORM INVK-ART
                                                  PERFORM VISK-RIF
                                                  GO TO ERRIO.
           UNLOCK MAGART.
       EX-SUBMAG.
           EXIT.
      *------------------
       A00-AGGPRZ.
           IF CLF-RBOL = ZERO GO TO A99.
           MOVE ORF-AZI TO KMA-AZI.
           MOVE RG-RIF-ARTIC TO KMA-ART.
       A10.
           READ MAGART INTO REKART KEPT LOCK INVALID GO TO A99.
           IF SF-ART > ZERO PERFORM REC-LOCK
                            GO TO A10.
      **** rel 4.0
      *    IF CLF-TPRZ = 1 MOVE RG-RIF-PREZZ TO ART-PRZ1.
      *    IF CLF-TPRZ = 2 MOVE RG-RIF-PREZZ TO ART-PRZ2.
      *    IF CLF-TPRZ = 3 MOVE RG-RIF-PREZZ TO ART-PRZ3.
           IF CLF-TPRZ = 1
              MOVE RG-RIF-FSC   TO DP-FSC
              MOVE RG-RIF-PREZZ TO DP-PREZZO
              CALL 'rforprz' USING DP-PREZZO DP-FSC FSC-UNI
              MOVE DP-PREZZO    TO ART-PRZ1.
           IF CLF-TPRZ = 2
              MOVE RG-RIF-FSC   TO DP-FSC
              MOVE RG-RIF-PREZZ TO DP-PREZZO
              CALL 'rforprz' USING DP-PREZZO DP-FSC FSC-UNI
              MOVE DP-PREZZO    TO ART-PRZ2.
           IF CLF-TPRZ = 3
              MOVE RG-RIF-FSC   TO DP-FSC
              MOVE RG-RIF-PREZZ TO DP-PREZZO
              CALL 'rforprz' USING DP-PREZZO DP-FSC FSC-UNI
              MOVE DP-PREZZO    TO ART-PRZ3.
      ************
           REWRITE RF-ART FROM REKART.
           UNLOCK MAGART.
       A99.
           EXIT.
      *------------------
       F00-GES-OBF.
           MOVE ZERO TO SW-ESBOL.
           MOVE KRF-AZI TO OBF-AZI.
           MOVE KRF-NUM TO OBF-NORD.
           MOVE KRF-PRG TO OBF-RGOR.
           MOVE ZERO    TO OBF-PRT.
           START BOLORF KEY NOT < KEYOB2 INVALID GO TO F99.
       F10.
           READ BOLORF NEXT AT END GO TO F99.
           IF SF-OBF = '9D' OR '9A' OR '35' GO TO F10.
           IF OBF-AZI  NOT = KRF-AZI OR
              OBF-NORD NOT = KRF-NUM OR
              OBF-RGOR NOT = KRF-PRG
              GO TO F99.
           MOVE 1 TO SW-ESBOL.
       F99.
           EXIT.
      *------------------
       L00-LISTINO.
      **** rel 6.3
      *    OPEN INPUT LISACQ.
      *    MOVE RG-RIF-AZI   TO KLAQ-AZI.
      *    MOVE RG-RIF-ARTIC TO KLAQ-ART.
      *    MOVE ORF-CDCLI    TO KLAQ-FOR.
      *    READ LISACQ INVALID KEY GO TO L90.
      *    IF ORF-DAT NOT < LAQ-DTDOC(4) AND
      *       LAQ-DTDOC(4) > LAQ-DTDOC(1) AND
      *       LAQ-PRZ(4) NOT = ZERO
      **** rel 4.0
      **          MOVE LAQ-PRZ(4) TO RG-RIF-PREZZ
      *           MOVE RG-RIF-FSC TO DP-FSC
      *           MOVE LAQ-PRZ(4) TO DP-PREZZO
      *           CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
      *           MOVE DP-PREZZO  TO RG-RIF-PREZZ
      ************
      *           MOVE LAQ-SC1(4) TO RG-RIF-1SCON
      *           MOVE LAQ-SC2(4) TO RG-RIF-2SCON
      *           GO TO L90.
      *    IF LAQ-PRZ(1) NOT = ZERO
      **** rel 4.0
      **      MOVE LAQ-PRZ(1) TO RG-RIF-PREZZ
      *       MOVE RG-RIF-FSC TO DP-FSC
      *       MOVE LAQ-PRZ(1) TO DP-PREZZO
      *       CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
      *       MOVE DP-PREZZO  TO RG-RIF-PREZZ
      ************
      *       MOVE LAQ-SC1(1) TO RG-RIF-1SCON
      *       MOVE LAQ-SC2(1) TO RG-RIF-2SCON.
      *L90.
      *    CLOSE LISACQ.
           INITIALIZE PARAC.
           MOVE RG-RIF-AZI   TO AC-AZI.
           MOVE RG-RIF-ARTIC TO AC-ART.
           MOVE ORF-CDCLI    TO AC-FOR.
           MOVE ORF-DAT      TO AC-DTDOC.
           MOVE 'R'          TO AC-FUN.
           CALL 'vrlsacq' USING PARAC.
           IF ERRIO-ST > ZERO GO TO ERRIO.
           CANCEL 'vrlsacq'.
           IF AC-PRZ NOT = ZERO
              MOVE RG-RIF-FSC TO DP-FSC
              MOVE AC-PRZ TO DP-PREZZO
              CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
              MOVE DP-PREZZO TO RG-RIF-PREZZ
              MOVE AC-SC1 TO RG-RIF-1SCON
              MOVE AC-SC2 TO RG-RIF-2SCON.
      ************
       L99.
           EXIT.
      *------------------
       G00-AGGLAQ.
           IF RIF-TPRIG NOT = ZERO GO TO G99.
      **** rel 6.3
           INITIALIZE PARAC.
      ************
           MOVE ORF-AZI    TO AC-AZI.
           MOVE RIF-ARTIC  TO AC-ART.
           MOVE ORF-CDCLI  TO AC-FOR.
           MOVE 'O'        TO AC-ORIG.
           MOVE ORF-NUM    TO AC-NDOC.
           MOVE ORF-DAT    TO AC-DTDOC.
           MOVE RIF-QUANT  TO AC-QTA.
           MOVE RIF-PREZZ  TO AC-PRZ.
           MOVE RIF-1SCON  TO AC-SC1.
           MOVE RIF-2SCON  TO AC-SC2.
           MOVE ZERO       TO AC-ST.
           CALL 'vrlsacq' USING PARAC.
      **** rel 6.3
           IF ERRIO-ST > ZERO GO TO ERRIO.
      ************
           CANCEL 'vrlsacq'.
       G99.
           EXIT.
      **** rel 2.0
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w9' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      ************
      *------------------
       REC-LOCK.
      **** rel 1.2
           CALL 'rlock' USING PARLK.
      ************
           EXIT.
      *------------------
      * setta RIF-TQUAN e RIF-TPRZ per righi occasionali ORDINE
       SETTA-TQP-RIF.
           IF RIF-TPRIG NOT = 2 GO TO EX-SETTA-TQP-RIF.
      *
           MOVE RIF-QUANT TO RD-NUM.
           CALL 'vrround' USING QTA-SET PARRD RD-TIPO.
           MOVE RD-TIPO TO RIF-TQUAN.
      *
           MOVE RIF-QARR TO RD-NUM.
           CALL 'vrround' USING QTA-SET PARRD RD-TIPO.
           IF RD-TIPO > RIF-TQUAN
              MOVE RD-TIPO TO RIF-TQUAN.
      *
      **** rel 4.0
      *    MOVE RIF-PREZZ TO RD-NUM.
      *    CALL 'vrround' USING PRZ-SET PARRD RD-TIPO.
      *    MOVE RD-TIPO TO RIF-TPRZ.
      *
      *    IF ORF-VALUT > 1 MOVE 1 TO RIF-TPRZ.
      ************
       EX-SETTA-TQP-RIF.
           EXIT.
      *------------------
      * fase di scrittura note aggiuntive rigo ordine fornitore
       DL-WR-NOTE.
           PERFORM DL-NOTE THRU EX-DL-NOTE.
      *
       WR-NOTE.
      **** rel 6.3
           IF RA-RIF-NOTE = SPACE AND RG-RIF-TPRIG = 1
      **** rel 7.2
           AND RG-RIF-FUN NOT = 'A'
      ************
              MOVE KRF-AZI TO KNRF-AZI
              MOVE KRF-NUM TO KNRF-NUM
              MOVE KRF-PRG TO KNRF-PRG
              MOVE 1       TO KNRF-PRGN
              MOVE SPACE   TO NRF-DESCR
              WRITE RF-NRF INVALID PERFORM INVK-NRF
                                   GO TO ERRIO
              END-WRITE
              GO TO EX-DL-WR-NOTE.
      ************
           IF RA-RIF-NOTE = SPACE GO TO EX-DL-WR-NOTE.
      *
      **** rel 6.2
      *    MOVE NRIGMAX TO KVALID.
           MOVE NRIGMAXL TO KVALID.
      ************
           PERFORM UNTIL RA-RIF-RIGNOT(KVALID) NOT = SPACE
              SUBTRACT 1 FROM KVALID
           END-PERFORM.
      *
      **** rel 6.2
      *    IF KVALID = 1 AND RIF-TPRIG = 1 GO TO EX-DL-WR-NOTE.
      ************
      *
           MOVE KRF-AZI TO KNRF-AZI.
           MOVE KRF-NUM TO KNRF-NUM.
           MOVE KRF-PRG TO KNRF-PRG.
      **** rel 5.0
      *    MOVE ZERO    TO KNRF-PRGN.
           IF NOT (FUN = 'S' AND RIF-ARTIC NOT = SPACE)
              MOVE ZERO TO KNRF-PRGN.
      ************
      *
           MOVE 1 TO KML.
      **** rel 6.2
      *    IF RIF-TPRIG = 1
      *       MOVE 2 TO KML.
      ************
           PERFORM UNTIL KML > KVALID
              ADD 1 TO KNRF-PRGN
              MOVE RA-RIF-RIGNOT(KML) TO NRF-DESCR
              WRITE RF-NRF INVALID PERFORM INVK-NRF
                                   GO TO ERRIO
              END-WRITE
              ADD 1 TO KML
           END-PERFORM.
      *
           PERFORM CONTA-NBYTE-RIF-NOTE.
      * conversione per visualizzazione automatica nel caso di conferma
      * dopo una variazione
      **** rel 6.2
      *    MOVE NRIGMAX TO ML-MAXRIG.
      *    MOVE 30      TO ML-LUNRIG.
      *    MOVE 2       TO ML-FUN.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4       TO ML-FUN.
      ************
           CALL 'vrmle' USING ML-CTRL RA-RIF-NOTE.
       EX-DL-WR-NOTE.
           EXIT.
      *------------------
      * cancellazione note aggiuntive rigo ordine fornitore
       DL-NOTE.
           MOVE KRF-AZI TO KNRF-AZI.
           MOVE KRF-NUM TO KNRF-NUM.
           MOVE KRF-PRG TO KNRF-PRG.
           MOVE ZERO    TO KNRF-PRGN.
      *
           START NOTRIF KEY >= KEYNRF INVALID GO TO EX-DL-NOTE.
       DL-NOTE-10.
           READ NOTRIF NEXT AT END GO TO EX-DL-NOTE.
           IF KNRF-AZI > KRF-AZI GO TO EX-DL-NOTE.
           IF KNRF-NUM > KRF-NUM GO TO EX-DL-NOTE.
           IF KNRF-PRG > KRF-PRG GO TO EX-DL-NOTE.
           DELETE NOTRIF INVALID PERFORM INVK-NRF
                                 GO TO V-ERROR.
           GO TO DL-NOTE-10.
       EX-DL-NOTE.
           EXIT.
      *------------------
      * fase di lettura note aggiuntive rigo ordine fornitore e
      * caricamento aree interfaccia
       RD-NRF.
           PERFORM AZZ-NOTE.
      *
           MOVE ZERO TO RA-RIF-FLGNOTE.
           MOVE ZERO TO KN.
      *
      **** rel 6.2
      *    IF RIF-TPRIG = 1
      *       MOVE RIF-DESAR TO RA-RIF-RIGNOT(1)
      *       MOVE 1 TO RA-RIF-FLGNOTE
      *       ADD 1 TO KN.
      ************
      *
           MOVE KRF-AZI TO KNRF-AZI.
           MOVE KRF-NUM TO KNRF-NUM.
           MOVE KRF-PRG TO KNRF-PRG.
           MOVE ZERO    TO KNRF-PRGN.
           START NOTRIF KEY >= KEYNRF INVALID GO TO RD-NRF-20.
       RD-NRF-10.
           READ NOTRIF NEXT AT END GO TO RD-NRF-20.
           IF KNRF-AZI > KRF-AZI GO TO RD-NRF-20.
           IF KNRF-NUM > KRF-NUM GO TO RD-NRF-20.
           IF KNRF-PRG > KRF-PRG GO TO RD-NRF-20.
           ADD 1 TO KN.
      **** rel 6.2
      *    IF KN <= NRIGMAX
           IF KN <= NRIGMAXL
      ************
              MOVE NRF-DESCR TO RA-RIF-RIGNOT(KN)
              MOVE 1 TO RA-RIF-FLGNOTE
           GO TO RD-NRF-10.
       RD-NRF-20.
      *
           PERFORM CONTA-NBYTE-RIF-NOTE.
      *
      **** rel 6.2
      *    MOVE NRIGMAX TO ML-MAXRIG.
      *    MOVE 30      TO ML-LUNRIG.
      *    MOVE 2       TO ML-FUN.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4       TO ML-FUN.
      ************
           CALL 'vrmle' USING ML-CTRL RA-RIF-NOTE.
      *
       EX-RD-NRF.
           EXIT.
      *------------------
       AZZ-NOTE.
           MOVE 1 TO KML.
           PERFORM UNTIL KML > NRIGMAX
              MOVE SPACE TO RA-RIF-RIGNOT(KML)
              ADD 1 TO KML
           END-PERFORM.
      *
           MOVE ZERO TO RA-RIF-NBYTE
                        RA-RIF-FLGNOTE.
      *------------------
      * conta nbyte note aggiuntive
       CONTA-NBYTE-RIF-NOTE.
           MOVE ZERO TO RA-RIF-NBYTE.
           IF RA-RIF-NOTE NOT = SPACE
      **** rel 6.2
      *       MOVE NRIGMAX TO KVALID
              MOVE NRIGMAXL TO KVALID
      ************
              PERFORM UNTIL RA-RIF-RIGNOT(KVALID) NOT = SPACE
                 SUBTRACT 1 FROM KVALID
              END-PERFORM
      **** rel 6.2
      *       COMPUTE RA-RIF-NBYTE = KVALID * 30.
              COMPUTE RA-RIF-NBYTE = KVALID * NCOLMAX.
      ************
      *------------------
      **** rel 2.0
      * evasione automatica righi offerta
       R-RDF00.
           MOVE ZERO TO SAVOFF.
           OPEN I-O WDSLAV.
           MOVE ZERO TO KEYLV.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO F-RDFFR.
       R-RDF10.
           READ WDSLAV NEXT AT END GO TO F-RDFFR.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO R-RDF10.
           IF SAVOFF = KLV-NOFF GO TO R-RDF15.
           IF SAVOFF NOT = ZERO
              ADD 5 TO RG-RIF-PRG.
           MOVE KLV-NOFF TO SAVOFF.
      * lettura testata offerta e caricamento righi ordine fissi
           MOVE RG-RIF-AZI TO KFFT-AZI.
           MOVE KLV-NOFF   TO KFFT-NUM.
           READ OFFFOR INTO REKFFT INVALID
                PERFORM INVK-FFT
                GO TO WARNING.
           IF SF-FFT = '9D' OR '9A' OR '35' MOVE RF-FFT TO REKFFT.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           MOVE KFFT-NUM TO DES2.
      *
           MOVE FFT-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DES4.
      *
      **** rel 6.2
      *    MOVE DESCRIZIONE TO RIF-DESAR.
           MOVE DESCRIZIONE TO RIF-DESAR NRF-DESCR.
      ************
           MOVE 1           TO RIF-TPRIG.
      **** rel 6.2
      *    MOVE KOF-AZI     TO RIF-AZI.
      *    MOVE KOF-NUM     TO RIF-NUM.
      *    MOVE RG-RIF-PRG  TO RIF-PRG.
           MOVE KOF-AZI     TO RIF-AZI RIF-AZ4 KNRF-AZI.
           MOVE KOF-NUM     TO RIF-NUM RIF-NU2 RIF-NU3 RIF-NU4 KNRF-NUM.
           MOVE RG-RIF-PRG  TO RIF-PRG KNRF-PRG.
           MOVE 1 TO KNRF-PRGN.
      ************
           MOVE 1           TO RIF-SALDO.
           WRITE RF-RIF FROM REKRIF INVALID PERFORM INVK-RIF
                                            GO TO WARNING.
      **** rel 6.2
           WRITE RF-NRF INVALID PERFORM INVK-NRF
                                   GO TO WARNING.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
           IF FFT-NSRIF = SPACE GO TO R-RDF15.
           MOVE FFT-NSRIF TO DES6.
      **** rel 6.2
      *    MOVE DESCRIZIONE2 TO RIF-DESAR.
           MOVE DESCRIZIONE2 TO RIF-DESAR NRF-DESCR.
      ************
           MOVE 1 TO RIF-TPRIG.
           ADD 5 TO RG-RIF-PRG.
      **** rel 6.2
      *    MOVE RG-RIF-PRG TO RIF-PRG.
           MOVE RG-RIF-PRG TO RIF-PRG KNRF-PRG.
      ************
           MOVE 1 TO RIF-SALDO.
           WRITE RF-RIF FROM REKRIF INVALID PERFORM INVK-RIF
                                            GO TO WARNING.
      **** rel 6.2
           WRITE RF-NRF INVALID PERFORM INVK-NRF
                                   GO TO WARNING.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
       R-RDF15.
           MOVE RIF-AZI  TO  KFFR-AZI.
           MOVE KLV-NOFF TO  KFFR-NUM.
           MOVE KLV-PRG  TO  KFFR-PRG.
           READ OFFRIF INTO REKFFR INVALID PERFORM INVK-FFR
                                           GO TO WARNING.
           IF SF-FFR = '9D' OR '9A' OR '35' MOVE RF-FFR TO REKFFR.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           MOVE KOF-AZI    TO RIF-AZI.
           MOVE KOF-NUM    TO RIF-NUM.
           ADD 5 TO RG-RIF-PRG.
           MOVE RG-RIF-PRG TO RIF-PRG.
           MOVE FFR-TPRIG  TO RIF-TPRIG.
           PERFORM B00-AUTOM THRU B99.
           GO TO R-RDF10.
       F-RDFFR.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
       R-RDF99.
           EXIT.
      *------------------
       B00-AUTOM.
           IF FFR-TPRIG = 3 GO TO B40.
           IF FFR-TPRIG = 1 GO TO B50.
           IF FFR-TPRIG = 2
              MOVE FFR-DESAR TO RIF-DESAR
              PERFORM L20-RD-ART THRU L99-RD-ART
              GO TO B20.
           MOVE FFR-ARTIC TO RIF-ARTIC.
           PERFORM L00-RD-ART THRU L99-RD-ART.
           IF FFR-UNMIS NOT = ART-2UNMIS AND NOT = ART-UNMIS
              MOVE 'Unita'' di misura non valida ' TO F-MES1
              MOVE 'Rigo offerta non importata'    TO F-MES2
              MOVE SPACE TO F-MES3
              STRING 'Prg ' FFR-PRG '  Articolo ' FFR-ARTIC
                     DELIMITED SIZE INTO F-MES3
              MOVE 3 TO F-NMES
              CALL 'vrmbox' USING PARMB
              GO TO B99.
       B20.
      **** rel 5.0
           IF RA-RIF-FLGOPF = 1
              PERFORM CREA-RIF-PROGRAMMA THRU EX-CREA-RIF-PROGRAMMA
              MOVE ZERO TO RIF-QARR
              MOVE ZERO TO RIF-QUANT
              MOVE ZERO TO RIF-SALDO
              GO TO B30.
      ************
      **** rel 5.2
           MOVE ORF-DTCSR TO RIF-DTCSR.
           IF FFR-DTCSR NOT = ZERO
              MOVE FFR-DTCSR TO RIF-DTCSR
           ELSE
              MOVE ORF-DTCSR TO RIF-DTCSR.
           MOVE ORF-DTCSC TO RIF-DTCSC.
      ************
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
       B30.
      **** rel 6.2
      *    MOVE KOF-AZI TO RIF-AZI.
      *    MOVE KOF-NUM TO RIF-NUM.
           MOVE KOF-AZI TO RIF-AZI RIF-AZ4.
           MOVE KOF-NUM TO RIF-NUM RIF-NU2 RIF-NU3 RIF-NU4.
      ************
           WRITE RF-RIF FROM REKRIF INVALID KEY PERFORM INVK-RIF
                                                GO TO WARNING.
      *
           IF ORF-VALUT = CLF-VAL
              MOVE RIF-TPRIG TO RG-RIF-TPRIG
              PERFORM G00-AGGLAQ THRU G99.
      *
           PERFORM TRAVAS-NOTE THRU EX-TRAVAS-NOTE.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
           GO TO B99.
       B40.
           MOVE FFR-CDSPE TO RIF-CDSPE.
           MOVE RIF-CDSPE TO KTB-COD.
           MOVE 11        TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-RIF
                                           GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RIF-DESAR.
           MOVE T11-CONTR TO RIF-CONTR.
           MOVE FFR-PREZZ TO RIF-PREZZ.
      **** rel 4.0
      *    MOVE FFR-TPRZ  TO RIF-TPRZ.
           MOVE FFR-FSC   TO RIF-FSC.
      ************
           MOVE ZERO      TO RIF-QUANT.
           MOVE 1         TO RIF-SALDO.
           GO TO B30.
       B50.
           MOVE FFR-DESAR TO RIF-DESAR.
      **** rel 4.0
      *    MOVE ZERO      TO RIF-TPRZ.
           MOVE ZERO      TO RIF-FSC.
      ************
           MOVE 1         TO RIF-SALDO.
           GO TO B30.
       B99.
           EXIT.
      *------------------
       L00-RD-ART.
           MOVE RIF-ARTIC TO KMA-ART.
           MOVE FFR-AZI   TO KMA-AZI.
           READ MAGART INTO REKART INVALID KEY PERFORM INVK-ART
                                               PERFORM VISK-RIF
                                               GO TO WARNING.
           IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
           IF FFR-UNMIS NOT = ART-2UNMIS AND NOT = ART-UNMIS
              GO TO L99-RD-ART.
      **** rel 3.0b
           MOVE ART-CDIVA TO RIF-CDIVA.
           MOVE 3         TO KTB-TIP.
           MOVE RIF-CDIVA TO KTB-COD.
           READ TABELL INVALID PERFORM INVK-TAB
                               PERFORM VISK-RIF
                               GO TO WARNING.
      ************
           MOVE FFR-QUANT TO RIF-QUANT.
           IF RG-RIF-UNMIS = ART-2UNMIS
              COMPUTE RD-NUM = FFR-QUANT / ART-COEFF.
              CALL 'vrround' USING QTA-S PARRD ART-TQUAN.
              MOVE RD-NUM TO RA-RIF-2QUANT.
           MOVE ART-DESCR TO RIF-DESAR.
           MOVE KMA-ART TO KAD-ART.
           MOVE KMA-AZI TO KAD-AZI.
           MOVE ORF-CDDEP TO KAD-DEP.
           READ MAGARD INTO REKARD INVALID KEY PERFORM INVK-ARD
                                               PERFORM VISK-RIF
                                               GO TO WARNING.
           IF SF-ARD = '9D' OR '9A' OR '35' MOVE RF-ARD TO REKARD.
       L20-RD-ART.
           MOVE FFR-TQUAN TO RIF-TQUAN.
      **** rel 4.0
      *    MOVE FFR-TPRZ  TO RIF-TPRZ.
           MOVE FFR-FSC   TO RIF-FSC.
      ************
           MOVE FFR-UNMIS TO RIF-UNMIS.
           MOVE FFR-PREZZ TO RIF-PREZZ.
           IF FFR-TPRIG = 2
              MOVE FFR-QUANT TO RIF-QUANT.
           MOVE FFR-1SCON TO RIF-1SCON.
           MOVE FFR-2SCON TO RIF-2SCON.
      **** rel 3.0b
      *    IF RIF-CDIVA = ZERO GO TO L99-RD-ART.
      *    MOVE 3         TO KTB-TIP.
      *    MOVE RIF-CDIVA TO KTB-COD.
      *    READ TABELL INVALID PERFORM INVK-TAB
      *                        PERFORM VISK-RIF
      *                        GO TO WARNING.
      ************
       L99-RD-ART.
           EXIT.
      *------------------
      * fase di scrittura note aggiuntive rigo ordine cliente
      * da rigo offerta
       TRAVAS-NOTE.
           PERFORM DL-NOTE THRU EX-DL-NOTE.
      **** rel 6.2
           MOVE SPACE TO COM-IN.
      ************
      *
           MOVE KRF-AZI TO KNRF-AZI.
           MOVE KRF-NUM TO KNRF-NUM.
           MOVE KRF-PRG TO KNRF-PRG.
           MOVE ZERO    TO KNRF-PRGN.
      *
           MOVE KFFR-AZI TO KNFF-AZI.
           MOVE KFFR-NUM TO KNFF-NUM.
           MOVE KFFR-PRG TO KNFF-PRG.
           MOVE ZERO     TO KNFF-PRGN.
      *
      **** rel 6.2
      *    START NOTOFF KEY >= KEYNFF INVALID GO TO EX-TRAVAS-NOTE.
      *RD-NOTE-OFF.
      *    READ NOTOFF NEXT AT END GO TO EX-TRAVAS-NOTE.
      *    IF KNFF-AZI > KFFR-AZI GO TO EX-TRAVAS-NOTE.
      *    IF KNFF-NUM > KFFR-NUM GO TO EX-TRAVAS-NOTE.
      *    IF KNFF-PRG > KFFR-PRG GO TO EX-TRAVAS-NOTE.
           START NOTOFF KEY >= KEYNFF INVALID GO TO END-TRAVAS-NOTE.
       RD-NOTE-OFF.
           READ NOTOFF NEXT AT END GO TO END-TRAVAS-NOTE.
           IF KNFF-AZI > KFFR-AZI GO TO END-TRAVAS-NOTE.
           IF KNFF-NUM > KFFR-NUM GO TO END-TRAVAS-NOTE.
           IF KNFF-PRG > KFFR-PRG GO TO END-TRAVAS-NOTE.
      ************
      *
           ADD 1 TO KNRF-PRGN.
      **** rel 6.2
      *    MOVE NFF-DESCR TO NRF-DESCR.
      *    WRITE RF-NRF INVALID PERFORM INVK-NRF GO TO ERRIO.
           MOVE NFF-DESCR TO COM-RIN(KNRF-PRGN).
      ************
           GO TO RD-NOTE-OFF.
      *
      **** rel 6.2
       END-TRAVAS-NOTE.
           IF COM-IN = SPACE GO TO EX-TRAVAS-NOTE.
      *
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4 TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL COM-IN. 
      *    
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 5 TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL COM-IN. 
      *
           MOVE NRIGMAXL TO KVALID.
           PERFORM UNTIL COM-RIN(KVALID) NOT = SPACE
                   SUBTRACT 1 FROM KVALID.
           MOVE ZERO TO KNRF-PRGN.
           PERFORM UNTIL KNRF-PRGN >= KVALID
                ADD 1 TO KNRF-PRGN
                MOVE COM-RIN(KNRF-PRGN) TO NRF-DESCR
                WRITE RF-NRF INVALID PERFORM INVK-NRF GO TO ERRIO.
      ************
       EX-TRAVAS-NOTE.
           EXIT.
      *------------------
      ************
      **** rel 4.0
       AGGIORNA-FSC-D.
           MOVE SPACE TO RA-RIF-FSC-D.
           IF RG-RIF-FSC = 1 MOVE 'x10'   TO RA-RIF-FSC-D.
           IF RG-RIF-FSC = 2 MOVE 'x100'  TO RA-RIF-FSC-D.
           IF RG-RIF-FSC = 3 MOVE 'x1000' TO RA-RIF-FSC-D.
      *------------------
       LISTINO-BASE-LIRE.
           MOVE RG-RIF-AZI   TO BL-AZI.
           MOVE RG-RIF-ARTIC TO BL-ART.
           MOVE RG-RIF-FSC   TO BL-FSC.
           CALL 'rlisbasl' USING PARBL.
           MOVE BL-PREZZO  TO RG-RIF-PREZZ.
       LL99.
           EXIT.
      ************
      **** rel 5.0
      * crea righi dell'ordine a programma
       CREA-RIF-PROGRAMMA.
           IF FFR-TPRIG = 3 OR 1 GO TO END-CREA-RIF.
           MOVE ZERO TO RF-OPF.
           MOVE KOF-AZI TO KOPF-AZI.
           MOVE KOF-NUM TO KOPF-NUM.
           MOVE RIF-PRG TO KOPF-PRG.
           MOVE 1       TO KOPF-PROG.
      *
           MOVE FFR-DTCSR TO OPF-DATA.
           IF OPF-DATA = ZERO
              MOVE COMDATPK TO OPF-DATA.
           MOVE ZERO      TO OPF-TIPO.
           MOVE RIF-QUANT TO OPF-QTAPR.
           MOVE ZERO      TO OPF-QTACF.
      *
           WRITE RF-OPF INVALID PERFORM INVK-OPF
                                PERFORM VISK-RIF
                                GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-O.
      ************
       END-CREA-RIF.

       EX-CREA-RIF-PROGRAMMA.
           EXIT.
      *------------------
       DEL-OBF.
           MOVE LOW-VALUE TO KEYOB2.
           MOVE KRF-AZI TO OBF-AZI.
           MOVE KRF-NUM TO OBF-NORD.
           MOVE KRF-PRG TO OBF-RGOR.
           START BOLORF KEY NOT < KEYOB2 INVALID GO TO ENDOBF.
       LPOBF.
           READ BOLORF NEXT AT END GO TO ENDOBF.
           IF SF-OBF = '9D' OR '9A' OR '35' GO TO LPOBF.
           IF OBF-AZI > KRF-AZI  GO TO ENDOBF.
           IF OBF-NORD > KRF-NUM GO TO ENDOBF.
           IF OBF-RGOR > KRF-PRG GO TO ENDOBF.
           IF OBF-FBOL = 1 GO TO LPDOBF.
           MOVE 1 TO OBF-FORD.
           REWRITE RF-OBF INVALID PERFORM INVK-OBF GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-OBF.
      ************
           MOVE ZERO TO PARBF.
           MOVE 1 TO BF-FUNZ.
           CALL 'vrcbpf' USING KEYOB PARBF.
           GO TO LPOBF.
       LPDOBF.
           MOVE ZERO TO PARBF.
           MOVE 2 TO BF-FUNZ.
           CALL 'vrcbpf' USING KEYOB PARBF.
           DELETE BOLORF INVALID PERFORM INVK-OBF GO TO ERRIO.
      **** rel 7.1
           MOVE ORF-DAT TO DTINT.
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-OBF.
      ************
           GO TO LPOBF.
       ENDOBF.

       EX-DEL-OBF.
           EXIT.
      *------------------
      ************
      *------------------*
      **** rel 6.2
       VER-ART-PRO.
           MOVE ZERO TO NROF.

           MOVE LOW-VALUE TO KEYRF.
           MOVE RG-RIF-ARTIC TO KRF-ART.
           MOVE RG-RIF-NUM   TO KRF-NU2.
           START ORDRIF KEY NOT < KEYRF2 INVALID GO TO NOPRO.
       RDPRO.
           READ ORDRIF NEXT INTO REKRIF AT END GO TO NOPRO.
           IF SF-RIF = '9D' OR '9A' OR '35' GO TO RDPRO.
           IF KRF-ART NOT = RG-RIF-ARTIC GO TO NOPRO.
           IF KRF-NU2 NOT = RG-RIF-NUM   GO TO NOPRO.

           IF KRF-AZI NOT = RG-RIF-AZI GO TO RDPRO.

           ADD 1 TO NROF.
           GO TO RDPRO.
       NOPRO.
           IF NROF > ZERO
              MOVE SPACE TO F-MES1
              STRING 'Articolo ' RG-RIF-ARTIC ' gi presente.' 
                                 DELIMITED SIZE INTO F-MES1
              MOVE 'Ordine a Programma gi utilizzato' TO F-MES2
              MOVE 'in almeno un Ordine a Richiamo.' TO F-MES3
              MOVE 3 TO F-NMES
              CALL 'vrmbox' USING PARMB.

      * rimette in linea RF-RIF + REKRIF recor in elaborazione
           PERFORM AZZ-REC THRU EX-AZZ-REC.
       EX-VER-ART-PRO.
           EXIT.
      *------------------*
       VER-ART-OPF.
           MOVE ZERO TO RA-RIF-PRGOPF.
           MOVE ZERO TO FLGI.
           MOVE ZERO TO NROF FLGCONF.
           IF KRF-AZI = ZERO MOVE 1 TO FLGI.   *> inserimento

           MOVE LOW-VALUE TO KEYRF.
           MOVE RG-RIF-ARTIC TO KRF-ART.
           MOVE PORF-NOPF    TO KRF-NU2.
           START ORDRIF KEY NOT < KEYRF2 INVALID GO TO NOOPF.
       RDOPF.
           READ ORDRIF NEXT INTO REKRIF AT END GO TO NOOPF.
           IF SF-RIF = '9D' OR '9A' OR '35' GO TO RDOPF.
           IF KRF-ART NOT = RG-RIF-ARTIC GO TO NOOPF.
           IF KRF-NU2 NOT = PORF-NOPF  GO TO NOOPF.

           IF KRF-AZI NOT = RG-RIF-AZI GO TO RDOPF.

           ADD 1 TO NROF.
           IF RA-RIF-PRGOPF = ZERO MOVE KRF-PRG TO RA-RIF-PRGOPF.
      *
           MOVE KRF-AZI TO SKOPF-AZI.
           MOVE KRF-NUM TO SKOPF-NUM.
           MOVE KRF-PRG TO SKOPF-PRG.
           MOVE ZERO    TO SKOPF-PROG.
           START ORDPRF KEY NOT < KEYOPF INVALID GO TO END-PROG.
       LP-PROG.
           READ ORDPRF NEXT AT END GO TO END-PROG.
           IF KRF-AZI NOT = SKOPF-AZI GO TO END-PROG.
           IF KRF-NUM NOT = SKOPF-NUM GO TO END-PROG.
           IF KRF-PRG NOT = SKOPF-PRG GO TO END-PROG.
       
           IF OPF-QTACF NOT = ZERO MOVE 1 TO FLGCONF
                                   GO TO END-PROG.
           GO TO LP-PROG.
       END-PROG.
      *
           GO TO RDOPF.
       NOOPF.
           IF NROF NOT = 1 
              IF NOT (FUN = 'R' OR 'r')
                 MOVE SPACE TO F-MES1
                 IF NROF = ZERO
                    STRING 'Articolo ' RG-RIF-ARTIC ' non presente' 
                                       DELIMITED SIZE INTO F-MES1
                    MOVE 'nell''Ordine a Programma' TO F-MES2
                 ELSE
                    STRING 'Articolo ' RG-RIF-ARTIC ' presente pi'
                                       DELIMITED SIZE INTO F-MES1
                    MOVE 'volte nell''Ordine a Programma' TO F-MES2
                 END-IF
                 MOVE 2 TO F-NMES
                 CALL 'vrmbox' USING PARMB.

           IF FLGCONF = 1 
              IF NOT (FUN = 'R' OR 'r')
                 MOVE SPACE TO F-MES1
                 STRING 'Articolo ' RG-RIF-ARTIC ' ha quantit' 
                                   DELIMITED SIZE INTO F-MES1
                 MOVE 'confermata nell''Ordine a Programma' TO F-MES2
                 MOVE 2 TO F-NMES
                 CALL 'vrmbox' USING PARMB.
           
       RDRIF.
      * rimette in linea RF-RIF + REKRIF recor in elaborazione
           IF FLGI = ZERO
              IF FUN = 'r'
                 MOVE 1 TO FLCK
              ELSE
                 MOVE ZERO TO FLCK
              END-IF
              PERFORM READ-K THRU EX-READ-K
              IF VKEY > ZERO
                 PERFORM INVK-RIF
                 GO TO ERRIO
              END-IF
           ELSE
              PERFORM AZZ-REC THRU EX-AZZ-REC.
       EX-VER-ART-OPF.
           EXIT.
      *------------------*
      ********
      **** rel 7.1
       CALL-VSRV133.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'RIF'   TO PPAR-TARC.
           MOVE KEYRF   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           IF PPAR-TOPE = 'C'
              MOVE DTINT TO PPAR-OPZ(1:5).
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 RIF ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *-------------------------------
       CALL-VSRV133-O.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'OPF'   TO PPAR-TARC.
           MOVE KEYOPF  TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 OPF ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *-------------------------------
       CALL-VSRV133-FFT.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'FFT'   TO PPAR-TARC.
           MOVE KEYFFT  TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 FFT ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *-------------------------------
       CALL-VSRV133-OBF.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'OBF'   TO PPAR-TARC.
           MOVE KEYOB   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           IF PPAR-TOPE = 'C'
              MOVE DTINT TO PPAR-OPZ(1:5).
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 OBF ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *-------------------------------
      ************
