      $SET LINKCOUNT"128"
       IDENTIFICATION DIVISION.
       PROGRAM-ID. VORFG75.
      *
      *    Interfaccia BOLFRI per scheda
      *
      *--------------------------------------------------------------
      * Note:
      *
      * - IF-FUN: oltre ai valori soliti, puo' assumere anche:
      *           e = evasione record selezionati da zoom multiplo
      *               con IDX = 1 (selezione per n. ordine)
      *           a = evasione record selezionati da zoom multiplo
      *               con IDX = 2 (selezione per cod. articolo)
      *               verranno considerati solo i primi 6 records
      *               caricati nel file di lavoro.
      *           w = controlla se sono gia' valorizzati dei campi
      *               di consegna sul rigo bolla, onde evitare la
      *               chiamata a zoom multiplo per articolo
      *--------------------------------------------------------------
      *
      **** rel 5.1
      * Ricompilato per gririfrk e gribfr variate per gestire 
      * sconti di rigo con due decimali
      ************
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'gritabsl'.
           COPY 'griorfsl'.
           COPY 'gririfsl'.
           COPY 'gribftsl'.
           COPY 'gribfrsl'.
           COPY 'griartsl'.
           COPY 'griardsl'.
           COPY 'griobfsl'.
           COPY 'griclfsl'.
           COPY 'griconsl'.
      **** rel 6.3
      *    COPY 'grilaqsl'.
      ************
      **** rel 6.2
           COPY 'grinfrsl'.
           COPY 'grinrfsl'.
           COPY 'griarnsl'.
           COPY 'grinatsl'.
      ************
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
       DATA DIVISION.
       FILE SECTION.
           COPY 'gritab'.
           COPY 'griorf'.
           COPY 'gririf'.
           COPY 'gribft'.
           COPY 'gribfr'.
           COPY 'griart'.
           COPY 'griard'.
           COPY 'griobf'.
           COPY 'griclf'.
           COPY 'gricon'.
      **** rel 6.3
      *    COPY 'grilaq'.
      ************
      **** rel 6.2
           COPY 'grinfr'.
           COPY 'grinrf'.
           COPY 'griarn'.
           COPY 'grinat'.
      ************
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 8 DATA RECORD RF-LAV.
       01  RF-LAV.
           02 KEYLV.
             05 KLV-NORD   PIC 9(5).
             05 KLV-PRG    PIC 999.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griclfrk'.
           COPY 'griconrk'.
           COPY 'gritabrk'.
           COPY 'griorfrk'.
           COPY 'gririfrk'.
           COPY 'griartrk'.
           COPY 'griardrk'.
           COPY 'rekt21'.
           COPY 'parmag'.
           COPY 'parim'.
           COPY 'parac'.
           COPY 'parrd'.
           COPY 'parzf'.
           COPY 'parmb'.
      **** rel 1.2
           COPY 'parlk'.
      ************
      **** rel 5.0
           COPY 'parbf'.
           COPY 'parof'.
      ************
      **** rel 4.0
           COPY 'pardp'.
           COPY 'parer'.
           COPY 'parbl'.
      ************
      **** rel 5.2
           COPY 'parpcfa'.
      ************
      **** rel 6.2
           COPY 'parml'.
      ************
      **** rel 6.2
           COPY 'partdc'.
      ************
      **** rel 7.1
           COPY 'parppar'.
      *
       01 S-KEYMM.
           05 S-KMM-AZI PIC 999.
           05 S-KMM-DEP PIC 99.
           05 S-KMM-ART PIC X(18).
           05 S-KMM-DAT PIC 9(5) COMP-3.
           05 S-KMM-NUM PIC 9(5) COMP-3.
      ************
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-ORF PIC X(15) VALUE 'ordfor'.
       01  ID-RIF PIC X(15) VALUE 'ordrif'.
       01  ID-BFT PIC X(15) VALUE 'bolfte'.
       01  ID-BFR PIC X(15) VALUE 'bolfri'.
       01  ID-ART PIC X(15) VALUE 'magart'.
       01  ID-ARD PIC X(15) VALUE 'magard'.
       01  ID-OBF PIC X(15) VALUE 'bolorf'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
      **** rel 6.3
      *01  ID-LAQ PIC X(15) VALUE 'lisacq'.
      ************
      **** rel 6.2
       01  ID-NFR PIC X(15) VALUE 'notbfr'.
       01  ID-NRF PIC X(15) VALUE 'notrif'.
       01  ID-ARN PIC X(15) VALUE 'arcnot'.
       01  ID-NAT PIC X(15) VALUE 'notart'.
      ************
       01  ID-LAV PIC X(15).
      **** rel 6.2
      *--------------------------------------------------------
      * costanti
      *    NRIGMAX: n. righe max note aggiuntive rigo fornitore
      **** rel 6.2
      *    NRIGMAX: n. righe fisiche max in pari con occurs
      *    NCOLMAX: n. colonne fisiche max
       78  NRIGMAX VALUE 100.
       78  NCOLMAX VALUE 60.
      *78  NRIGMAX VALUE 20.
      ************
      *--------------------------------------------------------
      ************
       01  COMODI.
           05 SF-TAB PIC XX.
           05 SF-ORF PIC XX.
           05 SF-RIF PIC XX.
           05 SF-BFT PIC XX.
           05 SF-BFR PIC XX.
           05 SF-ART PIC XX.
           05 SF-ARD PIC XX.
           05 SF-OBF PIC XX.
           05 SF-CLF PIC XX.
           05 SF-CON PIC XX.
      **** rel 6.3
      *    05 SF-LAQ  PIC XX.
      ************
      **** rel 6.2
           05 SF-NFR PIC XX.
           05 SF-NRF PIC XX.
           05 SF-ARN PIC XX.
           05 SF-NAT PIC XX.
      ************
           05 SF-LAV PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(30).
           05 IF-AZI   PIC 9(3).
           05 IF-PRT   PIC 9(7).
           05 CPART    PIC 9(3).
           05 RSAL0    PIC 9.
           05 RIGCOM   PIC X(35).
           05 COMPRG   PIC 999.
           05 K        PIC 99.
           05 K1       PIC 99.
           05 K2       PIC 99.
           05 KK       PIC 9.
      **** rel 5.0
           05 J        PIC 99.
           05 DAT      PIC 9(5).
           05 ORD      PIC S9(10)V9(3).
           05 MEDIAQ   PIC S9(3)V9(4).
           05 MEDIAG   PIC S9(3)V9(4).
           05 PERG     PIC S9(3)V9(4).
           05 PERQ     PIC S9(3)V9(4).
      ************
           05 WART     PIC X(18).
           05 SWDEL    PIC 9.
           05 SWORD    PIC 9.
           05 SWVET    PIC 9.
           05 SWERR    PIC 9.
           05 SWTEST   PIC 9.
           05 SWDGEST  PIC 9.
           05 SWCONS   PIC 9.
           05 TARD     PIC 9.
           05 CDFOR.
              10 MFOR  PIC 99.
              10 CFOR  PIC 9(5).
           05 QUAN     PIC S9(10)V999 VALUE ZERO.
           05 RESID    PIC S9(10)V999 VALUE ZERO.
           05 SAVQTA   PIC S9(10)V999 VALUE ZERO.
           05 LQUANT   PIC S9(10)V999 VALUE ZERO.
           05 LAVQTA   PIC S9(10)V999 VALUE ZERO.
           05 LRESID   PIC S9(10)V999 VALUE ZERO.
           05 LORDIN   PIC S9(10)V999 VALUE ZERO.
           05 LSALDO   PIC 9          VALUE ZERO.
      **** rel 2.0
           05 PREC-CON0 PIC S9(10)V99 OCCURS 6.
      ************
      **** rel 4.0
           05 COMEURO  PIC 9(3) VALUE ZERO.
      ************
      **** rel 6.2
           05 KML      PIC 9(5).
           05 KVALID   PIC 9(5).
           05 KN       PIC 9(5).
           05 MAXRIGD  PIC ZZ9.
      *    NRIGMAXL: n. righe  logiche max rigo cliente
      *    NCOLMAXL: n. colonne max note aggiuntive rigo cliente
           05 NRIGMAXL PIC 9(3).
           05 NCOLMAXL PIC 9(3).
      ************
      **** rel 7.1
           05 DTINT   PIC 9(5) VALUE ZERO.
      ************
      **** rel 6.2
       01  COM-IN.
           05 COM-RIN PIC X(60) OCCURS 100.
      ************
       LINKAGE SECTION.
           COPY 'gribfrrg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-BFR-CTRL
                                RG-BFR-REC
                                RA-BFR-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dcltab'.
           COPY 'dclorf'.
           COPY 'dclrif'.
           COPY 'dclbft'.
           COPY 'dclbfr'.
           COPY 'dclart'.
           COPY 'dclard'.
           COPY 'dclobf'.
           COPY 'dclclf'.
           COPY 'dclcon'.
           COPY 'dcllav'.
      **** rel 6.3
      *    COPY 'dcllaq'.
      ************
      **** rel 6.2
           COPY 'dclnfr'.
           COPY 'dclnrf'.
           COPY 'dclarn'.
           COPY 'dclnat'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-BFR-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-BFR-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
      **** rel 5.0
           IF RG-BFR-FUN = 'V' AND FUN-PREC = 'E' GO TO ESCI.
           IF RG-BFR-FUN = 'A' AND FUN-PREC = 'E' GO TO ESCI.
      ************
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           IF (RG-BFR-FUN = 'N' OR 'n') AND
              (RG-BFR-EOF = 2 OR 3)     GO TO ESCI.
           IF (RG-BFR-FUN = 'P' OR 'p') AND
              (RG-BFR-EOF = 1 OR 2)     GO TO ESCI.
           MOVE RG-BFR-FUN   TO FUN.
           MOVE RG-BFR-IDX   TO IDX.
           MOVE RG-BFR-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-BFR-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'e' GO TO F-MZOOM.
           IF FUN = 'a' GO TO F-MZOOM-ART.
           IF FUN = 'w' GO TO F-CTRL-CONS.
           IF FUN = 'E' GO TO F-EXIT.
      **** rel 6.2
           IF FUN = 'J' PERFORM F-LEG-TESTO THRU END-F-LEG-TESTO
                        GO TO FINE.
           IF FUN = 'T' GO TO F-LEG-NAT.
      ************
           MOVE 'vorfg75: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-MZOOM.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           IF ID-LAV NOT = SPACE PERFORM R-RDR00 THRU R-RDR99.
           GO TO CHIUDI.
      * - - - - - *
       F-MZOOM-ART.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           IF ID-LAV NOT = SPACE PERFORM B00-ART THRU B99-ART.
           GO TO FINE.
      * - - - - - *
       F-CTRL-CONS.
           MOVE ZERO TO SWCONS.
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              IF RA-BFR-NOR0(K) NOT = ZERO OR
                 RA-BFR-PRG0(K) NOT = ZERO OR
                 RA-BFR-RES0(K) NOT = ZERO OR
                 RA-BFR-CON0(K) NOT = ZERO OR
                 RA-BFR-SAL0(K) NOT = ZERO MOVE 1 TO SWCONS
                                           MOVE 7 TO K
              ELSE
                 ADD 1 TO K
              END-IF
           END-PERFORM.
           IF SWCONS = ZERO
              GO TO FINE.
           MOVE "  Non e' possibile utilizzare la    " TO F-MES1.
           MOVE "       selezione multipla.          " TO F-MES2.
           MOVE "Esistono gia' dei righi di consegna " TO F-MES3.
           MOVE 3 TO F-NMES.
           GO TO WARNING.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-BFR-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-BFR-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-BFR-ST = 7 GO TO FINE.
      *    IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           IF FUN = 'r' PERFORM CTRL-BOL THRU EX-CTRL-BOL
                        IF SWDGEST NOT = ZERO
                           GO TO WARNING.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
      *    PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK BOLFRI.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
      **** rel 5.0
           IF RA-BFR-NOR0(1) = ZERO
              PERFORM CALCOLA-MEDIE THRU EX-CALCOLA-MEDIE
           ELSE
              MOVE KRF-AZI TO OF-AZI
              MOVE RA-BFR-NOR0(1) TO OF-NUM
              CALL 'vrvopf' USING PAROF
              IF NOT OF-FLG = 1 
                 PERFORM CALCOLA-MEDIE THRU EX-CALCOLA-MEDIE.
      ************
           WRITE RF-BFR INVALID
              PERFORM INVK-BFR
              GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BFR.
      *
           PERFORM CALL-VSRV133-MMG.
      ************
      *
      **** rel 6.2
       F-SCRIVI-NFR.
           PERFORM DL-WR-NOTE THRU EX-DL-WR-NOTE.
      ************
           IF RA-BFR-NOR0(1) NOT = ZERO OR
              RA-BFR-NOR0(2) NOT = ZERO OR
              RA-BFR-NOR0(3) NOT = ZERO OR
              RA-BFR-NOR0(4) NOT = ZERO OR
              RA-BFR-NOR0(5) NOT = ZERO OR
              RA-BFR-NOR0(6) NOT = ZERO GO TO NO-LAQ01.
           IF BFT-VALUT = CLF-VAL PERFORM G00-AGGLAQ THRU G999.
       NO-LAQ01.
      *
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CAR-PARMAG THRU EX-CAR-PARMAG.
           PERFORM DB-STORNA  THRU EX-DB-STORNA.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
      **** rel 5.0
           IF RA-BFR-NOR0(1) = ZERO
              PERFORM CALCOLA-MEDIE THRU EX-CALCOLA-MEDIE
           ELSE
              MOVE KRF-AZI TO OF-AZI
              MOVE RA-BFR-NOR0(1) TO OF-NUM
              CALL 'vrvopf' USING PAROF
              IF NOT OF-FLG = 1 
                 PERFORM CALCOLA-MEDIE THRU EX-CALCOLA-MEDIE.
      ************
           REWRITE RF-BFR INVALID
              PERFORM INVK-BFR
              GO TO ERRIO.
           UNLOCK BOLFRI.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BFR.
      ************
      *
      **** rel 6.2
       F-AGGIOR-NFR.
           PERFORM DL-WR-NOTE THRU EX-DL-WR-NOTE.
      ************
           IF RA-BFR-NOR0(1) NOT = ZERO OR
              RA-BFR-NOR0(2) NOT = ZERO OR
              RA-BFR-NOR0(3) NOT = ZERO OR
              RA-BFR-NOR0(4) NOT = ZERO OR
              RA-BFR-NOR0(5) NOT = ZERO OR
              RA-BFR-NOR0(6) NOT = ZERO GO TO NO-LAQ02.
           IF BFT-VALUT = CLF-VAL PERFORM G00-AGGLAQ THRU G999.
       NO-LAQ02.
      *
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-BFR
              GO TO WARNING.
           IF RG-BFR-ST = 7 GO TO FINE.
      **** rel 6.1
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
      ************
           IF BFR-TPRIG = 1 OR 3 GO TO ANN10.
           PERFORM CTRL-BOL THRU EX-CTRL-BOL.
           IF SWDGEST NOT = ZERO GO TO WARNING.
           PERFORM CAR-PARMAG THRU EX-CAR-PARMAG.
           PERFORM DB-STORNA  THRU EX-DB-STORNA.
           IF SWDGEST NOT = ZERO UNLOCK BOLFRI
                                 GO TO WARNING.
           IF BFR-TPRIG NOT = ZERO GO TO ANN10.
      **** rel 5.0
           IF BFR-NUMOV = ZERO GO TO ANN10.
      ************
           MOVE BFR-CODART TO M-ART.
           MOVE BFR-NUMOV  TO M-ONUM.
           MOVE ZERO       TO M-NQTA.
      **** rel 7.1
           MOVE SPACE TO M-FDSV.
      ************
           CALL 'vrmvmag' USING PARMAG.
           IF ERRIO-ST = 9 GO TO ERRIO.
           IF ERRIO-ST = 8 MOVE ZERO TO ERRIO-ST
                           CALL 'vrmbox' USING PARMB.
       ANN10.
           DELETE BOLFRI INVALID
              PERFORM INVK-BFR
              GO TO ERRIO.
           UNLOCK BOLFRI.
      **** rel 7.1
           MOVE BFT-DTBO TO DTINT.
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BFR.
      ************
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-BFR-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK BOLFRI.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-BFR-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ORDFOR.
           CLOSE TABELL.
           CLOSE BOLFTE.
           CLOSE ANACLF.
           CLOSE ANACON.
           CLOSE BOLFRI.
           CLOSE MAGART.
           CLOSE MAGARD.
           CLOSE ORDRIF.
           CLOSE BOLORF.
      **** rel 6.2
           CLOSE NOTBFR.
           CLOSE NOTRIF.
           CLOSE ARCNOT.
           CLOSE NOTART.
      ************
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-BFR-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-BFR-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'gritaber'.
           COPY 'griorfer'.
           COPY 'gririfer'.
           COPY 'gribfter'.
           COPY 'gribfrer'.
           COPY 'griarter'.
           COPY 'griarder'.
           COPY 'griobfer'.
           COPY 'griclfer'.
           COPY 'griconer'.
      **** rel 6.2
           COPY 'grinfrer'.
           COPY 'grinrfer'.
           COPY 'griarner'.
           COPY 'grinater'.
      ************
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           OPEN INPUT ORDFOR
                      TABELL
                      ANACLF
                      ANACON.
           OPEN I-O BOLFTE
                    BOLFRI
                    MAGART
                    MAGARD
                    ORDRIF
                    BOLORF.
      **** rel 6.2
           OPEN I-O NOTBFR.
           OPEN I-O NOTRIF.
           OPEN I-O ARCNOT.
           OPEN I-O NOTART.
      ************
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MFOR TO MFOR.
      *
           MOVE RG-BFR-AZI TO KBF-AZI.
           MOVE RG-BFR-PRT TO KBF-PRT.
           READ BOLFTE INVALID PERFORM INVK-BFT
                               GO TO ERRIO.
      *
           MOVE RG-BFR-AZI TO KCF-AZI.
           MOVE BFT-FOR TO CFOR.
           MOVE CDFOR TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID PERFORM INVK-CLF
                                           GO TO ERRIO.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
      **** rel 5.0
           MOVE CLF-FORQUA TO RA-BFR-FORQUA.
      ************
      *
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
      **** rel 4.0
      *
           CALL 'rveur' USING COMEURO.
      ************
      *
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-BFR-EOF.
      **** rel 6.2
           MOVE RG-BFR-AZI TO PTDC-AZI.
           MOVE 'BOF'      TO PTDC-COD.
           CALL 'vrctdc' USING PARTDC. 
           MOVE PTDC-NRIG TO NRIGMAXL.
           MOVE PTDC-NCOL TO NCOLMAXL.
      ************
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO  TO RF-BFR.
           MOVE ZERO  TO BFR-QUANT
                         BFR-PZLOR
                         BFR-SCON1
                         BFR-SCON2
                         BFR-PZNET
                         BFR-NETRG
                         BFR-QUAFA
                         BFR-VALFA
      **** rel 5.0
                         BFR-QUADOC
      ************
      **** rel 6.3
                         BFR-NOMC
      ************
                         BFR-NUMOV.
           MOVE SPACE TO BFR-CODART
                         BFR-DESCR
      **** rel 5.0
                         BFR-CONLOT
      ************
                         BFR-UNMIS.
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
           MOVE RG-BFR-AZI TO IF-AZI.
           MOVE RG-BFR-PRT TO IF-PRT.

      * azzeramento aree interfaccia
           MOVE ZERO  TO RG-BFR-REC.
           MOVE ZERO  TO RG-BFR-QUANT
                         RG-BFR-PZLOR
                         RG-BFR-SCON1
                         RG-BFR-SCON2
                         RG-BFR-PZNET
                         RG-BFR-NETRG
                         RG-BFR-QUAFA
      **** rel 6.3
                         RG-BFR-NOMC
      ************
                         RG-BFR-VALFA.
           MOVE SPACE TO RG-BFR-CODART
                         RG-BFR-DESCR
      **** rel 5.0
                         RG-BFR-CONLOT
                         RG-BFR-QUADOC
      ************
                         RG-BFR-UNMIS.
           MOVE ZERO  TO RA-BFR-AGG.
           MOVE SPACE TO RA-BFR-CPART-D2
      **** rel 3.0b
                         RA-BFR-CPART-D
      ************
      **** rel 5.0
                         RA-BFR-CONLOT-D
                         RA-BFR-QUADOC-D
      ************
                         RA-BFR-UM1-D
                         RA-BFR-UM2-D.
      **** rel 4.0
           MOVE SPACE TO RA-BFR-FSC-D.
      ************
      **** rel 6.2
           PERFORM AZZ-NOTE.
      ************
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              MOVE ZERO TO RA-BFR-RES0(K)
                           RA-BFR-CON0(K)
              ADD 1 TO K
           END-PERFORM.

      * ripristino dei campi chiave fissi
           MOVE IF-AZI TO RG-BFR-AZI.
           MOVE IF-PRT TO RG-BFR-PRT.
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
      **** rel 5.0
      *
           MOVE RG-BFR-AZI TO KCF-AZI.
           MOVE BFT-FOR TO CFOR.
           MOVE CDFOR TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID PERFORM INVK-CLF
                                           GO TO ERRIO.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           MOVE CLF-FORQUA TO RA-BFR-FORQUA.
      *
      ************
           MOVE RG-BFR-AZI TO KFR-AZI.
           MOVE RG-BFR-PRT TO KFR-PRT.
           MOVE ZERO TO KFR-PRG RG-BFR-PRG.
           START BOLFRI KEY NOT < KEYFR INVALID GO TO NORIG.
       RDBLR.
           READ BOLFRI NEXT AT END GO TO NORIG.
           IF KFR-AZI > RG-BFR-AZI GO TO NORIG.
           IF KFR-PRT > RG-BFR-PRT GO TO NORIG.
           MOVE KFR-PRG TO RG-BFR-PRG.
           GO TO RDBLR.
       NORIG.
           ADD 5 TO RG-BFR-PRG.
      *
           PERFORM CAR-PARMAG THRU EX-CAR-PARMAG.
           MOVE ZERO  TO M-ODAT.
      *
           MOVE SPACE TO WART.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-BFR-AZI TO KFR-AZI.
           MOVE RG-BFR-PRT TO KFR-PRT.
           MOVE RG-BFR-PRG TO KFR-PRG.
           MOVE KEYFR TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYFR.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ BOLFRI INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ BOLFRI KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-BFR > ZERO MOVE 7 TO RG-BFR-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ BOLFRI PREVIOUS AT END MOVE 1 TO EOF
           ELSE
              READ BOLFRI NEXT AT END MOVE 3 TO EOF.
           IF EOF > ZERO GO TO RNP-80.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-BFR = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *
           IF KFR-AZI NOT = RG-BFR-AZI GO TO RNP-10.

      * trovato record valido: reset EOF
           MOVE ZERO TO RG-BFR-EOF.
           MOVE KEYFR TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-BFR-EOF.
           IF RG-BFR-EOF = 4 MOVE 2 TO RG-BFR-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-BFR = LOW-VALUE GO TO EX-TEST-EOL.
           IF KFR-AZI = RG-BFR-AZI AND
              KFR-PRT = RG-BFR-PRT GO TO EX-TEST-EOL.
           IF FUN = 'P' OR 'p'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
      **** rel 6.2
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 5       TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL RA-BFR-NOTE.
      ************
           MOVE RG-BFR-AZI       TO KFR-AZI.
           MOVE RG-BFR-PRT       TO KFR-PRT
                                    BFR-PRT.
           MOVE RG-BFR-PRG       TO KFR-PRG.
           MOVE RG-BFR-TPRIG     TO BFR-TPRIG.
           MOVE RG-BFR-DESCR     TO BFR-DESCR.
      *
           IF RG-BFR-TPRIG = 1
      **** rel 6.2
              MOVE RA-BFR-RIGNOT(1) TO BFR-DESCR
      ************
              GO TO EX-CARICA-REC.
      *
      **** rel 4.0
      *    MOVE RG-BFR-TPREZ     TO BFR-TPREZ.
      *    MOVE RG-BFR-PZNET     TO BFR-PZNET.
           MOVE RG-BFR-FSC       TO BFR-FSC.
      ************
           MOVE RG-BFR-CPART     TO BFR-CPART.
      *
           IF BFR-TPRIG = 3
              PERFORM LEGGI-T11 THRU EX-LEGGI-T11
              MOVE RG-BFR-CDSPE  TO BFR-CDSPE
              MOVE RG-BFR-PZLOR  TO BFR-PZLOR
                                    BFR-NETRG
      **** rel 4.0
              MOVE RG-BFR-PZNET  TO BFR-PZNET
      ************
              GO TO EX-CARICA-REC.
      *
           MOVE RG-BFR-CODART    TO BFR-CODART.
           MOVE RG-BFR-TQUAN     TO BFR-TQUAN.
           MOVE RG-BFR-UNMIS     TO BFR-UNMIS.
           MOVE RG-BFR-CDIVA     TO BFR-CDIVA.
           MOVE RG-BFR-QUANT     TO BFR-QUANT.
           MOVE RG-BFR-SCON1     TO BFR-SCON1.
           MOVE RG-BFR-SCON2     TO BFR-SCON2.
      **** rel 6.3
           MOVE RG-BFR-NOMC      TO BFR-NOMC.
      ************
      **** rel 4.0
      *    MOVE RG-BFR-PZLOR     TO BFR-PZLOR.
      *
           MOVE RG-BFR-FSC   TO DP-FSC.
           MOVE RG-BFR-PZLOR TO DP-PREZZO.
           CALL 'rforprz' USING DP-PREZZO DP-FSC FSC-UNI.
           MOVE DP-PREZZO    TO BFR-PZLOR.
      *
           MOVE RG-BFR-FSC   TO DP-FSC.
           MOVE RG-BFR-PZNET TO DP-PREZZO.
           CALL 'rforprz' USING DP-PREZZO DP-FSC FSC-UNI.
           MOVE DP-PREZZO    TO BFR-PZNET.
      *
      ************
           MOVE RG-BFR-NETRG     TO BFR-NETRG.
           MOVE RG-BFR-QUAFA     TO BFR-QUAFA.
           MOVE RG-BFR-VALFA     TO BFR-VALFA.
           MOVE RG-BFR-FLGFT     TO BFR-FLGFT.
           MOVE RG-BFR-NUMOV     TO BFR-NUMOV.
      **** rel 5.0
           MOVE RA-BFR-CONLOT-D  TO RG-BFR-CONLOT.
           MOVE RG-BFR-CONLOT    TO BFR-CONLOT.
           MOVE RA-BFR-QUADOC-D  TO RG-BFR-QUADOC.
           MOVE RG-BFR-QUADOC    TO BFR-QUADOC.
      ************
      *
           PERFORM SETTA-TQP-BFR THRU EX-SETTA-TQP-BFR.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE KFR-AZI       TO RG-BFR-AZI.
           MOVE KFR-PRT       TO RG-BFR-PRT.
           MOVE KFR-PRG       TO RG-BFR-PRG.
           MOVE BFR-CODART    TO RG-BFR-CODART
                                 WART.
           MOVE BFR-TPRIG     TO RG-BFR-TPRIG.
           MOVE BFR-CDSPE     TO RG-BFR-CDSPE.
           MOVE BFR-TQUAN     TO RG-BFR-TQUAN.
      **** rel 4.0
      *    MOVE BFR-TPREZ     TO RG-BFR-TPREZ.
           MOVE BFR-FSC       TO RG-BFR-FSC.
      ************
           MOVE BFR-DESCR     TO RG-BFR-DESCR.
           MOVE BFR-UNMIS     TO RG-BFR-UNMIS.
           MOVE BFR-CDIVA     TO RG-BFR-CDIVA.
           MOVE BFR-QUANT     TO RG-BFR-QUANT.
      **** rel 4.0
      *    MOVE BFR-PZLOR     TO RG-BFR-PZLOR.
           IF BFR-TPRIG = 3
              MOVE BFR-PZLOR     TO RG-BFR-PZLOR
           ELSE
              MOVE BFR-FSC   TO DP-FSC
              MOVE BFR-PZLOR TO DP-PREZZO
              CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
              MOVE DP-PREZZO TO RG-BFR-PZLOR.
      ************
           MOVE BFR-SCON1     TO RG-BFR-SCON1.
           MOVE BFR-SCON2     TO RG-BFR-SCON2.
      **** rel 6.3
           MOVE BFR-NOMC      TO RG-BFR-NOMC.
      ************
      **** rel 4.0
      *    MOVE BFR-PZNET     TO RG-BFR-PZNET.
           IF BFR-TPRIG = 3
              MOVE BFR-PZNET     TO RG-BFR-PZNET
           ELSE
              MOVE BFR-FSC   TO DP-FSC
              MOVE BFR-PZNET TO DP-PREZZO
              CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
              MOVE DP-PREZZO TO RG-BFR-PZNET.
      ************
           MOVE BFR-NETRG     TO RG-BFR-NETRG.
           MOVE BFR-CPART     TO RG-BFR-CPART.
           MOVE BFR-QUAFA     TO RG-BFR-QUAFA.
           MOVE BFR-VALFA     TO RG-BFR-VALFA.
           MOVE BFR-FLGFT     TO RG-BFR-FLGFT.
           MOVE BFR-NUMOV     TO RG-BFR-NUMOV.
      **** rel 5.0
           MOVE BFR-QUADOC    TO RG-BFR-QUADOC.
           MOVE BFR-CONLOT    TO RG-BFR-CONLOT.
      ************
      *
           IF BFR-TPRIG = 2
      **** rel 4.0
              MOVE 2 TO RG-BFR-TQUAN.
      *       MOVE 2 TO RG-BFR-TQUAN
      *       MOVE 1 TO RG-BFR-TPREZ.
      ************
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
      **** rel 6.2
      *    IF RG-BFR-TPRIG     = 1 GO TO EX-CARICA-RA.
           IF RG-BFR-TPRIG     = 1 GO TO RCO90.
      ************
           IF RG-BFR-TPRIG NOT = 3 GO TO RCO20.
           MOVE 11           TO KTB-TIP.
           MOVE RG-BFR-CDSPE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ALL '*' TO TAB-DESCR
                                           MOVE ZERO TO T11-CONTR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RG-BFR-DESCR.
           MOVE RG-BFR-AZI TO KPC-AZI.
           MOVE T11-CONTR  TO KPC-COD RA-BFR-CPART-D1.
           READ ANACON INTO REKCON INVALID MOVE ALL '*' TO CON-DSABB.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-DSABB TO RA-BFR-CPART-D2.
      **** rel 6.2
      *    GO TO EX-CARICA-RA.
           GO TO RCO90.
      ************
       RCO20.
           IF RG-BFR-TPRIG = 2 GO TO RCO30.
           MOVE RG-BFR-AZI    TO KMA-AZI.
           MOVE RG-BFR-CODART TO KMA-ART.
           READ MAGART INTO REKART INVALID MOVE ALL '*' TO ARTDESC.
           MOVE ARTDESC TO RG-BFR-DESCR.
      **** rel 5.1
      *    GO TO RCO40.
      ************
       RCO30.
           IF RG-BFR-CPART = ZERO MOVE ZERO  TO RA-BFR-CPART-D1
      **** rel 3.0b
      *                           MOVE SPACE TO RA-BFR-CPART-D2.
                                  MOVE SPACE TO RA-BFR-CPART-D
                                                RA-BFR-CPART-D2.
      ************
           MOVE 21           TO KTB-TIP.
           MOVE RG-BFR-CPART TO KTB-COD.
      **** rel 3.0b
      *    READ TABELL INTO REKT21 INVALID MOVE ZERO TO T21-CPART.
           READ TABELL INTO REKT21 INVALID MOVE ZERO TO T21-CPART
                                           MOVE SPACE TO T21-DESCR.
      ************
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT21.
           MOVE T21-CPART TO RA-BFR-CPART-D1.
      **** rel 3.0b
           MOVE T21-DESCR TO RA-BFR-CPART-D.
      ************
           MOVE RG-BFR-AZI      TO KPC-AZI.
           MOVE RA-BFR-CPART-D1 TO KPC-COD.
           READ ANACON INTO REKCON INVALID MOVE SPACE TO CON-DSABB.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-DSABB TO RA-BFR-CPART-D2.
       RCO40.
           MOVE ZERO TO K.
       RCO42.
           ADD 1 TO K.
           MOVE ZERO TO RA-BFR-NOR0(K)
                        RA-BFR-PRG0(K)
                        RA-BFR-CON0(K)
                        RA-BFR-RES0(K)
                        RA-BFR-SAL0(K).
      **** rel 2.0
           MOVE ZERO TO PREC-CON0(K).
      ************
           IF K < 6 GO TO RCO42.
           MOVE 1 TO K.
           MOVE RG-BFR-AZI TO KOB-AZI.
           MOVE RG-BFR-PRT TO KOB-PRT.
           MOVE RG-BFR-PRG TO KOB-PRB.
           MOVE ZERO       TO KOB-PRG.
           MOVE RG-BFR-QUANT TO RESID.
           START BOLORF KEY NOT < KEYOB INVALID GO TO RCO60.
       RCO50.
           READ BOLORF NEXT AT END GO TO RCO60.
           IF SF-OBF = '9D' OR '9A' OR '35' GO TO RCO60.
           IF KOB-AZI NOT = RG-BFR-AZI OR
              KOB-PRT NOT = RG-BFR-PRT OR
              KOB-PRB NOT = RG-BFR-PRG GO TO RCO60.
           MOVE OBF-NORD  TO RA-BFR-NOR0(K).
           MOVE OBF-RGOR  TO RA-BFR-PRG0(K).
           MOVE OBF-QUANT TO RA-BFR-CON0(K).
      **** rel 2.0
           MOVE OBF-QUANT TO PREC-CON0(K).
      ************
           SUBTRACT OBF-QUANT FROM RESID.
           IF OBF-FORD NOT = ZERO MOVE ZERO TO RA-BFR-RES0(K)
                                  MOVE 1    TO RA-BFR-SAL0(K)
                                  ADD 1 TO K
                                  GO TO RCO50.
           MOVE OBF-AZI  TO KRF-AZI.
           MOVE OBF-NORD TO KRF-NUM.
           MOVE OBF-RGOR TO KRF-PRG.
           READ ORDRIF INTO REKRIF INVALID MOVE ZERO TO RA-BFR-RES0(K)
                                           MOVE 1    TO RA-BFR-SAL0(K)
                                           ADD 1 TO K
                                           GO TO RCO50.
           IF SF-RIF = '9D' OR '9A' OR '35' MOVE RF-RIF TO REKRIF.
           COMPUTE RA-BFR-RES0(K) = RIF-QUANT - RIF-QARR + OBF-QUANT.
           IF RA-BFR-RES0(K) NOT > ZERO MOVE ZERO TO RA-BFR-RES0(K).
           IF RIF-SALDO = 1 MOVE 1 TO RA-BFR-SAL0(K).
           ADD 1 TO K.
           GO TO RCO50.
       RCO60.
           IF K < 7 MOVE RESID TO RA-BFR-CON0(K)
                    MOVE ZERO TO RESID.
      **** rel 4.0
           MOVE ZERO TO RA-BFR-CBFSC.
           IF RG-BFR-TPRIG = 2
              IF RG-BFR-FSC > ZERO MOVE 1 TO RA-BFR-CBFSC.
           PERFORM AGGIORNA-FSC-D.
      ************
      **** rel 6.2
       RCO90.
           PERFORM RD-NFR THRU EX-RD-NFR.
      ************
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-BFR-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
      *
       V-PRG.
           MOVE 'BFR-PRG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PRG.
           IF RG-BFR-PRG = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-PRG.
      *
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-BFR-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-TPRIG.
           MOVE 'BFR-TPRIG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPRIG.
           IF NOT (RG-BFR-TPRIG = ZERO OR 1 OR 2 OR 3)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF RG-BFR-TPRIG = 2 AND KFR-AZI = ZERO
      **** rel 4.0
              MOVE 2 TO RG-BFR-TQUAN.
      *       MOVE 2 TO RG-BFR-TQUAN
      *       MOVE 1 TO RG-BFR-TPREZ.
      ************
       E-TPRIG.
      *
       V-CODART.
           MOVE 'BFR-CODART' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CODART.
           IF NOT (RG-BFR-TPRIG = 0) GO TO E-CODART.
           CALL 'vrcartb' USING RG-BFR-AZI RG-BFR-CODART.
           IF RG-BFR-CODART = '0' OR SPACE
              MOVE SPACE TO RG-BFR-DESCR
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           IF WART = RG-BFR-CODART GO TO E-CODART.
      **** rel 5.2
           MOVE 9 TO PCFA-FUN.
       LP-PCFA.
      ************
           MOVE RG-BFR-CODART TO WART.
           MOVE RG-BFR-AZI    TO KMA-AZI.
           MOVE RG-BFR-CODART TO KMA-ART.
           READ MAGART INTO REKART INVALID
      **** rel 5.2
                IF PCFA-FUN = 9
                   MOVE RG-BFR-AZI TO PCFA-AZI
                   MOVE 'F' TO PCFA-TIP
                   MOVE BFT-FOR TO PCFA-CLF
                   MOVE RG-BFR-CODART TO PCFA-ART
                   CALL 'vrrcfa' USING PARPCFA
                   IF PCFA-ST = ZERO AND
                      PCFA-ART NOT = SPACE
                         MOVE PCFA-ART TO RG-BFR-CODART
                         MOVE ZERO TO PCFA-FUN
                         GO TO LP-PCFA
                   END-IF
                END-IF
      ************
                MOVE SPACE TO RG-BFR-DESCR
                PERFORM ERR-CINE
                MOVE SPACE TO WART
                GO TO V-ERROR.
           IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
           IF KFR-AZI NOT = ZERO  GO TO E-CODART.
      **** rel 4.0
           MOVE ART-FSC   TO DP-FSC.
           MOVE BFT-VALUT TO DP-VALUT.
           CALL 'rdetfsc' USING DP-VALUT DP-FSC.
           MOVE DP-FSC    TO RG-BFR-FSC.
           PERFORM AGGIORNA-FSC-D.
      ************
           MOVE ART-DESCR TO RG-BFR-DESCR.
      **** rel 6.3
           MOVE ART-NOMME TO RG-BFR-NOMC.
      ************
           MOVE KMA-AZI  TO KAD-AZI.
           MOVE KMA-ART  TO KAD-ART.
           MOVE BFT-CDEP TO KAD-DEP.
           PERFORM TESTARD THRU EX-TESTARD.
           IF TARD > ZERO
              MOVE 'Inesistente su deposito' TO MESS
              MOVE SPACE TO WART
              GO TO V-ERROR.
           IF FUN = 'W' GO TO E-CODART.
           MOVE ART-CDIVA TO RG-BFR-CDIVA.
           MOVE ART-UNMIS TO RG-BFR-UNMIS.
           MOVE ART-TQUAN TO RG-BFR-TQUAN.
      **** rel 4.0
      *    MOVE ART-TPRZ  TO RG-BFR-TPREZ.
      *    IF BFT-VALUT > 1 MOVE 1 TO RG-BFR-TPREZ.
      ************
           MOVE ZERO TO RG-BFR-PZLOR.
      **** rel 4.0
           IF BFT-VALUT = 1 AND CLF-TPRZ NOT = ZERO
              MOVE CLF-TPRZ TO BL-LIS
              PERFORM LISTINO-BASE-LIRE THRU LL99
              GO TO NO-LIS-BAS.
      ************
      **** rel 4.0
      *    IF CLF-TPRZ = 1 MOVE ART-PRZ1 TO RG-BFR-PZLOR.
      *    IF CLF-TPRZ = 2 MOVE ART-PRZ2 TO RG-BFR-PZLOR.
      *    IF CLF-TPRZ = 3 MOVE ART-PRZ3 TO RG-BFR-PZLOR.
           IF CLF-TPRZ = 1
              MOVE RG-BFR-FSC TO DP-FSC
              MOVE ART-PRZ1   TO DP-PREZZO
              CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
              MOVE DP-PREZZO  TO RG-BFR-PZLOR.
           IF CLF-TPRZ = 2
              MOVE RG-BFR-FSC TO DP-FSC
              MOVE ART-PRZ2   TO DP-PREZZO
              CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
              MOVE DP-PREZZO  TO RG-BFR-PZLOR.
           IF CLF-TPRZ = 3
              MOVE RG-BFR-FSC TO DP-FSC
              MOVE ART-PRZ3   TO DP-PREZZO
              CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
              MOVE DP-PREZZO  TO RG-BFR-PZLOR.
       NO-LIS-BAS.
      ************
           IF BFT-VALUT = CLF-VAL PERFORM L00-LISTINO THRU L999.
           IF RG-BFR-TPRIG = ZERO AND ART-2UNMIS = SPACE
              MOVE ART-UNMIS TO RG-BFR-UNMIS
              GO TO E-CODART.
           MOVE ART-UNMIS  TO RA-BFR-UM1-D.
           MOVE ART-2UNMIS TO RA-BFR-UM2-D.
           IF ART-2UNMIS = SPACE
              MOVE 1         TO RA-BFR-TPUM
              MOVE ART-UNMIS TO RG-BFR-UNMIS
           ELSE
              MOVE 2          TO RA-BFR-TPUM
              MOVE ART-2UNMIS TO RG-BFR-UNMIS.
       E-CODART.
      *
       V-TPUM.
           MOVE 'BFR-TPUM' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPUM.
           IF NOT (RG-BFR-TPRIG = 0) GO TO E-TPUM.
           IF RA-BFR-TPUM = 1
              MOVE ART-UNMIS TO RG-BFR-UNMIS.
           IF RA-BFR-TPUM = 2
              MOVE ART-2UNMIS TO RG-BFR-UNMIS.
       E-TPUM.
      *
       V-DESCR.
           MOVE 'BFR-DESCR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DESCR.
           IF NOT (RG-BFR-TPRIG = 2)  GO TO E-DESCR.
           IF RG-BFR-DESCR = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-DESCR.
      **** rel 4.0
      *
       V-FSC.
           MOVE 'BFR-FSC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FSC.
           IF RG-BFR-TPRIG NOT = 2 GO TO E-FSC.
           MOVE ZERO  TO RG-BFR-FSC.
           IF RA-BFR-CBFSC = 1 MOVE 3 TO RG-BFR-FSC.
           PERFORM AGGIORNA-FSC-D.
       E-FSC.
      ************
      *
       V-CPART.
           MOVE 'BFR-CPART' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CPART.
           IF NOT (RG-BFR-TPRIG = 2)  GO TO E-CPART.
      **** rel 3.0b
           MOVE SPACE TO RA-BFR-CPART-D.
      ************
           MOVE ZERO  TO RA-BFR-CPART-D1.
           MOVE SPACE TO RA-BFR-CPART-D2.
           IF RG-BFR-CPART = ZERO
              GO TO E-CPART.

           MOVE 21           TO T21-TIP.
           MOVE RG-BFR-CPART TO T21-COD.
           MOVE T21-KEYID TO KEYTB.
           READ TABELL INTO REKT21 INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT21.
      **** rel 3.0b
           MOVE T21-DESCR TO RA-BFR-CPART-D.
      ************
           MOVE T21-CPART TO RA-BFR-CPART-D1
                             KPC-COD.
           MOVE RG-BFR-AZI TO KPC-AZI.
           READ ANACON INTO REKCON INVALID
                MOVE 'Conto inesistente' TO MESS
                GO TO V-ERROR.
           MOVE CON-DSABB TO RA-BFR-CPART-D2.
       E-CPART.
      *
       V-NOR0.
           IF NOT (RG-BFR-TPRIG = 0 OR 2) GO TO E-NOR0.
           MOVE ZERO TO KK.
       V-NOR0-10.
           ADD 1 TO KK.
           IF KK > 6 GO TO E-NOR0.
           MOVE SPACE TO VCAMPO.
           STRING 'BFR-NOR' KK DELIMITED SIZE INTO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO V-NOR0-10.
           IF RA-BFR-NOR0(KK) = ZERO
              MOVE ZERO TO  RA-BFR-PRG0(KK)
                            RA-BFR-RES0(KK)
                            RA-BFR-SAL0(KK)
              GO TO V-NOR0-10.
           MOVE RA-BFR-NOR0(KK) TO KOF-NUM.
           PERFORM D00-RD-ORD THRU D99.
           IF SWORD NOT = ZERO
              GO TO V-ERROR.
           IF RA-BFR-PRG0(KK) = ZERO GO TO V-NOR0-15.
           MOVE KK TO K1.
           PERFORM Z00-CTR-VET THRU Z99.
           IF SWVET NOT = ZERO
              GO TO V-ERROR.
           MOVE RA-BFR-NOR0(KK) TO KRF-NUM.
           MOVE RA-BFR-PRG0(KK) TO KRF-PRG.
           PERFORM D10 THRU D19.
           IF SWORD NOT = ZERO
              GO TO V-ERROR.
           IF KK = 1 AND FUN NOT = 'W'
              MOVE RIF-CDIVA TO RG-BFR-CDIVA
      **** rel 4.0
      *       MOVE RIF-PREZZ TO RG-BFR-PZLOR
              MOVE RG-BFR-FSC TO DP-FSC
              MOVE RIF-PREZZ  TO DP-PREZZO
              CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
              MOVE DP-PREZZO  TO RG-BFR-PZLOR
      ************
              MOVE RIF-1SCON TO RG-BFR-SCON1
              MOVE RIF-2SCON TO RG-BFR-SCON2
              MOVE RIF-UNMIS TO RG-BFR-UNMIS
      **** rel 6.3
              MOVE RIF-NOMC  TO RG-BFR-NOMC
      ************
      **** rel 1.2
              IF RG-BFR-TPRIG = ZERO
      ************
              IF RIF-UNMIS = ART-UNMIS
                 MOVE 1 TO RA-BFR-TPUM
              ELSE
                 IF RIF-UNMIS = ART-2UNMIS
                    MOVE 2 TO RA-BFR-TPUM
                 ELSE
                    IF ART-2UNMIS NOT = SPACE
                       MOVE ART-2UNMIS TO RG-BFR-UNMIS
                       MOVE 2 TO RA-BFR-TPUM
                    ELSE
                       MOVE ART-UNMIS TO RG-BFR-UNMIS
                       MOVE 1 TO RA-BFR-TPUM.
           PERFORM D20 THRU D99.
           IF SWORD NOT = ZERO
              GO TO V-ERROR.
           PERFORM V00-CAL-RES THRU V99.
           MOVE RESID TO RA-BFR-RES0(KK).
           IF FUN = 'V' MOVE RSAL0 TO RA-BFR-SAL0(KK).
       V-NOR0-15.
           GO TO V-NOR0-10.
       E-NOR0.
      *
       V-PRG0.
           IF NOT (RG-BFR-TPRIG = 0 OR 2) GO TO E-PRG0.
           MOVE ZERO TO KK.
       V-PRG0-10.
           ADD 1 TO KK.
           IF KK > 6 GO TO E-PRG0.
           MOVE SPACE TO VCAMPO.
           STRING 'BFR-PRG' KK DELIMITED SIZE INTO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO V-PRG0-10.
           IF RA-BFR-PRG0(KK) = ZERO
              IF RA-BFR-NOR0(KK) NOT = ZERO
                 PERFORM ERR-CINE
                 GO TO V-ERROR
              ELSE
                 GO TO V-PRG0-10.
           MOVE KK TO K1.
           PERFORM Z00-CTR-VET THRU Z99.
           IF SWVET NOT = ZERO
              GO TO V-ERROR.
           MOVE RA-BFR-NOR0(KK) TO KRF-NUM.
           MOVE RA-BFR-PRG0(KK) TO KRF-PRG.
           PERFORM D10 THRU D19.
           IF SWORD NOT = ZERO
              GO TO V-ERROR.
           IF KK = 1 AND FUN NOT = 'W'
              MOVE RIF-CDIVA TO RG-BFR-CDIVA
      **** rel 4.0
      *       MOVE RIF-PREZZ TO RG-BFR-PZLOR
              MOVE RG-BFR-FSC TO DP-FSC
              MOVE RIF-PREZZ  TO DP-PREZZO
              CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
              MOVE DP-PREZZO  TO RG-BFR-PZLOR
      ************
              MOVE RIF-1SCON TO RG-BFR-SCON1
              MOVE RIF-2SCON TO RG-BFR-SCON2
              MOVE RIF-UNMIS TO RG-BFR-UNMIS
      **** rel 6.3
              MOVE RIF-NOMC  TO RG-BFR-NOMC
      ************
      **** rel 1.2
              IF RG-BFR-TPRIG = ZERO
      ************
              IF RIF-UNMIS = ART-UNMIS
                 MOVE 1 TO RA-BFR-TPUM
              ELSE
                 IF RIF-UNMIS = ART-2UNMIS
                    MOVE 2 TO RA-BFR-TPUM
                 ELSE
                    IF ART-2UNMIS NOT = SPACE
                       MOVE ART-2UNMIS TO RG-BFR-UNMIS
                       MOVE 2 TO RA-BFR-TPUM
                    ELSE
                       MOVE ART-UNMIS TO RG-BFR-UNMIS
                       MOVE 1 TO RA-BFR-TPUM.
           PERFORM D20 THRU D99.
           IF SWORD NOT = ZERO
              GO TO V-ERROR.
           PERFORM V00-CAL-RES THRU V99.
           MOVE RESID TO RA-BFR-RES0(KK).
           IF FUN = 'V' MOVE RSAL0 TO RA-BFR-SAL0(KK).
       E-PRG0.
      *
       V-CON0.
           IF NOT (RG-BFR-TPRIG = 0 OR 2) GO TO E-CON0.
           MOVE ZERO TO KK.
       V-CON0-10.
           ADD 1 TO KK.
           IF KK > 6 GO TO V-CON0-20.
           MOVE SPACE TO VCAMPO.
           STRING 'BFR-CON' KK DELIMITED SIZE INTO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO V-CON0-10.
           MOVE RA-BFR-CON0(KK) TO RD-NUM.
           CALL 'vrround' USING QTA-S PARRD RG-BFR-TQUAN.
           MOVE RD-NUM TO RA-BFR-CON0(KK).
           IF RD-ST > ZERO
              PERFORM ERR-NDEC
              GO TO V-ERROR.
      *    MOVE RA-BFR-CON0(KK) TO RD-NUM.
      *    CALL 'vrround' USING QTA-SET PARRD RD-TIPO.
      *    IF RA-BFR-PRG0(KK) = ZERO
      *       IF RD-TIPO > RG-BFR-TQUAN
      *          MOVE RA-BFR-CON0(KK) TO RD-NUM
      *          CALL 'vrround' USING QTA-S PARRD RG-BFR-TQUAN
      *          MOVE RD-NUM TO RA-BFR-CON0(KK)
      *          IF RD-ST > ZERO
      *             PERFORM ERR-NDEC
      *             GO TO V-ERROR
      *          END-IF
      *       END-IF
      *    ELSE
      *       IF RD-TIPO > RG-BFR-TQUAN OR RD-TIPO > RIF-TQUAN
      *          MOVE RA-BFR-CON0(KK) TO RD-NUM
      *          CALL 'vrround' USING QTA-S PARRD RIF-TQUAN
      *          MOVE RD-NUM TO RA-BFR-CON0(KK)
      *          IF RD-ST > ZERO
      *             PERFORM ERR-NDEC
      *             GO TO V-ERROR.
           IF RA-BFR-CON0(KK) = ZERO
              IF RA-BFR-NOR0(KK) NOT = ZERO
                 PERFORM ERR-ZERO
                 GO TO V-ERROR
              ELSE
                 GO TO V-CON0-10.
           IF RA-BFR-NOR0(KK) NOT = ZERO
              IF RA-BFR-RES0(KK) NOT > RA-BFR-CON0(KK)
                 MOVE 1 TO RA-BFR-SAL0(KK).
      **** rel 2.0
           IF FUN = 'V' AND RA-BFR-NOR0(KK) NOT = ZERO
              IF RA-BFR-RES0(KK) > RA-BFR-CON0(KK) AND
                 RA-BFR-CON0(KK) < PREC-CON0(KK)
                    MOVE ZERO TO RA-BFR-SAL0(KK).
      ************
           GO TO V-CON0-10.
       V-CON0-20.
           MOVE ZERO TO RG-BFR-QUANT.
           MOVE 1 TO KK.
           PERFORM UNTIL KK > 6
              ADD RA-BFR-CON0(KK) TO RG-BFR-QUANT
              ADD 1 TO KK
           END-PERFORM.
       E-CON0.
      *
       V-SAL0.
           IF NOT (RG-BFR-TPRIG = 0 OR 2) GO TO E-SAL0.
           MOVE ZERO TO KK.
       V-SAL0-10.
           ADD 1 TO KK.
           IF KK > 6 GO TO E-SAL0.
           MOVE SPACE TO VCAMPO.
           STRING 'BFR-SAL' KK DELIMITED SIZE INTO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO V-SAL0-10.
           IF NOT (RA-BFR-SAL0(KK) = ZERO OR 1)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           GO TO V-SAL0-10.
       E-SAL0.
      *
       V-CDSPE.
           MOVE 'BFR-CDSPE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDSPE.
           IF RG-BFR-TPRIG NOT = 3 GO TO E-CDSPE.
           MOVE ZERO  TO RA-BFR-CPART-D1.
           MOVE SPACE TO RA-BFR-CPART-D2.
           IF RG-BFR-CDSPE = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 11           TO KTB-TIP.
           MOVE RG-BFR-CDSPE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO RG-BFR-DESCR
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RG-BFR-DESCR.

           IF T11-TIMP NOT = ZERO
              MOVE 'Tipo inserimento non valido' TO MESS
              GO TO V-ERROR.
           MOVE RG-BFR-AZI TO KPC-AZI.
           MOVE T11-CONTR  TO KPC-COD RA-BFR-CPART-D1.
           READ ANACON INTO REKCON INVALID MOVE ALL '*' TO CON-DSABB.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-DSABB TO RA-BFR-CPART-D2.
      **** rel 4.0
      *    MOVE ZERO TO RG-BFR-TPREZ.
      *    IF BFT-VALUT > 1 MOVE 1 TO RG-BFR-TPREZ.
      ************
       E-CDSPE.
      *
       V-PZLOR.
           MOVE 'BFR-PZLOR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PZLOR.
           IF NOT (RG-BFR-TPRIG = ZERO OR 2 OR 3) GO TO E-PZLOR.
      **** rel 4.0
      *    MOVE RG-BFR-PZLOR TO RD-NUM.
      *    CALL 'vrround' USING PRZ-S PARRD RG-BFR-TPREZ.
      *    MOVE RD-NUM TO RG-BFR-PZLOR.
      *    IF RD-ST > ZERO
      *       PERFORM ERR-NDEC
      *       GO TO V-ERROR.
      ************
      *    MOVE RG-BFR-PZLOR TO RD-NUM.
      *    CALL 'vrround' USING PRZ-SET PARRD RD-TIPO.
      *    IF RD-TIPO > RG-BFR-TPREZ
      *       MOVE RG-BFR-TPREZ TO RD-NUM
      *       CALL 'vrround' USING PRZ-S PARRD RG-BFR-TPREZ
      *       MOVE RD-NUM TO RG-BFR-PZLOR
      *       IF RD-ST > ZERO
      *          PERFORM ERR-NDEC
      *          GO TO V-ERROR.
       E-PZLOR.
      *
      **** rel 6.2
       V-NOTE.
           MOVE 'BFR-NOTE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NOTE.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 0       TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL RA-BFR-NOTE.
           IF ML-ST = 1
              MOVE SPACE TO F-MES2
              MOVE 'E'' possibile caricare' TO F-MES1
              MOVE NRIGMAXL TO MAXRIGD
              STRING 'al massimo ' MAXRIGD ' righe'
                     DELIMITED SIZE INTO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
      * accende/spegne bottone presenza note aggiuntive
           MOVE ZERO TO RA-BFR-FLGNOTE.
           IF BFR-TPRIG = 1
              MOVE 1 TO RA-BFR-FLGNOTE
              GO TO E-NOTE.
           IF RA-BFR-NOTE = SPACE GO TO E-NOTE.
      *
           MOVE NRIGMAXL TO KVALID.
           PERFORM UNTIL RA-BFR-RIGNOT(KVALID) NOT = SPACE
              SUBTRACT 1 FROM KVALID
           END-PERFORM.
           IF KVALID > ZERO
              MOVE 1 TO RA-BFR-FLGNOTE.
       E-NOTE.
      *
      ************
      * solo valida tutto
      *
           IF RG-BFR-TPRIG = 1 OR 3 OR
              FUN NOT = 'W'         GO TO END-V-DATI.
       CMPVET.
           MOVE ZERO TO SWTEST.
           MOVE ZERO TO K.
           MOVE 1 TO K1.
       CMPV00.
           ADD 1 TO K K1.
           IF K1 > 6 GO TO CMPV20.
           IF RA-BFR-NOR0(K) NOT = ZERO GO TO CMPV00.
       CMPV10.
           IF RA-BFR-NOR0(K1) NOT = ZERO
              MOVE RA-BFR-VETOR(K)  TO RIGCOM
              MOVE RA-BFR-VETOR(K1) TO RA-BFR-VETOR(K)
              MOVE RIGCOM           TO RA-BFR-VETOR(K1)
              MOVE 1 TO SWTEST
              GO TO CMPV00.
           ADD 1 TO K1.
           IF K1 > 6 GO TO CMPV20.
           GO TO CMPV10.
       CMPV20.
           IF SWTEST = 1 GO TO CMPVET.
           MOVE ZERO TO SWTEST.
           MOVE ZERO TO RG-BFR-QUANT.
           MOVE ZERO TO K.
           MOVE 1 TO K1.
       CMPV30.
           ADD 1 TO K K1.
           IF K  > 6 GO TO CMPV50.
           IF RA-BFR-NOR0(K) NOT = ZERO
              ADD RA-BFR-CON0(K) TO RG-BFR-QUANT GO TO CMPV30.
           ADD RA-BFR-CON0(K) TO RG-BFR-QUANT.
           IF K1 > 6 GO TO CMPV50.
       CMPV40.
           ADD RA-BFR-CON0(K1) TO RA-BFR-CON0(K) RG-BFR-QUANT.
           MOVE ZERO TO RA-BFR-CON0(K1).
           ADD 1 TO K1.
           IF K1 > 6 GO TO CMPV50.
           GO TO CMPV40.
       CMPV50.
      *
       END-V-DATI.
      *
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
       CTRL-BOL.
           MOVE ZERO TO SWDGEST.
           IF BFT-FLGFT NOT = ZERO
              MOVE "Bolla gia' fatturata" TO MESS
              MOVE 1 TO SWDGEST
              GO TO EX-CTRL-BOL.
           IF BFT-FLGMG NOT = 2
              MOVE 'Bolla non gestibile' TO MESS
              MOVE 1 TO SWDGEST.
       EX-CTRL-BOL.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
           IF BFR-TPRIG = 1 OR 3 GO TO EX-DB-STORNA.
           MOVE 1 TO SWDEL.
           PERFORM F00-GES-ORD THRU F99.
           MOVE ZERO TO SWDEL.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
           IF BFR-TPRIG = 1 OR 3 GO TO EX-DB-AGGIORNA.
           PERFORM C00-CAL-IMP THRU C99.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
       C00-CAL-IMP.
           MOVE BFR-TPRIG  TO M-TCOR.
           MOVE BFR-CODART TO M-ART.
           MOVE BFR-UNMIS  TO M-UNM.

           MOVE "A"       TO IM-TIPO.
           MOVE BFR-PZLOR TO IM-PZLOR.
           MOVE BFR-QUANT TO IM-QTA.
           MOVE BFT-SCBAS TO IM-SCBAS.
           MOVE BFR-SCON1 TO IM-SC1.
           MOVE BFR-SCON2 TO IM-SC2.
           MOVE BFT-VALUT TO IM-VALUT.
           MOVE BFR-TPRIG TO IM-TCOR.
           MOVE BFR-TQUAN TO IM-TQUAN.
      **** rel 4.0
      *    MOVE BFR-TPREZ TO IM-TPRZ.
           MOVE BFR-FSC   TO IM-FSC.
      ************
           CALL 'vrimpor' USING PARIM.
           MOVE IM-PZNET  TO BFR-PZNET.
           MOVE IM-NETRG  TO BFR-NETRG.
           MOVE BFR-NETRG TO M-NIMP.
           IF BFR-TPRIG = 2 GO TO C15.
           MOVE KFR-AZI    TO KMA-AZI.
           MOVE BFR-CODART TO KMA-ART.
           READ MAGART INTO REKART INVALID KEY PERFORM INVK-ART
                                               PERFORM VISK-BFR
                                               GO TO ERRIO.
           IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
           IF BFR-UNMIS = ART-UNMIS GO TO C10.
           MOVE BFR-QUANT TO SAVQTA.
           COMPUTE RD-NUM = BFR-QUANT / ART-COEFF.
           CALL 'vrround' USING QTA-S PARRD ART-TQUAN.
           MOVE RD-NUM TO BFR-QUANT.
       C10.
           MOVE ART-UNMIS TO M-UNM.
           MOVE BFR-QUANT TO M-NQTA.
           IF BFR-UNMIS NOT = ART-UNMIS MOVE SAVQTA TO BFR-QUANT.
           MOVE BFR-NUMOV TO M-ONUM.
           MOVE ZERO TO M-NMOV M-STAT.
       C15.
           MOVE ZERO TO K.
       C20.
           ADD 1 TO K.
           IF K > 6 GO TO C30.
           IF RA-BFR-NOR0(K) = ZERO GO TO C30.
           MOVE RG-BFR-AZI TO KOB-AZI OBF-AZI.
           MOVE KFR-PRT TO KOB-PRT OBF-PRT.
           MOVE KFR-PRG TO KOB-PRB.
           MOVE RA-BFR-NOR0(K) TO OBF-NORD.
           MOVE RA-BFR-PRG0(K) TO OBF-RGOR.
           MOVE K TO KOB-PRG.
           MOVE ZERO TO OBF.
           MOVE BFR-TQUAN TO OBF-TQUAN.
           MOVE RA-BFR-CON0(K) TO OBF-QUANT.
           WRITE RF-OBF INVALID
      **** rel 6.1
      *          MOVE 'Errore scrittura BOL/ORD' TO MESS
                 MOVE 'Errore scrittura BOL/ORD' TO F-MES1
                 CALL 'vrmbox' USING PARMB
      ************
                 GO TO C40.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-OBF.
      ************
      **** rel 5.0
           MOVE ZERO     TO PARBF.
           MOVE ZERO     TO BF-FUNZ.
           MOVE 1        TO BF-FLG.
      **** rel 6.1
           IF BFR-UNMIS NOT = ART-UNMIS 
              MOVE 2     TO BF-FLG.
      ************
           MOVE BFT-CDEP TO BF-DEP.
           MOVE BFR-CODART TO BF-ART.
           CALL 'vrcbpf' USING KEYOB PARBF.
      ************
           GO TO C20.
       C30.
           MOVE ZERO TO SWDEL.
           PERFORM F00-GES-ORD THRU F99.
       C40.
           IF BFR-TPRIG NOT = ZERO GO TO C99.
      **** rel 5.0
           IF BFR-QUANT = ZERO GO TO C99.
      ************
      **** rel 7.1
           MOVE SPACE TO M-FDSV.
           IF KFR-AZI = ZERO MOVE 'N' TO M-FDSV. *> non aggiornare DSV in inserimento
      ************
           CALL 'vrmvmag' USING PARMAG.
      **** rel 7.1
           MOVE SPACE TO M-FDSV.
      ************
           IF ERRIO-ST = 9 GO TO ERRIO.
           IF ERRIO-ST = 8 MOVE ZERO TO ERRIO-ST
                           CALL 'vrmbox' USING PARMB.
           IF M-STAT = ZERO MOVE M-NMOV TO BFR-NUMOV.
       C99.
           EXIT.
      *------------------
       D00-RD-ORD.
           MOVE ZERO TO SWORD.
           MOVE RG-BFR-AZI TO KOF-AZI.
           READ ORDFOR INTO REKORF INVALID
                MOVE 'Ordine inesistente' TO MESS
                MOVE 1 TO SWORD
                GO TO D99.
           IF SF-ORF = '9D' OR '9A' OR '35' MOVE RF-ORF TO REKORF.
           IF ORF-CDCLI NOT = BFT-FOR
                MOVE 'Fornitore diverso' TO MESS
                MOVE 1 TO SWORD
                GO TO D99.
           IF ORF-VALUT NOT = BFT-VALUT
                MOVE 'Divisa diversa' TO MESS
                MOVE 1 TO SWORD
                GO TO D99.
      **** rel 5.0
      *    IF ORF-CDDEP NOT = BFT-CDEP
      *         MOVE 'Deposito diverso' TO MESS
      *         MOVE 1 TO SWORD
      *         GO TO D99.
      ************
           IF ORF-CATT  NOT = BFT-CATT
                MOVE 'Attivita'' diversa' TO MESS
                MOVE 1 TO SWORD
                GO TO D99.
           GO TO D99.
       D10.
           MOVE ZERO TO SWORD.
           MOVE RG-BFR-AZI TO KRF-AZI.
           READ ORDRIF INTO REKRIF INVALID
                MOVE 'Rigo ordine inesistente' TO MESS
                MOVE 1 TO SWORD
                GO TO D19.
           IF SF-RIF = '9D' OR '9A' OR '35' MOVE RF-RIF TO REKRIF.
       D19.
           EXIT.
       D20.
           MOVE ZERO TO SWORD.
           IF RIF-TPRIG NOT = RG-BFR-TPRIG
                MOVE 'Tipo rigo diverso' TO MESS
                MOVE 1 TO SWORD
                GO TO D99.
           IF RIF-ARTIC NOT = RG-BFR-CODART
                MOVE 'Articolo diverso' TO MESS
                MOVE 1 TO SWORD
                GO TO D99.
           IF RIF-UNMIS NOT = RG-BFR-UNMIS
                MOVE 'Unita'' misura diversa' TO MESS
                MOVE 1 TO SWORD
                GO TO D99.
           IF RIF-TQUAN >  RG-BFR-TQUAN
                MOVE 'Tipo quantita'' incongruente' TO MESS
                MOVE 1 TO SWORD
                GO TO D99.
           MOVE ZERO TO RSAL0.
           SUBTRACT RIF-QARR FROM RIF-QUANT GIVING RESID.
           IF RIF-SALDO = 1 MOVE 1 TO RSAL0
                            MOVE 1 TO F-NMES
                            MOVE 'Ordine gia'' saldato' TO F-MES1
                            IF KFR-AZI = ZERO
                               MOVE 1 TO SWORD
                               GO TO D99
                            ELSE
                               IF FUN = 'V'
                                  MOVE 8 TO ERRIO-ST
                               END-IF
                               GO TO D30.
           IF RESID < ZERO MOVE ZERO TO RESID.
           IF RESID NOT > ZERO MOVE 1 TO RSAL0.
       D30.
           IF RIF-CONTR = ZERO
              MOVE ORF-CONTR TO CPART
           ELSE
              MOVE RIF-CONTR TO CPART.
           IF CPART NOT = RG-BFR-CPART
              IF FUN NOT = 'W'
                MOVE 8 TO ERRIO-ST
                MOVE 2 TO F-NMES
                MOVE 'Codice costo diverso' TO F-MES2.
           IF RIF-PREZZ NOT = RG-BFR-PZLOR
              IF FUN NOT = 'W'
                MOVE 8 TO ERRIO-ST
                MOVE 3 TO F-NMES
                MOVE 'Prezzo diverso' TO F-MES3.
           IF RIF-1SCON NOT = RG-BFR-SCON1 OR
              RIF-2SCON NOT = RG-BFR-SCON2
              IF FUN NOT = 'W'
                MOVE 8 TO ERRIO-ST
                MOVE 4 TO F-NMES
                MOVE 'Sconti diversi' TO F-MES4.
       D99.
           EXIT.
      *------------------
       F00-GES-ORD.
           MOVE KFR-AZI TO KOB-AZI.
           MOVE KFR-PRT TO KOB-PRT.
           MOVE KFR-PRG TO KOB-PRB.
           MOVE ZERO    TO KOB-PRG.
           START BOLORF KEY NOT < KEYOB INVALID GO TO F99.
       F10.
           READ BOLORF NEXT KEPT LOCK AT END GO TO F99.
           IF SF-OBF > ZERO PERFORM REC-LOCK
                            GO TO F10.
           IF KOB-AZI NOT = KFR-AZI OR
              KOB-PRT NOT = KFR-PRT OR
              KOB-PRB NOT = KFR-PRG UNLOCK BOLORF GO TO F99.
      **** rel 5.0
      *    IF OBF-FORD NOT = ZERO DELETE BOLORF GO TO F10.
           IF OBF-FORD NOT = ZERO
              MOVE ZERO       TO PARBF
              MOVE 2          TO BF-FUNZ
              MOVE 1          TO BF-FLG
      **** rel 6.1
              IF BFR-UNMIS NOT = ART-UNMIS 
                 MOVE 2     TO BF-FLG
              END-IF
      ************
              MOVE BFT-CDEP   TO BF-DEP
              MOVE BFR-CODART TO BF-ART
              CALL 'vrcbpf' USING KEYOB PARBF
              DELETE BOLORF
      **** rel 7.1
              IF SF-OBF = ZERO
                 MOVE BFT-DTBO TO DTINT
                 MOVE 'C' TO PPAR-TOPE
                 PERFORM CALL-VSRV133-OBF
              END-IF
      ************
              GO TO F10.
      ************
           MOVE OBF-AZI  TO KRF-AZI.
           MOVE OBF-NORD TO KRF-NUM.
           MOVE OBF-RGOR TO KRF-PRG.
           IF SWDEL = 1
              PERFORM G00-STO-ORD THRU G99
           ELSE
      **** rel 6.1
      *       PERFORM H00-AGG-ORD THRU H99
      *       UNLOCK BOLORF.
              PERFORM H00-AGG-ORD THRU H99.
           UNLOCK BOLORF.
      ************
           GO TO F10.
       F99.
           EXIT.
      *------------------
       G00-STO-ORD.
      **** rel 5.0
           MOVE KRF-AZI TO OF-AZI.
           MOVE KRF-NUM TO OF-NUM.
           CALL 'vrvopf' USING PAROF.
           IF OF-FLG = 1 GO TO G98.
      *
      ************
           PERFORM I00-RDLCK THRU I99.
           IF SWERR = 1 GO TO G95.
           COMPUTE RESID = RIF-QUANT - RIF-QARR.
           COMPUTE RIF-QARR = RIF-QARR - OBF-QUANT.
           COMPUTE RESID = RESID + OBF-QUANT.
           IF RESID < ZERO MOVE ZERO TO RESID.
           IF BFR-TPRIG NOT = ZERO
                  IF RESID > ZERO MOVE ZERO TO RIF-SALDO
                                  GO TO G40
                     ELSE GO TO G40.
           IF BFR-UNMIS = ART-UNMIS GO TO G10.
           MOVE RIF-SALDO TO LSALDO.
           COMPUTE RD-NUM = OBF-QUANT / ART-COEFF.
           CALL 'vrround' USING QTA-S PARRD ART-TQUAN.
           MOVE RD-NUM TO LAVQTA.
           COMPUTE RD-NUM = RIF-QUANT / ART-COEFF.
           CALL 'vrround' USING QTA-S PARRD ART-TQUAN.
           MOVE RD-NUM TO LORDIN.
           COMPUTE LRESID = LORDIN - RIF-2QARR.
           IF LRESID < ZERO MOVE 1 TO LSALDO.
           COMPUTE RIF-2QARR = RIF-2QARR - LAVQTA.
           COMPUTE LRESID = LRESID + LAVQTA.
           IF LRESID < ZERO MOVE ZERO TO LRESID.
       G10.
           IF BFR-UNMIS = ART-UNMIS GO TO G20.
           IF LSALDO = ZERO ADD LAVQTA TO ART-IMPFO ARD-DORDA.
           IF LSALDO > ZERO ADD LRESID TO ART-IMPFO ARD-DORDA
                                       MOVE ZERO TO RIF-SALDO.
           GO TO G30.
       G20.
           IF RIF-SALDO = ZERO
              ADD OBF-QUANT TO ART-IMPFO ARD-DORDA.
           IF RIF-SALDO > ZERO
              ADD RESID TO ART-IMPFO ARD-DORDA
              MOVE ZERO TO RIF-SALDO.
       G30.
           REWRITE RF-ART FROM REKART INVALID
                  MOVE 'Errore scrittura articolo' TO F-MES1
                  GO TO G90.
           UNLOCK MAGART.
           REWRITE RF-ARD FROM REKARD INVALID
                  MOVE 'Errore scrittura deposito' TO F-MES1
                  GO TO G90.
           UNLOCK MAGARD.
       G40.
           PERFORM SETTA-TQP-RIF THRU EX-SETTA-TQP-RIF.
           REWRITE RF-RIF FROM REKRIF INVALID
                  MOVE 'Errore scrittura ordine' TO F-MES1
                  GO TO G90.
           UNLOCK ORDRIF.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
           GO TO G98.
       G90.
           UNLOCK MAGART.
           UNLOCK MAGARD.
           UNLOCK ORDRIF.
       G95.
           MOVE 'Ordine non aggiornato' TO F-MES2.
           MOVE 2 TO F-NMES.
       G98.
      **** rel 5.0
           MOVE ZERO       TO PARBF.
           MOVE 2          TO BF-FUNZ.
           MOVE 1          TO BF-FLG.
      **** rel 6.1
           IF BFR-UNMIS NOT = ART-UNMIS 
              MOVE 2     TO BF-FLG.
      ************
           MOVE BFT-CDEP   TO BF-DEP.
           MOVE BFR-CODART TO BF-ART.
           CALL 'vrcbpf' USING KEYOB PARBF.
      *
      ************
           DELETE BOLORF.
      **** rel 7.1
           IF SF-OBF = ZERO
              MOVE BFT-DTBO TO DTINT
              MOVE 'C' TO PPAR-TOPE
              PERFORM CALL-VSRV133-OBF.
      ************
       G99.
           EXIT.
      *------------------
       H00-AGG-ORD.
      **** rel 5.0
           MOVE KRF-AZI TO OF-AZI.
           MOVE KRF-NUM TO OF-NUM.
           CALL 'vrvopf' USING PAROF.
           IF OF-FLG = 1 GO TO H99.
      ************
           PERFORM I00-RDLCK THRU I99.
           IF SWERR = 1 GO TO H95.
           IF RA-BFR-SAL0(KOB-PRG) = 1 MOVE 1 TO RIF-SALDO.
           COMPUTE RESID = RIF-QUANT - RIF-QARR.
           IF RESID < ZERO MOVE ZERO TO RESID.
           MOVE OBF-QUANT TO QUAN.
           IF BFR-TPRIG NOT = ZERO GO TO H20.
           IF BFR-UNMIS = ART-UNMIS GO TO H10.
           MOVE OBF-QUANT TO SAVQTA.
           MOVE RIF-SALDO TO LSALDO.
           COMPUTE RD-NUM = QUAN / ART-COEFF.
           CALL 'vrround' USING QTA-S PARRD ART-TQUAN.
           MOVE RD-NUM TO QUAN.
           COMPUTE RD-NUM = OBF-QUANT / ART-COEFF.
           CALL 'vrround' USING QTA-S PARRD ART-TQUAN.
           MOVE RD-NUM TO OBF-QUANT.
           COMPUTE RD-NUM = RIF-QUANT / ART-COEFF.
           CALL 'vrround' USING QTA-S PARRD ART-TQUAN.
           MOVE RD-NUM TO LQUANT.
           COMPUTE RESID = LQUANT - RIF-2QARR.
           IF RESID NOT > ZERO MOVE ZERO TO RESID QUAN
                               MOVE 1 TO LSALDO.
           COMPUTE LRESID = RESID - OBF-QUANT.
           IF LRESID NOT > ZERO MOVE 1 TO LSALDO.
       H10.
           IF RIF-UNMIS = ART-UNMIS
              IF RIF-SALDO > ZERO MOVE RESID TO QUAN.
           IF RIF-UNMIS NOT = ART-UNMIS
              IF LSALDO > ZERO MOVE RESID TO QUAN.
           SUBTRACT QUAN FROM ART-IMPFO ARD-DORDA.
           IF BFR-UNMIS NOT = ART-UNMIS MOVE SAVQTA TO OBF-QUANT.
       H20.
           COMPUTE RIF-QARR = RIF-QARR + OBF-QUANT.
           IF BFR-TPRIG NOT = ZERO GO TO H30.
           IF BFR-UNMIS NOT = ART-UNMIS
              COMPUTE RD-NUM = OBF-QUANT / ART-COEFF
              CALL 'vrround' USING QTA-S PARRD ART-TQUAN
              MOVE RD-NUM TO OBF-QUANT
              COMPUTE RIF-2QARR = RIF-2QARR + OBF-QUANT.
           REWRITE RF-ART FROM REKART INVALID
                  MOVE 'Errore scrittura articolo' TO F-MES1
                  GO TO H90.
           UNLOCK MAGART.
           REWRITE RF-ARD FROM REKARD INVALID
                  MOVE 'Errore scrittura deposito' TO F-MES1
                  GO TO H90.
           UNLOCK MAGARD.
       H30.
           PERFORM SETTA-TQP-RIF THRU EX-SETTA-TQP-RIF.
           REWRITE RF-RIF FROM REKRIF INVALID
                  MOVE 'Errore scrittura ordine' TO F-MES1
                  GO TO H90.
           UNLOCK ORDRIF.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
           GO TO H99.
       H90.
           UNLOCK MAGART.
           UNLOCK MAGARD.
           UNLOCK ORDRIF.
       H95.
           MOVE 'Ordine non aggiornato' TO F-MES2.
           MOVE 2 TO F-NMES.
      **** rel 5.0
           MOVE ZERO       TO PARBF.
           MOVE 2          TO BF-FUNZ.
           MOVE 1          TO BF-FLG.
      **** rel 6.1
           IF BFR-UNMIS NOT = ART-UNMIS 
              MOVE 2     TO BF-FLG.
      ************
           MOVE BFT-CDEP   TO BF-DEP.
           MOVE BFR-CODART TO BF-ART.
           CALL 'vrcbpf' USING KEYOB PARBF.
      ************
           DELETE BOLORF.
      **** rel 7.1
           IF SF-OBF = ZERO
              MOVE BFT-DTBO TO DTINT
              MOVE 'C' TO PPAR-TOPE
              PERFORM CALL-VSRV133-OBF.
      ************
       H99.
           EXIT.
      *------------------
       I00-RDLCK.
           MOVE ZERO TO SWERR.
           READ ORDRIF INTO REKRIF KEPT LOCK INVALID KEY
                MOVE 'Manca rigo ordine' TO F-MES1
                GO TO I90.
           IF SF-RIF > ZERO PERFORM REC-LOCK
                            GO TO I00-RDLCK.
      **** rel 5.0
       I05.
           MOVE KRF-AZI TO KOF-AZI.
           MOVE KRF-NUM TO KOF-NUM.
           READ ORDFOR INTO REKORF INVALID KEY
                MOVE 'Manca ordine' TO F-MES1
                GO TO I90.
           IF SF-ORF > ZERO PERFORM REC-LOCK
                            GO TO I05.
      ************
           IF BFR-TPRIG NOT = ZERO GO TO I99.
       I10.
           MOVE KFR-AZI    TO KMA-AZI KAD-AZI.
           MOVE BFR-CODART TO KMA-ART KAD-ART.
      **** rel 5.0
      *    MOVE BFT-CDEP   TO KAD-DEP.
           MOVE ORF-CDDEP   TO KAD-DEP.
      ************
           READ MAGART INTO REKART KEPT LOCK INVALID KEY
                        MOVE 'Manca articolo' TO F-MES1
                        GO TO I90.
           IF SF-ART > ZERO PERFORM REC-LOCK
                            GO TO I10.
       I20.
           READ MAGARD INTO REKARD KEPT LOCK INVALID KEY
                MOVE 'Manca articolo deposito' TO F-MES1
                GO TO I90.
           IF SF-ARD > ZERO PERFORM REC-LOCK
                            GO TO I20.
           GO TO I99.
       I90.
           MOVE 1 TO SWERR.
           UNLOCK MAGART.
           UNLOCK MAGARD.
           UNLOCK ORDRIF.
       I99.
           EXIT.
      *------------------
       L00-LISTINO.
      **** rel 6.3
      *    OPEN INPUT LISACQ.
      *    MOVE RG-BFR-AZI    TO KLAQ-AZI.
      *    MOVE RG-BFR-CODART TO KLAQ-ART.
      *    MOVE BFT-FOR       TO KLAQ-FOR.
      *    READ LISACQ INVALID KEY GO TO L900.
      *    IF BFT-DTBO NOT < LAQ-DTDOC(4) AND
      *       LAQ-DTDOC(4) > LAQ-DTDOC(1) AND
      *       LAQ-PRZ(4) NOT = ZERO
      **** rel 4.0
      **          MOVE LAQ-PRZ(4) TO RG-BFR-PZLOR
      *           MOVE RG-BFR-FSC TO DP-FSC
      *           MOVE LAQ-PRZ(4) TO DP-PREZZO
      *           CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
      *           MOVE DP-PREZZO  TO RG-BFR-PZLOR
      ************
      *           MOVE LAQ-SC1(4) TO RG-BFR-SCON1
      *           MOVE LAQ-SC2(4) TO RG-BFR-SCON2
      *           GO TO L900.
      *    IF LAQ-PRZ(1) NOT = ZERO
      **** rel 4.0
      **      MOVE LAQ-PRZ(1) TO RG-BFR-PZLOR
      *       MOVE RG-BFR-FSC TO DP-FSC
      *       MOVE LAQ-PRZ(1) TO DP-PREZZO
      *       CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
      *       MOVE DP-PREZZO  TO RG-BFR-PZLOR
      ************
      *       MOVE LAQ-SC1(1) TO RG-BFR-SCON1
      *       MOVE LAQ-SC2(1) TO RG-BFR-SCON2.
      *L900.
      *    CLOSE LISACQ.
           INITIALIZE PARAC.
           MOVE RG-BFR-AZI    TO AC-AZI.
           MOVE RG-BFR-CODART TO AC-ART.
           MOVE BFT-FOR       TO AC-FOR.
           MOVE BFT-DTBO      TO AC-DTDOC.
           MOVE 'R'           TO AC-FUN.
           CALL 'vrlsacq' USING PARAC.
           IF ERRIO-ST > ZERO GO TO ERRIO.
           CANCEL 'vrlsacq'.
           IF AC-PRZ NOT = ZERO
              MOVE RG-BFR-FSC TO DP-FSC
              MOVE AC-PRZ TO DP-PREZZO
              CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
              MOVE DP-PREZZO TO RG-BFR-PZLOR
              MOVE AC-SC1 TO RG-BFR-SCON1
              MOVE AC-SC2 TO RG-BFR-SCON2.
      ************
       L999.
           EXIT.
      *------------------
       G00-AGGLAQ.
           IF BFR-TPRIG NOT = ZERO GO TO G999.
      **** rel 6.3
           INITIALIZE PARAC.
      ************
           MOVE KFR-AZI    TO AC-AZI.
           MOVE BFR-CODART TO AC-ART.
           MOVE BFT-FOR    TO AC-FOR.
           MOVE 'B'        TO AC-ORIG.
           MOVE KFR-PRT    TO AC-NDOC.
           MOVE BFT-DTBO   TO AC-DTDOC.
           MOVE BFR-QUANT  TO AC-QTA.
           MOVE BFR-PZLOR  TO AC-PRZ.
           MOVE BFR-SCON1  TO AC-SC1.
           MOVE BFR-SCON2  TO AC-SC2.
           MOVE ZERO       TO AC-ST.
           CALL 'vrlsacq' USING PARAC.
      **** rel 6.3
           IF ERRIO-ST > ZERO GO TO ERRIO.
      ************
           CANCEL 'vrlsacq'.
       G999.
           EXIT.
      *------------------
       Z00-CTR-VET.
           MOVE ZERO TO SWVET K.
       Z10.
           ADD 1 TO K.
           IF K > 6 GO TO Z99.
           IF K = K1 GO TO Z10.
           IF RA-BFR-PRG0(K) = ZERO GO TO Z10.
           IF ( RA-BFR-NOR0(K) = RA-BFR-NOR0(K1) ) AND
              ( RA-BFR-PRG0(K) = RA-BFR-PRG0(K1) )
              MOVE 'Rigo gia'' trattato' TO MESS
              MOVE 1 TO SWVET
              GO TO Z99.
           GO TO Z10.
       Z99.
           EXIT.
      *------------------
       V00-CAL-RES.
           MOVE RG-BFR-AZI TO KOB-AZI.
           MOVE RG-BFR-PRT TO KOB-PRT.
           MOVE RG-BFR-PRG TO KOB-PRB.
           MOVE ZERO       TO KOB-PRG.
           START BOLORF KEY NOT < KEYOB INVALID GO TO V90.
       V10.
           READ BOLORF NEXT KEPT LOCK AT END GO TO V90.
           IF SF-OBF > ZERO PERFORM REC-LOCK
                            GO TO V10.
           IF KOB-AZI NOT = RG-BFR-AZI OR
              KOB-PRT NOT = RG-BFR-PRT OR
              KOB-PRB NOT = RG-BFR-PRG UNLOCK BOLORF GO TO V90.
           IF OBF-NORD NOT = RA-BFR-NOR0(K1) OR
              OBF-RGOR NOT = RA-BFR-PRG0(K1) GO TO V10.
           ADD OBF-QUANT TO RESID.
           GO TO V10.
       V90.
      **** rel 6.1
           UNLOCK BOLORF.
      ************
           IF RESID < ZERO MOVE ZERO TO RESID.
       V99.
           EXIT.
      *------------------
      * evasione automatica righi ordine
       R-RDR00.
           MOVE RG-BFR-PRG TO COMPRG.
           OPEN I-O WDSLAV.
           MOVE ZERO TO KEYLV.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO F-RDRIG.
       R-RDR10.
           READ WDSLAV NEXT AT END GO TO F-RDRIG.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO R-RDR10.
           PERFORM AZZ-REC   THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
      **** rel 1.2
           MOVE RG-BFR-AZI TO KOF-AZI.
           MOVE KLV-NORD   TO KOF-NUM.
           READ ORDFOR INTO REKORF INVALID PERFORM INVK-ORF
                                           GO TO WARNING.
           IF SF-ORF = '9D' OR '9A' OR '35' MOVE RF-ORF TO REKORF.
      ************
           MOVE RG-BFR-AZI TO  KRF-AZI.
           MOVE KLV-NORD   TO  KRF-NUM RA-BFR-NOR0(1).
           MOVE KLV-PRG    TO  KRF-PRG RA-BFR-PRG0(1).
           READ ORDRIF INTO REKRIF INVALID PERFORM INVK-RIF
                                           GO TO WARNING.
           IF SF-RIF = '9D' OR '9A' OR '35' MOVE RF-RIF TO REKRIF.
           IF RIF-TPRIG = 1 GO TO R-RDR10.
           IF RIF-TPRIG NOT = 3
              IF RIF-SALDO NOT = ZERO GO TO R-RDR10.
      **** rel 1.2
      *    ADD 5 TO COMPRG.
      ************
           MOVE COMPRG TO RG-BFR-PRG.
           MOVE RIF-TPRIG TO RG-BFR-TPRIG.
           IF RIF-TPRIG = 3 GO TO R-RDR40.
           MOVE 1 TO K2.
           IF RIF-TPRIG = 2 MOVE RIF-DESAR TO RG-BFR-DESCR
                            PERFORM L20 THRU L99
                            GO TO R-RDR20.
           MOVE RIF-ARTIC TO RG-BFR-CODART.
           PERFORM L00-RD-ART THRU L99.
      **** rel 1.2
      *    IF RG-BFR-CODART = ZERO SUBTRACT 5 FROM RG-BFR-PRG
      *                            GO TO R-RDR10.
           IF RG-BFR-CODART = ZERO GO TO R-RDR10.
      ************
       R-RDR20.
      **** rel 4.0
      *    MOVE RIF-PREZZ TO RG-BFR-PZLOR
           MOVE RG-BFR-FSC TO DP-FSC.
           MOVE RIF-PREZZ  TO DP-PREZZO.
           CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC.
           MOVE DP-PREZZO  TO RG-BFR-PZLOR.
      ************
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM C00-CAL-IMP THRU C99.
      **** rel 5.0
              MOVE KRF-AZI TO OF-AZI.
              MOVE RA-BFR-NOR0(1) TO OF-NUM.
              CALL 'vrvopf' USING PAROF.
              IF NOT OF-FLG = 1 
                 PERFORM CALCOLA-MEDIE THRU EX-CALCOLA-MEDIE.
      ************
       R-RDR30.
           WRITE RF-BFR INVALID KEY PERFORM INVK-BFR
                                    GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BFR.
      *
           PERFORM CALL-VSRV133-MMG.
      ************
           PERFORM TRAVAS-NOTE THRU EX-TRAVAS-NOTE.
           MOVE ZERO TO RG-BFR-TPRIG.
      **** rel 1.2
           ADD 5 TO COMPRG.
      ************
           GO TO R-RDR10.
       R-RDR40.
           MOVE RIF-CDSPE TO RG-BFR-CDSPE.
           MOVE 11           TO KTB-TIP.
           MOVE RG-BFR-CDSPE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ALL '*' TO TAB-DESCR
                                           MOVE ZERO TO T11-CONTR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RG-BFR-DESCR.
           MOVE RIF-PREZZ TO RG-BFR-PZLOR RG-BFR-NETRG.
      **** rel 4.0
      *    MOVE RIF-TPRZ  TO RG-BFR-TPREZ.
           MOVE RIF-FSC   TO RG-BFR-FSC.
      ************
           MOVE ZERO      TO RG-BFR-QUANT.
           MOVE RIF-AZI   TO KPC-AZI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           GO TO R-RDR30.
       F-RDRIG.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
       R-RDR99.
           EXIT.
      *------------------
      * evasione automatica righi ordine con raggruppamento x articolo
       B00-ART.
           OPEN I-O WDSLAV.
       B-RDR00.
           MOVE ZERO TO K2.
           MOVE ZERO TO KEYLV.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO B99-ART.
       B-RDR10.
           READ WDSLAV NEXT AT END GO TO B99-ART.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO B-RDR10.
           ADD 1 TO K2.
           IF K2 > 6 GO TO B99-ART.
           MOVE RG-BFR-AZI TO KOF-AZI.
           MOVE KLV-NORD   TO KOF-NUM RA-BFR-NOR0(K2).
           READ ORDFOR INTO REKORF INVALID MOVE 1 TO SWORD
                                           GO TO B-RDR30.
           IF SF-ORF = '9D' OR '9A' OR '35' MOVE RF-ORF TO REKORF.
           IF ORF-CDCLI NOT = BFT-FOR   OR
              ORF-VALUT NOT = BFT-VALUT OR
              ORF-CDDEP NOT = BFT-CDEP  OR
              ORF-CATT  NOT = BFT-CATT  MOVE 1 TO SWORD.
       B-RDR30.
           MOVE RG-BFR-AZI TO  KRF-AZI.
           MOVE KLV-NORD   TO  KRF-NUM.
           MOVE KLV-PRG    TO  KRF-PRG RA-BFR-PRG0(K2).
           READ ORDRIF INTO REKRIF INVALID SUBTRACT 1 FROM K2
                                           GO TO B-RDR10.
           IF SF-RIF = '9D' OR '9A' OR '35' MOVE RF-RIF TO REKRIF.
           IF RIF-TPRIG NOT = ZERO SUBTRACT 1 FROM K2
                                   GO TO B-RDR10.
           MOVE RIF-TPRIG TO RG-BFR-TPRIG.
           IF K2 = 1 AND RIF-ARTIC NOT = RG-BFR-CODART
              SUBTRACT 1 FROM K2
              GO TO B-RDR10.
           IF RIF-SALDO NOT = ZERO SUBTRACT 1 FROM K2
                                   GO TO B-RDR10.
           IF K2 = 1
              PERFORM L00-RD-ART THRU L99
              IF RG-BFR-CODART = ZERO
                 SUBTRACT 1 FROM K2
                 GO TO B-RDR10
              ELSE
                 IF RG-BFR-UNMIS = ART-UNMIS
                    MOVE 1 TO RA-BFR-TPUM
                 ELSE
                    IF RG-BFR-UNMIS = ART-2UNMIS
                       MOVE 2 TO RA-BFR-TPUM
                    ELSE
                       MOVE 1 TO SWORD
                    END-IF
                 END-IF
                 GO TO B-RDR10.
           IF RIF-TPRIG NOT = RG-BFR-TPRIG  OR
              RIF-ARTIC NOT = RG-BFR-CODART OR
              RIF-UNMIS NOT = RG-BFR-UNMIS  OR
              RIF-TQUAN NOT = RG-BFR-TQUAN  OR
      **** rel 4.0
      *       RIF-TPRZ  NOT = RG-BFR-TPREZ  OR
              RIF-FSC   NOT = RG-BFR-FSC    OR
      ************
              RIF-PREZZ NOT = RG-BFR-PZLOR  OR
              RIF-1SCON NOT = RG-BFR-SCON1  OR
              RIF-2SCON NOT = RG-BFR-SCON2  MOVE 1 TO SWORD.
           IF RIF-CONTR = ZERO
              MOVE ORF-CONTR TO CPART
           ELSE
              MOVE RIF-CONTR TO CPART.
           IF CPART NOT = RG-BFR-CPART MOVE 1 TO SWORD.
           COMPUTE RA-BFR-RES0(K2) = RIF-QUANT - RIF-QARR.
                             MOVE RA-BFR-RES0(K2) TO RA-BFR-CON0(K2).
           ADD RA-BFR-RES0(K2) TO RG-BFR-QUANT.
           MOVE 1 TO RA-BFR-SAL0(K2).
           DELETE WDSLAV.
           GO TO B-RDR10.
       B99-ART.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           IF SWORD NOT = ZERO MOVE 'Attenzione anomalie' TO MESS
                               MOVE 8 TO ERRIO-ST.
       EX-B00-ART.
           EXIT.
      *------------------
       L00-RD-ART.
           MOVE RG-BFR-CODART TO KMA-ART.
           MOVE RG-BFR-AZI    TO KMA-AZI.
           READ MAGART INTO REKART INVALID KEY
                MOVE SPACE TO RG-BFR-DESCR
                MOVE ZERO  TO RG-BFR-CODART
                GO TO L99.
           IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
           MOVE ART-DESCR TO RG-BFR-DESCR.
           MOVE KMA-ART    TO KAD-ART.
           MOVE RG-BFR-AZI TO KAD-AZI.
           MOVE BFT-CDEP   TO KAD-DEP.
           PERFORM TESTARD THRU EX-TESTARD.
           IF TARD > ZERO MOVE ZERO TO RG-BFR-CODART GO TO L99.
       L20.
           MOVE RIF-UNMIS TO RG-BFR-UNMIS.
           MOVE RIF-CDIVA TO RG-BFR-CDIVA.
           MOVE RIF-TQUAN TO RG-BFR-TQUAN.
      **** rel 4.0
      *    MOVE RIF-TPRZ  TO RG-BFR-TPREZ.
      *    MOVE RIF-PREZZ TO RG-BFR-PZLOR.
      *    MOVE RIF-TPRZ  TO RG-BFR-TPREZ.
           MOVE RIF-FSC   TO RG-BFR-FSC.
           MOVE RG-BFR-FSC TO DP-FSC.
           MOVE RIF-PREZZ  TO DP-PREZZO.
           CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC.
           MOVE DP-PREZZO  TO RG-BFR-PZLOR.
      ************
           MOVE RIF-1SCON TO RG-BFR-SCON1.
           MOVE RIF-2SCON TO RG-BFR-SCON2.
      **** rel 6.3
           MOVE RIF-NOMC  TO RG-BFR-NOMC.
      ************
           IF RIF-CONTR = ZERO
              MOVE ORF-CONTR TO RG-BFR-CPART
           ELSE
              MOVE RIF-CONTR TO RG-BFR-CPART.
           COMPUTE RESID = RIF-QUANT - RIF-QARR.
           MOVE RESID TO RA-BFR-RES0(K2) RA-BFR-CON0(K2) RG-BFR-QUANT.
           MOVE 1 TO RA-BFR-SAL0(K2).
       L99.
           EXIT.
      *------------------
       TESTARD.
           MOVE KEYAD TO ARD-KEYID.
           READ MAGARD INTO REKARD INVALID MOVE 1 TO TARD
                                           GO TO EX-TESTARD.
           IF SF-ARD = '9D' OR '9A' OR '35' MOVE RF-ARD TO REKARD.
           MOVE ZERO TO TARD.
       EX-TESTARD.
           EXIT.
      *------------------
       CAR-PARMAG.
           MOVE ZERO  TO PARMAG.
           MOVE SPACE TO M-TIPO
                         M-ART
                         M-UNM
                         M-NBOF.
           MOVE 'A'       TO M-TIPO.
           MOVE BFT-FOR   TO CFOR.
           MOVE CDFOR     TO M-CLFO.
           MOVE KBF-AZI   TO M-AZI.
           MOVE 1         TO M-TDOC.
           MOVE BFT-CDEP  TO M-DEP1.
           MOVE BFT-DTCO  TO M-NDAT.
           MOVE BFT-DTCO  TO M-ODAT.
           MOVE BFT-CAUS  TO M-NCA1.
           MOVE BFT-VALUT TO M-NVAL.
           MOVE BFT-CAMGG TO M-NCAM.
           MOVE BFT-CPAG  TO M-NPAG.
           MOVE BFT-NBOF  TO M-NBOF.
       EX-CAR-PARMAG.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w9' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       REC-LOCK.
      **** rel 1.2
           CALL 'rlock' USING PARLK.
      ************
           EXIT.
      *------------------
      * setta BFR-TQUAN e BFR-TPREZ per righi occasionali BOLLA
       SETTA-TQP-BFR.
           IF BFR-TPRIG NOT = 2
              GO TO EX-SETTA-TQP-BFR.
      *
           MOVE BFR-QUANT TO RD-NUM.
           CALL 'vrround' USING QTA-SET PARRD RD-TIPO.
           MOVE RD-TIPO TO BFR-TQUAN.
      *
           MOVE BFR-QUAFA TO RD-NUM.
           CALL 'vrround' USING QTA-SET PARRD RD-TIPO.
           IF RD-TIPO > BFR-TQUAN
              MOVE RD-TIPO TO BFR-TQUAN.
      *
      **** rel 4.0
      *    MOVE BFR-PZLOR TO RD-NUM.
      *    CALL 'vrround' USING PRZ-SET PARRD RD-TIPO.
      *    MOVE RD-TIPO TO BFR-TPREZ.
      *
      *    MOVE BFR-PZNET TO RD-NUM.
      *    CALL 'vrround' USING PRZ-SET PARRD RD-TIPO.
      *    IF RD-TIPO > BFR-TPREZ
      *       MOVE RD-TIPO TO BFR-TPREZ.
      *
      *    MOVE BFR-VALFA TO RD-NUM.
      *    CALL 'vrround' USING PRZ-SET PARRD RD-TIPO.
      *    IF RD-TIPO > BFR-TPREZ
      *       MOVE RD-TIPO TO BFR-TPREZ.
      *
      *    IF BFT-VALUT > 1 MOVE 1 TO BFR-TPREZ.
      ************
       EX-SETTA-TQP-BFR.
           EXIT.
      *------------------*
      * setta RIF-TQUAN e RIF-TPRZ per righi occasionali ORDINE
       SETTA-TQP-RIF.
           IF RIF-TPRIG NOT = 2 GO TO EX-SETTA-TQP-RIF.
      *
           MOVE RIF-QUANT TO RD-NUM.
           CALL 'vrround' USING QTA-SET PARRD RD-TIPO.
           MOVE RD-TIPO TO RIF-TQUAN.
      *
           MOVE RIF-QARR TO RD-NUM.
           CALL 'vrround' USING QTA-SET PARRD RD-TIPO.
           IF RD-TIPO > RIF-TQUAN
              MOVE RD-TIPO TO RIF-TQUAN.
      *
      **** rel 4.0
      *    MOVE RIF-PREZZ TO RD-NUM.
      *    CALL 'vrround' USING PRZ-SET PARRD RD-TIPO.
      *    MOVE RD-TIPO TO RIF-TPRZ.
      *
      *    IF ORF-VALUT > 1 MOVE 1 TO RIF-TPRZ.
      ************
       EX-SETTA-TQP-RIF.
           EXIT.
      *------------------
      **** rel 4.0
       AGGIORNA-FSC-D.
           MOVE SPACE TO RA-BFR-FSC-D.
           IF RG-BFR-FSC = 1 MOVE 'x10'   TO RA-BFR-FSC-D.
           IF RG-BFR-FSC = 2 MOVE 'x100'  TO RA-BFR-FSC-D.
           IF RG-BFR-FSC = 3 MOVE 'x1000' TO RA-BFR-FSC-D.
      *------------------
       LISTINO-BASE-LIRE.
           MOVE RG-BFR-AZI    TO BL-AZI.
           MOVE RG-BFR-CODART TO BL-ART.
           MOVE RG-BFR-FSC    TO BL-FSC.
           CALL 'rlisbasl' USING PARBL.
           MOVE BL-PREZZO  TO RG-BFR-PZLOR.
       LL99.
           EXIT.
      ************
      **** rel 5.0
      *------------------
       CALCOLA-MEDIE.
           MOVE ZERO TO PERG PERQ MEDIAG MEDIAQ.
           MOVE ZERO TO J. 
           MOVE 1    TO K. 
       CICLO.
           PERFORM UNTIL K > 6   
              IF RA-BFR-NOR0(K) NOT= ZERO
                IF RA-BFR-PRG0(K) NOT= ZERO 
                  PERFORM CERCA-ORD THRU EX-CERCA-ORD
                  COMPUTE PERQ = ( 100 * ( RA-BFR-CON0(K) - ORD ) ) /ORD
                  ADD PERQ TO MEDIAQ
                  COMPUTE PERG = BFT-DTCO - DAT
                  ADD PERG TO MEDIAG
                  MOVE 1 TO BFR-FLGORD
                  ADD 1 TO J
                END-IF
              END-IF
              ADD 1 TO K.
      *
           IF J = ZERO MOVE ZERO TO MEDIAQ MEDIAG BFR-FLGORD.
           COMPUTE RD-NUM = MEDIAQ / J. 
           CALL 'vrround' USING NNN-M PARRD DEC-2.
           MOVE RD-NUM TO MEDIAQ.
      *
           COMPUTE RD-NUM = MEDIAG / J.
           CALL 'vrround' USING NNN-M PARRD DEC-2.
           MOVE RD-NUM TO MEDIAG.
      *
           MOVE MEDIAG TO BFR-MGIOR.
           MOVE MEDIAQ TO BFR-MQTA.
      *
       EX-CALCOLA-MEDIE.
           EXIT.
      *************************************
       CERCA-ORD.
           MOVE RA-BFR-NOR0(K) TO KRF-NUM.
           MOVE RA-BFR-PRG0(K) TO KRF-PRG.
           PERFORM D10 THRU D19.
           MOVE RIF-DTCSC TO DAT.
           MOVE RIF-QUANT TO ORD.
       EX-CERCA-ORD.
      ************
      **** rel 5.1
           EXIT.
      *------------------
       LEGGI-T11.
           MOVE 11           TO KTB-TIP.
           MOVE RG-BFR-CDSPE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE 1 TO T11-TACC.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T11-TACC = 2 AND RG-BFR-PZLOR > ZERO
              MULTIPLY -1 BY RG-BFR-PZLOR.
       EX-LEGGI-T11.
           EXIT.
      *------------------
      ************
      **** rel 6.2
      * fase di scrittura note aggiuntive rigo bolla fornitore
       DL-WR-NOTE.
           PERFORM DL-NOTE THRU EX-DL-NOTE.
      *
       WR-NOTE.
      **** rel 6.3
           IF RA-BFR-NOTE = SPACE AND RG-BFR-TPRIG = 1
      **** rel 7.2
           AND RG-BFR-FUN NOT = 'A'
      ************
              MOVE KFR-AZI TO KNFR-AZI
              MOVE KFR-PRT TO KNFR-PRT
              MOVE KFR-PRG TO KNFR-PGR
              MOVE 1       TO KNFR-PGRN
              MOVE SPACE   TO NFR-DESCR
              WRITE RF-NFR INVALID PERFORM INVK-NFR
                                   GO TO ERRIO
              END-WRITE
              GO TO EX-DL-WR-NOTE.
      ************
           IF RA-BFR-NOTE = SPACE GO TO EX-DL-WR-NOTE.
      *
           MOVE NRIGMAXL TO KVALID.
           PERFORM UNTIL RA-BFR-RIGNOT(KVALID) NOT = SPACE
              SUBTRACT 1 FROM KVALID
           END-PERFORM.
      *
           MOVE KFR-AZI TO KNFR-AZI.
           MOVE KFR-PRT TO KNFR-PRT.
           MOVE KFR-PRG TO KNFR-PGR.
           MOVE ZERO    TO KNFR-PGRN.
      *
           MOVE 1 TO KML.
           PERFORM UNTIL KML > KVALID
              ADD 1 TO KNFR-PGRN
              MOVE RA-BFR-RIGNOT(KML) TO NFR-DESCR
              WRITE RF-NFR INVALID PERFORM INVK-NFR
                                   GO TO ERRIO
              END-WRITE
              ADD 1 TO KML
           END-PERFORM.
      *
           PERFORM CONTA-NBYTE-BFR-NOTE.
      * conversione per visualizzazione automatica nel caso di conferma
      * dopo una variazione
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4       TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL RA-BFR-NOTE.
       EX-DL-WR-NOTE.
           EXIT.
      *------------------
      * cancellazione note aggiuntive rigo bolla fornitore
       DL-NOTE.
           MOVE KFR-AZI TO KNFR-AZI.
           MOVE KFR-PRT TO KNFR-PRT.
           MOVE KFR-PRG TO KNFR-PGR.
           MOVE ZERO    TO KNFR-PGRN.
      *
           START NOTBFR KEY >= KEYNFR INVALID GO TO EX-DL-NOTE.
       DL-NOTE-10.
           READ NOTBFR NEXT AT END GO TO EX-DL-NOTE.
           IF KNFR-AZI > KFR-AZI GO TO EX-DL-NOTE.
           IF KNFR-PRT > KFR-PRT GO TO EX-DL-NOTE.
           IF KNFR-PGR > KFR-PRG GO TO EX-DL-NOTE.
           DELETE NOTBFR INVALID PERFORM INVK-NFR
                                 GO TO V-ERROR.
           GO TO DL-NOTE-10.
       EX-DL-NOTE.
           EXIT.
      *------------------
      * fase di lettura note aggiuntive rigo bolla fornitore
      * caricamento aree interfaccia
       RD-NFR.
           PERFORM AZZ-NOTE.
      *
           MOVE ZERO TO RA-BFR-FLGNOTE.
           MOVE ZERO TO KN.
      *
           MOVE KFR-AZI TO KNFR-AZI.
           MOVE KFR-PRT TO KNFR-PRT.
           MOVE KFR-PRG TO KNFR-PGR.
           MOVE ZERO    TO KNFR-PGRN.
           START NOTBFR KEY >= KEYNFR INVALID GO TO RD-NFR-20.
       RD-NFR-10.
           READ NOTBFR NEXT AT END GO TO RD-NFR-20.
           IF KNFR-AZI > KFR-AZI GO TO RD-NFR-20.
           IF KNFR-PRT > KFR-PRT GO TO RD-NFR-20.
           IF KNFR-PGR > KFR-PRG GO TO RD-NFR-20.
           ADD 1 TO KN.
           IF KN <= NRIGMAXL
              MOVE NFR-DESCR TO RA-BFR-RIGNOT(KN)
              MOVE 1 TO RA-BFR-FLGNOTE
           GO TO RD-NFR-10.
       RD-NFR-20.
      *
           PERFORM CONTA-NBYTE-BFR-NOTE.
      *
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4       TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL RA-BFR-NOTE.
      *
       EX-RD-NFR.
           EXIT.
      *------------------
       AZZ-NOTE.
           MOVE 1 TO KML.
           PERFORM UNTIL KML > NRIGMAX
              MOVE SPACE TO RA-BFR-RIGNOT(KML)
              ADD 1 TO KML
           END-PERFORM.
      *
           MOVE ZERO TO RA-BFR-NBYTE
                        RA-BFR-FLGNOTE.
      *------------------
      * conta nbyte note aggiuntive
       CONTA-NBYTE-BFR-NOTE.
           MOVE ZERO TO RA-BFR-NBYTE.
           IF RA-BFR-NOTE NOT = SPACE
              MOVE NRIGMAXL TO KVALID
              PERFORM UNTIL RA-BFR-RIGNOT(KVALID) NOT = SPACE
                 SUBTRACT 1 FROM KVALID
              END-PERFORM
              COMPUTE RA-BFR-NBYTE = KVALID * NCOLMAX.
      *------------------
      * importazione testi esterni *
       F-LEG-TESTO.
           IF RA-BFR-NTESTO = ZERO GO TO END-F-LEG-TESTO.
           MOVE RG-BFR-AZI    TO KARN-AZI.
           MOVE RA-BFR-NTESTO TO KARN-NUM.
           MOVE ZERO          TO KARN-PGR.
      *
           MOVE 1 TO KML.
           PERFORM UNTIL KML > NRIGMAXL
              MOVE SPACE TO RA-BFR-RIGNOT(KML)
              ADD 1 TO KML
           END-PERFORM.
      *
           MOVE ZERO TO KN.
           START ARCNOT KEY >=  KEYARN INVALID GO TO F-LEG-TESTO-90.
       F-LEG-TESTO-10.
           READ ARCNOT NEXT AT END GO TO F-LEG-TESTO-90.
           IF KARN-AZI NOT = RG-BFR-AZI GO TO F-LEG-TESTO-90.
           IF KARN-NUM NOT = RA-BFR-NTESTO GO TO F-LEG-TESTO-90.

           ADD 1 TO KN.
           IF KN > NRIGMAXL GO TO F-LEG-TESTO-90.
           MOVE ARN-NOTE TO RA-BFR-RIGNOT(KN).
           GO TO F-LEG-TESTO-10.

           READ ARCNOT NEXT AT END GO TO F-LEG-TESTO-90.
           IF KARN-AZI NOT = RG-BFR-AZI GO TO F-LEG-TESTO-90.
           IF KARN-NUM NOT = RA-BFR-NTESTO GO TO F-LEG-TESTO-90.

           ADD 1 TO KN.
           IF KN > NRIGMAXL GO TO F-LEG-TESTO-90.
           MOVE ARN-NOTE TO RA-BFR-RIGNOT(KN).
           GO TO F-LEG-TESTO-10.
       F-LEG-TESTO-90.
           IF KN = ZERO GO TO END-F-LEG-TESTO.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4       TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL RA-BFR-NOTE.
       END-F-LEG-TESTO.
           EXIT.
      *-------------*
      ************
      **** rel 6.2
       TRAVAS-NOTE.
           PERFORM DL-NOTE THRU EX-DL-NOTE.
           MOVE SPACE TO COM-IN.
      *
           MOVE KFR-AZI TO KNFR-AZI.
           MOVE KFR-PRT TO KNFR-PRT.
           MOVE KFR-PRG TO KNFR-PGR.
           MOVE ZERO    TO KNFR-PGRN.
      *
           MOVE KRF-AZI TO KNRF-AZI.
           MOVE KRF-NUM TO KNRF-NUM.
           MOVE KRF-PRG TO KNRF-PRG.
           MOVE ZERO    TO KNRF-PRGN.
      *
           START NOTRIF KEY >= KEYNRF INVALID GO TO END-TRAVAS-NOTE.
       RD-NOTE-RIF.
           READ NOTRIF NEXT AT END GO TO END-TRAVAS-NOTE.
           IF KNRF-AZI > KRF-AZI GO TO END-TRAVAS-NOTE.
           IF KNRF-NUM > KRF-NUM GO TO END-TRAVAS-NOTE.
           IF KNRF-PRG > KRF-PRG GO TO END-TRAVAS-NOTE.
      *
           ADD 1 TO KNFR-PGRN.
           MOVE NRF-DESCR TO COM-RIN(KNFR-PGRN).
           GO TO RD-NOTE-RIF.
      *
       END-TRAVAS-NOTE.
           IF COM-IN = SPACE GO TO EX-TRAVAS-NOTE.
      *
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4 TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL COM-IN. 
      *    
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 5 TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL COM-IN. 
      *
           MOVE NRIGMAXL TO KVALID.
           PERFORM UNTIL COM-RIN(KVALID) NOT = SPACE
                   SUBTRACT 1 FROM KVALID.
           MOVE ZERO TO KNFR-PGRN.
           PERFORM UNTIL KNFR-PGRN >= KVALID
                ADD 1 TO KNFR-PGRN
                MOVE COM-RIN(KNFR-PGRN) TO NFR-DESCR
                WRITE RF-NFR INVALID PERFORM INVK-NFR GO TO ERRIO.
       EX-TRAVAS-NOTE.
           EXIT.
      *------------------*
       F-LEG-NAT.
           IF RG-BFR-CODART = SPACE
              GO TO END-F-LEG-NAT.
           IF RA-BFR-NOTE NOT = SPACE
              MOVE 'Per importare le note aggiuntive' TO F-MES1
              MOVE ' dell''articolo e'' necessario'   TO F-MES2
              MOVE 'cancellare il contenuto corrente' TO F-MES3
              MOVE 3 TO F-NMES
              GO TO WARNING.
           MOVE RG-BFR-AZI TO KNAT-AZI.
           MOVE RG-BFR-CODART TO KNAT-ART.
           MOVE 1          TO KNAT-TIP.
           MOVE ZERO       TO KNAT-PRG.
           MOVE ZERO TO KN.
           START NOTART KEY > KEYNAT INVALID GO TO F-LEG-NAT-90.
       F-LEG-NAT-10.
           READ NOTART NEXT AT END GO TO F-LEG-NAT-90.
           IF KNAT-AZI > RG-BFR-AZI GO TO F-LEG-NAT-90.
           IF KNAT-ART > RG-BFR-CODART GO TO F-LEG-NAT-90.
           IF KNAT-TIP > 1          GO TO F-LEG-NAT-90.
           ADD 1 TO KN.
           IF KN > NRIGMAXL GO TO F-LEG-NAT-90.
           MOVE NAT-DESCR TO RA-BFR-RIGNOT(KN).
           GO TO F-LEG-NAT-10.
       F-LEG-NAT-90.
           IF KN = ZERO GO TO END-F-LEG-NAT.
           MOVE NRIGMAXL TO ML-MAXRIG.
           MOVE NCOLMAXL TO ML-LUNRIG.
           MOVE 4       TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL RA-BFR-NOTE.
       END-F-LEG-NAT.
           EXIT.
      ************
      **** rel 7.1
       CALL-VSRV133.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'RIF'   TO PPAR-TARC.
           MOVE KEYRF   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 RIF ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------*
       CALL-VSRV133-BFR.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'BFR'   TO PPAR-TARC.
           MOVE KEYFR   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           IF PPAR-TOPE = 'C'
              MOVE DTINT TO PPAR-OPZ(1:5).
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 BFR ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------*
       CALL-VSRV133-OBF.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'OBF'   TO PPAR-TARC.
           MOVE KEYOB   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           IF PPAR-TOPE = 'C'
              MOVE DTINT TO PPAR-OPZ(1:5).
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 OBF ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------*
       CALL-VSRV133-MMG.
           IF BFR-TPRIG = ZERO AND
              BFR-QUANT NOT = ZERO
                 MOVE ZERO    TO PPAR-FUN
                 MOVE 'MMG'   TO PPAR-TARC
                 MOVE 'I'     TO PPAR-TOPE
                 MOVE KFR-AZI    TO S-KMM-AZI
                 MOVE BFT-CDEP   TO S-KMM-DEP
                 MOVE BFR-CODART TO S-KMM-ART
                 MOVE BFT-DTCO   TO S-KMM-DAT
                 MOVE BFR-NUMOV  TO S-KMM-NUM
                 MOVE S-KEYMM TO PPAR-KEY
                 MOVE ZERO    TO PPAR-CATT
                 CALL 'vsrv133' USING PARPPAR 'DSV'
                 IF PPAR-ERR > 1
                    MOVE SPACE TO MESS
                    STRING 'Errore vsrv133 MMG ' PPAR-ERR
                            DELIMITED SIZE INTO MESS
                    GO TO ERRIO.
      ************
