       IDENTIFICATION DIVISION.
       PROGRAM-ID. vpla339.
      **** rel 7.1
      * Nuova stampa su modulo ministeriale
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griditsl'.
           COPY 'griclfsl'.
           COPY 'gritabsl'.
           SELECT LETINT ASSIGN TO DISK
                  ORGANIZATION SEQUENTIAL
                  STATUS SF-LET.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gridit'.
           COPY 'grilet'.
           COPY 'griclf'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'grid02rk'.
           COPY 'griclfrk'.
           COPY 'gritabrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parpb'.
           COPY 'parmb'.
           COPY 'pardefw'.
           COPY 'parscmd'.
           COPY 'parwpla'.
           COPY 'parwcd'.
       01  PARWPLA2.
           05 PWPLA2-AZI      PIC 9(3).
           05 PWPLA2-NFILE    PIC X(77).
       01  PARCC2.
           05 PCC2-FUN     PIC X.
           05 PCC2-FLGS    PIC 9.
           05 PCC2-TIPEST  PIC XX.
           05 PCC2-PARAM   PIC X(20).
           05 PCC2-PATH    PIC X(60).
           05 PCC2-STAMP   PIC 9.
           05 PCC2-FILLER  PIC X(49).
           05 PCC2-ERR     PIC 9.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-DIT PIC X(15) VALUE 'leitab'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-LET PIC X(80) VALUE 'ivi15'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-DIT   PIC XX.
           05 SF-CLF   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-LET   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 DTPK1    PIC 9(5) COMP-3 VALUE ZERO.
           05 DTPK2    PIC 9(5) COMP-3 VALUE ZERO.
           05 KATTESA  PIC 9(5) VALUE ZERO.
           05 IND    PIC 99    VALUE ZERO.
           05 K1     PIC 999   VALUE ZERO.
           05 K2     PIC 999   VALUE ZERO.
           05 K3     PIC 999   VALUE ZERO.
           05 NFILE  PIC X(30).
           05 CONTA  PIC 9(5)  VALUE ZERO.
           05 MFOR   PIC 9(2)  VALUE ZERO.
           05 COMCOD.
              10 MCOM   PIC 99.
              10 CCOM   PIC 9(5).
      *
      *
           05 OPZIONI.
              10 COM-NPRT     PIC X(14).
              10 COM-FILE     PIC X(80).
              10 COM-NRIG     PIC 9(5) COMP-3.
              10 COM-DTDOC    PIC 9(5) COMP-3.

       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-NFILE     PIC X(80).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcldit'.
           COPY 'dclclf'.
           COPY 'dcltab'.
           COPY 'gridcl' REPLACING ==(SIGLA)== BY ==LET==
                                   ==NFILE== BY ==LETINT==
                                   =='nfile'== BY =='letint'==.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vpla339: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE LEITAB.
           CLOSE LETINT.
           CLOSE ANACLF.
           CLOSE TABELL.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griditer'.
           COPY 'gritaber'.
           COPY 'griclfer'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           OPEN INPUT ANAAZI LEITAB TABELL ANACLF.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'A'       TO D02-PRG.
           MOVE 02        TO D02-TIP.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INTO REKD02 INVALID PERFORM INVK-DIT
                                   GO TO ERRIO.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY 
             PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MFOR TO MFOR.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
           STRING D02-PATHECF "*ivi15*" DELIMITED SPACE INTO IF-NFILE.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-NFILE.
           MOVE 'IF-NFILE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NFILE.
           PERFORM ESTRAPOLA-NFILE THRU EX-ESTRAPOLA-NFILE.
           IF (NFILE(1:11) NOT NUMERIC OR
              NFILE(12:1) NOT = '_'    OR
              NFILE(13:2) NOT NUMERIC  OR
              NFILE(15:1) NOT = '_'    OR
              NFILE(16:4) NOT NUMERIC  OR
              NFILE(20:1) NOT = '_'    OR
              NFILE(21:5) NOT = 'ivi15')
              MOVE 'FILE NON CORRETTO' TO MESS
              MOVE SPACE TO IF-NFILE
              STRING D02-PATHECF "*ivi15*" DELIMITED SPACE INTO IF-NFILE
              GO TO V-ERROR.
           IF IF-NFILE = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-NFILE.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           MOVE 'PLA' TO SCMD-TDOC.
           CALL 'vrscmd' USING PARSCMD.
      *
           IF SCMD-TIPO(1) = 'LOC' AND SCMD-FLG(1) = 1
              MOVE KAZ-COD TO PWPLA-AZI
              MOVE 'I'     TO PCCD-FUN
              MOVE SCMD-OPZ(1) TO PCCD-PARAM
              MOVE SPACE TO PCCD-TIPEST
              MOVE ZERO  TO PCCD-FLGS
              MOVE SPACE TO PCCD-PATH
              CALL 'vplawrd' USING PARWPLA PARCCD
              IF PCCD-ERR NOT = ZERO GO TO ERRIO.
      *
           MOVE ZERO TO CONTA.
           MOVE IF-NFILE TO ID-LET.
           OPEN INPUT LETINT.
       INIZIO-LETTURA.
           READ LETINT AT END GO TO FINE-LETTURA.
           ADD 1 TO CONTA.
           IF RF-LET(1:1) = 'B'
              GO TO SISTAMPA.
           GO TO INIZIO-LETTURA.
       SISTAMPA.
      *
           MOVE 1 TO IND.
           PERFORM UNTIL IND > 10
              IF SCMD-TIPO(IND) NOT = SPACE AND SCMD-FLG(IND) = 1
                 IF SCMD-TIPO(IND) = 'LOC'
                    MOVE KAZ-COD    TO PWPLA-AZI
                    MOVE LETB-NATTR TO PWPLA-NPRT
                    MOVE IF-NFILE   TO PWPLA-FILE
                    MOVE CONTA      TO PWPLA-NRIG
                    MOVE 'R'        TO PCCD-FUN
                    CALL 'vplawrd' USING PARWPLA PARCCD
                    IF PCCD-ERR NOT = ZERO
                       GO TO ERRIO
                    END-IF
                 ELSE
                    PERFORM CERCA-FORNITORE THRU EX-CERCA-FORNITORE
                    MOVE ZERO  TO PWCD-FUN
                    MOVE SCMD-TIPO(IND) TO PWCD-TIPO
                    MOVE SCMD-TDOC      TO PWCD-TDOC
                    MOVE 2              TO PWCD-TDES
                    MOVE CCOM           TO PWCD-CDES
                    MOVE KEYCF          TO PWCD-KEY
                    MOVE SCMD-OPZ(IND)  TO PWCD-PARAM
      *
                    MOVE SPACE      TO PWCD-OPZ
                    MOVE LETB-NATTR TO COM-NPRT
                    MOVE IF-NFILE   TO COM-FILE
                    MOVE CONTA      TO COM-NRIG
                    MOVE 01         TO GG4 MM4
                    MOVE LETB-ANNOD TO AA4
                    MOVE 4 TO TIPOP1
                    CALL 'rdata' USING PARCDT
                    MOVE AAGGG   TO COM-DTDOC
                    MOVE OPZIONI TO PWCD-OPZ
      *
                    CALL 'vrwcoda' USING PARWCD
                    IF PWCD-ERR NOT = ZERO
                       GO TO ERRIO
                    END-IF
                 END-IF
              END-IF
              ADD 1 TO IND.
           GO TO INIZIO-LETTURA.
       FINE-LETTURA.
           IF SCMD-TIPO(1) = 'LOC' AND SCMD-FLG(1) = 1
              MOVE 'E' TO PCCD-FUN
              CALL 'vplawrd' USING PARWPLA PARCCD
              IF PCCD-ERR NOT = ZERO GO TO ERRIO.
           CLOSE LETINT.
           MOVE SPACE TO IF-NFILE.
           STRING D02-PATHECF "*ivi15*" DELIMITED SPACE INTO IF-NFILE.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       ESTRAPOLA-NFILE.
           MOVE 80 TO K1.
           MOVE 80 TO K2.
           MOVE 80 TO K3.
           MOVE SPACE TO NFILE.
           PERFORM UNTIL IF-NFILE(K1:1) = '\' OR '/'
               IF IF-NFILE(K1:1) = SPACE
                  MOVE K1 TO K2 
               END-IF 
               SUBTRACT 1 FROM K1.
           ADD 1 TO K1.
           COMPUTE K3 = K2 - K1.  
           MOVE SPACE TO NFILE.
           MOVE IF-NFILE(K1:K3) TO NFILE.
       EX-ESTRAPOLA-NFILE.
           EXIT.
      *------------------
       CERCA-FORNITORE.
           MOVE IF-AZI      TO KCF-AZI.
           MOVE LETB-PIVAD  TO KCF-PIVA.
           START ANACLF KEY NOT < KEYCF2 INVALID GO TO CERCA-50.
       CERCA-10.
           READ ANACLF NEXT INTO REKCLF AT END GO TO CERCA-10.
           IF SF-CLF = '9D' OR '9A' OR '35' GO TO CERCA-10.
           IF KCF-PIVA NOT = LETB-PIVAD      GO TO CERCA-50.
      *
           MOVE KCF-COD TO COMCOD.
           IF KCF-AZI        NOT = IF-AZI GO TO CERCA-10.
           IF MCOM           NOT = MFOR   GO TO CERCA-10.
           IF CLF-XRGS(1:60) NOT = LETB-DENOM GO TO CERCA-10. 
      *
       CERCA-50.
      *
       EX-CERCA-FORNITORE.
           EXIT.
      *------------------
