       IDENTIFICATION DIVISION.
       PROGRAM-ID. VPRCLF.
      *
      * Stampa archivio anagrafico clienti / fornitori
      *
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griclfrk'.
           COPY 'gritabrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-CLF   PIC XX.
           05 SF-TAB   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 FST.
              10 FSTM   PIC 99. 
              10 FSTC   PIC 9(5).
           05 ULT.
              10 ULTM   PIC 99. 
              10 ULTC   PIC 9(5).

           COPY 'vprclf.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-CLFO      PIC X.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-COD-1     PIC 9(5).
           05 IF-COD-2     PIC 9(5).
           05 IF-DATA      PIC 9(6).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'VPRCLF: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI
                 ANACLF
                 TABELL.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'anaclf' TO ID-CLF
                           MOVE 'tabell' TO ID-TAB
           ELSE            MOVE 'anazol' TO ID-AZI
                           MOVE 'anacfx' TO ID-CLF
                           MOVE 'tabold' TO ID-TAB.
      **** rel 6.1
           IF IF-FL = 3    MOVE 'anaazi' TO ID-AZI
                           MOVE 'allcfx' TO ID-CLF
                           MOVE 'tabell' TO ID-TAB.
      ************
           OPEN INPUT ANAAZI
                      ANACLF
                      TABELL.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID
                PERFORM INVK-AZI
                GO TO ERRIO.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF IF-CLFO = 'F'
              MOVE T01-MFOR TO FSTM ULTM
           ELSE
              MOVE T01-MCLI TO FSTM ULTM.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DATA.
           MOVE ZERO   TO IF-COD-1.
           MOVE 99999  TO IF-COD-2.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-COD-2.
           MOVE 'IF-COD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-2.
           IF IF-COD-2 < IF-COD-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-COD-2.
      *
       V-DATA.
           MOVE 'IF-DATA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DATA.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           MOVE IF-COD-1 TO FSTC.
           MOVE IF-COD-2 TO ULTC.
           MOVE ZERO TO NPAG.
      *
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              MOVE SPACE TO GBMMBA.
           MOVE GBMMBA   TO DATAST.
           MOVE AZRGSOC  TO DESCS1.
      **** rel 6.3
      *    MOVE '  ARCHIVIO ANAGRAFE' TO DESCS3.
           MOVE ' ARCHIVIO ANAGRAFICA' TO DESCS3.
      ************
           IF IF-CLFO = 'C'
              MOVE 'CLIENTI'   TO DESCS2
           ELSE
              MOVE 'FORNITORI' TO DESCS2.

      *
      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 58      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
      **** rel 6.3
      *    STRING 'ARCHIVIO ANAGRAFE ' DESCS2 DELIMITED SIZE 
           STRING 'ARCHIVIO ANAGRAFICA ' DESCS2 DELIMITED SIZE 
      ************
                                              INTO RP-TIT1.
           STRING 'AL ' DATAST DELIMITED SIZE INTO RP-TIT2.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG1-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

           MOVE KAZ-COD  TO KCF-AZI.
           MOVE FST      TO KCF-COD.
           START ANACLF KEY NOT < KEYCF INVALID GO TO FINES.
       LSTF.
           READ ANACLF NEXT INTO REKCLF AT END GO TO FINES. 
           IF SF-CLF = '9D' OR '9A' OR '35' GO TO LSTF.
           IF KCF-AZI > KAZ-COD GO TO FINES.
           IF KCF-COD > ULT     GO TO FINES.
           MOVE CLF-COD   TO RG1.
           MOVE CLF-RGSOC TO RG2.
           MOVE CLF-INDIR TO RG3
           MOVE CLF-CIT   TO RG5.
           MOVE CLF-PRV   TO RG51.
           MOVE CLF-CAP   TO RG4.
           MOVE CLF-PIVA  TO RG6.
           MOVE CLF-CFISC TO RG7.
           IF CLF-13IVA = 4 MOVE CLF-CFISC TO RG7
                            MOVE ZERO      TO RG6.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           IF CLF-RGSOC2 = SPACE AND CLF-INDIR2 = SPACE GO TO LSTF1.
           MOVE CLF-RGSOC2 TO RG2.
           MOVE CLF-INDIR2 TO RG3.
           MOVE 1 TO XCRR.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
       LSTF1.
           MOVE 2 TO XCRR.
           COPY 'grirpt-r'.
           GO TO LSTF.
       FINES.                
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'Codice' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Ragione Sociale' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Indirizzo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Cap' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Localita''' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Pr.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Partita Iva' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Cod.Fiscale' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
