       IDENTIFICATION DIVISION.
       PROGRAM-ID. VPRCON.
      *
      * Stampa archivio conti
      *
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricon'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griconrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-CON   PIC XX.
           05 SF-TAB   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 CONCOD.
              10 MAS PIC 99.
              10 CAP PIC 99.
              10 CON PIC 999.

       01  TESCON.
           05 FILLER PIC X(50) VALUE
           'CODICE   DESCRIZIONE CONTO                    '.
           05 FILLER PIC X(24) VALUE 'DESCRIZ.SINTETICA'.
           05 FILLER PIC X(58) VALUE
              'T  MOV  RIE  GRU  SOT  PRO   GRU2  SOT2  PRO2'.
       01  TESTCOA.
           05 FILLER PIC X(46) VALUE
           'CODICE   DESCRIZIONE CONTO'.
           05 FILLER PIC X(42) VALUE 'TIPO'.

           COPY 'vprcon.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-COD-1     PIC 9(7).
           05 IF-COD-2     PIC 9(7).
           05 IF-DATA      PIC 9(6).
           05 IF-TIPSTA    PIC 9.
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcon'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'VPRCON: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI
                 ANACON
                 TABELL.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griconer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'anacon' TO ID-CON
                           MOVE 'tabell' TO ID-TAB
           ELSE            MOVE 'anazol' TO ID-AZI
                           MOVE 'anacol' TO ID-CON
                           MOVE 'tabold' TO ID-TAB.
           OPEN INPUT ANAAZI
                      ANACON
                      TABELL.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DATA.
           MOVE ZERO    TO IF-COD-1.
           MOVE 9999999 TO IF-COD-2.
           MOVE ZERO    TO IF-TIPSTA.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-COD-2.
           MOVE 'IF-COD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-2.
           IF IF-COD-2 < IF-COD-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-COD-2.
      *
       V-DATA.
           MOVE 'IF-DATA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DATA.
      *
       V-TIPSTA.
           MOVE 'IF-TIPSTA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TIPSTA.
           IF IF-TIPSTA > 1
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-TIPSTA.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           MOVE ZERO TO NPAG.
           MOVE AZRGSOC TO DESCS1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              MOVE SPACE TO GBMMBA.
           MOVE GBMMBA   TO DATAST.
           MOVE 'CONTI'  TO DESCS2.
      **** rel 6.3
      *    MOVE '  ARCHIVIO ANAGRAFE' TO DESCS3.
           MOVE ' ARCHIVIO ANAGRAFICA' TO DESCS3.
      ************

           IF IF-TIPSTA = 1
      **** rel 6.3
      *       MOVE '          PIANO DEI' TO DESCS3
              MOVE '           PIANO DEI' TO DESCS3
      ************
              MOVE TESTCOA TO TESTAN
           ELSE
              MOVE TESCON TO TESTAN.
      *     
      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 58      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           IF IF-TIPSTA = ZERO
      **** rel 6.3
      *       STRING 'ARCHIVIO ANAGRAFE CONTI AL  ' DATAST
              STRING 'ARCHIVIO ANAGRAFICA CONTI AL  ' DATAST
      ************
                     DELIMITED SIZE INTO RP-TIT1
              PERFORM RPT-RIG1-INTC
           ELSE
              STRING 'PIANO DEI CONTI AL  ' DATAST
                     DELIMITED SIZE INTO RP-TIT1
              PERFORM RPT-RIG2-INTC.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

           MOVE IF-AZI   TO KPC-AZI.
           MOVE IF-COD-1 TO KPC-COD.
           START ANACON KEY NOT < KEYPC INVALID GO TO FINES.
       LSTC.
           READ ANACON NEXT INTO REKCON AT END 
                                        GO TO FINES. 
           IF SF-CON = '9D' OR '9A' OR '35' GO TO LSTC.
           IF KPC-AZI > IF-AZI   GO TO FINES.
           IF KPC-COD > IF-COD-2 GO TO FINES.
           IF IF-TIPSTA = 1 GO TO LSTC2.
           MOVE CON-COD   TO RG1.
           MOVE CON-DESCR TO RG2.
           MOVE CON-DSABB TO RG3.
           MOVE CON-TIPO  TO RGTIP.
           MOVE CON-BIL1  TO RB1.
           MOVE CON-BIL2  TO RB2.
           MOVE CON-BIL3  TO RB3.
           MOVE CON-BIL5  TO RB4.
           MOVE CON-FLRIE TO RB5.
           MOVE CON-MOVIM TO RB6.
           MOVE CON-PRO1  TO RP1.
           MOVE CON-PRO2  TO RP2.
           MOVE 'RIG1' TO RP-BLK.
      *
           GO TO LCALL.
       LSTC2.
           MOVE CON-COD TO CONCOD.
           IF CAP = ZERO AND CON = ZERO
              MOVE 3 TO XCRR
              MOVE '***' TO RCS0
              GO TO LSTC3.
           IF CON = ZERO
              MOVE 2 TO XCRR
              MOVE '*' TO RCS0
              GO TO LSTC3.
           IF CON NOT = ZERO
              MOVE 1 TO XCRR.
       LSTC3.
           MOVE CON-COD   TO RG1.
           MOVE CON-DESCR TO RG2.
           MOVE CON-TIPO  TO RGTIP.
           MOVE 'RIG1' TO RP-BLK.
       LCALL. 
           PERFORM RPT-WR.
      *
           COPY 'grirpt-r'.
      *
           MOVE 2 TO XCRR.
           GO TO LSTC. 
       FINES.                
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           PERFORM RPT-ADD-I.
           MOVE 'Codice' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione Conto' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descriz.Sintetica' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'T' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Mov' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Rie' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Gru' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Sot' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Pro' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Gru2' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Sot2' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Pro2' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
       RPT-RIG2-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           PERFORM RPT-ADD-I.
           MOVE 'Codice' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione Conto' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE SPACE TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Tip' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
