       IDENTIFICATION DIVISION.
       PROGRAM-ID. VPRMLI.
      *
      * Stampa archivio movimenti extra contabili
      *
      *** rel 5.0
      * Nuovo
      ***********
      **** rel 6.3
      * Aggiunto filtro per date di competenza
      * Aggiunta stampa campo centro di costo + descr.
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'grimlisl'.
           COPY 'griconsl'.
           COPY 'gritabsl'.
      **** rel 6.3
           COPY 'gricdcsl'.
           COPY 'gritrtsl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'grimli'.
           COPY 'gricon'.
           COPY 'gritab'.
      **** rel 6.3
           COPY 'gricdc'.
           COPY 'gritrt'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'gritabrk'.
           COPY 'griconrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-MLI PIC X(15) VALUE 'movlib'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
      **** rel 6.3
       01  ID-CDC PIC X(15) VALUE 'cdcost'.
       01  ID-TRT PIC X(15) VALUE 'tabrit'.
      ************
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-MLI   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-CON   PIC XX.
      **** rel 6.3
           05 SF-CDC   PIC XX.
           05 SF-TRT   PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 K        PIC 99     VALUE ZERO.
           05 ANNO     PIC 9(4)   VALUE ZERO.
           05 CATT     PIC X      VALUE SPACE.
           05 NFAT     PIC 9(5)   VALUE ZERO.
           05 TOT1     PIC S9(11)V99 VALUE ZERO.
           05 TOT2     PIC S9(11)V99 VALUE ZERO.
      **** rel 6.3
           05 DTCOM-1  PIC 9(5) VALUE ZERO.
           05 DTCOM-2  PIC 9(5) VALUE ZERO.
      ************

           COPY 'vprmli.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
      **** rel 7.2
      *    05 IF-PRG-1     PIC 9(3).
      *    05 IF-PRG-2     PIC 9(3).
           05 IF-PRG-1     PIC 9(5).
           05 IF-PRG-2     PIC 9(5).
      ************
           05 IF-CONTO-1   PIC 9(7).
           05 IF-CONTO-2   PIC 9(7).
      **** rel 6.3
           05 IF-DTCMP-1   PIC 9(6).
           05 IF-DTCMP-2   PIC 9(6).
      ************
           05 IF-DATA      PIC 9(6).
           05 IF-TPSTA     PIC 9.
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclmli'.
           COPY 'dclcon'.
           COPY 'dcltab'.
      **** rel 6.3
           COPY 'dclcdc'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vprmli: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE TABELL ANACON ANAAZI MOVLIB.
      **** rel 6.3
           CLOSE CDCOST.
           CLOSE TABRIT.
      ************
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'grimlier'.
           COPY 'griconer'.
           COPY 'gritaber'.
      **** rel 6.3
           COPY 'gricdcer'.
      ************
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'anacon' TO ID-CON
                           MOVE 'tabell' TO ID-TAB
                           MOVE 'movlib' TO ID-MLI
           ELSE            MOVE 'anazol' TO ID-AZI
                           MOVE 'anacol' TO ID-CON
                           MOVE 'tabold' TO ID-TAB
                           MOVE 'movlix' TO ID-MLI.
           OPEN INPUT ANAAZI ANACON TABELL MOVLIB.
      **** rel 6.3
           OPEN INPUT CDCOST.
           OPEN INPUT TABRIT.
      ************
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DATA.
           MOVE ZERO   TO IF-CONTO-1
                          IF-PRG-1.
           MOVE 9999999 TO IF-CONTO-2.
      **** rel 6.3
           MOVE ZERO TO IF-DTCMP-1 IF-DTCMP-2.
      ************
      **** rel 7.2
      *    MOVE 999    TO IF-PRG-2.
           MOVE 99999  TO IF-PRG-2.
      ************
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-CONTO-2.
           MOVE 'IF-CONTO-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CONTO-2.
           IF IF-CONTO-2 < IF-CONTO-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
           IF IF-CONTO-2 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-CONTO-2.
      *
      **** rel 6.3
       V-DTCMP-1.
           MOVE 'IF-DTCMP-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTCMP-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTCMP-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DTCOM-1.
       E-DTCMP-1.
      *
       V-DTCMP-2.
           MOVE 'IF-DTCMP-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTCMP-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTCMP-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DTCOM-2.
           IF DTCOM-2 < DTCOM-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DTCMP-2.
      ************
       V-DATA.
           MOVE 'IF-DATA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DATA.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           MOVE AZRGSOC TO TAZI.
      *
           MOVE IF-DATA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO TDAT.
      *
      *-- inizializza parametri per stampa a caratteri --*
      **** rel 6.3
      *    MOVE 1 TO LMOD.
           MOVE 2 TO LMOD.
      ************
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE ZERO  TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'STAMPA MOVIMENTI EXTRA CONTABILI - ' TDAT
                  DELIMITED SIZE INTO RP-TIT1.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG1-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

           MOVE ZERO TO TOT1 TOT2.
           MOVE LOW-VALUE TO KEYMLI.
           MOVE KAZ-COD    TO KMLI-AZI.
           MOVE IF-PRG-1   TO KMLI-PRG.
           MOVE IF-CONTO-1 TO KMLI-CONTO.
           START MOVLIB KEY NOT < KEYMLI INVALID GO TO ENDA.
       S030.
           READ MOVLIB NEXT AT END GO TO ENDA.
           IF SF-MLI = '9D' OR '9A' OR '35' GO TO S030.
           IF KMLI-AZI   > KAZ-COD    GO TO ENDA.
           IF KMLI-PRG   > IF-PRG-2   GO TO ENDA.
           IF KMLI-CONTO < IF-CONTO-1 GO TO S030.
           IF KMLI-CONTO > IF-CONTO-2 GO TO S030.

      **** rel 6.3
           IF MLI-DATA < DTCOM-1 OR MLI-DATA > DTCOM-2
              GO TO S030.
      ************

           MOVE KMLI-AZI    TO KPC-AZI.
           MOVE KMLI-CONTO  TO KPC-COD RCONTO.
           READ ANACON INTO REKCON INVALID MOVE ALL '*' TO CON-DESCR.
           MOVE CON-DESCR TO RDESCR.

      **** rel 6.3
           IF MLI-TRIP = ZERO
              MOVE KMLI-AZI  TO KCD-AZI
              MOVE MLI-CCOST TO KCD-COD RCDC
              READ CDCOST INVALID MOVE SPACE TO CDC-DESCR
                          END-READ
              MOVE CDC-DESCR TO RDCDC
           ELSE
              MOVE KMLI-AZI   TO KTRT-AZI
              MOVE MLI-TTIP   TO KTRT-COD RTTIP
              READ TABRIT INVALID MOVE ALL SPACES TO TRT-DESCR
              END-READ
              MOVE TRT-DESCR TO RDCDC.
      ************

           MOVE MLI-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GMMMA TO RDATA.

      **** rel 6.3
           IF MLI-VALID NOT = ZERO AND MLI-DTVALID NOT = ZERO
              MOVE MLI-DTVALID TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GMMMA TO RDTPRF.
      ************
           MOVE MLI-DESCR    TO RDESC1.
           IF MLI-DARE  NOT = ZERO MOVE MLI-DARE  TO RDARE.
           IF MLI-AVERE NOT = ZERO MOVE MLI-AVERE TO RAVERE.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           COPY 'grirpt-r'.
           ADD MLI-DARE  TO TOT1.
           ADD MLI-AVERE TO TOT2.
           GO TO S030.
       ENDA.
           PERFORM D00-STAMPA-TOTALI THRU D99.
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       D00-STAMPA-TOTALI.
           IF TOT1 = ZERO AND
              TOT2 = ZERO GO TO D99.
           MOVE ALL '-' TO RDAREX RAVERX.
      *
           MOVE 'RIG1' TO RP-BLK.
           MOVE 2 TO RP-FLGR.
           PERFORM RPT-WR.
      *
           MOVE 'TOTALE GENERALE :' TO RDESC1.
           MOVE TOT1 TO RDARE.
           MOVE TOT2 TO RAVERE.
           MOVE 'RIG1' TO RP-BLK.
           MOVE 1 TO RP-FLGP.
           PERFORM RPT-WR.
      *
           MOVE ALL '-' TO RDAREX RAVERX.
      *
           MOVE 'RIG1' TO RP-BLK.
           MOVE 2 TO RP-FLGR.
           PERFORM RPT-WR.
      *
           MOVE ZERO TO TOT1 TOT2.
       D99.
           EXIT. 
      *------------------
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'Conto' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      **** rel 6.3
           MOVE 'C.d.C' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'T.Rip' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *    MOVE 'Data' TO RP-IFLD.
           MOVE 'Dt.Comp' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Dt.Perf' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      ************
           MOVE 'Descrizione Movimento' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Dare' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Avere' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
