       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRGBAN.
      *
      *    Interfaccia ANABAN per scheda
      *
      **** rel 4.0
      * ricompilato
      ************
      **** rel 5.0
      * Ricompilato per variazione tracciato ANABAN
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'gribansl'.
      **** rel 6.3
           COPY 'griazisl'.
      ************
      **** rel 6.0
           COPY 'griabasl'.
           COPY 'griconsl'.
      ************
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griban'.
      **** rel 6.3
           COPY 'griazi'.
      ************
      **** rel 6.0
           COPY 'griaba'.
           COPY 'gricon'.
      ************
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
      **** rel 6.0
           COPY 'griconrk'.
      ************
      **** rel 6.2
           COPY 'pariban'.
           COPY 'parul'.
      ************
      **** rel 6.3
           COPY 'parmb'.
      ************
           COPY 'parzf'.
      **** rel 7.1
           COPY 'pardsvt'.
      ************
       01  ID-BAN PIC X(15) VALUE 'anaban'.
      **** rel 6.3
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
      ************
      **** rel 6.0
       01  ID-ABA PIC X(15) VALUE 'appban'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
      ************
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  COMODI.
           05 SF-BAN   PIC XX.
      **** rel 6.3
           05 SF-AZI   PIC XX.
      ************
      **** rel 6.0
           05 SF-ABA   PIC XX.
           05 SF-CON   PIC XX.
      ************
           05 SF-TAB   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(30).
      **** rel 6.2
           05 CCORXX   PIC X(12).
           05 K        PIC 99.
      ************
       LINKAGE SECTION.
           COPY 'gribanrg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-BAN-CTRL
                                RG-BAN-REC
                                RA-BAN-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclban'.
      **** rel 6.3
           COPY 'dclazi'.
      ************
      **** rel 6.0
           COPY 'dclaba'.
           COPY 'dclcon'.
      ************
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-BAN-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-BAN-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-BAN-FUN   TO FUN.
           MOVE RG-BAN-IDX   TO IDX.
           MOVE RG-BAN-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-BAN-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'vrgban: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-BAN-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-BAN-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-BAN-ST = 7 GO TO FINE.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK ANABAN.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-BAN INVALID
              PERFORM INVK-BAN
              GO TO ERRIO.
      **** rel 6.3
           MOVE EX-AZI  TO KABA-AZI.
           MOVE KBA-BAN TO KABA-BAN.
      ************
      **** rel 6.0
           WRITE RF-ABA INVALID
              REWRITE RF-ABA INVALID
              PERFORM INVK-ABA
              GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO DSVT-TOPE.
           PERFORM CALL-VSRV133.
      ************
      ************
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-BAN INVALID
              PERFORM INVK-BAN
              GO TO ERRIO.
      **** rel 6.3
           MOVE EX-AZI  TO KABA-AZI.
           MOVE KBA-BAN TO KABA-BAN.
      ************
      **** rel 6.0
           REWRITE RF-ABA INVALID
              WRITE RF-ABA INVALID
                    PERFORM INVK-ABA
                    GO TO ERRIO
              END-WRITE.
      ************
      **** rel 7.1
           MOVE 'M' TO DSVT-TOPE.
           PERFORM CALL-VSRV133.
      ************
           UNLOCK ANABAN.
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-BAN
              GO TO WARNING.
           IF RG-BAN-ST = 7 GO TO FINE.
           PERFORM DB-STORNA THRU EX-DB-STORNA.
      **** rel 6.3
           MOVE EX-AZI  TO KABA-AZI.
           MOVE KBA-BAN TO KABA-BAN.
           READ APPBAN NOT INVALID DELETE APPBAN.
      *
           MOVE LOW-VALUE TO KEYAZ.
           START ANAAZI KEY > KEYAZ INVALID GO TO END-AZI.
       LOOP-AZI.
           READ ANAAZI NEXT AT END GO TO END-AZI.
           IF SF-AZI = '9D' OR '9A' OR '35' GO TO LOOP-AZI.
      *
           MOVE KAZ-COD TO KABA-AZI.
           MOVE KBA-BAN TO KABA-BAN.
           READ APPBAN INVALID GO TO LOOP-AZI.
      *
           MOVE 'ATTENZIONE: banca NON cancellata!' TO MB-TITOLO.
           MOVE 'I dati anagrafici della banca sono' TO F-MES1.
           MOVE 'utilizzati per altre aziende.' TO F-MES2.
           MOVE 'Sono stati cancellati SOLO i dati' TO F-MES3.
           MOVE SPACE TO F-MES4.
           STRING 'specifici dell''azienda ' EX-AZI INTO F-MES4.
           MOVE 4 TO F-NMES.
           CALL 'vrmbox' USING PARMB.
      *
      **** rel 7.1
           MOVE 'M' TO DSVT-TOPE.
           PERFORM CALL-VSRV133.
      ************
           GO TO NO-DEL.
       END-AZI.
      ************
           DELETE ANABAN INVALID
              PERFORM INVK-BAN
              GO TO ERRIO.
      **** rel 6.3
      **** rel 6.0
      *    MOVE KEYBA TO KEYABA.
      *    DELETE APPBAN.
      ************
      **** rel 7.1
           MOVE 'C' TO DSVT-TOPE.
           PERFORM CALL-VSRV133.
      ************
       NO-DEL.
      ************
           UNLOCK ANABAN.
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-BAN-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK ANABAN.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-BAN-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE TABELL.
           CLOSE ANABAN.
      **** rel 6.3
           CLOSE ANAAZI
      ************
      **** rel 6.0
           CLOSE APPBAN.
           CLOSE ANACON.
      ************
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-BAN-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-BAN-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'gribaner'.
      **** rel 6.0
           COPY 'griabaer'.
           COPY 'griconer'.
      ************
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           OPEN INPUT TABELL.
           OPEN I-O ANABAN.
      **** rel 6.0
           OPEN I-O APPBAN.
           OPEN INPUT ANACON.
      ************
      **** rel 6.3
           OPEN INPUT ANAAZI.
      ************
      *
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-BAN-EOF.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO TO RF-BAN.
           MOVE SPACE TO BAN-AZCRE BAN-BLANK BAN-SPORT
      **** rel 5.0-2
      *                  BAN-CODAZ BAN-CODSP BAN-FILL
      **** rel 5.0-3
      *                  BAN-CODAZ BAN-CODSP BAN-CIN BAN-SWIFT
      **** rel 6.2
      *                  BAN-CODAZ BAN-CODSP BAN-FILL BAN-SWIFT
                         BAN-SWIFT BAN-CODSP(6:)
      ************
      **************
      **************
      **** rel 5.2
      **** rel 6.2
      *                  BAN-CCOR BAN-CINAZ
      ************
      **************
      **** rel 6.2
      *                  BAN-CIRC  BAN-CITTA BAN-RST.
                         BAN-CIRC  BAN-CITTA.
      ************
      **** rel 6.0
           MOVE ZERO TO RF-ABA.
      ************
      **** rel 6.2
           MOVE SPACE TO ABA-PAE ABA-IBAN.
      ************
      **** rel 7.2
           MOVE SPACE TO ABA-CUC.
      ************
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
      * azzeramento aree interfaccia
           MOVE ZERO TO RG-BAN-REC.
      **** rel 6.2
      *    MOVE SPACE TO RG-BAN-AZCRE RG-BAN-SPORT RG-BAN-CODAZ
      *                  RG-BAN-CODSP RG-BAN-CIRC  RG-BAN-CITTA
      *                  RG-BAN-RST.
           MOVE SPACE TO RG-BAN-AZCRE RG-BAN-SPORT
                         RG-BAN-CIRC  RG-BAN-CITTA
                         RG-BAN-PAE   RG-BAN-IBAN.
      ************
      **** rel 5.0-2
      **** rel 5.0-3
      *    MOVE SPACE TO RG-BAN-CIN RG-BAN-SWIFT.
           MOVE SPACE TO RG-BAN-SWIFT.
      **************
      **************
      **** rel 5.2
      **** rel 6.2
      *    MOVE SPACE TO RG-BAN-CCOR RG-BAN-CINAZ.
      ************
      **************
           MOVE ZERO TO RA-BAN-AGG.
      **** rel 6.0
           MOVE SPACE TO RA-BAN-CPART-D.
      ************
      * ripristino dei campi chiave fissi
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-KBA-BAN TO KBA-BAN.
           MOVE KEYBA TO KRIFER.
      **** rel 6.0
           MOVE RG-KBA-BAN TO KABA-BAN.
      ************
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYBA.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ ANABAN INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
      **** rel 6.0
      **** rel 6.3
      *    MOVE KEYBA TO KEYABA.
      *    READ APPBAN INVALID MOVE ZERO TO RF-ABA.
           MOVE EX-AZI  TO KABA-AZI.
           MOVE KBA-BAN TO KABA-BAN.
           READ APPBAN INVALID MOVE ZERO TO REKABA
                               MOVE SPACE TO ABA-CIBAN.
      ************
      ************
           GO TO EX-READ-K.
      *
       RDK-10.
           READ ANABAN KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-BAN > ZERO MOVE 7 TO RG-BAN-ST.
      **** rel 6.0
      **** rel 6.3
      *    MOVE KEYBA TO KEYABA.
      *    READ APPBAN INVALID MOVE ZERO TO RF-ABA.
           MOVE EX-AZI  TO KABA-AZI.
           MOVE KBA-BAN TO KABA-BAN.
           READ APPBAN INVALID MOVE ZERO TO REKABA
                               MOVE SPACE TO ABA-CIBAN.
      ************
      ************
      *
       EX-READ-K.
           EXIT.
      *------------------
      * posizionamento su chiave secondaria per successive
      * read next/previous
      *
       SET-KEYSEC.
           MOVE KEYBA TO KRIFER.
           IF IDX = 2
              START ANABAN KEY >= KEYBA2 INVALID GO TO SET-90.
       SET-10.
           READ ANABAN NEXT AT END GO TO SET-90.
           IF KEYBA = KRIFER GO TO EX-SET-KEYSEC.
           GO TO SET-10.
       SET-90.
           MOVE 'vrgban: errore di posizionamento su' TO F-MES1.
           MOVE 'chiave secondaria'                   TO F-MES2.
           MOVE 2 TO F-NMES.
           GO TO ERRIO.
       EX-SET-KEYSEC.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
           IF IDX > 1 PERFORM SET-KEYSEC THRU EX-SET-KEYSEC.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ ANABAN PREVIOUS AT END MOVE 1 TO EOF
           ELSE
              READ ANABAN NEXT AT END MOVE 3 TO EOF.
           IF EOF > ZERO GO TO RNP-80.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-BAN = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *

      * trovato record valido: reset EOF
           MOVE ZERO TO RG-BAN-EOF.
           MOVE KEYBA TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-BAN-EOF.
           IF RG-BAN-EOF = 4 MOVE 2 TO RG-BAN-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE RG-KBA-BAN       TO KBA-BAN.
           MOVE RG-BAN-AZCRE     TO BAN-AZCRE.
           MOVE RG-BAN-SPORT     TO BAN-SPORT.
           MOVE RG-BAN-CODAZ     TO BAN-CODAZ.
           MOVE RG-BAN-CODSP     TO BAN-CODSP.
           MOVE RG-BAN-CIRC      TO BAN-CIRC.
           MOVE RG-BAN-CITTA     TO BAN-CITTA.
      **** rel 6.2
      *    MOVE RG-BAN-RST       TO BAN-RST.
      ************
      **** rel 5.2
      **** rel 6.2
      *    MOVE RG-BAN-CCOR      TO BAN-CCOR.
      *    MOVE RG-BAN-CINAZ     TO BAN-CINAZ.
      ************
      **************
      **** rel 5.0-2
      **** rel 5.0-3
      *    MOVE RG-BAN-CIN       TO BAN-CIN.
      **************
           MOVE RG-BAN-SWIFT     TO BAN-SWIFT.
      **************
      **** rel 6.0
           MOVE RG-KBA-BAN       TO KABA-BAN.
           MOVE RG-BAN-CPART     TO ABA-CPART.
           MOVE RG-BAN-FIDO      TO ABA-FIDO.
           MOVE RG-BAN-CASSBF    TO ABA-CASSBF.
           MOVE RG-BAN-CASAEF    TO ABA-CASAEF.
           MOVE RG-BAN-CASAFT    TO ABA-CASAFT.
           MOVE RG-BAN-MESI      TO ABA-MESI.
           MOVE RG-BAN-GGVAL     TO ABA-GGVAL.
           MOVE RG-BAN-GGAFT     TO ABA-GGAFT.
           MOVE RG-BAN-PERAFT    TO ABA-PERAFT.
      ************
      **** rel 6.2
           MOVE RG-BAN-PAE       TO ABA-PAE.
           MOVE RG-BAN-IBAN      TO ABA-IBAN.
      ************
      **** rel 7.2
           MOVE RG-BAN-CUC       TO ABA-CUC.
      ************
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE KBA-BAN       TO RG-KBA-BAN.
           MOVE BAN-AZCRE     TO RG-BAN-AZCRE.
           MOVE BAN-SPORT     TO RG-BAN-SPORT.
           MOVE BAN-CODAZ     TO RG-BAN-CODAZ.
      **** rel 6.2
      *    MOVE BAN-CODSP     TO RG-BAN-CODSP.
           MOVE BAN-CODSP(1:5) TO RG-BAN-CODSP.
      ************
           MOVE BAN-CIRC      TO RG-BAN-CIRC.
           MOVE BAN-CITTA     TO RG-BAN-CITTA.
      **** rel 6.2
      *    MOVE BAN-RST       TO RG-BAN-RST.
      ************
      **** rel 5.2
      **** rel 6.2
      *    MOVE BAN-CCOR      TO RG-BAN-CCOR.
      *    MOVE BAN-CINAZ     TO RG-BAN-CINAZ.
      ************
      **************
      **** rel 5.0-2
      **** rel 5.0-3
      *    MOVE BAN-CIN       TO RG-BAN-CIN.
      **************
           MOVE BAN-SWIFT     TO RG-BAN-SWIFT.
      **************
      **** rel 6.0
           MOVE ABA-CPART     TO RG-BAN-CPART.
           MOVE ABA-FIDO      TO RG-BAN-FIDO.
           MOVE ABA-CASSBF    TO RG-BAN-CASSBF.
           MOVE ABA-CASAEF    TO RG-BAN-CASAEF.
           MOVE ABA-CASAFT    TO RG-BAN-CASAFT.
           MOVE ABA-MESI      TO RG-BAN-MESI.
           MOVE ABA-GGVAL     TO RG-BAN-GGVAL.
           MOVE ABA-GGAFT     TO RG-BAN-GGAFT.
           MOVE ABA-PERAFT    TO RG-BAN-PERAFT.
      ************
      **** rel 6.2
           MOVE ABA-PAE       TO RG-BAN-PAE.
           MOVE ABA-IBAN      TO RG-BAN-IBAN.
      ************
      **** rel 7.2
           MOVE ABA-CUC       TO RG-BAN-CUC.
      ************
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
      **** rel 6.0
           MOVE EX-AZI    TO KPC-AZI.
           MOVE ABA-CPART TO KPC-COD.
           READ ANACON INTO REKCON INVALID MOVE SPACE TO CON-DESCR.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-DESCR TO RA-BAN-CPART-D.
      ************
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-BAN-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
      *
       V-BAN.
           MOVE 'KBA-BAN' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-BAN.
           IF RG-KBA-BAN = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-BAN.
      *
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-BAN-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-AZCRE.
           MOVE 'BAN-AZCRE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-AZCRE.
           IF RG-BAN-AZCRE = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-AZCRE.
      **** rel 6.2
      *
       V-PAE.
           MOVE 'BAN-PAE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PAE.
           IF RG-BAN-PAE = SPACE 
              MOVE SPACE TO RG-BAN-IBAN
              GO TO E-PAE.
           MOVE RG-BAN-PAE TO UL-STR.
           MOVE 'U'        TO UL-FUN.
           CALL 'ruplo' USING PARUL.
           MOVE UL-STR     TO RG-BAN-PAE.
           IF RG-BAN-PAE = 'IT' 
              MOVE RG-BAN-CODAZ TO RG-BAN-IBAN-ABI
              MOVE RG-BAN-CODSP TO RG-BAN-IBAN-CAB.
       E-PAE.
      *
       V-IBAN.
           MOVE 'BAN-IBAN' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IBAN.
           IF RG-BAN-IBAN = SPACE GO TO E-IBAN.
           MOVE RG-BAN-PAE TO UL-STR.
           MOVE 'U'        TO UL-FUN.
           CALL 'ruplo' USING PARUL.
           MOVE UL-STR     TO RG-BAN-PAE.
           IF RG-BAN-PAE = 'IT'
              IF RG-BAN-IBAN-CC NOT = SPACE
                 MOVE 12 TO K
                 PERFORM UNTIL RG-BAN-IBAN-CC(K:1) NOT = SPACE
                    SUBTRACT 1 FROM K
                 END-PERFORM
                 SUBTRACT 1 FROM K
                 MOVE ZERO TO CCORXX
                 MOVE RG-BAN-IBAN-CC TO CCORXX(12 - K:)
                 MOVE CCORXX TO RG-BAN-IBAN-CC
              END-IF
              MOVE RG-BAN-IBAN-CIN TO UL-STR
              MOVE 'U'        TO UL-FUN
              CALL 'ruplo' USING PARUL
              MOVE UL-STR     TO RG-BAN-IBAN-CIN.
           MOVE ZERO       TO PARIBAN.
           MOVE SPACE      TO IBAN.
           MOVE RG-BAN-PAE TO IBAN-PAESE.
           MOVE RG-BAN-CTR TO IBAN-CTR.
           MOVE RG-BAN-COD TO IBAN-COD.
           CALL 'riban' USING PARIBAN PARBBAN.
           IF IBAN-FLG = 9 
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-IBAN.
      ************
      *
      **** rel 5.1
       V-CODAZ.
           MOVE 'BAN-CODAZ' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CODAZ.
      **** rel 6.2
      *    IF RG-BAN-CODAZ = SPACE
           IF RG-BAN-PAE = 'IT' AND RG-BAN-CODAZ = ZERO
      ************
              PERFORM ERR-ZERO
              GO TO V-ERROR.
      **** rel 6.2
           IF NOT (RG-BAN-PAE = 'IT' OR '  ') AND 
                   RG-BAN-CODAZ NOT = ZERO
              MOVE ZERO TO RG-BAN-CODAZ.
      ************
       E-CODAZ.
      *
      ************
      **** rel 6.2
       V-CODSP.
           MOVE 'BAN-CODSP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CODSP.
           IF RG-BAN-PAE = 'IT' AND RG-BAN-CODSP = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           IF NOT (RG-BAN-PAE = 'IT' OR '  ') AND 
                   RG-BAN-CODSP NOT = ZERO
              MOVE ZERO TO RG-BAN-CODSP.
       E-CODSP.
      *
      ************
      **** rel 6.0
       V-CPART.
           MOVE 'BAN-CPART' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CPART.
           MOVE SPACE TO RA-BAN-CPART-D.
           IF RG-BAN-CPART = ZERO GO TO E-CPART.
           MOVE EX-AZI       TO KPC-AZI.
           MOVE RG-BAN-CPART TO KPC-COD.
           READ ANACON INTO REKCON INVALID
              PERFORM ERR-CINE
              GO TO V-ERROR.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-DESCR TO RA-BAN-CPART-D.
           IF CON-MOVIM = 1
              MOVE 'Conto Non Movimentabile' TO MESS
              GO TO V-ERROR.
       E-CPART.
      *
       V-MESI.
           MOVE 'BAN-MESI' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-MESI.
           IF (RG-BAN-MESI = ZERO OR > 6)  AND
              (RG-BAN-CASSBF > ZERO OR RG-BAN-CASAEF > ZERO OR
               RG-BAN-CASAFT > ZERO)
                  PERFORM ERR-DINV
                  GO TO V-ERROR.
       E-MESI.
      *
      ************
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
      **** rel 7.1
       CALL-VSRV133.
           MOVE ZERO    TO DSVT-FUN.
           MOVE 'BAN'   TO DSVT-TARC.
           MOVE SPACE   TO DSVT-KEY.
           MOVE KBA-BAN TO DSVT-KEY.
           MOVE ZERO    TO DSVT-CATT.
           CALL 'dsv-tab' USING PARDSVT.
           IF DSVT-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133. BAN Errore ' DSVT-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      ************
