       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRIT190.
      *
      **** rel 1.2
      * NUOVO
      ************
      **** rel 5.0
      * Note 770/2002: il record E che prima conteneva i quadri
      *                SC - SE - ST, ora contiene solo il quadro ST.
      *                i quadri che prima erano SC - SE ora sono in 
      *                un'unico quadro chiamato AU contenuto nel tipo
      *                record H.
      ************
      **** rel 5.2
      * Tolti commenti fino a Primula NT rel 5.1
      * lasciate quindi asteriscate le righe del tracciato 
      * versione 2004 variato per adeguamento a vers. 2005
      *
      * N.B.: passa importi con i decimali usa NINT e NDEC  e
      *       non pi troncati come e' stato fino ad ora.
      ************
      *         
      * OGGETTO: CREAZIONE ARCHIVIO PER MODELLO 770
      *         
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
      **** rel 6.0
      *    COPY 'griauasl'.
      ************
           COPY 'griautsl'.
           COPY 'griaupsl'.
           COPY 'griauvsl'.
           COPY 'gributsl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS 
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
           SELECT MOD770 ASSIGN TO DISK
                  ORGANIZATION SEQUENTIAL
                  STATUS SF-770.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
      **** rel 6.0
      *    COPY 'griaua'.
      ************
           COPY 'griaut'.
           COPY 'griaup'.
           COPY 'griauv'.
           COPY 'gribut'.
           COPY 'gritab'.
           COPY 'grim770'.
       FD  WDSLAV LABEL RECORD STANDARD 
           VALUE OF FILE-ID ID-LAV
           RECORD 164 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
              10 KLV-QUA   PIC X.
              10 KLV-RIT   PIC 9.
              10 KLV-DIT   PIC 9.
              10 KLV-RGS   PIC X(42).
              10 KLV-COD   PIC 9(7).
              10 KLV-CAU   PIC 9(3).
              10 KLV-ALI   PIC 99V999.
           05 LAV-LORD     PIC S9(11)V99.
           05 LAV-NSOG     PIC S9(11)V99.
           05 LAV-ANTI     PIC S9(11)V99.
           05 LAV-RCON     PIC S9(11)V99.
           05 LAV-IMPO     PIC S9(11)V99.
           05 LAV-RITE     PIC S9(11)V99.
           05 LAV-RITIM    PIC S9(11)V99.
           05 LAV-RITS     PIC S9(11)V99.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'gritabrk'.
           COPY 'grit24rk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'prfisc'.
      **** rel 6.2
           COPY 'parpcfgr'.
           COPY 'parpcfgc'.
      ************
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
      **** rel 6.0
      *01  ID-AUA PIC X(15) VALUE 'aziaua'.
      ************
       01  ID-AUT PIC X(15) VALUE 'anaaut'.
       01  ID-AUP PIC X(15) VALUE 'pagaup'.
       01  ID-AUV PIC X(15) VALUE 'verauv'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-BUT PIC X(15) VALUE 'tribut'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
      **** rel 6.2
      *01  ID-770 PIC X(15) VALUE 'mod770'.
       01  ID-770 PIC X(80) VALUE 'mod770'.
      ************
       01  COMODI.
           05 SF-AZI  PIC XX.
      **** rel 6.0
      *    05 SF-AUA  PIC XX.
      ************
           05 SF-AUT  PIC XX.
           05 SF-AUP  PIC XX.
           05 SF-AUV  PIC XX.
           05 SF-TAB  PIC XX.
           05 SF-BUT  PIC XX.
           05 SF-LAV  PIC XX.
           05 SF-770  PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 J2      PIC 9(3)  VALUE ZERO.
           05 COMDT   PIC 9(8)  VALUE ZERO.
           05 COMDA   PIC 9(4)  VALUE ZERO.
           05 FLPAG   PIC 9      VALUE ZERO.
      **** rel 6.2
           05 PATH     PIC X(80) VALUE SPACE.
      ************
      **** rel 7.2
           05 PRIMO   PIC 9.  
           05 COMNCO.
              10 COMA PIC X.  
              10 COMN PIC 99.  
      ************

      * Comodi per campi non posizionali record
      * di tipo "E" "F" "G" "H"
           05 COMQUA. 
              10 QUA PIC X(2).
              10 NRI PIC 9(3).
              10 NCOA.
                 15 NCO PIC 9(3).
           05 COMCAM  PIC X(16).  
           05 CAMPN  REDEFINES COMCAM PIC Z(15)9.  
           05 CAMPD  REDEFINES COMCAM PIC Z(10)9(6).  
           05 CAMPDT REDEFINES COMCAM PIC Z(8)9(8).  
           05 CAMPDA REDEFINES COMCAM PIC Z(12)9(4).  
      **** rel 5.2
           05 CAMPDC REDEFINES COMCAM.
      **** nt 71
      *       10 NINT PIC Z(13)9.
              10 NINT PIC Z(12)9.
              10 VIRGOLA PIC X(1). 
      **********
              10 NDEC PIC 9(2).
      ************
           05 CAMP.
              10 CAMP1 PIC X(16).
              10 CAMP2 PIC X(15).
              10 CAMP3 PIC X(15).
           05 MODELLO.
              10 MOD PIC 9(2) VALUE 77.
              10 LET PIC X    VALUE 'S'.
              10 ANM PIC 9(2) VALUE ZERO.
      * Definizione campi non posizionali per record
      * di tipo "E"
       01  TRFGH OCCURS 75.
           05 770-QUADRO.
              10 770-QUA PIC X(2).
              10 770-RIG PIC X(3).
              10 770-COL PIC X(3).
           05 770-CAMPO  PIC X(16).  
       01  AREAFGH REDEFINES TRFGH PIC X(1800). 
      * comodi per riepilogativo
       01  RIEPIL.
           05 LORD   PIC S9(13) VALUE ZERO.
           05 NSOG   PIC S9(13) VALUE ZERO.
           05 ANTI   PIC S9(13) VALUE ZERO.
           05 RCON   PIC S9(13) VALUE ZERO.
           05 IMPO   PIC S9(13) VALUE ZERO.
           05 RITE   PIC S9(13) VALUE ZERO.
           05 RITS   PIC S9(13) VALUE ZERO.
           05 NUMP   PIC 9(5)   VALUE ZERO.
           05 NTREC  PIC 9(5)   VALUE ZERO.
           05 NRECB  PIC 9(5)   VALUE ZERO.
           05 NRECE  PIC 9(5)   VALUE ZERO.
           05 NRECH  PIC 9(5)   VALUE ZERO.
           05 TIMPON PIC S9(13) VALUE ZERO.
      **** rel 5.2
      *    05 TRITEN PIC S9(13) VALUE ZERO.
           05 TRITEN PIC S9(13)V99 VALUE ZERO.
      ************
           05 TTOVER PIC S9(13) VALUE ZERO.
           05 CODICE PIC 9(7)   VALUE ZERO.
           05 TQUA   PIC X      VALUE SPACE.
           05 TREC   PIC X      VALUE SPACE.
           05 NRMO   PIC 9(6)   VALUE ZERO.
           05 PERIO.
              10 PAN4 PIC 9(4) VALUE ZERO.
              10 PMES PIC 9(2) VALUE ZERO.
           05 PERMA PIC 9(6).
           05 FILLER REDEFINES PERMA.
              10 PME  PIC 9(2).
              10 PAN  PIC 9(4).

       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-ESERC     PIC 9(4).
           05 IF-CFSOS     PIC X(16).
           05 IF-DTEM      PIC 9(6).
      **** rel 6.2
           05 IF-770-D     PIC X(80).
      ************
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
      **** rel 6.0
      *    COPY 'dclaua'.
      ************
           COPY 'dclaut'.
           COPY 'dclaup'.
           COPY 'dclauv'.
           COPY 'dclbut'.
           COPY 'dcltab'.
           COPY 'dcllav'.
           COPY 'dcl770'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vrit190: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           CLOSE ANAAUT.
           CLOSE PAGAUP.
           CLOSE TRIBUT.
           CLOSE WDSLAV.
           CLOSE VERAUV.
           CLOSE MOD770.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
      **** rel 6.0
      *    COPY 'griauaer'.
      ************
           COPY 'griauter'.
           COPY 'griauper'.
           COPY 'griauver'.
           COPY 'gributer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN INPUT VERAUV.
           OPEN INPUT TRIBUT.
           OPEN INPUT ANAAUT.
           OPEN INPUT PAGAUP.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O WDSLAV.
      *
           MOVE IF-AZI TO KAZ-COD.
      **** rel 6.0
      *    READ ANAAZI INVALID PERFORM INVK-AZI
      *                        GO TO ERRIO.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      ************
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.

           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DTEM.
      **** rel 6.2
           MOVE AA9   TO ANM.
      ************

           MOVE ZERO   TO IF-ESERC.
           MOVE SPACE  TO IF-CFSOS.
      **** rel 6.2
           MOVE SPACE TO PATH.
           IF EX-DFL NOT = LOW-VALUE AND
              EX-FL NOT = LOW-VALUE
                STRING EX-DFL EX-FL '\' DELIMITED SPACE INTO PATH.
           IF EX-WS NOT = LOW-VALUE AND
              EX-UTI NOT = LOW-VALUE
      **** rel 6.3
      *          MOVE EX-UTI TO PCFG-PATH
                 DISPLAY 'PRF-DIR' UPON ENVIRONMENT-NAME
                 ACCEPT PCFG-PATH FROM ENVIRONMENT-VALUE ON EXCEPTION
                        MOVE EX-UTI TO PCFG-PATH
                 END-ACCEPT
      ************
                 MOVE ZERO TO PCFG-R-FUN
                 MOVE EX-WS TO PCFG-R-WS
                 MOVE 'PATH-770' TO PCFG-R-COD
                 CALL 'readcfg' USING PARPCFG-R PCFG-CTR
                                      ON EXCEPTION MOVE 9 TO PCFG-ST
                 END-CALL
                 IF PCFG-ST = ZERO AND PCFG-R-VAL NOT = SPACE
                    MOVE SPACE TO PATH
                    STRING PCFG-R-VAL '\' DELIMITED SPACE INTO PATH.

           MOVE SPACE TO ID-770.
           STRING PATH DELIMITED SPACE
                  'mod770' ANM DELIMITED SIZE INTO ID-770.
           MOVE ID-770 TO IF-770-D.
      ************
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-ESERC.
           MOVE 'IF-ESERC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ESERC.
           CALL 'ranno4' USING IF-ESERC.
           IF IF-ESERC = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
      **** rel 6.3
      *    IF IF-ESERC < 1900 
           IF IF-ESERC < 1940 
      ************
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-ESERC.
      *
       V-CFSOS.
           MOVE 'IF-CFSOS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CFSOS.
           MOVE IF-CFSOS TO COMFISC.
      *    CALL 'rfisc' USING PARFISC.
      *    IF RISPFISC NOT = ZERO
      *       MOVE "Codice fiscale errato" TO MESS
      *       GO TO V-ERROR.
       E-CFSOS.
      *
       V-DTEM.
           MOVE 'IF-DTEM' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTEM.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTEM TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AA9   TO ANM.
      **** rel 6.2
           MOVE SPACE TO ID-770.
           STRING PATH DELIMITED SPACE
                  'mod770' ANM DELIMITED SIZE INTO ID-770.
           MOVE ID-770 TO IF-770-D.
      ************
       E-DTEM.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
      *
      **** rel 6.0
      *    OPEN INPUT AZIAUA.
      *    MOVE KAZ-COD TO KAA-AZI.
      *    READ AZIAUA INVALID PERFORM INVK-AUA
      *                        CLOSE AZIAUA
      *                        GO TO ERRIO.
      *    CLOSE AZIAUA.
      ************
      *
           MOVE ZERO TO KEYAP KAP-DTR FLPAG.
           MOVE KAZ-COD  TO KAP-AZI.
           MOVE IF-ESERC TO KAP-ESE.
           START PAGAUP KEY NOT < KEYAP INVALID GO TO INS99.
       INS00.
           READ PAGAUP NEXT AT END GO TO INS99.
           IF SF-AUP = '9D' OR '9A' OR '35' GO TO INS00.
           IF KAP-AZI > KAZ-COD OR 
              KAP-ESE > IF-ESERC GO TO INS99.
           IF AUP-FLV = 2 GO TO INS00.

           MOVE KP3-TRI TO KUT-TRI.
           READ TRIBUT INVALID PERFORM INVK-BUT
                               PERFORM VISK-AUP
                               GO TO ERRIO.

      **** rel 6.0
      *    IF NOT (BUT-QUA = 'D  ' OR 'D-1') GO TO INS00.
      ************
           MOVE KAP-CAU TO KLV-CAU KTB-COD.
           MOVE 24 TO KTB-TIP.
           READ TABELL INTO REKT24 INVALID PERFORM INVK-TAB
                                           PERFORM VISK-AUP
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T24-TRIBU NOT = KP3-TRI
              MOVE 'CAUS.-TRIB. INCONGR.' TO MESS
              GO TO ERRIO.
      **** rel 6.0
      *    IF BUT-QUA = 'D-1' MOVE T24-TIPRT TO KLV-RIT
      *                       ADD 1      TO KLV-RIT
      *                       MOVE 'E'   TO KLV-QUA 
      *    ELSE               MOVE ZERO TO KLV-RIT
      *                       ADD 1 TO KLV-RIT
      *                       MOVE 'C'   TO KLV-QUA.
           MOVE 1   TO KLV-RIT.
           MOVE 'C' TO KLV-QUA.
      ************

           MOVE T24-ALIQU TO KLV-ALI.           
           MOVE KAZ-COD TO KAT-AZI.
           MOVE KAP-COD TO KAT-COD.
           READ ANAAUT INVALID PERFORM INVK-AUT
                               PERFORM VISK-AUP
                               GO TO ERRIO.
           IF AUT-TIP = 2
              MOVE 1 TO KLV-DIT
           ELSE
              MOVE 2 TO KLV-DIT.
           MOVE AUT-RGSOC TO KLV-RGS.
           MOVE KAP-COD   TO KLV-COD.
           READ WDSLAV INVALID
                MOVE ZERO TO LAV-LORD LAV-NSOG LAV-RCON
                             LAV-ANTI LAV-IMPO LAV-RITE LAV-RITIM
                             LAV-RITS
                WRITE RF-LAV.
           COMPUTE AUP-NSO = AUP-SOG - AUP-IMP.
           ADD AUP-SOG  TO LAV-LORD.
           ADD AUP-ANT  TO LAV-LORD.
      **** rel 6.0
      *    IF BUT-QUA NOT = 'D-1' 
      ************
                ADD AUP-RCON TO LAV-LORD
                ADD AUP-NSO  TO LAV-ANTI 
                ADD AUP-ANT  TO LAV-ANTI
                ADD AUP-RCON TO LAV-RCON 
                COMPUTE
                    LAV-IMPO = LAV-LORD - LAV-ANTI - LAV-RCON
      **** rel 6.0
      *    ELSE 
      *         ADD AUP-NSO  TO LAV-NSOG
      *         ADD AUP-ANT  TO LAV-NSOG
      *         COMPUTE 
      *             LAV-IMPO = LAV-LORD - (LAV-NSOG + LAV-ANTI).
      ************

      *> lav-rite = ritenute a titolo di acconto
           IF BUT-TIP = ZERO
              ADD AUP-RIT TO LAV-RITE.

      *> lav-ritim = ritenute a titolo di imposta
           IF BUT-TIP = 1
              ADD AUP-RIT TO LAV-RITIM.

      *> lav-rits = ritenute sospese
           IF AUP-FLS = 1 ADD AUP-RIT TO LAV-RITS.

           REWRITE RF-LAV INVALID MOVE 'RWR.LAV' TO MESS GO TO ERRIO.
           MOVE 1 TO FLPAG.
           GO TO INS00.
       INS99.
           IF FLPAG = ZERO GO TO EX-RUN-ELABORA.

      **** rel 6.2
      *    STRING 'mod770' DELIMITED SIZE
      *    ANM DELIMITED SIZE INTO ID-770.
      ************
           OPEN OUTPUT MOD770.
      *
      *--- Leggo il file di sort wdslav.
      *
           MOVE ZERO TO KEYLV.
           MOVE SPACE TO KLV-RGS.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO FINE.
      *
           MOVE ZERO TO CODICE NRMO NRI.
           MOVE SPACE TO TQUA.
           MOVE ZERO TO NTREC NRECE NRECB.
           MOVE ZERO TO NRECH.
           PERFORM AZZ-TOT THRU EX-AZZ-TOT.

           PERFORM CREA-REC-A THRU EX-REC-A.

           PERFORM CREA-REC-B THRU EX-REC-B.

           PERFORM CREA-REC-H THRU EX-REC-H. 

       RNEXT-LAV.
           READ  WDSLAV NEXT AT END GO TO END-LAV.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO RNEXT-LAV.
           MOVE KAZ-COD TO KAT-AZI.

           IF TQUA NOT = SPACE
              PERFORM END-REC-H THRU EX-END-REC-H
              PERFORM AZZ-TOT THRU EX-AZZ-TOT
              PERFORM CREA-REC-H THRU EX-REC-H.

           MOVE KLV-QUA TO TQUA.
           MOVE KLV-COD TO KAT-COD.
           IF KLV-COD NOT = CODICE 
              ADD 1 TO NUMP
              MOVE KLV-COD TO CODICE.
           READ ANAAUT INVALID PERFORM INVK-AUT
                               GO TO ERRIO.
           IF (TQUA = 'C' AND NRI = 999)  OR
              (TQUA = 'E' AND NRI = 999)
                   PERFORM END-REC-H THRU EX-END-REC-H
                   MOVE ZERO TO NRI
                   PERFORM CREA-REC-H THRU EX-REC-H.
           IF TQUA = 'C' OR 'E'
                   PERFORM CREA-QUA-CE THRU EX-QUA-CE.

           GO TO RNEXT-LAV.
       END-LAV.
           PERFORM END-REC-H THRU EX-END-REC-H.

           PERFORM RIT-VER THRU EX-RIT-VER.

           PERFORM CREA-REC-Z THRU EX-REC-Z.

       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-REC-A.
           MOVE SPACE   TO 770A.

           MOVE 'A'     TO 770A-TRA.
           MOVE MODELLO TO 770A-CDF.

      **** rel 4.1
      *    IF AUA-TIP = 2 MOVE 1 TO 770A-TFO
      *    ELSE           MOVE 2 TO 770A-TFO.
      *    MOVE AUA-FIS TO 770A-CFFO.
      ************
      **** rel 6.2
           MOVE 01 TO 770A-TFO.
           MOVE AZI-CFISC TO 770A-CFFO.
      ************

      *> Persona Fisica
      *> ex campi dal 6 al 28 non piu' usati ridefiniscono
      *> 770A-FIL2 in caso serviranno ancora.
      *    IF AUA-TIP = 2
      *       MOVE AUA-CGN TO 770A-CNF
      *       MOVE AUA-NOM TO 770A-NOF
      *       MOVE AUA-SES TO 770A-SEF
      *       MOVE AUA-DNA TO AAGGG
      *       MOVE 2 TO TIPOP1
      *       CALL 'rdata' USING PARCDT
      *       MOVE GGMMAA4 TO 770A-DTNA
      *       MOVE AUA-CNA TO 770A-COFN
      *       MOVE AUA-PNA TO 770A-PRFN
      *       MOVE AUA-CDO TO 770A-CODF
      *       MOVE AUA-PDO TO 770A-PRDF
      *       MOVE AUA-IND TO 770A-INDF
      *       MOVE AUA-CAP TO 770A-CAPD.

      *** Persone non Fisiche (societa')
      *    IF AUA-TIP = 1
      *       MOVE AUA-RGSOC TO 770A-RGSOC
      *       MOVE AZI-CIT   TO 770A-COSL
      *       MOVE AZI-PRV   TO 770A-PRSL
      *       MOVE AZI-INDIR TO 770A-INDSL
      *       MOVE AZI-CAP   TO 770A-CAPF
      *       MOVE AUA-CDO   TO 770A-COSLA
      *       MOVE AUA-PDO   TO 770A-PRSLA
      *       MOVE AUA-IND   TO 770A-INFO
      *       MOVE AUA-CAP   TO 770A-CAPDF.
      ************

           MOVE SPACE      TO 770A-FIL2.
           MOVE ZERO       TO 770A-PRGI.
           MOVE ZERO       TO 770A-TOTI.

           MOVE 'A'        TO 770A-FIL6.
           MOVE X'0D'      TO 770A-VACR.
           MOVE X'0A'      TO 770A-VALF.
           WRITE RF-M770.
       EX-REC-A.
           EXIT.
      *-----*
       CREA-REC-B.
           MOVE SPACE   TO 770B.

           MOVE ZERO    TO 770B-FLGC.
           MOVE ZERO    TO 770B-DTNA.
           MOVE SPACE   TO 770B-SESS.
      **** rel 5.2
      *    MOVE ZERO    TO 770B-FIL1.
      **** rel 6.2
      *    MOVE SPACE   TO 770B-FIL1.
      ************
      ************
           MOVE ZERO    TO 770B-CADF.
           MOVE ZERO    TO 770B-NTEL.
           MOVE ZERO    TO 770B-NFAX.
           MOVE ZERO    TO 770B-EMAIL.
           MOVE ZERO    TO 770B-FIL2.
           MOVE ZERO    TO 770B-CASL.
           MOVE ZERO    TO 770B-FIL3.
           MOVE ZERO    TO 770B-CPF1.
           MOVE ZERO    TO 770B-STAT.
           MOVE ZERO    TO 770B-NAGI.
           MOVE ZERO    TO 770B-SITU.
      **** rel 6.2
      *    MOVE ZERO    TO 770B-PRGT.
      *    MOVE ZERO    TO 770B-PRGX.
      *    MOVE ZERO    TO 770B-NDIP.
      *    MOVE ZERO    TO 770B-NAUT.
      ************

           MOVE 'B'     TO 770B-TRB.
           MOVE 1       TO 770B-PRMO.
      **** rel 6.0
      *    MOVE AUA-FIS TO 770B-CFDI.
      *
      *    IF AUA-TIP = 2
      *       MOVE AUA-CGN   TO 770B-COGN
      *       MOVE AUA-NOM   TO 770B-NOME
      *    ELSE
      *       MOVE AUA-RGSOC TO 770B-DENO.
           MOVE AZI-CFISC TO 770B-CFDI.
           MOVE AZRGSOC TO 770B-DENO.

      ************
           MOVE ZERO    TO 770B-DIIN.
           MOVE ZERO    TO 770B-DICO
      **** rel 6.3
                           770B-DICIP
      ************
                           770B-FIL5
      **** rel 5.2
      *                    770B-FIL7
      ************
                           770B-FIL10
      **** rel 5.2
      *                    770B-FIL12
      *                    770B-FIL14
      *                    770B-FIL17
      *                    770B-FIL19
      ************
      **** rel 5.2
      *                    770B-FIL21
      ************
                           770B-FIL22.

      **** rel 6.0
      *    IF AUA-TIP = 2
      *       MOVE AUA-DNA TO AAGGG
      *       MOVE 2 TO TIPOP1
      *       CALL 'rdata' USING PARCDT
      *       MOVE GGMMAA4 TO 770B-DTNA 
      *       MOVE AUA-SES TO 770B-SESS
      *       MOVE AUA-CNA TO 770B-CONA
      *       MOVE AUA-PNA TO 770B-PRNA
      ***** rel 5.2
      **       MOVE ZERO    TO 770B-FIL1
      *       MOVE SPACE   TO 770B-FIL1
      *************
      *       MOVE AUA-CDO TO 770B-CODF
      *       MOVE AUA-PDO TO 770B-PRDF
      *       MOVE AUA-IND TO 770B-INDF
      *       MOVE AUA-CAP TO 770B-CADF
      *       MOVE AUA-CAT TO 770B-CDAT
      *       MOVE ZERO    TO 770B-NTEL
      *       MOVE ZERO    TO 770B-NFAX
      *       MOVE ZERO    TO 770B-EMAIL.
      ************

      **** rel 6.0
      *    IF AUA-TIP = 1
      ************
              MOVE ZERO      TO 770B-FIL2
              MOVE AZI-CIT   TO 770B-COSL 
              MOVE AZI-PRV   TO 770B-PRSL
              MOVE AZI-INDIR TO 770B-INSL
              MOVE AZI-CAP   TO 770B-CASL 
              MOVE ZERO      TO 770B-FIL3
      **** rel 6.2
              MOVE SPACE     TO 770B-COMSL
      ************
      **** rel 6.0
      *       MOVE AUA-CDO   TO 770B-CDF1
      *       MOVE AUA-PDO   TO 770B-PDF1
      *       MOVE AUA-IND   TO 770B-IDF1
      *       MOVE AUA-CAP   TO 770B-CPF1
      ************
      **** Verificare tabelle come da istruz.
              MOVE ZERO      TO 770B-STAT
              MOVE ZERO      TO 770B-NAGI 
              MOVE ZERO      TO 770B-SITU.
      **** rel 6.1
      **** rel 6.2
      *    MOVE ZERO         TO 770B-NORCF.
      ************
      ************

      **** rel 6.2
      *    MOVE 'A'          TO 770B-FIL25.
           MOVE 'A'          TO 770B-FIL99.
      ************
           MOVE X'0D'        TO 770B-VACR.
           MOVE X'0A'        TO 770B-VALF.
           ADD 1 TO NTREC NRECB.
           WRITE RF-M770.
       EX-REC-B.
           EXIT.
      *-----*
       CREA-REC-E.
           ADD 1        TO NRMO.
           MOVE SPACE   TO 770E.

           MOVE 'E'     TO 770E-TRG TREC.
      **** rel 6.0
      *    MOVE AUA-FIS TO 770E-CFSD.
           MOVE AZI-CFISC TO 770E-CFSD.
      ************
           MOVE NRMO    TO 770E-NRMO.
           PERFORM AZZ-CAMPI THRU EX-AZZ-CAMPI.
       EX-REC-E.
           EXIT.
      *-----*
       END-REC-E.
           MOVE AREAFGH TO 770E-FIL1.
           MOVE 'A'     TO 770E-FIL3.
           MOVE X'0D'   TO 770E-VACR.
           MOVE X'0A'   TO 770E-VALF.
           ADD 1 TO NTREC NRECE.
           WRITE RF-M770.
       EX-END-REC-E.
           EXIT.
      *-----*
       CREA-REC-H.
           ADD 1        TO NRMO.
           MOVE SPACE   TO 770H.

           MOVE 'H'     TO 770H-TRG TREC.
      **** rel 6.0
      *    MOVE AUA-FIS TO 770H-CFSD.
           MOVE AZI-CFISC TO 770H-CFSD.
      ************
           MOVE NRMO    TO 770H-NRMO.
           PERFORM AZZ-CAMPI THRU EX-AZZ-CAMPI.
       EX-REC-H.
           EXIT.
      *-----*
       END-REC-H.
           MOVE AREAFGH TO 770H-FIL1.
           MOVE 'A'     TO 770H-FIL3.
           MOVE X'0D'   TO 770H-VACR.
           MOVE X'0A'   TO 770H-VALF.
           ADD 1 TO NTREC NRECH.
           WRITE RF-M770.
       EX-END-REC-H.
           EXIT.
      *-----*
       CREA-QUA-CE.
           MOVE 'AU' TO QUA.

           IF NRI = ZERO
              MOVE IF-CFSOS TO COMCAM
              PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.

      **** rel 7.2
           MOVE 'A' TO COMA.
      ************
           ADD 1  TO NRI.
           MOVE ZERO TO NCO.
           MOVE AUT-FIS TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
           MOVE AUT-FIS TO 770H-CFPP.

           IF KLV-DIT = 2 
              MOVE AUT-RGSOC TO CAMP
              PERFORM CAR-CAMPX THRU EX-CAR-CAMPX
      **** rel 7.2
      *       ADD 5 TO NCO
              ADD 17 TO NCO
      ************
              GO TO A30
           ELSE
              MOVE AUT-CGN   TO CAMP
              PERFORM CAR-CAMPX THRU EX-CAR-CAMPX.

           MOVE AUT-NOM TO CAMP.
           PERFORM CAR-CAMPX THRU EX-CAR-CAMPX.

           MOVE AUT-SES TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
            
           MOVE AUT-DNA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA4 TO COMDT.
           MOVE COMDT  TO CAMPDT.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.

      **** rel 6.3
      *    MOVE AUT-CNA TO CAMP.
           IF AUT-CNA(1:5) NUMERIC *> Tolgo il cap
              IF AUT-CNA(6:1) = SPACE
                 MOVE AUT-CNA(7:) TO CAMP
              ELSE
                 MOVE AUT-CNA(6:) TO CAMP
              END-IF
           ELSE
              MOVE AUT-CNA TO CAMP.
      ************
           PERFORM CAR-CAMPX THRU EX-CAR-CAMPX.

           IF AUT-PNA = 'EE' MOVE SPACE TO AUT-PNA.
           MOVE AUT-PNA TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
      **** rel 7.2
      *
           MOVE SPACE TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
           ADD 11 TO NCO.
      ************
       A30.
      **** rel 6.2
      *    IF AUT-PDO = 'EE' ADD 4 TO NCO
      **** rel 7.1
      *    IF AUT-PDO = 'EE' ADD 6 TO NCO
      **** rel 7.2
      *    IF AUT-PDO = 'EE' ADD 7 TO NCO
           IF AUT-PDO = 'EE' ADD 20 TO NCO
      ************
      ************
      ************
                                    GO TO A40.
      **** rel 6.3
      *    MOVE AUT-CDO TO CAMP.
           IF AUT-CDO(1:5) NUMERIC *> Tolgo il cap
              IF AUT-CDO(6:1) = SPACE
                 MOVE AUT-CDO(7:) TO CAMP
              ELSE
                 MOVE AUT-CDO(6:) TO CAMP
              END-IF
           ELSE
              MOVE AUT-CDO TO CAMP.
      ************
           PERFORM CAR-CAMPX THRU EX-CAR-CAMPX.

           MOVE AUT-PDO TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
       A35.
      **** rel 7.2
      **** rel 7.1
      *    ADD 1 TO NCO.
      *    ADD 2 TO NCO.
      ************
      *    MOVE AUT-IND TO CAMP.
      *    PERFORM CAR-CAMPX THRU EX-CAR-CAMPX.
      **** rel 6.2
      *    MOVE '0               ' TO COMCAM.
      *    PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
      *    ADD 1 TO NCO.
      ************
      ************
       A40.
           IF TQUA = 'E' ADD 4 TO NCO
                         GO TO A50.
           IF AUT-PDO NOT = 'EE' ADD 4 TO NCO
                                 GO TO A50.

           MOVE AUT-FSE TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.

           MOVE AUT-CDO TO CAMP.
           PERFORM CAR-CAMPX THRU EX-CAR-CAMPX.

           MOVE AUT-IND TO CAMP.
           PERFORM CAR-CAMPX THRU EX-CAR-CAMPX.

           MOVE AUT-CDE TO CAMPN.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
       A50.
      **** rel 7.2
           MOVE '0' TO COMA.
           MOVE ZERO TO NCO.
      ************
           MOVE 24 TO KTB-TIP.
           MOVE KLV-CAU TO KTB-COD.
           READ TABELL INTO REKT24 INVALID
                MOVE ALL '*' TO T24-DSABB T24-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T24-DSABB(1:1) TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
       
      **** rel 5.2
      *    MOVE 2003     TO COMDA.
      **** rel 6.1
      *    MOVE 2004     TO COMDA.
           MOVE IF-ESERC TO COMDA.
      ************
      ************
           MOVE COMDA  TO CAMPDA.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.

      **** rel 6.2
      *    ADD 1 TO NCO.
           MOVE '0               ' TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
      ************

      *> solo importi positivi
           IF LAV-LORD < ZERO MULTIPLY -1 BY LAV-LORD.
      **** rel 5.2
      *    MOVE LAV-LORD TO CAMPN.
           MOVE LAV-LORD(1:11) TO NINT.
      **** nt 71
           MOVE ','            TO VIRGOLA.
      **********
           MOVE LAV-LORD(12:2) TO NDEC.
      ************
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.

      *> solo importi positivi
           IF LAV-NSOG < ZERO MULTIPLY -1 BY LAV-NSOG.
           IF LAV-RCON < ZERO MULTIPLY -1 BY LAV-RCON.
           IF LAV-ANTI < ZERO MULTIPLY -1 BY LAV-ANTI.

           IF TQUA = 'E'
              ADD 1 TO NCO
      **** nt 71
              MOVE 3 TO CAMPN
      **** rel 7.2
      *       IF LAV-NSOG = ZERO MOVE ZERO TO CAMPN
              IF LAV-ANTI = ZERO MOVE ZERO TO CAMPN
      ************
              END-IF
              PERFORM CAR-CAMPI THRU EX-CAR-CAMPI
      **********
      **** rel 5.2
      *       MOVE LAV-NSOG TO CAMPN 
              MOVE LAV-NSOG(1:11) TO NINT
      **** nt 71
              MOVE ','            TO VIRGOLA
      **********
              MOVE LAV-NSOG(12:2) TO NDEC
      ************
              PERFORM CAR-CAMPI THRU EX-CAR-CAMPI
      **** rel 5.2
      *    ELSE MOVE LAV-RCON TO CAMPN 
           ELSE
                MOVE LAV-RCON(1:11) TO NINT
      **** nt 71
                MOVE ','            TO VIRGOLA
      **********
                MOVE LAV-RCON(12:2) TO NDEC
      ************
                PERFORM CAR-CAMPI THRU EX-CAR-CAMPI
      **** nt 71
                MOVE 3 TO CAMPN
      **** rel 7.2
      *         IF LAV-NSOG = ZERO MOVE ZERO TO CAMPN
                IF LAV-ANTI = ZERO MOVE ZERO TO CAMPN
      ************
                END-IF
                PERFORM CAR-CAMPI THRU EX-CAR-CAMPI
      **********
      **** rel 5.2
      *         MOVE LAV-ANTI TO CAMPN
                MOVE LAV-ANTI(1:11) TO NINT
      **** nt 71
                MOVE ','            TO VIRGOLA
      **********
                MOVE LAV-ANTI(12:2) TO NDEC
      ************
                PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
         
      *> solo importi positivi (Imponibile)
           IF LAV-IMPO < ZERO MULTIPLY -1 BY LAV-IMPO.
      **** rel 5.2
      *    MOVE LAV-IMPO TO CAMPN.
           MOVE LAV-IMPO(1:11) TO NINT.
      **** nt 71
           MOVE ','            TO VIRGOLA.
      **********
           MOVE LAV-IMPO(12:2) TO NDEC.
      ************
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.

      *> ritenute a titolo d'acconto (but-tip = 1)
      *> solo importi positivi
           IF LAV-RITE < ZERO MULTIPLY -1 BY LAV-RITE.
      **** rel 5.2
           IF LAV-RITE > LAV-IMPO MOVE LAV-IMPO TO LAV-RITE.
           MOVE LAV-RITE(1:11) TO NINT.
      **** nt 71
           MOVE ','            TO VIRGOLA.
      **********
           MOVE LAV-RITE(12:2) TO NDEC.
      *    MOVE LAV-RITE TO CAMPN.
      ************
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.

      *> ritenute a titolo d'imposta, a saldo (but-tip = 1)
           IF LAV-RITIM < ZERO MULTIPLY -1 BY LAV-RITIM.
      **** rel 5.2
           IF LAV-RITIM > LAV-IMPO MOVE LAV-IMPO TO LAV-RITIM.
           MOVE LAV-RITIM(1:11) TO NINT.
      **** nt 71
           MOVE ','             TO VIRGOLA.
      **********
           MOVE LAV-RITIM(12:2) TO NDEC.
      *    MOVE LAV-RITIM TO CAMPN.
      ************
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
      **** rel 5.2
           COMPUTE TRITEN =  LAV-RITE + LAV-RITIM.
      ************

      *> ritenute sospese
      *> solo importi positivi
           IF LAV-RITS < ZERO MULTIPLY -1 BY LAV-RITS.
      **** rel 5.2
           IF LAV-RITS > TRITEN MOVE TRITEN TO LAV-RITS.
           MOVE LAV-RITS(1:11) TO NINT.
      **** nt 71
           MOVE ','            TO VIRGOLA.
      **********
           MOVE LAV-RITS(12:2) TO NDEC.
      *    MOVE LAV-RITS TO CAMPN.
      ************
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.

       EX-QUA-CE.
           EXIT.

      *-----*
       RIT-VER.   
           MOVE 'T'  TO TQUA.
       RIT-VER-Q.   
           MOVE ZERO TO NRMO.
           PERFORM CREA-REC-E THRU EX-REC-E.

           MOVE ZERO TO KEYV3.
           START VERAUV KEY NOT < KEYV3 INVALID GO TO END-RIT-VER.
       RD-RIT-VER.
           READ VERAUV NEXT AT END GO TO END-RIT-VER.
           IF SF-AUV = '9D' OR '9A' OR '35' GO TO RD-RIT-VER.
           IF KAV-AZI NOT = KAZ-COD  GO TO RD-RIT-VER.
           IF KAV-ESE NOT = IF-ESERC GO TO RD-RIT-VER.
      **** rel 6.3
      *    IF NRI = 13
           IF NRI = 25
      ************
                   PERFORM END-REC-E THRU EX-END-REC-E
                   MOVE ZERO TO NRI
                   PERFORM CREA-REC-E THRU EX-REC-E.

           PERFORM CREA-QUA-T THRU EX-QUA-T
           GO TO RD-RIT-VER.
       END-RIT-VER.   
           PERFORM END-REC-E THRU EX-END-REC-E.
       EX-RIT-VER.   
           EXIT.
      *-----*
       CREA-QUA-T.
           MOVE 'ST'    TO QUA.

           IF NRI = ZERO ADD 1 TO NRI
              MOVE IF-CFSOS TO COMCAM
              PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.

           ADD 1  TO NRI.
           MOVE ZERO TO NCO.

           MOVE KAV-DAT TO PERIO.
           MOVE PAN4    TO PAN.
           MOVE PMES    TO PME.
           MOVE PERMA   TO CAMPD.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.

      *> solo importi positivi
           IF AUV-RIT < ZERO MULTIPLY -1 BY AUV-RIT.
      **** rel 5.2
      *    MOVE AUV-RIT TO CAMPN.
           MOVE AUV-RIT(1:11) TO NINT.
      **** nt 71
           MOVE ','           TO VIRGOLA.
      **********
           MOVE AUV-RIT(12:2) TO NDEC.
      ************
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.

           ADD 2 TO NCO.

      *> solo importi positivi
           IF AUV-VER < ZERO MULTIPLY -1 BY AUV-VER.
      **** rel 5.2
      *    MOVE AUV-VER TO CAMPN.
           MOVE AUV-VER(1:11) TO NINT.
      **** nt 71
           MOVE ','           TO VIRGOLA.
      **********
           MOVE AUV-VER(12:2) TO NDEC.
      ************
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.

           ADD 3 TO NCO.

           MOVE KAV-TRI TO KUT-TRI.
           READ TRIBUT INVALID MOVE ZERO TO KAV-TRI.
           MOVE KAV-TRI TO CAMPN.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.

           ADD 2 TO NCO.
           MOVE AUV-DTV TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA4 TO COMDT.
           MOVE COMDT  TO CAMPN.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.

       EX-QUA-T.
           EXIT.
      *-----*
       CREA-REC-Z.
           MOVE SPACE TO 770Z.
           
           MOVE 'Z'   TO 770Z-TRZ.

           MOVE NRECB   TO 770Z-NRTB.
           MOVE NRECE   TO 770Z-NRTE.
           MOVE ZERO    TO 770Z-NRTF.
           MOVE ZERO    TO 770Z-NRTG.
           MOVE NRECH   TO 770Z-NRTH.
      **** rel 6.2
           MOVE ZERO    TO 770Z-NRTJ.
      ************

           MOVE 'A'     TO 770Z-FIL4.
           MOVE X'0D'   TO 770Z-VACR.
           MOVE X'0A'   TO 770Z-VALF.
           WRITE RF-M770.
       EX-REC-Z.
           EXIT.
      *-----*
       AZZ-CAMPI.
           MOVE ZERO TO NRI NCO.
           MOVE SPACE TO COMCAM.
       AZZ1-CAMPI.
           MOVE 1 TO J2.
           PERFORM UNTIL J2 > 75
              MOVE SPACE TO 770-QUADRO(J2)
                            770-CAMPO(J2)
              ADD 1 TO J2
           END-PERFORM.
           MOVE ZERO TO J2.
       EX-AZZ-CAMPI.
           EXIT.
      *-----*
       AZZ-TOT.
           MOVE ZERO TO LORD NSOG ANTI
                        RCON IMPO RITE
                        RITS NUMP.
       EX-AZZ-TOT.
           EXIT.
      *-----*
       CAR-CAMPI.
           IF NRI NOT = ZERO
           ADD 1 TO NCO.
      **** rel 7.2
           IF COMA = 'A'
              MOVE NCO TO COMN
              MOVE COMNCO TO NCOA.
      ************
           IF COMCAM = SPACE OR '               0'
                            GO TO CAR2-CAMPI.
       CAR1-CAMPI.
           ADD 1 TO J2.
           IF J2 > 75
              IF TREC = 'E'
                 PERFORM END-REC-E THRU EX-END-REC-E
                 PERFORM AZZ1-CAMPI THRU EX-AZZ-CAMPI 
                 GO TO CAR1-CAMPI
              ELSE PERFORM END-REC-E THRU EX-END-REC-E
                   PERFORM AZZ1-CAMPI THRU EX-AZZ-CAMPI
                   GO TO CAR1-CAMPI.
           MOVE COMQUA  TO 770-QUADRO(J2).
           MOVE COMCAM  TO 770-CAMPO(J2).
       CAR2-CAMPI.
           MOVE SPACE   TO COMCAM.
       EX-CAR-CAMPI.
           EXIT.
      *-----*
       CAR-CAMPX.
           MOVE CAMP1 TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
           IF CAMP2 NOT = SPACE
              STRING '+' DELIMITED SIZE
              CAMP2 DELIMITED SIZE INTO COMCAM
              PERFORM CAR1-CAMPI THRU EX-CAR-CAMPI.
           IF CAMP3 NOT = SPACE
              STRING '+' DELIMITED SIZE
              CAMP3 DELIMITED SIZE INTO COMCAM
              PERFORM CAR1-CAMPI THRU EX-CAR-CAMPI.
       EX-CAR-CAMPX.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
