       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRIT290.
      *
      **** rel 7.2
      * Nuovo 
      ************
      *         
      * OGGETTO: CREAZIONE ARCHIVIO LAVORATORI AUTONOMI
      *         
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griautsl'.
           COPY 'griaupsl'.
           COPY 'griauvsl'.
           COPY 'gributsl'.
           COPY 'gritausl'.
           COPY 'griaazsl'.
           COPY 'griaausl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS 
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
           SELECT FILAUT ASSIGN TO DISK
                  ORGANIZATION SEQUENTIAL
                  STATUS SF-FAU.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griaut'.
           COPY 'griaup'.
           COPY 'griauv'.
           COPY 'gribut'.
           COPY 'gritab'.
           COPY 'grimaut'.
           COPY 'gritau'.
           COPY 'griaaz'.
           COPY 'griaau'.
       FD  WDSLAV LABEL RECORD STANDARD 
           VALUE OF FILE-ID ID-LAV
           RECORD 180 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
              10 KLV-QUA   PIC X.
              10 KLV-RIT   PIC 9.
              10 KLV-DIT   PIC 9.
              10 KLV-RGS   PIC X(42).
              10 KLV-COD   PIC 9(7).
              10 KLV-CAU   PIC 9(3).
              10 KLV-ALI   PIC 99V999.
           05 LAV-LORD     PIC S9(11)V99.
           05 LAV-NSOG     PIC S9(11)V99.
           05 LAV-ANTI     PIC S9(11)V99.
           05 LAV-RCON     PIC S9(11)V99.
           05 LAV-IMPO     PIC S9(11)V99.
           05 LAV-RITE     PIC S9(11)V99.
           05 LAV-RITIM    PIC S9(11)V99.
           05 LAV-RITS     PIC S9(11)V99.
           05 LAV-RIP      PIC S9(11)V99.
           05 LAV-RIS      PIC S9(11)V99.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'gritabrk'.
           COPY 'grit24rk'.
           COPY 'grie02rk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'prfisc'.
           COPY 'parer'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-AUT PIC X(15) VALUE 'anaaut'.
       01  ID-AUP PIC X(15) VALUE 'pagaup'.
       01  ID-AUV PIC X(15) VALUE 'verauv'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-BUT PIC X(15) VALUE 'tribut'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  ID-FAU PIC X(80) VALUE 'filaut'.
       01  ID-TAU PIC X(15) VALUE 'tabaut'.
       01  ID-AAZ PIC X(15) VALUE 'appazi'.
       01  ID-AAU PIC X(15) VALUE 'appaut'.
       01  COMODI.
           05 SF-AZI  PIC XX.
           05 SF-AUT  PIC XX.
           05 SF-AUP  PIC XX.
           05 SF-AUV  PIC XX.
           05 SF-TAB  PIC XX.
           05 SF-BUT  PIC XX.
           05 SF-LAV  PIC XX.
           05 SF-FAU  PIC XX.
           05 SF-TAU  PIC XX.
           05 SF-AAZ  PIC XX.
           05 SF-AAU  PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 J2      PIC 9(3)  VALUE ZERO.
           05 COMDT   PIC 9(8)  VALUE ZERO.
           05 COMDA   PIC 9(4)  VALUE ZERO.
           05 FLPAG   PIC 9      VALUE ZERO.
           05 PATH     PIC X(80) VALUE SPACE.
           05 SAV-PIVA  PIC 9(11).
           05 SAV-PATH  PIC X(80).
           05 CONT      PIC 9(11).
           05 K         PIC 9(11).
           05 COM-ALIVA PIC 9(3)V99.
           05 COMVAL    PIC S9(11)V99.
      *
      * Comodi per campi non posizionali record
      * di tipo "E" "F" "G" "H"
           05 COMQUA. 
              10 QUA PIC X(2).
              10 NRI PIC 9(3).
              10 NCO PIC 9(3).
           05 COMCAM  PIC X(16).  
           05 CAMPN  REDEFINES COMCAM PIC Z(15)9.  
           05 CAMPD  REDEFINES COMCAM PIC Z(10)9(6).  
           05 CAMPDT REDEFINES COMCAM PIC Z(8)9(8).  
           05 CAMPDA REDEFINES COMCAM PIC Z(12)9(4).  
      **** rel 5.2
           05 CAMPDC REDEFINES COMCAM.
      **** nt 71
      *       10 NINT PIC Z(13)9.
              10 NINT PIC Z(12)9.
              10 VIRGOLA PIC X(1). 
      **********
              10 NDEC PIC 9(2).
      ************
           05 CAMP.
              10 CAMP1 PIC X(16).
              10 CAMP2 PIC X(15).
              10 CAMP3 PIC X(15).
           05 MODELLO.
              10 MOD PIC X(2) VALUE 'CU'.
              10 LET PIC X    VALUE 'R'.
              10 ANM PIC 9(2) VALUE 15.
      * Definizione campi non posizionali per record
      * di tipo "E"
       01  TRFGH OCCURS 75.
           05 FAU-QUADRO.
              10 FAU-QUA PIC X(2).
              10 FAU-RIG PIC X(3).
              10 FAU-COL PIC X(3).
           05 FAU-CAMPO  PIC X(16).  
       01  AREAFGH REDEFINES TRFGH PIC X(1800). 
      * comodi per riepilogativo
       01  RIEPIL.
           05 LORD   PIC S9(13) VALUE ZERO.
           05 NSOG   PIC S9(13) VALUE ZERO.
           05 ANTI   PIC S9(13) VALUE ZERO.
           05 RCON   PIC S9(13) VALUE ZERO.
           05 IMPO   PIC S9(13) VALUE ZERO.
           05 RITE   PIC S9(13) VALUE ZERO.
           05 RITS   PIC S9(13) VALUE ZERO.
           05 NUMP   PIC 9(5)   VALUE ZERO.
           05 NTREC  PIC 9(5)   VALUE ZERO.
           05 NRECB  PIC 9(5)   VALUE ZERO.
           05 NRECE  PIC 9(5)   VALUE ZERO.
           05 NRECH  PIC 9(5)   VALUE ZERO.
           05 NRECD  PIC 9(5)   VALUE ZERO.
           05 TIMPON PIC S9(13) VALUE ZERO.
      **** rel 5.2
      *    05 TRITEN PIC S9(13) VALUE ZERO.
           05 TRITEN PIC S9(13)V99 VALUE ZERO.
      ************
           05 TTOVER PIC S9(13) VALUE ZERO.
           05 CODICE PIC 9(7)   VALUE ZERO.
           05 TQUA   PIC X      VALUE SPACE.
           05 TREC   PIC X      VALUE SPACE.
           05 NRMO   PIC 9(6)   VALUE ZERO.
           05 PERIO.
              10 PAN4 PIC 9(4) VALUE ZERO.
              10 PMES PIC 9(2) VALUE ZERO.
           05 PERMA PIC 9(6).
           05 FILLER REDEFINES PERMA.
              10 PME  PIC 9(2).
              10 PAN  PIC 9(4).
           05 ORA.
              10 ORAOO PIC 99.
              10 ORAMM PIC 99.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-ESERC     PIC 9(4).
           05 IF-DTEM      PIC 9(6).
           05 IF-FAU-D     PIC X(80).
           05 IF-DICO      PIC  9.
           05 IF-PROT1     PIC  9(17).
           05 IF-PROT2     PIC  9(6).
           05 IF-TPCOD     PIC 9.
           05 IF-COD       PIC 9(7).
           05 IF-DENOM     PIC X(42).
           05 IF-CATT      PIC X(8).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
      **** rel 6.0
      *    COPY 'dclaua'.
      ************
           COPY 'dclaut'.
           COPY 'dclaup'.
           COPY 'dclauv'.
           COPY 'dclbut'.
           COPY 'dcltab'.
           COPY 'dcllav'.
           COPY 'dcltau'.
           COPY 'dclaaz'.
      **** rel 7.2
           COPY 'dclaau'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vrit290: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           CLOSE ANAAUT.
           CLOSE PAGAUP.
           CLOSE TRIBUT.
           CLOSE WDSLAV.
           CLOSE VERAUV.
           CLOSE FILAUT.
           CLOSE TABAUT.
           CLOSE APPAZI.
           CLOSE APPAUT.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griauter'.
           COPY 'griauper'.
           COPY 'griauver'.
           COPY 'gributer'.
           COPY 'gritauer'.
           COPY 'gritaber'.
           COPY 'griaazer'.
           COPY 'griaauer'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN INPUT VERAUV.
           OPEN INPUT TRIBUT.
           OPEN INPUT ANAAUT.
           OPEN INPUT PAGAUP.
           OPEN INPUT TABAUT.
           OPEN INPUT APPAZI.
           OPEN INPUT APPAUT.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O WDSLAV.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           MOVE KAZ-COD TO KAAZ-COD.
           READ APPAZI INVALID
                       MOVE SPACE TO AAZ-RGSOC AAZ-CNA AAZ-PNA
                                     AAZ-SES AAZ-CATT
                       MOVE ZERO TO AAZ-DNA.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.

           ACCEPT ORA FROM TIME
      *
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DTEM.
           MOVE AA9   TO ANM.

           MOVE ZERO   TO IF-ESERC.
           MOVE AA9 TO AA4.
           CALL 'ranno4' USING AA4.
           SUBTRACT 1 FROM AA4.
           MOVE AA4 TO IF-ESERC.
      *
           MOVE KAZ-COD   TO E02-COD.
           MOVE 'A'       TO E02-PRG.
           MOVE 02        TO E02-TIP.
           MOVE E02-KEYID TO KEYTAU.
           READ TABAUT INTO REKE02 INVALID PERFORM INVK-TAU
                                   GO TO ERRIO.
      *
           MOVE AZI-PIVA    TO SAV-PIVA.
           MOVE E02-PATHECF TO SAV-PATH.
      *
           MOVE SPACE TO ID-FAU.
           STRING SAV-PATH     DELIMITED SPACE
                  SAV-PIVA     DELIMITED SPACE
                  '_'          DELIMITED SPACE
                  IF-ESERC(3:2) DELIMITED SPACE
                  '_'           DELIMITED SPACE
                  ORA           DELIMITED SPACE
                  '_cur15'     DELIMITED SIZE INTO ID-FAU.
           MOVE ID-FAU TO IF-FAU-D.
      *
           MOVE AAZ-CATT TO IF-CATT.
      *
           MOVE ZERO TO IF-DICO.
           MOVE ZERO TO IF-PROT1.
           MOVE ZERO TO IF-PROT2.
      *
           MOVE ZERO    TO IF-TPCOD
                           IF-COD.
           MOVE SPACE   TO IF-DENOM.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-PROT1.
           MOVE 'IF-PROT1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PROT1.
           IF IF-DICO = ZERO
              GO TO E-PROT1.
           IF IF-PROT1 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-PROT1.
      *
       V-PROT2.
           MOVE 'IF-PROT2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PROT2.
           IF IF-DICO = ZERO
              GO TO E-PROT2.
           IF IF-PROT2 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-PROT2.
      *
       V-ESERC.
           MOVE 'IF-ESERC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ESERC.
           CALL 'ranno4' USING IF-ESERC.
           IF IF-ESERC = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           IF IF-ESERC < 1940 
              PERFORM ERR-DINV
              GO TO V-ERROR.
           MOVE SPACE TO ID-FAU.
           STRING SAV-PATH     DELIMITED SPACE
                  SAV-PIVA     DELIMITED SPACE
                  '_'          DELIMITED SPACE
                  IF-ESERC(3:2) DELIMITED SPACE
                  '_'           DELIMITED SPACE
                  ORA           DELIMITED SPACE
                  '_cur15'     DELIMITED SIZE INTO ID-FAU.
           MOVE ID-FAU TO IF-FAU-D.
       E-ESERC.
      *
       V-DTEM.
           MOVE 'IF-DTEM' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTEM.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTEM TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AA9   TO ANM.
       E-DTEM.
      *
       V-TPCOD.
           MOVE 'IF-TPCOD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPCOD.
           IF NOT (IF-TPCOD = 0 OR 1)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF IF-TPCOD = 1 MOVE ZERO  TO IF-COD
                           MOVE SPACE TO IF-DENOM.
       E-TPCOD.
      *
       V-COD.
           MOVE 'IF-COD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD.
           MOVE SPACE TO IF-DENOM.
           IF IF-TPCOD = 1 GO TO E-COD.
           IF IF-COD = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE IF-AZI  TO KAT-AZI.
           MOVE IF-COD  TO KAT-COD.
           READ ANAAUT INVALID PERFORM ERR-CINE
                               GO TO V-ERROR.
           MOVE AUT-RGSOC TO IF-DENOM.
       E-COD.
      *
       V-CATT.
           MOVE 'IF-CATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CATT.
           IF IF-CATT(1:6) = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           IF IF-CATT(1:6) NOT NUMERIC 
              MOVE 'Verificare codice attivit su anagrafica' TO F-MES1
              MOVE 'azienda. Come da documentazione deve    ' TO F-MES2
              MOVE 'essere uno di quelli previsti dalla     ' TO F-MES3
              MOVE 'codifica ATECO 2007.                    ' TO F-MES4
              MOVE 4 TO F-NMES
              GO TO V-ERROR.
       E-CATT.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
      *
           MOVE ZERO TO KEYAP KAP-DTR FLPAG CONT.
           MOVE KAZ-COD  TO KAP-AZI.
           MOVE IF-ESERC TO KAP-ESE.
           START PAGAUP KEY NOT < KEYAP INVALID GO TO INS99.
       INS00.
           READ PAGAUP NEXT AT END GO TO INS99.
           IF SF-AUP = '9D' OR '9A' OR '35' GO TO INS00.
           IF KAP-AZI > KAZ-COD OR 
              KAP-ESE > IF-ESERC GO TO INS99.
           IF AUP-FLV = 2 GO TO INS00.
           IF IF-TPCOD = ZERO
              IF KAP-COD NOT = IF-COD
                 GO TO INS00.

           MOVE KP3-TRI TO KUT-TRI.
           READ TRIBUT INVALID PERFORM INVK-BUT
                               PERFORM VISK-AUP
                               GO TO ERRIO.

           MOVE KAP-CAU TO KLV-CAU KTB-COD.
           MOVE 24 TO KTB-TIP.
           READ TABELL INTO REKT24 INVALID PERFORM INVK-TAB
                                           PERFORM VISK-AUP
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T24-TRIBU NOT = KP3-TRI
              MOVE 'CAUS.-TRIB. INCONGR.' TO MESS
              GO TO ERRIO.
           MOVE 1   TO KLV-RIT.
           MOVE 'C' TO KLV-QUA.

           MOVE T24-ALIQU TO KLV-ALI.           
           MOVE KAZ-COD TO KAT-AZI.
           MOVE KAP-COD TO KAT-COD.
           READ ANAAUT INVALID PERFORM INVK-AUT
                               PERFORM VISK-AUP
                               GO TO ERRIO.
           MOVE KEYAT TO KEYAAU.
           READ APPAUT INVALID MOVE SPACE TO AAU-CDO2 AAU-PDO2 AAU-IND2 
                                             AAU-CCOM1 AAU-CCOM2 
                               MOVE ZERO  TO AAU-FORZA.
           IF AUT-TIP = 2
              MOVE 1 TO KLV-DIT
           ELSE
              MOVE 2 TO KLV-DIT.
           MOVE AUT-RGSOC TO KLV-RGS.
           MOVE KAP-COD   TO KLV-COD.
           READ WDSLAV INVALID
                MOVE ZERO TO LAV-LORD LAV-NSOG LAV-RCON
                             LAV-ANTI LAV-IMPO LAV-RITE LAV-RITIM
                             LAV-RITS LAV-RIS LAV-RIP
                ADD 1 TO CONT
                WRITE RF-LAV.
           COMPUTE AUP-NSO = AUP-SOG - AUP-IMP.
           ADD AUP-SOG  TO LAV-LORD.
           ADD AUP-ANT  TO LAV-LORD.
                ADD AUP-RCON TO LAV-LORD
                ADD AUP-NSO  TO LAV-ANTI 
                ADD AUP-ANT  TO LAV-ANTI
                ADD AUP-RCON TO LAV-RCON 
                COMPUTE
                    LAV-IMPO = LAV-LORD - LAV-ANTI - LAV-RCON
      *> lav-rite = ritenute a titolo di acconto
           IF BUT-TIP = ZERO
              ADD AUP-RIT TO LAV-RITE.

      *> lav-ritim = ritenute a titolo di imposta
           IF BUT-TIP = 1
              ADD AUP-RIT TO LAV-RITIM.

      *> lav-rits = ritenute sospese
           IF AUP-FLS = 1 ADD AUP-RIT TO LAV-RITS.

      * contributi previdenziali
           IF T24-CP-ALIQU = ZERO GO TO STA20.
      *
           MOVE AUP-SOG      TO ER-IMPORTO.
           MOVE ZERO         TO ER-VALUT.
           MOVE T24-CP-BSIMP TO COM-ALIVA.
           CALL 're2iva' USING ER-IMPORTO ER-VALUT COM-ALIVA.
           MOVE T24-CP-ALIQU TO COM-ALIVA.
           CALL 're2iva' USING ER-IMPORTO ER-VALUT COM-ALIVA.
           ADD ER-IMPORTO TO LAV-RIS.
           MOVE 1 TO K.
           PERFORM UNTIL K > 10
              ADD AUP-RIP(K) TO LAV-RIP
              ADD 1 TO K.
           
       STA20.

           REWRITE RF-LAV INVALID MOVE 'RWR.LAV' TO MESS GO TO ERRIO.
           MOVE 1 TO FLPAG.
           GO TO INS00.
       INS99.
           IF FLPAG = ZERO GO TO EX-RUN-ELABORA.

           OPEN OUTPUT FILAUT.
      *
      *--- Leggo il file di sort wdslav.
      *
           MOVE ZERO TO KEYLV.
           MOVE SPACE TO KLV-RGS.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO FINE.
      *
           MOVE ZERO TO CODICE NRMO NRI.
           MOVE SPACE TO TQUA.
           MOVE ZERO TO NTREC NRECE NRECB.
           MOVE ZERO TO NRECH NRECD.
           PERFORM AZZ-TOT THRU EX-AZZ-TOT.

           PERFORM CREA-REC-A THRU EX-REC-A.

           PERFORM CREA-REC-B THRU EX-REC-B.

           PERFORM CREA-REC-D THRU EX-REC-D.
       RNEXT-LAV.
           READ  WDSLAV NEXT AT END GO TO END-LAV.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO RNEXT-LAV.
           MOVE KAZ-COD TO KAT-AZI.

           IF TQUA NOT = SPACE
              PERFORM END-REC-H THRU EX-END-REC-H
              PERFORM AZZ-TOT THRU EX-AZZ-TOT
              PERFORM CREA-REC-D THRU EX-REC-D.

           MOVE KLV-QUA TO TQUA.
           MOVE KLV-COD TO KAT-COD.
           IF KLV-COD NOT = CODICE 
              ADD 1 TO NUMP
              MOVE KLV-COD TO CODICE.
           READ ANAAUT INVALID PERFORM INVK-AUT
                               GO TO ERRIO.
           MOVE KEYAT TO KEYAAU.
           READ APPAUT INVALID MOVE SPACE TO AAU-CDO2 AAU-PDO2 AAU-IND2 
                                             AAU-CCOM1 AAU-CCOM2
                               MOVE ZERO  TO AAU-FORZA.
           IF (TQUA = 'C' AND NRI = 999)  OR
              (TQUA = 'E' AND NRI = 999)
                   PERFORM END-REC-H THRU EX-END-REC-H
                   MOVE ZERO TO NRI
                   PERFORM CREA-REC-D THRU EX-REC-D.
           IF TQUA = 'C' OR 'E'
                   PERFORM CREA-QUA-CE THRU EX-QUA-CE.

           GO TO RNEXT-LAV.
       END-LAV.
           PERFORM END-REC-H THRU EX-END-REC-H.

           PERFORM CREA-REC-Z THRU EX-REC-Z.

       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-REC-A.
           MOVE SPACE   TO FAUA.
      *
           MOVE 'A'     TO FAUA-TRA.
           MOVE MODELLO TO FAUA-CDF.

           MOVE 02        TO E02-TIP.
           MOVE IF-AZI    TO E02-COD.
           MOVE 'I'       TO E02-PRG.
           MOVE E02-KEYID TO KEYTAU.
           READ TABAUT INTO REKE02 INVALID 
                MOVE 'Caricare tabella parametri' TO MESS
                GO TO ERRIO.
      *
           IF E02-CFINT NOT = SPACE 
              MOVE 10 TO FAUA-TFO
              MOVE E02-CFINT  TO FAUA-CFFO
           ELSE
              MOVE 01 TO FAUA-TFO
              MOVE AZI-CFISC  TO FAUA-CFFO.
      *
           MOVE SPACE      TO FAUA-FIL2.
           MOVE ZERO       TO FAUA-PRGI.
           MOVE ZERO       TO FAUA-TOTI.

           MOVE 'A'        TO FAUA-FIL6.
           MOVE X'0D'      TO FAUA-VACR.
           MOVE X'0A'      TO FAUA-VALF.
           WRITE RF-MFAU.
       EX-REC-A.
           EXIT.
      *-----*
       CREA-REC-B.
           MOVE SPACE   TO FAUB.
      *
           MOVE ZERO TO FAUB-PRMO.
           MOVE ZERO TO FAUB-DANN.
           MOVE ZERO TO FAUB-DSOS.
           IF IF-DICO = 1
              MOVE 1 TO FAUB-DSOS.
           IF IF-DICO = 2
              MOVE 1 TO FAUB-DANN.
           MOVE ZERO TO FAUB-CODC.
           MOVE ZERO TO FAUB-CFSOC.
           MOVE ZERO TO FAUB-NDIP.
           MOVE ZERO TO FAUB-NAUT.
           MOVE ZERO TO FAUB-QCT.
           MOVE ZERO TO FAUB-FIRMA.
           MOVE ZERO TO FAUB-IMPEG.
           MOVE ZERO TO FAUB-DTIM.
           MOVE ZERO TO FAUB-FIRMAI.
      *
           MOVE 'B'       TO FAUB-TRB.
           MOVE 1         TO FAUB-PRMO.
           MOVE AZI-CFISC TO FAUB-CFDI.
           MOVE AZRGSOC   TO FAUB-DENO.
      *
      *
           MOVE '00343650131' TO FAUB-PSWG.
      *  Dati del contribuente
           IF AAZ-CGN = SPACE GO TO DENOMA.
           MOVE AAZ-CGN  TO FAUB-COGN.
           MOVE AAZ-NOM  TO FAUB-NOME.
           MOVE SPACE    TO FAUB-DENO.
           GO TO NODENOMA.
       DENOMA.
           MOVE SPACE    TO FAUB-COGN.
           MOVE SPACE    TO FAUB-NOME.
           MOVE AZRGSOC  TO FAUB-DENO.
       NODENOMA.
           MOVE 02        TO E02-TIP.
           MOVE IF-AZI    TO E02-COD.
           MOVE 'E'       TO E02-PRG.
           MOVE E02-KEYID TO KEYTAU.
           READ TABAUT INTO REKE02 INVALID 
                MOVE 'Caricare tabella parametri' TO MESS
                GO TO ERRIO.
      *
           MOVE E02-EMAIL TO FAUB-EMAIL.
           IF E02-TEL NOT = SPACE
              MOVE E02-TEL   TO FAUB-NTEL
           ELSE
              MOVE SPACE     TO FAUB-NTEL.
           IF FAUB-NTEL = ZERO
              IF E02-FAX NOT = SPACE
                 MOVE E02-FAX   TO FAUB-NTEL
              ELSE
                 MOVE SPACE     TO FAUB-NTEL.
 
      *
      *** Dati soggetto tenuto alla comunicazione
           MOVE 02        TO E02-TIP.
           MOVE IF-AZI    TO E02-COD.
           MOVE 'B'       TO E02-PRG.
           MOVE E02-KEYID TO KEYTAU.
           READ TABAUT INTO REKE02 INVALID 
                MOVE 'Caricare tabella parametri' TO MESS
                GO TO ERRIO.
           MOVE E02-CFRAP TO FAUB-CFISC.
           MOVE E02-CARAP TO FAUB-CODC.
      *** Dati soggetto tenuto alla comunicazione(Persona fisica)
           MOVE E02-CORAP TO FAUB-CNF.
           MOVE E02-NORAP TO FAUB-NOF.
      *
           MOVE E02-CFSOC TO FAUB-CFSOC.
           MOVE ZERO      TO FAUB-NDIP.
           MOVE ZERO      TO FAUB-NAUT.
           MOVE ZERO      TO FAUB-QCT.
           MOVE 1         TO FAUB-FIRMA.
      *
           MOVE KAZ-COD   TO E02-COD.
           MOVE 'I'       TO E02-PRG.
           MOVE 02        TO E02-TIP.
           MOVE E02-KEYID TO KEYTAU.
           READ TABAUT INTO REKE02 INVALID PERFORM INVK-TAU
                                   GO TO ERRIO.
           MOVE E02-CFINT TO FAUB-CFISI.
           MOVE E02-DTIMP TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA4 TO FAUB-DTIM.
           IF FAUB-CFISI NOT = SPACE AND
              FAUB-CFISI NOT = ZERO
              MOVE 1 TO FAUB-FIRMAI
           ELSE
              MOVE 0 TO FAUB-FIRMAI.
           MOVE E02-FLGMOD TO FAUB-IMPEG.
           IF FAUB-FIRMAI = ZERO
              MOVE ZERO TO FAUB-IMPEG.
           MOVE CONT TO FAUB-NAUT.
      *
           MOVE 'A'          TO FAUB-FIL99.
           MOVE X'0D'        TO FAUB-VACR.
           MOVE X'0A'        TO FAUB-VALF.
           ADD 1 TO NTREC NRECB.
           WRITE RF-MFAU.
       EX-REC-B.
           EXIT.
      *-----*
       CREA-REC-D.
           ADD 1        TO NRMO.
           MOVE SPACE   TO FAUD.

           MOVE 'D'     TO FAUD-TRG TREC.
           MOVE AZI-CFISC TO FAUD-CFSD.
           MOVE 1       TO FAUD-NRMO.
           MOVE NRMO    TO FAUD-PRGC.
           MOVE ZERO TO FAUD-PROT1 FAUD-PROT2.
           IF IF-DICO NOT = ZERO
              MOVE IF-PROT1 TO FAUD-PROT1
              MOVE IF-PROT2 TO FAUD-PROT2
              IF IF-DICO = 1
                 MOVE 'S' TO FAUD-TOPE
              ELSE
                 MOVE 'A' TO FAUD-TOPE.
           PERFORM AZZ-CAMPI THRU EX-AZZ-CAMPI.
       EX-REC-D.
           EXIT.
      *-----*
       END-REC-D.
           MOVE AAU-FORZA TO FAUD-SCER.
           MOVE AREAFGH TO FAUD-FIL1.
           MOVE 'A'     TO FAUD-FIL3.
           MOVE X'0D'   TO FAUD-VACR.
           MOVE X'0A'   TO FAUD-VALF.
           ADD 1 TO NTREC NRECD.
           WRITE RF-MFAU.
       EX-END-REC-D.
           EXIT.
      *-----*
       CREA-REC-H.
           IF IF-DICO = 2
              GO TO EX-REC-H.
           MOVE SPACE   TO FAUH.

           MOVE 'H'     TO FAUH-TRG TREC.
           MOVE AZI-CFISC TO FAUH-CFSD.
           MOVE 1       TO FAUH-NRMO.
           MOVE NRMO    TO FAUH-PRGC.
           PERFORM AZZ-CAMPI THRU EX-AZZ-CAMPI.
       EX-REC-H.
           EXIT.
      *-----*
       END-REC-H.
           IF IF-DICO = 2
              GO TO EX-END-REC-H.
           MOVE AREAFGH TO FAUH-FIL1.
           MOVE 'A'     TO FAUH-FIL3.
           MOVE X'0D'   TO FAUH-VACR.
           MOVE X'0A'   TO FAUH-VALF.
           ADD 1 TO NTREC NRECH.
           WRITE RF-MFAU.
       EX-END-REC-H.
           EXIT.
      *-----*
       CREA-QUA-CE.
           PERFORM VAL-REC-D THRU EX-VAL-REC-D.
           PERFORM END-REC-D THRU EX-END-REC-D.
           IF IF-DICO = 2 GO TO EX-QUA-CE.
      *
           PERFORM CREA-REC-H THRU EX-REC-H.
      *
           MOVE 'AU' TO QUA.

           ADD 1  TO NRI.
           MOVE ZERO TO NCO.
           MOVE AUT-FIS TO FAUH-CFPP.
      *
           MOVE 24 TO KTB-TIP.
           MOVE KLV-CAU TO KTB-COD.
           READ TABELL INTO REKT24 INVALID
                MOVE ALL '*' TO T24-DSABB T24-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T24-DSABB(1:2) TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
       
           IF T24-DSABB(1:2) = 'G ' OR
              T24-DSABB(1:2) = 'H ' OR
              T24-DSABB(1:2) = 'I '
              MOVE IF-ESERC TO COMDA
              MOVE COMDA  TO CAMPDA
              PERFORM CAR-CAMPI THRU EX-CAR-CAMPI
           ELSE
              ADD 1 TO NCO.

           MOVE '               0' TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.

      *> solo importi positivi
           IF LAV-LORD < ZERO MULTIPLY -1 BY LAV-LORD.
           IF LAV-LORD NOT = ZERO
              MOVE LAV-LORD(1:11) TO NINT
              MOVE ','            TO VIRGOLA
              MOVE LAV-LORD(12:2) TO NDEC
              PERFORM CAR-CAMPI THRU EX-CAR-CAMPI
           ELSE
              ADD 1 TO NCO.

      *> solo importi positivi
           IF LAV-NSOG < ZERO MULTIPLY -1 BY LAV-NSOG.
           IF LAV-RCON < ZERO MULTIPLY -1 BY LAV-RCON.
           IF LAV-ANTI < ZERO MULTIPLY -1 BY LAV-ANTI.

           IF TQUA = 'E'
              ADD 1 TO NCO
              MOVE 3 TO CAMPN
              IF LAV-ANTI = ZERO MOVE ZERO TO CAMPN
              END-IF
              PERFORM CAR-CAMPI THRU EX-CAR-CAMPI
              IF LAV-NSOG NOT = ZERO
                 MOVE LAV-NSOG(1:11) TO NINT
                 MOVE ','            TO VIRGOLA
                 MOVE LAV-NSOG(12:2) TO NDEC
                 PERFORM CAR-CAMPI THRU EX-CAR-CAMPI
              ELSE
                 ADD 1 TO NCO
              END-IF
           ELSE
                IF LAV-RCON NOT = ZERO
                   MOVE LAV-RCON(1:11) TO NINT
                   MOVE ','            TO VIRGOLA
                   MOVE LAV-RCON(12:2) TO NDEC
                   PERFORM CAR-CAMPI THRU EX-CAR-CAMPI
                ELSE
                   ADD 1 TO NCO
                END-IF
                MOVE 3 TO CAMPN
                IF LAV-ANTI = ZERO MOVE ZERO TO CAMPN
                END-IF
                PERFORM CAR-CAMPI THRU EX-CAR-CAMPI
                IF LAV-ANTI NOT = ZERO
                   MOVE LAV-ANTI(1:11) TO NINT
                   MOVE ','            TO VIRGOLA
                   MOVE LAV-ANTI(12:2) TO NDEC
                   PERFORM CAR-CAMPI THRU EX-CAR-CAMPI
                ELSE
                   ADD 1 TO NCO.
         
      *> solo importi positivi (Imponibile)
           IF LAV-IMPO < ZERO MULTIPLY -1 BY LAV-IMPO.
           IF LAV-IMPO NOT = ZERO
              MOVE LAV-IMPO(1:11) TO NINT
              MOVE ','            TO VIRGOLA
              MOVE LAV-IMPO(12:2) TO NDEC
              PERFORM CAR-CAMPI THRU EX-CAR-CAMPI
          ELSE
              ADD 1 TO NCO.

      *> ritenute a titolo d'acconto (but-tip = 1)
      *> solo importi positivi
           IF LAV-RITE < ZERO MULTIPLY -1 BY LAV-RITE.
           IF LAV-RITE > LAV-IMPO MOVE LAV-IMPO TO LAV-RITE.
           IF LAV-RITE NOT = ZERO
              MOVE LAV-RITE(1:11) TO NINT
              MOVE ','            TO VIRGOLA
              MOVE LAV-RITE(12:2) TO NDEC
              PERFORM CAR-CAMPI THRU EX-CAR-CAMPI
           ELSE
              ADD 1 TO NCO.

      *> ritenute a titolo d'imposta, a saldo (but-tip = 1)
           IF LAV-RITIM < ZERO MULTIPLY -1 BY LAV-RITIM.
           IF LAV-RITIM > LAV-IMPO MOVE LAV-IMPO TO LAV-RITIM.
           IF LAV-RITIM NOT = ZERO
              MOVE LAV-RITIM(1:11) TO NINT
              MOVE ','             TO VIRGOLA
              MOVE LAV-RITIM(12:2) TO NDEC
              PERFORM CAR-CAMPI THRU EX-CAR-CAMPI
           ELSE
              ADD 1 TO NCO. 
           COMPUTE TRITEN =  LAV-RITE + LAV-RITIM.

      *> ritenute sospese
      *> solo importi positivi
           IF LAV-RITS < ZERO MULTIPLY -1 BY LAV-RITS.
           IF LAV-RITS > TRITEN MOVE TRITEN TO LAV-RITS.
           IF LAV-RITS NOT = ZERO
              MOVE LAV-RITS(1:11) TO NINT
              MOVE ','            TO VIRGOLA
              MOVE LAV-RITS(12:2) TO NDEC
              PERFORM CAR-CAMPI THRU EX-CAR-CAMPI
           ELSE
              ADD 1 TO NCO. 
      *
      *> contributi previdenziali soggetto erogazione
      *> solo importi positivi
           MOVE 19 TO NCO.
           COMPUTE COMVAL = LAV-RIS  - LAV-RIP.
           IF COMVAL < ZERO MULTIPLY -1 BY COMVAL.
           IF COMVAL NOT = ZERO
              MOVE COMVAL(1:11) TO NINT
              MOVE ','            TO VIRGOLA
              MOVE COMVAL(12:2) TO NDEC
              PERFORM CAR-CAMPI THRU EX-CAR-CAMPI
           ELSE
              ADD 1 TO NCO. 
      *> contributi previdenziali percipiente
      *> solo importi positivi
           IF LAV-RIP < ZERO MULTIPLY -1 BY LAV-RIP.
           IF LAV-RIP NOT = ZERO
              MOVE LAV-RIP(1:11) TO NINT
              MOVE ','            TO VIRGOLA
              MOVE LAV-RIP(12:2) TO NDEC
              PERFORM CAR-CAMPI THRU EX-CAR-CAMPI
           ELSE
              ADD 1 TO NCO. 
       EX-QUA-CE.
           EXIT.
      *-----*
       CREA-REC-Z.
           MOVE SPACE TO FAUZ.
           
           MOVE 'Z'   TO FAUZ-TRZ.

           MOVE NRECB   TO FAUZ-NRTB.
           MOVE ZERO    TO FAUZ-NRTC.
           MOVE NRECD   TO FAUZ-NRTD.
           MOVE ZERO    TO FAUZ-NRTG.
           MOVE NRECH   TO FAUZ-NRTH.

           MOVE 'A'     TO FAUZ-FIL4.
           MOVE X'0D'   TO FAUZ-VACR.
           MOVE X'0A'   TO FAUZ-VALF.
           WRITE RF-MFAU.
       EX-REC-Z.
           EXIT.
      *-----*
       AZZ-CAMPI.
           MOVE ZERO TO NRI NCO.
           MOVE SPACE TO COMCAM.
       AZZ1-CAMPI.
           MOVE 1 TO J2.
           PERFORM UNTIL J2 > 75
              MOVE SPACE TO FAU-QUADRO(J2)
                            FAU-CAMPO(J2)
              ADD 1 TO J2
           END-PERFORM.
           MOVE ZERO TO J2.
       EX-AZZ-CAMPI.
           EXIT.
      *-----*
       AZZ-TOT.
           MOVE ZERO TO LORD NSOG ANTI
                        RCON IMPO RITE
                        RITS NUMP.
       EX-AZZ-TOT.
           EXIT.
      *-----*
       CAR-CAMPI.
           IF NRI NOT = ZERO
           ADD 1 TO NCO.
           IF COMCAM = SPACE OR '               0'
                            GO TO CAR2-CAMPI.
       CAR1-CAMPI.
           ADD 1 TO J2.
           IF J2 > 75
              IF TREC = 'E'
                 PERFORM AZZ1-CAMPI THRU EX-AZZ-CAMPI 
                 GO TO CAR1-CAMPI
              ELSE PERFORM AZZ1-CAMPI THRU EX-AZZ-CAMPI
                   GO TO CAR1-CAMPI.
           MOVE COMQUA  TO FAU-QUADRO(J2).
           MOVE COMCAM  TO FAU-CAMPO(J2).
       CAR2-CAMPI.
           MOVE SPACE   TO COMCAM.
       EX-CAR-CAMPI.
           EXIT.
      *-----*
       CAR-CAMPX.
           MOVE CAMP1 TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
           IF CAMP2 NOT = SPACE
              STRING '+' DELIMITED SIZE
              CAMP2 DELIMITED SIZE INTO COMCAM
              PERFORM CAR1-CAMPI THRU EX-CAR-CAMPI.
           IF CAMP3 NOT = SPACE
              STRING '+' DELIMITED SIZE
              CAMP3 DELIMITED SIZE INTO COMCAM
              PERFORM CAR1-CAMPI THRU EX-CAR-CAMPI.
       EX-CAR-CAMPX.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       VAL-REC-D.
           MOVE 'DA' TO QUA.

           ADD 1  TO NRI.
           MOVE ZERO TO NCO.
           MOVE AZI-CFISC TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
           MOVE AUT-FIS TO FAUD-CFPP.

           IF AAZ-CGN = SPACE
              MOVE AZI-RGSOC TO CAMP
              PERFORM CAR-CAMPX THRU EX-CAR-CAMPX
              ADD 1 TO NCO
              GO TO A30
           ELSE
              MOVE AAZ-CGN   TO CAMP
              PERFORM CAR-CAMPX THRU EX-CAR-CAMPX.

           MOVE AAZ-NOM TO CAMP.
           PERFORM CAR-CAMPX THRU EX-CAR-CAMPX.

       A30.
           MOVE AZI-CIT TO CAMP.
           PERFORM CAR-CAMPX THRU EX-CAR-CAMPX.

           MOVE AZI-PRV TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
       A35.
           MOVE AZI-CAP TO CAMP
           PERFORM CAR-CAMPX THRU EX-CAR-CAMPX
      *
           MOVE AZI-INDIR TO CAMP.
           PERFORM CAR-CAMPX THRU EX-CAR-CAMPX.
      *
           MOVE 02        TO E02-TIP.
           MOVE IF-AZI    TO E02-COD.
           MOVE 'E'       TO E02-PRG.
           MOVE E02-KEYID TO KEYTAU.
           READ TABAUT INTO REKE02 INVALID 
                MOVE 'Caricare tabella parametri' TO MESS
                GO TO ERRIO.
      *
           IF E02-TEL NOT = SPACE
              MOVE E02-TEL TO COMCAM
              PERFORM CAR-CAMPI THRU EX-CAR-CAMPI
           ELSE
              ADD 1 TO NCO.
      *
           MOVE E02-EMAIL TO CAMP.
           PERFORM CAR-CAMPX THRU EX-CAR-CAMPX.
      *
           MOVE IF-CATT(1:6) TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
      *
       A40.
           ADD 1 TO NRI.
      *
           MOVE ZERO TO NCO.
           MOVE AUT-FIS TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.

           IF KLV-DIT = 2 
              MOVE AUT-RGSOC TO CAMP
              PERFORM CAR-CAMPX THRU EX-CAR-CAMPX
              ADD 5 TO NCO
              GO TO A31
           ELSE
              MOVE AUT-CGN   TO CAMP
              PERFORM CAR-CAMPX THRU EX-CAR-CAMPX.

           MOVE AUT-NOM TO CAMP.
           PERFORM CAR-CAMPX THRU EX-CAR-CAMPX.

           MOVE AUT-SES TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
            
           MOVE AUT-DNA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA4 TO COMDT.
           MOVE COMDT  TO CAMPDT.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.

           IF AUT-CNA(1:5) NUMERIC *> Tolgo il cap
              IF AUT-CNA(6:1) = SPACE
                 MOVE AUT-CNA(7:) TO CAMP
              ELSE
                 MOVE AUT-CNA(6:) TO CAMP
              END-IF
           ELSE
              MOVE AUT-CNA TO CAMP.
           PERFORM CAR-CAMPX THRU EX-CAR-CAMPX.

      *    IF AUT-PNA = 'EE' MOVE SPACE TO AUT-PNA.
           MOVE AUT-PNA TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
      *
           IF AUT-PDO = 'EE'
              MOVE 'Z' TO COMCAM
              PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
       A31.
           MOVE 24 TO KTB-TIP.
           MOVE KLV-CAU TO KTB-COD.
           READ TABELL INTO REKT24 INVALID
                MOVE ALL '*' TO T24-DSABB T24-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T24-DSABB(1:2) NOT = 'N ' GO TO A34. 
      * 
           IF AUT-PDO = 'EE' ADD 7 TO NCO
                                    GO TO A33.
           MOVE 19 TO NCO. 
           IF AUT-CDO(1:5) NUMERIC *> Tolgo il cap
              IF AUT-CDO(6:1) = SPACE
                 MOVE AUT-CDO(7:) TO CAMP
              ELSE
                 MOVE AUT-CDO(6:) TO CAMP
              END-IF
           ELSE
              MOVE AUT-CDO TO CAMP.
           PERFORM CAR-CAMPX THRU EX-CAR-CAMPX.

           MOVE AUT-PDO TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
       A32.
           MOVE AAU-CCOM1 TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
      *
           IF AAU-CDO2(1:5) NUMERIC *> Tolgo il cap
              IF AAU-CDO2(6:1) = SPACE
                 MOVE AAU-CDO2(7:) TO CAMP
              ELSE
                 MOVE AAU-CDO2(6:) TO CAMP
              END-IF
           ELSE
              MOVE AAU-CDO2 TO CAMP.
           PERFORM CAR-CAMPX THRU EX-CAR-CAMPX.

           MOVE AAU-PDO2 TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
       A33.
           MOVE AAU-CCOM2 TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
      *
       A34.
           IF AUT-PDO NOT = 'EE'
                   GO TO NOESTERO.
           MOVE 39 TO NCO. 
           MOVE AUT-FSE TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
      *
           MOVE AUT-CDO TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
      *
           MOVE AUT-IND TO COMCAM.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
      *
           MOVE AUT-CDE TO CAMPN.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
       NOESTERO.
      *
           ADD 1 TO NRI.
           MOVE ZERO TO NCO.
      *
           MOVE IF-DTEM TO GGMMAA
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA4 TO COMDT.
           MOVE COMDT  TO CAMPDT.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
      *
           MOVE 1       TO CAMPN.
           PERFORM CAR-CAMPI THRU EX-CAR-CAMPI.
       EX-VAL-REC-D.
           EXIT.
