       IDENTIFICATION DIVISION.
       PROGRAM-ID. vrit339.
      **** rel 7.1
      * Nuova stampa su modulo ministeriale
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gritausl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gritau'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'grie02rk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parpb'.
           COPY 'parmb'.
           COPY 'pardefw'.
           COPY 'parscmd'.
           COPY 'parwri2'.
       01  PARWCON2.
           05 PWCON2-AZI      PIC 9(3).
           05 PWCON2-NFILE    PIC X(100).
       01  PARCC2.
           05 PCC2-FUN     PIC X.
           05 PCC2-FLGS    PIC 9.
           05 PCC2-TIPEST  PIC XX.
           05 PCC2-PARAM   PIC X(20).
           05 PCC2-PATH    PIC X(60).
           05 PCC2-STAMP   PIC 9.
           05 PCC2-FILLER  PIC X(49).
           05 PCC2-ERR     PIC 9.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAU PIC X(15) VALUE 'tabaut'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-TAU   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 DTPK1    PIC 9(5) COMP-3 VALUE ZERO.
           05 DTPK2    PIC 9(5) COMP-3 VALUE ZERO.
           05 KATTESA  PIC 9(5) VALUE ZERO.
           05 IND    PIC 99    VALUE ZERO.
           05 K1     PIC 999   VALUE ZERO.
           05 K2     PIC 999   VALUE ZERO.
           05 K3     PIC 999   VALUE ZERO.
           05 NFILE  PIC X(30).

       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-NFILE     PIC X(100).
           05 IF-FIRMA     PIC X(40).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclTAU'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vrit339: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABAUT.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griTAUer'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           OPEN INPUT ANAAZI TABAUT.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
           MOVE KAZ-COD   TO E02-COD.
           MOVE 'A'       TO E02-PRG.
           MOVE 02        TO E02-TIP.
           MOVE E02-KEYID TO KEYTAU.
           READ TABAUT INTO REKE02 INVALID PERFORM INVK-TAU
                                   GO TO ERRIO.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
           STRING E02-PATHECF "*cur15*" DELIMITED SPACE INTO IF-NFILE.
           MOVE SPACE TO IF-FIRMA.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-NFILE.
           MOVE 'IF-NFILE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NFILE.
           PERFORM ESTRAPOLA-NFILE THRU EX-ESTRAPOLA-NFILE.
           IF (NFILE(1:11) NOT NUMERIC OR
              NFILE(12:1) NOT = '_'   OR
              NFILE(13:2) NOT NUMERIC OR
              NFILE(15:1) NOT = '_'   OR
              NFILE(16:4) NOT NUMERIC OR
              NFILE(20:6) NOT = '_cur15')
              MOVE 'FILE NON CORRETTO' TO MESS
              GO TO V-ERROR.
           IF IF-NFILE = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-NFILE.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           MOVE 'RI2' TO SCMD-TDOC.
           CALL 'vrscmd' USING PARSCMD.
      *
           IF SCMD-TIPO(1) = 'LOC' AND SCMD-FLG(1) = 1
              MOVE KAZ-COD TO PWRI2-AZI
              MOVE 'I'     TO PCCD-FUN
              MOVE SCMD-OPZ(1) TO PCCD-PARAM
              MOVE SPACE TO PCCD-TIPEST
              MOVE ZERO  TO PCCD-FLGS
              MOVE SPACE TO PCCD-PATH
              CALL 'vri2wrd' USING PARWRI2 PARCCD
              IF PCCD-ERR NOT = ZERO GO TO ERRIO.
      *
           MOVE 1 TO IND.
           PERFORM UNTIL IND > 10
              IF SCMD-TIPO(IND) NOT = SPACE AND SCMD-FLG(IND) = 1
                 IF SCMD-TIPO(IND) = 'LOC'
                    MOVE KAZ-COD    TO PWRI2-AZI
                    MOVE IF-NFILE   TO PWRI2-NFILE
                    MOVE IF-FIRMA   TO PWRI2-FIRMA
                    MOVE 'R'        TO PCCD-FUN
                    CALL 'vri2wrd' USING PARWRI2 PARCCD
                    IF PCCD-ERR NOT = ZERO
                       GO TO ERRIO
                    END-IF
                 END-IF
              END-IF
              ADD 1 TO IND.
           IF SCMD-TIPO(1) = 'LOC' AND SCMD-FLG(1) = 1
              MOVE 'E' TO PCCD-FUN
              CALL 'vri2wrd' USING PARWRI2 PARCCD
              IF PCCD-ERR NOT = ZERO GO TO ERRIO.
           MOVE SPACE TO IF-NFILE.
           MOVE SPACE TO IF-FIRMA.
           STRING E02-PATHECF "*cur15*" DELIMITED SPACE INTO IF-NFILE.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       ESTRAPOLA-NFILE.
           MOVE 100 TO K1.
           MOVE 100 TO K2.
           MOVE 100 TO K3.
           MOVE SPACE TO NFILE.
           PERFORM UNTIL IF-NFILE(K1:1) = '\' OR '/'
               IF IF-NFILE(K1:1) = SPACE
                  MOVE K1 TO K2 
               END-IF 
               SUBTRACT 1 FROM K1.
           ADD 1 TO K1.
           COMPUTE K3 = K2 - K1.  
           MOVE SPACE TO NFILE.
           MOVE IF-NFILE(K1:K3) TO NFILE.
       EX-ESTRAPOLA-NFILE.
           EXIT.
      *------------------
