       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRTOGMAS.
      *
      * Routine di ricalcolo totali di giornata conti riepilogativi da
      * movimenti clienti/fornitori
      *
      * In Input : AZI  = azienda  (0 = tutte)
      *            FL   = 0 - esercizio corrente 
      *                   1 - vecchio esercizio
      *
      **** rel 4.0
      * Nuovo
      ************
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'grimovsl'.
           COPY 'grimvxsl'.
           COPY 'griclfsl'.
           COPY 'grimszsl'.
           COPY 'grimsxsl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricon'.
           COPY 'grimov'.
           COPY 'grimvx'.
           COPY 'griclf'.
           COPY 'grimsz'.
           COPY 'grimsx'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parlk'.
           COPY 'griazirk'.
           COPY 'griconrk'.
           COPY 'grimovrk'.
           COPY 'griclfrk'.
           COPY 'gritabrk'.
           COPY 'grit14g'.
           COPY 'grit20rk'.
      **** rel 7.1
           COPY 'parppar'.
      ************
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-MVX PIC X(15) VALUE 'movmxx'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-MSZ PIC X(15) VALUE 'movsez'.
       01  ID-MSX PIC X(15) VALUE 'movsxx'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-CON   PIC XX.
           05 SF-MOV   PIC XX.
           05 SF-MVX   PIC XX.
           05 SF-CLF   PIC XX.
           05 SF-MSZ   PIC XX.
           05 SF-MSX   PIC XX.
           05 SF-TAB   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 CATCON PIC 9 VALUE ZERO.
           05 WCRPCL PIC 9(7).
           05 WCRPFR PIC 9(7).
           05 CRPCL  PIC 9(7) OCCURS 9.
           05 CRPFR  PIC 9(7) OCCURS 9.
           05 DESMV.
              10 FILLER PIC X(17) VALUE 'REGISTRAZIONI IN'.
              10 DAVE PIC X.
              10 AVER PIC X(4).
           05 CLAV  PIC S9(15)V99.
           05 CLV1   PIC S9(13).
           05 SAVAZI PIC 9(3).
      **** rel 7.2
           05 CONTA   PIC 9(5)   VALUE ZERO.
           05 S-TMOV  PIC XXX    VALUE SPACE.
      ************
       LINKAGE SECTION.
       01 RS-AZI PIC 9(3).
       01 RS-FL  PIC 9.
       PROCEDURE DIVISION USING RS-AZI RS-FL.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcon'.
           COPY 'dclmov'.
           COPY 'dclmvx'.
           COPY 'dclclf'.
           COPY 'dclmsz'.
           COPY 'dclmsx'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strsub'.
      *
           MOVE 'anaazi' TO ID-AZI.
           MOVE 'anacon' TO ID-CON.
           MOVE 'movime' TO ID-MOV.
           MOVE 'movmxx' TO ID-MVX.
           MOVE 'anaclf' TO ID-CLF.
           MOVE 'movsez' TO ID-MSZ.
           MOVE 'movsxx' TO ID-MSX.
           MOVE 'tabell' TO ID-TAB.
           IF RS-FL = 1
              MOVE 'anazol' TO ID-AZI
              MOVE 'anacol' TO ID-CON
              MOVE 'movmol' TO ID-MOV
              MOVE 'movoxx' TO ID-MVX
              MOVE 'anacfx' TO ID-CLF
              MOVE 'movsol' TO ID-MSZ
              MOVE 'mosoxx' TO ID-MSX
              MOVE 'tabold' TO ID-TAB.
      *
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN INPUT ANACON.
           OPEN INPUT ANACLF.
           OPEN INPUT MOVSEZ.
           OPEN INPUT MOVSXX.
           OPEN I-O   MOVIME.
           OPEN I-O   MOVMXX.
      *
           MOVE 20 TO KTB-TIP.
           MOVE 1  TO KTB-COD
           READ TABELL INTO RKTB20 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB20.
      *
           MOVE 14 TO KTB-TIP.
           MOVE  7 TO KTB-COD.
           READ TABELL INTO RKTB14G INVALID PERFORM INVK-TAB
                                            GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB14G.
      *
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *
           MOVE T01-CRPCL TO CRPCL(1).
           MOVE T01-CRPC1 TO CRPCL(2).
           MOVE T01-CRPC2 TO CRPCL(3).
           MOVE T14-CRPC3 TO CRPCL(4).
           MOVE T14-CRPC4 TO CRPCL(5).
           MOVE T14-CRPC5 TO CRPCL(6).
           MOVE T14-CRPC6 TO CRPCL(7).
           MOVE T14-CRPC7 TO CRPCL(8).
           MOVE T14-CRPC8 TO CRPCL(9).

           MOVE T01-CRPFR TO CRPFR(1).
           MOVE T01-CRPF1 TO CRPFR(2).
           MOVE T01-CRPF2 TO CRPFR(3).
           MOVE T14-CRPF3 TO CRPFR(4).
           MOVE T14-CRPF4 TO CRPFR(5).
           MOVE T14-CRPF5 TO CRPFR(6).
           MOVE T14-CRPF6 TO CRPFR(7).
           MOVE T14-CRPF7 TO CRPFR(8).
           MOVE T14-CRPF8 TO CRPFR(9).
      *
           PERFORM ELIMINA-TOTALI THRU EX-ELIMINA-TOTALI.
      *
           MOVE ZERO TO SAVAZI.
      *
      **** rel 7.2
           MOVE ZERO TO PPAR-FUN CONTA.
           MOVE SPACE TO S-TMOV.
      ************
           MOVE LOW-VALUE TO KEYSX.
           IF RS-AZI NOT = ZERO MOVE RS-AZI    TO KSX-AZI.
           START MOVSXX KEY NOT < KEYSX INVALID GO TO ST-MSZ.
       RD-MSX.
           READ MOVSXX NEXT INTO REKMOV AT END GO TO ST-MSZ.
           IF SF-MSX = '9D' OR '9A' OR '35' GO TO RD-MSX.
           IF RS-AZI NOT = ZERO 
              IF KSX-AZI > RS-AZI GO TO ST-MSZ.
      *
           PERFORM AGGIORNA-TOT THRU A99.
      *
           GO TO RD-MSX.
       ST-MSZ.
      **** rel 7.2
           PERFORM VER-END.
      ************
      *
           MOVE ZERO TO SAVAZI.
      *
      **** rel 7.2
           MOVE ZERO TO PPAR-FUN CONTA.
           MOVE SPACE TO S-TMOV.
      ************
           MOVE LOW-VALUE TO KEYMS.
           IF RS-AZI NOT = ZERO MOVE RS-AZI    TO KMS-AZI.
           START MOVSEZ KEY NOT < KEYMS INVALID GO TO END-MSZ.
       RD-MSZ.
           READ MOVSEZ NEXT INTO REKMOV AT END GO TO END-MSZ.
           IF SF-MSZ = '9D' OR '9A' OR '35' GO TO RD-MSZ.
           IF RS-AZI NOT = ZERO
              IF KMS-AZI > RS-AZI GO TO END-MSZ.
      *
           PERFORM AGGIORNA-TOT THRU A99.
      *
           GO TO RD-MSZ.
       END-MSZ.
      **** rel 7.2
           PERFORM VER-END.
      ************
      *
           GO TO FINE.
      * -------------- *
       ERRIO.
           COPY 'errsub'.
       FINE.
           CLOSE ANAAZI ANACON MOVIME MOVMXX TABELL.
           CLOSE ANACLF MOVSEZ MOVSXX.
           EXIT PROGRAM.
           STOP RUN.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griconer'.
           COPY 'grimover'.
           COPY 'grimvxer'.
           COPY 'griclfer'.
           COPY 'grimszer'.
           COPY 'grimsxer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      * --------------- *
       REC-LOCK.
           CALL 'rlock' USING PARLK.
           EXIT.
      * --------------- *
       AGGIORNA-TOT.
           MOVE MOV-D-A TO DAVE.
      *
           MOVE ZERO TO MOV-VALUT MOV-CAMGG MOV-IMVAL.
      *
           MOVE MOV-AZI TO KCF-AZI.
           MOVE MOV-CON TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID PERFORM INVK-CLF
                                           GO TO ERRIO.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
      *
           MOVE CLF-CATCON TO CATCON.
           IF CATCON = ZERO MOVE 1 TO CATCON.
           MOVE CRPCL (CATCON) TO WCRPCL.
           MOVE CRPFR (CATCON) TO WCRPFR.
           IF MOV-CAUS = T20-CDSOC OR T20-CASOC OR
                         T20-CDCLC OR T20-CACLC OR
                         T20-CDFOC OR T20-CAFOC OR
                         T20-CDSOA OR T20-CASOA OR
                         T20-CDCLA OR T20-CACLA OR
                         T20-CDFOA OR T20-CAFOA GO TO LKCLI1.
      *
           IF MOV-TREG = 2 MOVE WCRPCL TO MOV-CON
                           MOVE 99991  TO CLV1
                           PERFORM RCHGG THRU EX-RCHGG.
           IF MOV-TREG = 3 MOVE WCRPFR TO MOV-CON
                           MOVE 99993 TO CLV1
                           PERFORM RCHGG THRU EX-RCHGG.
      *
           GO TO LKCLI2.
       LKCLI1.
           IF MOV-TREG = 2 MOVE WCRPCL TO MOV-CON
                           MOVE 99995 TO CLV1
                           PERFORM RCHGG THRU EX-RCHGG.
           IF MOV-TREG = 3 MOVE WCRPFR TO MOV-CON
                           MOVE 99997 TO CLV1
                           PERFORM RCHGG THRU EX-RCHGG.
       LKCLI2.

       A99.
           EXIT.
      *----------------------*
       RCHGG.
           IF MOV-AZI NOT = SAVAZI PERFORM READ-ANAAZI.
           MOVE MOV-AZI TO SAVAZI.
      *
           MOVE 'ARE'   TO AVER.
           IF DAVE = 'A' ADD 1 TO CLV1 MOVE 'VERE' TO AVER.
           MOVE CLV1 TO MOV-NUM.
      *
           MOVE MOV-IMPO  TO CLAV.
           IF MOV-DAT NOT > AZI-RVDT 
              MOVE MOV-KEYID TO KEYMX
              READ MOVMXX INVALID GO TO WRMRP
              END-READ
              MOVE RF-MVX TO REKMOV
              GO TO RWMRP
           ELSE
              MOVE MOV-KEYID TO KEYMV
              READ MOVIME INVALID GO TO WRMRP
              END-READ
              MOVE RF-MOV TO REKMOV
              GO TO RWMRP.
       WRMRP.
           IF MOV-CAUS = T20-CDSOC OR T20-CASOC OR
                         T20-CDCLC OR T20-CACLC OR
                         T20-CDFOC OR T20-CAFOC 
                         IF DAVE = 'A'
                            MOVE T20-CASOC TO MOV-CAUS 
                            GO TO WRMRP1     
                         ELSE
                            MOVE T20-CDSOC TO MOV-CAUS
                            GO TO WRMRP1.     
      *
           IF MOV-CAUS = T20-CDSOA OR T20-CASOA OR
                         T20-CDCLA OR T20-CACLA OR
                         T20-CDFOA OR T20-CAFOA 
                         IF DAVE = 'A'
                            MOVE T20-CASOA TO MOV-CAUS 
                            GO TO WRMRP1     
                         ELSE
                            MOVE T20-CDSOA TO MOV-CAUS
                            GO TO WRMRP1.     
      *
           MOVE 999 TO MOV-CAUS.
       WRMRP1.
           MOVE DAVE  TO MOV-D-A.
           MOVE 1     TO MOV-TREG.
           MOVE ZERO  TO MOV-NDOC MOV-IMPO MOV-DTSCD MOV-NPRGI MOV-PART.
           MOVE 1     TO MOV-FLAG.
           MOVE DESMV TO MOV-DSAGG.
           MOVE SPACE TO MOV-CCOST.
           MOVE '0'   TO MOV-CATT.
           IF MOV-DAT NOT > AZI-RVDT 
              WRITE RF-MVX FROM REKMOV INVALID PERFORM INVK-MVX
                                               GO TO ERRIO
      **** rel 7.1
              END-WRITE
      **** rel 7.2
      *       MOVE 'I' TO PPAR-TOPE
              MOVE 'M' TO PPAR-TOPE
              PERFORM VER-MVX
              MOVE 'M' TO PPAR-TOPE
      ************
              PERFORM CALL-VSRV133-MVX
      ************
           ELSE
              WRITE RF-MOV FROM REKMOV INVALID PERFORM INVK-MOV
      **** rel 7.1
      *                                        GO TO ERRIO.
                                               GO TO ERRIO
              END-WRITE
      **** rel 7.2
      *       MOVE 'I' TO PPAR-TOPE
              MOVE 'M' TO PPAR-TOPE
              PERFORM VER-MOV
              MOVE 'M' TO PPAR-TOPE
      ************
              PERFORM CALL-VSRV133-MOV.
      ************
       RWMRP.
           ADD CLAV TO MOV-IMPO.
           IF MOV-DAT NOT > AZI-RVDT 
              REWRITE RF-MVX FROM REKMOV INVALID PERFORM INVK-MVX
                                                 GO TO ERRIO
      **** rel 7.1
              END-REWRITE
              MOVE 'M' TO PPAR-TOPE
      **** rel 7.2
              PERFORM VER-MVX
              MOVE 'M' TO PPAR-TOPE
      ************
              PERFORM CALL-VSRV133-MVX
      ************
           ELSE
              REWRITE RF-MOV FROM REKMOV INVALID PERFORM INVK-MOV
      **** rel 7.1
      *                                          GO TO ERRIO.
                                                 GO TO ERRIO
              END-REWRITE
              MOVE 'M' TO PPAR-TOPE
      **** rel 7.2
              PERFORM VER-MOV
              MOVE 'M' TO PPAR-TOPE
      ************
              PERFORM CALL-VSRV133-MOV.
      ************
       EX-RCHGG.
           EXIT.
      * - - - - - *
       READ-ANAAZI.
           MOVE MOV-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *---------------*
       ELIMINA-TOTALI.
      **** rel 7.2
           MOVE ZERO TO PPAR-FUN CONTA.
      ************
           MOVE LOW-VALUE TO KEYMX.
           IF RS-AZI NOT = ZERO MOVE RS-AZI TO KMX-AZI.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO ST-MOV.
       RD-MVX.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO ST-MOV.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO RD-MVX.
           IF RS-AZI NOT = ZERO 
              IF KMX-AZI > RS-AZI GO TO ST-MOV.
      *
           IF MOV-NUM < 99991    GO TO RD-MVX.
           IF MOV-CON = CRPCL(1) GO TO DEL-MVX.
           IF MOV-CON = CRPCL(2) GO TO DEL-MVX.
           IF MOV-CON = CRPCL(3) GO TO DEL-MVX.
           IF MOV-CON = CRPCL(4) GO TO DEL-MVX.
           IF MOV-CON = CRPCL(5) GO TO DEL-MVX.
           IF MOV-CON = CRPCL(6) GO TO DEL-MVX.
           IF MOV-CON = CRPCL(7) GO TO DEL-MVX.
           IF MOV-CON = CRPCL(8) GO TO DEL-MVX.
           IF MOV-CON = CRPCL(9) GO TO DEL-MVX.
           IF MOV-CON = CRPFR(1) GO TO DEL-MVX.
           IF MOV-CON = CRPFR(2) GO TO DEL-MVX.
           IF MOV-CON = CRPFR(3) GO TO DEL-MVX.
           IF MOV-CON = CRPFR(4) GO TO DEL-MVX.
           IF MOV-CON = CRPFR(5) GO TO DEL-MVX.
           IF MOV-CON = CRPFR(6) GO TO DEL-MVX.
           IF MOV-CON = CRPFR(7) GO TO DEL-MVX.
           IF MOV-CON = CRPFR(8) GO TO DEL-MVX.
           IF MOV-CON = CRPFR(9) GO TO DEL-MVX.
           GO TO RD-MVX.
      *
       DEL-MVX.
           DELETE MOVMXX.
      **** rel 7.2
           IF PPAR-FUN = ZERO 
              MOVE 1 TO PPAR-FUN
           ELSE
              MOVE 2 TO PPAR-FUN
              IF CONTA > 200
                 MOVE 'C' TO PPAR-TOPE
                 PERFORM END-SRV133-MVX
                 MOVE 1 TO PPAR-FUN
                 MOVE ZERO TO CONTA.
      ************
      **** rel 7.1
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MVX.
      ************
      *
           GO TO RD-MVX.
       ST-MOV.
      **** rel 7.2
           MOVE 'C' TO PPAR-TOPE.
           PERFORM END-SRV133-MVX.
      ************
      *
      **** rel 7.2
           MOVE ZERO TO PPAR-FUN CONTA.
      ************
           MOVE LOW-VALUE TO KEYMV.
           IF RS-AZI NOT = ZERO MOVE RS-AZI    TO KMV-AZI.
           START MOVIME KEY NOT < KEYMV INVALID GO TO END-MOV.
       RD-MOV.
           READ MOVIME NEXT INTO REKMOV AT END GO TO END-MOV.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO RD-MOV.
           IF RS-AZI NOT = ZERO
              IF KMV-AZI > RS-AZI GO TO END-MOV.
      *
           IF MOV-NUM < 99991    GO TO RD-MOV.
           IF MOV-CON = CRPCL(1) GO TO DEL-MOV.
           IF MOV-CON = CRPCL(2) GO TO DEL-MOV.
           IF MOV-CON = CRPCL(3) GO TO DEL-MOV.
           IF MOV-CON = CRPCL(4) GO TO DEL-MOV.
           IF MOV-CON = CRPCL(5) GO TO DEL-MOV.
           IF MOV-CON = CRPCL(6) GO TO DEL-MOV.
           IF MOV-CON = CRPCL(7) GO TO DEL-MOV.
           IF MOV-CON = CRPCL(8) GO TO DEL-MOV.
           IF MOV-CON = CRPCL(9) GO TO DEL-MOV.
           IF MOV-CON = CRPFR(1) GO TO DEL-MOV.
           IF MOV-CON = CRPFR(2) GO TO DEL-MOV.
           IF MOV-CON = CRPFR(3) GO TO DEL-MOV.
           IF MOV-CON = CRPFR(4) GO TO DEL-MOV.
           IF MOV-CON = CRPFR(5) GO TO DEL-MOV.
           IF MOV-CON = CRPFR(6) GO TO DEL-MOV.
           IF MOV-CON = CRPFR(7) GO TO DEL-MOV.
           IF MOV-CON = CRPFR(8) GO TO DEL-MOV.
           IF MOV-CON = CRPFR(9) GO TO DEL-MOV.
           GO TO RD-MOV.
      *
       DEL-MOV.
           DELETE MOVIME.
      **** rel 7.2
           IF PPAR-FUN = ZERO 
              MOVE 1 TO PPAR-FUN
           ELSE
              MOVE 2 TO PPAR-FUN
              IF CONTA > 200
                 MOVE 'C' TO PPAR-TOPE
                 PERFORM END-SRV133-MOV
                 MOVE 1 TO PPAR-FUN
                 MOVE ZERO TO CONTA.
      ************
      **** rel 7.1
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOV.
      ************
      *
           GO TO RD-MOV.
       END-MOV.
      **** rel 7.2
           MOVE 'C' TO PPAR-TOPE.
           PERFORM END-SRV133-MOV.
      ************
      *
       EX-ELIMINA-TOTALI.
           EXIT.
      *---------------*
      **** rel 7.1
       CALL-VSRV133-MOV.
      **** rel 7.2
      *    MOVE ZERO    TO PPAR-FUN.
           MOVE 'MOV' TO S-TMOV.
      ************
           MOVE 'MOV'   TO PPAR-TARC.
           MOVE KEYMV   TO PPAR-KEY.
      **** rel 7.2
           IF PPAR-FUN = 9 MOVE SPACE TO PPAR-KEY.
      ************
           MOVE ZERO    TO PPAR-CATT.
           IF ID-MOV = 'movime' MOVE '0' TO PPAR-OPZ(81:1).
           IF ID-MOV = 'movmol' MOVE '1' TO PPAR-OPZ(81:1).
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      **** rel 7.2
           ADD 1 TO CONTA.
      ************
      *
       CALL-VSRV133-MVX.
      **** rel 7.2
      *    MOVE ZERO    TO PPAR-FUN.
           MOVE 'MVX' TO S-TMOV.
      ************
           MOVE 'MOV'   TO PPAR-TARC.
           MOVE KEYMX   TO PPAR-KEY.
      **** rel 7.2
           IF PPAR-FUN = 9 MOVE SPACE TO PPAR-KEY.
      ************
           MOVE ZERO    TO PPAR-CATT.
           IF ID-MVX = 'movmxx' MOVE '2' TO PPAR-OPZ(81:1)
           IF ID-MVX = 'movoxx' MOVE '3' TO PPAR-OPZ(81:1)
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore chiamata vsrv133. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      **** rel 7.2
           ADD 1 TO CONTA.
      ************
      ************
      **** rel 7.2
      *----------------*
       END-SRV133-MOV.
           IF PPAR-FUN NOT = ZERO
              MOVE 9   TO PPAR-FUN
              PERFORM CALL-VSRV133-MOV.
      *----------------*
       END-SRV133-MVX.
           IF PPAR-FUN NOT = ZERO
              MOVE 9   TO PPAR-FUN
              PERFORM CALL-VSRV133-MVX.
      *----------------*
       VER-MOV.
           IF S-TMOV = 'MVX'
              PERFORM END-SRV133-MVX
              MOVE ZERO TO PPAR-FUN CONTA
              MOVE SPACE TO S-TMOV.
      *
           IF S-TMOV = SPACE OR 'MOV'
              IF PPAR-FUN = ZERO 
                 MOVE 1 TO PPAR-FUN
              ELSE
                 MOVE 2 TO PPAR-FUN
                 IF CONTA > 200
                    PERFORM END-SRV133-MOV
                    MOVE 1 TO PPAR-FUN
                    MOVE ZERO TO CONTA.
      *----------------*
       VER-MVX.
           IF S-TMOV = 'MOV'
              PERFORM END-SRV133-MOV
              MOVE ZERO TO PPAR-FUN CONTA
              MOVE SPACE TO S-TMOV.
      *
           IF S-TMOV = SPACE OR 'MVX'
              IF PPAR-FUN = ZERO 
                 MOVE 1 TO PPAR-FUN
              ELSE
                 MOVE 2 TO PPAR-FUN
                 IF CONTA > 200
                    PERFORM END-SRV133-MVX
                    MOVE 1 TO PPAR-FUN
                    MOVE ZERO TO CONTA.
      *----------------*
       VER-END.
           IF S-TMOV = 'MOV' PERFORM END-SRV133-MOV.
           IF S-TMOV = 'MVX' PERFORM END-SRV133-MVX.
      *
           MOVE ZERO TO PPAR-FUN CONTA.
           MOVE SPACE TO S-TMOV.
      *----------------*
      ************
