       IDENTIFICATION DIVISION.
       PROGRAM-ID. VSCA250.
      *
      * Stampa coerenza scadenze con saldo contabile
      *        ( Quadratura Scadenzario )
      *
      **** rel 7.2
      * Ricompilato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gricfxsl'.
           COPY 'griclfsl'.
           COPY 'griscasl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV
                  STATUS SF-LAV.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricfx'.
           COPY 'griclf'.
           COPY 'grisca'.
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 10 DATA RECORD RF-LAV.
       01 RF-LAV.
           02 KEYLV.
              05 KWS-AZI PIC 999.
              05 KWS-COD PIC 9(7).
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'griclfrk'.
           COPY 'gritabrk'.
           COPY 'parcdt'.
           COPY 'parzf'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-CFX PIC X(15) VALUE 'anacfx'.
       01  ID-SCA PIC X(15) VALUE 'anasca'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  COMODI.
           05 SF-AZI PIC XX.
           05 SF-CLF PIC XX.
           05 SF-CFX PIC XX.
           05 SF-SCA PIC XX.
           05 SF-TAB PIC XX.
           05 SF-LAV PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 CODICE.
              10 MAS  PIC 99     VALUE ZERO.
              10 COD  PIC 99999  VALUE ZERO.
           05 MCLI    PIC 99     VALUE ZERO.
           05 MFOR    PIC 99     VALUE ZERO.
           05 COD1.
              10 MS1  PIC 99     VALUE ZERO.
              10 CD1  PIC 99999  VALUE ZERO.
           05 COD2.
              10 MS2  PIC 99     VALUE ZERO.
              10 CD2  PIC 99999  VALUE ZERO.
           05 TOTALE  PIC S9(11)V99 VALUE ZERO.
           05 SCADE   PIC S9(11)V99 VALUE ZERO.
           05 SALAT   PIC S9(11)V99 VALUE ZERO.
           05 DIFFE   PIC S9(11)V99 VALUE ZERO.
           05 COMCLI  PIC 9(7)   VALUE ZERO.

           COPY 'vsca250.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-TPCLF     PIC 9.
           05 IF-COD-1     PIC 9(5).
           05 IF-COD-2     PIC 9(5).

       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcfx'.
           COPY 'dclclf'.
           COPY 'dclsca'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vsca250: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE WDSLAV.
           OPEN  OUTPUT WDSLAV.
           CLOSE WDSLAV.
           CLOSE ANACFX.
           CLOSE ANACLF.
           CLOSE ANASCA.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gricfxer'.
           COPY 'griclfer'.
           COPY 'griscaer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O WDSLAV.
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN INPUT ANACFX.
           OPEN INPUT ANACLF.
           OPEN INPUT ANASCA.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MCLI.
           MOVE T01-MFOR TO MFOR.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
           MOVE ZERO    TO IF-COD-1.
           MOVE 99999 TO IF-COD-2.
           MOVE ZERO  TO IF-TPCLF.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-COD-2.
           MOVE 'IF-COD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-2.
           IF IF-COD-2 < IF-COD-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-COD-2.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           COPY 'grirpt-sn' REPLACING 1 BY 2
                            RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9    TO AAGGG.
           MOVE AA9    TO GG9.
           MOVE AAGGG  TO AA9.
           MOVE 1      TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO TDAT.

           MOVE AZRGSOC TO TAZI.
           IF IF-TPCLF = ZERO MOVE MCLI TO MS1 MS2
                              MOVE ' - CLIENTI -' TO TTIPO
           ELSE               MOVE MFOR TO MS1 MS2
                              MOVE ' - FORNITORI -' TO TTIPO.
           MOVE IF-COD-1 TO CD1.
           MOVE IF-COD-2 TO CD2.

      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'SALDI CONTABILI DISCORDANTI CON SCADENZARIO'
                  DELIMITED SIZE INTO RP-TIT1.
      *
           STRING  'AL ' TDAT '  ' TTIPO 
                   DELIMITED SIZE INTO RP-TIT2.
      *
           PERFORM RPT-RIG1-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
           
           MOVE ZERO TO COMCLI XCRR.
           MOVE 1 TO RP-JMP.
           MOVE LOW-VALUE TO KEYS2.
           MOVE COD1      TO KS2-CODCF.
           START ANASCA KEY NOT < KEYS2 INVALID GO TO CLI90.
       CLI20.
           READ ANASCA NEXT AT END          GO TO CLI90.
           IF SF-SCA = '9D' OR '9A' OR '35' GO TO CLI20.
           IF KS2-CODCF > COD2              GO TO CLI90.
           IF KSC-AZI NOT = KAZ-COD         GO TO CLI20.
           IF (KSC-TIPO = 3 OR 4)           GO TO CLI20.
           IF SCA-STATO = 'P' OR 'I'        GO TO CLI20.
           MOVE KS2-CODCF TO CODICE.
           IF MAS = MCLI AND SCA-TPAG < 3   GO TO CLI20.
           IF KS2-CODCF NOT = COMCLI PERFORM CLIENTE THRU C99.
           COMPUTE SCADE = SCA-IMRATA - SCA-PAGATO.
           IF KSC-TIPO = 2 MULTIPLY -1 BY SCADE.
           COMPUTE TOTALE = TOTALE + SCADE.
      *
           COPY 'grirpt-r' REPLACING 1 BY 2
                           RPT-LB-RIENTRO BY RPT-LB-RIENTRO-2.
      *
           GO TO CLI20.
       CLI90.
           PERFORM CLIENTE THRU C050.
           MOVE ZERO TO TOTALE XCRR.
           MOVE 1 TO RP-JMP.
           MOVE KAZ-COD  TO KCF-AZI.
           MOVE COD1     TO KCF-COD.
           START ANACLF KEY NOT < KEYCF INVALID GO TO CLI190.
       CLI120.
           READ ANACLF NEXT INTO REKCLF AT END  GO TO CLI190.
           IF SF-CLF = '9D' OR '9A' OR '35'     GO TO CLI120.
           IF KCF-AZI NOT = KAZ-COD             GO TO CLI190.
      **** rel 6.1
      *    IF KCF-COD > IF-COD-2                GO TO CLI190.
      *    IF KCF-COD > COD2                    GO TO CLI90.
           IF KCF-COD > COD2                    GO TO CLI190.
      ************
           MOVE KEYCF TO KEYLV.
           READ WDSLAV INVALID GO TO CLI150.
           GO TO CLI120.
       CLI150.
           MOVE KCF-COD TO COMCLI.
           COMPUTE SALAT = CLF-SESP + CLF-SE-D - CLF-SE-A.
           MOVE KEYCF TO KEYCX.
           READ ANACFX INTO REKCLF INVALID 
                MOVE ZERO TO CLF-SESP CLF-SE-D CLF-SE-A
                GO TO CLI180.
           IF SF-CFX = '9D' OR '9A' OR '35' MOVE RF-CFX TO REKCLF.
       CLI180.
           COMPUTE SALAT = SALAT + CLF-SESP + CLF-SE-D - CLF-SE-A.
           MOVE RF-CLF TO REKCLF.
           PERFORM CLIENTE THRU C050.
      *
           COPY 'grirpt-r'.
      *
           GO TO CLI120.
       CLI190.
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w9' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       CLIENTE.
           IF COMCLI = ZERO OR TOTALE = SALAT GO TO C050.
           MOVE COMCLI TO RCLI.
           MOVE CLF-RGS TO RDCLI.
           MOVE SALAT   TO RSALDO.
           MOVE TOTALE  TO RSCADE.
           MOVE ZERO TO DIFFE.
           COMPUTE DIFFE = SALAT - TOTALE.
           MOVE DIFFE TO RDIFFE.
      *
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 1 TO XCRR.
       C050. EXIT.
       C060.
           MOVE KAZ-COD TO KCF-AZI.
           MOVE KS2-CODCF TO KCF-COD COMCLI.
           MOVE KEYCF TO KEYCX KEYLV.
           WRITE RF-LAV INVALID MOVE 'WR LAV' TO MESS GO TO ERRIO.
           READ ANACFX INTO REKCLF INVALID 
                MOVE ZERO TO CLF-SESP CLF-SE-D CLF-SE-A
                GO TO C070.
           IF SF-CFX = '9D' OR '9A' OR '35' MOVE RF-CFX TO REKCLF.
       C070.
           COMPUTE SALAT = CLF-SESP + CLF-SE-D - CLF-SE-A.
           READ ANACLF INTO REKCLF INVALID 
                MOVE ZERO TO CLF-SESP CLF-SE-D CLF-SE-A
                MOVE ALL '*' TO CLF-RGS
                GO TO C080.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
       C080.
           COMPUTE SALAT = SALAT + CLF-SESP + CLF-SE-D - CLF-SE-A.
           MOVE ZERO TO TOTALE.
       C99. EXIT.
      *------------------
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'Ragione Sociale' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Saldo Cont.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Scadenzario' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Differenza' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
