       IDENTIFICATION DIVISION.
       PROGRAM-ID. VUTI131.
      *
      * Routine annullamento movimenti contabilita'
      *         per numero di registrazione
      *
      * Nota: il chiamante dopo la call deve testare
      *       errio-st distinguendo: 9 per errore bloccante
      *                              8 per warning
      *
      **** rel 4.0-2
      * Nota: parametro di input CTR-131
      *       0 = non vengono effettuati controlli sull'annullamento
      *           (quando chiamato dalla variazione primanota, perche'
      *            i controlli necessari sono gia' stati effettuati
      *            a monte)
      *       1 = vengono effettuati controlli sull'annullamento
      *           (quando chiamato da vuti132, oppure quando si preme
      *            il bottone 'Annullamento registrazione' da vcon110)
      ************
      **** rel 5.0
      * Nota: parametro di input SCA-131
      *       0 = non vengono annullati i records scadenzario
      *           (quando chiamato dalla variazione primanota, perche'
      *            gli opportuni annullamenti vengono effettuati
      *            direttamente dal progr. di primanota)
      *       1 = vengono annullati i records dello scadenzario
      *           (quando chiamato da vuti132, oppure quando si preme
      *            il bottone 'Annullamento registrazione' da vcon110)
      ************
      **** rel 6.1
      * Nota: parametro di input FAF-131
      *       0 = non vengono effettuate cancellazioni delle fatture
      *           fornitori pubblicate
      *           (quando chiamato dalla variazione primanota, perche'
      *            i controlli necessari sono gia' stati effettuati
      *            a monte)
      *       1 = vengono effettuate cancellazioni delle fatture
      *           fornitori pubblicate
      *           (quando chiamato da vuti132, oppure quando si preme
      *            il bottone 'Annullamento registrazione' da vcon110)
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
      **** rel 4.0-2
           COPY 'griprasl'.
      ************
           COPY 'griconsl'.
           COPY 'griclfsl'.
           COPY 'grimovsl'.
           COPY 'grimszsl'.
           COPY 'grifcdsl'.
           COPY 'griparsl'.
           COPY 'griftssl'.
           COPY 'gripavsl'.
           COPY 'gritabsl'.
      **** rel 5.0
           COPY 'griscasl'.
           COPY 'gridscsl'.
      ************
      **** rel 6.3
           COPY 'gritrasl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
      **** rel 4.0-2
           COPY 'gripra'.
      ************
           COPY 'gricon'.
           COPY 'griclf'.
           COPY 'grimov'.
           COPY 'grimsz'.
           COPY 'grifcd'.
           COPY 'gripar'.
           COPY 'grifts'.
           COPY 'gripav'.
      **** rel 5.0
           COPY 'grisca'.
           COPY 'gridsc'.
      ************
           COPY 'gritab'.
      **** rel 6.3
           COPY 'gritra'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
      **** rel 4.0-2
           COPY 'griazirk'.
      ************
           COPY 'griconrk'.
           COPY 'griclfrk'.
           COPY 'gritabrk'.
           COPY 'grit20rk'.
           COPY 'grimovrk'.
           COPY 'griparrk'.
           COPY 'grit14g'.
           COPY 'grit25rk'.
           COPY 'parcdt'.
           COPY 'parzf'.
           COPY 'parmb'.
      **** rel 1.2
           COPY 'parlk'.
      ************
      **** rel 6.1
           COPY 'parppar'.
      ************
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
      **** rel 4.0-2
       01  ID-PRA PIC X(15) VALUE 'proazi'.
      ************
       01  ID-CON PIC X(15) VALUE 'anacon'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-MSZ PIC X(15) VALUE 'movsez'.
       01  ID-FCD PIC X(15) VALUE 'forncd'.
       01  ID-PAR PIC X(15) VALUE 'partit'.
       01  ID-FTS PIC X(15) VALUE 'fatsos'.
       01  ID-PAV PIC X(15) VALUE 'parval'.
      **** rel 5.0
       01  ID-SCA PIC X(15) VALUE 'anasca'.
       01  ID-DSC PIC X(15) VALUE 'detsca'.
      ************
      **** rel 6.3
       01  ID-TRA PIC X(15) VALUE 'eintra'.
      ************
       01  COMODI.
           05 SF-AZI  PIC XX.
      **** rel 4.0-2
           05 SF-PRA  PIC XX.
      ************
           05 SF-CON  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-TAB  PIC XX.
           05 SF-MOV  PIC XX.
           05 SF-MSZ  PIC XX.
           05 SF-FCD  PIC XX.
           05 SF-PAR  PIC XX.
           05 SF-FTS  PIC XX.
           05 SF-PAV  PIC XX.
      **** rel 5.0
           05 SF-SCA  PIC XX.
           05 SF-DSC  PIC XX.
      ************
      **** rel 6.3
           05 SF-TRA  PIC XX.
      ************
           05 K       PIC 9.
           05 WCAUSA  PIC 9(3).
           05 WDAVE   PIC X.
           05 WFLGIS  PIC 9.
           05 WTIPOP  PIC 99.
      **** rel 4.0
      *    05 WIMPOR  PIC S9(11) COMP-3.
           05 WIMPOR  PIC S9(11)V99 COMP-3.
      ************
           05 MESS    PIC X(40)  VALUE SPACE.
           05 CATCON  PIC 9      VALUE ZERO.
           05 SEGNO   PIC 9      VALUE ZERO.
      **** rel 4.0
      *    05 IVA     PIC S9(11) VALUE ZERO.
           05 IVA     PIC S9(11)V99 VALUE ZERO.
      ************
           05 CIVAV   PIC 9(7)   VALUE ZERO.
           05 CIVAQ   PIC 9(7)   VALUE ZERO.
           05 CIVSO   PIC 9(7)   VALUE ZERO.
      **** rel 4.0
      *    05 COMODO  PIC S9(11) VALUE ZERO.
           05 COMODO  PIC S9(11)V99 VALUE ZERO.
      ************
           05 CRPCL   PIC 9(7)   VALUE ZERO.
           05 CRPC1   PIC 9(7)   VALUE ZERO.
           05 CRPC2   PIC 9(7)   VALUE ZERO.
           05 CRPFR   PIC 9(7)   VALUE ZERO.
           05 CRPF1   PIC 9(7)   VALUE ZERO.
           05 CRPF2   PIC 9(7)   VALUE ZERO.
           05 WCAN    PIC 9(17)  VALUE ZERO.
           05 SWPAR   PIC 9      VALUE ZERO.
           05 NPAR    PIC 99     VALUE ZERO.
           05 SW      PIC 9      VALUE ZERO.
           05 STAT116 PIC 99     VALUE ZERO.
           05 CODICE  PIC 9(7).
           05 FILLER REDEFINES CODICE.
              10 MAS  PIC 99.
              10 CDX  PIC 9(5).
           05 CAN     PIC 9(17) VALUE ZERO.
           05 CCC REDEFINES CAN.
              10 TIPO  PIC 9.
              10 CLFO  PIC 9(5).
              10 ANNC  PIC 9(4).
              10 NDOC  PIC 9(5).
              10 NUME  PIC 99.
           05 DTRIF  PIC 9(5) COMP-3 VALUE ZERO.
      **** rel 4.0-2
           05 SWANL  PIC 9.
           05 DTAIVA PIC 9(5) COMP-3.
      ************
      **** rel 5.0-1
           05 TIPOP  PIC 99 VALUE ZERO.
      ************
      **** rel 5.1
           05 AGIVA  PIC 9    VALUE ZERO.
           05 SWIVA  PIC 9    VALUE ZERO.
      ************
      **** rel 6.2
           05 IMP     PIC S9(11)V99.
           05 IVN     PIC S9(11)V99.
      ************
      **** rel 6.1
           05 COMKEY.
              10 COM-AZI   PIC 9(3).
              10 COM-ANNO  PIC 9(4).
              10 COM-CATT  PIC X.
              10 COM-NPRGI PIC 9(5).
           05 COMMOV.
              10 COM-DAT   PIC 9(5).
              10 COM-DTDOC PIC 9(5).
              10 COM-NDOC  PIC 9(5).
              10 COM-ACF   PIC 9(5).
              10 COM-CAUS  PIC 9(3).
      ************
      **** rel 6.2
       01 PARDNS.
          05 DNS-AZI   PIC 9(3).
          05 DNS-TIPO  PIC 9.
          05 DNS-DTSCA PIC 9(5) COMP-3.
          05 DNS-PRG   PIC 9(5) COMP-3.
      ************
       LINKAGE SECTION.
       01  PARLINK-131.
           05 CDAZ-131  PIC 9(3).
           05 NREG-131  PIC 9(5).
           05 FL-131    PIC 9.
      **** rel 4.0-2
           05 CTR-131    PIC 9.
      ************
      **** rel 5.0
           05 SCA-131    PIC 9.
      ************
      **** rel 5.2
           05 DTMOV-131 PIC 9(5).
      ************
      **** rel 6.1
           05 FAF-131    PIC 9.
      ************
      **** nt 71
      * 0 = variazione ; 1 = annullamento
           05 FUN-C110   PIC 9.
      **********
       PROCEDURE DIVISION USING PARLINK-131.
           COPY 'declxer1'.
           COPY 'dclazi'.
      **** rel 4.0-2
           COPY 'dclpra'.
      ************
           COPY 'dclcon'.
           COPY 'dclclf'.
           COPY 'dclmov'.
           COPY 'dclmsz'.
           COPY 'dclfcd'.
           COPY 'dclpar'.
           COPY 'dclfts'.
           COPY 'dcltab'.
           COPY 'dclpav'.
      **** rel 5.0
           COPY 'dclsca'.
           COPY 'dcldsc'.
      ************
      **** rel 6.3
           COPY 'dcltra'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strsub'.
           IF FL-131 = ZERO
              MOVE 'anaazi' TO ID-AZI
              MOVE 'tabell' TO ID-TAB
              MOVE 'forncd' TO ID-FCD
              MOVE 'anaclf' TO ID-CLF
              MOVE 'anacon' TO ID-CON
              MOVE 'movime' TO ID-MOV
              MOVE 'movsez' TO ID-MSZ
           ELSE
              MOVE 'anazol' TO ID-AZI
              MOVE 'tabold' TO ID-TAB
              MOVE 'forncx' TO ID-FCD
              MOVE 'anacfx' TO ID-CLF
              MOVE 'anacol' TO ID-CON
              MOVE 'movmol' TO ID-MOV
              MOVE 'movsol' TO ID-MSZ.
      **** rel 5.0-2
      *    OPEN INPUT ANAAZI
      *               TABELL.
      *** open I/O per consentire LOCK
           OPEN I-O ANAAZI.
           OPEN INPUT TABELL.
      **************
           OPEN I-O ANACON
                    ANACLF
                    MOVIME
                    MOVSEZ
      **** rel 5.1
      *             FORNCD
      ************
                    PARTIT
      **** rel 5.1
      *             PARVAL
      ************
      **** rel 5.0
                    ANASCA
      **** rel 5.1
      *             DETSCA
                    DETSCA.
      ************
      ************
      **** rel 5.1
      *             FATSOS.
      ************
      **** rel 6.3
           OPEN I-O EINTRA.
      ************
      **** rel 5.2
      *    IF CDAZ-131  = ZERO OR NREG-131 = ZERO
           IF CDAZ-131  = ZERO OR NREG-131 = ZERO  OR DTMOV-131 = ZERO
      ************
              MOVE 'Vuti131: Errore parametri di chiamata  ' TO F-MES1
              MOVE 'Annullamento registrazione non eseguito' TO F-MES2
              MOVE 2 TO F-NMES
              GO TO ERRIO.
      *
      **** rel 4.0-2
           MOVE 9 TO SWANL.
      *
           OPEN INPUT PROAZI.
           MOVE CDAZ-131 TO KPR-COD.
           READ PROAZI INVALID PERFORM INVK-PRA
                               CLOSE PROAZI
                               GO TO ERRIO.
           CLOSE PROAZI.
      *
      ************
           MOVE 25       TO T25-TIP.
           MOVE CDAZ-131 TO T25-COD.
           MOVE '0'      TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
      **** rel 4.0-2
           MOVE T25-DUP TO DTAIVA.
      ************
      *
           MOVE 20 TO KTB-TIP.
           MOVE 1  TO KTB-COD.
           READ TABELL INTO RKTB20 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB20.
      *
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-CIVAV TO CIVAV.
           MOVE T01-CIVAQ TO CIVAQ.
           MOVE T01-CIVSO TO CIVSO.
           MOVE T01-CRPCL TO CRPCL.
           MOVE T01-CRPC1 TO CRPC1.
           MOVE T01-CRPC2 TO CRPC2.
           MOVE T01-CRPFR TO CRPFR.
           MOVE T01-CRPF1 TO CRPF1.
           MOVE T01-CRPF2 TO CRPF2.
      *
           MOVE 14 TO KTB-TIP.
           MOVE 7  TO KTB-COD.
           READ TABELL INTO RKTB14G INVALID PERFORM INVK-TAB
                                            GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB14G.
      *
           MOVE 14 TO KTB-TIP.
           MOVE 1  TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
      *
       A00-AZZ-MOV.
           MOVE 1 TO SW.
       A10.
           MOVE NREG-131 TO KEYMS2.
           START MOVSEZ KEY NOT < KEYMS2 INVALID GO TO A20.
       A10-00.
           READ MOVSEZ NEXT INTO REKMOV AT END GO TO A20.
           IF SF-MSZ = '9D' OR '9A' OR '35' GO TO A10-00.
           IF MOV-NREG > NREG-131 GO TO A20.
           IF MOV-AZI NOT = CDAZ-131 GO TO A10-00.
      **** rel 5.2
           IF MOV-DAT NOT = DTMOV-131 GO TO A10-00.
      ************
           GO TO A30.
       A20.
           MOVE NREG-131 TO KEYMV2.
           MOVE ZERO TO SW.
           START MOVIME KEY NOT < KEYMV2 INVALID GO TO A90.
       A20-00.
           READ MOVIME NEXT INTO REKMOV AT END GO TO A90.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO A20-00.
           IF MOV-CAUS = 999 GO TO A20-00.
           IF MOV-CON = CRPCL     OR
                        CRPC1     OR
                        CRPC2     OR
                        T14-CRPC3 OR
                        T14-CRPC4 OR
                        T14-CRPC5 OR
                        T14-CRPC6 OR
                        T14-CRPC7 OR
                        T14-CRPC8 OR
                        CRPFR     OR
                        CRPF1     OR
                        CRPF2     OR
                        T14-CRPF3 OR
                        T14-CRPF4 OR
                        T14-CRPF5 OR
                        T14-CRPF6 OR
                        T14-CRPF7 OR
                        T14-CRPF8 GO TO A20-00.
           IF MOV-NREG > NREG-131 GO TO A90.
           IF MOV-AZI NOT = CDAZ-131 GO TO A20-00.
      **** rel 5.2
           IF MOV-DAT NOT = DTMOV-131 GO TO A20-00.
      ************
       A30.
      **** rel 4.0
           IF MOV-FLGE2 > ZERO
              MOVE 'Movimento pre Big-Bang' TO F-MES1
              MOVE 'Non cancellabile      ' TO F-MES2
              MOVE 2 TO F-NMES
              GO TO ERRIO.
      ************
           MOVE MOV-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE 01 TO MM9 GG9.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO DTRIF.
           IF SW > ZERO GO TO LPMSZ.
           MOVE MOV-CAUS TO KTB-COD.
           MOVE 2        TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
       LP200.
           MOVE CDAZ-131 TO KAZ-COD.
      **** rel 4.0-2
      *    READ ANAAZI KEPT LOCK INVALID PERFORM INVK-AZI
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID PERFORM INVK-AZI
      ************
                                         GO TO ERRIO.
           IF SF-AZI NOT = ZERO PERFORM REC-LOCK
                                GO TO LP200.
      **** rel 4.0-2
           IF SWANL = 9
              PERFORM VER-SE-ANNULL THRU EX-VER-SE-ANNULL
              IF SWANL = ZERO GO TO FINE.
      ************
           MOVE CDAZ-131  TO KPC-AZI.
           MOVE KMV-CON TO KPC-COD.
           READ ANACON INTO REKCON INVALID PERFORM INVK-CON
                                           GO TO ERRIO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           IF MOV-D-A = 'D'
              SUBTRACT MOV-IMPO FROM CON-SP-D
              SUBTRACT MOV-IMPO FROM CON-SE-D
           ELSE
              SUBTRACT MOV-IMPO FROM CON-SP-A
              SUBTRACT MOV-IMPO FROM CON-SE-A.
           GO TO LP260.
       LP260.
           REWRITE RF-CON FROM REKCON INVALID PERFORM INVK-CON
                                              GO TO ERRIO.
           IF NOT (KMV-CON = CIVAV OR CIVAQ OR CIVSO) GO TO LP300.
           IF MOV-FLAG > ZERO GO TO LP300.
      **** rel 4.0
      **** rel 6.2
      *    IF MOV-TIP = 4 GO TO LP300.
           IF MOV-TIP = 4 AND KMV-CON NOT = CIVAQ GO TO LP300.
      ************
      ************
           MOVE T02-SEGNO TO SEGNO.
           MOVE T02-TIPOP TO WTIPOP.
           MOVE T02-FLGIS TO WFLGIS.
           MOVE 3       TO KTB-TIP.
           MOVE MOV-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE CDAZ-131 TO KCF-AZI.
           MOVE MOV-ACF  TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID PERFORM INVK-CLF
                                           GO TO ERRIO.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
      **** rel 6.2
      *    ADD MOV-IMPO MOV-IVN GIVING IVA.
           IF MOV-TIP = 4 MOVE MOV-INL TO IVN
           ELSE           MOVE MOV-IVN TO IVN.
           ADD MOV-IMPO IVN GIVING IVA.
      ************
           IF MOV-TREG = 3 AND
              MOV-DTDOC < DTRIF GO TO LP270.
           IF WFLGIS = 2 GO TO LP263.
      **** rel 6.2
           IF MOV-TIP = 4 MOVE MOV-IML TO IMP
           ELSE           MOVE MOV-IMP TO IMP.
      ************
           IF WTIPOP = 8
      **** rel 6.2
      *       SUBTRACT MOV-IMP FROM CLF-TACCR
      *       MULTIPLY -1 BY MOV-IMP
              SUBTRACT IMP FROM CLF-TACCR
              MULTIPLY -1 BY IMP
      ************
              MULTIPLY -1 BY IVA.
           IF T03-TPIVA < 2 OR
      **** rel 6.2
      *       T03-TPIVA = 7 SUBTRACT MOV-IMP FROM CLF-IMPON.
              T03-TPIVA = 7 SUBTRACT IMP FROM CLF-IMPON.
      ************
           IF T03-TPIVA > 1 AND
      **** rel 6.2
      *       T03-TPIVA < 5 SUBTRACT MOV-IMP FROM CLF-ESENT.
      **** rel 7.1
      *       T03-TPIVA < 5 SUBTRACT IMP FROM CLF-ESENT.
              T03-TPIVA < 6 SUBTRACT IMP FROM CLF-ESENT.
      ************
      ************
           IF T03-TPIVA = 6
      **** rel 6.2
      *       SUBTRACT MOV-IMP FROM CLF-NIMPO
              SUBTRACT IMP FROM CLF-NIMPO
      ************
              IF SEGNO = ZERO
                 SUBTRACT 1 FROM CLF-NOPNI
              ELSE
                 ADD 1 TO CLF-NOPNI.
      **** rel 7.1
      *    SUBTRACT IVA FROM CLF-IMIVA.
           IF MOV-TIP NOT = 4
              SUBTRACT IVA FROM CLF-IMIVA.
      ************
       LP263.
           IF WFLGIS = ZERO GO TO LP269.
           IF WFLGIS = 2 AND KMV-CON = CIVSO GO TO LP269.
      **** rel 5.1
           OPEN I-O FATSOS.
      ************
           MOVE CDAZ-131 TO KFS-AZI.
           MOVE MOV-ACF  TO KFS-CLI.
           MOVE MOV-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO KFS-ANNO.
           MOVE MOV-CATT TO KFS-CATT.
           MOVE MOV-NDOC TO KFS-NFAT.
      **** rel 5.1
      *    READ FATSOS INVALID GO TO LP269.
           READ FATSOS INVALID GO TO LP268.
      ************
           MOVE ZERO TO K.
       LP264.
           ADD 1 TO K.
           IF MOV-IVA = FTS-CDIVA(K) GO TO LP265.
           IF K < 6 GO TO LP264.
       LP265.
           IF WFLGIS = 1 SUBTRACT MOV-IMP FROM FTS-IMPON(K)
                         SUBTRACT IVA     FROM FTS-IMIVA(K).
           IF WFLGIS = 2 SUBTRACT MOV-IMP FROM FTS-IMPAG(K)
                         SUBTRACT IVA     FROM FTS-IVPAG(K).
           MOVE ZERO TO K COMODO.
       LP266.
           ADD 1 TO K.
           COMPUTE COMODO = COMODO + FTS-IMPON(K) + FTS-IMIVA(K)
                                  - (FTS-IMPAG(K) + FTS-IVPAG(K)).
           IF K < 6 GO TO LP266.
           MOVE ZERO TO FTS-FLAG.
           IF COMODO = ZERO MOVE 1 TO FTS-FLAG.
           REWRITE RF-FTS INVALID
                   MOVE 'Errore scrittura fatture sospeso' TO F-MES1
                   MOVE 1 TO F-NMES
                   CALL 'vrmbox' USING PARMB.
      **** rel 5.1
       LP268.
           CLOSE FATSOS.
      ************
       LP269.
           REWRITE RF-CLF FROM REKCLF INVALID PERFORM INVK-CLF
                                              GO TO ERRIO.
           GO TO LP300.
       LP270.
           IF WFLGIS > ZERO GO TO LP300.
      **** rel 5.1
           OPEN I-O FORNCD.
      ************
           MOVE KEYCF TO KEYFD.
           READ FORNCD INVALID MOVE ZERO TO RF-FCD
                               MOVE ZERO TO FCD-IMPON FCD-NIMPO
                                            FCD-ESENT FCD-IMIVA
                                            FCD-TACCR
                               MOVE KEYCF TO KEYFD.
           IF WTIPOP = 8
              SUBTRACT MOV-IMP FROM FCD-TACCR
              MULTIPLY -1 BY MOV-IMP
              MULTIPLY -1 BY IVA.
           IF T03-TPIVA < 2 OR
              T03-TPIVA = 7 SUBTRACT MOV-IMP FROM FCD-IMPON.
           IF T03-TPIVA > 1 AND
      **** rel 7.1
      *       T03-TPIVA < 5 SUBTRACT MOV-IMP FROM FCD-ESENT.
              T03-TPIVA < 6 SUBTRACT MOV-IMP FROM FCD-ESENT.
      ************
           IF T03-TPIVA = 6
              SUBTRACT MOV-IMP FROM FCD-NIMPO
              IF SEGNO = ZERO
                 SUBTRACT 1 FROM FCD-NOPNI
              ELSE
                 ADD 1 TO FCD-NOPNI.
           SUBTRACT IVA FROM FCD-IMIVA.
           IF SF-FCD = ZERO GO TO LP280.
           WRITE RF-FCD INVALID PERFORM INVK-FCD GO TO ERRIO.
      **** rel 5.1
      *    GO TO LP300.
           GO TO LP290.
      ************
       LP280.
           REWRITE RF-FCD INVALID PERFORM INVK-FCD GO TO ERRIO.
      **** rel 5.1
       LP290.
           CLOSE FORNCD.
      ************
       LP300.
           IF MOV-FLAG = ZERO AND T25-PER = 2 AND
                         MOV-TREG = 2 AND T03-TSOPE NOT = 7
                         MOVE 1 TO STAT116
                         CALL 'vcon116' USING STAT116 REKMOV
                         IF ERRIO-ST NOT = ZERO GO TO ERRIO.
           CANCEL 'vcon116'.
           DELETE MOVIME INVALID PERFORM INVK-MOV GO TO ERRIO.
      **** rel 7.1
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOV.
      ************
      **** rel 6.3
      **** nt 71
      *    PERFORM DEL-EINTRA THRU EX-DEL-EINTRA.
           IF FUN-C110 = 'D'
              PERFORM DEL-EINTRA THRU EX-DEL-EINTRA.
      **********
      ************
      **** rel 5.1
           OPEN I-O PARVAL.
      ************
           MOVE KMV-AZI   TO KPV-AZI.
           MOVE KMV-CON   TO KPV-CON.
           MOVE MOV-VALUT TO KPV-VAL.
           MOVE KMV-DAT   TO KPV-DAT.
           MOVE KMV-NUM   TO KPV-NUM.
           READ PARVAL INVALID GO TO LP310.
           DELETE PARVAL INVALID PERFORM INVK-PAV GO TO ERRIO.
       LP310.
      **** rel 5.1
           CLOSE PARVAL.
      ************
           UNLOCK ANAAZI.
           GO TO A20.
       LPMSZ.
           MOVE MOV-CAUS TO KTB-COD.
           MOVE 2        TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      **** rel 5.0-1
           MOVE T02-TIPOP TO TIPOP.
      ************
       LP520.
           MOVE CDAZ-131 TO KAZ-COD.
      **** rel 4.0-2
      *    READ ANAAZI KEPT LOCK INVALID PERFORM INVK-AZI
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID PERFORM INVK-AZI
      ************
                                         GO TO ERRIO.
           IF SF-AZI NOT = ZERO PERFORM REC-LOCK
                                GO TO LP520.
      **** rel 4.0-2
           IF SWANL = 9
              PERFORM VER-SE-ANNULL THRU EX-VER-SE-ANNULL
              IF SWANL = ZERO GO TO FINE.
      ************
           MOVE KMS-AZI TO KCF-AZI.
           MOVE KMS-CON TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID PERFORM INVK-CLF
                                           GO TO ERRIO.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           MOVE CLF-CATCON TO CATCON.
           IF T02-CTRIN > ZERO
              SUBTRACT MOV-IMPO FROM CLF-LINS
              IF T02-SEGNO = ZERO
                 SUBTRACT 1 FROM CLF-NINS
              ELSE
                 ADD 1 TO CLF-NINS.
           IF MOV-TREG = 3 AND
              MOV-DTDOC < DTRIF GO TO LP530.
           IF WFLGIS = 2 GO TO LP530.
           IF T02-CTRFT > ZERO
              IF T02-SEGNO = ZERO
                 SUBTRACT 1 FROM CLF-NFATT
              ELSE
                 ADD 1 TO CLF-NFATT.
           IF T02-CTRAC > ZERO
              IF T02-SEGNO = ZERO
                 SUBTRACT 1 FROM CLF-NACCR
              ELSE
                 ADD 1 TO CLF-NACCR.
           GO TO LP550.
       LP530.
           IF WFLGIS > ZERO GO TO LP550.
      **** rel 5.1
           OPEN I-O FORNCD.
      ************
           MOVE KEYCF TO KEYFD.
           READ FORNCD INVALID MOVE ZERO TO RF-FCD
                               MOVE ZERO TO FCD-IMPON FCD-NIMPO
                                            FCD-ESENT FCD-IMIVA
                                            FCD-TACCR
                               MOVE KEYCF TO KEYFD.
           IF T02-CTRFT > ZERO
              IF T02-SEGNO = ZERO
                 SUBTRACT 1 FROM FCD-NFATT
              ELSE
                 ADD 1 TO FCD-NFATT.
           IF T02-CTRAC > ZERO
              IF T02-SEGNO = ZERO
                 SUBTRACT 1 FROM FCD-NACCR
              ELSE
                 ADD 1 TO FCD-NACCR.
           IF SF-FCD = ZERO GO TO LP540.
      **** rel 5.1
      *    IF T02-CTRFT = ZERO AND T02-CTRAC = ZERO GO TO LP550.
           IF T02-CTRFT = ZERO AND T02-CTRAC = ZERO GO TO LP545.
      ************
           WRITE RF-FCD INVALID PERFORM INVK-FCD
                                GO TO ERRIO.
      **** rel 5.1
      *    GO TO LP550.
           GO TO LP545.
      ************
       LP540.
           REWRITE RF-FCD INVALID PERFORM INVK-FCD
                                  GO TO ERRIO.
      **** rel 5.1
       LP545.
           CLOSE FORNCD.
      ************
       LP550.
           IF MOV-D-A = 'D'
              SUBTRACT MOV-IMPO FROM CLF-SP-D
              SUBTRACT MOV-IMPO FROM CLF-SE-D
           ELSE
              SUBTRACT MOV-IMPO FROM CLF-SP-A
              SUBTRACT MOV-IMPO FROM CLF-SE-A.
           GO TO LP557.
       LP557.
           REWRITE RF-CLF FROM REKCLF INVALID PERFORM INVK-CLF
                                              GO TO ERRIO.
           MOVE MOV-IMPO TO WIMPOR.
           MOVE MOV-CAUS TO WCAUSA.
           MOVE MOV-D-A  TO WDAVE.
           MOVE CDAZ-131 TO KMV-AZI KPC-AZI.
           IF MOV-TREG = 3 GO TO LP560.
           MOVE CRPCL TO KMV-CON.
           IF CATCON = 2 MOVE CRPC1     TO KMV-CON.
           IF CATCON = 3 MOVE CRPC2     TO KMV-CON.
           IF CATCON = 4 MOVE T14-CRPC3 TO KMV-CON.
           IF CATCON = 5 MOVE T14-CRPC4 TO KMV-CON.
           IF CATCON = 6 MOVE T14-CRPC5 TO KMV-CON.
           IF CATCON = 7 MOVE T14-CRPC6 TO KMV-CON.
           IF CATCON = 8 MOVE T14-CRPC7 TO KMV-CON.
           IF CATCON = 9 MOVE T14-CRPC8 TO KMV-CON.
           MOVE 99991 TO KMV-NUM.
           IF WDAVE = 'A' MOVE 99992 TO KMV-NUM.
           GO TO LP570.
       LP560.
           MOVE CRPFR TO KMV-CON.
           IF CATCON = 2 MOVE CRPF1     TO KMV-CON.
           IF CATCON = 3 MOVE CRPF2     TO KMV-CON.
           IF CATCON = 4 MOVE T14-CRPF3 TO KMV-CON.
           IF CATCON = 5 MOVE T14-CRPF4 TO KMV-CON.
           IF CATCON = 6 MOVE T14-CRPF5 TO KMV-CON.
           IF CATCON = 7 MOVE T14-CRPF6 TO KMV-CON.
           IF CATCON = 8 MOVE T14-CRPF7 TO KMV-CON.
           IF CATCON = 9 MOVE T14-CRPF8 TO KMV-CON.
           MOVE 99993 TO KMV-NUM.
           IF WDAVE = 'A' MOVE 99994 TO KMV-NUM.
       LP570.
           IF WCAUSA = T20-CDSOC OR T20-CASOC OR
                       T20-CDCLC OR T20-CACLC OR
                       T20-CDFOC OR T20-CAFOC OR
                       T20-CDSOA OR T20-CASOA OR
                       T20-CDCLA OR T20-CACLA OR
                       T20-CDFOA OR T20-CAFOA ADD 4 TO KMV-NUM.
           MOVE KMV-CON TO KPC-COD.
           MOVE MOV-DAT TO KMV-DAT.
           READ MOVIME INTO REKMOV INVALID
                PERFORM E00-ERRORE THRU E99
                GO TO LP592.
           IF SF-MOV = '9D' OR '9A' OR '35' MOVE RF-MOV TO REKMOV.
           SUBTRACT WIMPOR FROM MOV-IMPO.
           IF MOV-IMPO NOT = ZERO GO TO RWMOV.
           DELETE MOVIME INVALID PERFORM INVK-MOV
                                 GO TO ERRIO.
      **** rel 7.1
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOV.
      ************
      **** rel 6.3
      **** nt 71
      *    PERFORM DEL-EINTRA THRU EX-DEL-EINTRA.
           IF FUN-C110 = 'D'
              PERFORM DEL-EINTRA THRU EX-DEL-EINTRA.
      **********
      ************
           GO TO LP575.
       RWMOV.
           REWRITE RF-MOV FROM REKMOV INVALID PERFORM INVK-MOV
                                              GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MOV.
      ************
       LP575.
           READ ANACON INTO REKCON INVALID PERFORM INVK-CON
                                           GO TO ERRIO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           IF WDAVE = 'D'
              SUBTRACT WIMPOR FROM CON-SP-D
              SUBTRACT WIMPOR FROM CON-SE-D
           ELSE
              SUBTRACT WIMPOR FROM CON-SP-A
              SUBTRACT WIMPOR FROM CON-SE-A.
           GO TO LP590.
       LP590.
           REWRITE RF-CON FROM REKCON INVALID PERFORM INVK-CON
                                              GO TO ERRIO.
       LP592.
           READ MOVSEZ INTO REKMOV INVALID PERFORM INVK-MSZ
                                           GO TO ERRIO.
           IF SF-MSZ = '9D' OR '9A' OR '35' MOVE RF-MSZ TO REKMOV.
           IF MOV-CAUS = T20-CDSOC OR T20-CASOC OR
                         T20-CDCLC OR T20-CACLC OR
                         T20-CDFOC OR T20-CAFOC OR
                         T20-CDSOA OR T20-CASOA OR
                         T20-CDCLA OR T20-CACLA OR
                         T20-CDFOA OR T20-CAFOA GO TO LP720.
           MOVE ZERO TO SWPAR NPAR.
           MOVE KMS-AZI TO KPA-AZI.
           MOVE MOV-TREG TO TIPO.
           MOVE KMS-CON TO CODICE.
           MOVE CDX TO CLFO.
           MOVE MOV-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO ANNC.
           MOVE MOV-NDOC TO NDOC.
           MOVE ZERO TO NUME.
           MOVE CAN TO KPA-CAN.
           START PARTIT KEY NOT < KEYPA INVALID GO TO LP700.
       RDPAR.
           READ PARTIT NEXT INTO REKPAR AT END GO TO LP700.
           IF SF-PAR = '9D' OR '9A' OR '35' GO TO RDPAR.
           IF KPA-AZI > KMS-AZI GO TO LP700.
           MOVE KPA-CAN TO CAN.
           IF TIPO NOT = MOV-TREG OR
              CLFO NOT = CDX      OR
              ANNC NOT = AA4      OR
              NDOC NOT = MOV-NDOC GO TO LP700.
           IF NUME = 1 MOVE CAN TO WCAN GO TO RDPAR.
           IF PAR-TIP NOT = 2 GO TO LP600.
           IF SWPAR = 1 GO TO LP700.
           MOVE ZERO TO SWPAR.
           IF PAR-DTCON NOT = MOV-DAT   OR
              PAR-CAUS  NOT = MOV-CAUS  OR
              PAR-IMPOR NOT = MOV-IMPO  OR
              PAR-VIMPO NOT = MOV-IMVAL OR
              PAR-CAMGG NOT = MOV-CAMGG OR
              PAR-D-A   NOT = MOV-D-A   GO TO RDPAR.
           DELETE PARTIT INVALID PERFORM INVK-PAR
                                 GO TO ERRIO.
           MOVE 1 TO SWPAR NPAR.
           GO TO RDPAR.
       LP600.
           IF SWPAR = ZERO GO TO RDPAR.
           IF NOT (PAR-TIP = 3 OR 4) GO TO RDPAR.
           DELETE PARTIT INVALID PERFORM INVK-PAR
                                 GO TO ERRIO.
           ADD 1 TO NPAR.
           GO TO RDPAR.
       LP700.
           IF NPAR = ZERO GO TO LP720.
           MOVE CDAZ-131 TO KPA-AZI.
           MOVE WCAN     TO KPA-CAN.
           READ PARTIT INTO REKPAR INVALID PERFORM INVK-PAR
                                           GO TO ERRIO.
           IF SF-PAR = '9D' OR '9A' OR '35' MOVE RF-PAR TO REKPAR.
           IF MOV-D-A = 'D'
              SUBTRACT MOV-IMPO  FROM PAR-SALDO
              SUBTRACT MOV-IMVAL FROM PAR-VSALD
           ELSE
              ADD MOV-IMPO  TO PAR-SALDO
              ADD MOV-IMVAL TO PAR-VSALD.
           REWRITE RF-PAR FROM REKPAR INVALID PERFORM INVK-PAR
                                              GO TO ERRIO.
       LB9D.
           READ PARTIT NEXT INTO REKPAR AT END GO TO LP710.
           IF SF-PAR = '9D' OR '9A' OR '35' GO TO LB9D.
           IF KPA-AZI > CDAZ-131 GO TO LP710.
           MOVE KPA-CAN TO CAN.
           IF TIPO NOT = MOV-TREG OR
              CLFO NOT = CDX      OR
              ANNC NOT = AA4      OR
              NDOC NOT = MOV-NDOC GO TO LP710.
           GO TO LP720.
       LP710.
           MOVE CDAZ-131 TO KPA-AZI.
           MOVE WCAN     TO KPA-CAN.
           READ PARTIT INVALID PERFORM INVK-PAR
                               GO TO ERRIO.
           DELETE PARTIT INVALID PERFORM INVK-PAR
                                 GO TO ERRIO.
       LP720.
      **** rel 5.0
      **** rel 5.0-1
      *    PERFORM CANC-SCADENZA THRU EX-CANC-SCADENZA.
           IF TIPOP = 6 PERFORM CANC-PAGAMENTI THRU EX-CANC-PAGAMENTI
           ELSE         PERFORM CANC-SCADENZA THRU EX-CANC-SCADENZA.
      ************
      ************
      **** rel 6.1
           IF MOV-TREG = 3
              IF TIPOP = 1 OR 8
                 PERFORM ACCODA-CANC-FAF THRU EX-ACCODA-CANC-FAF.
      ************
           DELETE MOVSEZ INVALID PERFORM INVK-MSZ
                                 GO TO ERRIO.
      **** rel 7.1
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-MSZ.
      ************
      **** rel 6.3
      **** nt 71
      *    PERFORM DEL-EINTRA THRU EX-DEL-EINTRA.
           IF FUN-C110 = 'D'
              PERFORM DEL-EINTRA THRU EX-DEL-EINTRA.
      **********
      ************
           UNLOCK ANAAZI.
           GO TO A10.
       A90.
           GO TO FINE.
       ERRIO.
           COPY 'errsub'.
       FINE.
           CLOSE ANAAZI
      **** rel 5.1
      *          PARVAL
      ************
                 TABELL
                 ANACON
                 ANACLF
                 MOVIME
                 MOVSEZ
      **** rel 5.1
      *          FORNCD
      ************
                 PARTIT
      **** rel 5.0
                 ANASCA
      **** rel 5.1
      *          DETSCA
                 DETSCA.
      ************
      ************
      **** rel 5.1
      *          FATSOS.
      ************
      **** rel 6.3
           CLOSE EINTRA.
      ************
           EXIT PROGRAM.
           STOP RUN.
           COPY 'errmes'.
           COPY 'griazier'.
      **** rel 4.0-2
           COPY 'gripraer'.
      ************
           COPY 'griconer'.
           COPY 'griclfer'.
           COPY 'grimover'.
           COPY 'grimszer'.
           COPY 'grifcder'.
           COPY 'griparer'.
           COPY 'griftser'.
           COPY 'gripaver'.
           COPY 'gritaber'.
      **** rel 5.0
           COPY 'griscaer'.
           COPY 'gridscer'.
      ************
      **** rel 6.3
           COPY 'gritraer'.
      ************
           COPY 'grixxxer'.
      *------------------
       E00-ERRORE.
           MOVE 5 TO F-NMES.
           MOVE '         Manca totale di giornata       '  TO F-MES1.
           MOVE '         ------------------------       '  TO F-MES2.
           MOVE 'Verra''  generato  uno  sbilancio  tra il' TO F-MES3.
           MOVE 'totale  dei  cli/for  e  il   saldo  del'  TO F-MES4.
           MOVE 'relativo mastro.                        '  TO F-MES5.
           CALL 'vrmbox' USING PARMB.
       E99.
           EXIT.
      *------------------
       REC-LOCK.
      **** rel 1.2
           CALL 'rlock' USING PARLK.
      ************
           EXIT.
      *------------------
      **** rel 4.0-2
      * controlli se movimento annullabile
       VER-SE-ANNULL.
           MOVE 1 TO SWANL.
           IF CTR-131 = ZERO GO TO EX-VER-SE-ANNULL.
      *
           MOVE SPACE TO F-MES1 F-MES2 F-MES3 F-MES4 F-MES5.
           IF MOV-DAT < PRA-DTLIG
              MOVE 'Data registraz. < data stampa giornale' TO F-MES1.
           IF MOV-DAT < AZI-RVDT
              MOVE 'Data registraz. < data chiusura mensile' TO F-MES2.
           IF MOV-DAT < AZI-DTAPE
              MOVE 'Data registraz. < data apertura' TO F-MES3.
      **** rel 5.1
           PERFORM VER-MOV-IVA THRU EX-VER-MOV-IVA.
           IF AGIVA = 1
      ************
              IF MOV-DAT < DTAIVA
                 MOVE 'Data registraz. < data chiusura IVA' TO F-MES4.
      *
           IF F-MES1 = SPACE AND
              F-MES2 = SPACE AND
              F-MES3 = SPACE AND
              F-MES4 = SPACE AND
              F-MES5 = SPACE GO TO EX-VER-SE-ANNULL.
       VER-SE-ANN-80.
           MOVE 'Vuoi annullare ugualmente ?' TO F-MES5.
           MOVE 5   TO F-NMES.
           MOVE 'Q' TO MB-TIPO.
           MOVE '2' TO MB-DEFAULT.
           MOVE 'Annullamento registrazione' TO MB-TITOLO.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP = 'N' MOVE ZERO TO SWANL.
       EX-VER-SE-ANNULL.
           EXIT.
      *------------------
      ************
      **** rel 5.0
       CANC-SCADENZA.
           IF SCA-131 = ZERO GO TO EX-CANC-SCADENZA.
           IF MOV-TREG = 1 GO TO EX-CANC-SCADENZA.

      *> starta per chiave splittata azienda/num. registrazione
           MOVE MOV-AZI  TO KSC-AZI.
           MOVE NREG-131 TO SCA-NREG.
           START ANASCA KEY NOT < SKEYSC4 INVALID
                                   GO TO EX-CANC-SCADENZA.
       RDNX-SCA.
           READ ANASCA NEXT AT END GO TO EX-CANC-SCADENZA.
           IF KSC-AZI  > MOV-AZI   GO TO EX-CANC-SCADENZA.
           IF SCA-NREG > NREG-131  GO TO EX-CANC-SCADENZA.
           IF MOV-TREG = 2
              IF KSC-TIPO NOT = 1  GO TO RDNX-SCA
              END-IF
           ELSE
              IF KSC-TIPO NOT = 2  GO TO RDNX-SCA.

      *> controllo su num. documento, data, importo, cliente/fornitore
           IF SCA-NDOC    NOT = MOV-NDOC  GO TO RDNX-SCA.
           IF SCA-DTDOC   NOT = MOV-DTDOC GO TO RDNX-SCA.
      **** rel 6.2
      *    IF SCA-IMPOR   NOT = MOV-IMPO  GO TO RDNX-SCA.
      *    IF SCA-VALDOC  NOT = MOV-IMVAL GO TO RDNX-SCA.
           IF NOT (SCA-IMPOR = MOV-IMPO OR
              SCA-IMPOR = MOV-IMPO * -1)
                 GO TO RDNX-SCA.
           IF NOT (SCA-VALDOC = MOV-IMVAL OR
              SCA-VALDOC = MOV-IMVAL * -1)
                 GO TO RDNX-SCA.
      ************
           IF KS2-CODCF   NOT = CODICE    GO TO RDNX-SCA.

      **** rel 5.1
      *> cancella dettagli pagamenti
           PERFORM DEL-DETSCA THRU EX-DEL-DETSCA.
      ************
      **** rel 6.2
          MOVE ZERO TO PARDNS.
          MOVE KSC-AZI   TO DNS-AZI.
          MOVE KSC-TIPO  TO DNS-TIPO.
          MOVE KSC-DTSCA TO DNS-DTSCA.
          MOVE KSC-PRG   TO DNS-PRG.
          CALL 'rdelnsc' USING PARDNS.
      ************

           DELETE ANASCA INVALID PERFORM INVK-SCA
                                 GO TO ERRIO.

      **** rel 5.1
      *> cancella dettagli pagamenti
      *    PERFORM DEL-DETSCA THRU EX-DEL-DETSCA.
      ************
      **** rel 7.2
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-SCA.
      ************

           GO TO RDNX-SCA.
       EX-CANC-SCADENZA.
           EXIT.
      *------------------
       DEL-DETSCA.
           MOVE KSC-AZI   TO KDSC-AZI.
           MOVE KSC-TIPO  TO KDSC-TIPO.
           MOVE KSC-DTSCA TO KDSC-DTSCA.
           MOVE KSC-PRG   TO KDSC-PRG.
           MOVE ZERO      TO KDSC-PROG.
           START DETSCA KEY NOT < KEYDSC INVALID GO TO EX-DEL-DETSCA.
       RDDET.
           READ DETSCA NEXT AT END GO TO EX-DEL-DETSCA.
           IF SF-DSC = '9D' OR '9A' OR '35' GO TO RDDET.
           IF KDSC-AZI   NOT = KSC-AZI   GO TO EX-DEL-DETSCA.
           IF KDSC-TIPO  NOT = KSC-TIPO  GO TO EX-DEL-DETSCA.
           IF KDSC-DTSCA NOT = KSC-DTSCA GO TO EX-DEL-DETSCA.
           IF KDSC-PRG   NOT = KSC-PRG   GO TO EX-DEL-DETSCA.
           DELETE DETSCA INVALID PERFORM INVK-DSC
                                 GO TO ERRIO.
      **** rel 7.2
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-DSC.
      ************
           GO TO RDDET.
       EX-DEL-DETSCA.
           EXIT.
      *------------------
      ************
      **** rel 5.0-1
       CANC-PAGAMENTI.
           IF SCA-131 = ZERO GO TO EX-CANC-PAGAMENTI.
           IF MOV-TREG = 1 GO TO EX-CANC-PAGAMENTI.

      *> starta per chiave splittata azienda/num. registrazione
           MOVE MOV-AZI  TO KDSC-AZI.
           MOVE NREG-131 TO DSC-NREG.
           START DETSCA KEY NOT < SKEYDSC2 INVALID
                                   GO TO EX-CANC-PAGAMENTI.
       RDNX-DSC.
           READ DETSCA NEXT AT END GO TO EX-CANC-PAGAMENTI.
           IF SF-DSC = '9D' OR '9A' OR '35' GO TO RDNX-DSC.
           IF KDSC-AZI > MOV-AZI   GO TO EX-CANC-PAGAMENTI.
           IF DSC-NREG > NREG-131  GO TO EX-CANC-PAGAMENTI.
           IF MOV-TREG = 2
              IF KDSC-TIPO NOT = 1  GO TO RDNX-DSC
              END-IF
           ELSE
              IF KDSC-TIPO NOT = 2  GO TO RDNX-DSC.

      **** rel 5.1
      *> controllo su scadenza di un pagamento anticipato
           IF (MOV-NDOC  = ZERO) AND
              (MOV-DTDOC = ZERO) AND
              (DSC-TIPOP = 'A')  AND
              (DSC-TPAG  = 9)    GO TO SOTTO.
      ************
      *> controllo su num. documento, data, importo, cliente/fornitore
           IF DSC-NDOC    NOT = MOV-NDOC  GO TO RDNX-DSC.
           IF DSC-DTDOC   NOT = MOV-DTDOC GO TO RDNX-DSC.
      **** rel 5.1
       SOTTO.
      *    IF DSC-IMPOR   NOT = MOV-IMPO  GO TO RDNX-DSC.
      *    IF DSC-VALDOC  NOT = MOV-IMVAL GO TO RDNX-DSC.
      ************
           IF DSC-CODCF   NOT = CODICE    GO TO RDNX-DSC.

           DELETE DETSCA INVALID PERFORM INVK-DSC
                                 GO TO ERRIO.
      **** rel 7.2
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-DSC.
      ************

      *> varia/azzera importo pagato su scadenza
           MOVE KDSC-AZI   TO KSC-AZI.
           MOVE KDSC-TIPO  TO KSC-TIPO.
           MOVE KDSC-DTSCA TO KSC-DTSCA.
           MOVE KDSC-PRG   TO KSC-PRG.
           READ ANASCA INVALID PERFORM INVK-SCA GO TO ERRIO.
      **** rel 5.1
      *> se pagamento anticipato cancella scadenza
           IF (MOV-NDOC  = ZERO) AND
              (MOV-DTDOC = ZERO) AND
              (DSC-TIPOP = 'A')  AND
              (SCA-TPAG  = 9)    DELETE ANASCA
      **** rel 7.2
                                 MOVE 'C' TO PPAR-TOPE
                                 PERFORM CALL-VSRV133-SCA
      ************
                                 GO TO RDNX-DSC.
      ************
           COMPUTE SCA-PAGATO = SCA-PAGATO - DSC-IMPOR.
           COMPUTE SCA-VALPAG = SCA-VALPAG - DSC-VALDOC.
           IF SCA-PAGATO = ZERO MOVE SPACE TO SCA-STATO.
      **** rel 5.1
      *    REWRITE RF-SCA INVALID PERFORM INVK-SCA GO TO ERRIO.
           REWRITE RF-SCA INVALID
                   MOVE 'Errore riscrittura file ANASCA' TO F-MES1
                   MOVE 1 TO F-NMES
                   CALL 'vrmbox' USING PARMB.
      ************
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-SCA.
      ************

           GO TO RDNX-DSC.
       EX-CANC-PAGAMENTI.
           EXIT.
      *------------------
      ************
      **** rel 5.1
       VER-MOV-IVA.
           MOVE MOV-CAUS TO KTB-COD.
           MOVE 2        TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T02-TIPRG > 1 AND T02-ATTRN = 1 MOVE 1 TO SWIVA.
           MOVE ZERO TO AGIVA.
           IF MOV-DAT NOT > DTAIVA AND SWIVA = 1 MOVE 1 TO AGIVA.
       EX-VER-MOV-IVA.
           EXIT.
      *------------------
      ************
      **** rel 6.1
       ACCODA-CANC-FAF.
           IF FAF-131 = ZERO GO TO EX-ACCODA-CANC-FAF.
      *
           MOVE ZERO      TO PPAR-FUN.
           MOVE 'FAF'     TO PPAR-TARC.
           MOVE 'C'       TO PPAR-TOPE.
      *
           MOVE KMV-AZI   TO COM-AZI.
           MOVE KMV-DAT   TO AAGGG.
           MOVE 2         TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4       TO COM-ANNO.
           MOVE MOV-CATT  TO COM-CATT.
           MOVE MOV-NPRGI TO COM-NPRGI.
           MOVE COMKEY    TO PPAR-KEY.
      *
           MOVE KMV-DAT   TO COM-DAT.
           MOVE MOV-DTDOC TO COM-DTDOC.
           MOVE MOV-NDOC  TO COM-NDOC.
           MOVE MOV-CAUS  TO COM-CAUS.
           MOVE MOV-CON   TO COM-ACF.
           MOVE COMMOV    TO PPAR-OPZ.
      *
           MOVE MOV-CATT  TO PPAR-CATT.
           CALL 'vsrv130' USING PARPPAR.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore chiamata vsrv130. Errore ' PPAR-ERR
                      DELIMITED SIZE INTO MESS
              GO TO ERRIO.
       EX-ACCODA-CANC-FAF.
           EXIT.
      *------------------
      **** rel 6.1
      **** rel 6.3
       DEL-EINTRA.
      *
           MOVE LOW-VALUE TO KEYTA.
           MOVE MOV-AZI  TO KAZ-COD KTA-AZI.
           READ ANAAZI INTO REKAZI INVALID GO TO EX-DEL-EINTRA.
           MOVE AZI-PIVA TO KTA-IVA.
      *
           MOVE MOV-DAT TO AAGGG.
           MOVE 2       TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4     TO KTA-ANNO.
           MOVE MM4     TO KTA-PERI.
           MOVE SPACE   TO KTA-TRAN.
           MOVE ZERO    TO KTA-TIPO.
           MOVE SPACE   TO KTA-TIPN.
           MOVE MOV-NPRGI TO KTA-PROT.
           MOVE ZERO    TO KTA-PROG.
           START EINTRA KEY NOT < KEYTA INVALID GO TO EX-DEL-EINTRA.
       RDN-TRA.
           READ EINTRA NEXT AT END GO TO EX-DEL-EINTRA.
           IF SF-TRA = '9D' OR '9A' OR '35' GO TO RDN-TRA.
      *
           IF KTA-AZI > KAZ-COD GO TO EX-DEL-EINTRA.
           IF KTA-IVA > AZI-PIVA GO TO EX-DEL-EINTRA.
           IF KTA-ANNO > AA4 GO TO EX-DEL-EINTRA.
           IF KTA-PERI > MM4 GO TO EX-DEL-EINTRA.
      *
           IF KTA-PROT NOT = MOV-NPRGI GO TO RDN-TRA.
      *
           DELETE EINTRA INVALID PERFORM INVK-TRA
                                 GO TO ERRIO.
      *
           GO TO RDN-TRA.
      *
       EX-DEL-EINTRA.
           EXIT.
      *------------------
      ************
      **** rel 7.1
       CALL-VSRV133-MOV.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'MOV'   TO PPAR-TARC.
           MOVE KEYMV   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           IF ID-MOV = 'movime' MOVE '0' TO PPAR-OPZ(81:1).
           IF ID-MOV = 'movmol' MOVE '1' TO PPAR-OPZ(81:1).
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 MOV. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------
       CALL-VSRV133-MSZ.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'MSZ'   TO PPAR-TARC.
           MOVE KEYMS   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           IF ID-MSZ = 'movsez' MOVE '0' TO PPAR-OPZ(81:1).
           IF ID-MSZ = 'movsol' MOVE '1' TO PPAR-OPZ(81:1).
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 MSZ. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------
       CALL-VSRV133-SCA.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'SCA'   TO PPAR-TARC.
           MOVE KEYSC   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 SCA. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      ************
      **** rel 7.2
      *------------------
       CALL-VSRV133-DSC.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'DSC'   TO PPAR-TARC.
           MOVE KEYDSC  TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 DSC. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------
      ************
