       IDENTIFICATION DIVISION.
       PROGRAM-ID. VUTIP10.
      *
      * Stampa archivio totali IVA
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griivasl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griiva'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
           COPY 'grit35rk'.
           COPY 'griivark'.
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-IVA PIC X(15) VALUE 'totiva'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-IVA   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 W-LINEE  PIC X(80) VALUE ALL '-'.

           COPY 'vutip10.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-CATT      PIC X.
           05 IF-CATT-D    PIC X(24).
           05 IF-CIVA-1    PIC 999.
           05 IF-CIVA-1-D  PIC X(24).
           05 IF-CIVA-2    PIC 999.
           05 IF-CIVA-2-D  PIC X(24).
           05 IF-DATA      PIC 9(6).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcliva'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vutip10: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI
                 TOTIVA
                 TABELL.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griivaer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           IF IF-FL = ZERO
              MOVE 'anaazi' TO ID-AZI
              MOVE 'tabell' TO ID-TAB
              MOVE 'totiva' TO ID-IVA
           ELSE
              MOVE 'anazol' TO ID-AZI
              MOVE 'tabold' TO ID-TAB
              MOVE 'tivaol' TO ID-IVA.
      *
           OPEN INPUT ANAAZI
                      TOTIVA
                      TABELL.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
           PERFORM RPT-INI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DATA.
      *
           MOVE AZRGSOC TO IF-AZI-D.
      *
           MOVE ZERO  TO IF-CIVA-1
                         IF-CIVA-2.
           MOVE SPACE TO IF-CATT
                         IF-CATT-D
                         IF-CIVA-1-D
                         IF-CIVA-2-D.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-CATT.
           MOVE 'IF-CATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CATT.
           IF IF-CATT = SPACE
              MOVE '0' TO IF-CATT.
           IF IF-CATT = '0'
              MOVE 'ATTIVITA'' PRINCIPALE' TO IF-CATT-D
              GO TO E-CATT.
           MOVE SPACE TO IF-CATT-D.
           MOVE 35 TO   T35-TIP.
           MOVE KAZ-COD TO T35-CDAZ.
           MOVE IF-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.      
           MOVE T35-DATT TO IF-CATT-D.
       E-CATT.
      *
       V-CIVA-1.
           MOVE 'IF-CIVA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CIVA-1.
           MOVE SPACE TO IF-CIVA-1-D.
           MOVE 3         TO KTB-TIP. 
           MOVE IF-CIVA-1 TO KTB-COD. 
           READ TABELL INTO REKTAB INVALID
                GO TO E-CIVA-1.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           MOVE TAB-DESCR TO IF-CIVA-1-D.
       E-CIVA-1.
      *
       V-CIVA-2.
           MOVE 'IF-CIVA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CIVA-2.
           MOVE SPACE TO IF-CIVA-2-D.
           MOVE 3         TO KTB-TIP. 
           MOVE IF-CIVA-2 TO KTB-COD. 
           READ TABELL INTO REKTAB INVALID
                GO TO E-CIVA-2.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           MOVE TAB-DESCR TO IF-CIVA-2-D.
           IF IF-CIVA-2 < IF-CIVA-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-CIVA-2.
      *
       V-DATA.
           MOVE 'IF-DATA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DATA.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
           MOVE IF-DATA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO PDATA.
      *
           MOVE ZERO      TO XCRR.
           MOVE AZRGSOC   TO PAZI.
           MOVE IF-CATT   TO PCOATT.
           MOVE IF-CATT-D TO PDEATT.

      *-- inizializza parametri per stampa a caratteri --*
           MOVE 66      TO NRGF.
           MOVE 60      TO NRGL.
           MOVE C-TTS   TO RTTS.
           MOVE 2       TO NINT.
           MOVE C-TINT1 TO XTINT(1).
           MOVE C-TINT2 TO XTINT(2).
      *--------------------------------------------------*

      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
           MOVE SPACE TO RP-TIT1.
           STRING 'ARCHIVIO TOTALI IVA - ' PDATA
                  DELIMITED SIZE INTO RP-TIT1.
      *
           MOVE SPACE TO RP-TIT2.
           STRING 'ATTIVITA'' ' PCOATT '     ' PDEATT
                  DELIMITED SIZE INTO RP-TIT2.
      **** rel 7.2
           MOVE IF-FL TO RP-FL.
      ************
      *
           PERFORM RPT-RIG2-INTC.
      *
           MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*

           MOVE KAZ-COD   TO KIV-AZI.  
           MOVE IF-CATT   TO KIV-CATT.  
           MOVE IF-CIVA-1 TO KIV-COD.  
           START TOTIVA KEY NOT < KEYIV INVALID KEY GO TO S90.
       S50.
           READ TOTIVA NEXT INTO REKIVA AT END GO TO S90.
           IF SF-IVA = '9D' OR '9A' OR '35' GO TO S50.
           IF KIV-AZI  > KAZ-COD   GO TO S90.
           IF KIV-CATT > IF-CATT   GO TO S90.
           IF KIV-COD  > IF-CIVA-2 GO TO S90.
           MOVE KIV-COD TO KTB-COD.
           MOVE 3       TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.      
           MOVE '                CODICE IVA' TO PDESCR.
           MOVE KIV-COD   TO PCODIC.
           MOVE TAB-DESCR TO PDEIVA.
           IF XCRR > 0 MOVE 1 TO XCRR.
           MOVE 'RIG1' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE '        PERIODO'   TO PPERIA.
           MOVE '      PROGRESSIVO' TO PPROGA.
           MOVE 1 TO XCRR.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'VENDITE       :' TO PDESC1.
           MOVE '  IMPONIBILE'    TO PDESC2.
           MOVE IVA-VIMP          TO PPERIN.
           MOVE IVA-PVIMP         TO PPROGN.
           MOVE 2 TO XCRR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE '         IVA'    TO PDESC2.
           MOVE IVA-VIVA          TO PPERIN.
           MOVE IVA-PVIVA         TO PPROGN.
           MOVE 1 TO XCRR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'ACQUISTI      :' TO PDESC1.
           MOVE '  IMPONIBILE'    TO PDESC2.
           MOVE IVA-AIMP          TO PPERIN.
           MOVE IVA-PAIMP         TO PPROGN.
           MOVE 2 TO XCRR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE '         IVA'    TO PDESC2.
           MOVE IVA-AIVA          TO PPERIN.
           MOVE IVA-PAIVA         TO PPROGN.
           MOVE 1 TO XCRR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'INDEDUCIBILI'    TO PDESC2.
           MOVE IVA-AIVN          TO PPERIN.
           MOVE IVA-PAIVN         TO PPROGN.
           MOVE 1 TO XCRR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'ACQUISTI CEE  :' TO PDESC1.
           MOVE '  IMPONIBILE'    TO PDESC2.
           MOVE IVA-IMCE          TO PPERIN.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE '         IVA'    TO PDESC2.
           MOVE IVA-IVCE          TO PPERIN.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'ACQUISTI PER '   TO PDESC1.
           MOVE 'RIVENDITA'       TO PDESC2.
           MOVE IVA-AVEN          TO PPERIN.
           MOVE IVA-PAVE          TO PPROGN.
           MOVE 2 TO XCRR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE 'CORRISPETTIVI :' TO PDESC1.
           MOVE IVA-CORR          TO PPERIN.
           MOVE IVA-PCOR          TO PPROGN.
           MOVE 2 TO XCRR.
           MOVE 'RIG2' TO RP-BLK.
           PERFORM RPT-WR.
      *
           MOVE W-LINEE           TO PDIVID.
           MOVE 1 TO XCRR.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3' TO RP-BLK.
           PERFORM RPT-WR.
      *
           COPY 'grirpt-r'.
      *
           GO TO S50.
       S90.
           PERFORM RPT-CL.
      *
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       RPT-RIG2-INTC.
           MOVE 'RIG2' TO RP-BLK.
      *
           PERFORM RPT-ADD-I.
           PERFORM RPT-ADD-I.
           MOVE 'Periodo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Progressivo' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
