       IDENTIFICATION DIVISION.
       PROGRAM-ID. VREPORT. 
      **** rel 6.0
      * nuovo
      ************
      *
      * Generazione report a carattere e XML
      *
      * RP-ERR:    0 - ok
      *            1 - problemi lettura file RPT
      *            2 - problemi mappatura pagina / blocco / campo
      *            3 - errore nome blocco
      *            4 - errore sequenza campi
      *            5 - errore file XML
      *            6 - errore RSETPRS
      *            7 - errore VRPMAP VRPTAB
      *            8 - errore VJASPER
      *
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           SELECT FILEIN ASSIGN TO DISK
                  ORGANIZATION LINE SEQUENTIAL 
                  STATUS SF-FIL.

           SELECT XMLDAT ASSIGN TO DISK
                  ORGANIZATION SEQUENTIAL 
                  STATUS SF-XML.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.

       FD  FILEIN LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-FIL
           RECORD 300 DATA RECORD RF-FIL.
       01  RF-FIL.
           02 FILLER     PIC X(300).

       FD  XMLDAT LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-XML
           DATA RECORD RF-XML.
       01  RF-XML PIC X(1).

       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
      * release di questo programma per XML
       01  RELPGM PIC X(5) VALUE '6.0'.
      *************************************
           COPY 'griazirk'.
           COPY 'parzf'.
           COPY 'parg'.
           COPY 'parcdt'.
           COPY 'parjrp'.
           COPY 'parrp-w'.
           COPY 'parprs'.
           COPY 'parpph'.
      **** rel 6.1
           COPY 'parpsb'.
           COPY 'parpmap'.
      ************
      **** rel 6.3
           COPY 'parpscs'.
           COPY 'parpcns'.
           COPY 'parpcfgr'.
           COPY 'parpcfgc'.
      ************

       01  ID-AZI        PIC X(15) VALUE 'anaazi'.
       01  ID-FIL        PIC X(60) VALUE 'filein'.
       01  ID-XML        PIC X(60) VALUE 'xmldat'.

       01  COMODI.
           05 SF-AZI     PIC XX.
           05 SF-FIL     PIC XX.
           05 SF-XML     PIC XX.
           05 SWINI      PIC 9     VALUE ZERO.
           05 SWOPE      PIC 9     VALUE ZERO.
      **** rel 6.3
      *    05 DIRRPT     PIC X(160).
           05 DIRRPT     PIC X(500).
      ************
           05 DIROUT     PIC X(50).
           05 TTAB       PIC X    VALUE X'09'.
           05 CR         PIC X    VALUE X'0d'.
           05 LF         PIC X    VALUE X'0a'.
           05 FLGCR      PIC 9    VALUE ZERO.
           05 FNPGC      PIC 9    VALUE ZERO.
           05 FNPGG      PIC 9    VALUE ZERO.
           05 EURO       PIC X    VALUE X'80'. 
           05 SDATA      PIC X(10).
           05 SORA       PIC X(5).
           05 ORA.
              10 HH      PIC 99.
              10 MM      PIC 99.
              10 SS      PIC 99.
              10 CC      PIC 99.
           05 TTIME      PIC 9(7).
           05 RNOME      PIC X(10).
           05 CREV       PIC X(10).
           05 DREV       PIC X(10).
           05 FLGP       PIC 9     VALUE ZERO.
           05 FPG        PIC 9     VALUE ZERO.
           05 NPG        PIC X(20) VALUE ZERO.
      **** rel 6.0a
           05 HTMLSPACE  PIC X(20) VALUE '&#x20;'.
           05 IMGBCK     PIC X(20) VALUE SPACE.
           05 FLGL       PIC 9     VALUE ZERO.
           05 FLGA       PIC 9     VALUE ZERO.
           05 FLGU       PIC 9     VALUE ZERO.
           05 FLGD       PIC 9     VALUE ZERO.
           05 K          PIC 99    VALUE ZERO.
           05 FPIEDE     PIC 9     VALUE ZERO.
           05 COMPAG     PIC 9(5)  VALUE ZERO.
           05 F-CDATA    PIC 9     VALUE ZERO.
      *************

      **** rel 6.0a
       01  VAR-PIEDE.
           05 PBK-DES-AZI.
              10 PBK-ADES  PIC X(60).
              10 PBK-AIND  PIC X(60).
              10 PBK-ACAP  PIC X(60).
              10 PBK-ACIT  PIC X(60).
              10 PBK-APRV  PIC X(60).
              10 PBK-APIV  PIC X(60).
              10 PBK-ACFI  PIC X(60).
           05 PBK-DPAG  PIC X(60).
           05 PBK-NPAGX PIC X(5).
           05 PBK-NPAG REDEFINES PBK-NPAGX PIC 9(5).
      *************

      * FSLIM: 0 - XML esteso (CR e TAB per ogni TAG)
      *        1 - XML compatto
       01  FSLIM      PIC 9    VALUE ZERO.

      * FLGTAG: 0 - non crea tag vuoti
      *         1 - crea tag vuoti
       01  FLGTAG     PIC 9    VALUE ZERO.
      *01  FLGTAG     PIC 9    VALUE 1.

      * manipolazione riga input
       01  R-IND      PIC 999.   *> puntatore riga
       01  R-I        PIC 999.   *> puntatore inizio campo
       01  R-F        PIC 999.   *> puntatore fine  campo
       01  R-L        PIC 999.   *> lunghezza campo
       01  R-NCC      PIC 999.   *> contatore numero campo carattere
       01  R-NCX      PIC 999.   *> contatore numero campo XML

      * manipolazione riga output XML
       01  X-IND      PIC 999.   *> puntatore riga
       01  X-TAB      PIC 99.    *> numero tabulazioni inizio riga
       01  X-LIV      PIC 99.    *> livello indentazione
       01  X-I        PIC 999.   *> puntatore inizio campo
       01  X-L        PIC 999.   *> lunghezza campo
       01  X-TAG      PIC X(15). *> tag campo
       01  X-FLD      PIC X(200). *> stringa campo
       01  X-FLD2     PIC X(200). *> campo di comodo
       01  X-K        PIC 999.   *> puntatore di comodo
       01  X-RIG      PIC X(1000). *> riga di comodo

      * manipolazione riga RSTMPN
       01  C-IND      PIC 999.   *> puntatore string riga
       01  C-I        PIC 999.   *> puntatore inizio campo
       01  C-L        PIC 999.   *> lunghezza campo

      * Vettore blocchi
       01  S-ITP      PIC 99.          *> salva indice inizio tipo pag
       01  S-IND      PIC 99.          *> salva indice blocco
       01  T-ITP      PIC 99.          *> indice inizio tipo pagina
       01  T-IND      PIC 9.           *> puntatore tipo pagina
       01  B-ILIV     PIC 99.          *> contatore livello blocco
       01  B-IND PIC 99.               *> puntatore blocco
       01  V-BLK OCCURS RP-BMAX.
           05 B-PIND     PIC 99.       *> indice inizio tipo pagina
           05 B-NOME     PIC X(15).    *> nome blocco
           05 B-TPAG     PIC 9.        *> tipo pagina
           05 B-LIV      PIC 99.       *> livello blocco
           05 B-TAG      PIC X(15).    *> tag blocco
           05 B-DA       PIC 999.      *> primo puntatore vettore campi
           05 B-NFLD     PIC 999.      *> numero campi
           05 B-PRG      PIC 9(7).     *> progressivo record

      * Vettore campi
       01  F-IND PIC 999.              *> puntatore campo
       01  F-STR.
           05 V-FLD OCCURS RP-FMAX.
              10 F-NOME     PIC X(15). *> nome campo
              10 F-OFF      PIC 999.   *> CRT * offset da campo prec
              10 F-LUN      PIC 999.   *> CRT * lunghezza campo
              10 F-TIP      PIC 99.    *> tipo campo: 0-stringa
      *                                *>             1-cod alfa
      *                                *>             2-cod num
      *                                *>             3-data
      *                                *>             4-numero generico
      *                                *>             5-numero
      *                                *>             6-testo label
      *                                *>            99-skip campo

      * Parametri CBL_CHECK_EXIST_FILE
       01  FILE-NAME          PIC X(60).
       01  FILE-OUT           PIC X(60).
       01  FILE-DETAILS.
           05 FILE-SIZE       PIC X(8) COMP-X.
           05 FILE-DATE.
              10 F-DAY        PIC X  COMP-X.
              10 F-MONTH      PIC X  COMP-X.
              10 F-YEAR       PIC X(2) COMP-X.
           05 FILE-TIME.
              10 F-HOURS      PIC X COMP-X.
              10 F-MINUTES    PIC X COMP-X.
              10 F-SECONDS    PIC X COMP-X.
              10 F-HINDREDTHS PIC X COMP-X.
       01  STATUS-CODE         PIC X(2) COMP-X.
      * Parametri EXIST-DIR
       01  RESULT.
           05 F-ERROR      PIC X     COMP-X.
           05 F-HANDLE     PIC X(2)  COMP-X.
           05 F-ATTROUT    PIC X     COMP-X.
           05 F-TIME       PIC X(2)  COMP-X.
           05 F-DATE       PIC X(2)  COMP-X.
           05 F-SIZE       PIC X(4)  COMP-X.
           05 F-FILEOUT    PIC X(60).
       01  FUNCTION-CODE   PIC X     COMP-X VALUE 69.
       01  PARAMETER.
           05 F-ACTION     PIC X     COMP-X.
           05 F-ATTRIN     PIC X     COMP-X.
           05 F-FILEIN     PIC X(60).

       01  RX-91         PIC 99 COMP-X.
       01  FX-91         PIC 99 COMP-X VALUE 47.

      * Parametri routine 'vrptip'
       01  PARPT.
           05 PT-FUN       PIC 9.
           05 PT-PR        PIC X(8).
           05 PT-TIP       PIC X.
           05 PT-ST        PIC 9.
      **** rel 6.1
      * Parametri routine 'vrpmap'
      *01  PARPM.
      *    05 PM-FUN       PIC 9.
      *    05 PM-PR        PIC X(8).
      *    05 PM-DEV       PIC X(45).
      *    05 PM-ST        PIC 9.
      ************

       LINKAGE SECTION.
           COPY 'parrp-l'.
           COPY 'parstn'.
       PROCEDURE DIVISION USING PARRP PARSTN.
       INIZIO.
           MOVE ZERO TO RP-ERR.
           MOVE SPACE TO RP-MSG.
      *
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
      *
           IF RP-FUN = 0
              IF RP-NOME = SPACE
                 MOVE 1 TO RP-ERR
                 GO TO ERRIO
              END-IF
              IF RP-BLK = SPACE
                 MOVE 3 TO RP-ERR
                 GO TO ERRIO
              ELSE
                 PERFORM WR-RIGA THRU EX-WR-RIGA
                 MOVE SPACE TO RP-BLK.

      **** rel 6.3
      *    IF RP-FUN = 9  PERFORM CL-FILE THRU EX-CL-FILE
      *                   IF RP-FEXE = ZERO
      *                      PERFORM LANCIO THRU EX-LANCIO
      *                   END-IF
           IF RP-FUN = 9  IF SWOPE NOT = ZERO OR PJR-FLGATT = ZERO
                             PERFORM CL-FILE THRU EX-CL-FILE
                             IF RP-FEXE = ZERO
                                PERFORM LANCIO THRU EX-LANCIO
                             END-IF
                          END-IF
      ************
                          GO TO CHIUDI.
      **** rel 6.0a
           IF RP-FUN = 98 PERFORM INI-PIEDE THRU EX-INI-PIEDE.
      *************
           IF RP-FUN = 99 PERFORM INI-RIGA.
      *
           GO TO FINE.
       ERRIO.
           MOVE SPACE TO RP-MSG.
      *
           IF RP-ERR = 1 MOVE 'Problemi lettura file RPT' TO RP-MSG.
           IF RP-ERR = 2
              MOVE 'Problemi mappatura pagina/blocco/campo' TO RP-MSG.
           IF RP-ERR = 3 MOVE 'Errore nome blocco' TO RP-MSG.
           IF RP-ERR = 4 MOVE 'Errore sequenza campi' TO RP-MSG.
           IF RP-ERR = 5 MOVE 'Errore file XML' TO RP-MSG.
           IF RP-ERR = 6
              MOVE 'Errore set/reset stampante RSETPRS' TO RP-MSG.
           IF RP-ERR = 7 MOVE 'Errore DEVICE / PRMAP / PRTAB' TO RP-MSG.
           IF RP-ERR = 8 MOVE 'Errore VJASPER' TO RP-MSG.
      *
           PERFORM CL-FILE THRU EX-CL-FILE.
       CHIUDI.
           MOVE ZERO TO SWINI.
       FINE.
           EXIT PROGRAM.
      *----------------------------*
       OP-FILE.
      *
           MOVE DIRRPT TO PPH-PATH.
           MOVE SPACE TO PPH-FILE.
           STRING RP-NOME DELIMITED SPACE
                  '.rpt' DELIMITED SIZE
                  INTO PPH-FILE.
           CALL 'vrpath' USING PARPPH.
           IF PPH-FILE = SPACE
              MOVE 1 TO RP-ERR
              GO TO ERRIO.

           MOVE PPH-FILE TO ID-FIL.
      *
           OPEN INPUT FILEIN.
           IF SF-FIL NOT = ZERO
              MOVE 1 TO RP-ERR
              GO TO ERRIO.

           MOVE SPACE TO RNOME CREV DREV.

      *    MOVE 1 TO FNPGC FNPGG.
           MOVE ZERO TO FNPGC FNPGG.
      **** rel 6.0a
           MOVE SPACE TO IMGBCK.
           MOVE ZERO TO FLGL.
           MOVE ZERO TO FLGA.
           MOVE ZERO TO FLGU.
           MOVE ZERO TO FLGD.
      *************

           MOVE ZERO TO FPG.
           MOVE SPACE TO NPG.
           MOVE ZERO TO B-IND F-IND.
           MOVE ZERO TO T-IND B-ILIV.

       LOOPFIL.
           READ FILEIN AT END GO TO ENDFIL.
           IF RF-FIL(1:1) = '#' GO TO LOOPFIL.
           IF RF-FIL = SPACE GO TO LOOPFIL.

           IF RF-FIL(1:5) = 'RNOM ' MOVE RF-FIL(6:) TO RNOME.
           IF RF-FIL(1:5) = 'CREV ' MOVE RF-FIL(6:) TO CREV.
           IF RF-FIL(1:5) = 'DREV ' MOVE RF-FIL(6:) TO DREV.
      **** rel 6.0a
           IF RF-FIL(1:7) = 'IMGBCK ' MOVE RF-FIL(8:) TO IMGBCK.
           IF RF-FIL(1:7) = 'NOLOGO ' MOVE 1 TO FLGL.
           IF RF-FIL(1:7) = 'NOAZI  ' MOVE 1 TO FLGA.
           IF RF-FIL(1:7) = 'NOUSER ' MOVE 1 TO FLGU.
           IF RF-FIL(1:7) = 'NODATA ' MOVE 1 TO FLGD.
      *************

           IF RF-FIL(1:3) = 'FPG'
              IF RF-FIL(5:2) = 'PR'
                 MOVE 1 TO FPG
              END-IF
              MOVE RF-FIL(23:20) TO NPG.

           IF RF-FIL(1:3) = 'TPG'
              IF T-IND = RP-TMAX
                 MOVE 2 TO RP-ERR
                 CLOSE FILEIN
                 GO TO ERRIO
              END-IF
              ADD 1 TO T-IND
              MOVE ZERO TO B-ILIV

      * inserimento blocco automatico tipo pagina
              PERFORM ADD-B-IND
              MOVE 'B_TPAG' TO B-NOME(B-IND)
              STRING 'RPT_TIP' T-IND DELIMITED SIZE
                     INTO B-TAG(B-IND)
              MOVE B-IND TO T-ITP B-PIND(B-IND)
      * inserimento blocco automatico paginone
              PERFORM ADD-B-IND
              MOVE 'B_PAGBLK' TO B-NOME(B-IND)
              MOVE 'RPT_PBK' TO B-TAG(B-IND)
              MOVE T-ITP TO B-PIND(B-IND)
      ****
              GO TO LOOPFIL.

           IF RF-FIL(1:3) = 'BLK'
              PERFORM ADD-B-IND
              MOVE RF-FIL(5:15) TO B-NOME(B-IND)
              ADD 1 TO B-ILIV
              MOVE B-ILIV TO B-LIV(B-IND)
              MOVE T-ITP TO B-PIND(B-IND)
              IF B-ILIV > 9
                 STRING 'TBK' DELIMITED SIZE
                        B-LIV(B-IND) DELIMITED SPACE
                        INTO B-TAG(B-IND)
              ELSE
                 STRING 'TBK' DELIMITED SIZE
                        B-LIV(B-IND)(2:1) DELIMITED SPACE
                        INTO B-TAG(B-IND)
              END-IF
              MOVE ZERO TO B-DA(B-IND) B-NFLD(B-IND)
              GO TO LOOPFIL.

           IF RF-FIL(1:3) = 'FLD'
              ADD 1 TO F-IND
              IF F-IND > RP-FMAX OR
                 B-IND = ZERO
                    MOVE 2 TO RP-ERR
                    CLOSE FILEIN
                    GO TO ERRIO
              END-IF
              IF B-DA(B-IND) = ZERO
                 MOVE F-IND TO B-DA(B-IND)
              END-IF
              ADD 1 TO B-NFLD(B-IND)
              MOVE RF-FIL(5:15) TO F-NOME(F-IND)
              MOVE 1 TO F-OFF(F-IND)
              IF F-IND = B-DA(B-IND)
                 MOVE ZERO TO F-OFF(F-IND)
              END-IF
              IF RF-FIL(21:3) NUMERIC
                 MOVE RF-FIL(21:3) TO F-OFF(F-IND)
              END-IF
              MOVE ZERO TO F-LUN(F-IND)
              IF RF-FIL(25:3) NUMERIC
                 MOVE RF-FIL(25:3) TO F-LUN(F-IND)
              ELSE
                 IF RF-FIL(25:3) = 'NUL'
                    MOVE 999 TO F-LUN(F-IND)
                 END-IF 
              END-IF 
              MOVE ZERO TO F-TIP(F-IND)
              IF RF-FIL(29:3) = 'CA' MOVE 1 TO F-TIP(F-IND) END-IF
              IF RF-FIL(29:3) = 'CN' MOVE 2 TO F-TIP(F-IND) END-IF
              IF RF-FIL(29:3) = 'DT' MOVE 3 TO F-TIP(F-IND) END-IF
              IF RF-FIL(29:3) = 'NG' MOVE 4 TO F-TIP(F-IND) END-IF
              IF RF-FIL(29:3) = 'NU' MOVE 5 TO F-TIP(F-IND) END-IF
              IF RF-FIL(29:3) = 'LB' MOVE 6 TO F-TIP(F-IND) END-IF
              IF RF-FIL(29:3) = 'NUL' MOVE 99 TO F-TIP(F-IND) END-IF
              GO TO LOOPFIL.

           GO TO LOOPFIL.
       ENDFIL.
           CLOSE FILEIN.
      *
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA4 TO SDATA.

           ACCEPT ORA FROM TIME.
           STRING HH ':' MM
                  DELIMITED SIZE INTO SORA.
      *
           MOVE SPACE TO ID-XML.
           COMPUTE TTIME = ((HH * 3600) + (MM * 60) + SS) * 100 + CC.
           STRING DIROUT DELIMITED SPACE
                  '\' DELIMITED SIZE
                  RP-NOME DELIMITED SPACE
                  '-' TTIME '.xml' DELIMITED SIZE
                  INTO ID-XML.

           IF RP-TRPT NOT = 2 PERFORM OPEN-XML.
      *
           MOVE ZERO TO XCRR NPAG FEXE. *> CRT
      **** rel 6.0a
           IF PBK-NPAGX NUMERIC           *> CRT
              IF PBK-NPAG NOT = ZERO      *> CRT
                 MOVE PBK-NPAG TO COMPAG  *> CRT
                 SUBTRACT 1 FROM COMPAG   *> CRT
                 ADD COMPAG TO NPAG.      *> CRT
      *************
           MOVE ZERO TO RP-JMP.
           MOVE ZERO TO S-ITP.
      **** rel 6.0a
           MOVE ZERO TO RP-NRIGG.
      *************
      *
      * verifica cambio stampante per stampa a carattere
           IF RP-TRPT NOT = 1 AND
              (RP-PR NOT = EX-PR OR
               RP-FMT NOT = EX-PRFMT)
                  MOVE ZERO  TO PARPRS        *> CRT
                  MOVE RP-PR  TO PRS-PR       *> CRT
                  MOVE RP-FMT TO PRS-PRFMT    *> CRT
                  CALL 'rsetprs' USING PARPRS *> CRT
                  IF PRS-ST = 9 GO TO ERRIO.  *> CRT
      *
           MOVE 1 TO SWOPE.
       EX-OP-FILE.
           EXIT.
      *----------------------------*
       ADD-B-IND.
           ADD 1 TO B-IND.
           IF B-IND > RP-BMAX OR
              T-IND = ZERO
                 MOVE 2 TO RP-ERR
                 CLOSE FILEIN
                 GO TO ERRIO.
           MOVE T-IND TO B-TPAG(B-IND).
      *----------------------------*
       OPEN-XML.
           OPEN OUTPUT XMLDAT.
           IF SF-XML NOT = ZERO MOVE 5 TO RP-ERR
                                GO TO ERRIO.
           CALL X'91' USING RX-91 FX-91 XMLDAT.

           MOVE '<?xml version="1.0" encoding="ISO-8859-1"?>' TO X-RIG.
           PERFORM WR-XML.
      *
           PERFORM WR-XML.
      *
           STRING '<REPORT NOMERPT="' DELIMITED SIZE
                  RP-NOME DELIMITED SPACE
                  '"' DELIMITED SIZE
                  ' P_REL="' DELIMITED SIZE
                  RELPGM DELIMITED SPACE
                  '">' DELIMITED SIZE
                  INTO X-RIG.
           PERFORM WR-XML.
      *
           MOVE ZERO TO X-LIV.
      *----------------------------*
       WR-RIGA.
           IF SWOPE = ZERO PERFORM OP-FILE THRU EX-OP-FILE.
      *
           MOVE SPACE TO RIGA.        *> CRT
           MOVE 1 TO C-IND.           *> CRT
      *
      * cerca blocco
           MOVE 1 TO B-IND.
           PERFORM UNTIL B-NOME(B-IND) = RP-BLK
                   ADD 1 TO B-IND
                   IF B-IND > RP-BMAX
                      MOVE 3 TO RP-ERR
                      GO TO ERRIO.
      *
      * verifica cambio tipo pagina o forzatura salto pagina
           IF S-ITP = ZERO GO TO NO-JMP.
           IF B-PIND(B-IND) = S-ITP AND
              RP-JMP = ZERO
                 GO TO NO-JMP.

           IF RP-JMP = 2 MOVE 1 TO FNPGC FNPGG.

           IF RP-TRPT NOT = 2 AND RP-FLGR NOT = 2
      **** rel 6.0a
              MOVE ZERO TO RP-NRIGG
      *************
              MOVE B-IND TO S-IND
              MOVE B-PIND(S-ITP) TO B-IND
              IF B-PIND(S-IND) = S-ITP
                 ADD 1 TO B-IND
              END-IF
              COMPUTE T-ITP = B-PIND(B-IND) - 1
              PERFORM VER-LIV THRU EX-VER-LIV
              SUBTRACT 1 FROM X-LIV
              MOVE S-IND TO B-IND.

           IF FNPGC = 1 MOVE ZERO TO NPAG.   *> CRT
           MOVE ZERO TO FNPGC.               *> CRT
           MOVE ZERO TO XCRR.                *> CRT
      *
       NO-JMP.
           MOVE ZERO TO RP-JMP.
           MOVE B-PIND(B-IND) TO S-ITP.
           COMPUTE T-ITP = B-PIND(B-IND) - 1.
      *
           MOVE B-DA(B-IND) TO F-IND.
      *
           IF RP-TRPT NOT = 2 AND RP-FLGR NOT = 2
      **** rel 6.0a
              ADD 1 TO RP-NRIGG
      *************
              PERFORM VER-LIV THRU EX-VER-LIV
              MOVE ZERO TO FLGCR
              IF FSLIM = 1
                 MOVE 1 TO FLGCR
              END-IF
              PERFORM OPEN-TAG THRU EX-OPEN-TAG.
      *
           MOVE 1 TO R-IND.
           MOVE ZERO TO R-NCC R-NCX R-I R-F.
      * estrae campo da RP-RIGA
        LPR.
           IF NOT (RP-RIGA(R-IND:1) = HIGH-VALUE OR LOW-VALUE)
              IF R-I = ZERO
                 MOVE R-IND TO R-I
              END-IF
              MOVE R-IND TO R-F
           ELSE
              PERFORM CAMPO THRU EX-CAMPO.

           IF R-IND NOT = RP-RMAX AND
              RP-RIGA(R-IND:1) NOT = LOW-VALUE
                 ADD 1 TO R-IND
                 GO TO LPR.
      *
           IF RP-TRPT NOT = 1 AND RP-FLGR NOT = 1  *> CRT
              PERFORM CALL-RSTMP                   *> CRT
              IF XCRR = ZERO MOVE 1 TO XCRR.       *> CRT
      *
           MOVE ZERO TO RP-FLGR.
           MOVE ZERO TO RP-FLGP.
       EX-WR-RIGA.
           EXIT.
      *----------------------------*
       CL-FILE.
           IF SWOPE = ZERO GO TO EX-CL-FILE.
      *
           IF RP-TRPT NOT = 2 PERFORM CLOSE-XML.
      *
           IF RP-TRPT NOT = 1               *> CRT
              MOVE RP-FEXE TO FEXE          *> CRT
              MOVE 9 TO XCRR                *> CRT
              PERFORM CALL-RSTMP.           *> CRT
      *
      * ripristino cambio stampante per stampa a carattere
           IF RP-TRPT NOT = 1 AND
              (RP-PR NOT = EX-PR OR
               RP-FMT NOT = EX-PRFMT)
                  MOVE 1     TO PRS-FUN       *> CRT
                  CALL 'rsetprs' USING PARPRS *> CRT
                  IF PRS-ST = 9 GO TO ERRIO.  *> CRT
      *
           MOVE ZERO TO SWOPE.
       EX-CL-FILE.
           EXIT.
      *----------------------------*
       CLOSE-XML.
           MOVE B-PIND(S-ITP) TO B-IND.
           COMPUTE T-ITP = B-PIND(B-IND) - 1.
           PERFORM VER-LIV THRU EX-VER-LIV.
      *
           MOVE '</REPORT>' TO X-RIG.
           PERFORM WR-XML.
      *
           CLOSE XMLDAT.
      *----------------------------*
       CAMPO.
           IF R-I = ZERO OR
              R-F = ZERO OR
              F-IND > B-DA(B-IND) + B-NFLD(B-IND) - 1
                 MOVE 4 TO RP-ERR
                 GO TO ERRIO.

           COMPUTE R-L = R-F - R-I + 1.
      *
           IF RP-TRPT NOT = 2 AND RP-FLGR NOT = 2
              PERFORM CAMPO-XML THRU EX-CAMPO-XML.
      *
           IF RP-TRPT NOT = 1 AND RP-FLGR NOT = 1    *> CRT
              PERFORM CAMPO-CRT THRU EX-CAMPO-CRT.   *> CRT
      *
           MOVE SPACE TO RP-RIGA(R-I:R-L).
      *
           MOVE ZERO TO R-I R-F.
           ADD 1 TO F-IND.
       EX-CAMPO.
           EXIT.
      *----------------------------*
      * generazione campo per stampa a carattere
       CAMPO-CRT.                                    *> CRT
           IF F-LUN(F-IND) = 999 GO TO EX-CAMPO-CRT.
           ADD 1 TO R-NCC.
           MOVE R-I TO C-I.
           MOVE R-L TO C-L.
           IF F-LUN(F-IND) NOT = ZERO AND
              F-LUN(F-IND) < C-L
                 MOVE F-LUN(F-IND) TO C-L
      * campi numerici tronca a sx
                 IF F-TIP(F-IND) = 2 OR 4 OR 5
                    COMPUTE C-I = R-I + (R-L - C-L).

           ADD F-OFF(F-IND) TO C-IND.

           STRING RP-RIGA(C-I:C-L) DELIMITED SIZE
                  INTO RIGA POINTER C-IND.
       EX-CAMPO-CRT.
           EXIT.
      *----------------------------*
      * generazione campo XML
       CAMPO-XML.
           IF F-TIP(F-IND) = 99 GO TO EX-CAMPO-XML.
           ADD 1 TO R-NCX.
           MOVE RP-RIGA(R-I:R-L) TO X-FLD.
           MOVE R-L TO X-L.

           IF F-TIP(F-IND) = 3
              PERFORM F-DATA THRU EX-F-DATA.
           IF F-TIP(F-IND) = 2 OR 4 OR 5
              PERFORM F-NUM THRU EX-F-NUM.
           PERFORM F-STRINGA THRU EX-F-STRINGA.

           MOVE ZERO TO FLGCR.
           IF FSLIM = 1 MOVE 1 TO FLGCR.

           IF RP-FLGP NOT = ZERO
              MOVE SPACE TO X-TAG
              MOVE 1 TO X-K
              STRING 'P' DELIMITED SIZE INTO X-TAG POINTER X-K

              IF B-LIV(X-LIV + T-ITP) > 9
                 STRING B-LIV(X-LIV + T-ITP) DELIMITED SPACE
                               INTO X-TAG POINTER X-K
              ELSE
                 STRING B-LIV(X-LIV + T-ITP)(2:1) DELIMITED SPACE
                               INTO X-TAG POINTER X-K
      **** rel 6.2
              END-IF
      ************

              MOVE 1 TO X-I
              PERFORM UNTIL R-NCX(X-I:1) NOT = '0'
                      ADD 1 TO X-I
              END-PERFORM
              STRING '_' R-NCX(X-I:3 - X-I + 1) DELIMITED SIZE
                     INTO X-TAG POINTER X-K
           ELSE
              MOVE F-NOME(F-IND) TO X-TAG.
           PERFORM AGGIUNGI-CAMPO.
      *
       EX-CAMPO-XML.
           EXIT.
      *----------------------------*
       F-NUM.
      * formatta campo numero
      * toglie spazi a sx
           IF X-FLD = SPACE GO TO EX-F-NUM.

      **** rel 6.3
           IF RP-FLGB NOT = 1 GO TO NO-NUM.
           IF F-TIP(F-IND) NOT = 5 GO TO NO-NUM.

      * formatta numero per formato bozza
           MOVE ZERO TO PARPSCS.
           MOVE X-FLD TO PSCS-CAMPO.
           MOVE 2 TO PSCS-TFLD.
           MOVE 'E' TO PSCS-FNUM.
           CALL 'scanstr' USING PARPSCS.
           IF PSCS-TFLD NOT = 2
              MOVE SPACE TO X-FLD
              MOVE ZERO TO X-L
              GO TO EX-F-NUM.

           MOVE ZERO TO PARPCNS.
           IF PSCS-NDEC > ZERO
              COMPUTE PCNS-NUM = PSCS-NUM / (10 ** PSCS-NDEC)
           ELSE
              MOVE PSCS-NUM TO PCNS-NUM.
           MOVE 1 TO PCNS-FLGB.
           MOVE 1 TO PCNS-FLGN.
           MOVE 'n' TO PCNS-SEGNO.
           MOVE 1 TO PCNS-FLGM.
           MOVE SPACE TO PCNS-STR.
           CALL 'concstr' USING PARPCNS.
           MOVE PCNS-STR TO X-FLD.
           MOVE PCNS-ULT TO X-L.

       NO-NUM.
      ************

           MOVE 1 TO X-I.
           PERFORM UNTIL X-FLD(X-I:1) NOT = SPACE OR X-I > X-L
                   ADD 1 TO X-I.

           MOVE X-FLD(X-I:) TO X-FLD.
           COMPUTE X-L = X-L - X-I + 1.
       EX-F-NUM.
           EXIT.
      *----------------------------*
       F-DATA.
      * formatta data
       EX-F-DATA.
           EXIT.
      *----------------------------*
       F-STRINGA.
      * formatta campo stringa
      * toglie spazi a dx
           MOVE 1 TO X-I.
           PERFORM UNTIL X-FLD(X-I:) = SPACE
                   ADD 1 TO X-I.

           COMPUTE X-L = X-I - 1.
       EX-F-STRINGA.
           EXIT.
      *----------------------------*
       CARSPECIALI.
           MOVE 1 TO X-K.
      **** rel 6.0a
      * modificata completamente rispetto a rel 6.0
           MOVE 1 TO X-I.
           MOVE SPACE TO X-FLD2.
       CS010.
           IF X-FLD(X-K:) = SPACE OR X-K > X-L GO TO CS095.

           IF X-FLD(X-K:1) = '&'
              STRING '&' DELIMITED SIZE
                     INTO X-FLD2 POINTER X-I
      **** rel 6.2
      *       IF F-CDATA NOT = ZERO AND X-FLD(X-K + 1:2) NOT = '#x'
      *          STRING 'amp;' DELIMITED SIZE
      *                 INTO X-FLD2 POINTER X-I
      *       END-IF
      *       STRING 'amp;' DELIMITED SIZE
      *              INTO X-FLD2 POINTER X-I
              IF F-CDATA = ZERO
                 STRING 'amp;' DELIMITED SIZE
                       INTO X-FLD2 POINTER X-I
              ELSE
                 IF X-FLD(X-K + 1:2) NOT = '#x'
                    STRING 'amp;' DELIMITED SIZE
                           INTO X-FLD2 POINTER X-I
                 END-IF
              END-IF
      ************
              GO TO CS090.

           IF X-FLD(X-K:1) = '<'
              STRING '&' DELIMITED SIZE
                     INTO X-FLD2 POINTER X-I
              IF F-CDATA NOT = ZERO
                 STRING 'amp;' DELIMITED SIZE
                        INTO X-FLD2 POINTER X-I
              END-IF
              STRING 'lt;' DELIMITED SIZE
                     INTO X-FLD2 POINTER X-I
              GO TO CS090.

           IF X-FLD(X-K:1) = '>'
              STRING '&' DELIMITED SIZE
                     INTO X-FLD2 POINTER X-I
              IF F-CDATA NOT = ZERO
                 STRING 'amp;' DELIMITED SIZE
                        INTO X-FLD2 POINTER X-I
              END-IF
              STRING 'gt;' DELIMITED SIZE
                     INTO X-FLD2 POINTER X-I
              GO TO CS090.

           IF X-FLD(X-K:1) = EURO
              STRING '&' DELIMITED SIZE
                     INTO X-FLD2 POINTER X-I
              IF F-CDATA NOT = ZERO
                 STRING 'amp;' DELIMITED SIZE
                        INTO X-FLD2 POINTER X-I
              END-IF
              STRING '#x20AC;' DELIMITED SIZE
                     INTO X-FLD2 POINTER X-I
              GO TO CS090.

           IF X-FLD(X-K:1) = TTAB
              STRING '&' DELIMITED SIZE
                     INTO X-FLD2 POINTER X-I
              IF F-CDATA NOT = ZERO
                 STRING 'amp;' DELIMITED SIZE
                        INTO X-FLD2 POINTER X-I
              END-IF
              STRING '#x9;' DELIMITED SIZE
                     INTO X-FLD2 POINTER X-I
              GO TO CS090.

           IF X-FLD(X-K:1) = '"'
              STRING '&' DELIMITED SIZE
                     INTO X-FLD2 POINTER X-I
              IF F-CDATA NOT = ZERO
                 STRING 'amp;' DELIMITED SIZE
                        INTO X-FLD2 POINTER X-I
              END-IF
              STRING 'quot;' DELIMITED SIZE
                     INTO X-FLD2 POINTER X-I
              GO TO CS090.

           STRING X-FLD(X-K:1) DELIMITED SIZE
                  INTO X-FLD2 POINTER X-I.
       CS090.
           ADD 1 TO X-K.
           GO TO CS010.
       CS095.
           MOVE X-FLD2 TO X-FLD.
           COMPUTE X-L = X-I - 1.
      *************
       EX-CARSPECIALI.
           EXIT.
      *----------------------------*
       VER-LIV.
           IF (B-IND - T-ITP) > X-LIV
              IF X-LIV = (B-IND - T-ITP) - 1
                 PERFORM WR-INTC THRU EX-WR-INTC
              END-IF
              ADD 1 TO X-LIV
              IF X-LIV = (B-IND - T-ITP)
                 GO TO EX-VER-LIV
              ELSE
                 PERFORM OPEN-TAG THRU EX-OPEN-TAG
                 GO TO VER-LIV.

           IF (B-IND - T-ITP) = X-LIV
              MOVE ZERO TO FLGCR
              PERFORM CLOSE-TAG THRU EX-CLOSE-TAG
              GO TO EX-VER-LIV.

       VER-LIV-2.
           IF (B-IND - T-ITP) < X-LIV
              PERFORM CLOSE-TAG THRU EX-CLOSE-TAG
              SUBTRACT 1 FROM X-LIV
              IF X-LIV = (B-IND - T-ITP)
                 MOVE ZERO TO FLGCR
                 PERFORM CLOSE-TAG THRU EX-CLOSE-TAG
                 GO TO EX-VER-LIV
              ELSE
                 GO TO VER-LIV-2.
       EX-VER-LIV.
           EXIT.
      *----------------------------*
       OPEN-TAG.
           ADD 1 TO B-PRG(X-LIV + T-ITP).

           MOVE X-LIV TO X-TAB.
           PERFORM ADD-TAB.

           STRING '<' DELIMITED SIZE
                  INTO X-RIG POINTER X-IND.

           MOVE ZERO TO FLGP.
           IF RP-FLGP NOT = ZERO AND
              X-LIV = (B-IND - T-ITP)
                 MOVE 1 TO FLGP
                 IF NOT ((B-PIND(X-LIV + T-ITP) = (X-LIV + T-ITP)) OR
                         (B-PIND(X-LIV + T-ITP) + 1 = (X-LIV + T-ITP)))
                       STRING 'P_' DELIMITED SIZE
                              INTO X-RIG POINTER X-IND.

           STRING B-TAG(X-LIV + T-ITP) DELIMITED SPACE
                  INTO X-RIG POINTER X-IND.

           STRING '>' DELIMITED SIZE
                  INTO X-RIG POINTER X-IND.

           PERFORM WR-XML.

           MOVE X-LIV TO X-TAB.
           ADD 1 TO X-TAB.
           PERFORM ADD-TAB.

           STRING '<PBK>' DELIMITED SIZE
                  INTO X-RIG POINTER X-IND.

           MOVE ZERO TO X-K.
           PERFORM UNTIL X-K = X-LIV
                  ADD 1 TO X-K
                  MOVE B-PRG(X-K + T-ITP) TO X-FLD
                  MOVE 1 TO X-I
                  PERFORM UNTIL X-FLD(X-I:1) NOT = '0'
                          ADD 1 TO X-I
                  END-PERFORM
                  IF X-K NOT = 1
                     STRING '.' DELIMITED SIZE
                            INTO X-RIG POINTER X-IND
                  END-IF
                  STRING B-PRG(X-K + T-ITP)(X-I:7 - X-I + 1)
                         DELIMITED SIZE INTO X-RIG POINTER X-IND.

           STRING '</PBK>' DELIMITED SIZE
                  INTO X-RIG POINTER X-IND.

           MOVE ZERO TO FLGCR.
           IF NOT (X-LIV = 1 OR 2) AND FSLIM = 1 MOVE 1 TO FLGCR.

           PERFORM WR-XML.

           IF X-LIV = 2 PERFORM INTES THRU EX-INTES.

       EX-OPEN-TAG.
           EXIT.
      *----------------------------*
       CLOSE-TAG.
           IF X-LIV = ZERO GO TO EX-CLOSE-TAG.

           MOVE X-LIV TO X-TAB.
           PERFORM ADD-TAB.

           STRING '</' DELIMITED SIZE
                  INTO X-RIG POINTER X-IND.

           IF FLGP NOT = ZERO
              MOVE ZERO TO FLGP
              STRING 'P_' DELIMITED SIZE
                     INTO X-RIG POINTER X-IND.

           STRING B-TAG(X-LIV + T-ITP) DELIMITED SPACE
                  '>' DELIMITED SIZE
                  INTO X-RIG POINTER X-IND.

           PERFORM WR-XML.

           IF B-PIND(X-LIV + T-ITP) = B-PIND(X-LIV + T-ITP + 1)
              MOVE ZERO TO B-PRG(X-LIV + T-ITP + 1).
           
       EX-CLOSE-TAG.
           EXIT.
      *----------------------------*
      * Inizializza a SPACE riga
       INI-RIGA.
           MOVE 1 TO R-IND.
           PERFORM UNTIL R-IND > RP-RMAX OR RP-RIGA(R-IND:) = SPACE
                   IF NOT (RP-RIGA(R-IND:1) = LOW-VALUE OR HIGH-VALUE)
                      MOVE SPACE TO RP-RIGA(R-IND:1)
                   END-IF
                   ADD 1 TO R-IND.
      *----------------------------*
       CALL-RSTMP.                        *> CRT
           CALL 'rstmpn' USING PARSTN.
      *----------------------------*
       INI-ELABORA.
      *
      **** rel 6.3
      *    MOVE 'GRRPT' TO G-VAR.
      *    CALL 'rgenv' USING PARG.
      *    IF G-RET = SPACE
      *       MOVE 'UTI' TO G-VAR
      *       CALL 'rgenv' USING PARG
      *       STRING G-RET DELIMITED SPACE
      *              '\..\RPT' DELIMITED SIZE
      *              INTO DIRRPT
      *    ELSE
      *       MOVE G-RET TO DIRRPT.
           DISPLAY 'GRRPT' UPON ENVIRONMENT-NAME.
           ACCEPT DIRRPT FROM ENVIRONMENT-VALUE ON EXCEPTION
              MOVE 'UTI' TO G-VAR
              CALL 'rgenv' USING PARG
              STRING G-RET DELIMITED SPACE
                     '\..\RPT' DELIMITED SIZE
                     INTO DIRRPT.
      ************
      *
           MOVE 'GRTMP' TO G-VAR.
           CALL 'rgenv' USING PARG.
           IF G-RET = SPACE
              STRING 'c:\TMP\RPT' DELIMITED SIZE
                     INTO DIROUT
           ELSE
              STRING G-RET DELIMITED SPACE
                     '\RPT' DELIMITED SIZE
                     INTO DIROUT.
      *
           MOVE DIROUT TO F-FILEIN.
           PERFORM EXIST-DIR.
           IF F-ERROR NOT = ZERO
              MOVE DIROUT TO FILE-NAME
              CALL "CBL_CREATE_DIR" USING FILE-NAME
                                    RETURNING STATUS-CODE
              END-CALL
              IF STATUS-CODE NOT = ZERO
                 MOVE SPACE TO DIROUT.
      *
           MOVE 1 TO B-IND.
           PERFORM UNTIL B-IND = RP-BMAX
                   MOVE SPACE TO B-NOME(B-IND) B-TAG(B-IND) 
                   MOVE ZERO TO B-PIND(B-IND) B-DA(B-IND) B-NFLD(B-IND)
                                B-TPAG(B-IND) B-LIV(B-IND) B-PRG(B-IND)
                   ADD 1 TO B-IND.
      *
           MOVE SPACE TO F-STR.
           MOVE ZERO TO FLGCR.
      **** rel 6.0a
           MOVE ZERO TO FPIEDE.
           MOVE SPACE TO VAR-PIEDE.
           MOVE ZERO TO F-CDATA.
      *************
      *
           MOVE 1 TO FSLIM.
           MOVE 'GRRDEBUG' TO G-VAR.
           CALL 'rgenv' USING PARG.
           IF G-RET NOT = SPACE
              MOVE ZERO TO FSLIM.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *----------------------------*
       AGGIUNGI-CAMPO.
           MOVE ZERO TO FLGCR.
           IF FSLIM = 1 MOVE 1 TO FLGCR.
      *
           IF X-L NOT = ZERO OR
              FLGTAG NOT = ZERO
                 MOVE X-LIV TO X-TAB
                 ADD 1 TO X-TAB
                 PERFORM ADD-TAB
                 PERFORM CARSPECIALI THRU EX-CARSPECIALI
                 STRING '<' DELIMITED SIZE
                        X-TAG DELIMITED SPACE
                        '>' DELIMITED SIZE
                        INTO X-RIG POINTER X-IND
                 IF X-L NOT = ZERO
      **** rel 6.0a
                    IF F-CDATA NOT = ZERO
                       STRING '<![CDATA[' DELIMITED SIZE
                              INTO X-RIG POINTER X-IND
                    END-IF
      *************
                    STRING X-FLD(1:X-L) DELIMITED SIZE
                           INTO X-RIG POINTER X-IND
      **** rel 6.0a
                    IF F-CDATA NOT = ZERO
                       STRING ']]>' DELIMITED SIZE
                              INTO X-RIG POINTER X-IND
                    END-IF
      *************
                 END-IF
                 STRING '</' DELIMITED SIZE
                        X-TAG DELIMITED SPACE
                        '>' DELIMITED SIZE
                        INTO X-RIG POINTER X-IND
                 PERFORM WR-XML.
      **** rel 6.0a
           MOVE ZERO TO F-CDATA.
      *************
      *----------------------------*
       WR-XML.
           MOVE 1 TO X-IND.
           PERFORM UNTIL X-RIG(X-IND:) = SPACE OR X-IND = 1000
                   MOVE X-RIG(X-IND:1) TO RF-XML
                   WRITE RF-XML
                   ADD 1 TO X-IND.
           MOVE SPACE TO X-RIG.
           MOVE 1 TO X-IND.
           IF FLGCR = ZERO PERFORM WR-CRLF.
           MOVE ZERO TO FLGCR.
      *----------------------------*
       WR-CRLF.
           MOVE CR TO RF-XML.
           WRITE RF-XML.
           MOVE LF TO RF-XML.
           WRITE RF-XML.
      *----------------------------*
       ADD-TAB.
           PERFORM UNTIL X-TAB = ZERO
                   IF FSLIM = ZERO
                      STRING TTAB DELIMITED SIZE
                             INTO X-RIG POINTER X-IND
                   END-IF
                   SUBTRACT 1 FROM X-TAB.
      *----------------------------*
       WR-INTC.
           IF RP-INTC = SPACE GO TO EX-WR-INTC.
           ADD 1 TO X-LIV.

           MOVE X-LIV TO X-TAB.
           PERFORM ADD-TAB.

           STRING '<I_' DELIMITED SIZE
                  INTO X-RIG POINTER X-IND.

           STRING B-TAG(X-LIV + T-ITP) DELIMITED SPACE
                  INTO X-RIG POINTER X-IND.

           STRING '>' DELIMITED SIZE
                  INTO X-RIG POINTER X-IND.

           MOVE ZERO TO FLGCR.
           IF FSLIM = 1 MOVE 1 TO FLGCR.
           PERFORM WR-XML.

           MOVE 1 TO R-IND.

           MOVE ZERO TO R-I R-F R-NCX.
      * estrae campo da RP-INTC
        LP-IC.
           IF NOT (RP-INTC(R-IND:1) = HIGH-VALUE OR LOW-VALUE)
              IF R-I = ZERO
                 MOVE R-IND TO R-I
              END-IF
              MOVE R-IND TO R-F
           ELSE
              ADD 1 TO R-NCX
              MOVE SPACE TO X-FLD
              IF R-I NOT = ZERO
                 COMPUTE R-L = R-F - R-I + 1
                 MOVE RP-INTC(R-I:R-L) TO X-FLD
              END-IF
              PERFORM F-STRINGA THRU EX-F-STRINGA

              MOVE SPACE TO X-TAG
              MOVE 1 TO X-K
              STRING 'I' DELIMITED SIZE INTO X-TAG POINTER X-K

              IF B-LIV(X-LIV + T-ITP) > 9
                 STRING B-LIV(X-LIV + T-ITP) DELIMITED SPACE
                               INTO X-TAG POINTER X-K
              ELSE
                 STRING B-LIV(X-LIV + T-ITP)(2:1) DELIMITED SPACE
                               INTO X-TAG POINTER X-K
      **** rel 6.2
              END-IF
      ************

              MOVE 1 TO X-I
              PERFORM UNTIL R-NCX(X-I:1) NOT = '0'
                      ADD 1 TO X-I
              END-PERFORM
              STRING '_' R-NCX(X-I:3 - X-I + 1) DELIMITED SIZE
                     INTO X-TAG POINTER X-K

              PERFORM AGGIUNGI-CAMPO
              MOVE ZERO TO R-I R-F.

           IF R-IND NOT = RP-CMAX AND
              RP-INTC(R-IND:1) NOT = LOW-VALUE AND
              RP-INTC(R-IND:) NOT = SPACE
                 ADD 1 TO R-IND
                 GO TO LP-IC.

           MOVE X-LIV TO X-TAB.
           PERFORM ADD-TAB.

           STRING '</I_' DELIMITED SIZE
                  INTO X-RIG POINTER X-IND.

           STRING B-TAG(X-LIV + T-ITP) DELIMITED SPACE
                  '>' DELIMITED SIZE
                  INTO X-RIG POINTER X-IND.

           MOVE ZERO TO FLGCR
           IF FSLIM = 1 MOVE 1 TO FLGCR.
           PERFORM WR-XML.
      *
           IF FSLIM = 1 PERFORM WR-CRLF.

           SUBTRACT 1 FROM X-LIV.
       EX-WR-INTC.
           EXIT.
      *----------------------------*
       INTES.
           MOVE SPACE TO X-FLD.
      **** rel 6.3
      *    STRING RP-NOME DELIMITED SPACE
      *           '_' B-TPAG(X-LIV + T-ITP) DELIMITED SIZE
      *           INTO X-FLD.
           IF RP-FLGB NOT = 1
              STRING RP-NOME DELIMITED SPACE
                     '_' B-TPAG(X-LIV + T-ITP) DELIMITED SIZE
                     INTO X-FLD
           ELSE
              STRING RP-NOME DELIMITED SPACE
                     '_' B-TPAG(X-LIV + T-ITP) '_b' DELIMITED SIZE
                     INTO X-FLD.
      ************
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_RPT' TO X-TAG.
           PERFORM AGGIUNGI-CAMPO.
      *
           IF RNOME = SPACE AND
              CREV = SPACE AND
              DREV = SPACE GO TO NO-DMOD.

           MOVE SPACE TO X-FLD.
           MOVE 1 TO X-I.
           STRING 'Mod ' DELIMITED SIZE
                  INTO X-FLD POINTER X-I.

           MOVE 1 TO X-K.
           PERFORM UNTIL RNOME(X-K:) = SPACE OR X-K = 10
                   STRING RNOME(X-K:1) DELIMITED SIZE
                          INTO X-FLD POINTER X-I
                   ADD 1 TO X-K.

           IF RNOME NOT = SPACE ADD 1 TO X-I.

           IF CREV NOT = SPACE
              STRING 'Rev ' DELIMITED SIZE
                     INTO X-FLD POINTER X-I
              MOVE 1 TO X-K
              PERFORM UNTIL CREV(X-K:) = SPACE OR X-K = 10
                      STRING CREV(X-K:1) DELIMITED SIZE
                             INTO X-FLD POINTER X-I
                      ADD 1 TO X-K
              END-PERFORM
              ADD 1 TO X-I.

           IF DREV NOT = SPACE
              IF NOT (RNOME = SPACE AND CREV = SPACE)
                 STRING '- ' DELIMITED SIZE
                        INTO X-FLD POINTER X-I
              END-IF
              MOVE 1 TO X-K
              PERFORM UNTIL DREV(X-K:) = SPACE OR X-K = 10
                      STRING DREV(X-K:1) DELIMITED SIZE
                             INTO X-FLD POINTER X-I
                      ADD 1 TO X-K.

           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_DMOD' TO X-TAG.
           PERFORM AGGIUNGI-CAMPO.
       NO-DMOD.
      *
           MOVE SPACE TO FILE-NAME.
           IF RP-CAZI = ZERO GO TO NOAZI.

      **** rel 7.2
           MOVE 'anaazi' TO ID-AZI.
           IF RP-FL NUMERIC
              IF RP-FL NOT = ZERO
                 MOVE 'anazol' TO ID-AZI.
      ************
           OPEN INPUT ANAAZI.
      **** rel 7.2
           IF SF-AZI NOT = ZERO
              IF ID-AZI = 'anaazi'
                 MOVE 'anazol' TO ID-AZI
              ELSE
                 MOVE 'anaazi' TO ID-AZI
              END-IF
              OPEN INPUT ANAAZI
              IF SF-AZI NOT = ZERO
                 GO TO NOAZI.
      ************
           MOVE RP-CAZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID CLOSE ANAAZI
                                           GO TO NOAZI.
           IF SF-AZI = '9A' OR '9D' OR '35' MOVE RF-AZI TO REKAZI.
           CLOSE ANAAZI.

      * riferimenti LOGO
           MOVE DIRRPT TO PPH-PATH.

           MOVE SPACE TO PPH-FILE.
           MOVE 1 TO X-IND.

           STRING 'images\' DELIMITED SIZE
                  INTO PPH-FILE POINTER X-IND.

           MOVE 'GRLOGO' TO G-VAR.
           CALL 'rgenv' USING PARG.
           IF G-RET NOT = SPACE
              STRING G-RET DELIMITED SPACE INTO PPH-FILE POINTER X-IND
           ELSE
              STRING 'AZI' DELIMITED SIZE INTO PPH-FILE POINTER X-IND.

           STRING RP-CAZI '.jpg' DELIMITED SIZE
                  INTO PPH-FILE POINTER X-IND.
           MOVE 1 TO X-IND.

           CALL 'vrpath' USING PARPPH.

           MOVE PPH-FILE TO X-FLD.
      **** rel 6.0a
           IF FLGL NOT = ZERO MOVE SPACE TO X-FLD.
      *************
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_LOGO' TO X-TAG.
           PERFORM AGGIUNGI-CAMPO.

      **** rel 6.0a
      * riferimenti immagine background
           MOVE DIRRPT TO PPH-PATH.

           IF IMGBCK = SPACE
              MOVE SPACE TO X-FLD
           ELSE
              MOVE SPACE TO PPH-FILE
              MOVE 1 TO X-IND
              STRING 'images\' DELIMITED SIZE
                     IMGBCK DELIMITED SPACE
                     INTO PPH-FILE POINTER X-IND
              MOVE 1 TO X-IND
              CALL 'vrpath' USING PARPPH
              MOVE PPH-FILE TO X-FLD.

           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_BACK' TO X-TAG.
           PERFORM AGGIUNGI-CAMPO.
      *************

      **** rel 6.0a
      *    GO TO OK-AZI.
           IF FLGA = ZERO GO TO OK-AZI.
      *************
       NOAZI.
           MOVE SPACE TO AZI-RGSOC.
           MOVE SPACE TO AZI-INDIR.
           MOVE ZERO  TO AZI-CAP.
           MOVE SPACE TO AZI-CIT.
           MOVE SPACE TO AZI-PRV.
           MOVE ZERO  TO AZI-PIVA.
           MOVE SPACE TO AZI-CFISC.

       OK-AZI.
      * riferimenti azienda
      **** rel 6.0a
      *    MOVE RP-CAZI TO X-FLD.
           MOVE HTMLSPACE TO X-FLD.
           IF RP-CAZI NOT = ZERO MOVE RP-CAZI TO X-FLD.
      *************
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_ACOD' TO X-TAG.
           PERFORM AGGIUNGI-CAMPO.

      **** rel 6.0a
      *    MOVE '.' TO X-FLD.
      *    IF AZI-RGSOC NOT = SPACE MOVE AZI-RGSOC TO X-FLD.
           MOVE HTMLSPACE TO X-FLD.
           IF FPIEDE = ZERO
              IF AZI-RGSOC NOT = SPACE
                 MOVE AZI-RGSOC TO X-FLD
              END-IF
           ELSE
              IF PBK-ADES NOT = SPACE
                 MOVE PBK-ADES TO X-FLD.
      *************
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_ADES' TO X-TAG.
           MOVE 1 TO F-CDATA.
           PERFORM AGGIUNGI-CAMPO.

      **** rel 6.0a
      *    MOVE '.' TO X-FLD.
      *    IF AZI-INDIR NOT = SPACE MOVE AZI-INDIR TO X-FLD.
           MOVE HTMLSPACE TO X-FLD.
           IF FPIEDE = ZERO
              IF AZI-INDIR NOT = SPACE
                 MOVE ' -&#x20;' TO X-FLD.
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_TIND' TO X-TAG.
           MOVE 1 TO F-CDATA.
           PERFORM AGGIUNGI-CAMPO.

           MOVE HTMLSPACE TO X-FLD.
           IF FPIEDE = ZERO
              IF AZI-INDIR NOT = SPACE
                 MOVE AZI-INDIR TO X-FLD
              END-IF
           ELSE
              IF PBK-AIND NOT = SPACE
                 MOVE PBK-AIND TO X-FLD.
      *************
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_AIND' TO X-TAG.
           MOVE 1 TO F-CDATA.
           PERFORM AGGIUNGI-CAMPO.

      **** rel 6.0a
      *    MOVE '.' TO X-FLD.
      *    IF AZI-CAP NOT = ZERO MOVE AZI-CAP TO X-FLD.
           MOVE HTMLSPACE TO X-FLD.
           IF FPIEDE = ZERO
              IF AZI-CAP NOT = ZERO OR
                 AZI-CIT NOT = SPACE OR
                 AZI-PRV NOT = SPACE
                    MOVE ' -&#x20;' TO X-FLD.
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_TCIT' TO X-TAG.
           MOVE 1 TO F-CDATA.
           PERFORM AGGIUNGI-CAMPO.

           MOVE HTMLSPACE TO X-FLD.
           IF FPIEDE = ZERO
              IF AZI-CAP NOT = ZERO
                 MOVE AZI-CAP TO X-FLD
              END-IF
           ELSE
              IF PBK-ACAP NOT = SPACE
                 MOVE PBK-ACAP TO X-FLD.
      *************
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_ACAP' TO X-TAG.
           MOVE 1 TO F-CDATA.
           PERFORM AGGIUNGI-CAMPO.

      **** rel 6.0a
      *    MOVE '.' TO X-FLD.
      *    IF AZI-CIT NOT = SPACE MOVE AZI-CIT TO X-FLD.
           MOVE HTMLSPACE TO X-FLD.
           IF FPIEDE = ZERO
              IF AZI-CIT NOT = SPACE
                 MOVE AZI-CIT TO X-FLD
              END-IF
           ELSE
              IF PBK-ACIT NOT = SPACE
                 MOVE PBK-ACIT TO X-FLD.
      *************
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_ACIT' TO X-TAG.
           MOVE 1 TO F-CDATA.
           PERFORM AGGIUNGI-CAMPO.

      **** rel 6.0a
      *    MOVE '.' TO X-FLD.
      *    IF AZI-PRV NOT = SPACE MOVE AZI-PRV TO X-FLD.
           MOVE HTMLSPACE TO X-FLD.
           IF FPIEDE = ZERO
              IF AZI-PRV NOT = SPACE
                 MOVE AZI-PRV TO X-FLD
              END-IF
           ELSE
              IF PBK-APRV NOT = SPACE
                 MOVE PBK-APRV TO X-FLD.
      *************
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_APRV' TO X-TAG.
           MOVE 1 TO F-CDATA.
           PERFORM AGGIUNGI-CAMPO.

      **** rel 6.0a
      *    MOVE '.' TO X-FLD.
      *    IF AZI-PIVA NOT = ZERO MOVE AZI-PIVA TO X-FLD.
           MOVE HTMLSPACE TO X-FLD.
           IF FPIEDE = ZERO 
              IF AZI-PIVA NOT = ZERO
                 MOVE ' - P.I:&#x20;' TO X-FLD.
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_APIVD' TO X-TAG.
           MOVE 1 TO F-CDATA.
           PERFORM AGGIUNGI-CAMPO.

           MOVE HTMLSPACE TO X-FLD.
           IF FPIEDE = ZERO
              IF AZI-PIVA NOT = ZERO
                 MOVE AZI-PIVA TO X-FLD
              END-IF
           ELSE
              IF PBK-APIV NOT = SPACE
                 MOVE PBK-APIV TO X-FLD.
      *************
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_APIV' TO X-TAG.
           MOVE 1 TO F-CDATA.
           PERFORM AGGIUNGI-CAMPO.

      **** rel 6.0a
      *    MOVE '.' TO X-FLD.
      *    IF AZI-CFISC NOT = SPACE MOVE AZI-CFISC TO X-FLD.
           MOVE HTMLSPACE TO X-FLD.
           IF FPIEDE = ZERO
              IF AZI-CFISC NOT = SPACE
                 MOVE ' - C.F:&#x20;' TO X-FLD.
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_ACFID' TO X-TAG.
           MOVE 1 TO F-CDATA.
           PERFORM AGGIUNGI-CAMPO.

           MOVE HTMLSPACE TO X-FLD.
           IF FPIEDE = ZERO
              IF AZI-CFISC NOT = SPACE
                 MOVE AZI-CFISC TO X-FLD
              END-IF
           ELSE
              IF PBK-ACFI NOT = SPACE
                 MOVE PBK-ACFI TO X-FLD.
      *************
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_ACFI' TO X-TAG.
           MOVE 1 TO F-CDATA.
           PERFORM AGGIUNGI-CAMPO.

      * titoli pagina
           MOVE RP-TIT1 TO X-FLD.
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           IF RP-TIT2 = SPACE
              MOVE 'PBK_TIT' TO X-TAG
           ELSE
              MOVE 'PBK_TIT1' TO X-TAG.
           PERFORM AGGIUNGI-CAMPO.

           IF RP-TIT2 NOT = SPACE
              MOVE RP-TIT2 TO X-FLD
              PERFORM F-STRINGA THRU EX-F-STRINGA
              MOVE 'PBK_TIT2' TO X-TAG
              PERFORM AGGIUNGI-CAMPO.

      * data ora elaborazione
      **** rel 6.0a
      *    MOVE SDATA TO X-FLD.
           MOVE HTMLSPACE TO X-FLD.
           IF FLGD = ZERO
              MOVE SPACE TO X-FLD
              STRING ' - Data: ' SDATA 
                     DELIMITED SIZE INTO X-FLD.
      *************
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_DATA' TO X-TAG.
           PERFORM AGGIUNGI-CAMPO.

      **** rel 6.0a
      *    MOVE SORA TO X-FLD.
           MOVE HTMLSPACE TO X-FLD.
           IF FLGD = ZERO
              MOVE SPACE TO X-FLD
              STRING ' Ora: ' SORA
                     DELIMITED SIZE INTO X-FLD.
      *************
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_ORA' TO X-TAG.
           PERFORM AGGIUNGI-CAMPO.

      * utente
      **** rel 6.0a
      *    MOVE '.' TO X-FLD.
      *    IF EX-LOGNAME NOT = LOW-VALUE MOVE EX-LOGNAME TO X-FLD.
           MOVE HTMLSPACE TO X-FLD.
           IF FLGU = ZERO AND EX-LOGNAME NOT = LOW-VALUE
              MOVE SPACE TO X-FLD
              STRING ' - Utente: ' EX-LOGNAME
                     DELIMITED SIZE INTO X-FLD.
      *************
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_USER' TO X-TAG.
           PERFORM AGGIUNGI-CAMPO.

      * posto di lavoro
      **** rel 6.0a
      *    MOVE '.' TO X-FLD.
      *    IF EX-WS NOT = LOW-VALUE MOVE EX-WS TO X-FLD.
           MOVE HTMLSPACE TO X-FLD.
           IF FLGU = ZERO AND EX-WS NOT = LOW-VALUE
              MOVE SPACE TO X-FLD
              STRING ' PdL: ' EX-WS
                     DELIMITED SIZE INTO X-FLD.
      *************
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_PDL' TO X-TAG.
           PERFORM AGGIUNGI-CAMPO.

      **** rel 6.0a
           MOVE HTMLSPACE TO X-FLD.
           IF PBK-DPAG NOT = SPACE
              MOVE PBK-DPAG TO X-FLD.
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_DPAG' TO X-TAG.
           PERFORM AGGIUNGI-CAMPO.

           MOVE '00000' TO X-FLD.
           IF PBK-NPAGX NUMERIC
              IF PBK-NPAG NOT = ZERO
                 MOVE PBK-NPAG TO COMPAG
                 SUBTRACT 1 FROM COMPAG
                 MOVE COMPAG TO X-FLD.
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_ADDP' TO X-TAG.
           PERFORM AGGIUNGI-CAMPO.
      *************

      * forza azzeramento numerazione pagina
      ** flag non implementato su report grafico **
           MOVE '0' TO X-FLD.
           IF FNPGG = 1 MOVE '1' TO X-FLD.
           MOVE ZERO TO FNPGG.
           PERFORM F-STRINGA THRU EX-F-STRINGA.
           MOVE 'PBK_NPAG' TO X-TAG.
           PERFORM AGGIUNGI-CAMPO.
      *
           IF FSLIM = 1 PERFORM WR-CRLF.

       EX-INTES.
           EXIT.
      *----------------------------*
       EXIST-DIR.
      * input : F-FILEIN = dir da controllare
      * output: F-ERROR  = 0 se dir esiste
           MOVE 3        TO F-ACTION.
           MOVE 16       TO F-ATTRIN.
           MOVE ZERO     TO F-HANDLE.
           MOVE SPACE    TO F-FILEOUT.
           CALL X"91" USING RESULT
                            FUNCTION-CODE
                            PARAMETER.
      *----------------------------*
       LANCIO.
           IF RP-TRPT = 2 GO TO EX-LANCIO.

           MOVE RP-PR TO PT-PR.
           CALL 'vrptip' USING PARPT.
           IF PT-ST NOT = ZERO MOVE 7 TO RP-ERR
                               GO TO ERRIO.

           MOVE RP-PR TO PM-PR.
           CALL 'vrpmap' USING PARPM.
           IF PM-ST NOT = ZERO MOVE 7 TO RP-ERR
                               GO TO ERRIO.

           MOVE ID-XML TO PJR-XML.

           MOVE SPACE TO PJR-MAIN.
      **** rel 6.0a
      *    IF NOT (NPG = SPACE OR '-') MOVE NPG TO PJR-MAIN.
           MOVE 1 TO K.
           IF NPG = SPACE OR '-'
              IF FPG = 1
                 STRING 'pra4' DELIMITED SIZE INTO PJR-MAIN POINTER K
              ELSE
                 STRING 'lsa4' DELIMITED SIZE INTO PJR-MAIN POINTER K
              END-IF
           ELSE
              STRING NPG DELIMITED SPACE INTO PJR-MAIN POINTER K.
      *
           IF RP-VERM NOT = SPACE
              STRING '_' RP-VERM DELIMITED SPACE
                     INTO PJR-MAIN POINTER K.
      *************
      **** rel 6.3
           IF RP-FLGB = 1 MOVE '_b' TO PJR-MAIN(5:).
      ************

           MOVE 'view' TO PJR-TIP.
           IF PT-TIP = 's' OR 'S' MOVE 'print' TO PJR-TIP.

           MOVE ZERO TO PJR-DEB.
           IF FSLIM = ZERO MOVE 1 TO PJR-DEB.

           MOVE DIROUT TO PJR-DLOG.

      **** rel 6.2
      *    MOVE SPACE TO PJR-SWOP.
      *    STRING DIROUT DELIMITED SPACE
      *           '\swop' DELIMITED SIZE
      *           INTO PJR-SWOP.
           MOVE SPACE TO PJR-SWAP.
           STRING DIROUT DELIMITED SPACE
                  '\swap' DELIMITED SIZE
                  INTO PJR-SWAP.
      ************

           MOVE SPACE TO PJR-NOUT.

           MOVE SPACE TO PJR-DOUT.
            
      **** rel 6.1
           MOVE ZERO TO PJR-FLGATT.

           IF NOT (PT-TIP = 'j' OR 'J') GO TO NO-JRP.

      **** rel 6.3
      *    STRING PM-DEV DELIMITED SPACE
      *           INTO PJR-DOUT.
           MOVE PM-DEV TO PJR-DOUT.
           DISPLAY 'PRF-DIR' UPON ENVIRONMENT-NAME.
           ACCEPT PCFG-PATH FROM ENVIRONMENT-VALUE ON EXCEPTION
                  MOVE EX-UTI TO PCFG-PATH.
           MOVE ZERO TO PCFG-R-FUN
           MOVE EX-WS TO PCFG-R-WS
           MOVE 'PATH-RPT' TO PCFG-R-COD
           CALL 'readcfg' USING PARPCFG-R PCFG-CTR
                                ON EXCEPTION MOVE 9 TO PCFG-ST
           END-CALL
           IF PCFG-ST = ZERO AND PCFG-R-VAL NOT = SPACE
              MOVE PCFG-R-VAL TO PJR-DOUT.
      ************

           MOVE 1 TO PJR-FLGATT.

           MOVE RP-PR TO PS-PR.
           MOVE RP-FMT TO PS-FMT.
           CALL 'rpsetb' USING PARPS ON EXCEPTION
                 MOVE SPACE TO PS-SET PS-RES
                 MOVE ZERO  TO PS-FF  PS-NRGL.

           IF PS-ST NOT = ZERO GO TO NO-JRP.
      *
           IF PS-SET = SPACE OR '-'
              MOVE '???' TO PJR-TIP
              MOVE 'xml' TO PS-SET
           ELSE
              MOVE PS-SET TO PJR-TIP.
      *
           IF NOT (PS-RES = 'PID' OR 'pid')
      **** rel 6.3
      *       STRING RP-NOME DELIMITED SPACE
      *              '-' TTIME '.' PS-SET DELIMITED SIZE
      *              INTO PJR-NOUT
              IF PS-RES = SPACE
                 STRING RP-NOME DELIMITED SPACE
                        '-' TTIME '.' PS-SET DELIMITED SIZE
                        INTO PJR-NOUT
              ELSE
                 STRING RP-NOME DELIMITED SPACE
                        '-' TTIME '.' PS-RES DELIMITED SIZE
                        INTO PJR-NOUT
              END-IF
      ************
           ELSE
              STRING 'JRP_' DELIMITED SIZE
                     PID DELIMITED SPACE
                     '.' PS-SET DELIMITED SIZE
                     INTO PJR-NOUT.
      *
           IF PJR-TIP = '???' GO TO NO-JASPER.
        NO-JRP.
      ************

           MOVE ZERO TO PJR-PINT.

           MOVE PM-DEV TO PJR-PRD.

           MOVE ZERO TO PJR-ORI.
           IF FPG = 1 MOVE 1 TO PJR-ORI.

           CALL 'vjasper' USING PARJRP. 
           IF PJR-ERR NOT = ZERO OR
              PJR-ST NOT = ZERO
                 MOVE 8 TO RP-ERR
                 GO TO ERRIO.
      **** rel 6.1
           GO TO EX-LANCIO.
       NO-JASPER.
           MOVE PJR-XML TO FILE-NAME.
           STRING PJR-DOUT DELIMITED SPACE
                  '\' DELIMITED SIZE
                  PJR-NOUT DELIMITED SPACE
                  INTO FILE-OUT.
           CALL "CBL_RENAME_FILE" USING FILE-NAME
                                        FILE-OUT
                             RETURNING STATUS-CODE.
      ************

       EX-LANCIO.
           EXIT.
      *----------------------------*
      **** rel 6.0a
       INI-PIEDE.
           IF RP-BLK = 'PBK_ADES' MOVE RP-RIGA TO PBK-ADES.
           IF RP-BLK = 'PBK_AIND' MOVE RP-RIGA TO PBK-AIND.
           IF RP-BLK = 'PBK_ACAP' MOVE RP-RIGA TO PBK-ACAP.
           IF RP-BLK = 'PBK_ACIT' MOVE RP-RIGA TO PBK-ACIT.
           IF RP-BLK = 'PBK_APRV' MOVE RP-RIGA TO PBK-APRV.
           IF RP-BLK = 'PBK_APIV' MOVE RP-RIGA TO PBK-APIV.
           IF RP-BLK = 'PBK_ACFI' MOVE RP-RIGA TO PBK-ACFI.
      *
           IF PBK-DES-AZI NOT = SPACE MOVE 1 TO FPIEDE.
      *
           IF RP-BLK='PBK_DPAG' MOVE RP-RIGA TO PBK-DPAG.
           IF RP-BLK='PBK_NPAG' MOVE RP-RIGA TO PBK-NPAGX.
      *
           MOVE SPACE TO RP-RIGA RP-BLK.
       EX-INI-PIEDE.
           EXIT.
      *----------------------------*
      *************
