      $SET LINKCOUNT"192"
       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON110.
      *
      * Data Entry Primanota
      *
      * IF-RG-FUN = 'I' : inserimento nuova registrazione
      * IF-RG-FUN = 'M' : variazione/annullamento registrazione IF-NREG
      *
      * Note:
      * - In questo programma il campo IF-FUN e' PIC XX.
      * - IF-FUN: oltre ai valori soliti, puo' assumere anche:
      *      NM = inserimento nuovo rigo movimento
      *           vengono azzerati i dati di interfaccia relativi
      *      B0 = aggiorna files di lavoro e caricamento buffer
      *           vengono aggiornati i files di lavoro con i dati
      *           relativi al movimento in elaborazione
      *           viene caricato il buffer con tutti i righi relativi
      *           ai movimenti gia' inseriti
      *      B1 = carica altri dati nel buffer se la funzione B0 non
      *           ha completato il caricamento di tutti i righi
      *      RM = reset rigo movimento in inserimento
      *           azzeramento dei dati di interfaccia del rigo
      *      DC = controlla se rigo eliminabile
      *      DM = eliminazione rigo movimento selezionato
      *           elimina dai file di lavoro il/i record relativi alla
      *           selezione e li elimina dal buffer di visualizzazione
      *      MM = modifica rigo movimento selezionato
      *           carica aree con dati del rigo da variare e si posiziona
      *           sulla maschera video relativo
      *      DF = calcola l'eventuale differenza cambio e
      *           richiede se deve essere contabilizzata.
      *           Questa funzione viene chiamata prima della B0
      *      WR = validazione di tutta la registrazione
      *      R  = esecuzione degli aggiornamenti contabili
      *      L  = fase di aggiornamento lavoratori autonomi
      *           viene continuamente rilanciato dall'interfaccia fino
      *           a che viene restituito IF-RIT = ZERO
      *           Quando IF-RIT = ZERO, l'interfaccia lancera' la fase
      *           di aggancio ai cespiti (il file wds135 contenente tutti
      *           i movimenti potenzialmente inseribili su cespiti e' stato
      *           scritto durante la RUN-ELABORA)
      *      RR = reset di tutta la registrazione
      *      DR = cancellazione della registrazione
      *           (abilitato solo nel caso di modifica registrazione
      *            ossia IF-RG-FUN = 'M')
      **** rel 2.0
      *      CL = caricamento buffer con i legami di contabilita'
      *           selezionabili.
      *           Viene eseguita durante la validazione della causale.
      *           Puo' essere chiamata da interfaccia se viene cambiata
      *           la causale di riferimento per i legami (causale presente
      *           in testa al buffer di selezione legami)
      *      SL = selezione legame di contabilita' da buffer
      *           l'interfaccia passa in IF-LEG-RIGSEL il n. di riga
      *           selezionato, e il cobol precarica il video con i dati
      *           ricavati dal legame
      ************
      *----------------------------
      * non e' piu' gestita la richiesta 'Escludere da ventilazione ? '
      * che era generata per le causali con Acquisti destinati alla
      * rivendita (T02-FLVEN = 1)
      *----------------------------
      *
      * Nota: IF-CAMPO puo' restituire 'AMM-SI' durante la RUN-ELABORA
      *       per fare in modo che l'interfaccia lanci l'aggancio
      *       ai cespiti.
      *
      **** rel 5.0
      * Ricompilato per variazione tracciato ANABAN
      ************
      **** rel 7.2
      * Ricompilato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
      **** rel 2.0
           COPY 'griprasl'.
      ************
           COPY 'griconsl'.
      **** rel 5.0-2
           COPY 'griacosl'.
      **************
           COPY 'griclfsl'.
      **** rel 5.0
           COPY 'gricolsl'.
           COPY 'gricfxsl'.
           COPY 'gridscsl'.
      ************
           COPY 'grilgcsl'.
           COPY 'griftssl'.
           COPY 'gricamsl'.
           COPY 'griparsl'.
           COPY 'griscasl'.
      **** rel 6.2
           COPY 'grinscsl'.
      ************
      **** rel 1.2
      *    COPY 'gricggsl'.
      ************
           COPY 'gribansl'.
           COPY 'gritabsl'.
           COPY 'gricdcsl'.
           COPY 'gritrtsl'.
           COPY 'gri112sl'.
           COPY 'gri114sl'.
           COPY 'gri185sl'.
           COPY 'gri400sl'.
           COPY 'gri135sl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
           SELECT WDSLA1 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL1 STATUS SF-LA1.
           SELECT WDSLCN ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLC STATUS SF-LCN.
      **** rel 5.1
           SELECT WDSLA2 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL2 STATUS SF-LA2.
      ************
      **** rel 5.2
           SELECT WDSLA3 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL3 STATUS SF-LA3.
      ************
      **** rel 6.1
           SELECT WDSLA4 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL4 STATUS SF-LA4.
      ************
debug *    SELECT FILDBG ASSIGN TO 'fildbg'
debug *           ORGANIZATION LINE SEQUENTIAL.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
      **** rel 2.0
           COPY 'gripra'.
      ************
           COPY 'gricon'.
      **** rel 5.0-2
           COPY 'griaco'.
      **************
           COPY 'griclf'.
      **** rel 5.0
           COPY 'gricol'.
           COPY 'gricfx'.
           COPY 'gridsc'.
      ************
           COPY 'grilgc'.
           COPY 'grifts'.
           COPY 'gricam'.
           COPY 'gripar'.
           COPY 'grisca'.
      **** rel 6.2
           COPY 'grinsc'.
      ************
      **** rel 1.2
      *    COPY 'gricgg'.
      ************
           COPY 'griban'.
           COPY 'gritab'.
           COPY 'gricdc'.
           COPY 'gritrt'.
      *
      * file di lavoro scarico scadenzario
      * legato al progressivo di rigo
      *
           COPY 'gri112'.
      *
      * file di lavoro per passaggio dati a vcon114
      * (area wrklav)
      *
           COPY 'gri114'.

      * file di lavoro generato da vrit185 durante
      * l'esecuzione di vcon114
           COPY 'gri185'.
      *
      * file di lavoro per passaggio dati a vcon400
      *
           COPY 'gri400'.
      *
      * file di lavoro per aggancio ai cespiti
      *
           COPY 'gri135'.
      *
      * file di lavoro righi registrazione
      *
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 600 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
              10 KLV-PROGR PIC 9(3).
      **** rel 3.0
      *    05 RECLAV PIC X(597).
           05 RECLAV.
              10 RECLAV-DATREG PIC 9(6).
              10 FILLER        PIC X(591).
      ************
      *
      * file di lavoro carico scadenzario
      * legato al progressivo di rigo
      *
       FD  WDSLA1 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA1
      **** rel 4.0
      *    RECORD 375 DATA RECORD RF-LA1.
           RECORD 399 DATA RECORD RF-LA1.
      ************
       01  RF-LA1.
           05 KEYL1.
              10 KL1-PROGR PIC 9(3).
      **** rel 4.0
      *    05 RECLA1 PIC X(372).
      **** rel 6.2
      *    05 RECLA1 PIC X(396).
           05 RECLA1 PIC X(780).
      ************
      ************
      *
      * file di lavoro saldo provvisorio conti/cli/for
      *
       FD  WDSLCN LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LCN
           RECORD 20 DATA RECORD RF-LCN.
       01  RF-LCN.
           05 KEYLC.
              10 KLC-COD PIC 9(7).
      **** rel 4.0
      *    05 LCN-SDO  PIC S9(13).
           05 LCN-SDO  PIC S9(11)V99.
      ************

      **** rel 5.1
      *
      * file di lavoro per variazione dettagli scadenzario
      *
       FD  WDSLA2 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA2
           RECORD 23 DATA RECORD RF-LA2.
       01  RF-LA2.
           05 KEYL2.
              10 KL2-PROGR  PIC 9(3).
           05 RECLA2.
              10 LA2-KEYDSC.
                 15 LA2-AZI     PIC 999.
                 15 LA2-TIPO    PIC 9.
                 15 LA2-DTSCA   PIC 9(5).
                 15 LA2-PRG     PIC 9(5).
                 15 LA2-PROG    PIC 9(5).
              10 LA2-FLGTRO PIC 9.
      ************

      **** rel 5.2
       FD  WDSLA3 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA3
           RECORD 71 DATA RECORD RF-LA3.
       01  RF-LA3.
           05 KEYL3.
              10 KL3-PROGR   PIC 9(3).
              10 KL3-DTREG   PIC 9(5).
           05 RECLA3.
              10 LA3-CAUS    PIC 9(3).
              10 LA3-CPART   PIC 9(7).
              10 LA3-IMPOR   PIC S9(11)V99.
              10 LA3-DESAG   PIC X(30).
              10 LA3-DOCUM   PIC 9(5).
              10 LA3-DTDOC   PIC 9(5).

      ************
      *
      * file normalizzato di wrklav per debug
debug *FD  FILDBG.
debug *01  RF-DBG.
debug *    05 DBG00 PIC XXX.
debug *    05 KEYDBG.
debug *       10 DBG-PROG PIC 9(3).
debug *    05 RECDBG.
debug *       10 DBG-IVA   PIC 9.
debug *       10 DBG-CAUSA PIC 9(3).
debug *       10 DBG-TIPRG PIC 9.
debug *       10 DBG-DAVE  PIC X.
debug *       10 DBG-SEGNO PIC 9.
debug *       10 DBG-FLGIS PIC 9.
debug *       10 DBG-TIPOP PIC 99.
debug *       10 DBG-FLGSC PIC 9.
debug *       10 DBG-SWAGG PIC 9.
debug *       10 DBG-FLGEC PIC 9.
debug *       10 DBG-DESAG PIC X(30).
debug *       10 DBG-PART  PIC 9(7).
debug *       10 DBG-IMPOR PIC ZZ.ZZZ.ZZZ.ZZ9+.
debug *       10 DBG-DOCUM PIC 9(5).
debug *       10 DBG-DTDOC PIC 9(5).
debug *       10 DBG-DTSCD PIC 9(5).
debug *       10 DBG-VALUT PIC 999.
debug *       10 DBG-CAMGG PIC 9999,999.
debug *       10 DBG-IMVAL PIC ZZ.ZZZ.ZZZ.ZZ9,99+.
debug *       10 DBG-CCOST PIC X(4).
debug *       10 DBG-DFCAM PIC ZZ.ZZZ.ZZZ.ZZ9+.
debug *       10 DBG-CAUDF PIC X(3).
debug *       10 DBG-DAVDF PIC X.
debug *       10 DBG-GECDF PIC X.
debug *    05 RECDBG2.
debug *       10 DBG-CPART PIC 9(7).
debug *       10 DBG-IMPCP PIC ZZ.ZZZ.ZZZ.ZZ9+.
debug *       10 DBG-CAUS2 PIC 9(3).
debug *       10 DBG-TIPR2 PIC 9.
debug *       10 DBG-TIPO2 PIC 9.
debug *       10 DBG-DTSC2 PIC 9(5).
debug *       10 DBG-FLGS2 PIC 9.
debug *       10 DBG-SWAG2 PIC 9.
debug *       10 DBG-FLGE2 PIC 9.
debug *       10 DBG-DESA2 PIC X(30).
debug *       10 DBG-CCOS2 PIC X(4).
debug *       10 DBG-CATT  PIC X.
debug *       10 DBG-NPRGI PIC 9(5).
debug *       10 DBG-CDIVA PIC 9(3).
debug *       10 DBG-IMPON PIC ZZ.ZZZ.ZZZ.ZZ9+.
debug *       10 DBG-IMPOS PIC ZZ.ZZZ.ZZZ.ZZ9+.
debug *       10 DBG-INDED PIC ZZ.ZZZ.ZZZ.ZZ9+.
debug *       10 DBG-ESVEN PIC 9.
debug *       10 DBG-PLAFO.
debug *          15 DBG-PLAM PIC 99.
debug *          15 DBG-PLAN PIC 9.
debug *    05 DBG-RCSCA.
debug *       10 DBG-FLAG  PIC 9.
debug *       10 DBG-CDPAG PIC 999.
debug *       10 DBG-NRATE PIC 99.
debug *       10 DBG-SCAD  OCCURS 12.
debug *          20 DBG-TPAG  PIC 9.
debug *          20 DBG-DTSCA PIC 9(5).
debug *          20 DBG-IMRATA PIC ZZ.ZZZ.ZZZ.ZZ9+.
debug *          20 DBG-VALRATA PIC ZZ.ZZZ.ZZZ.ZZ9,99+.
debug *    05 DBG-RCWSC.
debug *          10 DBG-WSC OCCURS 6.
debug *             15 DBG-WBDSC PIC 9(5).
debug *             15 DBG-WBISC PIC ZZ.ZZZ.ZZZ.ZZ9+.
debug *             15 DBG-WBVSC PIC ZZ.ZZZ.ZZZ.ZZ9,99+.
      **** rel 6.1
       FD  WDSLA4 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA4
           RECORD 36 DATA RECORD RF-LA4.
       01  RF-LA4.
           05 KEYL4.
              10 KL4-AZI   PIC 999.
              10 KL4-CATT  PIC X.
              10 KL4-NPRGI PIC 9(5).
              10 KL4-ANNO  PIC 9(4).
           05 RECLA4.
              10 LA4-DOCUM PIC 9(5).
              10 LA4-DTDOC PIC 9(5).
              10 LA4-DTREG PIC 9(5).
              10 LA4-FOR   PIC 9(5).
              10 LA4-CAUS  PIC 9(3).
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'griconrk'.
           COPY 'griclfrk'.
           COPY 'gritabrk'.
           COPY 'griparrk'.
           COPY 'grit20rk'.
           COPY 'grit25rk'.
           COPY 'grit35rk'.
           COPY 'rekt23'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parcos'.
      **** rel 1.2
           COPY 'parmb'.
           COPY 'parer'.
           COPY 'parlk'.
      ************
      **** rel 5.0
           COPY 'partra'.
      ************
      **** rel 6.0
           COPY 'paracf'.
      ************
      **** rel 6.1
           COPY 'parppar'.
           COPY 'parmfa'.
      ************
      * parametri per vcon114
       01  PARLINK-114.
           05 DTCON-114  PIC 9(5) COMP-3.
           05 FL-114     PIC 9.
           05 CDAZ-114   PIC 9(3).
           05 NREG-114   PIC 9(5).
      * parametri per vcon400
       01  PARLINK-400.
           05 DTCON-400 PIC 9(5) COMP-3.
           05 FL-400    PIC 9.
           05 CDAZ-400  PIC 9(3).
      **** rel 5.2
           05 FLTRA-400 PIC 9.
      ************
      **** rel 6.3
           05 W400-KEYTRA.
              10 W400-KEY-AZI  PIC 999.
              10 W400-KEY-IVA  PIC 9(11).
              10 W400-KEY-ANNO PIC 9(4).
              10 W400-KEY-PERI PIC 9(2).
              10 W400-KEY-TRAN PIC X.
              10 W400-KEY-TIPO PIC 9.
              10 W400-KEY-TIPN PIC X.
              10 W400-KEY-PROT PIC 9(5).
              10 W400-KEY-PROG PIC 9(3).
      ************
      * parametri per vcon350  (non sono le sole)
       01  PARLINK-350-PRG1.
           05 TIPRG-350 PIC 9.
           05 CAUS-350  PIC 999.
           05 ATTRN-350 PIC 9.
           05 FLGIS-350 PIC 9.
      **** rel 5.0
           05 AGIVA-350 PIC 9.
      ************
      * parametri per vuti131
       01  PARLINK-131.
           05 CDAZ-131  PIC 9(3).
           05 NREG-131  PIC 9(5).
           05 FL-131    PIC 9.
      **** rel 4.0-2
      * ctr-131: documentato in vuti131
           05 CTR-131   PIC 9.
      ************
      **** rel 5.0
      * sca-131: documentato in vuti131
           05 SCA-131   PIC 9.
      ************
      **** rel 5.2
           05 DTMOV-131 PIC 9(5).
      ************
      **** rel 6.1
      * faf-131: documentato in vuti131
           05 FAF-131   PIC 9.
      ************
      **** rel 7.1
      * M = variazione ; D = annullamento
           05 FUN-C110  PIC X.
      ************
      *
       01  ID-AZI  PIC X(15) VALUE 'anaazi'.
      **** rel 2.0
       01  ID-PRA  PIC X(15) VALUE 'proazi'.
      ************
       01  ID-CON  PIC X(15) VALUE 'anacon'.
      **** rel 5.0-2
       01  ID-ACO  PIC X(15) VALUE 'appcon'.
      **************
       01  ID-CLF  PIC X(15) VALUE 'anaclf'.
      **** rel 5.0
       01  ID-COL  PIC X(15) VALUE 'anacol'.
       01  ID-CFX  PIC X(15) VALUE 'anacfx'.
       01  ID-DSC  PIC X(15) VALUE 'detsca'.
      ************
       01  ID-MOV  PIC X(15) VALUE 'movime'.
       01  ID-LGC  PIC X(15) VALUE 'legcau'.
       01  ID-FTS  PIC X(15) VALUE 'fatsos'.
       01  ID-TAC  PIC X(15) VALUE 'tacoam'.
       01  ID-PAR  PIC X(15) VALUE 'partit'.
       01  ID-SCA  PIC X(15) VALUE 'anasca'.
      **** rel 6.2
       01  ID-NSC  PIC X(15) VALUE 'notsca'.
      ************
      **** rel 1.2
      *01  ID-CGG  PIC X(15) VALUE 'camgio'.
      ************
       01  ID-BAN  PIC X(15) VALUE 'anaban'.
       01  ID-TAB  PIC X(15) VALUE 'tabell'.
       01  ID-CDC  PIC X(15) VALUE 'cdcost'.
       01  ID-TRT  PIC X(15) VALUE 'tabrit'.
       01  ID-112  PIC X(15) VALUE 'wds112'.
       01  ID-114  PIC X(15) VALUE 'wds114'.
       01  ID-185  PIC X(15) VALUE 'wds185'.
       01  ID-400  PIC X(15) VALUE 'wds400'.
       01  ID-135  PIC X(15) VALUE 'wds135'.
       01  ID-LAV  PIC X(15) VALUE 'wdslav'.
       01  ID-LA1  PIC X(15) VALUE 'wdsla1'.
       01  ID-LCN  PIC X(15) VALUE 'wdslcn'.
      **** rel 5.1
       01  ID-LA2  PIC X(15) VALUE 'wdsla2'.
      ************
      **** rel 5.2
       01  ID-LA3  PIC X(15).
      ************
      **** rel 6.1
       01  ID-LA4  PIC X(15).
      ************
       01  REKTE14.
           05 FILLER   PIC X(5).
           05 T14IVER  PIC 9(7).
           05 T14RICO  PIC 9(7).
           05 T14GIIV  PIC 9(3).
           05 T14GICO  PIC 9(3).
           05 T14IDIR  PIC 9(3).
           05 T14ITRI  PIC 9(3).
           05 T14IIND  PIC 9(3).
           05 T14ISCV  PIC 9(3).
           05 T14IRSM  PIC 9(3).
           05 T14IASS  PIC 9(3).
           05 T14ISIN  PIC 9(3).
           05 T141ACQ  PIC 9(3).
           05 T141ACR  PIC 9(3).
           05 T141ACT  PIC 9(3).
           05 T142ACQ  PIC 9(3).
           05 T143ACQ  PIC 9(3).
           05 T14IPOS  PIC 9(3).
           05 FILLER   PIC X(8).
       01  RIGAVIDEO.
           05 VISPRG PIC XXX.
           05 FILLER PIC X.
           05 VISCON PIC 9(7) BLANK WHEN ZERO.
           05 FILLER PIC X.
           05 VISDES PIC X(30).
           05 FILLER PIC X.
           05 RVID1.
      **** rel 4.0
      *       10 VISDAR  PIC ZZ.ZZZ.ZZZ.ZZZ-.
      *       10 VISAVE  PIC ZZ.ZZZ.ZZZ.ZZZ-.
              10 VISDAR  PIC ZZZ.ZZZ.ZZ9,99-.
              10 VISAVE  PIC ZZZ.ZZZ.ZZ9,99-.
      ************
           05 RVID2 REDEFINES RVID1.
              10 FILLER  PIC X(6).
              10 VISPAR1 PIC X.
      **** rel 4.0
      *       10 VISIMP  PIC ZZ.ZZZ.ZZZ.ZZZ-.
              10 VISIMP  PIC ZZZ.ZZZ.ZZ9,99-.
      ************
              10 VISPAR2 PIC X.
              10 FILLER  PIC X(7).
      **** rel 2.0
       01  RIGAVIDEO-L.
           05 VLASTE   PIC X.
           05 FILLER   PIC X.
           05 VLCAUS   PIC XXX.
           05 FILLER   PIC X.
           05 VLCAUSD  PIC X(24).
           05 FILLER   PIC X.
           05 VLCONDAR PIC X(7).
           05 FILLER   PIC X.
           05 VLDESDAR PIC X(20).
           05 FILLER   PIC X.
           05 VLCONAVE PIC X(7).
           05 FILLER   PIC X.
           05 VLDESAVE PIC X(20).
      ************
       01  CODCEN PIC X(4) VALUE SPACE.
       01  TABMESI PIC X(24) VALUE '312831303130313130313031'.
       01  TBMESI  REDEFINES TABMESI.
           05 GIO PIC 99 OCCURS 12.
       01  COMODI.
           05 SF-AZI   PIC XX.
      **** rel 2.0
           05 SF-PRA   PIC XX.
      ************
           05 SF-CON   PIC XX.
      **** rel 5.0-2
           05 SF-ACO   PIC XX.
      **************
           05 SF-CLF   PIC XX.
      **** rel 5.0
           05 SF-COL   PIC XX.
           05 SF-CFX   PIC XX.
           05 SF-DSC   PIC XX.
      ************
           05 SF-LGC   PIC XX.
           05 SF-FTS   PIC XX.
           05 SF-LCN   PIC XX.
           05 SF-TAC   PIC XX.
           05 SF-PAR   PIC XX.
           05 SF-SCA   PIC XX.
      **** rel 6.2
           05 SF-NSC   PIC XX.
      ************
      **** rel 1.2
      *    05 SF-CGG   PIC XX.
      ************
           05 SF-BAN   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-CDC   PIC XX.
           05 SF-TRT   PIC XX.
           05 SF-112   PIC XX.
           05 SF-114   PIC XX.
           05 SF-185   PIC XX.
           05 SF-400   PIC XX.
           05 SF-135   PIC XX.
           05 SF-LAV   PIC XX.
           05 SF-LA1   PIC XX.
      **** rel 5.1
           05 SF-LA2   PIC XX.
      ************
      **** rel 5.2
           05 SF-LA3   PIC XX.
      ************
      **** rel 6.1
           05 SF-LA4   PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC XX    VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC XX.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 LNSEZ    PIC 999.
      **** rel 2.0
           05 LNSEZ-L  PIC 999.
      ************
      **** rel 6.3
           05 SAV-CAUS PIC 9(3).
      **********
           05 LF       PIC X     VALUE X'0A'.
           05 MCLI     PIC 99.
           05 MFOR     PIC 99.
           05 CODICE.
              10 MAS   PIC 99.
              10 CODCF PIC 9(5).
           05 K        PIC 99.
      **** rel 4.0-2
      *    05 K1       PIC 99.
           05 K1       PIC 999.
      ************
           05 K2       PIC 99.
debug *    05 K9       PIC 99.
           05 J1       PIC 99.
           05 L        PIC 9.
           05 J        PIC 99.
           05 DTPB     PIC ZZ/ZZZ9.
           05 COMVALUT PIC 999.
      **** rel 1.2
      *    05 COMCAMGG PIC 9999V99.
      **** rel 4.0
      *    05 COMCAMGG PIC 9999V999.
           05 COMCAMGG PIC 9(5)V9(6).
      ************
      **** rel 4.0
      *    05 TIMRATA  PIC S9(13).
           05 TIMRATA  PIC S9(11)V99.
      ************
           05 TOTIVV   PIC S9(11)V99.
      ************
      **** rel 4.0
      *    05 COMOCAM  PIC ZZZ9,999.
           05 COMOCAM  PIC ZZZZ9,999999.
      ************
           05 PERIO    PIC 9(6).
           05 FILLER REDEFINES PERIO.
              10 PERM  PIC 99.
              10 PERA  PIC 9(4).
           05 DTCT1.
              10 PERAA PIC 9(4).
              10 PERMA PIC 99.
           05 DTCT2.
              10 PLFAA PIC 9(4).
              10 PLFMM PIC 99.
      **** rel 4.0
      *    05 COMIVA PIC S9(10).
           05 COMIVA PIC S9(11)V99.
      ************
           05 SWIVA    PIC 9.
           05 SWCAMGG  PIC 9.
           05 SWCERCA  PIC 9.
           05 PRGSELX.
              10 PRGSEL PIC 999.
           05 W-DTSCA  PIC 9(5) COMP-3.
           05 CLAV1    PIC 99.
           05 CLAV2    PIC 99.
           05 NUMGG    PIC 9(5).
      **** rel 4.0
      *    05 COMUR    PIC S9(9).
           05 COMUR    PIC S9(11)V99.
      ************
           05 COM1     PIC 999.
           05 COM2     PIC 999.
      **** rel 4.0
      *    05 TOTIVA   PIC S9(11).
      *    05 COMFAT   PIC S9(11).
           05 TOTIVA   PIC S9(11)V99.
           05 COMFAT   PIC S9(11)V99.
      ************
           05 COMFTV   PIC S9(11)V99.
      **** rel 4.0
      *    05 CIMPIVA  PIC S9(10).
      *    05 COMR     PIC S9(9).
      *    05 COMRV    PIC S9(9)V99.
      *    05 COMURV   PIC S9(9)V99.
      *    05 FATTUR   PIC S9(11).
           05 CIMPIVA  PIC S9(11)V99.
           05 COMR     PIC S9(11)V99.
           05 COMRV    PIC S9(11)V99.
           05 COMURV   PIC S9(11)V99.
           05 FATTUR   PIC S9(11)V99.
      ************
           05 COMO-DVAL PIC ZZ.ZZZ.ZZZ.ZZ9,99-.
           05 COMODVAL REDEFINES COMO-DVAL PIC X(18).
      **** rel 4.0
      *    05 COMO-DCAM PIC ZZ.ZZZ.ZZZ.ZZ9-.
      *    05 COMODCAM REDEFINES COMO-DCAM PIC X(15).
           05 COMO-DCAM PIC ZZ.ZZZ.ZZZ.ZZ9,99-.
           05 COMODCAM REDEFINES COMO-DCAM PIC X(18).
      ************
           05 RGFUN    PIC X.
           05 OLDCDPAG PIC 999.
      **** rel 2.0
           05 SAVDATREG PIC 9(6).
           05 SAVCPCLF  PIC 9(7).
           05 K5        PIC 99.
           05 COMDESAG  PIC X(30).
           05 COMDSABB  PIC X(20).
           05 COMLCA1   PIC 999.
           05 COMLNUM   PIC 999.
      * sw-caul: flag interno tipo scansione legcau
      *          0=non ancora definito
      *          1=scansione di legami
      *          2=scansione di collegamenti
           05 SW-CAUL  PIC 9.
      ************
      *
           05 DTAIVA   PIC 9(5) COMP-3 VALUE ZERO.
           05 DATIVB   PIC X(8)   VALUE SPACE.
           05 DTMB     PIC X(8) VALUE SPACE.
           05 TPL      PIC 9    VALUE ZERO.
           05 DTP      PIC 9(4) VALUE ZERO.
           05 DTP6.
              10 MM6 PIC 99.
              10 AA6.
                 15 AA61 PIC 99.
                 15 AA62 PIC 99.
           05 AGIVA    PIC 9      VALUE ZERO.
           05 FLGPL    PIC 9    VALUE ZERO.
           05 SWERR    PIC 9    VALUE ZERO.
           05 SWSCAD   PIC 9    VALUE ZERO.
      * SWSCAD: ricerca importo da pagare/incassare
      *                      del documento inserito
      *         0=non trovato
      *         1=trovato su scadenzario
      *         2=trovato su partitario
      *  nota:la priorita' di ricerca e' sullo scadenzario
           05 SWERR-FTSP   PIC 9    VALUE ZERO.
      **** rel 4.0
      *    05 COMODO   PIC S9(11) VALUE ZERO.
           05 COMODO   PIC S9(11)V99 VALUE ZERO.
      ************
           05 ANNO     PIC 9(4) VALUE ZERO.
           05 COMO-VAL PIC 999  VALUE ZERO.
           05 CAN PIC 9(17) VALUE ZERO.
           05 CCC REDEFINES CAN.
              10 TIPO PIC 9.
              10 CLFO PIC 9(5).
              10 CANN PIC 9(4).
              10 PARD PIC 9(5).
              10 NUME PIC 99.
           05 GGESC    PIC 99 VALUE 15.
      **** rel 4.0
           05 COMIMPON PIC S9(13)V99.
           05 NCP      PIC 9.
           05 COMEURO  PIC 9(3) VALUE ZERO.
           05 PERC     PIC 9(3)V99.
           05 DTBIG    PIC 9(5).
      ************
      **** rel 4.0-2
           05 SW-GENMS PIC 9.
      ************
      **** rel 4.1a
           05 OLDCAUS PIC 999.
           05 SAVCLF  PIC 9(7) VALUE ZERO.
      ************
      **** rel 5.1
           05 DTSCA   PIC 9(5)      VALUE ZERO.
           05 DTREG   PIC 9(5)      VALUE ZERO.
           05 FLGDSC  PIC 9         VALUE ZERO.
      ************
      **** rel 5.0
           05 FLINTRA PIC 9         VALUE ZERO.
           05 FLGACF  PIC 9         VALUE ZERO.
           05 FLGCEE  PIC 9         VALUE ZERO.
           05 SALDAP  PIC S9(11)V99 VALUE ZERO.
           05 NPROG   PIC 9(5)      VALUE ZERO.
      **** rel 5.1
      *    05 DTDOC   PIC 9(6)      VALUE ZERO.
      ************
           05 CONT    PIC 999       VALUE ZERO.
      **** rel 6.1
           05 CIVACQ  PIC 9(7)      VALUE ZERO.
           05 COMPRGI PIC 9(5)      VALUE ZERO.
           05 COMCATT PIC X         VALUE ZERO.
           05 COMKEY.
              10 COM-AZI   PIC 9(3).
              10 COM-ANNO  PIC 9(4).
              10 COM-CATT  PIC X.
              10 COM-NPRGI PIC 9(5).
           05 COMMOV.
              10 COM-DAT   PIC 9(5).
              10 COM-DTDOC PIC 9(5).
              10 COM-NDOC  PIC 9(5).
              10 COM-ACF   PIC 9(5).
              10 COM-CAUS  PIC 9(3).
           05 NREGV    PIC ZZZZ9.
           05 NPRIVV   PIC ZZZZ9.
      ************
      **** rel 7.1
           05 NOMMEA  PIC 9(8) VALUE ZERO.
           05 NOMMEV  PIC 9(8) VALUE ZERO.
           05 COM-NOMME PIC 9(8) VALUE ZERO.
           05 COM-TRAN  PIC X(1) VALUE SPACE.
      ********
      **** rel 6.0
           05 FLGMCL   PIC 9        VALUE ZERO.
      ************
      **** rel 6.3
           05 COMPRT     PIC 9(5)     VALUE ZERO.
           05 ERRPRT     PIC 9        VALUE ZERO.
           05 SAV-CATT   PIC X.
           05 SAV-NPRGI  PIC 9(5).
      * protocollo originale presente all'atto dell'inserimento
           05 SAV-ONPRGI PIC 9(5).
           05 FLGMOV   PIC 9        VALUE ZERO.
      **********
      **** rel 6.2
           05 FLGAMM   PIC 9        VALUE ZERO.
      ************
      *
      *> flag per modifica scadenzario in
      *  funzione di variazione primanota
      *  flgsca = zero --> scadenza relativa al movimento variato
      *                    non trovata (ad es. movimenti prima della
      *                    conversione)
      *  flgsca = 1    --> record scadenzario trovati. Alla conferma
      *                    del movimento variato verranno cancellati
      *                    e poi verranno riscritti con i nuovi dati.
      *  flgsca = 2    --> record scadenzario non variabili:
      *                    se lo stato e' diverso da space (da pagare)
      *                    non viene fatta alcuna variazione sui
      *                    movimenti dello scadenzario oppure se vi
      *                    sono dettagli pagamento relativi alle
      *                    scadenze del movimento che si sta variando.
      *  flgsca = 3    --> record dettagli scadenzario da variare
      *  flgsca = 4    --> record dettagli scadenzario non trovati
           05 FLGSCA  PIC 9 VALUE ZERO.
      **** rel 5.0-1
      *  flgpan = 1    --> pagamenti anticipati: non fare rewrite su
      *                    anagrafica azienda con n. progr. scadenzario.
           05 FLGPAN  PIC 9 VALUE ZERO.
      ************
      **** rel 5.2
      *> comodi tabella 14L per conti fatt da emettere/ricevere
           05 VET-CONTI OCCURS 3.
              10 CP-FTRC   PIC 9(7).
              10 CP-NARC   PIC 9(7).
              10 CP-FTEM   PIC 9(7).
              10 CP-NAEM   PIC 9(7).
           05 CAU-FTRC     PIC 999.
           05 CAU-FTEM     PIC 999.

      *> data di systema da confrontare con data registrazione
           05 DATSYS  PIC 9(6).
           05 DATSYS5 PIC 9(5).
      ************

      *> comodi record scadenzario da cancellare
      *  nel caso di variazione movimento
           05 VET-SCA OCCURS 12.
              10 VET-SC-AZI   PIC 999.
              10 VET-SC-TIPO  PIC 9.
              10 VET-SC-DTSCA PIC 9(5).
              10 VET-SC-PRG   PIC 9(5).

      *> comodi record dettagli scadenzario da cancellare
      *  nel caso di variazione movimento
           05 VET-DSC OCCURS 99.
              10 VET-DSC-AZI   PIC 999.
              10 VET-DSC-TIPO  PIC 9.
              10 VET-DSC-DTSCA PIC 9(5).
              10 VET-DSC-PRG   PIC 9(5).
              10 VET-DSC-PROG  PIC 9(5).
      ************
      * vettore di comodo IVA indeducibile
      **** rel 4.0
      *01  VIVA-INDEDUC PIC S9(10) OCCURS 6.
       01  VIVA-INDEDUC PIC S9(10)V99 OCCURS 6.
      ************
      * aree salvataggio dati interfaccia
       01  COMINTERF.
           05 CDATREG  PIC 9(6).
      **** rel 3.0
           05 ULTDTREG PIC 9(6).
      ************
      * aree salvataggio impostazioni di base registrazione (rigo 1)
      * significative solo per tipo registrazione = 1/2
       01  PRG1-BASE.
           05 PRG1-TIPRG  PIC 9.
           05 PRG1-CAUS   PIC 999.
           05 PRG1-ATTRN  PIC 9.
           05 PRG1-FLGIS  PIC 9.
      * comodi utilizzati nelle subroutine CALC-DIFCAM e
      *                                    AGG-SCAD-SCARICO
       01  VET-SCARICO.
      **** rel 4.0-2
      *    05 VET-KEY OCCURS 24.
           05 VET-KEY OCCURS 192.
      ************
              10 VETK-TIPO  PIC 9.
              10 VETK-DTSCA PIC 9(5).
              10 VETK-PRG   PIC 9(5).
      **** rel 4.0-2
      *    05 VET-SCAS OCCURS 24.
           05 VET-SCAS OCCURS 192.
      ************
              10 VET-DTSCA   PIC X(8).
      **** rel 4.0
      *       10 VET-IMRATA  PIC S9(11).
              10 VET-IMRATA  PIC S9(11)V99.
      ************
              10 VET-VALRAT  PIC S9(11)V99.
              10 VET-SALDO   PIC X.
      **** rel 4.0
      *       10 VET-PAGRATA PIC S9(11).
              10 VET-PAGRATA PIC S9(11)V99.
      ************
              10 VET-VPAGRAT PIC S9(11)V99.
      * comodi di salvataggio dati IVA e C/P per ripristino
      * valori precedenti alla errata variazione degli stessi
      * n.b.: lunghezze identiche a IF-AREA-IVA e IF-AREA-CPAR.
      **** rel 4.0
      *01  SAV-AREA-IVA  PIC X(390).
       01  SAV-AREA-IVA  PIC X(432).
      ************
      **** rel 3.0b
      *01  SAV-AREA-CPAR PIC X(525).
      **** rel 4.0
      *01  SAV-AREA-CPAR PIC X(532).
      **** rel 6.2
      *01  SAV-AREA-CPAR PIC X(553).
       01  SAV-AREA-CPAR PIC X(1185).
      ************
      ************
      ************
      **** rel 2.0
      * vettore allineato all'area IF-LEG-BUFF
       01  VET-LEGAMI OCCURS 30.
           05 VETL-ASTE   PIC X.
           05 VETL-CAUS   PIC 999.
           05 VETL-CAUSD  PIC X(24).
           05 VETL-CONTO  PIC 9(7).
           05 VETL-DCONTO PIC X(20).
           05 VETL-CPART  PIC 9(7).
           05 VETL-DCPART PIC X(20).
           05 VETL-CONDAR PIC 9(7).
           05 VETL-CONAVE PIC 9(7).
      ************
      *
      *-------------------------------------------------------------
       01  CONTATORI.
      *    05 KBUF     PIC 999   VALUE 800.
      **** rel 2.0
      *    05 KNUM     PIC 999   VALUE 30.
           05 KNUM     PIC 999   VALUE 25.
      ************
           05 KULT     PIC 999.
           05 KBLO     PIC 999.
           05 KTOT     PIC 999.
           05 BUF-ST   PIC 9.
              88 BUF-PIENO VALUE 1.
      *    kbuf = limite massimo di righe da visualizzazione
      *           (la visualizzazione si interrompe quando il n. di
      *            righe visualizzate ha superato kbuf; il buffer
      *            corrente viene comunque sempre completato)
      *    knum = n. righe da caricare nel buffer
      *           mantenere < 100 se servono piu' righe video per record
      **** rel 2.0
      *           mantenere < del n. elementi vettore IF-BUFF
      *                       (almeno n. elementi IF-BUFF - 3)
      ************
      *    kult = n. ultima riga caricata nel buffer
      *    kblo = n. di riga ultimo blocco logico completo caricato
      *    ktot = n. totale righe caricate da inizio visualizzazione
      *-------------------------------------------------------------
      **** rel 6.3
       01 PARPRT.
          05 PPRT-AZI    PIC 9(3).
          05 PPRT-FL     PIC 9.
          05 PPRT-CON    PIC 9(7).
          05 PPRT-NREG   PIC 9(5).
          05 PPRT-UPRT   PIC 9(5).
          05 PPRT-DTUPR  PIC 9(5).
          05 PPRT-DTINS  PIC 9(5).
          05 PPRT-BUCPRT PIC 9(5).
          05 PPRT-BUCDT  PIC 9(5).
          05 PPRT-ST     PIC 9.
      **********
      **** rel 6.2
       01 PARDNS.
          05 DNS-AZI   PIC 9(3).
          05 DNS-TIPO  PIC 9.
          05 DNS-DTSCA PIC 9(5) COMP-3.
          05 DNS-PRG   PIC 9(5) COMP-3.
      ************
       LINKAGE SECTION.
           COPY 'parcon'.
           COPY 'parcon1'.
      *
       01  IF-AREA-SCA-CARICO.
           05 IF-SCA OCCURS 12.
              10 IF-SC-TPAG    PIC 9.
      * data
              10 IF-SC-DTSCA   PIC 9(6).
      **** rel 4.0
      *       10 IF-SC-IMRATA  PIC S9(11).
              10 IF-SC-IMRATA  PIC S9(11)V99.
      ************
              10 IF-SC-VALRAT  PIC S9(11)V99.
      **** rel 6.2
              10 IF-SC-NOTE    PIC XX.
              10 IF-SC-NOTEA   PIC X(30).
      ************
       01  IF-BUFF.
           05 IF-RIGA OCCURS 30.
              10 IF-RIG    PIC X(73).
              10 IF-EOR    PIC X.
      **** rel 2.0
       01  IF-LEG-BUFF.
           05 IF-RIGA-L OCCURS 30.
              10 IF-RIG-L PIC X(88).
              10 IF-EOR-L PIC X.
      ************
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-AREA-IVA
                                IF-AREA-CPAR
                                IF-AREA-SCA-CARICO
                                IF-BUFF
      **** rel 2.0
                                IF-LEG-BUFF
      ************
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
      **** rel 2.0
           COPY 'dclpra'.
      ************
           COPY 'dclcon'.
      **** rel 5.0-2
           COPY 'dclaco'.
      **************
           COPY 'dclclf'.
           COPY 'dcllgc'.
           COPY 'dclfts'.
           COPY 'dclcam'.
           COPY 'dclpar'.
           COPY 'dclsca'.
      **** rel 5.0
           COPY 'dcldsc'.
      ************
      **** rel 1.2
      *    COPY 'dclcgg'.
      ************
           COPY 'dclban'.
           COPY 'dcltab'.
           COPY 'dclcdc'.
           COPY 'dcltrt'.
           COPY 'dcl112'.
           COPY 'dcl114'.
           COPY 'dcl185'.
           COPY 'dcl400'.
           COPY 'dcl135'.
           COPY 'dcllav'.
           COPY 'dclla1'.
           COPY 'dclla2'.
           COPY 'dclla3'.
           COPY 'dclla4'.
      *
           COPY 'gridcl' REPLACING ==(SIGLA)== BY ==LCN==
                                   ==NFILE== BY ==WDSLCN==
                                   =='nfile'== BY =='wdslcn'==.
      *
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I'
              PERFORM INI-CAMPI THRU EX-INI-CAMPI
      **** rel 4.0-2
              IF SW-GENMS = 1
                 GO TO GEN-MESS
              ELSE
      ************
              GO TO FINE.
           IF FUN = 'NM'
              PERFORM AZZ-CAMPI-NRIGO
              PERFORM AZZ-IF-SCA
              PERFORM CANC-WDS112-000 THRU EX-CANC-WDS112-000
              ADD 1 TO IF-PROGR
      **** rel 2.0
              PERFORM ASSEGNA-LEG-POS THRU EX-ASSEGNA-LEG-POS
      ************
              GO TO FINE.
           IF FUN = 'B0' OR 'B1'
      **** rel 3.0
              MOVE IF-DATREG TO ULTDTREG
      ************
              PERFORM AGG-LAV-BUFF THRU EX-AGG-LAV-BUFF
      **** rel 3.0
              MOVE ULTDTREG TO IF-DATREG
      ************
              PERFORM LENGHT-SEZ
      **** rel 6.3
              IF FLGMOV = 1 MOVE 2 TO FLGMOV END-IF
      ************
              GO TO FINE.
           IF FUN = 'RM'
              PERFORM F-RESET-RIGO THRU EX-F-RESET-RIGO
      **** rel 2.0
              MOVE SPACE TO COMDESAG
      ************
      **** rel 4.1a
              MOVE ZERO  TO OLDCAUS
      ************
              GO TO FINE.
           IF FUN = 'DC'
              PERFORM SELEZIONATO
              IF IF-PROGR = 1 AND PRG1-TIPRG NOT = 0
                 MOVE 'Non annullabile' TO MESS
                 GO TO WARNING
              ELSE GO TO FINE.
           IF FUN = 'DM'
              PERFORM CANC-WDS112  THRU EX-CANC-WDS112
              PERFORM AGG-LAV-BUFF THRU EX-AGG-LAV-BUFF
              PERFORM LENGHT-SEZ
      **** rel 3.0
      *       PERFORM ATTR-ULT-PROGR THRU EX-ATTR-ULT-PROGR
      ************
              GO TO FINE.
           IF FUN = 'MM'
              PERFORM F-RESET-RIGO THRU EX-F-RESET-RIGO
              GO TO F-VARIA.
      **** rel 2.0
           IF FUN = 'CL'
              PERFORM CARICA-LEGAMI THRU EX-CARICA-LEGAMI
              GO TO FINE.
           IF FUN = 'SL'
              PERFORM SEL-LEGAMI THRU EX-SEL-LEGAMI
              GO TO FINE.
      ************
           IF FUN = 'V'  OR 'W'
      **** rel 4.1a
                         OR 'w'
      ************
              GO TO F-WALIDA.
           IF FUN = 'DF'
              IF IF-RG-FUN NOT = 'M'
                 PERFORM CALC-DIFCAM THRU EX-CALC-DIFCAM
              END-IF
              GO TO FINE.
           IF FUN = 'WR'
      **** rel 6.3
              IF IF-RG-FUN = 'M'
                 IF FLGMOV NOT = 2
                    MOVE 'Confermare prima il movimento!'  TO MESS
                    GO TO WARNING
                 END-IF
              END-IF
      ************
              PERFORM F-RESET-RIGO THRU EX-F-RESET-RIGO
              GO TO F-VAL-REG.
           IF FUN = 'R'
              PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
              GO TO FINE.
           IF FUN = 'L'
              PERFORM LAV-AUTONOMI THRU EX-LAV-AUTONOMI
      **** rel 6.2
      * serve ad interfaccia per abilitare aggancio ai cespiti
      *       IF AZI-FLAMM NOT = ZERO
              IF FLGAMM NOT = ZERO
      ************
                 MOVE 'AMM-SI' TO IF-CAMPO
              END-IF
      *
              GO TO FINE.
           IF FUN = 'RR'
              CLOSE WDSLCN WDSLAV WDSLA1 WDS112 WDS114 WDS185 WDS400
              GO TO FINE.
           IF FUN = 'DR'
      **** rel 4.0-2
              MOVE 1 TO CTR-131
      ************
      **** rel 5.0
              MOVE 1 TO SCA-131
      ************
      **** rel 6.1
              MOVE 1 TO FAF-131
      ************
      **** rel 7.1
              MOVE 'D' TO FUN-C110
      ************
              PERFORM LANCIA-VUTI131
              GO TO FINE.
           IF FUN = 'E'
              GO TO CHIUDI.
           MOVE 'vcon110: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       F-RESET-RIGO.
         PERFORM AZZ-CAMPI-NRIGO.
         PERFORM AZZ-IF-SCA.
         PERFORM CANC-WDS112-000 THRU EX-CANC-WDS112-000.
         IF IF-PROGR NOT = 1 GO TO END-F-RESET-RIGO.
      * verifica se inserimento o variazione
         MOVE IF-PROGR TO KLV-PROGR.
         READ WDSLAV INVALID
                     PERFORM AZZ-IF-IVA
                     PERFORM AZZ-IF-CPAR
                     GO TO END-F-RESET-RIGO.
         MOVE SAV-AREA-IVA  TO IF-AREA-IVA.
         MOVE SAV-AREA-CPAR TO IF-AREA-CPAR.
       END-F-RESET-RIGO.
         PERFORM ATTR-ULT-PROGR THRU EX-ATTR-ULT-PROGR.
         ADD 1 TO IF-PROGR.
       EX-F-RESET-RIGO.
         EXIT.
      * - - - - - *
       F-VARIA.
           PERFORM SELEZIONATO.
           IF IF-PROGR = 1
              MOVE IF-AREA-IVA  TO SAV-AREA-IVA
              MOVE IF-AREA-CPAR TO SAV-AREA-CPAR.
           MOVE IF-PROGR TO KLV-PROGR.
           READ WDSLAV INVALID
                MOVE 'Errore lettura wdslav' TO MESS
                GO TO ERRIO.
           MOVE RECLAV TO IF-REC-WDS.
           MOVE IF-CDPAG TO OLDCDPAG.
      **** rel 4.1a
           MOVE IF-CAUS  TO OLDCAUS.
      ************
           IF IF-HS-SCA = ZERO GO TO F-VARIA-10.
           MOVE IF-PROGR TO KL1-PROGR.
           READ WDSLA1 INVALID
                PERFORM AZZ-IF-SCA
                GO TO F-VARIA-10.
           MOVE RECLA1 TO IF-AREA-SCA-CARICO.
           MOVE 1 TO FLGDSC.
       F-VARIA-10.
      **** rel 5.0
           IF IF-RG-FUN = 'M'
      **** rel 5.1
              IF FLGDSC = ZERO
      ************
              PERFORM CALC-SCADENZE THRU END-CALC-SCADENZE.
      ************
           IF IF-HS-SCAS = ZERO GO TO F-VARIA-30.
      * cancellazione record provvisorio scarico scadenzario
           PERFORM CANC-WDS112-000 THRU EX-CANC-WDS112-000.
       F-VARIA-20.
           MOVE IF-PROGR TO K112-PROGR.
           READ WDS112 INVALID
                GO TO F-VARIA-30.
      * scrittura su record provvisorio dati scarico scadenzario
           MOVE 000 TO K112-PROGR.
           WRITE RF-112  INVALID
                 MOVE 'Errore scrittura wds112 / var' TO MESS
                 GO TO ERRIO.
       F-VARIA-30.
      *
       END-F-VARIA.
      **** rel 3.0
           MOVE ULTDTREG TO IF-DATREG.
      ************
      **** rel 6.3
           MOVE 1        TO FLGMOV.
      ************
           GO TO FINE.
      * - - - - - *
      * validazione di tutta la registrazione
       F-VAL-REG.
           IF IF-SBILANCIO NOT = ZERO
              MOVE 'Sistemare sbilancio' TO MESS
              GO TO WARNING.
           IF IF-DARE = ZERO AND IF-AVERE = ZERO
      **** rel 2.0
              AND IF-NBYTE = ZERO
      ************
              MOVE 'Registrazione non caricata' TO MESS
              GO TO WARNING.
      **** rel 3.0
           MOVE ULTDTREG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO DTCON-114.
      ************
      **** rel 6.3
      **** rel 7.1 
      * x ora nella fix si  deciso di toglierlo per 
      * verificarlo bene nella prox release effettiva
      *    PERFORM VERIFICA-PRT THRU EX-VERIFICA-PRT.
      *    IF ERRPRT = 2
      *       MOVE PPRT-DTUPR TO AAGGG
      *       MOVE 2          TO TIPOP1
      *       CALL 'rdata' USING PARCDT
      *       MOVE 'Errore sequenza data protocolli' TO F-MES1
      *       MOVE SPACE TO F-MES2
      *       STRING 'Data ultimo prot.:' GBMMBA DELIMITED SIZE
      *              INTO F-MES2
      *       MOVE 2 TO F-NMES
      *       GO TO WARNING.
      *    IF ERRPRT = 1
      *       PERFORM AGGIORNA-PRT THRU EX-AGGIORNA-PRT
      *       MOVE 1 TO F-NMES
      *       STRING 'VARIATO PROTOCOLLO IVA IN: ' COMPRT 
      *              DELIMITED SIZE INTO F-MES1
      *       CALL 'vrmbox' USING PARMB.
      ************
      ************
       END-F-VAL-REG.
           GO TO FINE.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
      **** rel 2.0
           CLOSE PROAZI.
      ************
           CLOSE TABELL.
           CLOSE ANACLF.
           CLOSE ANACON.
      **** rel 5.0-2
      **** rel 5.1
      *    CLOSE APPCON.
      ************
      **************
      **** rel 5.0
           CLOSE ANACFX.
           CLOSE ANACOL.
           CLOSE DETSCA.
      ************
           CLOSE LEGCAU.
           CLOSE ANASCA.
      **** rel 6.2
           CLOSE NOTSCA.
      ************
           CLOSE PARTIT.
           CLOSE ANABAN.
           CLOSE FATSOS.
           CLOSE CDCOST.
           CLOSE TABRIT.
           CLOSE WDSLCN WDSLAV WDSLA1 WDS112 WDS114 WDS185 WDS400.
           OPEN OUTPUT WDSLCN WDSLAV WDSLA1 WDS112 WDS114 WDS185 WDS400.
           CLOSE WDSLCN WDSLAV WDSLA1 WDS112 WDS114 WDS185 WDS400.
      **** rel 5.1
           CLOSE WDSLA2.
           OPEN OUTPUT WDSLA2.
           CLOSE WDSLA2.
      ************
      **** rel 5.2
           CLOSE WDSLA3.
           IF IF-FL NOT = ZERO
              IF IF-FLAVE = 2 OPEN OUTPUT WDSLA3
                              CLOSE WDSLA3.
      ************
      **** rel 6.1
           CLOSE WDSLA4.
           OPEN OUTPUT WDSLA4.
           CLOSE WDSLA4.
      ************
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
      **** rel 1.2
           COPY 'erreur'.
      ************
           COPY 'griazier'.
      **** rel 2.0
           COPY 'gripraer'.
      ************
           COPY 'griconer'.
      **** rel 5.0-2
           COPY 'griacoer'.
      **************
           COPY 'griclfer'.
      **** rel 5.0
           COPY 'gricoler'.
           COPY 'gricfxer'.
           COPY 'gridscer'.
      ************
           COPY 'grilgcer'.
           COPY 'griftser'.
           COPY 'gricamer'.
           COPY 'griparer'.
           COPY 'griscaer'.
      **** rel 6.2
           COPY 'grinscer'.
      ************
      **** rel 1.2
      *    COPY 'gricgger'.
      ************
           COPY 'gritaber'.
           COPY 'gricdcer'.
           COPY 'gritrter'.
           COPY 'gribaner'.
           COPY 'gri135er'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           IF IF-FL = ZERO
              MOVE 'anaazi' TO ID-AZI
              MOVE 'tabell' TO ID-TAB
              MOVE 'anacon' TO ID-CON
      **** rel 5.0-2
              MOVE 'appcon' TO ID-ACO
      **************
              MOVE 'anaclf' TO ID-CLF
              MOVE 'movime' TO ID-MOV
           ELSE
              MOVE 'anazol' TO ID-AZI
              MOVE 'tabold' TO ID-TAB
              MOVE 'anacol' TO ID-CON
      **** rel 5.0-2
              MOVE 'appcol' TO ID-ACO
      **************
              MOVE 'anacfx' TO ID-CLF
              MOVE 'movmol' TO ID-MOV.
      **** rel 6.3
      *    OPEN INPUT TABELL.
           OPEN I-O   TABELL.
      ************
           OPEN INPUT ANACLF.
           OPEN INPUT ANACON.
      **** rel 5.0-2
      **** rel 5.1
      *    OPEN INPUT APPCON.
      ************
      **************
      **** rel 5.0
           OPEN INPUT ANACFX.
           OPEN INPUT ANACOL.
      ************
           OPEN INPUT LEGCAU.
           OPEN INPUT PARTIT.
           OPEN INPUT ANABAN.
           OPEN INPUT CDCOST.
           OPEN INPUT TABRIT.
           OPEN I-O   ANAAZI.
      **** rel 2.0
           OPEN I-O   PROAZI.
      ************
           OPEN I-O   ANASCA.
      **** rel 6.2
           OPEN I-O   NOTSCA.
      ************
           OPEN I-O   FATSOS.
      **** rel 5.0
           OPEN I-O   DETSCA.
      ************
      **** rel 5.2
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO DATSYS.
           MOVE 1 TO TIPOP1.
           MOVE DATSYS TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO DATSYS5.
      ************
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      **** rel 5.2
           IF AZI-FLCON NOT = ZERO
              MOVE 'Registrazione precedente errata' TO MESS
              GO TO ERRIO.
      ************
      **** rel 2.0
           MOVE AZI-ULTDT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DATREG.
      *
           MOVE IF-AZI TO KPR-COD.
           READ PROAZI INVALID PERFORM INVK-PRA
                               GO TO ERRIO.
      ************
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY PERFORM INVK-TAB
                                               GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MCLI.
           MOVE T01-MFOR TO MFOR.
      *
           MOVE 20 TO KTB-TIP.
           MOVE 1  TO KTB-COD.
           READ TABELL INTO RKTB20 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB20.
      *
           MOVE 14 TO KTB-TIP.
           MOVE 5  TO KTB-COD.
           READ TABELL INTO REKTE14 INVALID MOVE ZERO TO REKTE14.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTE14.

      **** rel 5.2
           MOVE 14 TO KTB-TIP.
           MOVE 10 TO KTB-COD.
           READ TABELL INTO RKTB14L INVALID
                        MOVE ZERO TO RKTB14L
                        T14-CFTEM1 T14-CFTEM2 T14-CFTEM3
                        T14-CNAEM1 T14-CNAEM2 T14-CNAEM3
                        T14-CFTRC1 T14-CFTRC2 T14-CFTRC3
                        T14-CNARC1 T14-CNARC2 T14-CNARC3
                        T14-CAUFEM T14-CAUFRC.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB14L.
           MOVE T14-CFTEM1    TO CP-FTEM(1).
           MOVE T14-CFTEM2    TO CP-FTEM(2).
           MOVE T14-CFTEM3    TO CP-FTEM(3).
           MOVE T14-CNAEM1    TO CP-NAEM(1).
           MOVE T14-CNAEM2    TO CP-NAEM(2).
           MOVE T14-CNAEM3    TO CP-NAEM(3).
           MOVE T14-CFTRC1    TO CP-FTRC(1).
           MOVE T14-CFTRC2    TO CP-FTRC(2).
           MOVE T14-CFTRC3    TO CP-FTRC(3).
           MOVE T14-CNARC1    TO CP-NARC(1).
           MOVE T14-CNARC2    TO CP-NARC(2).
           MOVE T14-CNARC3    TO CP-NARC(3).
           MOVE T14-CAUFEM    TO CAU-FTEM.
           MOVE T14-CAUFRC    TO CAU-FTRC.
      ************

      **** rel 4.0
           CALL 'rveur' USING COMEURO.
      ************
      *
      **** rel 3.0
           MOVE ZERO TO ULTDTREG.
      *
      ************
      **** rel 6.1
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
              PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-CIVAQ TO CIVACQ.
      ************
      **** rel 6.3
           MOVE ZERO      TO FLGMOV.
      ************
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
      **** rel 4.0-2
           MOVE ZERO TO SW-GENMS.
      ************
           OPEN OUTPUT WDSLCN WDSLAV WDSLA1 WDS112 WDS114 WDS185 WDS400.
           CLOSE WDSLCN WDSLAV WDSLA1 WDS112 WDS114 WDS185 WDS400.
           OPEN I-O WDSLCN.
           OPEN I-O WDSLAV.
           OPEN I-O WDSLA1.
           OPEN I-O WDS112.
           OPEN I-O WDS114.
           OPEN I-O WDS185.
           OPEN I-O WDS400.
      **** rel 5.1
           OPEN OUTPUT WDSLA2.
           CLOSE WDSLA2.
           OPEN I-O WDSLA2.
      ************
      **** rel 5.2
           IF IF-FL = ZERO MOVE ZERO TO IF-FLAVE
                           OPEN OUTPUT WDSLA3
                           CLOSE WDSLA3.
           OPEN I-O WDSLA3.
      ************
      **** rel 6.1
           OPEN OUTPUT WDSLA4.
           CLOSE WDSLA4.
           OPEN I-O WDSLA4.
      ************
      *
      **** rel 2.0
           MOVE IF-DATREG TO SAVDATREG.
      *
      ************
      **** rel 3.0
           MOVE ZERO TO IF-NBYTE.
      ************
      **** rel 5.0
           MOVE ZERO TO IF-AGIVA.
      ************
      **** rel 5.2
           MOVE ZERO TO IF-FLGPL.
      ************
           MOVE ZERO  TO IF-REC.
           MOVE ZERO  TO IF-SALD
      **** rel 5.0
                         IF-FLRIPO
                         IF-SCA-PRG
      ************
                         IF-IMPOR
                         IF-IMVAL
                         IF-SALD2
                         IF-PAR-SALDO
                         IF-PAR-VSALD
                         IF-DIFCAM
                         IF-DIFVAL
                         IF-SBILANCIO
                         IF-DARE
                         IF-AVERE
                         IF-DIFDOC
                         IF-TOTIMPON
                         IF-TOTIMPOS
                         IF-DIFIMPON
                         IF-TOTIMPOR
                         IF-DIFDOCV
                         IF-TOTIMPONV
                         IF-TOTSCA
                         IF-DIFSCA
                         IF-TOTSCAV
                         IF-DIFSCAV
                         IF-AUV-ANNO.
           MOVE SPACE TO IF-CAUS-D
                         IF-DESAG
                         IF-PART-D
                         IF-CLIFOR-D
                         IF-CCOST
                         IF-CATT
                         IF-D-A
                         IF-SEGNI
                         IF-VALUT-D
                         IF-CPART-D
                         IF-DESAG2
                         IF-CCOST2
                         IF-AZI-D
                         IF-DESPAG
                         IF-DESBAN
                         IF-ACEE-T02-D-A
                         IF-ACEE-CAUS-D
                         IF-ACEE-CATTA
      **** rel 2.0
                         IF-LEG-CAUS-D
      ************
                         IF-ACEE-CATTV.
      *
           PERFORM AZZ-IF-IVA.
           PERFORM AZZ-IF-CPAR.
           PERFORM AZZ-IF-SCA.
      *
      **** rel 5.1
           PERFORM AZZ-VET-SCA THRU EX-AZZ-VET-SCA.
           PERFORM AZZ-VET-DSC THRU EX-AZZ-VET-DSC.
           MOVE ZERO TO CONT FLGSCA FLGDSC.
      ************
      **** rel 6.2
           MOVE ZERO TO FLGAMM.
      ************

           MOVE AZRGSOC TO IF-AZI-D.
      **** rel 2.0
      *    MOVE AZI-ULTDT TO AAGGG
      *                      DTCON-114.
      *    MOVE 2 TO TIPOP1.
      *    CALL 'rdata' USING PARCDT.
      *    MOVE GGMMAA TO IF-DATREG.
      **** rel 3.0
      *    MOVE SAVDATREG TO IF-DATREG GGMMAA.
      *    MOVE 1 TO TIPOP1.
      *    CALL 'rdata' USING PARCDT.
      *    MOVE AAGGG TO DTCON-114.
           MOVE SAVDATREG TO IF-DATREG.
      ************
      ************
      *
           MOVE 1 TO IF-PROGR.
      *
           MOVE ZERO TO IF-HS-VALUT
                        IF-HS-ATTRN
                        IF-HS-FLGEC
                        IF-HS-FLGSC
                        IF-HS-FLTIG
                        IF-HS-FL1SCAD
                        IF-HS-CPART
                        IF-HS-SCA
                        IF-HS-SCAS
                        IF-HS-CONTDIF
      **** rel 5.0
                        IF-HS-ACEEV
      ************
                        IF-HS-ACEE.
      **** rel 4.0
           MOVE 1 TO IF-HS-EURO.
      ************
           MOVE 1 TO IF-HS-TIPRG.
           MOVE AZI-FLCOS TO IF-HS-FLCOS
                             IF-FLCOSZ
                             IF-FLCOS2Z.
      *
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-DUP TO DTAIVA.
           MOVE 2 TO TIPOP1.
           MOVE DTAIVA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DATIVB.
      **** rel 5.0
           MOVE T25-INTRA TO FLINTRA.
      ************
      *
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '1'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           IF T25-PLA = ZERO MOVE ZERO TO T25-TIG T25-DTP
                                          T25-TPL T25-ATT.
           IF T25-PLA = 1 MOVE T25-DTM TO AAGGG
                          MOVE 2 TO TIPOP1
                          CALL 'rdata' USING PARCDT
                          MOVE GBMMBA TO DTMB.
           MOVE T25-TIG TO IF-HS-FLTIG.
           MOVE T25-TPL TO TPL.
           MOVE T25-DTP TO DTP.
           PERFORM CONV-DTP-A6.
      * azzeramento campi impostazioni di base registrazione
           MOVE ZERO TO PRG1-TIPRG
                        PRG1-CAUS
                        PRG1-ATTRN
                        PRG1-FLGIS.
      **** rel 2.0
           MOVE SPACE TO COMDESAG.
      ************
      *
           MOVE ZERO TO COMVALUT.
      *
           MOVE 'I' TO RGFUN.
      **** rel 5.2
           IF IF-FL NOT = ZERO
              IF IF-RG-FUN = 'I' AND IF-FLAVE = 1
                    PERFORM INI-DA-WDSLA3 THRU EX-INI-DA-WDSLA3.
      ************
           IF IF-RG-FUN = 'I' GO TO END-INI-CAMPI.
      * tolte le close di tutti gli altri files
           CLOSE WDSLCN.
           CLOSE WDSLAV.
           CLOSE WDSLA1.
      **** rel 5.1
           CLOSE WDSLA2.
      ************
           CLOSE WDS112.
           CLOSE WDS114.
           CLOSE WDS185.
           CLOSE WDS400.
      **** rel 6.1
           CLOSE WDSLA4.
      ************
           MOVE 'M' TO RGFUN.
      * variazione registrazione
      * lancio vcon350 per precaricare aree per variazione
           CALL 'vcon350' USING IF-CTRL IF-AREA-IVA IF-AREA-CPAR
                                PARLINK-350-PRG1.
           CANCEL 'vcon350'.
           IF ERRIO-ST = 9 GO TO ERRIO.
      * tolte le open di tutti gli altri files
           OPEN I-O WDSLCN.
           OPEN I-O WDSLAV.
           OPEN I-O WDSLA1.
      **** rel 5.1
           OPEN I-O WDSLA2.
      ************
           OPEN I-O WDS112.
           OPEN I-O WDS114.
           OPEN I-O WDS185.
           OPEN I-O WDS400.
      **** rel 6.1
           OPEN I-O WDSLA4.
      ************
      **** rel 4.0-2
      *    IF ERRIO-ST = 4 GO TO GEN-MESS.
           IF ERRIO-ST = 4
              MOVE 1 TO SW-GENMS
              GO TO EX-INI-CAMPI.
      ************
      **** rel 5.0
           IF ERRIO-ST = 7
              MOVE AGIVA-350 TO IF-AGIVA
              MOVE 8 TO ERRIO-ST.
      ************
           MOVE TIPRG-350  TO PRG1-TIPRG.
           MOVE CAUS-350   TO PRG1-CAUS.
           MOVE ATTRN-350  TO PRG1-ATTRN.
           MOVE FLGIS-350  TO PRG1-FLGIS.
      **** rel 3.0
           MOVE 1 TO KLV-PROGR.
           READ WDSLAV INVALID MOVE ZERO TO RECLAV-DATREG.
           MOVE RECLAV-DATREG TO IF-DATREG.
      ************
      **** rel 5.2
           MOVE 1 TO TIPOP1.
           MOVE IF-DATREG TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           PERFORM VERIFICA-FLGPL THRU EX-VERIFICA-FLGPL.
      ************
      **** rel 6.1
           PERFORM AGGIORNA-LA4 THRU EX-AGGIORNA-LA4.
      ************
       END-INI-CAMPI.
      **** rel 4.1a
           MOVE ZERO       TO OLDCAUS.
      ************
      **** rel 5.2
           MOVE ZERO       TO SWCERCA.
      ************
      **** rel 6.3
           MOVE ZERO       TO SAV-CAUS.
           MOVE ZERO       TO SAV-CATT
                              SAV-NPRGI
                              SAV-ONPRGI.
      ************
      *
       EX-INI-CAMPI.
           EXIT.
      *------------------
       AZZ-CAMPI-NRIGO.
      * salvataggio aree di interfaccia
           MOVE IF-DATREG TO CDATREG.
      *
           MOVE ZERO  TO IF-REC-WDS.
           MOVE ZERO  TO IF-SALD
      **** rel 5.0
                         IF-FLRIPO
      ************
                         IF-IMPOR
                         IF-IMVAL
                         IF-SALD2.
           MOVE SPACE TO IF-CAUS-D
                         IF-DESAG
                         IF-PART-D
                         IF-CLIFOR-D
                         IF-CCOST
                         IF-CATT
                         IF-D-A
                         IF-SEGNI
                         IF-VALUT-D
                         IF-CPART-D
                         IF-DESAG2
                         IF-CCOST2
                         IF-DESPAG
                         IF-DESBAN
                         IF-ACEE-CAUS-D
                         IF-ACEE-CATTA
                         IF-ACEE-CATTV.
           MOVE AZI-FLCOS TO IF-HS-FLCOS
                             IF-FLCOSZ
                             IF-FLCOS2Z.
      **** rel 4.1a
           MOVE ZERO TO OLDCAUS.
      ************
      * ripristino aree di interfaccia
           MOVE CDATREG TO IF-DATREG.
      *------------------
       AGG-LAV-BUFF.
           MOVE ZERO TO KULT KBLO.
           IF FUN = 'B1' GO TO AGG-BUF-RIENTRO.
           IF RGFUN = 'M' GO TO AGG-LAV-50.
           MOVE ZERO TO KTOT.
           MOVE ZERO TO IF-SBILANCIO
                        IF-DARE
                        IF-AVERE.
      *
      * aggiornamento files di lavoro
           MOVE ZERO TO IF-HS-SCA
                        IF-HS-SCAS.
      *
           MOVE IF-PROGR TO KLV-PROGR.
           READ WDSLAV INVALID GO TO AGG-LAV-05.
           DELETE WDSLAV INVALID
                  MOVE 'Errore cancellazione wdslav' TO MESS
                  GO TO ERRIO.
       AGG-LAV-05.
           MOVE IF-PROGR TO KL1-PROGR.
           READ WDSLA1 INVALID GO TO AGG-LAV-10.
           DELETE WDSLA1 INVALID
                  MOVE 'Errore cancellazione wdsla1' TO MESS
                  GO TO ERRIO.
       AGG-LAV-10.
           PERFORM CANC-WDS112 THRU EX-CANC-WDS112.
       AGG-LAV-15.
           IF FUN = 'DM' GO TO AGG-LAV-50.
           MOVE ZERO TO K.
       AGG-LAV-20.
           ADD 1 TO K.
           IF K > 12 GO TO AGG-LAV-30.
           IF IF-SC-DTSCA(K) = ZERO GO TO AGG-LAV-20.
      **** rel 5.0
      **** rel 5.1
      *    IF FLGSCA = 2 GO TO AGG-LAV-20.
      ************
      ************
           MOVE IF-PROGR TO KL1-PROGR.
           MOVE IF-AREA-SCA-CARICO TO RECLA1.
           WRITE RF-LA1 INVALID
                 MOVE 'Errore scrittura wdsla1' TO MESS
                 GO TO ERRIO.
           MOVE 1 TO IF-HS-SCA.
       AGG-LAV-30.
      * lettura record provvisorio wds112
           MOVE 000 TO K112-PROGR.
           READ WDS112 INVALID GO TO AGG-LAV-40.
      * scrittura record wds112 per vcon112
           MOVE IF-PROGR TO K112-PROGR.
           WRITE RF-112 INVALID
                 MOVE 'Errore scrittura wds112' TO MESS
                 GO TO ERRIO.
           MOVE 1 TO IF-HS-SCAS.
       AGG-LAV-40.
           MOVE IF-PROGR TO KLV-PROGR.
           MOVE IF-REC-WDS TO RECLAV.
           WRITE RF-LAV INVALID
                 MOVE 'Errore scrittura wdslav' TO MESS
                 GO TO ERRIO.
       AGG-LAV-50.
      * aggiornamento buffers di visualizzazione
           MOVE ZERO TO IF-ALTRBUF.
           MOVE ZERO TO KLV-PROGR.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO END-AGG-LAV-BUFF.
      *
      * label di rientro per visualizzazione pagine successive
       AGG-BUF-RIENTRO.
           MOVE ZERO TO IF-ALTRBUF.
      *
       AGG-BUF-10.
           READ WDSLAV NEXT AT END GO TO END-AGG-LAV-BUFF.
           MOVE KLV-PROGR TO VISPRG
                             IF-PROGR.
           MOVE RECLAV TO IF-REC-WDS.
           IF IF-HS-TIPRG = 1
              MOVE IF-PART   TO VISCON
              MOVE IF-PART-D TO VISDES
           ELSE
              MOVE IF-CLIFOR   TO VISCON
              MOVE IF-CLIFOR-D TO VISDES.
           IF IF-D-A = 'D'
              IF IF-T02-SEGNO = 1
                 COMPUTE VISDAR  = IF-IMPOR * -1
                 COMPUTE IF-DARE = IF-DARE + IF-IMPOR * -1
              ELSE
                 COMPUTE VISDAR  = IF-IMPOR
                 COMPUTE IF-DARE = IF-DARE + IF-IMPOR
              END-IF
           ELSE
              IF IF-T02-SEGNO = 1
                 COMPUTE VISAVE   = IF-IMPOR * -1
                 COMPUTE IF-AVERE = IF-AVERE + IF-IMPOR * -1
              ELSE
                 COMPUTE VISAVE   = IF-IMPOR
                 COMPUTE IF-AVERE = IF-AVERE + IF-IMPOR.
           PERFORM CARICA-BUF.
           IF IF-HS-ATTRN = 1 AND IF-T02-FLGIS NOT = 2
              GO TO AGG-BUF-20.
           IF IF-CPART = ZERO GO TO AGG-BUF-20.
      * dati contropartita
           MOVE KLV-PROGR  TO VISPRG.
           MOVE IF-CPART   TO VISCON.
           MOVE IF-CPART-D TO VISDES.
           IF IF-D-A = 'D'
              IF IF-T02-SEGNO = 1
                 COMPUTE VISAVE   = IF-IMPOR * -1
                 COMPUTE IF-AVERE = IF-AVERE + IF-IMPOR * -1
              ELSE
                 COMPUTE VISAVE   = IF-IMPOR
                 COMPUTE IF-AVERE = IF-AVERE + IF-IMPOR
              END-IF
           ELSE
              IF IF-T02-SEGNO = 1
                 COMPUTE VISDAR  = IF-IMPOR * -1
                 COMPUTE IF-DARE = IF-DARE + IF-IMPOR * -1
              ELSE
                 COMPUTE VISDAR  = IF-IMPOR
                 COMPUTE IF-DARE = IF-DARE + IF-IMPOR.
           PERFORM CARICA-BUF.
           IF IF-T02-FLGIS NOT = 2 GO TO AGG-BUF-50.
      * rigo IVA
       AGG-BUF-20.
           IF IF-HS-ATTRN = ZERO GO TO AGG-BUF-30.
           PERFORM SHIFT-IF-IVA.
           MOVE 'I00' TO VISPRG.
           MOVE 'IVA' TO VISDES.
           MOVE ZERO TO COMIVA.
      **** rel 3.0
           IF IF-RG-FUN = 'M'
              MOVE 1 TO K
              PERFORM UNTIL K > 6
                 PERFORM CALCOLA-IVA-INDED THRU EX-CALCOLA-IVA-INDED
                 ADD 1 TO K
              END-PERFORM.
      ************
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              ADD IF-IV-IMPOS(K) TO COMIVA
              SUBTRACT VIVA-INDEDUC(K) FROM COMIVA
              ADD 1 TO K
           END-PERFORM.
           IF IF-D-A = 'A'
              IF IF-T02-SEGNO = 1
                 COMPUTE VISDAR  = COMIVA * -1
                 COMPUTE IF-DARE = IF-DARE + COMIVA * -1
              ELSE
                 COMPUTE VISDAR  = COMIVA
                 COMPUTE IF-DARE = IF-DARE + COMIVA
              END-IF
           ELSE
              IF IF-T02-SEGNO = 1
                 COMPUTE VISAVE   = COMIVA * -1
                 COMPUTE IF-AVERE = IF-AVERE + COMIVA * -1
              ELSE
                 COMPUTE VISAVE   = COMIVA
                 COMPUTE IF-AVERE = IF-AVERE + COMIVA.
           PERFORM CARICA-BUF.
      *
           IF IF-T02-FLGIS NOT = 2 GO TO AGG-BUF-30.
           MOVE 'I01' TO VISPRG.
           MOVE 'IVA IN SOSPESO' TO VISDES.
           IF IF-D-A = 'D'
              IF IF-T02-SEGNO = 1
                 COMPUTE VISDAR  = COMIVA * -1
                 COMPUTE IF-DARE = IF-DARE + COMIVA * -1
              ELSE
                 COMPUTE VISDAR  = COMIVA
                 COMPUTE IF-DARE = IF-DARE + COMIVA
              END-IF
           ELSE
              IF IF-T02-SEGNO = 1
                 COMPUTE VISAVE   = COMIVA * -1
                 COMPUTE IF-AVERE = IF-AVERE + COMIVA * -1
              ELSE
                 COMPUTE VISAVE   = COMIVA
                 COMPUTE IF-AVERE = IF-AVERE + COMIVA.
           PERFORM CARICA-BUF.
       AGG-BUF-30.
      * rigo C/P
           IF IF-PROGR     > 1 GO TO AGG-BUF-50.
           IF IF-HS-CPART  = 1 GO TO AGG-BUF-50.
           IF IF-T02-FLGIS = 2 GO TO AGG-BUF-50.
           PERFORM SHIFT-IF-CPAR.
           MOVE 1 TO K.
      **** rel 6.2
      *    PERFORM UNTIL K > 7
           PERFORM UNTIL K > 15
      ************
              IF IF-CP-COD(K) NOT = ZERO
                 MOVE SPACE TO VISPRG
                 STRING 'C' K DELIMITED SIZE INTO VISPRG
                 MOVE IF-CP-COD(K)   TO VISCON
                 MOVE IF-CP-DESCR(K) TO VISDES
                 IF IF-D-A = 'A'
                    IF IF-T02-SEGNO = 1
                       COMPUTE VISDAR  = IF-CP-IMPON(K) * -1
                       COMPUTE IF-DARE = IF-DARE + IF-CP-IMPON(K) * -1
                    ELSE
                       COMPUTE VISDAR  = IF-CP-IMPON(K)
                       COMPUTE IF-DARE = IF-DARE + IF-CP-IMPON(K)
                    END-IF
                 ELSE
                    IF IF-T02-SEGNO = 1
                       COMPUTE VISAVE   = IF-CP-IMPON(K) * -1
                       COMPUTE IF-AVERE = IF-AVERE + IF-CP-IMPON(K) * -1
                    ELSE
                       COMPUTE VISAVE   = IF-CP-IMPON(K)
                       COMPUTE IF-AVERE = IF-AVERE + IF-CP-IMPON(K)
                    END-IF
                 END-IF
                 PERFORM CARICA-BUF
              END-IF
              ADD 1 TO K
           END-PERFORM.
           GO TO AGG-BUF-10.
       AGG-BUF-50.
           IF IF-HS-CONTDIF = 1
              MOVE KLV-PROGR TO VISPRG
              IF IF-T02-SEGNO = 1
                 COMPUTE VISIMP = IF-DIFCAM * -1
              ELSE
                 COMPUTE VISIMP = IF-DIFCAM
              END-IF
              MOVE '(' TO VISPAR1
              MOVE ')' TO VISPAR2
              MOVE 'Differenza cambio'  TO VISDES
              PERFORM CARICA-BUF.
           IF IF-HS-ACEE NOT = 1 GO TO AGG-BUF-90.
      * rigo IVA su vendite (mov. acquisti CEE)
           MOVE KLV-PROGR TO VISPRG.
           MOVE 'IVA SU VENDITE' TO VISDES.
           MOVE ZERO TO COMIVA.
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              ADD IF-IV-IMPOS(K) TO COMIVA
              ADD 1 TO K
           END-PERFORM.
           IF IF-ACEE-T02-TIPOP = 1
              IF IF-T02-SEGNO = 1
                 COMPUTE VISAVE   = COMIVA * -1
                 COMPUTE IF-AVERE = IF-AVERE + COMIVA * -1
              ELSE
                 COMPUTE VISAVE   = COMIVA
                 COMPUTE IF-AVERE = IF-AVERE + COMIVA
              END-IF
           ELSE
              IF IF-T02-SEGNO = 1
                 COMPUTE VISDAR  = COMIVA * -1
                 COMPUTE IF-DARE = IF-DARE + COMIVA * -1
              ELSE
                 COMPUTE VISDAR  = COMIVA
                 COMPUTE IF-DARE = IF-DARE + COMIVA.
           PERFORM CARICA-BUF.
      * rigo IVA su acquisti (mov. acquisti CEE)
           MOVE KLV-PROGR TO VISPRG.
           MOVE 'IVA SU ACQUISTI' TO VISDES.
           MOVE ZERO TO COMIVA.
      **** rel 3.0
           IF IF-RG-FUN = 'M'
              MOVE 1 TO K
              PERFORM UNTIL K > 6
                 PERFORM CALCOLA-IVA-INDED THRU EX-CALCOLA-IVA-INDED
                 ADD 1 TO K
              END-PERFORM.
      ************
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              ADD IF-IV-IMPOS(K) TO COMIVA
              SUBTRACT VIVA-INDEDUC(K) FROM COMIVA
              ADD 1 TO K
           END-PERFORM.
           IF IF-ACEE-T02-TIPOP = 1
              IF IF-T02-SEGNO = 1
                 COMPUTE VISDAR  = COMIVA * -1
                 COMPUTE IF-DARE = IF-DARE + COMIVA * -1
              ELSE
                 COMPUTE VISDAR  = COMIVA
                 COMPUTE IF-DARE = IF-DARE + COMIVA
              END-IF
           ELSE
              IF IF-T02-SEGNO = 1
                 COMPUTE VISAVE   = COMIVA * -1
                 COMPUTE IF-AVERE = IF-AVERE + COMIVA * -1
              ELSE
                 COMPUTE VISAVE   = COMIVA
                 COMPUTE IF-AVERE = IF-AVERE + COMIVA.
           PERFORM CARICA-BUF.
      * rigo C/P dell'IVA indeducibile (mov. acquisti CEE)
           IF IF-CP-COD(1) NOT = ZERO
              MOVE KLV-PROGR      TO VISPRG
              MOVE IF-CP-COD(1)   TO VISCON
              MOVE IF-CP-DESCR(1) TO VISDES
              IF IF-ACEE-T02-TIPOP = 1
                 IF IF-T02-SEGNO = 1
                    COMPUTE VISDAR  = IF-CP-IMPON(1) * -1
                    COMPUTE IF-DARE = IF-DARE + IF-CP-IMPON(1) * -1
                 ELSE
                    COMPUTE VISDAR  = IF-CP-IMPON(1)
                    COMPUTE IF-DARE = IF-DARE + IF-CP-IMPON(1)
                 END-IF
              ELSE
                 IF IF-T02-SEGNO = 1
                    COMPUTE VISAVE   = IF-CP-IMPON(1) * -1
                    COMPUTE IF-AVERE = IF-AVERE + IF-CP-IMPON(1) * -1
                 ELSE
                    COMPUTE VISAVE   = IF-CP-IMPON(1)
                    COMPUTE IF-AVERE = IF-AVERE + IF-CP-IMPON(1)
                 END-IF
              END-IF
              PERFORM CARICA-BUF.
      *
       AGG-BUF-90.
           IF BUF-PIENO
              MOVE 1 TO IF-ALTRBUF
              GO TO END-AGG-LAV-BUFF.
           GO TO AGG-BUF-10.
       END-AGG-LAV-BUFF.
           COMPUTE IF-SBILANCIO = IF-DARE - IF-AVERE.
      * per fine scansione setta blocco completato e EOF
           PERFORM CHIUDI-BLOCCO-DATI.
           MOVE 1 TO IF-EOF.
           MOVE 'I' TO RGFUN.
       EX-AGG-LAV-BUFF.
           EXIT.
      *------------------
       CARICA-BUF.
           MOVE ZERO TO BUF-ST.
           ADD 1 TO KULT KTOT.
           MOVE RIGAVIDEO TO IF-RIG(KULT).
           MOVE SPACE TO RIGAVIDEO.
           MOVE LF TO IF-EOR(KULT).
           IF KULT >= KNUM MOVE 1 TO BUF-ST.
      *------------------
       LENGHT-SEZ.
           IF KULT = ZERO
              MOVE ZERO TO LNSEZ
           ELSE
              MOVE 1 TO LNSEZ
              PERFORM UNTIL IF-BUFF(LNSEZ:1) = LF ADD 1 TO LNSEZ.
           IF KBLO = ZERO
              COMPUTE IF-NBYTE = LNSEZ * KULT
           ELSE
              COMPUTE IF-NBYTE = LNSEZ * KBLO.
      *------------------
       CHIUDI-BLOCCO-DATI.
           MOVE KULT TO KBLO.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
           MOVE ZERO TO SWIVA
                        SWCAMGG.
      *
       V-DATREG.
           MOVE 'IF-DATREG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATREG.
           IF IF-DATREG = ZERO PERFORM ERR-ZERO
                               GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATREG TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF AAGGG < AZI-RVDT
              MOVE 'Data minore della chiusura mensile' TO MESS
              GO TO V-ERROR.
           IF AAGGG < AZI-DTAPE
              MOVE 'Data minore della data apertura' TO MESS
              GO TO V-ERROR.
      **** rel 2.0
           IF AAGGG < PRA-DTLIG
              MOVE 'Data minore della data di'  TO F-MES1
              MOVE 'stampa del libro giornale'  TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
      ************
      **** rel 4.0
           CALL 'vrdtbigb' USING DTBIG.
           IF AAGGG <= DTBIG
              MOVE 'Data minore/uguale del Big-bang'  TO F-MES1
              MOVE 1 TO F-NMES
              GO TO V-ERROR.
      ************
      **** rel 5.2
           IF AAGGG > DATSYS5 AND FUN = 'V'
              MOVE 'DATA REGISTRAZIONE > DATA ODIERNA' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB.
      ************
           IF AAGGG NOT > DTAIVA
              MOVE 1 TO AGIVA
           ELSE
              MOVE ZERO TO AGIVA.
           IF T25-PLA > ZERO AND AAGGG NOT > T25-DTM
              MOVE 1 TO FLGPL
           ELSE
              MOVE ZERO TO FLGPL.
      **** rel 3.0
      *    MOVE AAGGG TO DTCON-114.
      ************
      *
           IF AAGGG = AZI-ULTDT GO TO E-DATREG.
      * aggiornamento ultima data contabile su anaazi
           PERFORM RD-AZI-LOCK THRU EX-RD-AZI-LOCK.
           MOVE AAGGG TO AZI-ULTDT.
           REWRITE RF-AZI FROM REKAZI INVALID PERFORM INVK-AZI
                                              GO TO ERRIO.
           UNLOCK ANAAZI.
       E-DATREG.
      *
       V-CAUS.
           MOVE 'IF-CAUS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CAUS.
      **** rel 4.1a
      **** rel 5.0-3
      *    IF IF-CAUS = OLDCAUS GO TO E-CAUS.
           IF OLDCAUS NOT = ZERO
              IF IF-CAUS = OLDCAUS GO TO E-CAUS.
      **************
           MOVE IF-CAUS TO OLDCAUS.
      ************
      **** rel 5.0
           MOVE ZERO TO IF-FLRIPO.
      ************
           IF IF-PROGR = 1
      **** rel 6.3
              MOVE IF-CAUS TO SAV-CAUS
      **********
              MOVE IF-CAUS TO PRG1-CAUS.
           MOVE SPACE TO IF-CAUS-D.
           IF IF-CAUS = ZERO PERFORM ERR-ZERO
                             GO TO V-ERROR.
           MOVE 2       TO KTB-TIP.
           MOVE IF-CAUS TO KTB-COD.
           PERFORM RDTAB1 THRU EX-RDTAB1.
      **** rel 5.0-1
      *    IF SWERR = 1 GO TO V-ERROR.
           IF SWERR = 1
              MOVE ZERO  TO OLDCAUS
              MOVE SPACE TO IF-CAUS-D
              GO TO V-ERROR.
      ************
           IF IF-HS-ATTRN = 1 AND AGIVA = 1
              MOVE SPACE TO MESS
              STRING 'Totali IVA aggiornati al ' DATIVB
                     DELIMITED '  ' INTO MESS
      **** rel 5.0-2
              IF IF-RG-FUN = 'I' MOVE ZERO TO OLDCAUS
              END-IF
      **************
              GO TO V-ERROR.
           IF IF-HS-ATTRN     = 1 AND
              FLGPL           = 1 AND
              IF-HS-TIPRG     = 2 AND
              IF-T02-FLGIS NOT = 1
                 MOVE SPACE TO MESS
                 STRING 'Movimenti plafond aggiornati al ' DTMB
                        DELIMITED '  ' INTO MESS
      **** rel 5.0-2
                 IF IF-RG-FUN = 'I' MOVE ZERO TO OLDCAUS
                 END-IF
      **************
                 GO TO V-ERROR.
      **** rel 2.0
           IF FUN = 'W' GO TO E-CAUS.
      **** rel 4.1a
           IF FUN = 'w' GO TO E-CAUS.
      ************
           IF IF-DESAG = SPACE
              MOVE COMDESAG TO IF-DESAG.
           IF IF-LEG-FLGPB2 = 1 MOVE 1 TO IF-LEG-FLGPB1.
           IF IF-LEG-FLGPB1 = 1 GO TO E-CAUS.
           MOVE IF-CAUS   TO IF-LEG-CAUS.
           MOVE IF-CAUS-D TO IF-LEG-CAUS-D.
           PERFORM CARICA-LEGAMI THRU EX-CARICA-LEGAMI.
           IF IF-LEG-NBYTE > ZERO
              MOVE 1    TO IF-LEG-FLGPB1
              MOVE ZERO TO IF-LEG-FLGPB2
              MOVE 1    TO IF-LEG-FLGDB
              IF IF-HS-ATTRN = 1 AND IF-PROGR = 1
                 MOVE ZERO TO IF-LEG-FLGPB1
                 MOVE 1    TO IF-LEG-FLGPB2.
      ************
       E-CAUS.
      *
       V-ACEE-CAUS.
           MOVE 'IF-ACEE-CAUS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ACEE-CAUS.
           IF IF-HS-ACEE NOT = 1 GO TO E-ACEE-CAUS.
           MOVE SPACE TO IF-ACEE-CAUS-D.
      **** rel 5.0
           IF FUN = 'w' AND IF-ACEE-CAUS = ZERO GO TO E-ACEE-CAUS.
      ************
           IF IF-ACEE-CAUS = ZERO PERFORM ERR-ZERO
                                  GO TO V-ERROR.
           MOVE 2            TO KTB-TIP.
           MOVE IF-ACEE-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO IF-ACEE-CAUS-D.
           IF T02-TIPRG = 3 AND T02-ATTRN = 1 AND
              ((T02-TIPOP = 1 AND T02-D-A = 'A') OR
              (T02-TIPOP = 8 AND T02-D-A = 'D'))
               MOVE T02-TIPRG TO IF-ACEE-T02-TIPRG
               MOVE T02-D-A   TO IF-ACEE-T02-D-A
               MOVE T02-TIPOP TO IF-ACEE-T02-TIPOP
               MOVE T02-SEGNO TO IF-ACEE-T02-SEGNO
               MOVE T02-FLGIS TO IF-ACEE-T02-FLGIS
               MOVE T02-ATTRN TO IF-ACEE-T02-ATTRN
               MOVE T02-FLVEN TO IF-ACEE-T02-FLVEN
               MOVE T02-FLGSC TO IF-ACEE-T02-FLGSC
               MOVE T02-DTSCO TO IF-ACEE-T02-DTSCO
               MOVE T02-FLGEC TO IF-ACEE-T02-FLGEC
               GO TO E-ACEE-CAUS.
           MOVE 'Causale non valida' TO MESS.
           GO TO V-ERROR.
       E-ACEE-CAUS.
      *
       V-LEGAME.
           MOVE 'IF-LEGAME' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-LEGAME.
       E-LEGAME.
      *
      **** rel 6.3
       V-BOLDOG.
           MOVE 'IF-BOLDOG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-BOLDOG.
           IF FUN NOT = 'V' GO TO E-BOLDOG.
           MOVE KAZ-COD       TO KCF-AZI.
           MOVE MFOR          TO MAS.
           MOVE IF-DESAG(1:5) TO CODCF.
           MOVE CODICE        TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID KEY
                MOVE ZERO TO KCF-COD
                PERFORM ERR-CINE
                GO TO E-BOLDOG.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
      *
           MOVE SPACE TO IF-DESAG.
           STRING CODCF '-' CLF-RGS DELIMITED SIZE INTO IF-DESAG.
       E-BOLDOG.
      *

      ************
       V-DESAG.
           MOVE 'IF-DESAG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DESAG.
      **** rel 2.0
           IF FUN = 'V'
              MOVE IF-DESAG TO COMDESAG.
      ************
       E-DESAG.
      *
       V-CLIFOR.
           MOVE 'IF-CLIFOR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CLIFOR.
           IF IF-HS-TIPRG = 1 GO TO E-CLIFOR.
           MOVE SPACE TO IF-CLIFOR-D.
           IF IF-CLIFOR = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           IF IF-HS-TIPRG = 2
              MOVE MCLI TO MAS
           ELSE
              MOVE MFOR TO MAS.
           MOVE IF-CLIFOR TO CODCF.
           MOVE CODICE TO KCF-COD.
           PERFORM RDCLF THRU EX-RDCLF.
           IF KCF-COD = ZERO GO TO V-ERROR.
           MOVE COMODO TO IF-SALD.
           IF IF-T02-FLGIS > ZERO AND CLF-FLGIS = ZERO
              MOVE 'Causale non valida' TO MESS
              GO TO V-ERROR.
           IF IF-HS-ACEE = 1 AND IF-PROGR > 1
              MOVE ZERO TO IF-HS-ACEE
              MOVE 'Il  movimento  IVA  acquisti  CEE'  TO F-MES1
              MOVE 'e'' gestibile solo come primo rigo' TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
      **** rel 5.0
           IF FUN = 'V'
      ************
      **** rel 2.0
           IF IF-HS-TIPRG = 3
      **** rel 4.1a
      *       IF T02-TIPOP = 1 OR 2
      *          IF IF-CP-COD(1) = ZERO
              IF IF-T02-TIPOP = 1 OR 2
                 IF IF-CP-COD(1) = ZERO OR KCF-COD NOT = SAVCLF
                    IF CLF-CPART NOT = ZERO
      ************
                    MOVE CLF-CPART TO IF-CP-COD(1)
                    MOVE KAZ-COD      TO KPC-AZI
                    MOVE IF-CP-COD(1) TO KPC-COD
                    READ ANACON INTO REKCON INVALID
                       MOVE ALL '*' TO CON-DESCR
                    END-READ
                    IF SF-CON = '9D' OR '9A' OR '35'
                       MOVE RF-CON TO REKCON
                    END-IF
      **** rel 4.1a
                    MOVE KCF-COD TO SAVCLF
      ************
                    MOVE CON-DESCR TO IF-CP-DESCR(1).
      ************
      **** rel 4.1a
           IF FUN = 'V'
              IF IF-HS-TIPRG = 3
                 IF IF-T02-TIPOP = 8
                    IF CLF-CPART NOT = ZERO
                       IF IF-HS-ATTRN = 1 AND IF-T02-FLGIS NOT = 2
                          MOVE CLF-CPART TO IF-CP-COD(1)
                          MOVE KAZ-COD      TO KPC-AZI
                          MOVE IF-CP-COD(1) TO KPC-COD
                          READ ANACON INTO REKCON INVALID
                             MOVE ALL '*' TO CON-DESCR
                          END-READ
                          IF SF-CON = '9D' OR '9A' OR '35'
                             MOVE RF-CON TO REKCON
                          END-IF
                          MOVE CON-DESCR TO IF-CP-DESCR(1)
                       ELSE
                          MOVE CLF-CPART TO IF-CPART KPC-COD
                          PERFORM RDCON THRU EX-RDCON
                          MOVE CON-DESCR TO IF-CPART-D.
      ************
      **** rel 5.0
           IF FUN = 'V'
              IF IF-HS-TIPRG     = 3       AND
                 IF-HS-ATTRN     = ZERO    AND
                 CLF-13IVA       = 4       AND
                 IF-HS-ACEE      = 1       AND
                 (IF-T02-TIPOP   = 1 OR 8) AND
                 (CLF-CPART NOT  = ZERO)
                    MOVE CLF-CPART TO IF-CPART
                    MOVE KAZ-COD   TO KPC-AZI
                    MOVE IF-CPART  TO KPC-COD
                    READ ANACON INTO REKCON INVALID
                       MOVE ALL '*' TO CON-DESCR
                    END-READ
                    IF SF-CON = '9D' OR '9A' OR '35'
                       MOVE RF-CON TO REKCON
                    END-IF
                    MOVE CON-DESCR TO IF-CPART-D.
      ************
       E-CLIFOR.
      *
       V-PART.
           MOVE 'IF-PART' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PART.
           IF IF-HS-TIPRG NOT = 1 GO TO E-PART.
           MOVE SPACE TO IF-PART-D.
           IF IF-PART = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE IF-PART TO KPC-COD.
           PERFORM RDCON THRU EX-RDCON.
           IF KPC-COD = ZERO GO TO V-ERROR.
      *
           MOVE ZERO TO IF-FLCOSZ.
           IF CON-TIPO NOT = 'E'
              MOVE ZERO  TO IF-FLCOSZ
              MOVE SPACE TO IF-CCOST
           ELSE
              IF CON-TRIP = ZERO
                 MOVE 2 TO IF-FLCOSZ
      **** rel 5.0-2
      **** rel 5.1
      *          IF ACO-CDC NOT = SPACE MOVE ACO-CDC TO IF-CCOST
                 IF ACO-CDC NOT = SPACE
                    IF FUN = 'V' MOVE ACO-CDC TO IF-CCOST
                    END-IF
      ************
                 END-IF
      **************
              ELSE
                 MOVE 3        TO IF-FLCOSZ
                 IF FUN = 'V'
                    MOVE CON-TTIP TO IF-CCOST.
      *
           MOVE CON-DESCR  TO IF-PART-D.
           MOVE COMODO TO IF-SALD.
           IF IF-HS-VALUT = ZERO
              MOVE ZERO  TO IF-VALUT
                            IF-CAMGG
                            IF-IMVAL
      **** rel 4.0
              MOVE 1     TO IF-HS-EURO
      ************
              MOVE SPACE TO IF-VALUT-D.
       E-PART.
      *
      **** rel 5.0
       V-FLRIPO.
           MOVE 'IF-FLRIPO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLRIPO.
           IF IF-HS-TIPRG = 1
              PERFORM CALC-SALDAP-GEN THRU END-CALC-SALDAP-GEN
           ELSE
              PERFORM CALC-SALDAP-CLFO THRU END-CALC-SALDAP-CLFO.
       E-FLRIPO.
      *
      ************
       V-CCOST.
           MOVE 'IF-CCOST' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CCOST.
           IF IF-HS-ACEE = 1 GO TO E-CCOST.
           IF AZI-FLCOS = ZERO GO TO E-CCOST.
           IF IF-CCOST = '0' MOVE SPACE TO IF-CCOST.
           IF IF-CCOST NOT = SPACE
              MOVE IF-PART TO KPC-COD
              PERFORM LEGG-TIPO-CONTO
              IF CON-TIPO NOT = 'E'
                 MOVE SPACE TO IF-CCOST
                 MOVE 'Conto non economico'      TO F-MES1
                 MOVE 'Azzerato centro di costo' TO F-MES2
                 MOVE 2 TO F-NMES
                 GO TO V-ERROR.
           IF CON-TRIP = ZERO
              MOVE IF-CCOST TO CODCEN
              CALL 'rcart4' USING CODCEN
              MOVE CODCEN TO IF-CCOST
           ELSE
              MOVE SPACE TO IF-FILL.
           IF IF-CCOST = SPACE GO TO E-CCOST.
           IF CON-TRIP = ZERO  GO TO LEGCDC.
           MOVE IF-AZI   TO KTRT-AZI.
           MOVE IF-CCOST TO KTRT-COD.
           READ TABRIT INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           GO TO NOCDC.
       LEGCDC.
           MOVE IF-AZI   TO KCD-AZI.
           MOVE IF-CCOST TO KCD-COD.
           READ CDCOST INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF CDC-STATO = ZERO
              MOVE 'Centro di costo non attivo' TO MESS
              GO TO V-ERROR.
       NOCDC.
           MOVE IF-AZI   TO COS-AZI.
           MOVE IF-CCOST TO COS-CCO.
           CALL 'vrccos' USING PARCOS.
           IF COS-ST > ZERO
              MOVE 'Errore centro di costo' TO MESS
              GO TO V-ERROR.
       E-CCOST.
      *
       V-CATT.
           MOVE 'IF-CATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CATT.
           IF IF-RG-FUN = 'M' GO TO V-CATT-10.
       V-CATT-10.
           MOVE T25-TIG TO IF-HS-FLTIG.
           MOVE T25-DTP TO DTP.
           PERFORM CONV-DTP-A6.
           MOVE T25-TPL TO TPL.
      **** rel 7.1
      *    IF IF-HS-ATTRN = ZERO MOVE SPACE TO IF-CATT
           IF IF-HS-ATTRN = ZERO
      ************
                                 GO TO E-CATT.
           IF IF-CATT = SPACE MOVE '0' TO IF-CATT.
      **** rel 6.3
           IF IF-PROGR = 1 MOVE IF-CATT TO SAV-CATT.
      **********
           IF IF-CATT = '0' GO TO V-CATT-30.
           MOVE 35      TO T35-TIP.
           MOVE KAZ-COD TO T35-CDAZ.
           MOVE IF-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           IF T25-ATT = 1 AND T35-GES = 1 MOVE T35-TIG TO IF-HS-FLTIG
                                          MOVE T35-TPL TO TPL
                                          MOVE T35-DTP TO DTP
                                          PERFORM CONV-DTP-A6.
           IF IF-T02-FLGIS = 2 AND AZI-FLGIS = 2 GO TO E-CATT.
           IF IF-RG-FUN = 'M' GO TO E-CATT.
           IF FUN NOT = 'V'
              IF IF-NPRGI NOT = ZERO GO TO E-CATT.
           MOVE T35-RVNRG TO IF-NPRGI.
           IF T35-NUMFT > T35-RVNRG MOVE T35-NUMFT TO IF-NPRGI.
           IF IF-HS-TIPRG = 3 MOVE T35-RANRG TO IF-NPRGI.
           ADD 1 TO IF-NPRGI.
      **** rel 6.3
           MOVE IF-NPRGI TO SAV-ONPRGI.
      **********
           GO TO E-CATT.
       V-CATT-30.
           IF IF-T02-FLGIS = 2 AND AZI-FLGIS = 2 GO TO E-CATT.
           IF IF-RG-FUN = 'M' GO TO E-CATT.
           IF FUN NOT = 'V'
              IF IF-NPRGI NOT = ZERO GO TO E-CATT.
      **** rel 6.3
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      **********
           MOVE AZI-RVNRG TO IF-NPRGI.
           IF AZI-NUMFT > AZI-RVNRG MOVE AZI-NUMFT TO IF-NPRGI.
           IF IF-HS-TIPRG = 3 MOVE AZI-RANRG TO IF-NPRGI.
           ADD 1 TO IF-NPRGI.
      **** rel 6.3
           MOVE IF-NPRGI TO SAV-ONPRGI.
      **********
       E-CATT.
      *
       V-NPRGI.
           MOVE 'IF-NPRGI' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NPRGI.
      **** rel 5.2
           IF FUN = 'V'
      ************
           IF IF-HS-ATTRN = ZERO MOVE ZERO TO IF-NPRGI
                                  GO TO E-NPRGI.
      **** rel 6.3
           MOVE IF-NPRGI TO SAV-NPRGI.
      **********
           IF IF-T02-FLGIS = 2 GO TO E-NPRGI.
           IF IF-RG-FUN = 'M' GO TO E-NPRGI.
           IF IF-HS-TIPRG NOT = 2 GO TO E-NPRGI.
           IF IF-DOCUM = ZERO
              MOVE IF-NPRGI  TO IF-DOCUM.
           IF IF-DTDOC = ZERO
              MOVE IF-DATREG TO IF-DTDOC.
       E-NPRGI.
      *
       V-ACEE-CATTA.
           MOVE 'IF-ACEE-CATTA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ACEE-CATTA.
           IF IF-HS-ACEE NOT = 1 GO TO E-ACEE-CATTA.
           IF IF-ACEE-CATTA = SPACE MOVE '0' TO IF-ACEE-CATTA.
      **** rel 6.3
           IF IF-PROGR = 1 MOVE IF-ACEE-CATTA TO SAV-CATT.
      **********
           IF FUN NOT = 'V' GO TO E-ACEE-CATTA.
           IF IF-ACEE-CATTA = '0'
              IF IF-RG-FUN = 'M'
                 GO TO E-ACEE-CATTA
              ELSE
              MOVE AZI-RANRG TO IF-ACEE-NPRGIA
              ADD 1 TO IF-ACEE-NPRGIA
              GO TO E-ACEE-CATTA.
           MOVE 35            TO T35-TIP.
           MOVE IF-AZI        TO T35-CDAZ.
           MOVE IF-ACEE-CATTA TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           IF IF-RG-FUN = 'M' GO TO E-ACEE-CATTA.
           MOVE T35-RANRG TO IF-ACEE-NPRGIA.
           ADD 1 TO IF-ACEE-NPRGIA.
       E-ACEE-CATTA.
      *
       V-ACEE-NPRGIA.
           MOVE 'IF-ACEE-NPRGIA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ACEE-NPRGIA.
           IF IF-HS-ACEE NOT = 1 GO TO E-ACEE-NPRGIA.
      **** rel 6.3
           MOVE IF-ACEE-NPRGIA TO SAV-NPRGI.
      **********
       E-ACEE-NPRGIA.
      *
       V-ACEE-CATTV.
           MOVE 'IF-ACEE-CATTV' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ACEE-CATTV.
           IF IF-HS-ACEE NOT = 1 GO TO E-ACEE-CATTV.
           IF IF-ACEE-CATTV = SPACE MOVE '0' TO IF-ACEE-CATTV.
           IF FUN NOT = 'V' GO TO E-ACEE-CATTV.
           IF IF-ACEE-CATTV = '0'
              IF IF-RG-FUN = 'M'
                 GO TO E-ACEE-CATTV
              ELSE
              MOVE AZI-RVNRG TO IF-ACEE-NPRGIV
              IF AZI-NUMFT > IF-ACEE-NPRGIV
                 MOVE AZI-NUMFT TO IF-ACEE-NPRGIV
              END-IF
              ADD 1 TO IF-ACEE-NPRGIV
              GO TO E-ACEE-CATTV.
           MOVE 35            TO T35-TIP.
           MOVE IF-AZI        TO T35-CDAZ.
           MOVE IF-ACEE-CATTV TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           IF IF-RG-FUN = 'M' GO TO E-ACEE-CATTV.
           MOVE T35-RVNRG TO IF-ACEE-NPRGIV.
           IF T35-NUMFT > IF-ACEE-NPRGIV
              MOVE T35-NUMFT TO IF-ACEE-NPRGIV.
           ADD 1 TO IF-ACEE-NPRGIV.
       E-ACEE-CATTV.
      *
       V-ACEE-NPRGIV.
           MOVE 'IF-ACEE-NPRGIV' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ACEE-NPRGIV.
           IF IF-HS-ACEE NOT = 1 GO TO E-ACEE-NPRGIV.
       E-ACEE-NPRGIV.
      *
       V-DOCUM.
           MOVE 'IF-DOCUM' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DOCUM.
           IF IF-HS-ACEE = 1 GO TO V-DOCUM-10.
           IF IF-T02-FLGIS = 2 AND IF-DOCUM = ZERO
              MOVE 'N. fattura in sospeso obbligatorio' TO MESS
              GO TO V-ERROR.
           IF IF-HS-TIPRG = 1 AND IF-DOCUM = ZERO
      **** rel 2.0
      *       MOVE ZERO TO IF-DTDOC
      ************
              GO TO E-DOCUM.
      **** rel 5.0
      *> per pagam. anticipati fornitori senza num. e data documento.
           IF IF-HS-TIPRG  = 3 AND
              IF-T02-TIPOP = 6 AND
              IF-T02-FLGSC = 2 AND
              IF-DOCUM = ZERO  GO TO E-DOCUM.
      ************
           IF IF-T02-FLGEC = ZERO AND IF-DOCUM = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           IF NOT (IF-T02-FLGSC = 1 OR 3) GO TO E-DOCUM.
       V-DOCUM-10.
           IF IF-DOCUM = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-DOCUM.
      *
       V-DTDOC.
           MOVE 'IF-DTDOC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTDOC.
           IF IF-HS-ACEE = 1 GO TO V-DTDOC-10.
           IF IF-HS-TIPRG = 1 AND IF-DOCUM = ZERO
      **** rel 2.0
              AND IF-DTDOC = ZERO
      *       MOVE ZERO TO IF-DTDOC
      ************
              GO TO E-DTDOC.
      **** rel 5.0
      *> per pagam. anticipati fornitori senza num. e data documento.
           IF IF-HS-TIPRG  = 3 AND
              IF-T02-TIPOP = 6 AND
              IF-T02-FLGSC = 2 AND
              IF-DOCUM = ZERO  AND
              IF-DTDOC = ZERO  GO TO E-DTDOC.
      ************
           IF IF-DTDOC = ZERO
              IF IF-T02-FLGIS = 2 OR IF-T02-FLGEC = ZERO
                 PERFORM ERR-ZERO
                 GO TO V-ERROR.
       V-DTDOC-10.
      **** rel 6.2
           MOVE ZERO TO DTREG.
           MOVE IF-DATREG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG     TO DTREG.
      ************
           MOVE IF-DTDOC TO GGMMAA.
           IF (IF-T02-FLGSC = 1 OR 3) OR IF-T02-FLGIS = 1
              MOVE 1 TO TIPOP1
           ELSE
              MOVE 3 TO TIPOP1.
           IF IF-DTDOC = ZERO MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE 1 TO TIPOP1.
      **** rel 6.2
      *    IF SWRET1 NOT = ZERO OR AAGGG > AZI-ULTDT
           IF SWRET1 NOT = ZERO OR AAGGG > DTREG
      ************
              PERFORM ERR-DATA
              GO TO V-ERROR.
      **** rel 6.1
      * controllo fattura acquisto gia' caricata
           IF IF-RG-FUN = 'I' AND
              FUN = 'V' AND
              AAGGG NOT = ZERO AND
              IF-DOCUM NOT = ZERO AND
              IF-CLIFOR NOT = ZERO
                 IF IF-T02-TIPRG = 3 AND (IF-T02-TIPOP = 1 OR 8)
                    MOVE IF-FL TO MFA-FL
                    MOVE IF-AZI TO MFA-AZI
                    MOVE IF-CLIFOR TO MFA-FORN
                    MOVE AAGGG    TO MFA-DTDOC
                    MOVE IF-DOCUM TO MFA-NDOC
                    IF IF-T02-TIPOP = 1
                       MOVE ZERO TO MFA-TIP
                    ELSE
                       MOVE 1 TO MFA-TIP
                    END-IF
                    CALL 'vrcmfa' USING PARMFA
      **** rel 6.3
      *             IF MFA-ST > 1
                    IF MFA-ST > 1 AND NOT = 9
      ************
                       MOVE 'ERRORE PARAMETRI vrcmfa' TO MESS
                       GO TO ERRIO
                    ELSE
      **** rel 6.3
      *                IF MFA-ST = 1
      *                   MOVE 3 TO F-NMES
      *                   MOVE 'ATTENZIONE: Documento gia'' caricato'
      *                        TO F-MES1
      *                   MOVE MFA-NREG TO NREGV
      *                   STRING 'Registrazione: ' NREGV INTO F-MES2
      *                   MOVE MFA-PRIVA TO NPRIVV
      *                   STRING 'Protocollo IVA: ' NPRIVV INTO F-MES3
      *                   GO TO V-ERROR.
      **** rel 7.1
      *                IF MFA-ST NOT = ZERO
      *                   MOVE 'Documento gia'' caricato' TO MB-TITOLO
      *                   MOVE SPACE TO F-MES1
      *                   MOVE MFA-NREG TO NREGV
      *                   STRING 'Registrazione: ' NREGV INTO F-MES2
      *                   MOVE MFA-PRIVA TO NPRIVV
      *                   STRING 'Protocollo IVA: ' NPRIVV INTO F-MES3
      *                   IF MFA-ST = 9
      *                     MOVE 3 TO F-NMES
      *                     MOVE 'Documento gia'' caricato' TO MB-TITOLO
      *                     MOVE '--> DATA DIVERSA <--' TO F-MES1
      *                     MOVE MFA-NREG TO NREGV
      *                     STRING 'Registrazione: ' NREGV INTO F-MES2
      *                     MOVE MFA-PRIVA TO NPRIVV
      *                     STRING 'Protocollo IVA: ' NPRIVV INTO F-MES3
      *                     MOVE 'Continua?' TO F-MES4
      *                     MOVE 4 TO F-NMES
      *                     MOVE 'Q' TO MB-TIPO
      *                     MOVE 2 TO MB-DEFAULT
      *                     CALL 'vrmbox' USING PARMB
      *                     IF MB-RISP = 'S'
      *                        MOVE ZERO TO MFA-ST
      *                     ELSE
      *                        MOVE 1 TO F-NMES
      *                        MOVE 'Dato non valido' TO F-MES1
      *                        GO TO V-ERROR.
                       IF MFA-ST = 1
      **** rel 7.1
      *                   MOVE 3 TO F-NMES
      *                   MOVE 'ATTENZIONE: Documento gia'' caricato'
      *                   TO F-MES1
      *                   MOVE MFA-NREG TO NREGV
      *                   STRING 'Registrazione: ' NREGV INTO F-MES2
      *                   MOVE MFA-PRIVA TO NPRIVV
      *                   STRING 'Protocollo IVA: ' NPRIVV INTO F-MES3
      *                   GO TO V-ERROR
                          MOVE 3 TO F-NMES
                          MOVE 'ATTENZIONE!' TO MB-TITOLO
                          MOVE 'Stesso documento e stessa data'
                               TO F-MES1
                          MOVE MFA-NREG TO NREGV
                          STRING 'Registrazione: ' NREGV INTO F-MES2
                          MOVE MFA-PRIVA TO NPRIVV
                          STRING 'Protocollo IVA: ' NPRIVV INTO F-MES3
                          MOVE 'Continua?' TO F-MES4
                          MOVE 4 TO F-NMES
                          MOVE 'Q' TO MB-TIPO
                          MOVE 2 TO MB-DEFAULT
                          CALL 'vrmbox' USING PARMB
                          IF MB-RISP = 'S'
                             MOVE ZERO TO MFA-ST
                          ELSE
                             MOVE 1 TO F-NMES
                             MOVE 'Dato non valido' TO F-MES1
                             GO TO V-ERROR
                          END-IF
      ************
                       END-IF
                       IF MFA-ST = 9
                          MOVE 3 TO F-NMES
      **** rel 7.1
      *                   MOVE 'Documento gia'' caricato' TO MB-TITOLO
      *                   MOVE '--> DATA DIVERSA <--' TO F-MES1
                          MOVE 'ATTENZIONE!' TO MB-TITOLO
                          MOVE 'Stesso documento con data diversa.'
                               TO F-MES1
      ************
                          MOVE MFA-NREG TO NREGV
                          STRING 'Registrazione: ' NREGV INTO F-MES2
                          MOVE MFA-PRIVA TO NPRIVV
                          STRING 'Protocollo IVA: ' NPRIVV INTO F-MES3
                          MOVE 'Continua?' TO F-MES4
                          MOVE 4 TO F-NMES
                          MOVE 'Q' TO MB-TIPO
                          MOVE 2 TO MB-DEFAULT
                          CALL 'vrmbox' USING PARMB
                          IF MB-RISP = 'S'
                             MOVE ZERO TO MFA-ST
                          ELSE
                             MOVE 1 TO F-NMES
                             MOVE 'Dato non valido' TO F-MES1
                             GO TO V-ERROR.
      ************
      ************
      ************
      **** rel 3.0
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DTDOC.
      ************
           IF IF-HS-ACEE = 1 GO TO E-DTDOC.
           MOVE AA4 TO ANNO.
           MOVE AA4 TO CANN.
      **** rel 4.1a-1
      *    IF FUN NOT = 'W' AND IF-RG-FUN NOT = 'M'
           IF FUN NOT = 'W' AND FUN NOT = 'w' AND IF-RG-FUN NOT = 'M'
      **************
              IF IF-T02-DTSCO = ZERO OR (IF-HS-FLGSC = 1 OR 3 OR 4)
                 PERFORM CERCA-SCA-PAR THRU EX-CERCA-SCA-PAR
                 IF SWCERCA = 1 AND FUN = 'V'
                    GO TO V-WARNING.
           IF IF-HS-TIPRG = 1 OR NOT (IF-T02-FLGSC = 1 OR 3)
              GO TO V-DTDOC-20.
           IF IF-DTDOC = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       V-DTDOC-20.
      * pagamento fattura in sospeso
           IF IF-RG-FUN = 'M' GO TO E-DTDOC.
           IF AZI-FLGIS = ZERO GO TO E-DTDOC.
           IF IF-T02-FLGIS NOT = 2 GO TO E-DTDOC.
           PERFORM FTS-PAG THRU EX-FTS-PAG.
           IF SWERR-FTSP = 1 GO TO V-ERROR.
       E-DTDOC.
      *
       V-DTSCD.
           MOVE 'IF-DTSCD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTSCD.
           IF IF-DTSCD = ZERO AND IF-T02-DTSCO = 1
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTSCD TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 NOT = ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
      **** rel 4.1a-1
      *    IF FUN NOT = 'W' AND IF-RG-FUN NOT = 'M'
           IF FUN NOT = 'W' AND FUN NOT = 'w' AND IF-RG-FUN NOT = 'M'
      **************
              PERFORM CERCA-SCA-PAR THRU EX-CERCA-SCA-PAR
              IF SWCERCA = 1 GO TO V-WARNING.
       E-DTSCD.
      *
       V-IMPOR.
           MOVE 'IF-IMPOR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IMPOR.
      **** rel 2.0
      *    IF IF-HS-ACEE = 1 GO TO E-IMPOR.
      *    IF IF-IMPOR NOT = ZERO
      *       GO TO E-IMPOR.
      *    IF IF-HS-TIPRG = 1 AND CON-CVAL = 1
      *       GO TO E-IMPOR.
      *    IF IF-HS-TIPRG > 1 AND IF-VALUT > ZERO
      *       GO TO E-IMPOR.
      *    PERFORM ERR-ZERO.
      *    GO TO V-ERROR.
      ************
       E-IMPOR.
      *
       V-D-A.
           MOVE 'IF-D-A' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-D-A.
           IF NOT (IF-D-A = 'D' OR 'A')
              MOVE 'Dato non valido' TO F-MES1
              MOVE 'Valori ammessi:' TO F-MES2
              MOVE 'D = Dare       ' TO F-MES3
              MOVE 'A = Avere      ' TO F-MES4
              MOVE 4 TO F-NMES
              GO TO V-ERROR.
       E-D-A.
      *
       V-VALUT.
           MOVE 'IF-VALUT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-VALUT.
           MOVE SPACE TO IF-VALUT-D.
      **** rel 2.0
           IF IF-HS-TIPRG = 1 AND
              IF-HS-VALUT = 1 AND
      **** rel 4.0
      *       (IF-VALUT = ZERO OR 1)
              (IF-VALUT = ZERO OR COMEURO)
      ************
              MOVE 'Divisa non valida' TO MESS
              MOVE ZERO TO IF-CAMGG
                           IF-IMVAL
              GO TO V-ERROR.
      ************
      **** rel 4.0
      *    IF IF-VALUT < 2
           MOVE ZERO TO IF-HS-EURO.
           IF (IF-VALUT = ZERO OR COMEURO)
              MOVE 1  TO IF-HS-EURO
      ************
              MOVE ZERO  TO IF-CAMGG
                            IF-IMVAL
      **** rel 4.0
      *       GO TO V-VALUT-20.
              GO TO V-VALUT-30.
      ************
      **** rel 1.2
      *    MOVE 10       TO KTB-TIP.
      *    MOVE IF-VALUT TO KTB-COD.
      *    READ TABELL INTO REKTAB INVALID
      *         MOVE ALL '*' TO T10-DSINT
      *         MOVE ZERO TO IF-CAMGG.
      *    IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *    MOVE T10-DSINT TO IF-VALUT-D.
           MOVE IF-VALUT TO ER-VALUT.
           MOVE IF-DATREG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO ER-DATA.
           CALL 'rvalut' USING ER-VALUT ER-DATA CG-PAR.
           IF CG-ST > ZERO
              PERFORM ERR-EURO
              GO TO V-ERROR.
           MOVE CG-DSINT TO IF-VALUT-D.
      **** rel 2.0
      *    IF IF-CAMGG = ZERO MOVE CG-CAMBIO TO IF-CAMGG.
           IF IF-CAMGG = ZERO
              IF NOT (IF-HS-TIPRG = 1 AND IF-HS-VALUT = 1)
                 MOVE CG-CAMBIO TO IF-CAMGG.
      ************
      ************
       V-VALUT-20.
      **** rel 4.0
           IF FUN = 'V' AND (CG-TVAL = 3 OR 1)
              MOVE CG-CAMBIO TO IF-CAMGG.
       V-VALUT-30.
      ************
           MOVE IF-VALUT TO COMVALUT.
       E-VALUT.
      *
       V-CAMGG.
           MOVE 'IF-CAMGG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CAMGG.
           IF IF-VALUT NOT = COMVALUT
              MOVE 'Divisa non valida' TO MESS
              MOVE ZERO     TO IF-CAMGG
              MOVE COMVALUT TO IF-VALUT
              GO TO V-ERROR.
      **** rel 4.0
      *    IF IF-VALUT < 2 GO TO E-CAMGG.
           IF (IF-VALUT = ZERO OR COMEURO) GO TO E-CAMGG.
      ************
      **** rel 1.2
           MOVE IF-VALUT TO ER-VALUT.
           MOVE IF-DATREG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO ER-DATA.
           CALL 'rvalut' USING ER-VALUT ER-DATA CG-PAR.
           IF CG-ST > ZERO
              PERFORM ERR-EURO
      **** rel 4.0
      *       GO TO E-CAMGG.
              GO TO V-ERROR.
      ************
      **** rel 2.0
           IF IF-HS-TIPRG = 1 AND IF-HS-VALUT = 1
              IF IF-CAMGG = ZERO AND IF-IMVAL = ZERO
                 GO TO E-CAMGG.
      ************
           IF FUN = 'V'
              IF (CG-TVAL = 3 OR 1) AND IF-CAMGG NOT = CG-CAMBIO
      **** rel 4.0
      *          MOVE CG-ETASSO TO ER-MESTA
      ************
                 MOVE CG-CAMBIO TO ER-MESCA
                 PERFORM ERR-POST
      **** rel 4.0
      *          CALL 'vrmbox' USING PARMB.
                 CALL 'vrmbox' USING PARMB
                 MOVE CG-CAMBIO TO IF-CAMGG.
      ************
           IF IF-CAMGG = ZERO MOVE CG-CAMBIO TO IF-CAMGG.
      ************
           IF IF-CAMGG = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
      **** rel 4.0
           MOVE IF-CAMGG TO EC-CAMBIO.
           CALL 're2cam' USING EC-PAR.
           IF IF-CAMGG NOT = EC-CAMBIO
              PERFORM ERR-CAMB
              GO TO V-ERROR.
      ************
      **** rel 5.2
      *    IF IF-HS-ACEE = 1 GO TO E-CAMGG.
      ************
           IF IF-IMVAL = ZERO
      **** rel 1.2
      **** rel 4.0
      *       MOVE IF-IMPOR TO ER-IMPORTO
      *       MOVE IF-VALUT TO ER-VALUT
      *       MOVE IF-CAMGG TO ER-CAMBIO
      *       MOVE IF-DATREG TO GGMMAA
      *       MOVE 1 TO TIPOP1
      *       CALL 'rdata' USING PARCDT
      *       MOVE AAGGG TO ER-DATA
      *       CALL 'rcamimp' USING ER-IMPORTO LIR-VAL ER-VALUT
      *                            ER-CAMBIO  ER-DATA
      *       MOVE ER-IMPORTO TO IF-IMVAL.
              MOVE IF-IMPOR TO ER-IMPORTO
              MOVE IF-VALUT TO ER-VALUT
              MOVE IF-CAMGG TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO EUR-VAL ER-VALUT
                                  ER-CAMBIO
              MOVE ER-IMPORTO TO IF-IMVAL.
      ************
      *       COMPUTE IF-IMVAL = IF-IMPOR / IF-CAMGG.
      ************
       E-CAMGG.
      *
       V-IMVAL.
           MOVE 'IF-IMVAL' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IMVAL.
      **** rel 1.2
      *    IF IF-IMPOR = ZERO
      *       COMPUTE IF-IMPOR = IF-IMVAL * IF-CAMGG
      *       GO TO E-IMVAL.
      **** rel 4.0
      *    IF IF-VALUT < 2 GO TO E-IMVAL.
           IF (IF-VALUT = ZERO OR COMEURO) GO TO E-IMVAL.
      ************
      **** rel 2.0
           IF IF-HS-TIPRG = 1 AND IF-HS-VALUT = 1
              IF IF-IMVAL = ZERO AND IF-CAMGG = ZERO GO TO E-IMVAL.
      ************
           IF IF-IMPOR = ZERO
      **** rel 4.0
      *       MOVE IF-IMVAL TO ER-IMPORTO
      *       MOVE IF-VALUT TO ER-VALUT
      *       MOVE IF-CAMGG TO ER-CAMBIO
      *       MOVE IF-DATREG TO GGMMAA
      *       MOVE 1 TO TIPOP1
      *       CALL 'rdata' USING PARCDT
      *       MOVE AAGGG TO ER-DATA
      *       CALL 'rcamimp' USING ER-IMPORTO VAL-LIR ER-VALUT
      *                            ER-CAMBIO  ER-DATA
      *       MOVE ER-IMPORTO TO IF-IMPOR.
              MOVE IF-IMVAL TO ER-IMPORTO
              MOVE IF-VALUT TO ER-VALUT
              MOVE IF-CAMGG TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT
                                  ER-CAMBIO
              MOVE ER-IMPORTO TO IF-IMPOR.
      ************
      ************
      **** rel 5.2
      *    IF IF-HS-ACEE = 1 GO TO E-IMVAL.
      ************
      **** rel 1.2
      *    IF IF-IMVAL = ZERO
      *       COMPUTE IF-IMVAL = IF-IMPOR / IF-CAMGG
      *       GO TO E-IMVAL.
           IF IF-IMVAL = ZERO
      **** rel 4.0
      *       MOVE IF-IMPOR TO ER-IMPORTO
      *       MOVE IF-VALUT TO ER-VALUT
      *       MOVE IF-CAMGG TO ER-CAMBIO
      *       MOVE IF-DATREG TO GGMMAA
      *       MOVE 1 TO TIPOP1
      *       CALL 'rdata' USING PARCDT
      *       MOVE AAGGG TO ER-DATA
      *       CALL 'rcamimp' USING ER-IMPORTO LIR-VAL ER-VALUT
      *                            ER-CAMBIO  ER-DATA
      *       MOVE ER-IMPORTO TO IF-IMVAL.
              MOVE IF-IMPOR TO ER-IMPORTO
              MOVE IF-VALUT TO ER-VALUT
              MOVE IF-CAMGG TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO EUR-VAL ER-VALUT
                                  ER-CAMBIO
              MOVE ER-IMPORTO TO IF-IMVAL.
      ************
      ************
      **** rel 4.0
      *    COMPUTE COMCAMGG  = IF-IMPOR / IF-IMVAL.
           COMPUTE EC-CAMBIO  = IF-IMVAL / IF-IMPOR.
           CALL 're2cam' USING EC-PAR.
           MOVE EC-CAMBIO TO COMCAMGG.
      ************
           IF COMCAMGG = IF-CAMGG GO TO E-IMVAL.
           MOVE 1 TO SWCAMGG.
           IF FUN NOT = 'V' GO TO E-IMVAL.
           MOVE COMCAMGG TO COMOCAM.
           STRING 'Cambio calcolato : ' DELIMITED SIZE
                  COMOCAM DELIMITED SIZE INTO MESS.
           MOVE COMCAMGG TO IF-CAMGG.
      **** rel 4.0
           IF (CG-TVAL = 3 OR 1) AND COMCAMGG NOT = CG-CAMBIO
              MOVE CG-CAMBIO TO IF-CAMGG.
      ************
           GO TO V-WARNING.
       E-IMVAL.
      *
       V-CPART.
           MOVE 'IF-CPART' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CPART.
           MOVE SPACE TO IF-CPART-D.
           IF IF-CPART = ZERO
              MOVE SPACE TO IF-CCOST2 IF-DESAG2
              MOVE ZERO  TO IF-FLCOS2Z
              GO TO E-CPART.
      **** rel 2.0
           IF IF-DESAG2 = SPACE AND FUN = 'V'
              MOVE COMDESAG TO IF-DESAG2.
      ************
           MOVE IF-CPART TO KPC-COD.
           PERFORM RDCON THRU EX-RDCON.
           IF KPC-COD = ZERO GO TO V-ERROR.
      *
           MOVE ZERO TO IF-FLCOS2Z.
           IF CON-TIPO NOT = 'E'
              MOVE ZERO  TO IF-FLCOS2Z
              MOVE SPACE TO IF-CCOST2
           ELSE
              IF CON-TRIP = ZERO
                 MOVE 2 TO IF-FLCOS2Z
      **** rel 5.0-2
      **** rel 5.1
      *          IF ACO-CDC NOT = SPACE MOVE ACO-CDC TO IF-CCOST2
                 IF ACO-CDC NOT = SPACE
                    IF FUN = 'V' MOVE ACO-CDC TO IF-CCOST2
                    END-IF
      ************
                 END-IF
      **************
              ELSE
                 MOVE 3        TO IF-FLCOS2Z
                 IF FUN = 'V'
                    MOVE CON-TTIP TO IF-CCOST2.
      *
           MOVE CON-DESCR TO IF-CPART-D.
           MOVE COMODO    TO IF-SALD2.
           IF IF-HS-TIPRG > 1 AND
      **** rel 4.0
      *       IF-VALUT < 2    AND
              (IF-VALUT = ZERO OR COMEURO) AND
      ************
              CON-CVAL = 1
              MOVE 'Indicare un conto non valutario' TO MESS
              GO TO V-ERROR.
       E-CPART.
      *
      **** rel 2.0
       V-DESAG2.
           MOVE 'IF-DESAG2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DESAG2.
           IF FUN = 'V' AND IF-CPART NOT = ZERO
              MOVE IF-DESAG2 TO COMDESAG.
       E-DESAG2.
      *
      ************
       V-CCOST2.
           MOVE 'IF-CCOST2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CCOST2.
           IF IF-HS-ACEE = 1 GO TO E-CCOST2.
           IF AZI-FLCOS = ZERO GO TO E-CCOST2.
           IF IF-CCOST2 = '0' MOVE SPACE TO IF-CCOST2.
           IF IF-CCOST2 NOT = SPACE
              MOVE IF-CPART TO KPC-COD
              PERFORM LEGG-TIPO-CONTO
              IF CON-TIPO NOT = 'E'
                 MOVE SPACE TO IF-CCOST2
                 MOVE 'Conto non economico'      TO F-MES1
                 MOVE 'Azzerato centro di costo' TO F-MES2
                 MOVE 2 TO F-NMES
                 GO TO V-ERROR.
           IF CON-TRIP = ZERO
              MOVE IF-CCOST2 TO CODCEN
              CALL 'rcart4' USING CODCEN
              MOVE CODCEN TO IF-CCOST2
           ELSE
              MOVE SPACE TO IF-FILL2.
           IF IF-CCOST2 = SPACE GO TO E-CCOST2.
           IF CON-TRIP = ZERO  GO TO LEGCDC2.
           MOVE IF-AZI    TO KTRT-AZI.
           MOVE IF-CCOST2 TO KTRT-COD.
           READ TABRIT INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           GO TO NOCDC2.
       LEGCDC2.
           MOVE IF-AZI    TO KCD-AZI.
           MOVE IF-CCOST2 TO KCD-COD.
           READ CDCOST INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF CDC-STATO = ZERO
              MOVE 'Centro di costo non attivo' TO MESS
              GO TO V-ERROR.
       NOCDC2.
           MOVE IF-AZI    TO COS-AZI.
           MOVE IF-CCOST2 TO COS-CCO.
           CALL 'vrccos' USING PARCOS.
           IF COS-ST > ZERO
              MOVE 'Errore centro di costo' TO MESS
              GO TO V-ERROR.
       E-CCOST2.
      *
      **** rel 4.1a
           IF FUN = 'w' GO TO END-V-DATI.
      ************
           IF FUN = 'W'          AND
              IF-HS-ATTRN = ZERO AND
              IF-HS-ACEE  = ZERO GO TO V-DATI-SCA-CAR.
      *
      * dati IVA
      *
       V-IV-COD.
           MOVE 'IF-IV-COD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IV-COD.
           MOVE ZERO TO K.
       V-IV-COD-10.
           ADD 1 TO K.
           IF K > 6 GO TO E-IV-COD.
           IF FUN = 'W'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-IV-COD-10.
           MOVE SPACE TO IF-IV-DESCR(K).
           IF IF-IV-COD(K) = ZERO
              MOVE ZERO  TO IF-ACEE-IV-IMPONV(K)
                            IF-IV-IMPON(K)
                            IF-IV-IMPOS(K)
                            IF-IV-PERPLA(K)
                            VIVA-INDEDUC(K)
              MOVE SPACE TO IF-IV-DESCR(K)
              GO TO V-IV-COD-10.
           MOVE IF-IV-COD(K) TO KTB-COD.
           MOVE 3            TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF IF-HS-ACEE = 1
              MOVE T03-DSIVA TO IF-IV-DESCR(K)
           ELSE
              MOVE TAB-DESCR TO IF-IV-DESCR(K).
           IF IF-HS-TIPRG NOT = 3
              IF T03-TPIVA = 1 OR 7
                 MOVE 'IVA Indeducibile - Tipo IVA non gestito' TO MESS
                 GO TO V-ERROR.
           PERFORM CALC-IMPOR-IVA.
      *
           IF NOT (T03-TPIVA = 3 OR 6) GO TO V-IV-COD-20.
           IF T25-PLA  = ZERO GO TO V-IV-COD-20.
           IF IF-HS-FLTIG = ZERO GO TO V-IV-COD-20.
           IF NOT (IF-IV-COD(K) = T141ACQ OR T141ACR OR T141ACT OR
                                  T142ACQ OR T143ACQ)
                  AND T03-TSPLA = ZERO
              GO TO V-IV-COD-20.
           IF TPL = 2
              IF IF-IV-COD(K) NOT = T142ACQ AND T03-TSPLA NOT = 2
                 GO TO V-IV-COD-20.
           IF TPL = 3
              IF IF-IV-COD(K) NOT = T143ACQ AND T03-TSPLA NOT = 3
                 GO TO V-IV-COD-20.
      **** rel 5.2
      *    IF FLGPL = 1
      *       MOVE SPACE TO F-MES1
      *       STRING 'Movimenti plafond aggiornati al ' DTMB
      *               DELIMITED '  ' INTO F-MES1
      *       MOVE 'Impossibile contabilizzare la fattura' TO F-MES2
      *       MOVE 2 TO F-NMES
      *       GO TO V-ERROR.
      ************
           IF IF-IV-PMES(K) = ZERO
              MOVE IF-DTDOC TO GGMMAA
              MOVE 1 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE MM4 TO IF-IV-PMES(K)
              MOVE AA4 TO IF-IV-PANN(K).
       V-IV-COD-20.
           GO TO V-IV-COD-10.
       E-IV-COD.
      *
       V-ACEE-IV-IMPONV.
           MOVE 'IF-ACEE-IV-IMPONV' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ACEE-IV-IMPONV.
           IF IF-HS-ACEE NOT = 1 GO TO E-ACEE-IV-IMPONV.
           MOVE ZERO TO K.
       V-ACEE-IV-IMPONV-10.
           ADD 1 TO K.
           IF K > 6 GO TO E-ACEE-IV-IMPONV.
           IF FUN = 'W'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-ACEE-IV-IMPONV-10.
           IF IF-ACEE-IV-IMPONV(K) = ZERO
              GO TO V-ACEE-IV-IMPONV-10.
           IF FUN NOT = 'W' AND
              IF-CAMGG NOT = ZERO AND
              IF-ACEE-IV-IMPONV(K) NOT = ZERO AND
              IF-IV-IMPON(K) = ZERO
      **** rel 1.2
      **** rel 4.0
      *       MOVE IF-ACEE-IV-IMPONV(K) TO ER-IMPORTO
      *       MOVE IF-VALUT TO ER-VALUT
      *       MOVE IF-CAMGG TO ER-CAMBIO
      *       MOVE IF-DATREG TO GGMMAA
      *       MOVE 1 TO TIPOP1
      *       CALL 'rdata' USING PARCDT
      *       MOVE AAGGG TO ER-DATA
      *       CALL 'rcamimp' USING ER-IMPORTO VAL-LIR ER-VALUT
      *                            ER-CAMBIO  ER-DATA
      *       MOVE ER-IMPORTO TO IF-IV-IMPON(K).
              MOVE IF-ACEE-IV-IMPONV(K) TO ER-IMPORTO
              MOVE IF-VALUT TO ER-VALUT
              MOVE IF-CAMGG TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT
                                  ER-CAMBIO
              MOVE ER-IMPORTO TO IF-IV-IMPON(K).
      ************
      *       COMPUTE IF-IV-IMPON(K) = IF-ACEE-IV-IMPONV(K) * IF-CAMGG.
      ************
           GO TO V-ACEE-IV-IMPONV-10.
       E-ACEE-IV-IMPONV.
      *
       V-IV-IMPON.
           MOVE 'IF-IV-IMPON' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IV-IMPON.
           MOVE ZERO TO K.
       V-IV-IMPON-10.
           ADD 1 TO K.
           IF K > 6 GO TO E-IV-IMPON.
           IF FUN = 'W'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-IV-IMPON-10.
           IF IF-IV-IMPON(K) = ZERO
              MOVE ZERO TO VIVA-INDEDUC(K)
              IF IF-IV-COD(K) = ZERO
                 MOVE ZERO TO IF-IV-IMPOS(K)
                 GO TO V-IV-IMPON-10.
           MOVE IF-IV-COD(K) TO KTB-COD.
           MOVE 3            TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ZERO TO IF-IV-IMPOS(K)
                GO TO V-IV-IMPON-10.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           PERFORM CALC-IMPOR-IVA.
           GO TO V-IV-IMPON-10.
       E-IV-IMPON.
      *
      **** rel 7.1
       V-IV-IMPOS.
           MOVE 'IF-IV-IMPOS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IV-IMPOS.
           MOVE ZERO TO K.
       V-IV-IMPOS-10.
           ADD 1 TO K.
           IF K > 6 GO TO E-IV-IMPOS.
           IF FUN = 'W'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-IV-IMPOS-10.
           MOVE IF-IV-COD(K) TO KTB-COD.
           MOVE 3            TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ZERO TO IF-IV-IMPOS(K)
                GO TO V-IV-IMPOS-10.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           PERFORM CALC-IMPOR-IVA-IND.
           GO TO V-IV-IMPOS-10.
       E-IV-IMPOS.
      *
      ************
       V-IV-PERPLA.
           MOVE 'IF-IV-PERPLA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IV-PERPLA.
           MOVE ZERO TO K.
       V-IV-PERPLA-10.
           ADD 1 TO K.
           IF K > 6 GO TO E-IV-PERPLA.
           IF FUN = 'W'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-IV-PERPLA-10.
           IF IF-IV-COD(K) = ZERO GO TO V-IV-PERPLA-20.
           MOVE IF-IV-COD(K) TO KTB-COD.
           MOVE 3            TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID GO TO V-IV-PERPLA-15.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF NOT (T03-TPIVA = 3 OR 6) GO TO V-IV-PERPLA-15.
           IF T25-PLA  = ZERO GO TO V-IV-PERPLA-15.
           IF IF-HS-FLTIG = ZERO GO TO V-IV-PERPLA-15.
           IF NOT (IF-IV-COD(K) = T141ACQ OR T141ACR OR T141ACT OR
                                  T142ACQ OR T143ACQ)
                  AND T03-TSPLA = ZERO
              GO TO V-IV-PERPLA-15.
           IF TPL = 2
              IF IF-IV-COD(K) NOT = T142ACQ AND T03-TSPLA NOT = 2
                 GO TO V-IV-PERPLA-15.
           IF TPL = 3
              IF IF-IV-COD(K) NOT = T143ACQ AND T03-TSPLA NOT = 3
                 GO TO V-IV-PERPLA-15.
      *
           IF IF-IV-PERPLA(K) = ZERO GO TO V-IV-PERPLA-20.
           IF IF-IV-PMES(K) < 1 OR > 12 OR IF-IV-PANN(K) = ZERO
              PERFORM ERR-DINV
              GO TO V-ERROR.
           MOVE IF-IV-PMES(K) TO PLFMM.
           MOVE IF-IV-PANN(K) TO PLFAA.
           MOVE IF-DTDOC TO GGMMAA.
           MOVE MM9 TO PERM.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4  TO PERA.
           MOVE PERM TO PERMA.
           MOVE PERA TO PERAA.
      *
           MOVE DTP6 TO PERIO.
           MOVE PERM TO PERMA.
           IF PERM = ZERO GO TO V-IV-PERPLA-20.
           MOVE PERA TO PERAA.
           IF DTCT1 < DTCT2 GO TO V-IV-PERPLA-20.
      **** rel 5.2
           IF IF-FLGPL = 1 OR FLGPL = 1 GO TO V-IV-PERPLA-20.
      ************
           MOVE SPACE TO MESS.
           MOVE DTP6 TO DTPB.
           STRING 'Plafond aggiornato al '
                  DTPB DELIMITED SIZE
                  INTO MESS.
           GO TO V-ERROR.
       V-IV-PERPLA-15.
           IF IF-IV-PERPLA(K) NOT = ZERO
              MOVE 'Il tipo IVA non ammette Plafond' TO MESS
              GO TO V-ERROR.
       V-IV-PERPLA-20.
           GO TO V-IV-PERPLA-10.
       E-IV-PERPLA.
      *
      * dati Contropartite
      *
       V-CP-COD.
           MOVE 'IF-CP-COD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CP-COD.
           MOVE ZERO TO K.
       V-CP-COD-10.
           ADD 1 TO K.
      **** rel 6.2
      *    IF K > 7 GO TO E-CP-COD.
           IF K > 15 GO TO E-CP-COD.
      ************
           IF FUN = 'W'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-CP-COD-10.
           MOVE SPACE TO IF-CP-DESCR(K).
           IF IF-CP-COD(K) = ZERO
              IF IF-HS-ACEE = 1 AND K = 1 AND IF-CP-IMPON(K) NOT = ZERO
                 PERFORM ERR-ZERO
                 GO TO V-ERROR
              ELSE
                 MOVE ZERO  TO IF-CP-IMPON(K)
                               IF-CP-FLCOSZ(K)
                 MOVE SPACE TO IF-CP-CCOST(K)
      **** rel 2.0
                               IF-CP-DESAG(K)
      ************
                 GO TO V-CP-COD-10.
           MOVE KAZ-COD      TO KPC-AZI.
           MOVE IF-CP-COD(K) TO KPC-COD.
           READ ANACON INTO REKCON INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
      **** rel 3.0
           IF CON-MOVIM > ZERO
              MOVE 'Non movimentabile' TO MESS
              GO TO V-ERROR.
      ************
      **** rel 5.0-2
      **** rel 5.1
           OPEN INPUT APPCON.
      ************
           MOVE KAZ-COD      TO KACO-AZI.
           MOVE IF-CP-COD(K) TO KACO-COD.
           READ APPCON INVALID MOVE SPACE TO ACO-CDC.
      **** rel 5.1
           CLOSE APPCON.
      ************
      **** rel 5.1-1
      *    IF FUN = 'V'        AND
      *       IF-HS-TIPRG  = 3 AND
      *       CON-TIPO = 'E'   AND
      *       CON-TRIP = ZERO
      *       IF ACO-CDC NOT = SPACE MOVE ACO-CDC TO IF-CP-CCOST(K).
      **************
      **************
           IF CON-DSABB NOT = SPACE
              MOVE CON-DSABB TO IF-CP-DESCR(K)
           ELSE
              MOVE CON-DESCR TO IF-CP-DESCR(K).
      **** rel 2.0
           IF IF-CP-DESAG(K) = SPACE AND FUN = 'V'
              MOVE COMDESAG TO IF-CP-DESAG(K).
      ************
           IF FUN NOT = 'W' AND IF-CP-IMPON(K) = ZERO
              MOVE IF-DIFIMPON TO IF-CP-IMPON(K).
      *
           MOVE ZERO TO IF-CP-FLCOSZ(K).
      **** rel 5.1
      **** rel 5.1-1
           IF FUN = 'V'
      **************
              MOVE SPACE TO IF-CP-CCOST(K).
      ************
      **** rel 5.1-1
           IF FUN = 'V'        AND
              IF-HS-TIPRG  = 3 AND
              CON-TIPO = 'E'   AND
              CON-TRIP = ZERO
              IF ACO-CDC NOT = SPACE MOVE ACO-CDC TO IF-CP-CCOST(K).
      **************
           IF CON-TIPO NOT = 'E'
              MOVE ZERO  TO IF-CP-FLCOSZ(K)
              MOVE SPACE TO IF-CP-CCOST(K)
           ELSE
              IF CON-TRIP = ZERO
                 MOVE 2 TO IF-CP-FLCOSZ(K)
      **** rel 5.1-1
                 IF FUN = 'V'
                    MOVE ACO-CDC TO IF-CP-CCOST(K)
                 END-IF
      **************
              ELSE
                 MOVE 3        TO IF-CP-FLCOSZ(K)
                 IF FUN = 'V'
                    MOVE CON-TTIP TO IF-CP-CCOST(K).
      *
           GO TO V-CP-COD-10.
       E-CP-COD.
      *
       V-CP-IMPON.
           MOVE 'IF-CP-IMPON' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CP-IMPON.
           MOVE ZERO TO K.
       V-CP-IMPON-10.
           ADD 1 TO K.
      **** rel 6.2
      *    IF K > 7 GO TO E-CP-IMPON.
           IF K > 15 GO TO E-CP-IMPON.
      ************
           IF FUN = 'W'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-CP-IMPON-10.
           IF IF-CP-IMPON(K) = ZERO
              IF IF-CP-COD(K) = ZERO
                 GO TO V-CP-IMPON-10
              ELSE
                 IF IF-HS-ACEE = 1
                    MOVE ZERO  TO IF-CP-COD(K)
                                  IF-CP-FLCOSZ(K)
                    MOVE SPACE TO IF-CP-DESCR(K)
                                  IF-CP-CCOST(K)
                 ELSE
                    PERFORM ERR-ZERO
                    GO TO V-ERROR.
           GO TO V-CP-IMPON-10.
       E-CP-IMPON.
      *
      **** rel 2.0
       V-CP-DESAG.
           MOVE 'IF-CP-DESAG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CP-DESAG.
           MOVE ZERO TO K.
       V-CP-DESAG-10.
           ADD 1 TO K.
      **** rel 6.2
      *    IF K > 7 GO TO E-CP-DESAG.
           IF K > 15 GO TO E-CP-DESAG.
      ************
           IF FUN NOT = 'V' GO TO E-CP-DESAG.
           IF K NOT = IF-IDXVET GO TO V-CP-DESAG-10.
           MOVE IF-CP-DESAG(K) TO COMDESAG.
       E-CP-DESAG.
      *
      ************
       V-CP-CCOST.
           MOVE 'IF-CP-CCOST' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CP-CCOST.
           MOVE ZERO TO K.
       V-CP-CCOST-10.
           ADD 1 TO K.
      **** rel 6.2
      *    IF K > 7 GO TO E-CP-CCOST.
           IF K > 15 GO TO E-CP-CCOST.
      ************
           IF FUN = 'W'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-CP-CCOST-10.
           IF AZI-FLCOS = ZERO GO TO E-CP-CCOST.
           IF IF-CP-CCOST(K) = '0' MOVE SPACE TO IF-CP-CCOST(K).
           IF IF-CP-CCOST(K) NOT = SPACE
              MOVE IF-CP-COD(K) TO KPC-COD
              PERFORM LEGG-TIPO-CONTO
              IF CON-TIPO NOT = 'E'
                 MOVE SPACE TO IF-CP-CCOST(K)
                 MOVE 'Conto non economico'      TO F-MES1
                 MOVE 'Azzerato centro di costo' TO F-MES2
                 MOVE 2 TO F-NMES
                 GO TO V-ERROR.
           IF CON-TRIP = ZERO
              MOVE IF-CP-CCOST(K) TO CODCEN
              CALL 'rcart4' USING CODCEN
              MOVE CODCEN TO IF-CP-CCOST(K)
           ELSE
              MOVE SPACE TO IF-CP-FILL(K).
           IF IF-CP-CCOST(K) = SPACE GO TO V-CP-CCOST-10.
           IF CON-TRIP = ZERO  GO TO LEGCDC3.
           MOVE IF-AZI         TO KTRT-AZI.
           MOVE IF-CP-CCOST(K) TO KTRT-COD.
           READ TABRIT INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           GO TO NOCDC3.
       LEGCDC3.
           MOVE IF-AZI         TO KCD-AZI.
           MOVE IF-CP-CCOST(K) TO KCD-COD.
           READ CDCOST INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF CDC-STATO = ZERO
              MOVE 'Centro di costo non attivo' TO MESS
              GO TO V-ERROR.
       NOCDC3.
           MOVE IF-AZI         TO COS-AZI.
           MOVE IF-CP-CCOST(K) TO COS-CCO.
           CALL 'vrccos' USING PARCOS.
           IF COS-ST > ZERO
              MOVE 'Errore centro di costo' TO MESS
              GO TO V-ERROR.
           GO TO V-CP-CCOST-10.
       E-CP-CCOST.
      *
       V-DATI-SCA-CAR.
           IF FUN = 'W' AND IF-HS-FLGSC = 4
              PERFORM AZZ-IF-SCA
              GO TO V-DATI-SEMPRE.
           IF FUN = 'W' AND (IF-HS-FLGSC = ZERO OR 2)
              GO TO V-DATI-SEMPRE.
      *
      * dati Scadenzario
      *
      **** rel 3.0
      **** rel 5.0-2
      *    IF IF-RG-FUN = 'M' GO TO V-DATI-SEMPRE.
      **************
      ************
       V-CDPAG.
           MOVE 'IF-CDPAG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDPAG.
           MOVE SPACE TO IF-DESPAG.
           IF IF-CDPAG = ZERO PERFORM AZZ-IF-SCA
                              GO TO E-CDPAG.
           MOVE IF-CDPAG TO KTB-COD.
           MOVE 4        TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO IF-DESPAG.
           IF T04-1SCAD >= 4
              MOVE 1 TO IF-HS-FL1SCAD
           ELSE
              MOVE ZERO TO IF-1SCAD
              MOVE ZERO TO IF-HS-FL1SCAD.
           IF FUN NOT = 'V' GO TO E-CDPAG.
           PERFORM RSCAD THRU EX-RSCAD.
      **** rel 1.2
           IF IF-IMVAL NOT = ZERO
      **** rel 4.0
      *       PERFORM RICAL-IMPSCA-LIRE THRU EX-RICAL-IMPSCA-LIRE.
              PERFORM RICAL-IMPSCA-EURO THRU EX-RICAL-IMPSCA-EURO.
      ************
      ************
       E-CDPAG.
      *
       V-1SCAD.
           MOVE 'IF-1SCAD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-1SCAD.
           MOVE IF-CDPAG TO KTB-COD.
           MOVE 4        TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID GO TO E-1SCAD.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T04-1SCAD < 3 GO TO E-1SCAD.
           MOVE 1 TO TIPOP1.
           MOVE IF-1SCAD TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF IF-1SCAD = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           IF FUN NOT = 'V' GO TO E-1SCAD.
           MOVE ZERO TO OLDCDPAG.
           PERFORM RSCAD THRU EX-RSCAD.
      **** rel 1.2
           IF IF-IMVAL NOT = ZERO
      **** rel 4.0
      *       PERFORM RICAL-IMPSCA-LIRE THRU EX-RICAL-IMPSCA-LIRE.
              PERFORM RICAL-IMPSCA-EURO THRU EX-RICAL-IMPSCA-EURO.
      ************
      ************
       E-1SCAD.
      *
       V-CDBAN.
           MOVE 'IF-CDBAN' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDBAN.
           MOVE SPACE TO IF-DESBAN.
           IF IF-CDBAN = ZERO GO TO E-CDBAN.
           MOVE IF-CDBAN TO KBA-BAN.
           READ ANABAN INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           MOVE BAN-RGSOC TO IF-DESBAN.
       E-CDBAN.
      *
       V-SC-TPAG.
           MOVE 'IF-SC-TPAG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-SC-TPAG.
           MOVE ZERO TO K.
       V-SC-TPAG-10.
           ADD 1 TO K.
           IF K > 12 GO TO E-SC-TPAG.
           IF FUN = 'W'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-SC-TPAG-10.
           IF IF-SC-TPAG(K) = ZERO
      **** rel 6.2
              MOVE SPACE TO IF-SC-NOTE(K)
                            IF-SC-NOTEA(K)
      ************
              MOVE ZERO TO IF-SC-DTSCA(K)
                           IF-SC-IMRATA(K)
                           IF-SC-VALRAT(K).
           GO TO V-SC-TPAG-10.
       E-SC-TPAG.
      *
       V-SC-DTSCA.
           MOVE 'IF-SC-DTSCA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-SC-DTSCA.
           MOVE ZERO TO K.
       V-SC-DTSCA-10.
           ADD 1 TO K.
           IF K > 12 GO TO E-SC-DTSCA.
           IF FUN = 'W'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-SC-DTSCA-10.
           MOVE IF-SC-DTSCA(K) TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           GO TO V-SC-DTSCA-10.
       E-SC-DTSCA.
      *
       V-SC-IMRATA.
           MOVE 'IF-SC-IMRATA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-SC-IMRATA.
           MOVE ZERO TO K.
       V-SC-IMRATA-10.
           ADD 1 TO K.
           IF K > 12 GO TO E-SC-IMRATA.
           IF FUN = 'W'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-SC-IMRATA-10.
      **** rel 4.0
      *    IF IF-VALUT < 2 GO TO V-SC-IMRATA-10.
           IF (IF-VALUT = ZERO OR COMEURO) GO TO V-SC-IMRATA-10.
      ************
           IF FUN NOT = 'V' GO TO V-SC-IMRATA-10.
           IF IF-SC-IMRATA(K) NOT = ZERO
      **** rel 1.2
      **** rel 4.0
      *       MOVE IF-SC-IMRATA(K) TO ER-IMPORTO
      *       MOVE IF-VALUT TO ER-VALUT
      *       MOVE IF-CAMGG TO ER-CAMBIO
      *       MOVE IF-DATREG TO GGMMAA
      *       MOVE 1 TO TIPOP1
      *       CALL 'rdata' USING PARCDT
      *       MOVE AAGGG TO ER-DATA
      *       CALL 'rcamimp' USING ER-IMPORTO LIR-VAL ER-VALUT
      *                            ER-CAMBIO  ER-DATA
      *       MOVE ER-IMPORTO TO IF-SC-VALRAT(K).
              MOVE IF-SC-IMRATA(K) TO ER-IMPORTO
              MOVE IF-VALUT TO ER-VALUT
              MOVE IF-CAMGG TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO EUR-VAL ER-VALUT
                                  ER-CAMBIO
              MOVE ER-IMPORTO TO IF-SC-VALRAT(K).
      ************
      *       COMPUTE IF-SC-VALRAT(K) = IF-SC-IMRATA(K) / IF-CAMGG.
      ************
           GO TO V-SC-IMRATA-10.
       E-SC-IMRATA.
      **** rel 7.1
       V-SC-VALRAT.
           MOVE 'IF-SC-VALRAT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-SC-VALRAT.
           MOVE ZERO TO K.
       V-SC-VALRAT-10.
           ADD 1 TO K.
           IF K > 12 GO TO E-SC-VALRAT.
           IF FUN = 'W'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-SC-VALRAT-10.
           IF (IF-VALUT = ZERO OR COMEURO) GO TO V-SC-VALRAT-10.
           IF FUN NOT = 'V' GO TO V-SC-VALRAT-10.
           IF IF-SC-VALRAT(K) NOT = ZERO
              MOVE IF-SC-VALRAT(K) TO ER-IMPORTO
              MOVE IF-VALUT TO ER-VALUT
              MOVE IF-CAMGG TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT
                                  ER-CAMBIO
              MOVE ER-IMPORTO TO IF-SC-IMRATA(K).
           GO TO V-SC-VALRAT-10.
       E-SC-VALRAT.
      ************
      *
      * esegue sempre se 'V' o 'W'.
      *
       V-DATI-SEMPRE.
           IF IF-HS-ATTRN = 1
              PERFORM CALC-IV-IMPON
              PERFORM CALC-IV-DIFF
              PERFORM CALC-CP-DIFF.
           IF IF-HS-ACEE = 1
              PERFORM CALC-IV-IMPON
              PERFORM CALC-ACEE-CP
              PERFORM CALC-ACEE-DIFF.
           IF IF-HS-FLGSC = 1 OR 3
              PERFORM CALC-SC-DIFF.
      * esegue solo se valida tutto di rigo
           IF FUN NOT = 'W' GO TO V-END-RIGO.
      **** rel 2.0
      *    IF IF-IMPOR = ZERO AND IF-IMVAL = ZERO
      *       MOVE "Importo in Lire mancante" TO MESS
      *       MOVE 'IF-IMPOR' TO VCAMPO
      *       GO TO V-ERROR.
      ************
           IF IF-HS-ACEE NOT = 1
              IF IF-DIFDOC NOT = ZERO
      **** rel 2.0
                 MOVE "Il castelletto IVA non quadra" TO F-MES1
                 MOVE "con il totale della fattura."  TO F-MES2
                 MOVE 2 TO F-NMES
                 CALL 'vrmbox' USING PARMB.
      *          MOVE "Errore di quadratura su IVA" TO MESS
      *          MOVE 'IF-IV-COD' TO VCAMPO
      *          MOVE 1 TO IF-IDXVET
      *          GO TO V-ERROR.
      ************
           IF IF-DIFSCA < ZERO OR IF-DIFSCAV < ZERO
              MOVE 'Sistemare scadenzario'              TO F-MES1
              MOVE 'Totale rate > del totale documento' TO F-MES2
              MOVE 2 TO F-NMES
              MOVE 'IF-SC-TPAG' TO VCAMPO
              MOVE 1 TO IF-IDXVET
              GO TO V-ERROR.
      *
      * warning
      *
           MOVE ZERO TO F-NMES.
           IF SWIVA = 1
              MOVE "L'importo IVA di uno o piu' righi"  TO F-MES1
              MOVE "e' diverso  da  quello  calcolato"  TO F-MES2
              MOVE 2 TO F-NMES.
           IF SWCAMGG = 1
              MOVE COMCAMGG TO COMOCAM
              STRING 'Cambio calcolato : ' DELIMITED SIZE
                      COMOCAM DELIMITED SIZE INTO F-MES3
              MOVE COMCAMGG TO IF-CAMGG
      **** rel 4.0
      *       MOVE 3 TO F-NMES.
              MOVE 3 TO F-NMES
              IF (CG-TVAL = 3 OR 1) AND COMCAMGG NOT = CG-CAMBIO
                  MOVE CG-CAMBIO TO IF-CAMGG.
      ************
           IF SWCERCA = 1
              MOVE 4 TO F-NMES
              IF IF-HS-TIPRG = 3
                 MOVE 'Importo a debito del fornitore' TO F-MES4
              ELSE
                 MOVE 'Importo a credito del cliente'  TO F-MES4.
      **** rel 5.0
      *    IF IF-RG-FUN NOT = 'M'
      *       IF IF-DIFSCA > ZERO OR IF-DIFSCAV > ZERO
           IF IF-DIFSCA > ZERO OR IF-DIFSCAV > ZERO
      ************
                 MOVE 4 TO F-NMES
                 MOVE 'Tot. rate scadenzario < tot. documento'
                                                    TO F-MES4.
           IF IF-HS-ACEE = 1
              IF IF-DIFDOC NOT = ZERO OR IF-DIFDOCV NOT = ZERO
                 MOVE 5 TO F-NMES
                 MOVE 'Differenze non a zero su IVA CEE' TO F-MES4.
           IF F-NMES NOT = ZERO
              GO TO V-WARNING.
      *
       V-END-RIGO.
           GO TO END-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO END-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO END-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       END-V-DATI.
      **** rel 5.0
      *    IF IF-RG-FUN = 'M' MOVE ZERO TO IF-HS-FLGSC.
      ************
      **** rel 5.0
      *> per pagam. anticipati fornitori senza num. e data documento.
      *    IF IF-RG-FUN NOT = 'M'
           IF (IF-RG-FUN NOT = 'M') AND (FUN NOT = 'V')
              IF IF-HS-TIPRG  = 3 AND
                 IF-T02-TIPOP = 6 AND
                 IF-T02-FLGSC = 2 AND
                 IF-DOCUM = ZERO  AND
      **** rel 5.1
      *          IF-DTDOC = ZERO  MOVE ZERO TO IF-HS-FLGSC.
                 IF-DTDOC = ZERO  MOVE ZERO TO IF-HS-FLGSC
                 IF FUN = 'W'
                    MOVE "Numero e data documento a zero : " TO F-MES1
                    MOVE "verra' creata una nuova scadenza " TO F-MES2
                    MOVE "per il pagamento anticipato.     " TO F-MES3
                    MOVE 3 TO F-NMES
                    CALL 'vrmbox' USING PARMB.
      ************
      ************
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           IF IF-RG-FUN = 'M'
      **** rel 4.0-2
              MOVE ZERO TO CTR-131
      ************
      **** rel 5.0
              MOVE ZERO TO SCA-131
      ************
      **** rel 6.1
              MOVE ZERO TO FAF-131
      ************
      **** rel 7.1
              MOVE 'M' TO FUN-C110
      ************
              PERFORM LANCIA-VUTI131.
      **** rel 5.0
           IF IF-RG-FUN = 'M'  AND FLGSCA = 1
              PERFORM DEL-SCADENZE THRU EX-DEL-SCADENZE.
      ************
           PERFORM CREA-WDS114 THRU EX-CREA-WDS114.
           PERFORM LANCIA-VCON114.
      **** rel 5.0
           IF IF-RG-FUN = 'M'  AND FLGSCA = 3
              PERFORM VARIA-DETTAGLI THRU EX-VARIA-DETTAGLI.
           IF IF-HS-ACEEV = 1
              PERFORM LANCIA-VCON440 THRU EX-LANCIA-VCON440.
      ************
           PERFORM CREA-WDS400      THRU EX-CREA-WDS400.
           PERFORM LANCIA-VCON400   THRU EX-LANCIA-VCON400.
           PERFORM AGG-SCAD-CARICO  THRU EX-AGG-SCAD-CARICO.
           PERFORM AGG-SCAD-SCARICO THRU EX-AGG-SCAD-SCARICO.
      **** rel 5.0
      *> per pagamenti anticipati fornitori
      *  genero record scadenzario
      **** rel 5.1
           IF IF-RG-FUN NOT = 'M'
      ************
              IF IF-HS-TIPRG  = 3 AND
                 IF-T02-TIPOP = 6 AND
      **** rel 6.2
                 IF-T02-FLGSC = 2
                 PERFORM AGG-SCAD-PAGANT-L THRU EX-AGG-SCAD-PAGANT-L.
      *          IF-T02-FLGSC = 2 AND
      *          IF-DOCUM = ZERO  AND
      *          IF-DTDOC = ZERO
      *          PERFORM AGG-SCAD-PAGANT THRU EX-AGG-SCAD-PAGANT.
      ************
      ************
      **** rel 6.1
           IF IF-RG-FUN = 'M'
              PERFORM CONTROLLA-FATFOR THRU EX-CONTROLLA-FATFOR.
      ************
           IF IF-RG-FUN NOT = 'M'
              PERFORM CREA-WDS135 THRU EX-CREA-WDS135.
      **** rel 5.0
           IF ERRIO-ST = ZERO
              IF IF-RG-FUN = 'M' AND FLINTRA = 1 AND FLGCEE = 4
              MOVE 'Il programma non provvede            ' TO F-MES1
              MOVE 'all''aggiornamento Elenchi IVA CEE   ' TO F-MES2
              MOVE '(Mod. INTRA). Effettuare le eventuali' TO F-MES3
              MOVE 'rettifiche con l''apposito programma.' TO F-MES4
              MOVE 4 TO F-NMES
              CALL 'vrmbox' USING PARMB.
           IF FLINTRA NOT = 1 MOVE ZERO TO IF-HS-ACEE
                                           IF-HS-ACEEV.
      ************
           IF ERRIO-ST = ZERO
      **** rel 5.2
      *       IF IF-RG-FUN = 'M'
              IF IF-RG-FUN = 'M' AND IF-HS-TIPRG NOT = 1
      ************
      **** rel 5.0
      *          MOVE 'Il programma non provvede           ' TO F-MES1
      *          MOVE 'all''aggiornamento dello scadenzario' TO F-MES2
      *          MOVE 'Effettuare le eventuali rettifiche  ' TO F-MES3
      *          MOVE 'con l''apposito programma.          ' TO F-MES4
      *          MOVE 4 TO F-NMES
      *          MOVE 8 TO ERRIO-ST.
                 IF FLGSCA = ZERO
                   MOVE 'Scadenze relative al movimento      ' TO F-MES1
                   MOVE 'variato non trovate.                ' TO F-MES2
                   MOVE 'Effettuare le eventuali rettifiche  ' TO F-MES3
                   MOVE 'dello scadenzario con l''apposito   ' TO F-MES4
                   MOVE 'programma.                          ' TO F-MES5
                   MOVE 5 TO F-NMES
                   MOVE 8 TO ERRIO-ST
                 END-IF
                 IF FLGSCA = 2
                   MOVE 'Record scadenzario non variabile:   ' TO F-MES1
                   MOVE 'scadenza pagata in tutto o in parte.' TO F-MES2
      **** rel 5.1
      *            MOVE 'Effettuare le eventuali rettifiche  ' TO F-MES3
      *            MOVE 'con l''apposito programma.          ' TO F-MES4
      *            MOVE 4 TO F-NMES
                   MOVE 'Verificare dettagli pagamenti scad. ' TO F-MES3
                   MOVE 'Effettuare le eventuali rettifiche  ' TO F-MES4
                   MOVE 'con l''apposito programma.          ' TO F-MES5
                   MOVE 5 TO F-NMES
      ************
                   MOVE 8 TO ERRIO-ST
                 END-IF
                 IF FLGSCA = 4
                   MOVE 'Dettaglio pagamento non trovato.    ' TO F-MES1
                   MOVE 'Effettuare le eventuali rettifiche  ' TO F-MES2
                   MOVE 'con l''apposito programma.          ' TO F-MES3
                   MOVE 3 TO F-NMES
                   MOVE 8 TO ERRIO-ST.
      ************
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       RDCON.
           MOVE ZERO TO COMODO.
      **** rel 5.0
           MOVE ZERO TO IF-FLRIPO.
      ************
           MOVE KPC-COD TO CODICE.
           MOVE KAZ-COD TO KPC-AZI.
           READ ANACON INTO REKCON INVALID
                MOVE ZERO TO KPC-COD
                PERFORM ERR-CINE
                GO TO EX-RDCON.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           IF CON-MOVIM > ZERO
              MOVE ZERO TO KPC-COD
              MOVE 'Non movimentabile' TO MESS
              GO TO EX-RDCON.
      **** rel 5.0-2
      **** rel 5.1
           OPEN INPUT APPCON.
      ************
           MOVE KAZ-COD TO KACO-AZI.
           MOVE KPC-COD TO KACO-COD.
           READ APPCON INVALID MOVE SPACE TO ACO-CDC.
      **************
      **** rel 5.1
           CLOSE APPCON.
      ************
           MOVE CON-CVAL TO IF-HS-VALUT.
           COMPUTE COMODO = CON-SESP + CON-SE-D - CON-SE-A.
           MOVE KPC-COD TO KLC-COD.
           READ WDSLCN INVALID GO TO EX-RDCON.
           ADD LCN-SDO TO COMODO.
       EX-RDCON.
           EXIT.
      *------------------
       LEGG-TIPO-CONTO.
           MOVE KAZ-COD TO KPC-AZI.
           READ ANACON INTO REKCON INVALID
                MOVE ZERO TO CON-TIPO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
      *------------------
       RDCLF.
           MOVE ZERO TO COMODO.
      **** rel 5.0
           MOVE ZERO TO IF-FLRIPO.
      ************
           MOVE KAZ-COD TO KCF-AZI.
           READ ANACLF INTO REKCLF INVALID KEY
                MOVE ZERO TO KCF-COD
                PERFORM ERR-CINE
                GO TO EX-RDCLF.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
      **** rel 6.0
           MOVE KAZ-COD    TO RACF-AZI.
           MOVE CODICE     TO RACF-COD.
           CALL 'rrdacf' USING PARACF.
      ************
      **** rel 7.2
           IF CLF-13IVA NOT = 4
              MOVE ZERO TO IF-CEE
           ELSE
              IF CLF-PAE IS NOT NUMERIC
                 IF CLF-PAE = 'IT' OR  CLF-PAE = SPACE
                    MOVE ZERO to IF-CEE 
                 ELSE
                    MOVE 1 to IF-CEE
                 END-IF
              ELSE
                 MOVE ZERO to IF-CEE.
      ************
      **** rel 5.0-2
      *    IF FUN NOT = 'W'
           IF FUN NOT = 'W' AND FUN NOT = 'w'
      **************
              IF IF-RG-FUN NOT = 'M'
                 MOVE CLF-VAL TO IF-VALUT.
      **** rel 1.2
      *    IF CLF-VAL > 1
           IF CLF-VAL > ZERO
      ************
              MOVE 1 TO IF-HS-VALUT
           ELSE
              MOVE 1 TO IF-HS-EURO
              MOVE ZERO TO IF-HS-VALUT.
           MOVE CLF-RGS  TO IF-CLIFOR-D.
      **** rel 3.0
      *    IF IF-CDPAG = ZERO
      **** rel 4.1a
      *    IF IF-CDPAG = ZERO OR FUN = 'V'
      **** rel 5.0
      *    IF IF-CDPAG = ZERO OR (FUN = 'V' OR 'w')
           IF IF-RG-FUN NOT = 'M'
              IF IF-CDPAG = ZERO OR (FUN = 'V' OR 'w')
      ************
      ************
      ************
              MOVE CLF-CPAG TO IF-CDPAG.
      *
           MOVE ZERO TO IF-HS-ACEE.
           IF IF-HS-TIPRG     = 3     AND
              IF-HS-ATTRN     = ZERO  AND
              CLF-13IVA       = 4     AND
              (IF-T02-TIPOP = 1 OR 8)
              IF IF-RG-FUN = 'M'
                 MOVE 1 TO IF-HS-VALUT
              ELSE
                 MOVE 1 TO IF-HS-ACEE
                 MOVE 1 TO IF-HS-VALUT
                 IF FUN NOT = 'W'
                    PERFORM DEF-ACEE-CONT.
      **** rel 5.0
           MOVE CLF-13IVA TO FLGCEE.
      *
      *> nota d'accredito fornitore CEE
      *
           MOVE ZERO TO FLGACF.
           IF IF-HS-TIPRG     = 3   AND
              IF-HS-ATTRN     = 1   AND
              CLF-13IVA       = 4   AND
              IF-T02-TIPOP    = 8   MOVE 1 TO FLGACF.
      *
      *> fattura o nota d'accredito cliente CEE
      *
           MOVE ZERO TO IF-HS-ACEEV.
           IF IF-HS-TIPRG     = 2     AND
              CLF-13IVA       = 4     AND
              (IF-T02-TIPOP = 1 OR 8)
              IF IF-RG-FUN NOT = 'M'
                 MOVE 1 TO IF-HS-ACEEV.
      ************
      *
           COMPUTE COMODO = CLF-SESP + CLF-SE-D - CLF-SE-A.
           MOVE KCF-COD TO KLC-COD.
      *
      **** rel 3.0
      *    MOVE CLF-BANC TO IF-CDBAN.
           IF FUN = 'V' OR IF-HS-TIPRG = 2
              MOVE CLF-BANC TO IF-CDBAN.
      ************
           IF IF-CDBAN = ZERO GO TO RDCLF-10.
           MOVE IF-CDBAN TO KBA-BAN.
           READ ANABAN INVALID MOVE ALL '*' TO BAN-RGSOC.
           MOVE BAN-RGSOC TO IF-DESBAN.
       RDCLF-10.
           READ WDSLCN INVALID GO TO EX-RDCLF.
           ADD LCN-SDO TO COMODO.
       EX-RDCLF.
           EXIT.
      *------------------
       RDTAB1.
           MOVE ZERO TO SWERR.
           MOVE SPACE TO MESS.
           MOVE 2 TO KTB-TIP.
           IF IF-FL NOT = ZERO
              IF KTB-COD = T20-CDCLA OR T20-CACLA OR
                           T20-CDFOA OR T20-CAFOA
                 MOVE 'Causale non ammessa' TO MESS
                 GO TO RDT1-90
              ELSE NEXT SENTENCE
           ELSE
              IF KTB-COD = T20-CDCLC OR T20-CACLC OR
                           T20-CDFOC OR T20-CAFOC
                 MOVE 'Causale non ammessa' TO MESS
                 GO TO RDT1-90.
           READ TABELL INTO REKTAB INVALID PERFORM ERR-CINE
                                           MOVE SPACE TO TAB-DESCR
                                           GO TO RDT1-90.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF AZI-FLGIS = ZERO AND T02-FLGIS > ZERO
              MOVE 'Causale non ammessa' TO MESS
              GO TO RDT1-90.
           MOVE TAB-DESCR TO IF-CAUS-D.
           IF IF-PROGR > 1
              IF KTB-COD = PRG1-CAUS
                 GO TO RDT1-15
              ELSE
              IF T02-TIPRG > 1 AND
                 T02-ATTRN = 1
                     MOVE 'Causale non ammessa' TO MESS
                     GO TO RDT1-90.
       RDT1-15.
           IF FUN = 'V'
              MOVE T02-D-A TO IF-D-A
      **** rel 1.2
      *       IF IF-PROGR > 1 AND KTB-COD = PRG1-CAUS
              IF IF-PROGR > 1 AND KTB-COD = PRG1-CAUS AND PRG1-ATTRN = 1
      ************
                 IF T02-D-A = 'D'
                    MOVE 'A' TO IF-D-A
                 ELSE
                    MOVE 'D' TO IF-D-A.
           MOVE T02-TIPRG TO IF-T02-TIPRG.
           MOVE T02-TIPOP TO IF-T02-TIPOP.
           MOVE T02-SEGNO TO IF-T02-SEGNO.
           MOVE T02-FLGIS TO IF-T02-FLGIS.
           MOVE T02-ATTRN TO IF-T02-ATTRN.
           MOVE T02-FLVEN TO IF-T02-FLVEN.
           MOVE T02-FLGSC TO IF-T02-FLGSC.
           MOVE T02-DTSCO TO IF-T02-DTSCO.
           MOVE T02-FLGEC TO IF-T02-FLGEC.
           MOVE SPACE     TO IF-SEGNI.
           IF T02-SEGNO = 1 MOVE '-' TO IF-SEGNI.
      * adeguamento flag HS legati alla causale
           MOVE T02-TIPRG TO IF-HS-TIPRG.
           IF IF-HS-FLGSC = 4
              IF FUN = 'V'
                 MOVE T02-FLGSC TO IF-HS-FLGSC
              END-IF
           ELSE
              MOVE T02-FLGSC TO IF-HS-FLGSC.
           IF T02-FLGEC = ZERO
              MOVE 1 TO IF-HS-FLGEC
           ELSE
              MOVE ZERO TO IF-HS-FLGEC.
           IF IF-PROGR > 1
              IF KTB-COD = PRG1-CAUS AND PRG1-ATTRN = 1
                 MOVE 1    TO IF-HS-TIPRG
                 MOVE ZERO TO IF-HS-FLGSC
                              IF-HS-FLGEC.
           IF IF-PROGR = 1
              MOVE T02-ATTRN TO IF-HS-ATTRN PRG1-ATTRN
              MOVE T02-TIPRG TO PRG1-TIPRG
              MOVE T02-FLGIS TO PRG1-FLGIS
           ELSE
              MOVE ZERO TO IF-HS-ATTRN.
           IF PRG1-ATTRN = ZERO
              MOVE 1 TO IF-HS-CPART
           ELSE
              IF IF-T02-FLGIS NOT = 2
                 MOVE ZERO  TO IF-HS-CPART
                 MOVE ZERO  TO IF-CPART
                               IF-SALD2
                 MOVE SPACE TO IF-CPART-D
                               IF-CCOST2
                               IF-DESAG2.
           IF IF-T02-FLGIS = 2 MOVE 1 TO IF-HS-CPART.
           GO TO EX-RDTAB1.
       RDT1-90.
           MOVE 1 TO IF-HS-TIPRG.
           MOVE ZERO TO IF-HS-ATTRN
                        IF-HS-FLGEC
                        IF-HS-FLGSC.
           MOVE TAB-DESCR TO IF-CAUS-D.
           MOVE 1 TO SWERR.
       EX-RDTAB1.
           EXIT.
      *------------------
       CONV-DTP-A6.
           IF DTP = ZERO MOVE ZERO TO DTP6
              ELSE MOVE DTP TO DTP6
                   MOVE AA61 TO AA62
                   MOVE ZERO TO AA61
                   CALL 'ranno4' USING AA6.
      *------------------
       CALC-IMPOR-IVA.
           IF IF-IV-IMPON(K) NOT = ZERO
      **** rel 4.0
      *       COMPUTE CIMPIVA = IF-IV-IMPON(K) * T03-ALIVA / 100 + 0,99
              MOVE IF-IV-IMPON(K) TO ER-IMPORTO
              MOVE ZERO           TO ER-VALUT
              CALL 're2iva' USING ER-IMPORTO ER-VALUT T03-ALIVA
              MOVE ER-IMPORTO     TO CIMPIVA
      ************
           ELSE
              MOVE IF-IV-IMPOS(K) TO CIMPIVA.
           IF FUN = 'W' AND CIMPIVA NOT = IF-IV-IMPOS(K)
              MOVE 1 TO SWIVA
           ELSE
              MOVE CIMPIVA TO IF-IV-IMPOS(K).
      **** rel 7.1
           PERFORM CALC-IMPOR-IVA-IND.
      *------------------
       CALC-IMPOR-IVA-IND.
      ************
      * iva indeducibile
           MOVE ZERO TO VIVA-INDEDUC(K).
           IF T03-TPIVA = 1 MOVE IF-IV-IMPOS(K) TO VIVA-INDEDUC(K).
           IF T03-TPIVA = 7
      **** rel 4.0
      *       COMPUTE VIVA-INDEDUC(K) = IF-IV-IMPOS(K) / 2 + 0,99.
              MOVE IF-IV-IMPOS(K) TO ER-IMPORTO
              MOVE ZERO           TO ER-VALUT
      **** rel 6.2
      *       MOVE 50             TO PERC
              MOVE T03-PERIVA     TO PERC
              IF PERC = ZERO MOVE 50 TO PERC
              END-IF
      ************
              CALL 're2iva' USING ER-IMPORTO ER-VALUT PERC
              MOVE ER-IMPORTO     TO VIVA-INDEDUC(K).
      ************
      *------------------
       CALC-IV-IMPON.
           MOVE ZERO TO IF-TOTIMPON
                        IF-TOTIMPOS
                        IF-TOTIMPONV.
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              ADD IF-IV-IMPON(K)       TO IF-TOTIMPON
              ADD IF-IV-IMPOS(K)       TO IF-TOTIMPOS
              ADD IF-ACEE-IV-IMPONV(K) TO IF-TOTIMPONV
              ADD 1 TO K
           END-PERFORM.
      *------------------
       CALC-IV-DIFF.
           MOVE IF-IMPOR TO IF-DIFDOC.
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              SUBTRACT IF-IV-IMPON(K) FROM IF-DIFDOC
              SUBTRACT IF-IV-IMPOS(K) FROM IF-DIFDOC
              ADD 1 TO K
           END-PERFORM.
      *------------------
       CALC-SC-DIFF.
           MOVE ZERO TO IF-TOTSCA
                        IF-TOTSCAV.
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
              ADD IF-SC-IMRATA(K) TO IF-TOTSCA
              ADD IF-SC-VALRAT(K) TO IF-TOTSCAV
              ADD 1 TO K
           END-PERFORM.
           COMPUTE IF-DIFSCA  = IF-IMPOR  - IF-TOTSCA.
           COMPUTE IF-DIFSCAV = IF-IMVAL  - IF-TOTSCAV.
      *------------------
       CALC-CP-DIFF.
           MOVE ZERO TO IF-TOTIMPOR.
           MOVE IF-TOTIMPON TO IF-DIFIMPON.
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              ADD VIVA-INDEDUC(K) TO IF-DIFIMPON
              ADD 1 TO K
           END-PERFORM.
           MOVE 1 TO K.
      **** rel 6.2
      *    PERFORM UNTIL K > 7
           PERFORM UNTIL K > 15
      ************
              SUBTRACT IF-CP-IMPON(K) FROM IF-DIFIMPON
              ADD IF-CP-IMPON(K) TO IF-TOTIMPOR
              ADD 1 TO K
           END-PERFORM.
      *------------------
       CALC-ACEE-CP.
           MOVE ZERO TO IF-CP-IMPON(1).
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              ADD VIVA-INDEDUC(K) TO IF-CP-IMPON(1)
              ADD 1 TO K
           END-PERFORM.
      *------------------
       CALC-ACEE-DIFF.
           MOVE IF-IMPOR TO IF-DIFDOC.
           MOVE IF-IMVAL TO IF-DIFDOCV.
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              SUBTRACT IF-IV-IMPON(K)       FROM IF-DIFDOC
              SUBTRACT IF-ACEE-IV-IMPONV(K) FROM IF-DIFDOCV
              ADD 1 TO K
           END-PERFORM.
      *------------------
       AZZ-IF-IVA.
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              MOVE ZERO  TO IF-IV-COD(K)
                            IF-ACEE-IV-IMPONV(K)
                            IF-IV-IMPON(K)
                            IF-IV-IMPOS(K)
                            IF-IV-PERPLA(K)
              MOVE SPACE TO IF-IV-DESCR(K)
              MOVE ZERO TO VIVA-INDEDUC(K)
              ADD 1 TO K
           END-PERFORM.
      *------------------
       AZZ-IF-CPAR.
           MOVE 1 TO K.
      **** rel 6.2
      *    PERFORM UNTIL K > 7
           PERFORM UNTIL K > 15
      ************
              MOVE ZERO  TO IF-CP-COD(K)
                            IF-CP-IMPON(K)
                            IF-CP-FLCOSZ(K)
              MOVE SPACE TO IF-CP-DESCR(K)
                            IF-CP-DESAG(K)
                            IF-CP-CCOST(K)
              ADD 1 TO K
           END-PERFORM.
      *------------------
       AZZ-IF-SCA.
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
              MOVE ZERO  TO IF-SC-TPAG(K)
                            IF-SC-DTSCA(K)
                            IF-SC-IMRATA(K)
                            IF-SC-VALRAT(K)
      **** rel 6.2
              MOVE SPACE TO IF-SC-NOTE(K)
                            IF-SC-NOTEA(K)
      ************
              ADD 1 TO K
           END-PERFORM.
           MOVE ZERO TO OLDCDPAG.
      *------------------
       RSCAD.
           IF OLDCDPAG NOT = ZERO
              IF IF-CDPAG = OLDCDPAG GO TO EX-RSCAD.
           PERFORM AZZ-IF-SCA.
           MOVE IF-CDPAG TO OLDCDPAG.
           IF T04-1SCAD >= 3 AND IF-1SCAD = ZERO GO TO EX-RSCAD.
           MOVE ZERO TO TOTIVA.
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              ADD IF-IV-IMPOS(K) TO TOTIVA
              ADD 1 TO K
           END-PERFORM.
           IF T04-1SCAD < 3
              MOVE IF-DTDOC TO GGMMAA
           ELSE
              MOVE IF-1SCAD  TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO W-DTSCA.
           IF T04-1SCAD NOT = ZERO GO TO RCAL1.
       FORSE0.
           MOVE 20 TO NUMGG.
           CALL 'radd30' USING W-DTSCA NUMGG.
       RCAL1.
           PERFORM RCALR THRU EX-RCALR.
           MOVE ZERO TO K.
       LOOPR1.
           ADD 1 TO K.
           IF K > T04-NRATE GO TO FINEL1.
           IF T04-FLGIVA = ZERO OR 2
              IF K = 1
                 MOVE T04-NG1SC TO NUMGG
              ELSE
                 MOVE T04-NGSSC TO NUMGG.
           IF T04-FLGIVA = 1
              IF K = 1
                 MOVE T04-NGIVA TO NUMGG
              ELSE
                 IF K = 2
                    MOVE T04-NG1SC TO NUMGG
                    IF T04-1SCAD < 3
                       MOVE IF-DTDOC TO GGMMAA
                    ELSE
                       MOVE IF-1SCAD  TO GGMMAA
                    END-IF
                    MOVE 1 TO TIPOP1
                    CALL 'rdata' USING PARCDT
                    MOVE AAGGG TO W-DTSCA
                 ELSE
                    MOVE T04-NGSSC TO NUMGG.
           CALL 'radd30' USING W-DTSCA NUMGG.
           MOVE W-DTSCA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-SC-DTSCA(K).
           MOVE T04-TIPAG TO IF-SC-TPAG(K).
           GO TO LOOPR1.
       FINEL1.
           MOVE ZERO TO K.
       LOOPR2.
           ADD 1 TO K.
           IF K > T04-NRATE GO TO FINEL2.
           IF IF-SC-DTSCA(K) = ZERO GO TO FINEL2.
           IF T04-1SCAD = 2 OR T04-1SCAD = 4 GO TO XCONT.
           GO TO FINEL2.
       XCONT.
           MOVE IF-SC-DTSCA(K) TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           DIVIDE AA9 BY 4 GIVING CLAV1 REMAINDER CLAV2.
           IF CLAV2 = ZERO
              MOVE 29 TO GIO(2)
           ELSE
              MOVE 28 TO GIO(2).
           MOVE GIO(MM9) TO GG9.
           MOVE GGMMAA TO IF-SC-DTSCA(K).
           GO TO LOOPR2.
       FINEL2.
           IF CLF-GSFM NOT = ZERO PERFORM SOMMA-GG THRU EX-SOMMA-GG.
      **** rel 6.0
      *    IF T04-ESCMM = ZERO GO TO EX-RSCAD.
           MOVE ZERO TO FLGMCL.
           MOVE 1 TO K.
       VPG.
           IF K > 12 GO TO VPG1.
           IF RACF-ESCM(K) = ZERO
              ADD 1 TO K
              GO TO VPG.
           MOVE 1 TO FLGMCL.
           GO TO VPG4.
      *
       VPG1.
           MOVE 1 TO K.
       VPG2.
           IF K > 12 GO TO VPG3.
           IF T04-ESCM(K) = ZERO
              ADD 1 TO K
              GO TO VPG2.
           GO TO VPG4.
       VPG3.
           GO TO EX-RSCAD.
       VPG4.
      ************
           MOVE ZERO TO K.
       LOOPR3.
           ADD 1 TO K.
           IF K > T04-NRATE GO TO EX-RSCAD.
           MOVE IF-SC-DTSCA(K) TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      **** rel 6.3
           IF MM9 = ZERO GO TO LOOPR3.
      ************
      **** rel 6.0
      *    IF MM9 NOT = 8 GO TO FORI2.
      *    IF T04-ESCMM = 1 OR T04-ESCMM = 3 GO TO LPMOV.
           IF (FLGMCL = 1 AND RACF-ESCM(MM9) = 1) OR
              (FLGMCL = ZERO AND T04-ESCM(MM9) = 1)
                 GO TO LPMOV.
      ************
           GO TO LOOPR3.
       LPMOV.
      **** rel 2.0
      *    MOVE GGESC TO GG9.
           IF CLF-GSESC NOT = ZERO
              MOVE CLF-GSESC TO GG9
           ELSE
              MOVE GGESC TO GG9.
      ************
           IF GG9 > 30 MOVE 30 TO GG9.
      **** rel 6.0
      *    MOVE 9 TO MM9.
      *    GO TO XDATA.
      *FORI2.
      *    IF MM9 NOT = 12 GO TO LOOPR3.
      *    IF T04-ESCMM = 2 GO TO LPMOV1.
      *    IF T04-ESCMM = 3 GO TO LPMOV1.
      *    GO TO LOOPR3.
      ************
       LPMOV1.
      **** rel 2.0
      *    MOVE GGESC TO GG9.
      **** rel 6.0
      *    IF CLF-GSESC NOT = ZERO
      *       MOVE CLF-GSESC TO GG9
      *    ELSE
      *       MOVE GGESC TO GG9.
      ************
      ************
      **** rel 6.0
      *    MOVE 1 TO MM9.
      *    ADD 1 TO AA9.
      *XDATA.
           IF MM9 = 12
              MOVE 1 TO MM9
              ADD 1  TO AA9
           ELSE
              ADD 1 TO MM9.

           IF (FLGMCL = 1 AND RACF-ESCM(MM9) = 1) OR
              (FLGMCL = ZERO AND T04-ESCM(MM9) = 1)
                 GO TO LPMOV1.
      ************
           MOVE GGMMAA TO IF-SC-DTSCA(K).
           GO TO LOOPR3.
       EX-RSCAD.
           EXIT.
      *------------------
       RCALR.
      **** rel 1.2
           MOVE ZERO TO TOTIVV.
      **** rel 4.0
      *    IF IF-VALUT > 1
      *       MOVE TOTIVA TO ER-IMPORTO
      *       MOVE IF-CAMGG  TO ER-CAMBIO
      *       MOVE IF-VALUT  TO ER-VALUT
      *       MOVE IF-DATREG TO GGMMAA
      *       MOVE 1 TO TIPOP1
      *       CALL 'rdata' USING PARCDT
      *       MOVE AAGGG TO ER-DATA
      *       CALL 'rcamimp' USING ER-IMPORTO LIR-VAL ER-VALUT
      *                            ER-CAMBIO  ER-DATA
      *       MOVE ER-IMPORTO TO TOTIVV.
           IF NOT (IF-VALUT = ZERO OR COMEURO)
              MOVE TOTIVA TO ER-IMPORTO
              MOVE IF-VALUT  TO ER-VALUT
              MOVE IF-CAMGG  TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO EUR-VAL ER-VALUT
                                  ER-CAMBIO
              MOVE ER-IMPORTO TO TOTIVV.
      ************
           IF T04-FLGIVA = ZERO GO TO CALR1.
           IF TOTIVA     = ZERO GO TO CALR1.
           IF T04-FLGIVA = 1 PERFORM RCALR1 THRU EX-RCALR1
                             GO TO EX-RCALR.
           IF T04-FLGIVA = 2 PERFORM RCALR2 THRU EX-RCALR2
                             GO TO EX-RCALR.
       CALR1.
           MOVE IF-IMPOR TO COMFAT.
           COMPUTE COMR = COMFAT / T04-NRATE.
           COMPUTE COM1 = T04-NRATE - 1.
           COMPUTE COMUR = COMFAT - (COMR * COM1).
           MOVE ZERO TO K.
           IF IF-IMVAL = ZERO GO TO LCALR.
           MOVE IF-IMVAL TO COMFTV.
           COMPUTE COMRV = COMFTV / T04-NRATE.
           COMPUTE COM2  = T04-NRATE - 1.
           COMPUTE COMURV = COMFTV - (COMRV * COM2).
       LCALR.
           ADD 1 TO K.
           IF K > T04-NRATE MOVE ZERO TO K GO TO LCALV.
           MOVE COMUR TO IF-SC-IMRATA(K).
           IF K < T04-NRATE
              MOVE COMR TO IF-SC-IMRATA(K).
           GO TO LCALR.
       LCALV.
           IF IF-IMVAL = ZERO GO TO EX-RCALR.
           ADD 1 TO K.
           IF K > T04-NRATE GO TO EX-RCALR.
           MOVE COMURV TO IF-SC-VALRAT(K).
           IF K < T04-NRATE
              MOVE COMRV TO IF-SC-VALRAT(K).
           GO TO LCALV.
       EX-RCALR.
           EXIT.
      *------------------
       RCALR1.
           COMPUTE COMFAT = IF-IMPOR - TOTIVA.
           COMPUTE COMR = COMFAT / ( T04-NRATE - 1 ).
           COMPUTE COM1 = T04-NRATE - 2.
           COMPUTE COMUR = COMFAT - (COMR * COM1).
      **** rel 1.2
           COMPUTE COMFTV = IF-IMVAL - TOTIVV.
           COMPUTE COMRV = COMFTV / ( T04-NRATE - 1 ).
           COMPUTE COMURV = COMFTV - (COMRV * COM1).
      ************
           MOVE ZERO TO K.
       LCALR1.
           ADD 1 TO K.
           IF K > T04-NRATE GO TO EX-RCALR1.
      **** rel 1.2
      *    IF K = 1 MOVE TOTIVA TO IF-SC-IMRATA(K) GO TO LCALR1.
           IF K = 1 MOVE TOTIVA TO IF-SC-IMRATA(K)
                    MOVE TOTIVV TO IF-SC-VALRAT(K)
                    GO TO LCALR1.
      ************
           MOVE COMUR TO IF-SC-IMRATA(K).
      **** rel 1.2
           MOVE COMURV TO IF-SC-VALRAT(K).
      ************
           IF K < T04-NRATE
      **** rel 1.2
      *       MOVE COMR TO IF-SC-IMRATA (K).
              MOVE COMR  TO IF-SC-IMRATA(K)
              MOVE COMRV TO IF-SC-VALRAT(K).
      ************
           GO TO LCALR1.
       EX-RCALR1.
           EXIT.
      *------------------
       RCALR2.
           COMPUTE COMFAT = IF-IMPOR - TOTIVA.
           COMPUTE COMR = COMFAT / T04-NRATE.
           COMPUTE COM1 = T04-NRATE - 1.
           COMPUTE COMUR = COMFAT - (COMR * COM1).
      **** rel 1.2
           COMPUTE COMFTV = IF-IMVAL - TOTIVV.
           COMPUTE COMRV = COMFTV / T04-NRATE.
           COMPUTE COMURV = COMFTV - (COMRV * COM1).
      ************
           MOVE ZERO TO K.
       LCALR2.
           ADD 1 TO K.
           IF K > T04-NRATE GO TO EX-RCALR2.
           IF K = 1
              COMPUTE IF-SC-IMRATA(1) = COMR + TOTIVA
      **** rel 1.2
              COMPUTE IF-SC-VALRAT(1) = COMRV + TOTIVV
      ************
              GO TO LCALR2.
           MOVE COMUR TO IF-SC-IMRATA(K).
      **** rel 1.2
           MOVE COMURV TO IF-SC-VALRAT(K).
      ************
           IF K < T04-NRATE
      **** rel 1.2
      *       MOVE COMR TO IF-SC-IMRATA(K).
              MOVE COMR  TO IF-SC-IMRATA(K)
              MOVE COMRV TO IF-SC-VALRAT(K).
      ************
           GO TO LCALR2.
       EX-RCALR2.
           EXIT.
      *------------------
      **** rel 1.2
      * ricalcola importi rate scadenzario carico
      * in euro tramite triangolazione
      **** rel 4.0
      *RICAL-IMPSCA-LIRE.
       RICAL-IMPSCA-EURO.
      ************
           MOVE ZERO TO TIMRATA.
           MOVE ZERO TO K.
       RICAL-10.
           ADD 1 TO K.
           IF K > 12 GO TO RICAL-90.
           IF IF-SC-VALRAT(K) = ZERO GO TO RICAL-90.
           MOVE IF-SC-VALRAT(K) TO ER-IMPORTO.
           MOVE IF-CAMGG        TO ER-CAMBIO.
           MOVE IF-VALUT        TO ER-VALUT.
      **** rel 4.0
      *    MOVE IF-DATREG TO GGMMAA.
      *    MOVE 1 TO TIPOP1.
      *    CALL 'rdata' USING PARCDT.
      *    MOVE AAGGG TO ER-DATA.
      *    CALL 'rcamimp' USING ER-IMPORTO VAL-LIR ER-VALUT
      *                         ER-CAMBIO  ER-DATA.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT
                               ER-CAMBIO.
      ************
           MOVE ER-IMPORTO TO IF-SC-IMRATA(K).
           ADD  ER-IMPORTO TO TIMRATA.
           GO TO RICAL-10.
       RICAL-90.
      * carica su ultima scadenza la eventuale differenza
           IF K > 1 SUBTRACT 1 FROM K.
           COMPUTE IF-SC-IMRATA(K) = IF-SC-IMRATA(K) + IF-IMPOR
                                     - TIMRATA.
      **** rel 4.0
      *EX-RICAL-IMPSCA-LIRE.
       EX-RICAL-IMPSCA-EURO.
      ************
           EXIT.
      *------------------
      ************
       CERCA-SCA-PAR.
           MOVE ZERO TO SWCERCA.
           MOVE ZERO TO IF-PAR-SALDO
                        IF-PAR-VSALD
                        IF-PAR-VALUT
                        IF-PAR-CADOC.
           MOVE ZERO TO SWSCAD.
           IF IF-HS-TIPRG  = 1      GO TO END-CERCA-SCA-PAR.
           IF IF-T02-TIPOP = 1 OR 8 GO TO END-CERCA-SCA-PAR.
           IF IF-DOCUM = ZERO       GO TO END-CERCA-SCA-PAR.
           IF IF-T02-FLGSC = ZERO   GO TO RDPAR.
           MOVE LOW-VALUE TO KEYS2.
           MOVE CODICE TO KS2-CODCF.
           START ANASCA KEY NOT < KEYS2 INVALID GO TO RDPAR.
       RDSCA.
           READ ANASCA NEXT AT END GO TO RDPAR.
           IF KS2-CODCF > CODICE      GO TO RDPAR.
           IF KSC-AZI NOT = KAZ-COD   GO TO RDSCA.
           IF SCA-NDOC NOT = IF-DOCUM GO TO RDSCA.
      **** rel 5.0
           IF (KSC-TIPO = 3 OR 4) GO TO RDSCA.
      ************
           IF IF-DTDOC NOT = ZERO
              MOVE IF-DTDOC TO GGMMAA
              MOVE 1 TO TIPOP1
              CALL 'rdata' USING PARCDT
              IF SCA-DTDOC NOT = AAGGG GO TO RDSCA.
      **** rel 5.1
      * mod. per permettere richiamo partite pagate da registrazione
      * insoluto su effetti o tratte presentate e quindi con flag
      * presentato da distinta alto: sca-stato = 'D'
           IF (IF-T02-TIPOP = 3) AND (SCA-TPAG = 1 OR 2) AND
              (SCA-STATO = 'D')
              GO TO OKSCA.
      ************
           IF SCA-STATO = 'P' OR
              SCA-IMRATA = SCA-PAGATO GO TO RDSCA.
      **** rel 5.1
       OKSCA.
      ************
           COMPUTE IF-IMPOR = SCA-IMRATA  - SCA-PAGATO.
           COMPUTE IF-IMVAL = SCA-VALRATA - SCA-VALPAG.
      **** rel 5.2
           IF IF-IMPOR < 0 AND IF-T02-SEGNO = 0
              IF (IF-HS-TIPRG = 2 AND IF-D-A = 'D') OR
                 (IF-HS-TIPRG = 3 AND IF-D-A = 'A')
                 COMPUTE IF-IMPOR = IF-IMPOR * -1
                 COMPUTE IF-IMVAL = IF-IMVAL * -1.
      ************
           MOVE SCA-CDVAL TO IF-VALUT.
           MOVE SCA-CDVAL TO KTB-COD.
           MOVE 10        TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO T10-DSINT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT  TO IF-VALUT-D.
           MOVE SCA-CAMDOC TO IF-CAMGG.
           MOVE SCA-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DTDOC.
           MOVE KSC-DTSCA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DTSCD.
           MOVE 1 TO SWSCAD.
           GO TO END-CERCA-SCA-PAR.
       RDPAR.
           IF IF-T02-FLGEC NOT = ZERO GO TO END-CERCA-SCA-PAR.
           MOVE IF-HS-TIPRG  TO TIPO.
           MOVE CODCF        TO CLFO.
           MOVE IF-DOCUM     TO PARD.
           MOVE 1            TO NUME.
           MOVE KAZ-COD TO KPA-AZI.
           MOVE CAN     TO KPA-CAN.
           READ PARTIT INTO REKPAR INVALID
                MOVE ZERO TO PAR-SALDO PAR-VSALD
                GO TO END-CERCA-SCA-PAR.
           IF SF-PAR = '9D' OR '9A' OR '35' MOVE RF-PAR TO REKPAR.
           IF PAR-SALDO = ZERO AND PAR-VSALD = ZERO
              GO TO END-CERCA-SCA-PAR.
           IF PAR-VSALD NOT = ZERO
              IF PAR-SALDO = ZERO OR
                 (PAR-SALDO > ZERO AND PAR-VSALD < ZERO) OR
                 (PAR-SALDO < ZERO AND PAR-VSALD > ZERO)
                  GO TO END-CERCA-SCA-PAR.
           IF IF-HS-TIPRG = 3 MULTIPLY -1 BY PAR-SALDO PAR-VSALD.
           MOVE PAR-SALDO TO IF-IMPOR IF-PAR-SALDO.
           MOVE PAR-VSALD TO IF-IMVAL IF-PAR-VSALD.
           MOVE PAR-CADOC TO IF-CAMGG IF-PAR-CADOC.
           MOVE PAR-VALUT TO IF-VALUT IF-PAR-VALUT.
           MOVE PAR-VALUT TO KTB-COD.
           MOVE 10        TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO T10-DSINT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT TO IF-VALUT-D.
           MOVE 2 TO SWSCAD.
           IF PAR-SALDO < ZERO
              MULTIPLY -1 BY PAR-SALDO PAR-VSALD IF-IMPOR IF-IMVAL
              MOVE 1 TO SWCERCA
              IF IF-HS-TIPRG = 3
                 MOVE 'Importo a debito del fornitore' TO MESS
              ELSE
                 MOVE 'Importo a credito del cliente' TO MESS.
      **** rel 3.0
           READ PARTIT NEXT INTO REKPAR AT END GO TO END-CERCA-SCA-PAR.
           IF SF-PAR = '9D' OR '9A' OR '35' MOVE RF-PAR TO REKPAR.
           IF PAR-TIP = 2 AND PAR-NDOC = IF-DOCUM
              MOVE PAR-DTDOC TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GGMMAA TO IF-DTDOC.
      ************
       END-CERCA-SCA-PAR.
      *
       EX-CERCA-SCA-PAR.
           EXIT.
      *------------------
       CANC-WDS112.
           MOVE IF-PROGR TO K112-PROGR.
           READ WDS112 INVALID GO TO EX-CANC-WDS112.
           DELETE WDS112 INVALID
                  MOVE 'Errore cancellazione wds112' TO MESS
                  GO TO ERRIO.
       EX-CANC-WDS112.
           EXIT.
      *------------------
       CANC-WDS112-000.
           MOVE 000 TO K112-PROGR.
           READ WDS112 INVALID GO TO EX-CANC-WDS112-000.
           DELETE WDS112.
       EX-CANC-WDS112-000.
           EXIT.
      *------------------
      * assegna ultimo progressivo movimento utilizzato
       ATTR-ULT-PROGR.
           MOVE ZERO TO IF-PROGR.
           MOVE ZERO TO KLV-PROGR.
           START WDSLAV KEY NOT < KEYLV INVALID
                 GO TO END-ATTR-ULT-PROGR.
       ATTR-N-P-10.
           READ WDSLAV NEXT AT END GO TO EX-ATTR-ULT-PROGR.
           MOVE KLV-PROGR TO IF-PROGR.
           GO TO ATTR-N-P-10.
       END-ATTR-ULT-PROGR.
      *
       EX-ATTR-ULT-PROGR.
           EXIT.
      *------------------
       SELEZIONATO.
           MOVE IF-BUFF(1:3) TO PRGSELX.
           IF FUN = 'MM'
              IF PRGSELX(1:1) = 'I'
                 MOVE 'IF-IV-COD' TO IF-CAMPO
                 MOVE 1           TO IF-IDXVET
              ELSE
                 IF PRGSELX(1:1) = 'C'
                    MOVE 'IF-CP-COD'  TO IF-CAMPO
                    MOVE PRGSELX(3:1) TO IF-IDXVET
                 ELSE
                    MOVE 'IF-CAUS' TO IF-CAMPO.
           IF PRGSEL NUMERIC
              MOVE PRGSEL TO IF-PROGR
           ELSE
              MOVE 001 TO IF-PROGR.
      *------------------
      * compatta vettore IVA
       SHIFT-IF-IVA.
           MOVE 1 TO K1.
           PERFORM UNTIL K1 > 6
              IF IF-IV-COD(K1) = ZERO
                 MOVE K1 TO J1
                 ADD 1 TO J1
                 PERFORM UNTIL J1 > 6
                    IF IF-IV-COD(J1) NOT = ZERO
                       MOVE IF-IVA(J1)       TO IF-IVA(K1)
                       MOVE VIVA-INDEDUC(J1) TO VIVA-INDEDUC(K1)
                       MOVE ZERO  TO IF-IV-COD(J1)
                                     IF-ACEE-IV-IMPONV(J1)
                                     IF-IV-IMPON(J1)
                                     IF-IV-IMPOS(J1)
                                     IF-IV-PERPLA(J1)
                       MOVE SPACE TO IF-IV-DESCR(J1)
                       ADD 1 TO K1
                    END-IF
                    ADD 1 TO J1
                 END-PERFORM
                 MOVE 6 TO K1
              END-IF
              ADD 1 TO K1
           END-PERFORM.
      *------------------
      * compatta vettore C/P
       SHIFT-IF-CPAR.
           MOVE 1 TO K1.
      **** rel 6.2
      *    PERFORM UNTIL K1 > 7
           PERFORM UNTIL K1 > 15
      ************
              IF IF-CP-COD(K1) = ZERO
                 MOVE K1 TO J1
                 ADD 1 TO J1
      **** rel 6.2
      *          PERFORM UNTIL J1 > 7
                 PERFORM UNTIL J1 > 15
      ************
                    IF IF-CP-COD(J1) NOT = ZERO
                       MOVE IF-CPAR(J1) TO IF-CPAR(K1)
                       MOVE ZERO  TO IF-CP-COD(J1)
                                     IF-CP-IMPON(J1)
                                     IF-CP-FLCOSZ(J1)
                       MOVE SPACE TO IF-CP-DESCR(J1)
                                     IF-CP-DESAG(J1)
                                     IF-CP-CCOST(J1)
                       ADD 1 TO K1
                    END-IF
                    ADD 1 TO J1
                 END-PERFORM
      **** rel 6.2
      *          MOVE 7 TO K1
                 MOVE 15 TO K1
      ************
              END-IF
              ADD 1 TO K1
           END-PERFORM.
      *------------------
      * lancia routine di annullamento registrazione
       LANCIA-VUTI131.
           MOVE IF-AZI  TO CDAZ-131.
           MOVE IF-NREG TO NREG-131.
      **** rel 5.2
           MOVE 1 TO TIPOP1.
           MOVE IF-DTMOV TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO DTMOV-131.
      ************
           MOVE IF-FL   TO FL-131.
      * tolte le close di tutti gli altri files
           CLOSE WDSLCN.
           CLOSE WDSLAV.
           CLOSE WDSLA1.
      **** rel 5.1
           CLOSE WDSLA2.
      ************
           CLOSE WDS112.
           CLOSE WDS114.
           CLOSE WDS185.
           CLOSE WDS400.
      **** rel 6.1
           CLOSE WDSLA4.
      ************
           CALL 'vuti131' USING PARLINK-131.
           CANCEL 'vuti131'.
           IF ERRIO-ST = 9 GO TO ERRIO.
      * tolte le open di tutti gli altri files
           OPEN I-O WDSLCN.
           OPEN I-O WDSLAV.
           OPEN I-O WDSLA1.
      **** rel 5.1
           OPEN I-O WDSLA2.
      ************
           OPEN I-O WDS112.
           OPEN I-O WDS114.
           OPEN I-O WDS185.
           OPEN I-O WDS400.
      **** rel 6.1
           OPEN I-O WDSLA4.
      ************
      *------------------
      * creazione file di lavoro WDS114 da passare a vcon114
       CREA-WDS114.
           MOVE ZERO TO K114-PROG.
      *
           OPEN OUTPUT WDS114.
           CLOSE WDS114.
           OPEN I-O WDS114.
      *
           MOVE ZERO TO KLV-PROGR.
           START WDSLAV KEY NOT < KLV-PROGR INVALID
                 GO TO EX-CREA-WDS114.
       CREA-114-10.
           READ WDSLAV NEXT AT END GO TO EX-CREA-WDS114.
           PERFORM AZZ-REC114 THRU EX-AZZ-REC114.
           MOVE RECLAV TO IF-REC-WDS.
           IF IF-HS-FLGSC NOT = 1 GO TO CREA-114-20.
      *
      * dati REC114-4 - dati per aggiornamento E/C
      *
           IF IF-HS-SCA = ZERO GO TO CREA-114-20.
           MOVE KLV-PROGR TO KL1-PROGR.
           READ WDSLA1 INVALID PERFORM AZZ-IF-SCA
                               GO TO CREA-114-20.
           MOVE RECLA1 TO IF-AREA-SCA-CARICO.
           MOVE 1 TO K1.
           PERFORM UNTIL K1 > 12
              MOVE IF-SC-DTSCA(K1) TO GGMMAA
              MOVE 1 TO TIPOP1
              CALL 'rdata' USING PARCDT
              IF K1 <= 6
                 MOVE AAGGG TO L114-WBDSC(K1)
                 MOVE IF-SC-IMRATA(K1) TO L114-WBISC(K1)
                 MOVE IF-SC-VALRAT(K1) TO L114-WBVSC(K1)
              ELSE
                 ADD IF-SC-IMRATA(K1) TO L114-WBISC(6)
                 ADD IF-SC-VALRAT(K1) TO L114-WBVSC(6)
              END-IF
              ADD 1 TO K1
           END-PERFORM.
       CREA-114-20.
      *
      * dati REC114-1
      *
           MOVE IF-CAUS      TO L114-CAUSA.
           MOVE IF-HS-TIPRG  TO L114-TIPRG.
           MOVE IF-D-A       TO L114-DAVE.
           MOVE IF-T02-SEGNO TO L114-SEGNO.
           MOVE IF-T02-FLGIS TO L114-FLGIS.
           MOVE IF-T02-TIPOP TO L114-TIPOP.
           MOVE IF-HS-FLGSC  TO L114-FLGSC.
           IF L114-FLGSC = 4
              MOVE 3 TO L114-FLGSC.
      *
           IF IF-HS-FLGEC = ZERO
              MOVE 1 TO L114-FLGEC
           ELSE
              MOVE ZERO TO L114-FLGEC.
      *
      **** rel 2.0
           MOVE ZERO TO SAVCPCLF.
      ************
           MOVE IF-DESAG TO L114-DESAG.
           IF IF-HS-TIPRG = 1
              MOVE IF-PART TO L114-PART
           ELSE
              MOVE IF-CLIFOR TO CODCF
              IF IF-HS-TIPRG = 2
                 MOVE MCLI TO MAS
              ELSE
                 MOVE MFOR TO MAS
              END-IF
      **** rel 2.0
              MOVE CODICE TO SAVCPCLF
      ************
              MOVE CODICE TO L114-PART.
           MOVE IF-IMPOR TO L114-IMPOR.
           MOVE IF-DOCUM TO L114-DOCUM.
      *
           MOVE IF-DTDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO L114-DTDOC.
      *
           MOVE IF-DTSCD TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO L114-DTSCD.
      *
           MOVE IF-VALUT TO L114-VALUT.
           MOVE IF-CAMGG TO L114-CAMGG.
           MOVE IF-IMVAL TO L114-IMVAL.
           MOVE IF-CCOST TO L114-CCOST.
           IF IF-HS-CONTDIF = 1
              MOVE IF-DIFCAM TO L114-DFCAM.
      *
      * dati REC114-2
      *
           MOVE IF-CATT  TO L114-CATT.
           MOVE IF-NPRGI TO L114-NPRGI.
      **** rel 5.0-2
           IF IF-HS-TIPRG     = 3     AND
              IF-HS-ATTRN     = ZERO  AND
              CLF-13IVA       = 4     AND
              (IF-T02-TIPOP = 1 OR 8)
              IF (IF-NPRGI = ZERO) AND (IF-ACEE-NPRGIA NOT = ZERO)
      **** rel 6.1
                 MOVE IF-ACEE-CATTA  TO L114-CATT
      **************
                 MOVE IF-ACEE-NPRGIA TO L114-NPRGI.
      **************
           MOVE IF-CPART TO L114-CPART.
           IF IF-CPART NOT = ZERO
              MOVE IF-IMPOR  TO L114-IMPCP.
           MOVE IF-DESAG2 TO L114-DESA2.
           MOVE IF-CCOST2 TO L114-CCOS2.
           MOVE ZERO      TO L114-IVA.
      **** rel 3.0
      *    IF KLV-PROGR > 1
           IF KLV-PROGR > 1 AND PRG1-ATTRN = 1
      ************
              MOVE 3 TO L114-IVA
              PERFORM SCRIVI-REC114
              GO TO CREA-114-10.
           IF PRG1-ATTRN = ZERO PERFORM SCRIVI-REC114
                                GO TO CREA-114-10.
      **** rel 5.0-1
           IF PRG1-ATTRN   = 1    AND
              IF-IMPOR     = ZERO AND
              IF-IV-COD(1) = ZERO PERFORM SCRIVI-REC114
                                  GO TO CREA-114-10.
      ************
      *
      * fase di scrittura dati iva+c/p oppure solo iva
      *
      **** rel 4.0
           MOVE ZERO TO COMIMPON.
           MOVE 1 TO K2.
           PERFORM UNTIL K2 > 6 OR IF-IV-COD(K2) = ZERO
              ADD IF-IV-IMPON(K2)  TO COMIMPON
              ADD VIVA-INDEDUC(K2) TO COMIMPON
              ADD 1 TO K2.
      *
      ************
           MOVE 1        TO L114-IVA.
           MOVE ZERO TO K2.
       CREA-114-IVA-10.
           ADD 1 TO K2.
           IF K2 > 6 GO TO CREA-114-CP.
           IF IF-IV-COD(K2) = ZERO GO TO CREA-114-CP.
           IF PRG1-FLGIS NOT = 2
              PERFORM AZZ-REC114-2
              MOVE IF-CATT  TO L114-CATT
              MOVE IF-NPRGI TO L114-NPRGI.
           MOVE IF-IV-COD(K2)    TO L114-CDIVA.
           MOVE IF-IV-IMPON(K2)  TO L114-IMPON.
           MOVE IF-IV-IMPOS(K2)  TO L114-IMPOS.
           MOVE VIVA-INDEDUC(K2) TO L114-INDED.
           MOVE ZERO             TO L114-ESVEN.
      *
           IF T25-PLA = ZERO     GO TO CREA-114-IVA-20.
           IF IF-HS-FLTIG = ZERO GO TO CREA-114-IVA-20.
           MOVE IF-IV-COD(K2) TO KTB-COD.
           MOVE 3             TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
      **** rel 4.0-2
                                           GO TO ERRIO.
      *                                    GO TO V-ERROR.
      ************
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF NOT (T03-TPIVA = 3 OR 6) GO TO CREA-114-IVA-20.
           MOVE IF-IV-PMES(K2)   TO L114-PLAM.
           MOVE IF-DTDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF IF-IV-PANN(K2) < AA4
              MOVE 1 TO L114-PLAN
           ELSE
              IF IF-IV-PANN(K2) > AA4
                 COMPUTE L114-PLAN = IF-IV-PANN(K2) - AA4 + 1.
       CREA-114-IVA-20.
      *
      * cerca eventuale rigo c/p relativo al rigo iva
      *
      **** rel 4.0
           MOVE ZERO TO NCP.
           MOVE 1 TO K1.
      **** rel 6.2
      *    PERFORM UNTIL K1 > 7
           PERFORM UNTIL K1 > 15
      ************
              IF IF-CP-COD(K1) NOT = ZERO
                 ADD 1 TO NCP
              END-IF
              ADD 1 TO K1
           END-PERFORM.
      *
      ************
           MOVE 1 TO K1.
      **** rel 6.2
      *    PERFORM UNTIL K1 > 7
           PERFORM UNTIL K1 > 15
      ************
              IF IF-CP-COD(K1) NOT = ZERO
      **** rel 4.0
      *          IF IF-CP-IMPON(K1) = L114-IMPON + L114-INDED
                 IF (NCP = 1 AND IF-CP-IMPON(K1) = COMIMPON) OR
                    (NCP > 1 AND
                    IF-CP-IMPON(K1) = L114-IMPON + L114-INDED)
      ************
                    MOVE IF-CP-COD(K1)   TO L114-CPART
                    MOVE IF-CP-IMPON(K1) TO L114-IMPCP
                    MOVE IF-CP-DESAG(K1) TO L114-DESA2
                    MOVE IF-CP-CCOST(K1) TO L114-CCOS2
      **** rel 2.0
                    MOVE SAVCPCLF        TO L114-PART
      ************
      **** rel 5.2
                    PERFORM VER-CP THRU EX-VER-CP
      ************
                    MOVE ZERO  TO IF-CP-COD(K1)
                                  IF-CP-IMPON(K1)
                                  IF-CP-FLCOSZ(K1)
                    MOVE SPACE TO IF-CP-DESCR(K1)
                                  IF-CP-DESAG(K1)
                                  IF-CP-CCOST(K1)
      **** rel 6.2
      *             MOVE 7 TO K1
                    MOVE 15 TO K1
      ************
                 END-IF
              END-IF
              ADD 1 TO K1
           END-PERFORM.
      *
      * pagamento fatt. sospeso - righi solo IVA
      *
           IF IF-T02-FLGIS = 2 AND L114-IVA > 1
              MOVE ZERO TO L114-CPART
                           L114-IMPCP
              MOVE SPACE TO L114-DESA2
                            L114-CCOS2.
           PERFORM SCRIVI-REC114.
           MOVE 2 TO L114-IVA.
           GO TO CREA-114-IVA-10.
      *
      * scrive record solo c/p rimanenti
      *
       CREA-114-CP.
           PERFORM AZZ-REC114-2.
           MOVE 3 TO L114-IVA.
           MOVE IF-CATT  TO L114-CATT.
           MOVE IF-NPRGI TO L114-NPRGI.
           PERFORM CARICA-114-CP.
           IF L114-PART = ZERO
              GO TO CREA-114-10.
      *
      * pagamento fatt. sospeso - righi solo IVA
      *
           IF IF-T02-FLGIS = 2 AND L114-IVA > 1
              MOVE ZERO TO L114-CPART
                           L114-IMPCP
              MOVE SPACE TO L114-DESA2
                            L114-CCOS2.
      *
           PERFORM SCRIVI-REC114.
           GO TO CREA-114-CP.
       CREA-114-40.
      * record carico scadenzario
      * lasciato a zero, non gestito da vcon114
      *    05 REC114-3.
      *       10 L114-FLAG  PIC 9.
      *       10 L114-CDPAG PIC 999.
      *       10 L114-NRATE PIC 99.
      *       10 L114-SCAD  OCCURS 12.
      *          20 L114-TPAG  PIC 9.
      *          20 L114-DTSCA PIC 9(5) COMP-3.
      *          20 L114-IMRATA PIC S9(11) COMP-3.
      *          20 L114-VALRATA PIC S9(11)V99 COMP-3.
      *
       EX-CREA-WDS114.
           EXIT.
      *------------------
      * lancia routine di aggiornamento vcon114
       LANCIA-VCON114.
      * tolte le close di tutti gli altri files
           CLOSE WDSLCN.
           CLOSE WDSLAV.
           CLOSE WDSLA1.
      **** rel 5.1
           CLOSE WDSLA2.
      ************
           CLOSE WDS112.
           CLOSE WDS114.
           CLOSE WDS185.
           CLOSE WDS400.
      **** rel 6.1
           CLOSE WDSLA4.
      ************
      **** rel 4.0-2
           CLOSE PARTIT.
      ************
debug *    PERFORM CAR-FILDBG THRU EX-CAR-FILDBG.
           MOVE IF-FL  TO FL-114.
           MOVE IF-AZI TO CDAZ-114.
           IF IF-RG-FUN = 'M'
              MOVE IF-NREG TO NREG-114
           ELSE
              MOVE ZERO TO NREG-114.
           CALL 'vcon114' USING PARLINK-114.
           CANCEL 'vcon114'.
           IF NOT (ERRIO-ST = ZERO OR 8) GO TO ERRIO.
      * tolte le open di tutti gli altri files
           OPEN I-O WDSLCN.
           OPEN I-O WDSLAV.
           OPEN I-O WDSLA1.
      **** rel 5.1
           OPEN I-O WDSLA2.
      ************
           OPEN I-O WDS112.
           OPEN I-O WDS114.
           OPEN I-O WDS185.
           OPEN I-O WDS400.
      **** rel 6.1
           OPEN I-O WDSLA4.
      ************
      **** rel 4.0-2
           OPEN INPUT PARTIT.
      ************
       EX-LANCIA-VCON114.
           EXIT.
      *------------------
      * carica campi di wds114 relativi ad un rigo di sola c/p
       CARICA-114-CP.
           MOVE 1 TO K1.
           MOVE ZERO TO L114-PART.
      **** rel 6.2
      *    PERFORM UNTIL K1 > 7
           PERFORM UNTIL K1 > 15
      ************
              IF IF-CP-COD(K1) NOT = ZERO
                 MOVE IF-CP-COD(K1)   TO L114-PART
                 MOVE IF-CP-IMPON(K1) TO L114-IMPOR
                 MOVE IF-CP-DESAG(K1) TO L114-DESAG
                 MOVE IF-CP-CCOST(K1) TO L114-CCOST
      **** rel 2.0
                 MOVE SAVCPCLF        TO L114-CPART
      ************
                 IF IF-D-A = 'D'
                    MOVE 'A' TO L114-DAVE
                 ELSE
                    MOVE 'D' TO L114-DAVE
                 END-IF
      **** rel 5.2
                 PERFORM VER-CP THRU EX-VER-CP
      ************
                 MOVE ZERO  TO IF-CP-COD(K1)
                               IF-CP-IMPON(K1)
                               IF-CP-FLCOSZ(K1)
                 MOVE SPACE TO IF-CP-DESCR(K1)
                               IF-CP-DESAG(K1)
                               IF-CP-CCOST(K1)
      **** rel 6.2
      *          MOVE 7 TO K1
                 MOVE 15 TO K1
      ************
              END-IF
              ADD 1 TO K1
           END-PERFORM.
      *------------------
      * scrittura record su file di lavoro wds114
       SCRIVI-REC114.
           ADD 1 TO K114-PROG.
           WRITE RF-114 INVALID
                 MOVE 'Errore scrittura wds114' TO MESS
                 GO TO ERRIO.
      **** rel 5.2
           IF IF-FL = ZERO AND IF-FLAVE = 1
              PERFORM SCRIVI-WDSLA3 THRU EX-SCRIVI-WDSLA3.
      ************
      *------------------
      * azzeramento aree di WDS114 (area wrklav)
       AZZ-REC114.
      * record 1
       AZZ-REC114-1.
           MOVE ZERO  TO REC114-1.
           MOVE ZERO  TO L114-IMPOR
                         L114-DTDOC
                         L114-DTSCD
                         L114-VALUT
                         L114-CAMGG
                         L114-IMVAL
                         L114-DFCAM.
           MOVE SPACE TO L114-DAVE
                         L114-DESAG
                         L114-CCOST
                         L114-DAVDF.
      * record 2
       AZZ-REC114-2.
           MOVE ZERO  TO REC114-2.
           MOVE ZERO  TO L114-IMPCP
                         L114-DTSC2
                         L114-IMPON
                         L114-IMPOS
                         L114-INDED.
           MOVE SPACE TO L114-DESA2
                         L114-CCOS2
                         L114-CATT.
      * record 3
       AZZ-REC114-3.
           MOVE ZERO  TO REC114-3.
           MOVE 1 TO K1.
           PERFORM UNTIL K1 > 12
              MOVE ZERO TO L114-TPAG(K1)
                           L114-DTSCA(K1)
                           L114-IMRATA(K1)
                           L114-VALRATA(K1)
              ADD 1 TO K1
           END-PERFORM.
       AZZ-REC114-4.
           MOVE ZERO  TO REC114-4.
           MOVE 1 TO K1.
           PERFORM UNTIL K1 > 6
              MOVE ZERO TO L114-WBDSC(K1)
                           L114-WBISC(K1)
                           L114-WBVSC(K1)
              ADD 1 TO K1
           END-PERFORM.
       EX-AZZ-REC114.
           EXIT.
      *------------------
      * creazione file di lavoro WDS400 da passare a vcon400
       CREA-WDS400.
           MOVE ZERO TO K40-PROG.
      *
           OPEN OUTPUT WDS400.
           CLOSE WDS400.
           OPEN I-O WDS400.
      *
           MOVE 001 TO KLV-PROGR.
           READ WDSLAV INVALID GO TO EX-CREA-WDS400.
           PERFORM AZZ-REC400.
           MOVE RECLAV TO IF-REC-WDS.
      **** rel 5.0
           IF IF-RG-FUN NOT = 'M'
              IF FLINTRA = 1 AND IF-HS-ACEE = ZERO AND FLGACF = 1
              MOVE 'Il programma non provvede          ' TO F-MES1
              MOVE 'all''aggiornamento Elenchi IVA CEE ' TO F-MES2
              MOVE '(Mod. INTRA) per note di accredito.' TO F-MES3
              MOVE 'Effettuare le eventuali rettifiche ' TO F-MES4
              MOVE 'con l''apposito programma.         ' TO F-MES5
              MOVE 5 TO F-NMES
              CALL 'vrmbox' USING PARMB.
      ************
           IF IF-HS-ACEE = ZERO GO TO EX-CREA-WDS400.
      *
           MOVE ZERO              TO L40-IVA.
           MOVE IF-ACEE-CAUS      TO L40-CAUSA.
           MOVE IF-ACEE-T02-TIPRG TO L40-TIPRG.
           MOVE IF-ACEE-T02-D-A   TO L40-DAVE.
           MOVE IF-ACEE-T02-SEGNO TO L40-SEGNO.
           MOVE IF-ACEE-T02-TIPOP TO L40-TIPOP.
      *
           MOVE IF-CLIFOR TO CODCF.
           MOVE MFOR TO MAS.
           MOVE CODICE TO L40-PART.
      *
           MOVE IF-IMVAL TO L40-IMPES.
           MOVE IF-IMPOR TO L40-IMPOR.
           MOVE IF-DOCUM TO L40-DOCUM.
      *
           MOVE IF-DTDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO L40-DTDOC.
      *
           MOVE IF-VALUT       TO L40-VALUT.
           MOVE IF-CP-COD(1)   TO L40-CPART.
           MOVE IF-CP-IMPON(1) TO L40-IMPCP.
           MOVE IF-ACEE-CATTA  TO L40-CATA.
           MOVE IF-ACEE-NPRGIA TO L40-NPRGA.
           MOVE IF-ACEE-CATTV  TO L40-CATV.
           MOVE IF-ACEE-NPRGIV TO L40-NPRGV.
           MOVE 1 TO L40-IVA.
      *
           MOVE 1 TO K2.
           PERFORM UNTIL K2 > 6
              IF IF-IV-COD(K2) NOT = ZERO
                 MOVE IF-IV-COD(K2)         TO L40-CDIVA
                 MOVE IF-ACEE-IV-IMPONV(K2) TO L40-IMPOE
                 MOVE IF-IV-IMPON(K2)       TO L40-IMPON
                 MOVE IF-IV-IMPOS(K2)       TO L40-IMPOS
                 MOVE VIVA-INDEDUC(K2)      TO L40-INDED
                 MOVE IF-IV-PMES(K2)        TO L40-PLAM
                 MOVE IF-DTDOC TO GGMMAA
                 MOVE 1 TO TIPOP1
                 CALL 'rdata' USING PARCDT
                 IF IF-IV-PANN(K2) < AA4
                    MOVE 1 TO L40-PLAN
                 ELSE
                    IF IF-IV-PANN(K2) > AA4
                       COMPUTE L40-PLAN = IF-IV-PANN(K2) - AA4 + 1
                    END-IF
                 END-IF
                 PERFORM SCRIVI-REC400
                 MOVE ZERO TO L40-CPART
                 MOVE ZERO TO L40-IMPCP
              END-IF
              ADD 1 TO K2
           END-PERFORM.
      *
       EX-CREA-WDS400.
           EXIT.
      *------------------
      * scrittura record su file di lavoro wds400
       SCRIVI-REC400.
           ADD 1 TO K40-PROG.
           WRITE RF-400 INVALID
                 MOVE 'Errore scrittura wds400' TO MESS
                 GO TO ERRIO.
      *------------------
      * azzeramento area di WDS400
       AZZ-REC400.
           MOVE ZERO TO RF-400.
           MOVE ZERO TO L40-IMPES
                        L40-IMPOR
                        L40-IMPCP
                        L40-IMPOE
                        L40-IMPON
                        L40-IMPOS
                        L40-INDED.
           MOVE SPACE TO L40-DAVE
                         L40-CATA
                         L40-CATV.
      *------------------
      * lancia routine di aggiornamento vcon400
       LANCIA-VCON400.
           MOVE 001 TO K40-PROG.
           READ WDS400 INVALID GO TO EX-LANCIA-VCON400.
      *
      * tolte le close di tutti gli altri files
           CLOSE WDSLCN.
           CLOSE WDSLAV.
           CLOSE WDSLA1.
      **** rel 5.1
           CLOSE WDSLA2.
      ************
           CLOSE WDS112.
           CLOSE WDS114.
           CLOSE WDS185.
           CLOSE WDS400.
      **** rel 6.1
           CLOSE WDSLA4.
      ************
           MOVE DTCON-114 TO DTCON-400.
           MOVE IF-FL     TO FL-400.
           MOVE IF-AZI    TO CDAZ-400.
      **** rel 5.2
           MOVE ZERO      TO FLTRA-400.
      ************
           CALL 'vcon400' USING PARLINK-400.
           CANCEL 'vcon400'.
           IF NOT (ERRIO-ST = ZERO OR 8) GO TO ERRIO.
      **** rel 6.3
           MOVE W400-KEYTRA TO IF-AREA-KTRA.
      ************
      * tolte le open di tutti gli altri files
           OPEN I-O WDSLCN.
           OPEN I-O WDSLAV.
           OPEN I-O WDSLA1.
      **** rel 5.1
           OPEN I-O WDSLA2.
      ************
           OPEN I-O WDS112.
           OPEN I-O WDS114.
           OPEN I-O WDS185.
           OPEN I-O WDS400.
      **** rel 6.1
           OPEN I-O WDSLA4.
      ************
       EX-LANCIA-VCON400.
           EXIT.
      *------------------
      **** rel 5.0
      * lancia routine vcon440 per aggiornamento elenchi CEE (INTRA)
       LANCIA-VCON440.
           IF FLINTRA NOT = 1 GO TO EX-LANCIA-VCON440.
           IF IF-HS-TIPRG NOT = 2 GO TO EX-LANCIA-VCON440.
      *
           MOVE ZERO  TO PARTRA.
           MOVE SPACE TO PTRA-CATT PTRA-TRAN.
           MOVE ZERO      TO PTRA-NOMME.
           MOVE 1         TO PTRA-PROG.
           MOVE IF-T02-TIPOP TO PTRA-TIPOP.
           MOVE IF-AZI    TO PTRA-AZI.
           MOVE DTCON-114 TO PTRA-DAT.
           MOVE IF-CATT   TO PTRA-CATT.
           MOVE IF-NPRGI  TO PTRA-NPRGI.
           MOVE SAVCPCLF  TO PTRA-CLFO.
           MOVE COMIMPON  TO PTRA-IML.
      **** rel 7.1
           MOVE ZERO      TO PTRA-IMV.
           MOVE ZERO      TO PTRA-VAL.
           MOVE ZERO      TO PTRA-MNET.
           MOVE SPACE     TO PTRA-CDPRO.
           MOVE SPACE     TO PTRA-CDPAP.
           MOVE SPACE     TO PTRA-CDPAO.
           MOVE SPACE     TO PTRA-SPAEP.
           MOVE SPACE     TO PTRA-MOER.
           MOVE SPACE     TO PTRA-MOIN.
           MOVE SPACE     TO PTRA-NATRA.
           MOVE ZERO      TO PTRA-FLGFIS.
           MOVE ZERO      TO PTRA-VASTA.
      ************
           MOVE IF-DOCUM  TO PTRA-NUDOC.
           MOVE IF-DTDOC  TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG    TO PTRA-DTDOC.
           MOVE 'C'      TO PTRA-TRAN.
      **** rel 7.1
           PERFORM VERIFICA-TIPO THRU EX-VERIFICA-TIPO.
      ********
           CALL 'vcon440' USING PARTRA.
           CANCEL 'vcon440'.
           IF NOT (ERRIO-ST = ZERO OR 8) GO TO ERRIO.
      **** rel 6.3
           MOVE PTRA-KEYTRA TO IF-AREA-KTRA.
      ************
      *
       EX-LANCIA-VCON440.
           EXIT.
      *------------------
      ************
      * fase di aggiornamento scadenzario in carico
      * serve in input: file di lavoro WDSLA1 e WDSLAV
       AGG-SCAD-CARICO.
      **** rel 5.0
           IF (IF-RG-FUN = 'M') AND (FLGSCA = ZERO OR 2 OR 3)
              GO TO EX-AGG-SCAD-CARICO.
      ************
      **** rel 5.0-1
           MOVE ZERO TO FLGPAN.
      ************
      **** rel 3.0a
           IF IF-FL NOT = ZERO
              CLOSE ANAAZI
              MOVE 'anaazi' TO ID-AZI
              OPEN I-O ANAAZI.
      *************
           PERFORM RD-AZI-LOCK THRU EX-RD-AZI-LOCK.
           MOVE AZI-PRSCA TO KSC-PRG.
      *
           MOVE ZERO TO KL1-PROGR.
           START WDSLA1 KEY NOT < KL1-PROGR INVALID
                 GO TO AGG-SCAD-CAR-90.
       AGG-SCAD-CAR-10.
           READ WDSLA1 NEXT AT END GO TO AGG-SCAD-CAR-90.
           MOVE RECLA1 TO IF-AREA-SCA-CARICO.
      * conta numero rate totali
           MOVE ZERO TO SCA-RATE.
           MOVE 1 TO K1.
           PERFORM UNTIL K1 > 12
              IF IF-SC-DTSCA(K1) NOT = ZERO
                 ADD 1 TO SCA-RATE
              END-IF
              ADD 1 TO K1
           END-PERFORM.
      *
           MOVE KL1-PROGR TO KLV-PROGR.
           READ WDSLAV INVALID GO TO AGG-SCAD-CAR-10.
           MOVE RECLAV TO IF-REC-WDS.
      **** rel 5.1
           MOVE ZERO TO DTSCA DTREG.
           MOVE IF-DATREG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG   TO DTREG.
           MOVE IF-SC-DTSCA(1) TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG   TO DTSCA.
      ************
      **** rel 5.0
           IF IF-HS-TIPRG    = 3         AND
              SCA-RATE       = 1         AND
      **** rel 5.0-1
      *       IF-SC-DTSCA(1) < IF-DATREG AND
      *       IF-SC-DTSCA(1) < IF-DTDOC  AND
      **** rel 5.1
      *       IF-SC-DTSCA(1) <= IF-DATREG AND
              DTSCA <= DTREG AND
      ************
      ************
              IF-SC-TPAG(1)  = 9
      **** rel 5.0-1
              MOVE 1 TO FLGPAN
      ************
              IF IF-SCA-PRG  NOT = ZERO
                 PERFORM RWR-SCAD-PAGANT THRU EX-RWR-SCAD-PAGANT
                 GO TO AGG-SCAD-CAR-10
              ELSE
                 MOVE "Non e'' stata selezionata alcuna " TO F-MES1
                 MOVE "scadenza di pagamento anticipato." TO F-MES2
                 MOVE "Nessun aggiornamento effettuato ." TO F-MES3
                 MOVE 3 TO F-NMES
                 CALL 'vrmbox' USING PARMB
                 GO TO AGG-SCAD-CAR-10.
      ************
      *
           MOVE ZERO TO K1.
       AGG-SCAD-CAR-20.
           ADD 1 TO K1.
           IF K1 > 12 GO TO AGG-SCAD-CAR-10.
           IF IF-SC-DTSCA(K1) = ZERO GO TO AGG-SCAD-CAR-20.
           MOVE KAZ-COD TO KSC-AZI.
           IF IF-HS-TIPRG = 2
              MOVE 1 TO KSC-TIPO
           ELSE
              MOVE 2 TO KSC-TIPO.
           ADD 1 TO KSC-PRG.
      *
           MOVE IF-SC-DTSCA(K1) TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      **** rel 5.0
      *    MOVE AAGGG TO KSC-DTSCA KS2-DTSCA KS3-DTSCA.
           MOVE AAGGG TO KSC-DTSCA KS2-DTSCA KS3-DTSCA SCA-DTSCAO.
      ************
      *
           MOVE IF-CLIFOR TO CODCF.
           IF IF-HS-TIPRG = 2
              MOVE MCLI TO MAS
           ELSE
              MOVE MFOR TO MAS.
           MOVE CODICE TO KS2-CODCF.
           MOVE IF-DOCUM TO SCA-NDOC.
      *
           MOVE IF-DTDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO SCA-DTDOC.
      *
           MOVE IF-IMPOR TO SCA-IMPOR.
           MOVE IF-IMVAL TO SCA-VALDOC.
           MOVE IF-SC-IMRATA(K1) TO SCA-IMRATA.
           MOVE IF-SC-VALRAT(K1) TO SCA-VALRATA.
      *
           IF IF-HS-TIPRG = 2 GO TO AGG-SCAD-CAR-22.
           IF IF-D-A = 'D' MULTIPLY -1 BY SCA-IMPOR
                           MULTIPLY -1 BY SCA-VALDOC
                           MULTIPLY -1 BY SCA-IMRATA
                           MULTIPLY -1 BY SCA-VALRATA.
           IF IF-D-A = 'A' AND IF-T02-SEGNO = 1
              MULTIPLY -1 BY SCA-IMPOR
              MULTIPLY -1 BY SCA-VALDOC
              MULTIPLY -1 BY SCA-IMRATA
              MULTIPLY -1 BY SCA-VALRATA.
           GO TO AGG-SCAD-CAR-24.
       AGG-SCAD-CAR-22.
           IF IF-D-A = 'A' MULTIPLY -1 BY SCA-IMPOR
                           MULTIPLY -1 BY SCA-VALDOC
                           MULTIPLY -1 BY SCA-IMRATA
                           MULTIPLY -1 BY SCA-VALRATA.
           IF IF-D-A = 'D' AND IF-T02-SEGNO = 1
              MULTIPLY -1 BY SCA-IMPOR
              MULTIPLY -1 BY SCA-VALDOC
              MULTIPLY -1 BY SCA-IMRATA
              MULTIPLY -1 BY SCA-VALRATA.
       AGG-SCAD-CAR-24.
           MOVE IF-CDPAG         TO SCA-CDPAG.
           MOVE IF-SC-TPAG(K1)   TO SCA-TPAG.
           MOVE K1               TO SCA-NRATA.
           MOVE ZERO             TO SCA-PAGATO.
           MOVE ZERO             TO SCA-VALPAG.
      **** rel 6.3
      *    MOVE SPACE            TO SCA-STATO.
           IF NOT SCA-STATO = 'R'
              MOVE SPACE TO SCA-STATO.
      ************
      **** rel 5.1
           IF (PRA-FLSCA = 1)
              IF (IF-HS-TIPRG = 2)  AND (IF-HS-FLGSC = 1) AND
                 (IF-T02-TIPOP = 1) AND (IF-SC-TPAG(K1) = 1 OR 2)
                 MOVE 'D' TO SCA-STATO.
      ************
           IF IF-HS-TIPRG > 1 AND (IF-HS-FLGSC = 3 OR 4)
              MOVE 'R' TO SCA-STATO.
           MOVE IF-CATT  TO SCA-CATT.
      **** rel 4.1
           IF SCA-STATO = 'R'
              IF SCA-CATT = SPACE
                 MOVE '0' TO SCA-CATT.
      ************
           MOVE IF-NPRGI TO SCA-NPROT.
      **** rel 5.0-2
           IF IF-HS-TIPRG     = 3     AND
              IF-HS-ATTRN     = ZERO  AND
              CLF-13IVA       = 4     AND
              (IF-T02-TIPOP = 1 OR 8)
              IF (IF-NPRGI = ZERO) AND (IF-ACEE-NPRGIA NOT = ZERO)
      **** rel 6.1
                 MOVE IF-ACEE-CATTA  TO SCA-CATT
      **************
                 MOVE IF-ACEE-NPRGIA TO SCA-NPROT.
      **************
           MOVE ZERO     TO SCA-SOLL.
      **** rel 5.0
      *    MOVE ZERO     TO SCA-FILL.
           MOVE SPACE    TO SCA-CODCFL.
           MOVE NREG-114 TO SCA-NREG.
      ************
      **** rel 6.2
      *    MOVE SPACE    TO SCA-NOTE.
           MOVE IF-SC-NOTE(K1) TO SCA-NOTE.
      ************
           MOVE IF-CDBAN TO KS3-BAN.
           MOVE IF-CAMGG TO SCA-CAMDOC.
           MOVE ZERO     TO SCA-CAMPAG.
           MOVE IF-VALUT TO SCA-CDVAL.
      **** rel 7.1
           IF SCA-TPAG = 9
                MOVE 'P' TO SCA-STATO
                MOVE SCA-IMRATA TO SCA-PAGATO. 
      ************
           WRITE RF-SCA INVALID PERFORM INVK-SCA
                                GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
      **** rel 6.2
      **** rel 6.3
           IF IF-SC-NOTEA(K1) = SPACE GO TO AGG-SCAD-CAR-30.
      ************
           MOVE ZERO      TO RF-NSC.
           MOVE KSC-AZI   TO KNSC-AZI.
           MOVE KSC-TIPO  TO KNSC-TIPO.
           MOVE KSC-DTSCA TO KNSC-DTSCA.
           MOVE KSC-PRG   TO KNSC-PRG.
           MOVE 1         TO KNSC-PRGN.
           MOVE IF-SC-NOTEA(K1) TO NSC-DESCR.
           WRITE RF-NSC INVALID PERFORM INVK-NSC
                                GO TO ERRIO.
      **** rel 6.3
       AGG-SCAD-CAR-30.
      ************
      ************
      **** rel 5.1
           IF (PRA-FLSCA = 1)
              IF (IF-HS-TIPRG = 2)  AND (IF-HS-FLGSC = 1) AND
                 (IF-T02-TIPOP = 1) AND (IF-SC-TPAG(K1) = 1 OR 2)
              MOVE SCA-IMRATA  TO VET-PAGRATA(K1)
              MOVE SCA-VALRATA TO VET-VPAGRAT(K1)
              PERFORM AGG-DETSCA-CARICO THRU EX-AGG-DETSCA-CARICO.
      ************
           GO TO AGG-SCAD-CAR-20.
       AGG-SCAD-CAR-90.
           IF KSC-PRG = AZI-PRSCA GO TO AGG-SCAD-CAR-95.
      **** rel 5.0-1
           IF FLGPAN NOT = ZERO   GO TO AGG-SCAD-CAR-95.
      ************
           MOVE KSC-PRG TO AZI-PRSCA.
           REWRITE RF-AZI FROM REKAZI INVALID PERFORM INVK-AZI
                                              GO TO ERRIO.
       AGG-SCAD-CAR-95.
           UNLOCK ANAAZI.
      **** rel 3.0a
           IF IF-FL = ZERO GO TO AGG-SCAD-CAR-98.
           CLOSE ANAAZI.
           MOVE 'anazol' TO ID-AZI.
           OPEN I-O ANAAZI.
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
       AGG-SCAD-CAR-98.
      *************
       EX-AGG-SCAD-CARICO.
           EXIT.
      *------------------
      * fase di aggiornamento scadenzario in scarico
      * serve in input: file di lavoro WDS112
       AGG-SCAD-SCARICO.
      **** rel 5.0
           IF (IF-RG-FUN = 'M') AND (FLGSCA = ZERO OR 2 OR 3)
              GO TO EX-AGG-SCAD-SCARICO.
      ************
           MOVE ZERO TO K112-PROGR.
           START WDS112 KEY NOT < K112-PROGR INVALID
                 GO TO AGG-SCAD-SCAR-90.
       AGG-SCAD-SCAR-10.
           READ WDS112 NEXT AT END GO TO AGG-SCAD-SCAR-90.
           MOVE REC112 TO VET-SCARICO.
      * lettura wdslav per ottenere if-camgg.
           MOVE K112-PROGR TO KLV-PROGR.
           READ WDSLAV INVALID MOVE ZERO TO IF-CAMGG
                               GO TO AGG-SCAD-SCAR-15.
           MOVE RECLAV TO IF-REC-WDS.
      *
       AGG-SCAD-SCAR-15.
           MOVE ZERO TO K1.
       AGG-SCAD-SCAR-20.
           ADD 1 TO K1.
      **** rel 4.0-2
      *    IF K1 > 24 GO TO AGG-SCAD-SCAR-10.
           IF K1 > 192 GO TO AGG-SCAD-SCAR-10.
      ************
           IF VETK-DTSCA(K1) = ZERO GO TO AGG-SCAD-SCAR-20.
           MOVE IF-AZI     TO KSC-AZI.
           MOVE VETK-TIPO(K1)  TO KSC-TIPO.
           MOVE VETK-DTSCA(K1) TO KSC-DTSCA.
           MOVE VETK-PRG(K1)   TO KSC-PRG.
           READ ANASCA KEPT LOCK INVALID PERFORM INVK-SCA GO TO ERRIO.
           IF VET-SALDO(K1) = 'S' OR 'I'
              MOVE VET-SALDO(K1) TO SCA-STATO
              GO TO AGG-SCAD-SCAR-30.
           IF VET-SALDO(K1) = 'X'
              MOVE 'P' TO SCA-STATO
              MOVE SCA-IMRATA TO SCA-PAGATO
              MOVE SCA-VALRATA TO SCA-VALPAG
              GO TO AGG-SCAD-SCAR-30.
           ADD VET-PAGRATA(K1) TO SCA-PAGATO.
           ADD VET-VPAGRAT(K1) TO SCA-VALPAG.
           MOVE IF-CAMGG       TO SCA-CAMPAG.
       AGG-SCAD-SCAR-30.
           REWRITE RF-SCA INVALID PERFORM INVK-SCA GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
           UNLOCK ANASCA.
      **** rel 5.0
           PERFORM AGG-DETSCA-CARICO  THRU EX-AGG-DETSCA-CARICO.
      ************
           GO TO AGG-SCAD-SCAR-20.
       AGG-SCAD-SCAR-90.
      *
       EX-AGG-SCAD-SCARICO.
           EXIT.
      *------------------
      * legge azienda con lock
       RD-AZI-LOCK.
           MOVE IF-AZI TO KAZ-COD.
       RD-AZI-L-10.
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID PERFORM INVK-AZI
                                                     GO TO ERRIO.
      **** rel 2.0
      *    IF SF-AZI NOT = ZERO PERFORM ERR-LOCK
           IF SF-AZI NOT = ZERO PERFORM REC-LOCK
      ************
                                GO TO RD-AZI-L-10.
      **** rel 2.0
           MOVE IF-AZI TO KPR-COD.
           READ PROAZI INVALID PERFORM INVK-PRA
                               GO TO ERRIO.
      ************
       EX-RD-AZI-LOCK.
      *------------------
      * pagamento fattura in sospeso
      * carica dati IVA interfaccia come da dati letti da fatsos
       FTS-PAG.
           MOVE ZERO TO SWERR-FTSP.
           MOVE IF-AZI    TO KFS-AZI.
           MOVE IF-CLIFOR TO KFS-CLI.
           MOVE ANNO      TO KFS-ANNO.
           IF IF-CATT = SPACE MOVE '0' TO IF-CATT.
           MOVE IF-CATT   TO KFS-CATT.
           MOVE IF-DOCUM  TO KFS-NFAT.
           READ FATSOS INVALID
                MOVE 'Fattura in sospeso inesistente' TO MESS
                GO TO FTS-PAG-ERR.
           MOVE FTS-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DTDOC.
           IF NOT (IF-T02-FLGIS = 2 AND AZI-FLGIS = 2) GO TO FTS-PAG-20.
           MOVE 010198 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF FTS-DTDOC NOT < AAGGG
              MOVE FTS-NREG TO IF-NPRGI
           ELSE
              IF IF-NPRGI = ZERO
                 MOVE 'Manca protocollo IVA, obbligatorio' TO MESS
                 GO TO FTS-PAG-ERR.
       FTS-PAG-20.
           IF AAGGG > AZI-ULTDT
              MOVE 'Data fatt. sosp. > data contabile' TO MESS
              GO TO FTS-PAG-ERR.
           IF FTS-FLAG = 1
              MOVE 'Fattura sospeso gia'' saldata' TO MESS
              GO TO FTS-PAG-ERR.
           MOVE ZERO TO FATTUR.
      *
           MOVE 1 TO L.
           PERFORM UNTIL L > 6
              COMPUTE FATTUR = FATTUR + FTS-IMPON(L) + FTS-IMIVA(L)
                                     - (FTS-IMPAG(L) + FTS-IVPAG(L))
              ADD 1 TO L
           END-PERFORM.
      *
      **** rel 2.0
      **** rel 5.1
      *    IF FUN = 'W' AND IF-IMPOR NOT = ZERO
           IF (FUN = 'W' OR 'w') AND (IF-IMPOR NOT = ZERO)
      ************
              IF FATTUR = ZERO
                 MOVE 'Fattura sospeso gia'' saldata' TO MESS
                 GO TO FTS-PAG-ERR
              ELSE
              IF IF-IMPOR > FATTUR
                 MOVE 'Importo superiore al residuo fattura' TO MESS
                 GO TO FTS-PAG-ERR
              ELSE
                 GO TO EX-FTS-PAG.
      ************
           MOVE FATTUR TO IF-IMPOR.
           IF FATTUR = ZERO
              MOVE 'Fattura sospeso gia'' saldata' TO MESS
              GO TO FTS-PAG-ERR.
           MOVE ZERO TO L COMODO.
       FTS-PAG-30.
           ADD 1 TO L.
           IF L > 6 GO TO FTS-PAG-40.
           COMPUTE IF-IV-IMPON(L) = FTS-IMPON(L) - FTS-IMPAG(L).
           COMPUTE IF-IV-IMPOS(L) = FTS-IMIVA(L) - FTS-IVPAG(L).
           MOVE FTS-CDIVA(L) TO IF-IV-COD(L).
           GO TO FTS-PAG-30.
       FTS-PAG-40.
           PERFORM SHIFT-IF-IVA.
           PERFORM CALC-IV-IMPON.
           PERFORM CALC-IV-DIFF.
           GO TO EX-FTS-PAG.
       FTS-PAG-ERR.
           MOVE 1 TO SWERR-FTSP.
       EX-FTS-PAG.
           EXIT.
      *------------------
      * controlla se ci sono mov. dei lavoratori autonomi da eseguire
       LAV-AUTONOMI.
           MOVE LOW-VALUE TO KEY185.
           START WDS185 KEY > KEY185 INVALID MOVE ZERO TO IF-RIT
                                             GO TO END-LAV-AUTONOMI.
       RDN-L185.
           READ WDS185 NEXT AT END MOVE ZERO TO IF-RIT
                                   GO TO END-LAV-AUTONOMI.
           MOVE K185-TIPO TO IF-RIT.
           IF IF-RIT NOT = 7 GO TO END-LAV-AUTONOMI.
      *
      * solo se versamento (if-rit = 7)
      * preparazione anno di elaborazione
      * cancellazione record da wds185
      * Nota: la cancellazione record da wds185
      *       per documenti e pagamenti, viene effettuata
      *       da vrit186 dopo aver caricato l'are d'interfaccia
      *
           MOVE IF-DATREG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO IF-AUV-ANNO.
           DELETE WDS185.
       END-LAV-AUTONOMI.
      *
       EX-LAV-AUTONOMI.
           EXIT.
      *------------------
      * calcola le eventuali differenze cambi e differenze valutarie.
      * sara'a  cura dell'interfaccia, qualora si presenti una
      * differenza cambio, a chiedere se dovra' essere contabilizzata.
       CALC-DIFCAM.
           MOVE ZERO TO IF-DIFCAM
                        IF-DIFVAL.
           IF IF-T02-TIPOP = 3 GO TO EX-CALC-DIFCAM.
      **** rel 4.0
      *    IF IF-VALUT < 2     GO TO EX-CALC-DIFCAM.
           IF (IF-VALUT = ZERO OR COMEURO) GO TO EX-CALC-DIFCAM.
      ************
      **** rel 3.0
           IF IF-HS-TIPRG  = 1      GO TO EX-CALC-DIFCAM.
           IF IF-T02-TIPOP = 1 OR 8 GO TO EX-CALC-DIFCAM.
           IF IF-DOCUM = ZERO       GO TO EX-CALC-DIFCAM.
      ************
           IF IF-HS-FLGSC = ZERO GO TO CALC-DF-PAR.
      * calcolo differenza cambio da dati scadenzario
           MOVE 000 TO K112-PROGR.
           READ WDS112 INVALID GO TO END-CALC-DIFCAM.
           MOVE REC112 TO VET-SCARICO.
           MOVE 1 TO K1.
      **** rel 4.0-2
      *    PERFORM UNTIL K1 > 24
           PERFORM UNTIL K1 > 192
      ************
              COMPUTE IF-DIFVAL =
                      IF-DIFVAL + VET-VALRAT(K1) - VET-VPAGRAT(K1)
              IF VET-SALDO(K1) = 'X'
                 COMPUTE IF-DIFCAM =
                         IF-DIFCAM - VET-IMRATA(K1) + VET-PAGRATA(K1)
              END-IF
              ADD 1 TO K1
           END-PERFORM.
           IF IF-DIFVAL NOT = ZERO MOVE ZERO TO IF-DIFCAM.
           GO TO END-CALC-DIFCAM.

      * calcolo differenza cambio da dati partitario
       CALC-DF-PAR.
      **** rel 3.0
      *    IF IF-HS-FLGEC NOT = ZERO GO TO END-CALC-DIFCAM.
           IF IF-HS-FLGEC  = ZERO GO TO END-CALC-DIFCAM.
           IF IF-PAR-VALUT = ZERO GO TO END-CALC-DIFCAM.
      ************
           COMPUTE IF-DIFCAM = IF-IMPOR - IF-PAR-SALDO.
           COMPUTE IF-DIFVAL = IF-IMVAL - IF-PAR-VSALD.
           IF IF-DIFVAL NOT = ZERO
              IF IF-CAMGG = IF-PAR-CADOC
                 MOVE ZERO TO IF-DIFCAM
                 GO TO END-CALC-DIFCAM
              ELSE
      **** rel 4.0
      *          COMPUTE IF-DIFCAM =
      *                  IF-IMPOR - (IF-IMVAL * IF-PAR-CADOC).
                         MOVE IF-VALUT     TO ER-VALUT
                         MOVE IF-IMVAL     TO ER-IMPORTO
                         MOVE IF-PAR-CADOC TO ER-CAMBIO
                         CALL 're2imp' USING ER-IMPORTO VAL-EUR
                                             ER-VALUT ER-CAMBIO
                 COMPUTE IF-DIFCAM = IF-IMPOR - ER-IMPORTO.
      ************
           IF (IF-HS-TIPRG = 2 AND IF-D-A = 'D') OR
              (IF-HS-TIPRG = 3 AND IF-D-A = 'A')
                MULTIPLY -1 BY IF-DIFCAM.
      *
       END-CALC-DIFCAM.
           MOVE SPACE TO F-MES1
                         F-MES2
                         F-MES3
                         F-MES4.
           IF IF-DIFVAL NOT = ZERO
              MOVE 1 TO F-NMES
              MOVE IF-DIFVAL TO COMO-DVAL
              STRING 'Differenza in  ' DELIMITED SIZE
                     IF-VALUT-D        DELIMITED SIZE
                     ' '               DELIMITED SIZE
                     COMODVAL          DELIMITED SIZE INTO F-MES1.
      *
           IF IF-DIFCAM NOT = ZERO
              MOVE 4 TO F-NMES
              MOVE '-----' TO F-MES2
              MOVE IF-DIFCAM TO COMO-DCAM
              STRING 'Differenza cambio : ' DELIMITED SIZE
                     COMODCAM               DELIMITED SIZE INTO F-MES3
              MOVE 'Differenza cambio da contabilizzare ?'   TO F-MES4.
      *
           PERFORM ERRIO-MSG THRU EX-ERRIO-MSG.
       EX-CALC-DIFCAM.
           EXIT.
      *------------------
      * solo per movimento acquisto CEE
      * propone i default dei codici attivita' e progressivi IVA
      * acquisti e vendite
       DEF-ACEE-CONT.
           MOVE '0' TO IF-ACEE-CATTA.
           MOVE AZI-RANRG TO IF-ACEE-NPRGIA.
           ADD 1 TO IF-ACEE-NPRGIA.
           MOVE '0' TO IF-ACEE-CATTV.
           MOVE AZI-RVNRG TO IF-ACEE-NPRGIV.
           IF AZI-NUMFT > IF-ACEE-NPRGIV
              MOVE AZI-NUMFT TO IF-ACEE-NPRGIV.
           ADD 1 TO IF-ACEE-NPRGIV.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV ID-LA1 ID-112 ID-LCN
      **** rel 5.1
                         ID-LA2
      ************
      **** rel 5.2
                         ID-LA3
      ************
      **** rel 6.1
                         ID-LA4
      ************
                         ID-114 ID-185 ID-400 ID-135.
           STRING 'w9' PID DELIMITED SPACE INTO ID-LAV.
           STRING 'w8' PID DELIMITED SPACE INTO ID-LA1.
           STRING 'w7' PID DELIMITED SPACE INTO ID-112.
           STRING 'w6' PID DELIMITED SPACE INTO ID-LCN.
           STRING 'w5' PID DELIMITED SPACE INTO ID-114.
           STRING 'w4' PID DELIMITED SPACE INTO ID-185.
           STRING 'w3' PID DELIMITED SPACE INTO ID-400.
           STRING 'wz' PID DELIMITED SPACE INTO ID-135.
      **** rel 5.1
           STRING 'wk' PID DELIMITED SPACE INTO ID-LA2.
      ************
      **** rel 5.2
           STRING 'wh' PID DELIMITED SPACE INTO ID-LA3.
      ************
      **** rel 6.1
           MOVE SPACE TO ID-LA4.
           STRING 'wx' PID DELIMITED SPACE INTO ID-LA4.
      ************
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       REC-LOCK.
      **** rel 1.2
           CALL 'rlock' USING PARLK.
      ************
           EXIT.
      *------------------
debug *CAR-FILDBG.
debug *       OPEN OUTPUT FILDBG.
debug *       OPEN INPUT WDS114.
debug *CAR-FILDBG-10.
debug *       READ WDS114 NEXT AT END GO TO CAR-FILDBG-90.
debug *       IF RF-LAV = LOW-VALUE GO TO CAR-FILDBG-10.
debug *       MOVE '***' TO DBG00.
debug *       MOVE K114-PROG TO DBG-PROG
debug *       MOVE L114-IVA TO DBG-IVA
debug *       MOVE L114-CAUSA to DBG-CAUSA
debug *       MOVE L114-TIPRG to DBG-TIPRG
debug *       MOVE L114-DAVE to DBG-DAVE
debug *       MOVE L114-SEGNO to DBG-SEGNO
debug *       MOVE L114-FLGIS to DBG-FLGIS
debug *       MOVE L114-TIPOP to DBG-TIPOP
debug *       MOVE L114-FLGSC to DBG-FLGSC
debug *       MOVE L114-SWAGG to DBG-SWAGG
debug *       MOVE L114-FLGEC to DBG-FLGEC
debug *       MOVE L114-DESAG to DBG-DESAG
debug *       MOVE L114-PART to DBG-PART
debug *       MOVE L114-IMPOR to DBG-IMPOR
debug *       MOVE L114-DOCUM to DBG-DOCUM
debug *       MOVE L114-DTDOC to DBG-DTDOC
debug *       MOVE L114-DTSCD to DBG-DTSCD
debug *       MOVE L114-VALUT to DBG-VALUT
debug *       MOVE L114-CAMGG to DBG-CAMGG
debug *       MOVE L114-IMVAL to DBG-IMVAL
debug *       MOVE L114-CCOST to DBG-CCOST
debug *       MOVE L114-DFCAM to DBG-DFCAM
debug *       MOVE XL114-CAUDF to DBG-CAUDF
debug *       MOVE L114-DAVDF to DBG-DAVDF
debug *       MOVE XL114-GECDF to DBG-GECDF
debug *       MOVE L114-CPART to DBG-CPART
debug *       MOVE L114-IMPCP to DBG-IMPCP
debug *       MOVE L114-CAUS2 to DBG-CAUS2
debug *       MOVE L114-TIPR2 to DBG-TIPR2
debug *       MOVE L114-TIPO2 to DBG-TIPO2
debug *       MOVE L114-DTSC2 to DBG-DTSC2
debug *       MOVE L114-FLGS2 to DBG-FLGS2
debug *       MOVE L114-SWAG2 to DBG-SWAG2
debug *       MOVE L114-FLGE2 to DBG-FLGE2
debug *       MOVE L114-DESA2 to DBG-DESA2
debug *       MOVE L114-CCOS2 to DBG-CCOS2
debug *       MOVE L114-CATT to DBG-CATT
debug *       MOVE L114-NPRGI to DBG-NPRGI
debug *       MOVE L114-CDIVA to DBG-CDIVA
debug *       MOVE L114-IMPON to DBG-IMPON
debug *       MOVE L114-IMPOS to DBG-IMPOS
debug *       MOVE L114-INDED to DBG-INDED
debug *       MOVE L114-ESVEN to DBG-ESVEN
debug *       MOVE L114-PLAM to DBG-PLAM
debug *       MOVE L114-PLAN to DBG-PLAN
debug *       MOVE L114-FLAG to DBG-FLAG
debug *       MOVE L114-CDPAG to DBG-CDPAG
debug *       MOVE L114-NRATE to DBG-NRATE.
debug *
debug *       MOVE 1 TO K9.
debug *       PERFORM UNTIL K9 > 12
debug *          MOVE L114-TPAG(K9) TO DBG-TPAG(K9)
debug *          MOVE L114-DTSCA(K9) TO DBG-DTSCA(K9)
debug *          MOVE L114-IMRATA(K9) TO DBG-IMRATA(K9)
debug *          MOVE L114-VALRATA(K9) TO DBG-VALRATA(K9)
debug *          ADD 1 TO K9
debug *       END-PERFORM.
debug *
debug *       MOVE 1 TO K9.
debug *       PERFORM UNTIL K9 > 6
debug *             MOVE L114-WBDSC(K9) TO DBG-WBDSC(K9)
debug *             MOVE L114-WBISC(K9) TO DBG-WBISC(K9)
debug *             MOVE L114-WBVSC(K9) TO DBG-WBVSC(K9)
debug *          ADD 1 TO K9
debug *       END-PERFORM.
debug *       WRITE RF-DBG.
debug *       GO TO CAR-FILDBG-10.
debug *CAR-FILDBG-90.
debug *       CLOSE FILDBG WDS114.
debug *EX-CAR-FILDBG.
debug *       EXIT.
      *------------------
       SOMMA-GG.
           IF NOT ( T04-1SCAD = 2 OR 4 ) GO TO EX-SOMMA-GG.
           MOVE ZERO TO K.
       SOM10.
           ADD 1 TO K.
           IF K > T04-NRATE GO TO EX-SOMMA-GG.
           IF IF-SC-DTSCA (K) = ZERO GO TO EX-SOMMA-GG.
           MOVE IF-SC-DTSCA(K) TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           ADD CLF-GSFM TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-SC-DTSCA(K).
           GO TO SOM10.
       EX-SOMMA-GG.
           EXIT.
      *------------------
       CREA-WDS135.
           OPEN OUTPUT WDS135.
           CLOSE WDS135.
           OPEN I-O WDS135.
      *
           MOVE ZERO TO K135-PROG.
      *
           MOVE KAZ-COD TO L135-CDAZ.
           MOVE AZRGSOC TO L135-DAZI.
      **** rel 6.2
      *    IF AZI-FLAMM NOT = 1 GO TO EX-CREA-WDS135.
           IF AZI-FLAMM NOT = 1 GO TO CREA-135-95.
      ************
           OPEN INPUT TACOAM.
      **** rel 6.2
      *    IF SF-TAC NOT = ZERO GO TO EX-CREA-WDS135.
           IF SF-TAC NOT = ZERO GO TO CREA-135-95.
      ************
           MOVE ZERO    TO KTC-CAT.
           MOVE KAZ-COD TO KTC-AZI.
           READ TACOAM INVALID GO TO CREA-135-90.
           IF TAC-AMORD = ZERO GO TO CREA-135-90.
           MOVE ZERO TO J.
       CREA-135-10.
           ADD 1 TO J.
           MOVE ZERO  TO L135-WIMPCP(J)
                         L135-WCPART(J)
                         L135-WCAUS2(J).
           MOVE SPACE TO L135-DCON(J).
           IF J < 15 GO TO CREA-135-10.
           MOVE 1 TO J.
           MOVE ZERO TO K114-PROG.
           START WDS114 KEY NOT < KEY114 INVALID GO TO CREA-135-90.
       CREA-135-20.
           READ WDS114 NEXT AT END GO TO CREA-135-90.
           IF SF-114 = '9D' OR '9A' OR '35' GO TO CREA-135-20.
      **** rel 6.3
      *    IF L114-IVA = ZERO GO TO CREA-135-90.
           IF L114-IVA = ZERO AND
              IF-HS-ACEE NOT = 1
                 GO TO CREA-135-90.
      ************
      *
           MOVE DTCON-114 TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO L135-DTCON.
      *
           IF L114-IVA = 1
      **** rel 6.3
              OR IF-HS-ACEE = 1
      ************
              MOVE L114-PART  TO L135-WPART
              MOVE L114-CAUSA TO L135-WCAUSA
              MOVE L114-TIPRG TO L135-WTIPRG
              MOVE L114-SEGNO TO L135-WSEGNO
              MOVE L114-TIPOP TO L135-WTIPOP
      *
              MOVE L114-DTDOC TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GGMMAA TO L135-WDTDOC
      *
              MOVE L114-DOCUM TO L135-WDOCUM
              MOVE L114-NPRGI TO L135-WNPRGI.
           IF L114-IVA = 1 OR L114-IVA = 2
      **** rel 6.3
              OR IF-HS-ACEE = 1
      ************
              MOVE L114-CPART TO L135-WCPART(J)
              MOVE L114-IMPCP TO L135-WIMPCP(J)
           ELSE
              MOVE L114-PART  TO L135-WCPART(J)
              MOVE L114-IMPOR TO L135-WIMPCP(J).
           MOVE L114-CAUS2 TO L135-WCAUS2(J).
           IF L135-WCPART(J) = ZERO GO TO CREA-135-20.
      *
           MOVE L135-WCPART(J) TO KPC-COD TAC-CONTO.
           MOVE KAZ-COD TO KPC-AZI TAC-AZI.
           READ TACOAM KEY KEYTC2 INVALID GO TO CREA-135-20.
      *
           READ ANACON INTO REKCON INVALID GO TO CREA-135-20.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-DESCR TO L135-DCON(J).
      *
           CLOSE TACOAM.
           ADD 1 TO K135-PROG.
           WRITE RF-135 INVALID PERFORM INVK-135
                                CLOSE WDS135
                                GO TO ERRIO.
      **** rel 6.2
      * serve ad interfaccia per abilitare aggancio ai cespiti
           IF AZI-FLAMM NOT = ZERO
              MOVE 1 TO FLGAMM.
      ************
           OPEN INPUT TACOAM.
           GO TO CREA-135-20.
       CREA-135-90.
           CLOSE TACOAM.
      **** rel 6.2
       CREA-135-95.
      ************
      **** rel 6.1
           CLOSE WDS135.
      ************
       EX-CREA-WDS135.
           EXIT.
      *------------------
      **** rel 2.0
      * azzera buffer di selezione dei legami
      * per ogni legame trovato, carica RIGAVIDEO-L
      *     del buffer di selezione
      *
      * occorre che IF-LEG-CAUS sia caricata
      *
       CARICA-LEGAMI.
           MOVE 1 TO K5.
           PERFORM UNTIL K5 > 30
              MOVE SPACE TO VETL-ASTE(K5)
                            VETL-CAUSD(K5)
                            VETL-DCONTO(K5)
                            VETL-DCPART(K5)
              MOVE ZERO  TO VETL-CAUS(K5)
                            VETL-CONTO(K5)
                            VETL-CPART(K5)
                            VETL-CONDAR(K5)
                            VETL-CONAVE(K5)
              ADD 1 TO K5
           END-PERFORM.
      *
           MOVE SPACE TO IF-LEG-BUFF.
           MOVE ZERO  TO K5.
           MOVE ZERO  TO IF-LEG-TIPO.
      *
           IF FUN NOT = 'CL' GO TO CARICA-LEGAMI-40.
      * legge causale inserita in testa al buffer legami
           MOVE 2           TO KTB-TIP.
           MOVE IF-LEG-CAUS TO KTB-COD.
           PERFORM RDCAUS-L THRU EX-RDCAUS-L.
           IF TAB-DESCR = SPACE
              MOVE ALL '*' TO IF-LEG-CAUS-D
              MOVE ZERO    TO IF-LEG-POS
              GO TO CARICA-LEGAMI-60.
           MOVE TAB-DESCR TO IF-LEG-CAUS-D.
       CARICA-LEGAMI-40.
      *
           MOVE ZERO TO SW-CAUL.
      *
           MOVE IF-AZI      TO KLG-AZI.
           MOVE IF-LEG-CAUS TO COMLCA1.
           MOVE ZERO        TO COMLNUM.
       CARICA-LEGAMI-45.
           MOVE COMLCA1 TO KLG-CA1.
           MOVE COMLNUM TO KLG-NUM.
           START LEGCAU KEY >= KEYLG INVALID GO TO CARICA-LEGAMI-60.
       CARICA-LEGAMI-50.
           READ LEGCAU NEXT AT END GO TO CARICA-LEGAMI-60.
           IF KLG-AZI > IF-AZI  GO TO CARICA-LEGAMI-60.
           IF KLG-CA1 > COMLCA1 GO TO CARICA-LEGAMI-60.
           IF SW-CAUL = 1
              IF LGC-CAU NOT = ZERO
                 GO TO CARICA-LEGAMI-50.
           IF SW-CAUL = 2
              IF KLG-NUM > COMLNUM
                 GO TO CARICA-LEGAMI-60.
      *
           IF SW-CAUL = ZERO
              IF LGC-CAU NOT = ZERO
                 MOVE 2 TO SW-CAUL
                 MOVE 1 TO IF-LEG-TIPO
              ELSE
                 MOVE 1 TO SW-CAUL.
      *
           ADD 1 TO K5.
           IF K5 > 30
              MOVE 'Superato limite legami visualizzabili' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              GO TO CARICA-LEGAMI-60.
      *
           IF LGC-CA2 NOT = ZERO
              MOVE LGC-CA2 TO VETL-CAUS(K5)
           ELSE
              MOVE KLG-CA1 TO VETL-CAUS(K5).
           MOVE 2             TO KTB-TIP.
           MOVE VETL-CAUS(K5) TO KTB-COD.
           PERFORM RDCAUS-L THRU EX-RDCAUS-L.
           IF TAB-DESCR = SPACE
              MOVE ALL '*'   TO VETL-CAUSD(K5)
           ELSE
              MOVE TAB-DESCR TO VETL-CAUSD(K5).
      *
           MOVE LGC-CO1 TO KPC-COD.
           PERFORM RDCON-L THRU EX-RDCON-L.
           MOVE LGC-CO1  TO VETL-CONTO(K5).
           MOVE COMDSABB TO VETL-DCONTO(K5).
      *
           MOVE LGC-CO2 TO KPC-COD.
           PERFORM RDCON-L THRU EX-RDCON-L.
           MOVE LGC-CO2  TO VETL-CPART(K5).
           MOVE COMDSABB TO VETL-DCPART(K5).
      *
           IF T02-D-A = 'D'
              MOVE VETL-CONTO(K5)  TO VETL-CONDAR(K5)
              MOVE VETL-CPART(K5)  TO VETL-CONAVE(K5)
           ELSE
              MOVE VETL-CONTO(K5)  TO VETL-CONAVE(K5)
              MOVE VETL-CPART(K5)  TO VETL-CONDAR(K5).
      *
           MOVE VETL-ASTE(K5) TO VLASTE.
           IF K5 < 2
              MOVE VETL-CAUS(K5)   TO VLCAUS
              MOVE VETL-CAUSD(K5)  TO VLCAUSD
              MOVE VETL-CONDAR(K5) TO VLCONDAR
              MOVE VETL-CONAVE(K5) TO VLCONAVE
              IF VETL-CONDAR(K5) = VETL-CONTO(K5)
                 MOVE VETL-DCONTO(K5) TO VLDESDAR
                 MOVE VETL-DCPART(K5) TO VLDESAVE
              ELSE
                 MOVE VETL-DCONTO(K5) TO VLDESAVE
                 MOVE VETL-DCPART(K5) TO VLDESDAR
           ELSE
              MOVE ' "'   TO VLCAUS
              MOVE '   "' TO VLCONDAR VLCONAVE
              IF VETL-CAUS(K5) NOT = VETL-CAUS(K5 - 1)
                 MOVE VETL-CAUS(K5)  TO VLCAUS
                 MOVE VETL-CAUSD(K5) TO VLCAUSD
              END-IF
              IF VETL-CONDAR(K5) NOT = VETL-CONDAR(K5 - 1)
                 MOVE VETL-CONDAR(K5) TO VLCONDAR
                 IF VETL-CONDAR(K5) = VETL-CONTO(K5)
                    MOVE VETL-DCONTO(K5) TO VLDESDAR
                 ELSE
                    MOVE VETL-DCPART(K5) TO VLDESDAR
                 END-IF
              END-IF
              IF VETL-CONAVE(K5) NOT = VETL-CONAVE(K5 - 1)
                 MOVE VETL-CONAVE(K5) TO VLCONAVE
                 IF VETL-CONAVE(K5) = VETL-CPART(K5)
                    MOVE VETL-DCPART(K5) TO VLDESAVE
                 ELSE
                    MOVE VETL-DCONTO(K5) TO VLDESAVE.
      *
           IF VLCAUS   = ZERO MOVE SPACE TO VLCAUS.
           IF VLCONDAR = ZERO MOVE SPACE TO VLCONDAR.
           IF VLCONAVE = ZERO MOVE SPACE TO VLCONAVE.
      *
           MOVE RIGAVIDEO-L TO IF-RIG-L(K5).
           MOVE SPACE TO RIGAVIDEO-L.
           MOVE LF TO IF-EOR-L(K5).
      *
           IF SW-CAUL = 2
              MOVE LGC-CAU TO COMLCA1
              MOVE LGC-NUM TO COMLNUM
              GO TO CARICA-LEGAMI-45.
      *
           GO TO CARICA-LEGAMI-50.
       CARICA-LEGAMI-60.
           MOVE 1 TO IF-LEG-POS.
      * calcola lunghezza buffer
           IF K5 = ZERO
              MOVE ZERO TO LNSEZ-L
           ELSE
              MOVE 1 TO LNSEZ-L
              PERFORM UNTIL IF-LEG-BUFF(LNSEZ-L:1) = LF
                 ADD 1 TO LNSEZ-L.
           COMPUTE IF-LEG-NBYTE = LNSEZ-L * K5.
           IF IF-LEG-NBYTE = ZERO
              MOVE ZERO TO IF-LEG-POS
              MOVE ZERO TO IF-LEG-FLGPB1
                           IF-LEG-FLGPB2
                           IF-LEG-FLGDB.
       EX-CARICA-LEGAMI.
           EXIT.
      *------------------
      * lettura causale contabile
       RDCAUS-L.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO TAB-DESCR
                GO TO EX-RDCAUS-L.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
       EX-RDCAUS-L.
           EXIT.
      *------------------
      * lettura conto
       RDCON-L.
           MOVE SPACE TO COMDSABB.
           IF KPC-COD = ZERO GO TO EX-RDCON-L.
           MOVE IF-AZI       TO KPC-AZI.
           READ ANACON INTO REKCON INVALID
                MOVE ALL '*' TO COMDSABB
                GO TO EX-RDCON-L.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           IF CON-DSABB NOT = SPACE
              MOVE CON-DSABB TO COMDSABB
           ELSE
              MOVE CON-DESCR TO COMDSABB.
       EX-RDCON-L.
           EXIT.
      *------------------
      * carica video di input con i dati prelevati dal legame
      * selezionato dall'interfaccia.
       SEL-LEGAMI.
           IF IF-PROGR > 1       GO TO SEL-LEGAMI-50.
           IF IF-HS-ATTRN = ZERO GO TO SEL-LEGAMI-50.
      * carica dati video 2
           IF VETL-CPART(IF-LEG-RIGSEL) NOT = ZERO
              MOVE 1 TO K1
      **** rel 6.2
      *       PERFORM UNTIL K1 > 7
              PERFORM UNTIL K1 > 15
      ************
                 IF IF-CP-COD(K1) = ZERO
                    MOVE VETL-CPART(IF-LEG-RIGSEL)  TO IF-CP-COD(K1)
                    MOVE VETL-DCPART(IF-LEG-RIGSEL) TO IF-CP-DESCR(K1)
                    MOVE 'IF-CP-COD' TO IF-CAMPO
                    MOVE K1          TO IF-IDXVET
      **** rel 6.2
      *             MOVE 7 TO K1
                    MOVE 15 TO K1
      ************
                 END-IF
                 ADD 1 TO K1
              END-PERFORM.
           GO TO SEL-LEGAMI-90.

       SEL-LEGAMI-50.
      * carica dati video 1
           MOVE SPACE TO IF-CAMPO.
      *
           MOVE 2           TO KTB-TIP.
           MOVE IF-LEG-CAUS TO KTB-COD.
           PERFORM RDCAUS-L THRU EX-RDCAUS-L.
           IF TAB-DESCR = SPACE MOVE ZERO TO T02-ATTRN.
           IF T02-ATTRN = 1
              IF VETL-CPART(IF-LEG-RIGSEL) NOT = ZERO
                 MOVE VETL-CPART(IF-LEG-RIGSEL)  TO IF-PART
                 MOVE VETL-DCPART(IF-LEG-RIGSEL) TO IF-PART-D
                 MOVE 'IF-PART' TO IF-CAMPO
                 GO TO SEL-LEGAMI-60.
      *
           IF VETL-CPART(IF-LEG-RIGSEL) NOT = ZERO
              MOVE VETL-CPART(IF-LEG-RIGSEL)  TO IF-CPART
              MOVE VETL-DCPART(IF-LEG-RIGSEL) TO IF-CPART-D
              MOVE 'IF-CPART' TO IF-CAMPO.
           IF VETL-CONTO(IF-LEG-RIGSEL) NOT = ZERO
              MOVE VETL-CONTO(IF-LEG-RIGSEL)  TO IF-PART
              MOVE VETL-DCONTO(IF-LEG-RIGSEL) TO IF-PART-D
              MOVE 'IF-PART' TO IF-CAMPO.
       SEL-LEGAMI-60.
           IF VETL-CAUS(IF-LEG-RIGSEL) NOT = ZERO
              MOVE VETL-CAUS(IF-LEG-RIGSEL)  TO IF-CAUS
              MOVE VETL-CAUSD(IF-LEG-RIGSEL) TO IF-CAUS-D
              MOVE 'IF-CAUS' TO IF-CAMPO.
       SEL-LEGAMI-90.
      * segna rigo buffer come gia' selezionato
           MOVE '*' TO VETL-ASTE(IF-LEG-RIGSEL).
           MOVE IF-RIG-L(IF-LEG-RIGSEL) TO RIGAVIDEO-L.
           MOVE '*' TO VLASTE.
           MOVE RIGAVIDEO-L TO IF-RIG-L(IF-LEG-RIGSEL).
      *
           PERFORM ASSEGNA-LEG-POS THRU EX-ASSEGNA-LEG-POS.
       EX-SEL-LEGAMI.
           EXIT.
      *------------------
      * calcola posizione della riga da colorare di blu
       ASSEGNA-LEG-POS.
           IF VETL-CAUS(1) = ZERO
              MOVE ZERO TO IF-LEG-POS
              GO TO EX-ASSEGNA-LEG-POS.
           MOVE 30 TO K5.
           PERFORM UNTIL K5 = ZERO
              IF VETL-ASTE(K5) = '*'
                 MOVE K5 TO IF-LEG-POS
                 MOVE 1 TO K5
              END-IF
              SUBTRACT 1 FROM K5
           END-PERFORM.
      **** rel 3.0
      *    IF IF-LEG-POS < 30 ADD 1 TO IF-LEG-POS.
           IF IF-LEG-POS < 30 AND K5 NOT = ZERO
              ADD 1 TO IF-LEG-POS.
      ************
       EX-ASSEGNA-LEG-POS.
           EXIT.
      *------------------
      ************
      **** rel 3.0
       CALCOLA-IVA-INDED.
           IF IF-IV-COD(K) = ZERO
              MOVE ZERO TO VIVA-INDEDUC(K)
              GO TO EX-CALCOLA-IVA-INDED.

           MOVE IF-IV-COD(K) TO KTB-COD.
           MOVE 3            TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.

      * iva indeducibile
           MOVE ZERO TO VIVA-INDEDUC(K).
           IF T03-TPIVA = 1 MOVE IF-IV-IMPOS(K) TO VIVA-INDEDUC(K).
           IF T03-TPIVA = 7
      **** rel 4.0
      *       COMPUTE VIVA-INDEDUC(K) = IF-IV-IMPOS(K) / 2 + 0,99.
              MOVE IF-IV-IMPOS(K) TO ER-IMPORTO
              MOVE ZERO           TO ER-VALUT
      **** rel 6.2
      *       MOVE 50             TO PERC
              MOVE T03-PERIVA     TO PERC
              IF PERC = ZERO MOVE 50 TO PERC
              END-IF
      ************
              CALL 're2iva' USING ER-IMPORTO ER-VALUT PERC
              MOVE ER-IMPORTO     TO VIVA-INDEDUC(K).
      ************
       EX-CALCOLA-IVA-INDED.
           EXIT.
      ************
      *------------------
      **** rel 5.0
       CALC-SALDAP-GEN.
           IF FUN NOT = 'V' GO TO END-CALC-SALDAP-GEN.
           MOVE ZERO TO SALDAP.
           MOVE KEYPC TO KEYCL.
           READ ANACOL INTO REKCON INVALID
                MOVE ZERO TO SALDAP
                GO TO RDCON-10.
           IF SF-COL = '9D' OR '9A' OR '35' MOVE RF-COL TO REKCON.
           COMPUTE SALDAP = CON-SESP + CON-SE-D - CON-SE-A.
       RDCON-10.
           READ ANACON INTO REKCON INVALID KEY
                MOVE ZERO TO KPC-COD
                PERFORM ERR-CINE
      **** rel 5.0-2
      *         GO TO EX-RDCON.
                GO TO END-CALC-SALDAP-GEN.
      **************
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
      *
           IF CON-TIPO = 'E' MOVE ZERO TO SALDAP.
           IF IF-FLRIPO > ZERO ADD SALDAP TO IF-SALD
           ELSE SUBTRACT SALDAP FROM IF-SALD.
       END-CALC-SALDAP-GEN.
           EXIT.
      *------------------
       CALC-SALDAP-CLFO.
           IF FUN NOT = 'V' GO TO END-CALC-SALDAP-CLFO.
           MOVE ZERO TO SALDAP.
           MOVE KEYCF TO KEYCX.
           READ ANACFX INTO REKCLF INVALID
                MOVE ZERO TO SALDAP
                GO TO RDCLF-05.
           IF SF-CFX = '9D' OR '9A' OR '35' MOVE RF-CFX TO REKCLF.
           COMPUTE SALDAP = CLF-SESP + CLF-SE-D - CLF-SE-A.
       RDCLF-05.
           READ ANACLF INTO REKCLF INVALID KEY
                MOVE ZERO TO KCF-COD
                PERFORM ERR-CINE
      **** rel 5.0-2
      *         GO TO EX-RDCLF.
                GO TO END-CALC-SALDAP-CLFO.
      **************
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
      **** rel 6.0
           MOVE KAZ-COD    TO RACF-AZI.
           MOVE KCF-COD    TO RACF-COD.
           CALL 'rrdacf' USING PARACF.
      ************
      *
           IF IF-FLRIPO > ZERO ADD SALDAP TO IF-SALD
           ELSE SUBTRACT SALDAP FROM IF-SALD.
       END-CALC-SALDAP-CLFO.
           EXIT.
      *------------------
      ************
      **** rel 5.0
      * Fase di aggiornamento scadenzario per pagamenti anticipati
      * fatture fornitori. Genera record principale e record di
      * dettaglio gia' con lo stato di pagato e con numero e data
      * di documento a zero.
       AGG-SCAD-PAGANT.
           IF IF-FL NOT = ZERO
              CLOSE ANAAZI
              MOVE 'anaazi' TO ID-AZI
              OPEN I-O ANAAZI.
           PERFORM RD-AZI-LOCK THRU EX-RD-AZI-LOCK.
           MOVE AZI-PRSCA TO KSC-PRG.
      *
           MOVE KAZ-COD   TO KSC-AZI.
           MOVE 2         TO KSC-TIPO.
           ADD 1          TO KSC-PRG.
           MOVE IF-DATREG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG     TO KSC-DTSCA KS2-DTSCA KS3-DTSCA SCA-DTSCAO.
      *
           MOVE IF-CLIFOR TO CODCF.
           MOVE MFOR      TO MAS.
           MOVE CODICE    TO KS2-CODCF.
      *
           MOVE IF-DOCUM TO SCA-NDOC.
           MOVE IF-DTDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG    TO SCA-DTDOC.
           MOVE IF-IMPOR TO SCA-IMPOR  SCA-IMRATA SCA-PAGATO.
           MOVE IF-IMVAL TO SCA-VALDOC SCA-VALRATA SCA-VALPAG.
           MOVE 1        TO SCA-RATE.
           MOVE 1        TO SCA-NRATA.
           MOVE ZERO     TO SCA-CDPAG.
           MOVE 9        TO SCA-TPAG.
           MOVE 'P'      TO SCA-STATO.
           MOVE IF-CATT  TO SCA-CATT.
           MOVE IF-NPRGI TO SCA-NPROT.
           MOVE ZERO     TO SCA-SOLL.
           MOVE NREG-114 TO SCA-NREG.
           MOVE SPACE    TO SCA-NOTE.
           MOVE SPACE    TO SCA-CODCFL.
           MOVE ZERO     TO KS3-BAN.
           MOVE IF-CAMGG TO SCA-CAMDOC.
           MOVE ZERO     TO SCA-CAMPAG.
           MOVE IF-VALUT TO SCA-CDVAL.
           WRITE RF-SCA INVALID PERFORM INVK-SCA
                                GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************

      *> scrive rigo di dettaglio pagamento
      **** rel 5.0-2
           MOVE 1 TO K1.
      **************
           MOVE SCA-IMPOR  TO VET-PAGRATA(K1).
           MOVE SCA-VALDOC TO VET-VPAGRAT(K1).
           PERFORM AGG-DETSCA-CARICO  THRU EX-AGG-DETSCA-CARICO.
      ****
           IF KSC-PRG = AZI-PRSCA GO TO AGG-SCAD-PAG-95.
           MOVE KSC-PRG TO AZI-PRSCA.
           REWRITE RF-AZI FROM REKAZI INVALID PERFORM INVK-AZI
                                              GO TO ERRIO.
       AGG-SCAD-PAG-95.
           UNLOCK ANAAZI.
           IF IF-FL = ZERO GO TO AGG-SCAD-PAG-98.
           CLOSE ANAAZI.
           MOVE 'anazol' TO ID-AZI.
           OPEN I-O ANAAZI.
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
       AGG-SCAD-PAG-98.
       EX-AGG-SCAD-PAGANT.
           EXIT.
      *------------------
      *> scrive record del dettaglio pagamento riferito alla
      *  scadenza pagata o insoluta
       AGG-DETSCA-CARICO.
           MOVE KSC-AZI   TO KDSC-AZI.
           MOVE KSC-TIPO  TO KDSC-TIPO.
           MOVE KSC-DTSCA TO KDSC-DTSCA.
           MOVE KSC-PRG   TO KDSC-PRG.
           MOVE ZERO      TO KDSC-PROG NPROG.
           START DETSCA KEY NOT < KEYDSC INVALID GO TO NODET.
       RDDET.
           READ DETSCA NEXT AT END GO TO NODET.
           IF SF-DSC = '9D' OR '9A' OR '35' GO TO RDDET.
           IF KDSC-AZI   > KSC-AZI   GO TO NODET.
           IF KDSC-TIPO  > KSC-TIPO  GO TO NODET.
           IF KDSC-DTSCA > KSC-DTSCA GO TO NODET.
           IF KDSC-PRG   > KSC-PRG   GO TO NODET.
           MOVE KDSC-PROG TO NPROG.
           GO TO RDDET.
       NODET.
           ADD 1 TO NPROG.
           MOVE KSC-AZI   TO KDSC-AZI.
           MOVE KSC-TIPO  TO KDSC-TIPO.
           MOVE KSC-DTSCA TO KDSC-DTSCA.
           MOVE KSC-PRG   TO KDSC-PRG.
           MOVE NPROG     TO KDSC-PROG.
      *
           MOVE KS2-CODCF TO DSC-CODCF.
      **** rel 5.1
           MOVE ZERO  TO DSC-NDOC
                         DSC-DTDOC
                         DSC-BAN.
           MOVE SPACE TO DSC-NOTE.
           IF PRA-FLSCA = 1
              IF (IF-HS-TIPRG = 2)  AND (IF-HS-FLGSC = 1)         AND
                 (IF-T02-TIPOP = 1) AND (IF-SC-TPAG(K1) = 1 OR 2) AND
                  SCA-STATO = 'D'
                  MOVE 'Fattura con RB da Primanota   ' TO DSC-NOTE
                  GO TO NO-RIF-DOC.
      ************
           MOVE IF-DOCUM  TO DSC-NDOC.
           MOVE IF-DTDOC  TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG     TO DSC-DTDOC.
      **** rel 5.1
           MOVE KS3-BAN   TO DSC-BAN.
       NO-RIF-DOC.
      ************
      *
           MOVE SCA-CDPAG       TO DSC-CDPAG.
           MOVE SCA-TPAG        TO DSC-TPAG.
           MOVE SPACE TO DSC-TIPOP.
           MOVE 'P'             TO DSC-TIPOP.
      **** rel 5.1
      *    IF SCA-STATO = 'I' OR 'S' MOVE SCA-STATO TO DSC-TIPOP.
      **** rel 7.1
           IF IF-T02-TIPOP NOT = 6
      ************
           IF SCA-STATO = 'I' OR 'S' OR 'D' MOVE SCA-STATO TO DSC-TIPOP.
      ************
           IF IF-DOCUM = ZERO AND
              IF-DTDOC = ZERO MOVE 'A' TO DSC-TIPOP.
      **** rel 5.1
      *> spostata sopra
      *    MOVE KS3-BAN         TO DSC-BAN.
      ************
           MOVE SCA-CDVAL       TO DSC-CDVAL.
           MOVE NREG-114        TO DSC-NREG.
      **** rel 5.1
      *> data reg. contabile su dettaglio non piu' gestita
      *    MOVE DTCON-114       TO DSC-DTREG.
      ************
           MOVE VET-PAGRATA(K1) TO DSC-IMPOR.
           MOVE VET-VPAGRAT(K1) TO DSC-VALDOC.
           MOVE SCA-CAMPAG      TO DSC-CAMDOC.
           MOVE ZERO            TO DSC-FILL.
           WRITE RF-DSC INVALID
              PERFORM INVK-DSC
              GO TO ERRIO.
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-DSC.
      ************
       EX-AGG-DETSCA-CARICO.
           EXIT.
      *------------------
      *> riscrive sulla scadenza del pagamento anticipato il
      *  numero e la data del documento. La trova solo se e'
      *  valorizzato if-sca-prg, passato dallo screenset dopo aver
      *  aperto lo zoom dello scadenzario.
       RWR-SCAD-PAGANT.
           MOVE KAZ-COD    TO KSC-AZI.
           MOVE 2          TO KSC-TIPO.
           MOVE IF-SC-DTSCA(1) TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG      TO KSC-DTSCA.
           MOVE IF-SCA-PRG TO KSC-PRG.
           READ ANASCA INVALID  GO TO RWR-SCAD-05.
           IF (KS2-CODCF(3:5) NOT = IF-CLIFOR) OR
              (SCA-NDOC  NOT = ZERO)           OR
              (SCA-DTDOC NOT = ZERO)           OR
              (SCA-IMPOR NOT = IF-IMPOR)       OR
              (SCA-TPAG  NOT = 9)              OR
              (SCA-STATO NOT = "P")            GO TO RWR-SCAD-05.
           MOVE IF-DOCUM TO SCA-NDOC.
           MOVE IF-DTDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO SCA-DTDOC.
           MOVE IF-CDPAG TO SCA-CDPAG.
           MOVE IF-NPRGI TO SCA-NPROT.
           REWRITE RF-SCA INVALID PERFORM INVK-SCA
                                  GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
      *
           PERFORM RWR-DETSCA-CARICO THRU EX-RWR-DETSCA-CARICO.
           GO TO EX-RWR-SCAD-PAGANT.
       RWR-SCAD-05.
           MOVE "Scadenza di pagamento anticipato "  TO F-MES1.
           MOVE "non trovata. Nessun aggiornamento"  TO F-MES2.
           MOVE "effettuato.                      "  TO F-MES3.
           MOVE 3 TO F-NMES.
           CALL 'vrmbox' USING PARMB.
      *
       EX-RWR-SCAD-PAGANT.
           EXIT.
      *------------------
      *> riscrive sul dettaglio della scadenza del pagamento
      *  anticipato il numero e la data del documento.
       RWR-DETSCA-CARICO.
           MOVE KSC-AZI   TO KDSC-AZI.
           MOVE KSC-TIPO  TO KDSC-TIPO.
           MOVE KSC-DTSCA TO KDSC-DTSCA.
           MOVE KSC-PRG   TO KDSC-PRG.
           MOVE ZERO      TO KDSC-PROG.
           START DETSCA KEY NOT < KEYDSC INVALID
                                         GO TO EX-RWR-DETSCA-CARICO.
       RD-05.
           READ DETSCA NEXT AT END GO TO EX-RWR-DETSCA-CARICO.
           IF SF-DSC = '9D' OR '9A' OR '35' GO TO RD-05.
           IF KDSC-AZI   > KSC-AZI   GO TO EX-RWR-DETSCA-CARICO.
           IF KDSC-TIPO  > KSC-TIPO  GO TO EX-RWR-DETSCA-CARICO.
           IF KDSC-DTSCA > KSC-DTSCA GO TO EX-RWR-DETSCA-CARICO.
           IF KDSC-PRG   > KSC-PRG   GO TO EX-RWR-DETSCA-CARICO.

           IF DSC-NREG   NOT = SCA-NREG   GO TO RD-05.

           IF (DSC-NDOC  NOT = ZERO) AND
              (DSC-DTDOC NOT = ZERO) AND
              (DSC-TIPOP NOT = "A" ) AND
              (DSC-IMPOR NOT = SCA-IMPOR) GO TO RD-05.

           MOVE IF-DOCUM  TO DSC-NDOC.
           MOVE IF-DTDOC  TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG     TO DSC-DTDOC.
           MOVE SCA-CDPAG TO DSC-CDPAG.
           REWRITE RF-DSC INVALID
              PERFORM INVK-DSC
              GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-DSC.
      ************
           GO TO RD-05.
       EX-RWR-DETSCA-CARICO.
           EXIT.
      *------------------
      **** rel 5.0
       CALC-SCADENZE.
           IF IF-RG-FUN NOT = 'M' GO TO END-CALC-SCADENZE.
      **** rel 5.1
      *    PERFORM AZZ-VET-SCA THRU EX-AZZ-VET-SCA.
      *    MOVE ZERO TO IF-CDPAG.
      *    MOVE ZERO TO DTDOC CONT FLGSCA.
      ************

           IF IF-HS-TIPRG  = 1 GO TO END-CALC-SCADENZE.

      *> per registrazioni di pagamento si lavora
      *  sul file dei dettagli DETSCA
           IF (IF-HS-TIPRG = 2 OR 3) AND (IF-T02-TIPOP = 6)
              PERFORM CALC-DETTAGLI THRU END-CALC-DETTAGLI
              GO TO END-CALC-SCADENZE.

      **** rel 5.1
           MOVE ZERO TO CONT.
      ************

           MOVE IF-CLIFOR TO CODCF.
           IF IF-HS-TIPRG = 2 MOVE MCLI TO MAS
           ELSE               MOVE MFOR TO MAS.

      *> starta per chiave splittata azienda/num. registrazione
           MOVE KAZ-COD TO KSC-AZI.
           MOVE IF-NREG TO SCA-NREG.
           START ANASCA KEY NOT < SKEYSC4 INVALID GO TO END-LPSCA.
       RDNX-SCA.
           READ ANASCA NEXT AT END GO TO END-LPSCA.
           IF KSC-AZI  > KAZ-COD   GO TO END-LPSCA.
           IF SCA-NREG > IF-NREG   GO TO END-LPSCA.
           IF IF-HS-TIPRG = 2
              IF KSC-TIPO NOT = 1  GO TO RDNX-SCA
              END-IF
           ELSE
              IF KSC-TIPO NOT = 2  GO TO RDNX-SCA.

      *> num. documento, data, importo, cliente/fornitore
           IF SCA-NDOC    NOT = IF-DOCUM GO TO RDNX-SCA.
      **** rel 5.1
      *    MOVE SCA-DTDOC TO AAGGG.
      *    MOVE 2 TO TIPOP1.
           MOVE IF-DTDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
      ************
           CALL 'rdata' USING PARCDT.
      **** rel 5.1
      *    MOVE GGMMAA TO DTDOC.
      *    IF DTDOC       NOT = IF-DTDOC GO TO RDNX-SCA.
           IF SCA-DTDOC   NOT = AAGGG    GO TO RDNX-SCA.
      ************
      **** rel 6.2
      *    IF SCA-IMPOR   NOT = IF-IMPOR GO TO RDNX-SCA.
      *    IF SCA-VALDOC  NOT = IF-IMVAL GO TO RDNX-SCA.
           IF NOT (SCA-IMPOR = IF-IMPOR OR
              SCA-IMPOR = IF-IMPOR * -1)
                 GO TO RDNX-SCA.
           IF NOT (SCA-VALDOC = IF-IMVAL OR
              SCA-VALDOC = IF-IMVAL * -1)
                 GO TO RDNX-SCA.
      ************
           IF KS2-CODCF   NOT = CODICE   GO TO RDNX-SCA.

           ADD 1 TO CONT.
      **** rel 5.0-2
      *> spostato questo test piu' sotto: viene caricato comunque il
      *  quadro dello scadenzario anche se non puo' essere variato
      *  (altrimenti il programma rilasciava:
      *   "Totale rate scadezario < totale documento").
      *
      *    IF (SCA-STATO NOT = SPACE) OR
      *       (SCA-PAGATO  > ZERO)    OR
      *       (SCA-VALPAG  > ZERO)    MOVE 2 TO FLGSCA
      *                               MOVE SCA-CDPAG TO IF-CDPAG
      *                               GO TO RDNX-SCA.
      *    IF FLGSCA = 2 GO TO RDNX-SCA.
      **************
           IF CONT > 12  GO TO RDNX-SCA.
           MOVE SCA-TPAG    TO IF-SC-TPAG(CONT).
           MOVE KSC-DTSCA   TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA      TO IF-SC-DTSCA(CONT).
      **** rel 6.3
           MOVE 2 TO KTB-TIP.
           MOVE IF-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ZERO TO T02-TIPOP.
           IF T02-TIPOP = 8 MULTIPLY -1 BY SCA-IMRATA
                            MULTIPLY -1 BY SCA-VALRATA.
      ************
           MOVE SCA-IMRATA  TO IF-SC-IMRATA(CONT).
           MOVE SCA-VALRATA TO IF-SC-VALRAT(CONT).
      **** rel 6.3
           IF T02-TIPOP = 8 MULTIPLY -1 BY SCA-IMRATA
                            MULTIPLY -1 BY SCA-VALRATA.
      ************
           MOVE SCA-CDPAG   TO IF-CDPAG OLDCDPAG.
      **** rel 6.2
           MOVE SCA-NOTE    TO IF-SC-NOTE(CONT).
      *
           MOVE ZERO      TO RF-NSC.
           MOVE KSC-AZI   TO KNSC-AZI.
           MOVE KSC-TIPO  TO KNSC-TIPO.
           MOVE KSC-DTSCA TO KNSC-DTSCA.
           MOVE KSC-PRG   TO KNSC-PRG.
           MOVE 1         TO KNSC-PRGN.
           READ NOTSCA INVALID MOVE SPACE TO NSC-DESCR.
           MOVE NSC-DESCR TO IF-SC-NOTEA(CONT).
      ************
      **** rel 5.0-2
           MOVE KS3-BAN     TO IF-CDBAN.

      **** rel 5.1
      *    IF (SCA-STATO NOT = SPACE) OR
      *       (SCA-PAGATO  > ZERO)    OR
           IF NOT (SCA-STATO = SPACE OR 'D')
              IF (SCA-PAGATO  > ZERO)    OR
      ************
                 (SCA-VALPAG  > ZERO)    MOVE 2 TO FLGSCA
                                         GO TO RDNX-SCA.
      **************
      **** rel 5.1
           PERFORM VER-DETSCA THRU EX-VER-DETSCA.
      ************

      *> salvo chiave scadenzario per cancellazione records
      *  al momento della conferma del movimento variato.
           MOVE KSC-AZI   TO VET-SC-AZI(CONT).
           MOVE KSC-TIPO  TO VET-SC-TIPO(CONT).
           MOVE KSC-DTSCA TO VET-SC-DTSCA(CONT).
           MOVE KSC-PRG   TO VET-SC-PRG(CONT).

           GO TO RDNX-SCA.
       END-LPSCA.
           IF CONT = ZERO AND IF-CDPAG = ZERO GO TO END-CALC-SCADENZE.
           IF IF-CDPAG = ZERO GO TO NO-CDPAG.
           MOVE SPACE    TO IF-DESPAG.
           MOVE IF-CDPAG TO KTB-COD.
           MOVE 4        TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO IF-DESPAG.
       NO-CDPAG.
           IF FLGSCA NOT = 2 MOVE 1 TO FLGSCA
                             MOVE 1 TO IF-HS-SCA.
      **** rel 5.1
           IF CONT NOT = ZERO MOVE 1 TO IF-HS-SCA.
      ************
           MOVE 1 TO IF-HS-FLGSC.
       END-CALC-SCADENZE.
           EXIT.
      *------------------
       AZZ-VET-SCA.
           MOVE 1 TO CONT.
           PERFORM UNTIL CONT > 12
              MOVE ZERO  TO VET-SC-AZI(CONT)
                            VET-SC-TIPO(CONT)
                            VET-SC-DTSCA(CONT)
                            VET-SC-PRG(CONT)
              ADD 1 TO CONT
           END-PERFORM.
           MOVE ZERO TO CONT.
       EX-AZZ-VET-SCA.
           EXIT.
      *------------------
       AZZ-VET-DSC.
           MOVE 1 TO CONT.
           PERFORM UNTIL CONT > 99
              MOVE ZERO  TO VET-DSC-AZI(CONT)
                            VET-DSC-TIPO(CONT)
                            VET-DSC-DTSCA(CONT)
                            VET-DSC-PRG(CONT)
                            VET-DSC-PROG(CONT)
              ADD 1 TO CONT
           END-PERFORM.
           MOVE ZERO TO CONT.
       EX-AZZ-VET-DSC.
           EXIT.
      *------------------
       DEL-SCADENZE.
           MOVE ZERO TO CONT.
       LP-DEL-SCA.
           ADD 1 TO CONT.
           IF CONT > 12 GO TO EX-DEL-SCADENZE.
           IF VET-SC-AZI(CONT) = ZERO GO TO LP-DEL-SCA.
           MOVE VET-SC-AZI(CONT)   TO KSC-AZI.
           MOVE VET-SC-TIPO(CONT)  TO KSC-TIPO.
           MOVE VET-SC-DTSCA(CONT) TO KSC-DTSCA.
           MOVE VET-SC-PRG(CONT)   TO KSC-PRG.
           READ ANASCA KEPT LOCK INVALID PERFORM INVK-SCA GO TO ERRIO.
           DELETE ANASCA INVALID PERFORM INVK-SCA GO TO ERRIO.
      **** rel 7.1
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
      **** rel 5.1
           IF (SCA-STATO = 'D') AND (SCA-TPAG = 1 OR 2)
              PERFORM DEL-DETSCA THRU EX-DEL-DETSCA.
      ************
      **** rel 6.2
          MOVE ZERO TO PARDNS.
          MOVE KSC-AZI   TO DNS-AZI.
          MOVE KSC-TIPO  TO DNS-TIPO.
          MOVE KSC-DTSCA TO DNS-DTSCA.
          MOVE KSC-PRG   TO DNS-PRG.
          CALL 'rdelnsc' USING PARDNS.
      ************
           UNLOCK ANASCA.
           GO TO LP-DEL-SCA.
       EX-DEL-SCADENZE.
           EXIT.
      *------------------
       CALC-DETTAGLI.
           IF IF-RG-FUN NOT = 'M' GO TO END-CALC-DETTAGLI.
      **** rel 5.1
      *    PERFORM AZZ-VET-DSC THRU EX-AZZ-VET-DSC.
      *    MOVE ZERO TO DTDOC CONT FLGSCA.
      ************

           MOVE IF-CLIFOR TO CODCF.
           IF IF-HS-TIPRG = 2 MOVE MCLI TO MAS
           ELSE               MOVE MFOR TO MAS.

      *> starta per chiave splittata azienda/num. registrazione
           MOVE KAZ-COD TO KDSC-AZI.
           MOVE IF-NREG TO DSC-NREG.
           START DETSCA KEY NOT < SKEYDSC2 INVALID GO TO END-LPDSC.
       RDNX-DSC.
           READ DETSCA NEXT AT END GO TO END-LPDSC.
           IF KDSC-AZI > KAZ-COD   GO TO END-LPDSC.
           IF DSC-NREG > IF-NREG   GO TO END-LPDSC.
           IF IF-HS-TIPRG = 2
              IF KDSC-TIPO NOT = 1  GO TO RDNX-DSC
              END-IF
           ELSE
              IF KDSC-TIPO NOT = 2  GO TO RDNX-DSC.
           IF DSC-CODCF NOT = CODICE  GO TO RDNX-DSC.

      **** rel 5.1
      *    MOVE DSC-DTDOC TO AAGGG.
      *    MOVE 2 TO TIPOP1.
      *    CALL 'rdata' USING PARCDT.
      *    MOVE GGMMAA TO DTDOC.

           IF IF-DOCUM = ZERO AND IF-DTDOC = ZERO AND
              DSC-TIPOP = 'A' GO TO NO-TEST.

           MOVE IF-DTDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF DSC-DTDOC   NOT = AAGGG    GO TO RDNX-DSC.
      ************
           IF DSC-NDOC    NOT = IF-DOCUM GO TO RDNX-DSC.
      **** rel 5.1
      *    IF DSC-DTDOC   NOT = DTDOC GO TO RDNX-DSC.
      ************
      **** rel 5.1
       NO-TEST.
      *    IF DSC-IMPOR   NOT = IF-IMPOR GO TO RDNX-DSC.
      *    IF DSC-VALDOC  NOT = IF-IMVAL GO TO RDNX-DSC.
      ************

      **** rel 5.1
           MOVE IF-PROGR TO KL2-PROGR.
           READ WDSLA2 INVALID GO TO WR-LA2.

           IF LA2-KEYDSC = ZERO
              MOVE 1 TO LA2-FLGTRO
              REWRITE RF-LA2 INVALID GO TO RDNX-DSC.

           GO TO RDNX-DSC.
       WR-LA2.
           IF DSC-IMPOR NOT = IF-IMPOR
              MOVE ZERO TO LA2-KEYDSC
           ELSE
              MOVE KDSC-AZI   TO LA2-AZI
              MOVE KDSC-TIPO  TO LA2-TIPO
              MOVE KDSC-DTSCA TO LA2-DTSCA
              MOVE KDSC-PRG   TO LA2-PRG
              MOVE KDSC-PROG  TO LA2-PROG.
           MOVE ZERO    TO LA2-FLGTRO.
           WRITE RF-LA2 INVALID GO TO RDNX-DSC.
           MOVE 3 TO FLGSCA.
           GO TO RDNX-DSC.

      *    ADD 1 TO CONT.
      *    IF CONT > 99  GO TO RDNX-DSC.

      *> salvo chiave dettagli scadenzario per modifica records
      *  al momento della conferma del movimento variato.

      *    MOVE KDSC-AZI   TO VET-DSC-AZI(CONT).
      *    MOVE KDSC-TIPO  TO VET-DSC-TIPO(CONT).
      *    MOVE KDSC-DTSCA TO VET-DSC-DTSCA(CONT).
      *    MOVE KDSC-PRG   TO VET-DSC-PRG(CONT).
      *    MOVE KDSC-PROG  TO VET-DSC-PROG(CONT).
      *    GO TO RDNX-DSC.
      ************
       END-LPDSC.
      **** rel 5.1
      *    IF CONT NOT = ZERO MOVE 3 TO FLGSCA.
      ************
       END-CALC-DETTAGLI.
           EXIT.
      *------------------
       VARIA-DETTAGLI.
      **** rel 5.1
      *    MOVE IF-CLIFOR TO CODCF.
      *    IF IF-HS-TIPRG = 2 MOVE MCLI TO MAS
      *    ELSE               MOVE MFOR TO MAS.

      *    MOVE ZERO TO CONT.
      *LP-VAR-DSC.
      *    ADD 1 TO CONT.
      *    IF CONT > 99 GO TO EX-VARIA-DETTAGLI.
      *    IF VET-DSC-AZI(CONT) = ZERO GO TO EX-VARIA-DETTAGLI.
      *
      *    MOVE VET-DSC-AZI(CONT)   TO KDSC-AZI.
      *    MOVE VET-DSC-TIPO(CONT)  TO KDSC-TIPO.
      *    MOVE VET-DSC-DTSCA(CONT) TO KDSC-DTSCA.
      *    MOVE VET-DSC-PRG(CONT)   TO KDSC-PRG.
      *    MOVE VET-DSC-PROG(CONT)  TO KDSC-PROG.
      *    READ DETSCA KEPT LOCK INVALID MOVE 4 TO FLGSCA
      *                                  GO TO LP-VAR-05.

      *    MOVE DSC-DTDOC TO AAGGG.
      *    MOVE 2 TO TIPOP1.
      *    CALL 'rdata' USING PARCDT.
      *    MOVE GGMMAA TO DTDOC.
      *    IF (DSC-NDOC  NOT = IF-DOCUM) OR
      *       (DTDOC     NOT = IF-DTDOC) OR
      *       (DSC-CODCF NOT = CODICE)   MOVE 4 TO FLGSCA
      *                                  GO TO LP-VAR-05.

           MOVE ZERO TO KL2-PROGR.
           START WDSLA2 KEY NOT < KEYL2 INVALID GO TO EX-VARIA-DETTAGLI.
       RD-LA2.
           READ WDSLA2 NEXT AT END GO TO EX-VARIA-DETTAGLI.

           IF LA2-FLGTRO = 1
              MOVE "Trovato piu' di un dettaglio pagamento "  TO F-MES1
              MOVE "relativo allo stesso documento.        "  TO F-MES2
              MOVE "Nel caso sono stati variati gli importi"  TO F-MES3
              MOVE "delle scadenze, effettuare manualmente "  TO F-MES4
              MOVE "le opportune rettifiche su scadenzario."  TO F-MES5
              MOVE 5 TO F-NMES
              CALL 'vrmbox' USING PARMB
              GO TO RD-LA2.

           MOVE KL2-PROGR TO KLV-PROGR.
           READ WDSLAV INVALID GO TO RD-LA2.
           MOVE RECLAV TO IF-REC-WDS.

           MOVE LA2-AZI   TO KDSC-AZI.
           MOVE LA2-TIPO  TO KDSC-TIPO.
           MOVE LA2-DTSCA TO KDSC-DTSCA.
           MOVE LA2-PRG   TO KDSC-PRG.
           MOVE LA2-PROG  TO KDSC-PROG.
           READ DETSCA KEPT LOCK INVALID MOVE 4 TO FLGSCA
                                         GO TO LP-VAR-05.

           MOVE IF-CLIFOR TO CODCF.
           IF IF-HS-TIPRG = 2 MOVE MCLI TO MAS
           ELSE               MOVE MFOR TO MAS.
           IF (DSC-CODCF NOT = CODICE)   MOVE 4 TO FLGSCA
                                         GO TO LP-VAR-05.
      ************

           IF DSC-IMPOR NOT = IF-IMPOR
              PERFORM VARIA-SCADENZA THRU EX-VARIA-SCADENZA.
           MOVE IF-IMPOR  TO DSC-IMPOR.
           MOVE IF-IMVAL  TO DSC-VALDOC.
      **** rel 5.1
      *> data reg. contabile su dettaglio non piu' gestita
      *    MOVE DTCON-114 TO DSC-DTREG.

      *> numero e data documento
           MOVE IF-DOCUM TO DSC-NDOC.
           MOVE IF-DTDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO DSC-DTDOC.
      ************
           REWRITE RF-DSC INVALID
              PERFORM INVK-DSC
              GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-DSC.
      ************
       LP-VAR-05.
           UNLOCK DETSCA.
           GO TO RD-LA2.
       EX-VARIA-DETTAGLI.
           EXIT.
      *------------------
       VARIA-SCADENZA.
           MOVE KDSC-AZI   TO KSC-AZI.
           MOVE KDSC-TIPO  TO KSC-TIPO.
           MOVE KDSC-DTSCA TO KSC-DTSCA.
           MOVE KDSC-PRG   TO KSC-PRG.
           READ ANASCA KEPT LOCK INVALID PERFORM INVK-SCA GO TO ERRIO.
      **** rel 5.1
      *    COMPUTE SCA-PAGATO = SCA-PAGATO + (IF-IMPOR - DSC-IMPOR).
      *    COMPUTE SCA-VALPAG = SCA-VALPAG + (IF-IMVAL - DSC-VALDOC).
           IF DSC-TIPOP = 'A' AND DSC-TPAG = 9 AND SCA-TPAG = 9
              MOVE IF-IMPOR TO SCA-PAGATO SCA-IMPOR SCA-IMRATA
              MOVE IF-IMPOR TO SCA-VALPAG SCA-VALDOC SCA-VALRATA
           ELSE
              COMPUTE SCA-PAGATO = SCA-PAGATO + (IF-IMPOR - DSC-IMPOR)
              COMPUTE SCA-VALPAG = SCA-VALPAG + (IF-IMVAL - DSC-VALDOC).
      ************
           IF SCA-PAGATO = SCA-IMRATA AND SCA-STATO = SPACE
              MOVE 'P' TO SCA-STATO.
           REWRITE RF-SCA INVALID PERFORM INVK-SCA GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133.
      ************
           UNLOCK ANASCA.
       EX-VARIA-SCADENZA.
           EXIT.
      *------------------
      ************
      **** rel 5.1
      *> verifica se ci sono dettagli di pagamento relativi alla
      *> scadenza del movimento che si sta variando.
      *> Se necessario bisognera' provvedere manualmente alla
      *> variazione dello scadenzario
       VER-DETSCA.
           MOVE KSC-AZI   TO KDSC-AZI.
           MOVE KSC-TIPO  TO KDSC-TIPO.
           MOVE KSC-DTSCA TO KDSC-DTSCA.
           MOVE KSC-PRG   TO KDSC-PRG.
           MOVE ZERO      TO KDSC-PROG.
           START DETSCA KEY NOT < KEYDSC INVALID GO TO EX-VER-DETSCA.
       RD-NXDSC.
           READ DETSCA NEXT AT END GO TO EX-VER-DETSCA.
           IF SF-DSC = '9D' OR '9A' OR '35' GO TO RD-NXDSC.
           IF (KDSC-AZI   NOT = KSC-AZI)   OR
              (KDSC-TIPO  NOT = KSC-TIPO)  OR
              (KDSC-DTSCA NOT = KSC-DTSCA) OR
              (KDSC-PRG   NOT = KSC-PRG)   GO TO EX-VER-DETSCA.
           MOVE 2 TO FLGSCA.
       EX-VER-DETSCA.
           EXIT.
      *------------------
      *> cancellazione di dettaglio generato da una fattura di vendita
      *> con tipo pagamento RB per quei clienti che non usano la
      *> gestione effetti ed inseriscono tutto da primanota.
       DEL-DETSCA.
           MOVE KSC-AZI   TO KDSC-AZI.
           MOVE KSC-TIPO  TO KDSC-TIPO.
           MOVE KSC-DTSCA TO KDSC-DTSCA.
           MOVE KSC-PRG   TO KDSC-PRG.
           MOVE ZERO      TO KDSC-PROG.
           START DETSCA KEY NOT < KEYDSC INVALID GO TO EX-DEL-DETSCA.
       RD-DSC.
           READ DETSCA NEXT KEPT LOCK AT END GO TO EX-DEL-DETSCA.
           IF SF-DSC = '9D' OR '9A' OR '35' GO TO RD-DSC.
           IF KDSC-AZI   > KSC-AZI   GO TO EX-DEL-DETSCA.
           IF KDSC-TIPO  > KSC-TIPO  GO TO EX-DEL-DETSCA.
           IF KDSC-DTSCA > KSC-DTSCA GO TO EX-DEL-DETSCA.
           IF KDSC-PRG   > KSC-PRG   GO TO EX-DEL-DETSCA.
           IF DSC-NREG  NOT = SCA-NREG GO TO RD-DSC.
           IF DSC-NDOC  NOT = ZERO AND
              DSC-DTDOC NOT = ZERO AND
              DSC-BAN   NOT = ZERO GO TO RD-DSC.
           IF DSC-TIPOP NOT = 'D'  GO TO RD-DSC.

           DELETE DETSCA INVALID PERFORM INVK-DSC GO TO ERRIO.

           UNLOCK DETSCA.

      **** rel 7.1
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-DSC.
      ************

           GO TO RD-DSC.
       EX-DEL-DETSCA.
           EXIT.
      *------------------
      ************
      **** rel 5.2
       VERIFICA-FLGPL.
           MOVE ZERO TO K.
       VER-10.
           ADD 1 TO K.
           IF K > 6 GO TO EX-VERIFICA-FLGPL.
           IF IF-IV-COD(K) = ZERO GO TO VER-10.
      *
           MOVE IF-IV-COD(K) TO KTB-COD.
           MOVE 3            TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID GO TO VER-10.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *
           IF NOT (T03-TPIVA = 3 OR 6) GO TO VER-10.
           IF T25-PLA  = ZERO          GO TO VER-10.
           IF IF-HS-FLTIG = ZERO       GO TO VER-10.
           IF NOT (IF-IV-COD(K) = T141ACQ OR T141ACR OR T141ACT OR
                                  T142ACQ OR T143ACQ)
                  AND T03-TSPLA = ZERO
              GO TO VER-10.
      *
           IF TPL = 2
              IF IF-IV-COD(K) NOT = T142ACQ AND T03-TSPLA NOT = 2
                 GO TO VER-10.
      *
           IF TPL = 3
              IF IF-IV-COD(K) NOT = T143ACQ AND T03-TSPLA NOT = 3
                 GO TO VER-10.
      *
           IF T25-PLA > ZERO AND AAGGG NOT > T25-DTM
              MOVE 1 TO IF-FLGPL
           ELSE
              MOVE ZERO TO IF-FLGPL.
      *
           GO TO VER-10.
       EX-VERIFICA-FLGPL.
           EXIT.
      *------------------
       VER-CP.
           IF IF-FL NOT = ZERO GO TO EX-VER-CP.

           MOVE ZERO TO J.
       LP-CP.
           ADD 1 TO J.
           IF J > 3 GO TO EX-VER-CP.
              IF CP-FTEM(J) = ZERO AND
                 CP-FTRC(J) = ZERO AND
                 CP-NAEM(J) = ZERO AND
                 CP-NARC(J) = ZERO GO TO LP-CP.

           IF IF-HS-TIPRG = 2
              IF (IF-CP-COD(K1) = CP-FTEM(J) OR CP-NAEM(J))
                 GO TO SI-FLAVE
              ELSE
                 GO TO LP-CP.
           IF IF-HS-TIPRG = 3
              IF (IF-CP-COD(K1) = CP-FTRC(J) OR CP-NARC(J))
                 GO TO SI-FLAVE
              ELSE
                 GO TO LP-CP.
       SI-FLAVE.
           MOVE 1 TO IF-FLAVE.
       EX-VER-CP.
           EXIT.
      *------------------
       SCRIVI-WDSLA3.
           IF IF-HS-TIPRG = 1 GO TO EX-SCRIVI-WDSLA3.
      *
           MOVE ZERO  TO RF-LA3.
           MOVE SPACE TO LA3-DESAG.

      *> key
           MOVE K114-PROG   TO KL3-PROGR.
           MOVE DTCON-114   TO KL3-DTREG.
      *
           IF IF-HS-TIPRG = 2
              MOVE CAU-FTEM TO LA3-CAUS
           ELSE
              MOVE CAU-FTRC TO LA3-CAUS.
           MOVE L114-CPART  TO LA3-CPART.
           MOVE L114-IMPCP  TO LA3-IMPOR.
           MOVE IF-CLIFOR-D TO LA3-DESAG.
           MOVE L114-DOCUM  TO LA3-DOCUM.
           MOVE L114-DTDOC  TO LA3-DTDOC.
           WRITE RF-LA3 INVALID
                 MOVE 'Errore scrittura wdsla3' TO MESS
                 GO TO ERRIO.
       EX-SCRIVI-WDSLA3.
           EXIT.
      *------------------
       INI-DA-WDSLA3.
           MOVE LOW-VALUE TO KEYL3.
           MOVE ZERO TO KL3-PROGR.
           MOVE ZERO TO KL3-DTREG.
           START WDSLA3 KEY NOT < KEYL3 INVALID MOVE 2 TO IF-FLAVE
                                                GO TO EX-INI-DA-WDSLA3.
       CREA-LA3-20.
           READ WDSLA3 NEXT AT END MOVE 2 TO IF-FLAVE
                                   GO TO EX-INI-DA-WDSLA3.
           IF SF-LA3 = '9D' OR '9A' OR '35' GO TO CREA-LA3-20.
           IF (LA3-CAUS  = ZERO) OR
              (LA3-CPART = ZERO) OR
              (LA3-IMPOR = ZERO) GO TO CREA-LA3-20.

      *> verifica la causale
           MOVE 2        TO KTB-TIP.
           MOVE LA3-CAUS TO KTB-COD.
           PERFORM RDTAB1 THRU EX-RDTAB1.
           MOVE T02-D-A TO IF-D-A.
           IF IF-PROGR > 1 AND KTB-COD = PRG1-CAUS AND PRG1-ATTRN = 1
              IF T02-D-A = 'D'
                 MOVE 'A' TO IF-D-A
              ELSE
                 MOVE 'D' TO IF-D-A.
           MOVE SPACE TO MESS.
           IF SWERR = 1
              MOVE ZERO  TO OLDCAUS
              MOVE SPACE TO IF-CAUS-D
              MOVE 'Causale incongruente' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              GO TO CREA-LA3-30.
           IF IF-HS-ATTRN = 1 AND AGIVA = 1
              MOVE SPACE TO F-MES1
              STRING 'Totali IVA aggiornati al ' DATIVB
                     DELIMITED '  ' INTO F-MES1
                 MOVE 1 TO F-NMES
                 CALL 'vrmbox' USING PARMB
                 GO TO CREA-LA3-30.
           IF IF-HS-ATTRN     = 1 AND
              FLGPL           = 1 AND
              IF-HS-TIPRG     = 2 AND
              IF-T02-FLGIS NOT = 1
                 MOVE SPACE TO F-MES1
                 STRING 'Movimenti plafond aggiornati al ' DTMB
                        DELIMITED '  ' INTO F-MES1
                 MOVE 1 TO F-NMES
                 CALL 'vrmbox' USING PARMB
                 GO TO CREA-LA3-30.

           IF IF-DESAG = SPACE
              MOVE COMDESAG TO IF-DESAG.
           IF IF-LEG-FLGPB2 = 1 MOVE 1 TO IF-LEG-FLGPB1.
           IF IF-LEG-FLGPB1 = 1 GO TO E-CAUS.
           MOVE IF-CAUS   TO IF-LEG-CAUS.
           MOVE IF-CAUS-D TO IF-LEG-CAUS-D.
           PERFORM CARICA-LEGAMI THRU EX-CARICA-LEGAMI.
           IF IF-LEG-NBYTE > ZERO
              MOVE 1    TO IF-LEG-FLGPB1
              MOVE ZERO TO IF-LEG-FLGPB2
              MOVE 1    TO IF-LEG-FLGDB
              IF IF-HS-ATTRN = 1 AND IF-PROGR = 1
                 MOVE ZERO TO IF-LEG-FLGPB1
                 MOVE 1    TO IF-LEG-FLGPB2.
       CREA-LA3-30.
           MOVE KL3-DTREG TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DATREG.

           MOVE LA3-CAUS  TO IF-CAUS.
           MOVE LA3-CPART TO IF-CPART.
           MOVE LA3-IMPOR TO IF-IMPOR.
           MOVE LA3-DESAG TO IF-DESAG.
           MOVE LA3-DOCUM TO IF-DOCUM.
           MOVE LA3-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DTDOC.

           DELETE WDSLA3.
       CREA-LA3-90.
           READ WDSLA3 NEXT AT END MOVE 2 TO IF-FLAVE
                                   GO TO EX-INI-DA-WDSLA3.
       EX-INI-DA-WDSLA3.
           EXIT.
      *------------------
      ************
      **** rel 6.3
       VERIFICA-PRT.
           MOVE ZERO TO ERRPRT.
           IF IF-HS-ATTRN = 1 MOVE IF-NPRGI       TO SAV-NPRGI.
           IF IF-HS-ACEE  = 1 MOVE IF-ACEE-NPRGIA TO SAV-NPRGI.
      *
      * se sono in modifica
           IF IF-RG-FUN = 'M'   GO TO FINE-PRT.
      *
           MOVE 2        TO KTB-TIP.
           MOVE SAV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY PERFORM INVK-TAB
                                               GO TO ERRIO.
      * se non e' fattura acquisto
           IF T02-TIPRG NOT = 3 GO TO EX-VERIFICA-PRT.
           IF NOT ( T02-TIPOP = 1 OR 8 ) GO TO EX-VERIFICA-PRT.
      *
          MOVE IF-DATREG TO GGMMAA.
          MOVE 1 TO TIPOP1.
          CALL 'rdata' USING PARCDT.
      *
          MOVE ZERO   TO PARPRT.
          MOVE IF-AZI TO PPRT-AZI.
          MOVE IF-FL  TO PPRT-FL.
          MOVE CIVACQ TO PPRT-CON.
      * memorizza data mov
          MOVE ULTDTREG TO GGMMAA.
          MOVE 1 TO TIPOP1.
          CALL 'rdata' USING PARCDT.
          MOVE AAGGG TO PPRT-DTINS.
      * cerca ult num e data                     
      * + num da proporre solo per acq
          CALL 'vrcprt' USING PARPRT
          IF PPRT-BUCPRT NOT = ZERO
             MOVE PPRT-BUCPRT TO COMPRT
             MOVE 1 TO ERRPRT
             GO TO EX-VERIFICA-PRT.                   
          IF PPRT-UPRT < SAV-NPRGI
             IF PPRT-DTUPR > AAGGG
                MOVE 2 TO ERRPRT
                GO TO EX-VERIFICA-PRT.
      *
           IF SAV-CATT NOT = '0' GO TO RD-T35-0.
      * protocollo da azienda
       RD-AZI-0.
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID PERFORM INVK-AZI
                                                     GO TO ERRIO.
           IF SF-AZI NOT = ZERO PERFORM REC-LOCK
                                GO TO RD-AZI-0.
      *
           MOVE AZI-RANRG TO COMPRT.
           ADD 1          TO COMPRT.
      *
      * se il protocollo utilizzato ancora esattamente il sucessivo
      * viene memorizzato gi qui su azienda in modo tale che se altri 
      * utenti cercassero di prelevare lo stesso numero darebbe errore
           IF SAV-NPRGI NOT < SAV-ONPRGI
              IF COMPRT NOT = SAV-NPRGI
              MOVE 1 TO ERRPRT
              UNLOCK ANAAZI 
              GO TO FINE-PRT.
      *
           MOVE COMPRT TO AZI-RANRG.
           REWRITE RF-AZI FROM REKAZI INVALID PERFORM INVK-AZI
                                              GO TO ERRIO.
           UNLOCK ANAAZI.
      *
           GO TO EX-VERIFICA-PRT.
       RD-T35-0.
           MOVE 35       TO T35-TIP.
           MOVE KAZ-COD  TO T35-CDAZ.
           MOVE SAV-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 KEPT LOCK INVALID PERFORM INVK-TAB
                                                     GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           IF SF-TAB NOT = ZERO PERFORM REC-LOCK
                                GO TO RD-T35-0.
           MOVE T35-RANRG TO COMPRT.
           ADD 1          TO COMPRT.
      *
      * se il protocollo utilizzato ancora esattamente il sucessivo
      * viene memorizzato gi qui su azienda in modo tale che se altri 
      * utenti cercassero di prelevare lo stesso numero darebbe errore
           IF SAV-NPRGI NOT < SAV-ONPRGI
              IF COMPRT NOT = SAV-NPRGI
                 MOVE 1 TO ERRPRT
                 UNLOCK TABELL 
                 GO TO FINE-PRT.
      *
           MOVE COMPRT TO T35-RANRG.
           REWRITE RF-TAB FROM REKT35 INVALID PERFORM INVK-TAB
                                              GO TO ERRIO.
           UNLOCK TABELL.
       FINE-PRT.
      *
       EX-VERIFICA-PRT.
           EXIT.
      *------------------
       AGGIORNA-PRT.
           MOVE ZERO TO KLV-PROGR.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO END-AGG-PRT.
       RD-WR-PRT.
           READ WDSLAV NEXT AT END GO TO END-AGG-PRT.
      *
           MOVE RECLAV TO IF-REC-WDS.
      *
           IF IF-HS-TIPRG NOT = 3         GO TO RD-WR-PRT.
           IF NOT (IF-T02-TIPOP = 1 OR 8) GO TO RD-WR-PRT.
           IF IF-NPRGI = ZERO AND IF-ACEE-NPRGIA = ZERO
              GO TO RD-WR-PRT.
      *
           IF IF-NPRGI NOT = ZERO       MOVE COMPRT TO IF-NPRGI.
           IF IF-ACEE-NPRGIA NOT = ZERO MOVE COMPRT TO IF-ACEE-NPRGIA.
      *
           MOVE IF-REC-WDS TO RECLAV.
           REWRITE RF-LAV INVALID MOVE 'RW LAV PRT' TO MESS
                                  GO TO ERRIO.
      *
           GO TO RD-WR-PRT.
       END-AGG-PRT.
       EX-AGGIORNA-PRT.
           EXIT.
      *------------------
      ************
      **** rel 6.1
       CONTROLLA-FATFOR.
           MOVE LOW-VALUE TO KEYL4.
           START WDSLA4 KEY NOT < KEYL4 INVALID GO TO END-LA4.
       RD-LA4.
           READ WDSLA4 NEXT AT END GO TO END-LA4.
      *
           MOVE IF-NPRGI TO COMPRGI.
           MOVE IF-CATT  TO COMCATT.
           IF (IF-NPRGI = ZERO) AND (IF-ACEE-NPRGIA NOT = ZERO)
              MOVE IF-ACEE-CATTA  TO COMCATT
              MOVE IF-ACEE-NPRGIA TO COMPRGI.
      *
           IF COMPRGI NOT = KL4-NPRGI GO TO CANC-LA4.
           IF COMCATT NOT = KL4-CATT   GO TO CANC-LA4.
      *
           IF IF-CLIFOR NOT = LA4-FOR GO TO CANC-LA4.
      *
           MOVE IF-DTDOC    TO GGMMAA.
           MOVE 1           TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF AAGGG NOT = LA4-DTDOC GO TO CANC-LA4.
      *
           MOVE IF-DATREG   TO GGMMAA.
           MOVE 1           TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF AAGGG NOT = LA4-DTREG GO TO CANC-LA4.
      *
           IF NOT (IF-T02-TIPOP = 1 OR 8) GO TO CANC-LA4.
      *
           GO TO NO-CANC-LA4.
       CANC-LA4.
      *
           MOVE ZERO      TO PPAR-FUN.
           MOVE 'FAF'     TO PPAR-TARC.
           MOVE 'C'       TO PPAR-TOPE.
      *
           MOVE KL4-AZI   TO COM-AZI.
           MOVE KL4-ANNO  TO COM-ANNO.
           MOVE KL4-CATT  TO COM-CATT.
           MOVE KL4-NPRGI TO COM-NPRGI.
           MOVE COMKEY    TO PPAR-KEY.
      *
           MOVE LA4-DTREG TO COM-DAT.
           MOVE LA4-DTDOC TO COM-DTDOC.
           MOVE LA4-DOCUM TO COM-NDOC.
           MOVE LA4-FOR   TO COM-ACF.
           MOVE LA4-CAUS  TO COM-CAUS.
           MOVE COMMOV    TO PPAR-OPZ.
      *
           MOVE KL4-CATT  TO PPAR-CATT.
           CALL 'vsrv130' USING PARPPAR.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore chiamata vsrv130. Errore ' PPAR-ERR
                      DELIMITED SIZE INTO MESS
              GO TO ERRIO.
       NO-CANC-LA4.
      *
           GO TO RD-LA4.
       END-LA4.
      *
       EX-CONTROLLA-FATFOR.
           EXIT.
      *------------------
       AGGIORNA-LA4.
           MOVE ZERO TO KLV-PROGR.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO END-WR-LA4.
       RD-WR-LA4.
           READ WDSLAV NEXT AT END GO TO END-WR-LA4.
      *
           MOVE RECLAV TO IF-REC-WDS.
      *
           IF IF-HS-TIPRG NOT = 3         GO TO RD-WR-LA4.
           IF NOT (IF-T02-TIPOP = 1 OR 8) GO TO RD-WR-LA4.
           IF IF-NPRGI = ZERO AND IF-ACEE-NPRGIA = ZERO
              GO TO RD-WR-LA4.
      *
           MOVE IF-AZI    TO KL4-AZI.
           IF IF-NPRGI NOT = ZERO MOVE IF-NPRGI  TO KL4-NPRGI
                                  MOVE IF-CATT   TO KL4-CATT
           ELSE                   MOVE IF-ACEE-NPRGIA TO KL4-NPRGI
                                  MOVE IF-ACEE-CATTA  TO KL4-CATT.
      *
           MOVE IF-DATREG TO GGMMAA.
           MOVE 1         TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4       TO KL4-ANNO.
      *
           READ WDSLA4 INVALID
                WRITE RF-LA4.
           MOVE  IF-DOCUM  TO LA4-DOCUM.
      *
           MOVE  IF-DTDOC  TO GGMMAA.
           MOVE 1          TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG      TO LA4-DTDOC.
      *
           MOVE  IF-DATREG TO GGMMAA.
           MOVE 1          TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG      TO LA4-DTREG.
      *
           MOVE  IF-CLIFOR TO LA4-FOR.
           MOVE  IF-CAUS   TO LA4-CAUS.
           REWRITE RF-LA4.
      *
           GO TO RD-WR-LA4.
       END-WR-LA4.
      *
       EX-AGGIORNA-LA4.
           EXIT.
      *------------------
      ************
      **** rel 6.2
       AGG-SCAD-PAGANT-L.
           MOVE ZERO TO KLV-PROGR.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO END-PAGANT.
       RD-PAGANT.
           READ WDSLAV NEXT AT END GO TO END-PAGANT.
      *
           MOVE RECLAV TO IF-REC-WDS.
      *
           IF IF-HS-TIPRG  = 3 AND
              IF-T02-TIPOP = 6 AND
              IF-T02-FLGSC = 2 AND
              IF-DOCUM = ZERO  AND
              IF-DTDOC = ZERO
                 PERFORM AGG-SCAD-PAGANT THRU EX-AGG-SCAD-PAGANT.
      *
           GO TO RD-PAGANT.
       END-PAGANT.
      *
       EX-AGG-SCAD-PAGANT-L.
           EXIT.
      *------------------
      ************
      **** rel 7.1
       VERIFICA-TIPO.
           MOVE 25        TO T25-TIP.
           MOVE PTRA-AZI  TO T25-COD.
           MOVE '6'       TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID
                MOVE 'Tabella 25/6 mancante' TO F-MES1
                MOVE 1 TO F-NMES
                CALL 'vrmbox' USING PARMB
                GO TO EX-VERIFICA-TIPO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-NOMMEA TO NOMMEA.
           MOVE T25-NOMMEV TO NOMMEV.
      *
           MOVE PTRA-TRAN TO COM-TRAN.
           IF PTRA-NOMME NOT = ZERO MOVE PTRA-NOMME TO COM-NOMME
           ELSE
              IF CLF-NOMME NOT = ZERO MOVE CLF-NOMME TO COM-NOMME
              ELSE
                 IF PTRA-TRAN = 'A' MOVE NOMMEA TO COM-NOMME
                 ELSE MOVE NOMMEV TO COM-NOMME.
           IF COM-NOMME NOT = ZERO AND COM-NOMME < 1000000
              IF PTRA-TRAN = 'A'
                 MOVE 'I'       TO COM-TRAN
              ELSE
                 MOVE 'R'       TO COM-TRAN.
           IF COM-TRAN NOT = 'I'
              GO TO EX-VERIFICA-TIPO. 
           MOVE IF-DATREG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO PTRA-DTDOC.
           MOVE IF-ACEE-NPRGIV TO PTRA-NUDOC.
       EX-VERIFICA-TIPO.
           EXIT.
      *------------------
       CALL-VSRV133.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'SCA'   TO PPAR-TARC.
           MOVE KEYSC   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 SCA. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *
       CALL-VSRV133-DSC.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'DSC'   TO PPAR-TARC.
           MOVE KEYDSC  TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 DSC. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------
      ************
