       IDENTIFICATION DIVISION.
       PROGRAM-ID. VORF184.
      *
      * OGGETTO: Controllo fatture/bolle e contabilizzazione
      *
      * Nota: valori particolari di FUN
      *       FUN= W  valida tutto dei dati di testata
      *       FUN= w  valida tutto degli altri dati
      *               (maschere IVA, C/P, Scadenzario)
      *       FUN= M  valida dati necessari per selezione bolle
      *       FUN= r  esegue chiamata Cobol a VORF183 e preleva
      *               il vettore delle bolle selezionate.
      *       FUN= c  fase di controlli preliminari da effettuare dopo
      *               che le validazioni sono andate a buon fine
      *       FUN= 1  passa una alla volta tutte le bolle selezionate
      *               all'interfaccia per permettere la loro variazione
      *
      * Nota: IF-CAMPO puo' restituire 'AMM-SI' durante la RUN-ELABORA
      *       per fare in modo che l'interfaccia lanci l'aggancio
      *       ai cespiti.
      *
      **** rel 5.2
      * Nota: IF-CAMPO2 puo' restituire 'AVE-SI' durante la RUN-ELABORA
      *       per fare in modo che l'interfaccia lanci il vcon110 per
      *       aprire Inserimento Prima Nota V. ES.
      ************
      **** rel 5.0
      * Ricompilato per variazione tracciato ANABAN
      ************
      **** rel 7.1
      * Ricompilato per variazione wrklav 
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
      **** rel 2.0
           COPY 'griprasl'.
      ************
           COPY 'griclfsl'.
           COPY 'gribftsl'.
      **** rel 6.1
           COPY 'griabfsl'.
      ************
           COPY 'gribfrsl'.
           COPY 'griconsl'.
      **** rel 5.2
           COPY 'griacosl'.
      ************
           COPY 'griartsl'.
      **** rel 1.2
      *    COPY 'gricggsl'.
      ************
           COPY 'gribansl'.
           COPY 'gricamsl'.
           COPY 'gritabsl'.
           COPY 'gricdcsl'.
           COPY 'gritrtsl'.
           COPY 'gri135sl'.
      **** rel 5.2
           COPY 'gri400sl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
           SELECT APPFTE  ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC
                  RECORD KEY KEYABT
                  ALTERNATE RECORD KEY KEYABT2 WITH DUPLICATES
                  ALTERNATE RECORD KEY KEYABT3 WITH DUPLICATES
                  ALTERNATE RECORD KEY KEYABT4 WITH DUPLICATES
                  STATUS SF-ABT.
           SELECT APPFRI  ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC
                  RECORD KEY KEYAFR
                  ALTERNATE RECORD KEY KEYAFR2 WITH DUPLICATES
                  STATUS SF-AFR.
           SELECT WDSLA3 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL3 STATUS SF-LA3.
      ************
      **** rel 6.2
           COPY 'gri185sl'.
      ************
      **** rel 6.2
           COPY 'griscasl'.
           COPY 'gridscsl'.
           COPY 'grinscsl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
      **** rel 2.0
           COPY 'gripra'.
      ************
           COPY 'griclf'.
           COPY 'gribft'.
      **** rel 6.1
           COPY 'griabf'.
      ************
           COPY 'gribfr'.
           COPY 'gricon'.
      **** rel 5.2
           COPY 'griaco'.
      ************
           COPY 'griart'.
      **** rel 1.2
      *    COPY 'gricgg'.
      ************
           COPY 'griban'.
           COPY 'gricam'.
           COPY 'gritab'.
           COPY 'gricdc'.
           COPY 'gritrt'.
           COPY 'gri135'.
      **** rel 6.2
      *
      * file di lavoro generato da vrit185 durante
      * l'esecuzione di vcon113
      *
           COPY 'gri185'.
      ************
      **** rel 5.2
      *
      * file di lavoro per passaggio dati a vcon400
      *
           COPY 'gri400'.
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
      **** rel 7.1
      *    RECORD 21 DATA RECORD RF-LAV.
           RECORD 45 DATA RECORD RF-LAV.
      ************
       01  RF-LAV.
           05 KEYLV.
              10 KLV-NOMME PIC 9(8).
           05 RECLAV.
              10 LAV-IMPO PIC S9(11)V99.
      **** rel 7.1
              10 LAV-IMPV PIC S9(11)V99.  *> importo in valuta
              10 LAV-MNET PIC S9(9)V99.   *> massa netta
      ************

      *> appoggio testata bolle per possibile variazione flag fatturato
      *> e poi non si conferma la contabilizzazione.
      *
       FD  APPFTE LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-AFT
           RECORD 120 DATA RECORD RF-AFT.
       01  RF-AFT.
           02 KEYABT.
              05 KABT-AZI    PIC 999.
              05 KABT-PRT    PIC 9(7).
           02 KEYABT2.
              05 AFT-NBOF   PIC X(8).
           02 KEYABT3.
              05 AFT-FOR    PIC 9(5).
              05 AFT-DTBO   PIC 9(5)     COMP-3.
           02 KEYABT4.
              05 AFT-DTCO   PIC 9(5)     COMP-3.
              05 AFT-PRT4   PIC 9(7)     COMP-3.
           02 AFT.
              05 AFT-FLGFT  PIC 9.
              05 AFT-FLGMG  PIC 9.
              05 AFT-CDEP   PIC 99.
              05 AFT-NORD   PIC 9(5).
              05 AFT-DTORD  PIC 9(5)     COMP-3.
              05 AFT-DSORD  PIC X(10).
              05 AFT-CSPE   PIC 999.
              05 AFT-CPOR   PIC 999.
              05 AFT-CPAG   PIC 999.
              05 AFT-SCBAS  PIC 99V99.
              05 AFT-CBAN   PIC 9(5).
              05 AFT-ESIVA  PIC 999.
              05 AFT-VALUT  PIC 999.
              05 AFT-CAMGG  PIC 9(5)V9(6) COMP-3.
              05 AFT-ZONA   PIC XXX.
              05 AFT-DTPAG  PIC 9(5)     COMP-3.
              05 AFT-NFAT   PIC 9(5)     COMP-3.
              05 AFT-CPART  PIC 999.
              05 AFT-CATT   PIC X.
              05 AFT-CAUS   PIC 9(3).
              05 FILLER     PIC X(19).

      *> appoggio righi bolle per possibile variazione flag fatturato
      *> e prezzi e poi non si conferma la contabilizzazione.
       FD  APPFRI LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-AFR
           RECORD 160 DATA RECORD RF-AFR.
       01  RF-AFR.
           02 KEYAFR.
              05 KAFR-AZI    PIC 999.
              05 KAFR-PRT    PIC 9(7).
              05 KAFR-PRG    PIC 9(3).
           02 KEYAFR2.
              05 AFR-CODART PIC X(18).
              05 AFR-PRT    PIC 9(7).
           02 AFR.
              05 AFR-TPRIG  PIC 9.
              05 AFR-CDSPE  PIC 9(3).
              05 AFR-TQUAN  PIC 9.
              05 AFR-FSC    PIC 9.
              05 AFR-DESCR  PIC X(30).
              05 AFR-UNMIS  PIC XX.
              05 AFR-CDIVA  PIC 999.
              05 AFR-QUANT  PIC S9(10)V999  COMP-3.
              05 AFR-PZLOR  PIC S9(11)V9(6) COMP-3.
              05 AFR-SCON1  PIC S99V99.
              05 AFR-PZNET  PIC S9(11)V9(6) COMP-3.
              05 AFR-NETRG  PIC S9(11)V99   COMP-3.
              05 AFR-CPART  PIC 999.
              05 AFR-QUAFA  PIC S9(10)V999  COMP-3.
              05 AFR-VALFA  PIC S9(11)V99   COMP-3.
              05 AFR-FLGFT  PIC 9.
              05 AFR-NUMOV  PIC 9(5)   COMP-3.
              05 AFR-FLGORD PIC 9.
              05 AFR-QUADOC PIC X.
              05 AFR-CONLOT PIC X.
              05 AFR-MQTA   PIC S999V99.
              05 AFR-MGIOR  PIC S999V99.
              05 AFR-SCON2  PIC S99V99.
              05 FILLER     PIC X(7).

       FD  WDSLA3 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA3
           RECORD 71 DATA RECORD RF-LA3.
       01  RF-LA3.
           05 KEYL3.
              10 KL3-PROGR   PIC 9(3).
              10 KL3-DTREG   PIC 9(5).
           05 RECLA3.
              10 LA3-CAUS    PIC 9(3).
              10 LA3-CPART   PIC 9(7).
              10 LA3-IMPOR   PIC S9(11)V99.
              10 LA3-DESAG   PIC X(30).
              10 LA3-DOCUM   PIC 9(5).
              10 LA3-DTDOC   PIC 9(5).
      ************
      **** rel 6.2
           COPY 'grisca'.
           COPY 'gridsc'.
           COPY 'grinsc'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'griclfrk'.
           COPY 'griconrk'.
           COPY 'griartrk'.
           COPY 'gritabrk'.
           COPY 'rekt21'.
           COPY 'grit25rk'.
           COPY 'grit35rk'.
      **** rel 7.1
           COPY 'grit37rk'.
      ************
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parrd'.
           COPY 'parcos'.
           COPY 'wrklav'.
      **** rel 1.2
           COPY 'parer'.
           COPY 'parlk'.
      ************
      **** rel 4.1a
           COPY 'parmb'.
      ************
      **** rel 5.2
           COPY 'parmag'.
           COPY 'partra'.
      * parametri per vcon400
       01  PARLINK-400.
           05 DTCON-400 PIC 9(5) COMP-3.
           05 FL-400    PIC 9.
           05 CDAZ-400  PIC 9(3).
           05 FLTRA-400 PIC 9.
      ************
      **** rel 6.3
           05 W400-KEYTRA.
              10 W400-KEY-AZI  PIC 999.
              10 W400-KEY-IVA  PIC 9(11).
              10 W400-KEY-ANNO PIC 9(4).
              10 W400-KEY-PERI PIC 9(2).
              10 W400-KEY-TRAN PIC X.
              10 W400-KEY-TIPO PIC 9.
              10 W400-KEY-TIPN PIC X.
              10 W400-KEY-PROT PIC 9(5).
              10 W400-KEY-PROG PIC 9(3).
      ************
      **** rel 6.0
           COPY 'paracf'.
      ************
      **** rel 6.1
           COPY 'parrcr'.
           COPY 'parmfa'.
      ************
      **** rel 7.1
           COPY 'parppar'.
      ************
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
      **** rel 2.0
       01  ID-PRA PIC X(15) VALUE 'proazi'.
      ************
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-BFT PIC X(15) VALUE 'bolfte'.
      **** rel 6.1
       01  ID-ABF PIC X(15) VALUE 'appbft'.
      ************
       01  ID-BFR PIC X(15) VALUE 'bolfri'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
      **** rel 5.2
       01  ID-ACO PIC X(15) VALUE 'appcon'.
      ************
       01  ID-ART PIC X(15) VALUE 'magart'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
      **** rel 1.2
      *01  ID-CGG PIC X(15) VALUE 'camgio'.
      ************
       01  ID-BAN PIC X(15) VALUE 'anaban'.
       01  ID-TAC PIC X(15) VALUE 'tacoam'.
       01  ID-CDC PIC X(15) VALUE 'cdcost'.
       01  ID-TRT PIC X(15) VALUE 'tabrit'.
       01  ID-135 PIC X(15) VALUE 'wds135'.
      **** rel 5.2
       01  ID-400 PIC X(15) VALUE 'wds400'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  ID-AFT PIC X(15) VALUE 'appfte'.
       01  ID-AFR PIC X(15) VALUE 'appfri'.
       01  ID-LA3 PIC X(15).
      ************
      **** rel 6.2
       01  ID-185  PIC X(15) VALUE 'wds185'.
      ************
      **** rel 6.2
       01  ID-SCA PIC X(15) VALUE 'anasca'.
       01  ID-DSC PIC X(15) VALUE 'detsca'.
       01  ID-NSC PIC X(15) VALUE 'notsca'.
      ************
       01  REKTE14.
           05 FILLER   PIC X(5).
           05 T14IVER  PIC 9(7).
           05 T14RICO  PIC 9(7).
           05 T14GIIV  PIC 9(3).
           05 T14GICO  PIC 9(3).
           05 T14IDIR  PIC 9(3).
           05 T14ITRI  PIC 9(3).
           05 T14IIND  PIC 9(3).
           05 T14ISCV  PIC 9(3).
           05 T14IRSM  PIC 9(3).
           05 T14IASS  PIC 9(3).
           05 T14ISIN  PIC 9(3).
           05 T141ACQ  PIC 9(3).
           05 T141ACR  PIC 9(3).
           05 T141ACT  PIC 9(3).
           05 T142ACQ  PIC 9(3).
           05 T143ACQ  PIC 9(3).
           05 FILLER    PIC X(11).
       01  CODCEN PIC X(4) VALUE SPACE.
       01  CODICE PIC 9(7).
       01  CODIC1 REDEFINES CODICE.
           05 MAS PIC 99.
           05 COD PIC 9(5).
       01  TABMESI PIC X(24) VALUE '312831303130313130313031'.
       01  TBMESI  REDEFINES TABMESI.
           05 GIO PIC 99 OCCURS 12.
       01  COMODI.
           05 SF-TAB PIC XX.
           05 SF-AZI PIC XX.
      **** rel 2.0
           05 SF-PRA PIC XX.
      ************
           05 SF-CLF PIC XX.
           05 SF-BFT PIC XX.
      **** rel 6.1
           05 SF-ABF PIC XX.
      ************
           05 SF-BFR PIC XX.
           05 SF-CON PIC XX.
      **** rel 5.2
           05 SF-ACO PIC XX.
      ************
           05 SF-ART PIC XX.
      **** rel 1.2
      *    05 SF-CGG PIC XX.
      ************
           05 SF-BAN PIC XX.
           05 SF-TAC PIC XX.
           05 SF-CDC PIC XX.
           05 SF-TRT PIC XX.
           05 SF-135 PIC XX.
      **** rel 5.2
           05 SF-400 PIC XX.
           05 SF-LAV PIC XX.
           05 SF-ABT PIC XX.
           05 SF-AFR PIC XX.
           05 SF-LA3 PIC XX.
      ************
      **** rel 6.2
           05 SF-185   PIC XX.
      ************
      **** rel 6.2
           05 SF-SCA PIC XX.
           05 SF-DSC PIC XX.
           05 SF-NSC PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
      **** rel 5.0-2
      *    05 K        PIC 99.
      *    05 K1       PIC 99.
      *    05 K2       PIC 99.
      *    05 K4       PIC 99.
      *    05 KF1      PIC 99.
      *    05 IND2     PIC 99.

           05 K        PIC 999.
           05 K1       PIC 999.
           05 K2       PIC 999.
           05 K4       PIC 999.
           05 KF1      PIC 999.
           05 IND2     PIC 999.
      **************
           05 TABCPT   PIC 9(7).
           05 COMVA1   PIC S9(11)V99.
           05 BOLCON   PIC 9(7) OCCURS 15.
      **** rel 4.0
      *    05 BOLTOT   PIC S9(11) OCCURS 15.
           05 BOLTOT   PIC S9(11)V99 OCCURS 15.
      ************
           05 SW-BOL   PIC 9.
           05 COMODO   PIC S9(13)V99.
           05 BOLTVA   PIC S9(11)V99 OCCURS 15.
           05 VALPVA   PIC S9(11)V99 OCCURS 15.
           05 TOTCVA   PIC S9(11)V99.
           05 W-DTSCA  PIC 9(5) COMP-3.
           05 CLAV1    PIC 99.
           05 CLAV2    PIC 99.
           05 NUMGG    PIC 9(5).
      **** rel 6.3
           05 J        PIC 999 VALUE ZERO.
           05 AZISPE   PIC 9(3)      OCCURS 100.
           05 NOMMESPE PIC 9(8)      OCCURS 100.
           05 IMPOSPE  PIC S9(11)V99 OCCURS 100.
           05 TOTSPESE2 PIC S9(11)V99 VALUE ZERO.
           05 SPESE2    PIC 9(5) VALUE ZERO.
           05 SAVIMPO   PIC S9(11)V99.
      ************
      **** rel 5.2
           05 FLGCEE   PIC 9    VALUE ZERO.
      **** rel 7.1
           05 FLGRB    PIC 9    VALUE ZERO.
           05 PAECEE   PIC XX   VALUE SPACE.
      *
           05 AC-PAPR PIC 9.
           05 AC-PAOR PIC 9.
           05 AC-PRDE PIC XX.
           05 AC-CDPP PIC 9.
           05 AC-MOER PIC X.
           05 AC-MOIN PIC X.
      ************
           05 NOMMEA   PIC 9(8) VALUE ZERO.
           05 NOMMEV   PIC 9(8) VALUE ZERO.
           05 NOMMEC   PIC 9(8) VALUE ZERO.
           05 NOMMEART PIC 9(8) VALUE ZERO.
           05 SAVNOM   PIC 9(8) VALUE ZERO.
           05 CONT     PIC 9(5) VALUE ZERO.
           05 SPESE    PIC 9(5) VALUE ZERO.
           05 TOTNETRG PIC S9(11)V99 VALUE ZERO.
           05 TOTSPESE PIC S9(11)V99 VALUE ZERO.

      *> comodi tabella 14L per conti fatt da emettere/ricevere
           05 VET-CONTI OCCURS 3.
              10 CP-FTRC   PIC 9(7).
           05 CAU-FTRC     PIC 999.
           05 FLAVE PIC 9  VALUE ZERO.
      ************
      **** rel 4.0
      *    05 COMUR    PIC S9(11).
           05 COMUR    PIC S9(11)V99.
      ************
           05 COM1     PIC 999.
           05 COM2     PIC 999.
      **** rel 4.0
      *    05 TOTIVA   PIC S9(11).
      *    05 COMFAT   PIC S9(11).
           05 TOTIVA   PIC S9(11)V99.
           05 COMFAT   PIC S9(11)V99.
      ************
           05 COMFTV   PIC S9(11)V99.
      **** rel 4.0
      *    05 CIMPIVA  PIC S9(11).
      *    05 COMR     PIC S9(11).
           05 CIMPIVA  PIC S9(11)V99.
           05 COMR     PIC S9(11)V99.
      ************
           05 COMRV    PIC S9(11)V99.
           05 SW-AGG   PIC 9.
           05 SWIVA    PIC 9.
           05 SWOPN    PIC X.
           05 PARM     PIC XXX.
      **** rel 5.0
           05 MNREG    PIC 9(5) VALUE ZERO.
      ************
           05 SEGNO    PIC 9.
           05 DTAIVA   PIC 9(5) COMP-3.
           05 DATIVB   PIC X(8).
      **** rel 6.1
           05 T25ATT   PIC 9.
           05 T25PLA   PIC 9.
           05 T25KDTM  PIC 9(5).
           05 NREGV    PIC ZZZZ9.
           05 NPRIVV   PIC ZZZZ9.
      ************
           05 DTM      PIC 9(6).
      **** rel 7.1
           05 COM-NOMME PIC 9(8) VALUE ZERO.
           05 COM-TRAN  PIC X(1) VALUE SPACE.
      ********
           05 DTMB     PIC X(8).
           05 DTP      PIC 9(4).
           05 DTPB     PIC ZZ/ZZZ9.
           05 DTP6.
              10 MM6 PIC 99.
              10 AA6.
                 15 AA61 PIC 99.
                 15 AA62 PIC 99.
           05 TPL      PIC 9.
           05 PERIO    PIC 9(6).
           05 FILLER REDEFINES PERIO.
              10 PERM  PIC 99.
              10 PERA  PIC 9(4).
           05 DTCT1.
              10 PERAA PIC 9(4).
              10 PERMA PIC 99.
           05 DTCT2.
              10 PLFAA PIC 9(4).
              10 PLFMM PIC 99.
           05 DTDOC    PIC 9(5) COMP-3.
           05 DTSCA    PIC 9(5) COMP-3.
      **** rel 6.2
           05 DTREG    PIC 9(5) COMP-3.
      ************
           05 DTCON    PIC 9(5) COMP-3.
           05 FLGPL    PIC 9.
           05 CODCON   PIC 9(7).
           05 COMURV   PIC S9(11)V99.
           05 GSFM     PIC 99.
      **** rel 2.0
           05 GSESC    PIC 99.
      ************
           05 FLAMM    PIC 9.
      **** rel 1.2
           05 CAUATTRN PIC 9.
           05 CODEURO  PIC 999.
      **** rel 4.0
      *    05 TIMRATA  PIC S9(13).
           05 TIMRATA  PIC S9(13)V99.
      ************
           05 TOTIVV   PIC S9(11)V99.
      ************
      **** rel 4.0
           05 DTBIG    PIC 9(5).
      ************
      *
           05 GGESC    PIC 99 VALUE 15.
      **** rel 4.1a
      **** rel 5.0-2
      *    05 CDPAG    PIC 999 OCCURS 50.
           05 CDPAG    PIC 999 OCCURS 100.
      **************
           05 FLGCP    PIC 9 VALUE ZERO.
      ************
      **** rel 6.0
           05 FLGMCL   PIC 9 VALUE ZERO.
      ************
      **** rel 6.2
           05 PERC     PIC 9(3)V99.
           05 FLGAMM   PIC 9 VALUE ZERO.
           05 IMP      PIC S9(13)V99.
      ************
      **** rel 6.3
           05 COMPRT     PIC 9(5)     VALUE ZERO.
           05 ERRPRT     PIC 9        VALUE ZERO.
           05 SAV-NPRGI  PIC 9(5).
      * protocollo originale presente all'atto dell'inserimento
           05 SAV-ONPRGI PIC 9(5).
           05 CIVACQ     PIC 9(7)     VALUE ZERO.
       01 PARPRT.
          05 PPRT-AZI    PIC 9(3).
          05 PPRT-FL     PIC 9.
          05 PPRT-CON    PIC 9(7).
          05 PPRT-NREG   PIC 9(5).
          05 PPRT-UPRT   PIC 9(5).
          05 PPRT-DTUPR  PIC 9(5).
          05 PPRT-DTINS  PIC 9(5).
          05 PPRT-BUCPRT PIC 9(5).
          05 PPRT-BUCDT  PIC 9(5).
          05 PPRT-ST     PIC 9.
      **********
       01  WW-CTRL.
           05 WW-AZI       PIC 999.
           05 WW-FUN       PIC X.
           05 WW-ST        PIC 9.
           05 WW-NBYTE     PIC 9(5).
           05 WW-NLETTI    PIC 999.
           05 WW-IDXVET    PIC 999.
           05 WW-PRT       PIC 9(7).
      **** rel 5.0-2
      *01  IF-VET   PIC X(900).
       01  IF-VET   PIC X(1800).
      **************
       01  CB-DATI.
           05 CB-FOR       PIC 9(5).
           05 CB-CATT      PIC X.
           05 CB-VALUT     PIC 999.
      **** rel 1.2
      *    05 CB-CAMGG     PIC 9999V99.
      **** rel 4.0
      *    05 CB-CAMGG     PIC 9999V999.
           05 CB-CAMGG     PIC 9(5)V9(6).
      ************
      ************
           05 CHI-BO.
      **** rel 5.0-2
      *       10 CHIBOL    PIC 9(7) OCCURS 50.
              10 CHIBOL    PIC 9(7) OCCURS 100.
      **************
      **** rel 6.2
      * vettore di comodo IVA indeducibile
       01  VIVA-INDEDUC PIC S9(10)V99 OCCURS 6.
      ************
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
      **** rel 5.2
           05 IF-CAMPO2    PIC X(20).
      ************
           05 IF-IDXVET    PIC 99.
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           05 IF-PRTBOL    PIC 9(7).
      **** rel 5.2
           05 IF-FLAGG     PIC 9.
      ************
      *
      * Record di interfaccia
      *
       01  IF-REC.
      *--- dati testata
           05 IF-DESAZI    PIC X(36).
           05 IF-CATT      PIC X.
           05 IF-DESATT    PIC X(24).
           05 IF-FOR       PIC 9(5).
           05 IF-RGSFOR    PIC X(36).
      * data
           05 IF-DATREG    PIC 9(6).
           05 IF-NUMDOC    PIC 9(5).
      * data
           05 IF-DATDOC    PIC 9(6).
           05 IF-CODCAU    PIC 999.
           05 IF-DESCAU    PIC X(24).
           05 IF-DARAVE    PIC X.
           05 IF-DESAGG    PIC X(30).
           05 IF-PRGIVA    PIC 9(5).
      * data
           05 IF-DATSCA    PIC 9(6).
           05 IF-CDVAL     PIC 999.
           05 IF-DESVAL    PIC X(4).
      **** rel 4.0
      *    05 IF-CAMGG     PIC 9999V999.
           05 IF-CAMGG     PIC 9(5)V9(6).
      ************
      **** rel 1.2
           05 IF-DTCAMGG   PIC 9(6).
      ************
           05 IF-TOTDOCV   PIC S9(11)V99.
      **** rel 7.2
           05 IF-CEE       PIC 9.
      ************
      **** rel 5.2
      *--- dati per fatt. acq. cee
           05 IF-DIFDOCV   PIC S9(11)V99.
           05 IF-TIMPAGG   PIC S9(11)V99.
           05 IF-TIMPBOL   PIC S9(11)V99.
      ************
      **** rel 6.3
           05 IF-DIFIMPO   PIC S9(11)V99.
      ************
      *--- dati IVA
      **** rel 4.0
      *    05 IF-TOTDOC    PIC S9(11).
      *    05 IF-DIFDOC    PIC S9(11).
           05 IF-TOTDOC    PIC S9(11)V99.
           05 IF-DIFDOC    PIC S9(11)V99.
      ************
      *--- dati Contropartite
      **** rel 4.0
      *    05 IF-TOTBOL    PIC S9(11).
      *    05 IF-DIFBOL    PIC S9(11).
      *    05 IF-TOTIMPON  PIC S9(11).
      *    05 IF-DIFIMPON  PIC S9(11).
           05 IF-TOTBOL    PIC S9(11)V99.
           05 IF-DIFBOL    PIC S9(11)V99.
           05 IF-TOTIMPON  PIC S9(11)V99.
           05 IF-DIFIMPON  PIC S9(11)V99.
      ************
      **** rel 5.2
           05 IF-TOTIMPOR  PIC S9(11)V99.
           05 IF-TOTIMPONV PIC S9(11)V99.
           05 IF-TOTALE    PIC S9(11)V99.
      ************
      *--- dati Scadenzario
           05 IF-CDPAG     PIC 999.
           05 IF-DESPAG    PIC X(24).
           05 IF-CDBAN     PIC 9(5).
           05 IF-DESBAN    PIC X(36).
      * data
           05 IF-1SCAD     PIC 9(6).
      **** rel 4.0
      *    05 IF-TOTSCA    PIC S9(11).
      *    05 IF-DIFSCA    PIC S9(11).
           05 IF-TOTSCA    PIC S9(11)V99.
           05 IF-DIFSCA    PIC S9(11)V99.
      ************
           05 IF-TOTSCAV   PIC S9(11)V99.
           05 IF-DIFSCAV   PIC S9(11)V99.
      *--- flag occorrenti all'interfaccia per hide/show
           05 IF-FLTIG     PIC 9.
           05 IF-FLVALUT   PIC 9.
           05 IF-FL1SCAD   PIC 9.
           05 IF-FLGSC     PIC 9.
      **** rel 1.2
           05 IF-FLIVA     PIC 9.
      ************
      **** rel 5.2
           05 IF-HS-ACEE    PIC 9.
           05 IF-HS-ATTRN   PIC 9.
      *--- dati relativi alla causale contabile come da tabella
           05 IF-TAB-CAUS.
              10 IF-T02-TIPRG  PIC 9.
              10 IF-T02-TIPOP  PIC 99.
              10 IF-T02-SEGNO  PIC 9.
              10 IF-T02-ATTRN  PIC 9.
              10 IF-T02-DTSCO  PIC 9.
              10 IF-T02-FLVEN  PIC 9.
              10 IF-T02-FLGEC  PIC 9.
              10 IF-T02-FLGSC  PIC 9.
              10 IF-T02-FLGIS  PIC 9.
      *--- dati relativi alla causale contabile per movimento
      *    acquisto CEE come da tabella
           05 IF-ACEE-TAB-CAUS.
              10 IF-ACEE-T02-TIPRG  PIC 9.
              10 IF-ACEE-T02-D-A    PIC X.
              10 IF-ACEE-T02-TIPOP  PIC 99.
              10 IF-ACEE-T02-SEGNO  PIC 9.
              10 IF-ACEE-T02-ATTRN  PIC 9.
              10 IF-ACEE-T02-DTSCO  PIC 9.
              10 IF-ACEE-T02-FLVEN  PIC 9.
              10 IF-ACEE-T02-FLGEC  PIC 9.
              10 IF-ACEE-T02-FLGSC  PIC 9.
              10 IF-ACEE-T02-FLGIS  PIC 9.
      *--- dati relativi a movimento acquisto CEE
      * - per la parte IVA viene utilizzato il vettore IF-IVA
      * - per la contropartita dell'IVA indeducibile viene utilizzato
      *   il primo elemento del vettore IF-CPAR.
           05 IF-ACEE-CAUS     PIC 999.
           05 IF-ACEE-CAUS-D   PIC X(24).
           05 IF-ACEE-CATTA    PIC X.
           05 IF-ACEE-NPRGIA   PIC 9(5).
           05 IF-ACEE-CATTV    PIC X.
           05 IF-ACEE-NPRGIV   PIC 9(5).
      ************
      **** rel 6.2
           05 IF-RIT       PIC 9.
      ************
      **** rel 6.2
           05 IF-SC-PRG    PIC 9(5).
      ************
      **** rel 6.3
      *---------------------------------------------------------------
      * Chiave archivio INTRA per far s che aprendo lo zoom INTRA in
      * automatico nel caso di cliente/fornitore CEE ci si poasizioni
      * in automatico sul record inserito da vcon440.
      *---------------------------------------------------------------
           05 IF-AREA-KTRA.
              10 IF-KTRA-AZI   PIC 999.
              10 IF-KTRA-IVA   PIC 9(11).
              10 IF-KTRA-ANNO  PIC 9(4).
              10 IF-KTRA-PERI  PIC 9(2).
              10 IF-KTRA-TRAN  PIC X.
              10 IF-KTRA-TIPO  PIC 9.
              10 IF-KTRA-TIPN  PIC X.
              10 IF-KTRA-PROT  PIC 9(5).
              10 IF-KTRA-PROG  PIC 99.
              10 IF-KTRA-NOBOL PIC 9.
      ************
      *
      **** rel 5.2
      * if-acee-iv-imponv: imponibile in valuta
      * significativo solo per acquisti CEE (IF-HS-ACEE = 1)
      ************
       01  IF-IVA OCCURS 6.
           05 IF-IV-COD     PIC 999.
           05 IF-IV-DESCR   PIC X(24).
      **** rel 4.0
      *    05 IF-IV-IMPON   PIC S9(11).
      *    05 IF-IV-IMPOR   PIC S9(11).
      **** rel 5.2
           05 IF-ACEE-IV-IMPONV  PIC S9(11)V99.
      ************
           05 IF-IV-IMPON   PIC S9(11)V99.
           05 IF-IV-IMPOR   PIC S9(11)V99.
      ************
           05 IF-IV-PERPLA  PIC 9(6).
           05 FILLER REDEFINES IF-IV-PERPLA.
              10 IF-IV-PMES PIC 99.
              10 IF-IV-PANN PIC 9(4).
      *
      **** rel 6.1sm(CMO40)05/06/2015
      *01  IF-CPAR OCCURS 15.
       01  IF-CPAR OCCURS 16.
      **** end rel 6.1sm(CMO40)05/06/2015
           05 IF-CP-COD     PIC 9(7).
           05 IF-CP-DESCR   PIC X(36).
      **** rel 4.0
      *    05 IF-CP-IMPON   PIC S9(11).
           05 IF-CP-IMPON   PIC S9(11)V99.
      ************
      **** rel 6.2
           05 IF-CP-DESAG   PIC X(30).
      ************
      * IF-CP-FLCOSZ: flag zoom di chiamata x centro di costo
      *              0=nessun zoom
      *              1=nessun zoom
      *              2=lancia vcdcx10 (centro di costo)
      *              3=lancia vcdcx20 (tabella ripartizioni)
           05 IF-CP-FLCOSZ  PIC 9.
           05 IF-CP-CCOST.
              10 IF-CP-TRIP PIC X(3).
              10 IF-CP-FILL PIC X.
      *
       01  IF-SCA OCCURS 12.
           05 IF-SC-TPAG    PIC 9.
      * data
           05 IF-SC-DTSCA   PIC 9(6).
      **** rel 4.0
      *    05 IF-SC-IMRATA  PIC S9(11).
           05 IF-SC-IMRATA  PIC S9(11)V99.
      ************
           05 IF-SC-VALRAT  PIC S9(11)V99.
      **** rel 6.2
           05 IF-SC-NOTE    PIC XX.
           05 IF-SC-NOTEA   PIC X(30).
      ************
      **** rel 5.2
      **** rel 7.1
      *01  IF-INTRA OCCURS 10.
      *    05 IF-TR-NOMME   PIC 9(8).
      *    05 IF-TR-IMPAGG  PIC S9(11)V99.
      *    05 IF-TR-IMPBOL  PIC S9(11)V99.
       01  IF-INTRA.
           05 IF-TR-CDPRO   PIC XX.
           05 IF-TR-CDPAP   PIC XX.
           05 IF-TR-DPAP    PIC X(24).
           05 IF-TR-CDPAO   PIC XX.
           05 IF-TR-DPAO    PIC X(24).
           05 IF-TR-CDVAL   PIC 999.
           05 IF-TR-DSINT   PIC X(4).
           05 IF-TR-CAMGG   PIC 9(5)V9(6).
           05 IF-TR-SPAEP   PIC XX.
           05 IF-TR-DSPP    PIC X(24).
           05 IF-TR-MOER    PIC X.
           05 IF-TR-MOIN    PIC X.
           05 FILLER OCCURS 10.
              10 IF-TR-NOMME   PIC 9(8).
              10 IF-TR-IMPAGG  PIC S9(11)V99.
              10 IF-TR-IMPBOL  PIC S9(11)V99.
              10 IF-TR-IMPVAL  PIC S9(11)V99.
              10 IF-TR-MASNET  PIC S9(9)V99.
      ************
      ************
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-IVA
                                IF-CPAR
                                IF-SCA
      **** rel 5.2
                                IF-INTRA
      ************
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
      **** rel 2.0
           COPY 'dclpra'.
      ************
           COPY 'dclclf'.
           COPY 'dclbft'.
      **** rel 6.1
           COPY 'dclabf'.
      ************
           COPY 'dclbfr'.
           COPY 'dclcon'.
           COPY 'dclart'.
           COPY 'dcltab'.
      **** rel 1.2
      *    COPY 'dclcgg'.
      ************
           COPY 'dclban'.
           COPY 'dclcam'.
           COPY 'dclcdc'.
           COPY 'dcltrt'.
           COPY 'dcl135'.
      **** rel 6.2
           COPY 'dcl185'.
      ************
      **** rel 5.2
           COPY 'dcl400'.
           COPY 'dclla3'.
      ************
      **** rel 6.2
           COPY 'dclsca'.
           COPY 'dcldsc'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' OR
                    'w' OR
      **** rel 4.1a-1
                    'p' OR
      **************
      **** rel 5.2
                    'P' OR
      **************
                    'M' GO TO F-WALIDA.
      **** rel 5.2
           IF FUN = 'n' PERFORM CALCOLA-NOMME THRU EX-CALCOLA-NOMME
                        GO TO FINE.
           IF FUN = 's' PERFORM RISCRIVI-SORT THRU EX-RISCRIVI-SORT
                        GO TO FINE.
      **************
           IF FUN = 'r' GO TO F-CTRL-LEG-BOLSEL.
      **** rel 6.3
           IF FUN = 'a' GO TO F-CTRL-LEG-BOLSEL.
      ************
      **** rel 5.2
           IF FUN = 'm' GO TO F-RICALCOLA-CP.
           IF FUN = 'q' GO TO CONTROLLA-CP.
           IF FUN = '2' GO TO F-1.
           IF FUN = 'U' PERFORM RISCRIVI-BOLLE THRU EX-RISCRIVI-BOLLE
                        GO TO CHIUDI.
      **************
      **** rel 6.2
           IF FUN = 'L'
              PERFORM LAV-AUTONOMI THRU EX-LAV-AUTONOMI
              IF FLGAMM NOT = ZERO
                 MOVE 'AMM-SI' TO IF-CAMPO
              END-IF
              IF IF-RIT = ZERO GO TO CHIUDI
              ELSE             GO TO FINE.
      ************
           IF FUN = 'c' GO TO F-CHECK.
           IF FUN = '1' GO TO F-1.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
      **** rel 6.2
      *                 GO TO CHIUDI.
                        GO TO FINE.
      ************
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vorf184: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD NOT = ZERO GO TO F-WALIDA-10.
           IF NOT (FUN = 'W' OR 'M') GO TO FINE.
           PERFORM PASSA-DATI-FISSI.
           IF ERRIO-ST = 9 GO TO ERRIO.
           IF ERRIO-ST NOT = ZERO GO TO WARNING.
           GO TO FINE.
       F-WALIDA-10.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       F-CTRL-LEG-BOLSEL.
      **** rel 6.3
           IF FUN = 'a' GO TO NO-AZZ.
      ************
           PERFORM PASSA-DATI-FISSI.
           IF ERRIO-ST = 9 GO TO ERRIO.
           IF ERRIO-ST NOT = ZERO GO TO WARNING.
           MOVE 'r' TO WW-FUN.
           CALL 'vorf183' USING WW-CTRL
                                IF-MESS
                                IF-VET
                                CB-DATI.
           IF ERRIO-ST = 9 GO TO ERRIO.
           IF ERRIO-ST NOT = ZERO GO TO WARNING.
      * azzeramento vettori interfaccia
           PERFORM AZZ-IF-IVA.
      **** rel 6.3
       NO-AZZ.
           MOVE ZERO TO IF-KTRA-NOBOL.
      ************
           PERFORM AZZ-IF-CPAR.
           PERFORM AZZ-IF-SCA.
      **** rel 5.2
           PERFORM AZZ-IF-INTRA.
      ************
           MOVE ZERO TO IF-TOTBOL.
      * calcolo dati IVA
           PERFORM CALC-IV-IMPON.
           PERFORM CALC-IV-DIFF.
      * calcolo contropartite da bolle.
           MOVE ZERO TO SW-BOL.
           PERFORM CAL-CP-MAIN THRU EX-CAL-CP-MAIN.
           IF SW-BOL = ZERO
      **** rel 6.3
              MOVE 1 TO IF-KTRA-NOBOL
      ************
      **** rel 5.2
      *       MOVE 'Nessuna bolla conteggiata' TO MESS
      *       GO TO WARNING.
              MOVE 'Nessuna bolla conteggiata' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB.
      ************
           MOVE ZERO TO K.
       LEG-DES-CON-10.
           ADD 1 TO K.
           IF K > 15 GO TO LEG-DES-CON-20.
           IF IF-CP-COD(K) = ZERO GO TO LEG-DES-CON-10.
           MOVE KAZ-COD      TO KPC-AZI.
           MOVE IF-CP-COD(K) TO KPC-COD.
           READ ANACON INVALID MOVE ALL '*' TO CON-DSC.
           MOVE CON-DSC TO IF-CP-DESCR(K).
      **** rel 7.1
           OPEN INPUT APPCON.
           MOVE KAZ-COD      TO KACO-AZI.
           MOVE IF-CP-COD(K) TO KACO-COD.
           READ APPCON INVALID MOVE SPACE TO ACO-CDC.
           CLOSE APPCON.
           IF IF-CP-CCOST(K) = SPACE
              IF CON-TIPO = 'E'
                 IF CON-TRIP = ZERO
                    MOVE ACO-CDC TO IF-CP-CCOST(K)
                 ELSE
                    MOVE CON-TTIP TO IF-CP-CCOST(K).
      ************
           GO TO LEG-DES-CON-10.
       LEG-DES-CON-20.
           PERFORM CALC-CP-DIFF.
      *
      * calcolo scadenzario
      *
           IF IF-FLGSC = ZERO GO TO END-F-CTRL-LEG-BOLSEL.
      **** rel 4.1a
      *    MOVE CLF-CPAG TO IF-CDPAG.

           MOVE CDPAG(1) TO IF-CDPAG.
           IF CDPAG(2) NOT = ZERO
              PERFORM CONTROLLA-CDPAG THRU END-CONTROLLA-CDPAG
              IF FLGCP = 1 MOVE CLF-CPAG TO IF-CDPAG.
      ************
      **** rel 6.1
           IF IF-CDPAG = ZERO MOVE CLF-CPAG TO IF-CDPAG.
      ************
           MOVE SPACE    TO IF-DESPAG.
           IF IF-CDPAG = ZERO GO TO LEG-DES-BAN-30.
           MOVE IF-CDPAG TO KTB-COD.
           MOVE 4        TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO IF-DESPAG
                GO TO LEG-DES-BAN-30.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T04-1SCAD >= 4 MOVE 1 TO IF-FL1SCAD.
           MOVE TAB-DESCR TO IF-DESPAG.
           PERFORM RSCAD THRU EX-RSCAD.
      **** rel 1.2
           IF IF-TOTDOCV NOT = ZERO
      **** rel 4.0
      *       PERFORM RICAL-IMPSCA-LIRE THRU EX-RICAL-IMPSCA-LIRE.
              PERFORM RICAL-IMPSCA-EURO THRU EX-RICAL-IMPSCA-EURO.
      ************
      ************
       LEG-DES-BAN-30.
           MOVE CLF-BANC TO IF-CDBAN.
           MOVE SPACE    TO IF-DESBAN.
           IF IF-CDBAN = ZERO GO TO LEG-DES-BAN-40.
           MOVE IF-CDBAN TO KBA-BAN.
           READ ANABAN INVALID MOVE ALL '*' TO BAN-RGSOC.
           MOVE BAN-RGSOC TO IF-DESBAN.
       LEG-DES-BAN-40.
           PERFORM CALC-SC-DIFF.
      *
       END-F-CTRL-LEG-BOLSEL.
           GO TO FINE.
      * - - - - - *
      **** rel 5.2
       F-RICALCOLA-CP.
      *> non pulisce aree c/p
      *    PERFORM AZZ-IF-CPAR.

      **** rel 6.0a
           PERFORM AZZ-IF-CPAR.
      *************
           MOVE ZERO TO IF-TOTBOL.
      * calcolo contropartite da bolle.
           MOVE ZERO TO SW-BOL.
           PERFORM CAL-CP-MAIN THRU EX-CAL-CP-MAIN.
           IF SW-BOL = ZERO
      **** rel 6.3
              MOVE 1 TO IF-KTRA-NOBOL
              MOVE KAZ-COD TO IF-KTRA-NOBOL
      ************
              MOVE 'Nessuna bolla conteggiata' TO MESS
              GO TO WARNING.

      *> non ricarica descr. c/p
      *    MOVE ZERO TO K.
      *RIC-DES-CON-10.
      *    ADD 1 TO K.
      *    IF K > 15 GO TO RIC-DES-CON-20.
      *    IF IF-CP-COD(K) = ZERO GO TO RIC-DES-CON-10.
      *    MOVE KAZ-COD      TO KPC-AZI.
      *    MOVE IF-CP-COD(K) TO KPC-COD.
      *    READ ANACON INVALID MOVE ALL '*' TO CON-DSC.
      *    MOVE CON-DSC TO IF-CP-DESCR(K).
      *    GO TO RIC-DES-CON-10.
      *RIC-DES-CON-20.

      **** rel 6.0a
           MOVE ZERO TO K.
       RIC-DES-CON-10.
           ADD 1 TO K.
           IF K > 15 GO TO RIC-DES-CON-20.
           IF IF-CP-COD(K) = ZERO GO TO RIC-DES-CON-10.
           MOVE KAZ-COD      TO KPC-AZI.
           MOVE IF-CP-COD(K) TO KPC-COD.
           READ ANACON INVALID MOVE ALL '*' TO CON-DSC.
           MOVE CON-DSC TO IF-CP-DESCR(K).
      **** rel 7.1
           OPEN INPUT APPCON.
           MOVE KAZ-COD      TO KACO-AZI.
           MOVE IF-CP-COD(K) TO KACO-COD.
           READ APPCON INVALID MOVE SPACE TO ACO-CDC.
           CLOSE APPCON.
           IF IF-CP-CCOST(K) = SPACE
              IF CON-TIPO = 'E'
                 IF CON-TRIP = ZERO
                    MOVE ACO-CDC TO IF-CP-CCOST(K)
                 ELSE
                    MOVE CON-TTIP TO IF-CP-CCOST(K).
      ************
           GO TO RIC-DES-CON-10.
       RIC-DES-CON-20.
      *************
           PERFORM CALC-CP-DIFF.
      **** rel 6.2
           MOVE IF-CDPAG TO KTB-COD.
           MOVE 4        TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           PERFORM RSCAD THRU EX-RSCAD.
      ************
      *
           GO TO FINE.
      * - - - - - *
       CONTROLLA-CP.
           PERFORM CALC-CP-DIFF.
           IF IF-TOTBOL = ZERO AND SW-BOL = ZERO
      **** rel 6.3
              MOVE 1 TO IF-KTRA-NOBOL
      ************
              MOVE ZERO TO IF-DIFBOL
              GO TO END-CONTROLLA-CP.

      **** rel 7.1
           MOVE ZERO TO FLGRB.
      ************
           IF IF-DIFIMPON NOT = ZERO
              MOVE 'Errore di quadratura su contropartite' TO F-MES1
              IF IF-TOTIMPON NOT = IF-TOTBOL
                 MOVE 'Tot. imponibile diverso da tot. bolle:'
                                                           TO F-MES2
                 MOVE 'effettuare rettifiche su bolle. '   TO F-MES3
              END-IF
              MOVE 'Vuoi proseguire ugualmente ?'       TO F-MES4
              MOVE 4 TO F-NMES
              MOVE 'Q' TO MB-TIPO
              MOVE '2' TO MB-DEFAULT
              CALL 'vrmbox' USING PARMB
      **** rel 7.1
              IF MB-RISP = 'S'
                 MOVE 9 TO FLGRB
              END-IF
      ************
              IF MB-RISP NOT = 'S'
                 IF IF-TOTIMPON = IF-TOTBOL
                    MOVE 2 TO IF-ST
                 ELSE
                    MOVE 5 TO IF-ST.
           IF IF-DIFBOL = ZERO GO TO END-CONTROLLA-CP.
           MOVE SPACE TO MESS.
           GO TO QUESTION.
       END-CONTROLLA-CP.
           GO TO FINE.
      * - - - - - *
      ************
       F-CHECK.
      **** rel 6.3
      **** rel 7.1
      *    PERFORM VERIFICA-PRT THRU EX-VERIFICA-PRT.
      *    IF ERRPRT = 2
      *       MOVE PPRT-DTUPR TO AAGGG
      *       MOVE 2          TO TIPOP1
      *       CALL 'rdata' USING PARCDT
      *       MOVE 'Errore sequenza data protocolli' TO F-MES1
      *       MOVE SPACE TO F-MES2
      *       STRING 'Data ultimo prot.:' GBMMBA DELIMITED SIZE
      *              INTO F-MES2
      *       MOVE 2 TO F-NMES
      *       GO TO WARNING.
      *    IF ERRPRT = 1
      *       PERFORM AGGIORNA-PRT THRU EX-AGGIORNA-PRT
      *       MOVE 1 TO F-NMES
      *       STRING 'VARIATO PROTOCOLLO IVA IN: ' COMPRT
      *              DELIMITED SIZE INTO F-MES1
      *       CALL 'vrmbox' USING PARMB.
      ************
      **********
           MOVE ZERO TO KF1.
      **** rel 5.2
           IF IF-FLAGG NOT = ZERO GO TO END-F-CHECK.
      ************
           PERFORM E00-AGG-BOL THRU E99.
           IF IF-DIFBOL = ZERO GO TO END-F-CHECK.
      **** rel 5.2
      **** rel 6.3
      *    IF SW-BOL = ZERO GO TO END-F-CHECK.
           IF SW-BOL = ZERO
              MOVE 1 TO IF-KTRA-NOBOL
              GO TO END-F-CHECK.
      ************
      ************
           MOVE SPACE TO MESS.
           GO TO QUESTION.
       END-F-CHECK.
           GO TO FINE.
      * - - - - - *
       F-1.
           ADD 1 TO KF1.
      **** rel 5.0-2
      *    IF KF1 > 50
           IF KF1 > 100
      **************
              MOVE ZERO TO IF-PRTBOL
              GO TO END-F-1.
      **** rel 5.2
      *    IF CHIBOL(KF1) = ZERO GO TO F-1.
           IF CHIBOL(KF1) = ZERO MOVE ZERO TO IF-PRTBOL
                                 MOVE ZERO TO KF1
                                 GO TO END-F-1.
      ************
           MOVE IF-AZI      TO KBF-AZI.
           MOVE CHIBOL(KF1) TO KBF-PRT.
           READ BOLFTE INVALID GO TO F-1.
      **** rel 5.2
           IF FUN = '2' PERFORM SCRIVI-APPOGGIO THRU EX-SCRIVI-APPOGGIO
                        GO TO NO-RWR-BFT.
      ************
           MOVE 1 TO BFT-FLGFT.
      **** rel 3.0
           MOVE IF-PRGIVA TO BFT-NFAT.
      ************
      **** rel 6.2
           IF IF-HS-ATTRN = ZERO AND IF-HS-ACEE  = 1
              IF (IF-PRGIVA = ZERO) AND (IF-ACEE-NPRGIA NOT = ZERO)
                 MOVE IF-ACEE-NPRGIA TO BFT-NFAT.
      ************
      **** rel 6.1
           PERFORM AGGIORNA-ABF THRU EX-AGGIORNA-ABF.
      ************
           REWRITE RF-BFT INVALID GO TO F-1.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BFT.
      ************
      **** rel 5.2
       NO-RWR-BFT.
      ************
           MOVE CHIBOL(KF1) TO IF-PRTBOL.
       END-F-1.
           GO TO FINE.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
           GO TO CHIUDI9.
       CHIUDI.
      * chiude vorf183
           MOVE 'e' TO WW-FUN.
           CALL 'vorf183' USING WW-CTRL
                                IF-MESS
                                IF-VET
                                CB-DATI.
       CHIUDI9.
           CLOSE TABELL
                 ANACLF
                 ANACON
      **** rel 1.2
      *          CAMGIO
      ************
                 MAGART
                 ANABAN
                 ANAAZI
      **** rel 2.0
                 PROAZI
      ************
                 BOLFTE
      **** rel 6.1
                 APPBFT
      ************
                 BOLFRI
                 CDCOST
                 TABRIT.
      **** rel 5.2
           CLOSE WDSLAV WDS400.
           OPEN OUTPUT WDSLAV WDS400.
           CLOSE WDSLAV WDS400.
      *
           CLOSE APPFTE APPFRI.
           OPEN OUTPUT APPFTE APPFRI.
           CLOSE APPFTE APPFRI.
      ************
      **** rel 6.2
           CLOSE WDS185.
           OPEN OUTPUT WDS185.
           CLOSE WDS185.
      ************
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
      **** rel 1.2
           COPY 'erreur'.
      ************
           COPY 'griazier'.
      **** rel 2.0
           COPY 'gripraer'.
      ************
           COPY 'griclfer'.
           COPY 'gribfter'.
      **** rel 6.1
           COPY 'griabfer'.
      ************
           COPY 'gribfrer'.
           COPY 'griconer'.
           COPY 'griarter'.
      **** rel 1.2
      *    COPY 'gricgger'.
      ************
           COPY 'gritaber'.
           COPY 'gribaner'.
           COPY 'gricamer'.
           COPY 'gricdcer'.
           COPY 'gritrter'.
           COPY 'gri135er'.
      **** rel 6.2
           COPY 'griscaer'.
           COPY 'gridscer'.
           COPY 'grinscer'.
      ************
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           IF IF-FL = ZERO
              MOVE 'anaazi' TO ID-AZI
              MOVE 'tabell' TO ID-TAB
              MOVE 'anacon' TO ID-CON
      **** rel 5.2
              MOVE 'appcon' TO ID-ACO
      ************
              MOVE 'anaclf' TO ID-CLF
              MOVE 'movime' TO ID-MOV
           ELSE
              MOVE 'anazol' TO ID-AZI
              MOVE 'tabold' TO ID-TAB
              MOVE 'anacol' TO ID-CON
      **** rel 5.2
              MOVE 'appcol' TO ID-ACO
      ************
              MOVE 'anacfx' TO ID-CLF
              MOVE 'movmol' TO ID-MOV.
      *
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
      *
           OPEN INPUT TABELL.
           OPEN INPUT ANACLF.
           OPEN INPUT ANACON.
      **** rel 1.2
      *    OPEN INPUT CAMGIO.
      ************
           OPEN INPUT MAGART.
           OPEN INPUT ANABAN.
           OPEN INPUT CDCOST.
           OPEN INPUT TABRIT.
           OPEN  I-O  ANAAZI.
      **** rel 2.0
           OPEN  I-O  PROAZI.
      ************
           OPEN  I-O  BOLFTE.
      **** rel 6.1
           OPEN  I-O  APPBFT.
      ************
           OPEN  I-O  BOLFRI.
      **** rel 5.2
           OPEN OUTPUT APPFTE APPFRI.
           CLOSE APPFTE APPFRI.
           OPEN I-O APPFTE APPFRI.
      ************
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      **** rel 2.0
      *
           MOVE IF-AZI TO KPR-COD.
           READ PROAZI INVALID PERFORM INVK-PRA
                               GO TO ERRIO.
      ************
      *
           MOVE AZI-FLAMM TO FLAMM.
           IF FLAMM = ZERO GO TO INI-ELAB-30.
           OPEN INPUT TACOAM.
           IF SF-TAC NOT = ZERO
              MOVE ZERO TO FLAMM
              GO TO INI-ELAB-30.
           MOVE ZERO    TO KTC-CAT.
           MOVE KAZ-COD TO KTC-AZI.
           READ TACOAM INVALID GO TO INI-ELAB-20.
           IF TAC-AMORD = ZERO GO TO INI-ELAB-20.
           CLOSE TACOAM.
           GO TO INI-ELAB-30.
       INI-ELAB-20.
           MOVE ZERO TO FLAMM.
           CLOSE TACOAM.
       INI-ELAB-30.
      **** rel 5.2
           MOVE 14 TO KTB-TIP.
           MOVE 10 TO KTB-COD.
           READ TABELL INTO RKTB14L INVALID
                        MOVE ZERO TO RKTB14L
                        T14-CFTEM1 T14-CFTEM2 T14-CFTEM3
                        T14-CNAEM1 T14-CNAEM2 T14-CNAEM3
                        T14-CFTRC1 T14-CFTRC2 T14-CFTRC3
                        T14-CNARC1 T14-CNARC2 T14-CNARC3
                        T14-CAUFEM T14-CAUFRC.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB14L.
           MOVE T14-CFTRC1    TO CP-FTRC(1).
           MOVE T14-CFTRC2    TO CP-FTRC(2).
           MOVE T14-CFTRC3    TO CP-FTRC(3).
           MOVE T14-CAUFRC    TO CAU-FTRC.
      ************
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY PERFORM INVK-TAB
                                               GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MFOR TO MAS.
      *
           MOVE 14 TO KTB-TIP.
           MOVE 5  TO KTB-COD.
           READ TABELL INTO REKTE14 INVALID MOVE ZERO TO REKTE14.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTE14.
      *
           MOVE 14 TO KTB-TIP.
           MOVE 1  TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY PERFORM INVK-TAB
                                               GO TO ERRIO.
           IF SF-TAB = '9A' OR '35' OR '9D' MOVE RF-TAB TO REKTAB.
           IF T14-COSTI = ZERO MOVE 'Manca conto su T14' TO MESS
                               GO TO ERRIO.
      *
           MOVE KAZ-COD TO KPC-AZI.
           MOVE T14-COSTI TO KPC-COD TABCPT.
           READ ANACON INVALID PERFORM INVK-CON GO TO ERRIO.
      **** rel 1.2
      *
           CALL 'rveur' USING ER-VALUT.
           MOVE ER-VALUT TO CODEURO.
      ************
      *
      **** rel 6.2
           MOVE ZERO  TO IF-FLAGG.
      ************
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
      **** rel 5.2
           OPEN OUTPUT WDSLAV WDS400.
           CLOSE WDSLAV WDS400.
           OPEN I-O WDSLAV WDS400.
      ************
      **** rel 6.2
           OPEN OUTPUT WDS185.
           CLOSE WDS185.
           OPEN I-O WDS185.
      ************
           MOVE ZERO  TO IF-REC.
           MOVE ZERO  TO IF-TOTDOCV
                         IF-TOTDOC
                         IF-DIFDOC
                         IF-TOTBOL
                         IF-DIFBOL
                         IF-TOTIMPON
                         IF-DIFIMPON
      **** rel 5.2
                         IF-TIMPAGG
                         IF-TIMPBOL
                         IF-TOTIMPOR
                         IF-TOTIMPONV
                         IF-TOTALE
                         IF-DIFDOCV
      ************
      **** rel 6.3
                         IF-DIFIMPO
      ************
      **** rel 6.2
                         IF-SC-PRG
      ************
      **** rel 6.3
      *                  IF-KTRA-AZI
                         IF-KTRA-IVA
                         IF-KTRA-ANNO
                         IF-KTRA-PERI
                         IF-KTRA-TIPO
                         IF-KTRA-PROT
                         IF-KTRA-PROG
      ************
                         IF-TOTSCA
                         IF-DIFSCA
                         IF-TOTSCAV
                         IF-DIFSCAV.
           MOVE SPACE TO IF-DESAZI
                         IF-DESATT
                         IF-RGSFOR
                         IF-DESCAU
                         IF-DARAVE
                         IF-DESAGG
                         IF-DESVAL
                         IF-DESPAG
                         IF-DESBAN
      **** rel 6.3
                         IF-KTRA-TRAN
                         IF-KTRA-TIPN
      ************
                         IF-DESVAL.
      **** rel 5.2
           MOVE ZERO  TO IF-FLAGG.
           MOVE ZERO  TO IF-HS-ACEE
                         IF-HS-ATTRN.
           MOVE SPACE TO IF-ACEE-T02-D-A
                         IF-ACEE-CAUS-D
                         IF-ACEE-CATTA
                         IF-ACEE-CATTV.
      *
      **** rel 7.1
           INITIALIZE IF-INTRA.
      ************
           MOVE 1 TO K.
           PERFORM UNTIL K > 10
              MOVE ZERO  TO IF-TR-NOMME(K)
                            IF-TR-IMPAGG(K)
                            IF-TR-IMPBOL(K)
              ADD 1 TO K
           END-PERFORM.
      ************
      *
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              MOVE SPACE TO IF-IV-DESCR(K)
              MOVE ZERO  TO IF-IV-IMPON(K)
      **** rel 6.2
                            VIVA-INDEDUC(K)
      ************
      **** rel 5.2
                            IF-ACEE-IV-IMPONV(K)
      ************
                            IF-IV-IMPOR(K)
                            IF-IV-PERPLA(K)
              ADD 1 TO K
           END-PERFORM.
      *
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
              MOVE ZERO  TO IF-SC-IMRATA(K)
                            IF-SC-VALRAT(K)
      **** rel 6.2
              MOVE SPACE TO IF-SC-NOTE(K)
                            IF-SC-NOTEA(K)
      ************
              ADD 1 TO K
           END-PERFORM.
      *
           MOVE 1 TO K.
      **** rel 6.1sm(CMO40)05/06/2015
      *    PERFORM UNTIL K > 15
           PERFORM UNTIL K > 16
      **** end rel 6.1sm(CMO40)05/06/2015
              MOVE SPACE TO IF-CP-DESCR(K)
      **** rel 6.2
                            IF-CP-DESAG(K)
      ************
                            IF-CP-CCOST(K)
              MOVE ZERO  TO IF-CP-IMPON(K)
                            IF-CP-FLCOSZ(K)
              ADD 1 TO K
           END-PERFORM.
      *
           MOVE AZRGSOC TO IF-DESAZI.
           MOVE AZI-ULTDT TO AAGGG
                             DTCON.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DATREG.
      *
           MOVE ZERO TO IF-FLTIG
                        IF-FLVALUT
      **** rel 1.2
                        IF-FLIVA
      ************
                        IF-FL1SCAD
                        IF-FLGSC.
           MOVE ZERO TO DTDOC
                        DTSCA.
           MOVE AZI-RANRG TO IF-PRGIVA.
           ADD 1 TO IF-PRGIVA.
      **** rel 6.3
           MOVE IF-PRGIVA TO SAV-ONPRGI.
      ************
      *
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-DUP TO DTAIVA.
           MOVE 2 TO TIPOP1.
           MOVE DTAIVA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DATIVB.
      *
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '1'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           IF T25-PLA = ZERO MOVE ZERO TO T25-TIG T25-DTP
                                          T25-TPL T25-ATT.
           IF T25-PLA = 1 MOVE T25-DTM TO AAGGG
                          MOVE 2 TO TIPOP1
                          CALL 'rdata' USING PARCDT
                          MOVE GGMMAA TO DTM
                          MOVE GBMMBA TO DTMB.
      **** rel 6.1
           MOVE T25-PLA TO T25PLA.
           MOVE T25-ATT TO T25ATT.
           MOVE T25-DTM TO T25KDTM.
      ************
           MOVE T25-TIG TO IF-FLTIG.
           MOVE T25-TPL TO TPL.
           MOVE T25-DTP TO DTP.
           PERFORM CONV-DTP-A6.
      **** rel 5.2
           MOVE 25        TO T25-TIP.
           MOVE KAZ-COD   TO T25-COD.
           MOVE '6'       TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID
                MOVE 'Tabella 25/6 mancante' TO MESS
                CLOSE TABELL
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-NOMMEA TO NOMMEA.
           MOVE T25-NOMMEV TO NOMMEV.
      ************
      **** rel 7.1
           MOVE T25-AC-PAPR TO AC-PAPR.
           MOVE T25-AC-PAOR TO AC-PAOR.
           MOVE T25-AC-PRDE TO AC-PRDE.
           MOVE T25-SI-CDPP TO AC-CDPP.
           MOVE T25-SI-MOER TO AC-MOER.
           MOVE T25-SI-MOIN TO AC-MOIN.
      ************
      *
      **** rel 1.2
           MOVE ZERO TO CAUATTRN.
      *
      ************
      **** rel 6.2
           MOVE ZERO TO FLGAMM.
      ************
      **** rel 6.3
           MOVE LOW-VALUE TO IF-AREA-KTRA.
           MOVE KAZ-COD   TO IF-KTRA-AZI.
           MOVE ZERO       TO SAV-NPRGI
                              SAV-ONPRGI.
      ************
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
           IF FUN = 'w' GO TO V-DATI-RIGO.
      **** rel 4.1a-1
           IF FUN = 'p' GO TO V-DATI-RIGO.
      **************
      **** rel 5.2
           IF FUN = 'P' GO TO V-DATI-INTRA.
      **************
      *
       V-CATT.
           MOVE 'IF-CATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CATT.
           IF FUN = 'M' GO TO E-CATT.
           MOVE SPACE TO IF-DESATT.
           IF IF-CATT = SPACE MOVE '0' TO IF-CATT.
           IF IF-CATT = '0'
              MOVE AZI-DATT TO IF-DESATT
      **** rel 6.0a
              IF FUN = 'V'
                 MOVE AZI-RANRG TO IF-PRGIVA
                 ADD 1 TO IF-PRGIVA
      **** rel 6.3
                 MOVE IF-PRGIVA TO SAV-ONPRGI
      ************
              END-IF
      *************
              GO TO E-CATT.
           MOVE 35      TO T35-TIP.
           MOVE KAZ-COD TO T35-CDAZ.
           MOVE IF-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID PERFORM ERR-CINE
                                           GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
      **** rel 6.1
      *    IF T25-ATT = 1 AND T35-GES = 1 MOVE T35-TIG TO IF-FLTIG
           IF T25ATT = 1 AND T35-GES = 1 MOVE T35-TIG TO IF-FLTIG
      ************
                                          MOVE T35-TPL TO TPL
                                          MOVE T35-DTP TO DTP
                                          PERFORM CONV-DTP-A6.
           MOVE T35-DATT TO IF-DESATT.
      **** rel 6.0a
           IF FUN = 'V'
              MOVE T35-RANRG TO IF-PRGIVA
      **** rel 6.3
      *       ADD 1 TO IF-PRGIVA.
              ADD 1 TO IF-PRGIVA
              MOVE IF-PRGIVA TO SAV-ONPRGI.
      ************
      *************
       E-CATT.
      *
       V-FOR.
           MOVE 'IF-FOR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FOR.
           MOVE SPACE TO IF-RGSFOR.
           IF IF-FOR = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE IF-AZI TO KCF-AZI.
           MOVE IF-FOR TO COD.
           MOVE CODICE TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID PERFORM ERR-CINE
                                           GO TO V-ERROR.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
      **** rel 6.0
           MOVE IF-AZI     TO RACF-AZI.
           MOVE CODICE     TO RACF-COD.
           CALL 'rrdacf' USING PARACF.
      ************
           MOVE CLF-RGS  TO IF-RGSFOR.
           MOVE CLF-GSFM TO GSFM.
      **** rel 2.0
           MOVE CLF-GSESC TO GSESC.
      ************
      **** rel 5.2
           MOVE CLF-13IVA TO FLGCEE.
      **** rel 7.1
           MOVE CLF-PAE   TO PAECEE.
      ************
      **** rel 7.2
           IF CLF-13IVA NOT = 4
              MOVE ZERO TO IF-CEE
           ELSE
              IF CLF-PAE IS NOT NUMERIC
                 IF CLF-PAE = 'IT' OR  CLF-PAE = SPACE
                    MOVE ZERO to IF-CEE 
                 ELSE
                    MOVE 1 to IF-CEE
                 END-IF
              ELSE
                 MOVE ZERO to IF-CEE.
      ************
      ************
           IF FUN = 'V'
              MOVE CLF-VAL TO IF-CDVAL
           ELSE
      **** rel 4.0
      *       IF CLF-VAL > 1 AND IF-CDVAL < 2
              IF NOT (CLF-VAL = ZERO OR CODEURO) AND
                 (IF-CDVAL = ZERO OR CODEURO)
      ************
                 MOVE CLF-VAL TO IF-CDVAL
                 MOVE 1 TO IF-FLVALUT
      **** rel 1.2
                 MOVE 1 TO IF-FLIVA
      ************
              ELSE
      **** rel 4.0
      *          IF CLF-VAL < 2 AND IF-CDVAL > 1
                 IF (CLF-VAL = ZERO OR CODEURO) AND
                    NOT (IF-CDVAL = ZERO OR CODEURO)
      ************
                 MOVE ZERO TO IF-CDVAL
      **** rel 1.2
                 MOVE ZERO TO IF-FLVALUT
                 MOVE ZERO TO IF-FLIVA.
      *          MOVE ZERO TO IF-FLVALUT.
      ************
      **** rel 4.0
      *    IF IF-CDVAL < 2
           IF IF-CDVAL = ZERO OR CODEURO
      ************
              MOVE ZERO TO IF-TOTDOCV IF-CAMGG IF-FLVALUT
      **** rel 1.2
              MOVE ZERO TO IF-FLIVA
      ************
              MOVE SPACE TO IF-DESVAL
      **** rel 1.2
      *       IF IF-PRGIVA = ZERO
      *          MOVE AZI-RANRG TO IF-PRGIVA
      *          ADD 1 TO IF-PRGIVA
      *       END-IF
      ************
              GO TO E-FOR.
      **** rel 1.2
      *    MOVE ZERO TO IF-PRGIVA.
      ************
           MOVE 1    TO IF-FLVALUT.
      **** rel 1.2
           MOVE 1    TO IF-FLIVA.
      ************
           MOVE 10       TO KTB-TIP.
           MOVE IF-CDVAL TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO T10-DSINT
                MOVE ZERO TO IF-CAMGG.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT  TO IF-DESVAL.
      **** rel 1.2
      **** rel 4.0
      *    IF CODEURO NOT = ZERO AND IF-CDVAL = CODEURO
           IF IF-CDVAL = 1
      ************
              IF CAUATTRN = 1
                 MOVE ZERO TO IF-FLIVA.
      ************
       E-FOR.
      *
       V-DATREG.
           MOVE 'IF-DATREG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATREG.
           IF FUN = 'M' GO TO E-DATREG.
           IF IF-DATREG = ZERO PERFORM ERR-ZERO
                               GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATREG TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
      **** rel 4.0
           CALL 'vrdtbigb' USING DTBIG.
           IF AAGGG <= DTBIG
              MOVE 'Data minore/uguale del Big-bang'  TO F-MES1
              MOVE 1 TO F-NMES
              GO TO V-ERROR.
      ************
           IF AAGGG < AZI-RVDT
              MOVE 'Data minore della chiusura mensile' TO MESS
              GO TO V-ERROR.
      **** rel 7.1
           IF AAGGG < AZI-DTAPE
              MOVE 'Data minore della data apertura' TO MESS
              GO TO V-ERROR.
      ************
      **** rel 2.0
           IF AAGGG < PRA-DTLIG
              MOVE 'Data minore della data di'  TO F-MES1
              MOVE 'stampa del libro giornale'  TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
      ************
           IF AAGGG NOT > DTAIVA
              MOVE SPACE TO MESS
              STRING 'Totali IVA aggiornati al ' DATIVB
                     DELIMITED '  ' INTO MESS
              GO TO V-ERROR.
      **** rel 6.1
      *    IF T25-PLA = 1 AND AAGGG NOT > T25-DTM
           IF T25PLA = 1 AND AAGGG NOT > T25KDTM
      ************
              MOVE 1 TO FLGPL
           ELSE
              MOVE ZERO TO FLGPL.
           MOVE AAGGG TO DTCON.
       E-DATREG.
      *
       V-NUMDOC.
           MOVE 'IF-NUMDOC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NUMDOC.
           IF FUN = 'M' GO TO E-NUMDOC.
           IF IF-NUMDOC = ZERO PERFORM ERR-ZERO
                               GO TO V-ERROR.
       E-NUMDOC.
      *
       V-DATDOC.
           MOVE 'IF-DATDOC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATDOC.
           IF FUN = 'M' GO TO E-DATDOC.
           IF IF-DATDOC = ZERO PERFORM ERR-ZERO
                               GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATDOC TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF AAGGG > DTCON
              MOVE 'Data maggiore della data registrazione' TO MESS
              GO TO V-ERROR.
           MOVE AAGGG TO DTDOC.
       E-DATDOC.
      *
       V-CODCAU.
           MOVE 'IF-CODCAU' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CODCAU.
           IF FUN = 'M' GO TO E-CODCAU.
           MOVE SPACE TO IF-DESCAU
                         IF-DARAVE.
           IF IF-CODCAU = ZERO PERFORM ERR-ZERO
                               GO TO V-ERROR.
           MOVE 2         TO KTB-TIP.
           MOVE IF-CODCAU TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO IF-DESCAU.
           MOVE T02-D-A   TO IF-DARAVE.
           MOVE T02-SEGNO TO SEGNO.
      **** rel 1.2
           MOVE T02-ATTRN TO CAUATTRN.
      ************
      **** rel 5.2
           MOVE T02-ATTRN TO IF-HS-ATTRN.
      ************
           IF T02-FLGSC = ZERO
              MOVE ZERO TO IF-FLGSC
           ELSE
              MOVE 1    TO IF-FLGSC.
      **** rel 6.1
      * controllo fattura acquisto gia' caricata
           IF FUN = 'V' AND
              DTDOC NOT = ZERO AND
              IF-NUMDOC NOT = ZERO AND
              IF-FOR NOT = ZERO
                 IF T02-TIPRG = 3 AND (T02-TIPOP = 1 OR 8)
                    MOVE IF-FL  TO MFA-FL
                    MOVE IF-AZI TO MFA-AZI
                    MOVE IF-FOR TO MFA-FORN
                    MOVE DTDOC  TO MFA-DTDOC
                    MOVE IF-NUMDOC TO MFA-NDOC
                    IF T02-TIPOP = 1
                       MOVE ZERO TO MFA-TIP
                    ELSE
                       MOVE 1 TO MFA-TIP
                    END-IF
                    CALL 'vrcmfa' USING PARMFA
      **** rel 6.3
      *             IF MFA-ST > 1
                    IF MFA-ST > 1 AND NOT = 9
      ************
                       MOVE 'ERRORE PARAMETRI vrcmfa' TO MESS
                       GO TO ERRIO
                    ELSE
      **** rel 6.3
      *                IF MFA-ST = 1
      *                   MOVE 3 TO F-NMES
      *                   MOVE 'ATTENZIONE: Documento gia'' caricato'
      *                        TO F-MES1
      *                   MOVE MFA-NREG TO NREGV
      *                   STRING 'Registrazione: ' NREGV INTO F-MES2
      *                   MOVE MFA-PRIVA TO NPRIVV
      *                   STRING 'Protocollo IVA: ' NPRIVV INTO F-MES3
      *                   GO TO V-ERROR.
      **** rel 7.1
      *                IF MFA-ST NOT = ZERO
      *                   MOVE 'Documento gia'' caricato' TO MB-TITOLO
      *                   MOVE SPACE TO F-MES1
      *                   MOVE MFA-NREG TO NREGV
      *                   STRING 'Registrazione: ' NREGV INTO F-MES2
      *                   MOVE MFA-PRIVA TO NPRIVV
      *                   STRING 'Protocollo IVA: ' NPRIVV INTO F-MES3
      *                   IF MFA-ST = 9
      *                      MOVE '--> DATA DIVERSA <--' TO F-MES1
      *                   END-IF
      *                   MOVE 'Continua?' TO F-MES4
      *                   MOVE 4 TO F-NMES
      *                   MOVE 'Q' TO MB-TIPO
      *                   MOVE 2 TO MB-DEFAULT
      *                   CALL 'vrmbox' USING PARMB
      *                   IF MB-RISP = 'S'
      *                      MOVE ZERO TO MFA-ST
      *                   ELSE
      *                      MOVE 1 TO F-NMES
      *                      MOVE 'Dato non valido' TO F-MES1
      *                      GO TO V-ERROR.
                       IF MFA-ST = 1
                          MOVE 3 TO F-NMES
                          MOVE 'ATTENZIONE!' TO MB-TITOLO
                          MOVE 'Stesso documento e stessa data'
                               TO F-MES1
                          MOVE MFA-NREG TO NREGV
                          STRING 'Registrazione: ' NREGV INTO F-MES2
                          MOVE MFA-PRIVA TO NPRIVV
                          STRING 'Protocollo IVA: ' NPRIVV INTO F-MES3
                          MOVE 'Continua?' TO F-MES4
                          MOVE 4 TO F-NMES
                          MOVE 'Q' TO MB-TIPO
                          MOVE 2 TO MB-DEFAULT
                          CALL 'vrmbox' USING PARMB
                          IF MB-RISP = 'S'
                             MOVE ZERO TO MFA-ST
                          ELSE
                             MOVE 1 TO F-NMES
                             MOVE 'Dato non valido' TO F-MES1
                             GO TO V-ERROR
                          END-IF
                       END-IF
                       IF MFA-ST = 9
                          MOVE 3 TO F-NMES
                          MOVE 'ATTENZIONE!' TO MB-TITOLO
                          MOVE 'Stesso documento con data diversa.'
                               TO F-MES1
                          MOVE MFA-NREG TO NREGV
                          STRING 'Registrazione: ' NREGV INTO F-MES2
                          MOVE MFA-PRIVA TO NPRIVV
                          STRING 'Protocollo IVA: ' NPRIVV INTO F-MES3
                          MOVE 'Continua?' TO F-MES4
                          MOVE 4 TO F-NMES
                          MOVE 'Q' TO MB-TIPO
                          MOVE 2 TO MB-DEFAULT
                          CALL 'vrmbox' USING PARMB
                          IF MB-RISP = 'S'
                             MOVE ZERO TO MFA-ST
                          ELSE
                             MOVE 1 TO F-NMES
                             MOVE 'Dato non valido' TO F-MES1
                             GO TO V-ERROR.
      ************
      ************
      ************
      **** rel 1.2
      **** rel 4.0
      *    IF CODEURO NOT = ZERO
      *       IF IF-CDVAL = CODEURO AND T02-TIPRG = 3 AND
              IF IF-CDVAL = 1 AND T02-TIPRG = 3 AND
      ************
                 (T02-TIPOP = 1 OR = 2)
                 IF T02-ATTRN = 1
                    MOVE ZERO  TO IF-FLIVA
                 ELSE
                    MOVE 1  TO IF-FLIVA
                 END-IF
                 GO TO V-CODCAU-90.
      ************
      **** rel 4.0
      *    IF (IF-CDVAL > 1 AND NOT
           IF ((NOT (IF-CDVAL = ZERO OR CODEURO)) AND NOT
      ************
              (T02-TIPRG = 3 AND T02-ATTRN = ZERO AND
              (T02-TIPOP = 1 OR = 2)))
      **** rel 4.0
      *    OR (IF-CDVAL < 2 AND NOT
           OR ((IF-CDVAL = ZERO OR CODEURO) AND NOT
      ************
      **** rel 5.2
      *       (T02-TIPRG = 3 AND T02-ATTRN = 1 AND
              (T02-TIPRG = 3 AND
      ************
              (T02-TIPOP = 1 OR = 2)))
              MOVE 'Causale non valida' TO MESS
              GO TO V-ERROR.
      **** rel 5.2
           MOVE IF-AZI TO KCF-AZI.
           MOVE IF-FOR TO COD.
           MOVE CODICE TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID PERFORM ERR-CINE
                                           GO TO V-ERROR.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           MOVE ZERO TO IF-HS-ACEE.
           IF T02-TIPRG     = 3     AND
              IF-HS-ATTRN   = ZERO  AND
              CLF-13IVA     = 4     AND
              T02-TIPOP = 1
                 PERFORM MOV-ACQ-CEE THRU EX-MOV-ACQ-CEE
                 GO TO E-CODCAU.
      ************
      **** rel 1.2
       V-CODCAU-90.
      **** rel 6.2
      *       IF IF-FLIVA = ZERO
              IF IF-FLIVA = ZERO AND T02-ATTRN = 1
      ************
                 IF IF-PRGIVA = ZERO
                    MOVE AZI-RANRG TO IF-PRGIVA
      **** rel 6.0a
                    IF IF-CATT NOT = ZERO
                       MOVE T35-RANRG TO IF-PRGIVA
                    END-IF
      *************
                    ADD 1 TO IF-PRGIVA
      **** rel 6.3
                    MOVE IF-PRGIVA TO SAV-ONPRGI
      ************
                 END-IF
              ELSE
      **** rel 6.3
                 MOVE ZERO TO SAV-ONPRGI
      ************
                 MOVE ZERO TO IF-PRGIVA.
      ************
       E-CODCAU.
      **** rel 6.3
       V-BOLDOG.
           MOVE 'IF-BOLDOG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-BOLDOG.
           IF FUN NOT = 'V' GO TO E-BOLDOG.
           MOVE KAZ-COD        TO KCF-AZI.
           MOVE IF-DESAGG(1:5) TO COD.
           MOVE CODICE         TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID KEY
                MOVE ZERO TO KCF-COD
                PERFORM ERR-CINE
                GO TO E-BOLDOG.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
      *
           MOVE SPACE TO IF-DESAGG.
           STRING COD '-' CLF-RGS DELIMITED SIZE INTO IF-DESAGG.
       E-BOLDOG.
      *
      ************
      *
       V-PRGIVA.
           MOVE 'IF-PRGIVA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PRGIVA.
           IF FUN = 'M' GO TO E-PRGIVA.
      **** rel 1.2
      **** rel 4.0
      *    IF CODEURO NOT = ZERO AND
      *       IF-CDVAL = CODEURO AND
           IF IF-CDVAL = 1 AND
      ************
              IF-FLIVA = ZERO    GO TO V-PRGIVA-10.
      ************
      **** rel 4.0
      *    IF IF-CDVAL > 1 GO TO E-PRGIVA.
           IF NOT (IF-CDVAL = ZERO OR CODEURO) GO TO E-PRGIVA.
      ************
      **** rel 1.2
       V-PRGIVA-10.
      ************
      **** rel 5.2
           IF IF-HS-ATTRN = ZERO AND
              IF-HS-ACEE  = 1    AND
              IF-PRGIVA   = ZERO GO TO E-PRGIVA.
      ************
      **** rel 6.2
           IF T02-ATTRN = ZERO GO TO E-PRGIVA.
      ************
           IF IF-PRGIVA = ZERO PERFORM ERR-ZERO
                               GO TO V-ERROR.
       E-PRGIVA.
      *
       V-DATSCA.
           MOVE 'IF-DATSCA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATSCA.
           IF FUN = 'M' GO TO E-DATSCA.
           IF IF-DATSCA = ZERO GO TO E-DATSCA.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATSCA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF AAGGG < DTDOC
              MOVE 'Data minore della data documento' TO MESS
              GO TO V-ERROR.
           MOVE AAGGG TO DTSCA.
       E-DATSCA.
      *
       V-TOTDOCV.
           MOVE 'IF-TOTDOCV' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TOTDOCV.
           IF FUN = 'M' GO TO E-TOTDOCV.
      **** rel 4.0
      *    IF IF-CDVAL <= 1 GO TO E-TOTDOCV.
           IF (IF-CDVAL = ZERO OR CODEURO) GO TO E-TOTDOCV.
      ************
           IF IF-TOTDOCV = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
      **** rel 1.2
           IF IF-CAMGG = ZERO
              MOVE ZERO TO IF-TOTDOC
              GO TO E-TOTDOCV.
           MOVE IF-TOTDOCV TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR.
           MOVE CG-CAMBIO TO ER-CAMBIO.
           MOVE CG-VALUT  TO ER-VALUT.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO.
      ************
           MOVE ER-IMPORTO TO IF-TOTDOC.
      *    COMPUTE IF-TOTDOC = IF-TOTDOCV * IF-CAMGG + 0,5.
      ************
       E-TOTDOCV.
      *
      **** rel 5.1
       V-CAMGG.
           MOVE 'IF-CAMGG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CAMGG.
           IF (IF-CDVAL = ZERO OR CODEURO) GO TO E-CAMGG.
           MOVE IF-DATREG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO ER-DATA.
           CALL 'rvalut' USING IF-CDVAL ER-DATA CG-PAR.
           IF CG-ST > ZERO PERFORM ERR-EURO
                           MOVE ALL '*' TO CG-DSINT
                           MOVE ZERO    TO CG-CAMBIO
                           GO TO V-ERROR.
           MOVE CG-CAMBIO TO IF-CAMGG.
           MOVE CG-DSINT  TO IF-DESVAL.
           MOVE IF-TOTDOCV TO ER-IMPORTO.
           MOVE CG-CAMBIO TO ER-CAMBIO.
           MOVE CG-VALUT  TO ER-VALUT.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO.
           MOVE ER-IMPORTO TO IF-TOTDOC.
           IF IF-CAMGG = ZERO
              MOVE 'Cambio a zero non accettabile' TO MESS
              GO TO V-ERROR.
       E-CAMGG.
      ************

       V-CDVAL.
           MOVE 'IF-CDVAL' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDVAL.
      **** rel 4.0
      *    IF IF-CDVAL < 2 GO TO E-CDVAL.
           IF (IF-CDVAL = ZERO OR CODEURO) GO TO E-CDVAL.
      ************
      **** rel 1.2
      *    MOVE 10       TO KTB-TIP.
      *    MOVE IF-CDVAL TO KTB-COD.
      *    READ TABELL INTO REKTAB INVALID
      *         MOVE ALL '*' TO T10-DSINT
      *         MOVE ZERO TO IF-CAMGG.
      *    IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *    MOVE T10-DSINT TO IF-DESVAL.
      *    COMPUTE IF-TOTDOC = IF-TOTDOCV * IF-CAMGG + 0,5.
           MOVE IF-DTCAMGG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO ER-DATA.
           CALL 'rvalut' USING IF-CDVAL ER-DATA CG-PAR.
           IF CG-ST > ZERO PERFORM ERR-EURO
                           MOVE ALL '*' TO CG-DSINT
                           MOVE ZERO    TO CG-CAMBIO.
           MOVE CG-CAMBIO TO IF-CAMGG.
           MOVE CG-DSINT  TO IF-DESVAL.
           MOVE IF-TOTDOCV TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR.
           MOVE CG-CAMBIO TO ER-CAMBIO.
           MOVE CG-VALUT  TO ER-VALUT.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO.
      ************
           MOVE ER-IMPORTO TO IF-TOTDOC.
      ************
           IF IF-CAMGG = ZERO
              MOVE 'Cambio a zero non accettabile' TO MESS
              GO TO V-ERROR.
       E-CDVAL.
      *
       V-TOTDOC.
           MOVE 'IF-TOTDOC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TOTDOC.
           IF FUN = 'M' GO TO E-TOTDOC.
           IF IF-TOTDOC = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-TOTDOC.
      *
           IF FUN = 'W' OR 'M' GO TO V-END-RIGO.
       V-DATI-RIGO.
           MOVE ZERO TO SWIVA.
      **** rel 5.2
       V-ACEE-CAUS.
           MOVE 'IF-ACEE-CAUS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ACEE-CAUS.
           IF IF-HS-ACEE NOT = 1 GO TO E-ACEE-CAUS.
           MOVE SPACE TO IF-ACEE-CAUS-D.
           IF FUN = 'w' AND IF-ACEE-CAUS = ZERO GO TO E-ACEE-CAUS.
           IF IF-ACEE-CAUS = ZERO PERFORM ERR-ZERO
                                  GO TO V-ERROR.
           MOVE 2            TO KTB-TIP.
           MOVE IF-ACEE-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO IF-ACEE-CAUS-D.
           IF T02-TIPRG = 3 AND T02-ATTRN = 1 AND
              ((T02-TIPOP = 1 AND T02-D-A = 'A') OR
              (T02-TIPOP = 8 AND T02-D-A = 'D'))
               MOVE T02-TIPRG TO IF-ACEE-T02-TIPRG
               MOVE T02-D-A   TO IF-ACEE-T02-D-A
               MOVE T02-TIPOP TO IF-ACEE-T02-TIPOP
               MOVE T02-SEGNO TO IF-ACEE-T02-SEGNO
               MOVE T02-FLGIS TO IF-ACEE-T02-FLGIS
               MOVE T02-ATTRN TO IF-ACEE-T02-ATTRN
               MOVE T02-FLVEN TO IF-ACEE-T02-FLVEN
               MOVE T02-FLGSC TO IF-ACEE-T02-FLGSC
               MOVE T02-DTSCO TO IF-ACEE-T02-DTSCO
               MOVE T02-FLGEC TO IF-ACEE-T02-FLGEC
               GO TO E-ACEE-CAUS.
           MOVE 'Causale non valida' TO MESS.
           GO TO V-ERROR.
       E-ACEE-CAUS.
      *
       V-ACEE-CATTA.
           MOVE 'IF-ACEE-CATTA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ACEE-CATTA.
           IF IF-HS-ACEE NOT = 1 GO TO E-ACEE-CATTA.
           IF IF-ACEE-CATTA = SPACE MOVE '0' TO IF-ACEE-CATTA.
           IF FUN NOT = 'V' GO TO E-ACEE-CATTA.
           IF IF-ACEE-CATTA = '0'
              MOVE AZI-RANRG TO IF-ACEE-NPRGIA
              ADD 1 TO IF-ACEE-NPRGIA
      **** rel 6.3
              MOVE IF-ACEE-NPRGIA TO SAV-ONPRGI
      ************
              GO TO E-ACEE-CATTA.
           MOVE 35            TO T35-TIP.
           MOVE IF-AZI        TO T35-CDAZ.
           MOVE IF-ACEE-CATTA TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           IF FUN = 'M' GO TO E-ACEE-CATTA.
           MOVE T35-RANRG TO IF-ACEE-NPRGIA.
           ADD 1 TO IF-ACEE-NPRGIA.
      **** rel 6.3
           MOVE IF-ACEE-NPRGIA TO SAV-ONPRGI.
      ************
       E-ACEE-CATTA.
      *
       V-ACEE-NPRGIA.
           MOVE 'IF-ACEE-NPRGIA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ACEE-NPRGIA.
           IF IF-HS-ACEE NOT = 1 GO TO E-ACEE-NPRGIA.
       E-ACEE-NPRGIA.
      *
       V-ACEE-CATTV.
           MOVE 'IF-ACEE-CATTV' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ACEE-CATTV.
           IF IF-HS-ACEE NOT = 1 GO TO E-ACEE-CATTV.
           IF IF-ACEE-CATTV = SPACE MOVE '0' TO IF-ACEE-CATTV.
           IF FUN NOT = 'V' GO TO E-ACEE-CATTV.
           IF IF-ACEE-CATTV = '0'
              MOVE AZI-RVNRG TO IF-ACEE-NPRGIV
              IF AZI-NUMFT > IF-ACEE-NPRGIV
                 MOVE AZI-NUMFT TO IF-ACEE-NPRGIV
              END-IF
              ADD 1 TO IF-ACEE-NPRGIV
              GO TO E-ACEE-CATTV.
           MOVE 35            TO T35-TIP.
           MOVE IF-AZI        TO T35-CDAZ.
           MOVE IF-ACEE-CATTV TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           IF FUN = 'M' GO TO E-ACEE-CATTV.
           MOVE T35-RVNRG TO IF-ACEE-NPRGIV.
           IF T35-NUMFT > IF-ACEE-NPRGIV
              MOVE T35-NUMFT TO IF-ACEE-NPRGIV.
           ADD 1 TO IF-ACEE-NPRGIV.
       E-ACEE-CATTV.
      *
       V-ACEE-NPRGIV.
           MOVE 'IF-ACEE-NPRGIV' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ACEE-NPRGIV.
           IF IF-HS-ACEE NOT = 1 GO TO E-ACEE-NPRGIV.
       E-ACEE-NPRGIV.
      ************
      *
      * dati IVA
      *
       V-IV-COD.
           MOVE 'IF-IV-COD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IV-COD.
           MOVE ZERO TO K.
       V-IV-COD-10.
           ADD 1 TO K.
           IF K > 6 GO TO E-IV-COD.
      **** rel 4.1a-1
      *    IF FUN = 'w'
           IF FUN = 'w' OR 'p'
      **************
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-IV-COD-10.
           MOVE SPACE TO IF-IV-DESCR(K).
           IF IF-IV-COD(K) = ZERO
              MOVE ZERO  TO IF-IV-IMPON(K)
      **** rel 5.2
                            IF-ACEE-IV-IMPONV(K)
      ************
                            IF-IV-IMPOR(K)
                            IF-IV-PERPLA(K)
              MOVE SPACE TO IF-IV-DESCR(K)
              GO TO V-IV-COD-10.
           MOVE IF-IV-COD(K) TO KTB-COD.
           MOVE 3            TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      **** rel 5.2
      *    MOVE TAB-DESCR TO IF-IV-DESCR(K).
           IF IF-HS-ACEE = 1
              MOVE T03-DSIVA TO IF-IV-DESCR(K)
           ELSE
              MOVE TAB-DESCR TO IF-IV-DESCR(K).
      ************
      **** rel 6.2
      *    IF T03-TPIVA = 1 OR 7
      *       MOVE 'IVA Indeducibile - Tipo IVA non gestito' TO MESS
      *       GO TO V-ERROR.
      ************
      **** rel 5.1
      *> per evitare ricalcolo su importo iva digitato
      *    PERFORM CALC-IMPOR-IVA.
           IF FUN = 'V'
              PERFORM CALC-IMPOR-IVA.
      ************
      *
           IF NOT (T03-TPIVA = 3 OR 6) GO TO V-IV-COD-20.
      **** rel 6.1
      *    IF T25-PLA  = ZERO GO TO V-IV-COD-20.
           IF T25PLA = ZERO GO TO V-IV-COD-20.
      ************
           IF IF-FLTIG = ZERO GO TO V-IV-COD-20.
           IF NOT (IF-IV-COD(K) = T141ACQ OR T141ACR OR T141ACT OR
                                  T142ACQ OR T143ACQ)
                  AND T03-TSPLA = ZERO
              GO TO V-IV-COD-20.
           IF TPL = 2
              IF IF-IV-COD(K) NOT = T142ACQ AND T03-TSPLA NOT = 2
                 GO TO V-IV-COD-20.
           IF TPL = 3
              IF IF-IV-COD(K) NOT = T143ACQ AND T03-TSPLA NOT = 3
                 GO TO V-IV-COD-20.
           IF FLGPL = 1
              MOVE SPACE TO F-MES1
              STRING 'Movimenti plafond aggiornati al ' DTMB
                      DELIMITED '  ' INTO F-MES1
              MOVE 'Impossibile contabilizzare la fattura' TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
           IF IF-IV-PMES(K) = ZERO
              MOVE IF-DATDOC TO GGMMAA
              MOVE 1 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE MM4 TO IF-IV-PMES(K)
              MOVE AA4 TO IF-IV-PANN(K).
       V-IV-COD-20.
           GO TO V-IV-COD-10.
       E-IV-COD.

      **** rel 5.2
       V-ACEE-IV-IMPONV.
           MOVE 'IF-ACEE-IV-IMPONV' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ACEE-IV-IMPONV.
           IF IF-HS-ACEE NOT = 1 GO TO E-ACEE-IV-IMPONV.
           MOVE ZERO TO K.
       V-ACEE-IV-IMPONV-10.
           ADD 1 TO K.
           IF K > 6 GO TO E-ACEE-IV-IMPONV.
           IF FUN = 'W'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-ACEE-IV-IMPONV-10.
           IF IF-ACEE-IV-IMPONV(K) = ZERO
              GO TO V-ACEE-IV-IMPONV-10.
           IF FUN NOT = 'W' AND
              IF-CAMGG NOT = ZERO AND
              IF-ACEE-IV-IMPONV(K) NOT = ZERO AND
              IF-IV-IMPON(K) = ZERO
              MOVE IF-ACEE-IV-IMPONV(K) TO ER-IMPORTO
              MOVE IF-CDVAL TO ER-VALUT
              MOVE IF-CAMGG TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT
                                  ER-CAMBIO
              MOVE ER-IMPORTO TO IF-IV-IMPON(K).
           GO TO V-ACEE-IV-IMPONV-10.
       E-ACEE-IV-IMPONV.
      ************
      *
       V-IV-IMPON.
           MOVE 'IF-IV-IMPON' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IV-IMPON.
           MOVE ZERO TO K.
       V-IV-IMPON-10.
           ADD 1 TO K.
           IF K > 6 GO TO E-IV-IMPON.
      **** rel 4.1a-1
      *    IF FUN = 'w'
           IF FUN = 'w' OR 'p'
      **************
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-IV-IMPON-10.
           IF IF-IV-IMPON(K) = ZERO
              MOVE ZERO TO IF-IV-IMPOR(K)
              IF IF-IV-COD(K) = ZERO
                 GO TO V-IV-IMPON-10
              ELSE
                 PERFORM ERR-ZERO
                 GO TO V-ERROR.
           MOVE IF-IV-COD(K) TO KTB-COD.
           MOVE 3            TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ZERO TO IF-IV-IMPOR(K)
                GO TO V-IV-IMPON-10.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      **** rel 6.2
      *    IF T03-TPIVA = 1 OR 7
      *       MOVE ZERO TO IF-IV-IMPOR(K)
      *       GO TO V-IV-IMPON-10.
      ************
      **** rel 5.1
      *> per evitare ricalcolo su importo iva digitato
      *    PERFORM CALC-IMPOR-IVA.
           IF FUN = 'V'
              PERFORM CALC-IMPOR-IVA.
      ************
           GO TO V-IV-IMPON-10.
       E-IV-IMPON.
      *
      **** rel 7.1
       V-IV-IMPOR.
           MOVE 'IF-IV-IMPOR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IV-IMPOR.
           MOVE ZERO TO K.
       V-IV-IMPOR-10.
           ADD 1 TO K.
           IF K > 6 GO TO E-IV-IMPOR.
           IF FUN = 'w' OR 'p'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-IV-IMPOR-10.
           IF FUN = 'V'
              PERFORM CALC-IMPOR-IVA-IND.
           GO TO V-IV-IMPOR-10.
       E-IV-IMPOR.
      *
      ************
       V-IV-PERPLA.
           MOVE 'IF-IV-PERPLA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IV-PERPLA.
           MOVE ZERO TO K.
       V-IV-PERPLA-10.
           ADD 1 TO K.
           IF K > 6 GO TO E-IV-PERPLA.
      **** rel 4.1a-1
      *    IF FUN = 'w'
           IF FUN = 'w' OR 'p'
      **************
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-IV-PERPLA-10.
           IF IF-IV-COD(K) = ZERO GO TO V-IV-PERPLA-20.
           MOVE IF-IV-COD(K) TO KTB-COD.
           MOVE 3            TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID GO TO V-IV-PERPLA-15.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF NOT (T03-TPIVA = 3 OR 6) GO TO V-IV-PERPLA-15.
      **** rel 6.1
      *    IF T25-PLA  = ZERO GO TO V-IV-PERPLA-15.
           IF T25PLA = ZERO GO TO V-IV-PERPLA-15.
      ************
           IF IF-FLTIG = ZERO GO TO V-IV-PERPLA-15.
           IF NOT (IF-IV-COD(K) = T141ACQ OR T141ACR OR T141ACT OR
                                  T142ACQ OR T143ACQ)
                  AND T03-TSPLA = ZERO
              GO TO V-IV-PERPLA-15.
           IF TPL = 2
              IF IF-IV-COD(K) NOT = T142ACQ AND T03-TSPLA NOT = 2
                 GO TO V-IV-PERPLA-15.
           IF TPL = 3
              IF IF-IV-COD(K) NOT = T143ACQ AND T03-TSPLA NOT = 3
                 GO TO V-IV-PERPLA-15.
      *
           IF IF-IV-PERPLA(K) = ZERO GO TO V-IV-PERPLA-20.
           IF IF-IV-PMES(K) < 1 OR > 12 OR IF-IV-PANN(K) = ZERO
              PERFORM ERR-DINV
              GO TO V-ERROR.
           MOVE IF-IV-PMES(K) TO PLFMM.
           MOVE IF-IV-PANN(K) TO PLFAA.
           MOVE IF-DATDOC TO GGMMAA.
           MOVE MM9 TO PERM.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4  TO PERA.
           MOVE PERM TO PERMA.
           MOVE PERA TO PERAA.
           IF DTCT2 > DTCT1
      **** rel 4.1a-1
      *       PERFORM ERR-DINC
      *       GO TO V-WARNING.
           MOVE 'Controllare periodo competenza Plafond' TO F-MES1
           MOVE 1 TO F-NMES
           CALL 'vrmbox' USING PARMB.
      **************
           MOVE DTP6 TO PERIO.
           MOVE PERM TO PERMA.
           IF PERM = ZERO GO TO V-IV-PERPLA-20.
           MOVE PERA TO PERAA.
           IF DTCT1 < DTCT2 GO TO V-IV-PERPLA-20.
           MOVE SPACE TO MESS.
           MOVE DTP6 TO DTPB.
           STRING 'Plafond aggiornato al '
                  DTPB DELIMITED SIZE
                  INTO MESS.
           GO TO V-ERROR.
       V-IV-PERPLA-15.
           IF IF-IV-PERPLA(K) NOT = ZERO
              MOVE 'Il tipo IVA non ammette Plafond' TO MESS
              GO TO V-ERROR.
       V-IV-PERPLA-20.
           GO TO V-IV-PERPLA-10.
       E-IV-PERPLA.
           IF FUN = 'p' GO TO V-END-RIGO.
      *
      * dati Contropartite
      *
       V-CP-IMPON.
           MOVE 'IF-CP-IMPON' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CP-IMPON.
           MOVE ZERO TO K.
       V-CP-IMPON-10.
           ADD 1 TO K.
           IF K > 15 GO TO E-CP-IMPON.
           IF FUN = 'w'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-CP-IMPON-10.
           IF IF-CP-IMPON(K) = ZERO
              MOVE ZERO  TO IF-CP-COD(K)
                            IF-CP-FLCOSZ(K)
              MOVE SPACE TO IF-CP-DESCR(K)
                            IF-CP-CCOST(K).
           GO TO V-CP-IMPON-10.
       E-CP-IMPON.
      *
       V-CP-COD.
           MOVE 'IF-CP-COD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CP-COD.
           MOVE ZERO TO K.
       V-CP-COD-10.
           ADD 1 TO K.
      **** rel 6.1sm(CMO40)05/06/2015
      *    IF K > 15 GO TO E-CP-COD.
           IF K > 16 GO TO E-CP-COD.
           IF K = 16 AND IF-CP-IMPON(K) = ZERO
              MOVE ZERO  TO IF-CP-COD(K)
                            IF-CP-FLCOSZ(K)
              MOVE SPACE TO IF-CP-DESCR(K)
                            IF-CP-CCOST(K).
      **** end rel 6.1sm(CMO40)
           IF FUN = 'w'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-CP-COD-10.
           MOVE SPACE TO IF-CP-DESCR(K).
           IF IF-CP-COD(K) = ZERO
      **** rel 5.2
      **** rel 6.1sm(CMO40)05/06/2015
      *       IF IF-HS-ACEE = 1 AND K = 1 AND IF-CP-IMPON(K) NOT = ZERO
              IF IF-HS-ACEE = 1 AND K = 16
                AND IF-CP-IMPON(K) NOT = ZERO
      **** end rel 6.1sm(CMO40)
                 PERFORM ERR-ZERO
                 GO TO V-ERROR
              END-IF
      ************
              IF IF-CP-IMPON(K) = ZERO
                 GO TO V-CP-COD-10
              ELSE
                 PERFORM ERR-ZERO
                 GO TO V-ERROR.
           MOVE KAZ-COD      TO KPC-AZI.
           MOVE IF-CP-COD(K) TO KPC-COD.
           READ ANACON INTO REKCON INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           MOVE CON-DSC TO IF-CP-DESCR(K).
      **** rel 5.2
           IF CON-MOVIM > ZERO
              MOVE 'Non movimentabile' TO MESS
              GO TO V-ERROR.
      ************
      *
           MOVE ZERO TO IF-CP-FLCOSZ(K).
           IF CON-TIPO NOT = 'E'
              MOVE ZERO  TO IF-CP-FLCOSZ(K)
              MOVE SPACE TO IF-CP-CCOST(K)
           ELSE
              IF CON-TRIP = ZERO
                 MOVE 2 TO IF-CP-FLCOSZ(K)
              ELSE
      **** rel 5.2
      *          MOVE 3        TO IF-CP-FLCOSZ(K)
      *          IF FUN = 'V'
      *             MOVE CON-TTIP TO IF-CP-CCOST(K).
                 MOVE 3        TO IF-CP-FLCOSZ(K).

           OPEN INPUT APPCON.
           MOVE KAZ-COD      TO KACO-AZI.
           MOVE IF-CP-COD(K) TO KACO-COD.
           READ APPCON INVALID MOVE SPACE TO ACO-CDC.
           CLOSE APPCON.

           IF FUN = 'V'
              IF CON-TIPO = 'E'
                 IF CON-TRIP = ZERO
                    MOVE ACO-CDC TO IF-CP-CCOST(K)
                 ELSE
                    MOVE CON-TTIP TO IF-CP-CCOST(K).
      ************
      **** rel 6.2
           IF IF-CP-COD(K) = ZERO
              MOVE ZERO  TO IF-CP-IMPON(K)
                            IF-CP-FLCOSZ(K)
              MOVE SPACE TO IF-CP-DESCR(K)
                            IF-CP-DESAG(K)
                            IF-CP-CCOST(K).
      ************
           GO TO V-CP-COD-10.
       E-CP-COD.
      *
       V-CP-CCOST.
           MOVE 'IF-CP-CCOST' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CP-CCOST.
           MOVE ZERO TO K.
       V-CP-CCOST-10.
           ADD 1 TO K.
           IF K > 15 GO TO E-CP-CCOST.
           IF FUN = 'W'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-CP-CCOST-10.
           IF AZI-FLCOS = ZERO GO TO E-CP-CCOST.
           IF IF-CP-CCOST(K) = '0' MOVE SPACE TO IF-CP-CCOST(K).
           IF IF-CP-CCOST(K) NOT = SPACE
              MOVE IF-CP-COD(K) TO KPC-COD
              PERFORM LEGG-TIPO-CONTO
              IF CON-TIPO NOT = 'E'
                 MOVE SPACE TO IF-CP-CCOST(K)
                 MOVE 'Conto non economico'      TO F-MES1
                 MOVE 'Azzerato centro di costo' TO F-MES2
                 MOVE 2 TO F-NMES
                 GO TO V-ERROR.
           IF CON-TRIP = ZERO
              MOVE IF-CP-CCOST(K) TO CODCEN
              CALL 'rcart4' USING CODCEN
              MOVE CODCEN TO IF-CP-CCOST(K)
           ELSE
              MOVE SPACE TO IF-CP-FILL(K).
           IF IF-CP-CCOST(K) = SPACE GO TO V-CP-CCOST-10.
           IF CON-TRIP = ZERO  GO TO LEGCDC3.
           MOVE IF-AZI         TO KTRT-AZI.
           MOVE IF-CP-CCOST(K) TO KTRT-COD.
           READ TABRIT INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           GO TO NOCDC3.
       LEGCDC3.
           MOVE IF-AZI         TO KCD-AZI.
           MOVE IF-CP-CCOST(K) TO KCD-COD.
           READ CDCOST INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF CDC-STATO = ZERO
              MOVE 'Centro di costo non attivo' TO MESS
              GO TO V-ERROR.
       NOCDC3.
           MOVE IF-AZI         TO COS-AZI.
           MOVE IF-CP-CCOST(K) TO COS-CCO.
           CALL 'vrccos' USING PARCOS.
           IF COS-ST > ZERO
              MOVE 'Errore centro di costo' TO MESS
              GO TO V-ERROR.
           GO TO V-CP-CCOST-10.
       E-CP-CCOST.
      *
      * dati Scadenzario
      *
       V-CDPAG.
           MOVE 'IF-CDPAG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDPAG.
           MOVE SPACE TO IF-DESPAG.
           IF IF-CDPAG = ZERO PERFORM AZZ-IF-SCA
                              GO TO E-CDPAG.
           MOVE IF-CDPAG TO KTB-COD.
           MOVE 4        TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO IF-DESPAG.
           IF T04-1SCAD >= 4 MOVE 1 TO IF-FL1SCAD.
           IF FUN NOT = 'V' GO TO E-CDPAG.
           PERFORM RSCAD THRU EX-RSCAD.
      **** rel 1.2
           IF IF-TOTDOCV NOT = ZERO
      **** rel 4.0
      *       PERFORM RICAL-IMPSCA-LIRE THRU EX-RICAL-IMPSCA-LIRE.
              PERFORM RICAL-IMPSCA-EURO THRU EX-RICAL-IMPSCA-EURO.
      ************
      ************
       E-CDPAG.
      *
       V-1SCAD.
           MOVE 'IF-1SCAD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-1SCAD.
           MOVE IF-CDPAG TO KTB-COD.
           MOVE 4        TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID GO TO E-1SCAD.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T04-1SCAD < 3 GO TO E-1SCAD.
           MOVE 1 TO TIPOP1.
           MOVE IF-1SCAD TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF IF-1SCAD = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-1SCAD.
      *
       V-CDBAN.
           MOVE 'IF-CDBAN' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDBAN.
           MOVE SPACE TO IF-DESBAN.
           IF IF-CDBAN = ZERO GO TO E-CDBAN.
           MOVE IF-CDBAN TO KBA-BAN.
           READ ANABAN INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           MOVE BAN-RGSOC TO IF-DESBAN.
       E-CDBAN.
      **** rel 6.2
       V-SC-PRG.
           MOVE 'IF-SC-PRG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-SC-PRG.
           IF IF-SC-PRG = ZERO GO TO E-SC-PRG.
           IF FUN NOT = 'V' GO TO E-SC-PRG.
           OPEN INPUT ANASCA NOTSCA.
           MOVE KAZ-COD    TO KSC-AZI.
           MOVE 2          TO KSC-TIPO.
           MOVE IF-SC-DTSCA(1) TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG      TO KSC-DTSCA.
           MOVE IF-SC-PRG  TO KSC-PRG.
           READ ANASCA INVALID  GO TO E-SC-PRG.
      *
           MOVE KSC-AZI   TO KNSC-AZI.
           MOVE KSC-TIPO  TO KNSC-TIPO.
           MOVE KSC-DTSCA TO KNSC-DTSCA.
           MOVE KSC-PRG   TO KNSC-PRG.
           MOVE 1         TO KNSC-PRGN.
           READ NOTSCA INVALID MOVE SPACE TO NSC-DESCR.
           CLOSE ANASCA NOTSCA.
           IF (KS2-CODCF(3:5) NOT = IF-FOR) OR
              (SCA-NDOC  NOT = ZERO)        OR
              (SCA-DTDOC NOT = ZERO)        OR
              (SCA-IMPOR NOT = IF-TOTDOC)   OR
              (SCA-TPAG  NOT = 9)           OR
              (SCA-STATO NOT = "P")         GO TO E-SC-PRG.
           MOVE SCA-NOTE  TO IF-SC-NOTE(1).
           MOVE NSC-DESCR TO IF-SC-NOTEA(1).
      *
       E-SC-PRG.
      *
      ************
      *
       V-SC-TPAG.
           MOVE 'IF-SC-TPAG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-SC-TPAG.
           MOVE ZERO TO K.
       V-SC-TPAG-10.
           ADD 1 TO K.
           IF K > 12 GO TO E-SC-TPAG.
           IF FUN = 'w'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-SC-TPAG-10.
           IF IF-SC-TPAG(K) = ZERO
      **** rel 6.2
              MOVE SPACE TO IF-SC-NOTE(K)
                            IF-SC-NOTEA(K)
      ************
              MOVE ZERO TO IF-SC-DTSCA(K)
                           IF-SC-IMRATA(K)
                           IF-SC-VALRAT(K).
           GO TO V-SC-TPAG-10.
       E-SC-TPAG.
      *
       V-SC-DTSCA.
           MOVE 'IF-SC-DTSCA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-SC-DTSCA.
           MOVE ZERO TO K.
       V-SC-DTSCA-10.
           ADD 1 TO K.
           IF K > 12 GO TO E-SC-DTSCA.
           IF FUN = 'w'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-SC-DTSCA-10.
           MOVE IF-SC-DTSCA(K) TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           GO TO V-SC-DTSCA-10.
       E-SC-DTSCA.
      *
       V-SC-IMRATA.
           MOVE 'IF-SC-IMRATA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-SC-IMRATA.
           MOVE ZERO TO K.
       V-SC-IMRATA-10.
           ADD 1 TO K.
           IF K > 12 GO TO E-SC-IMRATA.
           IF FUN = 'w'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-SC-IMRATA-10.
      **** rel 4.0
      *    IF IF-CDVAL < 2 GO TO V-SC-IMRATA-10.
           IF (IF-CDVAL = ZERO OR CODEURO) GO TO V-SC-IMRATA-10.
      ************
           IF FUN NOT = 'V' GO TO V-SC-IMRATA-10.
           IF IF-SC-IMRATA(K) NOT = ZERO
      **** rel 1.2
              MOVE IF-SC-IMRATA(K) TO ER-IMPORTO
              MOVE IF-CAMGG        TO ER-CAMBIO
      **** rel 4.0
      *       MOVE DTCON           TO ER-DATA
      ************
              MOVE IF-CDVAL        TO ER-VALUT
      **** rel 4.0
      *       CALL 'rcamimp' USING ER-IMPORTO LIR-VAL ER-VALUT
      *                            ER-CAMBIO  ER-DATA
              CALL 're2imp' USING ER-IMPORTO EUR-VAL ER-VALUT
                                  ER-CAMBIO
      ************
              MOVE ER-IMPORTO TO IF-SC-VALRAT(K).
      *       COMPUTE IF-SC-VALRAT(K) = IF-SC-IMRATA(K) / IF-CAMGG.
      ************
           GO TO V-SC-IMRATA-10.
       E-SC-IMRATA.

      **** rel 7.1
       V-TR-CDPAP.
           MOVE 'IF-TR-CDPAP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TR-CDPAP.
           IF IF-TR-CDPAP = SPACE
              MOVE SPACE TO IF-TR-DPAP
              MOVE ZERO TO IF-TR-CDVAL
              GO TO E-TR-CDPAP.
           MOVE IF-TR-CDPAP TO T37-COD.
           MOVE 37          TO T37-TIP.
           MOVE T37-KEYID TO KEYTB.
           READ TABELL INTO REKT37 INVALID PERFORM ERR-CINE
                                           GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT37.

           MOVE T37-DESCR TO IF-TR-DPAP.
       E-TR-CDPAP.
      *
       V-TR-CDPAO.
           MOVE 'IF-TR-CDPAO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TR-CDPAO.
           IF IF-TR-CDPAO = SPACE
              MOVE SPACE TO IF-TR-DPAO
              MOVE ZERO TO IF-TR-CDVAL
              GO TO E-TR-CDPAO.
           MOVE IF-TR-CDPAO TO T37-COD.
           MOVE 37          TO T37-TIP.
           MOVE T37-KEYID TO KEYTB.
           READ TABELL INTO REKT37 INVALID PERFORM ERR-CINE
                                           GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT37.

           MOVE T37-DESCR TO IF-TR-DPAO.

           IF FUN = 'V' MOVE T37-CDVAL TO IF-TR-CDVAL.
       E-TR-CDPAO.
      *
       V-TR-CDVAL.
           MOVE 'IF-TR-CDVAL' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TR-CDVAL.
           IF IF-TR-CDVAL = ZERO
              MOVE SPACE TO IF-TR-DSINT
              MOVE ZERO TO IF-TR-CAMGG
              GO TO E-TR-CDVAL.
      *
           MOVE IF-TR-CDVAL TO KTB-COD.
           MOVE 10          TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM ERR-CINE
                                           GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *
           MOVE IF-DATDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO ER-DATA.
           CALL 'rvalut' USING IF-TR-CDVAL ER-DATA CG-PAR.
           IF CG-ST > ZERO MOVE ALL '*' TO CG-DSINT
                           MOVE ZERO    TO CG-CAMBIO.
           MOVE CG-CAMBIO TO IF-TR-CAMGG.
           MOVE CG-DSINT  TO IF-TR-DSINT.
       E-TR-CDVAL.
      *
       V-TR-SPAEP.
           MOVE 'IF-TR-SPAEP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TR-SPAEP.
           IF IF-TR-SPAEP = SPACE
              MOVE SPACE TO IF-TR-DSPP
              MOVE ZERO TO IF-TR-CDVAL
              GO TO E-TR-SPAEP.
           MOVE IF-TR-SPAEP TO T37-COD.
           MOVE 37          TO T37-TIP.
           MOVE T37-KEYID TO KEYTB.
           READ TABELL INTO REKT37 INVALID PERFORM ERR-CINE
                                           GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT37.

           MOVE T37-DESCR TO IF-TR-DSPP.
       E-TR-SPAEP.
      *
       V-TR-MOER.
           MOVE 'IF-TR-MOER' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TR-MOER.
.     * leggere grimer
       E-TR-MOER.
      *
       V-TR-MOIN.
           MOVE 'IF-TR-MOIN' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TR-MOIN.
.     * leggere griami
       E-TR-MOIN.
      *
      ************
      **** rel 5.2
       V-DATI-INTRA.

       V-TR-IMPAGG.
           MOVE 'IF-TR-IMPAGG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TR-IMPAGG.
           MOVE ZERO TO K IF-TIMPAGG.
      **** rel 6.3
           MOVE ZERO TO IF-DIFIMPO.
           MOVE IF-TIMPBOL TO IF-DIFIMPO.
      ************
      **** rel 7.1
           IF FUN = 'V' AND
              IF-TR-CDVAL NOT = ZERO
                 MOVE IF-TR-IMPAGG(IF-IDXVET) TO ER-IMPORTO
                 MOVE IF-TR-CAMGG TO ER-CAMBIO
                 MOVE IF-TR-CDVAL TO ER-VALUT
                 CALL 're2imp' USING ER-IMPORTO
                                     EUR-VAL ER-VALUT ER-CAMBIO
                 MOVE ER-IMPORTO TO IF-TR-IMPVAL(IF-IDXVET).
      ************
       V-TR-IMPAGG-10.
           ADD 1 TO K.
           IF K > 10 GO TO V-TR-IMPAGG-20.
           ADD IF-TR-IMPAGG(K) TO IF-TIMPAGG.
      **** rel 6.3
           SUBTRACT IF-TR-IMPAGG(K) FROM IF-DIFIMPO.
      ************
           GO TO V-TR-IMPAGG-10.
       V-TR-IMPAGG-20.
           IF FUN = 'V' GO TO E-TR-IMPAGG.
           IF IF-TIMPAGG = IF-TIMPBOL GO TO E-TR-IMPAGG.
      **** rel 6.3
           IF IF-TIMPBOL = ZERO GO TO E-TR-IMPAGG.
      ************
      **** rel 7.1
           IF FLGRB = 9  *> non effettuate rettifiche su bolle
              MOVE "Differenza fra totale importo bolle e" TO F-MES1
              MOVE "importo per aggiornamento elenchi CEE" TO F-MES2
              MOVE SPACE TO F-MES3
              MOVE 'Vuoi proseguire ugualmente ?'       TO F-MES4
              MOVE 4 TO F-NMES
              MOVE 'Q' TO MB-TIPO
              MOVE '2' TO MB-DEFAULT
              CALL 'vrmbox' USING PARMB
              IF MB-RISP = 'S' GO TO E-TR-IMPAGG.
      ************
           MOVE "Sistemare differenza fra totale " TO F-MES1.
           MOVE "importo bolle e importo per     " TO F-MES2.
           MOVE "aggiornamento elenchi CEE       " TO F-MES3.
           MOVE 3 TO F-NMES.
           MOVE 'IF-TR-IMPAGG' TO VCAMPO.
           MOVE 1 TO IF-IDXVET.
           GO TO V-ERROR.
       E-TR-IMPAGG.
           IF FUN = 'P' GO TO V-END-RIGO.
      ************
      *
      * esegue sempre se 'V' o 'w'.
      **** rel 5.2
      *    PERFORM CALC-IV-IMPON.
      *    PERFORM CALC-IV-DIFF.
      *    PERFORM CALC-CP-DIFF.
      *    PERFORM CALC-SC-DIFF.

           IF IF-HS-ATTRN = 1
              PERFORM CALC-IV-IMPON
              PERFORM CALC-IV-DIFF
              PERFORM CALC-CP-DIFF.
           IF IF-HS-ACEE = 1
              PERFORM CALC-IV-IMPON
      **** rel 6.1sm(CMO40)05/06/2015
      *       PERFORM CALC-CP-DIFF
              PERFORM CALC-ACEE-CP
      **** end rel 6.1sm(CMO40)05/06/2015
              PERFORM CALC-ACEE-DIFF.
           IF IF-FLGSC = 1  OR 3
              PERFORM CALC-SC-DIFF.
      ************

      * esegue solo se valida tutto di rigo
           IF FUN NOT = 'w' GO TO V-END-RIGO.
      **** rel 5.2
           IF IF-HS-ACEE NOT = 1
      ************
           IF IF-DIFDOC NOT = ZERO
              MOVE "Errore di quadratura su IVA" TO MESS
              MOVE 'IF-IV-COD' TO VCAMPO
              MOVE 1 TO IF-IDXVET
              GO TO V-ERROR.
           IF IF-DIFIMPON NOT = ZERO
              MOVE 'Errore di quadratura su contropartite' TO MESS
              MOVE 'IF-CP-IMPON' TO VCAMPO
              MOVE 1 TO IF-IDXVET
      **** rel 6.3
      **** rel 7.1
              GO TO V-ERROR.
      *       GO TO V-WARNING.
      ************
      ************
           IF IF-DIFSCA < ZERO OR IF-DIFSCAV < ZERO
              MOVE 'Sistemare scadenzario'              TO F-MES1
              MOVE 'Totale rate > del totale documento' TO F-MES2
              MOVE 2 TO F-NMES
              MOVE 'IF-SC-TPAG' TO VCAMPO
              MOVE 1 TO IF-IDXVET
              GO TO V-ERROR.
           IF SWIVA = 1
              MOVE "L'importo IVA di uno o piu' righi"  TO F-MES1
              MOVE "e' diverso  da  quello  calcolato"  TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-WARNING.
      **** rel 5.2
           IF IF-HS-ACEE = 1
              IF IF-DIFDOC NOT = ZERO OR IF-DIFDOCV NOT = ZERO
                 MOVE 1 TO F-NMES
                 MOVE 'Differenze non a zero su IVA CEE' TO F-MES1
                 GO TO V-WARNING.
      ************
      *
       V-END-RIGO.
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * fase di contabilizzazione
       RUN-ELABORA.
           MOVE ZERO  TO WRKLAV.
      **** rel 3.0
           MOVE ZERO  TO WRKSCA.
      ************
           MOVE SPACE TO WDESC.
           MOVE ZERO  TO WVALUT WCAMGG WIMVAL WDTSCD WDATA WPART.
      **** rel 3.0b
           MOVE ZERO  TO WFLAG WCDPAG WCDBAN WNRATE.
      *
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
              MOVE ZERO TO WTPAG(K) WDTSCA(K) WIMRATA(K) WVALRATA(K)
      **** rel 6.2
              MOVE SPACE TO WNOTE(K) WNOTEA(K)
      ************
              ADD 1 TO K
           END-PERFORM.
      ************
      *
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              MOVE ZERO TO WDSC(K) WISC(K) WVSC(K)
              ADD 1 TO K
           END-PERFORM.
      *
           MOVE 1 TO K.
           PERFORM UNTIL K > 54
              MOVE ZERO  TO WIMP(K) WIVA(K)
              MOVE SPACE TO WD-A(K) WFIL(K) WCCOST(K)
              ADD 1 TO K
           END-PERFORM.
      *
           MOVE IF-AZI TO CDAZ.
           MOVE 3 TO TREG.
           MOVE IF-CODCAU TO WCAUS.
           MOVE CODICE TO WPART.
      *
           MOVE IF-DATSCA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF AAGGG NOT = ZERO
              MOVE AAGGG  TO WDTSCD WDSC(1).
      *
           MOVE IF-PRGIVA TO WNPRGI.
      **** rel 5.2
           IF IF-HS-ATTRN = ZERO AND IF-HS-ACEE  = 1
              IF (IF-PRGIVA = ZERO) AND (IF-ACEE-NPRGIA NOT = ZERO)
                 MOVE IF-ACEE-NPRGIA TO WNPRGI.
      ************
           MOVE IF-NUMDOC TO WNDOC.
      *
           MOVE IF-DATDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG  TO WDATA.
      *
           MOVE IF-DESAGG TO WDESC.
           MOVE IF-TOTDOC TO WTDOC WISC(1).
           MOVE IF-CATT TO WCATT.
      **** rel 6.2
           IF IF-HS-ATTRN = ZERO AND IF-HS-ACEE  = 1
              IF (IF-PRGIVA = ZERO) AND (IF-ACEE-NPRGIA NOT = ZERO)
                 MOVE IF-ACEE-CATTA TO WCATT.
      ************
           MOVE IF-CDVAL TO WVALUT.
           MOVE IF-CAMGG TO WCAMGG.
           MOVE IF-TOTDOCV TO WIMVAL WVSC(1).
      **** rel 5.2
           PERFORM CREA-WDS400   THRU EX-CREA-WDS400.
           IF IF-HS-ATTRN = ZERO AND
              IF-HS-ACEE  = 1
                 MOVE 6 TO K1
                 GO TO DATI-CP.
      ************
      * carica dati IVA
           MOVE 6 TO K1.
           MOVE 1 TO K.
           MOVE IF-DATDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           PERFORM UNTIL K > 6
              IF IF-IV-COD(K) NOT = ZERO
                 ADD 1 TO K1
                 MOVE IF-IV-COD(K)   TO WCOD(K1)
                 MOVE IF-IV-IMPON(K) TO WIMP(K1)
                 MOVE IF-IV-IMPOR(K) TO WIVA(K1)
                 MOVE 9999999        TO WCON(K1)
                 MOVE IF-DARAVE      TO WD-A(K1)
                 MOVE IF-IV-PMES(K)  TO WPLAM(K1)
      * nota: AA4 e' l'anno di IF-DATDOC
                 IF IF-IV-PANN(K) < AA4
                    MOVE 1 TO WPLAN(K1)
                 ELSE
                    IF IF-IV-PANN(K) > AA4
                       MOVE 2 TO WPLAN(K1)
                    END-IF
                 END-IF
              END-IF
              ADD 1 TO K
           END-PERFORM.
      **** rel 5.2
       DATI-CP.
      ************
      * carica dati C/P
           MOVE 1 TO K.
           PERFORM UNTIL K > 15
              IF IF-CP-COD(K) NOT = ZERO
                 ADD 1 TO K1
                 MOVE IF-CP-COD(K)   TO WCON(K1)
      **** rel 1.2
      *          MOVE IF-CP-IMPON(K) TO WIMP(K1)
                 IF CAUATTRN = ZERO
                    MOVE IF-CP-IMPON(K) TO WIVA(K1)
                 ELSE
                    MOVE IF-CP-IMPON(K) TO WIMP(K1)
                 END-IF
      ************
                 MOVE IF-CP-CCOST(K) TO WCCOST(K1)
                 MOVE IF-DESAGG      TO WDES(K1)
      **** rel 6.2
                 IF IF-CP-DESAG(K) NOT = SPACE
                    MOVE IF-CP-DESAG(K) TO WDES(K1)
                 END-IF
      ************
                 IF IF-DARAVE = 'D'
                    MOVE 'A' TO WD-A(K1)
                 ELSE
      **** rel 5.1
      *             MOVE 'D' TO WD-A(K1)
                    IF IF-CP-IMPON(K) < ZERO
                       MOVE 'A' TO WD-A(K1)
                    ELSE
                       MOVE 'D' TO WD-A(K1)
                    END-IF
      ************
                 END-IF
              END-IF
              ADD 1 TO K
           END-PERFORM.
      * carica dati Scadenzario
           IF IF-FLGSC = ZERO GO TO LP110.
           MOVE 2        TO WFLAG.
           MOVE IF-CDPAG TO WCDPAG.
           MOVE IF-CDBAN TO WCDBAN.
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
              IF IF-SC-TPAG(K) NOT = ZERO
                 MOVE K TO WNRATE
                 MOVE IF-SC-TPAG(K)  TO WTPAG(K)
                 MOVE IF-SC-DTSCA(K) TO GGMMAA
                 MOVE 1 TO TIPOP1
                 CALL 'rdata' USING PARCDT
                 MOVE AAGGG           TO WDTSCA(K)
                                         WDTSCD
                 MOVE IF-SC-IMRATA(K) TO WIMRATA(K)
                 MOVE IF-SC-VALRAT(K) TO WVALRATA(K)
      **** rel 6.2
                 MOVE IF-SC-NOTE(K)   TO WNOTE(K)
                 MOVE IF-SC-NOTEA(K)  TO WNOTEA(K)
      ************
                 IF IF-DARAVE = 'D' OR (IF-DARAVE = 'A' AND SEGNO = 1)
                    MULTIPLY -1 BY WIMRATA(K) WVALRATA(K)
                 END-IF
              END-IF
              ADD 1 TO K
           END-PERFORM.
      **** rel 6.2
           PERFORM CONTROLLA-PAGAM-ANT THRU EX-CONTROLLA-PAGAM-ANT.
      ************
           MOVE ZERO TO K K1.
       LP105.
           ADD 1 TO K1.
           IF K1 > 12 GO TO LP110.
           ADD 1 TO K.
           IF K > 6 MOVE 6 TO K.
           IF WDTSCA(K1) = ZERO GO TO LP110.
           IF K1 > 6
              ADD WIMRATA(K1)  TO WISC(K)
              ADD WVALRATA(K1) TO WVSC(K)
           ELSE
              MOVE WDTSCA(K1)   TO WDSC(K)
              MOVE WVALRATA(K1) TO WVSC(K)
              MOVE WIMRATA(K1)  TO WISC(K).
           GO TO LP105.
       LP110.
      *
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID PERFORM INVK-AZI
                                                     GO TO ERRIO.
      **** rel 3.0
      *    IF SF-AZI NOT = ZERO GO TO LP110.
           IF SF-AZI NOT = ZERO PERFORM REC-LOCK
                                GO TO LP110.
      ************
      **** rel 2.0
           MOVE IF-AZI TO KPR-COD.
           READ PROAZI INVALID PERFORM INVK-PRA
                               GO TO ERRIO.
      ************
           MOVE IF-DATREG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO AZI-ULTDT.
           REWRITE RF-AZI FROM REKAZI INVALID GO TO ERRIO.
           UNLOCK ANAAZI.
           CLOSE TABELL
                 ANACLF
                 ANACON
                 MAGART
                 ANAAZI
      **** rel 2.0
                 PROAZI
      ************
                 BOLFTE
                 BOLFRI
      **** rel 1.2
      *          CAMGIO
      ************
                 CDCOST
      **** rel 5.2
                 WDS400
      ************
      **** rel 6.2
                 WDS185
      ************
                 TABRIT.
           MOVE SPACE TO SWOPN.
           IF IF-FL = 1
              MOVE 'OLD' TO PARM
           ELSE
              MOVE SPACE TO PARM.
      **** rel 5.0
           MOVE ZERO TO MNREG.
      ************
           CALL 'vcon113' USING SWOPN DTCON WRKLAV WRKSCA
      **** rel 5.0
      *                         PARM ID-AZI ID-CON ID-MOV.
                                PARM ID-AZI ID-CON ID-MOV MNREG.
      ************
           CANCEL 'vcon113'.
           IF NOT (ERRIO-ST = ZERO OR 8) GO TO ERRIO.
      *
           PERFORM AMM-00 THRU EX-AMM-00.

      **** rel 5.2
           MOVE SPACE TO IF-CAMPO2.
           IF IF-FL = ZERO
              PERFORM VER-FATT-DA-EM THRU EX-VER-FATT-DA-EM.

           OPEN I-O WDS400.
           PERFORM LANCIA-VCON400 THRU EX-LANCIA-VCON400.
           IF IF-HS-ATTRN = ZERO AND
              IF-HS-ACEE  = 1
              PERFORM LANCIA-VCON440 THRU EX-LANCIA-VCON440.
      ************
      **** rel 6.2
           OPEN I-O WDS185.
      ************
      *
           OPEN INPUT TABELL
                      ANACLF
                      ANACON
                      MAGART
                      CDCOST
                      TABRIT.
           OPEN  I-O  ANAAZI
      **** rel 2.0
                      PROAZI
      ************
                      BOLFTE
      **** rel 1.2
                      BOLFRI.
      *               BOLFRI
      *               CAMGIO.
      ************
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       PASSA-DATI-FISSI.
      * carica nell'area di working di vorf183 i dati fissi di controllo
           MOVE KAZ-COD  TO WW-AZI.
           MOVE IF-FOR   TO CB-FOR.
           MOVE IF-CATT  TO CB-CATT.
           MOVE IF-CDVAL TO CB-VALUT.
           MOVE IF-CAMGG TO CB-CAMGG.
           MOVE 'c' TO WW-FUN.
           CALL 'vorf183' USING WW-CTRL
                                IF-MESS
                                IF-VET
                                CB-DATI.
      *------------------
       CONV-DTP-A6.
           IF DTP = ZERO
              MOVE ZERO TO DTP6
           ELSE
              MOVE DTP TO DTP6
              MOVE AA61 TO AA62
              MOVE ZERO TO AA61
              CALL 'ranno4' USING AA6.
      *------------------
       CALC-IV-IMPON.
           MOVE ZERO TO IF-TOTIMPON.
      **** rel 5.2
           MOVE ZERO TO IF-TOTIMPOR
                        IF-TOTALE
                        IF-TOTIMPONV.
      ************
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              ADD IF-IV-IMPON(K) TO IF-TOTIMPON
      **** rel 5.2
              ADD IF-IV-IMPON(K) TO IF-TOTALE
              ADD IF-IV-IMPOR(K)       TO IF-TOTIMPOR IF-TOTALE
              ADD IF-ACEE-IV-IMPONV(K) TO IF-TOTIMPONV
      ************
              ADD 1 TO K
           END-PERFORM.
      *------------------
       CALC-IV-DIFF.
           MOVE IF-TOTDOC TO IF-DIFDOC.
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              SUBTRACT IF-IV-IMPON(K) FROM IF-DIFDOC
              SUBTRACT IF-IV-IMPOR(K) FROM IF-DIFDOC
              ADD 1 TO K
           END-PERFORM.
      **** rel 1.2
           IF CAUATTRN = ZERO
      **** rel 5.2
              IF IF-HS-ACEE NOT = 1
      ************
              MOVE ZERO TO IF-DIFDOC.
      ************
      *------------------
       CALC-SC-DIFF.
           MOVE ZERO TO IF-TOTSCA
                        IF-TOTSCAV.
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
              ADD IF-SC-IMRATA(K) TO IF-TOTSCA
              ADD IF-SC-VALRAT(K) TO IF-TOTSCAV
              ADD 1 TO K
           END-PERFORM.
           COMPUTE IF-DIFSCA  = IF-TOTDOC  - IF-TOTSCA.
           COMPUTE IF-DIFSCAV = IF-TOTDOCV - IF-TOTSCAV.
      *------------------
       CALC-CP-DIFF.
           MOVE IF-TOTIMPON TO IF-DIFIMPON.
           MOVE IF-TOTBOL   TO IF-DIFBOL.
      **** rel 6.2
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              ADD VIVA-INDEDUC(K) TO IF-DIFIMPON
              ADD 1 TO K
           END-PERFORM.
      ************
           MOVE 1 TO K.
      **** rel 6.1sm(CMO40)05/06/2015
      *    PERFORM UNTIL K > 15
           PERFORM UNTIL K > 16
      **** end rel 6.1sm(CMO40)05/06/2015
              SUBTRACT IF-CP-IMPON(K) FROM IF-DIFIMPON
              SUBTRACT IF-CP-IMPON(K) FROM IF-DIFBOL
              ADD 1 TO K
           END-PERFORM.
      **** rel 1.2
           IF CAUATTRN = ZERO
      **** rel 5.2
              IF IF-HS-ACEE = ZERO
      ************
              MOVE ZERO TO IF-DIFIMPON.
      ************
      *------------------
       CAL-CP-MAIN.
           PERFORM I00-AZZTOT THRU I99.
      **** rel 4.1a
      **** rel 5.2
           IF FUN NOT = 'm'
      ************
           PERFORM AZZ-CDPAG THRU END-AZZ-CDPAG.
      ************
           MOVE ZERO TO K1.
       CALBOL.
           ADD 1 TO K1.
      **** rel 5.0-2
      *    IF K1 > 50 GO TO EX-CAL-CP-MAIN.
           IF K1 > 100 GO TO EX-CAL-CP-MAIN.
      **************
      **** rel 6.1
      *    IF CHIBOL(K1) = ZERO GO TO EX-CAL-CP-MAIN.
           IF CHIBOL(K1) = ZERO
              IF K1 = 1    *> nessuna bolla selezionata
                 MOVE CLF-CPART TO IF-CP-COD(K1)
              END-IF
              GO TO EX-CAL-CP-MAIN.
      ************
       CALB10.
           MOVE KAZ-COD    TO KBF-AZI KFR-AZI.
           MOVE CHIBOL(K1) TO KBF-PRT KFR-PRT.
           READ BOLFTE INVALID PERFORM INVK-BFT GO TO ERRIO.
      **** rel 4.1a
      **** rel 5.2
           IF FUN NOT = 'm'
      ************
              MOVE BFT-CPAG TO CDPAG(K1).
      ************
           MOVE ZERO TO KFR-PRG.
           START BOLFRI KEY NOT < KEYFR INVALID GO TO CALB50.
       CALB20.
           READ BOLFRI NEXT AT END GO TO CALB50.
           IF SF-BFR = '9D' OR '9A' OR '35' GO TO CALB20.
           IF KFR-AZI NOT = KBF-AZI OR
              KFR-PRT NOT = KBF-PRT GO TO CALB50.
           MOVE ZERO TO CODCON.
           IF BFR-TPRIG = 1 GO TO CALB20.
      **** rel 5.2
      *    IF BFR-FLGFT NOT = ZERO GO TO CALB20.
      ************
           IF BFR-TPRIG NOT = 3 GO TO CALB25.
           MOVE 11        TO KTB-TIP.
           MOVE BFR-CDSPE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO CALB25.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T11-CONTR TO KPC-COD.
           MOVE KAZ-COD   TO KPC-AZI.
      **** rel 6.3
      *    READ ANACON INVALID GO TO CALB25.
      *    MOVE KPC-COD TO CODCON GO TO CALB40.
           READ ANACON INVALID GO TO CALB30.
           MOVE KPC-COD TO CODCON.
           IF CODCON NOT = ZERO GO TO CALB40.
           GO TO CALB30.
      ************
       CALB25.
           MOVE BFR-CPART TO KTB-COD.
           PERFORM Z00-CONTR THRU Z99.
           IF CODCON NOT = ZERO GO TO CALB40.
           MOVE BFT-CPART TO KTB-COD.
           PERFORM Z00-CONTR THRU Z99.
           IF CODCON NOT = ZERO GO TO CALB40.
           IF BFR-TPRIG NOT = ZERO GO TO CALB30.
           MOVE KAZ-COD    TO KMA-AZI.
           MOVE BFR-CODART TO KMA-ART.
           READ MAGART INTO REKART INVALID MOVE ZERO TO ART-CONTR.
           IF SF-ART = '9A' OR '35' OR '9D' MOVE RF-ART TO REKART.
      **** rel 6.1
      *    MOVE ART-CONTR TO KTB-COD.
      *    PERFORM Z00-CONTR THRU Z99.
           PERFORM CERCA-CONTR THRU EX-CERCA-CONTR.
      ************
           IF CODCON NOT = ZERO GO TO CALB40.
      **** rel 2.0
      **** rel 6.3
       CALB30.
      ************
           MOVE CLF-CPART TO CODCON.
           MOVE KAZ-COD   TO KPC-AZI.
           MOVE CODCON    TO KPC-COD.
           READ ANACON INVALID MOVE ZERO TO CODCON.
           IF CODCON NOT = ZERO GO TO CALB40.
      ************
      **** rel 6.3
      *CALB30.
      ************
           MOVE TABCPT TO KPC-COD CODCON.
           READ ANACON INVALID PERFORM INVK-CON GO TO ERRIO.
       CALB40.
           PERFORM L00-AGGTOT THRU L99.
           GO TO CALB20.
       CALB50.
           PERFORM A00-ASSTOT THRU A99.
           MOVE 1 TO SW-BOL.
      **** rel 6.3
           MOVE ZERO TO IF-KTRA-NOBOL.
      ************
           PERFORM I00-AZZTOT THRU I99.
           GO TO CALBOL.
       EX-CAL-CP-MAIN.
           EXIT.
      *------------------
      * Calcolo contropartite e sommatoria totali bolle
       A00-ASSTOT.
           MOVE ZERO TO K4.
       A001.
           ADD 1 TO K4.
           IF K4 > 15 MOVE ZERO TO K4 GO TO A009.
           IF BOLCON(K4) = ZERO MOVE ZERO TO K4 GO TO A009.
      **** rel 5.2
      **** rel 6.0a
      *    IF FUN = 'm' GO TO A003.
      *************
      ************
           MOVE ZERO TO K2.
       A002.
           ADD 1 TO K2.
           IF K2 > 15 MOVE 15 TO K2.
           IF IF-CP-COD(K2) = ZERO
              MOVE BOLCON(K4) TO IF-CP-COD(K2)
              MOVE BOLTOT(K4) TO IF-CP-IMPON(K2)
              MOVE BOLTVA(K4) TO VALPVA(K2)
              GO TO A003.
           IF IF-CP-COD(K2) = BOLCON(K4)
              ADD BOLTOT(K4) TO IF-CP-IMPON(K2)
              ADD BOLTVA(K4) TO VALPVA(K2)
              GO TO A003.
           IF K2 = 15
              ADD BOLTOT(K4) TO IF-CP-IMPON(K2)
              ADD BOLTVA(K4) TO VALPVA(K2)
              GO TO A003.
           GO TO A002.
       A003.
           ADD BOLTOT(K4) TO IF-TOTBOL.
           ADD BOLTVA(K4) TO TOTCVA.
           GO TO A001.
       A009.
           ADD 1 TO K4.
           IF K4 > 15 GO TO A99.
           IF BOLCON(K4) = ZERO GO TO A99.
           MOVE ZERO TO BOLCON(K4) BOLTOT(K4) BOLTVA(K4).
           GO TO A009.
       A99.
           EXIT.
      *------------------
       I00-AZZTOT.
           MOVE ZERO TO K4.
       I10.
           ADD 1 TO K4.
           IF K4 > 15 GO TO I99.
           MOVE ZERO TO BOLCON(K4) BOLTOT(K4) BOLTVA(K4).
           GO TO I10.
       I99.
           EXIT.
      *------------------
      * calcolo contropartite di una bolla
       L00-AGGTOT.
           MOVE ZERO TO K4.
       L10.
           ADD 1 TO K4.
           IF K4 > 15 MOVE 15 TO K4.
      **** rel 4.0
      *    IF BFT-VALUT > 1
           IF NOT (BFT-VALUT = ZERO OR CODEURO)
      ************
      **** rel 1.2
      **** rel 5.2
      *       MOVE BFR-NETRG TO ER-IMPORTO
              IF FUN NOT = 'm'
                 MOVE BFR-NETRG TO ER-IMPORTO
              ELSE
                 MOVE BFR-VALFA TO ER-IMPORTO
              END-IF
      ************
              MOVE IF-CAMGG  TO ER-CAMBIO
      **** rel 4.0
      *       MOVE DTCON     TO ER-DATA
      ************
              MOVE BFT-VALUT TO ER-VALUT
      **** rel 4.0
      *       CALL 'rcamimp' USING ER-IMPORTO VAL-LIR ER-VALUT
      *                            ER-CAMBIO  ER-DATA
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT
                                  ER-CAMBIO
      ************
              MOVE ER-IMPORTO TO COMODO
      **** rel 5.2
      *       MOVE BFR-NETRG TO COMVA1.
              IF FUN NOT = 'm'
                 MOVE BFR-NETRG TO COMVA1
              ELSE
                 MOVE BFR-VALFA TO COMVA1.
      ************
      *       COMPUTE RD-NUM = BFR-NETRG * IF-CAMGG
      *       CALL 'vrround' USING NNN-S PARRD DEC-0
      *       MOVE RD-NUM TO COMODO
      *       MOVE BFR-NETRG TO COMVA1.
      ************
           IF BOLCON(K4) = ZERO
              MOVE CODCON TO BOLCON(K4)
      **** rel 4.0
      *       IF BFT-VALUT NOT > 1
              IF BFT-VALUT = ZERO OR CODEURO
      ************
      **** rel 5.2
      *          MOVE BFR-NETRG TO BOLTOT(K4)
                 IF FUN NOT = 'm'
                    MOVE BFR-NETRG TO BOLTOT(K4)
                 ELSE
                    MOVE BFR-VALFA TO BOLTOT(K4)
                 END-IF
      ************
                 GO TO L99
              ELSE
                 MOVE COMVA1 TO BOLTVA(K4)
                 MOVE COMODO TO BOLTOT(K4)
                 GO TO L99.
           IF BOLCON(K4) = CODCON
      **** rel 4.0
      *       IF BFT-VALUT NOT > 1
              IF BFT-VALUT = ZERO OR CODEURO
      ************
      **** rel 5.2
      *          ADD BFR-NETRG TO BOLTOT(K4)
                 IF FUN NOT = 'm'
                    ADD BFR-NETRG TO BOLTOT(K4)
                 ELSE
                    ADD BFR-VALFA TO BOLTOT(K4)
                 END-IF
      ************
                 GO TO L99
              ELSE
                 ADD COMVA1 TO BOLTVA(K4)
                 ADD COMODO TO BOLTOT(K4)
                 GO TO L99.
           IF K4 = 15
      **** rel 4.0
      *       IF BFT-VALUT NOT > 1
              IF BFT-VALUT = ZERO OR CODEURO
      ************
      **** rel 5.2
      *          ADD BFR-NETRG TO BOLTOT(K4)
                 IF FUN NOT = 'm'
                    ADD BFR-NETRG TO BOLTOT(K4)
                 ELSE
                    ADD BFR-VALFA TO BOLTOT(K4)
                 END-IF
      ************
                 GO TO L99
              ELSE
                 ADD COMVA1 TO BOLTVA(K4)
                 ADD COMODO TO BOLTOT(K4)
                 GO TO L99.
           GO TO L10.
       L99.
           EXIT.
      *------------------
       Z00-CONTR.
           MOVE 21 TO KTB-TIP.
           READ TABELL INTO REKT21 INVALID MOVE ZERO TO T21-CPART.
           IF SF-TAB = '9A' OR '35' OR '9D' MOVE RF-TAB TO REKT21.
           MOVE KAZ-COD   TO KPC-AZI.
           MOVE T21-CPART TO KPC-COD CODCON.
           READ ANACON INVALID MOVE ZERO TO CODCON.
       Z99.
           EXIT.
      *------------------
       AZZ-IF-IVA.
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              MOVE ZERO  TO IF-IV-COD(K)
                            IF-IV-IMPON(K)
      **** rel 5.2
                            IF-ACEE-IV-IMPONV(K)
      ************
                            IF-IV-IMPOR(K)
              MOVE SPACE TO IF-IV-DESCR(K)
              ADD 1 TO K
           END-PERFORM.
      *------------------
       AZZ-IF-CPAR.
           MOVE 1 TO K.
           PERFORM UNTIL K > 15
              MOVE ZERO  TO IF-CP-COD(K)
                            IF-CP-IMPON(K)
                            IF-CP-FLCOSZ(K)
              MOVE SPACE TO IF-CP-DESCR(K)
      **** rel 6.2
                            IF-CP-DESAG(K)
      ************
                            IF-CP-CCOST(K)
              ADD 1 TO K
           END-PERFORM.
      *------------------
       AZZ-IF-SCA.
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
              MOVE ZERO  TO IF-SC-TPAG(K)
                            IF-SC-DTSCA(K)
                            IF-SC-IMRATA(K)
                            IF-SC-VALRAT(K)
      **** rel 6.2
              MOVE SPACE TO IF-SC-NOTE(K)
                            IF-SC-NOTEA(K)
      ************
              ADD 1 TO K
           END-PERFORM.
      *------------------
      **** rel 5.2
       AZZ-IF-INTRA.
      **** rel 7.1
           INITIALIZE IF-INTRA.
      ************
           MOVE 1 TO K.
           PERFORM UNTIL K > 10
              MOVE ZERO  TO IF-TR-NOMME(K)
                            IF-TR-IMPAGG(K)
                            IF-TR-IMPBOL(K)
              ADD 1 TO K
           END-PERFORM.
      *------------------
      ************
       RSCAD.
           PERFORM AZZ-IF-SCA.
           IF T04-1SCAD >= 3 AND IF-1SCAD = ZERO GO TO EX-RSCAD.
           MOVE ZERO TO TOTIVA.
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              ADD IF-IV-IMPOR(K) TO TOTIVA
              ADD 1 TO K
           END-PERFORM.
           IF T04-1SCAD < 3
              MOVE IF-DATDOC TO GGMMAA
           ELSE
              MOVE IF-1SCAD  TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO W-DTSCA.
           IF T04-1SCAD NOT = ZERO GO TO RCAL1.
       FORSE0.
           MOVE 20 TO NUMGG.
           CALL 'radd30' USING W-DTSCA NUMGG.
       RCAL1.
           PERFORM RCALR THRU EX-RCALR.
           MOVE ZERO TO K.
       LOOPR1.
           ADD 1 TO K.
           IF K > T04-NRATE GO TO FINEL1.
           IF T04-FLGIVA = ZERO OR 2
              IF K = 1
                 MOVE T04-NG1SC TO NUMGG
              ELSE
                 MOVE T04-NGSSC TO NUMGG.
           IF T04-FLGIVA = 1
              IF K = 1
                 MOVE T04-NGIVA TO NUMGG
              ELSE
                 IF K = 2
                    MOVE T04-NG1SC TO NUMGG
                    IF T04-1SCAD < 3
                       MOVE IF-DATDOC TO GGMMAA
                    ELSE
                       MOVE IF-1SCAD  TO GGMMAA
                    END-IF
                    MOVE 1 TO TIPOP1
                    CALL 'rdata' USING PARCDT
                    MOVE AAGGG TO W-DTSCA
                 ELSE
                    MOVE T04-NGSSC TO NUMGG.
           CALL 'radd30' USING W-DTSCA NUMGG.
           MOVE W-DTSCA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-SC-DTSCA(K).
           MOVE T04-TIPAG TO IF-SC-TPAG(K).
           GO TO LOOPR1.
       FINEL1.
           MOVE ZERO TO K.
       LOOPR2.
           ADD 1 TO K.
           IF K > T04-NRATE GO TO FINEL2.
           IF IF-SC-DTSCA(K) = ZERO GO TO FINEL2.
           IF T04-1SCAD = 2 OR T04-1SCAD = 4 GO TO XCONT.
           GO TO FINEL2.
       XCONT.
           MOVE IF-SC-DTSCA(K) TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           DIVIDE AA9 BY 4 GIVING CLAV1 REMAINDER CLAV2.
           IF CLAV2 = ZERO
              MOVE 29 TO GIO(2)
           ELSE
              MOVE 28 TO GIO(2).
           MOVE GIO(MM9) TO GG9.
           MOVE GGMMAA TO IF-SC-DTSCA(K).
           GO TO LOOPR2.
       FINEL2.
           IF GSFM NOT = ZERO PERFORM SOMMA-GG THRU EX-SOMMA-GG.
      **** rel 6.0
      *    IF T04-ESCMM = ZERO GO TO EX-RSCAD.
           MOVE ZERO TO FLGMCL.
           MOVE 1 TO K.
       VPG.
           IF K > 12 GO TO VPG1.
           IF RACF-ESCM(K) = ZERO
              ADD 1 TO K
              GO TO VPG.
           MOVE 1 TO FLGMCL.
           GO TO VPG4.
      *
       VPG1.
           MOVE 1 TO K.
       VPG2.
           IF K > 12 GO TO VPG3.
           IF T04-ESCM(K) = ZERO
              ADD 1 TO K
              GO TO VPG2.
           GO TO VPG4.
       VPG3.
           GO TO EX-RSCAD.
       VPG4.
      ************
           MOVE ZERO TO K.
       LOOPR3.
           ADD 1 TO K.
           IF K > T04-NRATE GO TO EX-RSCAD.
           MOVE IF-SC-DTSCA(K) TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      **** rel 6.0
      *    IF MM9 NOT = 8 GO TO FORI2.
      *    IF T04-ESCMM = 1 OR T04-ESCMM = 3 GO TO LPMOV.
           IF (FLGMCL = 1 AND RACF-ESCM(MM9) = 1) OR
              (FLGMCL = ZERO AND T04-ESCM(MM9) = 1)
                 GO TO LPMOV.
      ************
           GO TO LOOPR3.
       LPMOV.
      **** rel 2.0
      *    MOVE GGESC TO GG9.
           IF GSESC NOT = ZERO
              MOVE GSESC TO GG9
           ELSE
              MOVE GGESC TO GG9.
      ************
           IF GG9 > 30 MOVE 30 TO GG9.
      **** rel 6.0
      *    MOVE 9 TO MM9.
      *    GO TO XDATA.
      *FORI2.
      *    IF MM9 NOT = 12 GO TO LOOPR3.
      *    IF T04-ESCMM = 2 GO TO LPMOV1.
      *    IF T04-ESCMM = 3 GO TO LPMOV1.
      *    GO TO LOOPR3.
      ************
       LPMOV1.
      **** rel 2.0
      *    MOVE GGESC TO GG9.
      **** rel 6.0
      *    IF GSESC NOT = ZERO
      *       MOVE GSESC TO GG9
      *    ELSE
      *       MOVE GGESC TO GG9.
      ************
      ************
      **** rel 6.0
      *    MOVE 1 TO MM9.
      *    ADD 1 TO AA9.
      *XDATA.
           IF MM9 = 12
              MOVE 1 TO MM9
              ADD 1  TO AA9
           ELSE
              ADD 1 TO MM9.

           IF (FLGMCL = 1 AND RACF-ESCM(MM9) = 1) OR
              (FLGMCL = ZERO AND T04-ESCM(MM9) = 1)
                 GO TO LPMOV1.

      ************
           MOVE GGMMAA TO IF-SC-DTSCA(K).
           GO TO LOOPR3.
       EX-RSCAD.
           EXIT.
      *------------------
       RCALR.
      **** rel 1.2
           MOVE ZERO TO TOTIVV.
      **** rel 4.0
      *    IF BFT-VALUT > 1
           IF NOT (BFT-VALUT = ZERO OR CODEURO)
      ************
              MOVE TOTIVA TO ER-IMPORTO
              MOVE IF-CAMGG  TO ER-CAMBIO
      **** rel 4.0
      *       MOVE DTCON     TO ER-DATA
      ************
              MOVE BFT-VALUT TO ER-VALUT
      **** rel 4.0
      *       CALL 'rcamimp' USING ER-IMPORTO LIR-VAL ER-VALUT
      *                            ER-CAMBIO  ER-DATA
              CALL 're2imp' USING ER-IMPORTO EUR-VAL ER-VALUT
                                  ER-CAMBIO
      ************
              MOVE ER-IMPORTO TO TOTIVV.
      ************
           IF T04-FLGIVA = ZERO GO TO CALR1.
           IF TOTIVA     = ZERO GO TO CALR1.
           IF T04-FLGIVA = 1 PERFORM RCALR1 THRU EX-RCALR1
                             GO TO EX-RCALR.
           IF T04-FLGIVA = 2 PERFORM RCALR2 THRU EX-RCALR2
                             GO TO EX-RCALR.
       CALR1.
           MOVE IF-TOTDOC TO COMFAT.
           COMPUTE COMR = COMFAT / T04-NRATE.
           COMPUTE COM1 = T04-NRATE - 1.
           COMPUTE COMUR = COMFAT - (COMR * COM1).
           MOVE ZERO TO K.
           IF IF-TOTDOCV = ZERO GO TO LCALR.
           MOVE IF-TOTDOCV TO COMFTV.
           COMPUTE COMRV = COMFTV / T04-NRATE.
           COMPUTE COM2  = T04-NRATE - 1.
           COMPUTE COMURV = COMFTV - (COMRV * COM2).
       LCALR.
           ADD 1 TO K.
           IF K > T04-NRATE MOVE ZERO TO K GO TO LCALV.
           MOVE COMUR TO IF-SC-IMRATA(K).
           IF K < T04-NRATE
              MOVE COMR TO IF-SC-IMRATA(K).
           GO TO LCALR.
       LCALV.
           IF IF-TOTDOCV = ZERO GO TO EX-RCALR.
           ADD 1 TO K.
           IF K > T04-NRATE GO TO EX-RCALR.
           MOVE COMURV TO IF-SC-VALRAT(K).
           IF K < T04-NRATE
              MOVE COMRV TO IF-SC-VALRAT(K).
           GO TO LCALV.
       EX-RCALR.
           EXIT.
      *------------------
       RCALR1.
           COMPUTE COMFAT = IF-TOTDOC - TOTIVA.
           COMPUTE COMR = COMFAT / ( T04-NRATE - 1 ).
           COMPUTE COM1 = T04-NRATE - 2.
           COMPUTE COMUR = COMFAT - (COMR * COM1).
      **** rel 1.2
           COMPUTE COMFTV = IF-TOTDOCV - TOTIVV.
           COMPUTE COMRV = COMFTV / ( T04-NRATE - 1 ).
           COMPUTE COMURV = COMFTV - (COMRV * COM1).
      ************
           MOVE ZERO TO K.
       LCALR1.
           ADD 1 TO K.
           IF K > T04-NRATE GO TO EX-RCALR1.
      **** rel 1.2
      *    IF K = 1 MOVE TOTIVA TO IF-SC-IMRATA(K) GO TO LCALR1.
           IF K = 1 MOVE TOTIVA TO IF-SC-IMRATA(K)
                    MOVE TOTIVV TO IF-SC-VALRAT(K)
                    GO TO LCALR1.
      ************
           MOVE COMUR TO IF-SC-IMRATA(K).
      **** rel 1.2
           MOVE COMURV TO IF-SC-VALRAT(K).
      ************
           IF K < T04-NRATE
      **** rel 1.2
      *       MOVE COMR TO IF-SC-IMRATA (K).
              MOVE COMR  TO IF-SC-IMRATA (K)
              MOVE COMRV TO IF-SC-VALRAT (K).
      ************
           GO TO LCALR1.
       EX-RCALR1.
           EXIT.
      *------------------
       RCALR2.
           COMPUTE COMFAT = IF-TOTDOC - TOTIVA.
           COMPUTE COMR = COMFAT / T04-NRATE.
           COMPUTE COM1 = T04-NRATE - 1.
           COMPUTE COMUR = COMFAT - (COMR * COM1).
      **** rel 1.2
           COMPUTE COMFTV = IF-TOTDOCV - TOTIVV.
           COMPUTE COMRV = COMFTV / T04-NRATE.
           COMPUTE COMURV = COMFTV - (COMRV * COM1).
      ************
           MOVE ZERO TO K.
       LCALR2.
           ADD 1 TO K.
           IF K > T04-NRATE GO TO EX-RCALR2.
           IF K = 1
              COMPUTE IF-SC-IMRATA(1) = COMR + TOTIVA
      **** rel 1.2
              COMPUTE IF-SC-VALRAT(1) = COMRV + TOTIVV
      ************
              GO TO LCALR2.
           MOVE COMUR TO IF-SC-IMRATA(K).
      **** rel 1.2
           MOVE COMURV TO IF-SC-VALRAT(K).
      ************
           IF K < T04-NRATE
      **** rel 1.2
      *       MOVE COMR TO IF-SC-IMRATA(K).
              MOVE COMR  TO IF-SC-IMRATA(K)
              MOVE COMRV TO IF-SC-VALRAT(K).
      ************
           GO TO LCALR2.
       EX-RCALR2.
           EXIT.
      *------------------
      **** rel 1.2
      * ricalcola importi rate scadenzario carico
      * in Lire tramite triangolazione
      **** rel 4.0
      *RICAL-IMPSCA-LIRE.
       RICAL-IMPSCA-EURO.
      ************
           MOVE ZERO TO TIMRATA.
           MOVE ZERO TO K.
       RICAL-10.
           ADD 1 TO K.
           IF K > 12 GO TO RICAL-90.
           IF IF-SC-VALRAT(K) = ZERO GO TO RICAL-90.
           MOVE IF-SC-VALRAT(K) TO ER-IMPORTO.
           MOVE IF-CAMGG        TO ER-CAMBIO.
      **** rel 4.0
      *    MOVE DTCON           TO ER-DATA.
      ************
           MOVE IF-CDVAL        TO ER-VALUT.
      **** rel 4.0
      *    CALL 'rcamimp' USING ER-IMPORTO VAL-LIR ER-VALUT
      *                         ER-CAMBIO  ER-DATA.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT
                               ER-CAMBIO.
      ************
           MOVE ER-IMPORTO TO IF-SC-IMRATA(K).
           ADD  ER-IMPORTO TO TIMRATA.
           GO TO RICAL-10.
       RICAL-90.
      * carica su ultima scadenza la eventuale differenza
           IF K > 1 SUBTRACT 1 FROM K.
           COMPUTE IF-SC-IMRATA(K) = IF-SC-IMRATA(K) + IF-TOTDOC
                                     - TIMRATA.
      **** rel 4.0
      *EX-RICAL-IMPSCA-LIRE.
       EX-RICAL-IMPSCA-EURO.
      ************
           EXIT.
      *------------------
      ************
       E00-AGG-BOL.
           MOVE ZERO TO K.
       E10.
           ADD 1 TO K.
      **** rel 5.0-2
      *    IF K > 50 GO TO E99.
           IF K > 100 GO TO E99.
      **************
           IF CHIBOL(K) = ZERO GO TO E10.
           MOVE IF-AZI    TO KBF-AZI KFR-AZI.
           MOVE CHIBOL(K) TO KBF-PRT KFR-PRT.
       E20.
           READ BOLFTE KEPT LOCK INVALID PERFORM INVK-BFT
                                         GO TO ERRIO.
           IF SF-BFT NOT = ZERO PERFORM REC-LOCK
                                GO TO E20.
           MOVE ZERO TO KFR-PRG SW-AGG.
           START BOLFRI KEY NOT < KEYFR INVALID GO TO E90.
       E30.
           READ BOLFRI NEXT KEPT LOCK AT END GO TO E90.
           IF SF-BFR NOT = ZERO PERFORM REC-LOCK
                                GO TO E30.
           IF KFR-AZI NOT = KBF-AZI OR
              KFR-PRT NOT = KBF-PRT UNLOCK BOLFRI GO TO E90.
           MOVE BFR-QUANT TO BFR-QUAFA.
           MOVE BFR-NETRG TO BFR-VALFA.
           MOVE 2 TO BFR-FLGFT.
           REWRITE RF-BFR INVALID PERFORM INVK-BFR
                                  GO TO ERRIO.
           UNLOCK BOLFRI.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BFR.
      ************
           MOVE 1 TO SW-AGG.
           GO TO E30.
       E90.
           IF SW-AGG = 1 MOVE 2 TO BFT-FLGFT.
      **** rel 3.0
           MOVE IF-PRGIVA TO BFT-NFAT.
      ************
      **** rel 6.2
           IF IF-HS-ATTRN = ZERO AND IF-HS-ACEE  = 1
              IF (IF-PRGIVA = ZERO) AND (IF-ACEE-NPRGIA NOT = ZERO)
                 MOVE IF-ACEE-NPRGIA TO BFT-NFAT.
      ************
           REWRITE RF-BFT INVALID PERFORM INVK-BFT
                                  GO TO ERRIO.
      **** rel 6.1
           PERFORM AGGIORNA-ABF THRU EX-AGGIORNA-ABF.
      ************
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BFT.
      ************
           UNLOCK BOLFTE.
           GO TO E10.
       E99.
           EXIT.
      *------------------
       CALC-IMPOR-IVA.
      **** rel 4.0
      *    COMPUTE CIMPIVA = IF-IV-IMPON(K) * T03-ALIVA / 100 + 0,99.
           MOVE IF-IV-IMPON(K) TO ER-IMPORTO.
           MOVE ZERO           TO ER-VALUT.
           CALL 're2iva' USING ER-IMPORTO ER-VALUT T03-ALIVA.
           MOVE ER-IMPORTO TO CIMPIVA.
      ************
           IF FUN = 'w' AND CIMPIVA NOT = IF-IV-IMPOR(K)
              MOVE 1 TO SWIVA
           ELSE
              MOVE CIMPIVA TO IF-IV-IMPOR(K).
      **** rel 7.1
           PERFORM CALC-IMPOR-IVA-IND.
      *------------------
       CALC-IMPOR-IVA-IND.
      ************
      **** rel 6.2
      * iva indeducibile
           MOVE ZERO TO VIVA-INDEDUC(K).
      **** rel 7.1
      *    IF T03-TPIVA = 1 MOVE CIMPIVA TO VIVA-INDEDUC(K).
           IF T03-TPIVA = 1 MOVE IF-IV-IMPOR(K) TO VIVA-INDEDUC(K).
      ************
           IF T03-TPIVA = 7
      **** rel 7.1
      *       MOVE CIMPIVA    TO ER-IMPORTO
              MOVE IF-IV-IMPOR(K) TO ER-IMPORTO
      ************
              MOVE ZERO       TO ER-VALUT
      **** rel 6.2
      *       MOVE 50         TO PERC
              MOVE T03-PERIVA TO PERC
              IF PERC = ZERO MOVE 50 TO PERC
              END-IF
      ************
              CALL 're2iva' USING ER-IMPORTO ER-VALUT PERC
              MOVE ER-IMPORTO TO VIVA-INDEDUC(K).
      ************
      *------------------
       REC-LOCK.
      **** rel 1.2
           CALL 'rlock' USING PARLK.
      ************
           EXIT.
      *------------------
       SOMMA-GG.
           IF NOT ( T04-1SCAD = 2 OR 4 ) GO TO EX-SOMMA-GG.
           MOVE ZERO TO K.
       SOM10.
           ADD 1 TO K.
           IF K > T04-NRATE GO TO EX-SOMMA-GG.
           IF IF-SC-DTSCA (K) = ZERO GO TO EX-SOMMA-GG.
           MOVE IF-SC-DTSCA(K) TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           ADD CLF-GSFM TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-SC-DTSCA(K).
           GO TO SOM10.
       EX-SOMMA-GG.
           EXIT.
      *------------------
       AMM-00.
           OPEN OUTPUT WDS135.
           CLOSE WDS135.
           OPEN I-O WDS135.
      *
           MOVE ZERO TO K135-PROG.
           IF FLAMM = ZERO GO TO AMM-99.
      **** rel 6.2
      * serve ad interfaccia per abilitare aggancio ai cespiti
      *    MOVE 'AMM-SI' TO IF-CAMPO.
      ************
      *
           MOVE KAZ-COD TO L135-CDAZ.
           MOVE AZRGSOC TO L135-DAZI.
           MOVE ZERO TO K1.
       AMM-05.
           OPEN INPUT TABELL ANACON TACOAM.
       AMM-10.
           ADD 1 TO K1.
           IF K1 > 8 GO TO AMM-95.
           IF WCOR (K1) = ZERO GO TO AMM-95.
           MOVE WCOR (K1) TO WCORP.
           MOVE WPART TO L135-WPART.
      **** rel 6.3
      *    MOVE WNDOC TO L135-WNPRGI L135-WDOCUM.
           MOVE WNDOC TO L135-WDOCUM.
           MOVE IF-PRGIVA TO L135-WNPRGI.
           IF IF-HS-ATTRN = ZERO AND IF-HS-ACEE  = 1
              IF (IF-PRGIVA = ZERO) AND (IF-ACEE-NPRGIA NOT = ZERO)
                 MOVE IF-ACEE-NPRGIA TO L135-WNPRGI.
      ************
      *
           MOVE WDATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      **** rel 6.1
      *    MOVE GGMMAA TO L135-DTCON L135-WDTDOC.
           MOVE GGMMAA TO L135-WDTDOC.

           MOVE IF-DATREG TO L135-DTCON.
      ************
      *

           MOVE WCAUS TO L135-WCAUSA.
      *
           MOVE 2           TO KTB-TIP.
           MOVE L135-WCAUSA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO AMM-10.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T02-TIPRG TO L135-WTIPRG.
           MOVE T02-SEGNO TO L135-WSEGNO.
           MOVE T02-TIPOP TO L135-WTIPOP.
      *
           MOVE ZERO TO K.
       AMM-20.
           ADD 1 TO K.
           MOVE ZERO  TO L135-WCPART(K)
                         L135-WIMPCP(K)
                         L135-WCAUS2(K).
           MOVE SPACE TO L135-DCON(K).
           IF K < 15 GO TO AMM-20.
           MOVE ZERO TO K IND2.
       AMM-30.
           ADD 1 TO IND2.
           IF IND2 > 6 GO TO AMM-90.
      **** rel 6.3
      *    IF WIMP(IND2) = ZERO GO TO AMM-30.
           IF WIMP(IND2) = ZERO
              IF IF-HS-ATTRN = ZERO AND
                 IF-HS-ACEE  = 1
                    IF (CAUATTRN = ZERO AND WIVA(IND2)) OR
                       (CAUATTRN NOT = ZERO AND WIMP(IND2))
                           GO TO AMM-30
                    END-IF
              ELSE
                 GO TO AMM-30.
      ************
           IF WCON(IND2) = ZERO GO TO AMM-30.
           MOVE KAZ-COD TO KPC-AZI TAC-AZI.
           MOVE WCON(IND2) TO KPC-COD TAC-CONTO.
           READ ANACON INVALID GO TO AMM-30.
           READ TACOAM KEY KEYTC2 INVALID GO TO AMM-30.
           ADD 1 TO K.
           MOVE WCON(IND2) TO L135-WCPART(K).
      **** rel 6.3
      *    MOVE WIMP(IND2) TO L135-WIMPCP(K).
           IF IF-HS-ATTRN = ZERO AND
              IF-HS-ACEE  = 1
                 IF CAUATTRN = ZERO
                    MOVE WIVA(IND2) TO L135-WIMPCP(K)
                 ELSE
                    MOVE WIMP(IND2) TO L135-WIMPCP(K)
                 END-IF
           ELSE
               MOVE WIMP(IND2) TO L135-WIMPCP(K).
      ************
           MOVE CON-DSC    TO L135-DCON(K).
           GO TO AMM-30.
       AMM-90.
           IF K = ZERO GO TO AMM-10.
           CLOSE TABELL ANACON TACOAM.
           ADD 1 TO K135-PROG.
           WRITE RF-135 INVALID PERFORM INVK-135
                                CLOSE WDS135
                                GO TO ERRIO.
      **** rel 6.2
      * serve ad interfaccia per abilitare aggancio ai cespiti
      **** rel 6.2
      *    MOVE 'AMM-SI' TO IF-CAMPO.
      ************
      ************
      **** rel 6.3
      **** rel 6.2
      * serve ad interfaccia per abilitare aggancio ai cespiti
      *    IF AZI-FLAMM NOT = ZERO
      *       MOVE 1 TO FLGAMM.
      ************
      ************
           GO TO AMM-05.
       AMM-95.
           CLOSE TABELL ANACON TACOAM.
       AMM-99.
      **** rel 6.3
      * serve ad interfaccia per abilitare aggancio ai cespiti
           IF AZI-FLAMM NOT = ZERO
              MOVE 1 TO FLGAMM.
      ************
           CLOSE WDS135.
      *
       EX-AMM-00.
           EXIT.
      *------------------
       LEGG-TIPO-CONTO.
           MOVE KAZ-COD TO KPC-AZI.
           READ ANACON INTO REKCON INVALID
                MOVE ZERO TO CON-TIPO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-135.
           STRING 'wz' PID DELIMITED SPACE INTO ID-135.
      **** rel 5.2
           MOVE SPACE TO ID-400.
           STRING 'w3' PID DELIMITED SPACE INTO ID-400.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
           MOVE SPACE TO ID-LA3.
           STRING 'wh' PID DELIMITED SPACE INTO ID-LA3.
      ************
      **** rel 6.2
           MOVE SPACE TO ID-AFT ID-AFR.
           STRING 'wt' PID DELIMITED SPACE INTO ID-AFT.
           STRING 'wr' PID DELIMITED SPACE INTO ID-AFR.
           MOVE SPACE TO ID-185.
           STRING 'w4' PID DELIMITED SPACE INTO ID-185.
      ************
       EX-CREA-IDLAV.
           EXIT.
      *------------------
      **** rel 4.1a
       AZZ-CDPAG.
           MOVE ZERO TO K1.
       A10.
           ADD 1 TO K1.
      **** rel 5.0-2
      *    IF K1 > 50 GO TO END-AZZ-CDPAG.
           IF K1 > 100 GO TO END-AZZ-CDPAG.
      **************
           MOVE ZERO TO CDPAG(K1).
           GO TO A10.
       END-AZZ-CDPAG.
           EXIT.
      *------------------
       CONTROLLA-CDPAG.
           MOVE ZERO TO FLGCP.
           MOVE 1 TO K.
       C10.
           ADD 1 TO K.
      **** rel 5.0-2
      *    IF K > 50 GO TO END-CONTROLLA-CDPAG.
           IF K > 100 GO TO END-CONTROLLA-CDPAG.
      **************
           IF CDPAG(K) = ZERO GO TO END-CONTROLLA-CDPAG.
           IF CDPAG(K) = CDPAG(1) GO TO C10.
           MOVE '     PAGAMENTI DIFFERENTI !       ' TO F-MES1.
           MOVE 'Verra'' proposto il cod. pagamento' TO F-MES3.
           MOVE 'dell''anagrafica fornitore.       ' TO F-MES4.
           MOVE 4 TO F-NMES
           CALL 'vrmbox' USING PARMB.
           MOVE 1 TO FLGCP.
       END-CONTROLLA-CDPAG.
           EXIT.
      *------------------
      ************
      **** rel 5.2
       SCRIVI-APPOGGIO.
           IF CHIBOL(KF1) = ZERO GO TO EX-SCRIVI-APPOGGIO.
           MOVE RF-BFT TO RF-AFT.
           WRITE RF-AFT INVALID GO TO EX-SCRIVI-APPOGGIO.

           MOVE KBF-AZI TO KFR-AZI.
           MOVE KBF-PRT TO KFR-PRT.
           MOVE ZERO    TO KFR-PRG.
           START BOLFRI KEY NOT < KEYFR INVALID GO TO VALFAT.
       RD-BFR.
           READ BOLFRI NEXT AT END GO TO VALFAT.
           IF SF-BFR = '9D' OR '9A' OR '35' GO TO RD-BFR.
           IF KFR-AZI NOT = KBF-AZI OR
              KFR-PRT NOT = KBF-PRT GO TO VALFAT.
           MOVE RF-BFR TO RF-AFR.
           WRITE RF-AFR INVALID GO TO RD-BFR.
           GO TO RD-BFR.
      *
       VALFAT.
           MOVE IF-AZI      TO KBF-AZI KFR-AZI.
           MOVE CHIBOL(KF1) TO KBF-PRT KFR-PRT.
       RDNX-TES.
           READ BOLFTE KEPT LOCK INVALID PERFORM INVK-BFT
                                         GO TO ERRIO.
           IF SF-BFT NOT = ZERO PERFORM REC-LOCK
                                GO TO RDNX-TES.
           MOVE ZERO TO KFR-PRG SW-AGG.
           START BOLFRI KEY NOT < KEYFR INVALID
                                        GO TO END-BFR.
       RDNX.
           READ BOLFRI NEXT KEPT LOCK AT END GO TO END-BFR.
           IF SF-BFR NOT = ZERO PERFORM REC-LOCK
                                GO TO RDNX.
           IF KFR-AZI NOT = KBF-AZI OR
              KFR-PRT NOT = KBF-PRT UNLOCK BOLFRI
                                    GO TO END-BFR.
           MOVE BFR-QUANT TO BFR-QUAFA.
           MOVE BFR-NETRG TO BFR-VALFA.
           MOVE 2 TO BFR-FLGFT.
           REWRITE RF-BFR INVALID PERFORM INVK-BFR
                                  GO TO ERRIO.
           UNLOCK BOLFRI.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BFR.
      ************
           MOVE 1 TO SW-AGG.
           GO TO RDNX.
       END-BFR.
           IF SW-AGG = 1 MOVE 2 TO BFT-FLGFT.
           MOVE IF-PRGIVA TO BFT-NFAT.
      **** rel 6.2
      *
           IF IF-HS-ATTRN = ZERO AND IF-HS-ACEE  = 1
              IF (IF-PRGIVA = ZERO) AND (IF-ACEE-NPRGIA NOT = ZERO)
                 MOVE IF-ACEE-NPRGIA TO BFT-NFAT.
      ************
      **** rel 6.1
           PERFORM AGGIORNA-ABF THRU EX-AGGIORNA-ABF.
      ************
           REWRITE RF-BFT INVALID PERFORM INVK-BFT
                                  GO TO ERRIO.
           UNLOCK BOLFTE.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BFT.
      ************
      *
           MOVE 1 TO IF-FLAGG.
      *
       EX-SCRIVI-APPOGGIO.
           EXIT.
      *------------------
       RISCRIVI-BOLLE.
           MOVE LOW-VALUE TO KEYABT.
           START APPFTE KEY > KEYABT INVALID GO TO R99.
       RD-ABT.
           READ APPFTE NEXT AT END GO TO R99.
           IF SF-ABT = '9D' OR '9A' OR '35' GO TO RD-ABT.

           MOVE KABT-AZI TO KBF-AZI.
           MOVE KABT-PRT TO KBF-PRT.
           READ BOLFTE INVALID GO TO RD-ABT.
           IF BFT-FLGFT = ZERO GO TO RD-ABT.

           MOVE KABT-AZI TO KAFR-AZI.
           MOVE KABT-PRT TO KAFR-PRT.
           MOVE ZERO     TO KAFR-PRG.
           START APPFRI KEY NOT < KEYAFR INVALID GO TO END-AFR.
       RD-AFR.
           READ APPFRI NEXT AT END GO TO END-AFR.
           IF SF-AFR = '9D' OR '9A' OR '35' GO TO RD-AFR.
           IF KAFR-AZI NOT = KABT-AZI OR
              KAFR-PRT NOT = KABT-PRT GO TO END-AFR.

           MOVE KAFR-AZI TO KFR-AZI.
           MOVE KAFR-PRT TO KFR-PRT.
           MOVE KAFR-PRG TO KFR-PRG.
           READ BOLFRI INVALID GO TO RD-AFR.
           IF BFR-FLGFT = ZERO GO TO RD-AFR.
      *
           IF BFR-TPRIG NOT = ZERO GO TO F-READ-20.
           MOVE KFR-AZI    TO KMA-AZI.
           MOVE BFR-CODART TO KMA-ART.
           READ MAGART INTO REKART INVALID PERFORM INVK-ART
                                           PERFORM VISK-BFR
                                           GO TO ERRIO.
           MOVE ZERO  TO PARMAG.
           MOVE SPACE TO M-TIPO
                         M-ART
                         M-UNM
                         M-NBOF.
           MOVE AFR-NUMOV  TO M-ONUM.
           MOVE AFR-CODART TO M-ART.
           MOVE BFR-NETRG  TO M-NIMP.
           MOVE ART-UNMIS  TO M-UNM
           IF ART-UNMIS = AFR-UNMIS
              MOVE AFR-QUANT  TO M-NQTA
           ELSE
              COMPUTE RD-NUM = AFR-QUANT / ART-COEFF
              CALL 'vrround' USING QTA-S PARRD ART-TQUAN
              MOVE RD-NUM TO M-NQTA.

           MOVE ZERO TO M-NMOV M-STAT.

           IF BFR-QUAFA = AFR-QUANT AND BFR-VALFA = AFR-NETRG
              GO TO F-READ-20.

           MOVE AFR-NETRG TO M-NIMP.

           PERFORM CAR-PARMAG THRU EX-CAR-PARMAG.
           IF AFT-FLGMG = 2
              CALL 'vrmvmag' USING PARMAG
              IF M-STAT = ZERO MOVE M-NMOV TO AFR-NUMOV.
       F-READ-20.
           MOVE RF-AFR TO RF-BFR.
           REWRITE RF-BFR INVALID GO TO RD-AFR.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BFR.
      ************

           GO TO RD-AFR.
       END-AFR.
           MOVE RF-AFT TO RF-BFT.
           REWRITE RF-BFT INVALID GO TO RD-ABT.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BFT.
      ************

           GO TO RD-ABT.
       R99.
           CLOSE APPFTE APPFRI.
           OPEN OUTPUT APPFTE APPFRI.
           CLOSE APPFTE APPFRI.
           OPEN I-O APPFTE APPFRI.
       EX-RISCRIVI-BOLLE.
           EXIT.
      *------------------
       CAR-PARMAG.
           MOVE 'A'       TO M-TIPO.
           MOVE AFT-FOR   TO COD.
           MOVE CODICE    TO M-CLFO.
           MOVE KABT-AZI   TO M-AZI.
           MOVE 1         TO M-TDOC.
           MOVE AFT-CDEP  TO M-DEP1.
           MOVE AFT-DTCO  TO M-NDAT.
           MOVE AFT-DTCO  TO M-ODAT.
           MOVE AFT-CAUS  TO M-NCA1.
           MOVE AFT-VALUT TO M-NVAL.
           MOVE AFT-CAMGG TO M-NCAM.
           MOVE AFT-CPAG  TO M-NPAG.
           MOVE AFT-NBOF  TO M-NBOF.
       EX-CAR-PARMAG.
           EXIT.
      *------------------
      * solo per movimento acquisto CEE
      * propone i default dei codici attivita' e progressivi IVA
      * acquisti e vendite
       DEF-ACEE-CONT.
           MOVE '0' TO IF-ACEE-CATTA.
           MOVE AZI-RANRG TO IF-ACEE-NPRGIA.
           ADD 1 TO IF-ACEE-NPRGIA.
      **** rel 6.3
           MOVE IF-ACEE-NPRGIA TO SAV-ONPRGI.
      ************
           MOVE '0' TO IF-ACEE-CATTV.
           MOVE AZI-RVNRG TO IF-ACEE-NPRGIV.
           IF AZI-NUMFT > IF-ACEE-NPRGIV
              MOVE AZI-NUMFT TO IF-ACEE-NPRGIV.
           ADD 1 TO IF-ACEE-NPRGIV.
      **** rel 6.1sm(CMO40)05/06/2015
      *------------------
       CALC-ACEE-CP.
           MOVE ZERO TO IF-CP-IMPON(16).
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              ADD VIVA-INDEDUC(K) TO IF-CP-IMPON(16)
              ADD 1 TO K
           END-PERFORM.
      **** end rel 6.1sm(CMO40)05/06/2015
      *------------------
       CALC-ACEE-DIFF.
           MOVE IF-TOTDOC  TO IF-DIFDOC.
           MOVE IF-TOTDOCV TO IF-DIFDOCV.
           MOVE 1 TO K.
           PERFORM UNTIL K > 6
              SUBTRACT IF-IV-IMPON(K)       FROM IF-DIFDOC
              SUBTRACT IF-ACEE-IV-IMPONV(K) FROM IF-DIFDOCV
              ADD 1 TO K
           END-PERFORM.
      *------------------
      * creazione file di lavoro WDS400 da passare a vcon400
       CREA-WDS400.
           MOVE ZERO TO K40-PROG.
      *
           OPEN OUTPUT WDS400.
           CLOSE WDS400.
           OPEN I-O WDS400.
      *
           PERFORM AZZ-REC400.
           IF IF-HS-ACEE = ZERO GO TO EX-CREA-WDS400.
      *
           MOVE ZERO              TO L40-IVA.
           MOVE IF-ACEE-CAUS      TO L40-CAUSA.
           MOVE IF-ACEE-T02-TIPRG TO L40-TIPRG.
           MOVE IF-ACEE-T02-D-A   TO L40-DAVE.
           MOVE IF-ACEE-T02-SEGNO TO L40-SEGNO.
           MOVE IF-ACEE-T02-TIPOP TO L40-TIPOP.
      *
      *    MOVE IF-CLIFOR TO CODCF.
      *    MOVE MFOR TO MAS.
           MOVE CODICE TO L40-PART.
      *
           MOVE IF-TOTDOCV TO L40-IMPES.
           MOVE IF-TOTDOC  TO L40-IMPOR.
           MOVE IF-NUMDOC  TO L40-DOCUM.
      *
           MOVE IF-DATDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO L40-DTDOC.
      *
           MOVE IF-CDVAL       TO L40-VALUT.
      *    MOVE IF-CP-COD(1)   TO L40-CPART.
      *    MOVE IF-CP-IMPON(1) TO L40-IMPCP.
           MOVE ZERO           TO L40-CPART.
           MOVE ZERO           TO L40-IMPCP.
      **** rel 6.1sm(CMO40)05/06/2015
           MOVE IF-CP-COD(16)   TO L40-CPART.
           MOVE IF-CP-IMPON(16) TO L40-IMPCP.
      **** end rel 6.1sm(CMO40)05/06/2015
           MOVE IF-ACEE-CATTA  TO L40-CATA.
           MOVE IF-ACEE-NPRGIA TO L40-NPRGA.
           MOVE IF-ACEE-CATTV  TO L40-CATV.
           MOVE IF-ACEE-NPRGIV TO L40-NPRGV.
           MOVE 1 TO L40-IVA.
      *
           MOVE 1 TO K2.
           PERFORM UNTIL K2 > 6
              IF IF-IV-COD(K2) NOT = ZERO
                 MOVE IF-IV-COD(K2)         TO L40-CDIVA
                 MOVE IF-ACEE-IV-IMPONV(K2) TO L40-IMPOE
                 MOVE IF-IV-IMPON(K2)       TO L40-IMPON
                 MOVE IF-IV-IMPOR(K2)       TO L40-IMPOS
      *          MOVE IF-IV-IMPOS(K2)       TO L40-IMPOS
      *          MOVE VIVA-INDEDUC(K2)      TO L40-INDED
      **** rel 6.1sm(CMO40)05/06/2015
      *          MOVE ZERO                  TO L40-INDED
                 MOVE VIVA-INDEDUC(K2)      TO L40-INDED
      **** end rel 6.1sm(CMO40)05/06/2015
                 MOVE IF-IV-PMES(K2)        TO L40-PLAM
                 MOVE IF-DATDOC TO GGMMAA
                 MOVE 1 TO TIPOP1
                 CALL 'rdata' USING PARCDT
                 IF IF-IV-PANN(K2) < AA4
                    MOVE 1 TO L40-PLAN
                 ELSE
                    IF IF-IV-PANN(K2) > AA4
                       COMPUTE L40-PLAN = IF-IV-PANN(K2) - AA4 + 1
                    END-IF
                 END-IF
                 PERFORM SCRIVI-REC400
                 MOVE ZERO TO L40-CPART
                 MOVE ZERO TO L40-IMPCP
              END-IF
              ADD 1 TO K2
           END-PERFORM.
      *
       EX-CREA-WDS400.
           EXIT.
      *------------------
      * scrittura record su file di lavoro wds400
       SCRIVI-REC400.
           ADD 1 TO K40-PROG.
           WRITE RF-400 INVALID
                 MOVE 'Errore scrittura wds400' TO MESS
                 GO TO ERRIO.
      *------------------
      * azzeramento area di WDS400
       AZZ-REC400.
           MOVE ZERO TO RF-400.
           MOVE ZERO TO L40-IMPES
                        L40-IMPOR
                        L40-IMPCP
                        L40-IMPOE
                        L40-IMPON
                        L40-IMPOS
                        L40-INDED.
           MOVE SPACE TO L40-DAVE
                         L40-CATA
                         L40-CATV.
      *------------------
      * lancia routine di aggiornamento vcon400
       LANCIA-VCON400.
           MOVE 001 TO K40-PROG.
           READ WDS400 INVALID GO TO EX-LANCIA-VCON400.
      *
           CLOSE WDS400.
           MOVE IF-DATREG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG   TO DTCON-400.
           MOVE IF-FL   TO FL-400.
           MOVE IF-AZI  TO CDAZ-400.
           MOVE 1       TO FLTRA-400.
           CALL 'vcon400' USING PARLINK-400.
           CANCEL 'vcon400'.
           IF NOT (ERRIO-ST = ZERO OR 8) GO TO ERRIO.
      **** rel 6.3
           MOVE W400-KEYTRA TO IF-AREA-KTRA.
      ************
           OPEN I-O WDS400.
       EX-LANCIA-VCON400.
           EXIT.
      *------------------
       MOV-ACQ-CEE.
           MOVE 1 TO IF-HS-ACEE.
           MOVE ZERO TO IF-PRGIVA.
      **** rel 6.3
           MOVE ZERO TO SAV-ONPRGI.
      ************
           IF FUN NOT = 'W' PERFORM DEF-ACEE-CONT.
       EX-MOV-ACQ-CEE.
           EXIT.
      *------------------
       CALCOLA-NOMME.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O WDSLAV.
           MOVE ZERO TO IF-TIMPAGG IF-TIMPBOL.
      **** rel 6.3
           MOVE ZERO TO IF-DIFIMPO.
      ************

           MOVE ZERO   TO NOMMEC.
           MOVE IF-AZI TO KCF-AZI.
           MOVE IF-FOR TO COD.
           MOVE CODICE TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID PERFORM ERR-CINE
                                           GO TO V-ERROR.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           MOVE CLF-NOMME TO NOMMEC.

      **** rel 6.3
           PERFORM AZZ-NOMSPE THRU EX-AZZ-NOMSPE.
           MOVE 1 TO J.
      ************
           MOVE ZERO TO K1 CONT SAVNOM.
       LP-BFT.
           ADD 1 TO K1.
           IF K1 > 50 GO TO END-LP-BFT.
           IF CHIBOL(K1) = ZERO GO TO END-LP-BFT.
       RD-BFT.
           MOVE KAZ-COD    TO KBF-AZI KFR-AZI.
           MOVE CHIBOL(K1) TO KBF-PRT KFR-PRT.
           READ BOLFTE INVALID PERFORM INVK-BFT GO TO ERRIO.

           MOVE ZERO TO TOTNETRG TOTSPESE SPESE.

           MOVE ZERO TO KFR-PRG.
           START BOLFRI KEY NOT < KEYFR INVALID GO TO END-LP-BFR.
       RDNX-BFR.
           READ BOLFRI NEXT AT END GO TO END-LP-BFR.
           IF SF-BFR = '9D' OR '9A' OR '35' GO TO RDNX-BFR.
           IF KFR-AZI NOT = KBF-AZI OR
              KFR-PRT NOT = KBF-PRT GO TO END-LP-BFR.
           IF BFR-TPRIG = 1 GO TO RDNX-BFR.

      *> rigo voce spesa
           IF BFR-TPRIG NOT = 3 GO TO NO-SPESA.
           MOVE 11        TO KTB-TIP.
           MOVE BFR-CDSPE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO RDNX-BFR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T11-INTRA = ZERO GO TO RDNX-BFR.
           IF NOT (IF-CDVAL = ZERO OR CODEURO)
              MOVE BFR-NETRG TO ER-IMPORTO
              MOVE IF-CDVAL  TO ER-VALUT
              MOVE IF-CAMGG  TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT
                                  ER-CAMBIO
              MOVE ER-IMPORTO TO BFR-NETRG.
      **** rel 6.3
      *    ADD BFR-NETRG TO TOTSPESE.
      *    ADD 1 TO SPESE.
           IF T11-NOMC = ZERO OR J > 100
              IF T11-SCONT = ZERO
                 ADD BFR-NETRG TO TOTSPESE
                 ADD 1 TO SPESE
              ELSE
      * escluso da sconto pagamento
                 ADD BFR-NETRG TO TOTSPESE2
                 ADD 1 TO SPESE2
           ELSE
      * Per voci spesa con nomenclatura specifica
              MOVE KFR-AZI   TO AZISPE(J)
              MOVE T11-NOMC  TO NOMMESPE(J)
              MOVE BFR-NETRG TO IMPOSPE(J)
              END-IF
              ADD 1 TO J.
      ************
           GO TO RDNX-BFR.
       NO-SPESA.
           MOVE ZERO TO NOMMEART.
      **** rel 6.3
      *    IF BFR-TPRIG = 2 OR BFR-CODART = SPACE GO TO NO-ART.
           IF BFR-TPRIG = 2 AND BFR-NOMC NOT = ZERO
              MOVE BFR-NOMC TO NOMMEART
              GO TO NO-ART.
      ************
           IF BFR-CODART = SPACE GO TO NO-ART.
      **** rel 6.3
      *    MOVE KFR-AZI    TO KMA-AZI.
      *    MOVE BFR-CODART TO KMA-ART.
      *    READ MAGART INTO REKART INVALID KEY MOVE ZERO TO ART-NOMME.
      *    IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
      *    MOVE ART-NOMME TO NOMMEART.
           MOVE BFR-NOMC TO NOMMEART.
      ************
       NO-ART.
           IF NOMMEART NOT = ZERO MOVE NOMMEART TO KLV-NOMME
           ELSE
              IF NOMMEC NOT = ZERO MOVE NOMMEC TO KLV-NOMME
              ELSE MOVE NOMMEA TO KLV-NOMME.
       RD-LV.
           READ WDSLAV INVALID
                       IF CONT < 10
      **** rel 7.1
                          INITIALIZE RECLAV
      ************
                          MOVE ZERO TO LAV-IMPO
                          ADD 1 TO CONT
                       ELSE
                          MOVE SAVNOM TO KLV-NOMME
                          IF KLV-NOMME = ZERO GO TO RDNX-BFR
                          ELSE GO TO RD-LV.

           IF NOT (IF-CDVAL = ZERO OR CODEURO)
              MOVE BFR-NETRG TO ER-IMPORTO
              MOVE IF-CDVAL  TO ER-VALUT
              MOVE IF-CAMGG  TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT
                                  ER-CAMBIO
              MOVE ER-IMPORTO TO BFR-NETRG.

           ADD BFR-NETRG TO LAV-IMPO.

           IF SF-LAV = ZERO REWRITE RF-LAV
           ELSE WRITE RF-LAV.

           IF KLV-NOMME > SAVNOM MOVE KLV-NOMME TO SAVNOM.
           IF BFR-TPRIG = ZERO OR
              BFR-TPRIG = 2    ADD BFR-NETRG TO TOTNETRG.
           GO TO RDNX-BFR.
       END-LP-BFR.
           GO TO LP-BFT.
       END-LP-BFT.
      **** rel 6.3
      *    IF TOTNETRG = ZERO AND TOTSPESE > ZERO GO TO ENDLAV.
           IF NOMMESPE(1) NOT = ZERO
              PERFORM WR-NOMSPE THRU EX-WR-NOMSPE.
           IF TOTNETRG = ZERO AND
              (TOTSPESE > ZERO OR TOTSPESE2 > ZERO) GO TO ENDLAV.
      ************
      *
           PERFORM AZZ-IF-INTRA.
      **** rel 7.1
           IF FLGCEE NOT = 4 OR
              (FLGCEE = 4 AND PAECEE = 'IT') OR
              (FLGCEE = 4 AND PAECEE = SPACE)
                 GO TO NO-INTRA.
      *
           IF AC-PAPR NOT = ZERO
              MOVE PAECEE TO IF-TR-CDPAP
              MOVE IF-TR-CDPAP TO T37-COD
              MOVE 37          TO T37-TIP
              MOVE T37-KEYID TO KEYTB
              READ TABELL INTO REKT37 INVALID MOVE SPACE TO T37-DESCR
                                              MOVE ZERO TO T37-CDVAL
              END-READ
              IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT37
              END-IF
              MOVE T37-DESCR TO IF-TR-DPAP.
      *
           IF AC-PAOR NOT = ZERO
              MOVE PAECEE TO IF-TR-CDPAO
              MOVE IF-TR-CDPAO TO T37-COD
              MOVE 37          TO T37-TIP
              MOVE T37-KEYID TO KEYTB
              READ TABELL INTO REKT37 INVALID MOVE SPACE TO T37-DESCR
                                              MOVE ZERO TO T37-CDVAL
              END-READ
              IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT37
              END-IF
              MOVE T37-DESCR TO IF-TR-DPAO
              IF T37-CDVAL NOT = ZERO
                 MOVE T37-CDVAL TO IF-TR-CDVAL
                 MOVE IF-DATDOC TO GGMMAA
                 MOVE 1 TO TIPOP1
                 CALL 'rdata' USING PARCDT
                 MOVE AAGGG TO ER-DATA
                 CALL 'rvalut' USING IF-TR-CDVAL ER-DATA CG-PAR
                 IF CG-ST > ZERO MOVE ALL '*' TO CG-DSINT
                                 MOVE ZERO    TO CG-CAMBIO
                 END-IF
                 MOVE CG-CAMBIO TO IF-TR-CAMGG
                 MOVE CG-DSINT  TO IF-TR-DSINT.
      *
           MOVE AC-PRDE TO IF-TR-CDPRO.
      *
           IF AC-CDPP NOT = ZERO
              MOVE PAECEE TO IF-TR-SPAEP
              MOVE IF-TR-SPAEP TO T37-COD
              MOVE 37          TO T37-TIP
              MOVE T37-KEYID TO KEYTB
              READ TABELL INTO REKT37 INVALID MOVE SPACE TO T37-DESCR
              END-READ
              IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT37
              END-IF
              MOVE T37-DESCR TO IF-TR-DSPP.
      *
           IF AC-MOER NOT = SPACE MOVE AC-MOER TO IF-TR-MOER.
           IF AC-MOIN NOT = SPACE MOVE AC-MOIN TO IF-TR-MOIN.
       NO-INTRA.
      ************
           MOVE ZERO TO CONT.
           MOVE LOW-VALUE TO KEYLV.
      **** rel 6.3
           MOVE ZERO TO IF-DIFIMPO.
           MOVE IF-TIMPBOL TO IF-DIFIMPO.
      ************
           START WDSLAV KEY NOT < KEYLV INVALID KEY GO TO END-LAV.
       RD-LAV.
           READ WDSLAV NEXT AT END GO TO END-LAV.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO RD-LAV.
           ADD 1 TO CONT.
      *
           IF SPESE > ZERO
              COMPUTE RD-NUM =
                      LAV-IMPO + ((TOTSPESE * LAV-IMPO) / TOTNETRG)
                      CALL 'vrround' USING NNN-S PARRD DEC-2
                      MOVE RD-NUM TO LAV-IMPO.
      *
           MOVE KLV-NOMME TO IF-TR-NOMME(CONT).
           MOVE LAV-IMPO  TO IF-TR-IMPAGG(CONT)
                             IF-TR-IMPBOL(CONT).
      **** rel 7.1
           MOVE LAV-IMPV  TO IF-TR-IMPVAL(CONT).
           MOVE LAV-MNET  TO IF-TR-MASNET(CONT).
      ************
           ADD LAV-IMPO TO IF-TIMPAGG
                           IF-TIMPBOL.
      **** rel 6.3
           SUBTRACT IF-TIMPAGG FROM IF-DIFIMPO.
      ************
           GO TO RD-LAV.
       END-LAV.
      **** rel 7.1
           IF FLGCEE NOT = 4 OR
              (FLGCEE = 4 AND PAECEE = 'IT') OR
              (FLGCEE = 4 AND PAECEE = SPACE)
              GO TO EX-CALCOLA-NOMME.
           IF K1 > 10
              MOVE 'Numero nomenclature eccessivo' TO MB-TITOLO
              MOVE 'W' TO MB-TIPO
              MOVE 2 TO F-NMES
              MOVE 'Nomenclature restanti inglobate' TO F-MES1
              MOVE 'nell''ultima nomenclatura gestita' TO F-MES2
              CALL 'vrmbox' USING PARMB
              GO TO EX-CALCOLA-NOMME.
      ************
      **** rel 6.3
           IF IF-TR-NOMME(K1) = ZERO AND K1 = 1 
              MOVE ZERO TO IF-DIFIMPO
              IF NOMMEC = ZERO
                 MOVE NOMMEA TO NOMMEC
              END-IF
              MOVE NOMMEC TO IF-TR-NOMME(K1)
              MOVE IF-TOTDOC TO IF-TR-IMPAGG(K1)
                                IF-TIMPAGG
                                IF-TR-IMPBOL(K1)
                                IF-TIMPBOL
              COMPUTE IF-DIFIMPO = IF-TIMPBOL - IF-TIMPAGG.
      ************
      *
       EX-CALCOLA-NOMME.
           EXIT.
      *------------------
       LANCIA-VCON440.
           MOVE ZERO TO CONT.
           IF TOTNETRG = ZERO AND TOTSPESE > ZERO GO TO ENDLAV.

           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY NOT < KEYLV INVALID KEY GO TO ENDLAV.
       RDNX-LAV.
           READ WDSLAV NEXT AT END GO TO ENDLAV.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO RDNX-LAV.
           ADD 1 TO CONT.

           MOVE ZERO      TO PARTRA.
           MOVE SPACE     TO PTRA-CATT PTRA-TRAN.
           MOVE 1         TO PTRA-TIPOP.
           MOVE KAZ-COD   TO PTRA-AZI.

      *> data registrazione / cod. attivita'
           MOVE IF-DATREG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG   TO PTRA-DAT.
           MOVE IF-CATT        TO PTRA-CATT.
      *> protocollo d'acquisto
           MOVE IF-ACEE-NPRGIA TO PTRA-NPRGI.
      *> cod. fornitore
           MOVE IF-FOR TO COD.
           MOVE CODICE TO PTRA-CLFO.

           MOVE KLV-NOMME  TO PTRA-NOMME.
           MOVE LAV-IMPO   TO PTRA-IML.
      **** rel 7.1
      *    MOVE ZERO       TO PTRA-IMV.
      *    MOVE ZERO       TO PTRA-VAL.
           MOVE LAV-IMPV    TO PTRA-IMV.
           MOVE LAV-MNET    TO PTRA-MNET.
           MOVE IF-TR-CDVAL TO PTRA-VAL.
           MOVE IF-TR-CDPRO TO PTRA-CDPRO.
           MOVE IF-TR-CDPAP TO PTRA-CDPAP.
           MOVE IF-TR-CDPAO TO PTRA-CDPAO.
           MOVE IF-TR-SPAEP TO PTRA-SPAEP.
           MOVE SPACE       TO PTRA-NATRA.
           MOVE IF-TR-MOER  TO PTRA-MOER.
           MOVE IF-TR-MOIN  TO PTRA-MOIN.
           MOVE ZERO        TO PTRA-FLGFIS.
           MOVE ZERO        TO PTRA-VASTA.
      ************

      *> numero e data documento
           MOVE IF-NUMDOC  TO PTRA-NUDOC.
           MOVE IF-DATDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG  TO PTRA-DTDOC.
      *
           MOVE 'A'        TO PTRA-TRAN.
           MOVE CONT       TO PTRA-PROG.
      **** rel 7.1
           PERFORM VERIFICA-TIPO THRU EX-VERIFICA-TIPO.
      ************
           CALL 'vcon440' USING PARTRA.
           CANCEL 'vcon440'.
           IF NOT (ERRIO-ST = ZERO OR 8) GO TO ERRIO.
      **** rel 6.3
           MOVE PTRA-KEYTRA TO IF-AREA-KTRA.
      ************

           DELETE WDSLAV.
           GO TO RDNX-LAV.
       ENDLAV.
       EX-LANCIA-VCON440.
           EXIT.
      *------------------
      *> cancellazione e riscrittura file di sort dei codici
      *  nomenclatura combinata ed importi per aggiornamento
      *  file EINTRA (in quanto modificabili dall'utente)
       RISCRIVI-SORT.
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY NOT < KEYLV INVALID KEY GO TO END-LP-DEL.
       LP-DEL.
           READ WDSLAV NEXT AT END GO TO END-LP-DEL.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO LP-DEL.
           DELETE WDSLAV.
           GO TO LP-DEL.
       END-LP-DEL.
           MOVE ZERO TO CONT.
       LP-WR-LAV.
           ADD 1 TO CONT.
           IF CONT > 10 GO TO EX-RISCRIVI-SORT.
           IF IF-TR-NOMME(CONT) = ZERO GO TO LP-WR-LAV.
           MOVE IF-TR-NOMME(CONT) TO KLV-NOMME.
           READ WDSLAV INVALID GO TO WR-LAV.
           ADD IF-TR-IMPAGG(CONT) TO LAV-IMPO.
      **** rel 7.1
           ADD IF-TR-IMPVAL(CONT) TO LAV-IMPV.
           ADD IF-TR-MASNET(CONT) TO LAV-MNET.
      ************
           REWRITE RF-LAV.
           GO TO LP-WR-LAV.
       WR-LAV.
      **** rel 7.1
           INITIALIZE RECLAV.
      ************
           MOVE IF-TR-IMPAGG(CONT) TO LAV-IMPO.
      **** rel 7.1
           MOVE IF-TR-IMPVAL(CONT) TO LAV-IMPV.
           MOVE IF-TR-MASNET(CONT) TO LAV-MNET.
      ************
           WRITE RF-LAV.
           GO TO LP-WR-LAV.
       EX-RISCRIVI-SORT.
           EXIT.
      *------------------
       VER-FATT-DA-EM.
           OPEN OUTPUT WDSLA3.
           CLOSE WDSLA3.
           OPEN I-O WDSLA3.
      *
      *> K = contatore per progressivo chiave file di sort wdsla3
           MOVE ZERO TO K.

           MOVE ZERO TO K1.
       AVE-10.
           ADD 1 TO K1.
           IF K1 > 8 GO TO AVE-95.
           IF WCOR (K1) = ZERO GO TO AVE-95.
           MOVE WCOR (K1) TO WCORP.
      *
           MOVE ZERO TO IND2.
       AVE-30.
           ADD 1 TO IND2.
           IF IND2 > 6 GO TO AVE-90.
      **** rel 6.2
      *    IF WIMP(IND2) = ZERO GO TO AVE-30.
           IF CAUATTRN = ZERO
              MOVE WIVA(K1) TO IMP
           ELSE
              MOVE WIMP(K1) TO IMP.
           IF IMP = ZERO GO TO AVE-30.
      ************
           IF WCON(IND2) = ZERO GO TO AVE-30.

      *> controllo contropartita con quelle tabellate in T14L
           MOVE ZERO TO FLAVE.
           PERFORM VER-CP THRU EX-VER-CP.
           IF FLAVE NOT = 1 GO TO AVE-30.

           ADD 1 TO K.
       CARICA-REC-LA3.
           MOVE ZERO  TO RF-LA3.
           MOVE SPACE TO LA3-DESAG.
      *> key
           MOVE K     TO KL3-PROGR.
           MOVE DTCON TO KL3-DTREG.
      *
           MOVE CAU-FTRC   TO LA3-CAUS.
           MOVE IF-RGSFOR  TO LA3-DESAG.
           MOVE WNDOC      TO LA3-DOCUM.
           MOVE WDATA      TO LA3-DTDOC.
           MOVE WCON(IND2) TO LA3-CPART.
      **** rel 6.2
      *    MOVE WIMP(IND2) TO LA3-IMPOR.
           MOVE IMP        TO LA3-IMPOR.
      ************

           WRITE RF-LA3 INVALID
                 MOVE 'Errore scrittura wdsla3' TO MESS
                 CLOSE WDSLA3
                 GO TO ERRIO.

      * serve ad interfaccia per aprire inserimento prima nota V.ES.
           MOVE 'AVE-SI' TO IF-CAMPO2.
      *
           GO TO AVE-30.
       AVE-90.
           GO TO AVE-10.
       AVE-95.
           CLOSE WDSLA3.
       EX-VER-FATT-DA-EM.
           EXIT.
      *------------------
      *> per ogni N.Accr. verifica se la contropartita e' del
      *> tipo fatture da emettere (tabellate in T14L)
       VER-CP.
           MOVE ZERO TO CONT.
       LP-CP.
           ADD 1 TO CONT.
           IF CONT > 3 GO TO EX-VER-CP.
           IF CP-FTRC(CONT) = ZERO GO TO LP-CP.
           IF WCON(IND2) NOT = CP-FTRC(CONT) GO TO LP-CP.

           MOVE 1 TO FLAVE.
       EX-VER-CP.
           EXIT.
      *------------------
      ************
      **** rel 6.3
       VERIFICA-PRT.
           IF IF-HS-ATTRN = 1 MOVE IF-PRGIVA      TO SAV-NPRGI.
           IF IF-HS-ACEE  = 1 MOVE IF-ACEE-NPRGIA TO SAV-NPRGI.
      *
          MOVE ZERO TO ERRPRT.
           MOVE 2         TO KTB-TIP.
           MOVE IF-CODCAU TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY PERFORM INVK-TAB
                                               GO TO ERRIO.
      * se non e' fattura acquisto
           IF T02-TIPRG NOT = 3 GO TO EX-VERIFICA-PRT.
           IF NOT ( T02-TIPOP = 1 OR 8 ) GO TO EX-VERIFICA-PRT.
          MOVE IF-DATREG TO GGMMAA.
          MOVE 1 TO TIPOP1.
          CALL 'rdata' USING PARCDT.
      *
          MOVE ZERO   TO PARPRT.
          MOVE IF-AZI TO PPRT-AZI.
          MOVE IF-FL  TO PPRT-FL.
          MOVE CIVACQ TO PPRT-CON.
      * memorizza data mov
          MOVE IF-DATREG TO GGMMAA.
          MOVE 1 TO TIPOP1.
          CALL 'rdata' USING PARCDT.
          MOVE AAGGG TO PPRT-DTINS.
      * cerca ult num e data                     
      * + num da proporre solo per acq
          CALL 'vrcprt' USING PARPRT
          IF PPRT-BUCPRT NOT = ZERO
             MOVE PPRT-BUCPRT TO COMPRT
             MOVE 1 TO ERRPRT
             GO TO EX-VERIFICA-PRT.                   
          IF PPRT-UPRT < SAV-NPRGI
             IF PPRT-DTUPR > AAGGG
                MOVE 2 TO ERRPRT
                GO TO EX-VERIFICA-PRT.
      *
           IF IF-CATT NOT = '0' GO TO RD-T35-0.
      * protocollo da azienda
       RD-AZI-0.
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID PERFORM INVK-AZI
                                                     GO TO ERRIO.
           IF SF-AZI NOT = ZERO PERFORM REC-LOCK
                                GO TO RD-AZI-0.
      *
           MOVE AZI-RANRG TO COMPRT.
           ADD 1          TO COMPRT.
      *
      * se il protocollo utilizzato ancora esattamente il sucessivo
      * viene memorizzato gi qui su azienda in modo tale che se altri 
      * utenti cercassero di prelevare lo stesso numero darebbe errore
           IF SAV-NPRGI NOT < SAV-ONPRGI
              IF COMPRT NOT = SAV-NPRGI
              MOVE 1 TO ERRPRT
              UNLOCK ANAAZI 
              GO TO FINE-PRT.
      *
           MOVE COMPRT TO AZI-RANRG.
           REWRITE RF-AZI FROM REKAZI INVALID PERFORM INVK-AZI
                                              GO TO ERRIO.
           UNLOCK ANAAZI.
      *
           GO TO EX-VERIFICA-PRT.
       RD-T35-0.
           MOVE 35       TO T35-TIP.
           MOVE KAZ-COD  TO T35-CDAZ.
           MOVE IF-CATT  TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 KEPT LOCK INVALID PERFORM INVK-TAB
                                                     GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           IF SF-TAB NOT = ZERO PERFORM REC-LOCK
                                GO TO RD-T35-0.
           MOVE T35-RANRG TO COMPRT.
           ADD 1          TO COMPRT.
      *
      * se il protocollo utilizzato ancora esattamente il sucessivo
      * viene memorizzato gi qui su azienda in modo tale che se altri 
      * utenti cercassero di prelevare lo stesso numero darebbe errore
           IF SAV-NPRGI NOT < SAV-ONPRGI
              IF COMPRT NOT = SAV-NPRGI
                 MOVE 1 TO ERRPRT
                 UNLOCK TABELL 
                 GO TO FINE-PRT.
      *
      **** rel 7.1
           CLOSE TABELL.
           OPEN I-O TABELL.
      ************
           MOVE COMPRT TO T35-RANRG.
           REWRITE RF-TAB FROM REKT35 INVALID PERFORM INVK-TAB
                                              GO TO ERRIO.
           UNLOCK TABELL.
      **** rel 7.1
           CLOSE TABELL.
           OPEN INPUT TABELL.
      ************
       FINE-PRT.
      *
       EX-VERIFICA-PRT.
           EXIT.
      *------------------
       AGGIORNA-PRT.
           IF IF-PRGIVA NOT = ZERO      MOVE COMPRT TO IF-PRGIVA.
           IF IF-ACEE-NPRGIA NOT = ZERO MOVE COMPRT TO IF-ACEE-NPRGIA.
       EX-AGGIORNA-PRT.
           EXIT.
      *------------------
      ************
      **** rel 6.1
        CERCA-CONTR.
           MOVE ZERO      TO PARRCR.
           MOVE KMA-AZI   TO RCR-AZI.
           MOVE 'C'       TO RCR-TIP.
           MOVE IF-FOR    TO RCR-CLF.
           MOVE KMA-ART   TO RCR-ART.
           CALL 'vrdcrc' USING PARRCR.
           MOVE RCR-CONTR TO CODCON.
        EX-CERCA-CONTR.
           EXIT.
      *------------------*
       WR-ABF.
           MOVE ZERO TO RF-ABF.
           MOVE ZERO TO ABF-NFAT ABF-DTREGF ABF-DTDOC ABF-NDOC.
           MOVE KEYBF TO KEYABF.
           WRITE RF-ABF INVALID PERFORM INVK-ABF
                                GO TO ERRIO.
       EX-WR-ABF.
           EXIT.
      *------------------*
       AGGIORNA-ABF.
           MOVE KEYBF TO KEYABF.
           READ APPBFT INVALID PERFORM WR-ABF THRU EX-WR-ABF.
      *
           MOVE KEYBF TO KEYABF.
      *
           MOVE IF-PRGIVA TO ABF-NFAT.
      **** rel 6.2
           IF IF-HS-ATTRN = ZERO AND IF-HS-ACEE  = 1
              IF (IF-PRGIVA = ZERO) AND (IF-ACEE-NPRGIA NOT = ZERO)
                 MOVE IF-ACEE-NPRGIA TO ABF-NFAT.
      ************
           MOVE IF-NUMDOC TO ABF-NDOC.
      *
           MOVE IF-DATREG TO GGMMAA.
           MOVE 1         TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG     TO ABF-DTREGF.
      *
           MOVE IF-DATDOC TO GGMMAA.
           MOVE 1         TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG     TO ABF-DTDOC.
      *
           REWRITE RF-ABF INVALID PERFORM INVK-ABF
                                  GO TO ERRIO.
       EX-AGGIORNA-ABF.
           EXIT.
      *------------------*
      ***********
      **** rel 6.2
      * controlla se ci sono mov. dei lavoratori autonomi da eseguire
       LAV-AUTONOMI.
           OPEN INPUT WDS185.
      *
           MOVE ZERO TO IF-RIT.
      *
           MOVE LOW-VALUE TO KEY185.
           START WDS185 KEY > KEY185 INVALID MOVE ZERO TO IF-RIT
                                             GO TO END-LAV-AUTONOMI.
       RDN-L185.
           READ WDS185 NEXT AT END MOVE ZERO TO IF-RIT
                                   GO TO END-LAV-AUTONOMI.
           MOVE K185-TIPO TO IF-RIT.
       END-LAV-AUTONOMI.
      *
       EX-LAV-AUTONOMI.
           EXIT.
      *------------------
       CONTROLLA-PAGAM-ANT.
           MOVE ZERO TO DTSCA DTREG.
           MOVE IF-DATREG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG   TO DTREG.
           MOVE IF-SC-DTSCA(1) TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG   TO DTSCA.
      *
      * conta numero rate totali
           MOVE ZERO TO SCA-RATE.
           MOVE 1 TO K1.
           PERFORM UNTIL K1 > 12
              IF IF-SC-DTSCA(K1) NOT = ZERO
                 ADD 1 TO SCA-RATE
              END-IF
              ADD 1 TO K1
           END-PERFORM.
      *
           IF SCA-RATE       = 1         AND
              DTSCA <= DTREG AND
              IF-SC-TPAG(1)  = 9
      *       MOVE 1 TO FLGPAN
              IF IF-SC-PRG  NOT = ZERO
                 PERFORM RWR-SCAD-PAGANT THRU EX-RWR-SCAD-PAGANT
              ELSE
                 MOVE "Non e'' stata selezionata alcuna " TO F-MES1
                 MOVE "scadenza di pagamento anticipato." TO F-MES2
                 MOVE "Nessun aggiornamento effettuato ." TO F-MES3
                 MOVE 3 TO F-NMES
                 CALL 'vrmbox' USING PARMB
               END-IF
               MOVE ZERO  TO WRKSCA.
       EX-CONTROLLA-PAGAM-ANT.
              EXIT.
      *---------------*
      *> riscrive sulla scadenza del pagamento anticipato il
      *  numero e la data del documento. La trova solo se e'
      *  valorizzato if-sc-prg, passato dallo screenset dopo aver
      *  aperto lo zoom dello scadenzario.
       RWR-SCAD-PAGANT.
           OPEN I-O ANASCA DETSCA NOTSCA.
           MOVE KAZ-COD    TO KSC-AZI.
           MOVE 2          TO KSC-TIPO.
           MOVE IF-SC-DTSCA(1) TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG      TO KSC-DTSCA.
           MOVE IF-SC-PRG  TO KSC-PRG.
           READ ANASCA INVALID  GO TO RWR-SCAD-05.
           IF (KS2-CODCF(3:5) NOT = IF-FOR) OR
              (SCA-NDOC  NOT = ZERO)        OR
              (SCA-DTDOC NOT = ZERO)        OR
              (SCA-IMPOR NOT = IF-TOTDOC)   OR
              (SCA-TPAG  NOT = 9)           OR
              (SCA-STATO NOT = "P")         GO TO RWR-SCAD-05.
      *
           MOVE IF-NUMDOC TO SCA-NDOC.
           MOVE IF-DATDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO SCA-DTDOC.
      *
           MOVE IF-CDPAG  TO SCA-CDPAG.
           MOVE IF-PRGIVA TO SCA-NPROT.
      **** rel 7.2
           IF IF-HS-ATTRN = ZERO AND IF-HS-ACEE  = 1
              IF (IF-PRGIVA = ZERO) AND (IF-ACEE-NPRGIA NOT = ZERO)
                 MOVE IF-ACEE-NPRGIA TO SCA-NPROT.
      ************
           MOVE IF-SC-NOTE(1) TO SCA-NOTE.
           REWRITE RF-SCA INVALID PERFORM INVK-SCA
                                  GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-SCA.
      ************
      *
           MOVE ZERO      TO RF-NSC.
           MOVE KSC-AZI   TO KNSC-AZI.
           MOVE KSC-TIPO  TO KNSC-TIPO.
           MOVE KSC-DTSCA TO KNSC-DTSCA.
           MOVE KSC-PRG   TO KNSC-PRG.
           MOVE 1         TO KNSC-PRGN.
           READ NOTSCA INVALID MOVE SPACE TO NSC-DESCR.
           MOVE IF-SC-NOTEA(1) TO NSC-DESCR.
           REWRITE RF-NSC INVALID
                   IF IF-SC-NOTEA(1) NOT = SPACE
                      MOVE ZERO TO RF-NSC
                      MOVE KSC-AZI   TO KNSC-AZI
                      MOVE KSC-TIPO  TO KNSC-TIPO
                      MOVE KSC-DTSCA TO KNSC-DTSCA
                      MOVE KSC-PRG   TO KNSC-PRG
                      MOVE 1         TO KNSC-PRGN
                      MOVE IF-SC-NOTEA(1) TO NSC-DESCR
                      WRITE RF-NSC INVALID PERFORM INVK-NSC
                                           GO TO ERRIO.
      *
           PERFORM RWR-DETSCA-CARICO THRU EX-RWR-DETSCA-CARICO.
           CLOSE ANASCA DETSCA NOTSCA.
           GO TO EX-RWR-SCAD-PAGANT.
       RWR-SCAD-05.
           MOVE "Scadenza di pagamento anticipato "  TO F-MES1.
           MOVE "non trovata. Nessun aggiornamento"  TO F-MES2.
           MOVE "effettuato.                      "  TO F-MES3.
           MOVE 3 TO F-NMES.
           CALL 'vrmbox' USING PARMB.
       EX-RWR-SCAD-PAGANT.
           EXIT.
      *------------------
      *> riscrive sul dettaglio della scadenza del pagamento
      *  anticipato il numero e la data del documento.
       RWR-DETSCA-CARICO.
           MOVE KSC-AZI   TO KDSC-AZI.
           MOVE KSC-TIPO  TO KDSC-TIPO.
           MOVE KSC-DTSCA TO KDSC-DTSCA.
           MOVE KSC-PRG   TO KDSC-PRG.
           MOVE ZERO      TO KDSC-PROG.
           START DETSCA KEY NOT < KEYDSC INVALID
                                         GO TO EX-RWR-DETSCA-CARICO.
       RD-05.
           READ DETSCA NEXT AT END GO TO EX-RWR-DETSCA-CARICO.
           IF SF-DSC = '9D' OR '9A' OR '35' GO TO RD-05.
           IF KDSC-AZI   > KSC-AZI   GO TO EX-RWR-DETSCA-CARICO.
           IF KDSC-TIPO  > KSC-TIPO  GO TO EX-RWR-DETSCA-CARICO.
           IF KDSC-DTSCA > KSC-DTSCA GO TO EX-RWR-DETSCA-CARICO.
           IF KDSC-PRG   > KSC-PRG   GO TO EX-RWR-DETSCA-CARICO.

           IF DSC-NREG   NOT = SCA-NREG   GO TO RD-05.

           IF (DSC-NDOC  NOT = ZERO) AND
              (DSC-DTDOC NOT = ZERO) AND
              (DSC-TIPOP NOT = "A" ) AND
              (DSC-IMPOR NOT = SCA-IMPOR) GO TO RD-05.

           MOVE IF-NUMDOC TO DSC-NDOC.
           MOVE IF-DATDOC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG     TO DSC-DTDOC.
           MOVE SCA-CDPAG TO DSC-CDPAG.
           REWRITE RF-DSC INVALID
              PERFORM INVK-DSC
              GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-DSC.
      ************
           GO TO RD-05.
       EX-RWR-DETSCA-CARICO.
           EXIT.
      *------------------
      ************
      **** rel 6.3
       AZZ-NOMSPE.
      *
           MOVE ZERO TO J.
       ANSPE-10.
           ADD 1 TO J.
           IF J > 100 GO TO EX-AZZ-NOMSPE.
           MOVE ZERO TO NOMMESPE(J) IMPOSPE(J).
           GO TO ANSPE-10.
      *
       EX-AZZ-NOMSPE.
           EXIT.
      *------------------
       WR-NOMSPE.
      *
           MOVE ZERO TO J.
       WNS-10.
           ADD 1 TO J.
      *
           IF NOMMESPE(J) = ZERO OR J > 100 GO TO EX-WR-NOMSPE.
      *
           MOVE LOW-VALUE TO RF-LAV.
           MOVE NOMMESPE(J) TO KLV-NOMME.
      **** rel 7.1
      *    READ WDSLAV INVALID MOVE IMPOSPE(J) TO LAV-IMPO
           READ WDSLAV INVALID INITIALIZE RECLAV
                               MOVE IMPOSPE(J) TO LAV-IMPO
      ************
                               WRITE RF-LAV
                               GO TO WNS-10.
      *
           ADD IMPOSPE(J) TO LAV-IMPO.
           REWRITE RF-LAV.
      *
           GO TO WNS-10.
      *
       EX-WR-NOMSPE.
           EXIT.
      *------------------
      ************
      **** rel 7.1
       VERIFICA-TIPO.
           MOVE PTRA-TRAN TO COM-TRAN.
           IF PTRA-NOMME NOT = ZERO MOVE PTRA-NOMME TO COM-NOMME
           ELSE
              IF CLF-NOMME NOT = ZERO MOVE CLF-NOMME TO COM-NOMME
              ELSE
                 IF PTRA-TRAN = 'A' MOVE NOMMEA TO COM-NOMME
                 ELSE MOVE NOMMEV TO COM-NOMME.
           IF COM-NOMME NOT = ZERO AND COM-NOMME < 1000000
              IF PTRA-TRAN = 'A'
                 MOVE 'I'       TO COM-TRAN
              ELSE
                 MOVE 'R'       TO COM-TRAN.
           IF COM-TRAN NOT = 'I'
              GO TO EX-VERIFICA-TIPO. 
           MOVE IF-DATREG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO PTRA-DTDOC.
           MOVE IF-ACEE-NPRGIV TO PTRA-NUDOC.
       EX-VERIFICA-TIPO.
           EXIT.
      *------------------
       CALL-VSRV133-BFR.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'BFR'   TO PPAR-TARC.
           MOVE KEYFR   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 BFR. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------
       CALL-VSRV133-BFT.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'BFT'   TO PPAR-TARC.
           MOVE KEYBF   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 BFT. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------
       CALL-VSRV133-SCA.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'SCA'   TO PPAR-TARC.
           MOVE KEYSC   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 SCA. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------
       CALL-VSRV133-DSC.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'DSC'   TO PPAR-TARC.
           MOVE KEYDSC  TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 DSC. Errore ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      ************
